/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/types","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/arrays","vs/platform/storage/common/storage","vs/base/common/network","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/stream","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/base/common/jsonFormatter","vs/base/common/extpath","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","fs","child_process","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/userDataSync/common/userDataSyncProfilesStorageService","vs/base/common/functional","vs/base/common/jsonEdit","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/userDataSync/electron-sandbox/userDataSyncProfilesStorageService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],re=function(Q){for(var e=[],R=0,r=Q.length;R<r;R++)e[R]=ne[Q[R]];return e};define(ne[51],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function R(T){return T?T.replace(/\$\((.*?)\)/g,(I,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=R;class r{constructor(I,E,C){this.id=I,this.definition=E,this.description=C,r._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return r._allCodicons}}e.Codicon=r,r._allCodicons=[],r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",r.add.definition),r.gistNew=new r("gist-new",r.add.definition),r.repoCreate=new r("repo-create",r.add.definition),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",r.circleFilled.definition),r.closeDirty=new r("close-dirty",r.circleFilled.definition),r.debugBreakpoint=new r("debug-breakpoint",r.circleFilled.definition),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",r.circleFilled.definition),r.debugHint=new r("debug-hint",r.circleFilled.definition),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circle=new r("circle",{fontCharacter:"\\eabc"}),r.circleOutline=new r("circle-outline",r.circle.definition),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",r.circle.definition),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eba4"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolCustomColor=new r("symbol-customcolor",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.circleSmallFilled=new r("circle-small-filled",{fontCharacter:"\\eb8a"}),r.debugStackframeDot=new r("debug-stackframe-dot",r.circleSmallFilled.definition),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLarge=new r("circle-large",{fontCharacter:"\\ebb5"}),r.circleLargeOutline=new r("circle-large-outline",r.circleLarge.definition),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.layers=new r("layers",{fontCharacter:"\\ebd2"}),r.layersDot=new r("layers-dot",{fontCharacter:"\\ebd3"}),r.layersActive=new r("layers-active",{fontCharacter:"\\ebd4"}),r.compass=new r("compass",{fontCharacter:"\\ebd5"}),r.compassDot=new r("compass-dot",{fontCharacter:"\\ebd6"}),r.compassActive=new r("compass-active",{fontCharacter:"\\ebd7"}),r.azure=new r("azure",{fontCharacter:"\\ebd8"}),r.issueDraft=new r("issue-draft",{fontCharacter:"\\ebd9"}),r.gitPullRequestClosed=new r("git-pull-request-closed",{fontCharacter:"\\ebda"}),r.gitPullRequestDraft=new r("git-pull-request-draft",{fontCharacter:"\\ebdb"}),r.debugAll=new r("debug-all",{fontCharacter:"\\ebdc"}),r.debugCoverage=new r("debug-coverage",{fontCharacter:"\\ebdd"}),r.runErrors=new r("run-errors",{fontCharacter:"\\ebde"}),r.folderLibrary=new r("folder-library",{fontCharacter:"\\ebdf"}),r.debugContinueSmall=new r("debug-continue-small",{fontCharacter:"\\ebe0"}),r.beakerStop=new r("beaker-stop",{fontCharacter:"\\ebe1"}),r.graphLine=new r("graph-line",{fontCharacter:"\\ebe2"}),r.graphScatter=new r("graph-scatter",{fontCharacter:"\\ebe3"}),r.pieChart=new r("pie-chart",{fontCharacter:"\\ebe4"}),r.bracket=new r("bracket",r.json.definition),r.bracketDot=new r("bracket-dot",{fontCharacter:"\\ebe5"}),r.bracketError=new r("bracket-error",{fontCharacter:"\\ebe6"}),r.lockSmall=new r("lock-small",{fontCharacter:"\\ebe7"}),r.azureDevops=new r("azure-devops",{fontCharacter:"\\ebe8"}),r.verifiedFilled=new r("verified-filled",{fontCharacter:"\\ebe9"}),r.newLine=new r("newline",{fontCharacter:"\\ebea"}),r.layout=new r("layout",{fontCharacter:"\\ebeb"}),r.layoutActivitybarLeft=new r("layout-activitybar-left",{fontCharacter:"\\ebec"}),r.layoutActivitybarRight=new r("layout-activitybar-right",{fontCharacter:"\\ebed"}),r.layoutPanelLeft=new r("layout-panel-left",{fontCharacter:"\\ebee"}),r.layoutPanelCenter=new r("layout-panel-center",{fontCharacter:"\\ebef"}),r.layoutPanelJustify=new r("layout-panel-justify",{fontCharacter:"\\ebf0"}),r.layoutPanelRight=new r("layout-panel-right",{fontCharacter:"\\ebf1"}),r.layoutPanel=new r("layout-panel",{fontCharacter:"\\ebf2"}),r.layoutSidebarLeft=new r("layout-sidebar-left",{fontCharacter:"\\ebf3"}),r.layoutSidebarRight=new r("layout-sidebar-right",{fontCharacter:"\\ebf4"}),r.layoutStatusbar=new r("layout-statusbar",{fontCharacter:"\\ebf5"}),r.layoutMenubar=new r("layout-menubar",{fontCharacter:"\\ebf6"}),r.layoutCentered=new r("layout-centered",{fontCharacter:"\\ebf7"}),r.layoutSidebarRightOff=new r("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),r.layoutPanelOff=new r("layout-panel-off",{fontCharacter:"\\ec01"}),r.layoutSidebarLeftOff=new r("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),r.target=new r("target",{fontCharacter:"\\ebf8"}),r.indent=new r("indent",{fontCharacter:"\\ebf9"}),r.recordSmall=new r("record-small",{fontCharacter:"\\ebfa"}),r.errorSmall=new r("error-small",{fontCharacter:"\\ebfb"}),r.arrowCircleDown=new r("arrow-circle-down",{fontCharacter:"\\ebfc"}),r.arrowCircleLeft=new r("arrow-circle-left",{fontCharacter:"\\ebfd"}),r.arrowCircleRight=new r("arrow-circle-right",{fontCharacter:"\\ebfe"}),r.arrowCircleUp=new r("arrow-circle-up",{fontCharacter:"\\ebff"}),r.heartFilled=new r("heart-filled",{fontCharacter:"\\ec04"}),r.map=new r("map",{fontCharacter:"\\ec05"}),r.mapFilled=new r("map-filled",{fontCharacter:"\\ec06"}),r.circleSmall=new r("circle-small",{fontCharacter:"\\ec07"}),r.bellSlash=new r("bell-slash",{fontCharacter:"\\ec08"}),r.bellSlashDot=new r("bell-slash-dot",{fontCharacter:"\\ec09"}),r.commentUnresolved=new r("comment-unresolved",{fontCharacter:"\\ec0a"}),r.gitPullRequestGoToChanges=new r("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),r.gitPullRequestNewChanges=new r("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),r.searchFuzzy=new r("search-fuzzy",{fontCharacter:"\\ec0d"}),r.dialogError=new r("dialog-error",r.error.definition),r.dialogWarning=new r("dialog-warning",r.warning.definition),r.dialogInfo=new r("dialog-info",r.info.definition),r.dialogClose=new r("dialog-close",r.close.definition),r.treeItemExpanded=new r("tree-item-expanded",r.chevronDown.definition),r.treeFilterOnTypeOn=new r("tree-filter-on-type-on",r.listFilter.definition),r.treeFilterOnTypeOff=new r("tree-filter-on-type-off",r.listSelection.definition),r.treeFilterClear=new r("tree-filter-clear",r.close.definition),r.treeItemLoading=new r("tree-item-loading",r.loading.definition),r.menuSelection=new r("menu-selection",r.check.definition),r.menuSubmenu=new r("menu-submenu",r.chevronRight.definition),r.menuBarMore=new r("menubar-more",r.more.definition),r.scrollbarButtonLeft=new r("scrollbar-button-left",r.triangleLeft.definition),r.scrollbarButtonRight=new r("scrollbar-button-right",r.triangleRight.definition),r.scrollbarButtonUp=new r("scrollbar-button-up",r.triangleUp.definition),r.scrollbarButtonDown=new r("scrollbar-button-down",r.triangleDown.definition),r.toolBarMore=new r("toolbar-more",r.more.definition),r.quickInputBack=new r("quick-input-back",r.arrowLeft.definition);function D(T,I){const E=["codicon","codicon-"+T];return I&&E.push("codicon-modifier-"+I),E}e.getClassNamesArray=D;var L;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function E(S){if(S instanceof r)return["codicon","codicon-"+S.id];const m=I.exec(S.id);if(!m)return E(r.error);const[,v,h]=m,y=["codicon","codicon-"+v];return h&&y.push("codicon-modifier-"+h.substr(1)),y}T.asClassNameArray=E;function C(S){return E(S).join(" ")}T.asClassName=C;function b(S){return"."+E(S).join(".")}T.asCSSSelector=b})(L=e.CSSIcon||(e.CSSIcon={}))}),define(ne[62],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(T){return(I,E,C)=>{let b=null,S=null;if(typeof C.value=="function"?(b="value",S=C.value):typeof C.get=="function"&&(b="get",S=C.get),!S)throw new Error("not supported");C[b]=T(S,E)}}e.createDecorator=R;function r(T,I,E){let C=null,b=null;if(typeof E.value=="function"?(C="value",b=E.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(C="get",b=E.get),!b)throw new Error("not supported");const S=`$memoize$${I}`;E[C]=function(...m){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,m)}),this[S]}}e.memoize=r;function D(T,I,E){return R((C,b)=>{const S=`$debounce$${b}`,m=`$debounce$result$${b}`;return function(...v){this[m]||(this[m]=E?E():void 0),clearTimeout(this[S]),I&&(this[m]=I(this[m],...v),v=[this[m]]),this[S]=setTimeout(()=>{C.apply(this,v),this[m]=E?E():void 0},T)}})}e.debounce=D;function L(T,I,E){return R((C,b)=>{const S=`$throttle$timer$${b}`,m=`$throttle$result$${b}`,v=`$throttle$lastRun$${b}`,h=`$throttle$pending$${b}`;return function(...y){if(this[m]||(this[m]=E?E():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...y)),this[h])return;const P=this[v]+T;P<=Date.now()?(this[v]=Date.now(),C.apply(this,[this[m]]),this[m]=E?E():void 0):(this[h]=!0,this[S]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),C.apply(this,[this[m]]),this[m]=E?E():void 0},P-Date.now()))}})}e.throttle=L}),define(ne[9],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?a.isErrorNoTelemetry(i)?new a(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(s=>{s(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=R,e.errorHandler=new R;function r(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=r;function D(l){E(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function L(l){E(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=L;function T(l){if(l instanceof Error){const{name:i,message:s}=l,t=l.stacktrace||l.stack;return{$isError:!0,name:i,message:s,stack:t,noTelemetry:a.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=T;const I="Canceled";function E(l){return l instanceof C?!0:l instanceof Error&&l.name===I&&l.message===I}e.isCancellationError=E;class C extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=C;function b(){const l=new Error(I);return l.name=l.message,l}e.canceled=b;function S(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=S;function m(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=m;function v(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function h(l){const i=new Error(`${l} has been disposed`);return i.name="DISPOSED",i}e.disposed=h;function y(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=y;class P extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=P;class p extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=p;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class a extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof a)return i;const s=new a;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=a;class d extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype);debugger}}e.BugIndicatingError=d}),define(ne[19],re([0,1,9]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function r(X,ie=0){return X[X.length-(1+ie)]}e.tail=r;function D(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.tail2=D;function L(X,ie,se=(ue,he)=>ue===he){if(X===ie)return!0;if(!X||!ie||X.length!==ie.length)return!1;for(let ue=0,he=X.length;ue<he;ue++)if(!se(X[ue],ie[ue]))return!1;return!0}e.equals=L;function T(X,ie){const se=X.length-1;ie<se&&(X[ie]=X[se]),X.pop()}e.removeFastWithoutKeepingOrder=T;function I(X,ie,se){return E(X.length,ue=>se(X[ue],ie))}e.binarySearch=I;function E(X,ie){let se=0,ue=X-1;for(;se<=ue;){const he=(se+ue)/2|0,ve=ie(he);if(ve<0)se=he+1;else if(ve>0)ue=he-1;else return he}return-(se+1)}e.binarySearch2=E;function C(X,ie){let se=0,ue=X.length;if(ue===0)return 0;for(;se<ue;){const he=Math.floor((se+ue)/2);ie(X[he])?ue=he:se=he+1}return se}e.findFirstInSorted=C;function b(X,ie,se){if(X=X|0,X>=ie.length)throw new TypeError("invalid index");const ue=ie[Math.floor(ie.length*Math.random())],he=[],ve=[],we=[];for(const Ee of ie){const Pe=se(Ee,ue);Pe<0?he.push(Ee):Pe>0?ve.push(Ee):we.push(Ee)}return X<he.length?b(X,he,se):X<he.length+we.length?we[0]:b(X-(he.length+we.length),ve,se)}e.quickSelect=b;function S(X,ie){const se=[];let ue;for(const he of X.slice(0).sort(ie))!ue||ie(ue[0],he)!==0?(ue=[he],se.push(ue)):ue.push(he);return se}e.groupBy=S;function m(X,ie,se){const ue=[];function he(Ee,Pe,Ue){if(Pe===0&&Ue.length===0)return;const ze=ue[ue.length-1];ze&&ze.start+ze.deleteCount===Ee?(ze.deleteCount+=Pe,ze.toInsert.push(...Ue)):ue.push({start:Ee,deleteCount:Pe,toInsert:Ue})}let ve=0,we=0;for(;;){if(ve===X.length){he(ve,0,ie.slice(we));break}if(we===ie.length){he(ve,X.length-ve,[]);break}const Ee=X[ve],Pe=ie[we],Ue=se(Ee,Pe);Ue===0?(ve+=1,we+=1):Ue<0?(he(ve,1,[]),ve+=1):Ue>0&&(he(ve,0,[Pe]),we+=1)}return ue}e.sortedDiff=m;function v(X,ie,se){const ue=m(X,ie,se),he=[],ve=[];for(const we of ue)he.push(...X.slice(we.start,we.start+we.deleteCount)),ve.push(...we.toInsert);return{removed:he,added:ve}}e.delta=v;function h(X,ie,se){if(se===0)return[];const ue=X.slice(0,se).sort(ie);return P(X,ie,ue,se,X.length),ue}e.top=h;function y(X,ie,se,ue,he){return se===0?Promise.resolve([]):new Promise((ve,we)=>{(async()=>{const Ee=X.length,Pe=X.slice(0,se).sort(ie);for(let Ue=se,ze=Math.min(se+ue,Ee);Ue<Ee;Ue=ze,ze=Math.min(ze+ue,Ee)){if(Ue>se&&await new Promise(Ve=>setTimeout(Ve)),he&&he.isCancellationRequested)throw new R.CancellationError;P(X,ie,Pe,Ue,ze)}return Pe})().then(ve,we)})}e.topAsync=y;function P(X,ie,se,ue,he){for(const ve=se.length;ue<he;ue++){const we=X[ue];if(ie(we,se[ve-1])<0){se.pop();const Ee=C(se,Pe=>ie(we,Pe)<0);se.splice(Ee,0,we)}}}function p(X){return X.filter(ie=>!!ie)}e.coalesce=p;function g(X){let ie=0;for(let se=0;se<X.length;se++)X[se]&&(X[ie]=X[se],ie+=1);X.length=ie}e.coalesceInPlace=g;function a(X,ie,se){X.splice(se,0,X.splice(ie,1)[0])}e.move=a;function d(X){return!Array.isArray(X)||X.length===0}e.isFalsyOrEmpty=d;function l(X){return Array.isArray(X)&&X.length>0}e.isNonEmptyArray=l;function i(X,ie=se=>se){const se=new Set;return X.filter(ue=>{const he=ie(ue);return se.has(he)?!1:(se.add(he),!0)})}e.distinct=i;function s(X){const ie=new Set;return se=>{const ue=X(se);return ie.has(ue)?!1:(ie.add(ue),!0)}}e.uniqueFilter=s;function t(X,ie){const se=n(X,ie);if(se!==-1)return X[se]}e.findLast=t;function n(X,ie){for(let se=X.length-1;se>=0;se--){const ue=X[se];if(ie(ue))return se}return-1}e.lastIndex=n;function o(X,ie){return X.length>0?X[0]:ie}e.firstOrDefault=o;function c(X,ie){return X.length>0?X[X.length-1]:ie}e.lastOrDefault=c;function u(X,ie,se=(ue,he)=>ue===he){let ue=0;for(let he=0,ve=Math.min(X.length,ie.length);he<ve&&se(X[he],ie[he]);he++)ue++;return ue}e.commonPrefixLength=u;function f(X){return[].concat(...X)}e.flatten=f;function w(X,ie){let se=typeof ie=="number"?X:0;typeof ie=="number"?se=X:(se=0,ie=X);const ue=[];if(se<=ie)for(let he=se;he<ie;he++)ue.push(he);else for(let he=se;he>ie;he--)ue.push(he);return ue}e.range=w;function _(X,ie,se){return X.reduce((ue,he)=>(ue[ie(he)]=se?se(he):he,ue),Object.create(null))}e.index=_;function N(X,ie){return X.push(ie),()=>A(X,ie)}e.insert=N;function A(X,ie){const se=X.indexOf(ie);if(se>-1)return X.splice(se,1),ie}e.remove=A;function O(X,ie,se){const ue=X.slice(0,ie),he=X.slice(ie);return ue.concat(se,he)}e.arrayInsert=O;function k(X,ie){let se;if(typeof ie=="number"){let ue=ie;se=()=>{const he=Math.sin(ue++)*179426549;return he-Math.floor(he)}}else se=Math.random;for(let ue=X.length-1;ue>0;ue-=1){const he=Math.floor(se()*(ue+1)),ve=X[ue];X[ue]=X[he],X[he]=ve}}e.shuffle=k;function M(X,ie){const se=X.indexOf(ie);se>-1&&(X.splice(se,1),X.unshift(ie))}e.pushToStart=M;function $(X,ie){const se=X.indexOf(ie);se>-1&&(X.splice(se,1),X.push(ie))}e.pushToEnd=$;function W(X,ie){for(const se of ie)X.push(se)}e.pushMany=W;function J(X,ie){return Array.isArray(X)?X.map(ie):ie(X)}e.mapArrayOrNot=J;function H(X){return Array.isArray(X)?X:[X]}e.asArray=H;function G(X){return X[Math.floor(Math.random()*X.length)]}e.getRandomElement=G;function q(X,ie){for(const se of X){const ue=ie(se);if(ue!==void 0)return ue}}e.mapFind=q;function x(X,ie,se){const ue=te(X,ie),he=X.length,ve=se.length;X.length=he+ve;for(let we=he-1;we>=ue;we--)X[we+ve]=X[we];for(let we=0;we<ve;we++)X[we+ue]=se[we]}e.insertInto=x;function Y(X,ie,se,ue){const he=te(X,ie),ve=X.splice(he,se);return x(X,he,ue),ve}e.splice=Y;function te(X,ie){return ie<0?Math.max(ie+X.length,0):Math.min(ie,X.length)}var ce;(function(X){function ie(he){return he<0}X.isLessThan=ie;function se(he){return he>0}X.isGreaterThan=se;function ue(he){return he===0}X.isNeitherLessOrGreaterThan=ue,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function z(X,ie){return(se,ue)=>ie(X(se),X(ue))}e.compareBy=z;function V(...X){return(ie,se)=>{for(const ue of X){const he=ue(ie,se);if(!ce.isNeitherLessOrGreaterThan(he))return he}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=V;const U=(X,ie)=>X-ie;e.numberComparator=U;function F(X,ie){if(X.length===0)return;let se=X[0];for(let ue=1;ue<X.length;ue++){const he=X[ue];ie(he,se)>0&&(se=he)}return se}e.findMaxBy=F;function j(X,ie){if(X.length===0)return;let se=X[0];for(let ue=1;ue<X.length;ue++){const he=X[ue];ie(he,se)>=0&&(se=he)}return se}e.findLastMaxBy=j;function B(X,ie){return F(X,(se,ue)=>-ie(se,ue))}e.findMinBy=B;class Z{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let se=this.firstIdx;for(;se<this.items.length&&ie(this.items[se]);)se++;const ue=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ue}takeFromEndWhile(ie){let se=this.lastIdx;for(;se>=0&&ie(this.items[se]);)se--;const ue=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ue}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const se=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,se}}e.ArrayQueue=Z;class oe{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(se=>(ie(se),!0))}toArray(){const ie=[];return this.iterate(se=>(ie.push(se),!0)),ie}filter(ie){return new oe(se=>this.iterate(ue=>ie(ue)?se(ue):!0))}map(ie){return new oe(se=>this.iterate(ue=>se(ie(ue))))}some(ie){let se=!1;return this.iterate(ue=>(se=ie(ue),!se)),se}findFirst(ie){let se;return this.iterate(ue=>ie(ue)?(se=ue,!1):!0),se}findLast(ie){let se;return this.iterate(ue=>(ie(ue)&&(se=ue),!0)),se}findLastMaxBy(ie){let se,ue=!0;return this.iterate(he=>((ue||ce.isGreaterThan(ie(he,se)))&&(ue=!1,se=he),!0)),se}}e.CallbackIterable=oe,oe.empty=new oe(X=>{})}),define(ne[114],re([0,1,9]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function r(E,C){if(!E)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=r;function D(E,C="Unreachable"){throw new Error(C)}e.assertNever=D;function L(E){if(!E)throw new R.BugIndicatingError("Assertion Failed")}e.assert=L;function T(E){if(!E()){debugger;E(),(0,R.onUnexpectedError)(new R.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function I(E,C){let b=0;for(;b<E.length-1;){const S=E[b],m=E[b+1];if(!C(S,m))return!1;b++}return!0}e.checkAdjacentItems=I}),define(ne[78],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(r){const D=this;let L=!1,T;return function(){return L||(L=!0,T=r.apply(D,arguments)),T}}e.once=R}),define(ne[52],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(r){function D(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}r.is=D;const L=Object.freeze([]);function T(){return L}r.empty=T;function*I(s){yield s}r.single=I;function E(s){return s||L}r.from=E;function C(s){return!s||s[Symbol.iterator]().next().done===!0}r.isEmpty=C;function b(s){return s[Symbol.iterator]().next().value}r.first=b;function S(s,t){for(const n of s)if(t(n))return!0;return!1}r.some=S;function m(s,t){for(const n of s)if(t(n))return n}r.find=m;function*v(s,t){for(const n of s)t(n)&&(yield n)}r.filter=v;function*h(s,t){let n=0;for(const o of s)yield t(o,n++)}r.map=h;function*y(...s){for(const t of s)for(const n of t)yield n}r.concat=y;function*P(s){for(const t of s)for(const n of t)yield n}r.concatNested=P;function p(s,t,n){let o=n;for(const c of s)o=t(o,c);return o}r.reduce=p;function g(s,t){let n=0;for(const o of s)t(o,n++)}r.forEach=g;function*a(s,t,n=s.length){for(t<0&&(t+=s.length),n<0?n+=s.length:n>s.length&&(n=s.length);t<n;t++)yield s[t]}r.slice=a;function d(s,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,s];const o=s[Symbol.iterator]();for(let c=0;c<t;c++){const u=o.next();if(u.done)return[n,r.empty()];n.push(u.value)}return[n,{[Symbol.iterator](){return o}}]}r.consume=d;function l(s){return d(s)[0]}r.collect=l;function i(s,t,n=(o,c)=>o===c){const o=s[Symbol.iterator](),c=t[Symbol.iterator]();for(;;){const u=o.next(),f=c.next();if(u.done!==f.done)return!1;if(u.done)return!0;if(!n(u.value,f.value))return!1}}r.equals=i})(R=e.Iterable||(e.Iterable={}))}),define(ne[35],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var r;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(r=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function T(i,s=!1){let t=0;const n=i.length;let o="",c=0,u=16,f=0;function w($){let W=0,J=0;for(;W<$;){const H=i.charCodeAt(t);if(H>=48&&H<=57)J=J*16+H-48;else if(H>=65&&H<=70)J=J*16+H-65+10;else if(H>=97&&H<=102)J=J*16+H-97+10;else break;t++,W++}return W<$&&(J=-1),J}function _($){t=$,o="",c=0,u=16,f=0}function N(){const $=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&C(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&C(i.charCodeAt(t)))for(t++;t<i.length&&C(i.charCodeAt(t));)t++;else return f=3,i.substring($,t);let W=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&C(i.charCodeAt(t))){for(t++;t<i.length&&C(i.charCodeAt(t));)t++;W=t}else f=3;return i.substring($,W)}function A(){let $="",W=t;for(;;){if(t>=n){$+=i.substring(W,t),f=2;break}const J=i.charCodeAt(t);if(J===34){$+=i.substring(W,t),t++;break}if(J===92){if($+=i.substring(W,t),t++,t>=n){f=2;break}switch(i.charCodeAt(t++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const G=w(4);G>=0?$+=String.fromCharCode(G):f=4;break}default:f=5}W=t;continue}if(J>=0&&J<=31)if(E(J)){$+=i.substring(W,t),f=2;break}else f=6;t++}return $}function O(){if(o="",f=0,c=t,t>=n)return c=n,u=17;let $=i.charCodeAt(t);if(I($)){do t++,o+=String.fromCharCode($),$=i.charCodeAt(t);while(I($));return u=15}if(E($))return t++,o+=String.fromCharCode($),$===13&&i.charCodeAt(t)===10&&(t++,o+=`
`),u=14;switch($){case 123:return t++,u=1;case 125:return t++,u=2;case 91:return t++,u=3;case 93:return t++,u=4;case 58:return t++,u=6;case 44:return t++,u=5;case 34:return t++,o=A(),u=10;case 47:{const W=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!E(i.charCodeAt(t));)t++;return o=i.substring(W,t),u=12}if(i.charCodeAt(t+1)===42){t+=2;const J=n-1;let H=!1;for(;t<J;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,H=!0;break}t++}return H||(t++,f=1),o=i.substring(W,t),u=13}return o+=String.fromCharCode($),t++,u=16}case 45:if(o+=String.fromCharCode($),t++,t===n||!C(i.charCodeAt(t)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=N(),u=11;default:for(;t<n&&k($);)t++,$=i.charCodeAt(t);if(c!==t){switch(o=i.substring(c,t),o){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return o+=String.fromCharCode($),t++,u=16}}function k($){if(I($)||E($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let $;do $=O();while($>=12&&$<=15);return $}return{setPosition:_,getPosition:()=>t,scan:s?M:O,getToken:()=>u,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>f}}e.createScanner=T;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function E(i){return i===10||i===13||i===8232||i===8233}function C(i){return i>=48&&i<=57}var b;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(b||(b={}));function S(i,s){const t=[],n=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function f(w,_,N,A){c.value=w,c.offset=_,c.length=N,c.type=A,c.colonOffset=void 0,o=c}try{a(i,{onObjectBegin:(w,_)=>{if(s<=w)throw n;o=void 0,u=s>w,t.push("")},onObjectProperty:(w,_,N)=>{if(s<_||(f(w,_,N,"property"),t[t.length-1]=w,s<=_+N))throw n},onObjectEnd:(w,_)=>{if(s<=w)throw n;o=void 0,t.pop()},onArrayBegin:(w,_)=>{if(s<=w)throw n;o=void 0,t.push(0)},onArrayEnd:(w,_)=>{if(s<=w)throw n;o=void 0,t.pop()},onLiteralValue:(w,_,N)=>{if(s<_||(f(w,_,N,l(w)),s<=_+N))throw n},onSeparator:(w,_,N)=>{if(s<=_)throw n;if(w===":"&&o&&o.type==="property")o.colonOffset=_,u=!1,o=void 0;else if(w===","){const A=t[t.length-1];typeof A=="number"?t[t.length-1]=A+1:(u=!0,t[t.length-1]=""),o=void 0}}})}catch(w){if(w!==n)throw w}return{path:t,previousNode:o,isAtPropertyKey:u,matches:w=>{let _=0;for(let N=0;_<w.length&&N<t.length;N++)if(w[_]===t[N]||w[_]==="*")_++;else if(w[_]!=="**")return!1;return _===w.length}}}e.getLocation=S;function m(i,s=[],t=L.DEFAULT){let n=null,o=[];const c=[];function u(w){Array.isArray(o)?o.push(w):n!==null&&(o[n]=w)}return a(i,{onObjectBegin:()=>{const w={};u(w),c.push(o),o=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const w=[];u(w),c.push(o),o=w,n=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:u,onError:(w,_,N)=>{s.push({error:w,offset:_,length:N})}},t),o[0]}e.parse=m;function v(i,s=[],t=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(w){n.type==="property"&&(n.length=w-n.offset,n=n.parent)}function c(w){return n.children.push(w),w}a(i,{onObjectBegin:w=>{n=c({type:"object",offset:w,length:-1,parent:n,children:[]})},onObjectProperty:(w,_,N)=>{n=c({type:"property",offset:_,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:w,offset:_,length:N,parent:n})},onObjectEnd:(w,_)=>{n.length=w+_-n.offset,n=n.parent,o(w+_)},onArrayBegin:(w,_)=>{n=c({type:"array",offset:w,length:-1,parent:n,children:[]})},onArrayEnd:(w,_)=>{n.length=w+_-n.offset,n=n.parent,o(w+_)},onLiteralValue:(w,_,N)=>{c({type:l(w),offset:_,length:N,parent:n,value:w}),o(_+N)},onSeparator:(w,_,N)=>{n.type==="property"&&(w===":"?n.colonOffset=_:w===","&&o(_))},onError:(w,_,N)=>{s.push({error:w,offset:_,length:N})}},t);const f=n.children[0];return f&&delete f.parent,f}e.parseTree=v;function h(i,s){if(!i)return;let t=i;for(const n of s)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===n){t=c.children[1],o=!0;break}if(!o)return}else{const o=n;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=h;function y(i){if(!i.parent||!i.parent.children)return[];const s=y(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;s.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&s.push(t)}return s}e.getNodePath=y;function P(i){switch(i.type){case"array":return i.children.map(P);case"object":{const s=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(s[t.children[0].value]=P(n))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=P;function p(i,s,t=!1){return s>=i.offset&&s<i.offset+i.length||t&&s===i.offset+i.length}e.contains=p;function g(i,s,t=!1){if(p(i,s,t)){const n=i.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=s;o++){const c=g(n[o],s,t);if(c)return c}return i}}e.findNodeAtOffset=g;function a(i,s,t=L.DEFAULT){const n=T(i,!1);function o(z){return z?()=>z(n.getTokenOffset(),n.getTokenLength()):()=>!0}function c(z){return z?V=>z(V,n.getTokenOffset(),n.getTokenLength()):()=>!0}const u=o(s.onObjectBegin),f=c(s.onObjectProperty),w=o(s.onObjectEnd),_=o(s.onArrayBegin),N=o(s.onArrayEnd),A=c(s.onLiteralValue),O=c(s.onSeparator),k=o(s.onComment),M=c(s.onError),$=t&&t.disallowComments,W=t&&t.allowTrailingComma;function J(){for(;;){const z=n.scan();switch(n.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:$||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(z){case 12:case 13:$?H(10):k();break;case 16:H(1);break;case 15:case 14:break;default:return z}}}function H(z,V=[],U=[]){if(M(z),V.length+U.length>0){let F=n.getToken();for(;F!==17;){if(V.indexOf(F)!==-1){J();break}else if(U.indexOf(F)!==-1)break;F=J()}}}function G(z){const V=n.getTokenValue();return z?A(V):f(V),J(),!0}function q(){switch(n.getToken()){case 11:{let z=0;try{z=JSON.parse(n.getTokenValue()),typeof z!="number"&&(H(2),z=0)}catch{H(2)}A(z);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return J(),!0}function x(){return n.getToken()!==10?(H(3,[],[2,5]),!1):(G(!1),n.getToken()===6?(O(":"),J(),ce()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function Y(){u(),J();let z=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(z||H(4,[],[]),O(","),J(),n.getToken()===2&&W)break}else z&&H(6,[],[]);x()||H(4,[],[2,5]),z=!0}return w(),n.getToken()!==2?H(7,[2],[]):J(),!0}function te(){_(),J();let z=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(z||H(4,[],[]),O(","),J(),n.getToken()===4&&W)break}else z&&H(6,[],[]);ce()||H(4,[],[4,5]),z=!0}return N(),n.getToken()!==4?H(8,[4],[]):J(),!0}function ce(){switch(n.getToken()){case 3:return te();case 1:return Y();case 10:return G(!0);default:return q()}}return J(),n.getToken()===17?t.allowEmptyContent?!0:(H(4,[],[]),!1):ce()?(n.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=a;function d(i,s){const t=T(i),n=[];let o,c=0,u;do switch(u=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:c!==u&&n.push(i.substring(c,u)),s!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,s)),c=t.getPosition();break}while(o!==17);return n.join("")}e.stripComments=d;function l(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ne[46],re([0,1,35]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function r(C,b,S){let m,v,h,y,P;if(b){for(y=b.offset,P=y+b.length,h=y;h>0&&!E(C,h-1);)h--;let u=P;for(;u<C.length&&!E(C,u);)u++;v=C.substring(h,u),m=T(v,S)}else v=C,m=0,h=0,y=0,P=C.length;const p=I(S,C);let g=!1,a=0,d;S.insertSpaces?d=L(" ",S.tabSize||4):d="	";const l=(0,R.createScanner)(v,!1);let i=!1;function s(){return p+L(d,m+a)}function t(){let u=l.scan();for(g=!1;u===15||u===14;)g=g||u===14,u=l.scan();return i=u===16||l.getTokenError()!==0,u}const n=[];function o(u,f,w){!i&&f<P&&w>y&&C.substring(f,w)!==u&&n.push({offset:f,length:w-f,content:u})}let c=t();if(c!==17){const u=l.getTokenOffset()+h,f=L(d,m);o(f,h,u)}for(;c!==17;){let u=l.getTokenOffset()+l.getTokenLength()+h,f=t(),w="";for(;!g&&(f===12||f===13);){const N=l.getTokenOffset()+h;o(" ",u,N),u=l.getTokenOffset()+l.getTokenLength()+h,w=f===12?s():"",f=t()}if(f===2)c!==1&&(a--,w=s());else if(f===4)c!==3&&(a--,w=s());else{switch(c){case 3:case 1:a++,w=s();break;case 5:case 12:w=s();break;case 13:g?w=s():w=" ";break;case 6:w=" ";break;case 10:if(f===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?w=" ":f!==5&&f!==17&&(i=!0);break;case 16:i=!0;break}g&&(f===12||f===13)&&(w=s())}const _=l.getTokenOffset()+h;o(w,u,_),c=f}return n}e.format=r;function D(C,b){const S=JSON.stringify(C,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?S.replace(/\r\n|\r|\n/g,b.eol):S}e.toFormattedString=D;function L(C,b){let S="";for(let m=0;m<b;m++)S+=C;return S}function T(C,b){let S=0,m=0;const v=b.tabSize||4;for(;S<C.length;){const h=C.charAt(S);if(h===" ")m++;else if(h==="	")m+=v;else break;S++}return Math.floor(m/v)}function I(C,b){for(let S=0;S<b.length;S++){const m=b.charAt(S);if(m==="\r")return S+1<b.length&&b.charAt(S+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return C&&C.eol||`
`}e.getEOL=I;function E(C,b){return`\r
`.indexOf(C.charAt(b))!==-1}e.isEOL=E}),define(ne[79],re([0,1,35,46]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(C,b,S){return L(C,b,void 0,S)}e.removeProperty=D;function L(C,b,S,m,v){const h=b.slice(),y=[],P=(0,R.parseTree)(C,y);let p,g;for(;h.length>0&&(g=h.pop(),p=(0,R.findNodeAtLocation)(P,h),p===void 0&&S!==void 0);)typeof g=="string"?S={[g]:S}:S=[S];if(p)if(p.type==="object"&&typeof g=="string"&&Array.isArray(p.children)){const a=(0,R.findNodeAtLocation)(p,[g]);if(a!==void 0)if(S===void 0){if(!a.parent)throw new Error("Malformed AST");const d=p.children.indexOf(a.parent);let l,i=a.parent.offset+a.parent.length;if(d>0){const s=p.children[d-1];l=s.offset+s.length}else l=p.offset+1,p.children.length>1&&(i=p.children[1].offset);return T(C,{offset:l,length:i-l,content:""},m)}else return T(C,{offset:a.offset,length:a.length,content:JSON.stringify(S)},m);else{if(S===void 0)return[];const d=`${JSON.stringify(g)}: ${JSON.stringify(S)}`,l=v?v(p.children.map(s=>s.children[0].value)):p.children.length;let i;if(l>0){const s=p.children[l-1];i={offset:s.offset+s.length,length:0,content:","+d}}else p.children.length===0?i={offset:p.offset+1,length:0,content:d}:i={offset:p.offset+1,length:0,content:d+","};return T(C,i,m)}}else if(p.type==="array"&&typeof g=="number"&&Array.isArray(p.children))if(S!==void 0){const a=`${JSON.stringify(S)}`;let d;if(p.children.length===0||g===0)d={offset:p.offset+1,length:0,content:p.children.length===0?a:a+","};else{const l=g===-1||g>p.children.length?p.children.length:g,i=p.children[l-1];d={offset:i.offset+i.length,length:0,content:","+a}}return T(C,d,m)}else{const a=g,d=p.children[a];let l;if(p.children.length===1)l={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===a){const i=p.children[a-1],s=i.offset+i.length,t=p.offset+p.length;l={offset:s,length:t-2-s,content:""}}else l={offset:d.offset,length:p.children[a+1].offset-d.offset,content:""};return T(C,l,m)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${p.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return T(C,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(S)},m)}}e.setProperty=L;function T(C,b,S){let m=I(C,b),v=b.offset,h=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;v>0&&!(0,r.isEOL)(m,v-1);)v--;for(;h<m.length&&!(0,r.isEOL)(m,h);)h++}const y=(0,r.format)(m,{offset:v,length:h-v},S);for(let p=y.length-1;p>=0;p--){const g=y[p];m=I(m,g),v=Math.min(v,g.offset),h=Math.max(h,g.offset+g.length),h+=g.content.length-g.length}const P=C.length-(m.length-h)-v;return[{offset:v,length:P,content:m.substring(v,h)}]}e.withFormatting=T;function I(C,b){return C.substring(0,b.offset)+b.content+C.substring(b.offset+b.length)}e.applyEdit=I;function E(C,b){const S=b.slice(0).sort((v,h)=>{const y=v.offset-h.offset;return y===0?v.length-h.length:y});let m=C.length;for(let v=S.length-1;v>=0;v--){const h=S[v];if(h.offset+h.length<=m)C=I(C,h);else throw new Error("Overlapping edit");m=h.offset}return C}e.applyEdits=E}),define(ne[115],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class R{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new R(()=>D(this.getValue()))}}e.Lazy=R}),define(ne[2],re([0,1,78,52]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let L=null;function T(o){L=o}if(e.setDisposableTracker=T,D){const o="__is_disposable_tracked__";T(new class{trackDisposable(c){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[o]||console.log(u)},3e3)}setParent(c,u){if(c&&c!==g.None)try{c[o]=!0}catch{}}markAsDisposed(c){if(c&&c!==g.None)try{c[o]=!0}catch{}}markAsSingleton(c){}})}function I(o){return L?.trackDisposable(o),o}function E(o){L?.markAsDisposed(o)}function C(o,c){L?.setParent(o,c)}function b(o,c){if(!!L)for(const u of o)L.setParent(u,c)}function S(o){return L?.markAsSingleton(o),o}e.markAsSingleton=S;function m(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=m;function v(o){if(r.Iterable.is(o)){const c=[];for(const u of o)if(u)try{u.dispose()}catch(f){c.push(f)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=v;function h(o){for(const c of o)m(c)&&c.dispose();return[]}e.disposeIfDisposable=h;function y(...o){const c=P(()=>v(o));return b(o,c),c}e.combinedDisposable=y;function P(o){const c=I({dispose:(0,R.once)(()=>{E(c),o()})});return c}e.toDisposable=P;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{v(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return C(c,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new p,I(this),C(this._store,this)}dispose(){E(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&C(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&C(c,null),c}}e.MutableDisposable=a;class d{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=d;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(c){let u=c;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,E(this))},this}}e.SafeDisposable=l;class i{constructor(){this.references=new Map}acquire(c,...u){let f=this.references.get(c);f||(f={counter:0,object:this.createReferencedObject(c,...u)},this.references.set(c,f));const{object:w}=f,_=(0,R.once)(()=>{--f.counter===0&&(this.destroyReferencedObject(c,f.object),this.references.delete(c))});return f.counter++,{object:w,dispose:_}}}e.ReferenceCollection=i;class s{constructor(c){this.referenceCollection=c}async acquire(c,...u){const f=this.referenceCollection.acquire(c,...u);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(w){throw f.dispose(),w}}}e.AsyncReferenceCollection=s;class t{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=t;function n(o){const c=new p;try{o(c)}finally{c.dispose()}}e.disposeOnReturn=n}),define(ne[116],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(L){this.element=L,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class r{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let L=this._first;for(;L!==R.Undefined;){const T=L.next;L.prev=R.Undefined,L.next=R.Undefined,L=T}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,T){const I=new R(L);if(this._first===R.Undefined)this._first=I,this._last=I;else if(T){const C=this._last;this._last=I,I.prev=C,C.next=I}else{const C=this._first;this._first=I,I.next=C,C.prev=I}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(I))}}shift(){if(this._first!==R.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==R.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==R.Undefined&&L.next!==R.Undefined){const T=L.prev;T.next=L.next,L.next.prev=T}else L.prev===R.Undefined&&L.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):L.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):L.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==R.Undefined;)yield L.element,L=L.next}}e.LinkedList=r}),function(){function Q(D){const L=[];typeof D=="number"&&L.push("code/timeOrigin",D);function T(E){L.push(E,Date.now())}function I(){const E=[];for(let C=0;C<L.length;C+=2)E.push({name:L[C],startTime:L[C+1]});return E}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const T of performance.getEntriesByType("mark"))L.push({name:T.name,startTime:Math.round(D+T.startTime)});return L}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function R(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=R(r))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var r in R)(typeof exports=="object"?exports:Q)[r]=R[r]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function R(r){if(e[r])return e[r].exports;var D=e[r]={i:r,l:!1,exports:{}};return Q[r].call(D.exports,D,D.exports,R),D.l=!0,D.exports}return R.m=Q,R.c=e,R.d=function(r,D,L){R.o(r,D)||Object.defineProperty(r,D,{enumerable:!0,get:L})},R.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},R.t=function(r,D){if(1&D&&(r=R(r)),8&D||4&D&&typeof r=="object"&&r&&r.__esModule)return r;var L=Object.create(null);if(R.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:r}),2&D&&typeof r!="string")for(var T in r)R.d(L,T,function(I){return r[I]}.bind(null,T));return L},R.n=function(r){var D=r&&r.__esModule?function(){return r.default}:function(){return r};return R.d(D,"a",D),D},R.o=function(r,D){return Object.prototype.hasOwnProperty.call(r,D)},R.p="",R(R.s=0)}([function(Q,e,R){(function(r){var D;e=Q.exports=U,D=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],E=e.src=[],C=0,b=C++;E[b]="0|[1-9]\\d*";var S=C++;E[S]="[0-9]+";var m=C++;E[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=C++;E[v]="("+E[b]+")\\.("+E[b]+")\\.("+E[b]+")";var h=C++;E[h]="("+E[S]+")\\.("+E[S]+")\\.("+E[S]+")";var y=C++;E[y]="(?:"+E[b]+"|"+E[m]+")";var P=C++;E[P]="(?:"+E[S]+"|"+E[m]+")";var p=C++;E[p]="(?:-("+E[y]+"(?:\\."+E[y]+")*))";var g=C++;E[g]="(?:-?("+E[P]+"(?:\\."+E[P]+")*))";var a=C++;E[a]="[0-9A-Za-z-]+";var d=C++;E[d]="(?:\\+("+E[a]+"(?:\\."+E[a]+")*))";var l=C++,i="v?"+E[v]+E[p]+"?"+E[d]+"?";E[l]="^"+i+"$";var s="[v=\\s]*"+E[h]+E[g]+"?"+E[d]+"?",t=C++;E[t]="^"+s+"$";var n=C++;E[n]="((?:<|>)?=?)";var o=C++;E[o]=E[S]+"|x|X|\\*";var c=C++;E[c]=E[b]+"|x|X|\\*";var u=C++;E[u]="[v=\\s]*("+E[c]+")(?:\\.("+E[c]+")(?:\\.("+E[c]+")(?:"+E[p]+")?"+E[d]+"?)?)?";var f=C++;E[f]="[v=\\s]*("+E[o]+")(?:\\.("+E[o]+")(?:\\.("+E[o]+")(?:"+E[g]+")?"+E[d]+"?)?)?";var w=C++;E[w]="^"+E[n]+"\\s*"+E[u]+"$";var _=C++;E[_]="^"+E[n]+"\\s*"+E[f]+"$";var N=C++;E[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=C++;E[A]="(?:~>?)";var O=C++;E[O]="(\\s*)"+E[A]+"\\s+",I[O]=new RegExp(E[O],"g");var k=C++;E[k]="^"+E[A]+E[u]+"$";var M=C++;E[M]="^"+E[A]+E[f]+"$";var $=C++;E[$]="(?:\\^)";var W=C++;E[W]="(\\s*)"+E[$]+"\\s+",I[W]=new RegExp(E[W],"g");var J=C++;E[J]="^"+E[$]+E[u]+"$";var H=C++;E[H]="^"+E[$]+E[f]+"$";var G=C++;E[G]="^"+E[n]+"\\s*("+s+")$|^$";var q=C++;E[q]="^"+E[n]+"\\s*("+i+")$|^$";var x=C++;E[x]="(\\s*)"+E[n]+"\\s*("+s+"|"+E[u]+")",I[x]=new RegExp(E[x],"g");var Y=C++;E[Y]="^\\s*("+E[u]+")\\s+-\\s+("+E[u]+")\\s*$";var te=C++;E[te]="^\\s*("+E[f]+")\\s+-\\s+("+E[f]+")\\s*$";var ce=C++;E[ce]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)D(z,E[z]),I[z]||(I[z]=new RegExp(E[z]));function V(ae,de){if(ae instanceof U)return ae;if(typeof ae!="string"||ae.length>L||!(de?I[t]:I[l]).test(ae))return null;try{return new U(ae,de)}catch{return null}}function U(ae,de){if(ae instanceof U){if(ae.loose===de)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof U))return new U(ae,de);D("SemVer",ae,de),this.loose=de;var fe=ae.trim().match(de?I[t]:I[l]);if(!fe)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Ie=+Ce;if(Ie>=0&&Ie<T)return Ie}return Ce}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=V,e.valid=function(ae,de){var fe=V(ae,de);return fe?fe.version:null},e.clean=function(ae,de){var fe=V(ae.trim().replace(/^[=v]+/,""),de);return fe?fe.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(ae){return D("SemVer.compare",this.version,this.loose,ae),ae instanceof U||(ae=new U(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},U.prototype.compareMain=function(ae){return ae instanceof U||(ae=new U(ae,this.loose)),j(this.major,ae.major)||j(this.minor,ae.minor)||j(this.patch,ae.patch)},U.prototype.comparePre=function(ae){if(ae instanceof U||(ae=new U(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var de=0;do{var fe=this.prerelease[de],Ce=ae.prerelease[de];if(D("prerelease compare",de,fe,Ce),fe===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ce)return j(fe,Ce)}while(++de)},U.prototype.inc=function(ae,de){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,de,fe,Ce){typeof fe=="string"&&(Ce=fe,fe=void 0);try{return new U(ae,fe).inc(de,Ce).version}catch{return null}},e.diff=function(ae,de){if(X(ae,de))return null;var fe=V(ae),Ce=V(de);if(fe.prerelease.length||Ce.prerelease.length){for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Ce[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Ce[Ie])return Ie},e.compareIdentifiers=j;var F=/^[0-9]+$/;function j(ae,de){var fe=F.test(ae),Ce=F.test(de);return fe&&Ce&&(ae=+ae,de=+de),fe&&!Ce?-1:Ce&&!fe?1:ae<de?-1:ae>de?1:0}function B(ae,de,fe){return new U(ae,fe).compare(new U(de,fe))}function Z(ae,de,fe){return B(ae,de,fe)>0}function oe(ae,de,fe){return B(ae,de,fe)<0}function X(ae,de,fe){return B(ae,de,fe)===0}function ie(ae,de,fe){return B(ae,de,fe)!==0}function se(ae,de,fe){return B(ae,de,fe)>=0}function ue(ae,de,fe){return B(ae,de,fe)<=0}function he(ae,de,fe,Ce){var Ie;switch(de){case"===":typeof ae=="object"&&(ae=ae.version),typeof fe=="object"&&(fe=fe.version),Ie=ae===fe;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof fe=="object"&&(fe=fe.version),Ie=ae!==fe;break;case"":case"=":case"==":Ie=X(ae,fe,Ce);break;case"!=":Ie=ie(ae,fe,Ce);break;case">":Ie=Z(ae,fe,Ce);break;case">=":Ie=se(ae,fe,Ce);break;case"<":Ie=oe(ae,fe,Ce);break;case"<=":Ie=ue(ae,fe,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Ie}function ve(ae,de){if(ae instanceof ve){if(ae.loose===de)return ae;ae=ae.value}if(!(this instanceof ve))return new ve(ae,de);D("comparator",ae,de),this.loose=de,this.parse(ae),this.semver===we?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ae,de){return j(de,ae)},e.major=function(ae,de){return new U(ae,de).major},e.minor=function(ae,de){return new U(ae,de).minor},e.patch=function(ae,de){return new U(ae,de).patch},e.compare=B,e.compareLoose=function(ae,de){return B(ae,de,!0)},e.rcompare=function(ae,de,fe){return B(de,ae,fe)},e.sort=function(ae,de){return ae.sort(function(fe,Ce){return e.compare(fe,Ce,de)})},e.rsort=function(ae,de){return ae.sort(function(fe,Ce){return e.rcompare(fe,Ce,de)})},e.gt=Z,e.lt=oe,e.eq=X,e.neq=ie,e.gte=se,e.lte=ue,e.cmp=he,e.Comparator=ve;var we={};function Ee(ae,de){if(ae instanceof Ee)return ae.loose===de?ae:new Ee(ae.raw,de);if(ae instanceof ve)return new Ee(ae.value,de);if(!(this instanceof Ee))return new Ee(ae,de);if(this.loose=de,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Pe(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Ue(ae,de,fe,Ce,Ie,Me,De,$e,Ae,Fe,_e,ke,ee){return((de=Pe(fe)?"":Pe(Ce)?">="+fe+".0.0":Pe(Ie)?">="+fe+"."+Ce+".0":">="+de)+" "+($e=Pe(Ae)?"":Pe(Fe)?"<"+(+Ae+1)+".0.0":Pe(_e)?"<"+Ae+"."+(+Fe+1)+".0":ke?"<="+Ae+"."+Fe+"."+_e+"-"+ke:"<="+$e)).trim()}function ze(ae,de){for(var fe=0;fe<ae.length;fe++)if(!ae[fe].test(de))return!1;if(de.prerelease.length){for(fe=0;fe<ae.length;fe++)if(D(ae[fe].semver),ae[fe].semver!==we&&ae[fe].semver.prerelease.length>0){var Ce=ae[fe].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ve(ae,de,fe){try{de=new Ee(de,fe)}catch{return!1}return de.test(ae)}function We(ae,de,fe,Ce){var Ie,Me,De,$e,Ae;switch(ae=new U(ae,Ce),de=new Ee(de,Ce),fe){case">":Ie=Z,Me=ue,De=oe,$e=">",Ae=">=";break;case"<":Ie=oe,Me=se,De=Z,$e="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ve(ae,de,Ce))return!1;for(var Fe=0;Fe<de.set.length;++Fe){var _e=de.set[Fe],ke=null,ee=null;if(_e.forEach(function(le){le.semver===we&&(le=new ve(">=0.0.0")),ke=ke||le,ee=ee||le,Ie(le.semver,ke.semver,Ce)?ke=le:De(le.semver,ee.semver,Ce)&&(ee=le)}),ke.operator===$e||ke.operator===Ae||(!ee.operator||ee.operator===$e)&&Me(ae,ee.semver)||ee.operator===Ae&&De(ae,ee.semver))return!1}return!0}ve.prototype.parse=function(ae){var de=this.loose?I[G]:I[q],fe=ae.match(de);if(!fe)throw new TypeError("Invalid comparator: "+ae);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new U(fe[2],this.loose):this.semver=we},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ae){return D("Comparator.test",ae,this.loose),this.semver===we||(typeof ae=="string"&&(ae=new U(ae,this.loose)),he(ae,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ae,de){if(!(ae instanceof ve))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Ee(ae.value,de),Ve(this.value,fe,de);if(ae.operator==="")return fe=new Ee(this.value,de),Ve(ae.semver,fe,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Me=this.semver.version===ae.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),$e=he(this.semver,"<",ae.semver,de)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ae=he(this.semver,">",ae.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Ce||Ie||Me&&De||$e||Ae},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ae){var de=this.loose;ae=ae.trim(),D("range",ae,de);var fe=de?I[te]:I[Y];ae=ae.replace(fe,Ue),D("hyphen replace",ae),ae=ae.replace(I[x],"$1$2$3"),D("comparator trim",ae,I[x]),ae=(ae=(ae=ae.replace(I[O],"$1~")).replace(I[W],"$1^")).split(/\s+/).join(" ");var Ce=de?I[G]:I[q],Ie=ae.split(" ").map(function(Me){return function(De,$e){return D("comp",De),De=function(Ae,Fe){return Ae.trim().split(/\s+/).map(function(_e){return function(ke,ee){D("caret",ke,ee);var le=ee?I[H]:I[J];return ke.replace(le,function(me,ge,Se,be,Re){var Te;return D("caret",ke,me,ge,Se,be,Re),Pe(ge)?Te="":Pe(Se)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Pe(be)?Te=ge==="0"?">="+ge+"."+Se+".0 <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+".0 <"+(+ge+1)+".0.0":Re?(D("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=ge==="0"?Se==="0"?">="+ge+"."+Se+"."+be+Re+" <"+ge+"."+Se+"."+(+be+1):">="+ge+"."+Se+"."+be+Re+" <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+"."+be+Re+" <"+(+ge+1)+".0.0"):(D("no pr"),Te=ge==="0"?Se==="0"?">="+ge+"."+Se+"."+be+" <"+ge+"."+Se+"."+(+be+1):">="+ge+"."+Se+"."+be+" <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+"."+be+" <"+(+ge+1)+".0.0"),D("caret return",Te),Te})}(_e,Fe)}).join(" ")}(De,$e),D("caret",De),De=function(Ae,Fe){return Ae.trim().split(/\s+/).map(function(_e){return function(ke,ee){var le=ee?I[M]:I[k];return ke.replace(le,function(me,ge,Se,be,Re){var Te;return D("tilde",ke,me,ge,Se,be,Re),Pe(ge)?Te="":Pe(Se)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Pe(be)?Te=">="+ge+"."+Se+".0 <"+ge+"."+(+Se+1)+".0":Re?(D("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=">="+ge+"."+Se+"."+be+Re+" <"+ge+"."+(+Se+1)+".0"):Te=">="+ge+"."+Se+"."+be+" <"+ge+"."+(+Se+1)+".0",D("tilde return",Te),Te})}(_e,Fe)}).join(" ")}(De,$e),D("tildes",De),De=function(Ae,Fe){return D("replaceXRanges",Ae,Fe),Ae.split(/\s+/).map(function(_e){return function(ke,ee){ke=ke.trim();var le=ee?I[_]:I[w];return ke.replace(le,function(me,ge,Se,be,Re,Te){D("xRange",ke,me,ge,Se,be,Re,Te);var qe=Pe(Se),Le=qe||Pe(be),Ne=Le||Pe(Re);return ge==="="&&Ne&&(ge=""),qe?me=ge===">"||ge==="<"?"<0.0.0":"*":ge&&Ne?(Le&&(be=0),Ne&&(Re=0),ge===">"?(ge=">=",Le?(Se=+Se+1,be=0,Re=0):Ne&&(be=+be+1,Re=0)):ge==="<="&&(ge="<",Le?Se=+Se+1:be=+be+1),me=ge+Se+"."+be+"."+Re):Le?me=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ne&&(me=">="+Se+"."+be+".0 <"+Se+"."+(+be+1)+".0"),D("xRange return",me),me})}(_e,Fe)}).join(" ")}(De,$e),D("xrange",De),De=function(Ae,Fe){return D("replaceStars",Ae,Fe),Ae.trim().replace(I[ce],"")}(De,$e),D("stars",De),De}(Me,de)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Me){return!!Me.match(Ce)})),Ie=Ie.map(function(Me){return new ve(Me,de)})},Ee.prototype.intersects=function(ae,de){if(!(ae instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ce){return ae.set.some(function(Ie){return Ie.every(function(Me){return Ce.intersects(Me,de)})})})})},e.toComparators=function(ae,de){return new Ee(ae,de).set.map(function(fe){return fe.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new U(ae,this.loose));for(var de=0;de<this.set.length;de++)if(ze(this.set[de],ae))return!0;return!1},e.satisfies=Ve,e.maxSatisfying=function(ae,de,fe){var Ce=null,Ie=null;try{var Me=new Ee(de,fe)}catch{return null}return ae.forEach(function(De){Me.test(De)&&(Ce&&Ie.compare(De)!==-1||(Ie=new U(Ce=De,fe)))}),Ce},e.minSatisfying=function(ae,de,fe){var Ce=null,Ie=null;try{var Me=new Ee(de,fe)}catch{return null}return ae.forEach(function(De){Me.test(De)&&(Ce&&Ie.compare(De)!==1||(Ie=new U(Ce=De,fe)))}),Ce},e.validRange=function(ae,de){try{return new Ee(ae,de).range||"*"}catch{return null}},e.ltr=function(ae,de,fe){return We(ae,de,"<",fe)},e.gtr=function(ae,de,fe){return We(ae,de,">",fe)},e.outside=We,e.prerelease=function(ae,de){var fe=V(ae,de);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ae,de,fe){return ae=new Ee(ae,fe),de=new Ee(de,fe),ae.intersects(de)},e.coerce=function(ae){if(ae instanceof U)return ae;if(typeof ae!="string")return null;var de=ae.match(I[N]);return de==null?null:V((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,R(1))},function(Q,e){var R,r,D=Q.exports={};function L(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function I(P){if(R===setTimeout)return setTimeout(P,0);if((R===L||!R)&&setTimeout)return R=setTimeout,setTimeout(P,0);try{return R(P,0)}catch{try{return R.call(null,P,0)}catch{return R.call(this,P,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:L}catch{R=L}try{r=typeof clearTimeout=="function"?clearTimeout:T}catch{r=T}})();var E,C=[],b=!1,S=-1;function m(){b&&E&&(b=!1,E.length?C=E.concat(C):S=-1,C.length&&v())}function v(){if(!b){var P=I(m);b=!0;for(var p=C.length;p;){for(E=C,C=[];++S<p;)E&&E[S].run();S=-1,p=C.length}E=null,b=!1,function(g){if(r===clearTimeout)return clearTimeout(g);if((r===T||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(g);try{r(g)}catch{try{return r.call(null,g)}catch{return r.call(this,g)}}}(P)}}function h(P,p){this.fun=P,this.array=p}function y(){}D.nextTick=function(P){var p=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)p[g-1]=arguments[g];C.push(new h(P,p)),C.length!==1||b||I(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=y,D.addListener=y,D.once=y,D.off=y,D.removeListener=y,D.removeAllListeners=y,D.emit=y,D.prependListener=y,D.prependOnceListener=y,D.listeners=function(P){return[]},D.binding=function(P){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(P){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(ne[117],re([0,1]),function(Q,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class r{constructor(I,E,C){this.level=I,this.key=E,this.value=C,this.forward=[]}}const D=void 0;class L{constructor(I,E=2**16){this.comparator=I,this[R]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(E)|0),this._header=new r(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new r(this._maxLevel,D,D)}has(I){return Boolean(L._search(this,I,this.comparator))}get(I){return L._search(this,I,this.comparator)?.value}set(I,E){return L._insert(this,I,E,this.comparator)&&(this._size+=1),this}delete(I){const E=L._delete(this,I,this.comparator);return E&&(this._size-=1),E}forEach(I,E){let C=this._header.forward[0];for(;C;)I.call(E,C.value,C.key,this),C=C.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",E=this._header.forward[0];for(;E;)I+=`node(${E.key}, ${E.value}, lvl:${E.level})`,E=E.forward[0];return I}static _search(I,E,C){let b=I._header;for(let S=I._level-1;S>=0;S--)for(;b.forward[S]&&C(b.forward[S].key,E)<0;)b=b.forward[S];if(b=b.forward[0],b&&C(b.key,E)===0)return b}static _insert(I,E,C,b){const S=[];let m=I._header;for(let v=I._level-1;v>=0;v--){for(;m.forward[v]&&b(m.forward[v].key,E)<0;)m=m.forward[v];S[v]=m}if(m=m.forward[0],m&&b(m.key,E)===0)return m.value=C,!1;{const v=L._randomLevel(I);if(v>I._level){for(let h=I._level;h<v;h++)S[h]=I._header;I._level=v}m=new r(v,E,C);for(let h=0;h<v;h++)m.forward[h]=S[h].forward[h],S[h].forward[h]=m;return!0}}static _randomLevel(I,E=.5){let C=1;for(;Math.random()<E&&C<I._maxLevel;)C+=1;return C}static _delete(I,E,C){const b=[];let S=I._header;for(let m=I._level-1;m>=0;m--){for(;S.forward[m]&&C(S.forward[m].key,E)<0;)S=S.forward[m];b[m]=S}if(S=S.forward[0],!S||C(S.key,E)!==0)return!1;for(let m=0;m<I._level&&b[m].forward[m]===S;m++)b[m].forward[m]=S.forward[m];for(;I._level>0&&I._header.forward[I._level-1]===D;)I._level-=1;return!0}}e.SkipList=L}),define(ne[42],re([0,1,9,2]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(d){const l=d;return l?typeof l.read=="function":!1}e.isReadable=D;function L(d){const l=d;return l?[l.on,l.pause,l.resume,l.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=L;function T(d){const l=d;return l?L(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=T;function I(d,l){return new E(d,l)}e.newWriteableStream=I;class E{constructor(l,i){this.reducer=l,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l<"u"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(i=>i(l))}emitError(l){this.listeners.error.length===0?(0,R.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(i=>i(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,i){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(l,i){if(this.state.destroyed)return;let s;switch(l){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const t=s.indexOf(i);t>=0&&s.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(d,l){const i=[];let s;for(;(s=d.read())!==null;)i.push(s);return l(i)}e.consumeReadable=C;function b(d,l,i){const s=[];let t;for(;(t=d.read())!==null&&s.length<i;)s.push(t);return t===null&&s.length>0?l(s):{read:()=>{if(s.length>0)return s.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return d.read()}}}e.peekReadable=b;function S(d,l){return new Promise((i,s)=>{const t=[];m(d,{onData:n=>{l&&t.push(n)},onError:n=>{l?s(n):i(void 0)},onEnd:()=>{i(l?l(t):void 0)}})})}e.consumeStream=S;function m(d,l){let i=!1;return d.on("error",s=>{i||l.onError(s)}),d.on("end",()=>{i||l.onEnd()}),d.on("data",s=>{i||l.onData(s)}),(0,r.toDisposable)(()=>i=!0)}e.listenStream=m;function v(d,l){return new Promise((i,s)=>{const t=new r.DisposableStore,n=[],o=f=>{if(n.push(f),n.length>l)return t.dispose(),d.pause(),i({stream:d,buffer:n,ended:!1})},c=f=>s(f),u=()=>i({stream:d,buffer:n,ended:!0});t.add((0,r.toDisposable)(()=>d.removeListener("error",c))),d.on("error",c),t.add((0,r.toDisposable)(()=>d.removeListener("end",u))),d.on("end",u),t.add((0,r.toDisposable)(()=>d.removeListener("data",o))),d.on("data",o)})}e.peekStream=v;function h(d,l){const i=I(l);return i.end(d),i}e.toStream=h;function y(){const d=I(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=y;function P(d){let l=!1;return{read:()=>l?null:(l=!0,d)}}e.toReadable=P;function p(d,l,i){const s=I(i);return m(d,{onData:t=>s.write(l.data(t)),onError:t=>s.error(l.error?l.error(t):t),onEnd:()=>s.end()}),s}e.transform=p;function g(d,l,i){let s=!1;return{read:()=>{const t=l.read();return s?t:(s=!0,t!==null?i([d,t]):d)}}}e.prefixedReadable=g;function a(d,l,i){let s=!1;const t=I(i);return m(l,{onData:n=>s?t.write(n):(s=!0,t.write(i([d,n]))),onError:n=>t.error(n),onEnd:()=>{s||(s=!0,t.write(d)),t.end()}}),t}e.prefixedStream=a}),define(ne[16],re([0,1,42]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const r=typeof Buffer<"u";let D,L;class T{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return r?new T(Buffer.allocUnsafe(f)):new T(new Uint8Array(f))}static wrap(f){return r&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new T(f)}static fromString(f,w){return!(w?.dontUseNodeBuffer||!1)&&r?new T(Buffer.from(f)):(D||(D=new TextEncoder),new T(D.encode(f)))}static fromByteArray(f){const w=T.alloc(f.length);for(let _=0,N=f.length;_<N;_++)w.buffer[_]=f[_];return w}static concat(f,w){if(typeof w>"u"){w=0;for(let A=0,O=f.length;A<O;A++)w+=f[A].byteLength}const _=T.alloc(w);let N=0;for(let A=0,O=f.length;A<O;A++){const k=f[A];_.set(k,N),N+=k.byteLength}return _}clone(){const f=T.alloc(this.byteLength);return f.set(this),f}toString(){return r?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(f,w){return new T(this.buffer.subarray(f,w))}set(f,w){if(f instanceof T)this.buffer.set(f.buffer,w);else if(f instanceof Uint8Array)this.buffer.set(f,w);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),w);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return C(this.buffer,f)}writeUInt32BE(f,w){b(this.buffer,f,w)}readUInt32LE(f){return S(this.buffer,f)}writeUInt32LE(f,w){m(this.buffer,f,w)}readUInt8(f){return v(this.buffer,f)}writeUInt8(f,w){h(this.buffer,f,w)}}e.VSBuffer=T;function I(u,f){return u[f+0]<<0>>>0|u[f+1]<<8>>>0}e.readUInt16LE=I;function E(u,f,w){u[w+0]=f&255,f=f>>>8,u[w+1]=f&255}e.writeUInt16LE=E;function C(u,f){return u[f]*2**24+u[f+1]*2**16+u[f+2]*2**8+u[f+3]}e.readUInt32BE=C;function b(u,f,w){u[w+3]=f,f=f>>>8,u[w+2]=f,f=f>>>8,u[w+1]=f,f=f>>>8,u[w]=f}e.writeUInt32BE=b;function S(u,f){return u[f+0]<<0>>>0|u[f+1]<<8>>>0|u[f+2]<<16>>>0|u[f+3]<<24>>>0}e.readUInt32LE=S;function m(u,f,w){u[w+0]=f&255,f=f>>>8,u[w+1]=f&255,f=f>>>8,u[w+2]=f&255,f=f>>>8,u[w+3]=f&255}e.writeUInt32LE=m;function v(u,f){return u[f]}e.readUInt8=v;function h(u,f,w){u[w]=f}e.writeUInt8=h;function y(u){return R.consumeReadable(u,f=>T.concat(f))}e.readableToBuffer=y;function P(u){return R.toReadable(u)}e.bufferToReadable=P;function p(u){return R.consumeStream(u,f=>T.concat(f))}e.streamToBuffer=p;async function g(u){return u.ended?T.concat(u.buffer):T.concat([...u.buffer,await p(u.stream)])}e.bufferedStreamToBuffer=g;function a(u){return R.toStream(u,f=>T.concat(f))}e.bufferToStream=a;function d(u){return R.transform(u,{data:f=>typeof f=="string"?T.fromString(f):T.wrap(f)},f=>T.concat(f))}e.streamToBufferReadableStream=d;function l(u){return R.newWriteableStream(f=>T.concat(f),u)}e.newWriteableBufferStream=l;function i(u,f){return R.prefixedReadable(u,f,w=>T.concat(w))}e.prefixedBufferReadable=i;function s(u,f){return R.prefixedStream(u,f,w=>T.concat(w))}e.prefixedBufferStream=s;function t(u){let f=0,w=0,_=0;const N=new Uint8Array(Math.floor(u.length/4*3)),A=k=>{switch(w){case 3:N[_++]=f|k,w=0;break;case 2:N[_++]=f|k>>>2,f=k<<6,w=3;break;case 1:N[_++]=f|k>>>4,f=k<<4,w=2;break;default:f=k<<2,w=1}};for(let k=0;k<u.length;k++){const M=u.charCodeAt(k);if(M>=65&&M<=90)A(M-65);else if(M>=97&&M<=122)A(M-97+26);else if(M>=48&&M<=57)A(M-48+52);else if(M===43||M===45)A(62);else if(M===47||M===95)A(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${u[k]}`)}}const O=_;for(;w>0;)A(0);return T.wrap(N).slice(0,O)}e.decodeBase64=t;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:u},f=!0,w=!1){const _=w?o:n;let N="";const A=u.byteLength%3;let O=0;for(;O<u.byteLength-A;O+=3){const k=u[O+0],M=u[O+1],$=u[O+2];N+=_[k>>>2],N+=_[(k<<4|M>>>4)&63],N+=_[(M<<2|$>>>6)&63],N+=_[$&63]}if(A===1){const k=u[O+0];N+=_[k>>>2],N+=_[k<<4&63],f&&(N+="==")}else if(A===2){const k=u[O+0],M=u[O+1];N+=_[k>>>2],N+=_[(k<<4|M>>>4)&63],N+=_[M<<2&63],f&&(N+="=")}return N}e.encodeBase64=c}),define(ne[15],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function R(s){return typeof s=="string"}e.isString=R;function r(s){return Array.isArray(s)&&s.every(t=>R(t))}e.isStringArray=r;function D(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=D;function L(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}e.isTypedArray=L;function T(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=T;function I(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=I;function E(s){return s===!0||s===!1}e.isBoolean=E;function C(s){return typeof s>"u"}e.isUndefined=C;function b(s){return!S(s)}e.isDefined=b;function S(s){return C(s)||s===null}e.isUndefinedOrNull=S;function m(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=m;function v(s){if(S(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=v;function h(...s){const t=[];for(let n=0;n<s.length;n++){const o=s[n];if(S(o))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(o)}return t}e.assertAllDefined=h;const y=Object.prototype.hasOwnProperty;function P(s){if(!D(s))return!1;for(const t in s)if(y.call(s,t))return!1;return!0}e.isEmptyObject=P;function p(s){return typeof s=="function"}e.isFunction=p;function g(...s){return s.length>0&&s.every(p)}e.areFunctions=g;function a(s,t){const n=Math.min(s.length,t.length);for(let o=0;o<n;o++)d(s[o],t[o])}e.validateConstraints=a;function d(s,t){if(R(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(p(t)){try{if(s instanceof t)return}catch{}if(!S(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function l(s){return s===null?void 0:s}e.withNullAsUndefined=l;function i(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=i}),define(ne[32],re([0,1,15]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function r(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const g=Array.isArray(p)?[]:{};return Object.keys(p).forEach(a=>{p[a]&&typeof p[a]=="object"?g[a]=r(p[a]):g[a]=p[a]}),g}e.deepClone=r;function D(p){if(!p||typeof p!="object")return p;const g=[p];for(;g.length>0;){const a=g.shift();Object.freeze(a);for(const d in a)if(L.call(a,d)){const l=a[d];typeof l=="object"&&!Object.isFrozen(l)&&!(0,R.isTypedArray)(l)&&g.push(l)}}return p}e.deepFreeze=D;const L=Object.prototype.hasOwnProperty;function T(p,g){return I(p,g,new Set)}e.cloneAndChange=T;function I(p,g,a){if((0,R.isUndefinedOrNull)(p))return p;const d=g(p);if(typeof d<"u")return d;if(Array.isArray(p)){const l=[];for(const i of p)l.push(I(i,g,a));return l}if((0,R.isObject)(p)){if(a.has(p))throw new Error("Cannot clone recursive data-structure");a.add(p);const l={};for(const i in p)L.call(p,i)&&(l[i]=I(p[i],g,a));return a.delete(p),l}return p}function E(p,g,a=!0){return(0,R.isObject)(p)?((0,R.isObject)(g)&&Object.keys(g).forEach(d=>{d in p?a&&((0,R.isObject)(p[d])&&(0,R.isObject)(g[d])?E(p[d],g[d],a):p[d]=g[d]):p[d]=g[d]}),p):g}e.mixin=E;function C(p,g){if(p===g)return!0;if(p==null||g===null||g===void 0||typeof p!=typeof g||typeof p!="object"||Array.isArray(p)!==Array.isArray(g))return!1;let a,d;if(Array.isArray(p)){if(p.length!==g.length)return!1;for(a=0;a<p.length;a++)if(!C(p[a],g[a]))return!1}else{const l=[];for(d in p)l.push(d);l.sort();const i=[];for(d in g)i.push(d);if(i.sort(),!C(l,i))return!1;for(a=0;a<l.length;a++)if(!C(p[l[a]],g[l[a]]))return!1}return!0}e.equals=C;function b(p){const g=new Set;return JSON.stringify(p,(a,d)=>{if((0,R.isObject)(d)||Array.isArray(d)){if(g.has(d))return"[Circular]";g.add(d)}return d})}e.safeStringify=b;function S(p,g){const a=Object.create(null);return!p||!g||Object.keys(g).forEach(l=>{const i=p[l],s=g[l];C(i,s)||(a[l]=s)}),a}e.distinct=S;function m(p,g){const a=g.toLowerCase(),d=Object.keys(p).find(l=>l.toLowerCase()===a);return d?p[d]:p[g]}e.getCaseInsensitive=m;function v(p,g){const a=Object.create(null);for(const[d,l]of Object.entries(p))g(d,l)&&(a[d]=l);return a}e.filter=v;function h(p){let g=[],a=Object.getPrototypeOf(p);for(;Object.prototype!==a;)g=g.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return g}e.getAllPropertyNames=h;function y(p){const g=[];for(const a of h(p))typeof p[a]=="function"&&g.push(a);return g}e.getAllMethodNames=y;function P(p,g){const a=l=>function(){const i=Array.prototype.slice.call(arguments,0);return g(l,i)},d={};for(const l of p)d[l]=a(l);return d}e.createProxyObject=P}),define(ne[30],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(D){return R.test(D)}e.isUUID=r,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(I){for(let E=0;E<I.length;E++)I[E]=Math.floor(Math.random()*256);return I};const L=new Uint8Array(16),T=[];for(let I=0;I<256;I++)T.push(I.toString(16).padStart(2,"0"));return function(){D(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,C="";return C+=T[L[E++]],C+=T[L[E++]],C+=T[L[E++]],C+=T[L[E++]],C+="-",C+=T[L[E++]],C+=T[L[E++]],C+="-",C+=T[L[E++]],C+=T[L[E++]],C+="-",C+=T[L[E++]],C+=T[L[E++]],C+="-",C+=T[L[E++]],C+=T[L[E++]],C+=T[L[E++]],C+=T[L[E++]],C+=T[L[E++]],C+=T[L[E++]],C}}()}),define(ne[118],re([0,1,37]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(T){const I=T.replace(/\-/g,":").toLowerCase();return!r.has(I)}function L(){const T=(0,R.networkInterfaces)();for(const I in T){const E=T[I];if(E){for(const{mac:C}of E)if(D(C))return C}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(ne[119],re([0,1,80]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function r(I,E,C,b=1){let S=!1;return new Promise(m=>{const v=setTimeout(()=>{if(!S)return S=!0,m(0)},C);D(I,E,b,h=>{if(!S)return S=!0,clearTimeout(v),m(h)})})}e.findFreePort=r;function D(I,E,C,b){if(E===0)return b(0);const S=new R.Socket;S.once("connect",()=>(T(S),D(I+C,E-1,C,b))),S.once("data",()=>{}),S.once("error",m=>(T(S),m.code!=="ECONNREFUSED"?D(I+C,E-1,C,b):b(I))),S.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(I,E,C){let b=!1,S,m=1;const v=R.createServer({pauseOnConnect:!0});function h(y,P){b||(b=!0,v.removeAllListeners(),v.close(),S&&clearTimeout(S),P(y))}return new Promise(y=>{S=setTimeout(()=>{h(0,y)},C),v.on("listening",()=>{h(I,y)}),v.on("error",P=>{P&&(P.code==="EADDRINUSE"||P.code==="EACCES")&&m<E?(I++,m++,v.listen(I,"127.0.0.1")):h(0,y)}),v.on("close",()=>{h(0,y)}),v.listen(I,"127.0.0.1")})}e.findFreePortFaster=L;function T(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(E){console.error(E)}}}),define(ne[120],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const R="Offline";function r(L){return L instanceof D?!0:L instanceof Error&&L.name===R&&L.message===R}e.isOfflineError=r;class D extends Error{constructor(){super(R),this.name=this.message}}e.OfflineError=D}),define(ne[121],re([0,1,16,9,120]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(E,C){if(!navigator.onLine)throw new D.OfflineError;E.proxyAuthorization&&(E.headers={...E.headers||{},"Proxy-Authorization":E.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((S,m)=>{b.open(E.type||"GET",E.url||"",!0,E.user,E.password),T(b,E),b.responseType="arraybuffer",b.onerror=v=>m(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=v=>{S({res:{statusCode:b.status,headers:I(b)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=v=>m(new Error(`XHR timeout: ${E.timeout}ms`)),E.timeout&&(b.timeout=E.timeout),b.send(E.data),C.onCancellationRequested(()=>{b.abort(),m((0,r.canceled)())})})}e.request=L;function T(E,C){if(C.headers){e:for(const b in C.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}E.setRequestHeader(b,C.headers[b])}}}function I(E){const C=Object.create(null);for(const b of E.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const S=b.indexOf(":");C[b.substr(0,S).trim().toLowerCase()]=b.substr(S+1).trim()}return C}}),define(ne[122],re([10,11]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ne[63],re([0,1,122]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const r=60,D=r*60,L=D*24,T=L*7,I=L*30,E=L*365;function C(S,m,v){typeof S!="number"&&(S=S.getTime());const h=Math.round((new Date().getTime()-S)/1e3);if(h<-30)return(0,R.localize)(0,null,C(new Date().getTime()+h*1e3,!1));if(h<30)return(0,R.localize)(1,null);let y;return h<r?(y=h,m?y===1?v?(0,R.localize)(2,null,y):(0,R.localize)(3,null,y):v?(0,R.localize)(4,null,y):(0,R.localize)(5,null,y):y===1?v?(0,R.localize)(6,null,y):(0,R.localize)(7,null,y):v?(0,R.localize)(8,null,y):(0,R.localize)(9,null,y)):h<D?(y=Math.floor(h/r),m?y===1?v?(0,R.localize)(10,null,y):(0,R.localize)(11,null,y):v?(0,R.localize)(12,null,y):(0,R.localize)(13,null,y):y===1?v?(0,R.localize)(14,null,y):(0,R.localize)(15,null,y):v?(0,R.localize)(16,null,y):(0,R.localize)(17,null,y)):h<L?(y=Math.floor(h/D),m?y===1?v?(0,R.localize)(18,null,y):(0,R.localize)(19,null,y):v?(0,R.localize)(20,null,y):(0,R.localize)(21,null,y):y===1?v?(0,R.localize)(22,null,y):(0,R.localize)(23,null,y):v?(0,R.localize)(24,null,y):(0,R.localize)(25,null,y)):h<T?(y=Math.floor(h/L),m?y===1?(0,R.localize)(26,null,y):(0,R.localize)(27,null,y):y===1?(0,R.localize)(28,null,y):(0,R.localize)(29,null,y)):h<I?(y=Math.floor(h/T),m?y===1?v?(0,R.localize)(30,null,y):(0,R.localize)(31,null,y):v?(0,R.localize)(32,null,y):(0,R.localize)(33,null,y):y===1?v?(0,R.localize)(34,null,y):(0,R.localize)(35,null,y):v?(0,R.localize)(36,null,y):(0,R.localize)(37,null,y)):h<E?(y=Math.floor(h/I),m?y===1?v?(0,R.localize)(38,null,y):(0,R.localize)(39,null,y):v?(0,R.localize)(40,null,y):(0,R.localize)(41,null,y):y===1?v?(0,R.localize)(42,null,y):(0,R.localize)(43,null,y):v?(0,R.localize)(44,null,y):(0,R.localize)(45,null,y)):(y=Math.floor(h/E),m?y===1?v?(0,R.localize)(46,null,y):(0,R.localize)(47,null,y):v?(0,R.localize)(48,null,y):(0,R.localize)(49,null,y):y===1?v?(0,R.localize)(50,null,y):(0,R.localize)(51,null,y):v?(0,R.localize)(52,null,y):(0,R.localize)(53,null,y))}e.fromNow=C;function b(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(ne[123],re([10,11]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ne[38],re([0,1,19,15,123]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(S,m){return m&&(S.stack||S.stacktrace)?D.localize(0,null,I(S),T(S.stack)||T(S.stacktrace)):I(S)}function T(S){return Array.isArray(S)?S.join(`
`):S}function I(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?D.localize(1,null,S.message):S.message||D.localize(2,null)}function E(S=null,m=!1){if(!S)return D.localize(3,null);if(Array.isArray(S)){const v=R.coalesce(S),h=E(v[0],m);return v.length>1?D.localize(4,null,h,v.length):h}if(r.isString(S))return S;if(S.detail){const v=S.detail;if(v.error)return L(v.error,m);if(v.exception)return L(v.exception,m)}return S.stack?L(S,m):S.message?S.message:D.localize(5,null)}e.toErrorMessage=E;function C(S){const m=S;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=C;function b(S,m){let v;return typeof S=="string"?v=new Error(S):v=S,v.actions=m,v}e.createErrorWithActions=b}),define(ne[124],re([10,11]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(ne[125],re([0,1,124]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function r(D){switch(D){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}e.getParseErrorMessage=r}),define(ne[126],re([10,11]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(ne[4],re([0,1,126]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const r="en";let D=!1,L=!1,T=!1,I=!1,E=!1,C=!1,b=!1,S=!1,m=!1,v=!1,h,y=r,P,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?g=e.globals.vscode.process:typeof process<"u"&&(g=process);const a=typeof g?.versions?.electron=="string",d=a&&g?.type==="renderer";if(typeof navigator=="object"&&!d)p=navigator.userAgent,D=p.indexOf("Windows")>=0,L=p.indexOf("Macintosh")>=0,S=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=p.indexOf("Linux")>=0,v=p?.indexOf("Mobi")>=0,C=!0,h=R.getConfiguredDefaultLocale(R.localize(0,null))||r,y=h;else if(typeof g=="object"){D=g.platform==="win32",L=g.platform==="darwin",T=g.platform==="linux",I=T&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,b=a,m=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=r,y=r;const f=g.env.VSCODE_NLS_CONFIG;if(f)try{const w=JSON.parse(f),_=w.availableLanguages["*"];h=w.locale,y=_||r,P=w._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var l;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(l=e.Platform||(e.Platform={}));function i(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=i;let s=0;L?s=1:D?s=3:T&&(s=2),e.isWindows=D,e.isMacintosh=L,e.isLinux=T,e.isLinuxSnap=I,e.isNative=E,e.isElectron=b,e.isWeb=C,e.isWebWorker=C&&typeof e.globals.importScripts=="function",e.isIOS=S,e.isMobile=v,e.isCI=m,e.platform=s,e.userAgent=p,e.language=y;var t;(function(f){function w(){return e.language}f.value=w;function _(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}f.isDefaultVariant=_;function N(){return e.language==="en"}f.isDefault=N})(t=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=P,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const f=[];e.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeScheduleAsyncWork)for(let N=0,A=f.length;N<A;N++){const O=f[N];if(O.id===_.data.vscodeScheduleAsyncWork){f.splice(N,1),O.callback();return}}});let w=0;return _=>{const N=++w;f.push({id:N,callback:_}),e.globals.postMessage({vscodeScheduleAsyncWork:N},"*")}}return f=>setTimeout(f)})();var n;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||S?2:D?1:3;let o=!0,c=!1;function u(){if(!c){c=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,o=new Uint16Array(f.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[36],re([0,1,4]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let r;if(typeof R.globals.vscode<"u"&&typeof R.globals.vscode.process<"u"){const D=R.globals.vscode.process;r={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.platform=r.platform,e.arch=r.arch}),define(ne[12],re([0,1,36]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const r=65,D=97,L=90,T=122,I=46,E=47,C=92,b=58,S=63;class m extends Error{constructor(d,l,i){let s;typeof l=="string"&&l.indexOf("not ")===0?(s="must not be",l=l.replace(/^not /,"")):s="must be";const t=d.indexOf(".")!==-1?"property":"argument";let n=`The "${d}" ${t} ${s} of type ${l}`;n+=`. Received type ${typeof i}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function v(a,d){if(typeof a!="string")throw new m(d,"string",a)}function h(a){return a===E||a===C}function y(a){return a===E}function P(a){return a>=r&&a<=L||a>=D&&a<=T}function p(a,d,l,i){let s="",t=0,n=-1,o=0,c=0;for(let u=0;u<=a.length;++u){if(u<a.length)c=a.charCodeAt(u);else{if(i(c))break;c=E}if(i(c)){if(!(n===u-1||o===1))if(o===2){if(s.length<2||t!==2||s.charCodeAt(s.length-1)!==I||s.charCodeAt(s.length-2)!==I){if(s.length>2){const f=s.lastIndexOf(l);f===-1?(s="",t=0):(s=s.slice(0,f),t=s.length-1-s.lastIndexOf(l)),n=u,o=0;continue}else if(s.length!==0){s="",t=0,n=u,o=0;continue}}d&&(s+=s.length>0?`${l}..`:"..",t=2)}else s.length>0?s+=`${l}${a.slice(n+1,u)}`:s=a.slice(n+1,u),t=u-n-1;n=u,o=0}else c===I&&o!==-1?++o:o=-1}return s}function g(a,d){if(d===null||typeof d!="object")throw new m("pathObject","Object",d);const l=d.dir||d.root,i=d.base||`${d.name||""}${d.ext||""}`;return l?l===d.root?`${l}${i}`:`${l}${a}${i}`:i}e.win32={resolve(...a){let d="",l="",i=!1;for(let s=a.length-1;s>=-1;s--){let t;if(s>=0){if(t=a[s],v(t,"path"),t.length===0)continue}else d.length===0?t=R.cwd():(t=R.env[`=${d}`]||R.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==d.toLowerCase()&&t.charCodeAt(2)===C)&&(t=`${d}\\`));const n=t.length;let o=0,c="",u=!1;const f=t.charCodeAt(0);if(n===1)h(f)&&(o=1,u=!0);else if(h(f))if(u=!0,h(t.charCodeAt(1))){let w=2,_=w;for(;w<n&&!h(t.charCodeAt(w));)w++;if(w<n&&w!==_){const N=t.slice(_,w);for(_=w;w<n&&h(t.charCodeAt(w));)w++;if(w<n&&w!==_){for(_=w;w<n&&!h(t.charCodeAt(w));)w++;(w===n||w!==_)&&(c=`\\\\${N}\\${t.slice(_,w)}`,o=w)}}}else o=1;else P(f)&&t.charCodeAt(1)===b&&(c=t.slice(0,2),o=2,n>2&&h(t.charCodeAt(2))&&(u=!0,o=3));if(c.length>0)if(d.length>0){if(c.toLowerCase()!==d.toLowerCase())continue}else d=c;if(i){if(d.length>0)break}else if(l=`${t.slice(o)}\\${l}`,i=u,u&&d.length>0)break}return l=p(l,!i,"\\",h),i?`${d}\\${l}`:`${d}${l}`||"."},normalize(a){v(a,"path");const d=a.length;if(d===0)return".";let l=0,i,s=!1;const t=a.charCodeAt(0);if(d===1)return y(t)?"\\":a;if(h(t))if(s=!0,h(a.charCodeAt(1))){let o=2,c=o;for(;o<d&&!h(a.charCodeAt(o));)o++;if(o<d&&o!==c){const u=a.slice(c,o);for(c=o;o<d&&h(a.charCodeAt(o));)o++;if(o<d&&o!==c){for(c=o;o<d&&!h(a.charCodeAt(o));)o++;if(o===d)return`\\\\${u}\\${a.slice(c)}\\`;o!==c&&(i=`\\\\${u}\\${a.slice(c,o)}`,l=o)}}}else l=1;else P(t)&&a.charCodeAt(1)===b&&(i=a.slice(0,2),l=2,d>2&&h(a.charCodeAt(2))&&(s=!0,l=3));let n=l<d?p(a.slice(l),!s,"\\",h):"";return n.length===0&&!s&&(n="."),n.length>0&&h(a.charCodeAt(d-1))&&(n+="\\"),i===void 0?s?`\\${n}`:n:s?`${i}\\${n}`:`${i}${n}`},isAbsolute(a){v(a,"path");const d=a.length;if(d===0)return!1;const l=a.charCodeAt(0);return h(l)||d>2&&P(l)&&a.charCodeAt(1)===b&&h(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let d,l;for(let t=0;t<a.length;++t){const n=a[t];v(n,"path"),n.length>0&&(d===void 0?d=l=n:d+=`\\${n}`)}if(d===void 0)return".";let i=!0,s=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++s;const t=l.length;t>1&&h(l.charCodeAt(1))&&(++s,t>2&&(h(l.charCodeAt(2))?++s:i=!1))}if(i){for(;s<d.length&&h(d.charCodeAt(s));)s++;s>=2&&(d=`\\${d.slice(s)}`)}return e.win32.normalize(d)},relative(a,d){if(v(a,"from"),v(d,"to"),a===d)return"";const l=e.win32.resolve(a),i=e.win32.resolve(d);if(l===i||(a=l.toLowerCase(),d=i.toLowerCase(),a===d))return"";let s=0;for(;s<a.length&&a.charCodeAt(s)===C;)s++;let t=a.length;for(;t-1>s&&a.charCodeAt(t-1)===C;)t--;const n=t-s;let o=0;for(;o<d.length&&d.charCodeAt(o)===C;)o++;let c=d.length;for(;c-1>o&&d.charCodeAt(c-1)===C;)c--;const u=c-o,f=n<u?n:u;let w=-1,_=0;for(;_<f;_++){const A=a.charCodeAt(s+_);if(A!==d.charCodeAt(o+_))break;A===C&&(w=_)}if(_!==f){if(w===-1)return i}else{if(u>f){if(d.charCodeAt(o+_)===C)return i.slice(o+_+1);if(_===2)return i.slice(o+_)}n>f&&(a.charCodeAt(s+_)===C?w=_:_===2&&(w=3)),w===-1&&(w=0)}let N="";for(_=s+w+1;_<=t;++_)(_===t||a.charCodeAt(_)===C)&&(N+=N.length===0?"..":"\\..");return o+=w,N.length>0?`${N}${i.slice(o,c)}`:(i.charCodeAt(o)===C&&++o,i.slice(o,c))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const d=e.win32.resolve(a);if(d.length<=2)return a;if(d.charCodeAt(0)===C){if(d.charCodeAt(1)===C){const l=d.charCodeAt(2);if(l!==S&&l!==I)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(P(d.charCodeAt(0))&&d.charCodeAt(1)===b&&d.charCodeAt(2)===C)return`\\\\?\\${d}`;return a},dirname(a){v(a,"path");const d=a.length;if(d===0)return".";let l=-1,i=0;const s=a.charCodeAt(0);if(d===1)return h(s)?a:".";if(h(s)){if(l=i=1,h(a.charCodeAt(1))){let o=2,c=o;for(;o<d&&!h(a.charCodeAt(o));)o++;if(o<d&&o!==c){for(c=o;o<d&&h(a.charCodeAt(o));)o++;if(o<d&&o!==c){for(c=o;o<d&&!h(a.charCodeAt(o));)o++;if(o===d)return a;o!==c&&(l=i=o+1)}}}}else P(s)&&a.charCodeAt(1)===b&&(l=d>2&&h(a.charCodeAt(2))?3:2,i=l);let t=-1,n=!0;for(let o=d-1;o>=i;--o)if(h(a.charCodeAt(o))){if(!n){t=o;break}}else n=!1;if(t===-1){if(l===-1)return".";t=l}return a.slice(0,t)},basename(a,d){d!==void 0&&v(d,"ext"),v(a,"path");let l=0,i=-1,s=!0,t;if(a.length>=2&&P(a.charCodeAt(0))&&a.charCodeAt(1)===b&&(l=2),d!==void 0&&d.length>0&&d.length<=a.length){if(d===a)return"";let n=d.length-1,o=-1;for(t=a.length-1;t>=l;--t){const c=a.charCodeAt(t);if(h(c)){if(!s){l=t+1;break}}else o===-1&&(s=!1,o=t+1),n>=0&&(c===d.charCodeAt(n)?--n===-1&&(i=t):(n=-1,i=o))}return l===i?i=o:i===-1&&(i=a.length),a.slice(l,i)}for(t=a.length-1;t>=l;--t)if(h(a.charCodeAt(t))){if(!s){l=t+1;break}}else i===-1&&(s=!1,i=t+1);return i===-1?"":a.slice(l,i)},extname(a){v(a,"path");let d=0,l=-1,i=0,s=-1,t=!0,n=0;a.length>=2&&a.charCodeAt(1)===b&&P(a.charCodeAt(0))&&(d=i=2);for(let o=a.length-1;o>=d;--o){const c=a.charCodeAt(o);if(h(c)){if(!t){i=o+1;break}continue}s===-1&&(t=!1,s=o+1),c===I?l===-1?l=o:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||s===-1||n===0||n===1&&l===s-1&&l===i+1?"":a.slice(l,s)},format:g.bind(null,"\\"),parse(a){v(a,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return d;const l=a.length;let i=0,s=a.charCodeAt(0);if(l===1)return h(s)?(d.root=d.dir=a,d):(d.base=d.name=a,d);if(h(s)){if(i=1,h(a.charCodeAt(1))){let w=2,_=w;for(;w<l&&!h(a.charCodeAt(w));)w++;if(w<l&&w!==_){for(_=w;w<l&&h(a.charCodeAt(w));)w++;if(w<l&&w!==_){for(_=w;w<l&&!h(a.charCodeAt(w));)w++;w===l?i=w:w!==_&&(i=w+1)}}}}else if(P(s)&&a.charCodeAt(1)===b){if(l<=2)return d.root=d.dir=a,d;if(i=2,h(a.charCodeAt(2))){if(l===3)return d.root=d.dir=a,d;i=3}}i>0&&(d.root=a.slice(0,i));let t=-1,n=i,o=-1,c=!0,u=a.length-1,f=0;for(;u>=i;--u){if(s=a.charCodeAt(u),h(s)){if(!c){n=u+1;break}continue}o===-1&&(c=!1,o=u+1),s===I?t===-1?t=u:f!==1&&(f=1):t!==-1&&(f=-1)}return o!==-1&&(t===-1||f===0||f===1&&t===o-1&&t===n+1?d.base=d.name=a.slice(n,o):(d.name=a.slice(n,t),d.base=a.slice(n,o),d.ext=a.slice(t,o))),n>0&&n!==i?d.dir=a.slice(0,n-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let d="",l=!1;for(let i=a.length-1;i>=-1&&!l;i--){const s=i>=0?a[i]:R.cwd();v(s,"path"),s.length!==0&&(d=`${s}/${d}`,l=s.charCodeAt(0)===E)}return d=p(d,!l,"/",y),l?`/${d}`:d.length>0?d:"."},normalize(a){if(v(a,"path"),a.length===0)return".";const d=a.charCodeAt(0)===E,l=a.charCodeAt(a.length-1)===E;return a=p(a,!d,"/",y),a.length===0?d?"/":l?"./":".":(l&&(a+="/"),d?`/${a}`:a)},isAbsolute(a){return v(a,"path"),a.length>0&&a.charCodeAt(0)===E},join(...a){if(a.length===0)return".";let d;for(let l=0;l<a.length;++l){const i=a[l];v(i,"path"),i.length>0&&(d===void 0?d=i:d+=`/${i}`)}return d===void 0?".":e.posix.normalize(d)},relative(a,d){if(v(a,"from"),v(d,"to"),a===d||(a=e.posix.resolve(a),d=e.posix.resolve(d),a===d))return"";const l=1,i=a.length,s=i-l,t=1,n=d.length-t,o=s<n?s:n;let c=-1,u=0;for(;u<o;u++){const w=a.charCodeAt(l+u);if(w!==d.charCodeAt(t+u))break;w===E&&(c=u)}if(u===o)if(n>o){if(d.charCodeAt(t+u)===E)return d.slice(t+u+1);if(u===0)return d.slice(t+u)}else s>o&&(a.charCodeAt(l+u)===E?c=u:u===0&&(c=0));let f="";for(u=l+c+1;u<=i;++u)(u===i||a.charCodeAt(u)===E)&&(f+=f.length===0?"..":"/..");return`${f}${d.slice(t+c)}`},toNamespacedPath(a){return a},dirname(a){if(v(a,"path"),a.length===0)return".";const d=a.charCodeAt(0)===E;let l=-1,i=!0;for(let s=a.length-1;s>=1;--s)if(a.charCodeAt(s)===E){if(!i){l=s;break}}else i=!1;return l===-1?d?"/":".":d&&l===1?"//":a.slice(0,l)},basename(a,d){d!==void 0&&v(d,"ext"),v(a,"path");let l=0,i=-1,s=!0,t;if(d!==void 0&&d.length>0&&d.length<=a.length){if(d===a)return"";let n=d.length-1,o=-1;for(t=a.length-1;t>=0;--t){const c=a.charCodeAt(t);if(c===E){if(!s){l=t+1;break}}else o===-1&&(s=!1,o=t+1),n>=0&&(c===d.charCodeAt(n)?--n===-1&&(i=t):(n=-1,i=o))}return l===i?i=o:i===-1&&(i=a.length),a.slice(l,i)}for(t=a.length-1;t>=0;--t)if(a.charCodeAt(t)===E){if(!s){l=t+1;break}}else i===-1&&(s=!1,i=t+1);return i===-1?"":a.slice(l,i)},extname(a){v(a,"path");let d=-1,l=0,i=-1,s=!0,t=0;for(let n=a.length-1;n>=0;--n){const o=a.charCodeAt(n);if(o===E){if(!s){l=n+1;break}continue}i===-1&&(s=!1,i=n+1),o===I?d===-1?d=n:t!==1&&(t=1):d!==-1&&(t=-1)}return d===-1||i===-1||t===0||t===1&&d===i-1&&d===l+1?"":a.slice(d,i)},format:g.bind(null,"/"),parse(a){v(a,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return d;const l=a.charCodeAt(0)===E;let i;l?(d.root="/",i=1):i=0;let s=-1,t=0,n=-1,o=!0,c=a.length-1,u=0;for(;c>=i;--c){const f=a.charCodeAt(c);if(f===E){if(!o){t=c+1;break}continue}n===-1&&(o=!1,n=c+1),f===I?s===-1?s=c:u!==1&&(u=1):s!==-1&&(u=-1)}if(n!==-1){const f=t===0&&l?1:t;s===-1||u===0||u===1&&s===n-1&&s===t+1?d.base=d.name=a.slice(f,n):(d.name=a.slice(f,s),d.base=a.slice(f,n),d.ext=a.slice(s,n))}return t>0?d.dir=a.slice(0,t-1):l&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[127],re([0,1,12]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const r={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(b){const S=(0,R.extname)(b),m=r[S.toLowerCase()];return m!==void 0?m:T(b)}e.getMediaOrTextMime=L;function T(b){const S=(0,R.extname)(b);return D[S.toLowerCase()]}e.getMediaMime=T;function I(b){for(const S in D)if(D[S]===b)return S}e.getExtensionForMimeType=I;const E=/^(.+)\/(.+?)(;.+)?$/;function C(b,S){const m=E.exec(b);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:S?void 0:b}e.normalizeMimeType=C}),define(ne[81],re([0,1,4]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var r;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(r=e.Source||(e.Source={}));var D;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(I,...E){const C=E.reduce((m,v)=>(m[v]=!0,m),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(m=>!C[m]).forEach(m=>{for(let v=0;v<b.length;v++)if(m.search(b[v])!==-1){delete I[m];break}})}e.sanitizeProcessEnvironment=L;function T(I){!I||(delete I.DEBUG,R.isMacintosh&&delete I.DYLD_LIBRARY_PATH,R.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(ne[128],re([0,1,4]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const r=R.globals.performance&&typeof R.globals.performance.now=="function";class D{constructor(T){this._highResolution=r&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new D(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=D}),define(ne[3],re([0,1,9,78,2,116,128]),function(Q,e,R,r,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,E=!1;var C;(function(c){c.None=()=>D.Disposable.None;function u(F){if(E){const{onListenerDidAdd:j}=F,B=h.create();let Z=0;F.onListenerDidAdd=()=>{++Z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),B.print()),j?.()}}}function f(F){return(j,B=null,Z)=>{let oe=!1,X;return X=F(ie=>{if(!oe)return X?X.dispose():oe=!0,j.call(B,ie)},null,Z),oe&&X.dispose(),X}}c.once=f;function w(F,j,B){return M((Z,oe=null,X)=>F(ie=>Z.call(oe,j(ie)),null,X),B)}c.map=w;function _(F,j,B){return M((Z,oe=null,X)=>F(ie=>{j(ie),Z.call(oe,ie)},null,X),B)}c.forEach=_;function N(F,j,B){return M((Z,oe=null,X)=>F(ie=>j(ie)&&Z.call(oe,ie),null,X),B)}c.filter=N;function A(F){return F}c.signal=A;function O(...F){return(j,B=null,Z)=>(0,D.combinedDisposable)(...F.map(oe=>oe(X=>j.call(B,X),null,Z)))}c.any=O;function k(F,j,B,Z){let oe=B;return w(F,X=>(oe=j(oe,X),oe),Z)}c.reduce=k;function M(F,j){let B;const Z={onFirstListenerAdd(){B=F(oe.fire,oe)},onLastListenerRemove(){B?.dispose()}};j||u(Z);const oe=new P(Z);return j?.add(oe),oe.event}function $(F,j,B=100,Z=!1,oe,X){let ie,se,ue,he=0;const ve={leakWarningThreshold:oe,onFirstListenerAdd(){ie=F(Ee=>{he++,se=j(se,Ee),Z&&!ue&&(we.fire(se),se=void 0),clearTimeout(ue),ue=setTimeout(()=>{const Pe=se;se=void 0,ue=void 0,(!Z||he>1)&&we.fire(Pe),he=0},B)})},onLastListenerRemove(){ie.dispose()}};X||u(ve);const we=new P(ve);return X?.add(we),we.event}c.debounce=$;function W(F,j=(Z,oe)=>Z===oe,B){let Z=!0,oe;return N(F,X=>{const ie=Z||!j(X,oe);return Z=!1,oe=X,ie},B)}c.latch=W;function J(F,j,B){return[c.filter(F,j,B),c.filter(F,Z=>!j(Z),B)]}c.split=J;function H(F,j=!1,B=[]){let Z=B.slice(),oe=F(se=>{Z?Z.push(se):ie.fire(se)});const X=()=>{Z?.forEach(se=>ie.fire(se)),Z=null},ie=new P({onFirstListenerAdd(){oe||(oe=F(se=>ie.fire(se)))},onFirstListenerDidAdd(){Z&&(j?setTimeout(X):X())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return ie.event}c.buffer=H;class G{constructor(j){this.event=j,this.disposables=new D.DisposableStore}map(j){return new G(w(this.event,j,this.disposables))}forEach(j){return new G(_(this.event,j,this.disposables))}filter(j){return new G(N(this.event,j,this.disposables))}reduce(j,B){return new G(k(this.event,j,B,this.disposables))}latch(){return new G(W(this.event,void 0,this.disposables))}debounce(j,B=100,Z=!1,oe){return new G($(this.event,j,B,Z,oe,this.disposables))}on(j,B,Z){return this.event(j,B,Z)}once(j,B,Z){return f(this.event)(j,B,Z)}dispose(){this.disposables.dispose()}}function q(F){return new G(F)}c.chain=q;function x(F,j,B=Z=>Z){const Z=(...se)=>ie.fire(B(...se)),oe=()=>F.on(j,Z),X=()=>F.removeListener(j,Z),ie=new P({onFirstListenerAdd:oe,onLastListenerRemove:X});return ie.event}c.fromNodeEventEmitter=x;function Y(F,j,B=Z=>Z){const Z=(...se)=>ie.fire(B(...se)),oe=()=>F.addEventListener(j,Z),X=()=>F.removeEventListener(j,Z),ie=new P({onFirstListenerAdd:oe,onLastListenerRemove:X});return ie.event}c.fromDOMEventEmitter=Y;function te(F){return new Promise(j=>f(F)(j))}c.toPromise=te;function ce(F,j){return j(void 0),F(B=>j(B))}c.runAndSubscribe=ce;function z(F,j){let B=null;function Z(X){B?.dispose(),B=new D.DisposableStore,j(X,B)}Z(void 0);const oe=F(X=>Z(X));return(0,D.toDisposable)(()=>{oe.dispose(),B?.dispose()})}c.runAndSubscribeWithStore=z;class V{constructor(j,B){this.obs=j,this._counter=0,this._hasChanged=!1;const Z={onFirstListenerAdd:()=>{j.addObserver(this)},onLastListenerRemove:()=>{j.removeObserver(this)}};B||u(Z),this.emitter=new P(Z),B&&B.add(this.emitter)}beginUpdate(j){this._counter++}handleChange(j,B){this._hasChanged=!0}endUpdate(j){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function U(F,j){return new V(F,j).emitter.event}c.fromObservable=U})(C=e.Event||(e.Event={}));class b{constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${b._idPool++}`,b.all.add(this)}start(u){this._stopWatch=new T.StopWatch(!0),this.listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=b,b.all=new Set,b._idPool=0;let S=-1;function m(c){const u=S;return S=c,{dispose(){S=u}}}e.setGlobalLeakWarningThreshold=m;class v{constructor(u,f=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u,f){let w=S;if(typeof this.customThreshold=="number"&&(w=this.customThreshold),w<=0||f<w)return;this._stacks||(this._stacks=new Map);const _=this._stacks.get(u.value)||0;if(this._stacks.set(u.value,_+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=w*.5;let N,A=0;for(const[O,k]of this._stacks)(!N||A<k)&&(N=O,A=k);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${A}):`),console.warn(N)}return()=>{const N=this._stacks.get(u.value)||0;this._stacks.set(u.value,N-1)}}}class h{constructor(u){this.value=u}static create(){return new h(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y{constructor(u,f,w){this.callback=u,this.callbackThis=f,this.stack=w,this.subscription=new D.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class P{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=S>0?new v(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const u=Array.from(this._listeners);queueMicrotask(()=>{for(const f of u)f.subscription.isset()&&(f.subscription.unset(),f.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(u,f,w)=>{this._listeners||(this._listeners=new L.LinkedList);const _=this._listeners.isEmpty();_&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let N,A;this._leakageMon&&this._listeners.size>=30&&(A=h.create(),N=this._leakageMon.check(A,this._listeners.size+1)),I&&(A=A??h.create());const O=new y(u,f,A),k=this._listeners.push(O);_&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,f);const M=O.subscription.set(()=>{N?.(),this._disposed||(k(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return w instanceof D.DisposableStore?w.add(M):Array.isArray(w)&&w.push(M),M}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const f of this._listeners)this._deliveryQueue.push(this,f,u);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=P;class p{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(u,f,w){this._queue.push(new a(u,f,w))}clear(u){const f=new L.LinkedList;for(const w of this._queue)w.emitter!==u&&f.push(w);this._queue=f}deliver(){for(;this._queue.size>0;){const u=this._queue.shift();try{u.listener.invoke(u.event)}catch(f){(0,R.onUnexpectedError)(f)}}}}e.EventDeliveryQueue=p;class g extends p{clear(u){this._queue.clear()}}class a{constructor(u,f,w){this.emitter=u,this.listener=f,this.event=w}}class d extends P{async fireAsync(u,f,w){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const _ of this._listeners)this._asyncDeliveryQueue.push([_,u]);for(;this._asyncDeliveryQueue.size>0&&!f.isCancellationRequested;){const[_,N]=this._asyncDeliveryQueue.shift(),A=[],O={...N,token:f,waitUntil:k=>{if(Object.isFrozen(A))throw new Error("waitUntil can NOT be called asynchronous");w&&(k=w(k,_.callback)),A.push(k)}};try{_.invoke(O)}catch(k){(0,R.onUnexpectedError)(k);continue}Object.freeze(A),await Promise.allSettled(A).then(k=>{for(const M of k)M.status==="rejected"&&(0,R.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=d;class l extends P{constructor(u){super(u),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=l;class i extends l{constructor(u){super(u),this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=i;class s extends P{constructor(u){super(u),this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){!this.hasListeners()||(this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(f=>super.fire(f)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new P({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const f={event:u,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const w=()=>{this.hasListeners&&this.unhook(f);const _=this.events.indexOf(f);this.events.splice(_,1)};return(0,D.toDisposable)((0,r.once)(w))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(f=>this.emitter.fire(f))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class n{constructor(){this.buffers=[]}wrapEvent(u){return(f,w,_)=>u(N=>{const A=this.buffers[this.buffers.length-1];A?A.push(()=>f.call(w,N)):f.call(w,N)},void 0,_)}bufferEvents(u){const f=[];this.buffers.push(f);const w=u();return this.buffers.pop(),f.forEach(_=>_()),w}}e.EventBufferer=n;class o{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=D.Disposable.None,this.emitter=new P({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(ne[24],re([0,1,3]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const r=Object.freeze(function(I,E){const C=setTimeout(I.bind(E),0);return{dispose(){clearTimeout(C)}}});var D;(function(I){function E(C){return C===I.None||C===I.Cancelled||C instanceof L?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}I.isCancellationToken=E,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(D=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?r:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=D.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=T}),define(ne[129],re([0,1,24]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class r{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new R.CancellationTokenSource,E=this.task(I.token);return this.result={promise:E,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=r;class D{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const E=JSON.stringify(I);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=D;class L{constructor(I){this.fn=I,this._map=new Map}get cachedValues(){return this._map}get(I){if(this._map.has(I))return this._map.get(I);const E=this.fn(I);return this._map.set(I,E),E}}e.CachedFunction=L}),define(ne[82],re([0,1,3,2]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=T=>({onDidChange:R.Event.None,value:T});e.staticObservableValue=D;class L extends r.Disposable{constructor(I){super(),this._value=I,this.changeEmitter=this._register(new R.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(I){I!==this._value&&(this._value=I,this.changeEmitter.fire(I))}}e.MutableObservableValue=L}),define(ne[27],re([0,1,129,115]),function(Q,e,R,r){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.isFalsyOrWhitespace=L;const T=/{(\d+)}/g;function I(ee,...le){return le.length===0?ee:ee.replace(T,function(me,ge){const Se=parseInt(ge,10);return isNaN(Se)||Se<0||Se>=le.length?me:le[Se]})}e.format=I;const E=/{([^}]+)}/g;function C(ee,le){return ee.replace(E,(me,ge)=>le[ge]??me)}e.format2=C;function b(ee){return ee.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=b;function S(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function m(ee,le){let me=0;const ge=le.charCodeAt(0);for(let Se=ee.length-1;Se>=0;Se--)ee.charCodeAt(Se)===ge&&me++;return me}e.count=m;function v(ee,le,me="\u2026"){return ee.length<=le?ee:`${ee.substr(0,le)}${me}`}e.truncate=v;function h(ee,le=" "){const me=y(ee,le);return P(me,le)}e.trim=h;function y(ee,le){if(!ee||!le)return ee;const me=le.length;if(me===0||ee.length===0)return ee;let ge=0;for(;ee.indexOf(le,ge)===ge;)ge=ge+me;return ee.substring(ge)}e.ltrim=y;function P(ee,le){if(!ee||!le)return ee;const me=le.length,ge=ee.length;if(me===0||ge===0)return ee;let Se=ge,be=-1;for(;be=ee.lastIndexOf(le,Se-1),!(be===-1||be+me!==Se);){if(be===0)return"";Se=be}return ee.substring(0,Se)}e.rtrim=P;function p(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function g(ee){return ee.replace(/\*/g,"")}e.stripWildcards=g;function a(ee,le,me={}){if(!ee)throw new Error("Cannot create regex from empty string");le||(ee=S(ee)),me.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let ge="";return me.global&&(ge+="g"),me.matchCase||(ge+="i"),me.multiline&&(ge+="m"),me.unicode&&(ge+="u"),new RegExp(ee,ge)}e.createRegExp=a;function d(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function l(ee){return!!ee.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function i(ee){return(ee.global?"g":"")+(ee.ignoreCase?"i":"")+(ee.multiline?"m":"")+(ee.unicode?"u":"")}e.regExpFlags=i;function s(ee){return ee.split(/\r\n|\r|\n/)}e.splitLines=s;function t(ee){for(let le=0,me=ee.length;le<me;le++){const ge=ee.charCodeAt(le);if(ge!==32&&ge!==9)return le}return-1}e.firstNonWhitespaceIndex=t;function n(ee,le=0,me=ee.length){for(let ge=le;ge<me;ge++){const Se=ee.charCodeAt(ge);if(Se!==32&&Se!==9)return ee.substring(le,ge)}return ee.substring(le,me)}e.getLeadingWhitespace=n;function o(ee,le=ee.length-1){for(let me=le;me>=0;me--){const ge=ee.charCodeAt(me);if(ge!==32&&ge!==9)return me}return-1}e.lastNonWhitespaceIndex=o;function c(ee,le,me){const ge=[];let Se=0;for(const be of ee.matchAll(le)){if(ge.push(ee.slice(Se,be.index)),be.index===void 0)throw new Error("match.index should be defined");Se=be.index+be[0].length,ge.push(me(be[0],...be.slice(1),be.index,ee,be.groups))}return ge.push(ee.slice(Se)),Promise.all(ge).then(be=>be.join(""))}e.replaceAsync=c;function u(ee,le){return ee<le?-1:ee>le?1:0}e.compare=u;function f(ee,le,me=0,ge=ee.length,Se=0,be=le.length){for(;me<ge&&Se<be;me++,Se++){const qe=ee.charCodeAt(me),Le=le.charCodeAt(Se);if(qe<Le)return-1;if(qe>Le)return 1}const Re=ge-me,Te=be-Se;return Re<Te?-1:Re>Te?1:0}e.compareSubstring=f;function w(ee,le){return _(ee,le,0,ee.length,0,le.length)}e.compareIgnoreCase=w;function _(ee,le,me=0,ge=ee.length,Se=0,be=le.length){for(;me<ge&&Se<be;me++,Se++){let qe=ee.charCodeAt(me),Le=le.charCodeAt(Se);if(qe===Le)continue;if(qe>=128||Le>=128)return f(ee.toLowerCase(),le.toLowerCase(),me,ge,Se,be);A(qe)&&(qe-=32),A(Le)&&(Le-=32);const Ne=qe-Le;if(Ne!==0)return Ne}const Re=ge-me,Te=be-Se;return Re<Te?-1:Re>Te?1:0}e.compareSubstringIgnoreCase=_;function N(ee){return ee>=48&&ee<=57}e.isAsciiDigit=N;function A(ee){return ee>=97&&ee<=122}e.isLowerAsciiLetter=A;function O(ee){return ee>=65&&ee<=90}e.isUpperAsciiLetter=O;function k(ee,le){return ee.length===le.length&&_(ee,le)===0}e.equalsIgnoreCase=k;function M(ee,le){const me=le.length;return le.length>ee.length?!1:_(ee,le,0,me)===0}e.startsWithIgnoreCase=M;function $(ee,le){const me=Math.min(ee.length,le.length);let ge;for(ge=0;ge<me;ge++)if(ee.charCodeAt(ge)!==le.charCodeAt(ge))return ge;return me}e.commonPrefixLength=$;function W(ee,le){const me=Math.min(ee.length,le.length);let ge;const Se=ee.length-1,be=le.length-1;for(ge=0;ge<me;ge++)if(ee.charCodeAt(Se-ge)!==le.charCodeAt(be-ge))return ge;return me}e.commonSuffixLength=W;function J(ee){return 55296<=ee&&ee<=56319}e.isHighSurrogate=J;function H(ee){return 56320<=ee&&ee<=57343}e.isLowSurrogate=H;function G(ee,le){return(ee-55296<<10)+(le-56320)+65536}e.computeCodePoint=G;function q(ee,le,me){const ge=ee.charCodeAt(me);if(J(ge)&&me+1<le){const Se=ee.charCodeAt(me+1);if(H(Se))return G(ge,Se)}return ge}e.getNextCodePoint=q;function x(ee,le){const me=ee.charCodeAt(le-1);if(H(me)&&le>1){const ge=ee.charCodeAt(le-2);if(J(ge))return G(ge,me)}return me}class Y{constructor(le,me=0){this._str=le,this._len=le.length,this._offset=me}get offset(){return this._offset}setOffset(le){this._offset=le}prevCodePoint(){const le=x(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=q(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=Y;class te{constructor(le,me=0){this._iterator=new Y(le,me)}get offset(){return this._iterator.offset}nextGraphemeLength(){const le=Ie.getInstance(),me=this._iterator,ge=me.offset;let Se=le.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const be=me.offset,Re=le.getGraphemeBreakType(me.nextCodePoint());if(fe(Se,Re)){me.setOffset(be);break}Se=Re}return me.offset-ge}prevGraphemeLength(){const le=Ie.getInstance(),me=this._iterator,ge=me.offset;let Se=le.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const be=me.offset,Re=le.getGraphemeBreakType(me.prevCodePoint());if(fe(Re,Se)){me.setOffset(be);break}Se=Re}return ge-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=te;function ce(ee,le){return new te(ee,le).nextGraphemeLength()}e.nextCharLength=ce;function z(ee,le){return new te(ee,le).prevGraphemeLength()}e.prevCharLength=z;function V(ee,le){le>0&&H(ee.charCodeAt(le))&&le--;const me=le+ce(ee,le);return[me-z(ee,me),me]}e.getCharContainingOffset=V;let U;function F(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(ee){return U||(U=F()),U.test(ee)}e.containsRTL=j;const B=/^[\t\n\r\x20-\x7E]*$/;function Z(ee){return B.test(ee)}e.isBasicASCII=Z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(ee){return e.UNUSUAL_LINE_TERMINATORS.test(ee)}e.containsUnusualLineTerminators=oe;function X(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.isFullWidthCharacter=X;function ie(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.isEmojiImprecise=ie;function se(ee,le){if(ee.length<le)return ee;const me=/\b/g;let ge=0;for(;me.test(ee)&&!(ee.length-me.lastIndex<le);)ge=me.lastIndex,me.lastIndex+=1;return ee.substring(ge).replace(/^\s/,"")}e.lcut=se;const ue=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function we(ee){return ee&&(ee=ee.replace(ue,""),ee=ee.replace(he,""),ee=ee.replace(ve,"")),ee}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Pe(ee){return Ee(ee)?ee.substr(1):ee}e.stripUTF8BOM=Pe;function Ue(ee,le){if(!ee||!le||ee.length<le.length)return!1;const me=le.length,ge=ee.toLowerCase();let Se=0,be=-1;for(;Se<me;){const Re=ge.indexOf(le[Se],be+1);if(Re<0)return!1;be=Re,Se++}return!0}e.fuzzyContains=Ue;function ze(ee,le=!1){return ee?(le&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.containsUppercaseCharacter=ze;function Ve(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.uppercaseFirstLetter=Ve;function We(ee,le=1){if(le===0)return"";let me=-1;do me=ee.indexOf(`
`,me+1),le--;while(le>0&&me>=0);return me===-1?ee:(ee[me-1]==="\r"&&me--,ee.substr(0,me))}e.getNLines=We;function ae(ee){return ee=ee%(2*26),ee<26?String.fromCharCode(97+ee):String.fromCharCode(65+ee-26)}e.singleLetterHash=ae;function de(ee){return Ie.getInstance().getGraphemeBreakType(ee)}e.getGraphemeBreakType=de;function fe(ee,le){return ee===0?le!==5&&le!==7:ee===2&&le===3?!1:ee===4||ee===2||ee===3||le===4||le===2||le===3?!0:!(ee===8&&(le===8||le===9||le===11||le===12)||(ee===11||ee===9)&&(le===9||le===10)||(ee===12||ee===10)&&le===10||le===5||le===13||le===7||ee===1||ee===13&&le===14||ee===6&&le===6)}var Ce;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{constructor(){this._data=Me()}static getInstance(){return Ie._INSTANCE||(Ie._INSTANCE=new Ie),Ie._INSTANCE}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const me=this._data,ge=me.length/3;let Se=1;for(;Se<=ge;)if(le<me[3*Se])Se=2*Se;else if(le>me[3*Se+1])Se=2*Se+1;else return me[3*Se+2];return 0}}Ie._INSTANCE=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(ee,le){if(ee===0)return 0;const me=$e(ee,le);if(me!==void 0)return me;const ge=new Y(le,ee);return ge.prevCodePoint(),ge.offset}e.getLeftDeleteOffset=De;function $e(ee,le){const me=new Y(le,ee);let ge=me.prevCodePoint();for(;Ae(ge)||ge===65039||ge===8419;){if(me.offset===0)return;ge=me.prevCodePoint()}if(!ie(ge))return;let Se=me.offset;return Se>0&&me.prevCodePoint()===8205&&(Se=me.offset),Se}function Ae(ee){return 127995<=ee&&ee<=127999}var Fe;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class _e{constructor(le){this.confusableDictionary=le}static getInstance(le){return _e.cache.get(Array.from(le))}static getLocales(){return _e._locales.getValue()}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=_e,D=_e,_e.ambiguousCharacterData=new r.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),_e.cache=new R.LRUCachedFunction(ee=>{function le(Le){const Ne=new Map;for(let xe=0;xe<Le.length;xe+=2)Ne.set(Le[xe],Le[xe+1]);return Ne}function me(Le,Ne){const xe=new Map(Le);for(const[Xe,Ze]of Ne)xe.set(Xe,Ze);return xe}function ge(Le,Ne){if(!Le)return Ne;const xe=new Map;for(const[Xe,Ze]of Le)Ne.has(Xe)&&xe.set(Xe,Ze);return xe}const Se=D.ambiguousCharacterData.getValue();let be=ee.filter(Le=>!Le.startsWith("_")&&Le in Se);be.length===0&&(be=["_default"]);let Re;for(const Le of be){const Ne=le(Se[Le]);Re=ge(Re,Ne)}const Te=le(Se._common),qe=me(Te,Re);return new _e(qe)}),_e._locales=new r.Lazy(()=>Object.keys(_e.ambiguousCharacterData.getValue()).filter(ee=>!ee.startsWith("_")));class ke{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ke.getRawData())),this._data}static isInvisibleCharacter(le){return ke.getData().has(le)}static get codePoints(){return ke.getData()}}e.InvisibleCharacters=ke,ke._data=void 0}),define(ne[47],re([0,1,12,4,27,15]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(o){return o===47||o===92}e.isPathSeparator=T;function I(o){return o.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=I;function E(o){return o.indexOf("/")===-1&&(o=I(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=E;function C(o,c=R.posix.sep){if(!o)return"";const u=o.length,f=o.charCodeAt(0);if(T(f)){if(T(o.charCodeAt(1))&&!T(o.charCodeAt(2))){let _=3;const N=_;for(;_<u&&!T(o.charCodeAt(_));_++);if(N!==_&&!T(o.charCodeAt(_+1))){for(_+=1;_<u;_++)if(T(o.charCodeAt(_)))return o.slice(0,_+1).replace(/[\\/]/g,c)}}return c}else if(p(f)&&o.charCodeAt(1)===58)return T(o.charCodeAt(2))?o.slice(0,2)+c:o.slice(0,2);let w=o.indexOf("://");if(w!==-1){for(w+=3;w<u;w++)if(T(o.charCodeAt(w)))return o.slice(0,w+1)}return""}e.getRoot=C;function b(o){if(!r.isWindows||!o||o.length<5)return!1;let c=o.charCodeAt(0);if(c!==92||(c=o.charCodeAt(1),c!==92))return!1;let u=2;const f=u;for(;u<o.length&&(c=o.charCodeAt(u),c!==92);u++);return!(f===u||(c=o.charCodeAt(u+1),isNaN(c)||c===92))}e.isUNC=b;const S=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(o,c=r.isWindows){const u=c?S:m;return!(!o||o.length===0||/^\s+$/.test(o)||(u.lastIndex=0,u.test(o))||c&&v.test(o)||o==="."||o===".."||c&&o[o.length-1]==="."||c&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=h;function y(o,c,u){const f=o===c;return!u||f?f:!o||!c?!1:(0,D.equalsIgnoreCase)(o,c)}e.isEqual=y;function P(o,c,u,f=R.sep){if(o===c)return!0;if(!o||!c||c.length>o.length)return!1;if(u){if(!(0,D.startsWithIgnoreCase)(o,c))return!1;if(c.length===o.length)return!0;let _=c.length;return c.charAt(c.length-1)===f&&_--,o.charAt(_)===f}return c.charAt(c.length-1)!==f&&(c+=f),o.indexOf(c)===0}e.isEqualOrParent=P;function p(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=p;function g(o,c){return r.isWindows&&o.endsWith(":")&&(o+=R.sep),(0,R.isAbsolute)(o)||(o=(0,R.join)(c,o)),o=(0,R.normalize)(o),r.isWindows?(o=(0,D.rtrim)(o,R.sep),o.endsWith(":")&&(o+=R.sep)):(o=(0,D.rtrim)(o,R.sep),o||(o=R.sep)),o}e.sanitizeFilePath=g;function a(o){const c=(0,R.normalize)(o);return r.isWindows?o.length>3?!1:d(c)&&(o.length===2||c.charCodeAt(2)===92):c===R.posix.sep}e.isRootOrDriveLetter=a;function d(o,c=r.isWindows){return c?p(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function l(o){return d(o)?o[0]:void 0}e.getDriveLetter=l;function i(o,c,u){return c.length>o.length?-1:o===c?0:(u&&(o=o.toLowerCase(),c=c.toLowerCase()),o.indexOf(c))}e.indexOfPath=i;function s(o){const c=o.split(":");let u,f,w;for(const _ of c){const N=Number(_);(0,L.isNumber)(N)?f===void 0?f=N:w===void 0&&(w=N):u=u?[u,_].join(":"):_}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:f!==void 0?f:void 0,column:w!==void 0?w:f!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,c,u=8){let f="";for(let _=0;_<u;_++)f+=t.charAt(Math.floor(Math.random()*t.length));let w;return c?w=`${c}-${f}`:w=f,o?(0,R.join)(o,w):w}e.randomPath=n}),define(ne[64],re([0,1,27]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function r(p){return D(p,0)}e.hash=r;function D(p,g){switch(typeof p){case"object":return p===null?L(349,g):Array.isArray(p)?E(p,g):C(p,g);case"string":return I(p,g);case"boolean":return T(p,g);case"number":return L(p,g);case"undefined":return L(937,g);default:return L(617,g)}}e.doHash=D;function L(p,g){return(g<<5)-g+p|0}e.numberHash=L;function T(p,g){return L(p?433:863,g)}function I(p,g){g=L(149417,g);for(let a=0,d=p.length;a<d;a++)g=L(p.charCodeAt(a),g);return g}e.stringHash=I;function E(p,g){return g=L(104579,g),p.reduce((a,d)=>D(d,a),g)}function C(p,g){return g=L(181387,g),Object.keys(p).sort().reduce((a,d)=>(a=I(d,a),D(p[d],a)),g)}class b{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=D(g,this._value),this._value}}e.Hasher=b;var S;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function m(p,g,a=32){const d=a-g,l=~((1<<d)-1);return(p<<g|(l&p)>>>d)>>>0}function v(p,g=0,a=p.byteLength,d=0){for(let l=0;l<a;l++)p[g+l]=d}function h(p,g,a="0"){for(;p.length<g;)p=a+p;return p}function y(p,g=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(a=>a.toString(16).padStart(2,"0")).join(""):h((p>>>0).toString(16),g/4)}e.toHexString=y;class P{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const a=g.length;if(a===0)return;const d=this._buff;let l=this._buffLen,i=this._leftoverHighSurrogate,s,t;for(i!==0?(s=i,t=-1,i=0):(s=g.charCodeAt(0),t=0);;){let n=s;if(R.isHighSurrogate(s))if(t+1<a){const o=g.charCodeAt(t+1);R.isLowSurrogate(o)?(t++,n=R.computeCodePoint(s,o)):n=65533}else{i=s;break}else R.isLowSurrogate(s)&&(n=65533);if(l=this._push(d,l,n),t++,t<a)s=g.charCodeAt(t);else break}this._buffLen=l,this._leftoverHighSurrogate=i}_push(g,a,d){return d<128?g[a++]=d:d<2048?(g[a++]=192|(d&1984)>>>6,g[a++]=128|(d&63)>>>0):d<65536?(g[a++]=224|(d&61440)>>>12,g[a++]=128|(d&4032)>>>6,g[a++]=128|(d&63)>>>0):(g[a++]=240|(d&1835008)>>>18,g[a++]=128|(d&258048)>>>12,g[a++]=128|(d&4032)>>>6,g[a++]=128|(d&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=P._bigBlock32,a=this._buffDV;for(let u=0;u<64;u+=4)g.setUint32(u,a.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)g.setUint32(u,m(g.getUint32(u-12,!1)^g.getUint32(u-32,!1)^g.getUint32(u-56,!1)^g.getUint32(u-64,!1),1),!1);let d=this._h0,l=this._h1,i=this._h2,s=this._h3,t=this._h4,n,o,c;for(let u=0;u<80;u++)u<20?(n=l&i|~l&s,o=1518500249):u<40?(n=l^i^s,o=1859775393):u<60?(n=l&i|l&s|i&s,o=2400959708):(n=l^i^s,o=3395469782),c=m(d,5)+n+t+o+g.getUint32(u*4,!1)&4294967295,t=s,s=i,i=m(l,30),l=d,d=c;this._h0=this._h0+d&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=P,P._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ne[34],re([0,1,19,27]),function(Q,e,R,r){"use strict";var D,L,T;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(t,n,o){let c=t.get(n);return c===void 0&&(c=o,t.set(n,c)),c}e.getOrSet=I;function E(t){const n=[];return t.forEach((o,c)=>{n.push(`${c} => ${o}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=E;function C(t){const n=[];return t.forEach(o=>{n.push(o)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=C;class b{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),c=this._value.charCodeAt(this._pos);return o-c}value(){return this._value[this._pos]}}e.StringIterator=b;class S{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,r.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class m{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let o=n.length-1;o>=0;o--,this._valueLen--){const c=this._value.charCodeAt(o);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,r.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var v;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(n,o){this._ignorePathCasing=n,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,r.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,r.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,r.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,r.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(t){t[t.Left=-1]="Left",t[t.Mid=0]="Mid",t[t.Right=1]="Right"})(P||(P={}));class p{constructor(n){this._iter=n}static forUris(n=()=>!1,o=()=>!1){return new p(new h(n,o))}static forPaths(n=!1){return new p(new m(void 0,!n))}static forStrings(){return new p(new b)}static forConfigKeys(){return new p(new S)}clear(){this._root=void 0}fill(n,o){if(o){const c=o.slice(0);(0,R.shuffle)(c);for(const u of c)this.set(u,n)}else{const c=n.slice(0);(0,R.shuffle)(c);for(const u of c)this.set(u[0],u[1])}}set(n,o){const c=this._iter.reset(n);let u;this._root||(this._root=new y,this._root.segment=c.value());const f=[];for(u=this._root;;){const _=c.cmp(u.segment);if(_>0)u.left||(u.left=new y,u.left.segment=c.value()),f.push([-1,u]),u=u.left;else if(_<0)u.right||(u.right=new y,u.right.segment=c.value()),f.push([1,u]),u=u.right;else if(c.hasNext())c.next(),u.mid||(u.mid=new y,u.mid.segment=c.value()),f.push([0,u]),u=u.mid;else break}const w=u.value;u.value=o,u.key=n;for(let _=f.length-1;_>=0;_--){const N=f[_][1];N.updateHeight();const A=N.balanceFactor();if(A<-1||A>1){const O=f[_][0],k=f[_+1][0];if(O===1&&k===1)f[_][1]=N.rotateLeft();else if(O===-1&&k===-1)f[_][1]=N.rotateRight();else if(O===1&&k===-1)N.right=f[_+1][1]=f[_+1][1].rotateRight(),f[_][1]=N.rotateLeft();else if(O===-1&&k===1)N.left=f[_+1][1]=f[_+1][1].rotateLeft(),f[_][1]=N.rotateRight();else throw new Error;if(_>0)switch(f[_-1][0]){case-1:f[_-1][1].left=f[_][1];break;case 1:f[_-1][1].right=f[_][1];break;case 0:f[_-1][1].mid=f[_][1];break}else this._root=f[0][1]}}return w}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let c=this._root;for(;c;){const u=o.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(o.hasNext())o.next(),c=c.mid;else break}return c}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const c=this._iter.reset(n),u=[];let f=this._root;for(;f;){const w=c.cmp(f.segment);if(w>0)u.push([-1,f]),f=f.left;else if(w<0)u.push([1,f]),f=f.right;else if(c.hasNext())c.next(),u.push([0,f]),f=f.mid;else break}if(!!f){if(o?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const w=this._min(f.right),{key:_,value:N,segment:A}=w;this._delete(w.key,!1),f.key=_,f.value=N,f.segment=A}else{const w=f.left??f.right;if(u.length>0){const[_,N]=u[u.length-1];switch(_){case-1:N.left=w;break;case 0:N.mid=w;break;case 1:N.right=w;break}}else this._root=w}for(let w=u.length-1;w>=0;w--){const _=u[w][1];_.updateHeight();const N=_.balanceFactor();if(N>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),u[w][1]=_.rotateLeft()):N<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),u[w][1]=_.rotateRight()),w>0)switch(u[w-1][0]){case-1:u[w-1][1].left=u[w][1];break;case 1:u[w-1][1].right=u[w][1];break;case 0:u[w-1][1].mid=u[w][1];break}else this._root=u[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let c=this._root,u;for(;c;){const f=o.cmp(c.segment);if(f>0)c=c.left;else if(f<0)c=c.right;else if(o.hasNext())o.next(),u=c.value||u,c=c.mid;else break}return c&&c.value||u}findSuperstr(n){const o=this._iter.reset(n);let c=this._root;for(;c;){const u=o.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(o.hasNext())o.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(n){for(const[o,c]of this)n(c,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const o=[];return this._dfsEntries(n,o),o[Symbol.iterator]()}_dfsEntries(n,o){!n||(n.left&&this._dfsEntries(n.left,o),n.value&&o.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,o),n.right&&this._dfsEntries(n.right,o))}_isBalanced(){const n=o=>{if(!o)return!0;const c=o.balanceFactor();return c<-1||c>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=p;class g{constructor(n,o){this.uri=n,this.value=o}}class a{constructor(n,o){this[D]="ResourceMap",n instanceof a?(this.map=new Map(n.map),this.toKey=o??a.defaultToKey):(this.map=new Map,this.toKey=n??a.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new g(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[c,u]of this.map)n(u.value,u.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=a,a.defaultToKey=t=>t.toString();class d{constructor(n,o){this[L]="ResourceSet",!n||typeof n=="function"?this._map=new a(n):(this._map=new a(o),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,o){this._map.forEach((c,u)=>n.call(o,u,u,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=d;var l;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class i{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const c=this._map.get(n);if(!!c)return o!==0&&this.touch(c,o),c.value}set(n,o,c=0){let u=this._map.get(n);if(u)u.value=o,c!==0&&this.touch(u,c);else{switch(u={key:n,value:o,next:void 0,previous:void 0},c){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(n,u),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const c=this._state;let u=this._head;for(;u;){if(o?n.bind(o)(u.value,u.key,this):n(u.value,u.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,o=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:c.key,done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return u}values(){const n=this,o=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:c.value,done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return u}entries(){const n=this,o=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:[c.key,c.value],done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return u}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,c=this.size;for(;o&&c>n;)this._map.delete(o.key),o=o.next,c--;this._head=o,this._size=c,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,c=n.previous;if(!o||!c)throw new Error("Invalid list");o.previous=c,c.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const c=n.next,u=n.previous;n===this._tail?(u.next=void 0,this._tail=u):(c.previous=u,u.next=c),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const c=n.next,u=n.previous;n===this._head?(c.previous=void 0,this._head=c):(c.previous=u,u.next=c),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,c)=>{n.push([c,o])}),n}fromJSON(n){this.clear();for(const[o,c]of n)this.set(o,c)}}e.LinkedMap=i;class s extends i{constructor(n,o=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s}),define(ne[83],re([0,1,34]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const r=new R.LRUCache(1e4);function D(C){return E(C,"NFC",r)}e.normalizeNFC=D;const L=new R.LRUCache(1e4);function T(C){return E(C,"NFD",L)}e.normalizeNFD=T;const I=/[^\u0000-\u0080]/;function E(C,b,S){if(!C)return C;const m=S.get(C);if(m)return m;let v;return I.test(C)?v=C.normalize(b):v=C,S.set(C,v),v}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(b){return T(b).replace(C,"")}}()}),define(ne[84],re([0,1,27]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var r;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(r||(r={})),function(D){const L="error",T="warning",I="warn",E="info",C="ignore";function b(m){return m?R.equalsIgnoreCase(L,m)?D.Error:R.equalsIgnoreCase(T,m)||R.equalsIgnoreCase(I,m)?D.Warning:R.equalsIgnoreCase(E,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=b;function S(m){switch(m){case D.Error:return L;case D.Warning:return T;case D.Info:return E;default:return C}}D.toString=S}(r||(r={})),e.default=r}),define(ne[7],re([0,1,12,4]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,L=/^\//,T=/^\/\//;function I(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!D.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!L.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(t,n){return!t&&!n?"file":t}function C(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==S&&(n=S+n):n=S;break}return n}const b="",S="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(n,o,c,u,f,w=!1){typeof n=="object"?(this.scheme=n.scheme||b,this.authority=n.authority||b,this.path=n.path||b,this.query=n.query||b,this.fragment=n.fragment||b):(this.scheme=E(n,w),this.authority=o||b,this.path=C(this.scheme,c||b),this.query=u||b,this.fragment=f||b,I(this,w))}static isUri(n){return n instanceof v?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return a(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:c,path:u,query:f,fragment:w}=n;return o===void 0?o=this.scheme:o===null&&(o=b),c===void 0?c=this.authority:c===null&&(c=b),u===void 0?u=this.path:u===null&&(u=b),f===void 0?f=this.query:f===null&&(f=b),w===void 0?w=this.fragment:w===null&&(w=b),o===this.scheme&&c===this.authority&&u===this.path&&f===this.query&&w===this.fragment?this:new y(o,c,u,f,w)}static parse(n,o=!1){const c=m.exec(n);return c?new y(c[2]||b,s(c[4]||b),s(c[5]||b),s(c[7]||b),s(c[9]||b),o):new y(b,b,b,b,b)}static file(n){let o=b;if(r.isWindows&&(n=n.replace(/\\/g,S)),n[0]===S&&n[1]===S){const c=n.indexOf(S,2);c===-1?(o=n.substring(2),n=S):(o=n.substring(2,c),n=n.substring(c)||S)}return new y("file",o,n,b,b)}static from(n){const o=new y(n.scheme,n.authority,n.path,n.query,n.fragment);return I(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return r.isWindows&&n.scheme==="file"?c=v.file(R.win32.join(a(n,!0),...o)).path:c=R.posix.join(n.path,...o),n.with({path:c})}toString(n=!1){return d(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof v)return n;{const o=new y(n);return o._formatted=n.external,o._fsPath=n._sep===h?n.fsPath:null,o}}else return n}}e.URI=v;const h=r.isWindows?1:void 0;class y extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(n=!1){return n?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=h),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(t,n){let o,c=-1;for(let u=0;u<t.length;u++){const f=t.charCodeAt(u);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||n&&f===47)c!==-1&&(o+=encodeURIComponent(t.substring(c,u)),c=-1),o!==void 0&&(o+=t.charAt(u));else{o===void 0&&(o=t.substr(0,u));const w=P[f];w!==void 0?(c!==-1&&(o+=encodeURIComponent(t.substring(c,u)),c=-1),o+=w):c===-1&&(c=u)}}return c!==-1&&(o+=encodeURIComponent(t.substring(c))),o!==void 0?o:t}function g(t){let n;for(let o=0;o<t.length;o++){const c=t.charCodeAt(o);c===35||c===63?(n===void 0&&(n=t.substr(0,o)),n+=P[c]):n!==void 0&&(n+=t[o])}return n!==void 0?n:t}function a(t,n){let o;return t.authority&&t.path.length>1&&t.scheme==="file"?o=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?o=t.path.substr(1):o=t.path[1].toLowerCase()+t.path.substr(2):o=t.path,r.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=a;function d(t,n){const o=n?g:p;let c="",{scheme:u,authority:f,path:w,query:_,fragment:N}=t;if(u&&(c+=u,c+=":"),(f||u==="file")&&(c+=S,c+=S),f){let A=f.indexOf("@");if(A!==-1){const O=f.substr(0,A);f=f.substr(A+1),A=O.indexOf(":"),A===-1?c+=o(O,!1):(c+=o(O.substr(0,A),!1),c+=":",c+=o(O.substr(A+1),!1)),c+="@"}f=f.toLowerCase(),A=f.indexOf(":"),A===-1?c+=o(f,!1):(c+=o(f.substr(0,A),!1),c+=f.substr(A))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const A=w.charCodeAt(1);A>=65&&A<=90&&(w=`/${String.fromCharCode(A+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const A=w.charCodeAt(0);A>=65&&A<=90&&(w=`${String.fromCharCode(A+32)}:${w.substr(2)}`)}c+=o(w,!0)}return _&&(c+="?",c+=o(_,!1)),N&&(c+="#",c+=n?N:p(N,!1)),c}function l(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+l(t.substr(3)):t}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(t){return t.match(i)?t.replace(i,n=>l(n)):t}}),define(ne[130],re([0,1,7]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function r(C){const b=C;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=r;function D(C){const b=[];let S;try{const m=JSON.parse(C.arguments),v=m[m.length-1];v&&v.__$stack&&(m.pop(),S=v.__$stack),b.push(...m)}catch{b.push("Unable to log remote console arguments",C.arguments)}return{args:b,stack:S}}e.parse=D;function L(C){if(typeof C!="string")return L(D(C).stack);const b=C;if(b){const S=T(b),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(m&&m.length===4)return{uri:R.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=L;function T(C){if(!C)return C;const b=C.indexOf(`
`);return b===-1?C:C.substring(0,b)}function I(C,b){const{args:S,stack:m}=D(C),v=typeof S[0]=="string"&&S.length===1;let h=T(m);h&&(h=`(${h.trim()})`);let y=[];if(typeof S[0]=="string"?h&&v?y=[`%c[${b}] %c${S[0]} %c${h}`,E("blue"),E(""),E("grey")]:y=[`%c[${b}] %c${S[0]}`,E("blue"),E(""),...S.slice(1)]:y=[`%c[${b}]%`,E("blue"),...S],h&&!v&&y.push(h),typeof console[C.severity]!="function")throw new Error("Unknown console method");console[C.severity].apply(console,y)}e.log=I;function E(C){return`color: ${C}`}}),define(ne[65],re([0,1,16,27,7]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(C){return JSON.stringify(C,I)}e.stringify=L;function T(C){let b=JSON.parse(C);return b=E(b),b}e.parse=T;function I(C,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,r.regExpFlags)(b)}:b}function E(C,b=0){if(!C||b>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return D.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 14:return new Date(C.source)}if(C instanceof R.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let S=0;S<C.length;++S)C[S]=E(C[S],b+1);else for(const S in C)Object.hasOwnProperty.call(C,S)&&(C[S]=E(C[S],b+1))}return C}e.revive=E}),define(ne[21],re([0,1,4,7]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}setServerRootPath(C){this._remoteResourcesPath=`${C}/${D.vscodeRemoteResource}`}set(C,b,S){this._hosts[C]=b,this._ports[C]=S}setConnectionToken(C,b){this._connectionTokens[C]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(C){if(this._delegate)return this._delegate(C);const b=C.authority;let S=this._hosts[b];S&&S.indexOf(":")!==-1&&(S=`[${S}]`);const m=this._ports[b],v=this._connectionTokens[b];let h=`path=${encodeURIComponent(C.path)}`;return typeof v=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),r.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${S}:${m}`,path:this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new L;class T{asBrowserUri(C,b){const S=this.toUri(C,b);return S.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(S):S.scheme===D.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${D.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?S.with({scheme:D.vscodeFileResource,authority:S.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):S}asFileUri(C,b){const S=this.toUri(C,b);return S.scheme===D.vscodeFileResource?S.with({scheme:D.file,authority:S.authority!==T.FALLBACK_AUTHORITY?S.authority:null,query:null,fragment:null}):S}toUri(C,b){return r.URI.isUri(C)?C:r.URI.parse(b.toUrl(C))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T;var I;(function(E){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(C.get("3"));const b="vscode-coi";function S(v){let h;typeof v=="string"?h=new URL(v).searchParams:v instanceof URL?h=v.searchParams:r.URI.isUri(v)&&(h=new URL(v.toString(!0)).searchParams);const y=h?.get(b);if(!!y)return C.get(y)}E.getHeadersFromQuery=S;function m(v,h,y){if(!globalThis.crossOriginIsolated)return;const P=h&&y?"3":y?"2":"1";v instanceof URLSearchParams?v.set(b,P):v[b]=P}E.addSearchParam=m})(I=e.COI||(e.COI={}))}),define(ne[17],re([0,1,47,21,12,4,27,7]),function(Q,e,R,r,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(v){return(0,I.uriToFsPath)(v,!0)}e.originalFSPath=E;class C{constructor(h){this._ignorePathCasing=h}compare(h,y,P=!1){return h===y?0:(0,T.compare)(this.getComparisonKey(h,P),this.getComparisonKey(y,P))}isEqual(h,y,P=!1){return h===y?!0:!h||!y?!1:this.getComparisonKey(h,P)===this.getComparisonKey(y,P)}getComparisonKey(h,y=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,y,P=!1){if(h.scheme===y.scheme){if(h.scheme===r.Schemas.file)return R.isEqualOrParent(E(h),E(y),this._ignorePathCasing(h))&&h.query===y.query&&(P||h.fragment===y.fragment);if((0,e.isEqualAuthority)(h.authority,y.authority))return R.isEqualOrParent(h.path,y.path,this._ignorePathCasing(h),"/")&&h.query===y.query&&(P||h.fragment===y.fragment)}return!1}joinPath(h,...y){return I.URI.joinPath(h,...y)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let y;return h.scheme===r.Schemas.file?y=I.URI.file(D.dirname(E(h))).path:(y=D.posix.dirname(h.path),h.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),y="/")),h.with({path:y})}normalizePath(h){if(!h.path.length)return h;let y;return h.scheme===r.Schemas.file?y=I.URI.file(D.normalize(E(h))).path:y=D.posix.normalize(h.path),h.with({path:y})}relativePath(h,y){if(h.scheme!==y.scheme||!(0,e.isEqualAuthority)(h.authority,y.authority))return;if(h.scheme===r.Schemas.file){const g=D.relative(E(h),E(y));return L.isWindows?R.toSlashes(g):g}let P=h.path||"/";const p=y.path||"/";if(this._ignorePathCasing(h)){let g=0;for(const a=Math.min(P.length,p.length);g<a&&!(P.charCodeAt(g)!==p.charCodeAt(g)&&P.charAt(g).toLowerCase()!==p.charAt(g).toLowerCase());g++);P=p.substr(0,g)+P.substr(g)}return D.posix.relative(P,p)}resolvePath(h,y){if(h.scheme===r.Schemas.file){const P=I.URI.file(D.resolve(E(h),y));return h.with({authority:P.authority,path:P.path})}return y=R.toPosixPath(y),h.with({path:D.posix.resolve(h.path,y)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,y){return h===y||h!==void 0&&y!==void 0&&(0,T.equalsIgnoreCase)(h,y)}hasTrailingPathSeparator(h,y=D.sep){if(h.scheme===r.Schemas.file){const P=E(h);return P.length>R.getRoot(P).length&&P[P.length-1]===y}else{const P=h.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,y=D.sep){return(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,y=D.sep){let P=!1;if(h.scheme===r.Schemas.file){const p=E(h);P=p!==void 0&&p.length===R.getRoot(p).length&&p[p.length-1]===y}else{y="/";const p=h.path;P=p.length===1&&p.charCodeAt(p.length-1)===47}return!P&&!(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path+"/"}):h}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(v=>v.scheme===r.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new C(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(v,h){const y=[];for(let P=0;P<v.length;P++){const p=h(v[P]);v.some((g,a)=>a===P?!1:(0,e.isEqualOrParent)(p,h(g)))||y.push(v[P])}return y}e.distinctParents=b;var S;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(y){const P=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(a=>{const[d,l]=a.split(":");d&&l&&P.set(d,l)});const g=y.path.substring(0,y.path.indexOf(";"));return g&&P.set(v.META_DATA_MIME,g),P}v.parseMetaData=h})(S=e.DataUri||(e.DataUri={}));function m(v,h,y){if(h){let P=v.path;return P&&P[0]!==D.posix.sep&&(P=D.posix.sep+P),v.with({scheme:y,authority:h,path:P})}return v.with({scheme:y})}e.toLocalResource=m}),define(ne[6],re([0,1,24,9,3,2,17,4]),function(Q,e,R,r,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(V){return!!V&&typeof V.then=="function"}e.isThenable=E;function C(V){const U=new R.CancellationTokenSource,F=V(U.token),j=new Promise((B,Z)=>{const oe=U.token.onCancellationRequested(()=>{oe.dispose(),U.dispose(),Z(new r.CancellationError)});Promise.resolve(F).then(X=>{oe.dispose(),U.dispose(),B(X)},X=>{oe.dispose(),U.dispose(),Z(X)})});return new class{cancel(){U.cancel()}then(B,Z){return j.then(B,Z)}catch(B){return this.then(void 0,B)}finally(B){return j.finally(B)}}}e.createCancelablePromise=C;function b(V,U,F){return new Promise((j,B)=>{const Z=U.onCancellationRequested(()=>{Z.dispose(),j(F)});V.then(j,B).finally(()=>Z.dispose())})}e.raceCancellation=b;function S(V,U){return new Promise((F,j)=>{const B=U.onCancellationRequested(()=>{B.dispose(),j(new r.CancellationError)});V.then(F,j).finally(()=>B.dispose())})}e.raceCancellationError=S;async function m(V){let U=-1;const F=V.map((B,Z)=>B.then(oe=>(U=Z,oe))),j=await Promise.race(F);return V.forEach((B,Z)=>{Z!==U&&B.cancel()}),j}e.raceCancellablePromises=m;function v(V,U,F){let j;const B=setTimeout(()=>{j?.(void 0),F?.()},U);return Promise.race([V.finally(()=>clearTimeout(B)),new Promise(Z=>j=Z)])}e.raceTimeout=v;function h(V){return new Promise((U,F)=>{const j=V();E(j)?j.then(U,F):U(j)})}e.asPromise=h;class y{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const F=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(F,F).then(j)})}return new Promise((F,j)=>{this.queuedPromise.then(F,j)})}return this.activePromise=U(),new Promise((F,j)=>{this.activePromise.then(B=>{this.activePromise=null,F(B)},B=>{this.activePromise=null,j(B)})})}}e.Throttler=y;class P{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=P;class p{constructor(){this.promiseMap=new Map}queue(U,F){const B=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.promiseMap.get(U)===B&&this.promiseMap.delete(U)});return this.promiseMap.set(U,B),B}}e.SequencerByKey=p;const g=(V,U)=>{let F=!0;const j=setTimeout(()=>{F=!1,U()},V);return{isTriggered:()=>F,dispose:()=>{clearTimeout(j),F=!1}}},a=V=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,V())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(U){this.defaultDelay=U,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,F=this.defaultDelay){this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,Z)=>{this.doResolve=B,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}}));const j=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=F===e.MicrotaskDelay?a(j):g(F,j),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new r.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=d;class l{constructor(U){this.delayer=new d(U),this.throttler=new y}trigger(U,F){return this.delayer.trigger(()=>this.throttler.queue(U),F)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class i{constructor(){this._isOpen=!1,this._promise=new Promise((U,F)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class s extends i{constructor(U){super(),this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function t(V,U){return U?new Promise((F,j)=>{const B=setTimeout(()=>{Z.dispose(),F()},V),Z=U.onCancellationRequested(()=>{clearTimeout(B),Z.dispose(),j(new r.CancellationError)})}):C(F=>t(V,F))}e.timeout=t;function n(V,U=0){const F=setTimeout(V,U);return(0,L.toDisposable)(()=>clearTimeout(F))}e.disposableTimeout=n;function o(V){const U=[];let F=0;const j=V.length;function B(){return F<j?V[F++]():null}function Z(oe){oe!=null&&U.push(oe);const X=B();return X?X.then(Z):Promise.resolve(U)}return Promise.resolve(null).then(Z)}e.sequence=o;function c(V,U=j=>!!j,F=null){let j=0;const B=V.length,Z=()=>{if(j>=B)return Promise.resolve(F);const oe=V[j++];return Promise.resolve(oe()).then(ie=>U(ie)?Promise.resolve(ie):Z())};return Z()}e.first=c;function u(V,U=j=>!!j,F=null){if(V.length===0)return Promise.resolve(F);let j=V.length;const B=()=>{j=-1;for(const Z of V)Z.cancel?.()};return new Promise((Z,oe)=>{for(const X of V)X.then(ie=>{--j>=0&&U(ie)?(B(),Z(ie)):j===0&&Z(F)}).catch(ie=>{--j>=0&&(B(),oe(ie))})})}e.firstParallel=u;class f{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(U){return this._size++,new Promise((F,j)=>{this.outstandingPromises.push({factory:U,c:F,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const F=U.factory();F.then(U.c,U.e),F.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=f;class w extends f{constructor(){super(1)}}e.Queue=w;class _{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const U=new q;return this.drainers.add(U),U.p}isDrained(){for(const[,U]of this.queues)if(U.size>0)return!1;return!0}queueFor(U,F=T.extUri){const j=F.getComparisonKey(U);let B=this.queues.get(j);return B||(B=new w,D.Event.once(B.onDrained)(()=>{B?.dispose(),this.queues.delete(j),this.onDidQueueDrain()}),this.queues.set(j,B)),B}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const U of this.drainers)U.complete();this.drainers.clear()}dispose(){for(const[,U]of this.queues)U.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=_;class N{constructor(U,F){this._token=-1,typeof U=="function"&&typeof F=="number"&&this.setIfNotSet(U,F)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,F){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},F)}setIfNotSet(U,F){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},F))}}e.TimeoutTimer=N;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,F){this.cancel(),this._token=setInterval(()=>{U()},F)}}e.IntervalTimer=A;class O{constructor(U,F){this.timeoutToken=-1,this.runner=U,this.timeout=F,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=O;class k{constructor(U,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=F,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=k;class M extends O{constructor(U,F){super(U,F),this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner?.(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class $ extends L.Disposable{constructor(U,F){super(),this.options=U,this.handler=F,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.options.maxBufferedWork)return!1}else if(this.pending+U.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=V=>{(0,I.setTimeout0)(()=>{if(U)return;const F=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.runWhenIdle=(V,U)=>{const F=requestIdleCallback(V,typeof U=="number"?{timeout:U}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(F))}}}}();class W{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(F){this._error=F}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=W;async function J(V,U,F){let j;for(let B=0;B<F;B++)try{return await V()}catch(Z){j=Z,await t(U)}throw j}e.retry=J;class H{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(U,F,j){return this._pending={taskId:U,cancel:()=>j?.(),promise:F},F.then(()=>this.donePending(U),()=>this.donePending(U)),F}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let F,j;const B=new Promise((Z,oe)=>{F=Z,j=oe});this._next={run:U,promise:B,promiseResolve:F,promiseReject:j}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=H;class G{constructor(U,F=()=>Date.now()){this.interval=U,this.nowFn=F,this.lastIncrementTime=0,this.value=0}increment(){const U=this.nowFn();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,F)=>{this.completeCallback=U,this.errorCallback=F})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(F=>{this.completeCallback(U),this.resolved=!0,F()})}error(U){return new Promise(F=>{this.errorCallback(U),this.rejected=!0,F()})}cancel(){new Promise(U=>{this.errorCallback(new r.CancellationError),this.rejected=!0,U()})}}e.DeferredPromise=q;var x;(function(V){async function U(j){let B;const Z=await Promise.all(j.map(oe=>oe.then(X=>X,X=>{B||(B=X)})));if(typeof B<"u")throw B;return Z}V.settled=U;function F(j){return new Promise(async(B,Z)=>{try{await j(B,Z)}catch(oe){Z(oe)}})}V.withAsyncBody=F})(x=e.Promises||(e.Promises={}));var Y;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(Y||(Y={}));class te{constructor(U){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const F={emitOne:j=>this.emitOne(j),emitMany:j=>this.emitMany(j),reject:j=>this.reject(j)};try{await Promise.resolve(U(F)),this.resolve()}catch(j){this.reject(j)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}static fromArray(U){return new te(F=>{F.emitMany(U)})}static fromPromise(U){return new te(async F=>{F.emitMany(await U)})}static fromPromises(U){return new te(async F=>{await Promise.all(U.map(async j=>F.emitOne(await j)))})}static merge(U){return new te(async F=>{await Promise.all(U.map(async j=>{for await(const B of j)F.emitOne(B)}))})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(U<this._results.length)return{done:!1,value:this._results[U++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(U,F){return new te(async j=>{for await(const B of U)j.emitOne(F(B))})}map(U){return te.map(this,U)}static filter(U,F){return new te(async j=>{for await(const B of U)F(B)&&j.emitOne(B)})}filter(U){return te.filter(this,U)}static coalesce(U){return te.filter(U,F=>!!F)}coalesce(){return te.coalesce(this)}static async toPromise(U){const F=[];for await(const j of U)F.push(j);return F}toPromise(){return te.toPromise(this)}emitOne(U){this._state===0&&(this._results.push(U),this._onStateChanged.fire())}emitMany(U){this._state===0&&(this._results=this._results.concat(U),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(U){this._state===0&&(this._state=2,this._error=U,this._onStateChanged.fire())}}e.AsyncIterableObject=te,te.EMPTY=te.fromArray([]);class ce extends te{constructor(U,F){super(F),this._source=U}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function z(V){const U=new R.CancellationTokenSource,F=V(U.token);return new ce(U,async j=>{const B=U.token.onCancellationRequested(()=>{B.dispose(),U.dispose(),j.reject(new r.CancellationError)});try{for await(const Z of F){if(U.token.isCancellationRequested)return;j.emitOne(Z)}B.dispose(),U.dispose()}catch(Z){B.dispose(),U.dispose(),j.reject(Z)}})}e.createCancelableAsyncIterable=z}),define(ne[85],re([0,1,19,6,47,34,12,4,27]),function(Q,e,R,r,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",S="[^/\\\\]",m=/\//g;function v(q,x){switch(q){case 0:return"";case 1:return`${S}*?`;default:return`(?:${b}|${S}+${b}${x?`|${b}${S}+`:""})*?`}}function h(q,x){if(!q)return[];const Y=[];let te=!1,ce=!1,z="";for(const V of q){switch(V){case x:if(!te&&!ce){Y.push(z),z="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}z+=V}return z&&Y.push(z),Y}e.splitGlobAware=h;function y(q){if(!q)return"";let x="";const Y=h(q,e.GLOB_SPLIT);if(Y.every(te=>te===e.GLOBSTAR))x=".*";else{let te=!1;Y.forEach((ce,z)=>{if(ce===e.GLOBSTAR){if(te)return;x+=v(2,z===Y.length-1)}else{let V=!1,U="",F=!1,j="";for(const B of ce){if(B!=="}"&&V){U+=B;continue}if(F&&(B!=="]"||!j)){let Z;B==="-"?Z=B:(B==="^"||B==="!")&&!j?Z="^":B===e.GLOB_SPLIT?Z="":Z=(0,E.escapeRegExpCharacters)(B),j+=Z;continue}switch(B){case"{":V=!0;continue;case"[":F=!0;continue;case"}":{x+=`(?:${h(U,",").map(X=>y(X)).join("|")})`,V=!1,U="";break}case"]":{x+="["+j+"]",F=!1,j="";break}case"?":x+=S;continue;case"*":x+=v(1);continue;default:x+=(0,E.escapeRegExpCharacters)(B)}}z<Y.length-1&&(Y[z+1]!==e.GLOBSTAR||z+2<Y.length)&&(x+=b)}te=ce===e.GLOBSTAR})}return x}const P=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.LRUCache(1e4),s=function(){return!1},t=function(){return null};function n(q,x){if(!q)return t;let Y;typeof q!="string"?Y=q.pattern:Y=q,Y=Y.trim();const te=`${Y}_${!!x.trimForExclusions}`;let ce=i.get(te);if(ce)return o(ce,q);let z;return P.test(Y)?ce=u(Y.substr(4),Y):(z=p.exec(c(Y,x)))?ce=f(z[1],Y):(x.trimForExclusions?a:g).test(Y)?ce=w(Y,x):(z=d.exec(c(Y,x)))?ce=_(z[1].substr(1),Y,!0):(z=l.exec(c(Y,x)))?ce=_(z[1],Y,!1):ce=N(Y),i.set(te,ce),o(ce,q)}function o(q,x){if(typeof x=="string")return q;const Y=function(te,ce){return(0,D.isEqualOrParent)(te,x.base,!I.isLinux)?q(te.substr(x.base.length+1),ce):null};return Y.allBasenames=q.allBasenames,Y.allPaths=q.allPaths,Y.basenames=q.basenames,Y.patterns=q.patterns,Y}function c(q,x){return x.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function u(q,x){return function(Y,te){return typeof Y=="string"&&Y.endsWith(q)?x:null}}function f(q,x){const Y=`/${q}`,te=`\\${q}`,ce=function(V,U){return typeof V!="string"?null:U?U===q?x:null:V===q||V.endsWith(Y)||V.endsWith(te)?x:null},z=[q];return ce.basenames=z,ce.patterns=[x],ce.allBasenames=z,ce}function w(q,x){const Y=H(q.slice(1,-1).split(",").map(U=>n(U,x)).filter(U=>U!==t),q),te=Y.length;if(!te)return t;if(te===1)return Y[0];const ce=function(U,F){for(let j=0,B=Y.length;j<B;j++)if(Y[j](U,F))return q;return null},z=Y.find(U=>!!U.allBasenames);z&&(ce.allBasenames=z.allBasenames);const V=Y.reduce((U,F)=>F.allPaths?U.concat(F.allPaths):U,[]);return V.length&&(ce.allPaths=V),ce}function _(q,x,Y){const te=T.sep===T.posix.sep,ce=te?q:q.replace(m,T.sep),z=T.sep+ce,V=T.posix.sep+q;let U;return Y?U=function(F,j){return typeof F=="string"&&(F===ce||F.endsWith(z)||!te&&(F===q||F.endsWith(V)))?x:null}:U=function(F,j){return typeof F=="string"&&(F===ce||!te&&F===q)?x:null},U.allPaths=[(Y?"*/":"./")+q],U}function N(q){try{const x=new RegExp(`^${y(q)}$`);return function(Y){return x.lastIndex=0,typeof Y=="string"&&x.test(Y)?q:null}}catch{return t}}function A(q,x,Y){return!q||typeof x!="string"?!1:O(q)(x,void 0,Y)}e.match=A;function O(q,x={}){if(!q)return s;if(typeof q=="string"||k(q)){const Y=n(q,x);if(Y===t)return s;const te=function(ce,z){return!!Y(ce,z)};return Y.allBasenames&&(te.allBasenames=Y.allBasenames),Y.allPaths&&(te.allPaths=Y.allPaths),te}return W(q,x)}e.parse=O;function k(q){const x=q;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=k;function M(q){return q.allBasenames||[]}e.getBasenameTerms=M;function $(q){return q.allPaths||[]}e.getPathTerms=$;function W(q,x){const Y=H(Object.getOwnPropertyNames(q).map(U=>J(U,q[U],x)).filter(U=>U!==t)),te=Y.length;if(!te)return t;if(!Y.some(U=>!!U.requiresSiblings)){if(te===1)return Y[0];const U=function(B,Z){let oe;for(let X=0,ie=Y.length;X<ie;X++){const se=Y[X](B,Z);if(typeof se=="string")return se;(0,r.isThenable)(se)&&(oe||(oe=[]),oe.push(se))}return oe?(async()=>{for(const X of oe){const ie=await X;if(typeof ie=="string")return ie}return null})():null},F=Y.find(B=>!!B.allBasenames);F&&(U.allBasenames=F.allBasenames);const j=Y.reduce((B,Z)=>Z.allPaths?B.concat(Z.allPaths):B,[]);return j.length&&(U.allPaths=j),U}const ce=function(U,F,j){let B,Z;for(let oe=0,X=Y.length;oe<X;oe++){const ie=Y[oe];ie.requiresSiblings&&j&&(F||(F=(0,T.basename)(U)),B||(B=F.substr(0,F.length-(0,T.extname)(U).length)));const se=ie(U,F,B,j);if(typeof se=="string")return se;(0,r.isThenable)(se)&&(Z||(Z=[]),Z.push(se))}return Z?(async()=>{for(const oe of Z){const X=await oe;if(typeof X=="string")return X}return null})():null},z=Y.find(U=>!!U.allBasenames);z&&(ce.allBasenames=z.allBasenames);const V=Y.reduce((U,F)=>F.allPaths?U.concat(F.allPaths):U,[]);return V.length&&(ce.allPaths=V),ce}function J(q,x,Y){if(x===!1)return t;const te=n(q,Y);if(te===t)return t;if(typeof x=="boolean")return te;if(x){const ce=x.when;if(typeof ce=="string"){const z=(V,U,F,j)=>{if(!j||!te(V,U))return null;const B=ce.replace("$(basename)",F),Z=j(B);return(0,r.isThenable)(Z)?Z.then(oe=>oe?q:null):Z?q:null};return z.requiresSiblings=!0,z}}return te}function H(q,x){const Y=q.filter(U=>!!U.basenames);if(Y.length<2)return q;const te=Y.reduce((U,F)=>{const j=F.basenames;return j?U.concat(j):U},[]);let ce;if(x){ce=[];for(let U=0,F=te.length;U<F;U++)ce.push(x)}else ce=Y.reduce((U,F)=>{const j=F.patterns;return j?U.concat(j):U},[]);const z=function(U,F){if(typeof U!="string")return null;if(!F){let B;for(B=U.length;B>0;B--){const Z=U.charCodeAt(B-1);if(Z===47||Z===92)break}F=U.substr(B)}const j=te.indexOf(F);return j!==-1?ce[j]:null};z.basenames=te,z.patterns=ce,z.allBasenames=te;const V=q.filter(U=>!U.basenames);return V.push(z),V}function G(q,x){return(0,R.equals)(q,x,(Y,te)=>typeof Y=="string"&&typeof te=="string"?Y===te:typeof Y!="string"&&typeof te!="string"?Y.base===te.base&&Y.pattern===te.pattern:!1)}e.patternsEquals=G}),define(ne[131],re([0,1,7]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(b){return b.toJSON()}class D{constructor(S){this._uriTransformer=S}transformIncoming(S){const m=this._uriTransformer.transformIncoming(S);return m===S?S:r(R.URI.from(m))}transformOutgoing(S){const m=this._uriTransformer.transformOutgoing(S);return m===S?S:r(R.URI.from(m))}transformOutgoingURI(S){const m=this._uriTransformer.transformOutgoing(S);return m===S?S:R.URI.from(m)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function L(b,S,m){if(!b||m>200)return null;if(typeof b=="object"){if(b instanceof R.URI)return S.transformOutgoing(b);for(const v in b)if(Object.hasOwnProperty.call(b,v)){const h=L(b[v],S,m+1);h!==null&&(b[v]=h)}}return null}function T(b,S){const m=L(b,S,0);return m===null?b:m}e.transformOutgoingURIs=T;function I(b,S,m,v){if(!b||v>200)return null;if(typeof b=="object"){if(b.$mid===1)return m?R.URI.revive(S.transformIncoming(b)):S.transformIncoming(b);for(const h in b)if(Object.hasOwnProperty.call(b,h)){const y=I(b[h],S,m,v+1);y!==null&&(b[h]=y)}}return null}function E(b,S){const m=I(b,S,!1,0);return m===null?b:m}e.transformIncomingURIs=E;function C(b,S){const m=I(b,S,!0,0);return m===null?b:m}e.transformAndReviveIncomingURIs=C}),define(ne[132],re([0,1,37,9,34,30,118]),function(Q,e,R,r,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(b){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(b)}value(){if(this._value===void 0){let b=0,S=0;const m=(0,R.networkInterfaces)();for(const v in m){const h=m[v];if(h)for(const{mac:y,internal:P}of h)P||(S+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(b+=1))}this._value=S>0?b/S:0}return this._value}};let I;async function E(){return I||(I=(async()=>await C()||L.generateUuid())()),I}e.getMachineId=E;async function C(){try{const b=await new Promise((m,v)=>{Q(["crypto"],m,v)}),S=(0,T.getMac)();return b.createHash("sha256").update(S,"utf8").digest("hex")}catch(b){r.onUnexpectedError(b);return}}}),define(ne[28],re([0,1,53,37,274,6,47,83,12,4,17,7]),function(Q,e,R,r,D,L,T,I,E,C,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function v(W,J=m.UNLINK){if((0,T.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return J===m.UNLINK?y(W):h(W)}async function h(W){try{const J=(0,T.randomPath)((0,r.tmpdir)());try{await R.promises.rename(W,J)}catch(H){return H.code==="ENOENT"?void 0:y(W)}y(J).catch(H=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function y(W){return(0,D.promisify)(R.rm)(W,{recursive:!0,force:!0,maxRetries:3})}function P(W){if((0,T.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(W,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=P;async function p(W,J){return d(await(J?g(W):(0,D.promisify)(R.readdir)(W)))}async function g(W){try{return await(0,D.promisify)(R.readdir)(W,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const J=[],H=await p(W);for(const G of H){let q=!1,x=!1,Y=!1;try{const te=await e.Promises.lstat((0,E.join)(W,G));q=te.isFile(),x=te.isDirectory(),Y=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}J.push({name:G,isFile:()=>q,isDirectory:()=>x,isSymbolicLink:()=>Y})}return J}function a(W){return d(R.readdirSync(W))}e.readdirSync=a;function d(W){return W.map(J=>typeof J=="string"?C.isMacintosh?(0,I.normalizeNFC)(J):J:(J.name=C.isMacintosh?(0,I.normalizeNFC)(J.name):J.name,J))}async function l(W){const J=await p(W),H=[];for(const G of J)await s.existsDirectory((0,E.join)(W,G))&&H.push(G);return H}function i(W,J=1e3){return new Promise(H=>{let G=!1;const q=setInterval(()=>{G||(G=!0,R.access(W,x=>{G=!1,x&&(clearInterval(q),H(void 0))}))},J)})}e.whenDeleted=i;var s;(function(W){async function J(q){let x;try{if(x=await e.Promises.lstat(q),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(C.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw te}throw Y}}W.stat=J;async function H(q){try{const{stat:x,symbolicLink:Y}=await W.stat(q);return x.isFile()&&Y?.dangling!==!0}catch{}return!1}W.existsFile=H;async function G(q){try{const{stat:x,symbolicLink:Y}=await W.stat(q);return x.isDirectory()&&Y?.dangling!==!0}catch{}return!1}W.existsDirectory=G})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new L.ResourceQueue;function n(W,J,H){return t.queueFor(S.URI.file(W),b.extUriBiasedIgnorePathCase).queue(()=>{const G=w(H);return new Promise((q,x)=>u(W,J,G,Y=>Y?x(Y):q()))})}let o=!0;function c(W){o=W}e.configureFlushOnWrite=c;function u(W,J,H,G){if(!o)return R.writeFile(W,J,{mode:H.mode,flag:H.flag},G);R.open(W,H.flag,H.mode,(q,x)=>{if(q)return G(q);R.writeFile(x,J,Y=>{if(Y)return R.close(x,()=>G(Y));R.fdatasync(x,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),c(!1)),R.close(x,ce=>G(ce))))})})}function f(W,J,H){const G=w(H);if(!o)return R.writeFileSync(W,J,{mode:G.mode,flag:G.flag});const q=R.openSync(W,G.flag,G.mode);try{R.writeFileSync(q,J);try{R.fdatasyncSync(q)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),c(!1)}}finally{R.closeSync(q)}}e.writeFileSync=f;function w(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function _(W,J){if(W!==J)try{await e.Promises.rename(W,J)}catch(H){if(W.toLowerCase()!==J.toLowerCase()&&H.code==="EXDEV"||W.endsWith("."))await N(W,J,{preserveSymlinks:!1}),await v(W,m.MOVE);else throw H}}async function N(W,J,H){return O(W,J,{root:{source:W,target:J},options:H,handledSourcePaths:new Set})}const A=511;async function O(W,J,H){if(H.handledSourcePaths.has(W))return;H.handledSourcePaths.add(W);const{stat:G,symbolicLink:q}=await s.stat(W);if(q){if(H.options.preserveSymlinks)try{return await $(W,J,H)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(q.dangling)return}return G.isDirectory()?k(W,J,G.mode&A,H):M(W,J,G.mode&A)}async function k(W,J,H,G){await e.Promises.mkdir(J,{recursive:!0,mode:H});const q=await p(W);for(const x of q)await O((0,E.join)(W,x),(0,E.join)(J,x),G)}async function M(W,J,H){await e.Promises.copyFile(W,J),await e.Promises.chmod(J,H)}async function $(W,J,H){let G=await e.Promises.readlink(W);(0,T.isEqualOrParent)(G,H.root.source,!C.isLinux)&&(G=(0,E.join)(H.root.target,G.substr(H.root.source.length+1))),await e.Promises.symlink(G,J)}e.Promises=new class{get access(){return(0,D.promisify)(R.access)}get stat(){return(0,D.promisify)(R.stat)}get lstat(){return(0,D.promisify)(R.lstat)}get utimes(){return(0,D.promisify)(R.utimes)}get read(){return(W,J,H,G,q)=>new Promise((x,Y)=>{R.read(W,J,H,G,q,(te,ce,z)=>te?Y(te):x({bytesRead:ce,buffer:z}))})}get readFile(){return(0,D.promisify)(R.readFile)}get write(){return(W,J,H,G,q)=>new Promise((x,Y)=>{R.write(W,J,H,G,q,(te,ce,z)=>te?Y(te):x({bytesWritten:ce,buffer:z}))})}get appendFile(){return(0,D.promisify)(R.appendFile)}get fdatasync(){return(0,D.promisify)(R.fdatasync)}get truncate(){return(0,D.promisify)(R.truncate)}get rename(){return(0,D.promisify)(R.rename)}get copyFile(){return(0,D.promisify)(R.copyFile)}get open(){return(0,D.promisify)(R.open)}get close(){return(0,D.promisify)(R.close)}get symlink(){return(0,D.promisify)(R.symlink)}get readlink(){return(0,D.promisify)(R.readlink)}get chmod(){return(0,D.promisify)(R.chmod)}get mkdir(){return(0,D.promisify)(R.mkdir)}get unlink(){return(0,D.promisify)(R.unlink)}get rmdir(){return(0,D.promisify)(R.rmdir)}get realpath(){return(0,D.promisify)(R.realpath)}async exists(W){try{return await e.Promises.access(W),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return l}get writeFile(){return n}get rm(){return v}get move(){return _}get copy(){return N}}}),define(ne[133],re([0,1,53,12,4,27,28]),function(Q,e,R,r,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(m){if(D.isLinux)return m;const v=(0,r.dirname)(m);if(m===v)return m;const h=((0,r.basename)(m)||m).toLowerCase();try{const P=(0,T.readdirSync)(v).filter(p=>p.toLowerCase()===h);if(P.length===1){const p=I(v);if(p)return(0,r.join)(p,P[0])}else if(P.length>1){const p=P.indexOf(h);if(p>=0){const g=I(v);if(g)return(0,r.join)(g,P[p])}}}catch{}return null}e.realcaseSync=I;async function E(m){if(D.isLinux)return m;const v=(0,r.dirname)(m);if(m===v)return m;const h=((0,r.basename)(m)||m).toLowerCase();try{const P=(await T.Promises.readdir(v)).filter(p=>p.toLowerCase()===h);if(P.length===1){const p=await E(v);if(p)return(0,r.join)(p,P[0])}else if(P.length>1){const p=P.indexOf(h);if(p>=0){const g=await E(v);if(g)return(0,r.join)(g,P[p])}}}catch{}return null}e.realcase=E;async function C(m){try{return await T.Promises.realpath(m)}catch{const h=S(m);return await T.Promises.access(h,R.constants.R_OK),h}}e.realpath=C;function b(m){try{return R.realpathSync(m)}catch{const h=S(m);return R.accessSync(h,R.constants.R_OK),h}}e.realpathSync=b;function S(m){return(0,L.rtrim)((0,r.normalize)(m),r.sep)}}),define(ne[86],re([0,1,37,12,28]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,T=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var E;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(E||(E={}));let C;switch(process.arch){case"ia32":case"x32":C=1;break;case"arm":case"arm64":C=2;break;default:C=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class S{constructor(l,i,s){this.exePath=l,this.displayName=i,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:d=!1}={}){return d?C===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:d=!1,findPreview:l=!1}={}){const i=m({useAlternateBitness:d});if(!i)return null;const s=r.join(i,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(s))return null;let t=-1,n=null;for(const u of await D.Promises.readdir(s)){let f=-1;if(l){const _=u.indexOf("-");if(_<0)continue;const N=u.substring(0,_);if(!L.test(N)||u.substring(_+1)!=="preview")continue;f=parseInt(N,10)}else{if(!L.test(u))continue;f=parseInt(u,10)}if(f<=t)continue;const w=r.join(s,u,"pwsh.exe");!await D.SymlinkSupport.existsFile(w)||(n=w,t=f)}if(!n)return null;const o=i.includes("x86")?" (x86)":"",c=l?" Preview":"";return new S(n,`PowerShell${c}${o}`,!0)}async function h({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const l=r.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=d?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(l))if(i.test(t)){const n=r.join(l,t,"pwsh.exe");return new S(n,s)}return null}function y(){const d=r.join(R.homedir(),".dotnet","tools","pwsh.exe");return new S(d,".NET Core PowerShell Global Tool")}function P(){const d=r.join(process.env.windir,C===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(d,"Windows PowerShell",!0)}async function*p(){let d=await v();d&&(yield d),d=await v({useAlternateBitness:!0}),d&&(yield d),d=await h(),d&&(yield d),d=y(),d&&(yield d),d=await v({findPreview:!0}),d&&(yield d),d=await h({findPreview:!0}),d&&(yield d),d=await v({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=P(),d&&(yield d)}async function*g(){for await(const d of p())await d.exists()&&(yield d)}e.enumeratePowerShellInstallations=g;async function a(){for await(const d of g())return d;return null}e.getFirstAvailablePowerShellInstallation=a}),define(ne[87],re([0,1,12,4,36,81,15,28]),function(Q,e,R,r,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function E(S=D.env){return S.comspec||"cmd.exe"}e.getWindowsShell=E;function C(S){let m=[],v=!1;const h=function(y){if(v){m.push(y);return}(!S.send(y,p=>{if(p&&console.error(p),v=!1,m.length>0){const g=m.slice(0);m=[],g.forEach(a=>h(a))}})||r.isWindows)&&(v=!0)};return{send:h}}e.createQueuedSender=C;var b;(function(S){async function m(v,h,y){if(R.isAbsolute(v))return v;if(h===void 0&&(h=D.cwd()),R.dirname(v)!=="."||(y===void 0&&T.isString(D.env.PATH)&&(y=D.env.PATH.split(R.delimiter)),y===void 0||y.length===0))return R.join(h,v);async function p(g){if(await I.Promises.exists(g)){let a;try{a=await I.Promises.stat(g)}catch(d){d.message.startsWith("EACCES")&&(a=await I.Promises.lstat(g))}return a?!a.isDirectory():!1}return!1}for(const g of y){let a;if(R.isAbsolute(g)?a=R.join(g,v):a=R.join(h,g,v),await p(a))return a;let d=a+".com";if(await p(d)||(d=a+".exe",await p(d)))return d}return R.join(h,v)}S.findExecutable=m})(b=e.win32||(e.win32={}))}),define(ne[134],re([0,1,54,21]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(T){return new Promise((I,E)=>{let C;const b=new Map;function S(v,h,y,P,p){const g=b.get(h);if(v===T||g){const a={name:m(y),cmd:y,pid:v,ppid:h,load:P,mem:p};b.set(v,a),v===T&&(C=a),g&&(g.children||(g.children=[]),g.children.push(a),g.children.length>1&&(g.children=g.children.sort((d,l)=>d.pid-l.pid)))}}function m(v){const h=/--vscode-window-kind=shared-process/,y=/--vscode-window-kind=issue-reporter/,P=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,a=/--crashes-directory/,d=/\\pipe\\winpty-control/,l=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(a.exec(v))return"electron-crash-reporter";if(d.exec(v))return"winpty-process";if(l.exec(v))return"console-window-host (Windows internal process)";let s=i.exec(v);if(s&&s.length===2){if(s[1]==="renderer")return h.exec(v)?"shared-process":y.exec(v)?"issue-reporter":P.exec(v)?"process-explorer":"window";if(s[1]==="utility"){if(p.exec(v))return"utility-network-service";if(g.exec(v))return"extension-host"}return s[1]}const t=/[a-zA-Z-]+\.js/g;let n="";do s=t.exec(v),s&&(n+=s+" ");while(s);return n&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${n}`:v}if(process.platform==="win32"){const v=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,y)=>{Q(["windows-process-tree"],h,y)}).then(h=>{h.getProcessList(T,y=>{if(!y){E(new Error(`Root process ${T} not found`));return}h.getProcessCpuUsage(y,P=>{const p=new Map;P.forEach(g=>{const a=v(g.commandLine||"");p.set(g.pid,{name:m(a),cmd:a,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),C=p.get(T),C?(p.forEach(g=>{const a=p.get(g.ppid);a&&(a.children||(a.children=[]),a.children.push(g))}),p.forEach(g=>{g.children&&(g.children=g.children.sort((a,d)=>a.pid-d.pid))}),I(C)):E(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let v=function(){let h=[C];const y=[];for(;h.length;){const p=h.shift();p&&(y.push(p.pid),p.children&&(h=h.concat(p.children)))}let P=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);P+=" "+y.join(" "),(0,R.exec)(P,{},(p,g,a)=>{if(p||a)E(p||new Error(a.toString()));else{const d=g.toString().split(`
`);for(let l=0;l<y.length;l++){const i=b.get(y[l]);i.load=parseFloat(d[l])}if(!C){E(new Error(`Root process ${T} not found`));return}I(C)}})};(0,R.exec)("which ps",{},(h,y,P)=>{if(h||P)if(process.platform!=="linux")E(h||new Error(P.toString()));else{const p=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,R.exec)(p,{},(g,a,d)=>{g||d?E(g||new Error(d.toString())):(L(a,S),v())})}else{const p=y.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${p} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(a,d,l)=>{a||l&&!l.includes("screen size is bogus")?E(a||new Error(l.toString())):(L(d,S),process.platform==="linux"?v():C?I(C):E(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=D;function L(T,I){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,C=T.toString().split(`
`);for(const b of C){const S=E.exec(b.trim());S&&S.length===6&&I(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(ne[135],re([0,1,37,4,86,87]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(v,h){return v===1?r.isWindows?S():L.getWindowsShell(h):C(v,h)}e.getSystemShell=T;function I(v,h){return v===1?r.isWindows?m(h):L.getWindowsShell(h):C(v,h)}e.getSystemShellSync=I;let E=null;function C(v,h){if(r.isLinux&&v===2||r.isMacintosh&&v===3)return"/bin/bash";if(!E){let y;if(r.isWindows)y="/bin/bash";else{if(y=h.SHELL,!y)try{y=(0,R.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}E=y}return E}let b=null;async function S(){return b||(b=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),b}function m(v){if(b)return b;const h=r.isWindows&&parseFloat((0,R.release)())>=10,y=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),P=`${v.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?P:L.getWindowsShell(v)}});var pe=this&&this.__decorate||function(Q,e,R,r){var D=arguments.length,L=D<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,R):r,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(Q,e,R,r);else for(var I=Q.length-1;I>=0;I--)(T=Q[I])&&(L=(D<3?T(L):D>3?T(e,R,L):T(e,R))||L);return D>3&&L&&Object.defineProperty(e,R,L),L};define(ne[39],re([0,1,19,6,16,24,62,9,3,2,65,27,15]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function h(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function P(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(p||(p={}));class g{constructor(x){this.buffer=x,this.pos=0}read(x){const Y=this.buffer.slice(this.pos,this.pos+x);return this.pos+=Y.byteLength,Y}}class a{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var d;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(d||(d={}));function l(q){const x=D.VSBuffer.alloc(4);return x.writeUInt32BE(q,0),x}function i(q){return q.read(4).readUInt32BE(0)}function s(q){const x=D.VSBuffer.alloc(1);return x.writeUInt8(q,0),x}const t={Undefined:s(d.Undefined),String:s(d.String),Buffer:s(d.Buffer),VSBuffer:s(d.VSBuffer),Array:s(d.Array),Object:s(d.Object)},n=typeof Buffer<"u";function o(q,x){if(typeof x>"u")q.write(t.Undefined);else if(typeof x=="string"){const Y=D.VSBuffer.fromString(x);q.write(t.String),q.write(l(Y.byteLength)),q.write(Y)}else if(n&&Buffer.isBuffer(x)){const Y=D.VSBuffer.wrap(x);q.write(t.Buffer),q.write(l(Y.byteLength)),q.write(Y)}else if(x instanceof D.VSBuffer)q.write(t.VSBuffer),q.write(l(x.byteLength)),q.write(x);else if(Array.isArray(x)){q.write(t.Array),q.write(l(x.length));for(const Y of x)o(q,Y)}else{const Y=D.VSBuffer.fromString(JSON.stringify(x));q.write(t.Object),q.write(l(Y.byteLength)),q.write(Y)}}function c(q){switch(q.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return q.read(i(q)).toString();case d.Buffer:return q.read(i(q)).buffer;case d.VSBuffer:return q.read(i(q));case d.Array:{const Y=i(q),te=[];for(let ce=0;ce<Y;ce++)te.push(c(q));return te}case d.Object:return JSON.parse(q.read(i(q)).toString())}}class u{constructor(x,Y,te=null,ce=1e3){this.protocol=x,this.ctx=Y,this.logger=te,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(z=>this.onRawMessage(z)),this.sendResponse({type:200})}registerChannel(x,Y){this.channels.set(x,Y),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const Y=this.send([x.type]);this.logger?.logOutgoing(Y,0,1,P(x.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([x.type,x.id],x.data);this.logger?.logOutgoing(Y,x.id,1,P(x.type),x.data);return}}}send(x,Y=void 0){const te=new a;return o(te,x),o(te,Y),this.sendBuffer(te.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const Y=new g(x),te=c(Y),ce=c(Y),z=te[0];switch(z){case 100:return this.logger?.logIncoming(x.byteLength,te[1],1,`${h(z)}: ${te[2]}.${te[3]}`,ce),this.onPromise({type:z,id:te[1],channelName:te[2],name:te[3],arg:ce});case 102:return this.logger?.logIncoming(x.byteLength,te[1],1,`${h(z)}: ${te[2]}.${te[3]}`,ce),this.onEventListen({type:z,id:te[1],channelName:te[2],name:te[3],arg:ce});case 101:return this.logger?.logIncoming(x.byteLength,te[1],1,`${h(z)}`),this.disposeActiveRequest({type:z,id:te[1]});case 103:return this.logger?.logIncoming(x.byteLength,te[1],1,`${h(z)}`),this.disposeActiveRequest({type:z,id:te[1]})}}onPromise(x){const Y=this.channels.get(x.channelName);if(!Y){this.collectPendingRequest(x);return}const te=new L.CancellationTokenSource;let ce;try{ce=Y.call(this.ctx,x.name,x.arg,te.token)}catch(U){ce=Promise.reject(U)}const z=x.id;ce.then(U=>{this.sendResponse({id:z,data:U,type:201}),this.activeRequests.delete(x.id)},U=>{U instanceof Error?this.sendResponse({id:z,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.sendResponse({id:z,data:U,type:203}),this.activeRequests.delete(x.id)});const V=(0,C.toDisposable)(()=>te.cancel());this.activeRequests.set(x.id,V)}onEventListen(x){const Y=this.channels.get(x.channelName);if(!Y){this.collectPendingRequest(x);return}const te=x.id,z=Y.listen(this.ctx,x.name,x.arg)(V=>this.sendResponse({id:te,data:V,type:204}));this.activeRequests.set(x.id,z)}disposeActiveRequest(x){const Y=this.activeRequests.get(x.id);Y&&(Y.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let Y=this.pendingRequests.get(x.channelName);Y||(Y=[],this.pendingRequests.set(x.channelName,Y));const te=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:x,timeoutTimer:te})}flushPendingRequests(x){const Y=this.pendingRequests.get(x);if(Y){for(const te of Y)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.onPromise(te.request);break;case 102:this.onEventListen(te.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=u;var f;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(x,Y=null){this.protocol=x,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(te=>this.onBuffer(te)),this.logger=Y}getChannel(x){const Y=this;return{call(te,ce,z){return Y.isDisposed?Promise.reject(new I.CancellationError):Y.requestPromise(x,te,ce,z)},listen(te,ce){return Y.isDisposed?E.Event.None:Y.requestEvent(x,te,ce)}}}requestPromise(x,Y,te,ce=L.CancellationToken.None){const z=this.lastRequestId++,U={id:z,type:100,channelName:x,name:Y,arg:te};if(ce.isCancellationRequested)return Promise.reject(new I.CancellationError);let F;return new Promise((B,Z)=>{if(ce.isCancellationRequested)return Z(new I.CancellationError);const oe=()=>{const ue=he=>{switch(he.type){case 201:this.handlers.delete(z),B(he.data);break;case 202:{this.handlers.delete(z);const ve=new Error(he.data.message);ve.stack=he.data.stack,ve.name=he.data.name,Z(ve);break}case 203:this.handlers.delete(z),Z(he.data);break}};this.handlers.set(z,ue),this.sendRequest(U)};let X=null;this.state===p.Idle?oe():(X=(0,r.createCancelablePromise)(ue=>this.whenInitialized()),X.then(()=>{X=null,oe()}));const ie=()=>{X?(X.cancel(),X=null):this.sendRequest({id:z,type:101}),Z(new I.CancellationError)},se=ce.onCancellationRequested(ie);F=(0,C.combinedDisposable)((0,C.toDisposable)(ie),se),this.activeRequests.add(F)}).finally(()=>{this.activeRequests.delete(F)})}requestEvent(x,Y,te){const ce=this.lastRequestId++,V={id:ce,type:102,channelName:x,name:Y,arg:te};let U=null;const F=new E.Emitter({onFirstListenerAdd:()=>{U=(0,r.createCancelablePromise)(B=>this.whenInitialized()),U.then(()=>{U=null,this.activeRequests.add(F),this.sendRequest(V)})},onLastListenerRemove:()=>{U?(U.cancel(),U=null):(this.activeRequests.delete(F),this.sendRequest({id:ce,type:103}))}}),j=B=>F.fire(B.data);return this.handlers.set(ce,j),F.event}sendRequest(x){switch(x.type){case 100:case 102:{const Y=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger?.logOutgoing(Y,x.id,0,`${h(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const Y=this.send([x.type,x.id]);this.logger?.logOutgoing(Y,x.id,0,h(x.type));return}}}send(x,Y=void 0){const te=new a;return o(te,x),o(te,Y),this.sendBuffer(te.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const Y=new g(x),te=c(Y),ce=c(Y),z=te[0];switch(z){case 200:return this.logger?.logIncoming(x.byteLength,0,0,P(z)),this.onResponse({type:te[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(x.byteLength,te[1],0,P(z),ce),this.onResponse({type:te[0],id:te[1],data:ce})}}onResponse(x){if(x.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(x.id)?.(x)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}pe([T.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class _{constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:Y,onDidClientDisconnect:te})=>{E.Event.once(Y.onMessage)(z=>{const V=new g(z),U=c(V),F=new u(Y,U),j=new w(Y);this.channels.forEach((Z,oe)=>F.registerChannel(oe,Z));const B={channelServer:F,channelClient:j,ctx:U};this._connections.add(B),this._onDidAddConnection.fire(B),te(()=>{F.dispose(),j.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}get connections(){const x=[];return this._connections.forEach(Y=>x.push(Y)),x}getChannel(x,Y){const te=this;return{call(ce,z,V){let U;if((0,m.isFunction)(Y)){const j=(0,R.getRandomElement)(te.connections.filter(Y));U=j?Promise.resolve(j):E.Event.toPromise(E.Event.filter(te.onDidAddConnection,Y))}else U=Y.routeCall(te,ce,z);const F=U.then(j=>j.channelClient.getChannel(x));return A(F).call(ce,z,V)},listen(ce,z){if((0,m.isFunction)(Y))return te.getMulticastEvent(x,Y,ce,z);const V=Y.routeEvent(te,ce,z).then(U=>U.channelClient.getChannel(x));return A(V).listen(ce,z)}}}getMulticastEvent(x,Y,te,ce){const z=this;let V=new C.DisposableStore;const U=new E.Emitter({onFirstListenerAdd:()=>{V=new C.DisposableStore;const F=new E.EventMultiplexer,j=new Map,B=oe=>{const ie=oe.channelClient.getChannel(x).listen(te,ce),se=F.add(ie);j.set(oe,se)},Z=oe=>{const X=j.get(oe);!X||(X.dispose(),j.delete(oe))};z.connections.filter(Y).forEach(B),E.Event.filter(z.onDidAddConnection,Y)(B,void 0,V),z.onDidRemoveConnection(Z,void 0,V),F.event(U.fire,U,V),V.add(F)},onLastListenerRemove:()=>{V.dispose()}});return U.event}registerChannel(x,Y){this.channels.set(x,Y),this._connections.forEach(te=>{te.channelServer.registerChannel(x,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class N{constructor(x,Y,te=null){const ce=new a;o(ce,Y),x.send(ce.buffer),this.channelClient=new w(x,te),this.channelServer=new u(x,Y,te)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,Y){this.channelServer.registerChannel(x,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=N;function A(q){return{call(x,Y,te){return q.then(ce=>ce.call(x,Y,te))},listen(x,Y){const te=new E.Relay;return q.then(ce=>te.input=ce.listen(x,Y)),te.event}}}e.getDelayedChannel=A;function O(q){let x=!1;return{call(Y,te,ce){return x?q.call(Y,te,ce):(0,r.timeout)(0).then(()=>x=!0).then(()=>q.call(Y,te,ce))},listen(Y,te){if(x)return q.listen(Y,te);const ce=new E.Relay;return(0,r.timeout)(0).then(()=>x=!0).then(()=>ce.input=q.listen(Y,te)),ce.event}}}e.getNextTickChannel=O;class k{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const Y of x.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await E.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=k;var M;(function(q){function x(z,V){const U=z,F=V&&V.disableMarshalling,j=new Map;for(const B in U)te(B)&&j.set(B,E.Event.buffer(U[B],!0));return new class{listen(B,Z,oe){const X=j.get(Z);if(X)return X;if(ce(Z)){const ie=U[Z];if(typeof ie=="function")return ie.call(U,oe)}throw new Error(`Event not found: ${Z}`)}call(B,Z,oe){const X=U[Z];if(typeof X=="function"){if(!F&&Array.isArray(oe))for(let ie=0;ie<oe.length;ie++)oe[ie]=(0,b.revive)(oe[ie]);return X.apply(U,oe)}throw new Error(`Method not found: ${Z}`)}}}q.fromService=x;function Y(z,V){const U=V&&V.disableMarshalling;return new Proxy({},{get(F,j){if(typeof j=="string")return V?.properties?.has(j)?V.properties.get(j):ce(j)?function(B){return z.listen(j,B)}:te(j)?z.listen(j):async function(...B){let Z;V&&!(0,m.isUndefinedOrNull)(V.context)?Z=[V.context,...B]:Z=B;const oe=await z.call(j,Z);return U?oe:(0,b.revive)(oe)};throw new Error(`Property not found: ${String(j)}`)}})}q.toService=Y;function te(z){return z[0]==="o"&&z[1]==="n"&&S.isUpperAsciiLetter(z.charCodeAt(2))}function ce(z){return/^onDynamic/.test(z)&&S.isUpperAsciiLetter(z.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const x=q.toString();if(x!=="[object Object]")return x}return q}function J(q){return Array.isArray(q)?q.map(W):W(q)}function H(q,x,Y,te,ce,z,V){V=J(V);const U=$[ce],F=U[te%U.length];let j=[`%c[${q}]%c[${String(x).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(z)?(j=j.concat(V),j.push(")")):j.push(V),console.log.apply(console,j)}e.logWithColors=H;class G{constructor(x,Y){this._outgoingPrefix=x,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,Y,te,ce,z){this._totalOutgoing+=x,H(this._outgoingPrefix,this._totalOutgoing,x,Y,te,ce,z)}logIncoming(x,Y,te,ce,z){this._totalIncoming+=x,H(this._incomingPrefix,this._totalIncoming,x,Y,te,ce,z)}}e.IPCLogger=G}),define(ne[136],re([0,1,16,3,39]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(E){this.port=E,this.onMessage=r.Event.fromDOMEventEmitter(this.port,"message",C=>R.VSBuffer.wrap(C.data)),E.start()}send(E){this.port.postMessage(E.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class T extends D.IPCClient{constructor(E,C){const b=new L(E);super(b,C),this.protocol=b}dispose(){this.protocol.disconnect()}}e.Client=T}),define(ne[88],re([0,1,16,3,2,39]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(n){n.enableDiagnostics=!1,n.records=[];const o=new WeakMap;let c=0;function u(w,_){if(!o.has(w)){const N=String(++c);o.set(w,N)}return o.get(w)}function f(w,_,N,A){if(!n.enableDiagnostics)return;const O=u(w,_);if(A instanceof R.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const k=R.VSBuffer.alloc(A.byteLength);k.set(A),n.records.push({timestamp:Date.now(),id:O,label:_,type:N,buff:k})}else n.records.push({timestamp:Date.now(),id:O,label:_,type:N,data:A})}n.traceSocketEvent=f})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function b(){return C||(C=R.VSBuffer.alloc(0)),C}class S{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,c){if(o===0)return b();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const _=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=o),_}if(this._chunks[0].byteLength>o){const _=this._chunks[0].slice(0,o);return c&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),_}const u=R.VSBuffer.alloc(o);let f=0,w=0;for(;o>0;){const _=this._chunks[w];if(_.byteLength>o){const N=_.slice(0,o);u.set(N,f),f+=o,c&&(this._chunks[w]=_.slice(o),this._totalLength-=o),o-=o}else u.set(_,f),f+=_.byteLength,c?(this._chunks.shift(),this._totalLength-=_.byteLength):w++,o-=_.byteLength}return u}}e.ChunkStream=S;var m;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(m||(m={}));function v(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class y{constructor(o,c,u,f){this.type=o,this.id=c,this.ack=u,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class P extends D.Disposable{constructor(o){super(),this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new S,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,f=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new y(u,f,w,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=R.VSBuffer.alloc(13);c.writeUInt8(o.type,0),c.writeUInt32BE(o.id,1),c.writeUInt32BE(o.ack,5),c.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:v(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(c,o.data)}_bufferAdd(o,c){const u=this._totalLength===0;return this._data.push(o,c),this._totalLength+=o.byteLength+c.byteLength,u}_bufferTake(){const o=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,c){this._bufferAdd(o,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class g extends D.Disposable{constructor(o){super(),this._onMessage=new r.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new P(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new y(1,0,0,o))}}e.Protocol=g;class a extends L.IPCClient{constructor(o,c,u=null){super(o,c,u),this.protocol=o}static fromSocket(o,c){return new a(new g(o),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=a;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new r.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class l{constructor(o){this.data=o,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let o=0,c=this._first;for(;c;)c=c.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let c=0,u=this._first;for(;u;)o[c++]=u.data,u=u.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const c=new l(o);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class s{constructor(){this.lastRuns=[];const o=Date.now();for(let c=0;c<s._HISTORY_LENGTH;c++)this.lastRuns[c]=o-1e3*c;setInterval(()=>{for(let c=s._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const o=Date.now(),c=(1+s._HISTORY_LENGTH)*1e3;let u=0;for(let f=0;f<s._HISTORY_LENGTH;f++)o-this.lastRuns[f]<=c&&u++;return 1-u/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class t{constructor(o,c=null,u=s.getInstance()){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new P(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),c&&this._socketReader.acceptChunk(c),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new y(5,0,0,b());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new y(7,0,0,b());this._socketWriter.write(o)}sendResume(){const o=new y(8,0,0,b());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,c){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new P(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new y(3,0,this._incomingAckId,b());this._socketWriter.write(o);const c=this._outgoingUnackMsg.toArray();for(let u=0,f=c.length;u<f;u++)this._socketWriter.write(c[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new y(6,0,0,b())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let u=0,f=c.length;u<f;u++)this._socketWriter.write(c[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new y(1,c,this._incomingAckId,o);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(o){const c=new y(2,0,0,o);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),c=Date.now()-o.writtenTime,u=Date.now()-this._socketReader.lastReadTime,f=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&u>=2e4&&f>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:u});return}const w=Math.max(2e4-c,2e4-u,2e4-f,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},w)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new y(3,0,this._incomingAckId,b());this._socketWriter.write(o)}_sendKeepAlive(){const o=new y(9,0,0,b());this._socketWriter.write(o)}}e.PersistentProtocol=t}),define(ne[137],re([0,1,89,3,39,136]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends D.IPCServer{static getOnDidClientConnect(){const E=r.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(C,b)=>b);return r.Event.map(E,C=>{const{port1:b,port2:S}=new MessageChannel,v={protocol:new L.Protocol(b),onDidClientDisconnect:r.Event.fromDOMEventEmitter(b,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",C,[S]),v})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(ne[66],re([0,1,54,6,16,24,130,9,3,2,32,87,81,39]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends v.ChannelServer{constructor(p){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",g=>D.VSBuffer.wrap(Buffer.from(g,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=h;class y{constructor(p,g){this.modulePath=p,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const a=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new r.Delayer(a),this.child=null,this._client=null}getChannel(p){const g=this;return{call(a,d,l){return g.requestPromise(p,a,d,l)},listen(a,d){return g.requestEvent(p,a,d)}}}requestPromise(p,g,a,d=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(p),i=(0,r.createCancelablePromise)(n=>l.call(g,a,n)),s=d.onCancellationRequested(()=>i.cancel()),t=(0,C.toDisposable)(()=>i.cancel());return this.activeRequests.add(t),i.finally(()=>{s.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(p,g,a){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let d;const l=new E.Emitter({onFirstListenerAdd:()=>{d=this.getCachedChannel(p).listen(g,a)(l.fire,l),this.activeRequests.add(d)},onLastListenerRemove:()=>{this.activeRequests.delete(d),d.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,m.removeDangerousEnvVariables)(g.env),this.child=(0,R.fork)(this.modulePath,p,g);const a=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,T.isRemoteConsoleLog)(o)){(0,T.log)(o,`IPC Library: ${this.options.serverName}`);return}a.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))});const l=this.options.useQueue?(0,S.createQueuedSender)(this.child):this.child,i=o=>this.child&&this.child.connected&&l.send(o.buffer.toString("base64")),s=a.event,t={send:i,onMessage:s};this._client=new v.ChannelClient(t);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,c)=>{process.removeListener("exit",n),this.activeRequests.forEach(u=>(0,C.dispose)(u)),this.activeRequests.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:c})})}return this._client}getCachedChannel(p){let g=this.channels.get(p);return g||(g=this.client.getChannel(p),this.channels.set(p,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(ne[138],re([0,1,16,9,3,2,12,4,30,39,88]),function(Q,e,R,r,D,L,T,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function S(){return{crypto:Q.__$__nodeRequire("crypto"),zlib:Q.__$__nodeRequire("zlib"),net:Q.__$__nodeRequire("net"),os:Q.__$__nodeRequire("os")}}class m{constructor(u,f=""){this.debugLabel=f,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=w=>{if(this.traceSocketEvent("error",{code:w?.code,message:w?.message}),w){if(w.code==="EPIPE")return;(0,r.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener)}traceSocketEvent(u,f){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,f)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const f=w=>{this.traceSocketEvent("read",w),u(R.VSBuffer.wrap(w))};return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(u){const f=w=>{this.traceSocketEvent("close",{hadError:w}),u({type:0,hadError:w,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(u){const f=()=>{this.traceSocketEvent("nodeEndReceived"),u()};return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(u){if(!this.socket.destroyed)try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,r.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,r.onUnexpectedError)(f)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,f)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const w=()=>{this.socket.off("close",w),this.socket.off("end",w),this.socket.off("error",w),this.socket.off("timeout",w),this.socket.off("drain",w),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",w),this.socket.on("end",w),this.socket.on("error",w),this.socket.on("timeout",w),this.socket.on("drain",w)})}}e.NodeSocket=m;var v;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var h;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(h||(h={}));class y extends L.Disposable{constructor(u,f,w,_){super(),this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:f,inflateBytesLength:w?.byteLength||0,recordInflateBytes:_}),this._flowManager=this._register(new P(this,f,w,_,this._onData,(N,A)=>this._write(N,A))),this._register(this._flowManager.onError(N=>{console.error(N),(0,r.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(N=>this._onClose.fire(N)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(u,f){this.socket.traceSocketEvent(u,f)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._flowManager.writeMessage(u)}_write(u,f){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let w=2;u.byteLength<126?w+=0:u.byteLength<2**16?w+=2:w+=8;const _=R.VSBuffer.alloc(w);if(f?_.writeUInt8(194,0):_.writeUInt8(130,0),u.byteLength<126)_.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){_.writeUInt8(126,1);let N=1;_.writeUInt8(u.byteLength>>>8&255,++N),_.writeUInt8(u.byteLength>>>0&255,++N)}else{_.writeUInt8(127,1);let N=1;_.writeUInt8(0,++N),_.writeUInt8(0,++N),_.writeUInt8(0,++N),_.writeUInt8(0,++N),_.writeUInt8(u.byteLength>>>24&255,++N),_.writeUInt8(u.byteLength>>>16&255,++N),_.writeUInt8(u.byteLength>>>8&255,++N),_.writeUInt8(u.byteLength>>>0&255,++N)}this.socket.write(R.VSBuffer.concat([_,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const f=this._incomingData.peek(this._state.readLen),w=f.readUInt8(0),_=(w&128)>>>7,N=(w&64)>>>6,A=f.readUInt8(1),O=(A&128)>>>7,k=A&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(k===126?2:0)+(k===127?8:0),this._state.fin=_,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(N)),this._state.firstFrameOfMessage=Boolean(_),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const f=this._incomingData.read(this._state.readLen),w=f.readUInt8(1),_=(w&128)>>>7;let N=w&127,A=1;N===126?N=f.readUInt8(++A)*2**8+f.readUInt8(++A):N===127&&(N=f.readUInt8(++A)*0+f.readUInt8(++A)*0+f.readUInt8(++A)*0+f.readUInt8(++A)*0+f.readUInt8(++A)*2**24+f.readUInt8(++A)*2**16+f.readUInt8(++A)*2**8+f.readUInt8(++A));let O=0;_&&(O=f.readUInt8(++A)*2**24+f.readUInt8(++A)*2**16+f.readUInt8(++A)*2**8+f.readUInt8(++A)),this._state.state=3,this._state.readLen=N,this._state.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const f=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",f),a(f,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",f),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(f,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class P extends L.Disposable{constructor(u,f,w,_,N,A){super(),this._tracer=u,this._onData=N,this._writeFn=A,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,f?(this._zlibInflateStream=this._register(new p(this._tracer,_,w,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(O=>this._onError.fire(O))),this._register(this._zlibDeflateStream.onError(O=>this._onError.fire(O)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}writeMessage(u){this._writeQueue.push(u),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const u=this._writeQueue.shift();if(this._zlibDeflateStream){const f=await this._deflateMessage(this._zlibDeflateStream,u);this._writeFn(f,!0)}else this._writeFn(u,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(u,f){return new Promise((w,_)=>{u.write(f),u.flush(N=>w(N))})}acceptFrame(u,f,w){this._readQueue.push({data:u,isCompressed:f,isLastFrameOfMessage:w}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const u=this._readQueue.shift();if(this._zlibInflateStream&&u.isCompressed){const f=await this._inflateFrame(this._zlibInflateStream,u.data,u.isLastFrameOfMessage);this._onData.fire(f)}else this._onData.fire(u.data)}this._isProcessingReadQueue=!1}}_inflateFrame(u,f,w){return new Promise((_,N)=>{u.write(f),w&&u.write(R.VSBuffer.fromByteArray([0,0,255,255])),u.flush(A=>_(A))})}}class p extends L.Disposable{constructor(u,f,w,_){super(),this._tracer=u,this._recordInflateBytes=f,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=S().zlib.createInflateRaw(_),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent("zlibInflateData",N),this._pendingInflateData.push(R.VSBuffer.wrap(N))}),w&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",w.buffer),this._zlibInflate.write(w.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}write(u){this._recordInflateBytes&&this._recordedInflateBytes.push(u.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",u),this._zlibInflate.write(u.buffer)}flush(u){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const f=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,u(f)})}}class g extends L.Disposable{constructor(u,f){super(),this._tracer=u,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=S().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",w=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:w?.message,code:w?.code}),this._onError.fire(w)}),this._zlibDeflate.on("data",w=>{this._tracer.traceSocketEvent("zlibDeflateData",w),this._pendingDeflateData.push(R.VSBuffer.wrap(w))})}write(u){this._tracer.traceSocketEvent("zlibDeflateWrite",u.buffer),this._zlibDeflate.write(u.buffer)}flush(u){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let f=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,f=f.slice(0,f.byteLength-4),u(f)})}}function a(c,u){if(u===0)return;const f=c.byteLength>>>2;for(let k=0;k<f;k++){const M=c.readUInt32BE(k*4);c.writeUInt32BE(M^u,k*4)}const w=f*4,_=c.byteLength-w,N=u>>>24&255,A=u>>>16&255,O=u>>>8&255;_>=1&&c.writeUInt8(c.readUInt8(w)^N,w),_>=2&&c.writeUInt8(c.readUInt8(w+1)^A,w+1),_>=3&&c.writeUInt8(c.readUInt8(w+2)^O,w+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const d={[2]:107,[1]:103};function l(){const c=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):u=(0,T.join)(S().os.tmpdir(),`vscode-ipc-${c}.sock`),s(u),u}e.createRandomIPCHandle=l;function i(c,u,f){const w=S().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${w}-${f}-${u}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${w.substr(0,8)}-${f}-${u}.sock`):_=(0,T.join)(c,`${f}-${u}.sock`),s(_),_}e.createStaticIPCHandle=i;function s(c){const u=d[I.platform];typeof u=="number"&&c.length>=u&&console.warn(`WARNING: IPC handle "${c}" is longer than ${u} chars, try a shorter --user-data-dir`)}class t extends C.IPCServer{constructor(u){super(t.toClientConnectionEvent(u)),this.server=u}static toClientConnectionEvent(u){const f=D.Event.fromNodeEventEmitter(u,"connection");return D.Event.map(f,w=>({protocol:new b.Protocol(new m(w,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(w,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function n(c){return new Promise((u,f)=>{const w=S().net.createServer();w.on("error",f),w.listen(c,()=>{w.removeListener("error",f),u(new t(w))})})}e.serve=n;function o(c,u){return new Promise((f,w)=>{const _=S().net.createConnection(c,()=>{_.removeListener("error",w),f(b.Client.fromSocket(new m(_,`ipc-client${u}`),u))});_.once("error",w)})}e.connect=o}),define(ne[67],re([0,1,6,3,2,15]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function I(S){const m=S;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var E;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(E=e.StorageState||(e.StorageState={}));class C extends D.Disposable{constructor(m,v=Object.create(null)){super(),this.database=m,this.options=v,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(C.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((v,h)=>this.accept(h,v)),m.deleted?.forEach(v=>this.accept(v,void 0))}accept(m,v){if(this.state===E.Closed)return;let h=!1;(0,L.isUndefinedOrNull)(v)?h=this.cache.delete(m):this.cache.get(m)!==v&&(this.cache.set(m,v),h=!0),h&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,v){const h=this.cache.get(m);return(0,L.isUndefinedOrNull)(h)?v:h}getBoolean(m,v){const h=this.get(m);return(0,L.isUndefinedOrNull)(h)?v:h==="true"}getNumber(m,v){const h=this.get(m);return(0,L.isUndefinedOrNull)(h)?v:parseInt(h,10)}async set(m,v){if(this.state===E.Closed)return;if((0,L.isUndefinedOrNull)(v))return this.delete(m);const h=String(v);if(this.cache.get(m)!==h)return this.cache.set(m,h),this.pendingInserts.set(m,h),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===E.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=C,C.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((v,h)=>this.items.set(h,v)),m.delete?.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=b}),define(ne[139],re([10,11]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(ne[140],re([10,11]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[141],re([10,11]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(ne[142],re([10,11]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(ne[143],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[144],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[145],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[146],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[147],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[148],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[149],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[150],re([10,11]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[151],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(ne[152],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ne[153],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(ne[154],re([10,11]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[155],re([10,11]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[156],re([10,11]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(ne[157],re([10,11]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(ne[158],re([10,11]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[159],re([10,11]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[160],re([10,11]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[161],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[162],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[163],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[164],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[165],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[166],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[167],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[168],re([10,11]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(ne[90],re([0,1,63,62,21,12,36,17,7]),function(Q,e,R,r,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class C{constructor(y,P,p){this._args=y,this.paths=P,this.productService=p,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,L.dirname)(D.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return E.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return E.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(this.paths.tmpDir)}get cacheHome(){return E.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const y=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",y)}return this.args.logsPath}get userDataSyncLogResource(){return E.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return E.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(E.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=T.env.VSCODE_PORTABLE;return y?E.URI.file((0,L.join)(y,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,L.resolve)(y):(0,L.normalize)((0,L.join)(D.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const y=this.args["extensions-download-dir"];return y?(0,L.resolve)(y):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,L.resolve)(y);const P=T.env.VSCODE_EXTENSIONS;if(P)return P;const p=T.env.VSCODE_PORTABLE;return p?(0,L.join)(p,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(P=>/^[^:/?#]+?:\/\//.test(P)?E.URI.parse(P):E.URI.file((0,L.normalize)(P)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?E.URI.parse(y):E.URI.file((0,L.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return E.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return E.URI.file((0,L.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const y=T.env.VSCODE_PORTABLE;return y?E.URI.file((0,L.join)(y,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}pe([r.memoize],C.prototype,"appRoot",null),pe([r.memoize],C.prototype,"userHome",null),pe([r.memoize],C.prototype,"userDataPath",null),pe([r.memoize],C.prototype,"appSettingsHome",null),pe([r.memoize],C.prototype,"tmpDir",null),pe([r.memoize],C.prototype,"cacheHome",null),pe([r.memoize],C.prototype,"stateResource",null),pe([r.memoize],C.prototype,"userRoamingDataHome",null),pe([r.memoize],C.prototype,"userDataSyncHome",null),pe([r.memoize],C.prototype,"userDataSyncLogResource",null),pe([r.memoize],C.prototype,"editSessionsLogResource",null),pe([r.memoize],C.prototype,"sync",null),pe([r.memoize],C.prototype,"machineSettingsResource",null),pe([r.memoize],C.prototype,"workspaceStorageHome",null),pe([r.memoize],C.prototype,"localHistoryHome",null),pe([r.memoize],C.prototype,"keyboardLayoutResource",null),pe([r.memoize],C.prototype,"argvResource",null),pe([r.memoize],C.prototype,"isExtensionDevelopment",null),pe([r.memoize],C.prototype,"untitledWorkspacesHome",null),pe([r.memoize],C.prototype,"installSourcePath",null),pe([r.memoize],C.prototype,"builtinExtensionsPath",null),pe([r.memoize],C.prototype,"extensionsPath",null),pe([r.memoize],C.prototype,"extensionDevelopmentLocationURI",null),pe([r.memoize],C.prototype,"extensionDevelopmentKind",null),pe([r.memoize],C.prototype,"extensionTestsLocationURI",null),pe([r.memoize],C.prototype,"debugExtensionHost",null),pe([r.memoize],C.prototype,"serviceMachineIdResource",null),pe([r.memoize],C.prototype,"telemetryLogResource",null),pe([r.memoize],C.prototype,"disableWorkspaceTrust",null),pe([r.memoize],C.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=C;function b(h,y){return v(h["inspect-extensions"],h["inspect-brk-extensions"],5870,y,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=b;function S(h,y){return v(h["inspect-search"],h["inspect-brk-search"],5876,y,h.extensionEnvironment)}e.parseSearchPort=S;function m(h,y){return v(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,y,h.extensionEnvironment)}e.parsePtyHostPort=m;function v(h,y,P,p,g,a){const l=Number(y||h)||(p?null:P),i=l?Boolean(!!y):!1;let s;if(a)try{s=JSON.parse(a)}catch{}return{port:l,break:i,debugId:g,env:s}}}),define(ne[169],re([0,1,275,4,141]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,D.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},category:{type:"string",cat:"e",description:(0,D.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(h,y,P=T){const p={},g=["_"],a=[];for(const s in y){const t=y[s];t.alias&&(p[s]=t.alias),t.type==="string"||t.type==="string[]"?(g.push(s),t.deprecates&&g.push(...t.deprecates)):t.type==="boolean"&&(a.push(s),t.deprecates&&a.push(...t.deprecates))}const d=R(h,{string:g,boolean:a,alias:p}),l={},i=d;l._=d._.map(s=>String(s)).filter(s=>s.length>0),delete i._;for(const s in y){const t=y[s];t.alias&&delete i[t.alias];let n=i[s];if(t.deprecates)for(const o of t.deprecates)i.hasOwnProperty(o)&&(n||(n=i[o],n&&P.onDeprecatedOption(o,t.deprecationMessage||(0,D.localize)(35,null,s))),delete i[o]);if(typeof n<"u"){if(t.type==="string[]"){if(Array.isArray(n)||(n=[n]),!t.allowEmptyValue){const o=n.filter(c=>c.length>0);o.length!==n.length&&(P.onEmptyValue(s),n=o.length>0?o:void 0)}}else t.type==="string"&&(Array.isArray(n)?(n=n.pop(),P.onMultipleValues(s,n)):!n&&!t.allowEmptyValue&&(P.onEmptyValue(s),n=void 0));l[s]=n,t.deprecationMessage&&P.onDeprecatedOption(s,t.deprecationMessage)}delete i[s]}for(const s in i)P.onUnknownOption(s);return l}e.parseArgs=I;function E(h,y){let P="";return y.args&&(Array.isArray(y.args)?P=` <${y.args.join("> <")}>`:P=` <${y.args}>`),y.alias?`-${y.alias} --${h}${P}`:`--${h}${P}`}function C(h,y){let P=0;const p=[];for(const l in h){const i=h[l],s=E(l,i);P=Math.max(P,s.length),p.push([s,i.description])}const g=P+2+1;if(y-g<25)return p.reduce((l,i)=>l.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const a=y-g-1,d=[];for(const l of p){const i=l[0],s=S(l[1],a),t=b(g-i.length-2);d.push("  "+i+t+s[0]);for(let n=1;n<s.length;n++)d.push(b(g)+s[n])}return d}e.formatOptions=C;function b(h){return" ".repeat(h)}function S(h,y){const P=[];for(;h.length;){const p=h.length<y?h.length:h.lastIndexOf(" ",y),g=h.slice(0,p).trim();h=h.slice(p),P.push(g)}return P}function m(h,y,P,p,g){const a=process.stdout.isTTY&&process.stdout.columns||80,d=g?.noInputFiles!==!0?`[${(0,D.localize)(36,null)}...]`:"",l=[`${h} ${P}`];l.push(""),l.push(`${(0,D.localize)(37,null)}: ${y} [${(0,D.localize)(38,null)}]${d}`),l.push(""),g?.noPipe!==!0&&(r.isWindows?l.push((0,D.localize)(39,null,y)):l.push((0,D.localize)(40,null,y)),l.push(""));const i={};for(const s in p){const t=p[s];if(t.description&&t.cat){let n=i[t.cat];n||(i[t.cat]=n={}),n[s]=t}}for(const s in i){const t=s,n=i[t];n&&(l.push(L[t]),l.push(...C(n,a)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=m;function v(h,y){return`${h||(0,D.localize)(41,null)}
${y||(0,D.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=v}),define(ne[170],re([0,1,276,142,169]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function T(m,v){const h={onUnknownOption:P=>{console.warn((0,r.localize)(0,null,P))},onMultipleValues:(P,p)=>{console.warn((0,r.localize)(1,null,P,p))},onEmptyValue:P=>{console.warn((0,r.localize)(2,null,P))},onDeprecatedOption:(P,p)=>{console.warn((0,r.localize)(3,null,P,p))}},y=(0,D.parseArgs)(m,D.OPTIONS,v?h:void 0);return y.goto&&y._.forEach(P=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(P),(0,r.localize)(4,null))),y["max-memory"]&&R(parseInt(y["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),y}function I(m){const v=m.findIndex(h=>!/^-/.test(h));if(v>-1)return[...m.slice(0,v),...m.slice(v+1)]}function E(m){let[,...v]=m;process.env.VSCODE_DEV&&(v=I(v)||[]);const h=!S(process.env);return T(v,h)}e.parseMainProcessArgv=E;function C(m){const[,,...v]=m;return T(v,!0)}e.parseCLIProcessArgv=C;function b(m,...v){const h=m.indexOf("--");return h===-1?m.push(...v):m.splice(h,0,...v),m}e.addArg=b;function S(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=S}),function(){"use strict";function Q(e,R,r,D){function L(I){const E=T(I),C=[E];return e.isAbsolute(E)||C.unshift(D),e.resolve(...C)}function T(I){const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let C=process.env.VSCODE_APPDATA;if(C)return e.join(C,r);const b=I["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(C=process.env.APPDATA,!C){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");C=e.join(S,"AppData","Roaming")}break;case"darwin":C=e.join(R.homedir(),"Library","Application Support");break;case"linux":C=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(C,r)}return{getUserDataPath:L}}if(typeof define=="function")define(ne[171],re([0,277,37,21,17,36]),function(e,R,r,D,L,T){const I=L.dirname(D.FileAccess.asFileUri("",e)),E=e.__$__nodeRequire(L.joinPath(I,"package.json").fsPath);return Q(R,r,E.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),r=require("os");module.exports=Q(R,r,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[172],re([0,1,37,90,171]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends r.AbstractNativeEnvironmentService{constructor(I,E){super(I,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,D.getUserDataPath)(I)},E)}}e.NativeEnvironmentService=L}),define(ne[173],re([0,1,7]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const r=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,I=/^\s*url\s*=\s*(.+\S)\s*$/mg,E=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function C(P){const p=P.match(T);return p?p[1]:null}function b(P){if(P.indexOf("://")===-1){const p=P.match(r);return p?C(p[2]):null}try{const p=R.URI.parse(P);if(p.authority)return C(p.authority)}catch{}return null}function S(P,p){const g=new Set;let a;for(;a=I.exec(P);){const l=b(a[1]);l&&g.add(l)}const d=new Set(p);return Array.from(g).map(l=>d.has(l)?l:l.replace(E,"a"))}e.getDomainsOfRemotes=S;function m(P){const p=P.match(L);return p?p[2]:null}function v(P,p,g){return P&&p?(g&&p.endsWith(".git")&&(p=p.substr(0,p.length-4)),p.indexOf("/")===0?`${P}${p}`:`${P}/${p}`):null}function h(P,p){if(P.indexOf("://")===-1){const g=P.match(D);if(g)return v(g[2],g[3],p)}try{const g=R.URI.parse(P);if(g.authority)return v(m(g.authority),g.path,p)}catch{}return null}function y(P,p=!1){const g=[];let a;for(;a=I.exec(P);){const d=h(a[1],p);d&&g.push(d)}return g}e.getRemotes=y}),define(ne[174],re([0,1,15,145]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(T,I,E){try{L(T,I,E)}catch{}return T}e.localizeManifest=D;function L(T,I,E){const C=(b,S,m)=>{const v=b[S];if((0,R.isString)(v)){const h=v,y=h.length;if(y>1&&h[0]==="%"&&h[y-1]==="%"){const P=h.substr(1,y-2);let p=I[P];p===void 0&&E&&(p=E[P]);const g=typeof p=="string"?p:p.message;if(g!==void 0){const a=E?.[P],d=typeof a=="string"?a:a?.message;if(m&&(S==="title"||S==="category")&&d&&d!==g){const l={value:g,original:d};b[S]=l}else b[S]=g}else console.warn(`[${T.name}]: ${(0,r.localize)(0,null,P)}`)}}else if((0,R.isObject)(v))for(const h in v)v.hasOwnProperty(h)&&(h==="commands"?C(v,h,!0):C(v,h,m));else if(Array.isArray(v))for(let h=0;h<v.length;h++)C(v,h,m)};for(const b in T)T.hasOwnProperty(b)&&C(T,b)}}),define(ne[175],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,T,I,E){return this.channel.call("promptImportantExtensionsInstallNotification",[L,T,I,E])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class r{constructor(L){this.service=L}listen(L,T){throw new Error(`Event not found: ${T}`)}call(L,T,I){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(I[0],I[1],I[2],I[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=r}),define(ne[68],re([0,1,17,84,150,55]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function E(p){return p=p.trim(),p==="*"||T.test(p)}e.isValidVersionStr=E;function C(p){if(!E(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=p.match(T);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=C;function b(p){if(!p)return null;const g=p.majorBase,a=p.majorMustEqual,d=p.minorBase;let l=p.minorMustEqual;const i=p.patchBase;let s=p.patchMustEqual;p.hasCaret&&(g===0||(l=!1),s=!1);let t=0;if(p.preRelease){const n=I.exec(p.preRelease);if(n){const[,o,c,u]=n;t=Date.UTC(Number(o),Number(c)-1,Number(u))}}return{majorBase:g,majorMustEqual:a,minorBase:d,minorMustEqual:l,patchBase:i,patchMustEqual:s,isMinimum:p.hasGreaterEquals,notBefore:t}}e.normalizeVersion=b;function S(p,g,a){let d;typeof p=="string"?d=b(C(p)):d=p;let l;g instanceof Date?l=g.getTime():typeof g=="string"&&(l=new Date(g).getTime());let i;if(typeof a=="string"?i=b(C(a)):i=a,!d||!i)return!1;const s=d.majorBase,t=d.minorBase,n=d.patchBase;let o=i.majorBase,c=i.minorBase,u=i.patchBase;const f=i.notBefore;let w=i.majorMustEqual,_=i.minorMustEqual,N=i.patchMustEqual;return i.isMinimum?s>o?!0:s<o?!1:t>c?!0:t<c||l&&l<f?!1:n>=u:(s===1&&o===0&&(!w||!_||!N)&&(o=1,c=0,u=0,w=!0,_=!1,N=!1),s<o?!1:s>o?!w:t<c?!1:t>c?!_:n<u?!1:n>u?!N:!(l&&l<f))}e.isValidVersion=S;function m(p,g,a,d,l){const i=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return i.push([r.default.Error,D.localize(0,null)]),i;if(typeof d.name!="string")return i.push([r.default.Error,D.localize(1,null,"name")]),i;if(typeof d.version!="string")return i.push([r.default.Error,D.localize(2,null,"version")]),i;if(!d.engines)return i.push([r.default.Error,D.localize(3,null,"engines")]),i;if(typeof d.engines.vscode!="string")return i.push([r.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof d.extensionDependencies<"u"&&!P(d.extensionDependencies))return i.push([r.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof d.activationEvents<"u"){if(!P(d.activationEvents))return i.push([r.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof d.main>"u"&&typeof d.browser>"u")return i.push([r.default.Error,D.localize(7,null,"activationEvents","main")]),i}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&i.push([r.default.Warning,D.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return i.push([r.default.Error,D.localize(9,null,"main")]),i;{const n=(0,R.joinPath)(a,d.main);(0,R.isEqualOrParent)(n,a)||i.push([r.default.Warning,D.localize(10,null,n.path,a.path)])}if(typeof d.activationEvents>"u")return i.push([r.default.Error,D.localize(11,null,"activationEvents","main")]),i}if(typeof d.browser<"u"){if(typeof d.browser!="string")return i.push([r.default.Error,D.localize(12,null,"browser")]),i;{const n=(0,R.joinPath)(a,d.browser);(0,R.isEqualOrParent)(n,a)||i.push([r.default.Warning,D.localize(13,null,n.path,a.path)])}if(typeof d.activationEvents>"u")return i.push([r.default.Error,D.localize(14,null,"activationEvents","browser")]),i}if(!L.valid(d.version))return i.push([r.default.Error,D.localize(15,null)]),i;const s=[];if(!v(p,g,d,l,s))for(const n of s)i.push([r.default.Error,n]);return i}e.validateExtensionManifest=m;function v(p,g,a,d,l){return d||typeof a.main>"u"&&typeof a.browser>"u"?!0:y(p,g,a.engines.vscode,l)}e.isValidExtensionVersion=v;function h(p,g,a){return p==="*"||y(g,a,p)}e.isEngineValid=h;function y(p,g,a,d=[]){const l=b(C(a));if(!l)return d.push(D.localize(16,null,a)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return d.push(D.localize(17,null,a)),!1}else if(!l.majorMustEqual)return d.push(D.localize(18,null,a)),!1;return S(p,g,l)?!0:(d.push(D.localize(19,null,p,a)),!1)}function P(p){if(!Array.isArray(p))return!1;for(let g=0,a=p.length;g<a;g++)if(typeof p[g]!="string")return!1;return!0}}),define(ne[48],re([0,1,16,30]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(L,T,I){let E=I&&I.get("storage.serviceMachineId",-1)||null;if(E)return E;try{const b=(await T.readFile(L.serviceMachineIdResource)).value.toString();E=(0,r.isUUID)(b)?b:null}catch{E=null}if(!E){E=(0,r.generateUuid)();try{await T.writeFile(L.serviceMachineIdResource,R.VSBuffer.fromString(E))}catch{}}return I?.store("storage.serviceMachineId",E,-1,1),E}e.getServiceMachineId=D}),define(ne[56],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(D,L=[],T=!1){this.ctor=D,this.staticArguments=L,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=R}),define(ne[91],re([0,1,56]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const r=[];var D;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function L(I,E,C){E instanceof R.SyncDescriptor||(E=new R.SyncDescriptor(E,[],Boolean(C))),r.push([I,E])}e.registerSingleton=L;function T(){return r}e.getSingletonServiceDescriptors=T}),define(ne[176],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(L,T){this.key=L,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=R;class r{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const T of this._nodes.values())T.outgoing.size===0&&L.push(T);return L}insertEdge(L,T){const I=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(T);I.outgoing.set(E.key,E),E.incoming.set(I.key,I)}removeNode(L){const T=this._hashFn(L);this._nodes.delete(T);for(const I of this._nodes.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(L){const T=this._hashFn(L);let I=this._nodes.get(T);return I||(I=new R(T,L),this._nodes.set(T,I)),I}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[T,I]of this._nodes)L.push(`${T}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,T]of this._nodes){const I=new Set([L]),E=this._findCycle(T,I);if(E)return E}}_findCycle(L,T){for(const[I,E]of L.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const C=this._findCycle(E,T);if(C)return C;T.delete(I)}}}e.Graph=r}),define(ne[5],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function I(E){return E[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=I})(R=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function r(T,I,E){I[R.DI_TARGET]===I?I[R.DI_DEPENDENCIES].push({id:T,index:E}):(I[R.DI_DEPENDENCIES]=[{id:T,index:E}],I[R.DI_TARGET]=I)}function D(T){if(R.serviceIds.has(T))return R.serviceIds.get(T);const I=function(E,C,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(I,E,b)};return I.toString=()=>T,R.serviceIds.set(T,I),I}e.createDecorator=D;function L(T){return T}e.refineServiceDecorator=L}),define(ne[177],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(ne[18],re([0,1,15,7,5]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function L(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof r.URI)}e.isConfigurationOverrides=L;function T(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof r.URI)}e.isConfigurationUpdateOverrides=T;var I;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function C(p,g){const a=Object.create(null);for(const d in p)b(a,d,p[d],g);return a}e.toValuesTree=C;function b(p,g,a,d){const l=g.split("."),i=l.pop();let s=p;for(let t=0;t<l.length;t++){const n=l[t];let o=s[n];switch(typeof o){case"undefined":o=s[n]=Object.create(null);break;case"object":break;default:d(`Ignoring ${g} as ${l.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}s=o}if(typeof s=="object"&&s!==null)try{s[i]=a}catch{d(`Ignoring ${g} as ${l.join(".")} is ${JSON.stringify(s)}`)}else d(`Ignoring ${g} as ${l.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=b;function S(p,g){const a=g.split(".");m(p,a)}e.removeFromValueTree=S;function m(p,g){const a=g.shift();if(g.length===0){delete p[a];return}if(Object.keys(p).indexOf(a)!==-1){const d=p[a];typeof d=="object"&&!Array.isArray(d)&&(m(d,g),Object.keys(d).length===0&&delete p[a])}}function v(p,g,a){function d(s,t){let n=s;for(const o of t){if(typeof n!="object"||n===null)return;n=n[o]}return n}const l=g.split("."),i=d(p,l);return typeof i>"u"?a:i}e.getConfigurationValue=v;function h(p,g,a){Object.keys(g).forEach(d=>{d!=="__proto__"&&(d in p?R.isObject(p[d])&&R.isObject(g[d])?h(p[d],g[d],a):a&&(p[d]=g[d]):p[d]=g[d])})}e.merge=h;function y(p,g,a){const d=p.inspect(g),l=p.inspect(a);return typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:d.defaultValue}e.getMigratedSettingValue=y;function P(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=P}),define(ne[178],re([0,1,4,27,5]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",R.isMacintosh),L.set("isLinux",R.isLinux),L.set("isWindows",R.isWindows),L.set("isWeb",R.isWeb),L.set("isMacNative",R.isMacintosh&&!R.isWeb),L.set("isEdge",R.isEdge),L.set("isFirefox",R.isFirefox),L.set("isChrome",R.isChrome),L.set("isSafari",R.isSafari);const T=Object.prototype.hasOwnProperty;var I;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return S.INSTANCE}static true(){return m.INSTANCE}static has(k){return v.create(k)}static equals(k,M){return h.create(k,M)}static notEquals(k,M){return p.create(k,M)}static regex(k,M){return t.create(k,M)}static in(k,M){return y.create(k,M)}static notIn(k,M){return P.create(k,M)}static not(k){return g.create(k)}static and(...k){return c.create(k,null)}static or(...k){return u.create(k,null,!0)}static greater(k,M){return d.create(k,M)}static greaterEquals(k,M){return l.create(k,M)}static smaller(k,M){return i.create(k,M)}static smallerEquals(k,M){return s.create(k,M)}static deserialize(k,M=!1){if(!!k)return this._deserializeOrExpression(k,M)}static _deserializeOrExpression(k,M){const $=k.split("||");return u.create($.map(W=>this._deserializeAndExpression(W,M)),null,!0)}static _deserializeAndExpression(k,M){const $=k.split("&&");return c.create($.map(W=>this._deserializeOne(W,M)),null)}static _deserializeOne(k,M){if(k=k.trim(),k.indexOf("!=")>=0){const $=k.split("!=");return p.create($[0].trim(),this._deserializeValue($[1],M))}if(k.indexOf("==")>=0){const $=k.split("==");return h.create($[0].trim(),this._deserializeValue($[1],M))}if(k.indexOf("=~")>=0){const $=k.split("=~");return t.create($[0].trim(),this._deserializeRegexValue($[1],M))}if(k.indexOf(" not in ")>=0){const $=k.split(" not in ");return P.create($[0].trim(),$[1].trim())}if(k.indexOf(" in ")>=0){const $=k.split(" in ");return y.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const $=k.split(">=");return l.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const $=k.split(">");return d.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const $=k.split("<=");return s.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const $=k.split("<");return i.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(k)?g.create(k.substr(1).trim()):v.create(k)}static _deserializeValue(k,M){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;const $=/^'([^']*)'$/.exec(k);return $?$[1].trim():k}static _deserializeRegexValue(k,M){if((0,r.isFalsyOrWhitespace)(k)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=k.indexOf("/"),W=k.lastIndexOf("/");if($===W||$<0){if(M)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}const J=k.slice($+1,W),H=k[W+1]==="i"?"i":"";try{return new RegExp(J,H)}catch(G){if(M)throw new Error(`bad regexp-value '${k}', parse error: ${G}`);return console.warn(`bad regexp-value '${k}', parse error: ${G}`),null}}}e.ContextKeyExpr=E;function C(O,k){const M=O?O.substituteConstants():void 0,$=k?k.substituteConstants():void 0;return!M&&!$?!0:!M||!$?!1:M.equals($)}e.expressionsAreEqualWithConstantSubstitution=C;function b(O,k){return O.cmp(k)}class S{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=S,S.INSTANCE=new S;class m{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return S.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class v{constructor(k,M){this.key=k,this.negated=M,this.type=2}static create(k,M=null){const $=L.get(k);return typeof $=="boolean"?$?m.INSTANCE:S.INSTANCE:new v(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:w(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=L.get(this.key);return typeof k=="boolean"?k?m.INSTANCE:S.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class h{constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=4}static create(k,M,$=null){if(typeof M=="boolean")return M?v.create(k,$):g.create(k,$);const W=L.get(k);return typeof W=="boolean"?M===(W?"true":"false")?m.INSTANCE:S.INSTANCE:new h(k,M,$)}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=L.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?m.INSTANCE:S.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class y{constructor(k,M){this.key=k,this.valueKey=M,this.type=10,this.negated=null}static create(k,M){return new y(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const M=k.getValue(this.valueKey),$=k.getValue(this.key);return Array.isArray(M)?M.includes($):typeof $=="string"&&typeof M=="object"&&M!==null?T.call(M,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=P.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=y;class P{constructor(k,M){this.key=k,this.valueKey=M,this.type=11,this._negated=y.create(k,M)}static create(k,M){return new P(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:this._negated.cmp(k._negated)}equals(k){return k.type===this.type?this._negated.equals(k._negated):!1}substituteConstants(){return this}evaluate(k){return!this._negated.evaluate(k)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(k){return k.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=P;class p{constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=5}static create(k,M,$=null){if(typeof M=="boolean")return M?g.create(k,$):v.create(k,$);const W=L.get(k);return typeof W=="boolean"?M===(W?"true":"false")?S.INSTANCE:m.INSTANCE:new p(k,M,$)}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=L.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?S.INSTANCE:m.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=p;class g{constructor(k,M){this.key=k,this.negated=M,this.type=3}static create(k,M=null){const $=L.get(k);return typeof $=="boolean"?$?S.INSTANCE:m.INSTANCE:new g(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:w(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=L.get(this.key);return typeof k=="boolean"?k?S.INSTANCE:m.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function a(O,k){if(typeof O=="string"){const M=parseFloat(O);isNaN(M)||(O=M)}return typeof O=="string"||typeof O=="number"?k(O):S.INSTANCE}class d{constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=12}static create(k,M,$=null){return a(M,W=>new d(k,W,$))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=d;class l{constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=13}static create(k,M,$=null){return a(M,W=>new l(k,W,$))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class i{constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=14}static create(k,M,$=null){return a(M,W=>new i(k,W,$))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class s{constructor(k,M,$){this.key=k,this.value=M,this.negated=$,this.type=15}static create(k,M,$=null){return a(M,W=>new s(k,W,$))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class t{constructor(k,M){this.key=k,this.regexp=M,this.type=7,this.negated=null}static create(k,M){return new t(k,M)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const M=this.regexp?this.regexp.source:"",$=k.regexp?k.regexp.source:"";return M<$?-1:M>$?1:0}equals(k){if(k.type===this.type){const M=this.regexp?this.regexp.source:"",$=k.regexp?k.regexp.source:"";return this.key===k.key&&M===$}return!1}substituteConstants(){return this}evaluate(k){const M=k.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class n{constructor(k){this._actual=k,this.type=8}static create(k){return new n(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new n(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function o(O){let k=null;for(let M=0,$=O.length;M<$;M++){const W=O[M].substituteConstants();if(O[M]!==W&&k===null){k=[];for(let J=0;J<M;J++)k[J]=O[J]}k!==null&&(k[M]=W)}return k===null?O:k}class c{constructor(k,M){this.expr=k,this.negated=M,this.type=6}static create(k,M){return c._normalizeArr(k,M)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const W=b(this.expr[M],k.expr[M]);if(W!==0)return W}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:c.create(k,this.negated)}evaluate(k){for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].evaluate(k))return!1;return!0}static _normalizeArr(k,M){const $=[];let W=!1;for(const J of k)if(!!J){if(J.type===1){W=!0;continue}if(J.type===0)return S.INSTANCE;if(J.type===6){$.push(...J.expr);continue}$.push(J)}if($.length===0&&W)return m.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(b);for(let J=1;J<$.length;J++)$[J-1].equals($[J])&&($.splice(J,1),J--);if($.length===1)return $[0];for(;$.length>1;){const J=$[$.length-1];if(J.type!==9)break;$.pop();const H=$.pop(),G=$.length===0,q=u.create(J.expr.map(x=>c.create([x,H],null)),null,G);q&&($.push(q),$.sort(b))}return $.length===1?$[0]:new c($,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const M of this.expr)k.push(...M.keys());return k}map(k){return new c(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){const k=[];for(const M of this.expr)k.push(M.negate());this.negated=u.create(k,this,!0)}return this.negated}}class u{constructor(k,M){this.expr=k,this.negated=M,this.type=9}static create(k,M,$){return u._normalizeArr(k,M,$)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const W=b(this.expr[M],k.expr[M]);if(W!==0)return W}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:u.create(k,this.negated,!1)}evaluate(k){for(let M=0,$=this.expr.length;M<$;M++)if(this.expr[M].evaluate(k))return!0;return!1}static _normalizeArr(k,M,$){let W=[],J=!1;if(k){for(let H=0,G=k.length;H<G;H++){const q=k[H];if(!!q){if(q.type===0){J=!0;continue}if(q.type===1)return m.INSTANCE;if(q.type===9){W=W.concat(q.expr);continue}W.push(q)}}if(W.length===0&&J)return S.INSTANCE;W.sort(b)}if(W.length!==0){if(W.length===1)return W[0];for(let H=1;H<W.length;H++)W[H-1].equals(W[H])&&(W.splice(H,1),H--);if(W.length===1)return W[0];if($){for(let H=0;H<W.length;H++)for(let G=H+1;G<W.length;G++)N(W[H],W[G])&&(W.splice(G,1),G--);if(W.length===1)return W[0]}return new u(W,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const M of this.expr)k.push(...M.keys());return k}map(k){return new u(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){const k=[];for(const M of this.expr)k.push(M.negate());for(;k.length>1;){const M=k.shift(),$=k.shift(),W=[];for(const H of A(M))for(const G of A($))W.push(c.create([H,G],null));const J=k.length===0;k.unshift(u.create(W,null,J))}this.negated=k[0]}return this.negated}}class f extends v{constructor(k,M,$){super(k,null),this._defaultValue=M,typeof $=="object"?f._info.push({...$,key:k}):$!==!0&&f._info.push({key:k,description:$,type:M!=null?typeof M:void 0})}static all(){return f._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return h.create(this.key,k)}notEqualsTo(k){return p.create(this.key,k)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function w(O,k){return O<k?-1:O>k?1:0}function _(O,k,M,$){return O<M?-1:O>M?1:k<$?-1:k>$?1:0}function N(O,k){if(k.type===6&&O.type!==9&&O.type!==6){for(const W of k.expr)if(O.equals(W))return!0}const M=O.negate(),$=A(M).concat(A(k));$.sort(b);for(let W=0;W<$.length;W++){const H=$[W].negate();for(let G=W+1;G<$.length;G++){const q=$[G];if(H.equals(q))return!0}}return!1}e.implies=N;function A(O){return O.type===9?O.expr:[O]}}),define(ne[92],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function r(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=r;class D{async getPerformanceInfo(T,I){return{}}async getSystemInfo(T,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,I){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=D}),define(ne[93],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(ne[14],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[29],re([0,1,144,5]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function L(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function T(p,g){switch(p){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function I(p,g){return g==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function E(p,g,a){return I(g,a)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===a?!0:C(a).includes(p)}e.isTargetPlatformCompatible=E;function C(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function b(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=b;var S;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var m;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var v;(function(p){p.Install="install",p.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var h;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,r.createDecorator)("extensionGalleryService");var y;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class P extends Error{constructor(g,a){super(g),this.code=a,this.name=a}}e.ExtensionManagementError=P,e.IExtensionManagementService=(0,r.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,r.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,r.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ne[179],re([0,1,3,2,65,32,7,131,29]),function(Q,e,R,r,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(P,p){return T.URI.revive(p?p.transformIncoming(P):P)}function b(P,p){return p?p.transformOutgoingURI(P):P}function S(P,p){p=p||I.DefaultURITransformer;const g=P.manifest;return{...(0,I.transformAndReviveIncomingURIs)({...P,manifest:void 0},p),manifest:g}}function m(P,p){return p?(0,L.cloneAndChange)(P,g=>g instanceof T.URI?p.transformOutgoingURI(g):void 0):P}class v{constructor(p,g){this.service=p,this.getUriTransformer=g,this.onInstallExtension=R.Event.buffer(p.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(p.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(p.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(p.onDidUninstallExtension,!0)}listen(p,g){const a=this.getUriTransformer(p);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,d=>d.map(l=>({...l,local:l.local?m(l.local,a):l.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(p,g,a){const d=this.getUriTransformer(p);switch(g){case"zip":return this.service.zip(S(a[0],d)).then(l=>b(l,d));case"unzip":return this.service.unzip(C(a[0],d));case"install":return this.service.install(C(a[0],d),(0,D.revive)(a[1]));case"getManifest":return this.service.getManifest(C(a[0],d));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(a[0]);case"installFromGallery":return this.service.installFromGallery(a[0],(0,D.revive)(a[1]));case"uninstall":return this.service.uninstall(S(a[0],d),(0,D.revive)(a[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(S(a[0],d));case"getInstalled":return this.service.getInstalled(a[0],T.URI.revive(a[1])).then(l=>l.map(i=>m(i,d)));case"getMetadata":return this.service.getMetadata(S(a[0],d));case"updateMetadata":return this.service.updateMetadata(S(a[0],d),a[1]).then(l=>m(l,d));case"updateExtensionScope":return this.service.updateExtensionScope(S(a[0],d),a[1]).then(l=>m(l,d));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=v;class h extends r.Disposable{constructor(p){super(),this.channel=p,this._onInstallExtension=this._register(new R.Emitter),this._onDidInstallExtensions=this._register(new R.Emitter),this._onUninstallExtension=this._register(new R.Emitter),this._onDidUninstallExtension=this._register(new R.Emitter),this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?T.URI.revive(g.source):g.source,profileLocation:T.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(a=>({...a,local:a.local?S(a.local,null):a.local,source:this.isUriComponents(a.source)?T.URI.revive(a.source):a.source,profileLocation:T.URI.revive(a.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire({identifier:g.identifier,profileLocation:T.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire({...g,profileLocation:T.URI.revive(g.profileLocation)})))}get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}isUriComponents(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(p){const g=await this.getTargetPlatform();return p.allTargetPlatforms.some(a=>(0,E.isTargetPlatformCompatible)(a,p.allTargetPlatforms,g))}zip(p){return Promise.resolve(this.channel.call("zip",[p]).then(g=>T.URI.revive(g)))}unzip(p){return Promise.resolve(this.channel.call("unzip",[p]))}install(p,g){return Promise.resolve(this.channel.call("install",[p,g])).then(a=>S(a,null))}getManifest(p){return Promise.resolve(this.channel.call("getManifest",[p]))}installFromGallery(p,g){return Promise.resolve(this.channel.call("installFromGallery",[p,g])).then(a=>S(a,null))}uninstall(p,g){return Promise.resolve(this.channel.call("uninstall",[p,g]))}reinstallFromGallery(p){return Promise.resolve(this.channel.call("reinstallFromGallery",[p]))}getInstalled(p=null,g){return Promise.resolve(this.channel.call("getInstalled",[p,g])).then(a=>a.map(d=>S(d,null)))}getMetadata(p){return Promise.resolve(this.channel.call("getMetadata",[p]))}updateMetadata(p,g){return Promise.resolve(this.channel.call("updateMetadata",[p,g])).then(a=>S(a,null))}updateExtensionScope(p,g){return Promise.resolve(this.channel.call("updateExtensionScope",[p,g])).then(a=>S(a,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class y{constructor(p){this.service=p}listen(p,g){throw new Error("Invalid listen")}call(p,g,a){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(a[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=y}),define(ne[94],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var r;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(r=e.RecommendationSource||(e.RecommendationSource={}));function D(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var L;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[13],re([0,1,34,12,27,15,7,152,5]),function(Q,e,R,r,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function C(H){return H.create===!0}e.isFileOpenForWriteOptions=C;var b;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var S;(function(H){H[H.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var m;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=v;function h(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=h;function y(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=y;function P(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=P;function p(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=p;function g(H){return v(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var a;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(a=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(G,q){super(G),this.code=q}}e.FileSystemProviderError=d;function l(H,G){const q=new d(H.toString(),G);return s(q,G),q}e.createFileSystemProviderError=l;function i(H){return H||l((0,I.localize)(0,null),a.Unknown)}e.ensureFileSystemProviderError=i;function s(H,G){return H.name=G?`${G} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=s;function t(H){if(!H)return a.Unknown;if(H instanceof d)return H.code;const G=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!G)return a.Unknown;switch(G[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileExceedsMemoryLimit:return a.FileExceedsMemoryLimit;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.toFileSystemProviderErrorCode=t;function n(H){if(H instanceof _)return H.fileOperationResult;switch(t(H)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 10;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileExceedsMemoryLimit:return 9;case a.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var o;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class c{constructor(G,q,x){this.resource=G,this.operation=q,this.target=x}isOperation(G){return this.operation===G}}e.FileOperationEvent=c;var u;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class f{constructor(G,q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=G;const x=new Map;for(const Y of G){const te=x.get(Y.type);switch(te?te.push([Y.resource,Y]):x.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,te]of x)switch(Y){case 1:this.added=R.TernarySearchTree.forUris(()=>q),this.added.fill(te);break;case 0:this.updated=R.TernarySearchTree.forUris(()=>q),this.updated.fill(te);break;case 2:this.deleted=R.TernarySearchTree.forUris(()=>q),this.deleted.fill(te);break}}contains(G,...q){return this.doContains(G,{includeChildren:!1},...q)}affects(G,...q){return this.doContains(G,{includeChildren:!0},...q)}doContains(G,q,...x){if(!G)return!1;const Y=x.length>0;return!!((!Y||x.includes(1))&&(this.added?.get(G)||q.includeChildren&&this.added?.findSuperstr(G))||(!Y||x.includes(0))&&(this.updated?.get(G)||q.includeChildren&&this.updated?.findSuperstr(G))||(!Y||x.includes(2))&&(this.deleted?.findSubstr(G)||q.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=f;function w(H,G,q){return!H||!G||H===G||G.length>H.length?!1:(G.charAt(G.length-1)!==r.sep&&(G+=r.sep),q?(0,D.startsWithIgnoreCase)(H,G):H.indexOf(G)===0)}e.isParent=w;class _ extends Error{constructor(G,q,x){super(G),this.fileOperationResult=q,this.options=x}}e.FileOperationError=_;class N extends _{constructor(G,q,x){super(G,2,x),this.stat=q}}e.NotModifiedSinceFileOperationError=N;var A;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function k(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=k;async function M(H,G){if(!G.hasProvider(T.URI.from({scheme:H.scheme})))return new Promise(q=>{const x=G.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===H.scheme&&Y.added&&(x.dispose(),q())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(G){return(0,L.isNumber)(G)||(G=0),G<$.KB?(0,I.localize)(1,null,G.toFixed(0)):G<$.MB?(0,I.localize)(2,null,(G/$.KB).toFixed(2)):G<$.GB?(0,I.localize)(3,null,(G/$.MB).toFixed(2)):G<$.TB?(0,I.localize)(4,null,(G/$.GB).toFixed(2)):(0,I.localize)(5,null,(G/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var W;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(W=e.Arch||(e.Arch={}));function J(H){return{maxFileSize:H===0?300*$.MB:16*$.GB,maxHeapSize:H===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=J});var K=this&&this.__param||function(Q,e){return function(R,r){e(R,r,Q)}};define(ne[180],re([0,1,95,42,13]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(I){this.fileService=I}async checksum(I){const E=(await this.fileService.readFileStream(I)).value;return new Promise((C,b)=>{const S=(0,R.createHash)("md5");(0,r.listenStream)(E,{onData:m=>S.update(m.buffer),onError:m=>b(m),onEnd:()=>C(S.digest("base64").replace(/=+$/,""))})})}};L=pe([K(0,D.IFileService)],L),e.ChecksumService=L}),define(ne[181],re([0,1,16,38,9,3,2,42,7,30,13]),function(Q,e,R,r,D,L,T,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class S extends T.Disposable{constructor(v,h){super(),this.channel=v,this.extraCapabilities=h,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,C.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,h){const{buffer:y}=await this.channel.call("readFile",[v,h]);return y}readFileStream(v,h,y){const P=(0,I.newWriteableStream)(g=>R.VSBuffer.concat(g.map(a=>R.VSBuffer.wrap(a))).buffer),p=this.channel.listen("readFileStream",[v,h])(g=>{if(g instanceof R.VSBuffer)P.write(g.buffer);else{if(g==="end")P.end();else{let a=g;a instanceof Error||(a=(0,b.createFileSystemProviderError)((0,r.toErrorMessage)(a),b.FileSystemProviderErrorCode.Unknown)),P.error(a),P.end()}p.dispose()}});return y.onCancellationRequested(()=>{P.error((0,D.canceled)()),P.end(),p.dispose()}),P}writeFile(v,h,y){return this.channel.call("writeFile",[v,R.VSBuffer.wrap(h),y])}open(v,h){return this.channel.call("open",[v,h])}close(v){return this.channel.call("close",[v])}async read(v,h,y,P,p){const[g,a]=await this.channel.call("read",[v,h,p]);return y.set(g.buffer.slice(0,a),P),a}write(v,h,y,P,p){return this.channel.call("write",[v,h,R.VSBuffer.wrap(y),P,p])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,h){return this.channel.call("delete",[v,h])}rename(v,h,y){return this.channel.call("rename",[v,h,y])}copy(v,h,y){return this.channel.call("copy",[v,h,y])}cloneFile(v,h){return this.channel.call("cloneFile",[v,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const h=v;this._onDidChange.fire(h.map(y=>({resource:E.URI.revive(y.resource),type:y.type})))}else{const h=v;this._onDidWatchError.fire(h)}}))}watch(v,h){const y=(0,C.generateUuid)();return this.channel.call("watch",[this.sessionId,y,v,h]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=S}),define(ne[96],re([0,1,16,9,153,13]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(b,S,m,v,h,y){let P;try{await I(b,S,m,v,h,y)}catch(p){P=p}finally{P&&h.errorTransformer&&(P=h.errorTransformer(P)),typeof P<"u"&&m.error(P),m.end()}}e.readFileIntoStream=T;async function I(b,S,m,v,h,y){E(y);const P=await b.open(S,{create:!1});try{E(y);let p=0,g=0,a=h&&typeof h.length=="number"?h.length:void 0,d=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof a=="number"?a:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,i=0;do g=await b.read(P,l,d.buffer,i,d.byteLength-i),l+=g,i+=g,p+=g,typeof a=="number"&&(a-=g),i===d.byteLength&&(await m.write(v(d)),d=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof a=="number"?a:h.bufferSize)),i=0);while(g>0&&(typeof a!="number"||a>0)&&E(y)&&C(p,h));if(i>0){let s=i;typeof a=="number"&&(s=Math.min(i,a)),m.write(v(d.slice(0,s)))}}catch(p){throw(0,L.ensureFileSystemProviderError)(p)}finally{await b.close(P)}}function E(b){if(b.isCancellationRequested)throw(0,r.canceled)();return!0}function C(b,S){if(S?.limits){if(typeof S.limits.memory=="number"&&b>S.limits.memory)throw(0,L.createFileSystemProviderError)((0,D.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&b>S.limits.size)throw(0,L.createFileSystemProviderError)((0,D.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[57],re([0,1,85,2,12,4,7,13]),function(Q,e,R,r,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function E(p){return p.recursive===!0}e.isRecursiveWatchRequest=E;class C extends r.Disposable{constructor(g,a,d,l){super(),this.onFileChanges=g,this.onLogMessage=a,this.verboseLogging=d,this.options=l,this.watcherDisposables=this._register(new r.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new r.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(a=>this.onFileChanges(a))),g.add(this.watcher.onDidLogMessage(a=>this.onLogMessage(a))),g.add(this.watcher.onDidError(a=>this.onError(a)))}onError(g){this.options.restartOnError?this.restartCounter<C.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=C,C.MAX_RESTARTS=5;class b extends C{constructor(g,a,d){super(g,a,d,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class S extends C{constructor(g,a,d){super(g,a,d,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=S;function m(p){return p.map(g=>({type:g.type,resource:T.URI.file(g.path)}))}e.toFileChanges=m;function v(p){const g=new P;for(const a of p)g.processEvent(a);return g.coalesce()}e.coalesceEvents=v;function h(p,g){return typeof g=="string"&&!g.startsWith(R.GLOBSTAR)&&!(0,D.isAbsolute)(g)?{base:p,pattern:g}:g}e.normalizeWatcherPattern=h;function y(p,g){const a=[];for(const d of g)a.push((0,R.parse)(h(p,d)));return a}e.parseWatcherPatterns=y;class P{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return L.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const a=this.mapPathToChange.get(this.toKey(g));let d=!1;if(a){const l=a.type,i=g.type;a.path!==g.path&&(g.type===2||g.type===1)?d=!0:l===1&&i===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(a)):l===2&&i===1?a.type=0:l===1&&i===0||(a.type=i)}else d=!0;d&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],a=[];return Array.from(this.coalesced).filter(d=>d.type!==2?(g.push(d),!1):!0).sort((d,l)=>d.path.length-l.path.length).filter(d=>a.some(l=>(0,I.isParent)(d.path,l,!L.isLinux))?!1:(a.push(d.path),!0)).concat(g)}}}),define(ne[182],re([0,1,53,6,24,47,2,83,12,4,133,28,57]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class v extends T.Disposable{constructor(P,p,g,a){super(),this.request=P,this.onDidFilesChange=p,this.onLogMessage=g,this.verboseLogging=a,this.throttledFileChangesWorker=new r.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.onDidFilesChange(d)),this.fileChangesDelayer=this._register(new r.ThrottledDelayer(v.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,m.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,m.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const P=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await S.Promises.stat(P);this._register(await this.doWatch(P,p.isDirectory()))}catch(P){P.code!=="ENOENT"?this.error(P):this.trace(P)}}async normalizePath(P){let p=P.path;try{p=await S.Promises.realpath(P.path),P.path===p&&(p=await(0,b.realcase)(P.path)??P.path),P.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${P.path}, real: ${p})`)}catch{}return p}async doWatch(P,p){if(C.isMacintosh&&(0,L.isEqualOrParent)(P,"/Volumes/",!0))return this.error(`Refusing to watch ${P} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const g=new D.CancellationTokenSource(this.cts.token),a=new T.DisposableStore;try{const d=(0,E.basename)(P),l=(0,R.watch)(P);a.add((0,T.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${P}'`);const i=new Set;if(p)try{for(const t of await S.Promises.readdir(P))i.add(t)}catch(t){this.error(t)}const s=new Map;a.add((0,T.toDisposable)(()=>{for(const[,t]of s)t.dispose();s.clear()})),l.on("error",(t,n)=>{this.error(`Failed to watch ${P} for changes using fs.watch() (${t}, ${n})`),this.dispose()}),l.on("change",(t,n)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${n}`);let o="";if(n&&(o=n.toString(),C.isMacintosh&&(o=(0,I.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(p)if(t==="rename"){s.get(o)?.dispose();const c=setTimeout(async()=>{if(s.delete(o),o===d&&!await S.Promises.exists(P)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,E.join)(P,o));if(g.token.isCancellationRequested)return;let f;u?i.has(o)?f=0:(f=1,i.add(o)):(i.delete(o),f=2),this.onFileChange({path:(0,E.join)(this.request.path,o),type:f})},v.FILE_DELETE_HANDLER_DELAY);s.set(o,(0,T.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(o)?c=0:(c=1,i.add(o)),this.onFileChange({path:(0,E.join)(this.request.path,o),type:c})}else if(t==="rename"||o!==d){const c=setTimeout(async()=>{const u=await S.Promises.exists(P);g.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),a.add(await this.doWatch(P,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},v.FILE_DELETE_HANDLER_DELAY);a.clear(),a.add((0,T.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(d){await S.Promises.exists(P)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${P} for changes using fs.watch() (${d.toString()})`)}return(0,T.toDisposable)(()=>{g.dispose(!0),a.dispose()})}async onFileChange(P,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${P.type===1?"[ADDED]":P.type===2?"[DELETED]":"[CHANGED]"} ${P.path}`),!p&&this.excludes.some(g=>g(P.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${P.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(P.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${P.path}`):this.fileChangesBuffer.push(P);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const a=(0,m.coalesceEvents)(g);if(a.length>0){if(this.verboseLogging)for(const l of a)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.throttledFileChangesWorker.work(a)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${a[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(P){if(C.isLinux)return S.Promises.exists(P);try{const p=(0,E.basename)(P);return(await S.Promises.readdir((0,E.dirname)(P))).some(a=>a===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(P){this.verboseLogging=P}error(P){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${P}`})}warn(P){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${P}`})}trace(P){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${P}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=v,v.FILE_DELETE_HANDLER_DELAY=100,v.FILE_CHANGES_HANDLER_DELAY=50;async function h(y,P,p,g,a=512){const d=await S.Promises.open(y,"r"),l=Buffer.allocUnsafe(a),i=new D.CancellationTokenSource(g);let s,t=!1;const n={path:y,excludes:[],recursive:!1},o=new v(n,c=>{(async()=>{for(const{type:u}of c)if(u===0){if(t)return;t=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:f}=await S.Promises.read(d,l,0,a,null);if(!f||i.token.isCancellationRequested)break;P(l.slice(0,f))}}catch(f){s=new Error(f),i.dispose(!0)}finally{t=!1}}})()});return await o.ready,p(),new Promise((c,u)=>{i.token.onCancellationRequested(async()=>{o.dispose();try{await S.Promises.close(d)}catch(f){s=new Error(f)}s?u(s):c()})})}e.watchFileContents=h}),define(ne[183],re([0,1,3,85,2,4,182]),function(Q,e,R,r,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends D.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(C){const b=this.normalizeRequests(C),S=b.filter(v=>{const h=this.watchers.get(v.path);return h?!(0,r.patternsEquals)(h.request.excludes,v.excludes)||!(0,r.patternsEquals)(h.request.includes,v.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:v})=>!b.find(h=>h.path===v.path&&(0,r.patternsEquals)(h.excludes,v.excludes)&&(0,r.patternsEquals)(h.includes,v.includes))).map(({request:v})=>v.path);S.length&&this.trace(`Request to start watching: ${S.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const v of m)this.stopWatching(v);for(const v of S)this.startWatching(v)}startWatching(C){const b=new T.NodeJSFileWatcherLibrary(C,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),S={request:C,instance:b};this.watchers.set(C.path,S)}async stop(){for(const[C]of this.watchers)this.stopWatching(C);this.watchers.clear()}stopWatching(C){const b=this.watchers.get(C);b&&(this.watchers.delete(C),b.instance.dispose())}normalizeRequests(C){const b=new Map;for(const S of C){const m=L.isLinux?S.path:S.path.toLowerCase();b.set(m,S)}return Array.from(b.values())}async setVerboseLogging(C){this.verboseLogging=C;for(const[,b]of this.watchers)b.instance.setVerboseLogging(C)}trace(C){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(C)})}toMessage(C,b){return b?`[File Watcher (node.js)] ${C} (path: ${b.request.path})`:`[File Watcher (node.js)] ${C}`}}e.NodeJSWatcher=I}),define(ne[184],re([0,1,57,183]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends R.AbstractNonRecursiveWatcherClient{constructor(T,I,E){super(T,I,E),this.init()}createWatcher(){return new r.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(ne[185],re([0,1,21,39,66,57]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends L.AbstractUniversalWatcherClient{constructor(E,C,b){super(E,C,b),this.init()}createWatcher(E){const C=E.add(new D.Client(R.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(C.onDidProcessExit(({code:b,signal:S})=>this.onError(`terminated by itself with code ${b}, signal: ${S}`))),r.ProxyChannel.toService((0,r.getNextTickChannel)(C.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ne[97],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...D){this._entries=new Map;for(const[L,T]of D)this.set(L,T)}set(D,L){const T=this._entries.get(D);return this._entries.set(D,L),T}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=R}),define(ne[186],re([0,1,6,9,56,176,5,97]),function(Q,e,R,r,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class C extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class b{constructor(h=new I.ServiceCollection,y=!1,P,p=E){this._services=h,this._strict=y,this._parent=P,this._enableTracing=p,this._activeInstantiations=new Set,this._services.set(T.IInstantiationService,this),this._globalGraph=p?P?._globalGraph??new L.Graph(g=>g):void 0}createChild(h){return new b(h,this._strict,this,this._enableTracing)}invokeFunction(h,...y){const P=m.traceInvocation(this._enableTracing,h);let p=!1;try{return h({get:a=>{if(p)throw(0,r.illegalState)("service accessor is only valid during the invocation of its target method");const d=this._getOrCreateServiceInstance(a,P);if(!d)throw new Error(`[invokeFunction] unknown service '${a}'`);return d}},...y)}finally{p=!0,P.stop()}}createInstance(h,...y){let P,p;return h instanceof D.SyncDescriptor?(P=m.traceCreation(this._enableTracing,h.ctor),p=this._createInstance(h.ctor,h.staticArguments.concat(y),P)):(P=m.traceCreation(this._enableTracing,h),p=this._createInstance(h,y,P)),P.stop(),p}_createInstance(h,y=[],P){const p=T._util.getServiceDependencies(h).sort((d,l)=>d.index-l.index),g=[];for(const d of p){const l=this._getOrCreateServiceInstance(d.id,P);l||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${d.id}.`,!1),g.push(l)}const a=p.length>0?p[0].index:y.length;if(y.length!==a){console.trace(`[createInstance] First service dependency of ${h.name} at position ${a+1} conflicts with ${y.length} static arguments`);const d=a-y.length;d>0?y=y.concat(new Array(d)):y=y.slice(0,a)}return new h(...y,...g)}_setServiceInstance(h,y){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,y);else if(this._parent)this._parent._setServiceInstance(h,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const y=this._services.get(h);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):y}_getOrCreateServiceInstance(h,y){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(h));const P=this._getServiceInstanceOrDescriptor(h);return P instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,P,y.branch(h,!0)):(y.branch(h,!1),P)}_safeCreateAndCacheServiceInstance(h,y,P){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,y,P)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,y,P){const p=new L.Graph(d=>d.id.toString());let g=0;const a=[{id:h,desc:y,_trace:P}];for(;a.length;){const d=a.pop();if(p.lookupOrInsertNode(d),g++>1e3)throw new C(p);for(const l of T._util.getServiceDependencies(d.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(l.id);if(i||this._throwIfStrict(`[createInstance] ${h} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(d.id),String(l.id)),i instanceof D.SyncDescriptor){const s={id:l.id,desc:i,_trace:d._trace.branch(l.id,!0)};p.insertEdge(d,s),a.push(s)}}}for(;;){const d=p.roots();if(d.length===0){if(!p.isEmpty())throw new C(p);break}for(const{data:l}of d){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const s=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,s)}p.removeNode(l)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,y,P=[],p,g){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(h,y,P,p,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,y,P,p,g);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(h,y,P=[],p,g){if(p){const a=new b(void 0,this._strict,this,this._enableTracing);a._globalGraphImplicitDependency=String(h);const d=new R.IdleValue(()=>a._createInstance(y,P,g));return new Proxy(Object.create(null),{get(l,i){if(i in l)return l[i];const s=d.value;let t=s[i];return typeof t!="function"||(t=t.bind(s),l[i]=t),t},set(l,i,s){return d.value[i]=s,!0}})}else return this._createInstance(y,P,g)}_throwIfStrict(h,y){if(y&&console.warn(h),this._strict)throw new Error(h)}}e.InstantiationService=b;var S;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(S||(S={}));class m{constructor(h,y){this.type=h,this.name=y,this._start=Date.now(),this._dep=[]}static traceInvocation(h,y){return h?new m(1,y.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m._None}static traceCreation(h,y){return h?new m(0,y.name):m._None}branch(h,y){const P=new m(2,h.toString());return this._dep.push([h,y,P]),P}stop(){const h=Date.now()-this._start;m._totals+=h;let y=!1;function P(g,a){const d=[],l=new Array(g+1).join("	");for(const[i,s,t]of a._dep)if(s&&t){y=!0,d.push(`${l}CREATES -> ${i}`);const n=P(g+1,t);n&&d.push(n)}else d.push(`${l}uses -> ${i}`);return d.join(`
`)}const p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(h>2||y)&&m.all.add(p.join(`
`))}}e.Trace=m,m.all=new Set,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(ne[187],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(D,L){this.server=D,this.router=L}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,L){this.server.registerChannel(D,L)}}e.MessagePortMainProcessService=R}),define(ne[58],re([0,1,39,56,91,5]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(v,h,y){const P=y.getChannel(v);return I(h)?new h.channelClientCtor(P):R.ProxyChannel.toService(P,h?.proxyOptions)}}function I(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let E=class extends T{constructor(v,h,y){super(v,h,y)}};E=pe([K(2,e.IMainProcessService)],E);function C(m,v,h){(0,D.registerSingleton)(m,new r.SyncDescriptor(E,[v,h],!0))}e.registerMainProcessRemoteService=C,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let b=class extends T{constructor(v,h,y){super(v,h,y)}};b=pe([K(2,e.ISharedProcessService)],b);function S(m,v,h){(0,D.registerSingleton)(m,new r.SyncDescriptor(b,[v,h],!0))}e.registerSharedProcessRemoteService=S}),define(ne[69],re([0,1,24,2,4,155,29,5]),function(Q,e,R,r,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let E=class extends r.Disposable{constructor(b){super(),this.extensionGalleryService=b}async getAvailableLanguages(){const b=new R.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let S;try{S=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const v=S.firstPage.filter(h=>h.properties.localizedLanguages?.length&&h.tags.some(y=>y.startsWith("lp-"))).map(h=>{const y=h.properties.localizedLanguages?.[0],P=this.getLocale(h);return{...this.createQuickPickItem(P,y,h),extensionId:h.identifier.id,galleryExtension:h}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(b){return b.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(b,S,m){const v=S??b;let h;if(v!==b&&(h=`(${b})`),b.toLowerCase()===D.language.toLowerCase()&&(h??="",h+=(0,L.localize)(0,null)),m?.installCount){h??="";const y=m.installCount;let P;y>1e6?P=`${Math.floor(y/1e5)/10}M`:y>1e3?P=`${Math.floor(y/1e3)}K`:P=String(y),h+=` $(cloud-download) ${P}`}return{id:b,label:v,description:h}}};E=pe([K(0,T.IExtensionGalleryService)],E),e.LanguagePackBaseService=E}),define(ne[188],re([0,1,2,69]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends R.Disposable{constructor(T){super(),this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=pe([K(0,r.ILanguagePackService)],D),e.LocalizationsUpdater=D}),define(ne[8],re([0,1,38,3,2,4,5]),function(Q,e,R,r,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function I(){return new Date().toISOString()}var E;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function C(s,t,n){switch(t){case E.Trace:s.trace(n);break;case E.Debug:s.debug(n);break;case E.Info:s.info(n);break;case E.Warning:s.warn(n);break;case E.Error:s.error(n);break;case E.Critical:s.critical(n);break;default:throw new Error("Invalid log level")}}e.log=C;function b(s){let t="";for(let n=0;n<s.length;n++){let o=s[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(n>0?" ":"")+o}return t}e.format=b;class S extends D.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new r.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=S;class m extends S{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(E.Trace)&&this.log(E.Trace,b([t,...n]))}debug(t,...n){this.checkLogLevel(E.Debug)&&this.log(E.Debug,b([t,...n]))}info(t,...n){this.checkLogLevel(E.Info)&&this.log(E.Info,b([t,...n]))}warn(t,...n){this.checkLogLevel(E.Warning)&&this.log(E.Warning,b([t,...n]))}error(t,...n){if(this.checkLogLevel(E.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(E.Error,b(o))}else this.log(E.Error,b([t,...n]))}critical(t,...n){this.checkLogLevel(E.Critical)&&this.log(E.Critical,b([t,...n]))}flush(){}}e.AbstractMessageLogger=m;class v extends S{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!L.isWindows}trace(t,...n){this.getLevel()<=E.Trace&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,t,...n):console.log(`[main ${I()}]`,t,...n))}debug(t,...n){this.getLevel()<=E.Debug&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,t,...n):console.log(`[main ${I()}]`,t,...n))}info(t,...n){this.getLevel()<=E.Info&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,t,...n):console.log(`[main ${I()}]`,t,...n))}warn(t,...n){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${I()}]\x1B[0m`,t,...n):console.warn(`[main ${I()}]`,t,...n))}error(t,...n){this.getLevel()<=E.Error&&(this.useColors?console.error(`\x1B[91m[main ${I()}]\x1B[0m`,t,...n):console.error(`[main ${I()}]`,t,...n))}critical(t,...n){this.getLevel()<=E.Critical&&(this.useColors?console.error(`\x1B[90m[main ${I()}]\x1B[0m`,t,...n):console.error(`[main ${I()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class h extends S{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...n){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=h;class y extends S{constructor(t,n=e.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,R.toErrorMessage)(t,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class P extends S{constructor(t){super(),this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const o of this.logServices)o.trace(t,...n)}debug(t,...n){for(const o of this.logServices)o.debug(t,...n)}info(t,...n){for(const o of this.logServices)o.info(t,...n)}warn(t,...n){for(const o of this.logServices)o.warn(t,...n)}error(t,...n){for(const o of this.logServices)o.error(t,...n)}critical(t,...n){for(const o of this.logServices)o.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=P;class p extends D.Disposable{constructor(t){super(),this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=p;class g extends D.Disposable{constructor(t,n){super(),this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,n){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,n?.always?E.Trace:this.logLevel,n),this.loggers.set(t.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class a{constructor(){this.onDidChangeLogLevel=new r.Emitter().event}setLevel(t){}getLevel(){return E.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=a;function d(s){if(s.verbose)return E.Trace;if(typeof s.logLevel=="string"){const t=l(s.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function l(s){switch(s){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=l;function i(s){switch(s){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=i}),define(ne[189],re([0,1,6,9,2,12,28,14,8]),function(Q,e,R,r,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let C=class extends D.Disposable{constructor(S,m){super(),this.environmentService=S,this.logService=m,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const S=(0,L.basename)(this.environmentService.logsPath),m=(0,L.dirname)(this.environmentService.logsPath),y=(await T.Promises.readdir(m)).filter(p=>/^\d{8}T\d{6}$/.test(p)).sort().filter(p=>p!==S),P=y.slice(0,Math.max(0,y.length-9));P.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${P.join(", ")}'`),await Promise.all(P.map(p=>T.Promises.rm((0,L.join)(m,p)))))}catch(S){(0,r.onUnexpectedError)(S)}}};C=pe([K(0,I.IEnvironmentService),K(1,E.ILogService)],C),e.LogsDataCleaner=C}),define(ne[190],re([0,1,19,6,9,3,2,12,57,8]),function(Q,e,R,r,D,L,T,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends T.Disposable{constructor(m,v){super(),this.logService=m,this.options=v,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new r.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new r.ThrottledDelayer(0))}watch(m,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,v):this.watchNonRecursive(m,v)}watchUniversal(m,v){const h={path:this.toFilePath(m),excludes:v.excludes,includes:v.includes,recursive:v.recursive},y=(0,R.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,D.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,E.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const v of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const v of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(v)&&m.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,v){const h={path:this.toFilePath(m),excludes:v.excludes,includes:v.includes,recursive:!1},y=(0,R.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,D.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,E.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,I.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(ne[191],re([0,1,19,6,16,24,3,64,52,2,34,21,192,17,42,151,13,96,8]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends C.Disposable{constructor(l){super(),this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new r.ResourceQueue)}registerProvider(l,i){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${l}`);const s=new C.DisposableStore;return this.provider.set(l,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:i}),s.add(i.onDidChangeFile(t=>this._onDidFilesChange.fire(new P.FileChangesEvent(t,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&s.add(i.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),s.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:l}))),(0,C.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:i}),this.provider.delete(l),(0,C.dispose)(s)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(s){i.push(s)}}),!this.provider.has(l)&&await r.Promises.settled(i)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,i){const s=this.provider.get(l.scheme);return!!(s&&s.capabilities&i)}listCapabilities(){return E.Iterable.map(this.provider,([l,i])=>({scheme:l,capabilities:i.capabilities}))}async withProvider(l){if(!(0,v.isAbsolutePath)(l))throw new P.FileOperationError((0,y.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const i=this.provider.get(l.scheme);if(!i){const s=new Error;throw s.name="ENOPRO",s.message=(0,y.localize)(1,null,l.toString()),s}return i}async withReadProvider(l){const i=await this.withProvider(l);if((0,P.hasOpenReadWriteCloseCapability)(i)||(0,P.hasReadWriteCapability)(i)||(0,P.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const i=await this.withProvider(l);if((0,P.hasOpenReadWriteCloseCapability)(i)||(0,P.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,i){try{return await this.doResolveFile(l,i)}catch(s){throw(0,P.toFileSystemProviderErrorCode)(s)===P.FileSystemProviderErrorCode.FileNotFound?new P.FileOperationError((0,y.localize)(2,null,this.resourceForError(l)),1):(0,P.ensureFileSystemProviderError)(s)}}async doResolveFile(l,i){const s=await this.withProvider(l),t=this.isPathCaseSensitive(s),n=i?.resolveTo,o=i?.resolveSingleChildDescendants,c=i?.resolveMetadata,u=await s.stat(l);let f;return this.toFileStat(s,l,u,void 0,!!c,(w,_)=>(f||(f=b.TernarySearchTree.forUris(()=>!t),f.set(l,!0),n&&f.fill(!0,n)),f.get(w.resource)||f.findSuperstr(w.resource.with({query:null,fragment:null}))?!0:w.isDirectory&&o?_===1:!1))}async toFileStat(l,i,s,t,n,o){const{providerExtUri:c}=this.getExtUri(l),u={resource:i,name:c.basename(i),isFile:(s.type&P.FileType.File)!==0,isDirectory:(s.type&P.FileType.Directory)!==0,isSymbolicLink:(s.type&P.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&P.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,P.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(u.isDirectory&&o(u,t)){try{const f=await l.readdir(i),w=await r.Promises.settled(f.map(async([_,N])=>{try{const A=c.joinPath(i,_),O=n?await l.stat(A):{type:N};return await this.toFileStat(l,A,O,f.length,n,o)}catch(A){return this.logService.trace(A),null}}));u.children=(0,R.coalesce)(w)}catch(f){this.logService.trace(f),u.children=[]}return u}return u}async resolveAll(l){return r.Promises.settled(l.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(l){const i=await this.withProvider(l),s=await i.stat(l);return this.toFileStat(i,l,s,void 0,!0,()=>!1)}async exists(l){const i=await this.withProvider(l);try{return!!await i.stat(l)}catch{return!1}}async canCreateFile(l,i){try{await this.doValidateCreateFile(l,i)}catch(s){return s}return!0}async doValidateCreateFile(l,i){if(!i?.overwrite&&await this.exists(l))throw new P.FileOperationError((0,y.localize)(3,null,this.resourceForError(l)),3,i)}async createFile(l,i=D.VSBuffer.fromString(""),s){await this.doValidateCreateFile(l,s);const t=await this.writeFile(l,i);return this._onDidRunOperation.fire(new P.FileOperationEvent(l,0,t)),t}async writeFile(l,i,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:n}=this.getExtUri(t);try{await this.validateWriteFile(t,l,s)||await this.mkdirp(t,n.dirname(l));let c;if((0,P.hasReadWriteCapability)(t)&&!(i instanceof D.VSBuffer))if((0,h.isReadableStream)(i)){const u=await(0,h.peekStream)(i,3);u.ended?c=D.VSBuffer.concat(u.buffer):c=u}else c=(0,h.peekReadable)(i,u=>D.VSBuffer.concat(u),3);else c=i;!(0,P.hasOpenReadWriteCloseCapability)(t)||(0,P.hasReadWriteCapability)(t)&&c instanceof D.VSBuffer?await this.doWriteUnbuffered(t,l,s,c):await this.doWriteBuffered(t,l,s,c instanceof D.VSBuffer?(0,D.bufferToReadable)(c):c),this._onDidRunOperation.fire(new P.FileOperationEvent(l,4))}catch(o){throw new P.FileOperationError((0,y.localize)(4,null,this.resourceForError(l),(0,P.ensureFileSystemProviderError)(o).toString()),(0,P.toFileOperationResult)(o),s)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,i,s){if(!!s?.unlock&&!(l.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(i)));let n;try{n=await l.stat(i)}catch{return}if((n.type&P.FileType.Directory)!==0)throw new P.FileOperationError((0,y.localize)(6,null,this.resourceForError(i)),0,s);if(this.throwIfFileIsReadonly(i,n),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==P.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&s.mtime<n.mtime&&s.etag!==(0,P.etag)({mtime:s.mtime,size:n.size}))throw new P.FileOperationError((0,y.localize)(7,null),3,s);return n}async readFile(l,i,s){const t=await this.withReadProvider(l);return i?.atomic?this.doReadFileAtomic(t,l,i,s):this.doReadFile(t,l,i,s)}async doReadFileAtomic(l,i,s,t){return new Promise((n,o)=>{this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(l,i,s,t);n(c)}catch(c){o(c)}})})}async doReadFile(l,i,s,t){const n=await this.doReadFileStream(l,i,{...s,preferUnbuffered:!0},t);return{...n,value:await(0,D.streamToBuffer)(n.value)}}async readFileStream(l,i,s){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,i,s)}async doReadFileStream(l,i,s,t){const n=new L.CancellationTokenSource(t),o=this.validateReadFile(i,s).then(u=>u,u=>{throw n.cancel(),u});let c;try{return typeof s?.etag=="string"&&s.etag!==P.ETAG_DISABLED&&await o,s?.atomic&&(0,P.hasFileAtomicReadCapability)(l)||!((0,P.hasOpenReadWriteCloseCapability)(l)||(0,P.hasFileReadStreamCapability)(l))||(0,P.hasReadWriteCapability)(l)&&s?.preferUnbuffered?c=this.readFileUnbuffered(l,i,s):(0,P.hasFileReadStreamCapability)(l)?c=this.readFileStreamed(l,i,n.token,s):c=this.readFileBuffered(l,i,n.token,s),{...await o,value:c}}catch(u){c&&await(0,h.consumeStream)(c);const f=(0,y.localize)(8,null,this.resourceForError(i),(0,P.ensureFileSystemProviderError)(u).toString());throw u instanceof P.NotModifiedSinceFileOperationError?new P.NotModifiedSinceFileOperationError(f,u.stat,s):new P.FileOperationError(f,(0,P.toFileOperationResult)(u),s)}}readFileStreamed(l,i,s,t=Object.create(null)){const n=l.readFileStream(i,t,s);return(0,h.transform)(n,{data:o=>o instanceof D.VSBuffer?o:D.VSBuffer.wrap(o),error:o=>new P.FileOperationError((0,y.localize)(9,null,this.resourceForError(i),(0,P.ensureFileSystemProviderError)(o).toString()),(0,P.toFileOperationResult)(o),t)},o=>D.VSBuffer.concat(o))}readFileBuffered(l,i,s,t=Object.create(null)){const n=(0,D.newWriteableBufferStream)();return(0,p.readFileIntoStream)(l,i,n,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new P.FileOperationError((0,y.localize)(10,null,this.resourceForError(i),(0,P.ensureFileSystemProviderError)(o).toString()),(0,P.toFileOperationResult)(o),t)},s),n}readFileUnbuffered(l,i,s){const t=(0,h.newWriteableStream)(n=>D.VSBuffer.concat(n));return(async()=>{try{let n;s?.atomic&&(0,P.hasFileAtomicReadCapability)(l)?n=await l.readFile(i,{atomic:!0}):n=await l.readFile(i),typeof s?.position=="number"&&(n=n.slice(s.position)),typeof s?.length=="number"&&(n=n.slice(0,s.length)),this.validateReadFileLimits(i,n.byteLength,s),t.end(D.VSBuffer.wrap(n))}catch(n){t.error(n),t.end()}})(),t}async validateReadFile(l,i){const s=await this.resolve(l,{resolveMetadata:!0});if(s.isDirectory)throw new P.FileOperationError((0,y.localize)(11,null,this.resourceForError(l)),0,i);if(typeof i?.etag=="string"&&i.etag!==P.ETAG_DISABLED&&i.etag===s.etag)throw new P.NotModifiedSinceFileOperationError((0,y.localize)(12,null),s,i);return this.validateReadFileLimits(l,s.size,i),s}validateReadFileLimits(l,i,s){if(s?.limits){let t;if(typeof s.limits.memory=="number"&&i>s.limits.memory&&(t=9),typeof s.limits.size=="number"&&i>s.limits.size&&(t=7),typeof t=="number")throw new P.FileOperationError((0,y.localize)(13,null,this.resourceForError(l)),t)}}async canMove(l,i,s){return this.doCanMoveCopy(l,i,"move",s)}async canCopy(l,i,s){return this.doCanMoveCopy(l,i,"copy",s)}async doCanMoveCopy(l,i,s,t){if(l.toString()!==i.toString())try{const n=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(n,l,o,i,s,t)}catch(n){return n}return!0}async move(l,i,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(t,l,n,i,"move",!!s),c=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(l,o==="move"?2:3,c)),c}async copy(l,i,s){const t=await this.withReadProvider(l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(t,l,n,i,"copy",!!s),c=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(l,o==="copy"?3:2,c)),c}async doMoveCopy(l,i,s,t,n,o){if(i.toString()===t.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(l,i,s,t,n,o);if(c&&!u&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(t)),n==="copy"){if(l===s&&(0,P.hasFileFolderCopyCapability)(l))await l.copy(i,t,{overwrite:o});else{const f=await this.resolve(i);f.isDirectory?await this.doCopyFolder(l,f,s,t):await this.doCopyFile(l,i,s,t)}return n}else return l===s?(await l.rename(i,t,{overwrite:o}),n):(await this.doMoveCopy(l,i,s,t,"copy",o),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(l,i,s,t){if((0,P.hasOpenReadWriteCloseCapability)(l)&&(0,P.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(l,i,s,t);if((0,P.hasOpenReadWriteCloseCapability)(l)&&(0,P.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(l,i,s,t);if((0,P.hasReadWriteCapability)(l)&&(0,P.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(l,i,s,t);if((0,P.hasReadWriteCapability)(l)&&(0,P.hasReadWriteCapability)(s))return this.doPipeUnbuffered(l,i,s,t)}async doCopyFolder(l,i,s,t){await s.mkdir(t),Array.isArray(i.children)&&await r.Promises.settled(i.children.map(async n=>{const o=this.getExtUri(s).providerExtUri.joinPath(t,n.name);return n.isDirectory?this.doCopyFolder(l,await this.resolve(n.resource),s,o):this.doCopyFile(l,n.resource,s,o)}))}async doValidateMoveCopy(l,i,s,t,n,o){let c=!1;if(l===s){const{providerExtUri:f,isPathCaseSensitive:w}=this.getExtUri(l);if(w||(c=f.isEqual(i,t)),c&&n==="copy")throw new Error((0,y.localize)(14,null,this.resourceForError(i),this.resourceForError(t)));if(!c&&f.isEqualOrParent(t,i))throw new Error((0,y.localize)(15,null,this.resourceForError(i),this.resourceForError(t)))}const u=await this.exists(t);if(u&&!c){if(!o)throw new P.FileOperationError((0,y.localize)(16,null,this.resourceForError(i),this.resourceForError(t)),4);if(l===s){const{providerExtUri:f}=this.getExtUri(l);if(f.isEqualOrParent(i,t))throw new Error((0,y.localize)(17,null,this.resourceForError(i),this.resourceForError(t)))}}return{exists:u,isSameResourceWithDifferentPathCase:c}}getExtUri(l){const i=this.isPathCaseSensitive(l);return{providerExtUri:i?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(i,l);const s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(l,0,s)),s}async mkdirp(l,i){const s=[],{providerExtUri:t}=this.getExtUri(l);for(;!t.isEqual(i,t.dirname(i));)try{if(((await l.stat(i)).type&P.FileType.Directory)===0)throw new Error((0,y.localize)(18,null,this.resourceForError(i)));break}catch(n){if((0,P.toFileSystemProviderErrorCode)(n)!==P.FileSystemProviderErrorCode.FileNotFound)throw n;s.push(t.basename(i)),i=t.dirname(i)}for(let n=s.length-1;n>=0;n--){i=t.joinPath(i,s[n]);try{await l.mkdir(i)}catch(o){if((0,P.toFileSystemProviderErrorCode)(o)!==P.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(l,i){try{await this.doValidateDelete(l,i)}catch(s){return s}return!0}async doValidateDelete(l,i){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!i?.useTrash&&!(s.capabilities&4096))throw new Error((0,y.localize)(19,null,this.resourceForError(l)));let n;try{n=await s.stat(l)}catch{}if(n)this.throwIfFileIsReadonly(l,n);else throw new P.FileOperationError((0,y.localize)(20,null,this.resourceForError(l)),1);if(!!!i?.recursive){const c=await this.resolve(l);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,y.localize)(21,null,this.resourceForError(l)))}return s}async del(l,i){const s=await this.doValidateDelete(l,i),t=!!i?.useTrash,n=!!i?.recursive;await s.delete(l,{recursive:n,useTrash:t}),this._onDidRunOperation.fire(new P.FileOperationEvent(l,1))}async cloneFile(l,i){const s=await this.withProvider(l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(s===t&&this.getExtUri(s).providerExtUri.isEqual(l,i))return;if(s===t&&(0,P.hasFileCloneCapability)(s))return s.cloneFile(l,i);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i));const n=this.writeQueue.queueFor(l,this.getExtUri(s).providerExtUri);return s===t&&(0,P.hasFileFolderCopyCapability)(s)?n.queue(()=>s.copy(l,i,{overwrite:!0})):n.queue(()=>this.doCopyFile(s,l,t,i))}watch(l,i={recursive:!1,excludes:[]}){const s=new C.DisposableStore;let t=!1,n=()=>{t=!0};return s.add((0,C.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(l,i);t?(0,C.dispose)(o):n=()=>(0,C.dispose)(o)}catch(o){this.logService.error(o)}})(),s}async doWatch(l,i){const s=await this.withProvider(l),t=(0,I.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(l),i]);let n=this.activeWatchers.get(t);return n||(n={count:0,disposable:s.watch(l,i)},this.activeWatchers.set(t,n)),n.count+=1,(0,C.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,C.dispose)(n.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,C.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,i,s,t){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(async()=>{const n=await l.open(i,{create:!0,unlock:s?.unlock??!1});try{(0,h.isReadableStream)(t)||(0,h.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(l,n,t):await this.doWriteReadableBufferedQueued(l,n,t)}catch(o){throw(0,P.ensureFileSystemProviderError)(o)}finally{await l.close(n)}})}async doWriteStreamBufferedQueued(l,i,s){let t=0,n;if((0,h.isReadableBufferedStream)(s)){if(s.buffer.length>0){const o=D.VSBuffer.concat(s.buffer);await this.doWriteBuffer(l,i,o,o.byteLength,t,0),t+=o.byteLength}if(s.ended)return;n=s.stream}else n=s;return new Promise((o,c)=>{(0,h.listenStream)(n,{onData:async u=>{n.pause();try{await this.doWriteBuffer(l,i,u,u.byteLength,t,0)}catch(f){return c(f)}t+=u.byteLength,setTimeout(()=>n.resume())},onError:u=>c(u),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(l,i,s){let t=0,n;for(;(n=s.read())!==null;)await this.doWriteBuffer(l,i,n,n.byteLength,t,0),t+=n.byteLength}async doWriteBuffer(l,i,s,t,n,o){let c=0;for(;c<t;)c+=await l.write(i,n+c,s.buffer,o+c,t-c)}async doWriteUnbuffered(l,i,s,t){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,i,s,t))}async doWriteUnbufferedQueued(l,i,s,t){let n;t instanceof D.VSBuffer?n=t:(0,h.isReadableStream)(t)?n=await(0,D.streamToBuffer)(t):(0,h.isReadableBufferedStream)(t)?n=await(0,D.bufferedStreamToBuffer)(t):n=(0,D.readableToBuffer)(t),await l.writeFile(i,n.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(l,i,s,t){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,i,s,t))}async doPipeBufferedQueued(l,i,s,t){let n,o;try{n=await l.open(i,{create:!1}),o=await s.open(t,{create:!0,unlock:!1});const c=D.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,f=0,w=0;do w=await l.read(n,u,c.buffer,f,c.byteLength-f),await this.doWriteBuffer(s,o,c,w,u,f),u+=w,f+=w,f===c.byteLength&&(f=0);while(w>0)}catch(c){throw(0,P.ensureFileSystemProviderError)(c)}finally{await r.Promises.settled([typeof n=="number"?l.close(n):Promise.resolve(),typeof o=="number"?s.close(o):Promise.resolve()])}}async doPipeUnbuffered(l,i,s,t){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,i,s,t))}async doPipeUnbufferedQueued(l,i,s,t){return s.writeFile(t,await l.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,i,s,t){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,i,s,t))}async doPipeUnbufferedToBufferedQueued(l,i,s,t){const n=await s.open(t,{create:!0,unlock:!1});try{const o=await l.readFile(i);await this.doWriteBuffer(s,n,D.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,P.ensureFileSystemProviderError)(o)}finally{await s.close(n)}}async doPipeBufferedToUnbuffered(l,i,s,t){const n=await(0,D.streamToBuffer)(this.readFileBuffered(l,i,L.CancellationToken.None));await this.doWriteUnbuffered(s,t,void 0,n)}throwIfFileSystemIsReadonly(l,i){if(l.capabilities&2048)throw new P.FileOperationError((0,y.localize)(22,null,this.resourceForError(i)),6);return l}throwIfFileIsReadonly(l,i){if((i.permissions??0)&P.FilePermission.Readonly)throw new P.FileOperationError((0,y.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===S.Schemas.file?l.fsPath:l.toString(!0)}};a=pe([K(0,g.ILogService)],a),e.FileService=a}),define(ne[193],re([0,1,53,278,6,34,16,3,47,2,12,4,17,42,28,154,13,96,190,38,185,184]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p,g,a,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,r.gracefulify)(R)}catch(s){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(s)}`)}})();class i extends g.AbstractDiskFileSystemProvider{constructor(t,n){super(t,n),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new L.ResourceMap(o=>m.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,S.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:n,symbolicLink:o}=await h.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(t){try{const n=await h.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async c=>{try{let u;c.isSymbolicLink()?u=(await this.stat((0,m.joinPath)(t,c.name))).type:u=this.toType(c),o.push([c.name,u])}catch(u){this.logService.trace(u)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(t,n){let o;return n?.dangling?o=P.FileType.Unknown:t.isFile()?o=P.FileType.File:t.isDirectory()?o=P.FileType.Directory:o=P.FileType.Unknown,n&&(o|=P.FileType.SymbolicLink),o}async createResourceLock(t){const n=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const c=new D.Barrier;return this.resourceLocks.set(t,c),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,C.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(t)===c&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),c.open()})}async readFile(t,n){let o;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const c=this.toFilePath(t);return await h.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{o?.dispose()}}readFileStream(t,n,o){const c=(0,v.newWriteableStream)(u=>T.VSBuffer.concat(u.map(f=>T.VSBuffer.wrap(f))).buffer);return(0,p.readFileIntoStream)(this,t,c,u=>u.buffer,{...n,bufferSize:256*1024},o),c}async writeFile(t,n,o){let c;try{const u=this.toFilePath(t);if(!o.create||!o.overwrite){if(await h.Promises.exists(u)){if(!o.overwrite)throw(0,P.createFileSystemProviderError)((0,y.localize)(0,null),P.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,P.createFileSystemProviderError)((0,y.localize)(1,null),P.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(c,0,n,0,n.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(t,u)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(t){i.canFlush=t}async open(t,n){const o=this.toFilePath(t);let c;(0,P.isFileOpenForWriteOptions)(n)&&(c=await this.createResourceLock(t));let u;try{if((0,P.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:w}=await h.SymlinkSupport.stat(o);w.mode&128||await h.Promises.chmod(o,w.mode|128)}catch(w){this.logService.trace(w)}let f;if((0,P.isFileOpenForWriteOptions)(n)){if(S.isWindows)try{await h.Promises.truncate(o,0),f="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}f||(f="w")}else f="r";u=await h.Promises.open(o,f)}catch(f){throw c?.dispose(),(0,P.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(t,f):this.toFileSystemProviderError(f)}if(this.mapHandleToPos.set(u,0),(0,P.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(u,t),c){const f=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${o})`),this.mapHandleToLock.set(u,c),f&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${o})`),f.dispose())}return u}async close(t){const n=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&i.canFlush)try{await h.Promises.fdatasync(t)}catch(o){i.configureFlushOnWrite(!1),this.logService.error(o)}return await h.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(t)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,o,c,u){const f=this.normalizePos(t,n);let w=null;try{w=(await h.Promises.read(t,o,c,u,f)).bytesRead}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(t,f,w)}return w}normalizePos(t,n){return n===this.mapHandleToPos.get(t)?null:n}updatePos(t,n,o){const c=this.mapHandleToPos.get(t);typeof c=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,c+o):this.mapHandleToPos.delete(t)))}async write(t,n,o,c,u){return(0,D.retry)(()=>this.doWrite(t,n,o,c,u),100,3)}async doWrite(t,n,o,c,u){const f=this.normalizePos(t,n);let w=null;try{w=(await h.Promises.write(t,o,c,u,f)).bytesWritten}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),_)}finally{this.updatePos(t,f,w)}return w}async mkdir(t){try{await h.Promises.mkdir(this.toFilePath(t))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(t,n){try{const o=this.toFilePath(t);n.recursive?await h.Promises.rm(o,h.RimRafMode.MOVE):await h.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,n,o){const c=this.toFilePath(t),u=this.toFilePath(n);if(c!==u)try{await this.validateTargetDeleted(t,n,"move",o.overwrite),await h.Promises.move(c,u)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,y.localize)(2,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(u)),f.toString()))),this.toFileSystemProviderError(f)}}async copy(t,n,o){const c=this.toFilePath(t),u=this.toFilePath(n);if(c!==u)try{await this.validateTargetDeleted(t,n,"copy",o.overwrite),await h.Promises.copy(c,u,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,y.localize)(3,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(u)),f.toString()))),this.toFileSystemProviderError(f)}}async validateTargetDeleted(t,n,o,c){const u=this.toFilePath(t),f=this.toFilePath(n);let w=!1;if(!!(this.capabilities&1024)||(w=(0,E.isEqual)(u,f,!0)),w&&o==="copy")throw(0,P.createFileSystemProviderError)((0,y.localize)(4,null),P.FileSystemProviderErrorCode.FileExists);if(!w&&await h.Promises.exists(f)){if(!c)throw(0,P.createFileSystemProviderError)((0,y.localize)(5,null),P.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(t,n){return this.doCloneFile(t,n,!1)}async doCloneFile(t,n,o){const c=this.toFilePath(t),u=this.toFilePath(n),f=!!(this.capabilities&1024);if((0,E.isEqual)(c,u,!f))return;const w=new C.DisposableStore;try{const[_,N]=await Promise.all([this.createResourceLock(t),this.createResourceLock(n)]);w.add(_),w.add(N),o&&await h.Promises.mkdir((0,b.dirname)(u),{recursive:!0}),await h.Promises.copyFile(c,u)}catch(_){if(_.code==="ENOENT"&&!o)return this.doCloneFile(t,n,!0);throw this.toFileSystemProviderError(_)}finally{w.dispose()}}createUniversalWatcher(t,n,o){return new d.UniversalWatcherClient(c=>t(c),c=>n(c),o)}createNonRecursiveWatcher(t,n,o){return new l.NodeJSWatcherClient(c=>t(c),c=>n(c),o)}toFileSystemProviderError(t){if(t instanceof P.FileSystemProviderError)return t;let n;switch(t.code){case"ENOENT":n=P.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=P.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=P.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=P.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=P.FileSystemProviderErrorCode.NoPermissions;break;default:n=P.FileSystemProviderErrorCode.Unknown}return(0,P.createFileSystemProviderError)(t,n)}async toFileSystemProviderWriteError(t,n){let o=this.toFileSystemProviderError(n);if(t&&o.code===P.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await h.SymlinkSupport.stat(this.toFilePath(t));c.mode&128||(o=(0,P.createFileSystemProviderError)(n,P.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return o}}e.DiskFileSystemProvider=i,i.canFlush=!0}),define(ne[98],re([0,1,3,7,8]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(m){this.service=m,this.onDidChangeLogLevel=R.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(m,v,h){switch(v){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=L;class T{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){T.setLevel(this.channel,m)}static setLevel(m,v){return m.call("setLevel",v)}}e.LogLevelChannelClient=T;class I{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,v){throw new Error(`Event not found: ${v}`)}async call(m,v,h){switch(v){case"createLogger":this.createLogger(r.URI.revive(h[0]),h[1]);return;case"log":return this.log(r.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${v}`)}createLogger(m,v){this.loggers.set(m.toString(),this.loggerService.createLogger(m,v))}consoleLog(m,v){let h=console.log;switch(m){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...v)}log(m,v){const h=this.loggers.get(m.toString());if(!h)throw new Error("Create the logger before logging");for(const[y,P]of v)(0,D.log)(h,y,P)}}e.LoggerChannel=I;class E extends D.AbstractLoggerService{constructor(m,v,h){super(m,v),this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(m,v)=>{this.channel.call("consoleLog",[m,v])}})}doCreateLogger(m,v,h){return new C(this.channel,m,v,h)}}e.LoggerChannelClient=E;class C extends D.AbstractMessageLogger{constructor(m,v,h,y){super(y?.always),this.channel=m,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[v,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,v){const h=[[m,v]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(m){this.channel.call("log",[this.file,m])}}class b extends D.LogService{constructor(m,v){super(v),this.parent=m,this._register(m.onDidChangeLogLevel(h=>v.setLevel(h)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=b}),define(ne[59],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(ne[60],re([0,1,3,52,2,5]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class T extends D.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(C){const b=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...C,...this.policyDefinitions},b!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(C),r.Iterable.reduce(this.policies.entries(),(S,[m,v])=>({...S,[m]:v}),{})}getPolicyValue(C){return this.policies.get(C)}serialize(){return r.Iterable.reduce(Object.entries(this.policyDefinitions),(C,[b,S])=>({...C,[b]:{definition:S,value:this.policies.get(b)}}),{})}}e.AbstractPolicyService=T;class I{constructor(){this.onDidChange=R.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(ne[194],re([0,1,3,2,60]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(E){this.service=E,this.disposables=new r.DisposableStore}listen(E,C){switch(C){case"onDidChange":return R.Event.map(this.service.onDidChange,b=>b.reduce((S,m)=>({...S,[m]:this.service.getPolicyValue(m)??null}),{}),this.disposables)}throw new Error(`Event not found: ${C}`)}call(E,C,b){switch(C){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(b)}throw new Error(`Call not found: ${C}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class T extends D.AbstractPolicyService{constructor(E,C){super(),this.channel=C;for(const b in E){const{definition:S,value:m}=E[b];this.policyDefinitions[b]=S,m!==void 0&&this.policies.set(b,m)}this.channel.listen("onDidChange")(b=>{for(const S in b){const m=b[S];m===null?this.policies.delete(S):this.policies.set(S,m)}this._onDidChange.fire(Object.keys(b))})}async initializePolicies(E){const C=await this.channel.call("registerPolicyDefinitions",E);for(const b in C)this.policies.set(b,C[b])}}e.PolicyChannelClient=T}),define(ne[99],re([0,1,21,4,36,17]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof r.globals.vscode<"u"&&typeof r.globals.vscode.context<"u"){const I=r.globals.vscode.context.configuration();if(I)T=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const I=(0,L.dirname)(R.FileAccess.asFileUri("",Q));T=Q.__$__nodeRequire((0,L.joinPath)(I,"product.json").fsPath);const E=Q.__$__nodeRequire((0,L.joinPath)(I,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),Object.assign(T,{version:E.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ne[25],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[195],re([0,1,6,9,2,12,28,8,25]),function(Q,e,R,r,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let C=class extends D.Disposable{constructor(S,m,v){super(),this.productService=m,this.logService=v,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,S&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(S)},3e4)).schedule()}async cleanUpCodeCaches(S){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),v=(0,L.dirname)(S),h=(0,L.basename)(S),y=await T.Promises.readdir(v);await Promise.all(y.map(async P=>{if(P===h)return;const p=(0,L.join)(v,P),g=await T.Promises.stat(p);if(g.isDirectory()&&m-g.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${P}.`),T.Promises.rm(p)}))}catch(m){(0,r.onUnexpectedError)(m)}}};C=pe([K(1,E.IProductService),K(2,I.ILogService)],C),e.CodeCacheCleaner=C}),define(ne[196],re([0,1,6,9,2,12,28,14,8,25]),function(Q,e,R,r,D,L,T,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let b=class extends D.Disposable{constructor(m,v,h){super(),this.environmentService=m,this.logService=v,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),v=JSON.parse(await T.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(v)){const a=v[g];m[`${a.hash}.${g}`]=!0}const h=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(h))return;const P=await T.Promises.readdir(h);for(const g of P){if(m[g]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await T.Promises.rm((0,L.join)(h,g))}const p=Date.now();for(const g of Object.keys(m)){const a=(0,L.join)(h,g),d=await T.Promises.readdir(a);for(const l of d){if(l==="tcf.json")continue;const i=(0,L.join)(a,l),s=await T.Promises.stat(i);s.isDirectory()&&p-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(g,l)}`),await T.Promises.rm(i))}}}catch(m){(0,r.onUnexpectedError)(m)}}};b=pe([K(0,I.INativeEnvironmentService),K(1,E.ILogService),K(2,C.IProductService)],b),e.LanguagePackCachedDataCleaner=b}),define(ne[197],re([0,1,12,5]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,r.createDecorator)("IV8InspectProfilingService");var D;(function(L){function T(I,E="noAbsolutePaths"){for(const C of I.nodes)C.callFrame&&C.callFrame.url&&((0,R.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(C.callFrame.url))&&(C.callFrame.url=(0,R.join)(E,(0,R.basename)(C.callFrame.url)));return I}L.rewriteAbsolutePaths=T})(D=e.Utils||(e.Utils={}))}),define(ne[198],re([0,1,30]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class r{constructor(){this._sessions=new Map}async startProfiling(L){const I=await(await new Promise((C,b)=>{Q(["v8-inspect-profiler"],C,b)})).startProfiling({port:L.port,checkForPaused:!0}),E=(0,R.generateUuid)();return this._sessions.set(E,I),E}async stopProfiling(L){const T=this._sessions.get(L);if(!T)throw new Error(`UNKNOWN session '${L}'`);const I=await T.stop();return this._sessions.delete(L),I.profile}}e.InspectProfilingService=r}),define(ne[40],re([0,1,114,15]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(T,I){R.ok(r.isString(T)),R.ok(r.isObject(I)),R.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,I)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new D}),define(ne[100],re([0,1,3,40]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class L{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,C){this.schemasById[D(E)]=C,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new L;r.Registry.add(e.Extensions.JSONContribution,T)}),define(ne[43],re([0,1,19,3,15,140,18,100,40]),function(Q,e,R,r,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=E.Registry.as(I.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new r.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new r.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const t=this.doRegisterConfigurations(i,s);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(i){const s=this.doDeregisterConfigurations(i);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:i,remove:s}){const t=[];t.push(...this.doDeregisterConfigurations(s)),t.push(...this.doRegisterConfigurations(i,!1)),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,R.distinct)(t)})}registerDefaultConfigurations(i){const s=[],t=[];for(const{overrides:n,source:o}of i)for(const c in n)if(s.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const u=this.configurationDefaultsOverrides.get(c),f=u?.valuesSources??new Map;if(o)for(const A of Object.keys(n[c]))f.set(A,o);const w={...u?.value||{},...n[c]};this.configurationDefaultsOverrides.set(c,{source:o,value:w,valuesSources:f});const _=(0,T.getLanguageTagSettingPlainKey)(c),N={type:"object",default:w,description:L.localize(1,null,_),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:D.isString(o)?void 0:o,defaultValueSource:o};t.push(...y(c)),this.configurationProperties[c]=N,this.defaultLanguageConfigurationOverridesNode.properties[c]=N}else{this.configurationDefaultsOverrides.set(c,{value:n[c],source:o});const u=this.configurationProperties[c];u&&(this.updatePropertyDefaultValue(c,u),this.updateSchema(c,u))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const s=[];for(const{overrides:t,source:n}of i)for(const o in t){const c=this.configurationDefaultsOverrides.get(o),u=D.isString(n)?n:n?.id,f=D.isString(c?.source)?c?.source:c?.source?.id;if(u===f)if(s.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const w=this.configurationProperties[o];w&&(this.updatePropertyDefaultValue(o,w),this.updateSchema(o,w))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const s of i)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,s){const t=[];return i.forEach(n=>{t.push(...this.validateAndRegisterProperties(n,s,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),t}doDeregisterConfigurations(i){const s=[],t=n=>{if(n.properties)for(const o in n.properties){s.push(o);const c=this.configurationProperties[o];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>t(o))};for(const n of i){t(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return s}validateAndRegisterProperties(i,s=!0,t,n,o=3){o=D.isUndefinedOrNull(i.scope)?o:i.scope;const c=[],u=i.properties;if(u)for(const w in u){const _=u[w];if(s&&a(w,_)){delete u[w];continue}if(_.source=t,_.defaultDefaultValue=u[w].default,this.updatePropertyDefaultValue(w,_),e.OVERRIDE_PROPERTY_REGEX.test(w)?_.scope=void 0:(_.scope=D.isUndefinedOrNull(_.scope)?o:_.scope,_.restricted=D.isUndefinedOrNull(_.restricted)?!!n?.includes(w):_.restricted),u[w].hasOwnProperty("included")&&!u[w].included){this.excludedConfigurationProperties[w]=u[w],delete u[w];continue}else this.configurationProperties[w]=u[w],u[w].policy?.name&&this.policyConfigurations.set(u[w].policy.name,w);!u[w].deprecationMessage&&u[w].markdownDeprecationMessage&&(u[w].deprecationMessage=u[w].markdownDeprecationMessage),c.push(w)}const f=i.allOf;if(f)for(const w of f)c.push(...this.validateAndRegisterProperties(w,s,t,n,o));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const s=t=>{const n=t.properties;if(n)for(const c in n)this.updateSchema(c,n[c]);t.allOf?.forEach(s)};s(i)}updateSchema(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.resourceLanguageSettingsSchema.properties[i]=s;break}}removeFromSchema(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const s=`[${i}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,t),e.allSettings.properties[s]=t,e.applicationSettings.properties[s]=t,e.machineSettings.properties[s]=t,e.machineOverridableSettings.properties[s]=t,e.windowSettings.properties[s]=t,e.resourceSettings.properties[s]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,s){const t=this.configurationDefaultsOverrides.get(i);let n=t?.value,o=t?.source;D.isUndefined(n)&&(n=s.defaultDefaultValue,o=void 0),D.isUndefined(n)&&(n=p(s.type)),s.default=n,s.defaultValueSource=o}}const v="\\[([^\\]]+)\\]",h=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(l){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let s=h.exec(l);for(;s?.length;){const t=s[1].trim();t&&i.push(t),s=h.exec(l)}}return(0,R.distinct)(i)}e.overrideIdentifiersFromKey=y;function P(l){return l.reduce((i,s)=>`${i}[${s}]`,"")}e.keyFromOverrideIdentifiers=P;function p(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const g=new m;E.Registry.add(e.Extensions.Configuration,g);function a(l,i){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?L.localize(7,null,l):g.getConfigurationProperties()[l]!==void 0?L.localize(8,null,l):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,l,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.validateProperty=a;function d(){const l=[],i=g.getConfigurationProperties();for(const s of Object.keys(i))l.push([s,i[s].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=d}),define(ne[70],re([0,1,19,3,35,2,34,32,15,7,18,43,40]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(i={},s=[],t=[]){this._contents=i,this._keys=s,this._overrides=t,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,b.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,s){const t=this.getContentsForOverrideIdentifer(s);return t?i?(0,b.getConfigurationValue)(t,i):t:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const t of this.overrides)t.identifiers.includes(i)&&s.push(...t.keys);return R.distinct(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return R.distinct(i)}override(i){let s=this.overrideConfigurations.get(i);return s||(s=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,s)),s}merge(...i){const s=I.deepClone(this.contents),t=I.deepClone(this.overrides),n=[...this.keys];for(const o of i)if(!o.isEmpty()){this.mergeContents(s,o.contents);for(const c of o.overrides){const[u]=t.filter(f=>R.equals(f.identifiers,c.identifiers));u?(this.mergeContents(u.contents,c.contents),u.keys.push(...c.keys),u.keys=R.distinct(u.keys)):t.push(I.deepClone(c))}for(const c of o.keys)n.indexOf(c)===-1&&n.push(c)}return new v(s,n,t)}freeze(){return this.frozen=!0,this}clone(){return new v(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}createOverrideConfigurationModel(i){const s=this.getContentsForOverrideIdentifer(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const n of R.distinct([...Object.keys(this.contents),...Object.keys(s)])){let o=this.contents[n];const c=s[n];c&&(typeof o=="object"&&typeof c=="object"?(o=I.deepClone(o),this.mergeContents(o,c)):o=c),t[n]=o}return new v(t,this.keys,this.overrides)}mergeContents(i,s){for(const t of Object.keys(s)){if(t in i&&E.isObject(i[t])&&E.isObject(s[t])){this.mergeContents(i[t],s[t]);continue}i[t]=I.deepClone(s[t])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?I.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let s=null,t=null;const n=o=>{o&&(t?this.mergeContents(t,o):t=I.deepClone(o))};for(const o of this.overrides)R.equals(o.identifiers,[i])?s=o.contents:o.identifiers.includes(i)&&n(o.contents);return n(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,s){this.addKey(i),(0,b.addToValueTree)(this.contents,i,s,t=>{throw new Error(t)})}removeValue(i){this.removeKey(i)&&(0,b.removeFromValueTree)(this.contents,i)}addKey(i){let s=this.keys.length;for(let t=0;t<s;t++)i.indexOf(this.keys[t])===0&&(s=t);this.keys.splice(s,1,i)}removeKey(i){const s=this.keys.indexOf(i);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=v;class h{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,s){if(!E.isUndefinedOrNull(i)){const t=this.doParseContent(i);this.parseRaw(t,s)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,s){this._raw=i;const{contents:t,keys:n,overrides:o,restricted:c}=this.doParseRaw(i,s);this._configurationModel=new v(t,n,o),this._restrictedConfigurations=c||[]}doParseContent(i){let s={},t=null,n=[];const o=[],c=[];function u(w){Array.isArray(n)?n.push(w):t!==null&&(n[t]=w)}const f={onObjectBegin:()=>{const w={};u(w),o.push(n),n=w,t=null},onObjectProperty:w=>{t=w},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const w=[];u(w),o.push(n),n=w,t=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:u,onError:(w,_,N)=>{c.push({error:w,offset:_,length:N})}};if(i)try{D.visit(i,f),s=n[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return s}doParseRaw(i,s){const t=m.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),n=this.filter(i,t,!0,s);i=n.raw;const o=(0,b.toValuesTree)(i,f=>console.error(`Conflict in settings file ${this._name}: ${f}`)),c=Object.keys(i),u=this.toOverrides(i,f=>console.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:o,keys:c,overrides:u,restricted:n.restricted}}filter(i,s,t,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:i,restricted:[]};const o={},c=[];for(const u in i)if(S.OVERRIDE_PROPERTY_REGEX.test(u)&&t){const f=this.filter(i[u],s,!1,n);o[u]=f.raw,c.push(...f.restricted)}else{const f=s[u],w=f?typeof f.scope<"u"?f.scope:3:void 0;f?.restricted&&c.push(u),(w===void 0||n.scopes===void 0||n.scopes.includes(w))&&(n.skipRestricted&&f?.restricted||(o[u]=i[u]))}return{raw:o,restricted:c}}toOverrides(i,s){const t=[];for(const n of Object.keys(i))if(S.OVERRIDE_PROPERTY_REGEX.test(n)){const o={};for(const c in i[n])o[c]=i[n][c];t.push({identifiers:(0,S.overrideIdentifiersFromKey)(n),keys:Object.keys(o),contents:(0,b.toValuesTree)(o,s)})}return t}}e.ConfigurationModelParser=h;class y extends L.Disposable{constructor(i,s,t,n){super(),this.userSettingsResource=i,this.scopes=s,this.fileService=n,this._onDidChange=this._register(new r.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(r.Event.any(r.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),r.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class P{constructor(i,s,t,n,o=new v,c=new v,u=new T.ResourceMap,f=new v,w=new T.ResourceMap,_=!0){this._defaultConfiguration=i,this._policyConfiguration=s,this._applicationConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=c,this._folderConfigurations=u,this._memoryConfiguration=f,this._memoryConfigurationByResource=w,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,s,t){return this.getConsolidatedConfigurationModel(i,s,t).getValue(i)}updateValue(i,s,t={}){let n;t.resource?(n=this._memoryConfigurationByResource.get(t.resource),n||(n=new v,this._memoryConfigurationByResource.set(t.resource,n))):n=this._memoryConfiguration,s===void 0?n.removeValue(i):n.setValue(i,s),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,s,t){const n=this.getConsolidatedConfigurationModel(i,s,t),o=this.getFolderConfigurationModelForResource(s.resource,t),c=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),f=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(i),w=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(i),_=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),N=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),A=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),O=t?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,k=o?s.overrideIdentifier?o.freeze().override(s.overrideIdentifier).getValue(i):o.freeze().getValue(i):void 0,M=s.overrideIdentifier?c.override(s.overrideIdentifier).getValue(i):c.getValue(i),$=n.getValue(i),W=R.distinct(n.overrides.map(J=>J.identifiers).flat()).filter(J=>n.getOverrideValue(i,J)!==void 0);return{defaultValue:u,policyValue:f,applicationValue:w,userValue:_,userLocalValue:N,userRemoteValue:A,workspaceValue:O,workspaceFolderValue:k,memoryValue:M,value:$,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,policy:f!==void 0?{value:f}:void 0,application:w!==void 0?{value:w,override:s.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspaceFolder:k!==void 0?{value:o?.freeze().getValue(i),override:s.overrideIdentifier?o?.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:c.getValue(i),override:s.overrideIdentifier?c.getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(i){const s=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,s){this._folderConfigurations.set(i,s),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const t=[];if(!s){const{added:n,updated:o,removed:c}=a(this._defaultConfiguration,i);s=[...n,...o,...c]}for(const n of s)for(const o of(0,S.overrideIdentifiersFromKey)(n)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(o),u=i.getKeysForOverrideIdentifier(o),f=[...u.filter(w=>c.indexOf(w)===-1),...c.filter(w=>u.indexOf(w)===-1),...c.filter(w=>!I.equals(this._defaultConfiguration.override(o).getValue(w),i.override(o).getValue(w)))];t.push([o,f])}return this.updateDefaultConfiguration(i),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:t,removed:n}=a(this._policyConfiguration,i),o=[...s,...t,...n];return o.length&&this.updatePolicyConfiguration(i),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:t,removed:n,overrides:o}=a(this.applicationConfiguration,i),c=[...s,...t,...n];return c.length&&this.updateApplicationConfiguration(i),{keys:c,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:t,removed:n,overrides:o}=a(this.localUserConfiguration,i),c=[...s,...t,...n];return c.length&&this.updateLocalUserConfiguration(i),{keys:c,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:t,removed:n,overrides:o}=a(this.remoteUserConfiguration,i),c=[...s,...t,...n];return c.length&&this.updateRemoteUserConfiguration(i),{keys:c,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:t,removed:n,overrides:o}=a(this.workspaceConfiguration,i),c=[...s,...t,...n];return c.length&&this.updateWorkspaceConfiguration(i),{keys:c,overrides:o}}compareAndUpdateFolderConfiguration(i,s){const t=this.folderConfigurations.get(i),{added:n,updated:o,removed:c,overrides:u}=a(t,s),f=[...n,...o,...c];return(f.length||!t)&&this.updateFolderConfiguration(i,s),{keys:f,overrides:u}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:t,updated:n,removed:o,overrides:c}=a(s,void 0);return{keys:[...t,...n,...o],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,s,t){let n=this.getConsolidatedConfigurationModelForResource(s,t);return s.overrideIdentifier&&(n=n.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:i},s){let t=this.getWorkspaceConsolidatedConfiguration();if(s&&i){const n=s.getFolder(i);n&&(t=this.getFolderConsolidatedConfiguration(n.uri)||t);const o=this._memoryConfigurationByResource.get(i);o&&(t=t.merge(o))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let s=this._foldersConsolidatedConfigurations.get(i);if(!s){const t=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(i);n?(s=t.merge(n),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(i,s)):s=t}return s}getFolderConfigurationModelForResource(i,s){if(s&&i){const t=s.getFolder(i);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,s)=>{const{contents:t,overrides:n,keys:o}=this._folderConfigurations.get(s);return i.push([s,{contents:t,overrides:n,keys:o}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>i.add(s)),this.userConfiguration.freeze().keys.forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(t=>i.add(t))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>s.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n))),[...s.values()]}static parse(i){const s=this.parseConfigurationModel(i.defaults),t=this.parseConfigurationModel(i.policy),n=this.parseConfigurationModel(i.application),o=this.parseConfigurationModel(i.user),c=this.parseConfigurationModel(i.workspace),u=i.folders.reduce((f,w)=>(f.set(C.URI.revive(w[0]),this.parseConfigurationModel(w[1])),f),new T.ResourceMap);return new P(s,t,n,o,new v,c,u,new v,new T.ResourceMap,!1)}static parseConfigurationModel(i){return new v(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=P;function p(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const i=new Set,s=new Map;for(const n of l)n.keys.forEach(o=>i.add(o)),n.overrides.forEach(([o,c])=>{const u=(0,T.getOrSet)(s,o,new Set);c.forEach(f=>u.add(f))});const t=[];return s.forEach((n,o)=>t.push([o,[...n.values()]])),{keys:[...i.values()],overrides:t}}e.mergeChanges=p;class g{constructor(i,s,t,n){this.change=i,this.previous=s,this.currentConfiguraiton=t,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;i.keys.forEach(u=>o.add(u)),i.overrides.forEach(([,u])=>u.forEach(f=>o.add(f))),this.affectedKeys=[...o.values()];const c=new v;this.affectedKeys.forEach(u=>c.setValue(u,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(s){const t=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(i,s,this.currentWorkspace);return!I.equals(t,n)}return!0}return!1}doesAffectedKeysTreeContains(i,s){let t=(0,b.toValuesTree)({[s]:!0},()=>{}),n;for(;typeof t=="object"&&(n=Object.keys(t)[0]);){if(i=i[n],!i)return!1;t=t[n]}return!0}}e.ConfigurationChangeEvent=g;function a(l,i){const{added:s,removed:t,updated:n}=d(i,l),o=[],c=l?.getAllOverrideIdentifiers()||[],u=i?.getAllOverrideIdentifiers()||[];if(i){const f=u.filter(w=>!c.includes(w));for(const w of f)o.push([w,i.getKeysForOverrideIdentifier(w)])}if(l){const f=c.filter(w=>!u.includes(w));for(const w of f)o.push([w,l.getKeysForOverrideIdentifier(w)])}if(i&&l){for(const f of c)if(u.includes(f)){const w=d({contents:l.getOverrideValue(void 0,f)||{},keys:l.getKeysForOverrideIdentifier(f)},{contents:i.getOverrideValue(void 0,f)||{},keys:i.getKeysForOverrideIdentifier(f)});o.push([f,[...w.added,...w.removed,...w.updated]])}}return{added:s,removed:t,updated:n,overrides:o}}function d(l,i){const s=l?i?l.keys.filter(o=>i.keys.indexOf(o)===-1):[...l.keys]:[],t=i?l?i.keys.filter(o=>l.keys.indexOf(o)===-1):[...i.keys]:[],n=[];if(l&&i){for(const o of i.keys)if(l.keys.indexOf(o)!==-1){const c=(0,b.getConfigurationValue)(i.contents,o),u=(0,b.getConfigurationValue)(l.contents,o);I.equals(c,u)||n.push(o)}}return{added:s,removed:t,updated:n}}}),define(ne[199],re([0,1,19,3,2,32,15,18,70,43,8,60,40]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class v extends D.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new h(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(m.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:a})=>this.onDidUpdateConfiguration(g,a))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,a){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=v;class h extends E.ConfigurationModel{constructor(g={}){const a=m.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),d=Object.keys(a),l=Object.create(null),i=[];for(const s in a){const t=g[s],n=t!==void 0?t:a[s].default;(0,I.addToValueTree)(l,s,n,o=>console.error(`Conflict in default settings: ${o}`))}for(const s of Object.keys(l))C.OVERRIDE_PROPERTY_REGEX.test(s)&&i.push({identifiers:(0,C.overrideIdentifiersFromKey)(s),keys:Object.keys(l[s]),contents:(0,I.toValuesTree)(l[s],t=>console.error(`Conflict in default settings file: ${t}`))});super(l,d,i)}}e.DefaultConfigurationModel=h;class y{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=new E.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=y;let P=class extends D.Disposable{constructor(g,a,d){super(),this.defaultConfiguration=g,this.policyService=a,this.logService=d,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new E.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const a={},d=[],l=m.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(const i of g){const s=l[i];if(!s){d.push(i);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.logService.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}d.push(i),a[s.policy.name]={type:s.type}}}return(0,T.isEmptyObject)(a)||await this.policyService.registerPolicyDefinitions(a),d}onDidChangePolicies(g){const a=m.Registry.as(C.Extensions.Configuration).getPolicyConfigurations(),d=(0,R.coalesce)(g.map(l=>a.get(l)));this.update(d,!0)}update(g,a){const d=m.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),l=[],i=this._configurationModel.isEmpty();for(const s of g){const t=d[s]?.policy?.name;if(t){const n=this.policyService.getPolicyValue(t);(i?n!==void 0:!(0,L.equals)(this._configurationModel.getValue(s),n))&&l.push([s,n])}else this._configurationModel.getValue(s)!==void 0&&l.push([s,void 0])}if(l.length){const s=this._configurationModel;this._configurationModel=new E.ConfigurationModel;for(const t of s.keys)this._configurationModel.setValue(t,s.getValue(t));for(const[t,n]of l)n===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,n);a&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};P=pe([K(1,S.IPolicyService),K(2,b.ILogService)],P),e.PolicyConfiguration=P}),define(ne[200],re([0,1,6,3,2,17,18,70,199,60]),function(Q,e,R,r,D,L,T,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends D.Disposable{constructor(m,v,h,y){super(),this.settingsResource=m,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new E.DefaultConfiguration),this.policyConfiguration=h instanceof C.NullPolicyService?new E.NullPolicyConfiguration:this._register(new E.PolicyConfiguration(this.defaultConfiguration,h,y)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,v)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:P,properties:p})=>this.onDidDefaultConfigurationChange(P,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(P=>this.onDidPolicyConfigurationChange(P))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[m,v,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(m,v,new I.ConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(m,v){const h=typeof m=="string"?m:void 0,y=(0,T.isConfigurationOverrides)(m)?m:(0,T.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(h,y,void 0)}updateValue(m,v,h,y){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(h,v,2)}onDidDefaultConfigurationChange(m,v){const h=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(m,v);this.trigger(y,h,7)}onDidPolicyConfigurationChange(m){const v=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(m);this.trigger(h,v,7)}trigger(m,v,h){const y=new I.ConfigurationChangeEvent(m,{data:v},this.configuration);y.source=h,y.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(m){switch(m){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(ne[201],re([0,1,9,5]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,r.createDecorator)("remoteAuthorityResolverService");var D;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends R.ErrorNoTelemetry{constructor(I,E=D.Unknown,C){super(I),this._message=I,this._code=E,this._detail=C,this.isHandled=E===D.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(I){return I instanceof L&&I._code===D.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof L&&I._code===D.NoResolverFound}static isHandled(I){return I instanceof L&&I.isHandled}}e.RemoteAuthorityResolverError=L}),define(ne[101],re([0,1,21]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function r(C){return C.scheme===R.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=r;function D(C){if(!C)return;const b=C.indexOf("+");return b<0?C:C.substr(0,b)}e.getRemoteName=D;function L(C){return`/${C.quality??"oss"}-${C.commit??"dev"}`}e.getRemoteServerRootPath=L;function T(C){const{host:b,port:S}=E(C);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:S}}e.parseAuthorityWithPort=T;function I(C,b){let{host:S,port:m}=E(C);return typeof m>"u"&&(m=b),{host:S,port:m}}e.parseAuthorityWithOptionalPort=I;function E(C){const b=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const S=C.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const m=C.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:C,port:void 0}}}),define(ne[44],re([0,1,27,5,101]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=L;function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var E;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,P){if(typeof y>"u"||y===null)return typeof P>"u"||P===null;if(typeof P>"u"||P===null)return!1;if(typeof y=="string"||typeof P=="string"){const p=typeof y=="string"?y:y.value,g=typeof P=="string"?P:P.value;return R.equalsIgnoreCase(p,g)}return y._lower===P._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=C;function b(h){return S(h)}e.isApplicationScopedExtension=b;function S(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function m(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function v(h,y){if(y){const P=`onResolveRemoteAuthority:${(0,D.getRemoteName)(y)}`;return h.activationEvents?.indexOf(P)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,r.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[33],re([0,1,27,29,44,4,7,9,36]),function(Q,e,R,r,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function C(s,t){return s.uuid&&t.uuid?s.uuid===t.uuid:s.id===t.id?!0:(0,R.compareIgnoreCase)(s.id,t.id)===0}e.areSameExtensions=C;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{constructor(t,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=t.id}static create(t){const n=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new S(t.identifier,n,o)}static parse(t){const n=b.exec(t);return n&&n[1]&&n[2]?new S({id:n[1]},n[2],n[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof S?C(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=S;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(s){const t=m.exec(s);return t&&t[1]?[y(t[1]),t[2]]:[y(s),void 0]}e.getIdAndVersion=v;function h(s,t){return`${s}.${t}`}e.getExtensionId=h;function y(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function P(s,t){return y(h(s,t))}e.getGalleryExtensionId=P;function p(s,t){const n=[],o=c=>{for(const u of n)if(u.some(f=>C(t(f),t(c))))return u;return null};for(const c of s){const u=o(c);u?u.push(c):n.push([c])}return n}e.groupByExtension=p;function g(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function a(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=a,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function d(s,t){const n=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&n.every(u=>!C(u.identifier,{id:c}))){const u=s.filter(f=>C(f.identifier,{id:c}));u.length===1&&(n.push(u[0]),o.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=d;async function l(s,t){if(!L.isLinux)return!1;let n;try{n=(await s.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(c))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=l;async function i(s,t){const n=await l(s,t),o=(0,r.getTargetPlatform)(n?"alpine":L.platform,E.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=i}),define(ne[49],re([0,1,6,16,2,34,7,33,13,5,8]),function(Q,e,R,r,D,L,T,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,C.createDecorator)("IExtensionsProfileScannerService");let S=class extends D.Disposable{constructor(v,h){super(),this.fileService=v,this.logService=h,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,h){return this.withProfileExtensions(h,y=>(y=y.filter(P=>v.some(([p])=>!(0,I.areSameExtensions)(P.identifier,p.identifier))),y.push(...v.map(([P,p])=>({identifier:P.identifier,version:P.manifest.version,location:P.location,metadata:p}))),y))}removeExtensionFromProfile(v,h){return this.withProfileExtensions(h,y=>y.filter(P=>!(0,I.areSameExtensions)(P.identifier,v)))}async withProfileExtensions(v,h){return this.getResourceAccessQueue(v).queue(async()=>{let y=[];try{const P=await this.fileService.readFile(v),p=JSON.parse(P.value.toString());for(const g of p){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}y.push({identifier:g.identifier,location:T.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(P){P.fileOperationResult!==1&&this.logService.error(P)}if(h){y=h(y);const P=y.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),metadata:p.metadata}));await this.fileService.writeFile(v,r.VSBuffer.fromString(JSON.stringify(P)))}return y})}getResourceAccessQueue(v){let h=this.resourcesAccessQueueMap.get(v);return h||(h=new R.Queue,this.resourcesAccessQueueMap.set(v,h)),h}};S=pe([K(0,E.IFileService),K(1,b.ILogService)],S),e.ExtensionsProfileScannerService=S}),define(ne[202],re([0,1,24,33]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function D(L,T,I,E,C){try{const b=await L.getExtensionsControlManifest();if(!b.deprecated)return;const S=await L.getInstalled(1);for(const[m,v]of Object.entries(b.deprecated)){if(!v?.extension)continue;const{id:h,autoMigrate:y,preRelease:P}=v.extension;if(!y)continue;const p=S.find(a=>(0,r.areSameExtensions)(a.identifier,{id:m}));if(!p)continue;const g=(await T.getExtensions([{id:h,preRelease:P}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!g){C.info(`Skipping migrating '${p.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{C.info(`Migrating '${p.identifier.id}' extension to '${h}' extension...`);const a=!E.getDisabledExtensions().some(l=>(0,r.areSameExtensions)(l,p.identifier));await L.uninstall(p),C.info(`Uninstalled the unsupported extension '${p.identifier.id}'`);let d=S.find(l=>(0,r.areSameExtensions)(l.identifier,{id:h}));(!d||!d.isPreReleaseVersion&&a)&&(d=await L.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:p.isMachineScoped,operation:4}),C.info(`Installed the pre-release extension '${d.identifier.id}'`),a||(await E.disableExtension(d.identifier),C.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${p.identifier.id}' is disabled`)),y.storage&&(I.addToMigrationList((0,r.getExtensionId)(p.manifest.publisher,p.manifest.name),(0,r.getExtensionId)(d.manifest.publisher,d.manifest.name)),C.info("Added pre-release extension to the storage migration list"))),C.info(`Migrated '${p.identifier.id}' extension to '${h}' extension.`)}catch(a){C.error(a)}}}catch(b){C.error(b)}}e.migrateUnsupportedExtensions=D}),define(ne[203],re([0,1,6,9,2,4,17,55,7,30,28,14,29,33,13,8]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let P=class extends D.Disposable{constructor(g,a,d,l){super(),this.fileService=a,this.extensionGalleryService=d,this.logService=l,this.extensionsDownloadDir=E.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,a){await this.cleanUpPromise;const d=this.getName(g),l=(0,T.joinPath)(this.extensionsDownloadDir,d);if(!await this.fileService.exists(l)){const i=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(g,i,a);try{await this.rename(i,l,Date.now()+2*60*1e3)}catch(s){try{await this.fileService.del(i)}catch{}if(s.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,r.getErrorMessage)(s)}. Deleted the vsix from downloaded location`,i.path),s}}return l}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,a,d){try{await b.Promises.rename(g.fsPath,a.fsPath)}catch(l){if(L.isWindows&&l&&l.code==="EPERM"&&Date.now()<d)return this.logService.info(`Failed renaming ${g} to ${a} with 'EPERM' error. Trying again...`),this.rename(g,a,d);throw l}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const a=[],d=[];for(const s of g.children){const t=v.ExtensionKey.parse(s.name);t&&d.push([t,s])}const l=(0,v.groupByExtension)(d,([s])=>s),i=[];for(const s of l)s.sort((t,n)=>I.rcompare(t[0].version,n[0].version)),a.push(...s.slice(1).map(t=>t[1].resource)),i.push(s[0][1]);i.sort((s,t)=>s.mtime-t.mtime),a.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(s=>s.resource)),await R.Promises.settled(a.map(s=>(this.logService.trace("Deleting vsix from cache",s.path),this.fileService.del(s))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?v.ExtensionKey.create(g).toString().toLowerCase():(0,C.generateUuid)()}};P=pe([K(0,S.INativeEnvironmentService),K(1,h.IFileService),K(2,m.IExtensionGalleryService),K(3,y.ILogService)],P),e.ExtensionsDownloader=P}),define(ne[204],re([0,1,2,12,28,44]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends R.Disposable{constructor(E,C){super(),this.environmentService=E,this.extensionsManifestCache=(0,r.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(C.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(C.onDidUninstallExtension(b=>this.onDidUnInstallExtension(b)))}onDidInstallExtensions(E){E.some(C=>!!C.local)&&this.invalidate()}onDidUnInstallExtension(E){E.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(ne[205],re([0,1,95,19,6,2,21,12,28,14,29,33,8,69]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let h=class extends v.LanguagePackBaseService{constructor(g,a,d,l){super(d),this.extensionManagementService=g,this.logService=l,this.cache=this._register(new y(a,l)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),a=Object.keys(g).map(d=>{const l=g[d];return{...this.createQuickPickItem(d,l.label),extensionId:l.extensions[0].extensionIdentifier.id}});return a.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),a.sort((d,l)=>d.label.localeCompare(l.label)),a}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const a=await this.cache.getLanguagePacks();Object.keys(a).some(d=>a[d]&&a[d].extensions.some(l=>(0,S.areSameExtensions)(l.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,a]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),d=await this.cache.update(a);return!(0,r.equals)(Object.keys(g),Object.keys(d))}};h=pe([K(0,b.IExtensionManagementService),K(1,C.INativeEnvironmentService),K(2,b.IExtensionGalleryService),K(3,m.ILogService)],h),e.NativeLanguagePackService=h;let y=class extends L.Disposable{constructor(g,a){super(),this.logService=a,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(a=>{Object.keys(a).forEach(d=>delete a[d]),this.createLanguagePacksFromExtensions(a,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...a){for(const d of a)d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,d);Object.keys(g).forEach(d=>this.updateHash(g[d]))}createLanguagePacksFromExtension(g,a){const d=a.identifier,l=a.manifest.contributes&&a.manifest.contributes.localizations?a.manifest.contributes.localizations:[];for(const i of l)if(a.location.scheme===T.Schemas.file&&P(i)){let s=g[i.languageId];s||(s={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},g[i.languageId]=s);const t=s.extensions.filter(n=>(0,S.areSameExtensions)(n.extensionIdentifier,d))[0];t?t.version=a.manifest.version:s.extensions.push({extensionIdentifier:d,version:a.manifest.version});for(const n of i.translations)s.translations[n.id]=(0,I.join)(a.location.fsPath,n.path)}}updateHash(g){if(g){const a=(0,R.createHash)("md5");for(const d of g.extensions)a.update(d.extensionIdentifier.uuid||d.extensionIdentifier.id).update(d.version);g.hash=a.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let a=null;return E.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,d=>d.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(d)).then(d=>{try{return JSON.parse(d)}catch{return{}}}).then(d=>(a=g(d),d)).then(d=>{for(const i of Object.keys(d))d[i]||delete d[i];this.languagePacks=d,this.initializedCache=!0;const l=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",l),E.Promises.writeFile(this.languagePacksFilePath,l)}).then(()=>a,d=>this.logService.error(d))})}};y=pe([K(0,C.INativeEnvironmentService),K(1,m.ILogService)],y);function P(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const g of p.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(ne[206],re([0,1,6,16,24,9,3,2,30,88,201,101]),function(Q,e,R,r,D,L,T,I,E,C,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const m=30*1e3;var v;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function h(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function y(z){const V=new D.CancellationTokenSource;return setTimeout(()=>V.cancel(),z),V.token}function P(z,V){if(z.isCancellationRequested||V.isCancellationRequested)return D.CancellationToken.Cancelled;const U=new D.CancellationTokenSource;return z.onCancellationRequested(()=>U.cancel()),V.onCancellationRequested(()=>U.cancel()),U.token}class p{constructor(V){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((U,F)=>{this._resolvePromise=U,this._rejectPromise=F}),V.isCancellationRequested?this._timeout():this._disposables.add(V.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(V){this._state==="pending"?this._disposables.add(V):V.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const V=new Error("Time limit reached");return V.code="ETIMEDOUT",V.syscall="connect",V}resolve(V){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(V))}reject(V){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(V))}}function g(z,V){const U=new p(V);return U.registerDisposable(z.onControlMessage(F=>{const j=JSON.parse(F.toString()),B=q(j);B?U.reject(B):U.resolve(j)})),U.promise}function a(z,V,U,F,j,B,Z,oe){const X=new p(oe);return V.connect(U,F,j,B,Z,(ie,se)=>{X.didTimeout?(ie&&z.error(ie),se?.dispose()):ie||!se?X.reject(ie):X.resolve(se)}),X.promise}function d(z,V){const U=new p(V);return z.then(F=>{U.didTimeout||U.resolve(F)},F=>{U.didTimeout||U.reject(F)}),U.promise}async function l(z,V,U,F){const j=te(z,V);z.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let B;try{B=await a(z.logService,z.socketFactory,z.host,z.port,(0,S.getRemoteServerRootPath)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,`renderer-${h(V)}-${z.reconnectionToken}`,F)}catch(se){throw z.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),z.logService.error(se),se}z.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let Z,oe;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(B,null),Z=z.reconnectionProtocol,oe=!1):(Z=new C.PersistentProtocol(B,null),oe=!0),z.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const X=await d(z.signService.createNewMessage((0,E.generateUuid)()),F),ie={type:"auth",auth:z.connectionToken||"00000000000000000000",data:X.data};Z.sendControl(r.VSBuffer.fromString(JSON.stringify(ie)));try{const se=await g(Z,P(F,y(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(z.logService.trace(`${j} 4/6. received SignRequest control message.`),!await d(z.signService.validate(X,se.signedData),F)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const he=await d(z.signService.sign(se.data),F),ve={type:"connectionType",commit:z.commit,signedData:he,desiredConnectionType:V};return U&&(ve.args=U),z.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(r.VSBuffer.fromString(JSON.stringify(ve))),{protocol:Z,ownsProtocol:oe}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(z.logService.error(`${j} the handshake timed out. Error:`),z.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${j} received error control message when negotiating connection. Error:`),z.logService.error(se)),oe&&G(Z),se}}async function i(z,V,U,F){const j=Date.now(),B=te(z,V),{protocol:Z,ownsProtocol:oe}=await l(z,V,U,F),X=new p(F);return X.registerDisposable(Z.onControlMessage(ie=>{const se=JSON.parse(ie.toString()),ue=q(se);ue?(z.logService.error(`${B} received error control message when negotiating connection. Error:`),z.logService.error(ue),oe&&G(Z),X.reject(ue)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${ce(j)}!`),X.resolve({protocol:Z,firstMessage:se}))})),X.promise}async function s(z,V){const{protocol:U}=await i(z,1,void 0,V);return{protocol:U}}async function t(z,V,U){const{protocol:F,firstMessage:j}=await i(z,2,V,U),B=j&&j.debugPort;return{protocol:F,debugPort:B}}async function n(z,V,U){const F=Date.now(),j=te(z,3),{protocol:B}=await l(z,3,V,U);return z.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${ce(F)}!`),B}async function o(z,V,U){const{host:F,port:j,connectionToken:B}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,host:F,port:j,connectionToken:B,reconnectionToken:V,reconnectionProtocol:U,socketFactory:z.socketFactory,signService:z.signService,logService:z.logService}}async function c(z,V,U){return f(z,async F=>{const{protocol:j}=await s(F,D.CancellationToken.None);return new J(z,V,U,F.reconnectionToken,j)})}e.connectRemoteAgentManagement=c;async function u(z,V){return f(z,async U=>{const{protocol:F,debugPort:j}=await t(U,V,D.CancellationToken.None);return new H(z,V,U.reconnectionToken,F,j)})}e.connectRemoteAgentExtensionHost=u;async function f(z,V){for(let F=1;;F++)try{const j=(0,E.generateUuid)(),B=await o(z,j,null);return await V(B)}catch(j){if(F<5)z.logService.error(`[remote-connection][attempt ${F}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(j);else throw z.logService.error(`[remote-connection][attempt ${F}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(j),W.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(j)),j}}async function w(z,V,U){const F=await o(z,(0,E.generateUuid)(),null);return await n(F,{host:V,port:U},D.CancellationToken.None)}e.connectRemoteAgentTunnel=w;function _(z){return(0,R.createCancelablePromise)(V=>new Promise((U,F)=>{const j=setTimeout(U,z*1e3);V.onCancellationRequested(()=>{clearTimeout(j),U()})}))}var N;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(N=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(V,U){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.type=0}}e.ConnectionLostEvent=A;class O{constructor(V,U,F,j){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.durationSeconds=F,this.cancellableTimer=j,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class k{constructor(V,U,F){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.attempt=F,this.type=2}}e.ReconnectionRunningEvent=k;class M{constructor(V,U,F){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.attempt=F,this.type=4}}e.ConnectionGainEvent=M;class ${constructor(V,U,F,j){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.attempt=F,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class W extends I.Disposable{constructor(V,U,F,j,B){super(),this._connectionType=V,this._options=U,this.reconnectionToken=F,this.protocol=j,this._reconnectionFailureIsFatal=B,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new M(this.reconnectionToken,0,0)),this._register(j.onSocketClose(Z=>{const oe=Y(this._connectionType,this.reconnectionToken,!0);Z?Z.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this._options.logService.error(Z.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this._options.logService.error(Z.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(j.onSocketTimeout(Z=>{const oe=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),W._instances.push(this),this._register((0,I.toDisposable)(()=>{const Z=W._instances.indexOf(this);Z>=0&&W._instances.splice(Z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(W._permanentFailureMillisSinceLastIncomingData,W._permanentFailureAttempt,W._permanentFailureHandled)}static triggerPermanentFailure(V,U,F){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=V,this._permanentFailureAttempt=U,this._permanentFailureHandled=F,this._instances.forEach(j=>j._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(V=>V._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(V=>V._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||W._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const V=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${V} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const j=F<U.length?U[F]:U[U.length-1];try{if(j>0){const Z=_(j);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,Z)),this._options.logService.info(`${V} waiting for ${j} seconds before reconnecting...`);try{await Z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${V} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this._options.logService.info(`${V} resolving connection...`);const B=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${V} connecting to ${B.host}:${B.port}...`),await this._reconnect(B,y(m)),this._options.logService.info(`${V} reconnected!`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${V} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this._options.logService.error(`${V} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(B)){this._options.logService.info(`${V} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this._options.logService.info(`${V} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((0,L.isCancellationError)(B)){this._options.logService.info(`${V} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if(B instanceof b.RemoteAuthorityResolverError){this._options.logService.error(`${V} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,b.RemoteAuthorityResolverError.isHandled(B));break}this._options.logService.error(`${V} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(V,U,F){this._reconnectionFailureIsFatal?W.triggerPermanentFailure(V,U,F):this._gotoPermanentFailure(V,U,F)}_gotoPermanentFailure(V,U,F){this._onDidStateChange.fire(new $(this.reconnectionToken,V,U,F)),G(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=W,W._permanentFailure=!1,W._permanentFailureMillisSinceLastIncomingData=0,W._permanentFailureAttempt=0,W._permanentFailureHandled=!1,W._instances=[];class J extends W{constructor(V,U,F,j,B){super(1,V,j,B,!0),this.client=this._register(new C.Client(B,{remoteAuthority:U,clientId:F},V.ipcLogger))}async _reconnect(V,U){await s(V,U)}}e.ManagementPersistentConnection=J;class H extends W{constructor(V,U,F,j,B){super(2,V,F,j,!1),this._startArguments=U,this.debugPort=B}async _reconnect(V,U){await t(V,this._startArguments,U)}}e.ExtensionHostPersistentConnection=H;function G(z){try{z.acceptDisconnect();const V=z.getSocket();z.dispose(),V.dispose()}catch(V){(0,L.onUnexpectedError)(V)}}function q(z){if(z&&z.type==="error"){const V=new Error(`Connection error: ${z.reason}`);return V.code="VSCODE_CONNECTION_ERROR",V}return null}function x(z,V){for(;z.length<V;)z+=" ";return z}function Y(z,V,U){return`[remote-connection][${x(h(z),13)}][${V.substr(0,5)}\u2026][${U?"reconnect":"initial"}]`}function te(z,V){return`${Y(V,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.host}:${z.port}]`}function ce(z){return`${Date.now()-z} ms`}}),define(ne[207],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[208],re([0,1,80,138]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,L,T,I,E,C){const b=m=>C(m,void 0),S=R.createConnection({host:D,port:L},()=>{S.removeListener("error",b);const m=Buffer.alloc(16);for(let P=0;P<16;P++)m[P]=Math.round(Math.random()*256);const v=m.toString("base64"),h=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${L}${T}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`];S.write(h.join(`\r
`)+`\r
\r
`);const y=P=>{P.toString().indexOf(`\r
\r
`)>=0&&(S.off("data",y),C(void 0,new r.NodeSocket(S,E)))};S.on("data",y)});S.setNoDelay(!0),S.once("error",b)}}}),define(ne[209],re([0,1,121,18,8]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(I,E){this.configurationService=I,this.logService=E}async request(I,E){this.logService.trace("RequestService#request (browser) - begin",I.url),I.proxyAuthorization||(I.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const C=await(0,R.request)(I,E);return this.logService.trace("RequestService#request (browser) - success",I.url),C}catch(C){throw this.logService.error("RequestService#request (browser) - error",I.url,C),C}}async resolveProxy(I){}};L=pe([K(0,r.IConfigurationService),K(1,D.ILogService)],L),e.RequestService=L}),define(ne[45],re([0,1,16,156,43,5,40]),function(Q,e,R,r,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function I(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=I;function E(y){return y.res.statusCode===204}async function C(y){return E(y)?null:(await(0,R.streamToBuffer)(y.stream)).toString()}e.asText=C;async function b(y){if(!I(y))throw new Error("Server returned "+y.res.statusCode);return C(y)}e.asTextOrError=b;async function S(y){if(!I(y))throw new Error("Server returned "+y.res.statusCode);if(E(y))return null;const p=(await(0,R.streamToBuffer)(y.stream)).toString();try{return JSON.parse(p)}catch(g){throw g.message+=`:
`+p,g}}e.asJson=S;function m(y){h(y)}e.updateProxyConfigurationsScope=m;let v;function h(y){const P=T.Registry.as(D.Extensions.Configuration),p=v;v={id:"http",order:15,title:(0,r.localize)(0,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,r.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,r.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,r.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,r.localize)(4,null),(0,r.localize)(5,null),(0,r.localize)(6,null),(0,r.localize)(7,null)],default:"override",description:(0,r.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,r.localize)(9,null),restricted:!0}}},P.updateConfigurations({add:[v],remove:p?[p]:[]})}h(2)}),define(ne[210],re([0,1,24,21,13,45]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(E,C){this.requestService=E,this.fileService=C}async download(E,C,b=R.CancellationToken.None){if(E.scheme===r.Schemas.file||E.scheme===r.Schemas.vscodeRemote){await this.fileService.copy(E,C);return}const S={type:"GET",url:E.toString(!0)},m=await this.requestService.request(S,b);if(m.res.statusCode===200)await this.fileService.writeFile(C,m.stream);else{const v=await(0,L.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${v}`)}}};T=pe([K(0,L.IRequestService),K(1,D.IFileService)],T),e.DownloadService=T}),define(ne[211],re([0,1,19,24,2,17,173,13,8,25,45]),function(Q,e,R,r,D,L,T,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let S=class extends D.Disposable{constructor(v,h,y,P){super(),this.fileService=v,this.productService=h,this.requestService=y,this.logService=P,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,p])=>this.allConfigBasedTips.set(p.configPath,p))}getConfigBasedTips(v){return this.getValidConfigBasedTips(v)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(v){const h=[];for(const[y,P]of this.allConfigBasedTips)if(!(P.configScheme&&P.configScheme!==v.scheme))try{const p=await this.fileService.readFile((0,L.joinPath)(v,y)),g=new Map;Object.entries(P.recommendations).forEach(([d,l])=>{if((0,R.isNonEmptyArray)(l.remotes))for(const i of l.remotes)g.set(i,{extensionId:d,extensionName:l.name,configName:P.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled});else h.push({extensionId:d,extensionName:l.name,configName:P.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled})});const a=(0,T.getDomainsOfRemotes)(p.value.toString(),[...g.keys()]);for(const d of a){const l=g.get(d);l&&h.push(l)}}catch{}return h}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const v=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},r.CancellationToken.None);if(v.res.statusCode!==200)return[];const h=await(0,b.asJson)(v);return h?h.workspaceRecommendations||[]:[]}catch(v){return this.logService.error(v),[]}}};S=pe([K(0,I.IFileService),K(1,C.IProductService),K(2,b.IRequestService),K(3,E.ILogService)],S),e.ExtensionTipsService=S}),define(ne[212],re([0,1,16,24]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(I){this.service=I}listen(I,E){throw new Error("Invalid listen")}call(I,E,C,b=r.CancellationToken.None){switch(E){case"request":return this.service.request(C[0],b).then(async({res:S,stream:m})=>{const v=await(0,R.streamToBuffer)(m);return[{statusCode:S.statusCode,headers:S.headers},v]});case"resolveProxy":return this.service.resolveProxy(C[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class L{constructor(I){this.channel=I}async request(I,E){const[C,b]=await this.channel.call("request",[I],E);return{res:C,stream:(0,R.bufferToStream)(b)}}async resolveProxy(I){return this.channel.call("resolveProxy",[I])}}e.RequestChannelClient=L}),define(ne[213],re([0,1,209,212]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class D{constructor(T,I,E){this.configurationService=I,this.logService=E,this.browserRequestService=new R.RequestService(I,E),this.mainRequestService=new r.RequestChannelClient(T.getChannel("request"))}request(T,I){return this.getRequestService().request(T,I)}async resolveProxy(T){return this.getRequestService().resolveProxy(T)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=D}),define(ne[102],re([0,1,64,5]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(L){return(0,R.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,r.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[214],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var R;(function(r){r.Spawn="vscode:shared-process->shared-process-worker=spawn",r.Terminate="vscode:shared-process->shared-process-worker=terminate",r.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",r.Ready="vscode:shared-process-worker->shared-process=ready",r.Ack="vscode:shared-process-worker->shared-process=ack",r.Trace="vscode:shared-process-worker->shared-process=trace",r.Info="vscode:shared-process-worker->shared-process=info",r.Warn="vscode:shared-process-worker->shared-process=warn",r.Error="vscode:shared-process-worker->shared-process=error"})(R=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[215],re([0,1,89,6,24,3,2,21,30,8,102,214]),function(Q,e,R,r,D,L,T,I,E,C,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let m=class{constructor(y){this.logService=y,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(y){const P=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${P})`);const p=(0,b.hash)(y);this.processeDisposables.has(p)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${P})`),this.doDisposeWorker(y));const g=new D.CancellationTokenSource;let a,d,l;this.processeDisposables.set(p,n=>{g.dispose(!0),a?.terminate(y,D.CancellationToken.None),d?.close(),l?.close(),this.processeDisposables.delete(p);const o=this.processResolvers.get(p);o&&(this.processResolvers.delete(p),o({reason:n}))}),a=await this.getOrCreateWebWorker(y);const i=new Promise(n=>{this.processResolvers.set(p,n)});if(g.token.isCancellationRequested)return i;const{port1:s,port2:t}=new MessageChannel;return d=s,l=t,await a.spawn(y,l,g.token),g.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${P})`),R.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",y,[d])),i}getOrCreateWebWorker(y){let P=this.workers.get(y.process.moduleId);if(!P){this.logService.trace(`SharedProcess: creating new web worker (${y.process.moduleId})`);const p=new v(y.process.type,this.logService);P=p.init(),p.onDidProcessSelfTerminate(({configuration:g,reason:a})=>{this.doDisposeWorker(g,a)}),this.workers.set(y.process.moduleId,P)}return P}async disposeWorker(y){return this.doDisposeWorker(y)}doDisposeWorker(y,P){const p=this.processeDisposables.get((0,b.hash)(y));p&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),p(P))}};m=pe([K(0,C.ILogService)],m),e.SharedProcessWorkerService=m;class v extends T.Disposable{constructor(y,P){super(),this.type=y,this.logService=P,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const y=new r.DeferredPromise,P=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return P.onerror=p=>{this.logService.error(`SharedProcess: worker error (${this.type})`,p.message)},P.onmessageerror=p=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,p)},P.onmessage=p=>{const{id:g,message:a,configuration:d,nonce:l}=p.data;switch(g){case S.SharedProcessWorkerMessages.Ready:y.complete(P);break;case S.SharedProcessWorkerMessages.Ack:if(l){const i=this.mapMessageNonceToPendingMessageResolve.get(l);i&&(this.mapMessageNonceToPendingMessageResolve.delete(l),i())}break;case S.SharedProcessWorkerMessages.SelfTerminated:d&&a&&this._onDidProcessSelfTerminate.fire({configuration:d,reason:JSON.parse(a)});break;case S.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,a);break;case S.SharedProcessWorkerMessages.Info:a&&this.logService.info(a);break;case S.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,a);break;case S.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,a);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,p)}},P.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),y.p}async send(y,P,p){const g=await this.workerReady;if(!P.isCancellationRequested)return new Promise(a=>{const d=(0,E.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(d,a);const l={...y,nonce:d};p?g.postMessage(l,[p]):g.postMessage(l),P.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(d)&&a()})})}spawn(y,P,p){const g={id:S.SharedProcessWorkerMessages.Spawn,configuration:y,environment:{bootstrapPath:I.FileAccess.asFileUri("bootstrap-fork",Q).fsPath}};return this.send(g,p,P)}terminate(y,P){const p={id:S.SharedProcessWorkerMessages.Terminate,configuration:y};return this.send(p,P)}}}),define(ne[216],re([0,1,62,21,172]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class L extends D.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}}pe([R.memoize],L.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=L}),define(ne[217],re([0,1,54,12,157,24,38,9,4,30,135,170,6]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let h;async function y(p,g,a){return g["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):E.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(a)&&!g["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(a)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=m.Promises.withAsyncBody(async(d,l)=>{const i=new L.CancellationTokenSource,s=setTimeout(()=>{i.dispose(!0),l(new Error((0,D.localize)(0,null)))},v);try{d(await P(p,i.token))}catch(t){!(0,I.isCancellationError)(t)&&!i.token.isCancellationRequested?l(new Error((0,D.localize)(1,null,(0,T.toErrorMessage)(t)))):d({})}finally{clearTimeout(s),i.dispose()}})),h)}e.getResolvedShellEnv=y;async function P(p,g){const a=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",a);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",d);const l=(0,C.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(l+"(.*)"+l),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",s);const t=await(0,b.getSystemShell)(E.OS,s);return p.trace("getUnixShellEnvironment#shell",t),new Promise((n,o)=>{if(g.isCancellationRequested)return o((0,I.canceled)());const c=(0,r.basename)(t);let u,f;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(u=`& '${process.execPath}' ${w} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,f=["-Login","-Command"]):(u=`'${process.execPath}' ${w} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,c==="tcsh"?f=["-ic"]:f=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),u);const _=(0,R.spawn)(t,[...f,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});g.onCancellationRequested(()=>(_.kill(),o((0,I.canceled)()))),_.on("error",O=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(O)),o(O)});const N=[];_.stdout.on("data",O=>N.push(O));const A=[];_.stderr.on("data",O=>A.push(O)),_.on("close",(O,k)=>{const M=Buffer.concat(N).toString("utf8");p.trace("getUnixShellEnvironment#raw",M);const $=Buffer.concat(A).toString("utf8");if($.trim()&&p.trace("getUnixShellEnvironment#stderr",$),O||k)return o(new Error((0,D.localize)(2,null,O,k)));const W=i.exec(M),J=W?W[1]:"{}";try{const H=JSON.parse(J);a?H.ELECTRON_RUN_AS_NODE=a:delete H.ELECTRON_RUN_AS_NODE,d?H.ELECTRON_NO_ATTACH_CONSOLE=d:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",H),n(H)}catch(H){p.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(H)),o(H)}})})}}),define(ne[103],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[218],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{constructor(){this.validators=new Map}vsda(){return new Promise((D,L)=>Q(["vsda"],D,L))}async createNewMessage(D){try{const L=await this.vsda(),T=new L.validator;if(T){const I=String(R._nextId++);return this.validators.set(I,T),{id:I,data:T.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,L){if(!D.id)return!0;const T=this.validators.get(D.id);if(!T)return!1;this.validators.delete(D.id);try{return T.validate(L)==="ok"}catch{return!1}}async sign(D){try{const L=await this.vsda(),T=new L.signer;if(T)return T.sign(D)}catch{}return D}}e.SignService=R,R._nextId=1}),define(ne[71],re([0,1,3,2]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class D extends r.Disposable{constructor(S,m,v){super(),this.channel=S,this.profile=m,this.workspace=v}async getItems(){const S={profile:this.profile,workspace:this.workspace},m=await this.channel.call("getItems",S);return new Map(m)}updateItems(S){const m={profile:this.profile,workspace:this.workspace};return S.insert&&(m.insert=Array.from(S.insert.entries())),S.delete&&(m.delete=Array.from(S.delete.values())),this.channel.call("updateItems",m)}}class L extends D{constructor(S,m){super(S,m,void 0),this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(S=>this.onDidChangeStorage(S)))}onDidChangeStorage(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this._onDidChangeItemsExternal.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}}class T extends L{constructor(S){super(S,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class I extends L{constructor(S,m){super(S,m)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=I;class E extends D{constructor(S,m){super(S,void 0,m),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=E;class C{constructor(S){this.channel=S}isUsed(S){const m={payload:S,profile:void 0,workspace:void 0};return this.channel.call("isUsed",m)}}e.StorageClient=C}),define(ne[104],re([0,1,4,36,7,30]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(C){if(R.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function I(C,b,S,m,v,h,y,P,p,g){const a=Object.create(null);a["common.machineId"]=y,a.sessionID=(0,L.generateUuid)()+Date.now(),a.commitHash=v,a.version=h,a["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,R.PlatformToString)(R.platform),a["common.nodePlatform"]=r.platform,a["common.nodeArch"]=m,a["common.product"]=g||"desktop",P&&(a["common.msftInternal"]=P);let d=0;const l=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),R.isLinuxSnap&&(a["common.snap"]="true");const i=T(S);i&&(a["common.platformDetail"]=i);try{const s=await C.readFile(D.URI.file(p));a["common.source"]=s.value.toString().slice(0,30)}catch{}return a}e.resolveCommonProperties=I;function E(C){const b=r.env.USERDNSDOMAIN;if(!b)return!1;const S=b.toLowerCase();return C.some(m=>S===m)}e.verifyMicrosoftInternalDomain=E}),define(ne[22],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var r;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(r=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[219],re([0,1,37,52,6,35,21,12,4,7,132,28,134,92,13,25,22]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function g(s,t){const n=`${s}::${t.join(":")}`,o=p.get(n);if(o)return o;const c=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,f=new Map,w=2e4;function _(A,O,k,M){const $=O.substring(A.length+1);return D.Promises.withAsyncBody(async W=>{let J;try{J=await S.Promises.readdir(O,{withFileTypes:!0})}catch{W();return}if(M.count>=w){M.count+=J.length,M.maxReached=!0,W();return}let H=J.length;if(H===0){W();return}let G=J;M.count+J.length>w&&(M.maxReached=!0,H=w-M.count,G=J.slice(0,H)),M.count+=J.length;for(const q of G)if(q.isDirectory()){if(k.includes(q.name)||await _(A,(0,I.join)(O,q.name),k,M),--H===0){W();return}}else{const x=q.name.lastIndexOf(".");if(x>=0){const Y=q.name.substring(x+1);Y&&u.set(Y,(u.get(Y)??0)+1)}for(const Y of c)Y.relativePathPattern?.test($)!==!1&&Y.filePattern.test(q.name)&&f.set(Y.tag,(f.get(Y.tag)??0)+1);if(--H===0){W();return}}})}const N=D.Promises.withAsyncBody(async A=>{const O={count:0,maxReached:!1};await _(s,s,t,O);const k=await l(s);A({configFiles:a(f),fileTypes:a(u),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:k})});return p.set(n,N),N}e.collectWorkspaceStats=g;function a(s){return[...r.Iterable.map(s.entries(),([t,n])=>({name:t,count:n}))].sort((t,n)=>n.count-t.count)}function d(){const s={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},t=R.cpus();return t&&t.length>0&&(s.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),s}e.getMachineInfo=d;async function l(s){try{const t=new Map,n=(0,I.join)(s,".vscode","launch.json"),o=await S.Promises.readFile(n),c=[],u=(0,L.parse)(o.toString(),c);if(c.length)return console.log(`Unable to parse ${n}`),[];if((0,L.getNodeType)(u)==="object"&&u.configurations)for(const f of u.configurations){const w=f.type;w&&(t.has(w)?t.set(w,t.get(w)+1):t.set(w,1))}return a(t)}catch{return[]}}e.collectLaunchConfigs=l;let i=class{constructor(t,n){this.telemetryService=t,this.productService=n}formatMachineInfo(t){const n=[];return n.push(`OS Version:       ${t.os}`),n.push(`CPUs:             ${t.cpus}`),n.push(`Memory (System):  ${t.memory}`),n.push(`VM:               ${t.vmHint}`),n.join(`
`)}formatEnvironment(t){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const o=R.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),E.isWindows||n.push(`Load (avg):       ${R.loadavg().map(c=>Math.round(c)).join(", ")}`),n.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${t.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(t,n){return Promise.all([(0,m.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async o=>{let[c,u]=o,f=this.formatProcessList(t,c);return n.forEach(w=>{if((0,v.isRemoteDiagnosticError)(w))f+=`
${w.errorMessage}`,u+=`
${w.errorMessage}`;else if(f+=`

Remote: ${w.hostName}`,w.processes&&(f+=`
${this.formatProcessList(t,w.processes)}`),w.workspaceMetadata){u+=`
|  Remote: ${w.hostName}`;for(const _ of Object.keys(w.workspaceMetadata)){const N=w.workspaceMetadata[_];let A=`${N.fileCount} files`;N.maxFilesReached&&(A=`more than ${A}`),u+=`|    Folder (${_}): ${A}`,u+=this.formatWorkspaceStats(N)}}}),{processInfo:f,workspaceInfo:u}})}async getSystemInfo(t,n){const{memory:o,vmHint:c,os:u,cpus:f}=d(),w={os:u,memory:o,cpus:f,vmHint:c,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:n};return E.isWindows||(w.load=`${R.loadavg().map(_=>Math.round(_)).join(", ")}`),E.isLinux&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(t,n){const o=[];return(0,m.listProcesses)(t.mainPID).then(async c=>(o.push(""),o.push(this.formatEnvironment(t)),o.push(""),o.push(this.formatProcessList(t,c)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(t))),n.forEach(u=>{if((0,v.isRemoteDiagnosticError)(u))o.push(`
${u.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${u.hostName}`),o.push(this.formatMachineInfo(u.machineInfo)),u.processes&&o.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const f of Object.keys(u.workspaceMetadata)){const w=u.workspaceMetadata[f];let _=`${w.fileCount} files`;w.maxFilesReached&&(_=`more than ${_}`),o.push(`Folder (${f}): ${_}`),o.push(this.formatWorkspaceStats(w))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(t){const n=[];let c=0;const u=(N,A)=>{const O=` ${N}(${A})`;c+O.length>60?(n.push(f),f="|                 ",c=f.length):c+=O.length,f+=O};let f="|      File types:";const w=10,_=t.fileTypes.length>w?w:t.fileTypes.length;for(let N=0;N<_;N++){const A=t.fileTypes[N];u(A.name,A.count)}if(n.push(f),t.configFiles.length>=0&&(f="|      Conf files:",c=0,t.configFiles.forEach(N=>{u(N.name,N.count)}),n.push(f)),t.launchConfigFiles.length>0){let N="|      Launch Configs:";t.launchConfigFiles.forEach(A=>{N+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),n.push(N)}return n.join(`
`)}expandGPUFeatures(t){const n=Math.max(...Object.keys(t).map(o=>o.length));return Object.keys(t).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${t[o]}`).join(`
                  `)}formatWorkspaceMetadata(t){const n=[],o=[];return t.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(n.push(`|  Window (${c.title})`),c.folderURIs.forEach(u=>{const f=C.URI.revive(u);if(f.scheme===T.Schemas.file){const w=f.fsPath;o.push(g(w,["node_modules",".git"]).then(_=>{let N=`${_.fileCount} files`;_.maxFilesReached&&(N=`more than ${N}`),n.push(`|    Folder (${(0,I.basename)(w)}): ${N}`),n.push(this.formatWorkspaceStats(_))}).catch(_=>{n.push(`|      Error: Unable to collect workspace stats for folder ${w} (${_.toString()})`)}))}else n.push(`|    Folder (${f.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(c=>n.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(t,n){const o=new Map;t.windows.forEach(u=>o.set(u.pid,u.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(t.mainPID,o,c,n,0),c.join(`
`)}formatProcessItem(t,n,o,c,u){const f=u===0;let w;f?w=c.pid===t?`${this.productService.applicationName} main`:"remote agent":(w=`${"  ".repeat(u)} ${c.name}`,c.name==="window"&&(w=`${w} (${n.get(c.pid)})`));const _=process.platform==="win32"?c.mem:R.totalmem()*(c.mem/100);o.push(`${c.load.toFixed(0).padStart(5," ")}	${(_/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(c.children)&&c.children.forEach(N=>this.formatProcessItem(t,n,o,N,u+1))}async getWorkspaceFileExtensions(t){const n=new Set;for(const{uri:o}of t.folders){const c=C.URI.revive(o);if(c.scheme!==T.Schemas.file)continue;const u=c.fsPath;try{(await g(u,["node_modules",".git"])).fileTypes.forEach(w=>n.add(w.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(t){for(const{uri:n}of t.folders){const o=C.URI.revive(n);if(o.scheme!==T.Schemas.file)continue;const c=o.fsPath;try{const u=await g(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:f.name,count:f.count})}),u.launchConfigFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:f.name,count:f.count})}),u.configFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:f.name,count:f.count})})}catch{}}}};i=pe([K(0,P.ITelemetryService),K(1,y.IProductService)],i),e.DiagnosticsService=i}),define(ne[105],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(L){this.appenders=L}listen(L,T){throw new Error(`Event not found: ${T}`)}call(L,T,{eventName:I,data:E}){return this.appenders.forEach(C=>C.log(I,E)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class r{constructor(L){this.channel=L}log(L,T){return this.channel.call("log",{eventName:L,data:T}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=r}),define(ne[50],re([0,1,32,82,15,18,104,22]),function(Q,e,R,r,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,r.staticObservableValue)(0)}publicLog(i,s){return Promise.resolve(void 0)}publicLog2(i,s){return this.publicLog(i,s)}publicLogError(i,s){return Promise.resolve(void 0)}publicLogError2(i,s){return this.publicLogError(i,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class C{async publicLog(i,s,t){}async publicLogError(i,s,t){}}e.NullEndpointTelemetryService=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(l,i){return i.onDidChangeConfiguration(s=>{s.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(s.source),configurationKeys:p(s.sourceConfig)})})}e.configurationTelemetry=b;function S(l,i){return!(i.disableTelemetry||!l.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=S;function m(l){const i=l.getValue(I.TELEMETRY_SETTING_ID),s=l.getValue("telemetry.enableCrashReporter");if(l.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function v(l){const i={},s={},t={};P(l,t);for(let n in t){n=n.length>150?n.substr(n.length-149):n;const o=t[n];typeof o=="number"?s[n]=o:typeof o=="boolean"?s[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),i[n]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(i[n]=o)}return{properties:i,measurements:s}}e.validateTelemetryData=v;const h=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function y(l){if(!l)return"none";for(const i of h)if(l.startsWith(`${i}+`))return i;return"other"}e.cleanRemoteAuthority=y;function P(l,i,s=0,t){if(!!l)for(const n of Object.getOwnPropertyNames(l)){const o=l[n],c=t?t+n:n;Array.isArray(o)?i[c]=(0,R.safeStringify)(o):o instanceof Date?i[c]=o.toISOString():(0,D.isObject)(o)?s<2?P(o,i,s+1,c+"."):i[c]=(0,R.safeStringify)(o):i[c]=o}}function p(l){if(!l)return[];const i=[];return g(i,"",l),i}function g(l,i,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(t=>g(l,i?`${i}.${t}`:t,s[t])):l.push(i)}function a(l,i){const s=l.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(s)||t}e.isInternalTelemetry=a;function d(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.getPiiPathsFromEnvironment=d}),define(ne[220],re([0,1,48,50]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(L,T,I,E,C,b,S){const m={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${T.nameShort})`};if((0,r.supportsTelemetry)(T,I)&&(0,r.getTelemetryLevel)(E)===3){const v=await(0,R.getServiceMachineId)(I,C,b),{sessionId:h}=await S.getTelemetryInfo();m["X-Market-User-Id"]=v,m["VSCode-SessionId"]=h}return m}e.resolveMarketplaceHeaders=D}),define(ne[221],re([0,1,9,32,50]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function T(E,C,b){const S=await new Promise((P,p)=>{Q(["@microsoft/1ds-core-js"],P,p)}),m=await new Promise((P,p)=>{Q(["@microsoft/1ds-post-js"],P,p)}),v=new S.AppInsightsCore,h=new m.PostChannel,y={instrumentationKey:E,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[h]]};if(b){y.extensionConfig={};const P={alwaysUseXhrOverride:!0,httpXHROverride:b};y.extensionConfig[h.identifier]=P}return v.initialize(y,[]),v.addTelemetryInitializer(P=>{C&&(P.ext=P.ext??{},P.ext.utc=P.ext.utc??{},P.ext.utc.flags=8462029)}),v}class I{constructor(C,b,S,m,v){this._isInternalTelemetry=C,this._eventPrefix=b,this._defaultData=S,this._xhrOverride=v,this.endPointUrl=L,this._defaultData||(this._defaultData={}),typeof m=="function"?this._aiCoreOrKey=m():this._aiCoreOrKey=m,this._asyncAiCore=null}_withAIClient(C){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){C(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=T(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(b=>{C(b)},b=>{(0,R.onUnexpectedError)(b),console.error(b)})}}log(C,b){if(!this._aiCoreOrKey)return;b=(0,r.mixin)(b,this._defaultData),b=(0,D.validateTelemetryData)(b);const S=this._eventPrefix+"/"+C;try{this._withAIClient(m=>{m.pluginVersionString=b?.properties.version??"Unknown",m.track({name:S,baseData:{name:S,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(C=>{this._withAIClient(b=>{b.unload(!0,()=>{this._aiCoreOrKey=void 0,C(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(ne[106],re([0,1,2,14,8,50]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends R.Disposable{constructor(E,C,b=""){super(),this.prefix=b;const S=E.getLogger(C.telemetryLogResource);S?this.logger=this._register(S):(this.logger=this._register(E.createLogger(C.telemetryLogResource)),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(E,C){this.logger.trace(`${this.prefix}telemetry/${E}`,(0,L.validateTelemetryData)(C))}};T=pe([K(0,D.ILoggerService),K(1,r.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(ne[107],re([0,1,2,32,82,4,27,158,18,43,99,25,40,22,50]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(g,a,d){this._configurationService=a,this._productService=d,this._experimentProperties={},this.telemetryLevel=new D.MutableObservableValue(3),this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,a){this._experimentProperties[g]=a}_updateTelemetryLevel(){let g=(0,h.getTelemetryLevel)(this._configurationService);const a=this._productService.enabledTelemetryLevels;if(a){this._sendErrorTelemetry=this.sendErrorTelemetry?a.error:!1;const d=a.usage?3:a.error?2:0;g=Math.min(g,d)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,a=g.sessionID,d=g["common.machineId"],l=g["common.firstSessionDate"],i=g["common.msftInternal"];return{sessionId:a,machineId:d,firstSessionDate:l,msftInternal:i}}dispose(){this._disposables.dispose()}_log(g,a,d,l){return this.telemetryLevel.value<a?Promise.resolve(void 0):this._commonProperties.then(i=>{d=(0,r.mixin)(d,i),d=(0,r.mixin)(d,this._experimentProperties),d=(0,r.cloneAndChange)(d,s=>{if(typeof s=="string")return this._cleanupInfo(s,l)}),this._appenders.forEach(s=>s.log(g,d))},i=>{console.error(i)})}publicLog(g,a,d){return this._log(g,3,a,d)}publicLog2(g,a,d){return this.publicLog(g,a,d)}publicLogError(g,a){return this._sendErrorTelemetry?this._log(g,2,a,!0):Promise.resolve(void 0)}publicLogError2(g,a){return this.publicLogError(g,a)}_anonymizeFilePaths(g){let a=g;const d=[];for(const t of this._cleanupPatterns)for(;;){const n=t.exec(g);if(!n)break;d.push([n.index,t.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(a="";;){const t=i.exec(g);if(!t)break;!l.test(t[0])&&d.every(([n,o])=>t.index<n||t.index>=o)&&(a+=g.substring(s,t.index)+"<REDACTED: user-file-path>",s=i.lastIndex)}return s<g.length&&(a+=g.substr(s)),a}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const a=g.toLowerCase(),d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const l of d)if(l.regex.test(a))return`<REDACTED: ${l.label}>`;return g}_cleanupInfo(g,a){let d=g;a&&(d=this._anonymizeFilePaths(d));for(const l of this._cleanupPatterns)d=d.replace(l,"");return d=this._removePropertiesWithPossibleUserInfo(d),d}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=pe([K(1,E.IConfigurationService),K(2,S.IProductService)],y),e.TelemetryService=y;function P(){const p=(0,I.localize)(0,null,b.default.nameLong),g=b.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),a=L.isWeb?"":(0,I.localize)(3,null),d=(0,I.localize)(4,null),l=(0,I.localize)(5,null),i=(0,I.localize)(6,null),s=(0,I.localize)(7,null),t=`
|       | ${d} | ${l} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,I.localize)(8,null);return`
${p} ${g} ${a}

&nbsp;

${s}
${t}

&nbsp;

${n}
`}m.Registry.as(C.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:P(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(C.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,I.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,I.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[222],re([0,1,279,221]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends r.AbstractOneDataSystemAppender{constructor(T,I,E,C){const b={sendPOST:(S,m)=>{const v={method:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data)}};try{const h=R.request(S.urlString,v,y=>{y.on("data",function(P){m(y.statusCode??200,y.headers,P.toString())}),y.on("error",function(P){m(0,{})})});h.write(S.data),h.end()}catch{m(0,{})}}};super(T,I,E,C,b)}}e.OneDataSystemAppender=D}),define(ne[223],re([0,1,21,66,18,14,8,25,22,105,106,107]),function(Q,e,R,r,D,L,T,I,E,C,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(h,y,P,p,g){this.configurationService=h,this.telemetryService=y,this.loggerService=P,this.environmentService=p,this.productService=g,this.customTelemetryServices=new Map}async getCustomTelemetryService(h){if(!this.customTelemetryServices.has(h.id)){const{machineId:y,sessionId:P}=await this.telemetryService.getTelemetryInfo(),p=Object.create(null);p["common.vscodemachineid"]=y,p["common.vscodesessionid"]=P;const g=[h.id,JSON.stringify(p),h.aiKey],d=new r.Client(R.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new C.TelemetryAppenderClient(d),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${h.id}] `)];this.customTelemetryServices.set(h.id,new S.TelemetryService({appenders:l,sendErrorTelemetry:h.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(h.id)}async publicLog(h,y,P){await(await this.getCustomTelemetryService(h)).publicLog(y,P)}async publicLogError(h,y,P){await(await this.getCustomTelemetryService(h)).publicLogError(y,P)}};m=pe([K(0,D.IConfigurationService),K(1,E.ITelemetryService),K(2,T.ILoggerService),K(3,L.IEnvironmentService),K(4,I.IProductService)],m),e.CustomEndpointTelemetryService=m}),define(ne[224],re([0,1,6,24,3,2,8]),function(Q,e,R,r,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends L.Disposable{constructor(C,b){super(),this._logService=b,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=C===void 0?15e3:C}createRequest(C){return new Promise((b,S)=>{const m=++this._lastRequestId;this._pendingRequests.set(m,b),this._onCreateRequest.fire({requestId:m,...C});const v=new r.CancellationTokenSource;(0,R.timeout)(this._timeout,v.token).then(()=>S(`Request ${m} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(m,[(0,L.toDisposable)(()=>v.cancel())])})}acceptReply(C,b){const S=this._pendingRequests.get(C);S?(this._pendingRequests.delete(C),(0,L.dispose)(this._pendingRequestDisposables.get(C)||[]),this._pendingRequestDisposables.delete(C),S(b)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${C}`)}};I=pe([K(1,T.ILogService)],I),e.RequestStore=I}),define(ne[108],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var r;(function(a){a.Shell="terminal.integrated.shell.",a.ShellArgs="terminal.integrated.shellArgs.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(r=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(a){a.ShellLinux="terminal.integrated.shell.linux",a.ShellMacOs="terminal.integrated.shell.osx",a.ShellWindows="terminal.integrated.shell.windows",a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationShellLinux="terminal.integrated.automationShell.linux",a.AutomationShellMacOs="terminal.integrated.automationShell.osx",a.AutomationShellWindows="terminal.integrated.automationShell.windows",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ShellArgsLinux="terminal.integrated.shellArgs.linux",a.ShellArgsMacOs="terminal.integrated.shellArgs.osx",a.ShellArgsWindows="terminal.integrated.shellArgs.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.CustomGlyphs="terminal.integrated.customGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(a){a.FileName="ptyhost"})(L=e.TerminalLogConstants||(e.TerminalLogConstants={}));var T;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var I;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash"})(I=e.WindowsShellType||(e.WindowsShellType={}));var E;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(E=e.TitleEventSource||(e.TitleEventSource={}));var C;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.Log="log",a.Heartbeat="heartbeat"})(C=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var b;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var S;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S=e.HeartbeatConstants||(e.HeartbeatConstants={}));var m;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(m=e.TerminalLocation||(e.TerminalLocation={}));var v;(function(a){a.TerminalView="view",a.Editor="editor"})(v=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var P;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(P=e.ProfileSource||(e.ProfileSource={}));var p;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(p=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ne[225],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(ne[226],re([0,1,37,21,32,12,4,36,27,15,28]),function(Q,e,R,r,D,L,T,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function S(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let l=0;return d&&d.length===4&&(l=parseInt(d[3])),l}e.getWindowsBuildNumber=S;async function m(d,l,i,s=I.env,t=b.Promises.exists){if(L.isAbsolute(d))return await t(d)?d:void 0;if(l===void 0&&(l=I.cwd()),L.dirname(d)!=="."){const u=L.join(l,d);return await t(u)?u:void 0}const o=(0,D.getCaseInsensitive)(s,"PATH");if(i===void 0&&(0,C.isString)(o)&&(i=o.split(L.delimiter)),i===void 0||i.length===0){const u=L.join(l,d);return await t(u)?u:void 0}for(const u of i){let f;if(L.isAbsolute(u)?f=L.join(u,d):f=L.join(l,u,d),await t(f))return f;if(T.isWindows){let w=f+".com";if(await t(w)||(w=f+".exe",await t(w)))return w}}const c=L.join(l,d);return await t(c)?c:void 0}e.findExecutable=m;function v(d,l,i,s){if(!l.enabled||!d.executable||d.isFeatureTerminal||d.hideFromUser||d.ignoreShellIntegration)return;const t=d.args,n=I.platform==="win32"?L.basename(d.executable).toLowerCase():L.basename(d.executable),o=L.dirname(r.FileAccess.asFileUri("",Q).fsPath);let c;const u={VSCODE_INJECTION:"1"};if(T.isWindows){if(n==="pwsh.exe")return!t||g(t)?c=e.shellIntegrationArgs.get(h.WindowsPwsh):p(t)&&(c=e.shellIntegrationArgs.get(h.WindowsPwshLogin)),c?(c=[...c],c[c.length-1]=(0,E.format)(c[c.length-1],o,""),{newArgs:c,envMixin:u}):void 0;s.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args);return}switch(n){case"bash":return!t||t.length===0?c=e.shellIntegrationArgs.get(h.Bash):a(t)&&(u.VSCODE_SHELL_LOGIN="1",c=e.shellIntegrationArgs.get(h.Bash)),c?(c=[...c],c[c.length-1]=(0,E.format)(c[c.length-1],o),{newArgs:c,envMixin:u}):void 0;case"pwsh":return!t||g(t)?c=e.shellIntegrationArgs.get(h.Pwsh):p(t)&&(c=e.shellIntegrationArgs.get(h.PwshLogin)),c?(c=[...c],c[c.length-1]=(0,E.format)(c[c.length-1],o,""),{newArgs:c,envMixin:u}):void 0;case"zsh":{if(!t||t.length===0?c=e.shellIntegrationArgs.get(h.Zsh):a(t)?c=e.shellIntegrationArgs.get(h.ZshLogin):(t===e.shellIntegrationArgs.get(h.Zsh)||t===e.shellIntegrationArgs.get(h.ZshLogin))&&(c=t),!c)return;c=[...c],c[c.length-1]=(0,E.format)(c[c.length-1],o);const f=L.join(R.tmpdir(),`${R.userInfo().username}-vscode-zsh`);u.ZDOTDIR=f;const w=i?.ZDOTDIR??R.homedir();u.USER_ZDOTDIR=w;const _=[];return _.push({source:L.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.join(f,".zshrc")}),_.push({source:L.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.join(f,".zprofile")}),_.push({source:L.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.join(f,".zshenv")}),_.push({source:L.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.join(f,".zlogin")}),{newArgs:c,envMixin:u,filesToCopy:_}}}s.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args)}e.getShellIntegrationInjection=v;var h;(function(d){d.WindowsPwsh="windows-pwsh",d.WindowsPwshLogin="windows-pwsh-login",d.Pwsh="pwsh",d.PwshLogin="pwsh-login",d.Zsh="zsh",d.ZshLogin="zsh-login",d.Bash="bash"})(h=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(h.Zsh,["-i"]),e.shellIntegrationArgs.set(h.ZshLogin,["-il"]),e.shellIntegrationArgs.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const y=["-login","-l"],P=["-nol","-nologo"];function p(d){return typeof d=="string"?y.includes(d.toLowerCase()):d.length===1&&y.includes(d[0].toLowerCase())||d.length===2&&(y.includes(d[0].toLowerCase())||y.includes(d[1].toLowerCase()))&&(P.includes(d[0].toLowerCase())||P.includes(d[1].toLowerCase()))}function g(d){return typeof d=="string"?P.includes(d.toLowerCase()):d.length===0||d?.length===1&&P.includes(d[0].toLowerCase())}function a(d){return d==="string"&&y.includes(d.toLowerCase())||typeof d!="string"&&d.length===1&&y.includes(d[0].toLowerCase())}}),define(ne[227],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var R;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(R=e.ColorScheme||(e.ColorScheme={}));function r(L){return L===R.HIGH_CONTRAST_DARK||L===R.HIGH_CONTRAST_LIGHT}e.isHighContrast=r;function D(L){return L===R.DARK||L===R.HIGH_CONTRAST_DARK}e.isDark=D}),define(ne[109],re([0,1,51,3,2,5,40,227]),function(Q,e,R,r,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var E;(function(P){function p(g){return g&&typeof g=="object"&&typeof g.id=="string"}P.isThemeColor=p})(E=e.ThemeColor||(e.ThemeColor={}));function C(P){return{id:P}}e.themeColorFromId=C;var b;(function(P){function p(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||E.isThemeColor(n.color))}P.isThemeIcon=p;const g=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function a(n){const o=g.exec(n);if(!o)return;const[,c]=o;return{id:c}}P.fromString=a;function d(n){return{id:n}}P.fromId=d;function l(n,o){let c=n.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),o&&(c=`${c}~${o}`),{id:c}}P.modify=l;function i(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}P.getModifier=i;function s(n,o){return n.id===o.id&&n.color?.id===o.color?.id}P.isEqual=s;function t(n,o){return{id:n.id,color:o?C(o):void 0}}P.asThemeIcon=t,P.asClassNameArray=R.CSSIcon.asClassNameArray,P.asClassName=R.CSSIcon.asClassName,P.asCSSSelector=R.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function S(P){switch(P){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new r.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,D.toDisposable)(()=>{const g=this.themingParticipants.indexOf(p);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const v=new m;T.Registry.add(e.Extensions.ThemingContribution,v);function h(P){return v.onColorThemeChange(P)}e.registerThemingParticipant=h;class y extends D.Disposable{constructor(p){super(),this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,g){let a=this.theme.getColor(p);return a&&g&&(a=g(a,this.theme)),a?a.toString():null}}e.Themable=y}),define(ne[228],re([0,1,51,7,160,109]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(m,v){const h=[{name:null,description:(0,D.localize)(0,null)}];return h.push(...m.map(y=>({name:y.profileName,description:I(y)}))),v&&h.push(...v.map(y=>({name:y.title,description:E(y)}))),{values:h.map(y=>y.name),markdownDescriptions:h.map(y=>y.description)}}e.createProfileSchemaEnums=T;function I(m){let v=`$(${L.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:R.Codicon.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?v+=`
- args: "${m.args}"`:v+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(v+=`
- overrideName: ${m.overrideName}`),m.color&&(v+=`
- color: ${m.color}`),m.env&&(v+=`
- env: ${JSON.stringify(m.env)}`),v}function E(m){return`$(${L.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:R.Codicon.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function C(m,v){if(!m&&!v)return!0;if(typeof m=="string"&&typeof v=="string")return m===v;if(Array.isArray(m)&&Array.isArray(v)){if(m.length!==v.length)return!1;for(let h=0;h<m.length;h++)if(m[h]!==v[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=C;function b(m,v){if(!m&&!v)return!0;if(!m||!v)return!1;if(L.ThemeIcon.isThemeIcon(m)&&L.ThemeIcon.isThemeIcon(v))return m.id===v.id&&m.color===v.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof v=="object"&&"light"in v&&"dark"in v){const h=m,y=v;if((r.URI.isUri(h.light)||S(h.light))&&(r.URI.isUri(h.dark)||S(h.dark))&&(r.URI.isUri(y.light)||S(y.light))&&(r.URI.isUri(y.dark)||S(y.dark)))return h.light.path===y.light.path&&h.dark.path===y.dark.path}if(r.URI.isUri(m)&&r.URI.isUri(v)||S(m)||S(v)){const h=m,y=v;return h.path===y.path&&h.scheme===y.scheme}return!1}e.terminalIconsEqual=b;function S(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}e.isUriComponents=S}),define(ne[229],re([0,1,51,159,43,40,228]),function(Q,e,R,r,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(R.Codicon.getAll(),d=>d.id),markdownEnumDescriptions:Array.from(R.Codicon.getAll(),d=>`$(${d.id})`)};const I={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.terminalIconSchema},color:{description:(0,r.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...I}},C={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...I}},b=(0,r.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),S=(0,r.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=(0,r.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),v=(0,r.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,r.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),y=(0,r.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),P={id:"terminal",order:100,title:(0,r.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:S},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,r.localize)(26,null)}},{type:"string",markdownDescription:(0,r.localize)(27,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(29,null),enum:["PowerShell","Git Bash"]},...I}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(30,null),type:"string"},id:{description:(0,r.localize)(31,null),type:"string"},title:{description:(0,r.localize)(32,null),type:"string"},...I}},{type:"null"},E]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(34,null),type:"string"},id:{description:(0,r.localize)(35,null),type:"string"},title:{description:(0,r.localize)(36,null),type:"string"},...I}},{type:"null"},E]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(38,null),type:"string"},id:{description:(0,r.localize)(39,null),type:"string"},title:{description:(0,r.localize)(40,null),type:"string"},...I}},{type:"null"},E]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,r.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function p(){L.Registry.as(D.Extensions.Configuration).registerConfiguration(P),a()}e.registerTerminalPlatformConfiguration=p;let g;function a(d,l){const i=L.Registry.as(D.Extensions.Configuration);let s;d&&(s=(0,T.createProfileSchemaEnums)(d?.profiles,l));const t=g;g={id:"terminal",order:100,title:(0,r.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:d?.os===3?s?.values:void 0,markdownEnumDescriptions:d?.os===3?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:d?.os===2?s?.values:void 0,markdownEnumDescriptions:d?.os===2?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:d?.os===1?s?.values:void 0,markdownEnumDescriptions:d?.os===1?s?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[g],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=a}),define(ne[230],re([0,1,54,51,12,4,28,86,226,109]),function(Q,e,R,r,D,L,T,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let b,S=!0;function m(s,t,n,o,c=process.env,u,f,w,_){return u=u||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},L.isWindows?v(n,u,c,f,o.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:o.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:o.getValue("terminal.integrated.defaultProfile.windows"),_,w):d(u,f,n,s&&typeof s=="object"?{...s}:o.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:o.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),_,w,c)}e.detectAvailableProfiles=m;async function v(s,t,n,o,c,u,f,w,_){const N=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),A=`${process.env.windir}\\${N?"Sysnative":"System32"}`;let O=!1;(0,E.getWindowsBuildNumber)()>=16299&&(O=!0),await P(w);const k=new Map;s&&(k.set("PowerShell",{source:"PowerShell",icon:r.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Windows PowerShell",{path:`${A}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:r.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),k.set("Command Prompt",{path:`${A}\\cmd.exe`,icon:r.Codicon.terminalCmd,isAutoDetected:!0})),l(u,k);const M=await h(k.entries(),f,t,n,o,_);if(s||c)try{const $=await g(`${A}\\${O?"wsl":"bash"}.exe`,f);for(const W of $)(!u||!(W.profileName in u))&&M.push(W)}catch{S&&(o?.info("WSL is not installed, so could not detect WSL profiles"),S=!1)}return M}async function h(s,t,n,o=process.env,c,u){const f=[];for(const[w,_]of s){if(_===null)continue;let N,A,O;if("source"in _){const $=b?.get(_.source);if(!$)continue;N=$.paths,A=_.args||$.args,_.icon?O=y(_.icon):$.icon&&(O=$.icon)}else N=Array.isArray(_.path)?_.path:[_.path],A=L.isWindows||Array.isArray(_.args)?_.args:void 0,O=y(_.icon);const k=await u?.(N)||N.slice(),M=await i(w,t,k,n,o,A,_.env,_.overrideName,_.isAutoDetected,c);M?(M.isAutoDetected=_.isAutoDetected,M.icon=O,M.color=_.color,f.push(M)):c?.debug("Terminal profile not validated",w,N)}return c?.debug("Validated terminal profiles",f),f}function y(s){return typeof s=="string"?{id:s}:s}async function P(s){b&&!s||(b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),b.set("PowerShell",{profileName:"PowerShell",paths:s||await p(),icon:C.ThemeIcon.asThemeIcon(r.Codicon.terminalPowershell)}))}async function p(){const s=[];for await(const t of(0,I.enumeratePowerShellInstallations)())s.push(t.exePath);return s}async function g(s,t){const n=[],o=await new Promise((f,w)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(_,N)=>{if(_)return w("Problem occurred when getting wsl distros");f(N)})});if(!o)return[];const c=new RegExp(/[\r?\n]/),u=o.split(c).filter(f=>f.trim().length>0&&f!=="");for(const f of u){if(f===""||f.startsWith("docker-desktop"))continue;const w=`${f} (WSL)`,_={profileName:w,path:s,args:["-d",`${f}`],isDefault:w===t,icon:a(f),isAutoDetected:!1};n.push(_)}return n}function a(s){return s.includes("Ubuntu")?C.ThemeIcon.asThemeIcon(r.Codicon.terminalUbuntu):s.includes("Debian")?C.ThemeIcon.asThemeIcon(r.Codicon.terminalDebian):C.ThemeIcon.asThemeIcon(r.Codicon.terminalLinux)}async function d(s,t,n,o,c,u,f,w){const _=new Map;if(n){const N=(await s.readFile("/etc/shells")).toString(),A=u||N.split(`
`).filter(k=>k.trim().indexOf("#")!==0&&k.trim().length>0),O=new Map;for(const k of A){let M=(0,D.basename)(k),$=O.get(M)||0;$++,$>1&&(M=`${M} (${$})`),O.set(M,$),_.set(M,{path:k,isAutoDetected:!0})}}return l(o,_),await h(_.entries(),c,s,w,t,f)}function l(s,t){if(!!s)for(const[n,o]of Object.entries(s))o===null||!("path"in o)&&!("source"in o)?t.delete(n):(o.icon=o.icon||t.get(n)?.icon,t.set(n,o))}async function i(s,t,n,o,c,u,f,w,_,N){if(n.length===0)return Promise.resolve(void 0);const A=n.shift();if(A==="")return i(s,t,n,o,c,u,f,w,_);const O={profileName:s,path:A,args:u,env:f,overrideName:w,isAutoDetected:_,isDefault:s===t};if((0,D.basename)(A)===A){const M=c.PATH?c.PATH.split(D.delimiter):void 0,$=await(0,E.findExecutable)(A,void 0,M,void 0,o.existsFile);return $?(O.path=$,O.isFromPath=!0,O):i(s,t,n,o,c,u)}return await o.existsFile((0,D.normalize)(A))?O:i(s,t,n,o,c,u,f,w,_)}}),define(ne[231],re([0,1,3,2,21,4,39,66,18,14,90,217,8,98,224,108,229,230]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(l){l[l.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let a=0,d=class extends r.Disposable{constructor(i,s,t,n){super(),this._reconnectConstants=i,this._configurationService=s,this._environmentService=t,this._logService=n,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,(0,P.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,r.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,S.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(i){return this._logService.error("ptyHost was unable to resolve shell environment",i),{}}}_startPtyHost(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:a,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},s=(0,b.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);s&&(s.break&&s.port?i.debugBrk=s.port:!s.break&&s.port&&(i.debug=s.port));const t=new I.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,i);this._onPtyHostStart.fire(),T.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(u=>{this._onPtyHostExit.fire(u.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}, giving up`))}));const o=t.getChannel(y.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const c=T.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.PtyHost));return this._register(c.onProcessData(u=>this._onProcessData.fire(u))),this._register(c.onProcessReady(u=>this._onProcessReady.fire(u))),this._register(c.onProcessExit(u=>this._onProcessExit.fire(u))),this._register(c.onDidChangeProperty(u=>this._onDidChangeProperty.fire(u))),this._register(c.onProcessReplay(u=>this._onProcessReplay.fire(u))),this._register(c.onProcessOrphanQuestion(u=>this._onProcessOrphanQuestion.fire(u))),this._register(c.onDidRequestDetach(u=>this._onDidRequestDetach.fire(u))),[t,c]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(i,s,t,n,o,c,u,f,w,_,N){const A=setTimeout(()=>this._handleUnresponsiveCreateProcess(),y.HeartbeatConstants.CreateProcessTimeout),O=await this._proxy.createProcess(i,s,t,n,o,c,u,f,w,_,N);return clearTimeout(A),a=Math.max(a,O),O}updateTitle(i,s,t){return this._proxy.updateTitle(i,s,t)}updateIcon(i,s,t,n){return this._proxy.updateIcon(i,s,t,n)}attachToProcess(i){return this._proxy.attachToProcess(i)}detachFromProcess(i,s){return this._proxy.detachFromProcess(i,s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(i){return this._proxy.start(i)}shutdown(i,s){return this._proxy.shutdown(i,s)}input(i,s){return this._proxy.input(i,s)}processBinary(i,s){return this._proxy.processBinary(i,s)}resize(i,s,t){return this._proxy.resize(i,s,t)}acknowledgeDataEvent(i,s){return this._proxy.acknowledgeDataEvent(i,s)}setUnicodeVersion(i,s){return this._proxy.setUnicodeVersion(i,s)}getInitialCwd(i){return this._proxy.getInitialCwd(i)}getCwd(i){return this._proxy.getCwd(i)}getLatency(i){return this._proxy.getLatency(i)}orphanQuestionReply(i){return this._proxy.orphanQuestionReply(i)}installAutoReply(i,s){return this._proxy.installAutoReply(i,s)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(i){return this._proxy.uninstallAutoReply(i)}getDefaultSystemShell(i){return this._proxy.getDefaultSystemShell(i)}async getProfiles(i,s,t,n=!1){const o=await this._shellEnv;return(0,p.detectAvailableProfiles)(s,t,n,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,i))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(i){return this._proxy.getWslPath(i)}getRevivedPtyNewId(i){return this._proxy.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this._proxy.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this._proxy.getTerminalLayoutInfo(i)}async requestDetachInstance(i,s){return this._proxy.requestDetachInstance(i,s)}async acceptDetachInstanceReply(i,s){return this._proxy.acceptDetachInstanceReply(i,s)}async serializeTerminalState(i){return this._proxy.serializeTerminalState(i)}async reviveTerminalProcesses(i,s){return this._proxy.reviveTerminalProcesses(i,s)}async refreshProperty(i,s){return this._proxy.refreshProperty(i,s)}async updateProperty(i,s,t){return this._proxy.updateProperty(i,s,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(i,s){return this._resolveVariablesRequestStore.createRequest({workspaceId:i,originalText:s})}async acceptPtyHostResolvedVariables(i,s){this._resolveVariablesRequestStore.acceptReply(i,s)}};d=pe([K(1,E.IConfigurationService),K(2,C.IEnvironmentService),K(3,m.ILogService)],d),e.PtyHostService=d}),define(ne[72],re([0,1,3,4,5,8]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var T;(function(y){y.Http="http",y.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const P=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!P)return{address:P[1],port:+P[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=S;function m(y,P){return P?P!==1&&y<1024:!r.isWindows&&y<1024}e.isPortPrivileged=m;class v{constructor(P,p,g){this.remoteAddress=P,this.localAddress=p,this._dispose=g,this._onDispose=new R.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=v;let h=class{constructor(P){this.logService=P,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(P){return this._tunnelProvider=P,P?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(P){this._canElevate=P.elevation,this._privacyOptions=P.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const P=[],p=Array.from(this._tunnels.values());for(const g of p){const a=Array.from(g.values());for(const d of a){const l=await d.value;l&&P.push(l)}}return P}async dispose(){for(const P of this._tunnels.values()){for(const{value:p}of P.values())await p.then(g=>g?.dispose());P.clear()}this._tunnels.clear()}openTunnel(P,p,g,a,d=!1,l,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${g} on local port ${a}.`),!P)return;if(p||(p="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.retainOrCreateTunnel(P,p,g,a,d,l,i);return s?s.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(t);return(t.tunnelRemoteHost!==p||t.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(P){return{tunnelRemotePort:P.tunnelRemotePort,tunnelRemoteHost:P.tunnelRemoteHost,tunnelLocalPort:P.tunnelLocalPort,localAddress:P.localAddress,privacy:P.privacy,protocol:P.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${P.tunnelRemoteHost}:${P.tunnelRemotePort} `);const p=this._tunnels.get(P.tunnelRemoteHost);if(p){const g=p.get(P.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(P.tunnelRemoteHost,P.tunnelRemotePort,g))}}}}async tryDisposeTunnel(P,p,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${P}:${p}.`);const a=g.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(P)&&this._tunnels.get(P).delete(p),a}}async closeTunnel(P,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${P}:${p} `);const g=this._tunnels.get(P);if(g&&g.has(p)){const a=g.get(p);a.refcount=0,await this.tryDisposeTunnel(P,p,a)}}addTunnelToMap(P,p,g){this._tunnels.has(P)||this._tunnels.set(P,new Map),this._tunnels.get(P).set(p,{refcount:1,value:g})}async removeEmptyTunnelFromMap(P,p){const g=this._tunnels.get(P);g&&(await g.get(p)||g.delete(p),g.size===0&&this._tunnels.delete(P))}getTunnelFromMap(P,p){const g=[P];b(P)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):S(P)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const a=g.map(d=>this._tunnels.get(d));for(const d of a){const l=d?.get(p);if(l)return l}}canTunnel(P){return!!C(P)}createWithProvider(P,p,g,a,d,l,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${g} on local port ${a}.`);const s=g;this._factoryInProgress.add(s);const n={elevationRequired:d?m(a===void 0?g:a):!1},o={remoteAddress:{host:p,port:g},localAddressPort:a,privacy:l,public:l?l!==I.Private:void 0,protocol:i},c=P.forwardPort(o,n);return c?(this.addTunnelToMap(p,g,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),c}};h=pe([K(0,L.ILogService)],h),e.AbstractTunnelService=h}),define(ne[232],re([0,1,8,72,2,9,6]),function(Q,e,R,r,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class I extends D.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(b){this._address=b,this._addressPromise&&(this._addressPromise.complete(b),this._addressPromise=null)}setTunnel(b){this._register(b)}}let E=class Pt extends D.Disposable{constructor(b,S){super(),this._tunnelService=b,this._logService=S,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(b=>b.dispose())}async createTunnel(){return{id:String(++Pt._lastId)}}async startTunnel(b,S,m,v,h,y){const P=new I,p=await Promise.resolve(this._tunnelService.openTunnel(b,P,m,v,h,y));if(!p)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${v} (remote).`),P.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(S))throw this._disposedTunnels.delete(S),P.dispose(),await p.dispose(),(0,L.canceled)();return P.setTunnel(p),this._tunnels.set(S,P),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${S}: ${p.localAddress} (local) to ${m}:${v} (remote).`),{tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress}}async setAddress(b,S){const m=this._tunnels.get(b);!m||m.setAddress(S)}async destroyTunnel(b){const S=this._tunnels.get(b);if(S){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${b}.`),this._tunnels.delete(b),await S.dispose();return}this._disposedTunnels.add(b)}};E._lastId=0,E=pe([K(0,r.ISharedTunnelsService),K(1,R.ILogService)],E),e.SharedProcessTunnelService=E}),define(ne[233],re([0,1,80,119,208,6,2,18,8,25,206,72,103]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(g,a,d,l,i){let s;for(let t=3;t&&(s?.dispose(),s=await new h(g,a,d,l,i).waitForReady(),!(i&&r.BROWSER_RESTRICTED_PORTS[i]||!r.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));t--);return s}class h extends T.Disposable{constructor(a,d,l,i,s){super(),this.defaultTunnelHost=d,this.suggestedLocalPort=s,this.privacy=S.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=a,this._server=R.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=t=>this._onConnection(t),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(d=>{d()})}async waitForReady(){let a=await(0,r.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),d=null;return this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),d=this._server.address(),d||(a=0,this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),d=this._server.address()),this.tunnelLocalPort=d.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${d.port}`,this}async _onConnection(a){a.pause();const d=(0,S.isLocalhost)(this.tunnelRemoteHost)||(0,S.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,b.connectRemoteAgentTunnel)(this._options,d,this.tunnelRemotePort),i=l.getSocket().socket,s=l.readEntireBuffer();l.dispose(),s.byteLength>0&&a.write(s.buffer),a.on("end",()=>{a.localAddress&&this._socketsDispose.delete(a.localAddress),i.end()}),a.on("close",()=>i.end()),a.on("error",()=>{a.localAddress&&this._socketsDispose.delete(a.localAddress),i.destroy()}),i.on("end",()=>a.end()),i.on("close",()=>a.end()),i.on("error",()=>{a.destroy()}),a.pipe(i),i.pipe(a),a.localAddress&&this._socketsDispose.set(a.localAddress,()=>{a.end(),i.end()})}}let y=class extends S.AbstractTunnelService{constructor(a,d,l,i,s){super(d),this.socketFactory=a,this.signService=l,this.productService=i,this.configurationService=s}get defaultTunnelHost(){const a=this.configurationService.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(a,d,l,i,s,t,n){const o=this.getTunnelFromMap(d,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,d,l,i,s,t,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${i}.`);const c={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:a,signService:this.signService,logService:this.logService,ipcLogger:null},u=v(c,this.defaultTunnelHost,d,l,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(d,l,u),u}}};y=pe([K(1,E.ILogService),K(2,m.ISignService),K(3,C.IProductService),K(4,I.IConfigurationService)],y),e.BaseTunnelService=y;let P=class extends y{constructor(a,d,l,i){super(D.nodeSocketFactory,a,d,l,i)}};P=pe([K(0,E.ILogService),K(1,m.ISignService),K(2,C.IProductService),K(3,I.IConfigurationService)],P),e.TunnelService=P;let p=class extends T.Disposable{constructor(a,d,l,i){super(),this.logService=a,this.productService=d,this.signService=l,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(a,d,l,i,s,t,n,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${i} on local port ${s}.`),!this._tunnelServices.has(a)){const c=new P(this.logService,this.signService,this.productService,this.configurationService);this._register(c),this._tunnelServices.set(a,c),c.onTunnelClosed(async()=>{(await c.tunnels).length===0&&(c.dispose(),this._tunnelServices.delete(a))})}return this._tunnelServices.get(a).openTunnel(d,l,i,s,t,n,o)}};p=pe([K(0,E.ILogService),K(1,C.IProductService),K(2,m.ISignService),K(3,I.IConfigurationService)],p),e.SharedTunnelsService=p}),define(ne[31],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(ne[234],re([0,1,3,2,7,14,33,13,8,31]),function(Q,e,R,r,D,L,T,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let b=class extends r.Disposable{constructor(m,v,h,y,P){super(),this.extensionsManagementService=m,this.logService=y,this.uriIdentityService=P,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(a=>a.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(g=>this.onInstallExtension(g))),this._register(m.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(m.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const p=D.URI.file(h.extensionsPath);this._register(v.watch(p)),this._register(R.Event.filter(v.onDidFilesChange,g=>g.rawChanges.some(a=>this.doesChangeAffects(a,p)))(()=>this.onDidChange()))}doesChangeAffects(m,v){return m.type!==1&&m.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(m.resource),v)?!1:this.uriIdentityService.extUri.isEqual(m.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(m.resource).startsWith(".")}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const v of m)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(v=>!(0,T.areSameExtensions)(v,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,T.areSameExtensions)(v,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(),v=m.filter(y=>[...this.installingExtensions,...this.installedExtensions].some(P=>(0,T.areSameExtensions)(P,y.identifier))?!1:y.installedTimestamp&&y.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",y.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",y.identifier.id),!1)),h=this.installedExtensions.filter(y=>this.installingExtensions.some(P=>(0,T.areSameExtensions)(P,y))?!1:m.every(P=>!(0,T.areSameExtensions)(P.identifier,y))?(this.logService.info("Detected extension removed from another source",y.id),!0):!1);this.installedExtensions=m.map(y=>y.identifier),(v.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:h})}}};b=pe([K(1,I.IFileService),K(2,L.INativeEnvironmentService),K(3,E.ILogService),K(4,C.IUriIdentityService)],b),e.ExtensionsWatcher=b}),define(ne[235],re([0,1,31,91,13,17,117,3,2]),function(Q,e,R,r,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class C{constructor(m){this.uri=m,this.time=C._clock++}touch(){return this.time=C._clock++,this}}C._clock=0;let b=class{constructor(m){this._fileService=m,this._dispooables=new E.DisposableStore,this._limit=2**16;const v=new Map,h=y=>{let P=v.get(y.scheme);return P===void 0&&(P=m.hasProvider(y)&&!this._fileService.hasCapability(y,1024),v.set(y.scheme,P)),P};this._dispooables.add(I.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(y=>{v.delete(y.scheme)})),this.extUri=new L.ExtUri(h),this._canonicalUris=new T.SkipList((y,P)=>this.extUri.compare(y,P,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,L.normalizePath)(m));const v=this._canonicalUris.get(m);return v?v.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new C(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((h,y)=>h[1].touch<y[1].touch?1:h[1].touch>y[1].touch?-1:0);C._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let h=0;h<v;h++)this._canonicalUris.set(m[h][0],m[h][1].touch())}};b=pe([K(0,D.IFileService)],b),e.UriIdentityService=b,(0,r.registerSingleton)(R.IUriIdentityService,b,!0)}),define(ne[236],re([0,1,3,2,13,42,34,16]),function(Q,e,R,r,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class E extends r.Disposable{constructor(b,S,m,v){super(),this.fileSystemScheme=b,this.fileSystemProvider=S,this.userDataScheme=m,this.logService=v,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(h=>this.handleFileChanges(h)))}get capabilities(){return this.fileSystemProvider.capabilities&-5}watch(b,S){this.watchResources.set(b,b);const m=this.fileSystemProvider.watch(this.toFileSystemResource(b),S);return(0,r.toDisposable)(()=>{this.watchResources.delete(b),m.dispose()})}stat(b){return this.fileSystemProvider.stat(this.toFileSystemResource(b))}mkdir(b){return this.fileSystemProvider.mkdir(this.toFileSystemResource(b))}rename(b,S,m){return this.fileSystemProvider.rename(this.toFileSystemResource(b),this.toFileSystemResource(S),m)}readFile(b){return this.fileSystemProvider.readFile(this.toFileSystemResource(b),{atomic:!0})}readFileStream(b,S,m){const v=(0,L.newWriteableStream)(h=>I.VSBuffer.concat(h.map(y=>I.VSBuffer.wrap(y))).buffer);return(async()=>{try{const h=await this.readFile(b);v.end(h)}catch(h){v.error(h),v.end()}})(),v}readdir(b){return this.fileSystemProvider.readdir(this.toFileSystemResource(b))}writeFile(b,S,m){return this.fileSystemProvider.writeFile(this.toFileSystemResource(b),S,m)}delete(b,S){return this.fileSystemProvider.delete(this.toFileSystemResource(b),S)}copy(b,S,m){if((0,D.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(b),this.toFileSystemResource(S),m);throw new Error("copy not supported")}handleFileChanges(b){const S=[];for(const m of b){if(m.resource.scheme!==this.fileSystemScheme)continue;const v=this.toUserDataResource(m.resource);this.watchResources.findSubstr(v)&&S.push({resource:v,type:m.type})}S.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(S))}toFileSystemResource(b){return b.with({scheme:this.fileSystemScheme})}toUserDataResource(b){return b.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=E}),define(ne[61],re([0,1,79]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function r(T,I,E,C){const b=(0,R.setProperty)(T,I,E,C)[0];return b&&(T=T.substring(0,b.offset)+b.content+T.substring(b.offset+b.length)),T}e.edit=r;function D(T,I,E){let C=E;for(;C>=0;){if(T.charAt(C)===I.charAt(I.length-1)&&I.length===1)return C+1;if(C--,I.length===2&&C>=0&&T.charAt(C)===I.charAt(0))return C+2}return 0}e.getLineStartOffset=D;function L(T,I,E){let C=E;for(;C>=0;)if(T.charAt(C)===I.charAt(I.length-1)&&I.length===1||(C++,I.length===2&&C>=0&&T.charAt(C)===I.charAt(1)))return C;return T.length-1}e.getLineEndOffset=L}),define(ne[237],re([0,1,32,55,15]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(m,v,h,y,P){const p=[],g=[],a=[];if(!v){const A=m.filter(({identifier:O})=>P.every(k=>k.toLowerCase()!==O.id.toLowerCase()));return{local:{added:p,removed:g,updated:a},remote:A.length>0?{added:A,updated:[],removed:[],all:A}:null}}m=m.map(b),v=v.map(b),h=h?h.map(b):null;const d=new Map,l=A=>{A.uuid&&d.set(A.id.toLowerCase(),A.uuid)};m.forEach(({identifier:A})=>l(A)),v.forEach(({identifier:A})=>l(A)),h?.forEach(({identifier:A})=>l(A));const i=A=>{const O=A.identifier.uuid||d.get(A.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${A.identifier.id.toLowerCase()}`},s=(A,O)=>(A.set(i(O),O),A),t=m.reduce(s,new Map),n=v.reduce(s,new Map),o=v.reduce((A,O)=>{const k=i(O);O=(0,R.deepClone)(O);const M=t.get(k);return M&&(M.installed&&(O.installed=!0),O.version||(O.version=M.version)),s(A,O)},new Map),c=h?h.reduce(s,new Map):null,u=y.reduce(s,new Map),f=P.reduce((A,O)=>{const k=d.get(O.toLowerCase());return A.add(k?`uuid:${k}`:`id:${O.toLowerCase()}`)},new Set),w=T(t,n,f);if(w.added.size>0||w.removed.size>0||w.updated.size>0){const A=T(c,t,f),O=T(c,n,f),k=(M,$)=>{const W=t.get(M);if(W){const J=n.get(M),H=$?J:W;return{...H,version:J.version&&(!W.installed||r.gt(J.version,W.version))?J.version:W.version,state:I(W,J,c?.get(M)),preRelease:(0,D.isUndefined)(H.preRelease)?W.preRelease:W.installed?H.preRelease:J.preRelease}}};for(const M of O.removed.values()){const $=t.get(M);$&&g.push($.identifier)}for(const M of O.added.values())if(A.added.has(M)){if(w.updated.has(M)){const $=k(M,!0);$&&(a.push(S($,M)),o.set(M,$))}}else{const $=n.get(M);$.installed&&p.push(S($,M))}for(const M of O.updated.values()){const $=k(M,!0);$&&(a.push(S($,M)),o.set(M,$))}for(const M of A.added.values())O.added.has(M)||o.set(M,t.get(M));for(const M of A.updated.values())if(!O.removed.has(M)&&!O.updated.has(M)){const $=k(M,!1);$&&(o.get(M)?.installed&&($.installed=!0),o.set(M,$))}for(const M of A.removed.values())!u.has(M)&&!O.updated.has(M)&&c?.get(M)?.installed&&o.delete(M)}const _=[],N=T(n,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(N.added.size>0||N.updated.size>0||N.removed.size>0)&&o.forEach((A,O)=>_.push(S(A,O))),{local:{added:p,removed:g,updated:a},remote:_.length?{added:[...N.added].map(A=>o.get(A)),updated:[...N.updated].map(A=>o.get(A)),removed:[...N.removed].map(A=>n.get(A)),all:_}:null}}e.merge=L;function T(m,v,h,{checkInstalledProperty:y,checkVersionProperty:P}={checkInstalledProperty:!1,checkVersionProperty:!1}){const p=m?[...m.keys()].filter(i=>!h.has(i)):[],g=[...v.keys()].filter(i=>!h.has(i)),a=g.filter(i=>p.indexOf(i)===-1).reduce((i,s)=>(i.add(s),i),new Set),d=p.filter(i=>g.indexOf(i)===-1).reduce((i,s)=>(i.add(s),i),new Set),l=new Set;for(const i of p){if(d.has(i))continue;const s=m.get(i),t=v.get(i);(!t||s.disabled!==t.disabled||s.installed&&t.installed&&s.preRelease!==t.preRelease||!C(s.state,t.state)||P&&s.version!==t.version||y&&s.installed!==t.installed)&&l.add(i)}return{added:a,removed:d,updated:l}}function I(m,v,h){const y=m.state,P=v.state,p=h?.state;if(!v.version||y&&r.gt(m.version,v.version))return y;if(P&&r.gt(v.version,m.version)||!y)return P;if(!P)return y;const g=(0,R.deepClone)(y),a=p?E(p,P):{added:Object.keys(P).reduce((l,i)=>(l.add(i),l),new Set),removed:new Set,updated:new Set},d=p?E(p,y):{added:Object.keys(y).reduce((l,i)=>(l.add(i),l),new Set),removed:new Set,updated:new Set};for(const l of[...a.added.values(),...a.updated.values()])g[l]=P[l];for(const l of a.removed.values())d.updated.has(l)||delete g[l];return g}function E(m,v){const h=Object.keys(m),y=Object.keys(v),P=y.filter(a=>h.indexOf(a)===-1).reduce((a,d)=>(a.add(d),a),new Set),p=h.filter(a=>y.indexOf(a)===-1).reduce((a,d)=>(a.add(d),a),new Set),g=new Set;for(const a of h){if(p.has(a))continue;const d=m[a],l=v[a];(0,R.equals)(d,l)||g.add(a)}return{added:P,removed:p,updated:g}}function C(m={},v={}){const{added:h,removed:y,updated:P}=E(m,v);return h.size===0&&y.size===0&&P.size===0}function b(m){return{...m,disabled:!!m.disabled,installed:!!m.installed}}function S(m,v){const h={identifier:{id:m.identifier.id,uuid:v.startsWith("uuid:")?v.substring(5):void 0},preRelease:!!m.preRelease};return m.version&&(h.version=m.version),m.disabled&&(h.disabled=!0),m.installed&&(h.installed=!0),m.state&&(h.state=m.state),h}}),define(ne[110],re([0,1,19,18,5]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(I){this.configurationService=I}hasToNeverSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,E){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(b=>b.toLowerCase());return C=C.filter(b=>b!==I&&b!==`-${I}`),E&&C.push(I.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,2)}updateSynchronizedExtensions(I,E){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(b=>b.toLowerCase());return C=C.filter(b=>b!==I&&b!==`-${I}`),E&&C.push(`-${I.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,2)}getIgnoredExtensions(I){const E=I.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),C=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),b=[],S=[];if(Array.isArray(C))for(const m of C)m.startsWith("-")?S.push(m.substring(1)):b.push(m);return(0,R.distinct)([...E,...b].filter(m=>S.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let I=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.configurationService.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(E=>E.toLowerCase())}};L=pe([K(0,r.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(ne[238],re([0,1,19,35,32,178,61]),function(Q,e,R,r,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function I(d){return(0,r.parse)(d)||[]}e.parseKeybindings=I;async function E(d,l,i,s,t){const n=I(d),o=I(l),c=i?I(i):null,u=[...n,...o,...c||[]].map(J=>J.key),f=await t.resolveUserBindings(u),w=b(n,o,c,f);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const _=m(n),N=m(o),A=c?m(c):null,O=h(_,N,f),k=A?h(A,_,f):{added:[..._.keys()].reduce((J,H)=>(J.add(H),J),new Set),removed:new Set,updated:new Set},M=A?h(A,N,f):{added:[...N.keys()].reduce((J,H)=>(J.add(H),J),new Set),removed:new Set,updated:new Set},$=C(O,k,M);let W=d;for(const J of $.removed.values())$.conflicts.has(J)||(W=g(W,J,s));for(const J of $.added.values()){if($.conflicts.has(J))continue;const H=N.get(J);if(H.some(G=>G.command!==`-${J}`&&w.conflicts.has(f[G.key]))){$.conflicts.add(J);continue}W=p(W,H,s)}for(const J of $.updated.values()){if($.conflicts.has(J))continue;const H=N.get(J);if(H.some(G=>G.command!==`-${J}`&&w.conflicts.has(f[G.key]))){$.conflicts.add(J);continue}W=a(W,J,H,s)}return{mergeContent:W,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=E;function C(d,l,i){const s=new Set,t=new Set,n=new Set,o=new Set;for(const c of l.removed.values())i.updated.has(c)&&o.add(c);for(const c of i.removed.values())o.has(c)||(l.updated.has(c)?o.add(c):t.add(c));for(const c of l.added.values())o.has(c)||i.added.has(c)&&d.updated.has(c)&&o.add(c);for(const c of i.added.values())o.has(c)||(l.added.has(c)?d.updated.has(c)&&o.add(c):s.add(c));for(const c of l.updated.values())o.has(c)||i.updated.has(c)&&d.updated.has(c)&&o.add(c);for(const c of i.updated.values())o.has(c)||(l.updated.has(c)?d.updated.has(c)&&o.add(c):n.add(c));return{added:s,removed:t,updated:n,conflicts:o}}function b(d,l,i,s){const t=new Set,n=S(d,s),o=S(l,s),c=i?S(i,s):null,u=v(n,o);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const f=c?v(c,n):{added:[...n.keys()].reduce((k,M)=>(k.add(M),k),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const w=c?v(c,o):{added:[...o.keys()].reduce((k,M)=>(k.add(M),k),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:_,removed:N,updated:A,conflicts:O}=C(u,f,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:_,removed:N,updated:A,conflicts:O}}function S(d,l){const i=new Map;for(const s of d){const t=l[s.key];let n=i.get(t);n||(n=[],i.set(t,n)),n.push(s)}return i}function m(d){const l=new Map;for(const i of d){const s=i.command[0]==="-"?i.command.substring(1):i.command;let t=l.get(s);t||(t=[],l.set(s,t)),t.push(i)}return l}function v(d,l){const i=[...d.keys()],s=[...l.keys()],t=s.filter(c=>i.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),n=i.filter(c=>s.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),o=new Set;for(const c of i){if(n.has(c))continue;const u=d.get(c).map(w=>({...w,key:c})),f=l.get(c).map(w=>({...w,key:c}));(0,R.equals)(u,f,(w,_)=>P(w,_))||o.add(c)}return{added:t,removed:n,updated:o}}function h(d,l,i){const s=[...d.keys()],t=[...l.keys()],n=t.filter(u=>s.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),o=s.filter(u=>t.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),c=new Set;for(const u of s){if(o.has(u))continue;const f=d.get(u).map(_=>({..._,key:i[_.key]})),w=l.get(u).map(_=>({..._,key:i[_.key]}));y(f,w)||c.add(u)}return{added:n,removed:o,updated:c}}function y(d,l){return!(!(0,R.equals)(d.filter(({command:i})=>i[0]!=="-"),l.filter(({command:i})=>i[0]!=="-"),(i,s)=>P(i,s))||!(0,R.equals)(d.filter(({command:i})=>i[0]==="-"),l.filter(({command:i})=>i[0]==="-"),(i,s)=>P(i,s)))}function P(d,l){if(d.command!==l.command||d.key!==l.key)return!1;const i=L.ContextKeyExpr.deserialize(d.when),s=L.ContextKeyExpr.deserialize(l.when);return!(i&&!s||!i&&s||i&&s&&!i.equals(s)||!D.equals(d.args,l.args))}function p(d,l,i){for(const s of l)d=T.edit(d,[-1],s,i);return d}function g(d,l,i){const s=I(d);for(let t=s.length-1;t>=0;t--)(s[t].command===l||s[t].command===`-${l}`)&&(d=T.edit(d,[t],void 0,i));return d}function a(d,l,i,s){const t=I(d),n=t.findIndex(o=>o.command===l||o.command===`-${l}`);for(let o=t.length-1;o>=0;o--)(t[o].command===l||t[o].command===`-${l}`)&&(d=T.edit(d,[o],void 0,s));for(let o=i.length-1;o>=0;o--)d=T.edit(d,[n],i[o],s);return d}}),define(ne[239],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(L,T,I){const E={},C={},b=new Set;if(!T)return{local:{added:E,updated:C,removed:[...b.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const S=r(L,T);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{local:{added:E,updated:C,removed:[...b.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=r(I,L),v=r(I,T),h={},y={},P=new Set,p=new Set;for(const g of m.removed.values())v.updated.has(g)?E[g]=T[g]:P.add(g);for(const g of v.removed.values())p.has(g)||(m.updated.has(g)?p.add(g):b.add(g));for(const g of m.updated.values())p.has(g)||(v.updated.has(g)?S.updated.has(g)&&p.add(g):y[g]=L[g]);for(const g of v.updated.values())p.has(g)||(m.updated.has(g)?S.updated.has(g)&&p.add(g):L[g]!==void 0&&(C[g]=T[g]));for(const g of m.added.values())p.has(g)||(v.added.has(g)?S.updated.has(g)&&p.add(g):h[g]=L[g]);for(const g of v.added.values())p.has(g)||(m.added.has(g)?S.updated.has(g)&&p.add(g):E[g]=T[g]);return{local:{added:E,removed:[...b.values()],updated:C},remote:{added:h,removed:[...P.values()],updated:y},conflicts:[...p.values()]}}e.merge=R;function r(L,T){const I=L?Object.keys(L):[],E=T?Object.keys(T):[],C=E.filter(m=>I.indexOf(m)===-1).reduce((m,v)=>(m.add(v),m),new Set),b=I.filter(m=>E.indexOf(m)===-1).reduce((m,v)=>(m.add(v),m),new Set),S=new Set;for(const m of I){if(b.has(m))continue;const v=L[m],h=T[m];v!==h&&S.add(m)}return{added:C,removed:b,updated:S}}function D(L,T){const{added:I,removed:E,updated:C}=r(L,T);return I.size===0&&E.size===0&&C.size===0}e.areSame=D}),define(ne[240],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(D,L,T,I){const E={local:{added:[],removed:[],updated:[]},remote:{added:[],removed:[],updated:[]}};if(!L){const b=D.filter(({id:S})=>!I.includes(S));return b.length?E.remote.added=b:E.remote=null,E}const C=r(D,L,I);if(C.added.length>0||C.removed.length>0||C.updated.length>0){const b=r(T,D,I),S=r(T,L,I);for(const m of S.removed){const v=D.find(h=>h.id===m);v&&E.local.removed.push(v)}for(const m of S.added){const v=L.find(h=>h.id===m);b.added.includes(m)?C.updated.includes(m)&&E.local.updated.push(v):E.local.added.push(v)}for(const m of S.updated)E.local.updated.push(L.find(v=>v.id===m));for(const m of b.added)S.added.includes(m)||E.remote.added.push(D.find(v=>v.id===m));for(const m of b.updated)S.removed.includes(m)||S.updated.includes(m)||E.remote.updated.push(D.find(v=>v.id===m));for(const m of b.removed)E.remote.removed.push(L.find(v=>v.id===m))}return E.remote.added.length===0&&E.remote.removed.length===0&&E.remote.updated.length===0&&(E.remote=null),E}e.merge=R;function r(D,L,T){D=D?D.filter(({id:m})=>!T.includes(m)):[],L=L.filter(({id:m})=>!T.includes(m));const I=D.map(({id:m})=>m),E=L.map(({id:m})=>m),C=E.filter(m=>I.indexOf(m)===-1),b=I.filter(m=>E.indexOf(m)===-1),S=[];for(const{id:m,name:v}of D){if(b.includes(m))continue;const h=L.find(y=>y.id===m);(!h||h.name!==v)&&S.push(m)}return{added:C,removed:b,updated:S}}}),define(ne[26],re([0,1,19,17,15,166,43,29,5,100,40]),function(Q,e,R,r,D,L,T,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function S(){const c=b.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(u=>!!c[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=S;function m(){const c=b.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(c).filter(_=>!!c[_].ignoreSync),f=Object.keys(c).filter(_=>c[_].scope===2||c[_].scope===6),w=S();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...f,...w])}e.getDefaultIgnoredSettings=m,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function v(){const c="vscode://schemas/ignoredSettings",u=b.Registry.as(T.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:I.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const f=b.Registry.as(C.Extensions.JSONContribution),w=()=>{const _=S(),N=m().filter(M=>M!==e.CONFIGURATION_SYNC_STORE_KEY),A=Object.keys(T.allSettings.properties).filter(M=>N.indexOf(M)===-1),O=N.filter(M=>_.indexOf(M)===-1),k={items:{type:"string",enum:[...A,...O.map(M=>`-${M}`)]}};f.registerSchema(c,k)};return u.onDidUpdateConfiguration(()=>w())}e.registerConfiguration=v;function h(c){return c&&(0,D.isObject)(c)&&(0,D.isString)(c.id)&&Array.isArray(c.scopes)}e.isAuthenticationProvider=h;var y;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState",c.Profiles="profiles"})(y=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function P(c,u,f){return f.joinPath(u.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=P,e.IUserDataSyncStoreManagementService=(0,E.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,E.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,E.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function p(c){const u={};return u[e.HEADER_EXECUTION_ID]=c,u}e.createSyncHeaders=p;var g;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.RequestProtocolNotSupported="RequestProtocolNotSupported",c.RequestPathNotEscaped="RequestPathNotEscaped",c.RequestHeadersNotObject="RequestHeadersNotObject",c.NoCollection="NoCollection",c.NoRef="NoRef",c.EmptyResponse="EmptyResponse",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(g=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class a extends Error{constructor(u,f,w,_){super(u),this.code=f,this.resource=w,this.operationId=_,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=a;class d extends a{constructor(u,f,w,_,N){super(u,w,void 0,N),this.url=f,this.serverCode=_}}e.UserDataSyncStoreError=d;class l extends a{constructor(u,f){super(u,f)}}e.UserDataAutoSyncError=l,function(c){function u(f){if(f instanceof c)return f;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(f.name);if(w&&w[1]){const _=w[2]==="unknown"?void 0:w[2],N=w[3]==="unknown"?void 0:w[3];return new c(f.message,w[1],_,N)}return new c(f.message,"Unknown")}c.toUserDataSyncError=u}(a=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var s;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var t;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(c){return`sync.enable.${c}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,E.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,E.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,E.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,E.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,E.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(c,u){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(f=>(0,r.isEqualOrParent)(c,(0,r.joinPath)(u.userDataSyncHome,f,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(ne[241],re([0,1,32,26]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(I,E,C,b,S){if(!E)return{remote:Object.keys(I).length>0?I:null,local:{added:{},removed:[],updated:{}}};const m=L(I,E);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const v=C?L(C,E):{added:Object.keys(E).reduce((g,a)=>(g.add(a),g),new Set),removed:new Set,updated:new Set},h=C?L(C,I):{added:Object.keys(I).reduce((g,a)=>(g.add(a),g),new Set),removed:new Set,updated:new Set},y={added:{},removed:[],updated:{}},P=R.deepClone(E),p=!C;for(const g of h.added.values())g!==r.SYNC_SERVICE_URL_TYPE&&p&&v.added.has(g)||(P[g]=I[g]);for(const g of h.updated.values())P[g]=I[g];for(const g of h.removed.values())b.unregistered.includes(g)||delete P[g];for(const g of v.added.values()){const a=E[g];if(b.machine.includes(g)){S.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(C&&h.added.has(g))continue;const d=I[g];d&&d.value===a.value||g===r.SYNC_SERVICE_URL_TYPE&&p&&h.added.has(g)||(d?y.updated[g]=a:y.added[g]=a)}for(const g of v.updated.values()){const a=E[g];if(b.machine.includes(g)){S.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(g)||h.removed.has(g))continue;const d=I[g];d&&d.value===a.value||(y.updated[g]=a)}for(const g of v.removed.values()){if(b.machine.includes(g)){S.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}h.updated.has(g)||h.removed.has(g)||y.removed.push(g)}return{local:y,remote:T(P,E)?null:P}}e.merge=D;function L(I,E){const C=Object.keys(I),b=Object.keys(E),S=b.filter(h=>C.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),m=C.filter(h=>b.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),v=new Set;for(const h of C){if(m.has(h))continue;const y=I[h],P=E[h];R.equals(y,P)||v.add(h)}return{added:S,removed:m,updated:v}}function T(I,E){const{added:C,removed:b,updated:S}=L(I,E);return C.size===0&&b.size===0&&S.size===0}}),define(ne[242],re([0,1,19,35,79,46,32,61,26]),function(Q,e,R,r,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function C(u,f,w){let _=[];w?_=S(w):_=b(f);const N=[],A=[...(0,E.getDisallowedIgnoredSettings)()];if(Array.isArray(_))for(const O of _)O.startsWith("-")?A.push(O.substring(1)):N.push(O);return(0,R.distinct)([...u,...N].filter(O=>A.indexOf(O)===-1))}e.getIgnoredSettings=C;function b(u){let f=u.inspect("settingsSync.ignoredSettings").userValue;return f!==void 0||(f=u.inspect("sync.ignoredSettings").userValue,f!==void 0)?f:u.getValue("settingsSync.ignoredSettings")||[]}function S(u){const f=(0,r.parse)(u);return f?f["settingsSync.ignoredSettings"]||f["sync.ignoredSettings"]||[]:[]}function m(u,f){const w=(0,r.parse)(u)||{};let _="{}";for(const N of Object.keys(w)){const A=(0,D.setProperty)(_,[N],w[N],f);_=(0,D.applyEdits)(_,A)}return _}e.removeComments=m;function v(u,f,w,_){if(w.length){const N=c(f),A=(0,r.parse)(f)||{},O=(0,r.parse)(u);if(!O)return u;const k=[];for(const M of w){const $=A[M],W=O[M];$===void 0?u=I.edit(u,[M],void 0,_):W!==void 0?u=I.edit(u,[M],$,_):k.push(i(M,N))}k.sort((M,$)=>M.startOffset-$.startOffset),k.forEach(M=>u=g(M.setting.key,f,u,_))}return u}e.updateIgnoredSettings=v;function h(u,f,w,_,N,A){const O=v(u,f,_,A),k=w!==O,M=w!==f;if(!k&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(k&&!M)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(M&&!k)return{conflictsSettings:[],localContent:v(f,u,_,A),remoteContent:null,hasConflicts:!1};if(w===null&&P(u)){const B=y(u,f,_)?null:v(f,u,_,A);return{conflictsSettings:[],localContent:B,remoteContent:null,hasConflicts:!1}}let $=u,W=f;const J=(0,r.parse)(u),H=(0,r.parse)(f),G=w?(0,r.parse)(w):null,q=_.reduce((B,Z)=>(B.add(Z),B),new Set),x=p(J,H,q),Y=p(G,J,q),te=p(G,H,q),ce=new Map,z=new Set,V=B=>{z.add(B);const Z=N.filter(({key:oe})=>oe===B)[0];Z?($=I.edit($,[B],Z.value,A),W=I.edit(W,[B],Z.value,A)):ce.set(B,{key:B,localValue:J[B],remoteValue:H[B]})};for(const B of Y.removed.values())te.updated.has(B)?V(B):W=I.edit(W,[B],void 0,A);for(const B of te.removed.values())z.has(B)||(Y.updated.has(B)?V(B):$=I.edit($,[B],void 0,A));for(const B of Y.updated.values())z.has(B)||(te.updated.has(B)?x.updated.has(B)&&V(B):W=I.edit(W,[B],J[B],A));for(const B of te.updated.values())z.has(B)||(Y.updated.has(B)?x.updated.has(B)&&V(B):$=I.edit($,[B],H[B],A));for(const B of Y.added.values())z.has(B)||(te.added.has(B)?x.updated.has(B)&&V(B):W=g(B,$,W,A));for(const B of te.added.values())z.has(B)||(Y.added.has(B)?x.updated.has(B)&&V(B):$=g(B,W,$,A));const U=ce.size>0||!y($,W,_),F=U||!y($,u,[]),j=U||!y(W,f,[]);return{localContent:F?$:null,remoteContent:j?W:null,conflictsSettings:[...ce.values()],hasConflicts:U}}e.merge=h;function y(u,f,w){if(u===f)return!0;const _=(0,r.parse)(u),N=(0,r.parse)(f),A=w.reduce((M,$)=>(M.add($),M),new Set),O=c(u).filter(M=>!(M.setting&&A.has(M.setting.key))),k=c(f).filter(M=>!(M.setting&&A.has(M.setting.key)));if(O.length!==k.length)return!1;for(let M=0;M<O.length;M++){const $=O[M],W=k[M];if($.setting&&W.setting){if($.setting.key!==W.setting.key||!T.equals(_[$.setting.key],N[$.setting.key]))return!1}else if(!$.setting&&!W.setting){if($.value!==W.value)return!1}else return!1}return!0}e.areSame=y;function P(u){return u?c(u).length===0:!0}e.isEmpty=P;function p(u,f,w){const _=u?Object.keys(u).filter(M=>!w.has(M)):[],N=Object.keys(f).filter(M=>!w.has(M)),A=N.filter(M=>_.indexOf(M)===-1).reduce((M,$)=>(M.add($),M),new Set),O=_.filter(M=>N.indexOf(M)===-1).reduce((M,$)=>(M.add($),M),new Set),k=new Set;if(u)for(const M of _){if(O.has(M))continue;const $=u[M],W=f[M];T.equals($,W)||k.add(M)}return{added:A,removed:O,updated:k}}function g(u,f,w,_){const N=(0,r.parse)(f),A=c(f),O=c(w),k=a(u,A,O);return d(w,u,N[u],k,O,_)}e.addSetting=g;function a(u,f,w){const _=f.findIndex(A=>A.setting?.key===u),N=f[_-1];if(N){if(N.setting){const O=i(N.setting.key,w);if(O)return{index:w.indexOf(O),insertAfter:!0}}else{const O=s(_,f);if(O){const k=i(O.setting.key,w);if(k){const M=t(w.indexOf(k),w),$=n(f,O,f[_]);if(M){const W=n(w,k,M),J=o($,W);return J?{index:w.indexOf(J),insertAfter:!0}:{index:w.indexOf(M),insertAfter:!1}}else{const W=n(w,k,w[w.length-1]),J=o($,W);return J?{index:w.indexOf(J),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const A=f[_+1];if(A)if(A.setting){const O=i(A.setting.key,w);if(O)return{index:w.indexOf(O),insertAfter:!1}}else{const O=t(_,f);if(O){const k=i(O.setting.key,w);if(k){const M=s(w.indexOf(k),w),$=n(f,f[_],O);if(M){const W=n(w,M,k),J=o($.reverse(),W.reverse());return J?{index:w.indexOf(J),insertAfter:!1}:{index:w.indexOf(M),insertAfter:!0}}else{const W=n(w,w[0],k),J=o($.reverse(),W.reverse());return J?{index:w.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function d(u,f,w,_,N,A){let O;return _.index===-1?O=(0,D.setProperty)(u,[f],w,A):O=l(u,f,w,_,N,A).map(k=>(0,D.withFormatting)(u,k,A)[0]),(0,D.applyEdits)(u,O)}function l(u,f,w,_,N,A){const O=`${JSON.stringify(f)}: ${JSON.stringify(w)}`,k=(0,L.getEOL)(A,u),M=N[_.index];if(_.insertAfter){const $=[];if(M.setting)$.push({offset:M.endOffset,length:0,content:","+O});else{const W=t(_.index,N),J=s(_.index,N),H=J?.setting?.commaOffset;J&&H===void 0&&$.push({offset:J.endOffset,length:0,content:","});const G=H!==void 0&&H>M.endOffset;$.push({offset:G?H+1:M.endOffset,length:0,content:W?k+O+",":k+O})}return $}else{if(M.setting)return[{offset:M.startOffset,length:0,content:O+","}];const $=(N[_.index-1]&&!N[_.index-1].setting?k:"")+O+(t(_.index,N)?",":"")+k;return[{offset:M.startOffset,length:0,content:$}]}}function i(u,f){return f.filter(w=>w.setting?.key===u)[0]}function s(u,f){for(let w=u-1;w>=0;w--)if(f[w].setting)return f[w]}function t(u,f){for(let w=u+1;w<f.length;w++)if(f[w].setting)return f[w]}function n(u,f,w){const _=u.indexOf(f),N=u.indexOf(w);return u.filter((A,O)=>_<O&&O<N)}function o(u,f){if(u.length&&f.length){let w=0;for(;w<f.length&&w<u.length;w++)if(u[w].value!==f[w].value)return f[w-1];return f[w-1]}}function c(u){const f=[];let w=-1,_,N;const A={onObjectBegin:O=>{w++},onObjectProperty:(O,k,M)=>{w===0&&(_=k,N=O)},onObjectEnd:(O,k)=>{w--,w===0&&f.push({startOffset:_,endOffset:O+k,value:u.substring(_,O+k),setting:{key:N,commaOffset:void 0}})},onArrayBegin:(O,k)=>{w++},onArrayEnd:(O,k)=>{w--,w===0&&f.push({startOffset:_,endOffset:O+k,value:u.substring(_,O+k),setting:{key:N,commaOffset:void 0}})},onLiteralValue:(O,k,M)=>{w===0&&f.push({startOffset:_,endOffset:k+M,value:u.substring(_,k+M),setting:{key:N,commaOffset:void 0}})},onSeparator:(O,k,M)=>{if(w===0&&O===","){let $=f.length-1;for(;$>=0&&!f[$].setting;$--);const W=f[$];W&&f.splice($,1,{startOffset:W.startOffset,endOffset:W.endOffset,value:W.value,setting:{key:W.setting.key,commaOffset:k}})}},onComment:(O,k)=>{w===0&&f.push({startOffset:O,endOffset:O+k,value:u.substring(O,O+k)})}};return(0,r.visit)(u,A),f}}),define(ne[73],re([0,1,3,2,5,26]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let T=class extends r.Disposable{constructor(E,C){super(),this.userDataSyncStoreService=E,this.logService=C,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(E.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(E.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(E){(E&&this._account?E.token!==this._account.token||E.authenticationProviderId!==this._account.authenticationProviderId:E!==this._account)&&(this._account=E,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(E))}};T=pe([K(0,L.IUserDataSyncStoreService),K(1,L.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(ne[243],re([0,1,6,16,63,2,17,18,14,13,26]),function(Q,e,R,r,D,L,T,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let S=class extends L.Disposable{constructor(v,h,y,P){super(),this.environmentService=v,this.fileService=h,this.configurationService=y,this.logService=P,b.ALL_SYNC_RESOURCES.forEach(p=>this.cleanUpBackup(p))}async getAllRefs(v){const h=(0,T.joinPath)(this.environmentService.userDataSyncHome,v),y=await this.fileService.resolve(h);return y.children?y.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.getCreationTime(p)})):[]}async resolveContent(v,h){if(!h){const y=await this.getAllRefs(v);y.length&&(h=y[y.length-1].ref)}if(h){const y=(0,T.joinPath)(this.environmentService.userDataSyncHome,v,h);return(await this.fileService.readFile(y)).value.toString()}return null}async backup(v,h){const y=(0,T.joinPath)(this.environmentService.userDataSyncHome,v),P=(0,T.joinPath)(y,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(P,r.VSBuffer.fromString(h))}catch(p){this.logService.error(p)}try{this.cleanUpBackup(v)}catch{}}async cleanUpBackup(v){const h=(0,T.joinPath)(this.environmentService.userDataSyncHome,v);try{try{if(!await this.fileService.exists(h))return}catch{return}const y=await this.fileService.resolve(h);if(y.children){const P=y.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),p=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let g=P.filter(d=>Date.now()-this.getCreationTime(d)>p);const a=P.length-g.length;a<10&&(g=g.slice(10-a)),await R.Promises.settled(g.map(async d=>{this.logService.info("Deleting from backup",d.resource.path),await this.fileService.del(d.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(v){return v.ctime||new Date(parseInt(v.name.substring(0,4)),parseInt(v.name.substring(4,6))-1,parseInt(v.name.substring(6,8)),parseInt(v.name.substring(9,11)),parseInt(v.name.substring(11,13)),parseInt(v.name.substring(13,15))).getTime()}};S=pe([K(0,E.IEnvironmentService),K(1,C.IFileService),K(2,I.IConfigurationService),K(3,b.IUserDataSyncLogService)],S),e.UserDataSyncBackupStoreService=S}),define(ne[244],re([0,1,2,7]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(m){this.service=m}listen(m,v){switch(v){case"onError":return this.service.onError}throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class L{constructor(m){this.service=m}listen(m,v){throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(r.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class T{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=T;class I{constructor(m){this.service=m}listen(m,v){switch(v){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${v}`)}async call(m,v,h){switch(v){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablements":return this.service.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=I;class E{constructor(m){this.service=m}listen(m,v){switch(v){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=E;class C{constructor(m){this.service=m}listen(m,v){switch(v){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=C;class b extends R.Disposable{constructor(m){super(),this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:r.URI.revive(m.url),type:m.type,defaultUrl:r.URI.revive(m.defaultUrl),insidersUrl:r.URI.revive(m.insidersUrl),stableUrl:r.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=b}),define(ne[245],re([0,1,14,8]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends r.AbstractLogger{constructor(T,I){super(),this.logger=this._register(T.createLogger(I.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...I){this.logger.trace(T,...I)}debug(T,...I){this.logger.debug(T,...I)}info(T,...I){this.logger.info(T,...I)}warn(T,...I){this.logger.warn(T,...I)}error(T,...I){this.logger.error(T,...I)}critical(T,...I){this.logger.critical(T,...I)}flush(){this.logger.flush()}};D=pe([K(0,r.ILoggerService),K(1,R.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(ne[246],re([0,1,3,2,7,26]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class T{constructor(b,S){this.service=b,this.logService=S,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(b,S){switch(S){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${S}`)}async call(b,S,m){try{return await this._call(b,S,m)}catch(v){throw this.logService.error(v),v}}async _call(b,S,m){switch(S){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(D.URI.revive(m[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(m[0],D.URI.revive(m[1]),m[2],m[3]);case"resolveContent":return this.service.resolveContent(D.URI.revive(m[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(m[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(m[0]);case"getAssociatedResources":return this.service.getAssociatedResources(m[0],{created:m[1].created,uri:D.URI.revive(m[1].uri)});case"getMachineId":return this.service.getMachineId(m[0],{created:m[1].created,uri:D.URI.revive(m[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(S.startsWith("manualSync/")){const v=S.substring(11),h=m[0],y=this.getManualSyncTask(h);switch(m=m.slice(1),v){case"preview":return y.preview();case"accept":return y.accept(D.URI.revive(m[0]),m[1]);case"merge":return y.merge(D.URI.revive(m[0]));case"discard":return y.discard(D.URI.revive(m[0]));case"discardConflicts":return y.discardConflicts();case"apply":return y.apply();case"pull":return y.pull();case"push":return y.push();case"stop":return y.stop();case"_getStatus":return y.status;case"dispose":return this.disposeManualSyncTask(y)}}throw new Error("Invalid call")}getManualSyncTask(b){const S=this.manualSyncTasks.get(this.createKey(b));if(!S)throw new Error(`Manual sync taks not found: ${b}`);return S.manualSyncTask}async createManualSyncTask(){const b=new r.DisposableStore,S=b.add(await this.service.createManualSyncTask());return b.add(S.onSynchronizeResources(m=>this.onManualSynchronizeResources.fire({manualSyncTaskId:S.id,data:m}))),this.manualSyncTasks.set(this.createKey(S.id),{manualSyncTask:S,disposables:b}),{id:S.id,manifest:S.manifest,status:S.status}}disposeManualSyncTask(b){b.dispose();const S=this.createKey(b.id);this.manualSyncTasks.get(S)?.disposables.dispose(),this.manualSyncTasks.delete(S)}createKey(b){return`manualSyncTask-${b}`}}e.UserDataSyncChannel=T;class I extends r.Disposable{constructor(b){super(),this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(S,m,v){return b.call(S,m,v).then(null,h=>{throw L.UserDataSyncError.toUserDataSyncError(h)})},listen(S,m){return b.listen(S,m)}},this.channel.call("_getInitialData").then(([S,m,v])=>{this.updateStatus(S),this.updateConflicts(m),v&&this.updateLastSyncTime(v),this._register(this.channel.listen("onDidChangeStatus")(h=>this.updateStatus(h))),this._register(this.channel.listen("onDidChangeLastSyncTime")(h=>this.updateLastSyncTime(h)))}),this._register(this.channel.listen("onDidChangeConflicts")(S=>this.updateConflicts(S))),this._register(this.channel.listen("onSyncErrors")(S=>this._onSyncErrors.fire(S.map(([m,v])=>[m,L.UserDataSyncError.toUserDataSyncError(v)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:b,manifest:S,status:m}=await this.channel.call("createManualSyncTask"),v=this,h=new E(b,S,m,{async call(y,P,p){return v.channel.call(`manualSync/${y}`,[b,...Array.isArray(P)?P:[P]],p)},listen(y,P){return R.Event.map(R.Event.filter(v.channel.listen(`manualSync/${y}`,P),p=>!h.isDiposed()&&p.manualSyncTaskId===b),p=>p.data)}});return h}replace(b){return this.channel.call("replace",[b])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(b,S,m,v){return this.channel.call("accept",[b,S,m,v])}resolveContent(b){return this.channel.call("resolveContent",[b])}async getLocalSyncResourceHandles(b){return(await this.channel.call("getLocalSyncResourceHandles",[b])).map(({created:m,uri:v})=>({created:m,uri:D.URI.revive(v)}))}async getRemoteSyncResourceHandles(b){return(await this.channel.call("getRemoteSyncResourceHandles",[b])).map(({created:m,uri:v})=>({created:m,uri:D.URI.revive(v)}))}async getAssociatedResources(b,S){return(await this.channel.call("getAssociatedResources",[b,S])).map(({resource:v,comparableResource:h})=>({resource:D.URI.revive(v),comparableResource:D.URI.revive(h)}))}async getMachineId(b,S){return this.channel.call("getMachineId",[b,S])}async updateStatus(b){this._status=b,this._onDidChangeStatus.fire(b)}async updateConflicts(b){this._conflicts=b.map(([S,m])=>[S,m.map(v=>({...v,baseResource:D.URI.revive(v.baseResource),localResource:D.URI.revive(v.localResource),remoteResource:D.URI.revive(v.remoteResource),previewResource:D.URI.revive(v.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(b){this._lastSyncTime!==b&&(this._lastSyncTime=b,this._onDidChangeLastSyncTime.fire(b))}}e.UserDataSyncChannelClient=I;class E extends r.Disposable{constructor(b,S,m,v){super(),this.id=b,this.manifest=S,this._disposed=!1,this._status=m;const h=this;this.channel={async call(y,P,p){try{const g=await v.call(y,P,p);return h.isDiposed()||(h._status=await v.call("_getStatus")),g}catch(g){throw L.UserDataSyncError.toUserDataSyncError(g)}},listen(y,P){return v.listen(y,P)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const b=await this.channel.call("preview");return this.deserializePreviews(b)}async accept(b,S){const m=await this.channel.call("accept",[b,S]);return this.deserializePreviews(m)}async merge(b){const S=await this.channel.call("merge",[b]);return this.deserializePreviews(S)}async discard(b){const S=await this.channel.call("discard",[b]);return this.deserializePreviews(S)}async discardConflicts(){const b=await this.channel.call("discardConflicts");return this.deserializePreviews(b)}async apply(){const b=await this.channel.call("apply");return this.deserializePreviews(b)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(b){return b.map(([S,m])=>[S,{isLastSyncFromCurrentMachine:m.isLastSyncFromCurrentMachine,resourcePreviews:m.resourcePreviews.map(v=>({...v,baseResource:D.URI.revive(v.baseResource),localResource:D.URI.revive(v.localResource),remoteResource:D.URI.revive(v.remoteResource),previewResource:D.URI.revive(v.previewResource),acceptedResource:D.URI.revive(v.acceptedResource)}))}])}}}),define(ne[247],re([0,1,6,3,2]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends D.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:E,getActiveWindowId:C}){super(),this.disposables=this._register(new D.DisposableStore),r.Event.latch(r.Event.any(I,E))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>C()),(async()=>{try{const S=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:S}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(ne[111],re([0,1,168,12,34,17,7,5,21]),function(Q,e,R,r,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function C(s){const t=s;return typeof t?.id=="string"&&T.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=C,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function b(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,r.basename)(s)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=s;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=b;function S(s){const t=s;return typeof t?.id=="string"&&T.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=S;function m(s){const t=s;if(t?.uri)return{id:t.id,uri:T.URI.revive(t.uri)};const n=s;if(n?.configPath)return{id:n.id,configPath:T.URI.revive(n.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=m;var v;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function h(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=h;function y(s){const t=s;return!!(t&&typeof t=="object"&&T.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=y;class P{constructor(t,n,o,c,u){this._id=t,this._transient=o,this._configuration=c,this._ignorePathCasing=u,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class p{constructor(t,n){this.raw=n,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function g(s){return new p({uri:s,index:0,name:(0,L.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(s,t){return L.extUriBiasedIgnorePathCase.isEqualOrParent(s,t.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function d(s){let t;return T.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=d;function l(s,t){return!a(s,t)&&!d(s)}e.isSavedWorkspace=l;function i(s){return(typeof s=="string"?(0,r.extname)(s):(0,L.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ne[23],re([0,1,64,3,2,17,15,7,161,14,13,5,8,111,34,31,6,30,27]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function a(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&I.URI.isUri(n.location)&&I.URI.isUri(n.globalStorageHome)&&I.URI.isUri(n.settingsResource)&&I.URI.isUri(n.keybindingsResource)&&I.URI.isUri(n.tasksResource)&&I.URI.isUri(n.snippetsHome)&&((0,T.isUndefined)(n.extensionsResource)||I.URI.isUri(n.extensionsResource)))}e.isUserDataProfile=a,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,S.createDecorator)("IUserDataProfilesService");function d(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,location:I.URI.revive(t.location).with({scheme:n}),globalStorageHome:I.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:I.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:I.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:I.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:I.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:I.URI.revive(t.extensionsResource)?.with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=d,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function l(t,n,o,c,u){return{id:t,name:n,location:o,isDefault:!1,globalStorageHome:(0,L.joinPath)(o,"globalStorage"),settingsResource:(0,L.joinPath)(o,"settings.json"),keybindingsResource:(0,L.joinPath)(o,"keybindings.json"),tasksResource:(0,L.joinPath)(o,"tasks.json"),snippetsHome:(0,L.joinPath)(o,"snippets"),extensionsResource:(0,L.joinPath)(o,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:c,isTransient:u}}e.toUserDataProfile=l;let i=class extends D.Disposable{constructor(n,o,c,u){super(),this.environmentService=n,this.fileService=o,this.uriIdentityService=c,this.logService=u,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new r.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new r.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new r.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new r.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(f=>l((0,L.basename)(f.location),f.name,f.location,f.useDefaultFlags)):[];let o;const c=new h.ResourceMap,u=l((0,R.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,E.localize)(0,null),this.environmentService.userRoamingDataHome);if(n.unshift({...u,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0||this.transientProfilesObject.profiles.length>0?u.extensionsResource:void 0}),n.length){const f=this.getStoredProfileAssociations();if(f.workspaces)for(const[w,_]of Object.entries(f.workspaces)){const N=I.URI.parse(w),A=I.URI.parse(_),O=n.find(k=>this.uriIdentityService.extUri.isEqual(k.location,A));O&&c.set(N,O)}if(f.emptyWindow){const w=I.URI.parse(f.emptyWindow);o=n.find(_=>this.uriIdentityService.extUri.isEqual(_.location,w))}}this._profilesObject={profiles:n,workspaces:c,emptyWindow:o}}return this._profilesObject}async createTransientProfile(n){const o="Temp",c=new RegExp(`${(0,g.escapeRegExpCharacters)(o)}\\s(\\d+)`);let u=0;for(const w of this.profiles){const _=c.exec(w.name),N=_?parseInt(_[1]):0;u=N>u?N:u}const f=`${o} ${u+1}`;return this.createProfile((0,R.hash)((0,p.generateUuid)()).toString(16),f,void 0,!0,n)}async createNamedProfile(n,o,c){return this.createProfile((0,R.hash)((0,p.generateUuid)()).toString(16),n,o,!1,c)}async createProfile(n,o,c,u,f){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const w=await this.doCreateProfile(n,o,c,!!u);return f&&await this.setProfileForWorkspace(f,w),w}async doCreateProfile(n,o,c,u){let f=this.profileCreationPromises.get(o);return f||(f=(async()=>{try{const w=this.profiles.find(A=>A.name===o||A.id===n);if(w)return w;const _=l(n,o,(0,L.joinPath)(this.profilesHome,n),c,u);await this.fileService.createFolder(_.location);const N=[];return this._onWillCreateProfile.fire({profile:_,join(A){N.push(A)}}),await P.Promises.settled(N),this.updateProfiles([_],[],[]),_}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,f)),f}async updateProfile(n,o,c,u){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let f=this.profiles.find(w=>w.id===n.id);if(!f)throw new Error(`Profile '${n.name}' does not exist`);return f=l(f.id,o,f.location,c,u??f.isTransient),this.updateProfiles([],[],[f]),f}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(u=>u.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:o,join(u){c.push(u)}}),await P.Promises.settled(c),o.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const u of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(u)?.id&&this.profilesObject.workspaces.delete(u);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(o.location,{recursive:!0})}catch(u){this.logService.error(u)}}getOrSetProfileForWorkspace(n,o=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let c=this.getProfileForWorkspace(n);return c||(c=o,this.profiles.length>1&&this.setProfileForWorkspaceSync(n,c)),c}async setProfileForWorkspace(n,o){this.setProfileForWorkspaceSync(n,o)}setProfileForWorkspaceSync(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(u=>u.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(n,c)}unsetWorkspace(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.getWorkspace(n);return I.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(n){return(0,v.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,v.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}isProfileAssociatedToWorkspace(n){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,n.location)||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,n.location)||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location)))}updateProfiles(n,o,c){const u=[...this.profiles,...n],f=[];this.transientProfilesObject.profiles=[];for(let w of u)w.isDefault||o.some(_=>w.id===_.id)||(w=c.find(_=>w.id===_.id)??w,w.isTransient?this.transientProfilesObject.profiles.push(w):f.push({location:w.location,name:w.name,useDefaultFlags:w.useDefaultFlags}));this.saveStoredProfiles(f),this._profilesObject=void 0,this.triggerProfilesChanges(n,o,c)}triggerProfilesChanges(n,o,c){this._onDidChangeProfiles.fire({added:n,removed:o,updated:c,all:this.profiles})}updateWorkspaceAssociation(n,o,c){c=o?.isTransient?!0:c,c||this.updateWorkspaceAssociation(n,void 0,!0);const u=this.getWorkspace(n),f=c?this.transientProfilesObject:this.profilesObject;I.URI.isUri(u)?(f.workspaces.delete(u),o&&f.workspaces.set(u,o)):f.emptyWindow=o,c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[c,u]of this.profilesObject.workspaces.entries())n[c.toString()]=u.location.toString();const o=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:o}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=pe([K(0,C.IEnvironmentService),K(1,b.IFileService),K(2,y.IUriIdentityService),K(3,m.ILogService)],i),e.UserDataProfilesService=i;class s extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=s}),define(ne[248],re([0,1,6,2,23]),function(Q,e,R,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let L=class extends r.Disposable{constructor(I){super(),this._register(new R.RunOnceScheduler(()=>{I.cleanUp()},10*1e3)).schedule()}};L=pe([K(0,D.IUserDataProfilesService)],L),e.UserDataProfilesCleaner=L}),define(ne[249],re([0,1,19,6,24,9,3,2,4,7,143,29,33,44,8,25,22,23]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends I.Disposable{constructor(t,n,o,c,u){super(),this.galleryService=t,this.telemetryService=n,this.logService=o,this.productService=c,this.userDataProfilesService=u,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(({task:f})=>f.cancel()),this.uninstallingExtensions.forEach(f=>f.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const n=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,S.isTargetPlatformCompatible)(o,t.allTargetPlatforms,n))}async installFromGallery(t,n={}){try{if(!this.galleryService.isEnabled())throw new S.ExtensionManagementError(b.localize(0,null),S.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(t,!!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,n)}catch(o){throw l(this.telemetryService,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(t),error:o}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(o),d(o)}}async uninstall(t,n={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,n)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(b.localize(1,null));const n=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:n,compatible:!0},D.CancellationToken.None);if(!o)throw new Error(b.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,n,o){const c=A=>`${m.ExtensionKey.create(A).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!C.URI.isUri(n)){const A=this.installingExtensions.get(c(n));if(A){this.logService.info("Extensions is already requested to install",n.identifier.id);const{local:O}=await A.task.waitUntilTaskIsFinished();return O}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const u=[],f=[],w=[],_=this.createInstallExtensionTask(t,n,o);C.URI.isUri(n)||this.installingExtensions.set(c(n),{task:_,waitingTasks:[]}),this._onInstallExtension.fire({identifier:_.identifier,source:n,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",_.identifier.id),u.push({task:_,manifest:t});let N=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",_.identifier.id);else try{const O=await this.getAllDepsAndPackExtensions(_.identifier,t,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),k=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:M,manifest:$}of O){N=N||!!$.extensionDependencies?.some(H=>(0,m.areSameExtensions)({id:H},_.identifier));const W=c(M),J=this.installingExtensions.get(W);if(J){if(this.canWaitForTask(_,J.task)){this.logService.info("Waiting for already requested installing extension",M.identifier.id,_.identifier.id),J.waitingTasks.push(_);const H=J.task.identifier;f.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,G=>G.some(q=>(0,m.areSameExtensions)(q.identifier,H)))).then(G=>{if(!G.find(x=>(0,m.areSameExtensions)(x.identifier,H))?.local)throw new Error(`Extension ${H.id} is not installed`)}))}}else if(!k.some(({identifier:H})=>(0,m.areSameExtensions)(H,M.identifier))){const H=this.createInstallExtensionTask($,M,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(W,{task:H,waitingTasks:[_]}),this._onInstallExtension.fire({identifier:H.identifier,source:M,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",H.identifier.id,_.identifier.id),u.push({task:H,manifest:$})}}}catch(O){if(C.URI.isUri(_.source))(0,R.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",_.identifier.id,O.message),(0,R.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",_.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",_.identifier.id),O}const A=u.reduce((O,{task:k,manifest:M})=>(O.set(k.identifier.id.toLowerCase(),{task:k,manifest:M}),O),new Map);for(;A.size;){let O;const k=[...A.values()].filter(({manifest:M})=>!M.extensionDependencies?.some($=>A.has($.toLowerCase())));k.length?O=A.size===1?k:k.filter(({task:M})=>!(M===_&&!N)):(this.logService.info("Found extensions with circular dependencies",k.map(({task:M})=>M.identifier.id)),O=[...A.values()]),await this.joinAllSettled(O.map(async({task:M})=>{const $=new Date().getTime();try{const{local:W}=await M.run();if(await this.joinAllSettled(this.participants.map(J=>J.postInstall(W,M.source,o,D.CancellationToken.None))),!C.URI.isUri(M.source)){const J=M.operation===3,H=J?void 0:(new Date().getTime()-M.source.lastUpdated)/1e3;if(l(this.telemetryService,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(M.source),duration:new Date().getTime()-$,durationSinceUpdate:H}),E.isWeb&&M.operation!==3)try{await this.galleryService.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch{}}w.push({local:W,identifier:M.identifier,operation:M.operation,source:M.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:W.isApplicationScoped})}catch(W){throw C.URI.isUri(M.source)||l(this.telemetryService,M.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(M.source),duration:new Date().getTime()-$,error:W}),this.logService.error("Error while installing the extension:",M.identifier.id),W}finally{A.delete(M.identifier.id.toLowerCase())}}))}return f.length&&await this.joinAllSettled(f),w.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(w),w.filter(({identifier:O})=>(0,m.areSameExtensions)(O,_.identifier))[0].local}catch(A){if(u.forEach(({task:O})=>O.cancel()),w.length)try{const O=await Promise.allSettled(w.map(({local:k})=>this.createUninstallExtensionTask(k,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let k=0;k<O.length;k++){const M=O[k],{identifier:$}=w[k];M.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",$.id):this.logService.warn("Rollback: Error while uninstalling extension",$.id,(0,L.getErrorMessage)(M.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(O),w.map(({identifier:k})=>k.id))}throw this._onDidInstallExtensions.fire(u.map(({task:O})=>({identifier:O.identifier,operation:2,source:O.source,context:o.context,profileLocation:o.profileLocation}))),A}finally{for(const[A,{task:O,waitingTasks:k}]of this.installingExtensions.entries()){const M=k.indexOf(_);M!==-1&&k.splice(M,1),k.length===0&&(O===_||M!==-1)&&this.installingExtensions.delete(A)}}}canWaitForTask(t,n){for(const[,{task:o,waitingTasks:c}]of this.installingExtensions.entries())if(o===t&&(c.includes(n)||c.some(u=>this.canWaitForTask(u,n)))||o===n&&c[0]&&!this.canWaitForTask(t,c[0]))return!1;return!0}async joinAllSettled(t){const n=[],o=[],c=await Promise.allSettled(t);for(const u of c)u.status==="fulfilled"?n.push(u.value):o.push(u.reason);if(o.length)throw a(o);return n}async getAllDepsAndPackExtensions(t,n,o,c,u){if(!this.galleryService.isEnabled())return[];const f=await this.getInstalled(void 0,u),w=[t],_=[],N=async(A,O)=>{const k=O.extensionDependencies||[],M=[...k];if(O.extensionPack){const $=o?f.find(W=>(0,m.areSameExtensions)(W.identifier,A)):void 0;for(const W of O.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(J=>(0,m.areSameExtensions)({id:J},{id:W}))||M.every(J=>!(0,m.areSameExtensions)({id:J},{id:W}))&&M.push(W)}if(M.length){const $=[...w,..._.map(J=>J.gallery.identifier)],W=M.filter(J=>$.every(H=>!(0,m.areSameExtensions)(H,{id:J})));if(W.length){const J=await this.galleryService.getExtensions(W.map(H=>({id:H,preRelease:c})),D.CancellationToken.None);for(const H of J){if($.find(x=>(0,m.areSameExtensions)(x,H.identifier)))continue;const G=k.some(x=>(0,m.areSameExtensions)({id:x},H.identifier));let q;try{q=await this.checkAndGetCompatibleVersion(H,!1,c)}catch(x){if(x instanceof S.ExtensionManagementError&&x.code===S.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!G){this.logService.info("Skipping the packed extension as it cannot be installed",H.identifier.id);continue}else throw x}_.push({gallery:q.extension,manifest:q.manifest}),await N(q.extension.identifier,q.manifest)}}}};return await N(t,n),_}async checkAndGetCompatibleVersion(t,n,o){if((await this.getExtensionsControlManifest()).malicious.some(w=>(0,m.areSameExtensions)(t.identifier,w)))throw new S.ExtensionManagementError(b.localize(3,null,t.identifier.id),S.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const w=await this.getTargetPlatform();throw new S.ExtensionManagementError(b.localize(4,null,t.identifier.id,this.productService.nameLong,(0,S.TargetPlatformToString)(w)),S.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const u=await this.getCompatibleVersion(t,n,o);if(u){if(o&&!n&&t.hasPreReleaseVersion&&!u.properties.isPreReleaseVersion)throw new S.ExtensionManagementError(b.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),S.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],D.CancellationToken.None))[0]?new S.ExtensionManagementError(b.localize(6,null,t.identifier.id),S.ExtensionManagementErrorCode.ReleaseVersionNotFound):new S.ExtensionManagementError(b.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),S.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",u.identifier.id);const f=await this.galleryService.getManifest(u,D.CancellationToken.None);if(f===null)throw new S.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,S.ExtensionManagementErrorCode.Invalid);if(f.version!==u.version)throw new S.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,S.ExtensionManagementErrorCode.Invalid);return{extension:u,manifest:f}}async getCompatibleVersion(t,n,o){const c=await this.getTargetPlatform();let u=null;return!n&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(u=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},D.CancellationToken.None))[0]||null),!u&&await this.galleryService.isExtensionCompatible(t,o,c)&&(u=t),u||(n?u=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:c,compatible:!0},D.CancellationToken.None))[0]||null:u=await this.galleryService.getCompatibleExtension(t,o,c)),u}async uninstallExtension(t,n){const o=N=>`${N.id.toLowerCase()}${n.versionOnly?`-${t.manifest.version}`:""}${n.profileLocation?`@${n.profileLocation.toString()}`:""}`,c=this.uninstallingExtensions.get(o(t.identifier));if(c)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),c.waitUntilTaskIsFinished();const u=(N,A)=>{const O=this.createUninstallExtensionTask(N,A);return this.uninstallingExtensions.set(o(O.extension.identifier),O),n.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,n.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${N.identifier.id}@${N.manifest.version}`),this._onUninstallExtension.fire({identifier:N.identifier,profileLocation:n.profileLocation,applicationScoped:N.isApplicationScoped}),O},f=(N,A)=>{A?n.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,n.profileLocation.toString(),A.message):this.logService.error("Failed to uninstall extension:",`${N.identifier.id}@${N.manifest.version}`,A.message):n.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${N.identifier.id}@${N.manifest.version}`,n.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${N.identifier.id}@${N.manifest.version}`),l(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(N),error:A}),this._onDidUninstallExtension.fire({identifier:N.identifier,version:N.manifest.version,error:A?.code,profileLocation:n.profileLocation,applicationScoped:N.isApplicationScoped})},w=[],_=[];try{w.push(u(t,n));const N=await this.getInstalled(1,n.profileLocation);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const A=this.getAllPackExtensionsToUninstall(t,N);for(const O of A)this.uninstallingExtensions.has(o(O.identifier))?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):w.push(u(O,n))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(w.map(A=>A.extension),N,t),await this.joinAllSettled(w.map(async A=>{try{if(await A.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(A.extension,n,D.CancellationToken.None))),A.extension.identifier.uuid)try{await this.galleryService.reportStatistic(A.extension.manifest.publisher,A.extension.manifest.name,A.extension.manifest.version,"uninstall")}catch{}f(A.extension)}catch(O){const k=O instanceof S.ExtensionManagementError?O:new S.ExtensionManagementError((0,L.getErrorMessage)(O),S.ExtensionManagementErrorCode.Internal);throw f(A.extension,k),k}finally{_.push(A)}}))}catch(N){const A=N instanceof S.ExtensionManagementError?N:new S.ExtensionManagementError((0,L.getErrorMessage)(N),S.ExtensionManagementErrorCode.Internal);for(const O of w){try{O.cancel()}catch{}_.includes(O)||f(O.extension,A)}throw A}finally{for(const N of w)this.uninstallingExtensions.delete(o(N.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",N.extension.identifier.id)}}checkForDependents(t,n,o){for(const c of t){const u=this.getDependents(c,n);if(u.length){const f=u.filter(w=>!t.some(_=>(0,m.areSameExtensions)(_.identifier,w.identifier)));if(f.length)throw new Error(this.getDependentsErrorMessage(c,f,o))}}}getDependentsErrorMessage(t,n,o){return o===t?n.length===1?b.localize(8,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?b.localize(9,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):b.localize(10,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?b.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?b.localize(12,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):b.localize(13,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(t,n,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const c=t.manifest.extensionPack?t.manifest.extensionPack:[];if(c.length){const u=n.filter(w=>!w.isBuiltin&&c.some(_=>(0,m.areSameExtensions)({id:_},w.identifier))),f=[];for(const w of u)f.push(...this.getAllPackExtensionsToUninstall(w,n,o));return[...u,...f]}return[]}getDependents(t,n){return n.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,m.areSameExtensions)({id:c},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,n,o){return o.profileLocation&&(0,v.isApplicationScopedExtension)(t)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,n,o)}createUninstallExtensionTask(t,n){return n.profileLocation&&t.isApplicationScoped&&(n={...n,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,n)}};g=pe([K(0,S.IExtensionGalleryService),K(1,P.ITelemetryService),K(2,h.ILogService),K(3,y.IProductService),K(4,p.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function a(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((n,o)=>new Error(`${n.message}${n.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=a;function d(s){if(s instanceof S.ExtensionManagementError)return s;const t=new S.ExtensionManagementError(s.message,S.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function l(s,t,{extensionData:n,duration:o,error:c,durationSinceUpdate:u}){const f=c?c instanceof S.ExtensionManagementError?c.code:S.ExtensionManagementErrorCode.Internal:void 0;s.publicLog(t,{...n,success:!c,duration:o,errorcode:f,durationSinceUpdate:u})}e.reportTelemetry=l;class i{constructor(){this.barrier=new r.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,r.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,r.createCancelablePromise)(t=>new Promise((n,o)=>{const c=t.onCancellationRequested(()=>{c.dispose(),o(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=i}),define(ne[74],re([0,1,19,6,32,16,9,35,125,2,21,12,4,17,55,84,15,7,146,14,33,44,68,13,5,8,25,3,65,49,23,31,174]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p,g,a,d,l,i,s,t,n,o,c,u,f,w,_,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var A;(function(H){function G(q,x){if(q===x)return!0;const Y=Object.keys(q),te=new Set;for(const ce of Object.keys(x))te.add(ce);if(Y.length!==te.size)return!1;for(const ce of Y){if(q[ce]!==x[ce])return!1;te.delete(ce)}return te.size===0}H.equals=G})(A=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let O=class extends C.Disposable{constructor(G,q,x,Y,te,ce,z,V,U,F,j){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=q,this.extensionsControlLocation=x,this.cacheLocation=Y,this.userDataProfilesService=te,this.extensionsProfileScannerService=ce,this.fileService=z,this.logService=V,this.environmentService=U,this.productService=F,this.instantiationService=j,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance($,(0,v.joinPath)(this.cacheLocation,l.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance($,(0,v.joinPath)(this.cacheLocation,l.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(M,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,d.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(G,q,x){const[Y,te]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(q)]),ce=x?await this.scanExtensionsUnderDevelopment(G,[...Y,...te]):[];return this.dedupExtensions(Y,te,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const q=[];q.push(this.scanDefaultSystemExtensions(!!G.useCache,G.language)),q.push(this.scanDevSystemExtensions(G.language,!!G.checkControlFile));const[x,Y]=await Promise.all(q);return this.applyScanOptions([...x,...Y],0,G,!1)}async scanUserExtensions(G){this.logService.trace("Started scanning user extensions");const q=await this.createExtensionScannerInput(G.profileLocation??this.userExtensionsLocation,!!G.profileLocation,1,!G.includeUninstalled,G.language);let Y=await(G.useCache&&!q.devMode&&q.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(q);return Y=await this.applyScanOptions(Y,1,G,!0),this.logService.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(G,q){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(Y=>Y.scheme===b.Schemas.file).map(async Y=>{const te=await this.createExtensionScannerInput(Y,!1,1,!0,G.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(te)).map(z=>(z.type=q.find(V=>(0,d.areSameExtensions)(V.identifier,z.identifier))?.type??z.type,this.extensionsScanner.validate(z,te)))}))).flat();return this.applyScanOptions(x,"development",G,!0)}return[]}async scanExistingExtension(G,q,x){const Y=await this.createExtensionScannerInput(G,!1,q,!0,x.language),te=await this.extensionsScanner.scanExtension(Y);return!te||!x.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(G,q,x){const Y=await this.createExtensionScannerInput(G,!1,q,!0,x.language),te=await this.extensionsScanner.scanOneOrMultipleExtensions(Y);return this.applyScanOptions(te,q,x,!0)}async scanMetadata(G){const q=(0,v.joinPath)(G,"package.json"),x=(await this.fileService.readFile(q)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(G,q){const x=(0,v.joinPath)(G,"package.json"),Y=(await this.fileService.readFile(x)).value.toString(),te=JSON.parse(Y);q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,q.installedTimestamp=q.installedTimestamp||void 0,te.__metadata={...te.__metadata,...q},await this.fileService.writeFile((0,v.joinPath)(G,"package.json"),L.VSBuffer.fromString(JSON.stringify(te,null,"	")))}async applyScanOptions(G,q,x,Y){return x.includeAllVersions||(G=this.dedupExtensions(q===0?G:void 0,q===1?G:void 0,q==="development"?G:void 0,await this.getTargetPlatform(),Y)),x.includeInvalid||(G=G.filter(te=>te.isValid)),G.sort((te,ce)=>{const z=S.basename(te.location.fsPath),V=S.basename(ce.location.fsPath);return z<V?-1:z>V?1:0})}dedupExtensions(G,q,x,Y,te){const ce=(V,U,F)=>{if(V.isValid&&!U.isValid)return!1;if(V.isValid===U.isValid){if(te&&h.gt(V.manifest.version,U.manifest.version))return this.logService.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(h.eq(V.manifest.version,U.manifest.version)){if(V.type===0)return this.logService.debug(`Skipping extension ${U.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===Y)return this.logService.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return F?this.logService.warn(`Overwriting user extension ${V.location.path} with ${U.location.path}.`):this.logService.debug(`Overwriting user extension ${V.location.path} with ${U.location.path}.`),!0},z=new Map;return G?.forEach(V=>{const U=l.ExtensionIdentifier.toKey(V.identifier.id),F=z.get(U);(!F||ce(F,V,!1))&&z.set(U,V)}),q?.forEach(V=>{const U=l.ExtensionIdentifier.toKey(V.identifier.id),F=z.get(U);if(!F&&G&&V.type===0){this.logService.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!F||ce(F,V,!1))&&z.set(U,V)}),x?.forEach(V=>{const U=l.ExtensionIdentifier.toKey(V.identifier.id),F=z.get(U);(!F||ce(F,V,!0))&&z.set(U,V),z.set(U,V)}),[...z.values()]}async scanDefaultSystemExtensions(G,q){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,q),te=await(G&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",te.length),te}async scanDevSystemExtensions(G,q){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const Y=q?await this.getBuiltInExtensionControl():{},te=[],ce=p.URI.file(S.normalize(S.join(b.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions")));for(const V of x){const U=Y[V.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":te.push((0,v.joinPath)(ce,V.name));break;default:te.push(p.URI.file(U));break}}const z=await Promise.all(te.map(async V=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(V,!1,0,!0,G))));return this.logService.trace("Scanned dev system extensions:",z.length),(0,R.coalesce)(z)}async getBuiltInExtensionControl(){try{const G=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(G.value.toString())}catch{return{}}}async createExtensionScannerInput(G,q,x,Y,te,ce=!0){const z=await this.getTranslations(te??m.language),V=await this.getMtime(G),U=q?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,F=U?await this.getMtime(U):void 0;return new k(G,V,U,F,q,x,Y,ce,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,te,z)}async getMtime(G){try{const q=await this.fileService.stat(G);if(typeof q.mtime=="number")return q.mtime}catch{}}};O=pe([K(4,w.IUserDataProfilesService),K(5,f.IExtensionsProfileScannerService),K(6,s.IFileService),K(7,n.ILogService),K(8,a.IEnvironmentService),K(9,o.IProductService),K(10,t.IInstantiationService)],O),e.AbstractExtensionsScannerService=O;class k{constructor(G,q,x,Y,te,ce,z,V,U,F,j,B,Z,oe){this.location=G,this.mtime=q,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=Y,this.profile=te,this.type=ce,this.excludeObsolete=z,this.validate=V,this.productVersion=U,this.productDate=F,this.productCommit=j,this.devMode=B,this.language=Z,this.translations=oe}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,q){return(0,v.isEqual)(G.location,q.location)&&G.mtime===q.mtime&&(0,v.isEqual)(G.applicationExtensionslocation,q.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===q.applicationExtensionslocationMtime&&G.profile===q.profile&&G.type===q.type&&G.excludeObsolete===q.excludeObsolete&&G.validate===q.validate&&G.productVersion===q.productVersion&&G.productDate===q.productDate&&G.productCommit===q.productCommit&&G.devMode===q.devMode&&G.language===q.language&&A.equals(G.translations,q.translations)}}let M=class extends C.Disposable{constructor(G,q,x,Y,te){super(),this.obsoleteFile=G,this.extensionsProfileScannerService=q,this.uriIdentityService=x,this.fileService=Y,this.logService=te}async scanExtensions(G){const q=G.profile?await this.scanExtensionsFromProfile(G):await this.scanExtensionsFromLocation(G);let x={};if(G.excludeObsolete&&G.type===1)try{const Y=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(Y)}catch{}return(0,P.isEmptyObject)(x)?q:q.filter(Y=>!x[d.ExtensionKey.create(Y).toString()])}async scanExtensionsFromLocation(G){const q=await this.fileService.resolve(G.location);if(!q.children?.length)return[];const x=await Promise.all(q.children.map(async Y=>{if(!Y.isDirectory||G.type===1&&(0,v.basename)(Y.resource).indexOf(".")===0)return null;const te=new k(Y.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(te)}));return(0,R.coalesce)(x).sort((Y,te)=>Y.location.path<te.location.path?-1:1)}async scanExtensionsFromProfile(G){let q=await this.scanExtensionsFromProfileResource(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(G.location,G.applicationExtensionslocation)){q=q.filter(Y=>!Y.metadata?.isApplicationScoped);const x=await this.scanExtensionsFromProfileResource(G.applicationExtensionslocation,Y=>!!Y.metadata?.isApplicationScoped,G);q.push(...x)}return q}async scanExtensionsFromProfileResource(G,q,x){const Y=await this.extensionsProfileScannerService.scanProfileExtensions(G);if(!Y.length)return[];const te=await Promise.all(Y.map(async ce=>{if(q(ce)){const z=new k(ce.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(z,ce.metadata)}return null}));return(0,R.coalesce)(te)}async scanOneOrMultipleExtensions(G){try{if(await this.fileService.exists((0,v.joinPath)(G.location,"package.json"))){const q=await this.scanExtension(G);return q?[q]:[]}else return await this.scanExtensions(G)}catch(q){return this.logService.error(`Error scanning extensions at ${G.location.path}:`,(0,T.getErrorMessage)(q)),[]}}async scanExtension(G,q){try{let x=await this.scanExtensionManifest(G.location);if(x){x.publisher||(x.publisher=l.UNDEFINED_PUBLISHER),q=q??x.__metadata,delete x.__metadata;const Y=(0,d.getGalleryExtensionId)(x.publisher,x.name),te=q?.id?{id:Y,uuid:q.id}:{id:Y},ce=q?.isSystem?0:G.type,z=ce===0||!!q?.isBuiltin;x=await this.translateManifest(G.location,x,k.createNlsConfiguration(G));const V={type:ce,identifier:te,manifest:x,location:G.location,isBuiltin:z,targetPlatform:q?.targetPlatform??"undefined",metadata:q,isValid:!0,validations:[]};return G.validate?this.validate(V,G):V}}catch(x){G.type!==0&&this.logService.error(x)}return null}validate(G,q){let x=!0;const Y=(0,i.validateExtensionManifest)(q.productVersion,q.productDate,q.location,G.manifest,G.isBuiltin);for(const[te,ce]of Y)te===y.default.Error&&(x=!1,this.logService.error(this.formatMessage(q.location,ce)));return G.isValid=x,G.validations=Y,G}async scanExtensionManifest(G){const q=(0,v.joinPath)(G,"package.json");let x;try{x=(await this.fileService.readFile(q)).value.toString()}catch(te){return(0,s.toFileOperationResult)(te)!==1&&this.logService.error(this.formatMessage(G,(0,g.localize)(0,null,q.path,te.message))),null}let Y;try{Y=JSON.parse(x)}catch{const ce=[];(0,I.parse)(x,ce);for(const z of ce)this.logService.error(this.formatMessage(G,(0,g.localize)(1,null,q.path,z.offset,z.length,(0,E.getParseErrorMessage)(z.error))));return null}return(0,I.getNodeType)(Y)!=="object"?(this.logService.error(this.formatMessage(G,(0,g.localize)(2,null,q.path))),null):Y}async translateManifest(G,q,x){const Y=await this.getLocalizedMessages(G,q,x);if(Y)try{const te=[],ce=await this.resolveOriginalMessageBundle(Y.default,te);if(te.length>0)return te.forEach(V=>{this.logService.error(this.formatMessage(G,(0,g.localize)(3,null,Y.default?.path,(0,E.getParseErrorMessage)(V.error))))}),q;if((0,I.getNodeType)(Y)!=="object")return this.logService.error(this.formatMessage(G,(0,g.localize)(4,null,Y.default?.path))),q;const z=Y.values||Object.create(null);return(0,N.localizeManifest)(q,z,ce)}catch{}return q}async getLocalizedMessages(G,q,x){const Y=(0,v.joinPath)(G,"package.nls.json"),te=(U,F)=>{F.forEach(j=>{this.logService.error(this.formatMessage(G,(0,g.localize)(5,null,U?.path,(0,E.getParseErrorMessage)(j.error))))})},ce=U=>{this.logService.error(this.formatMessage(G,(0,g.localize)(6,null,U?.path)))},z=`${q.publisher}.${q.name}`,V=x.translations[z];if(V)try{const U=p.URI.file(V),F=(await this.fileService.readFile(U)).value.toString(),j=[],B=(0,I.parse)(F,j);return j.length>0?(te(U,j),{values:void 0,default:Y}):(0,I.getNodeType)(B)!=="object"?(ce(U),{values:void 0,default:Y}):{values:B.contents?B.contents.package:void 0,default:Y}}catch{return{values:void 0,default:Y}}else{if(!await this.fileService.exists(Y))return;let F;try{F=await this.findMessageBundles(G,x)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const j=(await this.fileService.readFile(F.localized)).value.toString(),B=[],Z=(0,I.parse)(j,B);return B.length>0?(te(F.localized,B),{values:void 0,default:F.original}):(0,I.getNodeType)(Z)!=="object"?(ce(F.localized),{values:void 0,default:F.original}):{values:Z,default:F.original}}catch{return{values:void 0,default:F.original}}}}async resolveOriginalMessageBundle(G,q){if(G)try{const x=(await this.fileService.readFile(G)).value.toString();return(0,I.parse)(x,q)}catch{}}findMessageBundles(G,q){return new Promise((x,Y)=>{const te=ce=>{const z=(0,v.joinPath)(G,`package.nls.${ce}.json`);this.fileService.exists(z).then(V=>{V&&x({localized:z,original:(0,v.joinPath)(G,"package.nls.json")});const U=ce.lastIndexOf("-");U===-1?x({localized:(0,v.joinPath)(G,"package.nls.json"),original:null}):(ce=ce.substring(0,U),te(ce))})};if(q.devMode||q.pseudo||!q.language)return x({localized:(0,v.joinPath)(G,"package.nls.json"),original:null});te(q.language)})}formatMessage(G,q){return`[${G.path}]: ${q}`}};M=pe([K(1,f.IExtensionsProfileScannerService),K(2,_.IUriIdentityService),K(3,s.IFileService),K(4,n.ILogService)],M);let $=class extends M{constructor(G,q,x,Y,te,ce){super(q,x,Y,te,ce),this.cacheFile=G,this.cacheValidatorThrottler=this._register(new r.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(G){const q=await this.readExtensionCache();if(this.input=G,q&&q.input&&k.equals(q.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),q.result.map(Y=>(Y.location=p.URI.revive(Y.location),Y));const x=await super.scanExtensions(G);return await this.writeExtensionCache({input:G,result:x}),x}async readExtensionCache(){try{const G=await this.fileService.readFile(this.cacheFile),q=JSON.parse(G.value.toString());return{result:q.result,input:(0,u.revive)(q.input)}}catch(G){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(G))}return null}async writeExtensionCache(G){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify(G)))}catch(q){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(q))}}async validateCache(){if(!this.input)return;const G=await this.readExtensionCache();if(!G)return;const q=G.result,x=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!D.equals(x,q))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(Y){this.logService.error(Y)}}};$=pe([K(2,f.IExtensionsProfileScannerService),K(3,_.IUriIdentityService),K(4,s.IFileService),K(5,n.ILogService)],$);function W(H,G){const q=(0,d.getExtensionId)(H.manifest.publisher,H.manifest.name);return{id:q,identifier:new l.ExtensionIdentifier(q),isBuiltin:H.type===0,isUserBuiltin:H.type===1&&H.isBuiltin,isUnderDevelopment:G,extensionLocation:H.location,uuid:H.identifier.uuid,targetPlatform:H.targetPlatform,...H.manifest}}e.toExtensionDescription=W;class J extends O{constructor(G,q,x,Y,te,ce,z,V,U,F,j){super(G,q,(0,v.joinPath)(x,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(Y,l.MANIFEST_CACHE_FOLDER),te,ce,z,V,U,F,j),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const B=await this.fileService.readFile(p.URI.file(m.translationsConfigFile));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}getTranslations(G){return this.translationsPromise}}e.NativeExtensionsScannerService=J}),define(ne[250],re([0,1,54,6,38,3,2,21,12,28,8,23]),function(Q,e,R,r,D,L,T,I,E,C,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends T.Disposable{constructor(h,y){super(),this.userDataProfilesService=h,this.logService=y,this.processesLimiter=new r.Limiter(5)}async postUninstall(h){const y=this.parseScript(h,"uninstall");return y&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),P=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${P}`)))),C.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,P=>this.logService.error("Error while removing extension storage path",P))}parseScript(h,y){const P=`vscode:${y}`;if(h.location.scheme===I.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[P]=="string"){const p=h.manifest.scripts[P].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${P} should be a node script`),null):{script:(0,E.join)(h.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(h,y,P,p,g){return new Promise((a,d)=>{const l=this.start(h,y,P,g);let i;const s=t=>{i&&(clearTimeout(i),i=null),t?d(t):a(void 0)};l.on("error",t=>{s((0,D.toErrorMessage)(t)||"Unknown")}),l.on("exit",(t,n)=>{s(t?`post-${y} process exited with code ${t}`:void 0)}),p&&(i=setTimeout(()=>{i=null,l.kill(),d("timed out")},5e3))})}start(h,y,P,p){const g={silent:!0,execArgv:void 0},a=(0,R.fork)(h,[`--type=extension-post-${y}`,...P],g);a.stdout.setEncoding("utf8"),a.stderr.setEncoding("utf8");const d=L.Event.fromNodeEventEmitter(a.stdout,"data"),l=L.Event.fromNodeEventEmitter(a.stderr,"data");d(t=>this.logService.info(p.identifier.id,p.manifest.version,`post-${y}`,t)),l(t=>this.logService.error(p.identifier.id,p.manifest.version,`post-${y}`,t));const i=L.Event.any(L.Event.map(d,t=>({data:`%c${t}`,format:[""]})),L.Event.map(l,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(p.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),a}getExtensionStoragePath(h){return(0,E.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};m=pe([K(0,S.IUserDataProfilesService),K(1,b.ILogService)],m),e.ExtensionsLifecycle=m}),define(ne[251],re([0,1,7,14,49,74,13,5,8,25,23]),function(Q,e,R,r,D,L,T,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let S=class extends L.NativeExtensionsScannerService{constructor(v,h,y,P,p,g,a){super(R.URI.file(p.builtinExtensionsPath),R.URI.file(p.extensionsPath),p.userHome,R.URI.file(p.userDataPath),v,h,y,P,p,g,a)}};S=pe([K(0,b.IUserDataProfilesService),K(1,D.IExtensionsProfileScannerService),K(2,T.IFileService),K(3,E.ILogService),K(4,r.INativeEnvironmentService),K(5,C.IProductService),K(6,I.IInstantiationService)],S),e.ExtensionsScannerService=S}),define(ne[20],re([0,1,6,3,2,192,15,67,5,23]),function(Q,e,R,r,D,L,T,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,E.createDecorator)("storageService");var b;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function v(g){const a=g.get(e.TARGET_KEY);if(a)try{return JSON.parse(a)}catch{}return Object.create(null)}e.loadKeyTargets=v;class h extends D.Disposable{constructor(a={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=a,this._onDidChangeValue=this._register(new r.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new r.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new r.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(a,d){if(d===e.TARGET_KEY){switch(a){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:a})}else this._onDidChangeValue.fire({scope:a,key:d,target:this.getKeyTargets(a)[d]})}emitWillSaveState(a){this._onWillSaveState.fire({reason:a})}get(a,d,l){return this.getStorage(d)?.get(a,l)}getBoolean(a,d,l){return this.getStorage(d)?.getBoolean(a,l)}getNumber(a,d,l){return this.getStorage(d)?.getNumber(a,l)}store(a,d,l,i){if((0,T.isUndefinedOrNull)(d)){this.remove(a,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(a,l,i),this.getStorage(l)?.set(a,d)})}remove(a,d){this.withPausedEmitters(()=>{this.updateKeyTarget(a,d,void 0),this.getStorage(d)?.delete(a)})}withPausedEmitters(a){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{a()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(a,d){const l=[],i=this.getKeyTargets(a);for(const s of Object.keys(i))i[s]===d&&l.push(s);return l}updateKeyTarget(a,d,l){const i=this.getKeyTargets(d);typeof l=="number"?i[a]!==l&&(i[a]=l,this.getStorage(d)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[a]=="number"&&(delete i[a],this.getStorage(d)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(a){switch(a){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(a){const d=this.getStorage(a);return d?v(d):Object.create(null)}isNew(a){return this.getBoolean(e.IS_NEW_KEY,a)===!0}async flush(a=b.NONE){this._onWillSaveState.fire({reason:a});const d=this.getStorage(-1),l=this.getStorage(0),i=this.getStorage(1);switch(a){case b.NONE:await R.Promises.settled([d?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await R.Promises.settled([d?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const a=this.getStorage(-1)?.items??new Map,d=this.getStorage(0)?.items??new Map,l=this.getStorage(1)?.items??new Map;return p(a,d,l,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(a,d){return this.emitWillSaveState(b.NONE),(0,C.isUserDataProfile)(a)?this.switchToProfile(a,d):this.switchToWorkspace(a,d)}canSwitchProfile(a,d){return!(a.id===d.id||y(d)&&y(a))}switchData(a,d,l,i){this.withPausedEmitters(()=>{if(i)for(const[s,t]of a)d.set(s,t);else{const s=new Set;for(const[t,n]of a)s.add(t),d.get(t)!==n&&this.emitDidChangeValue(l,t);for(const[t]of d.items)s.has(t)||this.emitDidChangeValue(l,t)}})}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;function y(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=y;class P extends h{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(a=>this.emitDidChangeValue(1,a))),this._register(this.profileStorage.onDidChangeStorage(a=>this.emitDidChangeValue(0,a))),this._register(this.applicationStorage.onDidChangeStorage(a=>this.emitDidChangeValue(-1,a)))}getStorage(a){switch(a){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(a){switch(a){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(a){return!1}}e.InMemoryStorageService=P;async function p(g,a,d,l,i,s){const t=A=>{try{return JSON.parse(A)}catch{return A}},n=new Map,o=new Map;g.forEach((A,O)=>{n.set(O,A),o.set(O,t(A))});const c=new Map,u=new Map;a.forEach((A,O)=>{c.set(O,A),u.set(O,t(A))});const f=new Map,w=new Map;d.forEach((A,O)=>{f.set(O,A),w.set(O,t(A))}),console.group(l!==i?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const _=[];if(n.forEach((A,O)=>{_.push({key:O,value:A})}),console.table(_),console.groupEnd(),console.log(o),l!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const A=[];c.forEach((O,k)=>{A.push({key:k,value:O})}),console.table(A),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${s})`);const N=[];f.forEach((A,O)=>{N.push({key:O,value:A})}),console.table(N),console.groupEnd(),console.log(w)}e.logStorage=p}),define(ne[252],re([0,1,3,2,15,29,33,20]),function(Q,e,R,r,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let E=class extends r.Disposable{constructor(S,m){super(),this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new C(S)),this._register(this.storageManger.onDidChange(v=>this._onDidChangeEnablement.fire({extensions:v,source:"storage"}))),this._register(m.onDidInstallExtensions(v=>v.forEach(({local:h,operation:y})=>{h&&y===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(S,m){return this._removeFromDisabledExtensions(S)?(this._onDidChangeEnablement.fire({extensions:[S],source:m}),!0):!1}async disableExtension(S,m){return this._addToDisabledExtensions(S)?(this._onDidChangeEnablement.fire({extensions:[S],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(S){const m=this.getDisabledExtensions();return m.every(v=>!(0,T.areSameExtensions)(v,S))?(m.push(S),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(S){const m=this.getDisabledExtensions();for(let v=0;v<m.length;v++){const h=m[v];if((0,T.areSameExtensions)(h,S))return m.splice(v,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(S){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,S)}_getExtensions(S){return this.storageManger.get(S,0)}_setExtensions(S,m){this.storageManger.set(S,m,0)}};E=pe([K(0,I.IStorageService),K(1,L.IExtensionManagementService)],E),e.GlobalExtensionEnablementService=E;class C extends r.Disposable{constructor(S){super(),this.storageService=S,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(S.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(S,m){let v;return m===0?((0,D.isUndefinedOrNull)(this.storage[S])&&(this.storage[S]=this._get(S,m)),v=this.storage[S]):v=this._get(S,m),JSON.parse(v)}set(S,m,v){const h=JSON.stringify(m.map(({id:P,uuid:p})=>({id:P,uuid:p})));this._get(S,v)!==h&&(v===0&&(m.length?this.storage[S]=h:delete this.storage[S]),this._set(S,m.length?h:void 0,v))}onDidStorageChange(S){if(S.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[S.key])&&this._get(S.key,S.scope)!==this.storage[S.key]){const v=this.get(S.key,S.scope);delete this.storage[S.key];const h=this.get(S.key,S.scope),y=v.filter(p=>!h.some(g=>(0,T.areSameExtensions)(p,g))),P=h.filter(p=>!v.some(g=>(0,T.areSameExtensions)(g,p)));(y.length||P.length)&&this._onDidChange.fire([...y,...P])}}_get(S,m){return this.storageService.get(S,m,"[]")}_set(S,m,v){m?this.storageService.store(S,m,v,1):this.storageService.remove(S,v)}}e.StorageManager=C}),define(ne[253],re([0,1,19,24,9,4,36,15,7,18,14,29,33,68,13,8,25,45,220,20,22]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p,g,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const l=L.isWeb?"web":(0,S.getTargetPlatform)(L.platform,T.arch);var i;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function s(...U){return String(U.reduce((F,j)=>F|j,0))}var t;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class f{constructor(F=u){this.state=F}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(F,j=this.state.pageSize){return new f({...this.state,pageNumber:F,pageSize:j})}withFilter(F,...j){const B=[...this.state.criteria,...j.length?j.map(Z=>({filterType:F,value:Z})):[{filterType:F}]];return new f({...this.state,criteria:B})}withSortBy(F){return new f({...this.state,sortBy:F})}withSortOrder(F){return new f({...this.state,sortOrder:F})}withFlags(...F){return new f({...this.state,flags:F.reduce((j,B)=>j|B,0)})}withAssetTypes(...F){return new f({...this.state,assetTypes:F})}withSource(F){return new f({...this.state,source:F})}get raw(){const{criteria:F,pageNumber:j,pageSize:B,sortBy:Z,sortOrder:oe,flags:X,assetTypes:ie}=this.state;return{filters:[{criteria:F,pageNumber:j,pageSize:B,sortBy:Z,sortOrder:oe}],assetTypes:ie,flags:X}}get searchText(){const F=this.state.criteria.filter(j=>j.filterType===t.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(F=>String(F.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function w(U,F){const j=(U||[]).filter(B=>B.statisticName===F)[0];return j?j.value:0}function _(U){const F="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(B=>B.assetType.indexOf(F)===0).reduce((B,Z)=>{const oe=O(U,Z.assetType);return oe&&B.push([Z.assetType.substring(F.length),oe]),B},[])}function N(U){if(U.properties){const F=U.properties.filter(Z=>Z.key===n.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=F.filter(Z=>j.test(Z.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return O(U,n.Repository)}function A(U){return{uri:`${U.fallbackAssetUri}/${n.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${n.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function O(U,F){return U.files.filter(B=>B.assetType===F)[0]?{uri:`${U.assetUri}/${F}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${F}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function k(U,F){const j=U.properties?U.properties.filter(Z=>Z.key===F):[],B=j.length>0&&j[0].value;return B?B.split(",").map(Z=>(0,m.adoptToGalleryExtensionId)(Z)):[]}function M(U){const F=U.properties?U.properties.filter(j=>j.key===o.Engine):[];return F.length>0&&F[0].value||""}function $(U){const F=U.properties?U.properties.filter(j=>j.key===o.PreRelease):[];return F.length>0&&F[0].value==="true"}function W(U){const F=U.properties?U.properties.filter(B=>B.key===o.LocalizedLanguages):[],j=F.length>0&&F[0].value||"";return j?j.split(","):[]}function J(U){return U.properties?.find(F=>F.key===o.SponsorLink)?.value}function H(U){return U.indexOf("preview")!==-1}function G(U){return U.targetPlatform?(0,S.toTargetPlatform)(U.targetPlatform):"undefined"}function q(U){const F=(0,R.distinct)(U.versions.map(G)),j=!!U.tags?.includes(S.WEB_EXTENSION_TAG),B=F.indexOf("web");return j?B===-1&&F.push("web"):B!==-1&&F.splice(B,1),F}function x(U,F){const j=(0,S.getFallbackTargetPlarforms)(F);for(let B=0;B<U.length;B++){const Z=U[B];if(Z.version===U[B-1]?.version){let oe=B;const X=G(Z);if(X===F)for(;oe>0&&U[oe-1].version===Z.version;)oe--;else if(j.includes(X))for(;oe>0&&U[oe-1].version===Z.version&&G(U[oe-1])!==F;)oe--;oe!==B&&(U.splice(B,1),U.splice(oe,0,Z))}}return U}e.sortExtensionVersions=x;function Y(U,F,j){U.telemetryData={index:F,querySource:j}}function te(U,F,j){const B=U.versions[0],Z={manifest:O(F,n.Manifest),readme:O(F,n.Details),changelog:O(F,n.Changelog),license:O(F,n.License),repository:N(F),download:A(F),icon:O(F,n.Icon),coreTranslations:_(F)};return{identifier:{id:(0,m.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:F.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(B),description:U.shortDescription||"",installCount:w(U.statistics,"install"),rating:w(U.statistics,"averagerating"),ratingCount:w(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:j,assets:Z,properties:{dependencies:k(F,o.Dependency),extensionPack:k(F,o.ExtensionPack),engine:M(F),localizedLanguages:W(F),targetPlatform:G(F),isPreReleaseVersion:$(F)},hasPreReleaseVersion:$(B),hasReleaseVersion:!0,preview:H(U.flags)}}let ce=class{constructor(F,j,B,Z,oe,X,ie,se){this.requestService=j,this.logService=B,this.environmentService=Z,this.telemetryService=oe,this.fileService=X,this.productService=ie,this.configurationService=se;const ue=ie.extensionsGallery;this.extensionsGalleryUrl=ue&&ue.serviceUrl,this.extensionsControlUrl=ue&&ue.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,F,this.telemetryService)}api(F=""){return`${this.extensionsGalleryUrl}${F}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(F,j,B){const Z=r.CancellationToken.isCancellationToken(j)?{}:j,oe=r.CancellationToken.isCancellationToken(j)?j:B,X=[],ie=[],se=[],ue=[];let he=!0;for(const Ee of F){Ee.uuid?ie.push(Ee.uuid):X.push(Ee.id);const Pe=!!(Ee.version||Ee.preRelease);se.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Pe}),Ee.version&&ue.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),he=he&&!!Ee.hasPreRelease&&!Pe}if(!ie.length&&!X.length)return[];let ve=new f().withPage(1,F.length);ie.length&&(ve=ve.withFilter(t.ExtensionId,...ie)),X.length&&(ve=ve.withFilter(t.ExtensionName,...X)),(Z.queryAllVersions||he)&&(ve=ve.withFlags(ve.flags,i.IncludeVersions)),Z.source&&(ve=ve.withSource(Z.source));const{extensions:we}=await this.queryGalleryExtensions(ve,{targetPlatform:Z.targetPlatform??l,includePreRelease:se,versions:ue,compatible:!!Z.compatible},oe);return Z.source&&we.forEach((Ee,Pe)=>Y(Ee,Pe,Z.source)),we}async getCompatibleExtension(F,j,B){if((0,S.isNotWebExtensionInWebTargetPlatform)(F.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(F,j,B))return F;const Z=new f().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,F.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(Z,{targetPlatform:B,compatible:!0,includePreRelease:j},r.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(F,j,B){if(!(0,S.isTargetPlatformCompatible)(F.properties.targetPlatform,F.allTargetPlatforms,B)||!j&&F.properties.isPreReleaseVersion)return!1;let Z=F.properties.engine;if(!Z){const oe=await this.getManifest(F,r.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");Z=oe.engines.vscode}return(0,v.isEngineValid)(Z,this.productService.version,this.productService.date)}async isValidVersion(F,j,B,Z,oe){if(!(0,S.isTargetPlatformCompatible)(G(F),Z,oe)||j!=="any"&&$(F)!==(j==="prerelease"))return!1;if(B)try{const X=await this.getEngine(F);if(!(0,v.isEngineValid)(X,this.productService.version,this.productService.date))return!1}catch(X){return this.logService.error(`Error while getting the engine for the version ${F.version}.`,(0,D.getErrorMessage)(X)),!1}return!0}async query(F,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=F.text||"";const Z=F.pageSize??50;let oe=new f().withPage(1,Z);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ve,we)=>(oe=oe.withFilter(t.Category,we||ve),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ve,we)=>(oe=oe.withFilter(t.Tag,we||ve),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(t.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),oe=oe.withFilter(t.SearchText,B)),oe=oe.withSortBy(0)):F.ids?oe=oe.withFilter(t.ExtensionId,...F.ids):F.names?oe=oe.withFilter(t.ExtensionName,...F.names):oe=oe.withSortBy(4),typeof F.sortBy=="number"&&(oe=oe.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(oe=oe.withSortOrder(F.sortOrder)),F.source&&(oe=oe.withSource(F.source));const X=async(he,ve)=>{const{extensions:we,total:Ee}=await this.queryGalleryExtensions(he,{targetPlatform:l,compatible:!1,includePreRelease:!!F.includePreRelease},ve);return we.forEach((Pe,Ue)=>Y(Pe,(he.pageNumber-1)*he.pageSize+Ue,F.source)),{extensions:we,total:Ee}},{extensions:ie,total:se}=await X(oe,j),ue=async(he,ve)=>{if(ve.isCancellationRequested)throw new D.CancellationError;const{extensions:we}=await X(oe.withPage(he+1),ve);return we};return{firstPage:ie,total:se,pageSize:oe.pageSize,getPage:ue}}async queryGalleryExtensions(F,j,B){const Z=F.flags;!!(F.flags&i.IncludeLatestVersionOnly)&&!!(F.flags&i.IncludeVersions)&&(F=F.withFlags(F.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(F.flags&i.IncludeLatestVersionOnly)&&!(F.flags&i.IncludeVersions)&&(F=F.withFlags(F.flags,i.IncludeLatestVersionOnly)),j.versions?.length&&(F=F.withFlags(F.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),F=F.withFlags(F.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:oe,total:X}=await this.queryRawGalleryExtensions(F,B);if(!(F.flags&i.IncludeLatestVersionOnly)){const he=[];for(const ve of oe){const we=await this.toGalleryExtensionWithCriteria(ve,j);we&&he.push(we)}return{extensions:he,total:X}}const se=[],ue=new Map;for(let he=0;he<oe.length;he++){const ve=oe[he],we={id:(0,m.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},Ee=(0,I.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(Ue=>(0,m.areSameExtensions)(Ue,we))?.includePreRelease;if(j.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(q(ve),j.targetPlatform))continue;const Pe=await this.toGalleryExtensionWithCriteria(ve,j);!Pe||Pe.properties.isPreReleaseVersion&&(!Ee||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==j.targetPlatform&&Pe.hasPreReleaseVersion?ue.set(ve.extensionId,he):se.push([he,Pe])}if(ue.size){const he=new Date().getTime(),ve=new f().withFlags(Z&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ue.size).withFilter(t.ExtensionId,...ue.keys()),{extensions:we}=await this.queryGalleryExtensions(ve,j,B);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-he,count:ue.size});for(const Ee of we){const Pe=ue.get(Ee.identifier.uuid);se.push([Pe,Ee])}}return{extensions:se.sort((he,ve)=>he[0]-ve[0]).map(([,he])=>he),total:X}}async toGalleryExtensionWithCriteria(F,j){const B={id:(0,m.getGalleryExtensionId)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},Z=j.versions?.find(se=>(0,m.areSameExtensions)(se,B))?.version,oe=(0,I.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(se=>(0,m.areSameExtensions)(se,B))?.includePreRelease,X=q(F),ie=x(F.versions,j.targetPlatform);if(j.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(X,j.targetPlatform))return null;for(let se=0;se<ie.length;se++){const ue=ie[se];if(!(Z&&ue.version!==Z)){if(await this.isValidVersion(ue,oe?"any":"release",j.compatible,X,j.targetPlatform))return te(F,ue,X);if(Z&&ue.version===Z)return null}}return Z||j.compatible?null:te(F,F.versions[0],X)}async queryRawGalleryExtensions(F,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(i.Unpublished));const B=await this.commonHeadersPromise,Z=JSON.stringify(F.raw),oe={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},X=new Date().getTime();let ie,se,ue=0;try{if(ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:oe},j),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ue};const he=await(0,p.asJson)(ie);if(he){const ve=he.results[0],we=ve.extensions,Ee=ve.resultMetadata&&ve.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return ue=Ee&&Ee.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ue}}return{galleryExtensions:[],total:ue}}catch(he){throw se=he,he}finally{this.telemetryService.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-X,success:!!ie&&(0,p.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:se?(0,D.isCancellationError)(se)?"canceled":(0,D.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(F,j,B,Z){if(!this.isEnabled())return;const oe=L.isWeb?this.api(`/itemName/${F}.${j}/version/${B}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${F}/extensions/${j}/${B}/stats?statType=${Z}`),X=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.commonHeadersPromise,Accept:X};try{await this.requestService.request({type:"POST",url:oe,headers:se},r.CancellationToken.None)}catch{}}async download(F,j,B){this.logService.trace("ExtensionGalleryService#download",F.identifier.id);const Z=(0,m.getGalleryExtensionTelemetryData)(F),oe=new Date().getTime(),X=he=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Z,duration:he}),ie=B===2?"install":B===3?"update":"",se=ie?{uri:`${F.assets.download.uri}${E.URI.parse(F.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${F.assets.download.fallbackUri}${E.URI.parse(F.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:F.assets.download,ue=await this.getAsset(se);await this.fileService.writeFile(j,ue.stream),X(new Date().getTime()-oe)}async getReadme(F,j){if(F.assets.readme){const B=await this.getAsset(F.assets.readme,{},j);return await(0,p.asTextOrError)(B)||""}return""}async getManifest(F,j){if(F.assets.manifest){const B=await this.getAsset(F.assets.manifest,{},j),Z=await(0,p.asTextOrError)(B);return Z?JSON.parse(Z):null}return null}async getManifestFromRawExtensionVersion(F,j){const B=O(F,n.Manifest);if(!B)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},oe=await this.getAsset(B,{headers:Z});return await(0,p.asJson)(oe)}async getCoreTranslation(F,j){const B=F.assets.coreTranslations.filter(Z=>Z[0]===j.toUpperCase())[0];if(B){const Z=await this.getAsset(B[1]),oe=await(0,p.asTextOrError)(Z);return oe?JSON.parse(oe):null}return null}async getChangelog(F,j){if(F.assets.changelog){const B=await this.getAsset(F.assets.changelog,{},j);return await(0,p.asTextOrError)(B)||""}return""}async getAllCompatibleVersions(F,j,B){let Z=new f().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);F.identifier.uuid?Z=Z.withFilter(t.ExtensionId,F.identifier.uuid):Z=Z.withFilter(t.ExtensionName,F.identifier.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(Z,r.CancellationToken.None);if(!oe.length)return[];const X=q(oe[0]);if((0,S.isNotWebExtensionInWebTargetPlatform)(X,B))return[];const ie=[];await Promise.all(oe[0].versions.map(async he=>{try{await this.isValidVersion(he,j?"any":"release",!0,X,B)&&ie.push(he)}catch{}}));const se=[],ue=new Set;for(const he of x(ie,B))ue.has(he.version)||(ue.add(he.version),se.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:$(he)}));return se}async getAsset(F,j={},B=r.CancellationToken.None){const Z=await this.commonHeadersPromise,oe={type:"GET"},X={...Z,...j.headers||{}};j={...j,...oe,headers:X};const ie=F.uri,se=F.fallbackUri,ue={...j,url:ie};try{const he=await this.requestService.request(ue,B);if(he.res.statusCode===200)return he;const ve=await(0,p.asTextOrError)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${ve}`)}catch(he){if((0,D.isCancellationError)(he))throw he;const ve=(0,D.getErrorMessage)(he);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:ve});const we={...j,url:se};return this.requestService.request(we,B)}}async getEngine(F){let j=M(F);if(!j){const B=await this.getManifestFromRawExtensionVersion(F,r.CancellationToken.None);if(!B)throw new Error("Manifest was not found");j=B.engines.vscode}return j}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const F=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},r.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,p.asJson)(F),B=[],Z={};if(j){for(const oe of j.malicious)B.push({id:oe});if(j.migrateToPreRelease)for(const[oe,X]of Object.entries(j.migrateToPreRelease))(!X.engine||(0,v.isEngineValid)(X.engine,this.productService.version,this.productService.date))&&(Z[oe.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(j.deprecated)for(const[oe,X]of Object.entries(j.deprecated))X&&(Z[oe.toLowerCase()]=(0,I.isBoolean)(X)?{}:X)}return{malicious:B,deprecated:Z}}};ce=pe([K(1,p.IRequestService),K(2,y.ILogService),K(3,b.IEnvironmentService),K(4,d.ITelemetryService),K(5,h.IFileService),K(6,P.IProductService),K(7,C.IConfigurationService)],ce);let z=class extends ce{constructor(F,j,B,Z,oe,X,ie,se){super(F,j,B,Z,oe,X,ie,se)}};z=pe([K(0,a.IStorageService),K(1,p.IRequestService),K(2,y.ILogService),K(3,b.IEnvironmentService),K(4,d.ITelemetryService),K(5,h.IFileService),K(6,P.IProductService),K(7,C.IConfigurationService)],z),e.ExtensionGalleryService=z;let V=class extends ce{constructor(F,j,B,Z,oe,X,ie){super(void 0,F,j,B,Z,oe,X,ie)}};V=pe([K(0,p.IRequestService),K(1,y.ILogService),K(2,b.IEnvironmentService),K(3,d.ITelemetryService),K(4,h.IFileService),K(5,P.IProductService),K(6,C.IConfigurationService)],V),e.ExtensionGalleryServiceWithNoStorageService=V}),define(ne[75],re([0,1,5,3,2,20,33,25,19,8,15]),function(Q,e,R,r,D,L,T,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,R.createDecorator)("IExtensionStorageService");const S=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class Qe extends D.Disposable{constructor(h,y,P){super(),this.storageService=h,this.productService=y,this.logService=P,this._onDidChangeExtensionStorageToSync=this._register(new r.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Qe.readAllExtensionsWithKeysForSync(h),this._register(this.storageService.onDidChangeValue(p=>this.onDidChangeStorageValue(p)))}static toKey(h){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const y=S.exec(h);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(h,y){const P=await h.getInstalled(),p=[];for(const[g,a]of Qe.readAllExtensionsWithKeysForSync(y)){const d=P.find(l=>(0,T.areSameExtensions)(l.identifier,{id:g}))?.manifest.version;for(const l of a)d!==l&&p.push(Qe.toKey({id:g,version:l}))}for(const g of p)y.remove(g,0)}static readAllExtensionsWithKeysForSync(h){const y=new Map,P=h.keys(0,1);for(const p of P){const g=Qe.fromKey(p);if(g){let a=y.get(g.id.toLowerCase());a||y.set(g.id.toLowerCase(),a=[]),a.push(g.version)}}return y}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const y=Qe.fromKey(h.key);if(y){if(this.storageService.get(h.key,0)===void 0)this.extensionsWithKeysForSync.delete(y.id.toLowerCase());else{let P=this.extensionsWithKeysForSync.get(y.id.toLowerCase());P||this.extensionsWithKeysForSync.set(y.id.toLowerCase(),P=[]),P.push(y.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(h){if((0,b.isString)(h))return h;const y=h.manifest?h.manifest.publisher:h.publisher,P=h.manifest?h.manifest.name:h.name;return(0,T.getExtensionId)(y,P)}getExtensionState(h,y){const P=this.getExtensionId(h),p=this.storageService.get(P,y?0:1);if(p)try{return JSON.parse(p)}catch(g){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${P}, global: ${y}): ${g}`)}}setExtensionState(h,y,P){const p=this.getExtensionId(h);y===void 0?this.storageService.remove(p,P?0:1):this.storageService.store(p,JSON.stringify(y),P?0:1,1)}setKeysForSync(h,y){this.storageService.store(Qe.toKey(h),JSON.stringify(y),0,1)}getKeysForSync(h){const y=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],P=this.storageService.get(Qe.toKey(h),0),p=P?JSON.parse(P):void 0;return p&&y?(0,E.distinct)([...p,...y]):p||y}addToMigrationList(h,y){if(h!==y){const P=this.migrationList.filter(p=>!p.includes(h)&&!p.includes(y));P.push([h,y]),this.migrationList=P}}getSourceExtensionToMigrate(h){const y=this.migrationList.find(([,P])=>h===P);return y?y[0]:void 0}get migrationList(){const h=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(h);if(Array.isArray(y))return y}catch{}return[]}set migrationList(h){h.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(h),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};m=pe([K(0,L.IStorageService),K(1,I.IProductService),K(2,C.ILogService)],m),e.ExtensionStorageService=m}),define(ne[254],re([0,1,19,6,3,12,4,36,7,147,14,29,33,211,94,13,8,59,25,45,20,22]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p,g,a,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const i="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let t=class extends v.ExtensionTipsService{constructor(o,c,u,f,w,_,N,A,O,k){super(N,A,O,k),this.environmentService=o,this.telemetryService=c,this.extensionManagementService=u,this.storageService=f,this.nativeHostService=w,this.extensionRecommendationNotificationService=_,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,A.exeBasedExtensionTips&&Object.entries(A.exeBasedExtensionTips).forEach(([M,$])=>{const W=[],J=[],H=[];Object.entries($.recommendations).forEach(([G,q])=>{q.important?$.important?W.push({extensionId:G,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):J.push({extensionId:G,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):H.push({extensionId:G,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),W.length&&this.highImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:W}),J.length&&this.mediumImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:J}),H.length&&this.allOtherExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:H})}),(0,r.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,u)}groupImportantTipsByExe(o,c){const u=new Map;o.forEach(A=>u.set(A.extensionId.toLowerCase(),A));const{installed:f,uninstalled:w}=this.groupByInstalled([...u.keys()],c);for(const A of f){const O=u.get(A);O&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:A,exeName:O.exeName})}for(const A of w){const O=u.get(A);O&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:A,exeName:O.exeName})}const _=this.getPromptedExecutableTips(),N=new Map;for(const A of w){const O=u.get(A);if(O&&(!_[O.exeName]||!_[O.exeName].includes(O.extensionId))){let k=N.get(O.exeName);k||(k=[],N.set(O.exeName,k)),k.push(O)}}return N}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const f=D.Event.once(D.Event.latch(D.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(f(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const f=this._register((0,r.disposableTimeout)(()=>{f.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),c=Date.now()-o,u=7*24*60*60*1e3;if(c<u){const _=this._register((0,r.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},u-c));return}const[f,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(_=>{switch(_){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(f),this.addToRecommendedExecutables(w[0].exeName,w);const N=this._register((0,r.disposableTimeout)(()=>{N.dispose(),this.promptMediumImportanceExeBasedTip()},u));break}case"ignored":this.mediumImportanceTipsByExe.delete(f),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const N=D.Event.once(D.Event.latch(D.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(N(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const N=this._register((0,r.disposableTimeout)(()=>{N.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(o){const c=await this.extensionManagementService.getInstalled(1),u=o.filter(w=>!w.whenNotInstalled||w.whenNotInstalled.every(_=>c.every(N=>!(0,m.areSameExtensions)(N.identifier,{id:_})))).map(({extensionId:w})=>w.toLowerCase()),f=(0,C.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(u,f,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(s,-1);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(s,o,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(i,-1,"{}"))}addToRecommendedExecutables(o,c){const u=this.getPromptedExecutableTips();u[o]=c.map(({extensionId:f})=>f.toLowerCase()),this.storageService.store(i,JSON.stringify(u),-1,0)}groupByInstalled(o,c){const u=[],f=[],w=c.reduce((_,N)=>(_.add(N.identifier.id.toLowerCase()),_),new Set);return o.forEach(_=>{w.has(_.toLowerCase())?u.push(_):f.push(_)}),{installed:u,uninstalled:f}}async getValidExecutableBasedExtensionTips(o){const c=[],u=new Map;for(const f of o.keys()){const w=o.get(f);if(!w||!(0,R.isNonEmptyArray)(w.recommendations))continue;const _=[];T.isWindows?w.windowsPath&&_.push(w.windowsPath.replace("%USERPROFILE%",I.env.USERPROFILE).replace("%ProgramFiles(x86)%",I.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",I.env.ProgramFiles).replace("%APPDATA%",I.env.APPDATA).replace("%WINDIR%",I.env.WINDIR)):(_.push((0,L.join)("/usr/local/bin",f)),_.push((0,L.join)("/usr/bin",f)),_.push((0,L.join)(this.environmentService.userHome.fsPath,f)));for(const N of _){let A=u.get(N);if(A===void 0&&(A=await this.fileService.exists(E.URI.file(N)),u.set(N,A)),A)for(const{extensionId:O,extensionName:k,isExtensionPack:M,whenNotInstalled:$}of w.recommendations)c.push({extensionId:O,extensionName:k,isExtensionPack:M,exeName:f,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath,whenNotInstalled:$})}}return c}};t=pe([K(0,b.INativeEnvironmentService),K(1,l.ITelemetryService),K(2,S.IExtensionManagementService),K(3,d.IStorageService),K(4,p.INativeHostService),K(5,h.IExtensionRecommendationNotificationService),K(6,y.IFileService),K(7,g.IProductService),K(8,a.IRequestService),K(9,P.ILogService)],t),e.ExtensionTipsService=t}),define(ne[255],re([0,1,6,2,17,67,20,71,23]),function(Q,e,R,r,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class C extends T.AbstractStorageService{constructor(S,m,v,h){super(),this.initialWorkspace=S,this.initialProfiles=m,this.mainProcessService=v,this.environmentService=h,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new r.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new r.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const S=this._register(new I.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),m=this._register(new L.Storage(S));return this._register(m.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v))),m}createProfileStorage(S){this.profileStorageDisposables.clear(),this.profileStorageProfile=S;let m;if((0,T.isProfileUsingDefaultStorage)(S))m=this.applicationStorage;else{const v=this.profileStorageDisposables.add(new I.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),S));m=this.profileStorageDisposables.add(new L.Storage(v))}return this.profileStorageDisposables.add(m.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),m}createWorkspaceStorage(S){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=S?.id;let m;if(S){const v=this.workspaceStorageDisposables.add(new I.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),S));m=this.workspaceStorageDisposables.add(new L.Storage(v)),this.workspaceStorageDisposables.add(m.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)))}return m}async doInitialize(){await R.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(S){switch(S){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(S){switch(S){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,D.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(S,m){if(!this.canSwitchProfile(this.profileStorageProfile,S))return;const v=this.profileStorage,h=v.items;v!==this.applicationStorage&&await v.close(),this.profileStorage=this.createProfileStorage(S),await this.profileStorage.init(),this.switchData(h,this.profileStorage,0,m)}async switchToWorkspace(S,m){const v=this.workspaceStorage,h=v?.items??new Map;await v?.close(),this.workspaceStorage=this.createWorkspaceStorage(S),await this.workspaceStorage.init(),this.switchData(h,this.workspaceStorage,1,m)}hasScope(S){return(0,E.isUserDataProfile)(S)?this.profileStorageProfile.id===S.id:this.workspaceStorageId===S.id}}e.NativeStorageService=C}),define(ne[256],re([0,1,3,2,17,14,58,23]),function(Q,e,R,r,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let E=class extends r.Disposable{constructor(b,S,m){super(),this._profiles=[],this._onDidChangeProfiles=this._register(new R.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.channel=S.getChannel("userDataProfiles"),this.profilesHome=(0,D.joinPath)(m.userRoamingDataHome,"profiles"),this._profiles=b.map(v=>(0,I.reviveProfile)(v,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(v=>{const h=v.added.map(p=>(0,I.reviveProfile)(p,this.profilesHome.scheme)),y=v.removed.map(p=>(0,I.reviveProfile)(p,this.profilesHome.scheme)),P=v.updated.map(p=>(0,I.reviveProfile)(p,this.profilesHome.scheme));this._profiles=v.all.map(p=>(0,I.reviveProfile)(p,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:h,removed:y,updated:P,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}async createNamedProfile(b,S,m){const v=await this.channel.call("createNamedProfile",[b,S,m]);return(0,I.reviveProfile)(v,this.profilesHome.scheme)}async createProfile(b,S,m,v,h){const y=await this.channel.call("createProfile",[b,S,m,v,h]);return(0,I.reviveProfile)(y,this.profilesHome.scheme)}async createTransientProfile(b){const S=await this.channel.call("createTransientProfile",[b]);return(0,I.reviveProfile)(S,this.profilesHome.scheme)}async setProfileForWorkspace(b,S){await this.channel.call("setProfileForWorkspace",[b,S])}removeProfile(b){return this.channel.call("removeProfile",[b])}async updateProfile(b,S,m,v){const h=await this.channel.call("updateProfile",[b,S,m,v]);return(0,I.reviveProfile)(h,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};E=pe([K(1,T.IMainProcessService),K(2,L.IEnvironmentService)],E),e.UserDataProfilesNativeService=E}),define(ne[41],re([0,1,19,6,16,24,3,35,2,27,15,7,162,18,14,13,8,48,20,22,31,26,23]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p,g,a,d,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function s(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=s;let t=class extends E.Disposable{constructor(f,w,_,N,A,O,k,M,$,W,J){super(),this.resource=f,this.fileService=w,this.environmentService=_,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=k,this.telemetryService=M,this.logService=$,this.configurationService=W,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new r.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,C.uppercaseFirstLetter)(this.resource),this.extUri=J.extUri,this.syncFolder=this.extUri.joinPath(_.userDataSyncHome,f),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(f,_,this.extUri),this.currentMachineIdPromise=(0,p.getServiceMachineId)(_,w,N)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const f=await this.syncPreviewPromise;this.syncPreviewPromise=null;const w=await this.performSync(f.remoteUserData,f.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(w)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const f=await this.getLastSyncUserData();(f?await this.hasRemoteChanged(f):!0)&&this._onDidChangeLocal.fire()}}setStatus(f){this._status!==f&&(this._status=f,this._onDidChangStatus.fire(f))}async sync(f,w={}){await this._sync(f,!0,this.getUserDataSyncConfiguration(),w)}async preview(f,w,_={}){return this._sync(f,!1,w,_)}async apply(f,w={}){try{this.syncHeaders={...w};const _=await this.doApply(f);return this.setStatus(_),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(f,w,_,N){try{if(this.syncHeaders={...N},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let A="idle";try{const O=await this.getLastSyncUserData(),k=await this.getLatestRemoteUserData(f,O);return A=await this.performSync(k,O,w,_),A==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):A==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(A)}}finally{this.syncHeaders={}}}async replace(f){const w=await this.resolveContent(f);if(!w)return!1;const _=this.parseSyncData(w);if(!_)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const N=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,N),O=await this.isRemoteDataFromCurrentMachine(A),k=await this.generateSyncPreview({ref:A.ref,syncData:_},N,O,this.getUserDataSyncConfiguration(),L.CancellationToken.None),M=[];for(const $ of k){const W=await this.getAcceptResult($,$.remoteResource,void 0,L.CancellationToken.None),{remoteChange:J}=await this.getAcceptResult($,$.previewResource,$.remoteContent,L.CancellationToken.None);M.push([$,{...W,remoteChange:J!==0?J:2}])}await this.applyResult(A,N,M,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(f){const w=await this.currentMachineIdPromise;return!!f.syncData?.machineId&&f.syncData.machineId===w}async getLatestRemoteUserData(f,w){if(w){const _=f&&f.latest?f.latest[this.resource]:void 0;if(w.ref===_||_===void 0&&w.syncData===null)return w}return this.getRemoteUserData(w)}async performSync(f,w,_,N){if(f.syncData&&f.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,m.localize)(0,null,this.resource,this.version,f.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(f,w,_,N)}catch(A){if(A instanceof l.UserDataSyncError)switch(A.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(f,w,_,N);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),f=await this.getRemoteUserData(null),w=await this.getLastSyncUserData(),this.performSync(f,w,_,N)}throw A}}async doSync(f,w,_,N){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,r.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(f,w,_,N,O)));const A=await this.syncPreviewPromise;return this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":_?await this.doApply(!1):"syncing"}catch(A){throw this.syncPreviewPromise=null,A}}async merge(f){return await this.updateSyncResourcePreview(f,async w=>{const _=await this.getMergeResult(w,L.CancellationToken.None);await this.fileService.writeFile(w.previewResource,D.VSBuffer.fromString(_?.content||""));const N=_&&!_.hasConflicts?await this.getAcceptResult(w,w.previewResource,void 0,L.CancellationToken.None):void 0;return w.acceptResult=N,w.mergeState=_.hasConflicts?"conflict":N?"accepted":"preview",w.localChange=N?N.localChange:_.localChange,w.remoteChange=N?N.remoteChange:_.remoteChange,w}),this.syncPreviewPromise}async accept(f,w){return await this.updateSyncResourcePreview(f,async _=>{const N=await this.getAcceptResult(_,f,w,L.CancellationToken.None);return _.acceptResult=N,_.mergeState="accepted",_.localChange=N.localChange,_.remoteChange=N.remoteChange,_}),this.syncPreviewPromise}async discard(f){return await this.updateSyncResourcePreview(f,async w=>{const _=await this.getMergeResult(w,L.CancellationToken.None);return await this.fileService.writeFile(w.previewResource,D.VSBuffer.fromString(_.content||"")),w.acceptResult=void 0,w.mergeState="preview",w.localChange=_.localChange,w.remoteChange=_.remoteChange,w}),this.syncPreviewPromise}async updateSyncResourcePreview(f,w){if(!this.syncPreviewPromise)return;let _=await this.syncPreviewPromise;const N=_.resourcePreviews.findIndex(({localResource:A,remoteResource:O,previewResource:k})=>this.extUri.isEqual(A,f)||this.extUri.isEqual(O,f)||this.extUri.isEqual(k,f));N!==-1&&(this.syncPreviewPromise=(0,r.createCancelablePromise)(async A=>{const O=[..._.resourcePreviews];return O[N]=await w(O[N]),{..._,resourcePreviews:O}}),_=await this.syncPreviewPromise,this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(f){if(!this.syncPreviewPromise)return"idle";const w=await this.syncPreviewPromise;return w.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":w.resourcePreviews.some(({mergeState:_})=>_!=="accepted")?"syncing":(await this.applyResult(w.remoteUserData,w.lastSyncUserData,w.resourcePreviews.map(_=>[_,_.acceptResult]),f),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(f){const w=f.filter(({mergeState:_})=>_==="conflict");(0,R.equals)(this._conflicts,w,(_,N)=>this.extUri.isEqual(_.previewResource,N.previewResource))||(this._conflicts=w,this._onDidChangeConflicts.fire(w))}async hasPreviouslySynced(){const f=await this.getLastSyncUserData();return!!f&&f.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllResourceRefs(this.resource)).map(({created:w,ref:_})=>({created:w,uri:this.toRemoteBackupResource(_)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:w,ref:_})=>({created:w,uri:this.toLocalBackupResource(_)}))}toRemoteBackupResource(f){return S.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${f}`})}toLocalBackupResource(f){return S.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${f}`})}async getMachineId({uri:f}){const w=this.extUri.basename(f);if(this.extUri.isEqual(f,this.toRemoteBackupResource(w))){const{content:_}=await this.getUserData(w);if(_)return this.parseSyncData(_)?.machineId}}async resolveContent(f){const w=this.extUri.basename(f);if(this.extUri.isEqual(f,this.toRemoteBackupResource(w))){const{content:_}=await this.getUserData(w);return _}return this.extUri.isEqual(f,this.toLocalBackupResource(w))?this.userDataSyncBackupStoreService.resolveContent(this.resource,w):null}async resolvePreviewContent(f){const w=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(w)for(const _ of w.resourcePreviews){if(this.extUri.isEqual(_.acceptedResource,f))return _.acceptResult?_.acceptResult.content:null;if(this.extUri.isEqual(_.remoteResource,f))return _.remoteContent;if(this.extUri.isEqual(_.localResource,f))return _.localContent;if(this.extUri.isEqual(_.baseResource,f))return _.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(f,w,_,N,A){const O=await this.isRemoteDataFromCurrentMachine(f),k=await this.generateSyncPreview(f,w,O,N,A),M=[];for(const $ of k){const W=$.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if($.localChange===0&&$.remoteChange===0)M.push({...$,acceptedResource:W,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const J=_?await this.getMergeResult($,A):void 0;if(A.isCancellationRequested)break;await this.fileService.writeFile($.previewResource,D.VSBuffer.fromString(J?.content||""));const H=J&&!J.hasConflicts?await this.getAcceptResult($,$.previewResource,void 0,A):void 0;M.push({...$,acceptResult:H,mergeState:J?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:J?J.localChange:$.localChange,remoteChange:H?H.remoteChange:J?J.remoteChange:$.remoteChange})}}return{remoteUserData:f,lastSyncUserData:w,resourcePreviews:M,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const f=await this.fileService.readFile(this.lastSyncResource),w=JSON.parse(f.value.toString()),_=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=w.version&&_&&w.version!==_,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${w.version} is not compatible with current sync state version ${_}.`),await this.resetLocal(),null;const N=w;if(N.content===null)return{ref:w.ref,syncData:null};const A=JSON.parse(N.content);if(s(A))return{...w,syncData:A,content:void 0}}catch(f){f instanceof y.FileOperationError&&f.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Not synced yet. Last sync resource does not exist.`):this.logService.error(f)}return null}async updateLastSyncUserData(f,w={}){if(w.ref||w.content||w.version)throw new Error("Cannot have core properties as additional");const _=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),N={ref:f.ref,content:f.syncData?JSON.stringify(f.syncData):null,version:_,...w};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(N)))}async getRemoteUserData(f){const{ref:w,content:_}=await this.getUserData(f);let N=null;return _!==null&&(N=this.parseSyncData(_)),{ref:w,syncData:N}}parseSyncData(f){try{const w=JSON.parse(f);if(s(w))return w}catch(w){this.logService.error(w)}throw new l.UserDataSyncError((0,m.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(f){if((0,b.isString)(f)){const w=await this.userDataSyncStoreService.resolveResourceContent(this.resource,f);return{ref:f,content:w}}else{const w=f?{ref:f.ref,content:f.syncData?JSON.stringify(f.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,w,void 0,this.syncHeaders)}}async updateRemoteUserData(f,w){const _=await this.currentMachineIdPromise,N={version:this.version,machineId:_,content:f};try{return w=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(N),w,void 0,this.syncHeaders),{ref:w,syncData:N}}catch(A){throw A instanceof l.UserDataSyncError&&A.code==="TooLarge"&&(A=new l.UserDataSyncError(A.message,A.code,this.resource)),A}}async backupLocal(f){const w={version:this.version,content:f};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(w))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=pe([K(1,y.IFileService),K(2,h.IEnvironmentService),K(3,g.IStorageService),K(4,l.IUserDataSyncStoreService),K(5,l.IUserDataSyncBackupStoreService),K(6,l.IUserDataSyncEnablementService),K(7,a.ITelemetryService),K(8,l.IUserDataSyncLogService),K(9,v.IConfigurationService),K(10,d.IUriIdentityService)],t),e.AbstractSynchroniser=t;let n=class extends t{constructor(f,w,_,N,A,O,k,M,$,W,J,H){super(w,_,N,A,O,k,M,$,W,J,H),this.file=f,this._register(this.fileService.watch(this.extUri.dirname(f))),this._register(this.fileService.onDidFilesChange(G=>this.onFileChanges(G)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(f,w,_){try{w?await this.fileService.writeFile(this.file,D.VSBuffer.fromString(f),_?void 0:w):await this.fileService.createFile(this.file,D.VSBuffer.fromString(f),{overwrite:_})}catch(N){throw N instanceof y.FileOperationError&&N.fileOperationResult===1||N instanceof y.FileOperationError&&N.fileOperationResult===3?new l.UserDataSyncError(N.message,"LocalPreconditionFailed"):N}}onFileChanges(f){!f.contains(this.file)||this.triggerLocalChange()}};n=pe([K(2,y.IFileService),K(3,h.IEnvironmentService),K(4,g.IStorageService),K(5,l.IUserDataSyncStoreService),K(6,l.IUserDataSyncBackupStoreService),K(7,l.IUserDataSyncEnablementService),K(8,a.ITelemetryService),K(9,l.IUserDataSyncLogService),K(10,v.IConfigurationService),K(11,d.IUriIdentityService)],n),e.AbstractFileSynchroniser=n;let o=class extends n{constructor(f,w,_,N,A,O,k,M,$,W,J,H,G){super(f,w,_,N,A,O,k,M,$,W,H,G),this.userDataSyncUtilService=J,this._formattingOptions=void 0}hasErrors(f,w){const _=[],N=(0,I.parse)(f,_,{allowEmptyContent:!0,allowTrailingComma:!0});return _.length>0||!(0,b.isUndefined)(N)&&w!==Array.isArray(N)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};o=pe([K(2,y.IFileService),K(3,h.IEnvironmentService),K(4,g.IStorageService),K(5,l.IUserDataSyncStoreService),K(6,l.IUserDataSyncBackupStoreService),K(7,l.IUserDataSyncEnablementService),K(8,a.ITelemetryService),K(9,l.IUserDataSyncLogService),K(10,l.IUserDataSyncUtilService),K(11,v.IConfigurationService),K(12,d.IUriIdentityService)],o),e.AbstractJsonFileSynchroniser=o;let c=class{constructor(f,w,_,N,A,O){this.resource=f,this.userDataProfilesService=w,this.environmentService=_,this.logService=N,this.fileService=A,this.extUri=O.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,_,this.extUri)}async initialize({ref:f,content:w}){if(!w){this.logService.info("Remote content does not exist.",this.resource);return}const _=this.parseSyncData(w);if(!!_)try{await this.doInitialize({ref:f,syncData:_})}catch(N){this.logService.error(N)}}parseSyncData(f){try{const w=JSON.parse(f);if(s(w))return w}catch(w){this.logService.error(w)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(f,w={}){const _={ref:f.ref,content:f.syncData?JSON.stringify(f.syncData):null,...w};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(_)))}};c=pe([K(1,i.IUserDataProfilesService),K(2,h.IEnvironmentService),K(3,P.ILogService),K(4,y.IFileService),K(5,d.IUriIdentityService)],c),e.AbstractInitializer=c}),define(ne[257],re([0,1,6,24,9,3,46,27,7,18,14,29,33,75,13,8,20,22,31,23,41,237,110,26]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p,g,a,d,l,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(c,u){const f=JSON.parse(c.content);if(c.version===1||c.version===2){const w=(await u.getInstalled(0)).filter(_=>_.isBuiltin);for(const _ of f)c.version===1&&(_.enabled===!1&&(_.disabled=!0),delete _.enabled),c.version===2&&w.every(N=>!(0,m.areSameExtensions)(N.identifier,_.identifier))&&(_.installed=!0)}return f}let n=class gt extends d.AbstractSynchroniser{constructor(u,f,w,_,N,A,O,k,M,$,W,J,H,G,q,x){super("extensions",w,f,_,N,A,H,G,$,J,x),this.profileLocation=u,this.extensionManagementService=O,this.extensionEnablementService=k,this.ignoredExtensionsManagementService=M,this.extensionGalleryService=W,this.extensionStorageService=q,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,Y=>Y.some(({local:te})=>!!te)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,Y=>!Y.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(u,f){const w=u.syncData?await t(u.syncData,this.extensionManagementService):null,_=f?.skippedExtensions||[],N=f?.syncData?await t(f.syncData,this.extensionManagementService):null,A=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),O=this.getLocalExtensions(A),k=this.ignoredExtensionsManagementService.getIgnoredExtensions(A);w?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:M,remote:$}=(0,l.merge)(O,w,N,_,k),W={local:M,remote:$,content:this.getPreviewContent(O,M.added,M.updated,M.removed),localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:$!==null?2:0},J=this.stringify(O,!1);return[{skippedExtensions:_,baseResource:this.baseResource,baseContent:N?this.stringify(N,!1):J,localResource:this.localResource,localContent:J,localExtensions:O,remoteResource:this.remoteResource,remoteContent:w?this.stringify(w,!1):null,previewResource:this.previewResource,previewResult:W,localChange:W.localChange,remoteChange:W.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const f=u.syncData?await t(u.syncData,this.extensionManagementService):null,w=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),_=this.getLocalExtensions(w),N=this.ignoredExtensionsManagementService.getIgnoredExtensions(w),{remote:A}=(0,l.merge)(_,f,f,u.skippedExtensions||[],N);return A!==null}getPreviewContent(u,f,w,_){const N=[...f,...w],A=new Set,O=k=>{A.add(k.id.toLowerCase()),k.uuid&&A.add(k.uuid)};N.forEach(({identifier:k})=>O(k)),_.forEach(O);for(const k of u)A.has(k.identifier.id.toLowerCase())||k.identifier.uuid&&A.has(k.identifier.uuid)||N.push(k);return this.stringify(N,!1)}async getMergeResult(u,f){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,f,w,_){if(this.extUri.isEqual(f,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(f,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(f,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async acceptLocal(u){const f=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),_=(0,l.merge)(u.localExtensions,null,null,u.skippedExtensions,w),{local:N,remote:A}=_;return{content:u.localContent,local:N,remote:A,localChange:N.added.length>0||N.removed.length>0||N.updated.length>0?2:0,remoteChange:A!==null?2:0}}async acceptRemote(u){const f=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),_=u.remoteContent?JSON.parse(u.remoteContent):null;if(_!==null){const N=(0,l.merge)(u.localExtensions,_,u.localExtensions,[],w),{local:A,remote:O}=N;return{content:u.remoteContent,local:A,remote:O,localChange:A.added.length>0||A.removed.length>0||A.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,f,w,_){let{skippedExtensions:N,localExtensions:A}=w[0][0];const{local:O,remote:k,localChange:M,remoteChange:$}=w[0][1];if(M===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(A)),N=await this.updateLocalExtensions(O.added,O.removed,O.updated,N)),k){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const W=JSON.stringify(k.all);u=await this.updateRemoteUserData(W,_?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${k.added.length?` Added: ${JSON.stringify(k.added.map(J=>J.identifier.id))}.`:""}${k.updated.length?` Updated: ${JSON.stringify(k.updated.map(J=>J.identifier.id))}.`:""}${k.removed.length?` Removed: ${JSON.stringify(k.removed.map(J=>J.identifier.id))}.`:""}`)}f?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(u,{skippedExtensions:N}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${N.length?` Skipped: ${JSON.stringify(N.map(W=>W.identifier.id))}.`:""}`))}async getAssociatedResources({uri:u}){return[{resource:this.extUri.joinPath(u,"extensions.json"),comparableResource:gt.EXTENSIONS_DATA_URI}]}async resolveContent(u){if(this.extUri.isEqual(u,gt.EXTENSIONS_DATA_URI)){const w=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),_=this.ignoredExtensionsManagementService.getIgnoredExtensions(w),N=this.getLocalExtensions(w).filter(A=>!_.some(O=>(0,m.areSameExtensions)({id:O},A.identifier)));return this.stringify(N,!0)}if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)){const w=await this.resolvePreviewContent(u);return w&&this.stringify(JSON.parse(w),!0)}let f=await super.resolveContent(u);if(f)return f;if(f=await super.resolveContent(this.extUri.dirname(u)),f){const w=this.parseSyncData(f);if(w)switch(this.extUri.basename(u)){case"extensions.json":return this.stringify(this.parseExtensions(w),!0)}}return null}stringify(u,f){return u.sort((w,_)=>!w.identifier.uuid&&_.identifier.uuid?-1:w.identifier.uuid&&!_.identifier.uuid?1:(0,I.compare)(w.identifier.id,_.identifier.id)),f?(0,T.toFormattedString)(u,{}):JSON.stringify(u)}async hasLocalData(){try{const u=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if(this.getLocalExtensions(u).some(w=>w.installed||w.disabled))return!0}catch{}return!1}async updateLocalExtensions(u,f,w,_){const N=[],A=[],O=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if(f.length){const M=O.filter(({identifier:$,isBuiltin:W})=>!W&&f.some(J=>(0,m.areSameExtensions)($,J)));await R.Promises.settled(M.map(async $=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,$.identifier.id),await this.extensionManagementService.uninstall($,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,$.identifier.id),N.push($.identifier)}))}(u.length||w.length)&&await R.Promises.settled([...u,...w].map(async M=>{const $=O.find(J=>(0,m.areSameExtensions)(J.identifier,M.identifier));if($&&$.isBuiltin){M.state&&$.manifest.version===M.version&&this.updateExtensionState(M.state,$,$.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(H=>(0,m.areSameExtensions)(H,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id))),N.push(M.identifier);return}const W=(await this.extensionGalleryService.getExtensions([{...M.identifier,preRelease:M.preRelease}],r.CancellationToken.None))[0];if(M.state&&($?$.manifest.version===M.version:!!W)&&this.updateExtensionState(M.state,$||W,$?.manifest.version),W)try{this.extensionEnablementService.getDisabledExtensions().some(H=>(0,m.areSameExtensions)(H,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id,W.version),await this.extensionEnablementService.disableExtension(W.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id,W.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id,W.version),await this.extensionEnablementService.enableExtension(W.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id,W.version))),(!$||$.preRelease!==M.preRelease)&&(await this.extensionManagementService.canInstall(W)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,M.identifier.id,W.version),await this.extensionManagementService.installFromGallery(W,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:M.preRelease,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,M.identifier.id,W.version),N.push(W.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,W.displayName||W.identifier.id),A.push(M)))}catch(J){A.push(M),J instanceof S.ExtensionManagementError&&[S.ExtensionManagementErrorCode.Incompatible,S.ExtensionManagementErrorCode.IncompatiblePreRelease,S.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(J.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,W.displayName||W.identifier.id):(this.logService.error(J),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,W.displayName||W.identifier.id))}else A.push(M),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,M.identifier.id)}));const k=[];for(const M of _)N.some($=>(0,m.areSameExtensions)($,M.identifier))||k.push(M);for(const M of A)k.some($=>(0,m.areSameExtensions)($.identifier,M.identifier))||k.push(M);return k}updateExtensionState(u,f,w){const _=this.extensionStorageService.getExtensionState(f,!0)||{},N=w?this.extensionStorageService.getKeysForSync({id:f.identifier.id,version:w}):void 0;N?N.forEach(A=>{_[A]=u[A]}):Object.keys(u).forEach(A=>_[A]=u[A]),this.extensionStorageService.setExtensionState(f,_,!0)}parseExtensions(u){return JSON.parse(u.content)}getLocalExtensions(u){const f=this.extensionEnablementService.getDisabledExtensions();return u.map(w=>{const{identifier:_,isBuiltin:N,manifest:A,preRelease:O}=w,k={identifier:_,preRelease:O,version:A.version};f.some(M=>(0,m.areSameExtensions)(M,_))&&(k.disabled=!0),N||(k.installed=!0);try{const M=this.extensionStorageService.getKeysForSync({id:_.id,version:A.version});if(M){const $=this.extensionStorageService.getExtensionState(w,!0)||{};k.state=Object.keys($).reduce((W,J)=>(M.includes(J)&&(W[J]=$[J]),W),{})}}catch(M){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(M))}return k})}};n.EXTENSIONS_DATA_URI=E.URI.from({scheme:s.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),n=pe([K(1,b.IEnvironmentService),K(2,h.IFileService),K(3,P.IStorageService),K(4,s.IUserDataSyncStoreService),K(5,s.IUserDataSyncBackupStoreService),K(6,S.IExtensionManagementService),K(7,S.IGlobalExtensionEnablementService),K(8,i.IIgnoredExtensionsManagementService),K(9,s.IUserDataSyncLogService),K(10,S.IExtensionGalleryService),K(11,C.IConfigurationService),K(12,s.IUserDataSyncEnablementService),K(13,p.ITelemetryService),K(14,v.IExtensionStorageService),K(15,g.IUriIdentityService)],n),e.ExtensionsSynchroniser=n;let o=class extends d.AbstractInitializer{constructor(u,f,w,_,N,A,O){super("extensions",_,N,A,w,O),this.extensionManagementService=u,this.ignoredExtensionsManagementService=f}async parseExtensions(u){return u.syncData?await t(u.syncData,this.extensionManagementService):null}generatePreview(u,f){const w=[],_=[],N=[];for(const A of u){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(A.identifier.id))continue;const O=f.find(k=>(0,m.areSameExtensions)(k.identifier,A.identifier));O?(w.push(O),A.disabled&&N.push(A.identifier)):A.installed&&(_.push({...A.identifier,preRelease:!!A.preRelease}),A.disabled&&N.push(A.identifier))}return{installedExtensions:w,newExtensions:_,disabledExtensions:N,remoteExtensions:u}}};o=pe([K(0,S.IExtensionManagementService),K(1,i.IIgnoredExtensionsManagementService),K(2,h.IFileService),K(3,a.IUserDataProfilesService),K(4,b.IEnvironmentService),K(5,y.ILogService),K(6,g.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(ne[258],re([0,1,19,16,3,35,4,15,163,18,14,13,20,22,31,23,41,238,26]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function a(i,s,t){try{const n=JSON.parse(i);if(!s)return(0,I.isUndefined)(n.all)?null:n.all;switch(T.OS){case 2:return(0,I.isUndefined)(n.mac)?null:n.mac;case 3:return(0,I.isUndefined)(n.linux)?null:n.linux;case 1:return(0,I.isUndefined)(n.windows)?null:n.windows}}catch(n){return t.error(n),null}}e.getKeybindingsContentFromSyncContent=a;let d=class extends P.AbstractJsonFileSynchroniser{constructor(s,t,n,o,c,u,f,w,_,N,A,O){super(s,"keybindings",f,w,_,t,n,u,A,o,N,c,O),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(c.onDidChangeConfiguration,k=>k.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,t,n,o){const c=s.syncData?a(s.syncData.content,o.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&n?s:t;const u=t?this.getKeybindingsContentFromLastSyncUserData(t):null,f=await this.getLocalFileContent(),w=await this.getFormattingOptions();let _=null,N=!1,A=!1,O=!1;if(c){let $=f?f.value.toString():"[]";if($=$||"[]",this.hasErrors($,!0))throw new g.UserDataSyncError((0,E.localize)(0,null),"LocalInvalidContent",this.resource);if(!u||u!==$||u!==c){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const W=await(0,p.merge)($,c,u,w,this.userDataSyncUtilService);W.hasChanges&&(_=W.mergeContent,O=W.hasConflicts,N=O||W.mergeContent!==$,A=O||W.mergeContent!==c)}}else f&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),_=f.value.toString(),A=!0);const k={content:_,localChange:N?f?2:1:0,remoteChange:A?2:0,hasConflicts:O},M=f?f.value.toString():null;return[{fileContent:f,baseResource:this.baseResource,baseContent:u!==null?u:M,localResource:this.localResource,localContent:M,localChange:k.localChange,remoteResource:this.remoteResource,remoteContent:c,remoteChange:k.remoteChange,previewResource:this.previewResource,previewResult:k,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const t=this.getKeybindingsContentFromLastSyncUserData(s);if(t===null)return!0;const n=await this.getLocalFileContent(),o=n?n.value.toString():"",c=await this.getFormattingOptions(),u=await(0,p.merge)(o||"[]",t,t,c,this.userDataSyncUtilService);return u.hasConflicts||u.mergeContent!==t}async getMergeResult(s,t){return s.previewResult}async getAcceptResult(s,t,n,o){if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,n,o){const{fileContent:c}=n[0][0];let{content:u,localChange:f,remoteChange:w}=n[0][1];if(f===0&&w===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),u!==null&&(u=u.trim(),u=u||"[]",this.hasErrors(u,!0)))throw new g.UserDataSyncError((0,E.localize)(1,null),"LocalInvalidContent",this.resource);if(f!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),c&&await this.backupLocal(this.toSyncContent(c.value.toString())),await this.updateLocalFileContent(u||"[]",c,o),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),w!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const _=this.toSyncContent(u||"[]",s.syncData?.content);s=await this.updateRemoteUserData(_,o?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=(0,L.parse)(s.value.toString());if((0,R.isNonEmptyArray)(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"keybindings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.baseResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const n=this.parseSyncData(t);if(n)switch(this.extUri.basename(s)){case"keybindings.json":return a(n.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:a(s.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(s,t){let n={};try{n=JSON.parse(t||"{}")}catch(o){this.logService.error(o)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=s,T.OS){case 2:n.mac=s;break;case 3:n.linux=s;break;case 1:n.windows=s;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};d=pe([K(1,g.IUserDataSyncStoreService),K(2,g.IUserDataSyncBackupStoreService),K(3,g.IUserDataSyncLogService),K(4,C.IConfigurationService),K(5,g.IUserDataSyncEnablementService),K(6,S.IFileService),K(7,b.IEnvironmentService),K(8,m.IStorageService),K(9,g.IUserDataSyncUtilService),K(10,v.ITelemetryService),K(11,h.IUriIdentityService)],d),e.KeybindingsSynchroniser=d;let l=class extends P.AbstractInitializer{constructor(s,t,n,o,c){super("keybindings",t,n,o,s,c)}async doInitialize(s){const t=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,r.VSBuffer.fromString(t)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,L.parse)(s.value.toString());return!(0,R.isNonEmptyArray)(t)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return a(s,!0,this.logService)}catch(t){return this.logService.error(t),null}}};l=pe([K(0,S.IFileService),K(1,y.IUserDataProfilesService),K(2,b.IEnvironmentService),K(3,g.IUserDataSyncLogService),K(4,h.IUriIdentityService)],l),e.KeybindingsInitializer=l}),define(ne[259],re([0,1,16,3,164,18,70,14,29,13,20,22,31,23,41,61,242,26]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function a(i){const s=JSON.parse(i);return g(s)?s:{settings:i}}e.parseSettingsSyncContent=a;let d=class extends h.AbstractJsonFileSynchroniser{constructor(s,t,n,o,c,u,f,w,_,N,A,O,k){super(s,"settings",t,n,o,c,u,N,A,f,w,_,k),this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const t=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(s,t),o=this.getSettingsSyncContent(n),c=new T.ConfigurationModelParser(p.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&c.parse(o.settings),c.configurationModel.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,t,n){const o=await this.getLocalFileContent(),c=await this.getFormattingOptions(),u=this.getSettingsSyncContent(s);t=t===null&&n?s:t;const f=t?this.getSettingsSyncContent(t):null,w=await this.getIgnoredSettings();let _=null,N=!1,A=!1,O=!1;if(u){let $=o?o.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const W=(0,P.merge)($,u.settings,f?f.settings:null,w,[],c);_=W.localContent||W.remoteContent,N=W.localContent!==null,A=W.remoteContent!==null,O=W.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),_=o.value.toString().trim()||"{}",this.validateContent(_),A=!0);const k={content:_,localChange:N?2:0,remoteChange:A?2:0,hasConflicts:O},M=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:f?f.settings:M,localResource:this.localResource,localContent:M,localChange:k.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:k.remoteChange,previewResource:this.previewResource,previewResult:k,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const t=this.getSettingsSyncContent(s);if(t===null)return!0;const n=await this.getLocalFileContent(),o=n?n.value.toString().trim():"",c=await this.getIgnoredSettings(),u=await this.getFormattingOptions();return(0,P.merge)(o||"{}",t.settings,t.settings,c,[],u).remoteContent!==null}async getMergeResult(s,t){const n=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,P.updateIgnoredSettings)(s.previewResult.content,"{}",o,n):null}}async getAcceptResult(s,t,n,o){const c=await this.getFormattingOptions(),u=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?(0,P.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",u,c):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent!==null?(0,P.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",u,c):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,P.updateIgnoredSettings)(n,s.fileContent?s.fileContent.value.toString():"{}",u,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,n,o){const{fileContent:c}=n[0][0];let{content:u,localChange:f,remoteChange:w}=n[0][1];if(f===0&&w===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.validateContent(u),f!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),c&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(c.value.toString()))),await this.updateLocalFileContent(u,c,o),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),w!==0){const _=await this.getFormattingOptions(),N=this.getSettingsSyncContent(s),A=await this.getIgnoredSettings(u);u=(0,P.updateIgnoredSettings)(u,N?N.settings:"{}",A,_),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(u)),o?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=await this.getFormattingOptions(),n=(0,y.edit)(s.value.toString(),[p.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,P.isEmpty)(n)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"settings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)||this.extUri.isEqual(this.baseResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const n=this.parseSyncData(t);if(n){const o=this.parseSettingsSyncContent(n.content);if(o)switch(this.extUri.basename(s)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(s){let t=await super.resolvePreviewContent(s);if(t){const n=await this.getFormattingOptions(),o=await this.getIgnoredSettings();t=(0,P.updateIgnoredSettings)(t,"{}",o,n)}return t}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return a(s)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=r.Event.any(r.Event.filter(this.extensionManagementService.onDidInstallExtensions,o=>o.some(({local:c})=>!!c)),r.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,P.getIgnoredSettings)(t,this.configurationService,s)}validateContent(s){if(this.hasErrors(s,!1))throw new p.UserDataSyncError((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};d=pe([K(1,C.IFileService),K(2,I.IEnvironmentService),K(3,b.IStorageService),K(4,p.IUserDataSyncStoreService),K(5,p.IUserDataSyncBackupStoreService),K(6,p.IUserDataSyncLogService),K(7,p.IUserDataSyncUtilService),K(8,L.IConfigurationService),K(9,p.IUserDataSyncEnablementService),K(10,S.ITelemetryService),K(11,E.IExtensionManagementService),K(12,m.IUriIdentityService)],d),e.SettingsSynchroniser=d;let l=class extends h.AbstractInitializer{constructor(s,t,n,o,c){super("settings",t,n,o,s,c)}async doInitialize(s){const t=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,R.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,P.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return a(s)}catch(t){this.logService.error(t)}return null}};l=pe([K(0,C.IFileService),K(1,v.IUserDataProfilesService),K(2,I.IEnvironmentService),K(3,p.IUserDataSyncLogService),K(4,m.IUriIdentityService)],l),e.SettingsInitializer=l}),define(ne[260],re([0,1,16,3,32,18,14,13,20,22,31,23,41,239,26]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let y=class extends m.AbstractSynchroniser{constructor(g,a,d,l,i,s,t,n,o,c,u){super("snippets",d,a,l,i,s,o,c,t,n,u),this.snippetsFolder=g,this.version=1,this._register(this.fileService.watch(a.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(r.Event.filter(this.fileService.onDidFilesChange,f=>f.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,a,d){const l=await this.getSnippetsFileContents(),i=this.toSnippetsContents(l),s=g.syncData?this.parseSnippets(g.syncData):null;a=a===null&&d?g:a;const t=a&&a.syncData?this.parseSnippets(a.syncData):null;s?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,v.merge)(i,s,t);return this.getResourcePreviews(n,l,s||{},t||{})}async hasRemoteChanged(g){const a=g.syncData?this.parseSnippets(g.syncData):null;if(a===null)return!0;const d=await this.getSnippetsFileContents(),l=this.toSnippetsContents(d),i=(0,v.merge)(l,a,a);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async getMergeResult(g,a){return g.previewResult}async getAcceptResult(g,a,d,l){if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder))return d===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:d,localChange:d===null?g.fileContent!==null?3:0:2,remoteChange:d===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(g,a,d,l){const i=d.map(([s,t])=>({...s,acceptResult:t}));i.every(({localChange:s,remoteChange:t})=>s===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),i.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(i),await this.updateLocalSnippets(i,l)),i.some(({remoteChange:s})=>s!==0)&&(g=await this.updateRemoteSnippets(i,g,l)),a?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of i)try{await this.fileService.del(s)}catch{}}getResourcePreviews(g,a,d,l){const i=new Map;for(const s of Object.keys(g.local.added)){const t={content:g.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(g.local.updated)){const t={content:g.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0},n=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??n,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of g.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},n=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??n,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(g.remote.added)){const t={content:g.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1},n=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??n,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(g.remote.updated)){const t={content:g.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2},n=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??n,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of g.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of g.conflicts){const t={content:a[s]?a[s].value.toString():null,hasConflicts:!0,localChange:a[s]?2:1,remoteChange:d[s]?2:1},n=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??n,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s]||null,localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(a))if(!i.has(s)){const t={content:a[s]?a[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},n=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??n,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s]||null,localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...i.values()]}async getAssociatedResources({uri:g}){const a=await super.resolveContent(g);if(a){const d=this.parseSyncData(a);if(d){const l=this.parseSnippets(d),i=[];for(const s of Object.keys(l)){const t=this.extUri.joinPath(g,s),n=this.extUri.joinPath(this.snippetsFolder,s),o=await this.fileService.exists(n);i.push({resource:t,comparableResource:o?n:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})})}return i}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let a=await super.resolveContent(g);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(g)),a){const d=this.parseSyncData(a);if(d)return this.parseSnippets(d)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const a={};for(const d of g)d.fileContent&&(a[this.extUri.basename(d.localResource)]=d.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(a)))}async updateLocalSnippets(g,a){for(const{fileContent:d,acceptResult:l,localResource:i,remoteResource:s,localChange:t}of g)if(t!==0){const n=s?this.extUri.basename(s):this.extUri.basename(i),o=this.extUri.joinPath(this.snippetsFolder,n);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(o)),await this.fileService.del(o),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(o))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(o)),await this.fileService.createFile(o,R.VSBuffer.fromString(l.content),{overwrite:a}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(o))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(o)),await this.fileService.writeFile(o,R.VSBuffer.fromString(l.content),a?void 0:d),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(o)))}}async updateRemoteSnippets(g,a,d){const l=a.syncData?this.parseSnippets(a.syncData):{},i=(0,D.deepClone)(l);for(const{acceptResult:s,localResource:t,remoteResource:n,remoteChange:o}of g)if(o!==0){const c=t?this.extUri.basename(t):this.extUri.basename(n);o===3?delete i[c]:i[c]=s.content}return(0,v.areSame)(l,i)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),a=await this.updateRemoteUserData(JSON.stringify(i),d?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),a}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const a={};for(const d of Object.keys(g))a[d]=g[d].value.toString();return a}async getSnippetsFileContents(){const g={};let a;try{a=await this.fileService.resolve(this.snippetsFolder)}catch(d){if(d instanceof I.FileOperationError&&d.fileOperationResult===1)return g;throw d}for(const d of a.children||[]){const l=d.resource,i=this.extUri.extname(l);if(i===".json"||i===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,l),t=await this.fileService.readFile(l);g[s]=t}}return g}};y=pe([K(1,T.IEnvironmentService),K(2,I.IFileService),K(3,E.IStorageService),K(4,h.IUserDataSyncStoreService),K(5,h.IUserDataSyncBackupStoreService),K(6,h.IUserDataSyncLogService),K(7,L.IConfigurationService),K(8,h.IUserDataSyncEnablementService),K(9,C.ITelemetryService),K(10,b.IUriIdentityService)],y),e.SnippetsSynchroniser=y;let P=class extends m.AbstractInitializer{constructor(g,a,d,l,i){super("snippets",a,d,l,g,i)}async doInitialize(g){const a=g.syncData?JSON.parse(g.syncData.content):null;if(!a){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const l of Object.keys(a)){const i=a[l];if(i){const s=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,l);await this.fileService.createFile(s,R.VSBuffer.fromString(i)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};P=pe([K(0,I.IFileService),K(1,S.IUserDataProfilesService),K(2,T.IEnvironmentService),K(3,h.IUserDataSyncLogService),K(4,b.IUriIdentityService)],P),e.SnippetsInitializer=P}),define(ne[261],re([0,1,16,18,14,13,20,22,31,23,41,26]),function(Q,e,R,r,D,L,T,I,E,C,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function m(P,p){try{return JSON.parse(P).tasks}catch(g){return p.error(g),null}}e.getTasksContentFromSyncContent=m;let v=class extends b.AbstractFileSynchroniser{constructor(p,g,a,d,l,i,s,t,n,o,c){super(p,"tasks",s,t,n,g,a,i,o,d,l,c),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(p,g,a,d){const l=p.syncData?m(p.syncData.content,this.logService):null;g=g===null&&a?p:g;const i=g?.syncData?m(g.syncData.content,this.logService):null,s=await this.getLocalFileContent();let t=null,n=!1,o=!1,c=!1;if(l){const w=s?s.value.toString():null;if(!i||i!==w||i!==l){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const _=y(w,l,i);t=_.content,c=_.hasConflicts,n=_.hasLocalChanged,o=_.hasRemoteChanged}}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=s.value.toString(),o=!0);const u={content:t,localChange:n?s?2:1:0,remoteChange:o?2:0,hasConflicts:c},f=s?s.value.toString():null;return[{fileContent:s,baseResource:this.baseResource,baseContent:i!==null?i:f,localResource:this.localResource,localContent:f,localChange:u.localChange,remoteResource:this.remoteResource,remoteContent:l,remoteChange:u.remoteChange,previewResource:this.previewResource,previewResult:u,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(p){const g=p?.syncData?m(p.syncData.content,this.logService):null;if(g===null)return!0;const a=await this.getLocalFileContent(),d=a?a.value.toString():null,l=y(d,g,g);return l.hasLocalChanged||l.hasRemoteChanged}async getMergeResult(p,g){return p.previewResult}async getAcceptResult(p,g,a,d){if(this.extUri.isEqual(g,this.localResource))return{content:p.fileContent?p.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(g,this.remoteResource))return{content:p.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(g,this.previewResource))return a===void 0?{content:p.previewResult.content,localChange:p.previewResult.localChange,remoteChange:p.previewResult.remoteChange}:{content:a,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(p,g,a,d){const{fileContent:l}=a[0][0],{content:i,localChange:s,remoteChange:t}=a[0][1];if(s===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),s!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),l&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(l.value.toString()))),await this.updateLocalFileContent(i||"{}",l,d),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const n=JSON.stringify(this.toTasksSyncContent(i||"{}"));p=await this.updateRemoteUserData(n,d?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}g?.ref!==p.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(p),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:p}){const g=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(p,"tasks.json"),comparableResource:g}]}async resolveContent(p){if(this.extUri.isEqual(this.remoteResource,p)||this.extUri.isEqual(this.baseResource,p)||this.extUri.isEqual(this.localResource,p)||this.extUri.isEqual(this.acceptedResource,p))return this.resolvePreviewContent(p);let g=await super.resolveContent(p);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(p)),g){const a=this.parseSyncData(g);if(a)switch(this.extUri.basename(p)){case"tasks.json":return m(a.content,this.logService)}}return null}toTasksSyncContent(p){return{tasks:p}}};v=pe([K(1,S.IUserDataSyncStoreService),K(2,S.IUserDataSyncBackupStoreService),K(3,S.IUserDataSyncLogService),K(4,r.IConfigurationService),K(5,S.IUserDataSyncEnablementService),K(6,L.IFileService),K(7,D.IEnvironmentService),K(8,T.IStorageService),K(9,I.ITelemetryService),K(10,E.IUriIdentityService)],v),e.TasksSynchroniser=v;let h=class extends b.AbstractInitializer{constructor(p,g,a,d,l){super("tasks",g,a,d,p,l),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(p){const g=p.syncData?m(p.syncData.content,this.logService):null;if(!g){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,R.VSBuffer.fromString(g)),await this.updateLastSyncUserData(p)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};h=pe([K(0,L.IFileService),K(1,C.IUserDataProfilesService),K(2,D.IEnvironmentService),K(3,S.IUserDataSyncLogService),K(4,E.IUriIdentityService)],h),e.TasksInitializer=h;function y(P,p,g){if(P===null&&p===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(P===p)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const a=g!==P,d=g!==p;return!a&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:a&&!d?{content:P,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!a?{content:p,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:P,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[262],re([0,1,46,7,18,14,13,20,22,31,23,41,240,26]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesManifestSynchroniser=void 0;let h=class mt extends S.AbstractSynchroniser{constructor(p,g,a,d,l,i,s,t,n,o,c){super("profiles",g,a,d,l,i,n,o,s,t,c),this.userDataProfilesService=p,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(p,g,a){const d=p.syncData?y(p.syncData):null,l=g?.syncData?y(g.syncData):null,i=this.getLocalUserDataProfiles(),{local:s,remote:t}=(0,m.merge)(i,d,l,[]),n={local:s,remote:t,content:l?this.stringifyRemoteProfiles(l):null,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:t!==null?2:0},o=this.stringifyLocalProfiles(i,!1);return[{baseResource:this.baseResource,baseContent:l?this.stringifyRemoteProfiles(l):null,localResource:this.localResource,localContent:o,remoteResource:this.remoteResource,remoteContent:d?this.stringifyRemoteProfiles(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(p){const g=p?.syncData?y(p.syncData):null,a=this.getLocalUserDataProfiles(),{remote:d}=(0,m.merge)(a,g,g,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async getMergeResult(p,g){return{...p.previewResult,hasConflicts:!1}}async getAcceptResult(p,g,a,d){if(this.extUri.isEqual(g,this.localResource))return this.acceptLocal(p);if(this.extUri.isEqual(g,this.remoteResource))return this.acceptRemote(p);if(this.extUri.isEqual(g,this.previewResource))return p.previewResult;throw new Error(`Invalid Resource: ${g.toString()}`)}async acceptLocal(p){const g=this.getLocalUserDataProfiles(),a=(0,m.merge)(g,null,null,[]),{local:d,remote:l}=a;return{content:p.localContent,local:d,remote:l,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:l!==null?2:0}}async acceptRemote(p){const g=p.remoteContent?JSON.parse(p.remoteContent):null,a=[],d=[];for(const l of this.getLocalUserDataProfiles()){const i=g?.find(s=>s.id===l.id);i&&(a.push({id:l.id,name:l.name,collection:i.collection}),d.push(l))}if(g!==null){const l=(0,m.merge)(d,g,a,[]),{local:i,remote:s}=l;return{content:p.remoteContent,local:i,remote:s,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:s!==null?2:0}}else return{content:p.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(p,g,a,d){const{local:l,remote:i,localChange:s,remoteChange:t}=a[0][1];if(s===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`),s!==0){await this.backupLocal(this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!1));const n=[];for(const o of l.added)n.push(this.userDataProfilesService.createProfile(o.id,o.name));for(const o of l.removed)n.push(this.userDataProfilesService.removeProfile(o));for(const o of l.updated){const c=this.userDataProfilesService.profiles.find(u=>u.id===o.id);c?n.push(this.userDataProfilesService.updateProfile(c,o.name)):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${o.id}' to update.`)}await Promise.all(n)}if(t!==0){const n=a[0][0].remoteProfiles||[];this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);for(const o of i?.added||[]){const c=await this.userDataSyncStoreService.createCollection(this.syncHeaders);n.push({id:o.id,name:o.name,collection:c})}for(const o of i?.removed||[])n.splice(n.findIndex(({id:c})=>o.id===c),1);for(const o of i?.updated||[]){const c=n.find(({id:u})=>o.id===u);c&&n.splice(n.indexOf(c),1,{id:o.id,name:o.name,collection:c.collection})}p=await this.updateRemoteUserData(this.stringifyRemoteProfiles(n),d?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${i?.added.length?` Added: ${JSON.stringify(i.added.map(o=>o.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(o=>o.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(o=>o.name))}.`:""}`);for(const o of i?.removed||[])await this.userDataSyncStoreService.deleteCollection(o.collection,this.syncHeaders)}g?.ref!==p.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(p),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async getAssociatedResources({uri:p}){return[{resource:this.extUri.joinPath(p,"profiles.json"),comparableResource:mt.PROFILES_DATA_URI}]}async resolveContent(p){if(this.extUri.isEqual(p,mt.PROFILES_DATA_URI))return this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!0);if(this.extUri.isEqual(this.remoteResource,p)||this.extUri.isEqual(this.baseResource,p)||this.extUri.isEqual(this.localResource,p)||this.extUri.isEqual(this.acceptedResource,p)){const a=await this.resolvePreviewContent(p);return a&&(0,R.toFormattedString)(JSON.parse(a),{})}let g=await super.resolveContent(p);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(p)),g){const a=this.parseSyncData(g);if(a)switch(this.extUri.basename(p)){case"profiles.json":return(0,R.toFormattedString)(y(a),{})}}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(p=>!p.isDefault&&!p.isTransient)}stringifyRemoteProfiles(p){return JSON.stringify([...p].sort((g,a)=>g.name.localeCompare(a.name)))}stringifyLocalProfiles(p,g){const a=[...p].sort((d,l)=>d.name.localeCompare(l.name)).map(d=>({id:d.id,name:d.name}));return g?(0,R.toFormattedString)(a,{}):JSON.stringify(a)}};h.PROFILES_DATA_URI=r.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"profiles",path:"/profiles.json"}),h=pe([K(0,b.IUserDataProfilesService),K(1,T.IFileService),K(2,L.IEnvironmentService),K(3,I.IStorageService),K(4,v.IUserDataSyncStoreService),K(5,v.IUserDataSyncBackupStoreService),K(6,v.IUserDataSyncLogService),K(7,D.IConfigurationService),K(8,v.IUserDataSyncEnablementService),K(9,E.ITelemetryService),K(10,C.IUriIdentityService)],h),e.UserDataProfilesManifestSynchroniser=h;function y(P){return JSON.parse(P.content)}}),define(ne[263],re([0,1,3,2,4,14,20,22,26]),function(Q,e,R,r,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const C="sync.enable";let b=class extends r.Disposable{constructor(m,v,h,y){super(),this.storageService=m,this.telemetryService=v,this.environmentService=h,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(m.onDidChangeValue(P=>this.onDidStorageChange(P)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(C,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(C,{enabled:m}),this.storageService.store(C,m,-1,1))}isResourceEnabled(m){return this.storageService.getBoolean((0,E.getEnablementKey)(m),-1,!0)}setResourceEnablement(m,v){if(this.isResourceEnabled(m)!==v){const h=(0,E.getEnablementKey)(m);this.storeResourceEnablement(h,v)}}getResourceSyncStateVersion(m){}storeResourceEnablement(m,v){this.storageService.store(m,v,-1,D.isWeb?0:1)}onDidStorageChange(m){if(m.scope!==-1)return;if(C===m.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const v=E.ALL_SYNC_RESOURCES.filter(h=>(0,E.getEnablementKey)(h)===m.key)[0];if(v){this._onDidChangeResourceEnablement.fire([v,this.isResourceEnabled(v)]);return}}};b=pe([K(0,T.IStorageService),K(1,I.ITelemetryService),K(2,L.IEnvironmentService),K(3,E.IUserDataSyncStoreManagementService)],b),e.UserDataSyncEnablementService=b}),define(ne[76],re([0,1,3,2,4,27,167,14,13,5,25,48,20,26]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,C.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",y="Safari",P="Chrome",p="Edge",g="Firefox",a="Android";function d(s){switch(s){case y:case P:case p:case g:case a:case(0,D.PlatformToString)(0):return!0}return!1}e.isWebPlatform=d;function l(){return D.isSafari?y:D.isChrome?P:D.isEdge?p:D.isFirefox?g:D.isAndroid?a:(0,D.PlatformToString)(D.isWeb?0:D.platform)}let i=class nt extends r.Disposable{constructor(t,n,o,c,u,f){super(),this.storageService=o,this.userDataSyncStoreService=c,this.logService=u,this.productService=f,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,S.getServiceMachineId)(t,n,o)}async getMachines(t){const n=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(c=>({...c,isCurrent:c.id===n}))}async addCurrentMachine(t){const n=await this.currentMachineIdPromise,o=await this.readMachinesData(t);o.machines.some(({id:c})=>c===n)||(o.machines.push({id:n,name:this.computeCurrentMachineName(o.machines),platform:l()}),await this.writeMachinesData(o))}async removeCurrentMachine(t){const n=await this.currentMachineIdPromise,o=await this.readMachinesData(t),c=o.machines.filter(({id:u})=>u!==n);c.length!==o.machines.length&&(o.machines=c,await this.writeMachinesData(o))}async renameMachine(t,n,o){const c=await this.readMachinesData(o),u=c.machines.find(({id:f})=>f===t);if(u){u.name=n,await this.writeMachinesData(c);const f=await this.currentMachineIdPromise;t===f&&this.storageService.store(h,n,-1,1)}}async setEnablements(t){const n=await this.readMachinesData();for(const[o,c]of t){const u=n.machines.find(f=>f.id===o);u&&(u.disabled=c?void 0:!0)}await this.writeMachinesData(n)}computeCurrentMachineName(t){const n=this.storageService.get(h,-1);if(n)return n;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${l()} (${this.productService.nameShort})`,c=new RegExp(`${(0,L.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let u=0;for(const f of t){const w=c.exec(f.name),_=w?parseInt(w[1]):0;u=_>u?_:u}return`${o} #${u+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const n=this.parse(this.userData);if(n.version!==nt.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return n}async writeMachinesData(t){const n=JSON.stringify(t),o=await this.userDataSyncStoreService.writeResource(nt.RESOURCE,n,this.userData?.ref||null);this.userData={ref:o,content:n},this._onDidChange.fire()}async readUserData(t){if(this.userData){const n=t&&t.latest?t.latest[nt.RESOURCE]:void 0;if(this.userData.ref===n)return this.userData;if(n===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(nt.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(n){this.logService.error(n)}return{version:nt.VERSION,machines:[]}}};i.VERSION=1,i.RESOURCE="machines",i=pe([K(0,I.IEnvironmentService),K(1,E.IFileService),K(2,m.IStorageService),K(3,v.IUserDataSyncStoreService),K(4,v.IUserDataSyncLogService),K(5,b.IProductService)],i),e.UserDataSyncMachinesService=i}),define(ne[264],re([0,1,6,63,38,9,3,2,4,17,7,165,25,20,22,26,73,76]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const g="sync.disableMachineEventually",a="sync.sessionId",d="sync.storeUrl",l="sync.productQuality";let i=class extends I.Disposable{constructor(n,o,c,u,f,w,_,N,A,O){super(),this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=c,this.userDataSyncEnablementService=u,this.userDataSyncService=f,this.logService=w,this.userDataSyncAccountService=_,this.telemetryService=N,this.userDataSyncMachinesService=A,this.storageService=O,this.autoSync=this._register(new I.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new R.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=n.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(c.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(f.onDidChangeLocal(k=>this.triggerSync([k],!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,k])=>k)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const n=this.storageService.get(d,-1);return n?b.URI.parse(n):void 0}set syncUrl(n){n?this.storageService.store(d,n.toString(),-1,1):this.storageService.remove(d,-1)}get productQuality(){return this.storageService.get(l,-1)}set productQuality(n){n?this.storageService.store(l,n,-1,1):this.storageService.remove(l,-1)}updateAutoSync(){const{enabled:n,message:o}=this.isAutoSyncEnabled();n?this.autoSync.value===void 0&&(this.autoSync.value=new s(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(c=>this.onDidFinishSync(c))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,r.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(n,o,c){try{this.userDataSyncAccountService.account&&!c&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,-1),n?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(u){if(o)this.logService.error(u),this.updateEnablement(!1);else throw u}}updateEnablement(n){this.userDataSyncEnablementService.isEnabled()!==n&&(this.userDataSyncEnablementService.setEnablement(n),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(n){if(!n){this.successiveFailures=0;return}const o=y.UserDataSyncError.toUserDataSyncError(n);o instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?E.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(g,!0,-1,1),await(0,R.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(g,-1)}async triggerSync(n,o,c){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...n),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",c)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};i=pe([K(0,m.IProductService),K(1,y.IUserDataSyncStoreManagementService),K(2,y.IUserDataSyncStoreService),K(3,y.IUserDataSyncEnablementService),K(4,y.IUserDataSyncService),K(5,y.IUserDataSyncLogService),K(6,P.IUserDataSyncAccountService),K(7,h.ITelemetryService),K(8,p.IUserDataSyncMachinesService),K(9,v.IStorageService)],i),e.UserDataAutoSyncService=i;class s extends I.Disposable{constructor(n,o,c,u,f,w,_,N){super(),this.lastSyncUrl=n,this.interval=o,this.userDataSyncStoreManagementService=c,this.userDataSyncStoreService=u,this.userDataSyncService=f,this.userDataSyncMachinesService=w,this.logService=_,this.storageService=N,this.intervalHandler=this._register(new I.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,I.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(s.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(s.INTERVAL_SYNCING,!1),this.interval)}sync(n,o){const c=(0,R.createCancelablePromise)(async u=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(f){if((0,L.isCancellationError)(f))return}return this.doSync(n,o,u)});return this.syncPromise=c,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const n=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!n&&(!(0,C.isEqual)(o.defaultUrl,n.defaultUrl)||!(0,C.isEqual)(o.insidersUrl,n.insidersUrl)||!(0,C.isEqual)(o.stableUrl,n.stableUrl))}async doSync(n,o,c){this.logService.info(`Auto Sync: Triggered by ${n}`),this._onDidStartSync.fire();let u;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),c.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,S.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,S.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,S.localize)(2,null),"TurnedOff");const f=this.storageService.get(a,-1);if(f&&this.manifest&&f!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,S.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,S.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,S.localize)(5,null),"SessionExpired");const w=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(c.isCancellationRequested)return;const _=w.find(N=>N.isCurrent);if(_?.disabled)throw new y.UserDataAutoSyncError((0,S.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(N){throw new y.UserDataAutoSyncError((0,D.toErrorMessage)(N),N instanceof y.UserDataSyncError?N.code:"Unknown")}if(this.manifest&&this.manifest.session!==f&&this.storageService.store(a,this.manifest.session,-1,1),c.isCancellationRequested)return;_||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(f){this.logService.error(f),u=f}this._onDidFinishSync.fire(u)}register(n){return super._register(n)}}s.INTERVAL_SYNCING="Interval"}),define(ne[77],re([0,1,2,67,5,20]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataSyncProfilesStorageService=e.IUserDataSyncProfilesStorageService=void 0,e.IUserDataSyncProfilesStorageService=(0,D.createDecorator)("IUserDataSyncProfilesStorageService");let T=class extends R.Disposable{constructor(C){super(),this.storageService=C}async readStorageData(C){if(this.storageService.hasScope(C))return this.getItems(this.storageService);const b=await this.createStorageDatabase(C),S=new I(b);try{return await S.initialize(),this.getItems(S)}finally{S.dispose(),await this.closeAndDispose(b)}}async updateStorageData(C,b,S){if(this.storageService.hasScope(C))return this.writeItems(this.storageService,b,S);const m=await this.createStorageDatabase(C),v=new I(m);try{await v.initialize(),this.writeItems(v,b,S),await v.flush()}finally{v.dispose(),await this.closeAndDispose(m)}}getItems(C){const b=new Map,S=m=>{for(const v of C.keys(0,m))b.set(v,{value:C.get(v,0),target:m})};return S(0),S(1),b}writeItems(C,b,S){for(const[m,v]of b)C.store(m,v,0,S)}async closeAndDispose(C){try{await C.close()}finally{(0,R.isDisposable)(C)&&C.dispose()}}};T=pe([K(0,L.IStorageService)],T),e.AbstractUserDataSyncProfilesStorageService=T;class I extends L.AbstractStorageService{constructor(C){super({flushInterval:100}),this.profileStorage=this._register(new r.Storage(C))}doInitialize(){return this.profileStorage.init()}getStorage(C){return C===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(ne[265],re([0,1,16,9,3,35,46,4,7,30,18,14,13,8,48,20,22,31,41,61,241,26,23,77]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p,g,a,d,l,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const t="globalState.argv.",n=["locale"];function o(_,N){const A=_.storage?Object.keys(_.storage).sort():[],O={};return A.forEach(k=>O[k]=_.storage[k]),_.storage=O,N?(0,T.toFormattedString)(_,{}):JSON.stringify(_)}const c=1;let u=class pt extends g.AbstractSynchroniser{constructor(N,A,O,k,M,$,W,J,H,G,q,x){super("globalState",O,W,q,k,M,J,H,$,G,x),this.profile=N,this.userDataSyncProfilesStorageService=A,this.version=c,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(O.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(D.Event.any(D.Event.filter(O.onDidFilesChange,Y=>Y.contains(this.environmentService.argvResource)),D.Event.filter(this.userDataSyncProfilesStorageService.onDidChange,Y=>!!(Y.targetChanges.some(te=>this.profile.id===te.id)||Y.valueChanges.some(({profile:te,changes:ce})=>this.profile.id===te.id&&ce.some(z=>z.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(N,A,O){const k=N.syncData?JSON.parse(N.syncData.content):null;A=A===null&&O?N:A;const M=A&&A.syncData?JSON.parse(A.syncData.content):null,$=await this.getLocalGlobalState();k?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const W=await this.getStorageKeys(M),{local:J,remote:H}=(0,d.merge)($.storage,k?k.storage:null,M?M.storage:null,W,this.logService),G={content:null,local:J,remote:H,localChange:Object.keys(J.added).length>0||Object.keys(J.updated).length>0||J.removed.length>0?2:0,remoteChange:H!==null?2:0},q=o($,!1);return[{baseResource:this.baseResource,baseContent:M?o(M,!1):q,localResource:this.localResource,localContent:q,localUserData:$,remoteResource:this.remoteResource,remoteContent:k?o(k,!1):null,previewResource:this.previewResource,previewResult:G,localChange:G.localChange,remoteChange:G.remoteChange,acceptedResource:this.acceptedResource,storageKeys:W}]}async hasRemoteChanged(N){const A=N.syncData?JSON.parse(N.syncData.content):null;if(A===null)return!0;const O=await this.getLocalGlobalState(),k=await this.getStorageKeys(A),{remote:M}=(0,d.merge)(O.storage,A.storage,A.storage,k,this.logService);return M!==null}async getMergeResult(N,A){return{...N.previewResult,hasConflicts:!1}}async getAcceptResult(N,A,O,k){if(this.extUri.isEqual(A,this.localResource))return this.acceptLocal(N);if(this.extUri.isEqual(A,this.remoteResource))return this.acceptRemote(N);if(this.extUri.isEqual(A,this.previewResource))return N.previewResult;throw new Error(`Invalid Resource: ${A.toString()}`)}async acceptLocal(N){return{content:N.localContent,local:{added:{},removed:[],updated:{}},remote:N.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(N){if(N.remoteContent!==null){const A=JSON.parse(N.remoteContent),{local:O,remote:k}=(0,d.merge)(N.localUserData.storage,A.storage,null,N.storageKeys,this.logService);return{content:N.remoteContent,local:O,remote:k,localChange:Object.keys(O.added).length>0||Object.keys(O.updated).length>0||O.removed.length>0?2:0,remoteChange:k!==null?2:0}}else return{content:N.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(N,A,O,k){const{localUserData:M}=O[0][0],{local:$,remote:W,localChange:J,remoteChange:H}=O[0][1];if(J===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),J!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(M)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),H!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const G=JSON.stringify({storage:W});N=await this.updateRemoteUserData(G,k?null:N.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}A?.ref!==N.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(N),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:N}){return[{resource:this.extUri.joinPath(N,"globalState.json"),comparableResource:pt.GLOBAL_STATE_DATA_URI}]}async resolveContent(N){if(this.extUri.isEqual(N,pt.GLOBAL_STATE_DATA_URI)){const O=await this.getLocalGlobalState();return o(O,!0)}if(this.extUri.isEqual(this.remoteResource,N)||this.extUri.isEqual(this.baseResource,N)||this.extUri.isEqual(this.localResource,N)||this.extUri.isEqual(this.acceptedResource,N)){const O=await this.resolvePreviewContent(N);return O&&o(JSON.parse(O),!0)}let A=await super.resolveContent(N);if(A)return A;if(A=await super.resolveContent(this.extUri.dirname(N)),A){const O=this.parseSyncData(A);if(O)switch(this.extUri.basename(N)){case"globalState.json":return o(JSON.parse(O.content),!0)}}return null}async hasLocalData(){try{const{storage:N}=await this.getLocalGlobalState();if(Object.keys(N).length>1||N[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const N={},A=await this.getLocalArgvContent(),O=(0,L.parse)(A);for(const M of n)O[M]!==void 0&&(N[`${t}${M}`]={version:1,value:O[M]});const k=await this.userDataSyncProfilesStorageService.readStorageData(this.profile);for(const[M,$]of k)$.value&&$.target===0&&(N[M]={version:1,value:$.value});return{storage:N}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const N=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),N.value.toString()}catch(N){this.logService.debug((0,r.getErrorMessage)(N))}return"{}"}async writeLocalGlobalState({added:N,removed:A,updated:O}){const k={},M=new Map,$=await this.userDataSyncProfilesStorageService.readStorageData(this.profile),W=(J,H)=>{for(const G of J){if(G.startsWith(t)){k[G.substring(t.length)]=H?H[G].value:void 0;continue}if(H){const q=H[G];q.value!==$.get(G)?.value&&M.set(G,q.value)}else $.get(G)!==void 0&&M.set(G,void 0)}};W(Object.keys(N),N),W(Object.keys(O),O),W(A),Object.keys(k).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(k),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),M.size&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`),await this.userDataSyncProfilesStorageService.updateStorageData(this.profile,M,0),this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,[...M.keys()]))}async updateArgv(N){const A=await this.getLocalArgvContent();let O=A;for(const k of Object.keys(N))O=(0,a.edit)(O,[k],N[k],{});A!==O&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(O)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}async getStorageKeys(N){const A=await this.userDataSyncProfilesStorageService.readStorageData(this.profile),O=[],k=[];for(const[W,J]of A)J.target===0?O.push(W):J.target===1&&k.push(W);const M=[...O,...k],$=N?.storage?Object.keys(N.storage).filter(W=>!W.startsWith(t)&&!M.includes(W)&&A.get(W)!==void 0):[];if(!I.isWeb){const W=[...l.ALL_SYNC_RESOURCES.map(J=>(0,l.getEnablementKey)(J)),l.SYNC_SERVICE_URL_TYPE];$.push(...W),k.push(...W)}return{user:O,machine:k,unregistered:$}}};u.GLOBAL_STATE_DATA_URI=E.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),u=pe([K(1,s.IUserDataSyncProfilesStorageService),K(2,m.IFileService),K(3,l.IUserDataSyncStoreService),K(4,l.IUserDataSyncBackupStoreService),K(5,l.IUserDataSyncLogService),K(6,S.IEnvironmentService),K(7,l.IUserDataSyncEnablementService),K(8,P.ITelemetryService),K(9,b.IConfigurationService),K(10,y.IStorageService),K(11,p.IUriIdentityService)],u),e.GlobalStateSynchroniser=u;let f=class extends g.AbstractInitializer{constructor(N,A,O,k,M,$){super("globalState",O,k,M,A,$),this.storageService=N}async doInitialize(N){const A=N.syncData?JSON.parse(N.syncData.content):null;if(!A){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const O={},k={};for(const M of Object.keys(A.storage))M.startsWith(t)?O[M.substring(t.length)]=A.storage[M].value:this.storageService.get(M,0)===void 0&&(k[M]=A.storage[M].value);if(Object.keys(O).length){let M="{}";try{M=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const $ of Object.keys(O))M=(0,a.edit)(M,[$],O[$],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(M))}if(Object.keys(k).length)for(const M of Object.keys(k))this.storageService.store(M,k[M],0,0)}};f=pe([K(0,y.IStorageService),K(1,m.IFileService),K(2,i.IUserDataProfilesService),K(3,S.IEnvironmentService),K(4,l.IUserDataSyncLogService),K(5,p.IUriIdentityService)],f),e.GlobalStateInitializer=f;let w=class{constructor(N,A,O,k,M){this.userDataSyncStoreClient=N,this.storageService=A,this.environmentService=O,this.fileService=k,this.logService=M}getSyncStoreType(N){return this.parseGlobalState(N)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(N){const A=(0,l.createSyncHeaders)((0,C.generateUuid)());try{return await this.doSync(N,A)}catch(O){if(O instanceof l.UserDataSyncError)switch(O.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(N,A)}throw O}}async doSync(N,A){const O=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,A),k=this.parseGlobalState(O)||{storage:{}};k.storage[l.SYNC_SERVICE_URL_TYPE]={value:N,version:c};const M=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:c,machineId:M,content:o(k,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify($),O.ref,void 0,A)}parseGlobalState({content:N}){if(!N)return null;const A=JSON.parse(N);if((0,g.isSyncData)(A))return A?JSON.parse(A.content):null;throw new Error("Invalid remote data")}};w=pe([K(1,y.IStorageService),K(2,S.IEnvironmentService),K(3,m.IFileService),K(4,v.ILogService)],w),e.UserDataSyncStoreTypeSynchronizer=w}),define(ne[266],re([0,1,19,6,38,3,2,17,15,30,18,29,5,25,20,22,23,257,265,258,259,260,261,262,26]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p,g,a,d,l,i,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let o=class extends T.Disposable{constructor(A,O,k,M,$,W,J,H,G){super(),this.userDataSyncStoreService=A,this.userDataSyncStoreManagementService=O,this.instantiationService=k,this.configurationService=M,this.logService=$,this.telemetryService=W,this.storageService=J,this.userDataSyncEnablementService=H,this.userDataProfilesService=G,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this._status=O.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(n,-1,void 0),this._register((0,T.toDisposable)(()=>this.clearProfileSynchronizers()))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(A,O){this.checkEnablement();const k=(0,C.generateUuid)();try{const J=(0,t.createSyncHeaders)(k);O&&(J["Cache-Control"]="no-cache"),A=await this.userDataSyncStoreService.manifest(A,J)}catch(J){const H=t.UserDataSyncError.toUserDataSyncError(J);throw w(H,k,this.userDataSyncStoreManagementService,this.telemetryService),H}const M=!1,$=this;let W;return{manifest:A,async run(){if(M)throw new Error("Can run a task only once");return W=(0,r.createCancelablePromise)(J=>$.sync(A,k,J)),W.finally(()=>W=void 0)},stop(){return W?.cancel(),$.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const A=(0,C.generateUuid)(),O=(0,t.createSyncHeaders)(A);let k;try{k=await this.userDataSyncStoreService.manifest(null,O)}catch(W){const J=t.UserDataSyncError.toUserDataSyncError(W);throw w(J,A,this.userDataSyncStoreManagementService,this.telemetryService),J}await this.resetLocal();const M=this.getProfileSynchronizers(),$=async()=>{await this.stop(),await this.resetLocal()};return new c(A,k,O,M[0].enabled,$,this.configurationService,this.logService)}async sync(A,O,k){if(k.isCancellationRequested)return;const M=this.getProfileSynchronizers(),$=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");for(const W of M){if(k.isCancellationRequested)return;this._syncErrors.push(...await W.sync(A,O,k))}this.logService.info(`Sync done. Took ${new Date().getTime()-$}ms`),this.updateLastSyncTime()}finally{this._onSyncErrors.fire(this._syncErrors)}}async stop(){this.status!=="idle"&&this.profileSynchronizers&&await Promise.allSettled([...this.profileSynchronizers.values()].map(([A])=>A.stop()))}async replace(A){this.checkEnablement(),await this.performSynchronizerAction(async O=>{if(await O.replace(A))return!0})}async accept(A,O,k,M){this.checkEnablement(),await this.performSynchronizerAction(async $=>{if($.resource===A)return await $.accept(O,k),M&&await $.apply(!1,(0,t.createSyncHeaders)((0,C.generateUuid)())),!0})}async resolveContent(A){return this.performSynchronizerAction(async O=>{const k=await O.resolveContent(A);if(k)return k})}async getRemoteSyncResourceHandles(A){return await this.performSynchronizerAction(async k=>{if(k.resource===A)return k.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(A){return await this.performSynchronizerAction(async k=>{if(k.resource===A)return k.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(A,O){return await this.performSynchronizerAction(async M=>{if(M.resource===A)return M.getAssociatedResources(O)})||[]}async getMachineId(A,O){return await this.performSynchronizerAction(async M=>{if(M.resource===A)return await M.getMachineId(O)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async O=>{if(O.resource!=="globalState"&&await O.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async O=>{if(await O.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(A){this.logService.error(A)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(n,-1),this.profileSynchronizers){for(const[A]of this.profileSynchronizers.values())try{await A.resetLocal()}catch(O){this.logService.error(O)}this.clearProfileSynchronizers()}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(A){const O=new T.DisposableStore;try{let k=this.profileSynchronizers;k||(k=this.createProfileSynchronizers(),k.forEach(([,M])=>O.add(M)));for(const[M]of k.values()){const $=[...M.enabled,...M.disabled.map(W=>O.add(M.createSynchronizer(W)))];for(const W of $){const J=await A(W);if(!(0,E.isUndefined)(J))return J}}return null}finally{O.dispose()}}setStatus(A){const O=this._status;this._status!==A&&(this._status=A,this._onDidChangeStatus.fire(A),O==="hasConflicts"&&this.updateLastSyncTime())}setConflicts(A){(0,R.equals)(this._conflicts,A,([O,k],[M,$])=>O===O&&(0,R.equals)(k,$,(W,J)=>(0,I.isEqual)(W.previewResource,J.previewResource)))||(this._conflicts=A,this._onDidChangeConflicts.fire(A))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(n,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getProfileSynchronizers(){return this.profileSynchronizers||(this.profileSynchronizers=this.createProfileSynchronizers()),[...this.profileSynchronizers.values()].map(([A])=>A)}createProfileSynchronizers(){const A=new Map;for(const O of[this.userDataProfilesService.defaultProfile]){const k=new T.DisposableStore,M=k.add(this.instantiationService.createInstance(u,O));k.add(M.onDidChangeStatus($=>this.setStatus($))),k.add(M.onDidChangeConflicts($=>this.setConflicts($))),k.add(M.onDidChangeLocal($=>this._onDidChangeLocal.fire($))),A.set(O.id,[M,k])}return A}clearProfileSynchronizers(){this.profileSynchronizers&&(this.profileSynchronizers.forEach(([,A])=>A.dispose()),this.profileSynchronizers.clear(),this.profileSynchronizers=void 0)}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=pe([K(0,t.IUserDataSyncStoreService),K(1,t.IUserDataSyncStoreManagementService),K(2,m.IInstantiationService),K(3,b.IConfigurationService),K(4,t.IUserDataSyncLogService),K(5,y.ITelemetryService),K(6,h.IStorageService),K(7,t.IUserDataSyncEnablementService),K(8,P.IUserDataProfilesService)],o),e.UserDataSyncService=o;class c extends T.Disposable{constructor(A,O,k,M,$,W,J){super(),this.id=A,this.manifest=O,this.syncHeaders=k,this.synchronisers=M,this.onStop=$,this.configurationService=W,this.logService=J,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(A=>A.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(A=>A.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,r.createCancelablePromise)(A=>this.getPreviews(A))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(A){throw this.logService.error(A),A}}async accept(A,O){try{return await this.performAction(A,k=>k.accept(A,O))}catch(k){throw this.logService.error(k),k}}async merge(A){try{return A?await this.performAction(A,O=>O.merge(A)):await this.mergeAll()}catch(O){throw this.logService.error(O),O}}async discard(A){try{return await this.performAction(A,O=>O.discard(A))}catch(O){throw this.logService.error(O),O}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const A=[];for(const[,O]of this.previews)for(const k of O.resourcePreviews)k.mergeState==="conflict"&&A.push(k.previewResource);for(const O of A)await this.discard(O);return this.previews}catch(A){throw this.logService.error(A),A}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const A=[];for(const[O,k]of this.previews){this.synchronizingResources.push([O,k.resourcePreviews.map(W=>W.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const M=this.synchronisers.find(W=>W.resource===O);for(const W of k.resourcePreviews)(W.localChange!==0||W.remoteChange!==0)&&W.mergeState==="preview"&&await M.merge(W.previewResource);const $=await M.apply(!1,this.syncHeaders);$&&A.push(this.toSyncResourcePreview(M.resource,$)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(W=>W[0]===O),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=A,this.previews}catch(A){throw this.logService.error(A),A}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[A,O]of this.previews){this.synchronizingResources.push([A,O.resourcePreviews.map(M=>M.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const k=this.synchronisers.find(M=>M.resource===A);for(const M of O.resourcePreviews)await k.accept(M.remoteResource);await k.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(M=>M[0]===A),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(A){throw this.logService.error(A),A}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[A,O]of this.previews){this.synchronizingResources.push([A,O.resourcePreviews.map(M=>M.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const k=this.synchronisers.find(M=>M.resource===A);for(const M of O.resourcePreviews)await k.accept(M.localResource);await k.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(M=>M[0]===A),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(A){throw this.logService.error(A),A}}async stop(){await this.onStop(),this.reset()}async performAction(A,O){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const k=this.previews.findIndex(([,x])=>x.resourcePreviews.some(({localResource:Y,previewResource:te,remoteResource:ce})=>(0,I.isEqual)(A,Y)||(0,I.isEqual)(A,te)||(0,I.isEqual)(A,ce)));if(k===-1)return this.previews;const[M,$]=this.previews[k],W=$.resourcePreviews.find(({localResource:x,remoteResource:Y,previewResource:te})=>(0,I.isEqual)(x,A)||(0,I.isEqual)(Y,A)||(0,I.isEqual)(te,A));if(!W)return this.previews;let J=this.synchronizingResources.find(x=>x[0]===M);J||(J=[M,[]],this.synchronizingResources.push(J)),J[1].some(x=>(0,I.isEqual)(x,W.localResource))||(J[1].push(W.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const H=this.synchronisers.find(x=>x.resource===this.previews[k][0]),G=await O(H);G?this.previews.splice(k,1,this.toSyncResourcePreview(H.resource,G)):this.previews.splice(k,1);const q=this.synchronizingResources.findIndex(x=>x[0]===M);return this.synchronizingResources[q][1].splice(J[1].findIndex(x=>(0,I.isEqual)(x,W.localResource)),1),J[1].length||(this.synchronizingResources.splice(q,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const A=[];for(const[O,k]of this.previews){this.synchronizingResources.push([O,k.resourcePreviews.map(W=>W.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const M=this.synchronisers.find(W=>W.resource===O);let $=k;for(const W of k.resourcePreviews)(W.localChange!==0||W.remoteChange!==0)&&W.mergeState==="preview"&&($=await M.merge(W.previewResource));$&&A.push(this.toSyncResourcePreview(M.resource,$)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(W=>W[0]===O),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=A,this.previews}async getPreviews(A){const O=[],k=await this.getUserDataSyncConfiguration();for(const M of this.synchronisers){if(A.isCancellationRequested)return[];const $=await M.preview(this.manifest,k,this.syncHeaders);$&&O.push(this.toSyncResourcePreview(M.resource,$))}return O}async getUserDataSyncConfiguration(){const A=this.configurationService.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),O=this.synchronisers.find(k=>k instanceof d.SettingsSynchroniser);if(O){const k=await O.getRemoteUserDataSyncConfiguration(this.manifest);return{...A,...k}}return A}toSyncResourcePreview(A,O){return[A,{isLastSyncFromCurrentMachine:O.isLastSyncFromCurrentMachine,resourcePreviews:O.resourcePreviews.map(_)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let u=class extends T.Disposable{constructor(A,O,k,M,$,W,J,H,G){super(),this.profile=A,this.userDataSyncEnablementService=O,this.instantiationService=k,this.extensionGalleryService=M,this.userDataSyncStoreManagementService=$,this.telemetryService=W,this.logService=J,this.productService=H,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.profile.isDefault&&this._register(G.onDidChangeProfiles(()=>{(G.defaultProfile.extensionsResource&&!this.profile.extensionsResource||!G.defaultProfile.extensionsResource&&this.profile.extensionsResource)&&(this.deRegisterSynchronizer("extensions"),this.profile=G.defaultProfile,this.registerSynchronizer("extensions"))})),this._register(O.onDidChangeResourceEnablement(([q,x])=>this.onDidChangeResourceEnablement(q,x))),this._register((0,T.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,q])=>q.dispose())));for(const q of t.ALL_SYNC_RESOURCES)O.isResourceEnabled(q)&&this.registerSynchronizer(q)}get enabled(){return this._enabled.sort((A,O)=>A[1]-O[1]).map(([A])=>A)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(A=>!this.userDataSyncEnablementService.isResourceEnabled(A))}get status(){return this._status}get conflicts(){return this._conflicts}onDidChangeResourceEnablement(A,O){O?this.registerSynchronizer(A):this.deRegisterSynchronizer(A)}registerSynchronizer(A){if(this._enabled.some(([$])=>$.resource===A))return;if(A==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(A==="profiles"){if(!this.profile.isDefault)return;if(!this.productService.enableSyncingProfiles){this.logService.debug("Skipping profiles sync");return}}const O=new T.DisposableStore,k=O.add(this.createSynchronizer(A));O.add(k.onDidChangeStatus(()=>this.updateStatus())),O.add(k.onDidChangeConflicts(()=>this.updateConflicts())),O.add(k.onDidChangeLocal(()=>this._onDidChangeLocal.fire(A)));const M=this.getOrder(A);this._enabled.push([k,M,O])}deRegisterSynchronizer(A){const O=this._enabled.findIndex(([k])=>k.resource===A);if(O!==-1){const k=this._enabled.splice(O,1);for(const[M,,$]of k){if(M.status!=="idle"){const W=M.conflicts.length>0;M.stop(),W&&this.updateConflicts(),this.updateStatus()}$.dispose()}}}createSynchronizer(A){switch(A){case"settings":return this.instantiationService.createInstance(d.SettingsSynchroniser,this.profile.settingsResource);case"keybindings":return this.instantiationService.createInstance(a.KeybindingsSynchroniser,this.profile.keybindingsResource);case"snippets":return this.instantiationService.createInstance(l.SnippetsSynchroniser,this.profile.snippetsHome);case"tasks":return this.instantiationService.createInstance(i.TasksSynchroniser,this.profile.tasksResource);case"globalState":return this.instantiationService.createInstance(g.GlobalStateSynchroniser,this.profile);case"extensions":return this.instantiationService.createInstance(p.ExtensionsSynchroniser,this.profile.extensionsResource);case"profiles":return this.instantiationService.createInstance(s.UserDataProfilesManifestSynchroniser)}}async sync(A,O,k){if(k.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const $=[],W=(0,t.createSyncHeaders)(O);for(const J of M){if(k.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(J.resource))return[];try{await J.sync(A,W)}catch(H){const G=t.UserDataSyncError.toUserDataSyncError(H);if(w(G,O,this.userDataSyncStoreManagementService,this.telemetryService),f(H))throw G;this.logService.error(H),this.logService.error(`${J.resource}: ${(0,D.toErrorMessage)(H)}`),$.push([J.resource,G])}}return $}finally{this.updateStatus()}}async stop(){for(const A of this.enabled)try{A.status!=="idle"&&await A.stop()}catch(O){this.logService.error(O)}}async resetLocal(){for(const A of this.enabled)try{await A.resetLocal()}catch(O){this.logService.error(`${A.resource}: ${(0,D.toErrorMessage)(O)}`),this.logService.error(O)}}setStatus(A){this._status!==A&&(this._status=A,this._onDidChangeStatus.fire(A))}updateStatus(){return this.updateConflicts(),this.enabled.some(A=>A.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(A=>A.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const A=this.enabled.filter(O=>O.status==="hasConflicts").map(O=>[O.resource,O.conflicts.map(_)]);(0,R.equals)(this._conflicts,A,([O,k],[M,$])=>O===O&&(0,R.equals)(k,$,(W,J)=>(0,I.isEqual)(W.previewResource,J.previewResource)))||(this._conflicts=A,this._onDidChangeConflicts.fire(A))}getOrder(A){switch(A){case"profiles":return 0;case"settings":return 1;case"keybindings":return 2;case"snippets":return 3;case"tasks":return 4;case"globalState":return 5;case"extensions":return 6}}};u=pe([K(1,t.IUserDataSyncEnablementService),K(2,m.IInstantiationService),K(3,S.IExtensionGalleryService),K(4,t.IUserDataSyncStoreManagementService),K(5,y.ITelemetryService),K(6,t.IUserDataSyncLogService),K(7,v.IProductService),K(8,P.IUserDataProfilesService)],u);function f(N){if(N instanceof t.UserDataSyncError)switch(N.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function w(N,A,O,k){k.publicLog2("sync/error",{code:N.code,serverCode:N instanceof t.UserDataSyncStoreError?String(N.serverCode):void 0,url:N instanceof t.UserDataSyncStoreError?N.url:void 0,resource:N.resource,executionId:A,service:O.userDataSyncStore.url.toString()})}function _(N){return{baseResource:N.baseResource,localResource:N.localResource,previewResource:N.previewResource,remoteResource:N.remoteResource,acceptedResource:N.acceptedResource,localChange:N.localChange,remoteChange:N.remoteChange,mergeState:N.mergeState}}}),define(ne[267],re([0,1,6,24,9,3,2,127,4,17,15,7,30,18,14,13,25,45,48,20,26]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p,g,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",i="sync.donot-make-requests-until",s="sync.user-session-id",t="sync.machine-session-id",n=100,o=1e3*60*5;let c=class extends T.Disposable{constructor(A,O,k){super(),this.productService=A,this.configurationService=O,this.storageService=k,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(k.onDidChangeValue,M=>M.key===d.SYNC_SERVICE_URL_TYPE&&M.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(d.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(A){this.storageService.store(d.SYNC_SERVICE_URL_TYPE,A,-1,E.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[d.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(d.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(A,O){A=E.isWeb&&A?.web?{...A,...A.web}:A;const k={...A||{},...O||{}};if(k&&(0,b.isString)(k.url)&&(0,b.isObject)(k.authenticationProviders)&&Object.keys(k.authenticationProviders).every(M=>Array.isArray(k.authenticationProviders[M].scopes))){const M=k,$=!!M.canSwitch&&!O?.url,W=M.url===M.insidersUrl?"insiders":"stable",J=($?this.userDataSyncStoreType:void 0)||W,H=O?.url||(J==="insiders"?M.insidersUrl:J==="stable"?M.stableUrl:M.url);return{url:S.URI.parse(H),type:J,defaultType:W,defaultUrl:S.URI.parse(M.url),stableUrl:S.URI.parse(M.stableUrl),insidersUrl:S.URI.parse(M.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(M.authenticationProviders).reduce((G,q)=>(G.push({id:q,scopes:M.authenticationProviders[q].scopes}),G),[])}}}};c=pe([K(0,P.IProductService),K(1,v.IConfigurationService),K(2,a.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let u=class extends c{constructor(A,O,k){super(A,O,k);const M=this.storageService.get(l,-1);M&&(this.previousConfigurationSyncStore=JSON.parse(M));const $=this.productService[d.CONFIGURATION_SYNC_STORE_KEY];$?this.storageService.store(l,JSON.stringify($),-1,1):this.storageService.remove(l,-1)}async switch(A){A!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=A,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=pe([K(0,P.IProductService),K(1,v.IConfigurationService),K(2,a.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let f=class extends T.Disposable{constructor(A,O,k,M,$,W,J){super(),this.requestService=k,this.logService=M,this.storageService=J,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(A),this.commonHeadersPromise=(0,g.getServiceMachineId)($,W,J).then(H=>{const G={"X-Client-Name":`${O.applicationName}${E.isWeb?"-web":""}`,"X-Client-Version":O.version};return O.commit&&(G["X-Client-Commit"]=O.commit),G}),this.session=new _(n,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(A,O){this.authToken={token:A,type:O}}updateUserDataSyncStoreUrl(A){this.userDataSyncStoreUrl=A?(0,C.joinPath)(A,"v1"):void 0}initDonotMakeRequestsUntil(){const A=this.storageService.getNumber(i,-1);A&&Date.now()<A&&this.setDonotMakeRequestsUntil(new Date(A))}setDonotMakeRequestsUntil(A){this._donotMakeRequestsUntil?.getTime()!==A?.getTime()&&(this._donotMakeRequestsUntil=A,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(O=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),O).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,O=>null)):this.storageService.remove(i,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(A={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,C.joinPath)(this.userDataSyncStoreUrl,"collection").toString();A={...A},A["Content-Type"]="application/json";const k=await this.request(O,{type:"GET",headers:A},[],r.CancellationToken.None);return await(0,p.asJson)(k)||[]}async createCollection(A={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,C.joinPath)(this.userDataSyncStoreUrl,"collection").toString();A={...A},A["Content-Type"]=I.Mimes.text;const k=await this.request(O,{type:"POST",headers:A},[],r.CancellationToken.None),M=await(0,p.asTextOrError)(k);if(!M)throw new d.UserDataSyncStoreError("Server did not return the collection id",O,"NoCollection",k.res.statusCode,k.res.headers[d.HEADER_OPERATION_ID]);return M}async deleteCollection(A,O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=A?(0,C.joinPath)(this.userDataSyncStoreUrl,"collection",A).toString():(0,C.joinPath)(this.userDataSyncStoreUrl,"collection").toString();O={...O},await this.request(k,{type:"DELETE",headers:O},[],r.CancellationToken.None)}async getAllResourceRefs(A,O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=this.getResourceUrl(this.userDataSyncStoreUrl,O,A),M={},$=await this.request(k.toString(),{type:"GET",headers:M},[],r.CancellationToken.None);return(await(0,p.asJson)($)||[]).map(({url:J,created:H})=>({ref:(0,C.relativePath)(k,k.with({path:J})),created:H*1e3}))}async resolveResourceContent(A,O,k,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,C.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,A),O).toString();M={...M},M["Cache-Control"]="no-cache";const W=await this.request($,{type:"GET",headers:M},[],r.CancellationToken.None);return await(0,p.asTextOrError)(W)}async deleteResource(A,O,k){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=O!==null?(0,C.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,A),O).toString():this.getResourceUrl(this.userDataSyncStoreUrl,k,A).toString(),$={};await this.request(M,{type:"DELETE",headers:$},[],r.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const A=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),O={"Content-Type":I.Mimes.text};await this.request(A,{type:"DELETE",headers:O},[],r.CancellationToken.None)}async readResource(A,O,k,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,C.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,A),"latest").toString();M={...M},M["Cache-Control"]="no-cache",O&&(M["If-None-Match"]=O.ref);const W=await this.request($,{type:"GET",headers:M},[304],r.CancellationToken.None);let J=null;if(W.res.statusCode===304&&(J=O),J===null){const H=W.res.headers.etag;if(!H)throw new d.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",W.res.statusCode,W.res.headers[d.HEADER_OPERATION_ID]);const G=await(0,p.asTextOrError)(W);if(!G&&W.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",$,"EmptyResponse",W.res.statusCode,W.res.headers[d.HEADER_OPERATION_ID]);J={ref:H,content:G}}return J}async writeResource(A,O,k,M,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=this.getResourceUrl(this.userDataSyncStoreUrl,M,A).toString();$={...$},$["Content-Type"]=I.Mimes.text,k&&($["If-Match"]=k);const J=await this.request(W,{type:"POST",data:O,headers:$},[],r.CancellationToken.None),H=J.res.headers.etag;if(!H)throw new d.UserDataSyncStoreError("Server did not return the ref",W,"NoRef",J.res.statusCode,J.res.headers[d.HEADER_OPERATION_ID]);return H}async manifest(A,O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,C.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();O={...O},O["Content-Type"]="application/json",A&&(O["If-None-Match"]=A.ref);const M=await this.request(k,{type:"GET",headers:O},[304],r.CancellationToken.None);let $=null;if(M.res.statusCode===304&&($=A),!$){const J=M.res.headers.etag;if(!J)throw new d.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",M.res.statusCode,M.res.headers[d.HEADER_OPERATION_ID]);const H=await(0,p.asTextOrError)(M);if(!H&&M.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",k,"EmptyResponse",M.res.statusCode,M.res.headers[d.HEADER_OPERATION_ID]);H&&($={...JSON.parse(H),ref:J})}const W=this.storageService.get(s,-1);return W&&$&&W!==$.session&&this.clearSession(),$===null&&W&&this.clearSession(),$&&this.storageService.store(s,$.session,-1,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteResources(),await this.deleteCollection(),this.clearSession()}getResourceUrl(A,O,k){return O?(0,C.joinPath)(A,"collection",O,"resource",k):(0,C.joinPath)(A,"resource",k)}clearSession(){this.storageService.remove(s,-1),this.storageService.remove(t,-1)}async request(A,O,k,M){if(!this.authToken)throw new d.UserDataSyncStoreError("No Auth Token Available",A,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new d.UserDataSyncStoreError(`${O.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const $=await this.commonHeadersPromise;O.headers={...O.headers||{},...$,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(O.headers),this.logService.trace("Sending request to server",{url:A,type:O.type,headers:{...O.headers,authorization:void 0}});let W;try{W=await this.session.request(A,O,M)}catch(q){if(!(q instanceof d.UserDataSyncStoreError)){let x="RequestFailed";const Y=(0,D.getErrorMessage)(q).toLowerCase();Y.includes("xhr timeout")?x="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?x="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?x="RequestPathNotEscaped":Y.includes("headers must be an object")?x="RequestHeadersNotObject":(0,D.isCancellationError)(q)&&(x="RequestCanceled"),q=new d.UserDataSyncStoreError(`Connection refused for the request '${A}'.`,A,x,void 0,void 0)}throw this.logService.info("Request failed",A),q}const J=W.res.headers[d.HEADER_OPERATION_ID],H={url:A,status:W.res.statusCode,"execution-id":O.headers[d.HEADER_EXECUTION_ID],"operation-id":J},G=(0,p.isSuccess)(W)||W.res.statusCode&&k.indexOf(W.res.statusCode)!==-1;if(G?this.logService.trace("Request succeeded",H):this.logService.info("Request failed",H),W.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new d.UserDataSyncStoreError(`Request '${A}' failed because of Unauthorized (401).`,A,"Unauthorized",W.res.statusCode,J);if(this._onTokenSucceed.fire(),W.res.statusCode===409)throw new d.UserDataSyncStoreError(`${O.type} request '${A}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,A,"Conflict",W.res.statusCode,J);if(W.res.statusCode===410)throw new d.UserDataSyncStoreError(`${O.type} request '${A}' failed because the requested resource is not longer available (410).`,A,"Gone",W.res.statusCode,J);if(W.res.statusCode===412)throw new d.UserDataSyncStoreError(`${O.type} request '${A}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,A,"PreconditionFailed",W.res.statusCode,J);if(W.res.statusCode===413)throw new d.UserDataSyncStoreError(`${O.type} request '${A}' failed because of too large payload (413).`,A,"TooLarge",W.res.statusCode,J);if(W.res.statusCode===426)throw new d.UserDataSyncStoreError(`${O.type} request '${A}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,A,"UpgradeRequired",W.res.statusCode,J);if(W.res.statusCode===429){const q=W.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new d.UserDataSyncStoreError(`${O.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",W.res.statusCode,J)):new d.UserDataSyncStoreError(`${O.type} request '${A}' failed because of too many requests (429).`,A,"RemoteTooManyRequests",W.res.statusCode,J)}if(!G)throw new d.UserDataSyncStoreError("Server returned "+W.res.statusCode,A,"Unknown",W.res.statusCode,J);return W}addSessionHeaders(A){let O=this.storageService.get(t,-1);O===void 0&&(O=(0,m.generateUuid)(),this.storageService.store(t,O,-1,1)),A["X-Machine-Session-Id"]=O;const k=this.storageService.get(s,-1);k!==void 0&&(A["X-User-Session-Id"]=k)}};f=pe([K(1,P.IProductService),K(2,p.IRequestService),K(3,d.IUserDataSyncLogService),K(4,h.IEnvironmentService),K(5,y.IFileService),K(6,a.IStorageService)],f),e.UserDataSyncStoreClient=f;let w=class extends f{constructor(A,O,k,M,$,W,J){super(A.userDataSyncStore?.url,O,k,M,$,W,J),this._register(A.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(A.userDataSyncStore?.url)))}};w=pe([K(0,d.IUserDataSyncStoreManagementService),K(1,P.IProductService),K(2,p.IRequestService),K(3,d.IUserDataSyncLogService),K(4,h.IEnvironmentService),K(5,y.IFileService),K(6,a.IStorageService)],w),e.UserDataSyncStoreService=w;class _{constructor(A,O,k,M){this.limit=A,this.interval=O,this.requestService=k,this.logService=M,this.requests=[],this.startTime=void 0}request(A,O,k){if(this.isExpired()&&this.reset(),O.url=A,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new d.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,A,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(A),this.requestService.request(O,k)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=_}),define(ne[268],re([0,1,3,59,25,20,22,264,26,73,76]),function(Q,e,R,r,D,L,T,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let S=class extends I.UserDataAutoSyncService{constructor(v,h,y,P,p,g,a,d,l,i,s){super(v,h,y,P,p,a,d,l,i,s),this._register(R.Event.debounce(R.Event.any(R.Event.map(g.onDidFocusWindow,()=>"windowFocus"),R.Event.map(g.onDidOpenWindow,()=>"windowOpen")),(t,n)=>t?[...t,n]:[n],1e3)(t=>this.triggerSync(t,!0,!1)))}};S=pe([K(0,D.IProductService),K(1,E.IUserDataSyncStoreManagementService),K(2,E.IUserDataSyncStoreService),K(3,E.IUserDataSyncEnablementService),K(4,E.IUserDataSyncService),K(5,r.INativeHostService),K(6,E.IUserDataSyncLogService),K(7,C.IUserDataSyncAccountService),K(8,T.ITelemetryService),K(9,b.IUserDataSyncMachinesService),K(10,L.IStorageService)],S),e.UserDataAutoSyncService=S}),define(ne[269],re([0,1,3,2,58,8,77,20,71,23]),function(Q,e,R,r,D,L,T,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncProfilesStorageService=void 0;let b=class extends T.AbstractUserDataSyncProfilesStorageService{constructor(m,v,h,y){super(h),this.mainProcessService=m;const P=m.getChannel("profileStorageListener"),p=this._register(new r.MutableDisposable);this._onDidChange=this._register(new R.Emitter({onFirstListenerAdd:()=>{p.value=P.listen("onDidChange")(g=>{y.trace("profile storage changes",g),this._onDidChange.fire({targetChanges:g.targetChanges.map(a=>(0,C.reviveProfile)(a,v.profilesHome.scheme)),valueChanges:g.valueChanges.map(a=>({...a,profile:(0,C.reviveProfile)(a.profile,v.profilesHome.scheme)}))})})},onLastListenerRemove:()=>p.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(m){const v=this.mainProcessService.getChannel("storage");return(0,I.isProfileUsingDefaultStorage)(m)?new E.ApplicationStorageDatabaseClient(v):new E.ProfileStorageDatabaseClient(v,m)}};b=pe([K(0,D.IMainProcessService),K(1,C.IUserDataProfilesService),K(2,I.IStorageService),K(3,L.ILogService)],b),e.UserDataSyncProfilesStorageService=b}),define(ne[270],re([0,1,95,21,4,17]),function(Q,e,R,r,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(C){function b(){let S=C.scheme===r.Schemas.file?(0,L.originalFSPath)(C):C.toString();return D.isLinux||(S=S.toLowerCase()),(0,R.createHash)("md5").update(S).digest("hex")}return{id:b(),configPath:C}}e.getWorkspaceIdentifier=T;function I(C,b){function S(){if(C.scheme!==r.Schemas.file)return(0,R.createHash)("md5").update(C.toString()).digest("hex");if(!b)return;let v;return D.isLinux?v=b.ino:D.isMacintosh?v=b.birthtime.getTime():D.isWindows&&(typeof b.birthtimeMs=="number"?v=Math.floor(b.birthtimeMs):v=b.birthtime.getTime()),(0,R.createHash)("md5").update(C.fsPath).update(v?String(v):"").digest("hex")}const m=S();if(typeof m=="string")return{id:m,uri:C}}e.getSingleFolderWorkspaceIdentifier=I;function E(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=E}),define(ne[271],re([0,1,6,9,2,12,28,14,58,8,59,71,111,270]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let h=class extends D.Disposable{constructor(P,p,g,a){super(),this.environmentService=P,this.logService=p,this.nativeHostService=g,this.mainProcessService=a,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const P=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),p=new S.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(P.map(async g=>{const a=(0,L.join)(this.environmentService.workspaceStorageHome.fsPath,g);g.length===v.NON_EMPTY_WORKSPACE_ID_LENGTH||g===m.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(i=>i.workspace?.id===g)||await p.isUsed(a)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await T.Promises.rm(a))}))}catch(P){(0,r.onUnexpectedError)(P)}}};h=pe([K(0,I.INativeEnvironmentService),K(1,C.ILogService),K(2,b.INativeHostService),K(3,E.IMainProcessService)],h),e.UnusedWorkspaceStorageDataCleaner=h}),define(ne[112],re([0,1,53,6,12,15,28,139,280,281]),function(Q,e,R,r,D,L,T,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class b extends Error{constructor(i,s){let t=s.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=s}}e.ExtractError=b;function S(l){const i=l.externalFileAttributes>>16||33188;return[448,56,7].map(s=>i&s).reduce((s,t)=>s+t,i&61440)}function m(l){if(l instanceof b)return l;let i;return/end of central directory record signature not found/.test(l.message)&&(i="CorruptZip"),new b(i,l)}function v(l,i,s,t,n,o){const c=D.dirname(i),u=D.join(t,c);if(!u.startsWith(t))return Promise.reject(new Error(I.localize(0,null,i)));const f=D.join(t,i);let w;return o.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(T.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((_,N)=>{if(!o.isCancellationRequested)try{w=(0,R.createWriteStream)(f,{mode:s}),w.once("close",()=>_()),w.once("error",N),l.once("error",N),l.pipe(w)}catch(A){N(A)}}))}function h(l,i,s,t){let n=(0,r.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{n.cancel(),l.close()}),new Promise((c,u)=>{const f=new r.Sequencer,w=_=>{_.isCancellationRequested||(o++,l.readEntry())};l.once("error",u),l.once("close",()=>n.then(()=>{t.isCancellationRequested||l.entryCount===o?c():u(new b("Incomplete",new Error(I.localize(1,null,o,l.entryCount))))},u)),l.readEntry(),l.on("entry",_=>{if(t.isCancellationRequested)return;if(!s.sourcePathRegex.test(_.fileName)){w(t);return}const N=_.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(N)){const k=D.join(i,N);n=(0,r.createCancelablePromise)(M=>T.Promises.mkdir(k,{recursive:!0}).then(()=>w(M)).then(void 0,u));return}const A=P(l,_),O=S(_);n=(0,r.createCancelablePromise)(k=>f.queue(()=>A.then(M=>v(M,N,O,i,s,k).then(()=>w(k)))).then(null,u))})})}function y(l,i=!1){return new Promise((s,t)=>{(0,E.open)(l,i?{lazyEntries:!0}:void 0,(n,o)=>{n?t(m(n)):s((0,L.assertIsDefined)(o))})})}function P(l,i){return new Promise((s,t)=>{l.openReadStream(i,(n,o)=>{n?t(m(n)):s((0,L.assertIsDefined)(o))})})}function p(l,i){return new Promise((s,t)=>{const n=new C.ZipFile;i.forEach(c=>{c.contents?n.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&n.addFile(c.localPath,c.path)}),n.end();const o=(0,R.createWriteStream)(l);n.outputStream.pipe(o),n.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>s(l))})}e.zip=p;function g(l,i,s={},t){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let o=y(l,!0);return s.overwrite&&(o=o.then(c=>T.Promises.rm(i).then(()=>c))),o.then(c=>h(c,i,{sourcePathRegex:n},t))}e.extract=g;function a(l,i){return y(l).then(s=>new Promise((t,n)=>{s.on("entry",o=>{o.fileName===i&&P(s,o).then(c=>t(c),c=>n(c))}),s.once("close",()=>n(new Error(I.localize(2,null,i))))}))}function d(l,i){return a(l,i).then(s=>new Promise((t,n)=>{const o=[];s.once("error",n),s.on("data",c=>o.push(c)),s.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=d}),define(ne[272],re([0,1,112,149]),function(Q,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(L){return(0,R.buffer)(L,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,r.localize)(0,null))}})}e.getManifest=D}),define(ne[113],re([0,1,6,38,9,2,21,12,4,17,55,15,7,30,28,112,148,93,14,249,29,33,49,74,203,250,272,204,234,44,68,13,5,8,25,22,31,23]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p,g,a,d,l,i,s,t,n,o,c,u,f,w,_,N,A,O,k,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,N.refineServiceDecorator)(d.IExtensionManagementService);let W=class extends a.AbstractExtensionManagementService{constructor(z,V,U,F,j,B,Z,oe,X,ie,se,ue){super(z,V,U,ie,ue),this.extensionsScannerService=j,this.extensionsProfileScannerService=B,this.downloadService=Z,this.fileService=X,this.installGalleryExtensionsTasks=new Map;const he=this._register(oe.createInstance(n.ExtensionsLifecycle));this.extensionsScanner=this._register(oe.createInstance(J,we=>he.postUninstall(we))),this.manifestCache=this._register(new c.ExtensionsManifestCache(F,this)),this.extensionsDownloader=this._register(oe.createInstance(t.ExtensionsDownloader));const ve=this._register(new u.ExtensionsWatcher(this,X,F,U,se));this._register(ve.onDidChangeExtensionsByAnotherSource(({added:we,removed:Ee})=>{we.length&&this._onDidInstallExtensions.fire(we.map(Pe=>({identifier:Pe.identifier,operation:1,local:Pe}))),Ee.forEach(Pe=>this._onDidUninstallExtension.fire({identifier:Pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(z){this.logService.trace("ExtensionManagementService#zip",z.identifier.id);const V=await this.collectFiles(z),U=await(0,y.zip)((0,C.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,V);return m.URI.file(U)}async unzip(z){return this.logService.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const{location:V,cleanup:U}=await this.downloadVsix(z),F=I.resolve(V.fsPath);try{return await(0,o.getManifest)(F)}finally{await U()}}getInstalled(z,V){return this.extensionsScanner.scanExtensions(z??null,V)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(z,V={}){this.logService.trace("ExtensionManagementService#install",z.toString());const{location:U,cleanup:F}=await this.downloadVsix(z);try{const j=await(0,o.getManifest)(I.resolve(U.fsPath));if(j.engines&&j.engines.vscode&&!(0,w.isEngineValid)(j.engines.vscode,this.productService.version,this.productService.date))throw new Error(P.localize(0,null,(0,l.getGalleryExtensionId)(j.publisher,j.name),this.productService.version));return await this.installExtension(j,U,V)}finally{await F()}}getMetadata(z){return this.extensionsScannerService.scanMetadata(z.location)}async updateMetadata(z,V){this.logService.trace("ExtensionManagementService#updateMetadata",z.identifier.id);const U={...V};return V.isPreReleaseVersion&&(U.preRelease=!0),z=await this.extensionsScanner.updateMetadata(z,U),this.manifestCache.invalidate(),z}async updateExtensionScope(z,V){return this.logService.trace("ExtensionManagementService#updateExtensionScope",z.identifier.id),z=await this.extensionsScanner.updateMetadata(z,{isMachineScoped:V}),this.manifestCache.invalidate(),z}removeUninstalledExtensions(z){return this.extensionsScanner.cleanUp(z)}async downloadVsix(z){if(z.scheme===T.Schemas.file)return{location:z,async cleanup(){}};this.logService.trace("Downloading extension from",z.toString());const V=(0,C.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(z,V),this.logService.info("Downloaded extension to",V.toString()),{location:V,cleanup:async()=>{try{await this.fileService.del(V)}catch(F){this.logService.error(F)}}}}doCreateInstallExtensionTask(z,V,U){let F;if(m.URI.isUri(V))F=new q(z,V,U,this.galleryService,this.extensionsScanner,this.logService);else{const j=l.ExtensionKey.create(V).toString();F=this.installGalleryExtensionsTasks.get(j),F||(this.installGalleryExtensionsTasks.set(j,F=new G(z,V,U,this.extensionsDownloader,this.extensionsScanner,this.logService)),F.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(j)))}return U.profileLocation?new x(F,U.profileLocation,this.extensionsProfileScannerService):F}doCreateUninstallExtensionTask(z,V){return V.profileLocation?new te(z,V.profileLocation,this.extensionsProfileScannerService):new Y(z,V,this.extensionsScanner)}async collectFiles(z){const V=async F=>{let j=await h.Promises.readdir(F);j=j.map(oe=>I.join(F,oe));const B=await Promise.all(j.map(oe=>h.Promises.stat(oe)));let Z=Promise.resolve([]);return B.forEach((oe,X)=>{const ie=j[X];oe.isFile()&&(Z=Z.then(se=>[...se,ie])),oe.isDirectory()&&(Z=Z.then(se=>V(ie).then(ue=>[...se,...ue])))}),Z};return(await V(z.location.fsPath)).map(F=>({path:`extension/${I.relative(z.location.fsPath,F)}`,localPath:F}))}};W=pe([K(0,d.IExtensionGalleryService),K(1,k.ITelemetryService),K(2,A.ILogService),K(3,g.INativeEnvironmentService),K(4,s.IExtensionsScannerService),K(5,i.IExtensionsProfileScannerService),K(6,p.IDownloadService),K(7,N.IInstantiationService),K(8,_.IFileService),K(9,O.IProductService),K(10,M.IUriIdentityService),K(11,$.IUserDataProfilesService)],W),e.ExtensionManagementService=W;let J=class extends L.Disposable{constructor(z,V,U,F){super(),this.beforeRemovingExtension=z,this.fileService=V,this.extensionsScannerService=U,this.logService=F,this.uninstalledPath=(0,C.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new R.Queue}async cleanUp(z){await this.removeUninstalledExtensions(),z&&await this.removeOutdatedExtensions()}async scanExtensions(z,V){const U={includeInvalid:!0,profileLocation:V};let F=[];return z===null||z===0?F.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},U,!1)):z===1&&F.push(...await this.extensionsScannerService.scanUserExtensions(U)),F=z!==null?F.filter(j=>j.type===z):F,Promise.all(F.map(j=>this.toLocalExtension(j)))}async scanUserExtensions(z){const V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!z,includeInvalid:!0});return Promise.all(V.map(U=>this.toLocalExtension(U)))}async extractUserExtension(z,V,U,F){const j=z.toString(),B=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),Z=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,j);try{await h.Promises.rm(Z)}catch{throw new d.ExtensionManagementError(P.localize(1,null,Z,z.id),d.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(z,V,B,F),U={...U,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(m.URI.file(B),U);try{await this.rename(z,B,Z,Date.now()+2*60*1e3),this.logService.info("Renamed to",Z)}catch(oe){try{await h.Promises.rm(B)}catch{}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",z.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(oe)}. Deleted from extracted location`,B),oe}return this.scanLocalExtension(m.URI.file(Z),1)}async updateMetadata(z,V){return await this.extensionsScannerService.updateMetadata(z.location,V),this.scanLocalExtension(z.location,z.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...z){const V=z.map(U=>l.ExtensionKey.create(U));await this.withUninstalledExtensions(U=>{V.forEach(F=>U[F.toString()]=!0)})}async setInstalled(z){await this.withUninstalledExtensions(F=>delete F[z.toString()]);const U=(await this.scanUserExtensions(!0)).find(F=>l.ExtensionKey.create(F).equals(z))||null;return U?this.updateMetadata(U,{installedTimestamp:Date.now()}):null}async removeExtension(z,V){this.logService.trace(`Deleting ${V} extension from disk`,z.identifier.id,z.location.fsPath),await h.Promises.rm(z.location.fsPath),this.logService.info("Deleted from disk",z.identifier.id,z.location.fsPath)}async removeUninstalledExtension(z){await this.removeExtension(z,"uninstalled"),await this.withUninstalledExtensions(V=>delete V[l.ExtensionKey.create(z).toString()])}async withUninstalledExtensions(z){return this.uninstalledFileLimiter.queue(async()=>{let V;try{V=await h.Promises.readFile(this.uninstalledPath,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let U={};if(V)try{U=JSON.parse(V)}catch{}return z&&(z(U),Object.keys(U).length?await h.Promises.writeFile(this.uninstalledPath,JSON.stringify(U)):await h.Promises.rm(this.uninstalledPath)),U})}async extractAtLocation(z,V,U,F){this.logService.trace(`Started extracting the extension from ${V} to ${U}`);try{await h.Promises.rm(U)}catch(j){throw new d.ExtensionManagementError(this.joinErrors(j).message,d.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(V,U,{sourcePath:"extension",overwrite:!0},F),this.logService.info(`Extracted extension to ${U}:`,z.id)}catch(j){try{await h.Promises.rm(U)}catch{}let B=d.ExtensionManagementErrorCode.Extract;throw j instanceof y.ExtractError&&(j.type==="CorruptZip"?B=d.ExtensionManagementErrorCode.CorruptZip:j.type==="Incomplete"&&(B=d.ExtensionManagementErrorCode.IncompleteZip)),new d.ExtensionManagementError(j.message,B)}}async rename(z,V,U,F){try{await h.Promises.rename(V,U)}catch(j){if(E.isWindows&&j&&j.code==="EPERM"&&Date.now()<F)return this.logService.info(`Failed renaming ${V} to ${U} with 'EPERM' error. Trying again...`,z.id),this.rename(z,V,U,F);throw new d.ExtensionManagementError(j.message||P.localize(2,null,V,U),j.code||d.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(z,V){const U=await this.extensionsScannerService.scanExistingExtension(z,V,{includeInvalid:!0});if(U)return this.toLocalExtension(U);throw new Error(P.localize(3,null,z.path))}async toLocalExtension(z){const V=await this.fileService.resolve(z.location);let U,F;return V.children&&(U=V.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,F=V.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource),{identifier:z.identifier,type:z.type,isBuiltin:z.isBuiltin||!!z.metadata?.isBuiltin,location:z.location,manifest:z.manifest,targetPlatform:z.targetPlatform,validations:z.validations,isValid:z.isValid,readmeUrl:U,changelogUrl:F,publisherDisplayName:z.metadata?.publisherDisplayName||null,publisherId:z.metadata?.publisherId||null,isApplicationScoped:!!z.metadata?.isApplicationScoped,isMachineScoped:!!z.metadata?.isMachineScoped,isPreReleaseVersion:!!z.metadata?.isPreReleaseVersion,preRelease:!!z.metadata?.preRelease,installedTimestamp:z.metadata?.installedTimestamp,updated:!!z.metadata?.updated}}async removeUninstalledExtensions(){const z=await this.getUninstalledExtensions(),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),U=new Set;for(const B of V)z[l.ExtensionKey.create(B).toString()]||U.add(B.identifier.id.toLowerCase());const F=(0,l.groupByExtension)(V,B=>B.identifier);await R.Promises.settled(F.map(async B=>{const Z=B.sort((oe,X)=>b.rcompare(oe.manifest.version,X.manifest.version))[0];U.has(Z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(Z))}));const j=V.filter(B=>z[l.ExtensionKey.create(B).toString()]);await R.Promises.settled(j.map(B=>this.removeUninstalledExtension(B)))}async removeOutdatedExtensions(){const z=await this.extensionsScannerService.scanSystemExtensions({}),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),U=[],F=await this.extensionsScannerService.getTargetPlatform(),j=(0,l.groupByExtension)(V,B=>B.identifier);for(const B of j)if(B.length>1&&U.push(...B.sort((Z,oe)=>{const X=b.rcompare(Z.manifest.version,oe.manifest.version);return X!==0?X:Z.targetPlatform===F?-1:1}).slice(1)),B[0].type===0){const Z=z.find(oe=>(0,l.areSameExtensions)(oe.identifier,B[0].identifier));(!Z||b.gte(Z.manifest.version,B[0].manifest.version))&&U.push(B[0])}await R.Promises.settled(U.map(B=>this.removeExtension(B,"outdated")))}joinErrors(z){const V=Array.isArray(z)?z:[z];return V.length===1?V[0]instanceof Error?V[0]:new Error(V[0]):V.reduce((U,F)=>new Error(`${U.message}${U.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}};J=pe([K(1,_.IFileService),K(2,s.IExtensionsScannerService),K(3,A.ILogService)],J);class H extends a.AbstractExtensionTask{constructor(z,V,U,F,j){super(),this.identifier=z,this.source=V,this.options=U,this.extensionsScanner=F,this.logService=j,this._operation=2}get operation(){return(0,S.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(z,V){try{const U=await this.unsetUninstalledAndGetLocal(z.key);if(U)return z.metadata?this.extensionsScanner.updateMetadata(U,z.metadata):U}catch{throw E.isMacintosh?new d.ExtensionManagementError(P.localize(4,null),d.ExtensionManagementErrorCode.Internal):new d.ExtensionManagementError(P.localize(5,null),d.ExtensionManagementErrorCode.Internal)}return this.extract(z,V)}async unsetUninstalledAndGetLocal(z){if(!await this.isUninstalled(z))return null;this.logService.trace("Removing the extension from uninstalled list:",z.id);const U=await this.extensionsScanner.setInstalled(z);return this.logService.info("Removed the extension from uninstalled list:",z.id),U}async isUninstalled(z){return!!(await this.extensionsScanner.getUninstalledExtensions())[z.toString()]}async extract({zipPath:z,key:V,metadata:U},F){const j=await this.extensionsScanner.extractUserExtension(V,z,U,F);return this.logService.info("Extracting completed.",V.id),j}}class G extends H{constructor(z,V,U,F,j,B){super(V.identifier,V,U,j,B),this.manifest=z,this.gallery=V,this.extensionsDownloader=F}async doRun(z){const U=(await this.extensionsScanner.scanExtensions(null,void 0)).find(B=>(0,l.areSameExtensions)(B.identifier,this.gallery.identifier));U&&(this._operation=3);const F={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,f.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||U?.isMachineScoped,isBuiltin:this.options.isBuiltin||U?.isBuiltin,isSystem:U?.type===0?!0:void 0,updated:!!U,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,S.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:U?.preRelease)};if(U?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(U,F),metadata:F};const j=await this.downloadExtension(this.gallery,this._operation);try{const B=await this.installExtension({zipPath:j,key:l.ExtensionKey.create(this.gallery),metadata:F},z);return U&&!this.options.profileLocation&&(U.targetPlatform!==B.targetPlatform||b.neq(U.manifest.version,B.manifest.version))&&await this.extensionsScanner.setUninstalled(U),{local:B,metadata:F}}catch(B){throw await this.deleteDownloadedVSIX(j),B}}async deleteDownloadedVSIX(z){try{await this.extensionsDownloader.delete(m.URI.file(z))}catch(V){this.logService.warn("Error while deleting the downloaded vsix",z.toString(),(0,D.getErrorMessage)(V))}}async downloadExtension(z,V){let U;try{this.logService.trace("Started downloading extension:",z.identifier.id),U=(await this.extensionsDownloader.downloadExtension(z,V)).fsPath,this.logService.info("Downloaded extension:",z.identifier.id,U)}catch(F){throw new d.ExtensionManagementError((0,a.joinErrors)(F).message,d.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(U),U}catch(F){throw await this.deleteDownloadedVSIX(U),new d.ExtensionManagementError((0,a.joinErrors)(F).message,d.ExtensionManagementErrorCode.Invalid)}}}class q extends H{constructor(z,V,U,F,j,B){super({id:(0,l.getGalleryExtensionId)(z.publisher,z.name)},V,U,j,B),this.manifest=z,this.location=V,this.galleryService=F}async doRun(z){const V=new l.ExtensionKey(this.identifier,this.manifest.version),F=(await this.extensionsScanner.scanExtensions(1,void 0)).find(Z=>(0,l.areSameExtensions)(this.identifier,Z.identifier)),j=await this.getMetadata(this.identifier.id,this.manifest.version,z);if(j.isApplicationScoped=(0,f.isApplicationScopedExtension)(this.manifest),j.isMachineScoped=this.options.isMachineScoped||F?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||F?.isBuiltin,F)if(this._operation=3,V.equals(new l.ExtensionKey(F.identifier,F.manifest.version)))try{await this.extensionsScanner.removeExtension(F,"existing")}catch{throw new Error(P.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&b.gt(F.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(F);else{const Z=await this.unsetUninstalledAndGetLocal(V);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch{throw new Error(P.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:I.resolve(this.location.fsPath),key:V,metadata:j},z),metadata:j}}async getMetadata(z,V,U){try{let[F]=await this.galleryService.getExtensions([{id:z,version:V}],U);if(F||([F]=await this.galleryService.getExtensions([{id:z}],U)),F)return{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId,isPreReleaseVersion:F.properties.isPreReleaseVersion,preRelease:F.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class x{constructor(z,V,U){this.task=z,this.profileLocation=V,this.extensionsProfileScannerService=U,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const z=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[z.local,z.metadata]],this.profileLocation),z}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class Y extends a.AbstractExtensionTask{constructor(z,V,U){super(),this.extension=z,this.options=V,this.extensionsScanner=U}async doRun(z){const V=[],U=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const F=l.ExtensionKey.create(this.extension);V.push(...U.filter(j=>F.equals(l.ExtensionKey.create(j))))}else V.push(...U.filter(F=>(0,l.areSameExtensions)(F.identifier,this.extension.identifier)));if(!V.length)throw new Error(P.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...V),this.options.remove)for(const F of V)try{z.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(F)}catch(j){throw new Error(P.localize(9,null,(0,r.toErrorMessage)(j)))}}}class te extends a.AbstractExtensionTask{constructor(z,V,U){super(),this.extension=z,this.profileLocation=V,this.extensionsProfileScannerService=U}async doRun(z){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ne[273],re([0,1,2,29,33,49,75,202,113,44,5,8,20,31,23]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const y={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let P=class extends R.Disposable{constructor(a,d,l,i,s,t,n,o){super(),this.userDataProfilesService=d,a.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,I.migrateUnsupportedExtensions)(a,l,i,s,o),T.ExtensionStorageService.removeOutdatedExtensionVersions(a,n),this._register(t.createInstance(p))}};P=pe([K(0,E.INativeServerExtensionManagementService),K(1,h.IUserDataProfilesService),K(2,r.IExtensionGalleryService),K(3,T.IExtensionStorageService),K(4,r.IGlobalExtensionEnablementService),K(5,b.IInstantiationService),K(6,m.IStorageService),K(7,S.ILogService)],P),e.ExtensionsCleaner=P;let p=class extends R.Disposable{constructor(a,d,l,i,s){super(),this.extensionManagementService=a,this.userDataProfilesService=d,this.extensionsProfileScannerService=l,this.uriIdentityService=i,this.logService=s,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new R.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:a,removed:d,all:l}){try{await Promise.all(d.map(i=>i.extensionsResource?this.removeExtensionsFromProfile(i.extensionsResource):Promise.resolve()))}catch(i){this.logService.error(i)}if(l.length===1){this.profileModeDisposables.clear();const i=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{i.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{a.length&&(await Promise.all(a.map(i=>i.extensionsResource?this.populateExtensionsFromProfile(i.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new R.DisposableStore,this.profileModeDisposables.value.add((0,R.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(i=>this.onDidChangeProfiles(i))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(i=>this.onDidUninstallExtension(i))),await this.uninstallExtensionsNotInProfiles()))}catch(i){this.logService.error(i)}}async uninstallExtensionsNotInProfiles(){const d=(await this.extensionManagementService.getAllUserInstalled()).filter(l=>!this.profileExtensionsLocations.has(this.getKey(l.identifier,l.manifest.version)));d.length&&await Promise.all(d.map(l=>this.extensionManagementService.uninstall(l,y)))}async onDidInstallExtensions(a){for(const{local:d,profileLocation:l}of a)!d||!l||this.addExtensionWithKey(this.getKey(d.identifier,d.manifest.version),l)}async onDidUninstallExtension(a){!a.profileLocation||!a.version||this.removeExtensionWithKey(this.getKey(a.identifier,a.version),a.profileLocation)&&await this.uninstallExtensions([{identifier:a.identifier,version:a.version}])}async populateExtensionsFromProfile(a){const d=await this.extensionsProfileScannerService.scanProfileExtensions(a);for(const l of d)this.addExtensionWithKey(this.getKey(l.identifier,l.version),a)}async removeExtensionsFromProfile(a){const d=[];for(const l of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(l,a))continue;const i=this.fromKey(l);i&&d.push(i)}d.length&&await this.uninstallExtensions(d)}addExtensionWithKey(a,d){let l=this.profileExtensionsLocations.get(a);l||(l=[],this.profileExtensionsLocations.set(a,l)),l.push(d)}removeExtensionWithKey(a,d){const l=this.profileExtensionsLocations.get(a);if(l){const i=l.findIndex(s=>this.uriIdentityService.extUri.isEqual(s,d));i>-1&&l.splice(i,1)}return l?.length?!1:(this.profileExtensionsLocations.delete(a),!0)}async uninstallExtensions(a){const l=(await this.extensionManagementService.getAllUserInstalled()).filter(i=>a.some(s=>this.getKey(i.identifier,i.manifest.version)===this.getKey(s.identifier,s.version)));l.length&&await Promise.all(l.map(i=>this.extensionManagementService.uninstall(i,y)))}getKey(a,d){return`${C.ExtensionIdentifier.toKey(a.id)}@${d}`}fromKey(a){const[d,l]=(0,D.getIdAndVersion)(a);return l?{identifier:{id:d},version:l}:void 0}};p=pe([K(0,E.INativeServerExtensionManagementService),K(1,h.IUserDataProfilesService),K(2,L.IExtensionsProfileScannerService),K(3,v.IUriIdentityService),K(4,S.ILogService)],p)}),define(ne[282],re([0,1,89,37,38,9,2,21,17,7,39,137,195,273,196,188,189,271,177,180,18,200,92,219,93,210,14,216,252,253,29,179,254,113,94,175,13,191,193,56,5,186,97,187,58,69,205,8,98,59,99,25,45,20,255,104,22,105,106,107,50,223,108,225,231,75,110,26,73,243,244,245,76,263,266,246,267,268,269,77,247,103,218,72,233,207,232,102,215,31,235,4,236,181,198,197,74,251,23,49,194,60,256,213,222,248]),function(Q,e,R,r,D,L,T,I,E,C,b,S,m,v,h,y,P,p,g,a,d,l,i,s,t,n,o,c,u,f,w,_,N,A,O,k,M,$,W,J,H,G,q,x,Y,te,ce,z,V,U,F,j,B,Z,oe,X,ie,se,ue,he,ve,we,Ee,Pe,Ue,ze,Ve,We,ae,de,fe,Ce,Ie,Me,De,$e,Ae,Fe,_e,ke,ee,le,me,ge,Se,be,Re,Te,qe,Le,Ne,xe,Xe,Ze,It,vt,Rt,Dt,kt,St,Lt,yt,Tt,At,_t,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ut extends T.Disposable{constructor(ye){super(),this.configuration=ye,this.server=this._register(new S.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Oe="vscode:electron-main->shared-process=disposeWorker",je=(He,et)=>{this.onDisposeWorker(et)};R.ipcRenderer.on(Oe,je),this._register((0,T.toDisposable)(()=>R.ipcRenderer.removeListener(Oe,je)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,We.registerConfiguration)(),ye.invokeFunction(Oe=>{const je=Oe.get(z.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(je)}),this._register((0,T.combinedDisposable)(ye.createInstance(m.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(h.LanguagePackCachedDataCleaner),ye.createInstance(p.UnusedWorkspaceStorageDataCleaner),ye.createInstance(P.LogsDataCleaner),ye.createInstance(y.LocalizationsUpdater),ye.createInstance(v.ExtensionsCleaner),ye.createInstance(Ot.UserDataProfilesCleaner)))}async initServices(){const ye=new q.ServiceCollection,Oe={_serviceBrand:void 0,...F.default};ye.set(j.IProductService,Oe);const je=new b.StaticRouter(Ye=>Ye==="main"),He=new x.MessagePortMainProcessService(this.server,je);ye.set(Y.IMainProcessService,He);const et=this.configuration.policiesData?new Lt.PolicyChannelClient(this.configuration.policiesData,He.getChannel("policy")):new yt.NullPolicyService;ye.set(yt.IPolicyService,et);const Be=new c.SharedProcessEnvironmentService(this.configuration.args,Oe);ye.set(o.INativeEnvironmentService,Be);const ot=new V.LogLevelChannelClient(this.server.getChannel("logLevel",je)),tt=new V.LoggerChannelClient(this.configuration.logLevel,ot.onDidChangeLogLevel,He.getChannel("logger"));ye.set(z.ILoggerService,tt);const lt=this._register(new z.MultiplexLogService([this._register(new z.ConsoleLogger(this.configuration.logLevel)),this._register(tt.createLogger((0,E.joinPath)(C.URI.file(Be.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new V.FollowerLogService(ot,lt));ye.set(z.ILogService,Ge),this.sharedProcessWorkerService=new qe.SharedProcessWorkerService(Ge),ye.set(Te.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Je=this._register(new $.FileService(Ge));ye.set(M.IFileService,Je);const ut=this._register(new W.DiskFileSystemProvider(Ge));Je.registerProvider(I.Schemas.file,ut);const ht=this._register(new Xe.FileUserDataProvider(I.Schemas.file,this._register(new Ze.DiskFileSystemProviderClient(He.getChannel(Ze.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:xe.isLinux})),I.Schemas.vscodeUserData,Ge));Je.registerProvider(I.Schemas.vscodeUserData,ht);const it=this._register(new Tt.UserDataProfilesNativeService(this.configuration.profiles,He,Be));ye.set(kt.IUserDataProfilesService,it);const Ke=this._register(new l.ConfigurationService(it.defaultProfile.settingsResource,Je,et,Ge));ye.set(d.IConfigurationService,Ke);const rt=new oe.NativeStorageService(void 0,{defaultProfile:it.defaultProfile,currentProfile:it.defaultProfile},He,Be);ye.set(Z.IStorageService,rt),this._register((0,T.toDisposable)(()=>rt.flush())),await Promise.all([Ke.initialize(),rt.initialize()]),ye.set(Le.IUriIdentityService,new Ne.UriIdentityService(Je)),ye.set(B.IRequestService,new At.SharedProcessRequestService(He,Ke,Ge)),ye.set(g.IChecksumService,new J.SyncDescriptor(a.ChecksumService,void 0,!1)),ye.set(vt.IV8InspectProfilingService,new J.SyncDescriptor(It.InspectProfilingService,void 0,!1));const at=b.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(U.INativeHostService,at),ye.set(t.IDownloadService,new J.SyncDescriptor(n.DownloadService,void 0,!0));const dt=this._register(new ee.ActiveWindowManager(at)),Ft=new b.StaticRouter(Ye=>dt.getActiveClientId().then(ft=>Ye===ft));ye.set(O.IExtensionRecommendationNotificationService,new k.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Ft)));let ct;const st=[],Et=(0,ve.isInternalTelemetry)(Oe,Ke);if((0,ve.supportsTelemetry)(Oe,Be)){const Ye=new ue.TelemetryLogAppender(tt,Be);st.push(Ye);const{installSourcePath:ft}=Be;if(Oe.aiConfig?.ariaKey){const Ct=new _t.OneDataSystemAppender(Et,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,T.toDisposable)(()=>Ct.flush())),st.push(Ct)}ct=new he.TelemetryService({appenders:st,commonProperties:(0,X.resolveCommonProperties)(Je,(0,r.release)(),(0,r.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Et,ft),sendErrorTelemetry:!0,piiPaths:(0,ve.getPiiPathsFromEnvironment)(Be)},Ke,Oe)}else{ct=ve.NullTelemetryService;const Ye=ve.NullAppender;st.push(Ye)}this.server.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(st)),ye.set(ie.ITelemetryService,ct);const Nt=new we.CustomEndpointTelemetryService(Ke,ct,tt,Be,Oe);ye.set(ie.ICustomEndpointTelemetryService,Nt),ye.set(St.IExtensionsProfileScannerService,new J.SyncDescriptor(St.ExtensionsProfileScannerService,void 0,!0)),ye.set(Rt.IExtensionsScannerService,new J.SyncDescriptor(Dt.ExtensionsScannerService,void 0,!0)),ye.set(A.INativeServerExtensionManagementService,new J.SyncDescriptor(A.ExtensionManagementService,void 0,!0)),ye.set(w.IExtensionGalleryService,new J.SyncDescriptor(f.ExtensionGalleryService,void 0,!0)),ye.set(w.IExtensionTipsService,new J.SyncDescriptor(N.ExtensionTipsService,void 0,!1)),ye.set(te.ILanguagePackService,new J.SyncDescriptor(ce.NativeLanguagePackService,void 0,!1)),ye.set(i.IDiagnosticsService,new J.SyncDescriptor(s.DiagnosticsService,void 0,!1)),ye.set(ae.IUserDataSyncAccountService,new J.SyncDescriptor(ae.UserDataSyncAccountService,void 0,!0)),ye.set(We.IUserDataSyncLogService,new J.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),ye.set(We.IUserDataSyncUtilService,new fe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ye=>Ye.ctx!=="main"))),ye.set(w.IGlobalExtensionEnablementService,new J.SyncDescriptor(u.GlobalExtensionEnablementService,void 0,!1)),ye.set(Ve.IIgnoredExtensionsManagementService,new J.SyncDescriptor(Ve.IgnoredExtensionsManagementService,void 0,!0)),ye.set(ze.IExtensionStorageService,new J.SyncDescriptor(ze.ExtensionStorageService)),ye.set(We.IUserDataSyncStoreManagementService,new J.SyncDescriptor(Ae.UserDataSyncStoreManagementService,void 0,!0)),ye.set(We.IUserDataSyncStoreService,new J.SyncDescriptor(Ae.UserDataSyncStoreService,void 0,!0)),ye.set(Ie.IUserDataSyncMachinesService,new J.SyncDescriptor(Ie.UserDataSyncMachinesService,void 0,!0)),ye.set(We.IUserDataSyncBackupStoreService,new J.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),ye.set(We.IUserDataSyncEnablementService,new J.SyncDescriptor(Me.UserDataSyncEnablementService,void 0,!0)),ye.set(We.IUserDataSyncService,new J.SyncDescriptor(De.UserDataSyncService,void 0,!1)),ye.set(ke.IUserDataSyncProfilesStorageService,new J.SyncDescriptor(_e.UserDataSyncProfilesStorageService,void 0,!0));const bt=new Ue.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ke.getValue("terminal.integrated.persistentSessionScrollback")??100},Ke,Be,Ge);return bt.initialize(),ye.set(Pe.ILocalPtyService,this._register(bt)),ye.set(le.ISignService,new J.SyncDescriptor(me.SignService,void 0,!1)),ye.set(ge.ISharedTunnelsService,new J.SyncDescriptor(Se.SharedTunnelsService)),ye.set(be.ISharedProcessTunnelService,new J.SyncDescriptor(Re.SharedProcessTunnelService)),new G.InstantiationService(ye)}initChannels(ye){const Oe=new _.ExtensionManagementChannel(ye.get(w.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const je=b.ProxyChannel.fromService(ye.get(te.ILanguagePackService));this.server.registerChannel("languagePacks",je);const He=b.ProxyChannel.fromService(ye.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const et=new _.ExtensionTipsChannel(ye.get(w.IExtensionTipsService));this.server.registerChannel("extensionTipsService",et);const Be=b.ProxyChannel.fromService(ye.get(g.IChecksumService));this.server.registerChannel("checksum",Be);const ot=b.ProxyChannel.fromService(ye.get(vt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",ot);const tt=new fe.UserDataSyncMachinesServiceChannel(ye.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",tt);const lt=b.ProxyChannel.fromService(ye.get(ie.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",lt);const Ge=new fe.UserDataSyncAccountServiceChannel(ye.get(ae.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Je=new fe.UserDataSyncStoreManagementServiceChannel(ye.get(We.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Je);const ut=new $e.UserDataSyncChannel(ye.get(We.IUserDataSyncService),ye.get(z.ILogService));this.server.registerChannel("userDataSync",ut);const ht=this._register(ye.get(H.IInstantiationService).createInstance(Fe.UserDataAutoSyncService)),it=new fe.UserDataAutoSyncChannel(ht);this.server.registerChannel("userDataAutoSync",it);const Ke=ye.get(Pe.ILocalPtyService),rt=b.ProxyChannel.fromService(Ke);this.server.registerChannel(Ee.TerminalIpcChannels.LocalPty,rt);const at=b.ProxyChannel.fromService(ye.get(be.ISharedProcessTunnelService));this.server.registerChannel(be.ipcSharedProcessTunnelChannelName,at);const dt=b.ProxyChannel.fromService(ye.get(Te.ISharedProcessWorkerService));this.server.registerChannel(Te.ipcSharedProcessWorkerChannelName,dt)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Oe=>{(0,L.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Oe=>{const je=(0,D.toErrorMessage)(Oe,!0);!je||ye.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function Mt(wt){const ye=new Ut(wt);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Mt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/cfc01197555cb14a0d2d3463b331ce41de5733be/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
