/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/platform/files/common/files","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","os","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/map","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","vs/platform/state/electron-main/state","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/userDataProfile/electron-main/userDataProfile","vs/base/common/json","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/userDataSync/electron-main/userDataSyncProfilesStorageIpc","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ee=function(q){for(var e=[],w=0,t=q.length;w<t;w++)e[w]=Z[q[w]];return e};define(Z[119],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function w(M){return M?M.replace(/\$\((.*?)\)/g,(E,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=w;class t{constructor(E,l,m){this.id=E,this.definition=l,this.description=m,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(M,E){const l=["codicon","codicon-"+M];return E&&l.push("codicon-modifier-"+E),l}e.getClassNamesArray=k;var R;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function l(y){if(y instanceof t)return["codicon","codicon-"+y.id];const S=E.exec(y.id);if(!S)return l(t.error);const[,g,h]=S,b=["codicon","codicon-"+g];return h&&b.push("codicon-modifier-"+h.substr(1)),b}M.asClassNameArray=l;function m(y){return l(y).join(" ")}M.asClassName=m;function P(y){return"."+l(y).join(".")}M.asCSSSelector=P})(R=e.CSSIcon||(e.CSSIcon={}))}),define(Z[120],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function w(E,l){const m=Math.pow(10,l);return Math.round(E*m)/m}class t{constructor(l,m,P,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,P))|0,this.a=w(Math.max(Math.min(1,y),0),3)}static equals(l,m){return l.r===m.r&&l.g===m.g&&l.b===m.b&&l.a===m.a}}e.RGBA=t;class k{constructor(l,m,P,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=w(Math.max(Math.min(1,m),0),3),this.l=w(Math.max(Math.min(1,P),0),3),this.a=w(Math.max(Math.min(1,y),0),3)}static equals(l,m){return l.h===m.h&&l.s===m.s&&l.l===m.l&&l.a===m.a}static fromRGBA(l){const m=l.r/255,P=l.g/255,y=l.b/255,S=l.a,g=Math.max(m,P,y),h=Math.min(m,P,y);let b=0,C=0;const p=(h+g)/2,v=g-h;if(v>0){switch(C=Math.min(p<=.5?v/(2*p):v/(2-2*p),1),g){case m:b=(P-y)/v+(P<y?6:0);break;case P:b=(y-m)/v+2;break;case y:b=(m-P)/v+4;break}b*=60,b=Math.round(b)}return new k(b,C,p,S)}static _hue2rgb(l,m,P){return P<0&&(P+=1),P>1&&(P-=1),P<1/6?l+(m-l)*6*P:P<1/2?m:P<2/3?l+(m-l)*(2/3-P)*6:l}static toRGBA(l){const m=l.h/360,{s:P,l:y,a:S}=l;let g,h,b;if(P===0)g=h=b=y;else{const C=y<.5?y*(1+P):y+P-y*P,p=2*y-C;g=k._hue2rgb(p,C,m+1/3),h=k._hue2rgb(p,C,m),b=k._hue2rgb(p,C,m-1/3)}return new t(Math.round(g*255),Math.round(h*255),Math.round(b*255),S)}}e.HSLA=k;class R{constructor(l,m,P,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=w(Math.max(Math.min(1,m),0),3),this.v=w(Math.max(Math.min(1,P),0),3),this.a=w(Math.max(Math.min(1,y),0),3)}static equals(l,m){return l.h===m.h&&l.s===m.s&&l.v===m.v&&l.a===m.a}static fromRGBA(l){const m=l.r/255,P=l.g/255,y=l.b/255,S=Math.max(m,P,y),g=Math.min(m,P,y),h=S-g,b=S===0?0:h/S;let C;return h===0?C=0:S===m?C=((P-y)/h%6+6)%6:S===P?C=(y-m)/h+2:C=(m-P)/h+4,new R(Math.round(C*60),b,S,l.a)}static toRGBA(l){const{h:m,s:P,v:y,a:S}=l,g=y*P,h=g*(1-Math.abs(m/60%2-1)),b=y-g;let[C,p,v]=[0,0,0];return m<60?(C=g,p=h):m<120?(C=h,p=g):m<180?(p=g,v=h):m<240?(p=h,v=g):m<300?(C=h,v=g):m<=360&&(C=g,v=h),C=Math.round((C+b)*255),p=Math.round((p+b)*255),v=Math.round((v+b)*255),new t(C,p,v,S)}}e.HSVA=R;class M{constructor(l){if(l)if(l instanceof t)this.rgba=l;else if(l instanceof k)this._hsla=l,this.rgba=k.toRGBA(l);else if(l instanceof R)this._hsva=l,this.rgba=R.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(l){return M.Format.CSS.parseHex(l)||M.red}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}equals(l){return!!l&&t.equals(this.rgba,l.rgba)&&k.equals(this.hsla,l.hsla)&&R.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=M._relativeLuminanceForComponent(this.rgba.r),m=M._relativeLuminanceForComponent(this.rgba.g),P=M._relativeLuminanceForComponent(this.rgba.b),y=.2126*l+.7152*m+.0722*P;return w(y,4)}static _relativeLuminanceForComponent(l){const m=l/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(l){const m=this.getRelativeLuminance(),P=l.getRelativeLuminance();return m>P?(m+.05)/(P+.05):(P+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const m=this.getRelativeLuminance(),P=l.getRelativeLuminance();return m>P}isDarkerThan(l){const m=this.getRelativeLuminance(),P=l.getRelativeLuminance();return m<P}lighten(l){return new M(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new M(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:m,g:P,b:y,a:S}=this.rgba;return new M(new t(m,P,y,S*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const m=l.rgba,P=this.rgba.a,y=m.a,S=P+y*(1-P);if(S<1e-6)return M.transparent;const g=this.rgba.r*P/S+m.r*y*(1-P)/S,h=this.rgba.g*P/S+m.g*y*(1-P)/S,b=this.rgba.b*P/S+m.b*y*(1-P)/S;return new M(new t(g,h,b,S))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:m,g:P,b:y,a:S}=this.rgba;return new M(new t(l.rgba.r-S*(l.rgba.r-m),l.rgba.g-S*(l.rgba.g-P),l.rgba.b-S*(l.rgba.b-y),1))}flatten(...l){const m=l.reduceRight((P,y)=>M._flatten(y,P));return M._flatten(this,m)}static _flatten(l,m){const P=1-l.rgba.a;return new M(new t(P*m.rgba.r+l.rgba.a*l.rgba.r,P*m.rgba.g+l.rgba.a*l.rgba.g,P*m.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this._toString||(this._toString=M.Format.CSS.format(this)),this._toString}static getLighterColor(l,m,P){if(l.isLighterThan(m))return l;P=P||.5;const y=l.getRelativeLuminance(),S=m.getRelativeLuminance();return P=P*(S-y)/S,l.lighten(P)}static getDarkerColor(l,m,P){if(l.isDarkerThan(m))return l;P=P||.5;const y=l.getRelativeLuminance(),S=m.getRelativeLuminance();return P=P*(y-S)/y,l.darken(P)}}e.Color=M,M.white=new M(new t(255,255,255,1)),M.black=new M(new t(0,0,0,1)),M.red=new M(new t(255,0,0,1)),M.blue=new M(new t(0,0,255,1)),M.green=new M(new t(0,255,0,1)),M.cyan=new M(new t(0,255,255,1)),M.lightgrey=new M(new t(211,211,211,1)),M.transparent=new M(new t(0,0,0,0)),function(E){let l;(function(m){let P;(function(y){function S(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:E.Format.CSS.formatRGBA(i)}y.formatRGB=S;function g(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}y.formatRGBA=g;function h(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(i)}y.formatHSL=h;function b(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}y.formatHSLA=b;function C(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function p(i){return`#${C(i.rgba.r)}${C(i.rgba.g)}${C(i.rgba.b)}`}y.formatHex=p;function v(i,o=!1){return o&&i.rgba.a===1?E.Format.CSS.formatHex(i):`#${C(i.rgba.r)}${C(i.rgba.g)}${C(i.rgba.b)}${C(Math.round(i.rgba.a*255))}`}y.formatHexA=v;function d(i){return i.isOpaque()?E.Format.CSS.formatHex(i):E.Format.CSS.formatRGBA(i)}y.format=d;function f(i){const o=i.length;if(o===0||i.charCodeAt(0)!==35)return null;if(o===7){const n=16*a(i.charCodeAt(1))+a(i.charCodeAt(2)),r=16*a(i.charCodeAt(3))+a(i.charCodeAt(4)),s=16*a(i.charCodeAt(5))+a(i.charCodeAt(6));return new E(new t(n,r,s,1))}if(o===9){const n=16*a(i.charCodeAt(1))+a(i.charCodeAt(2)),r=16*a(i.charCodeAt(3))+a(i.charCodeAt(4)),s=16*a(i.charCodeAt(5))+a(i.charCodeAt(6)),c=16*a(i.charCodeAt(7))+a(i.charCodeAt(8));return new E(new t(n,r,s,c/255))}if(o===4){const n=a(i.charCodeAt(1)),r=a(i.charCodeAt(2)),s=a(i.charCodeAt(3));return new E(new t(16*n+n,16*r+r,16*s+s))}if(o===5){const n=a(i.charCodeAt(1)),r=a(i.charCodeAt(2)),s=a(i.charCodeAt(3)),c=a(i.charCodeAt(4));return new E(new t(16*n+n,16*r+r,16*s+s,(16*c+c)/255))}return null}y.parseHex=f;function a(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(P=m.CSS||(m.CSS={}))})(l=E.Format||(E.Format={}))}(M=e.Color||(e.Color={}))}),define(Z[53],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(M){return(E,l,m)=>{let P=null,y=null;if(typeof m.value=="function"?(P="value",y=m.value):typeof m.get=="function"&&(P="get",y=m.get),!y)throw new Error("not supported");m[P]=M(y,l)}}e.createDecorator=w;function t(M,E,l){let m=null,P=null;if(typeof l.value=="function"?(m="value",P=l.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(m="get",P=l.get),!P)throw new Error("not supported");const y=`$memoize$${E}`;l[m]=function(...S){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,S)}),this[y]}}e.memoize=t;function k(M,E,l){return w((m,P)=>{const y=`$debounce$${P}`,S=`$debounce$result$${P}`;return function(...g){this[S]||(this[S]=l?l():void 0),clearTimeout(this[y]),E&&(this[S]=E(this[S],...g),g=[this[S]]),this[y]=setTimeout(()=>{m.apply(this,g),this[S]=l?l():void 0},M)}})}e.debounce=k;function R(M,E,l){return w((m,P)=>{const y=`$throttle$timer$${P}`,S=`$throttle$result$${P}`,g=`$throttle$lastRun$${P}`,h=`$throttle$pending$${P}`;return function(...b){if(this[S]||(this[S]=l?l():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),E&&(this[S]=E(this[S],...b)),this[h])return;const C=this[g]+M;C<=Date.now()?(this[g]=Date.now(),m.apply(this,[this[S]]),this[S]=l?l():void 0):(this[h]=!0,this[y]=setTimeout(()=>{this[h]=!1,this[g]=Date.now(),m.apply(this,[this[S]]),this[S]=l?l():void 0},C-Date.now()))}})}e.throttle=R}),define(Z[17],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?d.isErrorNoTelemetry(i)?new d(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(o=>{o(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=w,e.errorHandler=new w;function t(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=t;function k(a){l(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=k;function R(a){l(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=R;function M(a){if(a instanceof Error){const{name:i,message:o}=a,n=a.stacktrace||a.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:d.isErrorNoTelemetry(a)}}return a}e.transformErrorForSerialization=M;const E="Canceled";function l(a){return a instanceof m?!0:a instanceof Error&&a.name===E&&a.message===E}e.isCancellationError=l;class m extends Error{constructor(){super(E),this.name=this.message}}e.CancellationError=m;function P(){const a=new Error(E);return a.name=a.message,a}e.canceled=P;function y(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=y;function S(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=S;function g(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function h(a){const i=new Error(`${a} has been disposed`);return i.name="DISPOSED",i}e.disposed=h;function b(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=b;class C extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=C;class p extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=p;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class d extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof d)return i;const o=new d;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=d;class f extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(Z[24],ee([0,1,17]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(H,ie=0){return H[H.length-(1+ie)]}e.tail=t;function k(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=k;function R(H,ie,ne=(ae,fe)=>ae===fe){if(H===ie)return!0;if(!H||!ie||H.length!==ie.length)return!1;for(let ae=0,fe=H.length;ae<fe;ae++)if(!ne(H[ae],ie[ae]))return!1;return!0}e.equals=R;function M(H,ie){const ne=H.length-1;ie<ne&&(H[ie]=H[ne]),H.pop()}e.removeFastWithoutKeepingOrder=M;function E(H,ie,ne){return l(H.length,ae=>ne(H[ae],ie))}e.binarySearch=E;function l(H,ie){let ne=0,ae=H-1;for(;ne<=ae;){const fe=(ne+ae)/2|0,De=ie(fe);if(De<0)ne=fe+1;else if(De>0)ae=fe-1;else return fe}return-(ne+1)}e.binarySearch2=l;function m(H,ie){let ne=0,ae=H.length;if(ae===0)return 0;for(;ne<ae;){const fe=Math.floor((ne+ae)/2);ie(H[fe])?ae=fe:ne=fe+1}return ne}e.findFirstInSorted=m;function P(H,ie,ne){if(H=H|0,H>=ie.length)throw new TypeError("invalid index");const ae=ie[Math.floor(ie.length*Math.random())],fe=[],De=[],Le=[];for(const ke of ie){const Ae=ne(ke,ae);Ae<0?fe.push(ke):Ae>0?De.push(ke):Le.push(ke)}return H<fe.length?P(H,fe,ne):H<fe.length+Le.length?Le[0]:P(H-(fe.length+Le.length),De,ne)}e.quickSelect=P;function y(H,ie){const ne=[];let ae;for(const fe of H.slice(0).sort(ie))!ae||ie(ae[0],fe)!==0?(ae=[fe],ne.push(ae)):ae.push(fe);return ne}e.groupBy=y;function S(H,ie,ne){const ae=[];function fe(ke,Ae,je){if(Ae===0&&je.length===0)return;const ge=ae[ae.length-1];ge&&ge.start+ge.deleteCount===ke?(ge.deleteCount+=Ae,ge.toInsert.push(...je)):ae.push({start:ke,deleteCount:Ae,toInsert:je})}let De=0,Le=0;for(;;){if(De===H.length){fe(De,0,ie.slice(Le));break}if(Le===ie.length){fe(De,H.length-De,[]);break}const ke=H[De],Ae=ie[Le],je=ne(ke,Ae);je===0?(De+=1,Le+=1):je<0?(fe(De,1,[]),De+=1):je>0&&(fe(De,0,[Ae]),Le+=1)}return ae}e.sortedDiff=S;function g(H,ie,ne){const ae=S(H,ie,ne),fe=[],De=[];for(const Le of ae)fe.push(...H.slice(Le.start,Le.start+Le.deleteCount)),De.push(...Le.toInsert);return{removed:fe,added:De}}e.delta=g;function h(H,ie,ne){if(ne===0)return[];const ae=H.slice(0,ne).sort(ie);return C(H,ie,ae,ne,H.length),ae}e.top=h;function b(H,ie,ne,ae,fe){return ne===0?Promise.resolve([]):new Promise((De,Le)=>{(async()=>{const ke=H.length,Ae=H.slice(0,ne).sort(ie);for(let je=ne,ge=Math.min(ne+ae,ke);je<ke;je=ge,ge=Math.min(ge+ae,ke)){if(je>ne&&await new Promise(we=>setTimeout(we)),fe&&fe.isCancellationRequested)throw new w.CancellationError;C(H,ie,Ae,je,ge)}return Ae})().then(De,Le)})}e.topAsync=b;function C(H,ie,ne,ae,fe){for(const De=ne.length;ae<fe;ae++){const Le=H[ae];if(ie(Le,ne[De-1])<0){ne.pop();const ke=m(ne,Ae=>ie(Le,Ae)<0);ne.splice(ke,0,Le)}}}function p(H){return H.filter(ie=>!!ie)}e.coalesce=p;function v(H){let ie=0;for(let ne=0;ne<H.length;ne++)H[ne]&&(H[ie]=H[ne],ie+=1);H.length=ie}e.coalesceInPlace=v;function d(H,ie,ne){H.splice(ne,0,H.splice(ie,1)[0])}e.move=d;function f(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=f;function a(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=a;function i(H,ie=ne=>ne){const ne=new Set;return H.filter(ae=>{const fe=ie(ae);return ne.has(fe)?!1:(ne.add(fe),!0)})}e.distinct=i;function o(H){const ie=new Set;return ne=>{const ae=H(ne);return ie.has(ae)?!1:(ie.add(ae),!0)}}e.uniqueFilter=o;function n(H,ie){const ne=r(H,ie);if(ne!==-1)return H[ne]}e.findLast=n;function r(H,ie){for(let ne=H.length-1;ne>=0;ne--){const ae=H[ne];if(ie(ae))return ne}return-1}e.lastIndex=r;function s(H,ie){return H.length>0?H[0]:ie}e.firstOrDefault=s;function c(H,ie){return H.length>0?H[H.length-1]:ie}e.lastOrDefault=c;function u(H,ie,ne=(ae,fe)=>ae===fe){let ae=0;for(let fe=0,De=Math.min(H.length,ie.length);fe<De&&ne(H[fe],ie[fe]);fe++)ae++;return ae}e.commonPrefixLength=u;function I(H){return[].concat(...H)}e.flatten=I;function D(H,ie){let ne=typeof ie=="number"?H:0;typeof ie=="number"?ne=H:(ne=0,ie=H);const ae=[];if(ne<=ie)for(let fe=ne;fe<ie;fe++)ae.push(fe);else for(let fe=ne;fe>ie;fe--)ae.push(fe);return ae}e.range=D;function T(H,ie,ne){return H.reduce((ae,fe)=>(ae[ie(fe)]=ne?ne(fe):fe,ae),Object.create(null))}e.index=T;function N(H,ie){return H.push(ie),()=>U(H,ie)}e.insert=N;function U(H,ie){const ne=H.indexOf(ie);if(ne>-1)return H.splice(ne,1),ie}e.remove=U;function $(H,ie,ne){const ae=H.slice(0,ie),fe=H.slice(ie);return ae.concat(ne,fe)}e.arrayInsert=$;function Y(H,ie){let ne;if(typeof ie=="number"){let ae=ie;ne=()=>{const fe=Math.sin(ae++)*179426549;return fe-Math.floor(fe)}}else ne=Math.random;for(let ae=H.length-1;ae>0;ae-=1){const fe=Math.floor(ne()*(ae+1)),De=H[ae];H[ae]=H[fe],H[fe]=De}}e.shuffle=Y;function oe(H,ie){const ne=H.indexOf(ie);ne>-1&&(H.splice(ne,1),H.unshift(ie))}e.pushToStart=oe;function ue(H,ie){const ne=H.indexOf(ie);ne>-1&&(H.splice(ne,1),H.push(ie))}e.pushToEnd=ue;function se(H,ie){for(const ne of ie)H.push(ne)}e.pushMany=se;function he(H,ie){return Array.isArray(H)?H.map(ie):ie(H)}e.mapArrayOrNot=he;function G(H){return Array.isArray(H)?H:[H]}e.asArray=G;function K(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=K;function F(H,ie){for(const ne of H){const ae=ie(ne);if(ae!==void 0)return ae}}e.mapFind=F;function A(H,ie,ne){const ae=z(H,ie),fe=H.length,De=ne.length;H.length=fe+De;for(let Le=fe-1;Le>=ae;Le--)H[Le+De]=H[Le];for(let Le=0;Le<De;Le++)H[Le+ae]=ne[Le]}e.insertInto=A;function W(H,ie,ne,ae){const fe=z(H,ie),De=H.splice(fe,ne);return A(H,fe,ae),De}e.splice=W;function z(H,ie){return ie<0?Math.max(ie+H.length,0):Math.min(ie,H.length)}var te;(function(H){function ie(fe){return fe<0}H.isLessThan=ie;function ne(fe){return fe>0}H.isGreaterThan=ne;function ae(fe){return fe===0}H.isNeitherLessOrGreaterThan=ae,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(te=e.CompareResult||(e.CompareResult={}));function B(H,ie){return(ne,ae)=>ie(H(ne),H(ae))}e.compareBy=B;function j(...H){return(ie,ne)=>{for(const ae of H){const fe=ae(ie,ne);if(!te.isNeitherLessOrGreaterThan(fe))return fe}return te.neitherLessOrGreaterThan}}e.tieBreakComparators=j;const L=(H,ie)=>H-ie;e.numberComparator=L;function O(H,ie){if(H.length===0)return;let ne=H[0];for(let ae=1;ae<H.length;ae++){const fe=H[ae];ie(fe,ne)>0&&(ne=fe)}return ne}e.findMaxBy=O;function _(H,ie){if(H.length===0)return;let ne=H[0];for(let ae=1;ae<H.length;ae++){const fe=H[ae];ie(fe,ne)>=0&&(ne=fe)}return ne}e.findLastMaxBy=_;function V(H,ie){return O(H,(ne,ae)=>-ie(ne,ae))}e.findMinBy=V;class x{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let ne=this.firstIdx;for(;ne<this.items.length&&ie(this.items[ne]);)ne++;const ae=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,ae}takeFromEndWhile(ie){let ne=this.lastIdx;for(;ne>=0&&ie(this.items[ne]);)ne--;const ae=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,ae}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const ne=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,ne}}e.ArrayQueue=x;class re{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(ne=>(ie(ne),!0))}toArray(){const ie=[];return this.iterate(ne=>(ie.push(ne),!0)),ie}filter(ie){return new re(ne=>this.iterate(ae=>ie(ae)?ne(ae):!0))}map(ie){return new re(ne=>this.iterate(ae=>ne(ie(ae))))}some(ie){let ne=!1;return this.iterate(ae=>(ne=ie(ae),!ne)),ne}findFirst(ie){let ne;return this.iterate(ae=>ie(ae)?(ne=ae,!1):!0),ne}findLast(ie){let ne;return this.iterate(ae=>(ie(ae)&&(ne=ae),!0)),ne}findLastMaxBy(ie){let ne,ae=!0;return this.iterate(fe=>((ae||te.isGreaterThan(ie(fe,ne)))&&(ae=!1,ne=fe),!0)),ne}}e.CallbackIterable=re,re.empty=new re(H=>{})}),define(Z[121],ee([0,1,17]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(l,m){if(!l)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=t;function k(l,m="Unreachable"){throw new Error(m)}e.assertNever=k;function R(l){if(!l)throw new w.BugIndicatingError("Assertion Failed")}e.assert=R;function M(l){if(!l()){debugger;l(),(0,w.onUnexpectedError)(new w.BugIndicatingError("Assertion Failed"))}}e.assertFn=M;function E(l,m){let P=0;for(;P<l.length-1;){const y=l[P],S=l[P+1];if(!m(y,S))return!1;P++}return!0}e.checkAdjacentItems=E}),define(Z[49],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(t){const k=this;let R=!1,M;return function(){return R||(R=!0,M=t.apply(k,arguments)),M}}e.once=w}),define(Z[57],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(t){function k(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function M(){return R}t.empty=M;function*E(o){yield o}t.single=E;function l(o){return o||R}t.from=l;function m(o){return!o||o[Symbol.iterator]().next().done===!0}t.isEmpty=m;function P(o){return o[Symbol.iterator]().next().value}t.first=P;function y(o,n){for(const r of o)if(n(r))return!0;return!1}t.some=y;function S(o,n){for(const r of o)if(n(r))return r}t.find=S;function*g(o,n){for(const r of o)n(r)&&(yield r)}t.filter=g;function*h(o,n){let r=0;for(const s of o)yield n(s,r++)}t.map=h;function*b(...o){for(const n of o)for(const r of n)yield r}t.concat=b;function*C(o){for(const n of o)for(const r of n)yield r}t.concatNested=C;function p(o,n,r){let s=r;for(const c of o)s=n(s,c);return s}t.reduce=p;function v(o,n){let r=0;for(const s of o)n(s,r++)}t.forEach=v;function*d(o,n,r=o.length){for(n<0&&(n+=o.length),r<0?r+=o.length:r>o.length&&(r=o.length);n<r;n++)yield o[n]}t.slice=d;function f(o,n=Number.POSITIVE_INFINITY){const r=[];if(n===0)return[r,o];const s=o[Symbol.iterator]();for(let c=0;c<n;c++){const u=s.next();if(u.done)return[r,t.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return s}}]}t.consume=f;function a(o){return f(o)[0]}t.collect=a;function i(o,n,r=(s,c)=>s===c){const s=o[Symbol.iterator](),c=n[Symbol.iterator]();for(;;){const u=s.next(),I=c.next();if(u.done!==I.done)return!1;if(u.done)return!0;if(!r(u.value,I.value))return!1}}t.equals=i})(w=e.Iterable||(e.Iterable={}))}),define(Z[43],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function M(i,o=!1){let n=0;const r=i.length;let s="",c=0,u=16,I=0;function D(ue){let se=0,he=0;for(;se<ue;){const G=i.charCodeAt(n);if(G>=48&&G<=57)he=he*16+G-48;else if(G>=65&&G<=70)he=he*16+G-65+10;else if(G>=97&&G<=102)he=he*16+G-97+10;else break;n++,se++}return se<ue&&(he=-1),he}function T(ue){n=ue,s="",c=0,u=16,I=0}function N(){const ue=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&m(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&m(i.charCodeAt(n)))for(n++;n<i.length&&m(i.charCodeAt(n));)n++;else return I=3,i.substring(ue,n);let se=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&m(i.charCodeAt(n))){for(n++;n<i.length&&m(i.charCodeAt(n));)n++;se=n}else I=3;return i.substring(ue,se)}function U(){let ue="",se=n;for(;;){if(n>=r){ue+=i.substring(se,n),I=2;break}const he=i.charCodeAt(n);if(he===34){ue+=i.substring(se,n),n++;break}if(he===92){if(ue+=i.substring(se,n),n++,n>=r){I=2;break}switch(i.charCodeAt(n++)){case 34:ue+='"';break;case 92:ue+="\\";break;case 47:ue+="/";break;case 98:ue+="\b";break;case 102:ue+="\f";break;case 110:ue+=`
`;break;case 114:ue+="\r";break;case 116:ue+="	";break;case 117:{const K=D(4);K>=0?ue+=String.fromCharCode(K):I=4;break}default:I=5}se=n;continue}if(he>=0&&he<=31)if(l(he)){ue+=i.substring(se,n),I=2;break}else I=6;n++}return ue}function $(){if(s="",I=0,c=n,n>=r)return c=r,u=17;let ue=i.charCodeAt(n);if(E(ue)){do n++,s+=String.fromCharCode(ue),ue=i.charCodeAt(n);while(E(ue));return u=15}if(l(ue))return n++,s+=String.fromCharCode(ue),ue===13&&i.charCodeAt(n)===10&&(n++,s+=`
`),u=14;switch(ue){case 123:return n++,u=1;case 125:return n++,u=2;case 91:return n++,u=3;case 93:return n++,u=4;case 58:return n++,u=6;case 44:return n++,u=5;case 34:return n++,s=U(),u=10;case 47:{const se=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<r&&!l(i.charCodeAt(n));)n++;return s=i.substring(se,n),u=12}if(i.charCodeAt(n+1)===42){n+=2;const he=r-1;let G=!1;for(;n<he;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,G=!0;break}n++}return G||(n++,I=1),s=i.substring(se,n),u=13}return s+=String.fromCharCode(ue),n++,u=16}case 45:if(s+=String.fromCharCode(ue),n++,n===r||!m(i.charCodeAt(n)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),u=11;default:for(;n<r&&Y(ue);)n++,ue=i.charCodeAt(n);if(c!==n){switch(s=i.substring(c,n),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(ue),n++,u=16}}function Y(ue){if(E(ue)||l(ue))return!1;switch(ue){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let ue;do ue=$();while(ue>=12&&ue<=15);return ue}return{setPosition:T,getPosition:()=>n,scan:o?oe:$,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>I}}e.createScanner=M;function E(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function l(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var P;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(P||(P={}));function y(i,o){const n=[],r=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function I(D,T,N,U){c.value=D,c.offset=T,c.length=N,c.type=U,c.colonOffset=void 0,s=c}try{d(i,{onObjectBegin:(D,T)=>{if(o<=D)throw r;s=void 0,u=o>D,n.push("")},onObjectProperty:(D,T,N)=>{if(o<T||(I(D,T,N,"property"),n[n.length-1]=D,o<=T+N))throw r},onObjectEnd:(D,T)=>{if(o<=D)throw r;s=void 0,n.pop()},onArrayBegin:(D,T)=>{if(o<=D)throw r;s=void 0,n.push(0)},onArrayEnd:(D,T)=>{if(o<=D)throw r;s=void 0,n.pop()},onLiteralValue:(D,T,N)=>{if(o<T||(I(D,T,N,a(D)),o<=T+N))throw r},onSeparator:(D,T,N)=>{if(o<=T)throw r;if(D===":"&&s&&s.type==="property")s.colonOffset=T,u=!1,s=void 0;else if(D===","){const U=n[n.length-1];typeof U=="number"?n[n.length-1]=U+1:(u=!0,n[n.length-1]=""),s=void 0}}})}catch(D){if(D!==r)throw D}return{path:n,previousNode:s,isAtPropertyKey:u,matches:D=>{let T=0;for(let N=0;T<D.length&&N<n.length;N++)if(D[T]===n[N]||D[T]==="*")T++;else if(D[T]!=="**")return!1;return T===D.length}}}e.getLocation=y;function S(i,o=[],n=R.DEFAULT){let r=null,s=[];const c=[];function u(D){Array.isArray(s)?s.push(D):r!==null&&(s[r]=D)}return d(i,{onObjectBegin:()=>{const D={};u(D),c.push(s),s=D,r=null},onObjectProperty:D=>{r=D},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const D=[];u(D),c.push(s),s=D,r=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:u,onError:(D,T,N)=>{o.push({error:D,offset:T,length:N})}},n),s[0]}e.parse=S;function g(i,o=[],n=R.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(D){r.type==="property"&&(r.length=D-r.offset,r=r.parent)}function c(D){return r.children.push(D),D}d(i,{onObjectBegin:D=>{r=c({type:"object",offset:D,length:-1,parent:r,children:[]})},onObjectProperty:(D,T,N)=>{r=c({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:D,offset:T,length:N,parent:r})},onObjectEnd:(D,T)=>{r.length=D+T-r.offset,r=r.parent,s(D+T)},onArrayBegin:(D,T)=>{r=c({type:"array",offset:D,length:-1,parent:r,children:[]})},onArrayEnd:(D,T)=>{r.length=D+T-r.offset,r=r.parent,s(D+T)},onLiteralValue:(D,T,N)=>{c({type:a(D),offset:T,length:N,parent:r,value:D}),s(T+N)},onSeparator:(D,T,N)=>{r.type==="property"&&(D===":"?r.colonOffset=T:D===","&&s(T))},onError:(D,T,N)=>{o.push({error:D,offset:T,length:N})}},n);const I=r.children[0];return I&&delete I.parent,I}e.parseTree=g;function h(i,o){if(!i)return;let n=i;for(const r of o)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===r){n=c.children[1],s=!0;break}if(!s)return}else{const s=r;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=h;function b(i){if(!i.parent||!i.parent.children)return[];const o=b(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}e.getNodePath=b;function C(i){switch(i.type){case"array":return i.children.map(C);case"object":{const o=Object.create(null);for(const n of i.children){const r=n.children[1];r&&(o[n.children[0].value]=C(r))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=C;function p(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}e.contains=p;function v(i,o,n=!1){if(p(i,o,n)){const r=i.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=o;s++){const c=v(r[s],o,n);if(c)return c}return i}}e.findNodeAtOffset=v;function d(i,o,n=R.DEFAULT){const r=M(i,!1);function s(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function c(B){return B?j=>B(j,r.getTokenOffset(),r.getTokenLength()):()=>!0}const u=s(o.onObjectBegin),I=c(o.onObjectProperty),D=s(o.onObjectEnd),T=s(o.onArrayBegin),N=s(o.onArrayEnd),U=c(o.onLiteralValue),$=c(o.onSeparator),Y=s(o.onComment),oe=c(o.onError),ue=n&&n.disallowComments,se=n&&n.allowTrailingComma;function he(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:ue||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(B){case 12:case 13:ue?G(10):Y();break;case 16:G(1);break;case 15:case 14:break;default:return B}}}function G(B,j=[],L=[]){if(oe(B),j.length+L.length>0){let O=r.getToken();for(;O!==17;){if(j.indexOf(O)!==-1){he();break}else if(L.indexOf(O)!==-1)break;O=he()}}}function K(B){const j=r.getTokenValue();return B?U(j):I(j),he(),!0}function F(){switch(r.getToken()){case 11:{let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&(G(2),B=0)}catch{G(2)}U(B);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return he(),!0}function A(){return r.getToken()!==10?(G(3,[],[2,5]),!1):(K(!1),r.getToken()===6?($(":"),he(),te()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function W(){u(),he();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||G(4,[],[]),$(","),he(),r.getToken()===2&&se)break}else B&&G(6,[],[]);A()||G(4,[],[2,5]),B=!0}return D(),r.getToken()!==2?G(7,[2],[]):he(),!0}function z(){T(),he();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||G(4,[],[]),$(","),he(),r.getToken()===4&&se)break}else B&&G(6,[],[]);te()||G(4,[],[4,5]),B=!0}return N(),r.getToken()!==4?G(8,[4],[]):he(),!0}function te(){switch(r.getToken()){case 3:return z();case 1:return W();case 10:return K(!0);default:return F()}}return he(),r.getToken()===17?n.allowEmptyContent?!0:(G(4,[],[]),!1):te()?(r.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=d;function f(i,o){const n=M(i),r=[];let s,c=0,u;do switch(u=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:c!==u&&r.push(i.substring(c,u)),o!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,o)),c=n.getPosition();break}while(s!==17);return r.join("")}e.stripComments=f;function a(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(Z[122],ee([0,1,43]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(m,P,y){let S,g,h,b,C;if(P){for(b=P.offset,C=b+P.length,h=b;h>0&&!l(m,h-1);)h--;let u=C;for(;u<m.length&&!l(m,u);)u++;g=m.substring(h,u),S=M(g,y)}else g=m,S=0,h=0,b=0,C=m.length;const p=E(y,m);let v=!1,d=0,f;y.insertSpaces?f=R(" ",y.tabSize||4):f="	";const a=(0,w.createScanner)(g,!1);let i=!1;function o(){return p+R(f,S+d)}function n(){let u=a.scan();for(v=!1;u===15||u===14;)v=v||u===14,u=a.scan();return i=u===16||a.getTokenError()!==0,u}const r=[];function s(u,I,D){!i&&I<C&&D>b&&m.substring(I,D)!==u&&r.push({offset:I,length:D-I,content:u})}let c=n();if(c!==17){const u=a.getTokenOffset()+h,I=R(f,S);s(I,h,u)}for(;c!==17;){let u=a.getTokenOffset()+a.getTokenLength()+h,I=n(),D="";for(;!v&&(I===12||I===13);){const N=a.getTokenOffset()+h;s(" ",u,N),u=a.getTokenOffset()+a.getTokenLength()+h,D=I===12?o():"",I=n()}if(I===2)c!==1&&(d--,D=o());else if(I===4)c!==3&&(d--,D=o());else{switch(c){case 3:case 1:d++,D=o();break;case 5:case 12:D=o();break;case 13:v?D=o():D=" ";break;case 6:D=" ";break;case 10:if(I===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?D=" ":I!==5&&I!==17&&(i=!0);break;case 16:i=!0;break}v&&(I===12||I===13)&&(D=o())}const T=a.getTokenOffset()+h;s(D,u,T),c=I}return r}e.format=t;function k(m,P){const y=JSON.stringify(m,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?y.replace(/\r\n|\r|\n/g,P.eol):y}e.toFormattedString=k;function R(m,P){let y="";for(let S=0;S<P;S++)y+=m;return y}function M(m,P){let y=0,S=0;const g=P.tabSize||4;for(;y<m.length;){const h=m.charAt(y);if(h===" ")S++;else if(h==="	")S+=g;else break;y++}return Math.floor(S/g)}function E(m,P){for(let y=0;y<P.length;y++){const S=P.charAt(y);if(S==="\r")return y+1<P.length&&P.charAt(y+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=E;function l(m,P){return`\r
`.indexOf(m.charAt(P))!==-1}e.isEOL=l}),define(Z[123],ee([0,1,43,122]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(m,P,y){return R(m,P,void 0,y)}e.removeProperty=k;function R(m,P,y,S,g){const h=P.slice(),b=[],C=(0,w.parseTree)(m,b);let p,v;for(;h.length>0&&(v=h.pop(),p=(0,w.findNodeAtLocation)(C,h),p===void 0&&y!==void 0);)typeof v=="string"?y={[v]:y}:y=[y];if(p)if(p.type==="object"&&typeof v=="string"&&Array.isArray(p.children)){const d=(0,w.findNodeAtLocation)(p,[v]);if(d!==void 0)if(y===void 0){if(!d.parent)throw new Error("Malformed AST");const f=p.children.indexOf(d.parent);let a,i=d.parent.offset+d.parent.length;if(f>0){const o=p.children[f-1];a=o.offset+o.length}else a=p.offset+1,p.children.length>1&&(i=p.children[1].offset);return M(m,{offset:a,length:i-a,content:""},S)}else return M(m,{offset:d.offset,length:d.length,content:JSON.stringify(y)},S);else{if(y===void 0)return[];const f=`${JSON.stringify(v)}: ${JSON.stringify(y)}`,a=g?g(p.children.map(o=>o.children[0].value)):p.children.length;let i;if(a>0){const o=p.children[a-1];i={offset:o.offset+o.length,length:0,content:","+f}}else p.children.length===0?i={offset:p.offset+1,length:0,content:f}:i={offset:p.offset+1,length:0,content:f+","};return M(m,i,S)}}else if(p.type==="array"&&typeof v=="number"&&Array.isArray(p.children))if(y!==void 0){const d=`${JSON.stringify(y)}`;let f;if(p.children.length===0||v===0)f={offset:p.offset+1,length:0,content:p.children.length===0?d:d+","};else{const a=v===-1||v>p.children.length?p.children.length:v,i=p.children[a-1];f={offset:i.offset+i.length,length:0,content:","+d}}return M(m,f,S)}else{const d=v,f=p.children[d];let a;if(p.children.length===1)a={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===d){const i=p.children[d-1],o=i.offset+i.length,n=p.offset+p.length;a={offset:o,length:n-2-o,content:""}}else a={offset:f.offset,length:p.children[d+1].offset-f.offset,content:""};return M(m,a,S)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${p.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return M(m,{offset:C?C.offset:0,length:C?C.length:0,content:JSON.stringify(y)},S)}}e.setProperty=R;function M(m,P,y){let S=E(m,P),g=P.offset,h=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;g>0&&!(0,t.isEOL)(S,g-1);)g--;for(;h<S.length&&!(0,t.isEOL)(S,h);)h++}const b=(0,t.format)(S,{offset:g,length:h-g},y);for(let p=b.length-1;p>=0;p--){const v=b[p];S=E(S,v),g=Math.min(g,v.offset),h=Math.max(h,v.offset+v.length),h+=v.content.length-v.length}const C=m.length-(S.length-h)-g;return[{offset:g,length:C,content:S.substring(g,h)}]}e.withFormatting=M;function E(m,P){return m.substring(0,P.offset)+P.content+m.substring(P.offset+P.length)}e.applyEdit=E;function l(m,P){const y=P.slice(0).sort((g,h)=>{const b=g.offset-h.offset;return b===0?g.length-h.length:b});let S=m.length;for(let g=y.length-1;g>=0;g--){const h=y[g];if(h.offset+h.length<=S)m=E(m,h);else throw new Error("Overlapping edit");S=h.offset}return m}e.applyEdits=l}),define(Z[124],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new w(()=>k(this.getValue()))}}e.Lazy=w}),define(Z[2],ee([0,1,49,57]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function M(s){R=s}if(e.setDisposableTracker=M,k){const s="__is_disposable_tracked__";M(new class{trackDisposable(c){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[s]||console.log(u)},3e3)}setParent(c,u){if(c&&c!==v.None)try{c[s]=!0}catch{}}markAsDisposed(c){if(c&&c!==v.None)try{c[s]=!0}catch{}}markAsSingleton(c){}})}function E(s){return R?.trackDisposable(s),s}function l(s){R?.markAsDisposed(s)}function m(s,c){R?.setParent(s,c)}function P(s,c){if(!!R)for(const u of s)R.setParent(u,c)}function y(s){return R?.markAsSingleton(s),s}e.markAsSingleton=y;function S(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=S;function g(s){if(t.Iterable.is(s)){const c=[];for(const u of s)if(u)try{u.dispose()}catch(I){c.push(I)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=g;function h(s){for(const c of s)S(c)&&c.dispose();return[]}e.disposeIfDisposable=h;function b(...s){const c=C(()=>g(s));return P(s,c),c}e.combinedDisposable=b;function C(s){const c=E({dispose:(0,w.once)(()=>{l(c),s()})});return c}e.toDisposable=C;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return m(c,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new p,E(this),m(this._store,this)}dispose(){l(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&m(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,l(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&m(c,null),c}}e.MutableDisposable=d;class f{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(c){let u=c;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,l(this))},this}}e.SafeDisposable=a;class i{constructor(){this.references=new Map}acquire(c,...u){let I=this.references.get(c);I||(I={counter:0,object:this.createReferencedObject(c,...u)},this.references.set(c,I));const{object:D}=I,T=(0,w.once)(()=>{--I.counter===0&&(this.destroyReferencedObject(c,I.object),this.references.delete(c))});return I.counter++,{object:D,dispose:T}}}e.ReferenceCollection=i;class o{constructor(c){this.referenceCollection=c}async acquire(c,...u){const I=this.referenceCollection.acquire(c,...u);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(D){throw I.dispose(),D}}}e.AsyncReferenceCollection=o;class n{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=n;function r(s){const c=new p;try{s(c)}finally{c.dispose()}}e.disposeOnReturn=r}),define(Z[125],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(R){this.element=R,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class t{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let R=this._first;for(;R!==w.Undefined;){const M=R.next;R.prev=w.Undefined,R.next=w.Undefined,R=M}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,M){const E=new w(R);if(this._first===w.Undefined)this._first=E,this._last=E;else if(M){const m=this._last;this._last=E,E.prev=m,m.next=E}else{const m=this._first;this._first=E,E.next=m,m.prev=E}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(E))}}shift(){if(this._first!==w.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==w.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==w.Undefined&&R.next!==w.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===w.Undefined&&R.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):R.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):R.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==w.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function q(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function M(l){R.push(l,Date.now())}function E(){const l=[];for(let m=0;m<R.length;m+=2)l.push({name:R[m],startTime:R[m+1]});return l}return{mark:M,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(k+M.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function w(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=w(t))}(),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var t in w)(typeof exports=="object"?exports:q)[t]=w[t]}}(typeof self<"u"?self:this,function(){return function(q){var e={};function w(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return q[t].call(k.exports,k,k.exports,w),k.l=!0,k.exports}return w.m=q,w.c=e,w.d=function(t,k,R){w.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},w.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},w.t=function(t,k){if(1&k&&(t=w(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(w.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var M in t)w.d(R,M,function(E){return t[E]}.bind(null,M));return R},w.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return w.d(k,"a",k),k},w.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},w.p="",w(w.s=0)}([function(q,e,w){(function(t){var k;e=q.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],l=e.src=[],m=0,P=m++;l[P]="0|[1-9]\\d*";var y=m++;l[y]="[0-9]+";var S=m++;l[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=m++;l[g]="("+l[P]+")\\.("+l[P]+")\\.("+l[P]+")";var h=m++;l[h]="("+l[y]+")\\.("+l[y]+")\\.("+l[y]+")";var b=m++;l[b]="(?:"+l[P]+"|"+l[S]+")";var C=m++;l[C]="(?:"+l[y]+"|"+l[S]+")";var p=m++;l[p]="(?:-("+l[b]+"(?:\\."+l[b]+")*))";var v=m++;l[v]="(?:-?("+l[C]+"(?:\\."+l[C]+")*))";var d=m++;l[d]="[0-9A-Za-z-]+";var f=m++;l[f]="(?:\\+("+l[d]+"(?:\\."+l[d]+")*))";var a=m++,i="v?"+l[g]+l[p]+"?"+l[f]+"?";l[a]="^"+i+"$";var o="[v=\\s]*"+l[h]+l[v]+"?"+l[f]+"?",n=m++;l[n]="^"+o+"$";var r=m++;l[r]="((?:<|>)?=?)";var s=m++;l[s]=l[y]+"|x|X|\\*";var c=m++;l[c]=l[P]+"|x|X|\\*";var u=m++;l[u]="[v=\\s]*("+l[c]+")(?:\\.("+l[c]+")(?:\\.("+l[c]+")(?:"+l[p]+")?"+l[f]+"?)?)?";var I=m++;l[I]="[v=\\s]*("+l[s]+")(?:\\.("+l[s]+")(?:\\.("+l[s]+")(?:"+l[v]+")?"+l[f]+"?)?)?";var D=m++;l[D]="^"+l[r]+"\\s*"+l[u]+"$";var T=m++;l[T]="^"+l[r]+"\\s*"+l[I]+"$";var N=m++;l[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=m++;l[U]="(?:~>?)";var $=m++;l[$]="(\\s*)"+l[U]+"\\s+",E[$]=new RegExp(l[$],"g");var Y=m++;l[Y]="^"+l[U]+l[u]+"$";var oe=m++;l[oe]="^"+l[U]+l[I]+"$";var ue=m++;l[ue]="(?:\\^)";var se=m++;l[se]="(\\s*)"+l[ue]+"\\s+",E[se]=new RegExp(l[se],"g");var he=m++;l[he]="^"+l[ue]+l[u]+"$";var G=m++;l[G]="^"+l[ue]+l[I]+"$";var K=m++;l[K]="^"+l[r]+"\\s*("+o+")$|^$";var F=m++;l[F]="^"+l[r]+"\\s*("+i+")$|^$";var A=m++;l[A]="(\\s*)"+l[r]+"\\s*("+o+"|"+l[u]+")",E[A]=new RegExp(l[A],"g");var W=m++;l[W]="^\\s*("+l[u]+")\\s+-\\s+("+l[u]+")\\s*$";var z=m++;l[z]="^\\s*("+l[I]+")\\s+-\\s+("+l[I]+")\\s*$";var te=m++;l[te]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)k(B,l[B]),E[B]||(E[B]=new RegExp(l[B]));function j(X,ce){if(X instanceof L)return X;if(typeof X!="string"||X.length>R||!(ce?E[n]:E[a]).test(X))return null;try{return new L(X,ce)}catch{return null}}function L(X,ce){if(X instanceof L){if(X.loose===ce)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(X,ce);k("SemVer",X,ce),this.loose=ce;var de=X.trim().match(ce?E[n]:E[a]);if(!de)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Ee=+ye;if(Ee>=0&&Ee<M)return Ee}return ye}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=j,e.valid=function(X,ce){var de=j(X,ce);return de?de.version:null},e.clean=function(X,ce){var de=j(X.trim().replace(/^[=v]+/,""),ce);return de?de.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(X){return k("SemVer.compare",this.version,this.loose,X),X instanceof L||(X=new L(X,this.loose)),this.compareMain(X)||this.comparePre(X)},L.prototype.compareMain=function(X){return X instanceof L||(X=new L(X,this.loose)),_(this.major,X.major)||_(this.minor,X.minor)||_(this.patch,X.patch)},L.prototype.comparePre=function(X){if(X instanceof L||(X=new L(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var ce=0;do{var de=this.prerelease[ce],ye=X.prerelease[ce];if(k("prerelease compare",ce,de,ye),de===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(de===void 0)return-1;if(de!==ye)return _(de,ye)}while(++ce)},L.prototype.inc=function(X,ce){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,ce,de,ye){typeof de=="string"&&(ye=de,de=void 0);try{return new L(X,de).inc(ce,ye).version}catch{return null}},e.diff=function(X,ce){if(H(X,ce))return null;var de=j(X),ye=j(ce);if(de.prerelease.length||ye.prerelease.length){for(var Ee in de)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&de[Ee]!==ye[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in de)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&de[Ee]!==ye[Ee])return Ee},e.compareIdentifiers=_;var O=/^[0-9]+$/;function _(X,ce){var de=O.test(X),ye=O.test(ce);return de&&ye&&(X=+X,ce=+ce),de&&!ye?-1:ye&&!de?1:X<ce?-1:X>ce?1:0}function V(X,ce,de){return new L(X,de).compare(new L(ce,de))}function x(X,ce,de){return V(X,ce,de)>0}function re(X,ce,de){return V(X,ce,de)<0}function H(X,ce,de){return V(X,ce,de)===0}function ie(X,ce,de){return V(X,ce,de)!==0}function ne(X,ce,de){return V(X,ce,de)>=0}function ae(X,ce,de){return V(X,ce,de)<=0}function fe(X,ce,de,ye){var Ee;switch(ce){case"===":typeof X=="object"&&(X=X.version),typeof de=="object"&&(de=de.version),Ee=X===de;break;case"!==":typeof X=="object"&&(X=X.version),typeof de=="object"&&(de=de.version),Ee=X!==de;break;case"":case"=":case"==":Ee=H(X,de,ye);break;case"!=":Ee=ie(X,de,ye);break;case">":Ee=x(X,de,ye);break;case">=":Ee=ne(X,de,ye);break;case"<":Ee=re(X,de,ye);break;case"<=":Ee=ae(X,de,ye);break;default:throw new TypeError("Invalid operator: "+ce)}return Ee}function De(X,ce){if(X instanceof De){if(X.loose===ce)return X;X=X.value}if(!(this instanceof De))return new De(X,ce);k("comparator",X,ce),this.loose=ce,this.parse(X),this.semver===Le?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(X,ce){return _(ce,X)},e.major=function(X,ce){return new L(X,ce).major},e.minor=function(X,ce){return new L(X,ce).minor},e.patch=function(X,ce){return new L(X,ce).patch},e.compare=V,e.compareLoose=function(X,ce){return V(X,ce,!0)},e.rcompare=function(X,ce,de){return V(ce,X,de)},e.sort=function(X,ce){return X.sort(function(de,ye){return e.compare(de,ye,ce)})},e.rsort=function(X,ce){return X.sort(function(de,ye){return e.rcompare(de,ye,ce)})},e.gt=x,e.lt=re,e.eq=H,e.neq=ie,e.gte=ne,e.lte=ae,e.cmp=fe,e.Comparator=De;var Le={};function ke(X,ce){if(X instanceof ke)return X.loose===ce?X:new ke(X.raw,ce);if(X instanceof De)return new ke(X.value,ce);if(!(this instanceof ke))return new ke(X,ce);if(this.loose=ce,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Ae(X){return!X||X.toLowerCase()==="x"||X==="*"}function je(X,ce,de,ye,Ee,We,Te,Ne,Be,ze,Ue,qe,Q){return((ce=Ae(de)?"":Ae(ye)?">="+de+".0.0":Ae(Ee)?">="+de+"."+ye+".0":">="+ce)+" "+(Ne=Ae(Be)?"":Ae(ze)?"<"+(+Be+1)+".0.0":Ae(Ue)?"<"+Be+"."+(+ze+1)+".0":qe?"<="+Be+"."+ze+"."+Ue+"-"+qe:"<="+Ne)).trim()}function ge(X,ce){for(var de=0;de<X.length;de++)if(!X[de].test(ce))return!1;if(ce.prerelease.length){for(de=0;de<X.length;de++)if(k(X[de].semver),X[de].semver!==Le&&X[de].semver.prerelease.length>0){var ye=X[de].semver;if(ye.major===ce.major&&ye.minor===ce.minor&&ye.patch===ce.patch)return!0}return!1}return!0}function we(X,ce,de){try{ce=new ke(ce,de)}catch{return!1}return ce.test(X)}function Ce(X,ce,de,ye){var Ee,We,Te,Ne,Be;switch(X=new L(X,ye),ce=new ke(ce,ye),de){case">":Ee=x,We=ae,Te=re,Ne=">",Be=">=";break;case"<":Ee=re,We=ne,Te=x,Ne="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(X,ce,ye))return!1;for(var ze=0;ze<ce.set.length;++ze){var Ue=ce.set[ze],qe=null,Q=null;if(Ue.forEach(function(le){le.semver===Le&&(le=new De(">=0.0.0")),qe=qe||le,Q=Q||le,Ee(le.semver,qe.semver,ye)?qe=le:Te(le.semver,Q.semver,ye)&&(Q=le)}),qe.operator===Ne||qe.operator===Be||(!Q.operator||Q.operator===Ne)&&We(X,Q.semver)||Q.operator===Be&&Te(X,Q.semver))return!1}return!0}De.prototype.parse=function(X){var ce=this.loose?E[K]:E[F],de=X.match(ce);if(!de)throw new TypeError("Invalid comparator: "+X);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new L(de[2],this.loose):this.semver=Le},De.prototype.toString=function(){return this.value},De.prototype.test=function(X){return k("Comparator.test",X,this.loose),this.semver===Le||(typeof X=="string"&&(X=new L(X,this.loose)),fe(X,this.operator,this.semver,this.loose))},De.prototype.intersects=function(X,ce){if(!(X instanceof De))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new ke(X.value,ce),we(this.value,de,ce);if(X.operator==="")return de=new ke(this.value,ce),we(X.semver,de,ce);var ye=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),We=this.semver.version===X.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),Ne=fe(this.semver,"<",X.semver,ce)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),Be=fe(this.semver,">",X.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return ye||Ee||We&&Te||Ne||Be},e.Range=ke,ke.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},ke.prototype.toString=function(){return this.range},ke.prototype.parseRange=function(X){var ce=this.loose;X=X.trim(),k("range",X,ce);var de=ce?E[z]:E[W];X=X.replace(de,je),k("hyphen replace",X),X=X.replace(E[A],"$1$2$3"),k("comparator trim",X,E[A]),X=(X=(X=X.replace(E[$],"$1~")).replace(E[se],"$1^")).split(/\s+/).join(" ");var ye=ce?E[K]:E[F],Ee=X.split(" ").map(function(We){return function(Te,Ne){return k("comp",Te),Te=function(Be,ze){return Be.trim().split(/\s+/).map(function(Ue){return function(qe,Q){k("caret",qe,Q);var le=Q?E[G]:E[he];return qe.replace(le,function(pe,me,Se,Re,Fe){var Ve;return k("caret",qe,pe,me,Se,Re,Fe),Ae(me)?Ve="":Ae(Se)?Ve=">="+me+".0.0 <"+(+me+1)+".0.0":Ae(Re)?Ve=me==="0"?">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0":">="+me+"."+Se+".0 <"+(+me+1)+".0.0":Fe?(k("replaceCaret pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),Ve=me==="0"?Se==="0"?">="+me+"."+Se+"."+Re+Fe+" <"+me+"."+Se+"."+(+Re+1):">="+me+"."+Se+"."+Re+Fe+" <"+me+"."+(+Se+1)+".0":">="+me+"."+Se+"."+Re+Fe+" <"+(+me+1)+".0.0"):(k("no pr"),Ve=me==="0"?Se==="0"?">="+me+"."+Se+"."+Re+" <"+me+"."+Se+"."+(+Re+1):">="+me+"."+Se+"."+Re+" <"+me+"."+(+Se+1)+".0":">="+me+"."+Se+"."+Re+" <"+(+me+1)+".0.0"),k("caret return",Ve),Ve})}(Ue,ze)}).join(" ")}(Te,Ne),k("caret",Te),Te=function(Be,ze){return Be.trim().split(/\s+/).map(function(Ue){return function(qe,Q){var le=Q?E[oe]:E[Y];return qe.replace(le,function(pe,me,Se,Re,Fe){var Ve;return k("tilde",qe,pe,me,Se,Re,Fe),Ae(me)?Ve="":Ae(Se)?Ve=">="+me+".0.0 <"+(+me+1)+".0.0":Ae(Re)?Ve=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0":Fe?(k("replaceTilde pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),Ve=">="+me+"."+Se+"."+Re+Fe+" <"+me+"."+(+Se+1)+".0"):Ve=">="+me+"."+Se+"."+Re+" <"+me+"."+(+Se+1)+".0",k("tilde return",Ve),Ve})}(Ue,ze)}).join(" ")}(Te,Ne),k("tildes",Te),Te=function(Be,ze){return k("replaceXRanges",Be,ze),Be.split(/\s+/).map(function(Ue){return function(qe,Q){qe=qe.trim();var le=Q?E[T]:E[D];return qe.replace(le,function(pe,me,Se,Re,Fe,Ve){k("xRange",qe,pe,me,Se,Re,Fe,Ve);var et=Ae(Se),He=et||Ae(Re),Xe=He||Ae(Fe);return me==="="&&Xe&&(me=""),et?pe=me===">"||me==="<"?"<0.0.0":"*":me&&Xe?(He&&(Re=0),Xe&&(Fe=0),me===">"?(me=">=",He?(Se=+Se+1,Re=0,Fe=0):Xe&&(Re=+Re+1,Fe=0)):me==="<="&&(me="<",He?Se=+Se+1:Re=+Re+1),pe=me+Se+"."+Re+"."+Fe):He?pe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Xe&&(pe=">="+Se+"."+Re+".0 <"+Se+"."+(+Re+1)+".0"),k("xRange return",pe),pe})}(Ue,ze)}).join(" ")}(Te,Ne),k("xrange",Te),Te=function(Be,ze){return k("replaceStars",Be,ze),Be.trim().replace(E[te],"")}(Te,Ne),k("stars",Te),Te}(We,ce)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(We){return!!We.match(ye)})),Ee=Ee.map(function(We){return new De(We,ce)})},ke.prototype.intersects=function(X,ce){if(!(X instanceof ke))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(ye){return X.set.some(function(Ee){return Ee.every(function(We){return ye.intersects(We,ce)})})})})},e.toComparators=function(X,ce){return new ke(X,ce).set.map(function(de){return de.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},ke.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new L(X,this.loose));for(var ce=0;ce<this.set.length;ce++)if(ge(this.set[ce],X))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(X,ce,de){var ye=null,Ee=null;try{var We=new ke(ce,de)}catch{return null}return X.forEach(function(Te){We.test(Te)&&(ye&&Ee.compare(Te)!==-1||(Ee=new L(ye=Te,de)))}),ye},e.minSatisfying=function(X,ce,de){var ye=null,Ee=null;try{var We=new ke(ce,de)}catch{return null}return X.forEach(function(Te){We.test(Te)&&(ye&&Ee.compare(Te)!==1||(Ee=new L(ye=Te,de)))}),ye},e.validRange=function(X,ce){try{return new ke(X,ce).range||"*"}catch{return null}},e.ltr=function(X,ce,de){return Ce(X,ce,"<",de)},e.gtr=function(X,ce,de){return Ce(X,ce,">",de)},e.outside=Ce,e.prerelease=function(X,ce){var de=j(X,ce);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(X,ce,de){return X=new ke(X,de),ce=new ke(ce,de),X.intersects(ce)},e.coerce=function(X){if(X instanceof L)return X;if(typeof X!="string")return null;var ce=X.match(E[N]);return ce==null?null:j((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,w(1))},function(q,e){var w,t,k=q.exports={};function R(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function E(C){if(w===setTimeout)return setTimeout(C,0);if((w===R||!w)&&setTimeout)return w=setTimeout,setTimeout(C,0);try{return w(C,0)}catch{try{return w.call(null,C,0)}catch{return w.call(this,C,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:R}catch{w=R}try{t=typeof clearTimeout=="function"?clearTimeout:M}catch{t=M}})();var l,m=[],P=!1,y=-1;function S(){P&&l&&(P=!1,l.length?m=l.concat(m):y=-1,m.length&&g())}function g(){if(!P){var C=E(S);P=!0;for(var p=m.length;p;){for(l=m,m=[];++y<p;)l&&l[y].run();y=-1,p=m.length}l=null,P=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===M||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(C)}}function h(C,p){this.fun=C,this.array=p}function b(){}k.nextTick=function(C){var p=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)p[v-1]=arguments[v];m.push(new h(C,p)),m.length!==1||P||E(g)},h.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=b,k.addListener=b,k.once=b,k.off=b,k.removeListener=b,k.removeAllListeners=b,k.emit=b,k.prependListener=b,k.prependOnceListener=b,k.listeners=function(C){return[]},k.binding=function(C){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(C){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Z[126],ee([0,1]),function(q,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(E,l,m){this.level=E,this.key=l,this.value=m,this.forward=[]}}const k=void 0;class R{constructor(E,l=2**16){this.comparator=E,this[w]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(E){return Boolean(R._search(this,E,this.comparator))}get(E){return R._search(this,E,this.comparator)?.value}set(E,l){return R._insert(this,E,l,this.comparator)&&(this._size+=1),this}delete(E){const l=R._delete(this,E,this.comparator);return l&&(this._size-=1),l}forEach(E,l){let m=this._header.forward[0];for(;m;)E.call(l,m.value,m.key,this),m=m.forward[0]}[(w=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this._header.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this._header.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this._header.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",l=this._header.forward[0];for(;l;)E+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return E}static _search(E,l,m){let P=E._header;for(let y=E._level-1;y>=0;y--)for(;P.forward[y]&&m(P.forward[y].key,l)<0;)P=P.forward[y];if(P=P.forward[0],P&&m(P.key,l)===0)return P}static _insert(E,l,m,P){const y=[];let S=E._header;for(let g=E._level-1;g>=0;g--){for(;S.forward[g]&&P(S.forward[g].key,l)<0;)S=S.forward[g];y[g]=S}if(S=S.forward[0],S&&P(S.key,l)===0)return S.value=m,!1;{const g=R._randomLevel(E);if(g>E._level){for(let h=E._level;h<g;h++)y[h]=E._header;E._level=g}S=new t(g,l,m);for(let h=0;h<g;h++)S.forward[h]=y[h].forward[h],y[h].forward[h]=S;return!0}}static _randomLevel(E,l=.5){let m=1;for(;Math.random()<l&&m<E._maxLevel;)m+=1;return m}static _delete(E,l,m){const P=[];let y=E._header;for(let S=E._level-1;S>=0;S--){for(;y.forward[S]&&m(y.forward[S].key,l)<0;)y=y.forward[S];P[S]=y}if(y=y.forward[0],!y||m(y.key,l)!==0)return!1;for(let S=0;S<E._level&&P[S].forward[S]===y;S++)P[S].forward[S]=y.forward[S];for(;E._level>0&&E._header.forward[E._level-1]===k;)E._level-=1;return!0}}e.SkipList=R}),define(Z[58],ee([0,1,17,2]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const a=f;return a?typeof a.read=="function":!1}e.isReadable=k;function R(f){const a=f;return a?[a.on,a.pause,a.resume,a.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function M(f){const a=f;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=M;function E(f,a){return new l(f,a)}e.newWriteableStream=E;class l{constructor(a,i){this.reducer=a,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a<"u"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(i=>i(a))}emitError(a){this.listeners.error.length===0?(0,w.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(i=>i(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,i){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(a,i){if(this.state.destroyed)return;let o;switch(a){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(f,a){const i=[];let o;for(;(o=f.read())!==null;)i.push(o);return a(i)}e.consumeReadable=m;function P(f,a,i){const o=[];let n;for(;(n=f.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const r=n;return n=void 0,r}return f.read()}}}e.peekReadable=P;function y(f,a){return new Promise((i,o)=>{const n=[];S(f,{onData:r=>{a&&n.push(r)},onError:r=>{a?o(r):i(void 0)},onEnd:()=>{i(a?a(n):void 0)}})})}e.consumeStream=y;function S(f,a){let i=!1;return f.on("error",o=>{i||a.onError(o)}),f.on("end",()=>{i||a.onEnd()}),f.on("data",o=>{i||a.onData(o)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=S;function g(f,a){return new Promise((i,o)=>{const n=new t.DisposableStore,r=[],s=I=>{if(r.push(I),r.length>a)return n.dispose(),f.pause(),i({stream:f,buffer:r,ended:!1})},c=I=>o(I),u=()=>i({stream:f,buffer:r,ended:!0});n.add((0,t.toDisposable)(()=>f.removeListener("error",c))),f.on("error",c),n.add((0,t.toDisposable)(()=>f.removeListener("end",u))),f.on("end",u),n.add((0,t.toDisposable)(()=>f.removeListener("data",s))),f.on("data",s)})}e.peekStream=g;function h(f,a){const i=E(a);return i.end(f),i}e.toStream=h;function b(){const f=E(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=b;function C(f){let a=!1;return{read:()=>a?null:(a=!0,f)}}e.toReadable=C;function p(f,a,i){const o=E(i);return S(f,{onData:n=>o.write(a.data(n)),onError:n=>o.error(a.error?a.error(n):n),onEnd:()=>o.end()}),o}e.transform=p;function v(f,a,i){let o=!1;return{read:()=>{const n=a.read();return o?n:(o=!0,n!==null?i([f,n]):f)}}}e.prefixedReadable=v;function d(f,a,i){let o=!1;const n=E(i);return S(a,{onData:r=>o?n.write(r):(o=!0,n.write(i([f,r]))),onError:r=>n.error(r),onEnd:()=>{o||(o=!0,n.write(f)),n.end()}}),n}e.prefixedStream=d}),define(Z[18],ee([0,1,58]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class M{constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}static alloc(I){return t?new M(Buffer.allocUnsafe(I)):new M(new Uint8Array(I))}static wrap(I){return t&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new M(I)}static fromString(I,D){return!(D?.dontUseNodeBuffer||!1)&&t?new M(Buffer.from(I)):(k||(k=new TextEncoder),new M(k.encode(I)))}static fromByteArray(I){const D=M.alloc(I.length);for(let T=0,N=I.length;T<N;T++)D.buffer[T]=I[T];return D}static concat(I,D){if(typeof D>"u"){D=0;for(let U=0,$=I.length;U<$;U++)D+=I[U].byteLength}const T=M.alloc(D);let N=0;for(let U=0,$=I.length;U<$;U++){const Y=I[U];T.set(Y,N),N+=Y.byteLength}return T}clone(){const I=M.alloc(this.byteLength);return I.set(this),I}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(I,D){return new M(this.buffer.subarray(I,D))}set(I,D){if(I instanceof M)this.buffer.set(I.buffer,D);else if(I instanceof Uint8Array)this.buffer.set(I,D);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),D);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return m(this.buffer,I)}writeUInt32BE(I,D){P(this.buffer,I,D)}readUInt32LE(I){return y(this.buffer,I)}writeUInt32LE(I,D){S(this.buffer,I,D)}readUInt8(I){return g(this.buffer,I)}writeUInt8(I,D){h(this.buffer,I,D)}}e.VSBuffer=M;function E(u,I){return u[I+0]<<0>>>0|u[I+1]<<8>>>0}e.readUInt16LE=E;function l(u,I,D){u[D+0]=I&255,I=I>>>8,u[D+1]=I&255}e.writeUInt16LE=l;function m(u,I){return u[I]*2**24+u[I+1]*2**16+u[I+2]*2**8+u[I+3]}e.readUInt32BE=m;function P(u,I,D){u[D+3]=I,I=I>>>8,u[D+2]=I,I=I>>>8,u[D+1]=I,I=I>>>8,u[D]=I}e.writeUInt32BE=P;function y(u,I){return u[I+0]<<0>>>0|u[I+1]<<8>>>0|u[I+2]<<16>>>0|u[I+3]<<24>>>0}e.readUInt32LE=y;function S(u,I,D){u[D+0]=I&255,I=I>>>8,u[D+1]=I&255,I=I>>>8,u[D+2]=I&255,I=I>>>8,u[D+3]=I&255}e.writeUInt32LE=S;function g(u,I){return u[I]}e.readUInt8=g;function h(u,I,D){u[D]=I}e.writeUInt8=h;function b(u){return w.consumeReadable(u,I=>M.concat(I))}e.readableToBuffer=b;function C(u){return w.toReadable(u)}e.bufferToReadable=C;function p(u){return w.consumeStream(u,I=>M.concat(I))}e.streamToBuffer=p;async function v(u){return u.ended?M.concat(u.buffer):M.concat([...u.buffer,await p(u.stream)])}e.bufferedStreamToBuffer=v;function d(u){return w.toStream(u,I=>M.concat(I))}e.bufferToStream=d;function f(u){return w.transform(u,{data:I=>typeof I=="string"?M.fromString(I):M.wrap(I)},I=>M.concat(I))}e.streamToBufferReadableStream=f;function a(u){return w.newWriteableStream(I=>M.concat(I),u)}e.newWriteableBufferStream=a;function i(u,I){return w.prefixedReadable(u,I,D=>M.concat(D))}e.prefixedBufferReadable=i;function o(u,I){return w.prefixedStream(u,I,D=>M.concat(D))}e.prefixedBufferStream=o;function n(u){let I=0,D=0,T=0;const N=new Uint8Array(Math.floor(u.length/4*3)),U=Y=>{switch(D){case 3:N[T++]=I|Y,D=0;break;case 2:N[T++]=I|Y>>>2,I=Y<<6,D=3;break;case 1:N[T++]=I|Y>>>4,I=Y<<4,D=2;break;default:I=Y<<2,D=1}};for(let Y=0;Y<u.length;Y++){const oe=u.charCodeAt(Y);if(oe>=65&&oe<=90)U(oe-65);else if(oe>=97&&oe<=122)U(oe-97+26);else if(oe>=48&&oe<=57)U(oe-48+52);else if(oe===43||oe===45)U(62);else if(oe===47||oe===95)U(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${u[Y]}`)}}const $=T;for(;D>0;)U(0);return M.wrap(N).slice(0,$)}e.decodeBase64=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:u},I=!0,D=!1){const T=D?s:r;let N="";const U=u.byteLength%3;let $=0;for(;$<u.byteLength-U;$+=3){const Y=u[$+0],oe=u[$+1],ue=u[$+2];N+=T[Y>>>2],N+=T[(Y<<4|oe>>>4)&63],N+=T[(oe<<2|ue>>>6)&63],N+=T[ue&63]}if(U===1){const Y=u[$+0];N+=T[Y>>>2],N+=T[Y<<4&63],I&&(N+="==")}else if(U===2){const Y=u[$+0],oe=u[$+1];N+=T[Y>>>2],N+=T[(Y<<4|oe>>>4)&63],N+=T[oe<<2&63],I&&(N+="=")}return N}e.encodeBase64=c}),define(Z[12],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function w(o){return typeof o=="string"}e.isString=w;function t(o){return Array.isArray(o)&&o.every(n=>w(n))}e.isStringArray=t;function k(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=k;function R(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}e.isTypedArray=R;function M(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=M;function E(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=E;function l(o){return o===!0||o===!1}e.isBoolean=l;function m(o){return typeof o>"u"}e.isUndefined=m;function P(o){return!y(o)}e.isDefined=P;function y(o){return m(o)||o===null}e.isUndefinedOrNull=y;function S(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=S;function g(o){if(y(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=g;function h(...o){const n=[];for(let r=0;r<o.length;r++){const s=o[r];if(y(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);n.push(s)}return n}e.assertAllDefined=h;const b=Object.prototype.hasOwnProperty;function C(o){if(!k(o))return!1;for(const n in o)if(b.call(o,n))return!1;return!0}e.isEmptyObject=C;function p(o){return typeof o=="function"}e.isFunction=p;function v(...o){return o.length>0&&o.every(p)}e.areFunctions=v;function d(o,n){const r=Math.min(o.length,n.length);for(let s=0;s<r;s++)f(o[s],n[s])}e.validateConstraints=d;function f(o,n){if(w(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(p(n)){try{if(o instanceof n)return}catch{}if(!y(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function a(o){return o===null?void 0:o}e.withNullAsUndefined=a;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(Z[50],ee([0,1,12]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const v=Array.isArray(p)?[]:{};return Object.keys(p).forEach(d=>{p[d]&&typeof p[d]=="object"?v[d]=t(p[d]):v[d]=p[d]}),v}e.deepClone=t;function k(p){if(!p||typeof p!="object")return p;const v=[p];for(;v.length>0;){const d=v.shift();Object.freeze(d);for(const f in d)if(R.call(d,f)){const a=d[f];typeof a=="object"&&!Object.isFrozen(a)&&!(0,w.isTypedArray)(a)&&v.push(a)}}return p}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function M(p,v){return E(p,v,new Set)}e.cloneAndChange=M;function E(p,v,d){if((0,w.isUndefinedOrNull)(p))return p;const f=v(p);if(typeof f<"u")return f;if(Array.isArray(p)){const a=[];for(const i of p)a.push(E(i,v,d));return a}if((0,w.isObject)(p)){if(d.has(p))throw new Error("Cannot clone recursive data-structure");d.add(p);const a={};for(const i in p)R.call(p,i)&&(a[i]=E(p[i],v,d));return d.delete(p),a}return p}function l(p,v,d=!0){return(0,w.isObject)(p)?((0,w.isObject)(v)&&Object.keys(v).forEach(f=>{f in p?d&&((0,w.isObject)(p[f])&&(0,w.isObject)(v[f])?l(p[f],v[f],d):p[f]=v[f]):p[f]=v[f]}),p):v}e.mixin=l;function m(p,v){if(p===v)return!0;if(p==null||v===null||v===void 0||typeof p!=typeof v||typeof p!="object"||Array.isArray(p)!==Array.isArray(v))return!1;let d,f;if(Array.isArray(p)){if(p.length!==v.length)return!1;for(d=0;d<p.length;d++)if(!m(p[d],v[d]))return!1}else{const a=[];for(f in p)a.push(f);a.sort();const i=[];for(f in v)i.push(f);if(i.sort(),!m(a,i))return!1;for(d=0;d<a.length;d++)if(!m(p[a[d]],v[a[d]]))return!1}return!0}e.equals=m;function P(p){const v=new Set;return JSON.stringify(p,(d,f)=>{if((0,w.isObject)(f)||Array.isArray(f)){if(v.has(f))return"[Circular]";v.add(f)}return f})}e.safeStringify=P;function y(p,v){const d=Object.create(null);return!p||!v||Object.keys(v).forEach(a=>{const i=p[a],o=v[a];m(i,o)||(d[a]=o)}),d}e.distinct=y;function S(p,v){const d=v.toLowerCase(),f=Object.keys(p).find(a=>a.toLowerCase()===d);return f?p[f]:p[v]}e.getCaseInsensitive=S;function g(p,v){const d=Object.create(null);for(const[f,a]of Object.entries(p))v(f,a)&&(d[f]=a);return d}e.filter=g;function h(p){let v=[],d=Object.getPrototypeOf(p);for(;Object.prototype!==d;)v=v.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return v}e.getAllPropertyNames=h;function b(p){const v=[];for(const d of h(p))typeof p[d]=="function"&&v.push(d);return v}e.getAllMethodNames=b;function C(p,v){const d=a=>function(){const i=Array.prototype.slice.call(arguments,0);return v(a,i)},f={};for(const a of p)f[a]=d(a);return f}e.createProxyObject=C}),define(Z[29],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return w.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(E){for(let l=0;l<E.length;l++)E[l]=Math.floor(Math.random()*256);return E};const R=new Uint8Array(16),M=[];for(let E=0;E<256;E++)M.push(E.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let l=0,m="";return m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m}}()}),define(Z[127],ee([0,1,76,40,49]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(M,E){if(await new Promise((P,y)=>{const S=t.createReadStream(M),g=w.createHash("sha1");S.pipe(g);const h=(0,k.once)((b,C)=>{S.removeAllListeners(),g.removeAllListeners(),b?y(b):P(C)});S.once("error",h),S.once("end",h),g.once("error",h),g.once("data",b=>h(void 0,b.toString("hex")))})!==E)throw new Error("Hash mismatch")}e.checksum=R}),define(Z[128],ee([0,1,28]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(M){const E=M.replace(/\-/g,":").toLowerCase();return!t.has(E)}function R(){const M=(0,w.networkInterfaces)();for(const E in M){const l=M[E];if(l){for(const{mac:m}of l)if(k(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(Z[94],ee([0,1,77]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(E,l,m,P=1){let y=!1;return new Promise(S=>{const g=setTimeout(()=>{if(!y)return y=!0,S(0)},m);k(E,l,P,h=>{if(!y)return y=!0,clearTimeout(g),S(h)})})}e.findFreePort=t;function k(E,l,m,P){if(l===0)return P(0);const y=new w.Socket;y.once("connect",()=>(M(y),k(E+m,l-1,m,P))),y.once("data",()=>{}),y.once("error",S=>(M(y),S.code!=="ECONNREFUSED"?k(E+m,l-1,m,P):P(E))),y.connect(E,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(E,l,m){let P=!1,y,S=1;const g=w.createServer({pauseOnConnect:!0});function h(b,C){P||(P=!0,g.removeAllListeners(),g.close(),y&&clearTimeout(y),C(b))}return new Promise(b=>{y=setTimeout(()=>{h(0,b)},m),g.on("listening",()=>{h(E,b)}),g.on("error",C=>{C&&(C.code==="EADDRINUSE"||C.code==="EACCES")&&S<l?(E++,S++,g.listen(E,"127.0.0.1")):h(0,b)}),g.on("close",()=>{h(0,b)}),g.listen(E,"127.0.0.1")})}e.findFreePortFaster=R;function M(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(l){console.error(l)}}}),define(Z[129],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[130],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class w{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=w}),define(Z[41],ee([0,1,15,17]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(M,E){const l=(m,...P)=>{this.validateEvent(M,m)&&E(m,...P)};return this.mapListenerToWrapper.set(E,l),w.ipcMain.on(M,l),this}once(M,E){return w.ipcMain.once(M,(l,...m)=>{this.validateEvent(M,l)&&E(l,...m)}),this}handle(M,E){return w.ipcMain.handle(M,(l,...m)=>this.validateEvent(M,l)?E(l,...m):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return w.ipcMain.removeHandler(M),this}removeListener(M,E){const l=this.mapListenerToWrapper.get(E);return l&&(w.ipcMain.removeListener(M,l),this.mapListenerToWrapper.delete(E)),this}validateEvent(M,E){if(!M||!M.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const l=E.senderFrame,m=l.url;if(!m)return!0;let P="unknown";try{P=new URL(m).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${m}'.`),!1}return P!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${P}'.`),!1):l.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${P}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(Z[131],ee([0,1,15,41,12,129]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(l,m,P,y,S)=>{const g=E(l,y,P);g.popup({window:(0,k.withNullAsUndefined)(w.BrowserWindow.fromWebContents(l.sender)),x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{g&&l.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=M;function E(l,m,P){const y=new w.Menu;return P.forEach(S=>{let g;S.type==="separator"?g=new w.MenuItem({type:S.type}):Array.isArray(S.submenu)?g=new w.MenuItem({submenu:E(l,m,S.submenu),label:S.label}):g=new w.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(h,b,C)=>l.sender.send(m,S.id,C)}),y.append(g)}),y}}),define(Z[132],ee([11,10]),function(q,e){return q.create("vs/base/common/date",e)}),define(Z[133],ee([0,1,132]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,M=R*7,E=R*30,l=R*365;function m(y,S,g){typeof y!="number"&&(y=y.getTime());const h=Math.round((new Date().getTime()-y)/1e3);if(h<-30)return(0,w.localize)(0,null,m(new Date().getTime()+h*1e3,!1));if(h<30)return(0,w.localize)(1,null);let b;return h<t?(b=h,S?b===1?g?(0,w.localize)(2,null,b):(0,w.localize)(3,null,b):g?(0,w.localize)(4,null,b):(0,w.localize)(5,null,b):b===1?g?(0,w.localize)(6,null,b):(0,w.localize)(7,null,b):g?(0,w.localize)(8,null,b):(0,w.localize)(9,null,b)):h<k?(b=Math.floor(h/t),S?b===1?g?(0,w.localize)(10,null,b):(0,w.localize)(11,null,b):g?(0,w.localize)(12,null,b):(0,w.localize)(13,null,b):b===1?g?(0,w.localize)(14,null,b):(0,w.localize)(15,null,b):g?(0,w.localize)(16,null,b):(0,w.localize)(17,null,b)):h<R?(b=Math.floor(h/k),S?b===1?g?(0,w.localize)(18,null,b):(0,w.localize)(19,null,b):g?(0,w.localize)(20,null,b):(0,w.localize)(21,null,b):b===1?g?(0,w.localize)(22,null,b):(0,w.localize)(23,null,b):g?(0,w.localize)(24,null,b):(0,w.localize)(25,null,b)):h<M?(b=Math.floor(h/R),S?b===1?(0,w.localize)(26,null,b):(0,w.localize)(27,null,b):b===1?(0,w.localize)(28,null,b):(0,w.localize)(29,null,b)):h<E?(b=Math.floor(h/M),S?b===1?g?(0,w.localize)(30,null,b):(0,w.localize)(31,null,b):g?(0,w.localize)(32,null,b):(0,w.localize)(33,null,b):b===1?g?(0,w.localize)(34,null,b):(0,w.localize)(35,null,b):g?(0,w.localize)(36,null,b):(0,w.localize)(37,null,b)):h<l?(b=Math.floor(h/E),S?b===1?g?(0,w.localize)(38,null,b):(0,w.localize)(39,null,b):g?(0,w.localize)(40,null,b):(0,w.localize)(41,null,b):b===1?g?(0,w.localize)(42,null,b):(0,w.localize)(43,null,b):g?(0,w.localize)(44,null,b):(0,w.localize)(45,null,b)):(b=Math.floor(h/l),S?b===1?g?(0,w.localize)(46,null,b):(0,w.localize)(47,null,b):g?(0,w.localize)(48,null,b):(0,w.localize)(49,null,b):b===1?g?(0,w.localize)(50,null,b):(0,w.localize)(51,null,b):g?(0,w.localize)(52,null,b):(0,w.localize)(53,null,b))}e.fromNow=m;function P(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(Z[134],ee([11,10]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(Z[44],ee([0,1,24,12,134]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(y,S){return S&&(y.stack||y.stacktrace)?k.localize(0,null,E(y),M(y.stack)||M(y.stacktrace)):E(y)}function M(y){return Array.isArray(y)?y.join(`
`):y}function E(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?k.localize(1,null,y.message):y.message||k.localize(2,null)}function l(y=null,S=!1){if(!y)return k.localize(3,null);if(Array.isArray(y)){const g=w.coalesce(y),h=l(g[0],S);return g.length>1?k.localize(4,null,h,g.length):h}if(t.isString(y))return y;if(y.detail){const g=y.detail;if(g.error)return R(g.error,S);if(g.exception)return R(g.exception,S)}return y.stack?R(y,S):y.message?y.message:k.localize(5,null)}e.toErrorMessage=l;function m(y){const S=y;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=m;function P(y,S){let g;return typeof y=="string"?g=new Error(y):g=y,g.actions=S,g}e.createErrorWithActions=P}),define(Z[135],ee([11,10]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(Z[136],ee([0,1,135]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,w.localize)(0,null);case 2:return(0,w.localize)(1,null);case 3:return(0,w.localize)(2,null);case 4:return(0,w.localize)(3,null);case 5:return(0,w.localize)(4,null);case 6:return(0,w.localize)(5,null);case 7:return(0,w.localize)(6,null);case 8:return(0,w.localize)(7,null);case 9:return(0,w.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(Z[137],ee([11,10]),function(q,e){return q.create("vs/base/common/platform",e)}),define(Z[4],ee([0,1,137]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let k=!1,R=!1,M=!1,E=!1,l=!1,m=!1,P=!1,y=!1,S=!1,g=!1,h,b=t,C,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?v=e.globals.vscode.process:typeof process<"u"&&(v=process);const d=typeof v?.versions?.electron=="string",f=d&&v?.type==="renderer";if(typeof navigator=="object"&&!f)p=navigator.userAgent,k=p.indexOf("Windows")>=0,R=p.indexOf("Macintosh")>=0,y=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=p.indexOf("Linux")>=0,g=p?.indexOf("Mobi")>=0,m=!0,h=w.getConfiguredDefaultLocale(w.localize(0,null))||t,b=h;else if(typeof v=="object"){k=v.platform==="win32",R=v.platform==="darwin",M=v.platform==="linux",E=M&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,P=d,S=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=t,b=t;const I=v.env.VSCODE_NLS_CONFIG;if(I)try{const D=JSON.parse(I),T=D.availableLanguages["*"];h=D.locale,b=T||t,C=D._translationsConfigFile}catch{}l=!0}else console.error("Unable to resolve platform.");var a;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(a=e.Platform||(e.Platform={}));function i(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=i;let o=0;R?o=1:k?o=3:M&&(o=2),e.isWindows=k,e.isMacintosh=R,e.isLinux=M,e.isLinuxSnap=E,e.isNative=l,e.isElectron=P,e.isWeb=m,e.isWebWorker=m&&typeof e.globals.importScripts=="function",e.isIOS=y,e.isMobile=g,e.isCI=S,e.platform=o,e.userAgent=p,e.language=b;var n;(function(I){function D(){return e.language}I.value=D;function T(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}I.isDefaultVariant=T;function N(){return e.language==="en"}I.isDefault=N})(n=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=C,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const I=[];e.globals.addEventListener("message",T=>{if(T.data&&T.data.vscodeScheduleAsyncWork)for(let N=0,U=I.length;N<U;N++){const $=I[N];if($.id===T.data.vscodeScheduleAsyncWork){I.splice(N,1),$.callback();return}}});let D=0;return T=>{const N=++D;I.push({id:N,callback:T}),e.globals.postMessage({vscodeScheduleAsyncWork:N},"*")}}return I=>setTimeout(I)})();var r;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||y?2:k?1:3;let s=!0,c=!1;function u(){if(!c){c=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,s=new Uint16Array(I.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[33],ee([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof w.globals.vscode<"u"&&typeof w.globals.vscode.process<"u"){const k=w.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Z[9],ee([0,1,33]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,M=122,E=46,l=47,m=92,P=58,y=63;class S extends Error{constructor(f,a,i){let o;typeof a=="string"&&a.indexOf("not ")===0?(o="must not be",a=a.replace(/^not /,"")):o="must be";const n=f.indexOf(".")!==-1?"property":"argument";let r=`The "${f}" ${n} ${o} of type ${a}`;r+=`. Received type ${typeof i}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function g(d,f){if(typeof d!="string")throw new S(f,"string",d)}function h(d){return d===l||d===m}function b(d){return d===l}function C(d){return d>=t&&d<=R||d>=k&&d<=M}function p(d,f,a,i){let o="",n=0,r=-1,s=0,c=0;for(let u=0;u<=d.length;++u){if(u<d.length)c=d.charCodeAt(u);else{if(i(c))break;c=l}if(i(c)){if(!(r===u-1||s===1))if(s===2){if(o.length<2||n!==2||o.charCodeAt(o.length-1)!==E||o.charCodeAt(o.length-2)!==E){if(o.length>2){const I=o.lastIndexOf(a);I===-1?(o="",n=0):(o=o.slice(0,I),n=o.length-1-o.lastIndexOf(a)),r=u,s=0;continue}else if(o.length!==0){o="",n=0,r=u,s=0;continue}}f&&(o+=o.length>0?`${a}..`:"..",n=2)}else o.length>0?o+=`${a}${d.slice(r+1,u)}`:o=d.slice(r+1,u),n=u-r-1;r=u,s=0}else c===E&&s!==-1?++s:s=-1}return o}function v(d,f){if(f===null||typeof f!="object")throw new S("pathObject","Object",f);const a=f.dir||f.root,i=f.base||`${f.name||""}${f.ext||""}`;return a?a===f.root?`${a}${i}`:`${a}${d}${i}`:i}e.win32={resolve(...d){let f="",a="",i=!1;for(let o=d.length-1;o>=-1;o--){let n;if(o>=0){if(n=d[o],g(n,"path"),n.length===0)continue}else f.length===0?n=w.cwd():(n=w.env[`=${f}`]||w.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==f.toLowerCase()&&n.charCodeAt(2)===m)&&(n=`${f}\\`));const r=n.length;let s=0,c="",u=!1;const I=n.charCodeAt(0);if(r===1)h(I)&&(s=1,u=!0);else if(h(I))if(u=!0,h(n.charCodeAt(1))){let D=2,T=D;for(;D<r&&!h(n.charCodeAt(D));)D++;if(D<r&&D!==T){const N=n.slice(T,D);for(T=D;D<r&&h(n.charCodeAt(D));)D++;if(D<r&&D!==T){for(T=D;D<r&&!h(n.charCodeAt(D));)D++;(D===r||D!==T)&&(c=`\\\\${N}\\${n.slice(T,D)}`,s=D)}}}else s=1;else C(I)&&n.charCodeAt(1)===P&&(c=n.slice(0,2),s=2,r>2&&h(n.charCodeAt(2))&&(u=!0,s=3));if(c.length>0)if(f.length>0){if(c.toLowerCase()!==f.toLowerCase())continue}else f=c;if(i){if(f.length>0)break}else if(a=`${n.slice(s)}\\${a}`,i=u,u&&f.length>0)break}return a=p(a,!i,"\\",h),i?`${f}\\${a}`:`${f}${a}`||"."},normalize(d){g(d,"path");const f=d.length;if(f===0)return".";let a=0,i,o=!1;const n=d.charCodeAt(0);if(f===1)return b(n)?"\\":d;if(h(n))if(o=!0,h(d.charCodeAt(1))){let s=2,c=s;for(;s<f&&!h(d.charCodeAt(s));)s++;if(s<f&&s!==c){const u=d.slice(c,s);for(c=s;s<f&&h(d.charCodeAt(s));)s++;if(s<f&&s!==c){for(c=s;s<f&&!h(d.charCodeAt(s));)s++;if(s===f)return`\\\\${u}\\${d.slice(c)}\\`;s!==c&&(i=`\\\\${u}\\${d.slice(c,s)}`,a=s)}}}else a=1;else C(n)&&d.charCodeAt(1)===P&&(i=d.slice(0,2),a=2,f>2&&h(d.charCodeAt(2))&&(o=!0,a=3));let r=a<f?p(d.slice(a),!o,"\\",h):"";return r.length===0&&!o&&(r="."),r.length>0&&h(d.charCodeAt(f-1))&&(r+="\\"),i===void 0?o?`\\${r}`:r:o?`${i}\\${r}`:`${i}${r}`},isAbsolute(d){g(d,"path");const f=d.length;if(f===0)return!1;const a=d.charCodeAt(0);return h(a)||f>2&&C(a)&&d.charCodeAt(1)===P&&h(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let f,a;for(let n=0;n<d.length;++n){const r=d[n];g(r,"path"),r.length>0&&(f===void 0?f=a=r:f+=`\\${r}`)}if(f===void 0)return".";let i=!0,o=0;if(typeof a=="string"&&h(a.charCodeAt(0))){++o;const n=a.length;n>1&&h(a.charCodeAt(1))&&(++o,n>2&&(h(a.charCodeAt(2))?++o:i=!1))}if(i){for(;o<f.length&&h(f.charCodeAt(o));)o++;o>=2&&(f=`\\${f.slice(o)}`)}return e.win32.normalize(f)},relative(d,f){if(g(d,"from"),g(f,"to"),d===f)return"";const a=e.win32.resolve(d),i=e.win32.resolve(f);if(a===i||(d=a.toLowerCase(),f=i.toLowerCase(),d===f))return"";let o=0;for(;o<d.length&&d.charCodeAt(o)===m;)o++;let n=d.length;for(;n-1>o&&d.charCodeAt(n-1)===m;)n--;const r=n-o;let s=0;for(;s<f.length&&f.charCodeAt(s)===m;)s++;let c=f.length;for(;c-1>s&&f.charCodeAt(c-1)===m;)c--;const u=c-s,I=r<u?r:u;let D=-1,T=0;for(;T<I;T++){const U=d.charCodeAt(o+T);if(U!==f.charCodeAt(s+T))break;U===m&&(D=T)}if(T!==I){if(D===-1)return i}else{if(u>I){if(f.charCodeAt(s+T)===m)return i.slice(s+T+1);if(T===2)return i.slice(s+T)}r>I&&(d.charCodeAt(o+T)===m?D=T:T===2&&(D=3)),D===-1&&(D=0)}let N="";for(T=o+D+1;T<=n;++T)(T===n||d.charCodeAt(T)===m)&&(N+=N.length===0?"..":"\\..");return s+=D,N.length>0?`${N}${i.slice(s,c)}`:(i.charCodeAt(s)===m&&++s,i.slice(s,c))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const f=e.win32.resolve(d);if(f.length<=2)return d;if(f.charCodeAt(0)===m){if(f.charCodeAt(1)===m){const a=f.charCodeAt(2);if(a!==y&&a!==E)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(C(f.charCodeAt(0))&&f.charCodeAt(1)===P&&f.charCodeAt(2)===m)return`\\\\?\\${f}`;return d},dirname(d){g(d,"path");const f=d.length;if(f===0)return".";let a=-1,i=0;const o=d.charCodeAt(0);if(f===1)return h(o)?d:".";if(h(o)){if(a=i=1,h(d.charCodeAt(1))){let s=2,c=s;for(;s<f&&!h(d.charCodeAt(s));)s++;if(s<f&&s!==c){for(c=s;s<f&&h(d.charCodeAt(s));)s++;if(s<f&&s!==c){for(c=s;s<f&&!h(d.charCodeAt(s));)s++;if(s===f)return d;s!==c&&(a=i=s+1)}}}}else C(o)&&d.charCodeAt(1)===P&&(a=f>2&&h(d.charCodeAt(2))?3:2,i=a);let n=-1,r=!0;for(let s=f-1;s>=i;--s)if(h(d.charCodeAt(s))){if(!r){n=s;break}}else r=!1;if(n===-1){if(a===-1)return".";n=a}return d.slice(0,n)},basename(d,f){f!==void 0&&g(f,"ext"),g(d,"path");let a=0,i=-1,o=!0,n;if(d.length>=2&&C(d.charCodeAt(0))&&d.charCodeAt(1)===P&&(a=2),f!==void 0&&f.length>0&&f.length<=d.length){if(f===d)return"";let r=f.length-1,s=-1;for(n=d.length-1;n>=a;--n){const c=d.charCodeAt(n);if(h(c)){if(!o){a=n+1;break}}else s===-1&&(o=!1,s=n+1),r>=0&&(c===f.charCodeAt(r)?--r===-1&&(i=n):(r=-1,i=s))}return a===i?i=s:i===-1&&(i=d.length),d.slice(a,i)}for(n=d.length-1;n>=a;--n)if(h(d.charCodeAt(n))){if(!o){a=n+1;break}}else i===-1&&(o=!1,i=n+1);return i===-1?"":d.slice(a,i)},extname(d){g(d,"path");let f=0,a=-1,i=0,o=-1,n=!0,r=0;d.length>=2&&d.charCodeAt(1)===P&&C(d.charCodeAt(0))&&(f=i=2);for(let s=d.length-1;s>=f;--s){const c=d.charCodeAt(s);if(h(c)){if(!n){i=s+1;break}continue}o===-1&&(n=!1,o=s+1),c===E?a===-1?a=s:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||o===-1||r===0||r===1&&a===o-1&&a===i+1?"":d.slice(a,o)},format:v.bind(null,"\\"),parse(d){g(d,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return f;const a=d.length;let i=0,o=d.charCodeAt(0);if(a===1)return h(o)?(f.root=f.dir=d,f):(f.base=f.name=d,f);if(h(o)){if(i=1,h(d.charCodeAt(1))){let D=2,T=D;for(;D<a&&!h(d.charCodeAt(D));)D++;if(D<a&&D!==T){for(T=D;D<a&&h(d.charCodeAt(D));)D++;if(D<a&&D!==T){for(T=D;D<a&&!h(d.charCodeAt(D));)D++;D===a?i=D:D!==T&&(i=D+1)}}}}else if(C(o)&&d.charCodeAt(1)===P){if(a<=2)return f.root=f.dir=d,f;if(i=2,h(d.charCodeAt(2))){if(a===3)return f.root=f.dir=d,f;i=3}}i>0&&(f.root=d.slice(0,i));let n=-1,r=i,s=-1,c=!0,u=d.length-1,I=0;for(;u>=i;--u){if(o=d.charCodeAt(u),h(o)){if(!c){r=u+1;break}continue}s===-1&&(c=!1,s=u+1),o===E?n===-1?n=u:I!==1&&(I=1):n!==-1&&(I=-1)}return s!==-1&&(n===-1||I===0||I===1&&n===s-1&&n===r+1?f.base=f.name=d.slice(r,s):(f.name=d.slice(r,n),f.base=d.slice(r,s),f.ext=d.slice(n,s))),r>0&&r!==i?f.dir=d.slice(0,r-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let f="",a=!1;for(let i=d.length-1;i>=-1&&!a;i--){const o=i>=0?d[i]:w.cwd();g(o,"path"),o.length!==0&&(f=`${o}/${f}`,a=o.charCodeAt(0)===l)}return f=p(f,!a,"/",b),a?`/${f}`:f.length>0?f:"."},normalize(d){if(g(d,"path"),d.length===0)return".";const f=d.charCodeAt(0)===l,a=d.charCodeAt(d.length-1)===l;return d=p(d,!f,"/",b),d.length===0?f?"/":a?"./":".":(a&&(d+="/"),f?`/${d}`:d)},isAbsolute(d){return g(d,"path"),d.length>0&&d.charCodeAt(0)===l},join(...d){if(d.length===0)return".";let f;for(let a=0;a<d.length;++a){const i=d[a];g(i,"path"),i.length>0&&(f===void 0?f=i:f+=`/${i}`)}return f===void 0?".":e.posix.normalize(f)},relative(d,f){if(g(d,"from"),g(f,"to"),d===f||(d=e.posix.resolve(d),f=e.posix.resolve(f),d===f))return"";const a=1,i=d.length,o=i-a,n=1,r=f.length-n,s=o<r?o:r;let c=-1,u=0;for(;u<s;u++){const D=d.charCodeAt(a+u);if(D!==f.charCodeAt(n+u))break;D===l&&(c=u)}if(u===s)if(r>s){if(f.charCodeAt(n+u)===l)return f.slice(n+u+1);if(u===0)return f.slice(n+u)}else o>s&&(d.charCodeAt(a+u)===l?c=u:u===0&&(c=0));let I="";for(u=a+c+1;u<=i;++u)(u===i||d.charCodeAt(u)===l)&&(I+=I.length===0?"..":"/..");return`${I}${f.slice(n+c)}`},toNamespacedPath(d){return d},dirname(d){if(g(d,"path"),d.length===0)return".";const f=d.charCodeAt(0)===l;let a=-1,i=!0;for(let o=d.length-1;o>=1;--o)if(d.charCodeAt(o)===l){if(!i){a=o;break}}else i=!1;return a===-1?f?"/":".":f&&a===1?"//":d.slice(0,a)},basename(d,f){f!==void 0&&g(f,"ext"),g(d,"path");let a=0,i=-1,o=!0,n;if(f!==void 0&&f.length>0&&f.length<=d.length){if(f===d)return"";let r=f.length-1,s=-1;for(n=d.length-1;n>=0;--n){const c=d.charCodeAt(n);if(c===l){if(!o){a=n+1;break}}else s===-1&&(o=!1,s=n+1),r>=0&&(c===f.charCodeAt(r)?--r===-1&&(i=n):(r=-1,i=s))}return a===i?i=s:i===-1&&(i=d.length),d.slice(a,i)}for(n=d.length-1;n>=0;--n)if(d.charCodeAt(n)===l){if(!o){a=n+1;break}}else i===-1&&(o=!1,i=n+1);return i===-1?"":d.slice(a,i)},extname(d){g(d,"path");let f=-1,a=0,i=-1,o=!0,n=0;for(let r=d.length-1;r>=0;--r){const s=d.charCodeAt(r);if(s===l){if(!o){a=r+1;break}continue}i===-1&&(o=!1,i=r+1),s===E?f===-1?f=r:n!==1&&(n=1):f!==-1&&(n=-1)}return f===-1||i===-1||n===0||n===1&&f===i-1&&f===a+1?"":d.slice(f,i)},format:v.bind(null,"/"),parse(d){g(d,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return f;const a=d.charCodeAt(0)===l;let i;a?(f.root="/",i=1):i=0;let o=-1,n=0,r=-1,s=!0,c=d.length-1,u=0;for(;c>=i;--c){const I=d.charCodeAt(c);if(I===l){if(!s){n=c+1;break}continue}r===-1&&(s=!1,r=c+1),I===E?o===-1?o=c:u!==1&&(u=1):o!==-1&&(u=-1)}if(r!==-1){const I=n===0&&a?1:n;o===-1||u===0||u===1&&o===r-1&&o===n+1?f.base=f.name=d.slice(I,r):(f.name=d.slice(I,o),f.base=d.slice(I,r),f.ext=d.slice(o,r))}return n>0?f.dir=d.slice(0,n-1):a&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[78],ee([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(E,...l){const m=l.reduce((S,g)=>(S[g]=!0,S),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(S=>!m[S]).forEach(S=>{for(let g=0;g<P.length;g++)if(S.search(P[g])!==-1){delete E[S];break}})}e.sanitizeProcessEnvironment=R;function M(E){!E||(delete E.DEBUG,w.isMacintosh&&delete E.DYLD_LIBRARY_PATH,w.isLinux&&delete E.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(Z[79],ee([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=w.globals.performance&&typeof w.globals.performance.now=="function";class k{constructor(M){this._highResolution=t&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new k(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Z[3],ee([0,1,17,49,2,125,79]),function(q,e,w,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const E=!1,l=!1;var m;(function(c){c.None=()=>k.Disposable.None;function u(O){if(l){const{onListenerDidAdd:_}=O,V=h.create();let x=0;O.onListenerDidAdd=()=>{++x===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),_?.()}}}function I(O){return(_,V=null,x)=>{let re=!1,H;return H=O(ie=>{if(!re)return H?H.dispose():re=!0,_.call(V,ie)},null,x),re&&H.dispose(),H}}c.once=I;function D(O,_,V){return oe((x,re=null,H)=>O(ie=>x.call(re,_(ie)),null,H),V)}c.map=D;function T(O,_,V){return oe((x,re=null,H)=>O(ie=>{_(ie),x.call(re,ie)},null,H),V)}c.forEach=T;function N(O,_,V){return oe((x,re=null,H)=>O(ie=>_(ie)&&x.call(re,ie),null,H),V)}c.filter=N;function U(O){return O}c.signal=U;function $(...O){return(_,V=null,x)=>(0,k.combinedDisposable)(...O.map(re=>re(H=>_.call(V,H),null,x)))}c.any=$;function Y(O,_,V,x){let re=V;return D(O,H=>(re=_(re,H),re),x)}c.reduce=Y;function oe(O,_){let V;const x={onFirstListenerAdd(){V=O(re.fire,re)},onLastListenerRemove(){V?.dispose()}};_||u(x);const re=new C(x);return _?.add(re),re.event}function ue(O,_,V=100,x=!1,re,H){let ie,ne,ae,fe=0;const De={leakWarningThreshold:re,onFirstListenerAdd(){ie=O(ke=>{fe++,ne=_(ne,ke),x&&!ae&&(Le.fire(ne),ne=void 0),clearTimeout(ae),ae=setTimeout(()=>{const Ae=ne;ne=void 0,ae=void 0,(!x||fe>1)&&Le.fire(Ae),fe=0},V)})},onLastListenerRemove(){ie.dispose()}};H||u(De);const Le=new C(De);return H?.add(Le),Le.event}c.debounce=ue;function se(O,_=(x,re)=>x===re,V){let x=!0,re;return N(O,H=>{const ie=x||!_(H,re);return x=!1,re=H,ie},V)}c.latch=se;function he(O,_,V){return[c.filter(O,_,V),c.filter(O,x=>!_(x),V)]}c.split=he;function G(O,_=!1,V=[]){let x=V.slice(),re=O(ne=>{x?x.push(ne):ie.fire(ne)});const H=()=>{x?.forEach(ne=>ie.fire(ne)),x=null},ie=new C({onFirstListenerAdd(){re||(re=O(ne=>ie.fire(ne)))},onFirstListenerDidAdd(){x&&(_?setTimeout(H):H())},onLastListenerRemove(){re&&re.dispose(),re=null}});return ie.event}c.buffer=G;class K{constructor(_){this.event=_,this.disposables=new k.DisposableStore}map(_){return new K(D(this.event,_,this.disposables))}forEach(_){return new K(T(this.event,_,this.disposables))}filter(_){return new K(N(this.event,_,this.disposables))}reduce(_,V){return new K(Y(this.event,_,V,this.disposables))}latch(){return new K(se(this.event,void 0,this.disposables))}debounce(_,V=100,x=!1,re){return new K(ue(this.event,_,V,x,re,this.disposables))}on(_,V,x){return this.event(_,V,x)}once(_,V,x){return I(this.event)(_,V,x)}dispose(){this.disposables.dispose()}}function F(O){return new K(O)}c.chain=F;function A(O,_,V=x=>x){const x=(...ne)=>ie.fire(V(...ne)),re=()=>O.on(_,x),H=()=>O.removeListener(_,x),ie=new C({onFirstListenerAdd:re,onLastListenerRemove:H});return ie.event}c.fromNodeEventEmitter=A;function W(O,_,V=x=>x){const x=(...ne)=>ie.fire(V(...ne)),re=()=>O.addEventListener(_,x),H=()=>O.removeEventListener(_,x),ie=new C({onFirstListenerAdd:re,onLastListenerRemove:H});return ie.event}c.fromDOMEventEmitter=W;function z(O){return new Promise(_=>I(O)(_))}c.toPromise=z;function te(O,_){return _(void 0),O(V=>_(V))}c.runAndSubscribe=te;function B(O,_){let V=null;function x(H){V?.dispose(),V=new k.DisposableStore,_(H,V)}x(void 0);const re=O(H=>x(H));return(0,k.toDisposable)(()=>{re.dispose(),V?.dispose()})}c.runAndSubscribeWithStore=B;class j{constructor(_,V){this.obs=_,this._counter=0,this._hasChanged=!1;const x={onFirstListenerAdd:()=>{_.addObserver(this)},onLastListenerRemove:()=>{_.removeObserver(this)}};V||u(x),this.emitter=new C(x),V&&V.add(this.emitter)}beginUpdate(_){this._counter++}handleChange(_,V){this._hasChanged=!0}endUpdate(_){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,_){return new j(O,_).emitter.event}c.fromObservable=L})(m=e.Event||(e.Event={}));class P{constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${P._idPool++}`,P.all.add(this)}start(u){this._stopWatch=new M.StopWatch(!0),this.listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=P,P.all=new Set,P._idPool=0;let y=-1;function S(c){const u=y;return y=c,{dispose(){y=u}}}e.setGlobalLeakWarningThreshold=S;class g{constructor(u,I=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=I,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u,I){let D=y;if(typeof this.customThreshold=="number"&&(D=this.customThreshold),D<=0||I<D)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(u.value)||0;if(this._stacks.set(u.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=D*.5;let N,U=0;for(const[$,Y]of this._stacks)(!N||U<Y)&&(N=$,U=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${U}):`),console.warn(N)}return()=>{const N=this._stacks.get(u.value)||0;this._stacks.set(u.value,N-1)}}}class h{constructor(u){this.value=u}static create(){return new h(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(u,I,D){this.callback=u,this.callbackThis=I,this.stack=D,this.subscription=new k.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class C{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=y>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(E){const u=Array.from(this._listeners);queueMicrotask(()=>{for(const I of u)I.subscription.isset()&&(I.subscription.unset(),I.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(u,I,D)=>{this._listeners||(this._listeners=new R.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let N,U;this._leakageMon&&this._listeners.size>=30&&(U=h.create(),N=this._leakageMon.check(U,this._listeners.size+1)),E&&(U=U??h.create());const $=new b(u,I,U),Y=this._listeners.push($);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,I);const oe=$.subscription.set(()=>{N?.(),this._disposed||(Y(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return D instanceof k.DisposableStore?D.add(oe):Array.isArray(D)&&D.push(oe),oe}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const I of this._listeners)this._deliveryQueue.push(this,I,u);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=C;class p{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(u,I,D){this._queue.push(new d(u,I,D))}clear(u){const I=new R.LinkedList;for(const D of this._queue)D.emitter!==u&&I.push(D);this._queue=I}deliver(){for(;this._queue.size>0;){const u=this._queue.shift();try{u.listener.invoke(u.event)}catch(I){(0,w.onUnexpectedError)(I)}}}}e.EventDeliveryQueue=p;class v extends p{clear(u){this._queue.clear()}}class d{constructor(u,I,D){this.emitter=u,this.listener=I,this.event=D}}class f extends C{async fireAsync(u,I,D){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,u]);for(;this._asyncDeliveryQueue.size>0&&!I.isCancellationRequested;){const[T,N]=this._asyncDeliveryQueue.shift(),U=[],$={...N,token:I,waitUntil:Y=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");D&&(Y=D(Y,T.callback)),U.push(Y)}};try{T.invoke($)}catch(Y){(0,w.onUnexpectedError)(Y);continue}Object.freeze(U),await Promise.allSettled(U).then(Y=>{for(const oe of Y)oe.status==="rejected"&&(0,w.onUnexpectedError)(oe.reason)})}}}}e.AsyncEmitter=f;class a extends C{constructor(u){super(u),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=a;class i extends a{constructor(u){super(u),this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=i;class o extends C{constructor(u){super(u),this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){!this.hasListeners()||(this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(I=>super.fire(I)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new C({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const I={event:u,listener:null};this.events.push(I),this.hasListeners&&this.hook(I);const D=()=>{this.hasListeners&&this.unhook(I);const T=this.events.indexOf(I);this.events.splice(T,1)};return(0,k.toDisposable)((0,t.once)(D))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(I=>this.emitter.fire(I))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class r{constructor(){this.buffers=[]}wrapEvent(u){return(I,D,T)=>u(N=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>I.call(D,N)):I.call(D,N)},void 0,T)}bufferEvents(u){const I=[];this.buffers.push(I);const D=u();return this.buffers.pop(),I.forEach(T=>T()),D}}e.EventBufferer=r;class s{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=k.Disposable.None,this.emitter=new C({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(Z[22],ee([0,1,3]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(E,l){const m=setTimeout(E.bind(l),0);return{dispose(){clearTimeout(m)}}});var k;(function(E){function l(m){return m===E.None||m===E.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}E.isCancellationToken=l,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(l=!1){l&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=M}),define(Z[138],ee([0,1,22]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(E){this.task=E,this.result=null}get(){if(this.result)return this.result;const E=new w.CancellationTokenSource,l=this.task(E.token);return this.result={promise:l,dispose:()=>{this.result=null,E.cancel(),E.dispose()}},this.result}}e.Cache=t;class k{constructor(E){this.fn=E,this.lastCache=void 0,this.lastArgKey=void 0}get(E){const l=JSON.stringify(E);return this.lastArgKey!==l&&(this.lastArgKey=l,this.lastCache=this.fn(E)),this.lastCache}}e.LRUCachedFunction=k;class R{constructor(E){this.fn=E,this._map=new Map}get cachedValues(){return this._map}get(E){if(this._map.has(E))return this._map.get(E);const l=this.fn(E);return this._map.set(E,l),l}}e.CachedFunction=R}),define(Z[95],ee([0,1,3,2]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=M=>({onDidChange:w.Event.None,value:M});e.staticObservableValue=k;class R extends t.Disposable{constructor(E){super(),this._value=E,this.changeEmitter=this._register(new w.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(E){E!==this._value&&(this._value=E,this.changeEmitter.fire(E))}}e.MutableObservableValue=R}),define(Z[25],ee([0,1,138,124]),function(q,e,w,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=R;const M=/{(\d+)}/g;function E(Q,...le){return le.length===0?Q:Q.replace(M,function(pe,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=le.length?pe:le[Se]})}e.format=E;const l=/{([^}]+)}/g;function m(Q,le){return Q.replace(l,(pe,me)=>le[me]??pe)}e.format2=m;function P(Q){return Q.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=P;function y(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function S(Q,le){let pe=0;const me=le.charCodeAt(0);for(let Se=Q.length-1;Se>=0;Se--)Q.charCodeAt(Se)===me&&pe++;return pe}e.count=S;function g(Q,le,pe="\u2026"){return Q.length<=le?Q:`${Q.substr(0,le)}${pe}`}e.truncate=g;function h(Q,le=" "){const pe=b(Q,le);return C(pe,le)}e.trim=h;function b(Q,le){if(!Q||!le)return Q;const pe=le.length;if(pe===0||Q.length===0)return Q;let me=0;for(;Q.indexOf(le,me)===me;)me=me+pe;return Q.substring(me)}e.ltrim=b;function C(Q,le){if(!Q||!le)return Q;const pe=le.length,me=Q.length;if(pe===0||me===0)return Q;let Se=me,Re=-1;for(;Re=Q.lastIndexOf(le,Se-1),!(Re===-1||Re+pe!==Se);){if(Re===0)return"";Se=Re}return Q.substring(0,Se)}e.rtrim=C;function p(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function v(Q){return Q.replace(/\*/g,"")}e.stripWildcards=v;function d(Q,le,pe={}){if(!Q)throw new Error("Cannot create regex from empty string");le||(Q=y(Q)),pe.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let me="";return pe.global&&(me+="g"),pe.matchCase||(me+="i"),pe.multiline&&(me+="m"),pe.unicode&&(me+="u"),new RegExp(Q,me)}e.createRegExp=d;function f(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function a(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=a;function i(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=i;function o(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=o;function n(Q){for(let le=0,pe=Q.length;le<pe;le++){const me=Q.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=n;function r(Q,le=0,pe=Q.length){for(let me=le;me<pe;me++){const Se=Q.charCodeAt(me);if(Se!==32&&Se!==9)return Q.substring(le,me)}return Q.substring(le,pe)}e.getLeadingWhitespace=r;function s(Q,le=Q.length-1){for(let pe=le;pe>=0;pe--){const me=Q.charCodeAt(pe);if(me!==32&&me!==9)return pe}return-1}e.lastNonWhitespaceIndex=s;function c(Q,le,pe){const me=[];let Se=0;for(const Re of Q.matchAll(le)){if(me.push(Q.slice(Se,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Se=Re.index+Re[0].length,me.push(pe(Re[0],...Re.slice(1),Re.index,Q,Re.groups))}return me.push(Q.slice(Se)),Promise.all(me).then(Re=>Re.join(""))}e.replaceAsync=c;function u(Q,le){return Q<le?-1:Q>le?1:0}e.compare=u;function I(Q,le,pe=0,me=Q.length,Se=0,Re=le.length){for(;pe<me&&Se<Re;pe++,Se++){const et=Q.charCodeAt(pe),He=le.charCodeAt(Se);if(et<He)return-1;if(et>He)return 1}const Fe=me-pe,Ve=Re-Se;return Fe<Ve?-1:Fe>Ve?1:0}e.compareSubstring=I;function D(Q,le){return T(Q,le,0,Q.length,0,le.length)}e.compareIgnoreCase=D;function T(Q,le,pe=0,me=Q.length,Se=0,Re=le.length){for(;pe<me&&Se<Re;pe++,Se++){let et=Q.charCodeAt(pe),He=le.charCodeAt(Se);if(et===He)continue;if(et>=128||He>=128)return I(Q.toLowerCase(),le.toLowerCase(),pe,me,Se,Re);U(et)&&(et-=32),U(He)&&(He-=32);const Xe=et-He;if(Xe!==0)return Xe}const Fe=me-pe,Ve=Re-Se;return Fe<Ve?-1:Fe>Ve?1:0}e.compareSubstringIgnoreCase=T;function N(Q){return Q>=48&&Q<=57}e.isAsciiDigit=N;function U(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=U;function $(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=$;function Y(Q,le){return Q.length===le.length&&T(Q,le)===0}e.equalsIgnoreCase=Y;function oe(Q,le){const pe=le.length;return le.length>Q.length?!1:T(Q,le,0,pe)===0}e.startsWithIgnoreCase=oe;function ue(Q,le){const pe=Math.min(Q.length,le.length);let me;for(me=0;me<pe;me++)if(Q.charCodeAt(me)!==le.charCodeAt(me))return me;return pe}e.commonPrefixLength=ue;function se(Q,le){const pe=Math.min(Q.length,le.length);let me;const Se=Q.length-1,Re=le.length-1;for(me=0;me<pe;me++)if(Q.charCodeAt(Se-me)!==le.charCodeAt(Re-me))return me;return pe}e.commonSuffixLength=se;function he(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=he;function G(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=G;function K(Q,le){return(Q-55296<<10)+(le-56320)+65536}e.computeCodePoint=K;function F(Q,le,pe){const me=Q.charCodeAt(pe);if(he(me)&&pe+1<le){const Se=Q.charCodeAt(pe+1);if(G(Se))return K(me,Se)}return me}e.getNextCodePoint=F;function A(Q,le){const pe=Q.charCodeAt(le-1);if(G(pe)&&le>1){const me=Q.charCodeAt(le-2);if(he(me))return K(me,pe)}return pe}class W{constructor(le,pe=0){this._str=le,this._len=le.length,this._offset=pe}get offset(){return this._offset}setOffset(le){this._offset=le}prevCodePoint(){const le=A(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=F(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class z{constructor(le,pe=0){this._iterator=new W(le,pe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const le=Ee.getInstance(),pe=this._iterator,me=pe.offset;let Se=le.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Re=pe.offset,Fe=le.getGraphemeBreakType(pe.nextCodePoint());if(de(Se,Fe)){pe.setOffset(Re);break}Se=Fe}return pe.offset-me}prevGraphemeLength(){const le=Ee.getInstance(),pe=this._iterator,me=pe.offset;let Se=le.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Re=pe.offset,Fe=le.getGraphemeBreakType(pe.prevCodePoint());if(de(Fe,Se)){pe.setOffset(Re);break}Se=Fe}return me-pe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=z;function te(Q,le){return new z(Q,le).nextGraphemeLength()}e.nextCharLength=te;function B(Q,le){return new z(Q,le).prevGraphemeLength()}e.prevCharLength=B;function j(Q,le){le>0&&G(Q.charCodeAt(le))&&le--;const pe=le+te(Q,le);return[pe-B(Q,pe),pe]}e.getCharContainingOffset=j;let L;function O(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(Q){return L||(L=O()),L.test(Q)}e.containsRTL=_;const V=/^[\t\n\r\x20-\x7E]*$/;function x(Q){return V.test(Q)}e.isBasicASCII=x,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function re(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=re;function H(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=H;function ie(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=ie;function ne(Q,le){if(Q.length<le)return Q;const pe=/\b/g;let me=0;for(;pe.test(Q)&&!(Q.length-pe.lastIndex<le);)me=pe.lastIndex,pe.lastIndex+=1;return Q.substring(me).replace(/^\s/,"")}e.lcut=ne;const ae=/\x1B\x5B[12]?K/g,fe=/\x1b\[\d+m/g,De=/\x1b\[0?m/g;function Le(Q){return Q&&(Q=Q.replace(ae,""),Q=Q.replace(fe,""),Q=Q.replace(De,"")),Q}e.removeAnsiEscapeCodes=Le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Ae(Q){return ke(Q)?Q.substr(1):Q}e.stripUTF8BOM=Ae;function je(Q,le){if(!Q||!le||Q.length<le.length)return!1;const pe=le.length,me=Q.toLowerCase();let Se=0,Re=-1;for(;Se<pe;){const Fe=me.indexOf(le[Se],Re+1);if(Fe<0)return!1;Re=Fe,Se++}return!0}e.fuzzyContains=je;function ge(Q,le=!1){return Q?(le&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=ge;function we(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=we;function Ce(Q,le=1){if(le===0)return"";let pe=-1;do pe=Q.indexOf(`
`,pe+1),le--;while(le>0&&pe>=0);return pe===-1?Q:(Q[pe-1]==="\r"&&pe--,Q.substr(0,pe))}e.getNLines=Ce;function X(Q){return Q=Q%(2*26),Q<26?String.fromCharCode(97+Q):String.fromCharCode(65+Q-26)}e.singleLetterHash=X;function ce(Q){return Ee.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=ce;function de(Q,le){return Q===0?le!==5&&le!==7:Q===2&&le===3?!1:Q===4||Q===2||Q===3||le===4||le===2||le===3?!0:!(Q===8&&(le===8||le===9||le===11||le===12)||(Q===11||Q===9)&&(le===9||le===10)||(Q===12||Q===10)&&le===10||le===5||le===13||le===7||Q===1||Q===13&&le===14||Q===6&&le===6)}var ye;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(ye=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ee{constructor(){this._data=We()}static getInstance(){return Ee._INSTANCE||(Ee._INSTANCE=new Ee),Ee._INSTANCE}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const pe=this._data,me=pe.length/3;let Se=1;for(;Se<=me;)if(le<pe[3*Se])Se=2*Se;else if(le>pe[3*Se+1])Se=2*Se+1;else return pe[3*Se+2];return 0}}Ee._INSTANCE=null;function We(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(Q,le){if(Q===0)return 0;const pe=Ne(Q,le);if(pe!==void 0)return pe;const me=new W(le,Q);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Te;function Ne(Q,le){const pe=new W(le,Q);let me=pe.prevCodePoint();for(;Be(me)||me===65039||me===8419;){if(pe.offset===0)return;me=pe.prevCodePoint()}if(!ie(me))return;let Se=pe.offset;return Se>0&&pe.prevCodePoint()===8205&&(Se=pe.offset),Se}function Be(Q){return 127995<=Q&&Q<=127999}var ze;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class Ue{constructor(le){this.confusableDictionary=le}static getInstance(le){return Ue.cache.get(Array.from(le))}static getLocales(){return Ue._locales.getValue()}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ue,k=Ue,Ue.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ue.cache=new w.LRUCachedFunction(Q=>{function le(He){const Xe=new Map;for(let it=0;it<He.length;it+=2)Xe.set(He[it],He[it+1]);return Xe}function pe(He,Xe){const it=new Map(He);for(const[at,dt]of Xe)it.set(at,dt);return it}function me(He,Xe){if(!He)return Xe;const it=new Map;for(const[at,dt]of He)Xe.has(at)&&it.set(at,dt);return it}const Se=k.ambiguousCharacterData.getValue();let Re=Q.filter(He=>!He.startsWith("_")&&He in Se);Re.length===0&&(Re=["_default"]);let Fe;for(const He of Re){const Xe=le(Se[He]);Fe=me(Fe,Xe)}const Ve=le(Se._common),et=pe(Ve,Fe);return new Ue(et)}),Ue._locales=new t.Lazy(()=>Object.keys(Ue.ambiguousCharacterData.getValue()).filter(Q=>!Q.startsWith("_")));class qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(qe.getRawData())),this._data}static isInvisibleCharacter(le){return qe.getData().has(le)}static get codePoints(){return qe.getData()}}e.InvisibleCharacters=qe,qe._data=void 0}),define(Z[30],ee([0,1,9,4,25,12]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(s){return s===47||s===92}e.isPathSeparator=M;function E(s){return s.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=E;function l(s){return s.indexOf("/")===-1&&(s=E(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=l;function m(s,c=w.posix.sep){if(!s)return"";const u=s.length,I=s.charCodeAt(0);if(M(I)){if(M(s.charCodeAt(1))&&!M(s.charCodeAt(2))){let T=3;const N=T;for(;T<u&&!M(s.charCodeAt(T));T++);if(N!==T&&!M(s.charCodeAt(T+1))){for(T+=1;T<u;T++)if(M(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,c)}}return c}else if(p(I)&&s.charCodeAt(1)===58)return M(s.charCodeAt(2))?s.slice(0,2)+c:s.slice(0,2);let D=s.indexOf("://");if(D!==-1){for(D+=3;D<u;D++)if(M(s.charCodeAt(D)))return s.slice(0,D+1)}return""}e.getRoot=m;function P(s){if(!t.isWindows||!s||s.length<5)return!1;let c=s.charCodeAt(0);if(c!==92||(c=s.charCodeAt(1),c!==92))return!1;let u=2;const I=u;for(;u<s.length&&(c=s.charCodeAt(u),c!==92);u++);return!(I===u||(c=s.charCodeAt(u+1),isNaN(c)||c===92))}e.isUNC=P;const y=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(s,c=t.isWindows){const u=c?y:S;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||c&&g.test(s)||s==="."||s===".."||c&&s[s.length-1]==="."||c&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=h;function b(s,c,u){const I=s===c;return!u||I?I:!s||!c?!1:(0,k.equalsIgnoreCase)(s,c)}e.isEqual=b;function C(s,c,u,I=w.sep){if(s===c)return!0;if(!s||!c||c.length>s.length)return!1;if(u){if(!(0,k.startsWithIgnoreCase)(s,c))return!1;if(c.length===s.length)return!0;let T=c.length;return c.charAt(c.length-1)===I&&T--,s.charAt(T)===I}return c.charAt(c.length-1)!==I&&(c+=I),s.indexOf(c)===0}e.isEqualOrParent=C;function p(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=p;function v(s,c){return t.isWindows&&s.endsWith(":")&&(s+=w.sep),(0,w.isAbsolute)(s)||(s=(0,w.join)(c,s)),s=(0,w.normalize)(s),t.isWindows?(s=(0,k.rtrim)(s,w.sep),s.endsWith(":")&&(s+=w.sep)):(s=(0,k.rtrim)(s,w.sep),s||(s=w.sep)),s}e.sanitizeFilePath=v;function d(s){const c=(0,w.normalize)(s);return t.isWindows?s.length>3?!1:f(c)&&(s.length===2||c.charCodeAt(2)===92):c===w.posix.sep}e.isRootOrDriveLetter=d;function f(s,c=t.isWindows){return c?p(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function a(s){return f(s)?s[0]:void 0}e.getDriveLetter=a;function i(s,c,u){return c.length>s.length?-1:s===c?0:(u&&(s=s.toLowerCase(),c=c.toLowerCase()),s.indexOf(c))}e.indexOfPath=i;function o(s){const c=s.split(":");let u,I,D;for(const T of c){const N=Number(T);(0,R.isNumber)(N)?I===void 0?I=N:D===void 0&&(D=N):u=u?[u,T].join(":"):T}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:I!==void 0?I:void 0,column:D!==void 0?D:I!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(s,c,u=8){let I="";for(let T=0;T<u;T++)I+=n.charAt(Math.floor(Math.random()*n.length));let D;return c?D=`${c}-${I}`:D=I,s?(0,w.join)(s,D):D}e.randomPath=r}),define(Z[66],ee([0,1,25]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(p){return k(p,0)}e.hash=t;function k(p,v){switch(typeof p){case"object":return p===null?R(349,v):Array.isArray(p)?l(p,v):m(p,v);case"string":return E(p,v);case"boolean":return M(p,v);case"number":return R(p,v);case"undefined":return R(937,v);default:return R(617,v)}}e.doHash=k;function R(p,v){return(v<<5)-v+p|0}e.numberHash=R;function M(p,v){return R(p?433:863,v)}function E(p,v){v=R(149417,v);for(let d=0,f=p.length;d<f;d++)v=R(p.charCodeAt(d),v);return v}e.stringHash=E;function l(p,v){return v=R(104579,v),p.reduce((d,f)=>k(f,d),v)}function m(p,v){return v=R(181387,v),Object.keys(p).sort().reduce((d,f)=>(d=E(f,d),k(p[f],d)),v)}class P{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=k(v,this._value),this._value}}e.Hasher=P;var y;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function S(p,v,d=32){const f=d-v,a=~((1<<f)-1);return(p<<v|(a&p)>>>f)>>>0}function g(p,v=0,d=p.byteLength,f=0){for(let a=0;a<d;a++)p[v+a]=f}function h(p,v,d="0"){for(;p.length<v;)p=d+p;return p}function b(p,v=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(d=>d.toString(16).padStart(2,"0")).join(""):h((p>>>0).toString(16),v/4)}e.toHexString=b;class C{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const d=v.length;if(d===0)return;const f=this._buff;let a=this._buffLen,i=this._leftoverHighSurrogate,o,n;for(i!==0?(o=i,n=-1,i=0):(o=v.charCodeAt(0),n=0);;){let r=o;if(w.isHighSurrogate(o))if(n+1<d){const s=v.charCodeAt(n+1);w.isLowSurrogate(s)?(n++,r=w.computeCodePoint(o,s)):r=65533}else{i=o;break}else w.isLowSurrogate(o)&&(r=65533);if(a=this._push(f,a,r),n++,n<d)o=v.charCodeAt(n);else break}this._buffLen=a,this._leftoverHighSurrogate=i}_push(v,d,f){return f<128?v[d++]=f:f<2048?(v[d++]=192|(f&1984)>>>6,v[d++]=128|(f&63)>>>0):f<65536?(v[d++]=224|(f&61440)>>>12,v[d++]=128|(f&4032)>>>6,v[d++]=128|(f&63)>>>0):(v[d++]=240|(f&1835008)>>>18,v[d++]=128|(f&258048)>>>12,v[d++]=128|(f&4032)>>>6,v[d++]=128|(f&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=C._bigBlock32,d=this._buffDV;for(let u=0;u<64;u+=4)v.setUint32(u,d.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)v.setUint32(u,S(v.getUint32(u-12,!1)^v.getUint32(u-32,!1)^v.getUint32(u-56,!1)^v.getUint32(u-64,!1),1),!1);let f=this._h0,a=this._h1,i=this._h2,o=this._h3,n=this._h4,r,s,c;for(let u=0;u<80;u++)u<20?(r=a&i|~a&o,s=1518500249):u<40?(r=a^i^o,s=1859775393):u<60?(r=a&i|a&o|i&o,s=2400959708):(r=a^i^o,s=3395469782),c=S(f,5)+r+n+s+v.getUint32(u*4,!1)&4294967295,n=o,o=i,i=S(a,30),a=f,f=c;this._h0=this._h0+f&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=C,C._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[31],ee([0,1,24,25]),function(q,e,w,t){"use strict";var k,R,M;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(n,r,s){let c=n.get(r);return c===void 0&&(c=s,n.set(r,c)),c}e.getOrSet=E;function l(n){const r=[];return n.forEach((s,c)=>{r.push(`${c} => ${s}`)}),`Map(${n.size}) {${r.join(", ")}}`}e.mapToString=l;function m(n){const r=[];return n.forEach(s=>{r.push(s)}),`Set(${n.size}) {${r.join(", ")}}`}e.setToString=m;class P{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),c=this._value.charCodeAt(this._pos);return s-c}value(){return this._value[this._pos]}}e.StringIterator=P;class y{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class S{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let s=r.length-1;s>=0;s--,this._valueLen--){const c=this._value.charCodeAt(s);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var g;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(g||(g={}));class h{constructor(r,s){this._ignorePathCasing=r,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,t.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(C||(C={}));class p{constructor(r){this._iter=r}static forUris(r=()=>!1,s=()=>!1){return new p(new h(r,s))}static forPaths(r=!1){return new p(new S(void 0,!r))}static forStrings(){return new p(new P)}static forConfigKeys(){return new p(new y)}clear(){this._root=void 0}fill(r,s){if(s){const c=s.slice(0);(0,w.shuffle)(c);for(const u of c)this.set(u,r)}else{const c=r.slice(0);(0,w.shuffle)(c);for(const u of c)this.set(u[0],u[1])}}set(r,s){const c=this._iter.reset(r);let u;this._root||(this._root=new b,this._root.segment=c.value());const I=[];for(u=this._root;;){const T=c.cmp(u.segment);if(T>0)u.left||(u.left=new b,u.left.segment=c.value()),I.push([-1,u]),u=u.left;else if(T<0)u.right||(u.right=new b,u.right.segment=c.value()),I.push([1,u]),u=u.right;else if(c.hasNext())c.next(),u.mid||(u.mid=new b,u.mid.segment=c.value()),I.push([0,u]),u=u.mid;else break}const D=u.value;u.value=s,u.key=r;for(let T=I.length-1;T>=0;T--){const N=I[T][1];N.updateHeight();const U=N.balanceFactor();if(U<-1||U>1){const $=I[T][0],Y=I[T+1][0];if($===1&&Y===1)I[T][1]=N.rotateLeft();else if($===-1&&Y===-1)I[T][1]=N.rotateRight();else if($===1&&Y===-1)N.right=I[T+1][1]=I[T+1][1].rotateRight(),I[T][1]=N.rotateLeft();else if($===-1&&Y===1)N.left=I[T+1][1]=I[T+1][1].rotateLeft(),I[T][1]=N.rotateRight();else throw new Error;if(T>0)switch(I[T-1][0]){case-1:I[T-1][1].left=I[T][1];break;case 1:I[T-1][1].right=I[T][1];break;case 0:I[T-1][1].mid=I[T][1];break}else this._root=I[0][1]}}return D}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let c=this._root;for(;c;){const u=s.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else break}return c}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const c=this._iter.reset(r),u=[];let I=this._root;for(;I;){const D=c.cmp(I.segment);if(D>0)u.push([-1,I]),I=I.left;else if(D<0)u.push([1,I]),I=I.right;else if(c.hasNext())c.next(),u.push([0,I]),I=I.mid;else break}if(!!I){if(s?(I.left=void 0,I.mid=void 0,I.right=void 0,I.height=1):(I.key=void 0,I.value=void 0),!I.mid&&!I.value)if(I.left&&I.right){const D=this._min(I.right),{key:T,value:N,segment:U}=D;this._delete(D.key,!1),I.key=T,I.value=N,I.segment=U}else{const D=I.left??I.right;if(u.length>0){const[T,N]=u[u.length-1];switch(T){case-1:N.left=D;break;case 0:N.mid=D;break;case 1:N.right=D;break}}else this._root=D}for(let D=u.length-1;D>=0;D--){const T=u[D][1];T.updateHeight();const N=T.balanceFactor();if(N>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),u[D][1]=T.rotateLeft()):N<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),u[D][1]=T.rotateRight()),D>0)switch(u[D-1][0]){case-1:u[D-1][1].left=u[D][1];break;case 1:u[D-1][1].right=u[D][1];break;case 0:u[D-1][1].mid=u[D][1];break}else this._root=u[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const s=this._iter.reset(r);let c=this._root,u;for(;c;){const I=s.cmp(c.segment);if(I>0)c=c.left;else if(I<0)c=c.right;else if(s.hasNext())s.next(),u=c.value||u,c=c.mid;else break}return c&&c.value||u}findSuperstr(r){const s=this._iter.reset(r);let c=this._root;for(;c;){const u=s.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(r){for(const[s,c]of this)r(c,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const s=[];return this._dfsEntries(r,s),s[Symbol.iterator]()}_dfsEntries(r,s){!r||(r.left&&this._dfsEntries(r.left,s),r.value&&s.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,s),r.right&&this._dfsEntries(r.right,s))}_isBalanced(){const r=s=>{if(!s)return!0;const c=s.balanceFactor();return c<-1||c>1?!1:r(s.left)&&r(s.right)};return r(this._root)}}e.TernarySearchTree=p;class v{constructor(r,s){this.uri=r,this.value=s}}class d{constructor(r,s){this[k]="ResourceMap",r instanceof d?(this.map=new Map(r.map),this.toKey=s??d.defaultToKey):(this.map=new Map,this.toKey=r??d.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),new v(r,s)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[c,u]of this.map)r(u.value,u.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=d,d.defaultToKey=n=>n.toString();class f{constructor(r,s){this[R]="ResourceSet",!r||typeof r=="function"?this._map=new d(r):(this._map=new d(s),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,s){this._map.forEach((c,u)=>r.call(s,u,u,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=f;var a;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class i{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const c=this._map.get(r);if(!!c)return s!==0&&this.touch(c,s),c.value}set(r,s,c=0){let u=this._map.get(r);if(u)u.value=s,c!==0&&this.touch(u,c);else{switch(u={key:r,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const c=this._state;let u=this._head;for(;u;){if(s?r.bind(s)(u.value,u.key,this):r(u.value,u.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,s=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const I={value:c.key,done:!1};return c=c.next,I}else return{value:void 0,done:!0}}};return u}values(){const r=this,s=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const I={value:c.value,done:!1};return c=c.next,I}else return{value:void 0,done:!0}}};return u}entries(){const r=this,s=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const I={value:[c.key,c.value],done:!1};return c=c.next,I}else return{value:void 0,done:!0}}};return u}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>r;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,c=r.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const c=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(c.previous=u,u.next=c),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const c=r.next,u=r.previous;r===this._head?(c.previous=void 0,this._head=c):(c.previous=u,u.next=c),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,c)=>{r.push([c,s])}),r}fromJSON(r){this.clear();for(const[s,c]of r)this.set(s,c)}}e.LinkedMap=i;class o extends i{constructor(r,s=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(Z[80],ee([0,1,31]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new w.LRUCache(1e4);function k(m){return l(m,"NFC",t)}e.normalizeNFC=k;const R=new w.LRUCache(1e4);function M(m){return l(m,"NFD",R)}e.normalizeNFD=M;const E=/[^\u0000-\u0080]/;function l(m,P,y){if(!m)return m;const S=y.get(m);if(S)return S;let g;return E.test(m)?g=m.normalize(P):g=m,y.set(m,g),g}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(P){return M(P).replace(m,"")}}()}),define(Z[96],ee([0,1,25]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",M="warning",E="warn",l="info",m="ignore";function P(S){return S?w.equalsIgnoreCase(R,S)?k.Error:w.equalsIgnoreCase(M,S)||w.equalsIgnoreCase(E,S)?k.Warning:w.equalsIgnoreCase(l,S)?k.Info:k.Ignore:k.Ignore}k.fromValue=P;function y(S){switch(S){case k.Error:return R;case k.Warning:return M;case k.Info:return l;default:return m}}k.toString=y}(t||(t={})),e.default=t}),define(Z[7],ee([0,1,9,4]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function E(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!k.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(n,r){return!n&&!r?"file":n}function m(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==y&&(r=y+r):r=y;break}return r}const P="",y="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(r,s,c,u,I,D=!1){typeof r=="object"?(this.scheme=r.scheme||P,this.authority=r.authority||P,this.path=r.path||P,this.query=r.query||P,this.fragment=r.fragment||P):(this.scheme=l(r,D),this.authority=s||P,this.path=m(this.scheme,c||P),this.query=u||P,this.fragment=I||P,E(this,D))}static isUri(r){return r instanceof g?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return d(this,!1)}with(r){if(!r)return this;let{scheme:s,authority:c,path:u,query:I,fragment:D}=r;return s===void 0?s=this.scheme:s===null&&(s=P),c===void 0?c=this.authority:c===null&&(c=P),u===void 0?u=this.path:u===null&&(u=P),I===void 0?I=this.query:I===null&&(I=P),D===void 0?D=this.fragment:D===null&&(D=P),s===this.scheme&&c===this.authority&&u===this.path&&I===this.query&&D===this.fragment?this:new b(s,c,u,I,D)}static parse(r,s=!1){const c=S.exec(r);return c?new b(c[2]||P,o(c[4]||P),o(c[5]||P),o(c[7]||P),o(c[9]||P),s):new b(P,P,P,P,P)}static file(r){let s=P;if(t.isWindows&&(r=r.replace(/\\/g,y)),r[0]===y&&r[1]===y){const c=r.indexOf(y,2);c===-1?(s=r.substring(2),r=y):(s=r.substring(2,c),r=r.substring(c)||y)}return new b("file",s,r,P,P)}static from(r){const s=new b(r.scheme,r.authority,r.path,r.query,r.fragment);return E(s,!0),s}static joinPath(r,...s){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&r.scheme==="file"?c=g.file(w.win32.join(d(r,!0),...s)).path:c=w.posix.join(r.path,...s),r.with({path:c})}toString(r=!1){return f(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof g)return r;{const s=new b(r);return s._formatted=r.external,s._fsPath=r._sep===h?r.fsPath:null,s}}else return r}}e.URI=g;const h=t.isWindows?1:void 0;class b extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(r=!1){return r?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=h),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(n,r){let s,c=-1;for(let u=0;u<n.length;u++){const I=n.charCodeAt(u);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||r&&I===47)c!==-1&&(s+=encodeURIComponent(n.substring(c,u)),c=-1),s!==void 0&&(s+=n.charAt(u));else{s===void 0&&(s=n.substr(0,u));const D=C[I];D!==void 0?(c!==-1&&(s+=encodeURIComponent(n.substring(c,u)),c=-1),s+=D):c===-1&&(c=u)}}return c!==-1&&(s+=encodeURIComponent(n.substring(c))),s!==void 0?s:n}function v(n){let r;for(let s=0;s<n.length;s++){const c=n.charCodeAt(s);c===35||c===63?(r===void 0&&(r=n.substr(0,s)),r+=C[c]):r!==void 0&&(r+=n[s])}return r!==void 0?r:n}function d(n,r){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=d;function f(n,r){const s=r?v:p;let c="",{scheme:u,authority:I,path:D,query:T,fragment:N}=n;if(u&&(c+=u,c+=":"),(I||u==="file")&&(c+=y,c+=y),I){let U=I.indexOf("@");if(U!==-1){const $=I.substr(0,U);I=I.substr(U+1),U=$.indexOf(":"),U===-1?c+=s($,!1):(c+=s($.substr(0,U),!1),c+=":",c+=s($.substr(U+1),!1)),c+="@"}I=I.toLowerCase(),U=I.indexOf(":"),U===-1?c+=s(I,!1):(c+=s(I.substr(0,U),!1),c+=I.substr(U))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const U=D.charCodeAt(1);U>=65&&U<=90&&(D=`/${String.fromCharCode(U+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const U=D.charCodeAt(0);U>=65&&U<=90&&(D=`${String.fromCharCode(U+32)}:${D.substr(2)}`)}c+=s(D,!0)}return T&&(c+="?",c+=s(T,!1)),N&&(c+="#",c+=r?N:p(N,!1)),c}function a(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+a(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(i)?n.replace(i,r=>a(r)):n}}),define(Z[139],ee([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(m){const P=m;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=t;function k(m){const P=[];let y;try{const S=JSON.parse(m.arguments),g=S[S.length-1];g&&g.__$stack&&(S.pop(),y=g.__$stack),P.push(...S)}catch{P.push("Unable to log remote console arguments",m.arguments)}return{args:P,stack:y}}e.parse=k;function R(m){if(typeof m!="string")return R(k(m).stack);const P=m;if(P){const y=M(P),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(S&&S.length===4)return{uri:w.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=R;function M(m){if(!m)return m;const P=m.indexOf(`
`);return P===-1?m:m.substring(0,P)}function E(m,P){const{args:y,stack:S}=k(m),g=typeof y[0]=="string"&&y.length===1;let h=M(S);h&&(h=`(${h.trim()})`);let b=[];if(typeof y[0]=="string"?h&&g?b=[`%c[${P}] %c${y[0]} %c${h}`,l("blue"),l(""),l("grey")]:b=[`%c[${P}] %c${y[0]}`,l("blue"),l(""),...y.slice(1)]:b=[`%c[${P}]%`,l("blue"),...y],h&&!g&&b.push(h),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,b)}e.log=E;function l(m){return`color: ${m}`}}),define(Z[67],ee([0,1,18,25,7]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(m){return JSON.stringify(m,E)}e.stringify=R;function M(m){let P=JSON.parse(m);return P=l(P),P}e.parse=M;function E(m,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,t.regExpFlags)(P)}:P}function l(m,P=0){if(!m||P>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return k.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 14:return new Date(m.source)}if(m instanceof w.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let y=0;y<m.length;++y)m[y]=l(m[y],P+1);else for(const y in m)Object.hasOwnProperty.call(m,y)&&(m[y]=l(m[y],P+1))}return m}e.revive=l}),define(Z[13],ee([0,1,4,7]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebook="vscode-notebook",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractive="vscode-interactive",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}setServerRootPath(m){this._remoteResourcesPath=`${m}/${k.vscodeRemoteResource}`}set(m,P,y){this._hosts[m]=P,this._ports[m]=y}setConnectionToken(m,P){this._connectionTokens[m]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(m){if(this._delegate)return this._delegate(m);const P=m.authority;let y=this._hosts[P];y&&y.indexOf(":")!==-1&&(y=`[${y}]`);const S=this._ports[P],g=this._connectionTokens[P];let h=`path=${encodeURIComponent(m.path)}`;return typeof g=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),t.URI.from({scheme:w.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${y}:${S}`,path:this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new R;class M{asBrowserUri(m,P){const y=this.toUri(m,P);return y.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===k.file&&(w.isNative||w.isWebWorker&&w.globals.origin===`${k.vscodeFileResource}://${M.FALLBACK_AUTHORITY}`)?y.with({scheme:k.vscodeFileResource,authority:y.authority||M.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(m,P){const y=this.toUri(m,P);return y.scheme===k.vscodeFileResource?y.with({scheme:k.file,authority:y.authority!==M.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(m,P){return t.URI.isUri(m)?m:t.URI.parse(P.toUrl(m))}}M.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new M;var E;(function(l){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(m.get("3"));const P="vscode-coi";function y(g){let h;typeof g=="string"?h=new URL(g).searchParams:g instanceof URL?h=g.searchParams:t.URI.isUri(g)&&(h=new URL(g.toString(!0)).searchParams);const b=h?.get(P);if(!!b)return m.get(b)}l.getHeadersFromQuery=y;function S(g,h,b){if(!globalThis.crossOriginIsolated)return;const C=h&&b?"3":b?"2":"1";g instanceof URLSearchParams?g.set(P,C):g[P]=C}l.addSearchParam=S})(E=e.COI||(e.COI={}))}),define(Z[16],ee([0,1,30,13,9,4,25,7]),function(q,e,w,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function l(g){return(0,E.uriToFsPath)(g,!0)}e.originalFSPath=l;class m{constructor(h){this._ignorePathCasing=h}compare(h,b,C=!1){return h===b?0:(0,M.compare)(this.getComparisonKey(h,C),this.getComparisonKey(b,C))}isEqual(h,b,C=!1){return h===b?!0:!h||!b?!1:this.getComparisonKey(h,C)===this.getComparisonKey(b,C)}getComparisonKey(h,b=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,b,C=!1){if(h.scheme===b.scheme){if(h.scheme===t.Schemas.file)return w.isEqualOrParent(l(h),l(b),this._ignorePathCasing(h))&&h.query===b.query&&(C||h.fragment===b.fragment);if((0,e.isEqualAuthority)(h.authority,b.authority))return w.isEqualOrParent(h.path,b.path,this._ignorePathCasing(h),"/")&&h.query===b.query&&(C||h.fragment===b.fragment)}return!1}joinPath(h,...b){return E.URI.joinPath(h,...b)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return k.posix.basename(h.path)}extname(h){return k.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let b;return h.scheme===t.Schemas.file?b=E.URI.file(k.dirname(l(h))).path:(b=k.posix.dirname(h.path),h.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),b="/")),h.with({path:b})}normalizePath(h){if(!h.path.length)return h;let b;return h.scheme===t.Schemas.file?b=E.URI.file(k.normalize(l(h))).path:b=k.posix.normalize(h.path),h.with({path:b})}relativePath(h,b){if(h.scheme!==b.scheme||!(0,e.isEqualAuthority)(h.authority,b.authority))return;if(h.scheme===t.Schemas.file){const v=k.relative(l(h),l(b));return R.isWindows?w.toSlashes(v):v}let C=h.path||"/";const p=b.path||"/";if(this._ignorePathCasing(h)){let v=0;for(const d=Math.min(C.length,p.length);v<d&&!(C.charCodeAt(v)!==p.charCodeAt(v)&&C.charAt(v).toLowerCase()!==p.charAt(v).toLowerCase());v++);C=p.substr(0,v)+C.substr(v)}return k.posix.relative(C,p)}resolvePath(h,b){if(h.scheme===t.Schemas.file){const C=E.URI.file(k.resolve(l(h),b));return h.with({authority:C.authority,path:C.path})}return b=w.toPosixPath(b),h.with({path:k.posix.resolve(h.path,b)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,b){return h===b||h!==void 0&&b!==void 0&&(0,M.equalsIgnoreCase)(h,b)}hasTrailingPathSeparator(h,b=k.sep){if(h.scheme===t.Schemas.file){const C=l(h);return C.length>w.getRoot(C).length&&C[C.length-1]===b}else{const C=h.path;return C.length>1&&C.charCodeAt(C.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,b=k.sep){return(0,e.hasTrailingPathSeparator)(h,b)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,b=k.sep){let C=!1;if(h.scheme===t.Schemas.file){const p=l(h);C=p!==void 0&&p.length===w.getRoot(p).length&&p[p.length-1]===b}else{b="/";const p=h.path;C=p.length===1&&p.charCodeAt(p.length-1)===47}return!C&&!(0,e.hasTrailingPathSeparator)(h,b)?h.with({path:h.path+"/"}):h}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(g=>g.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new m(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(g,h){const b=[];for(let C=0;C<g.length;C++){const p=h(g[C]);g.some((v,d)=>d===C?!1:(0,e.isEqualOrParent)(p,h(v)))||b.push(g[C])}return b}e.distinctParents=P;var y;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function h(b){const C=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(d=>{const[f,a]=d.split(":");f&&a&&C.set(f,a)});const v=b.path.substring(0,b.path.indexOf(";"));return v&&C.set(g.META_DATA_MIME,v),C}g.parseMetaData=h})(y=e.DataUri||(e.DataUri={}));function S(g,h,b){if(h){let C=g.path;return C&&C[0]!==k.posix.sep&&(C=k.posix.sep+C),g.with({scheme:b,authority:h,path:C})}return g.with({scheme:b})}e.toLocalResource=S}),define(Z[8],ee([0,1,22,17,3,2,16,4]),function(q,e,w,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function l(j){return!!j&&typeof j.then=="function"}e.isThenable=l;function m(j){const L=new w.CancellationTokenSource,O=j(L.token),_=new Promise((V,x)=>{const re=L.token.onCancellationRequested(()=>{re.dispose(),L.dispose(),x(new t.CancellationError)});Promise.resolve(O).then(H=>{re.dispose(),L.dispose(),V(H)},H=>{re.dispose(),L.dispose(),x(H)})});return new class{cancel(){L.cancel()}then(V,x){return _.then(V,x)}catch(V){return this.then(void 0,V)}finally(V){return _.finally(V)}}}e.createCancelablePromise=m;function P(j,L,O){return new Promise((_,V)=>{const x=L.onCancellationRequested(()=>{x.dispose(),_(O)});j.then(_,V).finally(()=>x.dispose())})}e.raceCancellation=P;function y(j,L){return new Promise((O,_)=>{const V=L.onCancellationRequested(()=>{V.dispose(),_(new t.CancellationError)});j.then(O,_).finally(()=>V.dispose())})}e.raceCancellationError=y;async function S(j){let L=-1;const O=j.map((V,x)=>V.then(re=>(L=x,re))),_=await Promise.race(O);return j.forEach((V,x)=>{x!==L&&V.cancel()}),_}e.raceCancellablePromises=S;function g(j,L,O){let _;const V=setTimeout(()=>{_?.(void 0),O?.()},L);return Promise.race([j.finally(()=>clearTimeout(V)),new Promise(x=>_=x)])}e.raceTimeout=g;function h(j){return new Promise((L,O)=>{const _=j();l(_)?_.then(L,O):L(_)})}e.asPromise=h;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(O,O).then(_)})}return new Promise((O,_)=>{this.queuedPromise.then(O,_)})}return this.activePromise=L(),new Promise((O,_)=>{this.activePromise.then(V=>{this.activePromise=null,O(V)},V=>{this.activePromise=null,_(V)})})}}e.Throttler=b;class C{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=C;class p{constructor(){this.promiseMap=new Map}queue(L,O){const V=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===V&&this.promiseMap.delete(L)});return this.promiseMap.set(L,V),V}}e.SequencerByKey=p;const v=(j,L)=>{let O=!0;const _=setTimeout(()=>{O=!1,L()},j);return{isTriggered:()=>O,dispose:()=>{clearTimeout(_),O=!1}}},d=j=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,j())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,x)=>{this.doResolve=V,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const _=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?d(_):v(O,_),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class a{constructor(L){this.delayer=new f(L),this.throttler=new b}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=a;class i{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class o extends i{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function n(j,L){return L?new Promise((O,_)=>{const V=setTimeout(()=>{x.dispose(),O()},j),x=L.onCancellationRequested(()=>{clearTimeout(V),x.dispose(),_(new t.CancellationError)})}):m(O=>n(j,O))}e.timeout=n;function r(j,L=0){const O=setTimeout(j,L);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=r;function s(j){const L=[];let O=0;const _=j.length;function V(){return O<_?j[O++]():null}function x(re){re!=null&&L.push(re);const H=V();return H?H.then(x):Promise.resolve(L)}return Promise.resolve(null).then(x)}e.sequence=s;function c(j,L=_=>!!_,O=null){let _=0;const V=j.length,x=()=>{if(_>=V)return Promise.resolve(O);const re=j[_++];return Promise.resolve(re()).then(ie=>L(ie)?Promise.resolve(ie):x())};return x()}e.first=c;function u(j,L=_=>!!_,O=null){if(j.length===0)return Promise.resolve(O);let _=j.length;const V=()=>{_=-1;for(const x of j)x.cancel?.()};return new Promise((x,re)=>{for(const H of j)H.then(ie=>{--_>=0&&L(ie)?(V(),x(ie)):_===0&&x(O)}).catch(ie=>{--_>=0&&(V(),re(ie))})})}e.firstParallel=u;class I{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,_)=>{this.outstandingPromises.push({factory:L,c:O,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=I;class D extends I{constructor(){super(1)}}e.Queue=D;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new F;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=M.extUri){const _=O.getComparisonKey(L);let V=this.queues.get(_);return V||(V=new D,k.Event.once(V.onDrained)(()=>{V?.dispose(),this.queues.delete(_),this.onDidQueueDrain()}),this.queues.set(_,V)),V}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class N{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=N;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=U;class ${constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=$;class Y{constructor(L,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=Y;class oe extends ${constructor(L,O){super(L,O),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=oe;class ue extends R.Disposable{constructor(L,O){super(),this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new $(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ue,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=j=>{(0,E.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(j,L)=>{const O=requestIdleCallback(j,typeof L=="number"?{timeout:L}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(O))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function he(j,L,O){let _;for(let V=0;V<O;V++)try{return await j()}catch(x){_=x,await n(L)}throw _}e.retry=he;class G{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(L,O,_){return this._pending={taskId:L,cancel:()=>_?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,_;const V=new Promise((x,re)=>{O=x,_=re});this._next={run:L,promise:V,promiseResolve:O,promiseReject:_}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=G;class K{constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class F{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=F;var A;(function(j){async function L(_){let V;const x=await Promise.all(_.map(re=>re.then(H=>H,H=>{V||(V=H)})));if(typeof V<"u")throw V;return x}j.settled=L;function O(_){return new Promise(async(V,x)=>{try{await _(V,x)}catch(re){x(re)}})}j.withAsyncBody=O})(A=e.Promises||(e.Promises={}));var W;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(W||(W={}));class z{constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(L(O)),this.resolve()}catch(_){this.reject(_)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(L){return new z(O=>{O.emitMany(L)})}static fromPromise(L){return new z(async O=>{O.emitMany(await L)})}static fromPromises(L){return new z(async O=>{await Promise.all(L.map(async _=>O.emitOne(await _)))})}static merge(L){return new z(async O=>{await Promise.all(L.map(async _=>{for await(const V of _)O.emitOne(V)}))})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new z(async _=>{for await(const V of L)_.emitOne(O(V))})}map(L){return z.map(this,L)}static filter(L,O){return new z(async _=>{for await(const V of L)O(V)&&_.emitOne(V)})}filter(L){return z.filter(this,L)}static coalesce(L){return z.filter(L,O=>!!O)}coalesce(){return z.coalesce(this)}static async toPromise(L){const O=[];for await(const _ of L)O.push(_);return O}toPromise(){return z.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class te extends z{constructor(L,O){super(O),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=te;function B(j){const L=new w.CancellationTokenSource,O=j(L.token);return new te(L,async _=>{const V=L.token.onCancellationRequested(()=>{V.dispose(),L.dispose(),_.reject(new t.CancellationError)});try{for await(const x of O){if(L.token.isCancellationRequested)return;_.emitOne(x)}V.dispose(),L.dispose()}catch(x){V.dispose(),L.dispose(),_.reject(x)}})}e.createCancelableAsyncIterable=B}),define(Z[97],ee([0,1,24,8,30,31,9,4,25]),function(q,e,w,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",y="[^/\\\\]",S=/\//g;function g(F,A){switch(F){case 0:return"";case 1:return`${y}*?`;default:return`(?:${P}|${y}+${P}${A?`|${P}${y}+`:""})*?`}}function h(F,A){if(!F)return[];const W=[];let z=!1,te=!1,B="";for(const j of F){switch(j){case A:if(!z&&!te){W.push(B),B="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":te=!0;break;case"]":te=!1;break}B+=j}return B&&W.push(B),W}e.splitGlobAware=h;function b(F){if(!F)return"";let A="";const W=h(F,e.GLOB_SPLIT);if(W.every(z=>z===e.GLOBSTAR))A=".*";else{let z=!1;W.forEach((te,B)=>{if(te===e.GLOBSTAR){if(z)return;A+=g(2,B===W.length-1)}else{let j=!1,L="",O=!1,_="";for(const V of te){if(V!=="}"&&j){L+=V;continue}if(O&&(V!=="]"||!_)){let x;V==="-"?x=V:(V==="^"||V==="!")&&!_?x="^":V===e.GLOB_SPLIT?x="":x=(0,l.escapeRegExpCharacters)(V),_+=x;continue}switch(V){case"{":j=!0;continue;case"[":O=!0;continue;case"}":{A+=`(?:${h(L,",").map(H=>b(H)).join("|")})`,j=!1,L="";break}case"]":{A+="["+_+"]",O=!1,_="";break}case"?":A+=y;continue;case"*":A+=g(1);continue;default:A+=(0,l.escapeRegExpCharacters)(V)}}B<W.length-1&&(W[B+1]!==e.GLOBSTAR||B+2<W.length)&&(A+=P)}z=te===e.GLOBSTAR})}return A}const C=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),o=function(){return!1},n=function(){return null};function r(F,A){if(!F)return n;let W;typeof F!="string"?W=F.pattern:W=F,W=W.trim();const z=`${W}_${!!A.trimForExclusions}`;let te=i.get(z);if(te)return s(te,F);let B;return C.test(W)?te=u(W.substr(4),W):(B=p.exec(c(W,A)))?te=I(B[1],W):(A.trimForExclusions?d:v).test(W)?te=D(W,A):(B=f.exec(c(W,A)))?te=T(B[1].substr(1),W,!0):(B=a.exec(c(W,A)))?te=T(B[1],W,!1):te=N(W),i.set(z,te),s(te,F)}function s(F,A){if(typeof A=="string")return F;const W=function(z,te){return(0,k.isEqualOrParent)(z,A.base,!E.isLinux)?F(z.substr(A.base.length+1),te):null};return W.allBasenames=F.allBasenames,W.allPaths=F.allPaths,W.basenames=F.basenames,W.patterns=F.patterns,W}function c(F,A){return A.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function u(F,A){return function(W,z){return typeof W=="string"&&W.endsWith(F)?A:null}}function I(F,A){const W=`/${F}`,z=`\\${F}`,te=function(j,L){return typeof j!="string"?null:L?L===F?A:null:j===F||j.endsWith(W)||j.endsWith(z)?A:null},B=[F];return te.basenames=B,te.patterns=[A],te.allBasenames=B,te}function D(F,A){const W=G(F.slice(1,-1).split(",").map(L=>r(L,A)).filter(L=>L!==n),F),z=W.length;if(!z)return n;if(z===1)return W[0];const te=function(L,O){for(let _=0,V=W.length;_<V;_++)if(W[_](L,O))return F;return null},B=W.find(L=>!!L.allBasenames);B&&(te.allBasenames=B.allBasenames);const j=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return j.length&&(te.allPaths=j),te}function T(F,A,W){const z=M.sep===M.posix.sep,te=z?F:F.replace(S,M.sep),B=M.sep+te,j=M.posix.sep+F;let L;return W?L=function(O,_){return typeof O=="string"&&(O===te||O.endsWith(B)||!z&&(O===F||O.endsWith(j)))?A:null}:L=function(O,_){return typeof O=="string"&&(O===te||!z&&O===F)?A:null},L.allPaths=[(W?"*/":"./")+F],L}function N(F){try{const A=new RegExp(`^${b(F)}$`);return function(W){return A.lastIndex=0,typeof W=="string"&&A.test(W)?F:null}}catch{return n}}function U(F,A,W){return!F||typeof A!="string"?!1:$(F)(A,void 0,W)}e.match=U;function $(F,A={}){if(!F)return o;if(typeof F=="string"||Y(F)){const W=r(F,A);if(W===n)return o;const z=function(te,B){return!!W(te,B)};return W.allBasenames&&(z.allBasenames=W.allBasenames),W.allPaths&&(z.allPaths=W.allPaths),z}return se(F,A)}e.parse=$;function Y(F){const A=F;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=Y;function oe(F){return F.allBasenames||[]}e.getBasenameTerms=oe;function ue(F){return F.allPaths||[]}e.getPathTerms=ue;function se(F,A){const W=G(Object.getOwnPropertyNames(F).map(L=>he(L,F[L],A)).filter(L=>L!==n)),z=W.length;if(!z)return n;if(!W.some(L=>!!L.requiresSiblings)){if(z===1)return W[0];const L=function(V,x){let re;for(let H=0,ie=W.length;H<ie;H++){const ne=W[H](V,x);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(re||(re=[]),re.push(ne))}return re?(async()=>{for(const H of re){const ie=await H;if(typeof ie=="string")return ie}return null})():null},O=W.find(V=>!!V.allBasenames);O&&(L.allBasenames=O.allBasenames);const _=W.reduce((V,x)=>x.allPaths?V.concat(x.allPaths):V,[]);return _.length&&(L.allPaths=_),L}const te=function(L,O,_){let V,x;for(let re=0,H=W.length;re<H;re++){const ie=W[re];ie.requiresSiblings&&_&&(O||(O=(0,M.basename)(L)),V||(V=O.substr(0,O.length-(0,M.extname)(L).length)));const ne=ie(L,O,V,_);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(x||(x=[]),x.push(ne))}return x?(async()=>{for(const re of x){const H=await re;if(typeof H=="string")return H}return null})():null},B=W.find(L=>!!L.allBasenames);B&&(te.allBasenames=B.allBasenames);const j=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return j.length&&(te.allPaths=j),te}function he(F,A,W){if(A===!1)return n;const z=r(F,W);if(z===n)return n;if(typeof A=="boolean")return z;if(A){const te=A.when;if(typeof te=="string"){const B=(j,L,O,_)=>{if(!_||!z(j,L))return null;const V=te.replace("$(basename)",O),x=_(V);return(0,t.isThenable)(x)?x.then(re=>re?F:null):x?F:null};return B.requiresSiblings=!0,B}}return z}function G(F,A){const W=F.filter(L=>!!L.basenames);if(W.length<2)return F;const z=W.reduce((L,O)=>{const _=O.basenames;return _?L.concat(_):L},[]);let te;if(A){te=[];for(let L=0,O=z.length;L<O;L++)te.push(A)}else te=W.reduce((L,O)=>{const _=O.patterns;return _?L.concat(_):L},[]);const B=function(L,O){if(typeof L!="string")return null;if(!O){let V;for(V=L.length;V>0;V--){const x=L.charCodeAt(V-1);if(x===47||x===92)break}O=L.substr(V)}const _=z.indexOf(O);return _!==-1?te[_]:null};B.basenames=z,B.patterns=te,B.allBasenames=z;const j=F.filter(L=>!L.basenames);return j.push(B),j}function K(F,A){return(0,w.equals)(F,A,(W,z)=>typeof W=="string"&&typeof z=="string"?W===z:typeof W!="string"&&typeof z!="string"?W.base===z.base&&W.pattern===z.pattern:!1)}e.patternsEquals=K}),define(Z[34],ee([0,1,24,30,9,4,16,25]),function(q,e,w,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function l(n,r){const{os:s,tildify:c,relative:u}=r;if(u){const T=m(n,u,s);if(typeof T=="string")return T}let I=n.fsPath;if(s===1&&!R.isWindows?I=I.replace(/\//g,"\\"):s!==1&&R.isWindows&&(I=I.replace(/\\/g,"/")),s!==1&&c?.userHome){const T=c.userHome.fsPath;let N;n.scheme!==c.userHome.scheme&&n.path.startsWith(k.posix.sep)?N=c.userHome.with({path:n.path}).fsPath:N=n.fsPath,I=S(N,T,s)}return(s===1?k.win32:k.posix).normalize(P(I,s===1))}e.getPathLabel=l;function m(n,r,s){const c=s===1?k.win32:k.posix,u=s===3?M.extUri:M.extUriIgnorePathCase,I=r.getWorkspace(),D=(0,w.firstOrDefault)(I.folders);if(!D)return;n.scheme!==D.uri.scheme&&n.path.startsWith(k.posix.sep)&&(n=D.uri.with({path:n.path}));const T=r.getWorkspaceFolder(n);if(!T)return;let N;if(u.isEqual(T.uri,n)?N="":N=u.relativePath(T.uri,n)??"",N&&(N=c.normalize(N)),I.folders.length>1&&!r.noPrefix){const U=T.name?T.name:u.basenameOrAuthority(T.uri);N=N?`${U} \u2022 ${N}`:U}return N}function P(n,r=R.isWindows){return(0,t.hasDriveLetter)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=P;let y=Object.create(null);function S(n,r,s=R.OS){if(s===1||!n||!r)return n;let c=y.original===r?y.normalized:void 0;c||(c=r,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,E.rtrim)(c,k.posix.sep)}${k.posix.sep}`,y={original:r,normalized:c});let u=n;return R.isWindows&&(u=(0,t.toSlashes)(u)),(s===3?u.startsWith(c):(0,E.startsWithIgnoreCase)(u,c))?`~/${u.substr(c.length)}`:n}e.tildify=S;function g(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=g;const h="\u2026",b="\\\\",C="~";function p(n,r=k.sep){const s=new Array(n.length);let c=!1;for(let u=0;u<n.length;u++){const I=n[u];if(I===""){s[u]=`.${r}`;continue}if(!I){s[u]=I;continue}c=!0;let D="",T=I;T.indexOf(b)===0?(D=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length)):T.indexOf(r)===0?(D=T.substr(0,T.indexOf(r)+r.length),T=T.substr(T.indexOf(r)+r.length)):T.indexOf(C)===0&&(D=T.substr(0,T.indexOf(C)+C.length),T=T.substr(T.indexOf(C)+C.length));const N=T.split(r);for(let U=1;c&&U<=N.length;U++)for(let $=N.length-U;c&&$>=0;$--){c=!1;let Y=N.slice($,$+U).join(r);for(let oe=0;!c&&oe<n.length;oe++)if(oe!==u&&n[oe]&&n[oe].indexOf(Y)>-1){const ue=$+U===N.length,se=$>0&&n[oe].indexOf(r)>-1?r+Y:Y,he=n[oe].endsWith(se);c=!ue||he}if(!c){let oe="";(N[0].endsWith(":")||D!=="")&&($===1&&($=0,U++,Y=N[0]+r+Y),$>0&&(oe=N[0]+r),oe=D+oe),$>0&&(oe=oe+h+r),oe=oe+Y,$+U<N.length&&(oe=oe+r+h),s[u]=oe}}c&&(s[u]=I)}return s}e.shorten=p;var v;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function d(n,r=Object.create(null)){const s=[];let c=!1,u="";for(const I of n)if(I==="$"||c&&I==="{")u&&s.push({value:u,type:v.TEXT}),u="",c=!0;else if(I==="}"&&c){const D=r[u];if(typeof D=="string")D.length&&s.push({value:D,type:v.VARIABLE});else if(D){const T=s[s.length-1];(!T||T.type!==v.SEPARATOR)&&s.push({value:D.label,type:v.SEPARATOR})}u="",c=!1}else u+=I;return u&&!c&&s.push({value:u,type:v.TEXT}),s.filter((I,D)=>{if(I.type===v.SEPARATOR){const T=s[D-1],N=s[D+1];return[T,N].every(U=>U&&(U.type===v.VARIABLE||U.type===v.TEXT)&&U.value.length>0)}return!0}).map(I=>I.value).join("")}e.template=d;function f(n,r){return R.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):n.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function a(n,r){return R.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,""):R.isWindows?n.replace(/&&|&/g,s=>s==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(n){const r=n.indexOf("/")!==-1?k.posix:k.win32,s=r.basename(n),c=r.dirname(n);return s.length?{name:s,parentPath:c}:{name:c,parentPath:""}}e.splitName=o}),define(Z[140],ee([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(P){return P.toJSON()}class k{constructor(y){this._uriTransformer=y}transformIncoming(y){const S=this._uriTransformer.transformIncoming(y);return S===y?y:t(w.URI.from(S))}transformOutgoing(y){const S=this._uriTransformer.transformOutgoing(y);return S===y?y:t(w.URI.from(S))}transformOutgoingURI(y){const S=this._uriTransformer.transformOutgoing(y);return S===y?y:w.URI.from(S)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function R(P,y,S){if(!P||S>200)return null;if(typeof P=="object"){if(P instanceof w.URI)return y.transformOutgoing(P);for(const g in P)if(Object.hasOwnProperty.call(P,g)){const h=R(P[g],y,S+1);h!==null&&(P[g]=h)}}return null}function M(P,y){const S=R(P,y,0);return S===null?P:S}e.transformOutgoingURIs=M;function E(P,y,S,g){if(!P||g>200)return null;if(typeof P=="object"){if(P.$mid===1)return S?w.URI.revive(y.transformIncoming(P)):y.transformIncoming(P);for(const h in P)if(Object.hasOwnProperty.call(P,h)){const b=E(P[h],y,S,g+1);b!==null&&(P[h]=b)}}return null}function l(P,y){const S=E(P,y,!1,0);return S===null?P:S}e.transformIncomingURIs=l;function m(P,y){const S=E(P,y,!0,0);return S===null?P:S}e.transformAndReviveIncomingURIs=m}),define(Z[81],ee([0,1,28,17,31,29,128]),function(q,e,w,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,y=0;const S=(0,w.networkInterfaces)();for(const g in S){const h=S[g];if(h)for(const{mac:b,internal:C}of h)C||(y+=1,this._isVirtualMachineMacAddress(b.toUpperCase())&&(P+=1))}this._value=y>0?P/y:0}return this._value}};let E;async function l(){return E||(E=(async()=>await m()||R.generateUuid())()),E}e.getMachineId=l;async function m(){try{const P=await new Promise((S,g)=>{q(["crypto"],S,g)}),y=(0,M.getMac)();return P.createHash("sha256").update(y,"utf8").digest("hex")}catch(P){t.onUnexpectedError(P);return}}}),define(Z[23],ee([0,1,40,28,141,8,30,80,9,4,16,7]),function(q,e,w,t,k,R,M,E,l,m,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function g(se,he=S.UNLINK){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return he===S.UNLINK?b(se):h(se)}async function h(se){try{const he=(0,M.randomPath)((0,t.tmpdir)());try{await w.promises.rename(se,he)}catch(G){return G.code==="ENOENT"?void 0:b(se)}b(he).catch(G=>{})}catch(he){if(he.code!=="ENOENT")throw he}}async function b(se){return(0,k.promisify)(w.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function C(se){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");w.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=C;async function p(se,he){return f(await(he?v(se):(0,k.promisify)(w.readdir)(se)))}async function v(se){try{return await(0,k.promisify)(w.readdir)(se,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const he=[],G=await p(se);for(const K of G){let F=!1,A=!1,W=!1;try{const z=await e.Promises.lstat((0,l.join)(se,K));F=z.isFile(),A=z.isDirectory(),W=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}he.push({name:K,isFile:()=>F,isDirectory:()=>A,isSymbolicLink:()=>W})}return he}function d(se){return f(w.readdirSync(se))}e.readdirSync=d;function f(se){return se.map(he=>typeof he=="string"?m.isMacintosh?(0,E.normalizeNFC)(he):he:(he.name=m.isMacintosh?(0,E.normalizeNFC)(he.name):he.name,he))}async function a(se){const he=await p(se),G=[];for(const K of he)await o.existsDirectory((0,l.join)(se,K))&&G.push(K);return G}function i(se,he=1e3){return new Promise(G=>{let K=!1;const F=setInterval(()=>{K||(K=!0,w.access(se,A=>{K=!1,A&&(clearInterval(F),G(void 0))}))},he)})}e.whenDeleted=i;var o;(function(se){async function he(F){let A;try{if(A=await e.Promises.lstat(F),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(F),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(m.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw z}throw W}}se.stat=he;async function G(F){try{const{stat:A,symbolicLink:W}=await se.stat(F);return A.isFile()&&W?.dangling!==!0}catch{}return!1}se.existsFile=G;async function K(F){try{const{stat:A,symbolicLink:W}=await se.stat(F);return A.isDirectory()&&W?.dangling!==!0}catch{}return!1}se.existsDirectory=K})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new R.ResourceQueue;function r(se,he,G){return n.queueFor(y.URI.file(se),P.extUriBiasedIgnorePathCase).queue(()=>{const K=D(G);return new Promise((F,A)=>u(se,he,K,W=>W?A(W):F()))})}let s=!0;function c(se){s=se}e.configureFlushOnWrite=c;function u(se,he,G,K){if(!s)return w.writeFile(se,he,{mode:G.mode,flag:G.flag},K);w.open(se,G.flag,G.mode,(F,A)=>{if(F)return K(F);w.writeFile(A,he,W=>{if(W)return w.close(A,()=>K(W));w.fdatasync(A,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),c(!1)),w.close(A,te=>K(te))))})})}function I(se,he,G){const K=D(G);if(!s)return w.writeFileSync(se,he,{mode:K.mode,flag:K.flag});const F=w.openSync(se,K.flag,K.mode);try{w.writeFileSync(F,he);try{w.fdatasyncSync(F)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),c(!1)}}finally{w.closeSync(F)}}e.writeFileSync=I;function D(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,he){if(se!==he)try{await e.Promises.rename(se,he)}catch(G){if(se.toLowerCase()!==he.toLowerCase()&&G.code==="EXDEV"||se.endsWith("."))await N(se,he,{preserveSymlinks:!1}),await g(se,S.MOVE);else throw G}}async function N(se,he,G){return $(se,he,{root:{source:se,target:he},options:G,handledSourcePaths:new Set})}const U=511;async function $(se,he,G){if(G.handledSourcePaths.has(se))return;G.handledSourcePaths.add(se);const{stat:K,symbolicLink:F}=await o.stat(se);if(F){if(G.options.preserveSymlinks)try{return await ue(se,he,G)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(F.dangling)return}return K.isDirectory()?Y(se,he,K.mode&U,G):oe(se,he,K.mode&U)}async function Y(se,he,G,K){await e.Promises.mkdir(he,{recursive:!0,mode:G});const F=await p(se);for(const A of F)await $((0,l.join)(se,A),(0,l.join)(he,A),K)}async function oe(se,he,G){await e.Promises.copyFile(se,he),await e.Promises.chmod(he,G)}async function ue(se,he,G){let K=await e.Promises.readlink(se);(0,M.isEqualOrParent)(K,G.root.source,!m.isLinux)&&(K=(0,l.join)(G.root.target,K.substr(G.root.source.length+1))),await e.Promises.symlink(K,he)}e.Promises=new class{get access(){return(0,k.promisify)(w.access)}get stat(){return(0,k.promisify)(w.stat)}get lstat(){return(0,k.promisify)(w.lstat)}get utimes(){return(0,k.promisify)(w.utimes)}get read(){return(se,he,G,K,F)=>new Promise((A,W)=>{w.read(se,he,G,K,F,(z,te,B)=>z?W(z):A({bytesRead:te,buffer:B}))})}get readFile(){return(0,k.promisify)(w.readFile)}get write(){return(se,he,G,K,F)=>new Promise((A,W)=>{w.write(se,he,G,K,F,(z,te,B)=>z?W(z):A({bytesWritten:te,buffer:B}))})}get appendFile(){return(0,k.promisify)(w.appendFile)}get fdatasync(){return(0,k.promisify)(w.fdatasync)}get truncate(){return(0,k.promisify)(w.truncate)}get rename(){return(0,k.promisify)(w.rename)}get copyFile(){return(0,k.promisify)(w.copyFile)}get open(){return(0,k.promisify)(w.open)}get close(){return(0,k.promisify)(w.close)}get symlink(){return(0,k.promisify)(w.symlink)}get readlink(){return(0,k.promisify)(w.readlink)}get chmod(){return(0,k.promisify)(w.chmod)}get mkdir(){return(0,k.promisify)(w.mkdir)}get unlink(){return(0,k.promisify)(w.unlink)}get rmdir(){return(0,k.promisify)(w.rmdir)}get realpath(){return(0,k.promisify)(w.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return a}get writeFile(){return r}get rm(){return g}get move(){return T}get copy(){return N}}}),define(Z[98],ee([0,1,40,9,4,25,23]),function(q,e,w,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function E(S){if(k.isLinux)return S;const g=(0,t.dirname)(S);if(S===g)return S;const h=((0,t.basename)(S)||S).toLowerCase();try{const C=(0,M.readdirSync)(g).filter(p=>p.toLowerCase()===h);if(C.length===1){const p=E(g);if(p)return(0,t.join)(p,C[0])}else if(C.length>1){const p=C.indexOf(h);if(p>=0){const v=E(g);if(v)return(0,t.join)(v,C[p])}}}catch{}return null}e.realcaseSync=E;async function l(S){if(k.isLinux)return S;const g=(0,t.dirname)(S);if(S===g)return S;const h=((0,t.basename)(S)||S).toLowerCase();try{const C=(await M.Promises.readdir(g)).filter(p=>p.toLowerCase()===h);if(C.length===1){const p=await l(g);if(p)return(0,t.join)(p,C[0])}else if(C.length>1){const p=C.indexOf(h);if(p>=0){const v=await l(g);if(v)return(0,t.join)(v,C[p])}}}catch{}return null}e.realcase=l;async function m(S){try{return await M.Promises.realpath(S)}catch{const h=y(S);return await M.Promises.access(h,w.constants.R_OK),h}}e.realpath=m;function P(S){try{return w.realpathSync(S)}catch{const h=y(S);return w.accessSync(h,w.constants.R_OK),h}}e.realpathSync=P;function y(S){return(0,R.rtrim)((0,t.normalize)(S),t.sep)}}),define(Z[142],ee([0,1,28,9,23]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,M=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var l;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(l||(l={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class y{constructor(a,i,o){this.exePath=a,this.displayName=i,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:f=!1}={}){return f?m===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:f=!1,findPreview:a=!1}={}){const i=S({useAlternateBitness:f});if(!i)return null;const o=t.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(o))return null;let n=-1,r=null;for(const u of await k.Promises.readdir(o)){let I=-1;if(a){const T=u.indexOf("-");if(T<0)continue;const N=u.substring(0,T);if(!R.test(N)||u.substring(T+1)!=="preview")continue;I=parseInt(N,10)}else{if(!R.test(u))continue;I=parseInt(u,10)}if(I<=n)continue;const D=t.join(o,u,"pwsh.exe");!await k.SymlinkSupport.existsFile(D)||(r=D,n=I)}if(!r)return null;const s=i.includes("x86")?" (x86)":"",c=a?" Preview":"";return new y(r,`PowerShell${c}${s}`,!0)}async function h({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const a=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=f?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const n of await k.Promises.readdir(a))if(i.test(n)){const r=t.join(a,n,"pwsh.exe");return new y(r,o)}return null}function b(){const f=t.join(w.homedir(),".dotnet","tools","pwsh.exe");return new y(f,".NET Core PowerShell Global Tool")}function C(){const f=t.join(process.env.windir,m===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(f,"Windows PowerShell",!0)}async function*p(){let f=await g();f&&(yield f),f=await g({useAlternateBitness:!0}),f&&(yield f),f=await h(),f&&(yield f),f=b(),f&&(yield f),f=await g({findPreview:!0}),f&&(yield f),f=await h({findPreview:!0}),f&&(yield f),f=await g({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=C(),f&&(yield f)}async function*v(){for await(const f of p())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=v;async function d(){for await(const f of v())return f;return null}e.getFirstAvailablePowerShellInstallation=d}),define(Z[82],ee([0,1,9,4,33,78,12,23]),function(q,e,w,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function l(y=k.env){return y.comspec||"cmd.exe"}e.getWindowsShell=l;function m(y){let S=[],g=!1;const h=function(b){if(g){S.push(b);return}(!y.send(b,p=>{if(p&&console.error(p),g=!1,S.length>0){const v=S.slice(0);S=[],v.forEach(d=>h(d))}})||t.isWindows)&&(g=!0)};return{send:h}}e.createQueuedSender=m;var P;(function(y){async function S(g,h,b){if(w.isAbsolute(g))return g;if(h===void 0&&(h=k.cwd()),w.dirname(g)!=="."||(b===void 0&&M.isString(k.env.PATH)&&(b=k.env.PATH.split(w.delimiter)),b===void 0||b.length===0))return w.join(h,g);async function p(v){if(await E.Promises.exists(v)){let d;try{d=await E.Promises.stat(v)}catch(f){f.message.startsWith("EACCES")&&(d=await E.Promises.lstat(v))}return d?!d.isDirectory():!1}return!1}for(const v of b){let d;if(w.isAbsolute(v)?d=w.join(v,g):d=w.join(h,v,g),await p(d))return d;let f=d+".com";if(await p(f)||(f=d+".exe",await p(f)))return f}return w.join(h,g)}y.findExecutable=S})(P=e.win32||(e.win32={}))}),define(Z[99],ee([0,1,45,13]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(M){return new Promise((E,l)=>{let m;const P=new Map;function y(g,h,b,C,p){const v=P.get(h);if(g===M||v){const d={name:S(b),cmd:b,pid:g,ppid:h,load:C,mem:p};P.set(g,d),g===M&&(m=d),v&&(v.children||(v.children=[]),v.children.push(d),v.children.length>1&&(v.children=v.children.sort((f,a)=>f.pid-a.pid)))}}function S(g){const h=/--vscode-window-kind=shared-process/,b=/--vscode-window-kind=issue-reporter/,C=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,v=/--utility-sub-type=node.mojom.NodeService/,d=/--crashes-directory/,f=/\\pipe\\winpty-control/,a=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(d.exec(g))return"electron-crash-reporter";if(f.exec(g))return"winpty-process";if(a.exec(g))return"console-window-host (Windows internal process)";let o=i.exec(g);if(o&&o.length===2){if(o[1]==="renderer")return h.exec(g)?"shared-process":b.exec(g)?"issue-reporter":C.exec(g)?"process-explorer":"window";if(o[1]==="utility"){if(p.exec(g))return"utility-network-service";if(v.exec(g))return"extension-host"}return o[1]}const n=/[a-zA-Z-]+\.js/g;let r="";do o=n.exec(g),o&&(r+=o+" ");while(o);return r&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${r}`:g}if(process.platform==="win32"){const g=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,b)=>{q(["windows-process-tree"],h,b)}).then(h=>{h.getProcessList(M,b=>{if(!b){l(new Error(`Root process ${M} not found`));return}h.getProcessCpuUsage(b,C=>{const p=new Map;C.forEach(v=>{const d=g(v.commandLine||"");p.set(v.pid,{name:S(d),cmd:d,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),m=p.get(M),m?(p.forEach(v=>{const d=p.get(v.ppid);d&&(d.children||(d.children=[]),d.children.push(v))}),p.forEach(v=>{v.children&&(v.children=v.children.sort((d,f)=>d.pid-f.pid))}),E(m)):l(new Error(`Root process ${M} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let g=function(){let h=[m];const b=[];for(;h.length;){const p=h.shift();p&&(b.push(p.pid),p.children&&(h=h.concat(p.children)))}let C=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",q).fsPath);C+=" "+b.join(" "),(0,w.exec)(C,{},(p,v,d)=>{if(p||d)l(p||new Error(d.toString()));else{const f=v.toString().split(`
`);for(let a=0;a<b.length;a++){const i=P.get(b[a]);i.load=parseFloat(f[a])}if(!m){l(new Error(`Root process ${M} not found`));return}E(m)}})};(0,w.exec)("which ps",{},(h,b,C)=>{if(h||C)if(process.platform!=="linux")l(h||new Error(C.toString()));else{const p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",q).fsPath);(0,w.exec)(p,{},(v,d,f)=>{v||f?l(v||new Error(f.toString())):(R(d,y),g())})}else{const p=b.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${p} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,f,a)=>{d||a&&!a.includes("screen size is bogus")?l(d||new Error(a.toString())):(R(f,y),process.platform==="linux"?g():m?E(m):l(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=k;function R(M,E){const l=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=M.toString().split(`
`);for(const P of m){const y=l.exec(P.trim());y&&y.length===6&&E(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(Z[143],ee([0,1,28,4,142,82]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(g,h){return g===1?t.isWindows?y():R.getWindowsShell(h):m(g,h)}e.getSystemShell=M;function E(g,h){return g===1?t.isWindows?S(h):R.getWindowsShell(h):m(g,h)}e.getSystemShellSync=E;let l=null;function m(g,h){if(t.isLinux&&g===2||t.isMacintosh&&g===3)return"/bin/bash";if(!l){let b;if(t.isWindows)b="/bin/bash";else{if(b=h.SHELL,!b)try{b=(0,w.userInfo)().shell}catch{}b||(b="sh"),b==="/bin/false"&&(b="/bin/bash")}l=b}return l}let P=null;async function y(){return P||(P=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),P}function S(g){if(P)return P;const h=t.isWindows&&parseFloat((0,w.release)())>=10,b=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),C=`${g.windir}\\${b?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?C:R.getWindowsShell(g)}});var ve=this&&this.__decorate||function(q,e,w,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,w):t,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(q,e,w,t);else for(var E=q.length-1;E>=0;E--)(M=q[E])&&(R=(k<3?M(R):k>3?M(e,w,R):M(e,w))||R);return k>3&&R&&Object.defineProperty(e,w,R),R};define(Z[46],ee([0,1,24,8,18,22,53,17,3,2,67,25,12]),function(q,e,w,t,k,R,M,E,l,m,P,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function h(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(b=e.ResponseType||(e.ResponseType={}));function C(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(p||(p={}));class v{constructor(A){this.buffer=A,this.pos=0}read(A){const W=this.buffer.slice(this.pos,this.pos+A);return this.pos+=W.byteLength,W}}class d{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var f;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(f||(f={}));function a(F){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(F,0),A}function i(F){return F.read(4).readUInt32BE(0)}function o(F){const A=k.VSBuffer.alloc(1);return A.writeUInt8(F,0),A}const n={Undefined:o(f.Undefined),String:o(f.String),Buffer:o(f.Buffer),VSBuffer:o(f.VSBuffer),Array:o(f.Array),Object:o(f.Object)},r=typeof Buffer<"u";function s(F,A){if(typeof A>"u")F.write(n.Undefined);else if(typeof A=="string"){const W=k.VSBuffer.fromString(A);F.write(n.String),F.write(a(W.byteLength)),F.write(W)}else if(r&&Buffer.isBuffer(A)){const W=k.VSBuffer.wrap(A);F.write(n.Buffer),F.write(a(W.byteLength)),F.write(W)}else if(A instanceof k.VSBuffer)F.write(n.VSBuffer),F.write(a(A.byteLength)),F.write(A);else if(Array.isArray(A)){F.write(n.Array),F.write(a(A.length));for(const W of A)s(F,W)}else{const W=k.VSBuffer.fromString(JSON.stringify(A));F.write(n.Object),F.write(a(W.byteLength)),F.write(W)}}function c(F){switch(F.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return F.read(i(F)).toString();case f.Buffer:return F.read(i(F)).buffer;case f.VSBuffer:return F.read(i(F));case f.Array:{const W=i(F),z=[];for(let te=0;te<W;te++)z.push(c(F));return z}case f.Object:return JSON.parse(F.read(i(F)).toString())}}class u{constructor(A,W,z=null,te=1e3){this.protocol=A,this.ctx=W,this.logger=z,this.timeoutDelay=te,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(A,W){this.channels.set(A,W),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const W=this.send([A.type]);this.logger?.logOutgoing(W,0,1,C(A.type));return}case 201:case 202:case 204:case 203:{const W=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(W,A.id,1,C(A.type),A.data);return}}}send(A,W=void 0){const z=new d;return s(z,A),s(z,W),this.sendBuffer(z.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const W=new v(A),z=c(W),te=c(W),B=z[0];switch(B){case 100:return this.logger?.logIncoming(A.byteLength,z[1],1,`${h(B)}: ${z[2]}.${z[3]}`,te),this.onPromise({type:B,id:z[1],channelName:z[2],name:z[3],arg:te});case 102:return this.logger?.logIncoming(A.byteLength,z[1],1,`${h(B)}: ${z[2]}.${z[3]}`,te),this.onEventListen({type:B,id:z[1],channelName:z[2],name:z[3],arg:te});case 101:return this.logger?.logIncoming(A.byteLength,z[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:z[1]});case 103:return this.logger?.logIncoming(A.byteLength,z[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:z[1]})}}onPromise(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const z=new R.CancellationTokenSource;let te;try{te=W.call(this.ctx,A.name,A.arg,z.token)}catch(L){te=Promise.reject(L)}const B=A.id;te.then(L=>{this.sendResponse({id:B,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:B,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:B,data:L,type:203}),this.activeRequests.delete(A.id)});const j=(0,m.toDisposable)(()=>z.cancel());this.activeRequests.set(A.id,j)}onEventListen(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const z=A.id,B=W.listen(this.ctx,A.name,A.arg)(j=>this.sendResponse({id:z,data:j,type:204}));this.activeRequests.set(A.id,B)}disposeActiveRequest(A){const W=this.activeRequests.get(A.id);W&&(W.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let W=this.pendingRequests.get(A.channelName);W||(W=[],this.pendingRequests.set(A.channelName,W));const z=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:A,timeoutTimer:z})}flushPendingRequests(A){const W=this.pendingRequests.get(A);if(W){for(const z of W)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=u;var I;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(I=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(A,W=null){this.protocol=A,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=W}getChannel(A){const W=this;return{call(z,te,B){return W.isDisposed?Promise.reject(new E.CancellationError):W.requestPromise(A,z,te,B)},listen(z,te){return W.isDisposed?l.Event.None:W.requestEvent(A,z,te)}}}requestPromise(A,W,z,te=R.CancellationToken.None){const B=this.lastRequestId++,L={id:B,type:100,channelName:A,name:W,arg:z};if(te.isCancellationRequested)return Promise.reject(new E.CancellationError);let O;return new Promise((V,x)=>{if(te.isCancellationRequested)return x(new E.CancellationError);const re=()=>{const ae=fe=>{switch(fe.type){case 201:this.handlers.delete(B),V(fe.data);break;case 202:{this.handlers.delete(B);const De=new Error(fe.data.message);De.stack=fe.data.stack,De.name=fe.data.name,x(De);break}case 203:this.handlers.delete(B),x(fe.data);break}};this.handlers.set(B,ae),this.sendRequest(L)};let H=null;this.state===p.Idle?re():(H=(0,t.createCancelablePromise)(ae=>this.whenInitialized()),H.then(()=>{H=null,re()}));const ie=()=>{H?(H.cancel(),H=null):this.sendRequest({id:B,type:101}),x(new E.CancellationError)},ne=te.onCancellationRequested(ie);O=(0,m.combinedDisposable)((0,m.toDisposable)(ie),ne),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(A,W,z){const te=this.lastRequestId++,j={id:te,type:102,channelName:A,name:W,arg:z};let L=null;const O=new l.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(V=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest(j)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:te,type:103}))}}),_=V=>O.fire(V.data);return this.handlers.set(te,_),O.event}sendRequest(A){switch(A.type){case 100:case 102:{const W=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(W,A.id,0,`${h(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const W=this.send([A.type,A.id]);this.logger?.logOutgoing(W,A.id,0,h(A.type));return}}}send(A,W=void 0){const z=new d;return s(z,A),s(z,W),this.sendBuffer(z.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const W=new v(A),z=c(W),te=c(W),B=z[0];switch(B){case 200:return this.logger?.logIncoming(A.byteLength,0,0,C(B)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,z[1],0,C(B),te),this.onResponse({type:z[0],id:z[1],data:te})}}onResponse(A){if(A.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([M.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class T{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:W,onDidClientDisconnect:z})=>{l.Event.once(W.onMessage)(B=>{const j=new v(B),L=c(j),O=new u(W,L),_=new D(W);this.channels.forEach((x,re)=>O.registerChannel(re,x));const V={channelServer:O,channelClient:_,ctx:L};this._connections.add(V),this._onDidAddConnection.fire(V),z(()=>{O.dispose(),_.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const A=[];return this._connections.forEach(W=>A.push(W)),A}getChannel(A,W){const z=this;return{call(te,B,j){let L;if((0,S.isFunction)(W)){const _=(0,w.getRandomElement)(z.connections.filter(W));L=_?Promise.resolve(_):l.Event.toPromise(l.Event.filter(z.onDidAddConnection,W))}else L=W.routeCall(z,te,B);const O=L.then(_=>_.channelClient.getChannel(A));return U(O).call(te,B,j)},listen(te,B){if((0,S.isFunction)(W))return z.getMulticastEvent(A,W,te,B);const j=W.routeEvent(z,te,B).then(L=>L.channelClient.getChannel(A));return U(j).listen(te,B)}}}getMulticastEvent(A,W,z,te){const B=this;let j=new m.DisposableStore;const L=new l.Emitter({onFirstListenerAdd:()=>{j=new m.DisposableStore;const O=new l.EventMultiplexer,_=new Map,V=re=>{const ie=re.channelClient.getChannel(A).listen(z,te),ne=O.add(ie);_.set(re,ne)},x=re=>{const H=_.get(re);!H||(H.dispose(),_.delete(re))};B.connections.filter(W).forEach(V),l.Event.filter(B.onDidAddConnection,W)(V,void 0,j),B.onDidRemoveConnection(x,void 0,j),O.event(L.fire,L,j),j.add(O)},onLastListenerRemove:()=>{j.dispose()}});return L.event}registerChannel(A,W){this.channels.set(A,W),this._connections.forEach(z=>{z.channelServer.registerChannel(A,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class N{constructor(A,W,z=null){const te=new d;s(te,W),A.send(te.buffer),this.channelClient=new D(A,z),this.channelServer=new u(A,W,z)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,W){this.channelServer.registerChannel(A,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=N;function U(F){return{call(A,W,z){return F.then(te=>te.call(A,W,z))},listen(A,W){const z=new l.Relay;return F.then(te=>z.input=te.listen(A,W)),z.event}}}e.getDelayedChannel=U;function $(F){let A=!1;return{call(W,z,te){return A?F.call(W,z,te):(0,t.timeout)(0).then(()=>A=!0).then(()=>F.call(W,z,te))},listen(W,z){if(A)return F.listen(W,z);const te=new l.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>te.input=F.listen(W,z)),te.event}}}e.getNextTickChannel=$;class Y{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const W of A.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await l.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=Y;var oe;(function(F){function A(B,j){const L=B,O=j&&j.disableMarshalling,_=new Map;for(const V in L)z(V)&&_.set(V,l.Event.buffer(L[V],!0));return new class{listen(V,x,re){const H=_.get(x);if(H)return H;if(te(x)){const ie=L[x];if(typeof ie=="function")return ie.call(L,re)}throw new Error(`Event not found: ${x}`)}call(V,x,re){const H=L[x];if(typeof H=="function"){if(!O&&Array.isArray(re))for(let ie=0;ie<re.length;ie++)re[ie]=(0,P.revive)(re[ie]);return H.apply(L,re)}throw new Error(`Method not found: ${x}`)}}}F.fromService=A;function W(B,j){const L=j&&j.disableMarshalling;return new Proxy({},{get(O,_){if(typeof _=="string")return j?.properties?.has(_)?j.properties.get(_):te(_)?function(V){return B.listen(_,V)}:z(_)?B.listen(_):async function(...V){let x;j&&!(0,S.isUndefinedOrNull)(j.context)?x=[j.context,...V]:x=V;const re=await B.call(_,x);return L?re:(0,P.revive)(re)};throw new Error(`Property not found: ${String(_)}`)}})}F.toService=W;function z(B){return B[0]==="o"&&B[1]==="n"&&y.isUpperAsciiLetter(B.charCodeAt(2))}function te(B){return/^onDynamic/.test(B)&&y.isUpperAsciiLetter(B.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const A=F.toString();if(A!=="[object Object]")return A}return F}function he(F){return Array.isArray(F)?F.map(se):se(F)}function G(F,A,W,z,te,B,j){j=he(j);const L=ue[te],O=L[z%L.length];let _=[`%c[${F}]%c[${String(A).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(B)?(_=_.concat(j),_.push(")")):_.push(j),console.log.apply(console,_)}e.logWithColors=G;class K{constructor(A,W){this._outgoingPrefix=A,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,W,z,te,B){this._totalOutgoing+=A,G(this._outgoingPrefix,this._totalOutgoing,A,W,z,te,B)}logIncoming(A,W,z,te,B){this._totalIncoming+=A,G(this._incomingPrefix,this._totalIncoming,A,W,z,te,B)}}e.IPCLogger=K}),define(Z[144],ee([0,1,18,3,46]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(l){this.port=l,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",m=>w.VSBuffer.wrap(m.data)),l.start()}send(l){this.port.postMessage(l.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class M extends k.IPCClient{constructor(l,m){const P=new R(l);super(P,m),this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=M}),define(Z[100],ee([0,1,18,3,2,46]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(M=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var E;(function(r){r.enableDiagnostics=!1,r.records=[];const s=new WeakMap;let c=0;function u(D,T){if(!s.has(D)){const N=String(++c);s.set(D,N)}return s.get(D)}function I(D,T,N,U){if(!r.enableDiagnostics)return;const $=u(D,T);if(U instanceof w.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const Y=w.VSBuffer.alloc(U.byteLength);Y.set(U),r.records.push({timestamp:Date.now(),id:$,label:T,type:N,buff:Y})}else r.records.push({timestamp:Date.now(),id:$,label:T,type:N,data:U})}r.traceSocketEvent=I})(E=e.SocketDiagnostics||(e.SocketDiagnostics={}));var l;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(l=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function P(){return m||(m=w.VSBuffer.alloc(0)),m}class y{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,c){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const T=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=s),T}if(this._chunks[0].byteLength>s){const T=this._chunks[0].slice(0,s);return c&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),T}const u=w.VSBuffer.alloc(s);let I=0,D=0;for(;s>0;){const T=this._chunks[D];if(T.byteLength>s){const N=T.slice(0,s);u.set(N,I),I+=s,c&&(this._chunks[D]=T.slice(s),this._totalLength-=s),s-=s}else u.set(T,I),I+=T.byteLength,c?(this._chunks.shift(),this._totalLength-=T.byteLength):D++,s-=T.byteLength}return u}}e.ChunkStream=y;var S;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(S||(S={}));function g(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class b{constructor(s,c,u,I){this.type=s,this.id=c,this.ack=u,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class C extends k.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:g(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,I=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new b(u,I,D,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=w.VSBuffer.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:g(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(c,s.data)}_bufferAdd(s,c){const u=this._totalLength===0;return this._data.push(s,c),this._totalLength+=s.byteLength+c.byteLength,u}_bufferTake(){const s=w.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,c){this._bufferAdd(s,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class v extends k.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new C(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new b(1,0,0,s))}}e.Protocol=v;class d extends R.IPCClient{constructor(s,c,u=null){super(s,c,u),this.protocol=s}static fromSocket(s,c){return new d(new v(s),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=d;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class a{constructor(s){this.data=s,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let s=0,c=this._first;for(;c;)c=c.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let c=0,u=this._first;for(;u;)s[c++]=u.data,u=u.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const c=new a(s);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class o{constructor(){this.lastRuns=[];const s=Date.now();for(let c=0;c<o._HISTORY_LENGTH;c++)this.lastRuns[c]=s-1e3*c;setInterval(()=>{for(let c=o._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}load(){const s=Date.now(),c=(1+o._HISTORY_LENGTH)*1e3;let u=0;for(let I=0;I<o._HISTORY_LENGTH;I++)s-this.lastRuns[I]<=c&&u++;return 1-u/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class n{constructor(s,c=null,u=o.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(I=>this._receiveMessage(I))),this._socketDisposables.push(this._socket.onClose(I=>this._onSocketClose.fire(I))),c&&this._socketReader.acceptChunk(c),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new b(5,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new b(7,0,0,P());this._socketWriter.write(s)}sendResume(){const s=new b(8,0,0,P());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,c){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new b(3,0,this._incomingAckId,P());this._socketWriter.write(s);const c=this._outgoingUnackMsg.toArray();for(let u=0,I=c.length;u<I;u++)this._socketWriter.write(c[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new b(6,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let u=0,I=c.length;u<I;u++)this._socketWriter.write(c[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new b(1,c,this._incomingAckId,s);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(s){const c=new b(2,0,0,s);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),c=Date.now()-s.writtenTime,u=Date.now()-this._socketReader.lastReadTime,I=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&u>=2e4&&I>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:u});return}const D=Math.max(2e4-c,2e4-u,2e4-I,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},D)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new b(3,0,this._incomingAckId,P());this._socketWriter.write(s)}_sendKeepAlive(){const s=new b(9,0,0,P());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(Z[145],ee([0,1,41,18,3,2,46,130]),function(q,e,w,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function l(P,y){const S=k.Event.fromNodeEventEmitter(w.validatedIpcMain,y,(h,b)=>({event:h,message:b})),g=k.Event.filter(S,({event:h})=>h.sender.id===P);return k.Event.map(g,({message:h})=>h&&t.VSBuffer.wrap(h))}class m extends M.IPCServer{constructor(){super(m.getOnDidClientConnect())}static getOnDidClientConnect(){const y=k.Event.fromNodeEventEmitter(w.validatedIpcMain,"vscode:hello",({sender:S})=>S);return k.Event.map(y,S=>{const g=S.id;m.Clients.get(g)?.dispose();const b=new k.Emitter;m.Clients.set(g,(0,R.toDisposable)(()=>b.fire()));const C=l(g,"vscode:message"),p=k.Event.any(k.Event.signal(l(g,"vscode:disconnect")),b.event);return{protocol:new E.Protocol(S,C),onDidClientDisconnect:p}})}}e.Server=m,m.Clients=new Map}),define(Z[101],ee([0,1,41,3,29,144]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends R.Client{constructor(m,P){super({addEventListener:(y,S)=>m.addListener(y,S),removeEventListener:(y,S)=>m.removeListener(y,S),postMessage:y=>m.postMessage(y),start:()=>m.start(),close:()=>m.close()},P)}}e.Client=M;async function E(l){if(l.isDestroyed()||l.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,k.generateUuid)();l.webContents.send("vscode:createMessageChannel",m);const P=t.Event.fromNodeEventEmitter(w.validatedIpcMain,"vscode:createMessageChannelResult",(S,g)=>({nonce:g,port:S.ports[0]})),{port:y}=await t.Event.toPromise(t.Event.once(t.Event.filter(P,S=>S.nonce===m)));return y}e.connect=E}),define(Z[146],ee([0,1,45,8,18,22,139,17,3,2,50,82,78,46]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends g.ChannelServer{constructor(p){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",v=>k.VSBuffer.wrap(Buffer.from(v,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=h;class b{constructor(p,v){this.modulePath=p,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new t.Delayer(d),this.child=null,this._client=null}getChannel(p){const v=this;return{call(d,f,a){return v.requestPromise(p,d,f,a)},listen(d,f){return v.requestEvent(p,d,f)}}}requestPromise(p,v,d,f=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(p),i=(0,t.createCancelablePromise)(r=>a.call(v,d,r)),o=f.onCancellationRequested(()=>i.cancel()),n=(0,m.toDisposable)(()=>i.cancel());return this.activeRequests.add(n),i.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(p,v,d){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let f;const a=new l.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(p).listen(v,d)(a.fire,a),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,S.removeDangerousEnvVariables)(v.env),this.child=(0,w.fork)(this.modulePath,p,v);const d=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,M.isRemoteConsoleLog)(s)){(0,M.log)(s,`IPC Library: ${this.options.serverName}`);return}d.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const a=this.options.useQueue?(0,y.createQueuedSender)(this.child):this.child,i=s=>this.child&&this.child.connected&&a.send(s.buffer.toString("base64")),o=d.event,n={send:i,onMessage:o};this._client=new g.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,c)=>{process.removeListener("exit",r),this.activeRequests.forEach(u=>(0,m.dispose)(u)),this.activeRequests.clear(),s!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:c})})}return this._client}getCachedChannel(p){let v=this.channels.get(p);return v||(v=this.client.getChannel(p),this.channels.set(p,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=b}),define(Z[83],ee([0,1,18,17,3,2,9,4,29,46,100]),function(q,e,w,t,k,R,M,E,l,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function y(){return{crypto:q.__$__nodeRequire("crypto"),zlib:q.__$__nodeRequire("zlib"),net:q.__$__nodeRequire("net"),os:q.__$__nodeRequire("os")}}class S{constructor(u,I=""){this.debugLabel=I,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,t.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}traceSocketEvent(u,I){P.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,I)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const I=D=>{this.traceSocketEvent("read",D),u(w.VSBuffer.wrap(D))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(u){const I=D=>{this.traceSocketEvent("close",{hadError:D}),u({type:0,hadError:D,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(u){const I=()=>{this.traceSocketEvent("nodeEndReceived"),u()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(u){if(!this.socket.destroyed)try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,t.onUnexpectedError)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,t.onUnexpectedError)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=S;var g;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var h;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(h||(h={}));class b extends R.Disposable{constructor(u,I,D,T){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:D?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new C(this,I,D,T,this._onData,(N,U)=>this._write(N,U))),this._register(this._flowManager.onError(N=>{console.error(N),(0,t.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})})),this._incomingData=new P.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(N=>this._onClose.fire(N)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(u,I){this.socket.traceSocketEvent(u,I)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._flowManager.writeMessage(u)}_write(u,I){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let D=2;u.byteLength<126?D+=0:u.byteLength<2**16?D+=2:D+=8;const T=w.VSBuffer.alloc(D);if(I?T.writeUInt8(194,0):T.writeUInt8(130,0),u.byteLength<126)T.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){T.writeUInt8(126,1);let N=1;T.writeUInt8(u.byteLength>>>8&255,++N),T.writeUInt8(u.byteLength>>>0&255,++N)}else{T.writeUInt8(127,1);let N=1;T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(u.byteLength>>>24&255,++N),T.writeUInt8(u.byteLength>>>16&255,++N),T.writeUInt8(u.byteLength>>>8&255,++N),T.writeUInt8(u.byteLength>>>0&255,++N)}this.socket.write(w.VSBuffer.concat([T,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const I=this._incomingData.peek(this._state.readLen),D=I.readUInt8(0),T=(D&128)>>>7,N=(D&64)>>>6,U=I.readUInt8(1),$=(U&128)>>>7,Y=U&127;this._state.state=2,this._state.readLen=2+($?4:0)+(Y===126?2:0)+(Y===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(N)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const I=this._incomingData.read(this._state.readLen),D=I.readUInt8(1),T=(D&128)>>>7;let N=D&127,U=1;N===126?N=I.readUInt8(++U)*2**8+I.readUInt8(++U):N===127&&(N=I.readUInt8(++U)*0+I.readUInt8(++U)*0+I.readUInt8(++U)*0+I.readUInt8(++U)*0+I.readUInt8(++U)*2**24+I.readUInt8(++U)*2**16+I.readUInt8(++U)*2**8+I.readUInt8(++U));let $=0;T&&($=I.readUInt8(++U)*2**24+I.readUInt8(++U)*2**16+I.readUInt8(++U)*2**8+I.readUInt8(++U)),this._state.state=3,this._state.readLen=N,this._state.mask=$,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const I=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),d(I,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(I,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class C extends R.Disposable{constructor(u,I,D,T,N,U){super(),this._tracer=u,this._onData=N,this._writeFn=U,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,I?(this._zlibInflateStream=this._register(new p(this._tracer,T,D,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError($=>this._onError.fire($))),this._register(this._zlibDeflateStream.onError($=>this._onError.fire($)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:w.VSBuffer.alloc(0)}writeMessage(u){this._writeQueue.push(u),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const u=this._writeQueue.shift();if(this._zlibDeflateStream){const I=await this._deflateMessage(this._zlibDeflateStream,u);this._writeFn(I,!0)}else this._writeFn(u,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(u,I){return new Promise((D,T)=>{u.write(I),u.flush(N=>D(N))})}acceptFrame(u,I,D){this._readQueue.push({data:u,isCompressed:I,isLastFrameOfMessage:D}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const u=this._readQueue.shift();if(this._zlibInflateStream&&u.isCompressed){const I=await this._inflateFrame(this._zlibInflateStream,u.data,u.isLastFrameOfMessage);this._onData.fire(I)}else this._onData.fire(u.data)}this._isProcessingReadQueue=!1}}_inflateFrame(u,I,D){return new Promise((T,N)=>{u.write(I),D&&u.write(w.VSBuffer.fromByteArray([0,0,255,255])),u.flush(U=>T(U))})}}class p extends R.Disposable{constructor(u,I,D,T){super(),this._tracer=u,this._recordInflateBytes=I,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=y().zlib.createInflateRaw(T),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent("zlibInflateData",N),this._pendingInflateData.push(w.VSBuffer.wrap(N))}),D&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?w.VSBuffer.concat(this._recordedInflateBytes):w.VSBuffer.alloc(0)}write(u){this._recordInflateBytes&&this._recordedInflateBytes.push(u.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",u),this._zlibInflate.write(u.buffer)}flush(u){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const I=w.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,u(I)})}}class v extends R.Disposable{constructor(u,I){super(),this._tracer=u,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=y().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",D=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibDeflate.on("data",D=>{this._tracer.traceSocketEvent("zlibDeflateData",D),this._pendingDeflateData.push(w.VSBuffer.wrap(D))})}write(u){this._tracer.traceSocketEvent("zlibDeflateWrite",u.buffer),this._zlibDeflate.write(u.buffer)}flush(u){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let I=w.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,I=I.slice(0,I.byteLength-4),u(I)})}}function d(c,u){if(u===0)return;const I=c.byteLength>>>2;for(let Y=0;Y<I;Y++){const oe=c.readUInt32BE(Y*4);c.writeUInt32BE(oe^u,Y*4)}const D=I*4,T=c.byteLength-D,N=u>>>24&255,U=u>>>16&255,$=u>>>8&255;T>=1&&c.writeUInt8(c.readUInt8(D)^N,D),T>=2&&c.writeUInt8(c.readUInt8(D+1)^U,D+1),T>=3&&c.writeUInt8(c.readUInt8(D+2)^$,D+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const f={[2]:107,[1]:103};function a(){const c=(0,l.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):u=(0,M.join)(y().os.tmpdir(),`vscode-ipc-${c}.sock`),o(u),u}e.createRandomIPCHandle=a;function i(c,u,I){const D=y().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${I}-${u}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${I}-${u}.sock`):T=(0,M.join)(c,`${I}-${u}.sock`),o(T),T}e.createStaticIPCHandle=i;function o(c){const u=f[E.platform];typeof u=="number"&&c.length>=u&&console.warn(`WARNING: IPC handle "${c}" is longer than ${u} chars, try a shorter --user-data-dir`)}class n extends m.IPCServer{constructor(u){super(n.toClientConnectionEvent(u)),this.server=u}static toClientConnectionEvent(u){const I=k.Event.fromNodeEventEmitter(u,"connection");return k.Event.map(I,D=>({protocol:new P.Protocol(new S(D,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(D,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function r(c){return new Promise((u,I)=>{const D=y().net.createServer();D.on("error",I),D.listen(c,()=>{D.removeListener("error",I),u(new n(D))})})}e.serve=r;function s(c,u){return new Promise((I,D)=>{const T=y().net.createConnection(c,()=>{T.removeListener("error",D),I(P.Client.fromSocket(new S(T,`ipc-client${u}`),u))});T.once("error",D)})}e.connect=s}),define(Z[102],ee([0,1,8,3,2,12]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));function E(y){const S=y;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var l;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(l=e.StorageState||(e.StorageState={}));class m extends k.Disposable{constructor(S,g=Object.create(null)){super(),this.database=S,this.options=g,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new w.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((g,h)=>this.accept(h,g)),S.deleted?.forEach(g=>this.accept(g,void 0))}accept(S,g){if(this.state===l.Closed)return;let h=!1;(0,R.isUndefinedOrNull)(g)?h=this.cache.delete(S):this.cache.get(S)!==g&&(this.cache.set(S,g),h=!0),h&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,g){const h=this.cache.get(S);return(0,R.isUndefinedOrNull)(h)?g:h}getBoolean(S,g){const h=this.get(S);return(0,R.isUndefinedOrNull)(h)?g:h==="true"}getNumber(S,g){const h=this.get(S);return(0,R.isUndefinedOrNull)(h)?g:parseInt(h,10)}async set(S,g){if(this.state===l.Closed)return;if((0,R.isUndefinedOrNull)(g))return this.delete(S);const h=String(g);if(this.cache.get(S)!==h)return this.cache.set(S,h),this.pendingInserts.set(S,h),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===l.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((g,h)=>this.items.set(h,g)),S.delete?.forEach(g=>this.items.delete(g))}async close(){}}e.InMemoryStorageDatabase=P}),define(Z[147],ee([0,1,8,3,31,9,23]),function(q,e,w,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class E{constructor(P,y=Object.create(null)){this.path=P,this.options=y,this.name=(0,R.basename)(this.path),this.logger=new l(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const P=await this.whenConnected,y=new Map;return(await this.all(P,"SELECT * FROM ItemTable")).forEach(g=>y.set(g.key,g.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${y.size} rows`),y}async updateItems(P){const y=await this.whenConnected;return this.doUpdateItems(y,P)}doUpdateItems(P,y){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${y.insert?(0,k.mapToString)(y.insert):"0"}), delete(${y.delete?(0,k.setToString)(y.delete):"0"})`),this.transaction(P,()=>{const S=y.insert,g=y.delete;if(S&&S.size>0){const h=[];h.push([]);let b=0;S.forEach((C,p)=>{let v=h[b];v.length>E.MAX_HOST_PARAMETERS&&(b++,v=[],h.push(v)),v.push(p,C)}),h.forEach(C=>{this.prepare(P,`INSERT INTO ItemTable VALUES ${new Array(C.length/2).fill("(?,?)").join(",")}`,p=>p.run(C),()=>{const p=[];let v=0;return S.forEach((d,f)=>{p.push(f),v+=d.length}),`Keys: ${p.join(", ")} Length: ${v}`})})}if(g&&g.size){const h=[];h.push([]);let b=0;g.forEach(C=>{let p=h[b];p.length>E.MAX_HOST_PARAMETERS&&(b++,p=[],h.push(p)),p.push(C)}),h.forEach(C=>{this.prepare(P,`DELETE FROM ItemTable WHERE key IN (${new Array(C.length).fill("?").join(",")})`,p=>p.run(C),()=>{const p=[];return g.forEach(v=>{p.push(v)}),`Keys: ${p.join(", ")}`})})}})}async close(P){this.logger.trace(`[storage ${this.name}] close()`);const y=await this.whenConnected;return this.doClose(y,P)}doClose(P,y){return new Promise((S,g)=>{P.db.close(h=>(h&&this.handleSQLiteError(P,`[storage ${this.name}] close(): ${h}`),this.path===E.IN_MEMORY_PATH?S():!P.isErroneous&&!P.isInMemory?this.backup().then(S,b=>(this.logger.error(`[storage ${this.name}] backup(): ${b}`),S())):typeof y=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(b=>{const C=()=>this.doClose(b,void 0);return this.doUpdateItems(b,{insert:y()}).then(()=>C(),p=>(C(),Promise.reject(p)))})).then(S,g):g(h||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const P=this.toBackupPath(this.path);return M.Promises.copy(this.path,P,{preserveSymlinks:!1})}toBackupPath(P){return`${P}.backup`}async checkIntegrity(P){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${P})`);const y=await this.whenConnected,S=await this.get(y,P?"PRAGMA integrity_check":"PRAGMA quick_check"),g=P?S.integrity_check:S.quick_check;return y.isErroneous?`${g} (last error: ${y.lastError})`:y.isInMemory?`${g} (in-memory!)`:g}async connect(P,y=!0){this.logger.trace(`[storage ${this.name}] open(${P}, retryOnBusy: ${y})`);try{return await this.doConnect(P)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&y)return await(0,w.timeout)(E.BUSY_OPEN_TIMEOUT),this.connect(P,!1);try{await M.Promises.unlink(P);try{await M.Promises.rename(this.toBackupPath(P),P)}catch{}return await this.doConnect(P)}catch(g){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${g}`),this.doConnect(E.IN_MEMORY_PATH)}}}handleSQLiteError(P,y){P.isErroneous=!0,P.lastError=y,this.logger.error(y)}doConnect(P){return new Promise((y,S)=>{new Promise((g,h)=>{q(["@vscode/sqlite3"],g,h)}).then(g=>{const h={db:new(this.logger.isTracing?g.verbose().Database:g.Database)(P,b=>b?h.db&&b.code!=="SQLITE_CANTOPEN"?h.db.close(()=>S(b)):S(b):this.exec(h,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(h),C=>h.db.close(()=>S(C)))),isInMemory:P===E.IN_MEMORY_PATH};h.db.on("error",b=>this.handleSQLiteError(h,`[storage ${this.name}] Error (event): ${b}`)),this.logger.isTracing&&h.db.on("trace",b=>this.logger.trace(`[storage ${this.name}] Trace (event): ${b}`))},S)})}exec(P,y){return new Promise((S,g)=>{P.db.exec(y,h=>h?(this.handleSQLiteError(P,`[storage ${this.name}] exec(): ${h}`),g(h)):S())})}get(P,y){return new Promise((S,g)=>{P.db.get(y,(h,b)=>h?(this.handleSQLiteError(P,`[storage ${this.name}] get(): ${h}`),g(h)):S(b))})}all(P,y){return new Promise((S,g)=>{P.db.all(y,(h,b)=>h?(this.handleSQLiteError(P,`[storage ${this.name}] all(): ${h}`),g(h)):S(b))})}transaction(P,y){return new Promise((S,g)=>{P.db.serialize(()=>{P.db.run("BEGIN TRANSACTION"),y(),P.db.run("END TRANSACTION",h=>h?(this.handleSQLiteError(P,`[storage ${this.name}] transaction(): ${h}`),g(h)):S())})})}prepare(P,y,S,g){const h=P.db.prepare(y),b=C=>{this.handleSQLiteError(P,`[storage ${this.name}] prepare(): ${C} (${y}). Details: ${g()}`)};h.on("error",b),S(h),h.finalize(C=>{C&&b(C),h.removeListener("error",b)})}}e.SQLiteStorageDatabase=E,E.IN_MEMORY_PATH=":memory:",E.BUSY_OPEN_TIMEOUT=2e3,E.MAX_HOST_PARAMETERS=256;class l{constructor(P){P&&typeof P.logTrace=="function"&&process.env[l.VSCODE_TRACE_STORAGE]&&(this.logTrace=P.logTrace),P&&typeof P.logError=="function"&&(this.logError=P.logError)}get isTracing(){return!!this.logTrace}trace(P){this.logTrace?.(P)}error(P){this.logError?.(P)}}l.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[148],ee([11,10]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(Z[149],ee([11,10]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[150],ee([11,10]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[151],ee([11,10]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(Z[152],ee([11,10]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(Z[153],ee([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[154],ee([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[155],ee([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[156],ee([11,10]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[157],ee([11,10]),function(q,e){return q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[158],ee([11,10]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(Z[159],ee([11,10]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(Z[160],ee([11,10]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(Z[161],ee([11,10]),function(q,e){return q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[162],ee([11,10]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[163],ee([11,10]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[164],ee([11,10]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[165],ee([11,10]),function(q,e){return q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[166],ee([11,10]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(Z[167],ee([11,10]),function(q,e){return q.create("vs/platform/shell/node/shellEnv",e)}),define(Z[168],ee([11,10]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[169],ee([11,10]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[170],ee([11,10]),function(q,e){return q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[171],ee([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(Z[172],ee([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[173],ee([11,10]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(Z[174],ee([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[175],ee([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[176],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function w(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=w;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(Z[177],ee([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(M){return typeof M?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function k(M){let E=[];try{Array.isArray(M.workspaces)&&(E=M.workspaces.map(l=>({workspace:{id:l.id,configPath:w.URI.parse(l.configURIPath)},remoteAuthority:l.remoteAuthority})))}catch{}return E}e.deserializeWorkspaceInfos=k;function R(M){let E=[];try{Array.isArray(M.folders)&&(E=M.folders.map(l=>({folderUri:w.URI.parse(l.folderUri),remoteAuthority:l.remoteAuthority})))}catch{}return E}e.deserializeFolderInfos=R}),define(Z[178],ee([0,1,3,2]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new w.Emitter,this._onReloadEmitter=new w.Emitter,this._onTerminateEmitter=new w.Emitter,this._onAttachEmitter=new w.Emitter}call(E,l,m){switch(l){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(E,l,m){switch(l){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(E){super(),this.channel=E}reload(E){this.channel.call("reload",[E])}get onReload(){return this.channel.listen("reload")}close(E){this.channel.call("close",[E])}get onClose(){return this.channel.listen("close")}attachSession(E,l,m){this.channel.call("attach",[E,l,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(E,l){this.channel.call("terminate",[E,l])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(E,l){return this.channel.call("openExtensionDevelopmentHostWindow",[E,l])}}e.ExtensionHostDebugChannelClient=R}),define(Z[179],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class w{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>q(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=w}),define(Z[180],ee([0,1,133,53,13,9,33,16,7]),function(q,e,w,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{constructor(b,C,p){this._args=b,this.paths=C,this.productService=p,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",q).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,E.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const b=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",b)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return l.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(l.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const b=M.env.VSCODE_PORTABLE;return b?l.URI.file((0,R.join)(b,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const b=this.args["builtin-extensions-dir"];return b?(0,R.resolve)(b):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const b=this.args["extensions-download-dir"];return b?(0,R.resolve)(b):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const b=this.args["extensions-dir"];if(b)return(0,R.resolve)(b);const C=M.env.VSCODE_EXTENSIONS;if(C)return C;const p=M.env.VSCODE_PORTABLE;return p?(0,R.join)(p,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const b=this.args.extensionDevelopmentPath;if(Array.isArray(b))return b.map(C=>/^[^:/?#]+?:\/\//.test(C)?l.URI.parse(C):l.URI.file((0,R.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(b=>b==="ui"||b==="workspace"||b==="web"?b:"workspace")}get extensionTestsLocationURI(){const b=this.args.extensionTestsPath;if(b)return/^[^:/?#]+?:\/\//.test(b)?l.URI.parse(b):l.URI.file((0,R.normalize)(b))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const b=this.args["disable-extension"];if(b){if(typeof b=="string")return[b];if(Array.isArray(b)&&b.length>0)return b}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,E.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return l.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return l.URI.file((0,R.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const b=M.env.VSCODE_PORTABLE;return b?l.URI.file((0,R.join)(b,"policy.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}ve([t.memoize],m.prototype,"appRoot",null),ve([t.memoize],m.prototype,"userHome",null),ve([t.memoize],m.prototype,"userDataPath",null),ve([t.memoize],m.prototype,"appSettingsHome",null),ve([t.memoize],m.prototype,"tmpDir",null),ve([t.memoize],m.prototype,"cacheHome",null),ve([t.memoize],m.prototype,"stateResource",null),ve([t.memoize],m.prototype,"userRoamingDataHome",null),ve([t.memoize],m.prototype,"userDataSyncHome",null),ve([t.memoize],m.prototype,"userDataSyncLogResource",null),ve([t.memoize],m.prototype,"editSessionsLogResource",null),ve([t.memoize],m.prototype,"sync",null),ve([t.memoize],m.prototype,"machineSettingsResource",null),ve([t.memoize],m.prototype,"workspaceStorageHome",null),ve([t.memoize],m.prototype,"localHistoryHome",null),ve([t.memoize],m.prototype,"keyboardLayoutResource",null),ve([t.memoize],m.prototype,"argvResource",null),ve([t.memoize],m.prototype,"isExtensionDevelopment",null),ve([t.memoize],m.prototype,"untitledWorkspacesHome",null),ve([t.memoize],m.prototype,"installSourcePath",null),ve([t.memoize],m.prototype,"builtinExtensionsPath",null),ve([t.memoize],m.prototype,"extensionsPath",null),ve([t.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ve([t.memoize],m.prototype,"extensionDevelopmentKind",null),ve([t.memoize],m.prototype,"extensionTestsLocationURI",null),ve([t.memoize],m.prototype,"debugExtensionHost",null),ve([t.memoize],m.prototype,"serviceMachineIdResource",null),ve([t.memoize],m.prototype,"telemetryLogResource",null),ve([t.memoize],m.prototype,"disableWorkspaceTrust",null),ve([t.memoize],m.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=m;function P(h,b){return g(h["inspect-extensions"],h["inspect-brk-extensions"],5870,b,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=P;function y(h,b){return g(h["inspect-search"],h["inspect-brk-search"],5876,b,h.extensionEnvironment)}e.parseSearchPort=y;function S(h,b){return g(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,b,h.extensionEnvironment)}e.parsePtyHostPort=S;function g(h,b,C,p,v,d){const a=Number(b||h)||(p?null:C),i=a?Boolean(!!b):!1;let o;if(d)try{o=JSON.parse(d)}catch{}return{port:a,break:i,debugId:v,env:o}}}),define(Z[103],ee([0,1,275,4,151]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},category:{type:"string",cat:"e",description:(0,k.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(h,b,C=M){const p={},v=["_"],d=[];for(const o in b){const n=b[o];n.alias&&(p[o]=n.alias),n.type==="string"||n.type==="string[]"?(v.push(o),n.deprecates&&v.push(...n.deprecates)):n.type==="boolean"&&(d.push(o),n.deprecates&&d.push(...n.deprecates))}const f=w(h,{string:v,boolean:d,alias:p}),a={},i=f;a._=f._.map(o=>String(o)).filter(o=>o.length>0),delete i._;for(const o in b){const n=b[o];n.alias&&delete i[n.alias];let r=i[o];if(n.deprecates)for(const s of n.deprecates)i.hasOwnProperty(s)&&(r||(r=i[s],r&&C.onDeprecatedOption(s,n.deprecationMessage||(0,k.localize)(35,null,o))),delete i[s]);if(typeof r<"u"){if(n.type==="string[]"){if(Array.isArray(r)||(r=[r]),!n.allowEmptyValue){const s=r.filter(c=>c.length>0);s.length!==r.length&&(C.onEmptyValue(o),r=s.length>0?s:void 0)}}else n.type==="string"&&(Array.isArray(r)?(r=r.pop(),C.onMultipleValues(o,r)):!r&&!n.allowEmptyValue&&(C.onEmptyValue(o),r=void 0));a[o]=r,n.deprecationMessage&&C.onDeprecatedOption(o,n.deprecationMessage)}delete i[o]}for(const o in i)C.onUnknownOption(o);return a}e.parseArgs=E;function l(h,b){let C="";return b.args&&(Array.isArray(b.args)?C=` <${b.args.join("> <")}>`:C=` <${b.args}>`),b.alias?`-${b.alias} --${h}${C}`:`--${h}${C}`}function m(h,b){let C=0;const p=[];for(const a in h){const i=h[a],o=l(a,i);C=Math.max(C,o.length),p.push([o,i.description])}const v=C+2+1;if(b-v<25)return p.reduce((a,i)=>a.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const d=b-v-1,f=[];for(const a of p){const i=a[0],o=y(a[1],d),n=P(v-i.length-2);f.push("  "+i+n+o[0]);for(let r=1;r<o.length;r++)f.push(P(v)+o[r])}return f}e.formatOptions=m;function P(h){return" ".repeat(h)}function y(h,b){const C=[];for(;h.length;){const p=h.length<b?h.length:h.lastIndexOf(" ",b),v=h.slice(0,p).trim();h=h.slice(p),C.push(v)}return C}function S(h,b,C,p,v){const d=process.stdout.isTTY&&process.stdout.columns||80,f=v?.noInputFiles!==!0?`[${(0,k.localize)(36,null)}...]`:"",a=[`${h} ${C}`];a.push(""),a.push(`${(0,k.localize)(37,null)}: ${b} [${(0,k.localize)(38,null)}]${f}`),a.push(""),v?.noPipe!==!0&&(t.isWindows?a.push((0,k.localize)(39,null,b)):a.push((0,k.localize)(40,null,b)),a.push(""));const i={};for(const o in p){const n=p[o];if(n.description&&n.cat){let r=i[n.cat];r||(i[n.cat]=r={}),r[o]=n}}for(const o in i){const n=o,r=i[n];r&&(a.push(R[n]),a.push(...m(r,d)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=S;function g(h,b){return`${h||(0,k.localize)(41,null)}
${b||(0,k.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=g}),define(Z[181],ee([0,1,77,178,103]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(E,l){super(),this.windowsMainService=E,this.userDataProfilesMainService=l}call(E,l,m){return l==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1]):super.call(E,l,m)}async openExtensionDevelopmentHostWindow(E,l){const m=(0,k.parseArgs)(E,k.OPTIONS);m.debugRenderer=l;const P=m.extensionDevelopmentPath;if(!P)return{success:!1};const[y]=await this.windowsMainService.openExtensionDevelopmentHostWindow(P,{context:5,cli:m,profile:await this.userDataProfilesMainService.checkAndCreateProfileFromCli(m)});if(!l)return{success:!0};const S=y.win;if(!S)return{success:!0};const g=S.webContents.debugger;let h=g.isAttached()?1/0:0;const b=(0,w.createServer)(C=>{h++===0&&g.attach();let p=!1;const v=a=>{p||C.write(JSON.stringify(a)+"\0")},d=(a,i,o,n)=>v({method:i,params:o,sessionId:n});S.on("close",()=>{g.removeListener("message",d),C.end(),p=!0}),g.addListener("message",d);let f=Buffer.alloc(0);C.on("data",a=>{f=Buffer.concat([f,a]);for(let i=f.indexOf(0);i!==-1;i=f.indexOf(0)){let o;try{const n=f.slice(0,i).toString("utf8");f=f.slice(i+1),o=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}g.sendCommand(o.method,o.params,o.sessionId).then(n=>v({id:o.id,sessionId:o.sessionId,result:n})).catch(n=>v({id:o.id,sessionId:o.sessionId,error:{code:0,message:n.message}}))}}),C.on("error",a=>{console.error("error on cdp pipe:",a)}),C.on("close",()=>{p=!0,--h===0&&g.detach()})});return await new Promise(C=>b.listen(0,C)),S.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(Z[59],ee([0,1,276,152,103]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function M(S,g){const h={onUnknownOption:C=>{console.warn((0,t.localize)(0,null,C))},onMultipleValues:(C,p)=>{console.warn((0,t.localize)(1,null,C,p))},onEmptyValue:C=>{console.warn((0,t.localize)(2,null,C))},onDeprecatedOption:(C,p)=>{console.warn((0,t.localize)(3,null,C,p))}},b=(0,k.parseArgs)(S,k.OPTIONS,g?h:void 0);return b.goto&&b._.forEach(C=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(C),(0,t.localize)(4,null))),b["max-memory"]&&w(parseInt(b["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),b}function E(S){const g=S.findIndex(h=>!/^-/.test(h));if(g>-1)return[...S.slice(0,g),...S.slice(g+1)]}function l(S){let[,...g]=S;process.env.VSCODE_DEV&&(g=E(g)||[]);const h=!y(process.env);return M(g,h)}e.parseMainProcessArgv=l;function m(S){const[,,...g]=S;return M(g,!0)}e.parseCLIProcessArgv=m;function P(S,...g){const h=S.indexOf("--");return h===-1?S.push(...g):S.splice(h,0,...g),S}e.addArg=P;function y(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=y}),function(){"use strict";function q(e,w,t,k){function R(E){const l=M(E),m=[l];return e.isAbsolute(l)||m.unshift(k),e.resolve(...m)}function M(E){const l=process.env.VSCODE_PORTABLE;if(l)return e.join(l,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,t);const P=E["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(y,"AppData","Roaming")}break;case"darwin":m=e.join(w.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,t)}return{getUserDataPath:R}}if(typeof define=="function")define(Z[182],ee([0,183,28,13,16,33]),function(e,w,t,k,R,M){const E=R.dirname(k.FileAccess.asFileUri("",e)),l=e.__$__nodeRequire(R.joinPath(E,"package.json").fsPath);return q(w,t,l.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),w=require("path"),t=require("os");module.exports=q(w,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[184],ee([0,1,28,180,182]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(E,l){super(E,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,k.getUserDataPath)(E)},l)}}e.NativeEnvironmentService=R}),define(Z[185],ee([0,1,40,28,30]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(M){const E=(0,k.randomPath)((0,t.tmpdir)());try{return(0,w.writeFileSync)(E,""),M&&console.log(`Marker file for --wait created: ${E}`),E}catch(l){M&&console.error(`Failed to create marker file for --wait: ${l}`);return}}e.createWaitMarkerFileSync=R}),define(Z[186],ee([0,1,12,154]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(M,E,l){try{R(M,E,l)}catch{}return M}e.localizeManifest=k;function R(M,E,l){const m=(P,y,S)=>{const g=P[y];if((0,w.isString)(g)){const h=g,b=h.length;if(b>1&&h[0]==="%"&&h[b-1]==="%"){const C=h.substr(1,b-2);let p=E[C];p===void 0&&l&&(p=l[C]);const v=typeof p=="string"?p:p.message;if(v!==void 0){const d=l?.[C],f=typeof d=="string"?d:d?.message;if(S&&(y==="title"||y==="category")&&f&&f!==v){const a={value:v,original:f};P[y]=a}else P[y]=v}else console.warn(`[${M.name}]: ${(0,t.localize)(0,null,C)}`)}}else if((0,w.isObject)(g))for(const h in g)g.hasOwnProperty(h)&&(h==="commands"?m(g,h,!0):m(g,h,S));else if(Array.isArray(g))for(let h=0;h<g.length;h++)m(g,h,S)};for(const P in M)M.hasOwnProperty(P)&&m(M,P)}}),define(Z[187],ee([0,1,16,96,156,188]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function l(p){return p=p.trim(),p==="*"||M.test(p)}e.isValidVersionStr=l;function m(p){if(!l(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=p.match(M);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=m;function P(p){if(!p)return null;const v=p.majorBase,d=p.majorMustEqual,f=p.minorBase;let a=p.minorMustEqual;const i=p.patchBase;let o=p.patchMustEqual;p.hasCaret&&(v===0||(a=!1),o=!1);let n=0;if(p.preRelease){const r=E.exec(p.preRelease);if(r){const[,s,c,u]=r;n=Date.UTC(Number(s),Number(c)-1,Number(u))}}return{majorBase:v,majorMustEqual:d,minorBase:f,minorMustEqual:a,patchBase:i,patchMustEqual:o,isMinimum:p.hasGreaterEquals,notBefore:n}}e.normalizeVersion=P;function y(p,v,d){let f;typeof p=="string"?f=P(m(p)):f=p;let a;v instanceof Date?a=v.getTime():typeof v=="string"&&(a=new Date(v).getTime());let i;if(typeof d=="string"?i=P(m(d)):i=d,!f||!i)return!1;const o=f.majorBase,n=f.minorBase,r=f.patchBase;let s=i.majorBase,c=i.minorBase,u=i.patchBase;const I=i.notBefore;let D=i.majorMustEqual,T=i.minorMustEqual,N=i.patchMustEqual;return i.isMinimum?o>s?!0:o<s?!1:n>c?!0:n<c||a&&a<I?!1:r>=u:(o===1&&s===0&&(!D||!T||!N)&&(s=1,c=0,u=0,D=!0,T=!1,N=!1),o<s?!1:o>s?!D:n<c?!1:n>c?!T:r<u?!1:r>u?!N:!(a&&a<I))}e.isValidVersion=y;function S(p,v,d,f,a){const i=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return i.push([t.default.Error,k.localize(0,null)]),i;if(typeof f.name!="string")return i.push([t.default.Error,k.localize(1,null,"name")]),i;if(typeof f.version!="string")return i.push([t.default.Error,k.localize(2,null,"version")]),i;if(!f.engines)return i.push([t.default.Error,k.localize(3,null,"engines")]),i;if(typeof f.engines.vscode!="string")return i.push([t.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof f.extensionDependencies<"u"&&!C(f.extensionDependencies))return i.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof f.activationEvents<"u"){if(!C(f.activationEvents))return i.push([t.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof f.main>"u"&&typeof f.browser>"u")return i.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&i.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return i.push([t.default.Error,k.localize(9,null,"main")]),i;{const r=(0,w.joinPath)(d,f.main);(0,w.isEqualOrParent)(r,d)||i.push([t.default.Warning,k.localize(10,null,r.path,d.path)])}if(typeof f.activationEvents>"u")return i.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof f.browser<"u"){if(typeof f.browser!="string")return i.push([t.default.Error,k.localize(12,null,"browser")]),i;{const r=(0,w.joinPath)(d,f.browser);(0,w.isEqualOrParent)(r,d)||i.push([t.default.Warning,k.localize(13,null,r.path,d.path)])}if(typeof f.activationEvents>"u")return i.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(f.version))return i.push([t.default.Error,k.localize(15,null)]),i;const o=[];if(!g(p,v,f,a,o))for(const r of o)i.push([t.default.Error,r]);return i}e.validateExtensionManifest=S;function g(p,v,d,f,a){return f||typeof d.main>"u"&&typeof d.browser>"u"?!0:b(p,v,d.engines.vscode,a)}e.isValidExtensionVersion=g;function h(p,v,d){return p==="*"||b(v,d,p)}e.isEngineValid=h;function b(p,v,d,f=[]){const a=P(m(d));if(!a)return f.push(k.localize(16,null,d)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return f.push(k.localize(17,null,d)),!1}else if(!a.majorMustEqual)return f.push(k.localize(18,null,d)),!1;return y(p,v,a)?!0:(f.push(k.localize(19,null,p,d)),!1)}function C(p){if(!Array.isArray(p))return!1;for(let v=0,d=p.length;v<d;v++)if(typeof p[v]!="string")return!1;return!0}}),define(Z[189],ee([0,1,18,29]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,M,E){let l=E&&E.get("storage.serviceMachineId",-1)||null;if(l)return l;try{const P=(await M.readFile(R.serviceMachineIdResource)).value.toString();l=(0,t.isUUID)(P)?P:null}catch{l=null}if(!l){l=(0,t.generateUuid)();try{await M.writeFile(R.serviceMachineIdResource,w.VSBuffer.fromString(l))}catch{}}return E?.store("storage.serviceMachineId",l,-1,1),l}e.getServiceMachineId=k}),define(Z[68],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(k,R=[],M=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=w}),define(Z[190],ee([0,1,68]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function R(E,l,m){l instanceof w.SyncDescriptor||(l=new w.SyncDescriptor(l,[],Boolean(m))),t.push([E,l])}e.registerSingleton=R;function M(){return t}e.getSingletonServiceDescriptors=M}),define(Z[191],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(R,M){this.key=R,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.Node=w;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const M of this._nodes.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const E=this.lookupOrInsertNode(R),l=this.lookupOrInsertNode(M);E.outgoing.set(l.key,l),l.incoming.set(E.key,E)}removeNode(R){const M=this._hashFn(R);this._nodes.delete(M);for(const E of this._nodes.values())E.outgoing.delete(M),E.incoming.delete(M)}lookupOrInsertNode(R){const M=this._hashFn(R);let E=this._nodes.get(M);return E||(E=new w(M,R),this._nodes.set(M,E)),E}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[M,E]of this._nodes)R.push(`${M}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this._nodes){const E=new Set([R]),l=this._findCycle(M,E);if(l)return l}}_findCycle(R,M){for(const[E,l]of R.outgoing){if(M.has(E))return[...M,E].join(" -> ");M.add(E);const m=this._findCycle(l,M);if(m)return m;M.delete(E)}}}e.Graph=t}),define(Z[5],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function E(l){return l[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=E})(w=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(M,E,l){E[w.DI_TARGET]===E?E[w.DI_DEPENDENCIES].push({id:M,index:l}):(E[w.DI_DEPENDENCIES]=[{id:M,index:l}],E[w.DI_TARGET]=E)}function k(M){if(w.serviceIds.has(M))return w.serviceIds.get(M);const E=function(l,m,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(E,l,P)};return E.toString=()=>M,w.serviceIds.set(M,E),E}e.createDecorator=k;function R(M){return M}e.refineServiceDecorator=R}),define(Z[60],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,w.createDecorator)("backupMainService")}),define(Z[19],ee([0,1,12,7,5]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationOverrides=R;function M(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=M;var E;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function l(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=l;function m(p,v){const d=Object.create(null);for(const f in p)P(d,f,p[f],v);return d}e.toValuesTree=m;function P(p,v,d,f){const a=v.split("."),i=a.pop();let o=p;for(let n=0;n<a.length;n++){const r=a[n];let s=o[r];switch(typeof s){case"undefined":s=o[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${v} as ${a.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[i]=d}catch{f(`Ignoring ${v} as ${a.join(".")} is ${JSON.stringify(o)}`)}else f(`Ignoring ${v} as ${a.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=P;function y(p,v){const d=v.split(".");S(p,d)}e.removeFromValueTree=y;function S(p,v){const d=v.shift();if(v.length===0){delete p[d];return}if(Object.keys(p).indexOf(d)!==-1){const f=p[d];typeof f=="object"&&!Array.isArray(f)&&(S(f,v),Object.keys(f).length===0&&delete p[d])}}function g(p,v,d){function f(o,n){let r=o;for(const s of n){if(typeof r!="object"||r===null)return;r=r[s]}return r}const a=v.split("."),i=f(p,a);return typeof i>"u"?d:i}e.getConfigurationValue=g;function h(p,v,d){Object.keys(v).forEach(f=>{f!=="__proto__"&&(f in p?w.isObject(p[f])&&w.isObject(v[f])?h(p[f],v[f],d):d&&(p[f]=v[f]):p[f]=v[f])})}e.merge=h;function b(p,v,d){const f=p.inspect(v),a=p.inspect(d);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof a.userValue<"u"||typeof a.workspaceValue<"u"||typeof a.workspaceFolderValue<"u"?a.value:f.defaultValue}e.getMigratedSettingValue=b;function C(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=C}),define(Z[69],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,w.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,w.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,M){return this.secretVault[R]?.[M]??null}async setPassword(R,M,E){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][M]=E}async deletePassword(R,M){return this.secretVault[R]?.[M]?(delete this.secretVault[R][M],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const M=[];for(const E of Object.keys(this.secretVault[R]||{}))M.push({account:E,password:this.secretVault[R][E]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(Z[84],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(M,E){return{}}async getSystemInfo(M,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,E){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=k}),define(Z[104],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService")}),define(Z[35],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[26],ee([0,1,53,9,83,35,184,5]),function(q,e,w,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,E.refineServiceDecorator)(R.IEnvironmentService);class l extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([w.memoize],l.prototype,"cachedLanguagesPath",null),ve([w.memoize],l.prototype,"backupHome",null),ve([w.memoize],l.prototype,"mainIPCHandle",null),ve([w.memoize],l.prototype,"mainLockfile",null),ve([w.memoize],l.prototype,"disableUpdates",null),ve([w.memoize],l.prototype,"disableKeytar",null),ve([w.memoize],l.prototype,"crossOriginIsolated",null),ve([w.memoize],l.prototype,"codeCachePath",null),ve([w.memoize],l.prototype,"useCodeCache",null),e.EnvironmentMainService=l}),define(Z[192],ee([0,1,153,5]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function M(p,v){switch(p){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function E(p,v){return v==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function l(p,v,d){return E(v,d)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===d?!0:m(d).includes(p)}e.isTargetPlatformCompatible=l;function m(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function P(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=P;var y;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var S;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var g;(function(p){p.Install="install",p.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var h;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var b;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class C extends Error{constructor(v,d){super(v),this.code=d,this.name=d}}e.ExtensionManagementError=C,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,w.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,w.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Z[193],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,w.createDecorator)("extensionUrlTrustService")}),define(Z[194],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,w.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[105],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,w.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,w.createDecorator)("externalTerminal")}),define(Z[195],ee([0,1,45,13,9,4,78,23,82,157,105]),function(q,e,w,t,k,R,M,E,l,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=m.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:g.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class g extends S{openTerminal(f,a){return this.spawnTerminal(w,f,l.getWindowsShell(),a)}spawnTerminal(f,a,i,o){const n=a.windowsExec||g.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const r=k.basename(n).toLowerCase();if(r==="cmder"||r==="cmder.exe")return f.spawn(n,o?[o]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return n.indexOf(" ")>=0&&s.push('""'),s.push(n),(r==="wt"||r==="wt.exe")&&s.push("-d ."),new Promise((c,u)=>{const I=C(process),D=f.spawn(i,s,{cwd:o,env:I});D.on("error",u),D.on("exit",()=>c())})}runInTerminal(f,a,i,o,n){const r="windowsExec"in n&&n.windowsExec?n.windowsExec:g.getDefaultTerminalWindows();return new Promise((s,c)=>{const u=`"${a} - ${y}"`,I=`""${i.join('" "')}" & pause"`,D=["/c","start",u,"/wait",r,"/c",I],T=Object.assign({},C(process),o);Object.keys(T).filter($=>T[$]===null).forEach($=>delete T[$]);const N={cwd:a,env:T,windowsVerbatimArguments:!0};w.spawn(g.CMD,D,N).on("error",$=>{c(p($))}),s(void 0)})}static getDefaultTerminalWindows(){if(!g._DEFAULT_TERMINAL_WINDOWS){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return g._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=g,g.CMD="cmd.exe";class h extends S{openTerminal(f,a){return this.spawnTerminal(w,f,a)}runInTerminal(f,a,i,o,n){const r=n.osxExec||P.DEFAULT_TERMINAL_OSX;return new Promise((s,c)=>{if(r===P.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const u=r===P.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`,q).fsPath,"-t",f||y,"-w",a];for(const U of i)D.push("-a"),D.push(U);if(o){const U=Object.assign({},C(process),o);for(const $ in U){const Y=U[$];Y===null?(D.push("-u"),D.push($)):(D.push("-e"),D.push(`${$}=${Y}`))}}let T="";const N=w.spawn(h.OSASCRIPT,D);N.on("error",U=>{c(p(U))}),N.stderr.on("data",U=>{T+=U.toString()}),N.on("exit",U=>{if(U===0)s(void 0);else if(T){const $=T.split(`
`,1);c(new Error($[0]))}else c(new Error(m.localize(1,null,u,U)))})}else c(new Error(m.localize(2,null,r)))})}spawnTerminal(f,a,i){const o=a.osxExec||P.DEFAULT_TERMINAL_OSX;return new Promise((n,r)=>{const s=["-a",o];i&&s.push(i);const c=C(process),u=f.spawn("/usr/bin/open",s,{cwd:i,env:c});u.on("error",r),u.on("exit",()=>n())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class b extends S{openTerminal(f,a){return this.spawnTerminal(w,f,a)}runInTerminal(f,a,i,o,n){const r=n.linuxExec?Promise.resolve(n.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((s,c)=>{const u=[];r.then(I=>{I.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const D=`${v(i)}; echo; read -p "${b.WAIT_MESSAGE}" -n1;`;u.push(`''${D}''`);const T=Object.assign({},C(process),o);Object.keys(T).filter(Y=>T[Y]===null).forEach(Y=>delete T[Y]);const N={cwd:a,env:T};let U="";const $=w.spawn(I,u,N);$.on("error",Y=>{c(p(Y))}),$.stderr.on("data",Y=>{U+=Y.toString()}),$.on("exit",Y=>{if(Y===0)s(void 0);else if(U){const oe=U.split(`
`,1);c(new Error(oe[0]))}else c(new Error(m.localize(4,null,I,Y)))})})})}static async getDefaultTerminalLinuxReady(){if(!b._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)b._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const f=await E.Promises.exists("/etc/debian_version");b._DEFAULT_TERMINAL_LINUX_READY=new Promise(a=>{f?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return b._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(f,a,i){const o=a.linuxExec?Promise.resolve(a.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((n,r)=>{o.then(s=>{const c=C(process),u=f.spawn(s,[],{cwd:i,env:c});u.on("error",r),u.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=b,b.WAIT_MESSAGE=m.localize(3,null);function C(d){const f={...d.env};return(0,M.sanitizeProcessEnvironment)(f),f}function p(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(m.localize(5,null,d.path)):d}function v(d){let f="";for(const a of d)a.indexOf(" ")>=0?f+='"'+a+'"':f+=a,f+=" ";return f}}),define(Z[14],ee([0,1,31,9,25,12,7,159,5]),function(q,e,w,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,l.createDecorator)("fileService");function m(G){return G.create===!0}e.isFileOpenForWriteOptions=m;var P;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var y;(function(G){G[G.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var S;(function(G){G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(G){return!!(G.capabilities&2)}e.hasReadWriteCapability=g;function h(G){return!!(G.capabilities&8)}e.hasFileFolderCopyCapability=h;function b(G){return!!(G.capabilities&32768)}e.hasFileCloneCapability=b;function C(G){return!!(G.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function p(G){return!!(G.capabilities&16)}e.hasFileReadStreamCapability=p;function v(G){return g(G)?!!(G.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var d;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(d=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(K,F){super(K),this.code=F}}e.FileSystemProviderError=f;function a(G,K){const F=new f(G.toString(),K);return o(F,K),F}e.createFileSystemProviderError=a;function i(G){return G||a((0,E.localize)(0,null),d.Unknown)}e.ensureFileSystemProviderError=i;function o(G,K){return G.name=K?`${K} (FileSystemError)`:"FileSystemError",G}e.markAsFileSystemProviderError=o;function n(G){if(!G)return d.Unknown;if(G instanceof f)return G.code;const K=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!K)return d.Unknown;switch(K[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileExceedsMemoryLimit:return d.FileExceedsMemoryLimit;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}e.toFileSystemProviderErrorCode=n;function r(G){if(G instanceof T)return G.fileOperationResult;switch(n(G)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 10;case d.FileWriteLocked:return 5;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileExceedsMemoryLimit:return 9;case d.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class c{constructor(K,F,A){this.resource=K,this.operation=F,this.target=A}isOperation(K){return this.operation===K}}e.FileOperationEvent=c;var u;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class I{constructor(K,F){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=K;const A=new Map;for(const W of K){const z=A.get(W.type);switch(z?z.push([W.resource,W]):A.set(W.type,[[W.resource,W]]),W.type){case 1:this.rawAdded.push(W.resource);break;case 0:this.rawUpdated.push(W.resource);break;case 2:this.rawDeleted.push(W.resource);break}}for(const[W,z]of A)switch(W){case 1:this.added=w.TernarySearchTree.forUris(()=>F),this.added.fill(z);break;case 0:this.updated=w.TernarySearchTree.forUris(()=>F),this.updated.fill(z);break;case 2:this.deleted=w.TernarySearchTree.forUris(()=>F),this.deleted.fill(z);break}}contains(K,...F){return this.doContains(K,{includeChildren:!1},...F)}affects(K,...F){return this.doContains(K,{includeChildren:!0},...F)}doContains(K,F,...A){if(!K)return!1;const W=A.length>0;return!!((!W||A.includes(1))&&(this.added?.get(K)||F.includeChildren&&this.added?.findSuperstr(K))||(!W||A.includes(0))&&(this.updated?.get(K)||F.includeChildren&&this.updated?.findSuperstr(K))||(!W||A.includes(2))&&(this.deleted?.findSubstr(K)||F.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=I;function D(G,K,F){return!G||!K||G===K||K.length>G.length?!1:(K.charAt(K.length-1)!==t.sep&&(K+=t.sep),F?(0,k.startsWithIgnoreCase)(G,K):G.indexOf(K)===0)}e.isParent=D;class T extends Error{constructor(K,F,A){super(K),this.fileOperationResult=F,this.options=A}}e.FileOperationError=T;class N extends T{constructor(K,F,A){super(K,2,A),this.stat=F}}e.NotModifiedSinceFileOperationError=N;var U;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",G[G.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var $;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})($=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Y(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}e.etag=Y;async function oe(G,K){if(!K.hasProvider(M.URI.from({scheme:G.scheme})))return new Promise(F=>{const A=K.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===G.scheme&&W.added&&(A.dispose(),F())})})}e.whenProviderRegistered=oe,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ue{static formatSize(K){return(0,R.isNumber)(K)||(K=0),K<ue.KB?(0,E.localize)(1,null,K.toFixed(0)):K<ue.MB?(0,E.localize)(2,null,(K/ue.KB).toFixed(2)):K<ue.GB?(0,E.localize)(3,null,(K/ue.MB).toFixed(2)):K<ue.TB?(0,E.localize)(4,null,(K/ue.GB).toFixed(2)):(0,E.localize)(5,null,(K/ue.TB).toFixed(2))}}e.ByteSize=ue,ue.KB=1024,ue.MB=ue.KB*ue.KB,ue.GB=ue.MB*ue.KB,ue.TB=ue.GB*ue.KB;var se;(function(G){G[G.IA32=0]="IA32",G[G.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function he(G){return{maxFileSize:G===0?300*ue.MB:16*ue.GB,maxHeapSize:G===0?700*ue.MB:2*700*ue.MB}}e.getPlatformLimits=he}),define(Z[196],ee([0,1,18,44,17,3,2,58,7,29,14]),function(q,e,w,t,k,R,M,E,l,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class y extends M.Disposable{constructor(g,h){super(),this.channel=g,this.extraCapabilities=h,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,m.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(g){return this.channel.call("stat",[g])}readdir(g){return this.channel.call("readdir",[g])}async readFile(g,h){const{buffer:b}=await this.channel.call("readFile",[g,h]);return b}readFileStream(g,h,b){const C=(0,E.newWriteableStream)(v=>w.VSBuffer.concat(v.map(d=>w.VSBuffer.wrap(d))).buffer),p=this.channel.listen("readFileStream",[g,h])(v=>{if(v instanceof w.VSBuffer)C.write(v.buffer);else{if(v==="end")C.end();else{let d=v;d instanceof Error||(d=(0,P.createFileSystemProviderError)((0,t.toErrorMessage)(d),P.FileSystemProviderErrorCode.Unknown)),C.error(d),C.end()}p.dispose()}});return b.onCancellationRequested(()=>{C.error((0,k.canceled)()),C.end(),p.dispose()}),C}writeFile(g,h,b){return this.channel.call("writeFile",[g,w.VSBuffer.wrap(h),b])}open(g,h){return this.channel.call("open",[g,h])}close(g){return this.channel.call("close",[g])}async read(g,h,b,C,p){const[v,d]=await this.channel.call("read",[g,h,p]);return b.set(v.buffer.slice(0,d),C),d}write(g,h,b,C,p){return this.channel.call("write",[g,h,w.VSBuffer.wrap(b),C,p])}mkdir(g){return this.channel.call("mkdir",[g])}delete(g,h){return this.channel.call("delete",[g,h])}rename(g,h,b){return this.channel.call("rename",[g,h,b])}copy(g,h,b){return this.channel.call("copy",[g,h,b])}cloneFile(g,h){return this.channel.call("cloneFile",[g,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(g=>{if(Array.isArray(g)){const h=g;this._onDidChange.fire(h.map(b=>({resource:l.URI.revive(b.resource),type:b.type})))}else{const h=g;this._onDidWatchError.fire(h)}}))}watch(g,h){const b=(0,m.generateUuid)();return this.channel.call("watch",[this.sessionId,b,g,h]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,b]))}}e.DiskFileSystemProviderClient=y}),define(Z[106],ee([0,1,18,17,160,14]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(P,y,S,g,h,b){let C;try{await E(P,y,S,g,h,b)}catch(p){C=p}finally{C&&h.errorTransformer&&(C=h.errorTransformer(C)),typeof C<"u"&&S.error(C),S.end()}}e.readFileIntoStream=M;async function E(P,y,S,g,h,b){l(b);const C=await P.open(y,{create:!1});try{l(b);let p=0,v=0,d=h&&typeof h.length=="number"?h.length:void 0,f=w.VSBuffer.alloc(Math.min(h.bufferSize,typeof d=="number"?d:h.bufferSize)),a=h&&typeof h.position=="number"?h.position:0,i=0;do v=await P.read(C,a,f.buffer,i,f.byteLength-i),a+=v,i+=v,p+=v,typeof d=="number"&&(d-=v),i===f.byteLength&&(await S.write(g(f)),f=w.VSBuffer.alloc(Math.min(h.bufferSize,typeof d=="number"?d:h.bufferSize)),i=0);while(v>0&&(typeof d!="number"||d>0)&&l(b)&&m(p,h));if(i>0){let o=i;typeof d=="number"&&(o=Math.min(i,d)),S.write(g(f.slice(0,o)))}}catch(p){throw(0,R.ensureFileSystemProviderError)(p)}finally{await P.close(C)}}function l(P){if(P.isCancellationRequested)throw(0,t.canceled)();return!0}function m(P,y){if(y?.limits){if(typeof y.limits.memory=="number"&&P>y.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&P>y.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[70],ee([0,1,97,2,9,4,7,14]),function(q,e,w,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function l(p){return p.recursive===!0}e.isRecursiveWatchRequest=l;class m extends t.Disposable{constructor(v,d,f,a){super(),this.onFileChanges=v,this.onLogMessage=d,this.verboseLogging=f,this.options=a,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const v=new t.DisposableStore;this.watcherDisposables.value=v,this.watcher=this.createWatcher(v),this.watcher.setVerboseLogging(this.verboseLogging),v.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),v.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),v.add(this.watcher.onDidError(d=>this.onError(d)))}onError(v){this.options.restartOnError?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${v}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${v}`):this.error(v)}restart(v){this.restartCounter++,this.init(),this.watch(v)}async watch(v){this.requests=v,await this.watcher?.watch(v)}async setVerboseLogging(v){this.verboseLogging=v,await this.watcher?.setVerboseLogging(v)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${v}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.MAX_RESTARTS=5;class P extends m{constructor(v,d,f){super(v,d,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class y extends m{constructor(v,d,f){super(v,d,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function S(p){return p.map(v=>({type:v.type,resource:M.URI.file(v.path)}))}e.toFileChanges=S;function g(p){const v=new C;for(const d of p)v.processEvent(d);return v.coalesce()}e.coalesceEvents=g;function h(p,v){return typeof v=="string"&&!v.startsWith(w.GLOBSTAR)&&!(0,k.isAbsolute)(v)?{base:p,pattern:v}:v}e.normalizeWatcherPattern=h;function b(p,v){const d=[];for(const f of v)d.push((0,w.parse)(h(p,f)));return d}e.parseWatcherPatterns=b;class C{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(v){return R.isLinux?v.path:v.path.toLowerCase()}processEvent(v){const d=this.mapPathToChange.get(this.toKey(v));let f=!1;if(d){const a=d.type,i=v.type;d.path!==v.path&&(v.type===2||v.type===1)?f=!0:a===1&&i===2?(this.mapPathToChange.delete(this.toKey(v)),this.coalesced.delete(d)):a===2&&i===1?d.type=0:a===1&&i===0||(d.type=i)}else f=!0;f&&(this.coalesced.add(v),this.mapPathToChange.set(this.toKey(v),v))}coalesce(){const v=[],d=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(v.push(f),!1):!0).sort((f,a)=>f.path.length-a.path.length).filter(f=>d.some(a=>(0,E.isParent)(f.path,a,!R.isLinux))?!1:(d.push(f.path),!0)).concat(v)}}}),define(Z[197],ee([0,1,40,8,22,30,2,80,9,4,98,23,70]),function(q,e,w,t,k,R,M,E,l,m,P,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class g extends M.Disposable{constructor(C,p,v,d){super(),this.request=C,this.onDidFilesChange=p,this.onLogMessage=v,this.verboseLogging=d,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(g.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const C=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await y.Promises.stat(C);this._register(await this.doWatch(C,p.isDirectory()))}catch(C){C.code!=="ENOENT"?this.error(C):this.trace(C)}}async normalizePath(C){let p=C.path;try{p=await y.Promises.realpath(C.path),C.path===p&&(p=await(0,P.realcase)(C.path)??C.path),C.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${C.path}, real: ${p})`)}catch{}return p}async doWatch(C,p){if(m.isMacintosh&&(0,R.isEqualOrParent)(C,"/Volumes/",!0))return this.error(`Refusing to watch ${C} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const v=new k.CancellationTokenSource(this.cts.token),d=new M.DisposableStore;try{const f=(0,l.basename)(C),a=(0,w.watch)(C);d.add((0,M.toDisposable)(()=>{a.removeAllListeners(),a.close()})),this.trace(`Started watching: '${C}'`);const i=new Set;if(p)try{for(const n of await y.Promises.readdir(C))i.add(n)}catch(n){this.error(n)}const o=new Map;d.add((0,M.toDisposable)(()=>{for(const[,n]of o)n.dispose();o.clear()})),a.on("error",(n,r)=>{this.error(`Failed to watch ${C} for changes using fs.watch() (${n}, ${r})`),this.dispose()}),a.on("change",(n,r)=>{if(v.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${r}`);let s="";if(r&&(s=r.toString(),m.isMacintosh&&(s=(0,E.normalizeNFC)(s))),!(!s||n!=="change"&&n!=="rename"))if(p)if(n==="rename"){o.get(s)?.dispose();const c=setTimeout(async()=>{if(o.delete(s),s===f&&!await y.Promises.exists(C)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,l.join)(C,s));if(v.token.isCancellationRequested)return;let I;u?i.has(s)?I=0:(I=1,i.add(s)):(i.delete(s),I=2),this.onFileChange({path:(0,l.join)(this.request.path,s),type:I})},g.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,M.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(s)?c=0:(c=1,i.add(s)),this.onFileChange({path:(0,l.join)(this.request.path,s),type:c})}else if(n==="rename"||s!==f){const c=setTimeout(async()=>{const u=await y.Promises.exists(C);v.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),d.add(await this.doWatch(C,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},g.FILE_DELETE_HANDLER_DELAY);d.clear(),d.add((0,M.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await y.Promises.exists(C)&&!v.token.isCancellationRequested&&this.error(`Failed to watch ${C} for changes using fs.watch() (${f.toString()})`)}return(0,M.toDisposable)(()=>{v.dispose(!0),d.dispose()})}async onFileChange(C,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),!p&&this.excludes.some(v=>v(C.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${C.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(v=>v(C.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${C.path}`):this.fileChangesBuffer.push(C);try{await this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const d=(0,S.coalesceEvents)(v);if(d.length>0){if(this.verboseLogging)for(const a of d)this.trace(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`);this.throttledFileChangesWorker.work(d)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(C){if(m.isLinux)return y.Promises.exists(C);try{const p=(0,l.basename)(C);return(await y.Promises.readdir((0,l.dirname)(C))).some(d=>d===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(C){this.verboseLogging=C}error(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${C}`})}warn(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${C}`})}trace(C){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=g,g.FILE_DELETE_HANDLER_DELAY=100,g.FILE_CHANGES_HANDLER_DELAY=50;async function h(b,C,p,v,d=512){const f=await y.Promises.open(b,"r"),a=Buffer.allocUnsafe(d),i=new k.CancellationTokenSource(v);let o,n=!1;const r={path:b,excludes:[],recursive:!1},s=new g(r,c=>{(async()=>{for(const{type:u}of c)if(u===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:I}=await y.Promises.read(f,a,0,d,null);if(!I||i.token.isCancellationRequested)break;C(a.slice(0,I))}}catch(I){o=new Error(I),i.dispose(!0)}finally{n=!1}}})()});return await s.ready,p(),new Promise((c,u)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await y.Promises.close(f)}catch(I){o=new Error(I)}o?u(o):c()})})}e.watchFileContents=h}),define(Z[198],ee([0,1,3,97,2,4,197]),function(q,e,w,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new w.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new w.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=w.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const P=this.normalizeRequests(m),y=P.filter(g=>{const h=this.watchers.get(g.path);return h?!(0,t.patternsEquals)(h.request.excludes,g.excludes)||!(0,t.patternsEquals)(h.request.includes,g.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:g})=>!P.find(h=>h.path===g.path&&(0,t.patternsEquals)(h.excludes,g.excludes)&&(0,t.patternsEquals)(h.includes,g.includes))).map(({request:g})=>g.path);y.length&&this.trace(`Request to start watching: ${y.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const g of S)this.stopWatching(g);for(const g of y)this.startWatching(g)}startWatching(m){const P=new M.NodeJSFileWatcherLibrary(m,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),y={request:m,instance:P};this.watchers.set(m.path,y)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const P=this.watchers.get(m);P&&(this.watchers.delete(m),P.instance.dispose())}normalizeRequests(m){const P=new Map;for(const y of m){const S=R.isLinux?y.path:y.path.toLowerCase();P.set(S,y)}return Array.from(P.values())}async setVerboseLogging(m){this.verboseLogging=m;for(const[,P]of this.watchers)P.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,P){return P?`[File Watcher (node.js)] ${m} (path: ${P.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=E}),define(Z[199],ee([0,1,70,198]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends w.AbstractNonRecursiveWatcherClient{constructor(M,E,l){super(M,E,l),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Z[200],ee([0,1,13,46,146,70]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends R.AbstractUniversalWatcherClient{constructor(l,m,P){super(l,m,P),this.init()}createWatcher(l){const m=l.add(new k.Client(w.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(m.onDidProcessExit(({code:P,signal:y})=>this.onError(`terminated by itself with code ${P}, signal: ${y}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(Z[85],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...k){this._entries=new Map;for(const[R,M]of k)this.set(R,M)}set(k,R){const M=this._entries.get(k);return this._entries.set(k,R),M}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=w}),define(Z[201],ee([0,1,8,17,68,191,5,85]),function(q,e,w,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const l=!1;class m extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class P{constructor(h=new E.ServiceCollection,b=!1,C,p=l){this._services=h,this._strict=b,this._parent=C,this._enableTracing=p,this._activeInstantiations=new Set,this._services.set(M.IInstantiationService,this),this._globalGraph=p?C?._globalGraph??new R.Graph(v=>v):void 0}createChild(h){return new P(h,this._strict,this,this._enableTracing)}invokeFunction(h,...b){const C=S.traceInvocation(this._enableTracing,h);let p=!1;try{return h({get:d=>{if(p)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(d,C);if(!f)throw new Error(`[invokeFunction] unknown service '${d}'`);return f}},...b)}finally{p=!0,C.stop()}}createInstance(h,...b){let C,p;return h instanceof k.SyncDescriptor?(C=S.traceCreation(this._enableTracing,h.ctor),p=this._createInstance(h.ctor,h.staticArguments.concat(b),C)):(C=S.traceCreation(this._enableTracing,h),p=this._createInstance(h,b,C)),C.stop(),p}_createInstance(h,b=[],C){const p=M._util.getServiceDependencies(h).sort((f,a)=>f.index-a.index),v=[];for(const f of p){const a=this._getOrCreateServiceInstance(f.id,C);a||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${f.id}.`,!1),v.push(a)}const d=p.length>0?p[0].index:b.length;if(b.length!==d){console.trace(`[createInstance] First service dependency of ${h.name} at position ${d+1} conflicts with ${b.length} static arguments`);const f=d-b.length;f>0?b=b.concat(new Array(f)):b=b.slice(0,d)}return new h(...b,...v)}_setServiceInstance(h,b){if(this._services.get(h)instanceof k.SyncDescriptor)this._services.set(h,b);else if(this._parent)this._parent._setServiceInstance(h,b);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const b=this._services.get(h);return!b&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):b}_getOrCreateServiceInstance(h,b){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(h));const C=this._getServiceInstanceOrDescriptor(h);return C instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,C,b.branch(h,!0)):(b.branch(h,!1),C)}_safeCreateAndCacheServiceInstance(h,b,C){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,b,C)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,b,C){const p=new R.Graph(f=>f.id.toString());let v=0;const d=[{id:h,desc:b,_trace:C}];for(;d.length;){const f=d.pop();if(p.lookupOrInsertNode(f),v++>1e3)throw new m(p);for(const a of M._util.getServiceDependencies(f.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(a.id);if(i||this._throwIfStrict(`[createInstance] ${h} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(f.id),String(a.id)),i instanceof k.SyncDescriptor){const o={id:a.id,desc:i,_trace:f._trace.branch(a.id,!0)};p.insertEdge(f,o),d.push(o)}}}for(;;){const f=p.roots();if(f.length===0){if(!p.isEmpty())throw new m(p);break}for(const{data:a}of f){if(this._getServiceInstanceOrDescriptor(a.id)instanceof k.SyncDescriptor){const o=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,o)}p.removeNode(a)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,b,C=[],p,v){if(this._services.get(h)instanceof k.SyncDescriptor)return this._createServiceInstance(h,b,C,p,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,b,C,p,v);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}_createServiceInstance(h,b,C=[],p,v){if(p){const d=new P(void 0,this._strict,this,this._enableTracing);d._globalGraphImplicitDependency=String(h);const f=new w.IdleValue(()=>d._createInstance(b,C,v));return new Proxy(Object.create(null),{get(a,i){if(i in a)return a[i];const o=f.value;let n=o[i];return typeof n!="function"||(n=n.bind(o),a[i]=n),n},set(a,i,o){return f.value[i]=o,!0}})}else return this._createInstance(b,C,v)}_throwIfStrict(h,b){if(b&&console.warn(h),this._strict)throw new Error(h)}}e.InstantiationService=P;var y;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(y||(y={}));class S{constructor(h,b){this.type=h,this.name=b,this._start=Date.now(),this._dep=[]}static traceInvocation(h,b){return h?new S(1,b.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S._None}static traceCreation(h,b){return h?new S(0,b.name):S._None}branch(h,b){const C=new S(2,h.toString());return this._dep.push([h,b,C]),C}stop(){const h=Date.now()-this._start;S._totals+=h;let b=!1;function C(v,d){const f=[],a=new Array(v+1).join("	");for(const[i,o,n]of d._dep)if(o&&n){b=!0,f.push(`${a}CREATES -> ${i}`);const r=C(v+1,n);r&&f.push(r)}else f.push(`${a}uses -> ${i}`);return f.join(`
`)}const p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${C(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(h>2||b)&&S.all.add(p.join(`
`))}}e.Trace=S,S.all=new Set,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(Z[6],ee([0,1,44,3,2,4,5]),function(q,e,w,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,M.createDecorator)("logService"),e.ILoggerService=(0,M.createDecorator)("loggerService");function E(){return new Date().toISOString()}var l;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(l=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=l.Info;function m(o,n,r){switch(n){case l.Trace:o.trace(r);break;case l.Debug:o.debug(r);break;case l.Info:o.info(r);break;case l.Warning:o.warn(r);break;case l.Error:o.error(r);break;case l.Critical:o.critical(r);break;default:throw new Error("Invalid log level")}}e.log=m;function P(o){let n="";for(let r=0;r<o.length;r++){let s=o[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(r>0?" ":"")+s}return n}e.format=P;class y extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class S extends y{constructor(n){super(),this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...r){this.checkLogLevel(l.Trace)&&this.log(l.Trace,P([n,...r]))}debug(n,...r){this.checkLogLevel(l.Debug)&&this.log(l.Debug,P([n,...r]))}info(n,...r){this.checkLogLevel(l.Info)&&this.log(l.Info,P([n,...r]))}warn(n,...r){this.checkLogLevel(l.Warning)&&this.log(l.Warning,P([n,...r]))}error(n,...r){if(this.checkLogLevel(l.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(l.Error,P(s))}else this.log(l.Error,P([n,...r]))}critical(n,...r){this.checkLogLevel(l.Critical)&&this.log(l.Critical,P([n,...r]))}flush(){}}e.AbstractMessageLogger=S;class g extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.useColors=!R.isWindows}trace(n,...r){this.getLevel()<=l.Trace&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,n,...r):console.log(`[main ${E()}]`,n,...r))}debug(n,...r){this.getLevel()<=l.Debug&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,n,...r):console.log(`[main ${E()}]`,n,...r))}info(n,...r){this.getLevel()<=l.Info&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,n,...r):console.log(`[main ${E()}]`,n,...r))}warn(n,...r){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,n,...r):console.warn(`[main ${E()}]`,n,...r))}error(n,...r){this.getLevel()<=l.Error&&(this.useColors?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,n,...r):console.error(`[main ${E()}]`,n,...r))}critical(n,...r){this.getLevel()<=l.Critical&&(this.useColors?console.error(`\x1B[90m[main ${E()}]\x1B[0m`,n,...r):console.error(`[main ${E()}]`,n,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class h extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...r){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",n,...r)}debug(n,...r){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...r)}info(n,...r){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",n,...r)}warn(n,...r){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",n,...r)}error(n,...r){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",n,...r)}critical(n,...r){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...r)}dispose(){}flush(){}}e.ConsoleLogger=h;class b extends y{constructor(n,r=e.DEFAULT_LOG_LEVEL){super(),this.adapter=n,this.setLevel(r)}trace(n,...r){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(n),...r])}debug(n,...r){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(n),...r])}info(n,...r){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(n),...r])}warn(n,...r){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(n),...r])}error(n,...r){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(n),...r])}critical(n,...r){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(n),...r])}extractMessage(n){return typeof n=="string"?n:(0,w.toErrorMessage)(n,this.getLevel()<=l.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class C extends y{constructor(n){super(),this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const r of this.logServices)r.setLevel(n);super.setLevel(n)}trace(n,...r){for(const s of this.logServices)s.trace(n,...r)}debug(n,...r){for(const s of this.logServices)s.debug(n,...r)}info(n,...r){for(const s of this.logServices)s.info(n,...r)}warn(n,...r){for(const s of this.logServices)s.warn(n,...r)}error(n,...r){for(const s of this.logServices)s.error(n,...r)}critical(n,...r){for(const s of this.logServices)s.critical(n,...r)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=C;class p extends k.Disposable{constructor(n){super(),this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...r){this.logger.trace(n,...r)}debug(n,...r){this.logger.debug(n,...r)}info(n,...r){this.logger.info(n,...r)}warn(n,...r){this.logger.warn(n,...r)}error(n,...r){this.logger.error(n,...r)}critical(n,...r){this.logger.critical(n,...r)}flush(){this.logger.flush()}}e.LogService=p;class v extends k.Disposable{constructor(n,r){super(),this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,r){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,r?.always?l.Trace:this.logLevel,r),this.loggers.set(n.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class d{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return l.Info}trace(n,...r){}debug(n,...r){}info(n,...r){}warn(n,...r){}error(n,...r){}critical(n,...r){}dispose(){}flush(){}}e.NullLogService=d;function f(o){if(o.verbose)return l.Trace;if(typeof o.logLevel=="string"){const n=a(o.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function a(o){switch(o){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}e.parseLogLevel=a;function i(o){switch(o){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}e.LogLevelToString=i});var J=this&&this.__param||function(q,e){return function(w,t){e(w,t,q)}};define(Z[202],ee([0,1,69,3,2,6,4,8]),function(q,e,w,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let l=class bt extends k.Disposable{constructor(P){super(),this.logService=P,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(P,y){this.logService.trace("Getting password from keytar:",P,y);let S;try{S=await this.withKeytar()}catch{return null}const g=await(0,E.retry)(()=>S.getPassword(P,y),50,3);if(!g)return this.logService.trace("Did not get a password from keytar for account:",y),g;let h,b;try{const C=JSON.parse(g);h=C.content,b=C.hasNextChunk}catch{}if(!h||!b)return this.logService.trace("Got password from keytar for account:",y),g;try{let C=1;for(;b;){const p=await(0,E.retry)(()=>S.getPassword(P,`${y}-${C}`),50,3),v=JSON.parse(p);h+=v.content,b=v.hasNextChunk,C++}return this.logService.trace(`Got ${C}-chunked password from keytar for account:`,y),h}catch(C){return this.logService.error(C),g}}async setPassword(P,y,S){this.logService.trace("Setting password using keytar:",P,y);let g;try{g=await this.withKeytar()}catch(h){throw this.surfaceKeytarLoadError?.(h),h}if(M.isWindows&&S.length>bt.MAX_PASSWORD_LENGTH){let h=0,b=0,C=!0;for(;C;){const p=S.substring(h,h+bt.PASSWORD_CHUNK_SIZE);h+=bt.PASSWORD_CHUNK_SIZE,C=S.length-h>0;const v={content:p,hasNextChunk:C};await(0,E.retry)(()=>g.setPassword(P,b?`${y}-${b}`:y,JSON.stringify(v)),50,3),b++}this.logService.trace(`Got${b?` ${b}-chunked`:""} password from keytar for account:`,y)}else await(0,E.retry)(()=>g.setPassword(P,y,S),50,3),this.logService.trace("Got password from keytar for account:",y);this._onDidChangePassword.fire({service:P,account:y})}async deletePassword(P,y){this.logService.trace("Deleting password using keytar:",P,y);let S;try{S=await this.withKeytar()}catch(p){throw this.surfaceKeytarLoadError?.(p),p}const g=await S.getPassword(P,y);if(!g)return this.logService.trace("Did not get a password to delete from keytar for account:",y),!1;let h,b;try{const p=JSON.parse(g);h=p.content,b=p.hasNextChunk}catch{}let C=0;if(h&&b)try{for(C++;b;){const p=`${y}-${C}`,v=await S.getPassword(P,p);await S.deletePassword(P,p),b=JSON.parse(v).hasNextChunk,C++}}catch(p){this.logService.error(p)}return await S.deletePassword(P,y)?(this._onDidChangePassword.fire({service:P,account:y}),this.logService.trace(`Deleted${C?` ${C}-chunked`:""} password from keytar for account:`,y),!0):(this.logService.trace(`Keytar failed to delete${C?` ${C}-chunked`:""} password for account:`,y),!1)}async findPassword(P){let y;try{y=await this.withKeytar()}catch{return null}return await y.findPassword(P)}async findCredentials(P){let y;try{y=await this.withKeytar()}catch{return[]}return await y.findCredentials(P)}clear(){return this._keytarCache instanceof w.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};l.MAX_PASSWORD_LENGTH=2500,l.PASSWORD_CHUNK_SIZE=l.MAX_PASSWORD_LENGTH-100,l=ve([J(0,R.ILogService)],l),e.BaseCredentialsMainService=l}),define(Z[203],ee([0,1,24,8,17,3,2,9,70,6]),function(q,e,w,t,k,R,M,E,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends M.Disposable{constructor(S,g){super(),this.logService=S,this.options=g,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(S,g){return g.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,g):this.watchNonRecursive(S,g)}watchUniversal(S,g){const h={path:this.toFilePath(S),excludes:g.excludes,includes:g.includes,recursive:g.recursive},b=(0,w.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{b(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,k.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(g=>this._onDidChangeFile.fire((0,l.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const g of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const g of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(g)&&S.includes(g.path)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,g){const h={path:this.toFilePath(S),excludes:g.excludes,includes:g.includes,recursive:!1},b=(0,w.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{b(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,k.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,l.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,E.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(Z[204],ee([0,1,24,8,18,22,3,66,57,2,31,13,71,16,58,158,14,106,6]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let d=class extends m.Disposable{constructor(a){super(),this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(a,i){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${a}`);const o=new m.DisposableStore;return this.provider.set(a,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:i}),o.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new C.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&o.add(i.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),o.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:a}))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:i}),this.provider.delete(a),(0,m.dispose)(o)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(o){i.push(o)}}),!this.provider.has(a)&&await t.Promises.settled(i)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,i){const o=this.provider.get(a.scheme);return!!(o&&o.capabilities&i)}listCapabilities(){return l.Iterable.map(this.provider,([a,i])=>({scheme:a,capabilities:i.capabilities}))}async withProvider(a){if(!(0,g.isAbsolutePath)(a))throw new C.FileOperationError((0,b.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const i=this.provider.get(a.scheme);if(!i){const o=new Error;throw o.name="ENOPRO",o.message=(0,b.localize)(1,null,a.toString()),o}return i}async withReadProvider(a){const i=await this.withProvider(a);if((0,C.hasOpenReadWriteCloseCapability)(i)||(0,C.hasReadWriteCapability)(i)||(0,C.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const i=await this.withProvider(a);if((0,C.hasOpenReadWriteCloseCapability)(i)||(0,C.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,i){try{return await this.doResolveFile(a,i)}catch(o){throw(0,C.toFileSystemProviderErrorCode)(o)===C.FileSystemProviderErrorCode.FileNotFound?new C.FileOperationError((0,b.localize)(2,null,this.resourceForError(a)),1):(0,C.ensureFileSystemProviderError)(o)}}async doResolveFile(a,i){const o=await this.withProvider(a),n=this.isPathCaseSensitive(o),r=i?.resolveTo,s=i?.resolveSingleChildDescendants,c=i?.resolveMetadata,u=await o.stat(a);let I;return this.toFileStat(o,a,u,void 0,!!c,(D,T)=>(I||(I=P.TernarySearchTree.forUris(()=>!n),I.set(a,!0),r&&I.fill(!0,r)),I.get(D.resource)||I.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&s?T===1:!1))}async toFileStat(a,i,o,n,r,s){const{providerExtUri:c}=this.getExtUri(a),u={resource:i,name:c.basename(i),isFile:(o.type&C.FileType.File)!==0,isDirectory:(o.type&C.FileType.Directory)!==0,isSymbolicLink:(o.type&C.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&C.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,C.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(u.isDirectory&&s(u,n)){try{const I=await a.readdir(i),D=await t.Promises.settled(I.map(async([T,N])=>{try{const U=c.joinPath(i,T),$=r?await a.stat(U):{type:N};return await this.toFileStat(a,U,$,I.length,r,s)}catch(U){return this.logService.trace(U),null}}));u.children=(0,w.coalesce)(D)}catch(I){this.logService.trace(I),u.children=[]}return u}return u}async resolveAll(a){return t.Promises.settled(a.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(a){const i=await this.withProvider(a),o=await i.stat(a);return this.toFileStat(i,a,o,void 0,!0,()=>!1)}async exists(a){const i=await this.withProvider(a);try{return!!await i.stat(a)}catch{return!1}}async canCreateFile(a,i){try{await this.doValidateCreateFile(a,i)}catch(o){return o}return!0}async doValidateCreateFile(a,i){if(!i?.overwrite&&await this.exists(a))throw new C.FileOperationError((0,b.localize)(3,null,this.resourceForError(a)),3,i)}async createFile(a,i=k.VSBuffer.fromString(""),o){await this.doValidateCreateFile(a,o);const n=await this.writeFile(a,i);return this._onDidRunOperation.fire(new C.FileOperationEvent(a,0,n)),n}async writeFile(a,i,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:r}=this.getExtUri(n);try{await this.validateWriteFile(n,a,o)||await this.mkdirp(n,r.dirname(a));let c;if((0,C.hasReadWriteCapability)(n)&&!(i instanceof k.VSBuffer))if((0,h.isReadableStream)(i)){const u=await(0,h.peekStream)(i,3);u.ended?c=k.VSBuffer.concat(u.buffer):c=u}else c=(0,h.peekReadable)(i,u=>k.VSBuffer.concat(u),3);else c=i;!(0,C.hasOpenReadWriteCloseCapability)(n)||(0,C.hasReadWriteCapability)(n)&&c instanceof k.VSBuffer?await this.doWriteUnbuffered(n,a,o,c):await this.doWriteBuffered(n,a,o,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this._onDidRunOperation.fire(new C.FileOperationEvent(a,4))}catch(s){throw new C.FileOperationError((0,b.localize)(4,null,this.resourceForError(a),(0,C.ensureFileSystemProviderError)(s).toString()),(0,C.toFileOperationResult)(s),o)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,i,o){if(!!o?.unlock&&!(a.capabilities&8192))throw new Error((0,b.localize)(5,null,this.resourceForError(i)));let r;try{r=await a.stat(i)}catch{return}if((r.type&C.FileType.Directory)!==0)throw new C.FileOperationError((0,b.localize)(6,null,this.resourceForError(i)),0,o);if(this.throwIfFileIsReadonly(i,r),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==C.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&o.mtime<r.mtime&&o.etag!==(0,C.etag)({mtime:o.mtime,size:r.size}))throw new C.FileOperationError((0,b.localize)(7,null),3,o);return r}async readFile(a,i,o){const n=await this.withReadProvider(a);return i?.atomic?this.doReadFileAtomic(n,a,i,o):this.doReadFile(n,a,i,o)}async doReadFileAtomic(a,i,o,n){return new Promise((r,s)=>{this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(a,i,o,n);r(c)}catch(c){s(c)}})})}async doReadFile(a,i,o,n){const r=await this.doReadFileStream(a,i,{...o,preferUnbuffered:!0},n);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(a,i,o){const n=await this.withReadProvider(a);return this.doReadFileStream(n,a,i,o)}async doReadFileStream(a,i,o,n){const r=new R.CancellationTokenSource(n),s=this.validateReadFile(i,o).then(u=>u,u=>{throw r.cancel(),u});let c;try{return typeof o?.etag=="string"&&o.etag!==C.ETAG_DISABLED&&await s,o?.atomic&&(0,C.hasFileAtomicReadCapability)(a)||!((0,C.hasOpenReadWriteCloseCapability)(a)||(0,C.hasFileReadStreamCapability)(a))||(0,C.hasReadWriteCapability)(a)&&o?.preferUnbuffered?c=this.readFileUnbuffered(a,i,o):(0,C.hasFileReadStreamCapability)(a)?c=this.readFileStreamed(a,i,r.token,o):c=this.readFileBuffered(a,i,r.token,o),{...await s,value:c}}catch(u){c&&await(0,h.consumeStream)(c);const I=(0,b.localize)(8,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(u).toString());throw u instanceof C.NotModifiedSinceFileOperationError?new C.NotModifiedSinceFileOperationError(I,u.stat,o):new C.FileOperationError(I,(0,C.toFileOperationResult)(u),o)}}readFileStreamed(a,i,o,n=Object.create(null)){const r=a.readFileStream(i,n,o);return(0,h.transform)(r,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new C.FileOperationError((0,b.localize)(9,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(s).toString()),(0,C.toFileOperationResult)(s),n)},s=>k.VSBuffer.concat(s))}readFileBuffered(a,i,o,n=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,p.readFileIntoStream)(a,i,r,s=>s,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new C.FileOperationError((0,b.localize)(10,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(s).toString()),(0,C.toFileOperationResult)(s),n)},o),r}readFileUnbuffered(a,i,o){const n=(0,h.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;o?.atomic&&(0,C.hasFileAtomicReadCapability)(a)?r=await a.readFile(i,{atomic:!0}):r=await a.readFile(i),typeof o?.position=="number"&&(r=r.slice(o.position)),typeof o?.length=="number"&&(r=r.slice(0,o.length)),this.validateReadFileLimits(i,r.byteLength,o),n.end(k.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async validateReadFile(a,i){const o=await this.resolve(a,{resolveMetadata:!0});if(o.isDirectory)throw new C.FileOperationError((0,b.localize)(11,null,this.resourceForError(a)),0,i);if(typeof i?.etag=="string"&&i.etag!==C.ETAG_DISABLED&&i.etag===o.etag)throw new C.NotModifiedSinceFileOperationError((0,b.localize)(12,null),o,i);return this.validateReadFileLimits(a,o.size,i),o}validateReadFileLimits(a,i,o){if(o?.limits){let n;if(typeof o.limits.memory=="number"&&i>o.limits.memory&&(n=9),typeof o.limits.size=="number"&&i>o.limits.size&&(n=7),typeof n=="number")throw new C.FileOperationError((0,b.localize)(13,null,this.resourceForError(a)),n)}}async canMove(a,i,o){return this.doCanMoveCopy(a,i,"move",o)}async canCopy(a,i,o){return this.doCanMoveCopy(a,i,"copy",o)}async doCanMoveCopy(a,i,o,n){if(a.toString()!==i.toString())try{const r=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,a,s,i,o,n)}catch(r){return r}return!0}async move(a,i,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(n,a,r,i,"move",!!o),c=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(a,s==="move"?2:3,c)),c}async copy(a,i,o){const n=await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(n,a,r,i,"copy",!!o),c=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(a,s==="copy"?3:2,c)),c}async doMoveCopy(a,i,o,n,r,s){if(i.toString()===n.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(a,i,o,n,r,s);if(c&&!u&&s&&await this.del(n,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(n)),r==="copy"){if(a===o&&(0,C.hasFileFolderCopyCapability)(a))await a.copy(i,n,{overwrite:s});else{const I=await this.resolve(i);I.isDirectory?await this.doCopyFolder(a,I,o,n):await this.doCopyFile(a,i,o,n)}return r}else return a===o?(await a.rename(i,n,{overwrite:s}),r):(await this.doMoveCopy(a,i,o,n,"copy",s),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(a,i,o,n){if((0,C.hasOpenReadWriteCloseCapability)(a)&&(0,C.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(a,i,o,n);if((0,C.hasOpenReadWriteCloseCapability)(a)&&(0,C.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(a,i,o,n);if((0,C.hasReadWriteCapability)(a)&&(0,C.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(a,i,o,n);if((0,C.hasReadWriteCapability)(a)&&(0,C.hasReadWriteCapability)(o))return this.doPipeUnbuffered(a,i,o,n)}async doCopyFolder(a,i,o,n){await o.mkdir(n),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async r=>{const s=this.getExtUri(o).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.doCopyFolder(a,await this.resolve(r.resource),o,s):this.doCopyFile(a,r.resource,o,s)}))}async doValidateMoveCopy(a,i,o,n,r,s){let c=!1;if(a===o){const{providerExtUri:I,isPathCaseSensitive:D}=this.getExtUri(a);if(D||(c=I.isEqual(i,n)),c&&r==="copy")throw new Error((0,b.localize)(14,null,this.resourceForError(i),this.resourceForError(n)));if(!c&&I.isEqualOrParent(n,i))throw new Error((0,b.localize)(15,null,this.resourceForError(i),this.resourceForError(n)))}const u=await this.exists(n);if(u&&!c){if(!s)throw new C.FileOperationError((0,b.localize)(16,null,this.resourceForError(i),this.resourceForError(n)),4);if(a===o){const{providerExtUri:I}=this.getExtUri(a);if(I.isEqualOrParent(i,n))throw new Error((0,b.localize)(17,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:u,isSameResourceWithDifferentPathCase:c}}getExtUri(a){const i=this.isPathCaseSensitive(a);return{providerExtUri:i?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(i,a);const o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(a,0,o)),o}async mkdirp(a,i){const o=[],{providerExtUri:n}=this.getExtUri(a);for(;!n.isEqual(i,n.dirname(i));)try{if(((await a.stat(i)).type&C.FileType.Directory)===0)throw new Error((0,b.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,C.toFileSystemProviderErrorCode)(r)!==C.FileSystemProviderErrorCode.FileNotFound)throw r;o.push(n.basename(i)),i=n.dirname(i)}for(let r=o.length-1;r>=0;r--){i=n.joinPath(i,o[r]);try{await a.mkdir(i)}catch(s){if((0,C.toFileSystemProviderErrorCode)(s)!==C.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(a,i){try{await this.doValidateDelete(a,i)}catch(o){return o}return!0}async doValidateDelete(a,i){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!i?.useTrash&&!(o.capabilities&4096))throw new Error((0,b.localize)(19,null,this.resourceForError(a)));let r;try{r=await o.stat(a)}catch{}if(r)this.throwIfFileIsReadonly(a,r);else throw new C.FileOperationError((0,b.localize)(20,null,this.resourceForError(a)),1);if(!!!i?.recursive){const c=await this.resolve(a);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,b.localize)(21,null,this.resourceForError(a)))}return o}async del(a,i){const o=await this.doValidateDelete(a,i),n=!!i?.useTrash,r=!!i?.recursive;await o.delete(a,{recursive:r,useTrash:n}),this._onDidRunOperation.fire(new C.FileOperationEvent(a,1))}async cloneFile(a,i){const o=await this.withProvider(a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(o===n&&this.getExtUri(o).providerExtUri.isEqual(a,i))return;if(o===n&&(0,C.hasFileCloneCapability)(o))return o.cloneFile(a,i);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i));const r=this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri);return o===n&&(0,C.hasFileFolderCopyCapability)(o)?r.queue(()=>o.copy(a,i,{overwrite:!0})):r.queue(()=>this.doCopyFile(o,a,n,i))}watch(a,i={recursive:!1,excludes:[]}){const o=new m.DisposableStore;let n=!1,r=()=>{n=!0};return o.add((0,m.toDisposable)(()=>r())),(async()=>{try{const s=await this.doWatch(a,i);n?(0,m.dispose)(s):r=()=>(0,m.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(a,i){const o=await this.withProvider(a),n=(0,E.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(a),i]);let r=this.activeWatchers.get(n);return r||(r={count:0,disposable:o.watch(a,i)},this.activeWatchers.set(n,r)),r.count+=1,(0,m.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,m.dispose)(r.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,m.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,i,o,n){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(async()=>{const r=await a.open(i,{create:!0,unlock:o?.unlock??!1});try{(0,h.isReadableStream)(n)||(0,h.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(a,r,n):await this.doWriteReadableBufferedQueued(a,r,n)}catch(s){throw(0,C.ensureFileSystemProviderError)(s)}finally{await a.close(r)}})}async doWriteStreamBufferedQueued(a,i,o){let n=0,r;if((0,h.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=k.VSBuffer.concat(o.buffer);await this.doWriteBuffer(a,i,s,s.byteLength,n,0),n+=s.byteLength}if(o.ended)return;r=o.stream}else r=o;return new Promise((s,c)=>{(0,h.listenStream)(r,{onData:async u=>{r.pause();try{await this.doWriteBuffer(a,i,u,u.byteLength,n,0)}catch(I){return c(I)}n+=u.byteLength,setTimeout(()=>r.resume())},onError:u=>c(u),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(a,i,o){let n=0,r;for(;(r=o.read())!==null;)await this.doWriteBuffer(a,i,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(a,i,o,n,r,s){let c=0;for(;c<n;)c+=await a.write(i,r+c,o.buffer,s+c,n-c)}async doWriteUnbuffered(a,i,o,n){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,i,o,n))}async doWriteUnbufferedQueued(a,i,o,n){let r;n instanceof k.VSBuffer?r=n:(0,h.isReadableStream)(n)?r=await(0,k.streamToBuffer)(n):(0,h.isReadableBufferedStream)(n)?r=await(0,k.bufferedStreamToBuffer)(n):r=(0,k.readableToBuffer)(n),await a.writeFile(i,r.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(a,i,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,i,o,n))}async doPipeBufferedQueued(a,i,o,n){let r,s;try{r=await a.open(i,{create:!1}),s=await o.open(n,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,I=0,D=0;do D=await a.read(r,u,c.buffer,I,c.byteLength-I),await this.doWriteBuffer(o,s,c,D,u,I),u+=D,I+=D,I===c.byteLength&&(I=0);while(D>0)}catch(c){throw(0,C.ensureFileSystemProviderError)(c)}finally{await t.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(a,i,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,i,o,n))}async doPipeUnbufferedQueued(a,i,o,n){return o.writeFile(n,await a.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,i,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,i,o,n))}async doPipeUnbufferedToBufferedQueued(a,i,o,n){const r=await o.open(n,{create:!0,unlock:!1});try{const s=await a.readFile(i);await this.doWriteBuffer(o,r,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,C.ensureFileSystemProviderError)(s)}finally{await o.close(r)}}async doPipeBufferedToUnbuffered(a,i,o,n){const r=await(0,k.streamToBuffer)(this.readFileBuffered(a,i,R.CancellationToken.None));await this.doWriteUnbuffered(o,n,void 0,r)}throwIfFileSystemIsReadonly(a,i){if(a.capabilities&2048)throw new C.FileOperationError((0,b.localize)(22,null,this.resourceForError(i)),6);return a}throwIfFileIsReadonly(a,i){if((i.permissions??0)&C.FilePermission.Readonly)throw new C.FileOperationError((0,b.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===y.Schemas.file?a.fsPath:a.toString(!0)}};d=ve([J(0,v.ILogService)],d),e.FileService=d}),define(Z[86],ee([0,1,40,277,8,31,18,3,30,2,9,4,16,58,23,162,14,106,203,44,200,199]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p,v,d,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(w)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(o)}`)}})();class i extends v.AbstractDiskFileSystemProvider{constructor(n,r){super(n,r),this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new R.ResourceMap(s=>S.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,y.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:r,symbolicLink:s}=await h.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(r,s),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(n){try{const r=await h.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),s=[];return await Promise.all(r.map(async c=>{try{let u;c.isSymbolicLink()?u=(await this.stat((0,S.joinPath)(n,c.name))).type:u=this.toType(c),s.push([c.name,u])}catch(u){this.logService.trace(u)}})),s}catch(r){throw this.toFileSystemProviderError(r)}}toType(n,r){let s;return r?.dangling?s=C.FileType.Unknown:n.isFile()?s=C.FileType.File:n.isDirectory()?s=C.FileType.Directory:s=C.FileType.Unknown,r&&(s|=C.FileType.SymbolicLink),s}async createResourceLock(n){const r=this.toFilePath(n);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let s;for(;s=this.resourceLocks.get(n);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await s.wait();const c=new k.Barrier;return this.resourceLocks.set(n,c),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,m.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(n)===c&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(n)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(n,r){let s;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),s=await this.createResourceLock(n));const c=this.toFilePath(n);return await h.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{s?.dispose()}}readFileStream(n,r,s){const c=(0,g.newWriteableStream)(u=>M.VSBuffer.concat(u.map(I=>M.VSBuffer.wrap(I))).buffer);return(0,p.readFileIntoStream)(this,n,c,u=>u.buffer,{...r,bufferSize:256*1024},s),c}async writeFile(n,r,s){let c;try{const u=this.toFilePath(n);if(!s.create||!s.overwrite){if(await h.Promises.exists(u)){if(!s.overwrite)throw(0,C.createFileSystemProviderError)((0,b.localize)(0,null),C.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,C.createFileSystemProviderError)((0,b.localize)(1,null),C.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(n,{create:!0,unlock:s.unlock}),await this.write(c,0,r,0,r.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(n,u)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(n){i.canFlush=n}async open(n,r){const s=this.toFilePath(n);let c;(0,C.isFileOpenForWriteOptions)(r)&&(c=await this.createResourceLock(n));let u;try{if((0,C.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:D}=await h.SymlinkSupport.stat(s);D.mode&128||await h.Promises.chmod(s,D.mode|128)}catch(D){this.logService.trace(D)}let I;if((0,C.isFileOpenForWriteOptions)(r)){if(y.isWindows)try{await h.Promises.truncate(s,0),I="r+"}catch(D){D.code!=="ENOENT"&&this.logService.trace(D)}I||(I="w")}else I="r";u=await h.Promises.open(s,I)}catch(I){throw c?.dispose(),(0,C.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(n,I):this.toFileSystemProviderError(I)}if(this.mapHandleToPos.set(u,0),(0,C.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(u,n),c){const I=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${s})`),this.mapHandleToLock.set(u,c),I&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${s})`),I.dispose())}return u}async close(n){const r=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&i.canFlush)try{await h.Promises.fdatasync(n)}catch(s){i.configureFlushOnWrite(!1),this.logService.error(s)}return await h.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}finally{r&&(this.mapHandleToLock.get(n)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),r.dispose())}}async read(n,r,s,c,u){const I=this.normalizePos(n,r);let D=null;try{D=(await h.Promises.read(n,s,c,u,I)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(n,I,D)}return D}normalizePos(n,r){return r===this.mapHandleToPos.get(n)?null:r}updatePos(n,r,s){const c=this.mapHandleToPos.get(n);typeof c=="number"&&(typeof r=="number"||(typeof s=="number"?this.mapHandleToPos.set(n,c+s):this.mapHandleToPos.delete(n)))}async write(n,r,s,c,u){return(0,k.retry)(()=>this.doWrite(n,r,s,c,u),100,3)}async doWrite(n,r,s,c,u){const I=this.normalizePos(n,r);let D=null;try{D=(await h.Promises.write(n,s,c,u,I)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),T)}finally{this.updatePos(n,I,D)}return D}async mkdir(n){try{await h.Promises.mkdir(this.toFilePath(n))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(n,r){try{const s=this.toFilePath(n);r.recursive?await h.Promises.rm(s,h.RimRafMode.MOVE):await h.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(n,r,s){const c=this.toFilePath(n),u=this.toFilePath(r);if(c!==u)try{await this.validateTargetDeleted(n,r,"move",s.overwrite),await h.Promises.move(c,u)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,b.localize)(2,null,(0,P.basename)(c),(0,P.basename)((0,P.dirname)(u)),I.toString()))),this.toFileSystemProviderError(I)}}async copy(n,r,s){const c=this.toFilePath(n),u=this.toFilePath(r);if(c!==u)try{await this.validateTargetDeleted(n,r,"copy",s.overwrite),await h.Promises.copy(c,u,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,b.localize)(3,null,(0,P.basename)(c),(0,P.basename)((0,P.dirname)(u)),I.toString()))),this.toFileSystemProviderError(I)}}async validateTargetDeleted(n,r,s,c){const u=this.toFilePath(n),I=this.toFilePath(r);let D=!1;if(!!(this.capabilities&1024)||(D=(0,l.isEqual)(u,I,!0)),D&&s==="copy")throw(0,C.createFileSystemProviderError)((0,b.localize)(4,null),C.FileSystemProviderErrorCode.FileExists);if(!D&&await h.Promises.exists(I)){if(!c)throw(0,C.createFileSystemProviderError)((0,b.localize)(5,null),C.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(n,r){return this.doCloneFile(n,r,!1)}async doCloneFile(n,r,s){const c=this.toFilePath(n),u=this.toFilePath(r),I=!!(this.capabilities&1024);if((0,l.isEqual)(c,u,!I))return;const D=new m.DisposableStore;try{const[T,N]=await Promise.all([this.createResourceLock(n),this.createResourceLock(r)]);D.add(T),D.add(N),s&&await h.Promises.mkdir((0,P.dirname)(u),{recursive:!0}),await h.Promises.copyFile(c,u)}catch(T){if(T.code==="ENOENT"&&!s)return this.doCloneFile(n,r,!0);throw this.toFileSystemProviderError(T)}finally{D.dispose()}}createUniversalWatcher(n,r,s){return new f.UniversalWatcherClient(c=>n(c),c=>r(c),s)}createNonRecursiveWatcher(n,r,s){return new a.NodeJSWatcherClient(c=>n(c),c=>r(c),s)}toFileSystemProviderError(n){if(n instanceof C.FileSystemProviderError)return n;let r;switch(n.code){case"ENOENT":r=C.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=C.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=C.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=C.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=C.FileSystemProviderErrorCode.NoPermissions;break;default:r=C.FileSystemProviderErrorCode.Unknown}return(0,C.createFileSystemProviderError)(n,r)}async toFileSystemProviderWriteError(n,r){let s=this.toFileSystemProviderError(r);if(n&&s.code===C.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await h.SymlinkSupport.stat(this.toFilePath(n));c.mode&128||(s=(0,C.createFileSystemProviderError)(r,C.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return s}}e.DiskFileSystemProvider=i,i.canFlush=!0}),define(Z[205],ee([0,1,3,86,2,18,58,22]),function(q,e,w,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class l extends k.Disposable{constructor(y,S){super(),this.provider=y,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(y,S,g){const h=this.getUriTransformer(y);switch(S){case"stat":return this.stat(h,g[0]);case"readdir":return this.readdir(h,g[0]);case"open":return this.open(h,g[0],g[1]);case"close":return this.close(g[0]);case"read":return this.read(g[0],g[1],g[2]);case"readFile":return this.readFile(h,g[0],g[1]);case"write":return this.write(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.writeFile(h,g[0],g[1],g[2]);case"rename":return this.rename(h,g[0],g[1],g[2]);case"copy":return this.copy(h,g[0],g[1],g[2]);case"cloneFile":return this.cloneFile(h,g[0],g[1]);case"mkdir":return this.mkdir(h,g[0]);case"delete":return this.delete(h,g[0],g[1]);case"watch":return this.watch(h,g[0],g[1],g[2],g[3]);case"unwatch":return this.unwatch(g[0],g[1])}throw new Error(`IPC Command ${S} not found`)}listen(y,S,g){const h=this.getUriTransformer(y);switch(S){case"fileChange":return this.onFileChange(h,g[0]);case"readFileStream":return this.onReadFileStream(h,g[0],g[1])}throw new Error(`Unknown event ${S}`)}stat(y,S){const g=this.transformIncoming(y,S,!0);return this.provider.stat(g)}readdir(y,S){const g=this.transformIncoming(y,S);return this.provider.readdir(g)}async readFile(y,S,g){const h=this.transformIncoming(y,S,!0),b=await this.provider.readFile(h,g);return R.VSBuffer.wrap(b)}onReadFileStream(y,S,g){const h=this.transformIncoming(y,S,!0),b=new E.CancellationTokenSource,C=new w.Emitter({onLastListenerRemove:()=>{b.cancel()}}),p=this.provider.readFileStream(h,g,b.token);return(0,M.listenStream)(p,{onData:v=>C.fire(R.VSBuffer.wrap(v)),onError:v=>C.fire(v),onEnd:()=>{C.fire("end"),C.dispose(),b.dispose()}}),C.event}writeFile(y,S,g,h){const b=this.transformIncoming(y,S);return this.provider.writeFile(b,g.buffer,h)}open(y,S,g){const h=this.transformIncoming(y,S,!0);return this.provider.open(h,g)}close(y){return this.provider.close(y)}async read(y,S,g){const h=R.VSBuffer.alloc(g),b=0,C=await this.provider.read(y,S,h.buffer,b,g);return[h,C]}write(y,S,g,h,b){return this.provider.write(y,S,g.buffer,h,b)}mkdir(y,S){const g=this.transformIncoming(y,S);return this.provider.mkdir(g)}delete(y,S,g){const h=this.transformIncoming(y,S);return this.provider.delete(h,g)}rename(y,S,g,h){const b=this.transformIncoming(y,S),C=this.transformIncoming(y,g);return this.provider.rename(b,C,h)}copy(y,S,g,h){const b=this.transformIncoming(y,S),C=this.transformIncoming(y,g);return this.provider.copy(b,C,h)}cloneFile(y,S,g){const h=this.transformIncoming(y,S),b=this.transformIncoming(y,g);return this.provider.cloneFile(h,b)}onFileChange(y,S){const g=new w.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(y,g))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return g.event}async watch(y,S,g,h,b){const C=this.sessionToWatcher.get(S);if(C){const p=this.transformIncoming(y,h),v=C.watch(g,p,b);this.watchRequests.set(S+g,v)}}async unwatch(y,S){const g=y+S,h=this.watchRequests.get(g);h&&((0,k.dispose)(h),this.watchRequests.delete(g))}dispose(){super.dispose();for(const[,y]of this.watchRequests)y.dispose();this.watchRequests.clear();for(const[,y]of this.sessionToWatcher)y.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=l;class m extends k.Disposable{constructor(y,S,g,h){super(),this.uriTransformer=y,this.logService=g,this.environmentService=h,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(y){const S=this._register(new w.Emitter);this._register(S.event(g=>{y.fire(g.map(h=>({resource:this.uriTransformer.transformOutgoingURI(h.resource),type:h.type})))})),this._register(this.fileWatcher.onDidChangeFile(g=>S.fire(g))),this._register(this.fileWatcher.onDidWatchError(g=>y.fire(g)))}getRecursiveWatcherOptions(y){}getExtraExcludes(y){}watch(y,S,g){const h=this.getExtraExcludes(this.environmentService);return Array.isArray(h)&&(g.excludes=[...g.excludes,...h]),this.watcherRequests.set(y,this.fileWatcher.watch(S,g)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(y)),this.watcherRequests.delete(y)})}dispose(){super.dispose();for(const[,y]of this.watcherRequests)y.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=m}),define(Z[206],ee([0,1,15,161,4,7,14,9,205,140]),function(q,e,w,t,k,R,M,E,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class P extends l.AbstractDiskFileSystemProviderChannel{constructor(g,h,b){super(g,h),this.environmentService=b}getUriTransformer(g){return m.DefaultURITransformer}transformIncoming(g,h){return R.URI.revive(h)}async delete(g,h,b){if(!b.useTrash)return super.delete(g,h,b);const C=this.transformIncoming(g,h),p=(0,E.normalize)(C.fsPath);try{await w.shell.trashItem(p)}catch{throw(0,M.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,E.basename)(p)):(0,t.localize)(1,null,(0,E.basename)(p)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(g,h){return new y(g,h,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=P;class y extends l.AbstractSessionFileWatcher{watch(g,h,b){if(b.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(g,h,b)}}}),define(Z[107],ee([0,1,6]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,M){switch(M){case w.LogLevel.Trace:return R.trace;case w.LogLevel.Debug:return R.debug;case w.LogLevel.Info:return R.info;case w.LogLevel.Warning:return R.warn;case w.LogLevel.Error:return R.error;case w.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends w.AbstractLogger{constructor(M=w.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(E=>{this._logger?.setLevel(E)}))}set logger(M){this._logger=M;for(const{level:E,args:l}of this.buffer)t(M,E).apply(M,l);this.buffer=[]}_log(M,...E){this._logger?t(this._logger,M).apply(this._logger,E):this.getLevel()<=M&&this.buffer.push({level:M,args:E})}trace(M,...E){this._log(w.LogLevel.Trace,M,...E)}debug(M,...E){this._log(w.LogLevel.Debug,M,...E)}info(M,...E){this._log(w.LogLevel.Info,M,...E)}warn(M,...E){this._log(w.LogLevel.Warning,M,...E)}error(M,...E){this._log(w.LogLevel.Error,M,...E)}critical(M,...E){this._log(w.LogLevel.Critical,M,...E)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(Z[207],ee([0,1,8,18,16,14,5,107,6]),function(q,e,w,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const m=5*R.ByteSize.MB;let P=class extends l.AbstractLogger{constructor(g,h,b,C,p){super(),this.name=g,this.resource=h,this.donotUseFormatters=C,this.fileService=p,this.backupIndex=1,this.setLevel(b),this.queue=this._register(new w.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=l.LogLevel.Trace&&this._log(l.LogLevel.Trace,(0,l.format)(arguments))}debug(){this.getLevel()<=l.LogLevel.Debug&&this._log(l.LogLevel.Debug,(0,l.format)(arguments))}info(){this.getLevel()<=l.LogLevel.Info&&this._log(l.LogLevel.Info,(0,l.format)(arguments))}warn(){this.getLevel()<=l.LogLevel.Warning&&this._log(l.LogLevel.Warning,(0,l.format)(arguments))}error(){if(this.getLevel()<=l.LogLevel.Error){const g=arguments[0];if(g instanceof Error){const h=Array.prototype.slice.call(arguments);h[0]=g.stack,this._log(l.LogLevel.Error,(0,l.format)(h))}else this._log(l.LogLevel.Error,(0,l.format)(arguments))}}critical(){this.getLevel()<=l.LogLevel.Critical&&this._log(l.LogLevel.Critical,(0,l.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(g){if(g.fileOperationResult!==3)throw g}}_log(g,h){this.queue.queue(async()=>{await this.initializePromise;let b=await this.loadContent();b.length>m&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(b)),b=""),this.donotUseFormatters?b+=h:b+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(g)}] ${h}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(b))})}getCurrentTimestamp(){const g=C=>C<10?`0${C}`:C,h=C=>C<10?`00${C}`:C<100?`0${C}`:C,b=new Date;return`${b.getFullYear()}-${g(b.getMonth()+1)}-${g(b.getDate())} ${g(b.getHours())}:${g(b.getMinutes())}:${g(b.getSeconds())}.${h(b.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(g){switch(g){case l.LogLevel.Critical:return"critical";case l.LogLevel.Debug:return"debug";case l.LogLevel.Error:return"error";case l.LogLevel.Info:return"info";case l.LogLevel.Trace:return"trace";case l.LogLevel.Warning:return"warning"}return""}};P=ve([J(4,R.IFileService)],P),e.FileLogger=P;let y=class extends l.AbstractLoggerService{constructor(g,h,b){super(g.getLevel(),g.onDidChangeLogLevel),this.instantiationService=h,this.fileService=b}doCreateLogger(g,h,b){const C=new E.BufferLogService(h);return(0,R.whenProviderRegistered)(g,this.fileService).then(()=>C.logger=this.instantiationService.createInstance(P,b?.name||(0,k.basename)(g),g,C.getLevel(),!!b?.donotUseFormatters)),C}};y=ve([J(0,l.ILogService),J(1,M.IInstantiationService),J(2,R.IFileService)],y),e.FileLoggerService=y}),define(Z[208],ee([0,1,3,7,6]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(S){this.service=S,this.onDidChangeLogLevel=w.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}async call(S,g,h){switch(g){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${g}`)}}e.LogLevelChannel=R;class M{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S){M.setLevel(this.channel,S)}static setLevel(S,g){return S.call("setLevel",g)}}e.LogLevelChannelClient=M;class E{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,g){throw new Error(`Event not found: ${g}`)}async call(S,g,h){switch(g){case"createLogger":this.createLogger(t.URI.revive(h[0]),h[1]);return;case"log":return this.log(t.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${g}`)}createLogger(S,g){this.loggers.set(S.toString(),this.loggerService.createLogger(S,g))}consoleLog(S,g){let h=console.log;switch(S){case k.LogLevel.Error:h=console.error;break;case k.LogLevel.Warning:h=console.warn;break;case k.LogLevel.Info:h=console.info;break}h.call(console,...g)}log(S,g){const h=this.loggers.get(S.toString());if(!h)throw new Error("Create the logger before logging");for(const[b,C]of g)(0,k.log)(h,b,C)}}e.LoggerChannel=E;class l extends k.AbstractLoggerService{constructor(S,g,h){super(S,g),this.channel=h}createConsoleMainLogger(){return new k.AdapterLogger({log:(S,g)=>{this.channel.call("consoleLog",[S,g])}})}doCreateLogger(S,g,h){return new m(this.channel,S,g,h)}}e.LoggerChannelClient=l;class m extends k.AbstractMessageLogger{constructor(S,g,h,b){super(b?.always),this.channel=S,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[g,b]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,g){const h=[[S,g]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(S){this.channel.call("log",[this.file,S])}}class P extends k.LogService{constructor(S,g){super(g),this.parent=S,this._register(S.onDidChangeLogLevel(h=>g.setLevel(h)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=P}),define(Z[108],ee([0,1,14,6]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(E,l,m,P,y){try{const S=await new Promise((h,b)=>{q(["spdlog"],h,b)});S.setFlushOn(t.LogLevel.Trace);const g=await S.createAsyncRotatingLogger(E,l,m,P);return y&&g.clearFormatters(),g}catch(S){console.error(S)}return null}function R(E,l,m){switch(l){case t.LogLevel.Trace:E.trace(m);break;case t.LogLevel.Debug:E.debug(m);break;case t.LogLevel.Info:E.info(m);break;case t.LogLevel.Warning:E.warn(m);break;case t.LogLevel.Error:E.error(m);break;case t.LogLevel.Critical:E.critical(m);break;default:throw new Error("Invalid log level")}}class M extends t.AbstractMessageLogger{constructor(l,m,P,y,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(l,m,P,y),this._register(this.onDidChangeLogLevel(g=>{this._logger?.setLevel(g)}))}async _createSpdLogLogger(l,m,P,y){const S=P?6:1,g=30/S*w.ByteSize.MB,h=await k(l,m,g,S,y);if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:b,message:C}of this.buffer)R(this._logger,b,C);this.buffer=[]}}log(l,m){this._logger?R(this._logger,l,m):this.getLevel()<=l&&this.buffer.push({level:l,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=M}),define(Z[209],ee([0,1,13,16,29,14,207,6,108]),function(q,e,w,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let m=class extends E.AbstractLoggerService{constructor(y,S){super(y.getLevel(),y.onDidChangeLogLevel),this.fileService=S}doCreateLogger(y,S,g){return y.scheme===w.Schemas.file?new l.SpdLogLogger(g?.name||(0,k.generateUuid)(),y.fsPath,!g?.donotRotate,!!g?.donotUseFormatters,S):new M.FileLogger(g?.name??(0,t.basename)(y),y,S,!!g?.donotUseFormatters,this.fileService)}};m=ve([J(0,E.ILogService),J(1,R.IFileService)],m),e.LoggerService=m}),define(Z[210],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function w(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=w;function t(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(M){return!w(M)&&!t(M)&&!k(M)}e.isMenubarMenuItemAction=R}),define(Z[37],ee([0,1,3,57,2,5]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class M extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(m){const P=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...m,...this.policyDefinitions},P!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(m),t.Iterable.reduce(this.policies.entries(),(y,[S,g])=>({...y,[S]:g}),{})}getPolicyValue(m){return this.policies.get(m)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(m,[P,y])=>({...m,[P]:{definition:y,value:this.policies.get(P)}}),{})}}e.AbstractPolicyService=M;class E{constructor(){this.onDidChange=w.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=E}),define(Z[211],ee([0,1,8,3,57,12,14,6,37]),function(q,e,w,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function m(y,S){const g=[];for(const h of k.Iterable.concat(y.keys(),S.keys()))y.get(h)!==S.get(h)&&g.push(h);return g}let P=class extends l.AbstractPolicyService{constructor(S,g,h){super(),this.file=S,this.fileService=g,this.logService=h,this.throttledDelayer=this._register(new w.ThrottledDelayer(500));const b=t.Event.filter(g.onDidFilesChange,C=>C.affects(S));this._register(g.watch(S)),this._register(b(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(S){await this.refresh()}async read(){const S=new Map;try{const g=await this.fileService.readFile(this.file),h=JSON.parse(g.value.toString());if(!(0,R.isObject)(h))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(h))this.policyDefinitions[b]&&S.set(b,h[b])}catch(g){g.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",g)}return S}async refresh(){const S=await this.read(),g=m(this.policies,S);this.policies=S,g.length>0&&this._onDidChange.fire(g)}};P=ve([J(1,M.IFileService),J(2,E.ILogService)],P),e.FilePolicyService=P}),define(Z[212],ee([0,1,3,2,37]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(l){this.service=l,this.disposables=new t.DisposableStore}listen(l,m){switch(m){case"onDidChange":return w.Event.map(this.service.onDidChange,P=>P.reduce((y,S)=>({...y,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${m}`)}call(l,m,P){switch(m){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(P)}throw new Error(`Call not found: ${m}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class M extends k.AbstractPolicyService{constructor(l,m){super(),this.channel=m;for(const P in l){const{definition:y,value:S}=l[P];this.policyDefinitions[P]=y,S!==void 0&&this.policies.set(P,S)}this.channel.listen("onDidChange")(P=>{for(const y in P){const S=P[y];S===null?this.policies.delete(y):this.policies.set(y,S)}this._onDidChange.fire(Object.keys(P))})}async initializePolicies(l){const m=await this.channel.call("registerPolicyDefinitions",l);for(const P in m)this.policies.set(P,m[P])}}e.PolicyChannelClient=M}),define(Z[54],ee([0,1,13,4,33,16]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const E=t.globals.vscode.context.configuration();if(E)M=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof q?.__$__nodeRequire=="function"){const E=(0,R.dirname)(w.FileAccess.asFileUri("",q));M=q.__$__nodeRequire((0,R.joinPath)(E,"product.json").fsPath);const l=q.__$__nodeRequire((0,R.joinPath)(E,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),Object.assign(M,{version:l.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=M}),define(Z[20],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[213],ee([0,1,76,6,20]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(E,l){this.productService=E,this.logService=l,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(E,l){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(l);if(!m)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",l),!1;const[,P,y]=m;let S=this.trustedExtensionUrlPublicKeys.get(E);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[E],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",E),!1;this.trustedExtensionUrlPublicKeys.set(E,[...S])}const g=Buffer.from(decodeURIComponent(y),"base64");if(g.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",l),!1;const h=g.slice(0,6),b=g.readUIntBE(0,6),C=Date.now()-b;if(C<0||C>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",l),!1;const p=g.slice(6),v=w.createVerify("SHA256");v.write(h),v.write(Buffer.from(P)),v.end();for(let d=0;d<S.length;d++){let f=S[d];if(f!==null){if(typeof f=="string")try{f=w.createPublicKey({key:Buffer.from(f,"base64"),format:"der",type:"spki"}),S[d]=f}catch(a){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${d+1} for ${E}:`,a),S[d]=null;continue}if(v.verify(f,p))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",l),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",l),!1}};R=ve([J(0,k.IProductService),J(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(Z[61],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,w.createDecorator)("protocolMainService")}),define(Z[47],ee([0,1,121,12]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(M,E){w.ok(t.isString(M)),w.ok(t.isObject(E)),w.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,E)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new k}),define(Z[214],ee([0,1,3,47]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class R{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,m){this.schemasById[k(l)]=m,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new R;t.Registry.add(e.Extensions.JSONContribution,M)}),define(Z[62],ee([0,1,24,3,12,149,19,214,47]),function(q,e,w,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=l.Registry.as(E.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=this.doRegisterConfigurations(i,o);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(i){const o=this.doDeregisterConfigurations(i);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=[];n.push(...this.doDeregisterConfigurations(o)),n.push(...this.doRegisterConfigurations(i,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,w.distinct)(n)})}registerDefaultConfigurations(i){const o=[],n=[];for(const{overrides:r,source:s}of i)for(const c in r)if(o.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const u=this.configurationDefaultsOverrides.get(c),I=u?.valuesSources??new Map;if(s)for(const U of Object.keys(r[c]))I.set(U,s);const D={...u?.value||{},...r[c]};this.configurationDefaultsOverrides.set(c,{source:s,value:D,valuesSources:I});const T=(0,M.getLanguageTagSettingPlainKey)(c),N={type:"object",default:D,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:k.isString(s)?void 0:s,defaultValueSource:s};n.push(...b(c)),this.configurationProperties[c]=N,this.defaultLanguageConfigurationOverridesNode.properties[c]=N}else{this.configurationDefaultsOverrides.set(c,{value:r[c],source:s});const u=this.configurationProperties[c];u&&(this.updatePropertyDefaultValue(c,u),this.updateSchema(c,u))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const o=[];for(const{overrides:n,source:r}of i)for(const s in n){const c=this.configurationDefaultsOverrides.get(s),u=k.isString(r)?r:r?.id,I=k.isString(c?.source)?c?.source:c?.source?.id;if(u===I)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const D=this.configurationProperties[s];D&&(this.updatePropertyDefaultValue(s,D),this.updateSchema(s,D))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const o of i)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,o){const n=[];return i.forEach(r=>{n.push(...this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),n}doDeregisterConfigurations(i){const o=[],n=r=>{if(r.properties)for(const s in r.properties){o.push(s);const c=this.configurationProperties[s];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,r.properties[s])}r.allOf?.forEach(s=>n(s))};for(const r of i){n(r);const s=this.configurationContributors.indexOf(r);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(i,o=!0,n,r,s=3){s=k.isUndefinedOrNull(i.scope)?s:i.scope;const c=[],u=i.properties;if(u)for(const D in u){const T=u[D];if(o&&d(D,T)){delete u[D];continue}if(T.source=n,T.defaultDefaultValue=u[D].default,this.updatePropertyDefaultValue(D,T),e.OVERRIDE_PROPERTY_REGEX.test(D)?T.scope=void 0:(T.scope=k.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=k.isUndefinedOrNull(T.restricted)?!!r?.includes(D):T.restricted),u[D].hasOwnProperty("included")&&!u[D].included){this.excludedConfigurationProperties[D]=u[D],delete u[D];continue}else this.configurationProperties[D]=u[D],u[D].policy?.name&&this.policyConfigurations.set(u[D].policy.name,D);!u[D].deprecationMessage&&u[D].markdownDeprecationMessage&&(u[D].deprecationMessage=u[D].markdownDeprecationMessage),c.push(D)}const I=i.allOf;if(I)for(const D of I)c.push(...this.validateAndRegisterProperties(D,o,n,r,s));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const o=n=>{const r=n.properties;if(r)for(const c in r)this.updateSchema(c,r[c]);n.allOf?.forEach(o)};o(i)}updateSchema(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.resourceLanguageSettingsSchema.properties[i]=o;break}}removeFromSchema(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const o=`[${i}]`,n={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,o){const n=this.configurationDefaultsOverrides.get(i);let r=n?.value,s=n?.source;k.isUndefined(r)&&(r=o.defaultDefaultValue,s=void 0),k.isUndefined(r)&&(r=p(o.type)),o.default=r,o.defaultValueSource=s}}const g="\\[([^\\]]+)\\]",h=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(a){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let o=h.exec(a);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=h.exec(a)}}return(0,w.distinct)(i)}e.overrideIdentifiersFromKey=b;function C(a){return a.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=C;function p(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const v=new S;l.Registry.add(e.Extensions.Configuration,v);function d(a,i){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?R.localize(7,null,a):v.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):i.policy?.name&&v.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,a,i.policy?.name,v.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=d;function f(){const a=[],i=v.getConfigurationProperties();for(const o of Object.keys(i))a.push([o,i[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=f}),define(Z[109],ee([0,1,24,3,43,2,31,50,12,7,19,62,47]),function(q,e,w,t,k,R,M,E,l,m,P,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class g{constructor(i={},o=[],n=[]){this._contents=i,this._keys=o,this._overrides=n,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,o){const n=this.getContentsForOverrideIdentifer(o);return n?i?(0,P.getConfigurationValue)(n,i):n:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const n of this.overrides)n.identifiers.includes(i)&&o.push(...n.keys);return w.distinct(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return w.distinct(i)}override(i){let o=this.overrideConfigurations.get(i);return o||(o=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,o)),o}merge(...i){const o=E.deepClone(this.contents),n=E.deepClone(this.overrides),r=[...this.keys];for(const s of i)if(!s.isEmpty()){this.mergeContents(o,s.contents);for(const c of s.overrides){const[u]=n.filter(I=>w.equals(I.identifiers,c.identifiers));u?(this.mergeContents(u.contents,c.contents),u.keys.push(...c.keys),u.keys=w.distinct(u.keys)):n.push(E.deepClone(c))}for(const c of s.keys)r.indexOf(c)===-1&&r.push(c)}return new g(o,r,n)}freeze(){return this.frozen=!0,this}clone(){return new g(E.deepClone(this.contents),[...this.keys],E.deepClone(this.overrides))}createOverrideConfigurationModel(i){const o=this.getContentsForOverrideIdentifer(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const n={};for(const r of w.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[r];const c=o[r];c&&(typeof s=="object"&&typeof c=="object"?(s=E.deepClone(s),this.mergeContents(s,c)):s=c),n[r]=s}return new g(n,this.keys,this.overrides)}mergeContents(i,o){for(const n of Object.keys(o)){if(n in i&&l.isObject(i[n])&&l.isObject(o[n])){this.mergeContents(i[n],o[n]);continue}i[n]=E.deepClone(o[n])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?E.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let o=null,n=null;const r=s=>{s&&(n?this.mergeContents(n,s):n=E.deepClone(s))};for(const s of this.overrides)w.equals(s.identifiers,[i])?o=s.contents:s.identifiers.includes(i)&&r(s.contents);return r(o),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,o){this.addKey(i),(0,P.addToValueTree)(this.contents,i,o,n=>{throw new Error(n)})}removeValue(i){this.removeKey(i)&&(0,P.removeFromValueTree)(this.contents,i)}addKey(i){let o=this.keys.length;for(let n=0;n<o;n++)i.indexOf(this.keys[n])===0&&(o=n);this.keys.splice(o,1,i)}removeKey(i){const o=this.keys.indexOf(i);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=g;class h{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,o){if(!l.isUndefinedOrNull(i)){const n=this.doParseContent(i);this.parseRaw(n,o)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,o){this._raw=i;const{contents:n,keys:r,overrides:s,restricted:c}=this.doParseRaw(i,o);this._configurationModel=new g(n,r,s),this._restrictedConfigurations=c||[]}doParseContent(i){let o={},n=null,r=[];const s=[],c=[];function u(D){Array.isArray(r)?r.push(D):n!==null&&(r[n]=D)}const I={onObjectBegin:()=>{const D={};u(D),s.push(r),r=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const D=[];u(D),s.push(r),r=D,n=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:u,onError:(D,T,N)=>{c.push({error:D,offset:T,length:N})}};if(i)try{k.visit(i,I),o=r[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return o}doParseRaw(i,o){const n=S.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,n,!0,o);i=r.raw;const s=(0,P.toValuesTree)(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),c=Object.keys(i),u=this.toOverrides(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:s,keys:c,overrides:u,restricted:r.restricted}}filter(i,o,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const s={},c=[];for(const u in i)if(y.OVERRIDE_PROPERTY_REGEX.test(u)&&n){const I=this.filter(i[u],o,!1,r);s[u]=I.raw,c.push(...I.restricted)}else{const I=o[u],D=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&c.push(u),(D===void 0||r.scopes===void 0||r.scopes.includes(D))&&(r.skipRestricted&&I?.restricted||(s[u]=i[u]))}return{raw:s,restricted:c}}toOverrides(i,o){const n=[];for(const r of Object.keys(i))if(y.OVERRIDE_PROPERTY_REGEX.test(r)){const s={};for(const c in i[r])s[c]=i[r][c];n.push({identifiers:(0,y.overrideIdentifiersFromKey)(r),keys:Object.keys(s),contents:(0,P.toValuesTree)(s,o)})}return n}}e.ConfigurationModelParser=h;class b extends R.Disposable{constructor(i,o,n,r){super(),this.userSettingsResource=i,this.scopes=o,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&n.isEqual(s.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class C{constructor(i,o,n,r,s=new g,c=new g,u=new M.ResourceMap,I=new g,D=new M.ResourceMap,T=!0){this._defaultConfiguration=i,this._policyConfiguration=o,this._applicationConfiguration=n,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=c,this._folderConfigurations=u,this._memoryConfiguration=I,this._memoryConfigurationByResource=D,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(i,o,n){return this.getConsolidatedConfigurationModel(i,o,n).getValue(i)}updateValue(i,o,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new g,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,o===void 0?r.removeValue(i):r.setValue(i,o),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,o,n){const r=this.getConsolidatedConfigurationModel(i,o,n),s=this.getFolderConfigurationModelForResource(o.resource,n),c=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,u=o.overrideIdentifier?this._defaultConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),I=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(i),D=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(i),T=o.overrideIdentifier?this.userConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),N=o.overrideIdentifier?this.localUserConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),U=o.overrideIdentifier?this.remoteUserConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),$=n?o.overrideIdentifier?this._workspaceConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,Y=s?o.overrideIdentifier?s.freeze().override(o.overrideIdentifier).getValue(i):s.freeze().getValue(i):void 0,oe=o.overrideIdentifier?c.override(o.overrideIdentifier).getValue(i):c.getValue(i),ue=r.getValue(i),se=w.distinct(r.overrides.map(he=>he.identifiers).flat()).filter(he=>r.getOverrideValue(i,he)!==void 0);return{defaultValue:u,policyValue:I,applicationValue:D,userValue:T,userLocalValue:N,userRemoteValue:U,workspaceValue:$,workspaceFolderValue:Y,memoryValue:oe,value:ue,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,policy:I!==void 0?{value:I}:void 0,application:D!==void 0?{value:D,override:o.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,workspace:$!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,workspaceFolder:Y!==void 0?{value:s?.freeze().getValue(i),override:o.overrideIdentifier?s?.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,memory:oe!==void 0?{value:c.getValue(i),override:o.overrideIdentifier?c.getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(i){const o=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,o){this._folderConfigurations.set(i,o),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const n=[];if(!o){const{added:r,updated:s,removed:c}=d(this._defaultConfiguration,i);o=[...r,...s,...c]}for(const r of o)for(const s of(0,y.overrideIdentifiersFromKey)(r)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(s),u=i.getKeysForOverrideIdentifier(s),I=[...u.filter(D=>c.indexOf(D)===-1),...c.filter(D=>u.indexOf(D)===-1),...c.filter(D=>!E.equals(this._defaultConfiguration.override(s).getValue(D),i.override(s).getValue(D)))];n.push([s,I])}return this.updateDefaultConfiguration(i),{keys:o,overrides:n}}compareAndUpdatePolicyConfiguration(i){const{added:o,updated:n,removed:r}=d(this._policyConfiguration,i),s=[...o,...n,...r];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=d(this.applicationConfiguration,i),c=[...o,...n,...r];return c.length&&this.updateApplicationConfiguration(i),{keys:c,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=d(this.localUserConfiguration,i),c=[...o,...n,...r];return c.length&&this.updateLocalUserConfiguration(i),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=d(this.remoteUserConfiguration,i),c=[...o,...n,...r];return c.length&&this.updateRemoteUserConfiguration(i),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=d(this.workspaceConfiguration,i),c=[...o,...n,...r];return c.length&&this.updateWorkspaceConfiguration(i),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(i,o){const n=this.folderConfigurations.get(i),{added:r,updated:s,removed:c,overrides:u}=d(n,o),I=[...r,...s,...c];return(I.length||!n)&&this.updateFolderConfiguration(i,o),{keys:I,overrides:u}}compareAndDeleteFolderConfiguration(i){const o=this.folderConfigurations.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:r,removed:s,overrides:c}=d(o,void 0);return{keys:[...n,...r,...s],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,o,n){let r=this.getConsolidatedConfigurationModelForResource(o,n);return o.overrideIdentifier&&(r=r.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:i},o){let n=this.getWorkspaceConsolidatedConfiguration();if(o&&i){const r=o.getFolder(i);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const s=this._memoryConfigurationByResource.get(i);s&&(n=n.merge(s))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let o=this._foldersConsolidatedConfigurations.get(i);if(!o){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(o=n.merge(r),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(i,o)):o=n}return o}getFolderConfigurationModelForResource(i,o){if(o&&i){const n=o.getFolder(i);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,o)=>{const{contents:n,overrides:r,keys:s}=this._folderConfigurations.get(o);return i.push([o,{contents:n,overrides:r,keys:s}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>i.add(o)),this.userConfiguration.freeze().keys.forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(n=>i.add(n))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>o.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>o.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(r=>o.add(r))),[...o.values()]}static parse(i){const o=this.parseConfigurationModel(i.defaults),n=this.parseConfigurationModel(i.policy),r=this.parseConfigurationModel(i.application),s=this.parseConfigurationModel(i.user),c=this.parseConfigurationModel(i.workspace),u=i.folders.reduce((I,D)=>(I.set(m.URI.revive(D[0]),this.parseConfigurationModel(D[1])),I),new M.ResourceMap);return new C(o,n,r,s,new g,c,u,new g,new M.ResourceMap,!1)}static parseConfigurationModel(i){return new g(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=C;function p(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,o=new Map;for(const r of a)r.keys.forEach(s=>i.add(s)),r.overrides.forEach(([s,c])=>{const u=(0,M.getOrSet)(o,s,new Set);c.forEach(I=>u.add(I))});const n=[];return o.forEach((r,s)=>n.push([s,[...r.values()]])),{keys:[...i.values()],overrides:n}}e.mergeChanges=p;class v{constructor(i,o,n,r){this.change=i,this.previous=o,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const s=new Set;i.keys.forEach(u=>s.add(u)),i.overrides.forEach(([,u])=>u.forEach(I=>s.add(I))),this.affectedKeys=[...s.values()];const c=new g;this.affectedKeys.forEach(u=>c.setValue(u,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(o){const n=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,o,this.currentWorkspace);return!E.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(i,o){let n=(0,P.toValuesTree)({[o]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(i=i[r],!i)return!1;n=n[r]}return!0}}e.ConfigurationChangeEvent=v;function d(a,i){const{added:o,removed:n,updated:r}=f(i,a),s=[],c=a?.getAllOverrideIdentifiers()||[],u=i?.getAllOverrideIdentifiers()||[];if(i){const I=u.filter(D=>!c.includes(D));for(const D of I)s.push([D,i.getKeysForOverrideIdentifier(D)])}if(a){const I=c.filter(D=>!u.includes(D));for(const D of I)s.push([D,a.getKeysForOverrideIdentifier(D)])}if(i&&a){for(const I of c)if(u.includes(I)){const D=f({contents:a.getOverrideValue(void 0,I)||{},keys:a.getKeysForOverrideIdentifier(I)},{contents:i.getOverrideValue(void 0,I)||{},keys:i.getKeysForOverrideIdentifier(I)});s.push([I,[...D.added,...D.removed,...D.updated]])}}return{added:o,removed:n,updated:r,overrides:s}}function f(a,i){const o=a?i?a.keys.filter(s=>i.keys.indexOf(s)===-1):[...a.keys]:[],n=i?a?i.keys.filter(s=>a.keys.indexOf(s)===-1):[...i.keys]:[],r=[];if(a&&i){for(const s of i.keys)if(a.keys.indexOf(s)!==-1){const c=(0,P.getConfigurationValue)(i.contents,s),u=(0,P.getConfigurationValue)(a.contents,s);E.equals(c,u)||r.push(s)}}return{added:o,removed:n,updated:r}}}),define(Z[215],ee([0,1,24,3,2,50,12,19,109,62,6,37,47]),function(q,e,w,t,k,R,M,E,l,m,P,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class g extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new h(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(S.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:d})=>this.onDidUpdateConfiguration(v,d))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(v,d){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:v})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=g;class h extends l.ConfigurationModel{constructor(v={}){const d=S.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(d),a=Object.create(null),i=[];for(const o in d){const n=v[o],r=n!==void 0?n:d[o].default;(0,E.addToValueTree)(a,o,r,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(a))m.OVERRIDE_PROPERTY_REGEX.test(o)&&i.push({identifiers:(0,m.overrideIdentifiersFromKey)(o),keys:Object.keys(a[o]),contents:(0,E.toValuesTree)(a[o],n=>console.error(`Conflict in default settings file: ${n}`))});super(a,f,i)}}e.DefaultConfigurationModel=h;class b{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new l.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=b;let C=class extends k.Disposable{constructor(v,d,f){super(),this.defaultConfiguration=v,this.policyService=d,this.logService=f,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new l.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(v=>this.onDidChangePolicies(v))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:v})=>this.update(await this.registerPolicyDefinitions(v),!0))),this._configurationModel}async registerPolicyDefinitions(v){const d={},f=[],a=S.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const i of v){const o=a[i];if(!o){f.push(i);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}f.push(i),d[o.policy.name]={type:o.type}}}return(0,M.isEmptyObject)(d)||await this.policyService.registerPolicyDefinitions(d),f}onDidChangePolicies(v){const d=S.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),f=(0,w.coalesce)(v.map(a=>d.get(a)));this.update(f,!0)}update(v,d){const f=S.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),a=[],i=this._configurationModel.isEmpty();for(const o of v){const n=f[o]?.policy?.name;if(n){const r=this.policyService.getPolicyValue(n);(i?r!==void 0:!(0,R.equals)(this._configurationModel.getValue(o),r))&&a.push([o,r])}else this._configurationModel.getValue(o)!==void 0&&a.push([o,void 0])}if(a.length){const o=this._configurationModel;this._configurationModel=new l.ConfigurationModel;for(const n of o.keys)this._configurationModel.setValue(n,o.getValue(n));for(const[n,r]of a)r===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,r);d&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};C=ve([J(1,y.IPolicyService),J(2,P.ILogService)],C),e.PolicyConfiguration=C}),define(Z[216],ee([0,1,8,3,2,16,19,109,215,37]),function(q,e,w,t,k,R,M,E,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends k.Disposable{constructor(S,g,h,b){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new l.DefaultConfiguration),this.policyConfiguration=h instanceof m.NullPolicyService?new l.NullPolicyConfiguration:this._register(new l.PolicyConfiguration(this.defaultConfiguration,h,b)),this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,g)),this.configuration=new E.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new E.ConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:C,properties:p})=>this.onDidDefaultConfigurationChange(C,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(C=>this.onDidPolicyConfigurationChange(C))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,g,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new E.Configuration(S,g,new E.ConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(S,g){const h=typeof S=="string"?S:void 0,b=(0,M.isConfigurationOverrides)(S)?S:(0,M.isConfigurationOverrides)(g)?g:{};return this.configuration.getValue(h,b,void 0)}updateValue(S,g,h,b){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const g=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(h,g,2)}onDidDefaultConfigurationChange(S,g){const h=this.configuration.toData(),b=this.configuration.compareAndUpdateDefaultConfiguration(S,g);this.trigger(b,h,7)}onDidPolicyConfigurationChange(S){const g=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(h,g,7)}trigger(S,g,h){const b=new E.ConfigurationChangeEvent(S,{data:g},this.configuration);b.source=h,b.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(b)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(Z[217],ee([0,1,17,5]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends w.ErrorNoTelemetry{constructor(E,l=k.Unknown,m){super(E),this._message=E,this._code=l,this._detail=m,this.isHandled=l===k.NotAvailable&&m===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(E){return E instanceof R&&E._code===k.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof R&&E._code===k.NoResolverFound}static isHandled(E){return E instanceof R&&E.isHandled}}e.RemoteAuthorityResolverError=R}),define(Z[63],ee([0,1,13]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(m){return m.scheme===w.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=t;function k(m){if(!m)return;const P=m.indexOf("+");return P<0?m:m.substr(0,P)}e.getRemoteName=k;function R(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=R;function M(m){const{host:P,port:y}=l(m);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:y}}e.parseAuthorityWithPort=M;function E(m,P){let{host:y,port:S}=l(m);return typeof S>"u"&&(S=P),{host:y,port:S}}e.parseAuthorityWithOptionalPort=E;function l(m){const P=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const y=m.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const S=m.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:m,port:void 0}}}),define(Z[110],ee([0,1,25,5,63]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=R;function M(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));var l;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(l=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,C){if(typeof b>"u"||b===null)return typeof C>"u"||C===null;if(typeof C>"u"||C===null)return!1;if(typeof b=="string"||typeof C=="string"){const p=typeof b=="string"?b:b.value,v=typeof C=="string"?C:C.value;return w.equalsIgnoreCase(p,v)}return b._lower===C._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=m;function P(h){return y(h)}e.isApplicationScopedExtension=P;function y(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function S(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function g(h,b){if(b){const C=`onResolveRemoteAuthority:${(0,k.getRemoteName)(b)}`;return h.activationEvents?.indexOf(C)!==-1}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[111],ee([0,1,25,192,110,4,7,17,33]),function(q,e,w,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(o,n){return o.uuid&&n.uuid?o.uuid===n.uuid:o.id===n.id?!0:(0,w.compareIgnoreCase)(o.id,n.id)===0}e.areSameExtensions=m;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{constructor(n,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=n.id}static create(n){const r=n.manifest?n.manifest.version:n.version,s=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new y(n.identifier,r,s)}static parse(n){const r=P.exec(n);return r&&r[1]&&r[2]?new y({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof y?m(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=y;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(o){const n=S.exec(o);return n&&n[1]?[b(n[1]),n[2]]:[b(o),void 0]}e.getIdAndVersion=g;function h(o,n){return`${o}.${n}`}e.getExtensionId=h;function b(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=b;function C(o,n){return b(h(o,n))}e.getGalleryExtensionId=C;function p(o,n){const r=[],s=c=>{for(const u of r)if(u.some(I=>m(n(I),n(c))))return u;return null};for(const c of o){const u=s(c);u?u.push(c):r.push([c])}return r}e.groupByExtension=p;function v(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function d(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(o,n){const r=[],s=n.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const c=s.shift();if(c&&r.every(u=>!m(u.identifier,{id:c}))){const u=o.filter(I=>m(I.identifier,{id:c}));u.length===1&&(r.push(u[0]),s.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=f;async function a(o,n){if(!R.isLinux)return!1;let r;try{r=(await o.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await o.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){n.debug("Error while getting the os-release file.",(0,E.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=a;async function i(o,n){const r=await a(o,n),s=(0,t.getTargetPlatform)(r?"alpine":R.platform,l.arch);return n.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=i}),define(Z[72],ee([0,1,8,18,2,31,7,111,14,5,6]),function(q,e,w,t,k,R,M,E,l,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let y=class extends k.Disposable{constructor(g,h){super(),this.fileService=g,this.logService=h,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(g){return this.withProfileExtensions(g)}addExtensionsToProfile(g,h){return this.withProfileExtensions(h,b=>(b=b.filter(C=>g.some(([p])=>!(0,E.areSameExtensions)(C.identifier,p.identifier))),b.push(...g.map(([C,p])=>({identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:p}))),b))}removeExtensionFromProfile(g,h){return this.withProfileExtensions(h,b=>b.filter(C=>!(0,E.areSameExtensions)(C.identifier,g)))}async withProfileExtensions(g,h){return this.getResourceAccessQueue(g).queue(async()=>{let b=[];try{const C=await this.fileService.readFile(g),p=JSON.parse(C.value.toString());for(const v of p){if(!v.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",v);continue}if(!v.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",v);continue}if(!v.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",v);continue}b.push({identifier:v.identifier,location:M.URI.revive(v.location),version:v.version,metadata:v.metadata})}}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}if(h){b=h(b);const C=b.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),metadata:p.metadata}));await this.fileService.writeFile(g,t.VSBuffer.fromString(JSON.stringify(C)))}return b})}getResourceAccessQueue(g){let h=this.resourcesAccessQueueMap.get(g);return h||(h=new w.Queue,this.resourcesAccessQueueMap.set(g,h)),h}};y=ve([J(0,l.IFileService),J(1,P.ILogService)],y),e.ExtensionsProfileScannerService=y}),define(Z[218],ee([0,1,8,18,22,17,3,2,29,100,217,63]),function(q,e,w,t,k,R,M,E,l,m,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var g;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function h(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function b(B){const j=new k.CancellationTokenSource;return setTimeout(()=>j.cancel(),B),j.token}function C(B,j){if(B.isCancellationRequested||j.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return B.onCancellationRequested(()=>L.cancel()),j.onCancellationRequested(()=>L.cancel()),L.token}class p{constructor(j){this._state="pending",this._disposables=new E.DisposableStore,this.promise=new Promise((L,O)=>{this._resolvePromise=L,this._rejectPromise=O}),j.isCancellationRequested?this._timeout():this._disposables.add(j.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(j){this._state==="pending"?this._disposables.add(j):j.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(j))}reject(j){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(j))}}function v(B,j){const L=new p(j);return L.registerDisposable(B.onControlMessage(O=>{const _=JSON.parse(O.toString()),V=F(_);V?L.reject(V):L.resolve(_)})),L.promise}function d(B,j,L,O,_,V,x,re){const H=new p(re);return j.connect(L,O,_,V,x,(ie,ne)=>{H.didTimeout?(ie&&B.error(ie),ne?.dispose()):ie||!ne?H.reject(ie):H.resolve(ne)}),H.promise}function f(B,j){const L=new p(j);return B.then(O=>{L.didTimeout||L.resolve(O)},O=>{L.didTimeout||L.reject(O)}),L.promise}async function a(B,j,L,O){const _=z(B,j);B.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let V;try{V=await d(B.logService,B.socketFactory,B.host,B.port,(0,y.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${h(j)}-${B.reconnectionToken}`,O)}catch(ne){throw B.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),B.logService.error(ne),ne}B.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let x,re;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(V,null),x=B.reconnectionProtocol,re=!1):(x=new m.PersistentProtocol(V,null),re=!0),B.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const H=await f(B.signService.createNewMessage((0,l.generateUuid)()),O),ie={type:"auth",auth:B.connectionToken||"00000000000000000000",data:H.data};x.sendControl(t.VSBuffer.fromString(JSON.stringify(ie)));try{const ne=await v(x,C(O,b(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const Le=new Error("Unexpected handshake message");throw Le.code="VSCODE_CONNECTION_ERROR",Le}if(B.logService.trace(`${_} 4/6. received SignRequest control message.`),!await f(B.signService.validate(H,ne.signedData),O)){const Le=new Error("Refused to connect to unsupported server");throw Le.code="VSCODE_CONNECTION_ERROR",Le}const fe=await f(B.signService.sign(ne.data),O),De={type:"connectionType",commit:B.commit,signedData:fe,desiredConnectionType:j};return L&&(De.args=L),B.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(t.VSBuffer.fromString(JSON.stringify(De))),{protocol:x,ownsProtocol:re}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(B.logService.error(`${_} the handshake timed out. Error:`),B.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${_} received error control message when negotiating connection. Error:`),B.logService.error(ne)),re&&K(x),ne}}async function i(B,j,L,O){const _=Date.now(),V=z(B,j),{protocol:x,ownsProtocol:re}=await a(B,j,L,O),H=new p(O);return H.registerDisposable(x.onControlMessage(ie=>{const ne=JSON.parse(ie.toString()),ae=F(ne);ae?(B.logService.error(`${V} received error control message when negotiating connection. Error:`),B.logService.error(ae),re&&K(x),H.reject(ae)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${te(_)}!`),H.resolve({protocol:x,firstMessage:ne}))})),H.promise}async function o(B,j){const{protocol:L}=await i(B,1,void 0,j);return{protocol:L}}async function n(B,j,L){const{protocol:O,firstMessage:_}=await i(B,2,j,L),V=_&&_.debugPort;return{protocol:O,debugPort:V}}async function r(B,j,L){const O=Date.now(),_=z(B,3),{protocol:V}=await a(B,3,j,L);return B.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${te(O)}!`),V}async function s(B,j,L){const{host:O,port:_,connectionToken:V}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:O,port:_,connectionToken:V,reconnectionToken:j,reconnectionProtocol:L,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function c(B,j,L){return I(B,async O=>{const{protocol:_}=await o(O,k.CancellationToken.None);return new he(B,j,L,O.reconnectionToken,_)})}e.connectRemoteAgentManagement=c;async function u(B,j){return I(B,async L=>{const{protocol:O,debugPort:_}=await n(L,j,k.CancellationToken.None);return new G(B,j,L.reconnectionToken,O,_)})}e.connectRemoteAgentExtensionHost=u;async function I(B,j){for(let O=1;;O++)try{const _=(0,l.generateUuid)(),V=await s(B,_,null);return await j(V)}catch(_){if(O<5)B.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(_);else throw B.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(_),se.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(_)),_}}async function D(B,j,L){const O=await s(B,(0,l.generateUuid)(),null);return await r(O,{host:j,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=D;function T(B){return(0,w.createCancelablePromise)(j=>new Promise((L,O)=>{const _=setTimeout(L,B*1e3);j.onCancellationRequested(()=>{clearTimeout(_),L()})}))}var N;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(N=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(j,L){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=U;class ${constructor(j,L,O,_){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.durationSeconds=O,this.cancellableTimer=_,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=$;class Y{constructor(j,L,O){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=Y;class oe{constructor(j,L,O){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=4}}e.ConnectionGainEvent=oe;class ue{constructor(j,L,O,_){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=O,this.handled=_,this.type=3}}e.ReconnectionPermanentFailureEvent=ue;class se extends E.Disposable{constructor(j,L,O,_,V){super(),this._connectionType=j,this._options=L,this.reconnectionToken=O,this.protocol=_,this._reconnectionFailureIsFatal=V,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new oe(this.reconnectionToken,0,0)),this._register(_.onSocketClose(x=>{const re=W(this._connectionType,this.reconnectionToken,!0);x?x.type===0?(this._options.logService.info(`${re} received socket close event (hadError: ${x.hadError}).`),x.error&&this._options.logService.error(x.error)):(this._options.logService.info(`${re} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this._options.logService.error(x.event)):this._options.logService.info(`${re} received socket close event.`),this._beginReconnecting()})),this._register(_.onSocketTimeout(x=>{const re=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,E.toDisposable)(()=>{const x=se._instances.indexOf(this);x>=0&&se._instances.splice(x,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}static triggerPermanentFailure(j,L,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=j,this._permanentFailureAttempt=L,this._permanentFailureHandled=O,this._instances.forEach(_=>_._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(j=>j._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(j=>j._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const j=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const _=O<L.length?L[O]:L[L.length-1];try{if(_>0){const x=T(_);this._onDidStateChange.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,x)),this._options.logService.info(`${j} waiting for ${_} seconds before reconnecting...`);try{await x}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${j} resolving connection...`);const V=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${j} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,b(S)),this._options.logService.info(`${j} reconnected!`),this._onDidStateChange.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,R.isCancellationError)(V)){this._options.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,P.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(j,L,O){this._reconnectionFailureIsFatal?se.triggerPermanentFailure(j,L,O):this._gotoPermanentFailure(j,L,O)}_gotoPermanentFailure(j,L,O){this._onDidStateChange.fire(new ue(this.reconnectionToken,j,L,O)),K(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class he extends se{constructor(j,L,O,_,V){super(1,j,_,V,!0),this.client=this._register(new m.Client(V,{remoteAuthority:L,clientId:O},j.ipcLogger))}async _reconnect(j,L){await o(j,L)}}e.ManagementPersistentConnection=he;class G extends se{constructor(j,L,O,_,V){super(2,j,O,_,!1),this._startArguments=L,this.debugPort=V}async _reconnect(j,L){await n(j,this._startArguments,L)}}e.ExtensionHostPersistentConnection=G;function K(B){try{B.acceptDisconnect();const j=B.getSocket();B.dispose(),j.dispose()}catch(j){(0,R.onUnexpectedError)(j)}}function F(B){if(B&&B.type==="error"){const j=new Error(`Connection error: ${B.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function A(B,j){for(;B.length<j;)B+=" ";return B}function W(B,j,L){return`[remote-connection][${A(h(B),13)}][${j.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function z(B,j){return`${W(j,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function te(B){return`${Date.now()-B} ms`}}),define(Z[219],ee([0,1,77,83]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,M,E,l,m){const P=S=>m(S,void 0),y=w.createConnection({host:k,port:R},()=>{y.removeListener("error",P);const S=Buffer.alloc(16);for(let C=0;C<16;C++)S[C]=Math.round(Math.random()*256);const g=S.toString("base64"),h=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${M}?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];y.write(h.join(`\r
`)+`\r
\r
`);const b=C=>{C.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",b),m(void 0,new t.NodeSocket(y,l)))};y.on("data",b)});y.setNoDelay(!0),y.once("error",P)}}}),define(Z[220],ee([0,1,28,45,40,183]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let M;async function E(g=!1){return(M===void 0||g)&&(M=l()),M}e.hasWSLFeatureInstalled=E;async function l(){const g=m();if(g===void 0)return!1;if(g>=22e3){const h=y();if(h)return new Promise(b=>{t.execFile(h,["--status"],C=>b(!C))})}else{const h=S();if(h)try{if((await k.promises.stat(h)).isFile())return!0}catch{}}return!1}function m(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(w.release());if(g)return parseInt(g[3])}function P(g){const h=process.env.SystemRoot;if(h){const b=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(h,b?"Sysnative":"System32",g)}}function y(){return P("wsl.exe")}function S(){return P("lxss\\LxssManager.dll")}}),define(Z[55],ee([0,1,18,166,62,5,47]),function(q,e,w,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function E(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}e.isSuccess=E;function l(b){return b.res.statusCode===204}async function m(b){return l(b)?null:(await(0,w.streamToBuffer)(b.stream)).toString()}e.asText=m;async function P(b){if(!E(b))throw new Error("Server returned "+b.res.statusCode);return m(b)}e.asTextOrError=P;async function y(b){if(!E(b))throw new Error("Server returned "+b.res.statusCode);if(l(b))return null;const p=(await(0,w.streamToBuffer)(b.stream)).toString();try{return JSON.parse(p)}catch(v){throw v.message+=`:
`+p,v}}e.asJson=y;function S(b){h(b)}e.updateProxyConfigurationsScope=S;let g;function h(b){const C=M.Registry.as(k.Extensions.Configuration),p=g;g={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:b,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},C.updateConfigurations({add:[g],remove:p?[p]:[]})}h(2)}),define(Z[221],ee([0,1,18,22]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(E){this.service=E}listen(E,l){throw new Error("Invalid listen")}call(E,l,m,P=t.CancellationToken.None){switch(l){case"request":return this.service.request(m[0],P).then(async({res:y,stream:S})=>{const g=await(0,w.streamToBuffer)(S);return[{statusCode:y.statusCode,headers:y.headers},g]});case"resolveProxy":return this.service.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(E){this.channel=E}async request(E,l){const[m,P]=await this.channel.call("request",[E],l);return{res:m,stream:(0,w.bufferToStream)(P)}}async resolveProxy(E){return this.channel.call("resolveProxy",[E])}}e.RequestChannelClient=R}),define(Z[222],ee([0,1,223,12]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(M,E){return M.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:M.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function R(M,E,l={}){const m=(0,w.parse)(M),P=l.proxyUrl||k(m,E);if(!P)return null;const y=(0,w.parse)(P);if(!/^https?:$/.test(y.protocol||""))return null;const S={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,t.isBoolean)(l.strictSSL)?l.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((g,h)=>{q(["http-proxy-agent"],g,h)}))(S):new(await new Promise((g,h)=>{q(["https-proxy-agent"],g,h)}))(S)}e.getProxyAgent=R}),define(Z[112],ee([0,1,45,9,167,22,44,17,4,29,143,59,8]),function(q,e,w,t,k,R,M,E,l,m,P,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const g=1e4;let h;async function b(p,v,d){return v["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(d)&&!v["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(d)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=S.Promises.withAsyncBody(async(f,a)=>{const i=new R.CancellationTokenSource,o=setTimeout(()=>{i.dispose(!0),a(new Error((0,k.localize)(0,null)))},g);try{f(await C(p,i.token))}catch(n){!(0,E.isCancellationError)(n)&&!i.token.isCancellationRequested?a(new Error((0,k.localize)(1,null,(0,M.toErrorMessage)(n)))):f({})}finally{clearTimeout(o),i.dispose()}})),h)}e.getResolvedShellEnv=b;async function C(p,v){const d=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",d);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",f);const a=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(a+"(.*)"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",o);const n=await(0,P.getSystemShell)(l.OS,o);return p.trace("getUnixShellEnvironment#shell",n),new Promise((r,s)=>{if(v.isCancellationRequested)return s((0,E.canceled)());const c=(0,t.basename)(n);let u,I;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(u=`& '${process.execPath}' ${D} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,I=["-Login","-Command"]):(u=`'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,c==="tcsh"?I=["-ic"]:I=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),u);const T=(0,w.spawn)(n,[...I,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});v.onCancellationRequested(()=>(T.kill(),s((0,E.canceled)()))),T.on("error",$=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)($)),s($)});const N=[];T.stdout.on("data",$=>N.push($));const U=[];T.stderr.on("data",$=>U.push($)),T.on("close",($,Y)=>{const oe=Buffer.concat(N).toString("utf8");p.trace("getUnixShellEnvironment#raw",oe);const ue=Buffer.concat(U).toString("utf8");if(ue.trim()&&p.trace("getUnixShellEnvironment#stderr",ue),$||Y)return s(new Error((0,k.localize)(2,null,$,Y)));const se=i.exec(oe),he=se?se[1]:"{}";try{const G=JSON.parse(he);d?G.ELECTRON_RUN_AS_NODE=d:delete G.ELECTRON_RUN_AS_NODE,f?G.ELECTRON_NO_ATTACH_CONSOLE=f:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",G),r(G)}catch(G){p.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(G)),s(G)}})})}}),define(Z[87],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,w.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[224],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>q(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),M=new R.validator;if(M){const E=String(w._nextId++);return this.validators.set(E,M),{id:E,data:M.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const M=this.validators.get(k.id);if(!M)return!1;this.validators.delete(k.id);try{return M.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),M=new R.signer;if(M)return M.sign(k)}catch{}return k}}e.SignService=w,w._nextId=1}),define(Z[38],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,w.createDecorator)("stateMainService")}),define(Z[21],ee([0,1,15,41,8,3,2,4,33,12,5,6,38,26]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,P.createDecorator)("lifecycleMainService");var h;(function(p){p[p.QUIT=1]="QUIT",p[p.KILL=2]="KILL"})(h=e.ShutdownReason||(e.ShutdownReason={}));var b;(function(p){p[p.Starting=1]="Starting",p[p.Ready=2]="Ready",p[p.AfterWindowOpen=3]="AfterWindowOpen",p[p.Eventually=4]="Eventually"})(b=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let C=class Et extends M.Disposable{constructor(v,d,f){super(),this.logService=v,this.stateMainService=d,this.environmentMainService=f,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(Et.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(Et.QUIT_AND_RESTART_KEY)}registerListeners(){const v=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),E.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};w.app.addListener("before-quit",v);const d=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!E.isMacintosh)&&w.app.quit()};w.app.addListener("window-all-closed",d),w.app.once("will-quit",f=>{this.trace("Lifecycle#app.on(will-quit)"),f.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),w.app.removeListener("before-quit",v),w.app.removeListener("window-all-closed",d),w.app.quit()})})}fireOnWillShutdown(v){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const d=[];return this._onWillShutdown.fire({reason:v,join(f){d.push(f)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(d)}catch(f){this.logService.error(f)}try{await this.stateMainService.close()}catch(f){this.logService.error(f)}})(),this.pendingWillShutdownPromise}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===v)return;this.trace(`lifecycle (main): phase changed (value: ${v})`),this._phase=v;const d=this.phaseWhen.get(this._phase);d&&(d.open(),this.phaseWhen.delete(this._phase))}async when(v){if(v<=this._phase)return;let d=this.phaseWhen.get(v);d||(d=new k.Barrier,this.phaseWhen.set(v,d)),await d.wait()}registerWindow(v){const d=new M.DisposableStore;this.windowCounter++,d.add(v.onWillLoad(a=>this._onWillLoadWindow.fire({window:v,workspace:a.workspace,reason:a.reason})));const f=(0,m.assertIsDefined)(v.win);f.on("close",a=>{const i=v.id;if(this.windowToCloseRequest.has(i)){this.windowToCloseRequest.delete(i);return}this.trace(`Lifecycle#window.on('close') - window ID ${v.id}`),a.preventDefault(),this.unload(v,1).then(o=>{if(o){this.windowToCloseRequest.delete(i);return}this.windowToCloseRequest.add(i),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${i}`),this._onBeforeCloseWindow.fire(v),v.close()})}),f.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.windowCounter--,d.dispose(),this.windowCounter===0&&(!E.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(v,d){await this.unload(v,3)||v.reload(d)}unload(v,d){const f=this.mapWindowIdToPendingUnload.get(v.id);if(f)return f;const a=this.doUnload(v,d).finally(()=>{this.mapWindowIdToPendingUnload.delete(v.id)});return this.mapWindowIdToPendingUnload.set(v.id,a),a}async doUnload(v,d){if(!v.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${v.id}`);const f=this._quitRequested?2:d,a=await this.onBeforeUnloadWindowInRenderer(v,f);return a?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.handleWindowUnloadVeto(a)):(await this.onWillUnloadWindowInRenderer(v,f),!1)}handleWindowUnloadVeto(v){return v?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(v){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(v),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(v,d){return new Promise(f=>{const a=this.oneTimeListenerTokenGenerator++,i=`vscode:ok${a}`,o=`vscode:cancel${a}`;t.validatedIpcMain.once(i,()=>{f(!1)}),t.validatedIpcMain.once(o,()=>{f(!0)}),v.send("vscode:onBeforeUnload",{okChannel:i,cancelChannel:o,reason:d})})}onWillUnloadWindowInRenderer(v,d){return new Promise(f=>{const i=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(i,()=>f()),v.send("vscode:onWillUnload",{replyChannel:i,reason:d})})}quit(v){return this.trace(`Lifecycle#quit() - begin (willRestart: ${v})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(v&&this.stateMainService.setItem(Et.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(d=>{this.pendingQuitPromiseResolve=d,this.trace("Lifecycle#quit() - calling app.quit()"),w.app.quit()}),this.pendingQuitPromise)}trace(v){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(v):this.logService.trace(v)}async relaunch(v){this.trace("Lifecycle#relaunch()");const d=process.argv.slice(1);if(v?.addArgs&&d.push(...v.addArgs),v?.removeArgs)for(const i of v.removeArgs){const o=d.indexOf(i);o>=0&&d.splice(o,1)}const f=()=>{try{if(E.isWindows){const i=(0,l.cwd)();i!==process.cwd()&&process.chdir(i)}}catch(i){this.logService.error(i)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),w.app.relaunch({args:d})};w.app.once("quit",f),await this.quit(!0)&&w.app.removeListener("quit",f)}async kill(v){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const d of w.BrowserWindow.getAllWindows())if(d&&!d.isDestroyed()){let f;d.webContents&&!d.webContents.isDestroyed()?f=new Promise(a=>d.once("closed",a)):f=Promise.resolve(),d.destroy(),await f}})()]),w.app.exit(v)}};C.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",C=ve([J(0,y.ILogService),J(1,S.IStateMainService),J(2,g.IEnvironmentMainService)],C),e.LifecycleMainService=C}),define(Z[225],ee([0,1,4,3,2,5,21]),function(q,e,w,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let E=class extends k.Disposable{constructor(P){super(),this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,P.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const P=await new Promise((y,S)=>{q(["native-keymap"],y,S)});this._keyboardLayoutData=l(P),w.isCI||P.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=l(P),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=ve([J(0,M.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function l(m){const P=m.getKeyMap(),y=m.getCurrentKeyboardLayout();return{keyboardMapping:P,keyboardLayoutInfo:y}}}),define(Z[226],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,w.createDecorator)("stateService")}),define(Z[227],ee([0,1,8,18,12,35,14,6]),function(q,e,w,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class l{constructor(y,S,g){this.storagePath=y,this.logService=S,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new w.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,S){const g=this.storage[y];return(0,k.isUndefinedOrNull)(g)?S:g}setItem(y,S){this.setItems([{key:y,data:S}])}setItems(y){let S=!1;for(const{key:g,data:h}of y)this.storage[g]!==h&&((0,k.isUndefinedOrNull)(h)?(0,k.isUndefined)(this.storage[g])||(this.storage[g]=void 0,S=!0):(this.storage[g]=h,S=!0));S&&this.save()}removeItem(y){(0,k.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(S){this.logService.error(S)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=l;let m=class{constructor(y,S,g){this.fileStorage=new l(y.stateResource,S,g)}async init(){await this.fileStorage.init()}getItem(y,S){return this.fileStorage.getItem(y,S)}};m=ve([J(0,R.IEnvironmentService),J(1,E.ILogService),J(2,M.IFileService)],m),e.StateService=m}),define(Z[228],ee([0,1,227]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends w.StateService{setItem(R,M){this.fileStorage.setItem(R,M)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(Z[113],ee([0,1,4,33,7,29]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(m){if(w.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function E(m,P,y,S,g,h,b,C,p,v){const d=Object.create(null);d["common.machineId"]=b,d.sessionID=(0,R.generateUuid)()+Date.now(),d.commitHash=g,d.version=h,d["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,w.PlatformToString)(w.platform),d["common.nodePlatform"]=t.platform,d["common.nodeArch"]=S,d["common.product"]=v||"desktop",C&&(d["common.msftInternal"]=C);let f=0;const a=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),w.isLinuxSnap&&(d["common.snap"]="true");const i=M(y);i&&(d["common.platformDetail"]=i);try{const o=await m.readFile(k.URI.file(p));d["common.source"]=o.value.toString().slice(0,30)}catch{}return d}e.resolveCommonProperties=E;function l(m){const P=t.env.USERDNSDOMAIN;if(!P)return!1;const y=P.toLowerCase();return m.some(S=>y===S)}e.verifyMicrosoftInternalDomain=l}),define(Z[36],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[229],ee([0,1,28,57,8,43,13,9,4,7,81,23,99,84,14,20,36]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function v(o,n){const r=`${o}::${n.join(":")}`,s=p.get(r);if(s)return s;const c=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,I=new Map,D=2e4;function T(U,$,Y,oe){const ue=$.substring(U.length+1);return k.Promises.withAsyncBody(async se=>{let he;try{he=await y.Promises.readdir($,{withFileTypes:!0})}catch{se();return}if(oe.count>=D){oe.count+=he.length,oe.maxReached=!0,se();return}let G=he.length;if(G===0){se();return}let K=he;oe.count+he.length>D&&(oe.maxReached=!0,G=D-oe.count,K=he.slice(0,G)),oe.count+=he.length;for(const F of K)if(F.isDirectory()){if(Y.includes(F.name)||await T(U,(0,E.join)($,F.name),Y,oe),--G===0){se();return}}else{const A=F.name.lastIndexOf(".");if(A>=0){const W=F.name.substring(A+1);W&&u.set(W,(u.get(W)??0)+1)}for(const W of c)W.relativePathPattern?.test(ue)!==!1&&W.filePattern.test(F.name)&&I.set(W.tag,(I.get(W.tag)??0)+1);if(--G===0){se();return}}})}const N=k.Promises.withAsyncBody(async U=>{const $={count:0,maxReached:!1};await T(o,o,n,$);const Y=await a(o);U({configFiles:d(I),fileTypes:d(u),fileCount:$.count,maxFilesReached:$.maxReached,launchConfigFiles:Y})});return p.set(r,N),N}e.collectWorkspaceStats=v;function d(o){return[...t.Iterable.map(o.entries(),([n,r])=>({name:n,count:r}))].sort((n,r)=>r.count-n.count)}function f(){const o={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},n=w.cpus();return n&&n.length>0&&(o.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),o}e.getMachineInfo=f;async function a(o){try{const n=new Map,r=(0,E.join)(o,".vscode","launch.json"),s=await y.Promises.readFile(r),c=[],u=(0,R.parse)(s.toString(),c);if(c.length)return console.log(`Unable to parse ${r}`),[];if((0,R.getNodeType)(u)==="object"&&u.configurations)for(const I of u.configurations){const D=I.type;D&&(n.has(D)?n.set(D,n.get(D)+1):n.set(D,1))}return d(n)}catch{return[]}}e.collectLaunchConfigs=a;let i=class{constructor(n,r){this.telemetryService=n,this.productService=r}formatMachineInfo(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}formatEnvironment(n){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const s=w.cpus();return s&&s.length>0&&r.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),r.push(`Memory (System):  ${(w.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),l.isWindows||r.push(`Load (avg):       ${w.loadavg().map(c=>Math.round(c)).join(", ")}`),r.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,S.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async s=>{let[c,u]=s,I=this.formatProcessList(n,c);return r.forEach(D=>{if((0,g.isRemoteDiagnosticError)(D))I+=`
${D.errorMessage}`,u+=`
${D.errorMessage}`;else if(I+=`

Remote: ${D.hostName}`,D.processes&&(I+=`
${this.formatProcessList(n,D.processes)}`),D.workspaceMetadata){u+=`
|  Remote: ${D.hostName}`;for(const T of Object.keys(D.workspaceMetadata)){const N=D.workspaceMetadata[T];let U=`${N.fileCount} files`;N.maxFilesReached&&(U=`more than ${U}`),u+=`|    Folder (${T}): ${U}`,u+=this.formatWorkspaceStats(N)}}}),{processInfo:I,workspaceInfo:u}})}async getSystemInfo(n,r){const{memory:s,vmHint:c,os:u,cpus:I}=f(),D={os:u,memory:s,cpus:I,vmHint:c,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return l.isWindows||(D.load=`${w.loadavg().map(T=>Math.round(T)).join(", ")}`),l.isLinux&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(n,r){const s=[];return(0,S.listProcesses)(n.mainPID).then(async c=>(s.push(""),s.push(this.formatEnvironment(n)),s.push(""),s.push(this.formatProcessList(n,c)),n.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(n))),r.forEach(u=>{if((0,g.isRemoteDiagnosticError)(u))s.push(`
${u.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${u.hostName}`),s.push(this.formatMachineInfo(u.machineInfo)),u.processes&&s.push(this.formatProcessList(n,u.processes)),u.workspaceMetadata)for(const I of Object.keys(u.workspaceMetadata)){const D=u.workspaceMetadata[I];let T=`${D.fileCount} files`;D.maxFilesReached&&(T=`more than ${T}`),s.push(`Folder (${I}): ${T}`),s.push(this.formatWorkspaceStats(D))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(n){const r=[];let c=0;const u=(N,U)=>{const $=` ${N}(${U})`;c+$.length>60?(r.push(I),I="|                 ",c=I.length):c+=$.length,I+=$};let I="|      File types:";const D=10,T=n.fileTypes.length>D?D:n.fileTypes.length;for(let N=0;N<T;N++){const U=n.fileTypes[N];u(U.name,U.count)}if(r.push(I),n.configFiles.length>=0&&(I="|      Conf files:",c=0,n.configFiles.forEach(N=>{u(N.name,N.count)}),r.push(I)),n.launchConfigFiles.length>0){let N="|      Launch Configs:";n.launchConfigFiles.forEach(U=>{N+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),r.push(N)}return r.join(`
`)}expandGPUFeatures(n){const r=Math.max(...Object.keys(n).map(s=>s.length));return Object.keys(n).map(s=>`${s}:  ${" ".repeat(r-s.length)}  ${n[s]}`).join(`
                  `)}formatWorkspaceMetadata(n){const r=[],s=[];return n.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(r.push(`|  Window (${c.title})`),c.folderURIs.forEach(u=>{const I=m.URI.revive(u);if(I.scheme===M.Schemas.file){const D=I.fsPath;s.push(v(D,["node_modules",".git"]).then(T=>{let N=`${T.fileCount} files`;T.maxFilesReached&&(N=`more than ${N}`),r.push(`|    Folder (${(0,E.basename)(D)}): ${N}`),r.push(this.formatWorkspaceStats(T))}).catch(T=>{r.push(`|      Error: Unable to collect workspace stats for folder ${D} (${T.toString()})`)}))}else r.push(`|    Folder (${I.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(c=>r.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(n,r){const s=new Map;n.windows.forEach(u=>s.set(u.pid,u.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(n.mainPID,s,c,r,0),c.join(`
`)}formatProcessItem(n,r,s,c,u){const I=u===0;let D;I?D=c.pid===n?`${this.productService.applicationName} main`:"remote agent":(D=`${"  ".repeat(u)} ${c.name}`,c.name==="window"&&(D=`${D} (${r.get(c.pid)})`));const T=process.platform==="win32"?c.mem:w.totalmem()*(c.mem/100);s.push(`${c.load.toFixed(0).padStart(5," ")}	${(T/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(c.children)&&c.children.forEach(N=>this.formatProcessItem(n,r,s,N,u+1))}async getWorkspaceFileExtensions(n){const r=new Set;for(const{uri:s}of n.folders){const c=m.URI.revive(s);if(c.scheme!==M.Schemas.file)continue;const u=c.fsPath;try{(await v(u,["node_modules",".git"])).fileTypes.forEach(D=>r.add(D.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const s=m.URI.revive(r);if(s.scheme!==M.Schemas.file)continue;const c=s.fsPath;try{const u=await v(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),u.fileTypes.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:I.name,count:I.count})}),u.launchConfigFiles.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:I.name,count:I.count})}),u.configFiles.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:I.name,count:I.count})})}catch{}}}};i=ve([J(0,C.ITelemetryService),J(1,b.IProductService)],i),e.DiagnosticsService=i}),define(Z[230],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(R){this.appenders=R}listen(R,M){throw new Error(`Event not found: ${M}`)}call(R,M,{eventName:E,data:l}){return this.appenders.forEach(m=>m.log(E,l)),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class t{constructor(R){this.channel=R}log(R,M){return this.channel.call("log",{eventName:R,data:M}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(Z[73],ee([0,1,50,95,12,19,113,36]),function(q,e,w,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class l{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(i,o){return Promise.resolve(void 0)}publicLog2(i,o){return this.publicLog(i,o)}publicLogError(i,o){return Promise.resolve(void 0)}publicLogError2(i,o){return this.publicLogError(i,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=l,e.NullTelemetryService=new l;class m{async publicLog(i,o,n){}async publicLogError(i,o,n){}}e.NullEndpointTelemetryService=m,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(a,i){return i.onDidChangeConfiguration(o=>{o.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(o.source),configurationKeys:p(o.sourceConfig)})})}e.configurationTelemetry=P;function y(a,i){return!(i.disableTelemetry||!a.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=y;function S(a){const i=a.getValue(E.TELEMETRY_SETTING_ID),o=a.getValue("telemetry.enableCrashReporter");if(a.getValue(E.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function g(a){const i={},o={},n={};C(a,n);for(let r in n){r=r.length>150?r.substr(r.length-149):r;const s=n[r];typeof s=="number"?o[r]=s:typeof s=="boolean"?o[r]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${s.length}`),i[r]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(i[r]=s)}return{properties:i,measurements:o}}e.validateTelemetryData=g;const h=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function b(a){if(!a)return"none";for(const i of h)if(a.startsWith(`${i}+`))return i;return"other"}e.cleanRemoteAuthority=b;function C(a,i,o=0,n){if(!!a)for(const r of Object.getOwnPropertyNames(a)){const s=a[r],c=n?n+r:r;Array.isArray(s)?i[c]=(0,w.safeStringify)(s):s instanceof Date?i[c]=s.toISOString():(0,k.isObject)(s)?o<2?C(s,i,o+1,c+"."):i[c]=(0,w.safeStringify)(s):i[c]=s}}function p(a){if(!a)return[];const i=[];return v(i,"",a),i}function v(a,i,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(n=>v(a,i?`${i}.${n}`:n,o[n])):a.push(i)}function d(a,i){const o=a.msftInternalDomains||[],n=i.getValue("telemetry.internalTesting");return(0,M.verifyMicrosoftInternalDomain)(o)||n}e.isInternalTelemetry=d;function f(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=f}),define(Z[231],ee([0,1,189,73]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,M,E,l,m,P,y){const S={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${M.nameShort})`};if((0,t.supportsTelemetry)(M,E)&&(0,t.getTelemetryLevel)(l)===3){const g=await(0,w.getServiceMachineId)(E,m,P),{sessionId:h}=await y.getTelemetryInfo();S["X-Market-User-Id"]=g,S["VSCode-SessionId"]=h}return S}e.resolveMarketplaceHeaders=k}),define(Z[232],ee([0,1,2,50,95,4,25,168,19,62,54,20,47,36,73]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(v,d,f){this._configurationService=d,this._productService=f,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const a of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(a),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(v,d){this._experimentProperties[v]=d}_updateTelemetryLevel(){let v=(0,h.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const f=d.usage?3:d.error?2:0;v=Math.min(v,f)}this.telemetryLevel.value=v}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const v=await this._commonProperties,d=v.sessionID,f=v["common.machineId"],a=v["common.firstSessionDate"],i=v["common.msftInternal"];return{sessionId:d,machineId:f,firstSessionDate:a,msftInternal:i}}dispose(){this._disposables.dispose()}_log(v,d,f,a){return this.telemetryLevel.value<d?Promise.resolve(void 0):this._commonProperties.then(i=>{f=(0,t.mixin)(f,i),f=(0,t.mixin)(f,this._experimentProperties),f=(0,t.cloneAndChange)(f,o=>{if(typeof o=="string")return this._cleanupInfo(o,a)}),this._appenders.forEach(o=>o.log(v,f))},i=>{console.error(i)})}publicLog(v,d,f){return this._log(v,3,d,f)}publicLog2(v,d,f){return this.publicLog(v,d,f)}publicLogError(v,d){return this._sendErrorTelemetry?this._log(v,2,d,!0):Promise.resolve(void 0)}publicLogError2(v,d){return this.publicLogError(v,d)}_anonymizeFilePaths(v){let d=v;const f=[];for(const n of this._cleanupPatterns)for(;;){const r=n.exec(v);if(!r)break;f.push([r.index,n.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(d="";;){const n=i.exec(v);if(!n)break;!a.test(n[0])&&f.every(([r,s])=>n.index<r||n.index>=s)&&(d+=v.substring(o,n.index)+"<REDACTED: user-file-path>",o=i.lastIndex)}return o<v.length&&(d+=v.substr(o)),d}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const d=v.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const a of f)if(a.regex.test(d))return`<REDACTED: ${a.label}>`;return v}_cleanupInfo(v,d){let f=v;d&&(f=this._anonymizeFilePaths(f));for(const a of this._cleanupPatterns)f=f.replace(a,"");return f=this._removePropertiesWithPossibleUserInfo(f),f}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=ve([J(1,l.IConfigurationService),J(2,y.IProductService)],b),e.TelemetryService=b;function C(){const p=(0,E.localize)(0,null,P.default.nameLong),v=P.default.privacyStatementUrl?(0,E.localize)(2,null,"https://aka.ms/vscode-telemetry",P.default.privacyStatementUrl):(0,E.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=R.isWeb?"":(0,E.localize)(3,null),f=(0,E.localize)(4,null),a=(0,E.localize)(5,null),i=(0,E.localize)(6,null),o=(0,E.localize)(7,null),n=`
|       | ${f} | ${a} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,E.localize)(8,null);return`
${p} ${v} ${d}

&nbsp;

${o}
${n}

&nbsp;

${r}
`}S.Registry.as(m.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,E.localize)(10,null),(0,E.localize)(11,null),(0,E.localize)(12,null),(0,E.localize)(13,null)],markdownDescription:C(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(m.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:P.default.privacyStatementUrl?(0,E.localize)(16,null,P.default.nameLong,P.default.privacyStatementUrl):(0,E.localize)(15,null,P.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,E.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[233],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var w;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(w=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===w.HIGH_CONTRAST_DARK||R===w.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===w.DARK||R===w.HIGH_CONTRAST_DARK}e.isDark=k}),define(Z[234],ee([0,1,119,3,2,5,47,233]),function(q,e,w,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var l;(function(C){function p(v){return v&&typeof v=="object"&&typeof v.id=="string"}C.isThemeColor=p})(l=e.ThemeColor||(e.ThemeColor={}));function m(C){return{id:C}}e.themeColorFromId=m;var P;(function(C){function p(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||l.isThemeColor(r.color))}C.isThemeIcon=p;const v=new RegExp(`^\\$\\((${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?)\\)$`);function d(r){const s=v.exec(r);if(!s)return;const[,c]=s;return{id:c}}C.fromString=d;function f(r){return{id:r}}C.fromId=f;function a(r,s){let c=r.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),s&&(c=`${c}~${s}`),{id:c}}C.modify=a;function i(r){const s=r.id.lastIndexOf("~");if(s!==-1)return r.id.substring(s+1)}C.getModifier=i;function o(r,s){return r.id===s.id&&r.color?.id===s.color?.id}C.isEqual=o;function n(r,s){return{id:r.id,color:s?m(s):void 0}}C.asThemeIcon=n,C.asClassNameArray=w.CSSIcon.asClassNameArray,C.asClassName=w.CSSIcon.asClassName,C.asCSSSelector=w.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=w.Codicon.file,e.FolderThemeIcon=w.Codicon.folder;function y(C){switch(C){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case E.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,k.toDisposable)(()=>{const v=this.themingParticipants.indexOf(p);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const g=new S;M.Registry.add(e.Extensions.ThemingContribution,g);function h(C){return g.onColorThemeChange(C)}e.registerThemingParticipant=h;class b extends k.Disposable{constructor(p){super(),this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,v){let d=this.theme.getColor(p);return d&&v&&(d=v(d,this.theme)),d?d.toString():null}}e.Themable=b}),define(Z[64],ee([0,1,15,3,2,4,19,5,38]),function(q,e,w,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const m="#FFFFFF",P="#1E1E1E",y="#000000",S="#FFFFFF",g="theme",h="themeBackground",b="windowSplash";e.IThemeMainService=(0,E.createDecorator)("themeMainService");let C=class extends k.Disposable{constructor(v,d){super(),this.stateMainService=v,this.configurationService=d,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,w.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(w.nativeTheme.shouldUseHighContrastColors)return{dark:w.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors)return{dark:w.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&w.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:w.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return v.dark?y:S;let d=this.stateMainService.getItem(h,null);if(!d)switch(this.stateMainService.getItem(g,"vs-dark").split(" ")[0]){case"vs":d=m;break;case"hc-black":d=y;break;case"hc-light":d=S;break;default:d=P}return R.isMacintosh&&d.toUpperCase()===P&&(d="#171717"),d}saveWindowSplash(v,d){this.stateMainService.setItems([{key:g,data:d.baseTheme},{key:h,data:d.colorInfo.background},{key:b,data:d}]),typeof v=="number"&&this.updateBackgroundColor(v,d)}updateBackgroundColor(v,d){for(const f of w.BrowserWindow.getAllWindows())if(f.id===v){f.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(b)}};C=ve([J(0,l.IStateMainService),J(1,M.IConfigurationService)],C),e.ThemeMainService=C}),define(Z[114],ee([0,1,3,4,5,6]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var M;(function(b){b.Http="http",b.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var E;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(E=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var l;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(l=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const C=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(!!C)return{address:C[1],port:+C[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=y;function S(b,C){return C?C!==1&&b<1024:!t.isWindows&&b<1024}e.isPortPrivileged=S;class g{constructor(C,p,v){this.remoteAddress=C,this.localAddress=p,this._dispose=v,this._onDispose=new w.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=g;let h=class{constructor(C){this.logService=C,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(C){return this._tunnelProvider=C,C?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(C){this._canElevate=C.elevation,this._privacyOptions=C.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const C=[],p=Array.from(this._tunnels.values());for(const v of p){const d=Array.from(v.values());for(const f of d){const a=await f.value;a&&C.push(a)}}return C}async dispose(){for(const C of this._tunnels.values()){for(const{value:p}of C.values())await p.then(v=>v?.dispose());C.clear()}this._tunnels.clear()}openTunnel(C,p,v,d,f=!1,a,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${v} on local port ${d}.`),!C)return;if(p||(p="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(C,p,v,d,f,a,i);return o?o.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(n);return(n.tunnelRemoteHost!==p||n.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(C){return{tunnelRemotePort:C.tunnelRemotePort,tunnelRemoteHost:C.tunnelRemoteHost,tunnelLocalPort:C.tunnelLocalPort,localAddress:C.localAddress,privacy:C.privacy,protocol:C.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${C.tunnelRemoteHost}:${C.tunnelRemotePort} `);const p=this._tunnels.get(C.tunnelRemoteHost);if(p){const v=p.get(C.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(C.tunnelRemoteHost,C.tunnelRemotePort,v))}}}}async tryDisposeTunnel(C,p,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${C}:${p}.`);const d=v.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(C)&&this._tunnels.get(C).delete(p),d}}async closeTunnel(C,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${C}:${p} `);const v=this._tunnels.get(C);if(v&&v.has(p)){const d=v.get(p);d.refcount=0,await this.tryDisposeTunnel(C,p,d)}}addTunnelToMap(C,p,v){this._tunnels.has(C)||this._tunnels.set(C,new Map),this._tunnels.get(C).set(p,{refcount:1,value:v})}async removeEmptyTunnelFromMap(C,p){const v=this._tunnels.get(C);v&&(await v.get(p)||v.delete(p),v.size===0&&this._tunnels.delete(C))}getTunnelFromMap(C,p){const v=[C];P(C)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):y(C)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const d=v.map(f=>this._tunnels.get(f));for(const f of d){const a=f?.get(p);if(a)return a}}canTunnel(C){return!!m(C)}createWithProvider(C,p,v,d,f,a,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${v} on local port ${d}.`);const o=v;this._factoryInProgress.add(o);const r={elevationRequired:f?S(d===void 0?v:d):!1},s={remoteAddress:{host:p,port:v},localAddressPort:d,privacy:a,public:a?a!==E.Private:void 0,protocol:i},c=C.forwardPort(s,r);return c?(this.addTunnelToMap(p,v,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),c}};h=ve([J(0,R.ILogService)],h),e.AbstractTunnelService=h}),define(Z[235],ee([0,1,77,94,219,8,2,19,6,20,218,114,87]),function(q,e,w,t,k,R,M,E,l,m,P,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function g(v,d,f,a,i){let o;for(let n=3;n&&(o?.dispose(),o=await new h(v,d,f,a,i).waitForReady(),!(i&&t.BROWSER_RESTRICTED_PORTS[i]||!t.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));n--);return o}class h extends M.Disposable{constructor(d,f,a,i,o){super(),this.defaultTunnelHost=f,this.suggestedLocalPort=o,this.privacy=y.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=d,this._server=w.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(f=>{f()})}async waitForReady(){let d=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),f=null;return this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address(),f||(d=0,this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async _onConnection(d){d.pause();const f=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,P.connectRemoteAgentTunnel)(this._options,f,this.tunnelRemotePort),i=a.getSocket().socket,o=a.readEntireBuffer();a.dispose(),o.byteLength>0&&d.write(o.buffer),d.on("end",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),i.end()}),d.on("close",()=>i.end()),d.on("error",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),i.destroy()}),i.on("end",()=>d.end()),i.on("close",()=>d.end()),i.on("error",()=>{d.destroy()}),d.pipe(i),i.pipe(d),d.localAddress&&this._socketsDispose.set(d.localAddress,()=>{d.end(),i.end()})}}let b=class extends y.AbstractTunnelService{constructor(d,f,a,i,o){super(f),this.socketFactory=d,this.signService=a,this.productService=i,this.configurationService=o}get defaultTunnelHost(){const d=this.configurationService.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(d,f,a,i,o,n,r){const s=this.getTunnelFromMap(f,a);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,f,a,i,o,n,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${a} on local port ${i}.`);const c={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:d,signService:this.signService,logService:this.logService,ipcLogger:null},u=g(c,this.defaultTunnelHost,f,a,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(f,a,u),u}}};b=ve([J(1,l.ILogService),J(2,S.ISignService),J(3,m.IProductService),J(4,E.IConfigurationService)],b),e.BaseTunnelService=b;let C=class extends b{constructor(d,f,a,i){super(k.nodeSocketFactory,d,f,a,i)}};C=ve([J(0,l.ILogService),J(1,S.ISignService),J(2,m.IProductService),J(3,E.IConfigurationService)],C),e.TunnelService=C;let p=class extends M.Disposable{constructor(d,f,a,i){super(),this.logService=d,this.productService=f,this.signService=a,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(d,f,a,i,o,n,r,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${i} on local port ${o}.`),!this._tunnelServices.has(d)){const c=new C(this.logService,this.signService,this.productService,this.configurationService);this._register(c),this._tunnelServices.set(d,c),c.onTunnelClosed(async()=>{(await c.tunnels).length===0&&(c.dispose(),this._tunnelServices.delete(d))})}return this._tunnelServices.get(d).openTunnel(f,a,i,o,n,r,s)}};p=ve([J(0,l.ILogService),J(1,m.IProductService),J(2,S.ISignService),J(3,E.IConfigurationService)],p),e.SharedTunnelsService=p}),define(Z[48],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,M)=>({type:"idle",updateType:R,error:M}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,w.createDecorator)("updateService")}),define(Z[236],ee([0,1,4,169,62,47]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:w.isWindows&&!w.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[237],ee([0,1,3,48]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(E){this.service=E}listen(E,l){switch(l){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${l}`)}call(E,l,m){switch(l){case"checkForUpdates":return this.service.checkForUpdates(m);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(m)}throw new Error(`Call not found: ${l}`)}}e.UpdateChannel=k;class R{constructor(E){this.channel=E,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(l=>this.state=l),this.channel.call("_getInitialState").then(l=>this.state=l)}get state(){return this._state}set state(E){this._state=E,this._onStateChange.fire(E)}checkForUpdates(E){return this.channel.call("checkForUpdates",E)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(E){return this.channel.call("_applySpecificUpdate",E)}}e.UpdateChannelClient=R}),define(Z[88],ee([0,1,8,22,3,19,26,21,6,20,55,48]),function(q,e,w,t,k,R,M,E,l,m,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(h,b,C){return`${C.updateUrl}/api/update/${h}/${b}/${C.commit}`}e.createUpdateURL=S;let g=class{constructor(b,C,p,v,d,f){this.lifecycleMainService=b,this.configurationService=C,this.environmentMainService=p,this.requestService=v,this.logService=d,this.productService=f,this._state=y.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(b){this.logService.info("update#setState",b.type),this._state=b,this._onStateChange.fire(b)}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.getUpdateMode(),C=this.getProductQuality(b);if(!C){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(C),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(y.State.Idle(this.getUpdateType())),b==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(b){return b==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(b=60*60*1e3){return(0,w.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(b){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(b)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(b){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(b=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(b){}getUpdateType(){return 1}doQuitAndInstall(){}};g=ve([J(0,E.ILifecycleMainService),J(1,R.IConfigurationService),J(2,M.IEnvironmentMainService),J(3,P.IRequestService),J(4,l.ILogService),J(5,m.IProductService)],g),e.AbstractUpdateService=g}),define(Z[238],ee([0,1,15,53,3,2,19,26,21,6,20,55,36,48,88]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let b=class extends h.AbstractUpdateService{constructor(p,v,d,f,a,i,o){super(p,v,f,a,i,o),this.telemetryService=d,this.disposables=new R.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"error",(p,v)=>v)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-available",(p,v,d)=>({url:v,version:d,productVersion:d}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-downloaded",(p,v,d,f)=>({releaseNotes:v,version:d,productVersion:d,date:f}))}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.logService.error("UpdateService error:",p);const d=(this.state.type==="checking for updates"?this.state.explicit:!0)?p:void 0;this.setState(g.State.Idle(1,d))}buildUpdateFeedUrl(p){let v;this.productService.darwinUniversalAssetId?v=this.productService.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,h.createUpdateURL)(v,p,this.productService);try{w.autoUpdater.setFeedURL({url:d})}catch(f){this.logService.error("Failed to set update feed URL",f);return}return d}doCheckForUpdates(p){this.setState(g.State.CheckingForUpdates(p)),w.autoUpdater.checkForUpdates()}onUpdateAvailable(p){this.state.type==="checking for updates"&&this.setState(g.State.Downloading(p))}onUpdateDownloaded(p){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(g.State.Ready(p)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(g.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),w.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ve([t.memoize],b.prototype,"onRawError",null),ve([t.memoize],b.prototype,"onRawUpdateNotAvailable",null),ve([t.memoize],b.prototype,"onRawUpdateAvailable",null),ve([t.memoize],b.prototype,"onRawUpdateDownloaded",null),b=ve([J(0,l.ILifecycleMainService),J(1,M.IConfigurationService),J(2,S.ITelemetryService),J(3,E.IEnvironmentMainService),J(4,y.IRequestService),J(5,m.ILogService),J(6,P.IProductService)],b),e.DarwinUpdateService=b}),define(Z[239],ee([0,1,45,40,8,3,9,26,21,6,36,48]),function(q,e,w,t,k,R,M,E,l,m,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{constructor(b,C,p){if(this.lifecycleMainService=b,this.logService=p,this._state=y.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,C.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(y.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}get state(){return this._state}setState(b){this.logService.info("update#setState",b.type),this._state=b,this._onStateChange.fire(b)}scheduleCheckForUpdates(b=60*60*1e3){return(0,k.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(b){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(b)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(b){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(b=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(b){}};S=ve([J(0,l.ILifecycleMainService),J(1,E.IEnvironmentMainService),J(2,m.ILogService)],S);let g=class extends S{constructor(b,C,p,v,d,f){super(p,v,d),this.snap=b,this.snapRevision=C,this.telemetryService=f;const a=(0,t.watch)(M.dirname(this.snap)),i=R.Event.fromNodeEventEmitter(a,"change",(s,c)=>c),o=R.Event.filter(i,s=>s==="current"),r=R.Event.debounce(o,(s,c)=>c,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{r.dispose(),a.close()})}doCheckForUpdates(){this.setState(y.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(b=>{b?this.setState(y.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(y.State.Idle(2)))},b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(y.State.Idle(2,b.message||b))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,w.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const b=await new Promise((p,v)=>(0,t.realpath)(`${M.dirname(this.snap)}/current`,(d,f)=>d?v(d):p(f))),C=M.basename(b);return this.snapRevision!==C}isLatestVersion(){return this.isUpdateAvailable().then(void 0,b=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};g=ve([J(2,l.ILifecycleMainService),J(3,E.IEnvironmentMainService),J(4,m.ILogService),J(5,P.ITelemetryService)],g),e.SnapUpdateService=g}),define(Z[51],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,w.createDecorator)("IUriIdentityService")}),define(Z[240],ee([0,1,51,190,14,16,126,3,2]),function(q,e,w,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(S){this.uri=S,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let P=class{constructor(S){this._fileService=S,this._dispooables=new l.DisposableStore,this._limit=2**16;const g=new Map,h=b=>{let C=g.get(b.scheme);return C===void 0&&(C=S.hasProvider(b)&&!this._fileService.hasCapability(b,1024),g.set(b.scheme,C)),C};this._dispooables.add(E.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(b=>{g.delete(b.scheme)})),this.extUri=new R.ExtUri(h),this._canonicalUris=new M.SkipList((b,C)=>this.extUri.compare(b,C,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,R.normalizePath)(S));const g=this._canonicalUris.get(S);return g?g.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new m(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((h,b)=>h[1].touch<b[1].touch?1:h[1].touch>b[1].touch?-1:0);m._clock=0,this._canonicalUris.clear();const g=this._limit*.5;for(let h=0;h<g;h++)this._canonicalUris.set(S[h][0],S[h][1].touch())}};P=ve([J(0,k.IFileService)],P),e.UriIdentityService=P,(0,t.registerSingleton)(w.IUriIdentityService,P,!0)}),define(Z[115],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,w.createDecorator)("urlService")}),define(Z[241],ee([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(E){this.handler=E}listen(E,l){throw new Error(`Event not found: ${l}`)}call(E,l,m){switch(l){case"handleURL":return this.handler.handleURL(w.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${l}`)}}e.URLHandlerChannel=t;class k{constructor(E){this.channel=E}handleURL(E,l){return this.channel.call("handleURL",[E.toJSON(),l])}}e.URLHandlerChannelClient=k;class R{constructor(E){this.next=E}async routeCall(E,l,m,P){if(l!=="handleURL")throw new Error(`Call not found: ${l}`);if(m){const y=w.URI.revive(m);if(y&&y.query){const S=/\bwindowId=(\d+)/.exec(y.query);if(S){const g=S[1],h=new RegExp(`window:${g}`),b=E.connections.find(C=>h.test(C.ctx));if(b)return b}}}return this.next.routeCall(E,l,m,P)}routeEvent(E,l){throw new Error(`Event not found: ${l}`)}}e.URLHandlerRouter=R}),define(Z[242],ee([0,1,8,2,7,20]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends t.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(m,P){const y=[...this.handlers.values()];return(0,w.first)(y.map(S=>()=>S.handleURL(m,P)),void 0,!1).then(S=>S||!1)}registerHandler(m){return this.handlers.add(m),(0,t.toDisposable)(()=>this.handlers.delete(m))}}e.AbstractURLService=M;let E=class extends M{constructor(m){super(),this.productService=m}create(m){let{authority:P,path:y,query:S,fragment:g}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return P&&y&&y.indexOf("/")!==0&&(y=`/${y}`),k.URI.from({scheme:this.productService.urlProtocol,authority:P,path:y,query:S,fragment:g})}};E=ve([J(0,R.IProductService)],E),e.NativeURLService=E}),define(Z[243],ee([0,1,15,8,3,2,4,7]),function(q,e,w,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function l(P){try{return E.URI.parse(P)}catch{return null}}class m{constructor(y,S,g,h,b){if(this.urlService=S,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=y,M.isWindows){const v=h.isBuilt?[]:[`"${h.appRoot}"`];v.push("--open-url","--"),w.app.setAsDefaultProtocolClient(b.urlProtocol,process.execPath,v)}const C=k.Event.map(k.Event.fromNodeEventEmitter(w.app,"open-url",(v,d)=>({event:v,url:d})),({event:v,url:d})=>(v.preventDefault(),d));this.disposables.add(C(v=>{const d=l(v);!d||this.urlService.open(d,{originalUrl:v})})),g.getWindows().filter(v=>v.isReady).length>0?this.flush():k.Event.once(g.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const y=[];for(const S of this.uris)await this.urlService.open(S.uri,{originalUrl:S.url})||y.push(S);y.length!==0&&(this.uris=y,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=m}),define(Z[244],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,w.createDecorator)("webviewManagerService")}),define(Z[245],ee([0,1,15,2,13,7]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends t.Disposable{constructor(){super();const l=this.handleWebviewRequest.bind(this);w.protocol.registerFileProtocol(k.Schemas.vscodeWebview,l)}handleWebviewRequest(l,m){try{const P=R.URI.parse(l.url),y=M.validWebviewFilePaths.get(P.path);if(typeof y=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${y}`,g=k.FileAccess.asFileUri(S,q);return m({path:decodeURIComponent(g.fsPath),headers:{...k.COI.getHeadersFromQuery(l.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=M,M.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(Z[74],ee([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(P){return!!P.workspaceUri}e.isWorkspaceToOpen=t;function k(P){return!!P.folderUri}e.isFolderToOpen=k;function R(P){return!!P.fileUri}e.isFileToOpen=R;function M(P){const y=E(P),S=P.getValue("window.menuBarVisibility");return S==="default"||y==="native"&&S==="compact"||w.isMacintosh&&w.isNative?"classic":S}e.getMenuBarVisibility=M;function E(P){if(w.isWeb)return"custom";const y=P.getValue("window");if(y){if(w.isMacintosh&&y.nativeTabs===!0||w.isMacintosh&&y.nativeFullScreen===!1)return"native";const h=y.titleBarStyle;if(h==="native"||h==="custom")return h}return w.isLinux?"native":"custom"}e.getTitleBarStyle=E;function l(P,y){if(!w.isWindows||w.isWeb||!y.isBuilt||E(P)==="native")return!1;const S=P.getValue("window.experimental.windowControlsOverlay.enabled");return typeof S=="boolean"?S:!1}e.useWindowControlsOverlay=l;function m(P=0){return Math.pow(1.2,P)}e.zoomLevelToZoomFactor=m}),define(Z[116],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var w;(function(E){E[E.INITIAL=1]="INITIAL",E[E.LOAD=2]="LOAD",E[E.RELOAD=3]="RELOAD"})(w=e.LoadReason||(e.LoadReason={}));var t;(function(E){E[E.CLOSE=1]="CLOSE",E[E.QUIT=2]="QUIT",E[E.RELOAD=3]="RELOAD",E[E.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(E=1){return{width:1024,height:768,mode:E}};e.defaultWindowState=k;var R;(function(E){E[E.Maximized=0]="Maximized",E[E.Normal=1]="Normal",E[E.Minimized=2]="Minimized",E[E.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var M;(function(E){E[E.UNRESPONSIVE=1]="UNRESPONSIVE",E[E.PROCESS_GONE=2]="PROCESS_GONE",E[E.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(Z[32],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,w.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(Z[246],ee([0,1,15,22,3,66,2,29,69,104,6,20,32]),function(q,e,w,t,k,R,M,E,l,m,P,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var g;(function(b){b[b.Initial=1]="Initial",b[b.StoredCredentialsUsed=2]="StoredCredentialsUsed",b[b.LoginDialogShown=3]="LoginDialogShown"})(g||(g={}));let h=class extends M.Disposable{constructor(C,p,v,d,f){super(),this.logService=C,this.windowsMainService=p,this.credentialsService=v,this.encryptionMainService=d,this.productService=f,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=g.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const C=k.Event.fromNodeEventEmitter(w.app,"login",(p,v,d,f,a)=>({event:p,webContents:v,req:d,authInfo:f,callback:a}));this._register(C(this.onLogin,this))}async onLogin({event:C,authInfo:p,req:v,callback:d}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===g.LoginDialogShown&&v.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}C.preventDefault();let f;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),f=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{f=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}d(f?.username,f?.password)}async resolveProxyCredentials(C){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(C);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(C){this.logService.trace("auth#doResolveProxyCredentials - enter",C);const p=String((0,R.hash)({scheme:C.scheme,host:C.host,port:C.port}));let v,d;try{const o=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p);if(o){const n=JSON.parse(await this.encryptionMainService.decrypt(o));v=n.username,d=n.password}}catch(o){this.logService.error(o)}if(this.state!==g.StoredCredentialsUsed&&typeof v=="string"&&typeof d=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=g.StoredCredentialsUsed,{username:v,password:d};const f=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!f){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${f.id} to handle proxy login`);const a={authInfo:C,username:this.sessionCredentials?.username??v,password:this.sessionCredentials?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,E.generateUuid)()}`};f.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,a),this.state=g.LoginDialogShown;const i=await new Promise(o=>{const n=async(r,s,c)=>{if(s===a.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${f.id}`),f.win?.webContents.off("ipc-message",n),c){const u={username:c.username,password:c.password};try{if(c.remember){const I=await this.encryptionMainService.encrypt(JSON.stringify(u));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p,I)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p)}catch(I){this.logService.error(I)}o({username:u.username,password:u.password})}else o(void 0)};f.win?.webContents.on("ipc-message",n)});return this.sessionCredentials=i,i}};h=ve([J(0,P.ILogService),J(1,S.IWindowsMainService),J(2,l.ICredentialsMainService),J(3,m.IEncryptionMainService),J(4,y.IProductService)],h),e.ProxyAuthHandler=h}),define(Z[247],ee([0,1,69,6,35,20,32,202]),function(q,e,w,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let l=class extends E.BaseCredentialsMainService{constructor(P,y,S,g){super(P),this.environmentMainService=y,this.productService=S,this.windowsMainService=g,this.surfaceKeytarLoadError=h=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",h.message??h)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new w.InMemoryCredentialsProvider,this._keytarCache;const P=await new Promise((y,S)=>{q(["keytar"],y,S)});return await P.findCredentials("test-keytar-loads"),this._keytarCache=P,this._keytarCache}};l=ve([J(0,t.ILogService),J(1,k.INativeEnvironmentService),J(2,R.IProductService),J(3,M.IWindowsMainService)],l),e.CredentialsNativeMainService=l}),define(Z[248],ee([0,1,17,2,3,6,21,79,45,278,8,13,50,4,33,15,32]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const p=b.UtilityProcess,v=typeof p<"u";let d=class Ft{constructor(o,n,r){this._logService=o,this._windowsMainService=r,this._shutdown=!1,this._extHosts=new Map,n.onWillShutdown(s=>{this._shutdown=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(o){const n=this._extHosts.get(o);if(!n)throw new Error("Unknown extension host!");return n}onDynamicStdout(o){return this._getExtHost(o).onStdout}onDynamicStderr(o){return this._getExtHost(o).onStderr}onDynamicMessage(o){return this._getExtHost(o).onMessage}onDynamicError(o){return this._getExtHost(o).onError}onDynamicExit(o){return this._getExtHost(o).onExit}async canUseUtilityProcess(){return v}async createExtensionHost(o){if(this._shutdown)throw(0,w.canceled)();const n=String(++Ft._lastId);let r;if(o){if(!v)throw new Error("Cannot use UtilityProcess!");r=new a(n,this._logService,this._windowsMainService)}else r=new f(n,this._logService);return this._extHosts.set(n,r),r.onExit(({pid:s,code:c,signal:u})=>{this._logService.info(`Extension host with pid ${s} exited with code: ${c}, signal: ${u}.`),setTimeout(()=>{r.dispose(),this._extHosts.delete(n)})}),{id:n}}async start(o,n){if(this._shutdown)throw(0,w.canceled)();return this._getExtHost(o).start(n)}async enableInspectPort(o){if(this._shutdown)throw(0,w.canceled)();const n=this._extHosts.get(o);return n?n.enableInspectPort():!1}async kill(o){if(this._shutdown)throw(0,w.canceled)();const n=this._extHosts.get(o);!n||n.kill()}async _killAllNow(){for(const[,o]of this._extHosts)o.kill()}async _waitForAllExit(o){const n=[];for(const[,r]of this._extHosts)n.push(r.waitForExit(o));return P.Promises.settled(n).then(()=>{})}};d._lastId=0,d=ve([J(0,R.ILogService),J(1,M.ILifecycleMainService),J(2,C.IWindowsMainService)],d),e.ExtensionHostStarter=d;let f=class extends t.Disposable{constructor(o,n){super(),this.id=o,this._logService=n,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){g.isCI&&this._logService.info("Calling fork to start extension host...");const n=E.StopWatch.create(!1);this._process=(0,l.fork)(y.FileAccess.asFileUri("bootstrap-fork",q).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,S.mixin)({cwd:(0,h.cwd)()},o));const r=n.elapsed(),s=this._process.pid;this._logService.info(`Starting extension host with pid ${s} (fork() took ${r} ms).`);const c=new m.StringDecoder("utf-8");this._process.stdout?.on("data",I=>{const D=typeof I=="string"?I:c.write(I);this._onStdout.fire(D)});const u=new m.StringDecoder("utf-8");this._process.stderr?.on("data",I=>{const D=typeof I=="string"?I:u.write(I);this._onStderr.fire(D)}),this._process.on("message",I=>{this._onMessage.fire(I)}),this._process.on("error",I=>{this._onError.fire({error:(0,w.transformErrorForSerialization)(I)})}),this._process.on("exit",(I,D)=>{this._hasExited=!0,this._onExit.fire({pid:s,code:I,signal:D})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const n=this._process.pid;this._logService.info(`Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,P.timeout)(o)]),this._hasExited||(this._logService.info(`Extension host with pid ${n} did not exit within ${o}ms.`),this._process.kill())}};f=ve([J(1,R.ILogService)],f);let a=class extends t.Disposable{constructor(o,n,r){super(),this.id=o,this._logService=n,this._windowsMainService=r,this.onStdout=k.Event.None,this.onStderr=k.Event.None,this.onError=k.Event.None,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){const n=this._windowsMainService.getWindowById(o.responseWindowId);if(!n){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const r=n.win;if(!r||r.isDestroyed()||r.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,c=y.FileAccess.asFileUri("bootstrap-fork.js",q).fsPath,u=["--type=extensionHost","--skipWorkspaceStorageLock"],I=o.execArgv||[],D={...o.env};for(const Y of Object.keys(D))D[Y]=String(D[Y]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new p(c,u,{serviceName:s,env:D,execArgv:I}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const T=k.Event.fromNodeEventEmitter(this._process,"exit",(Y,oe)=>oe);this._register(T(Y=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${Y}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:Y,signal:""})}));const N=(Y,oe)=>{oe.type==="Utility"&&oe.name===s&&(this._logService.info(`UtilityProcess<${this.id}>: terminated unexpectedly with code ${oe.exitCode}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:oe.exitCode,signal:""}))};b.app.on("child-process-gone",N),this._register((0,t.toDisposable)(()=>{b.app.off("child-process-gone",N)}));const{port1:U,port2:$}=new b.MessageChannelMain;this._process.postMessage("port",null,[$]),r.webContents.postMessage(o.responseChannel,o.responseNonce,[U])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const n=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,P.timeout)(o)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${n} did not exit within ${o}ms, will kill it now.`),this._process.kill())}};a=ve([J(1,R.ILogService),J(2,C.IWindowsMainService)],a)}),define(Z[249],ee([0,1,15,3,2,245,32]),function(q,e,w,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let E=class extends k.Disposable{constructor(m){super(),this.windowsMainService=m,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,P){let y;if(typeof m.windowId=="number"){const{windowId:S}=m,g=this.windowsMainService.getWindowById(S);if(!g?.win)throw new Error(`Invalid windowId: ${S}`);y=g.win.webContents}else{const{webContentsId:S}=m;if(y=w.webContents.fromId(S),!y)throw new Error(`Invalid webContentsId: ${S}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(P)}async findInFrame(m,P,y,S){const h=this.getFrameByName(m,P);if(typeof h.findInFrame=="function"){h.findInFrame(y,{findNext:S.findNext,forward:S.forward});const b=(C,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),h.removeListener("found-in-frame",b))};h.on("found-in-frame",b)}}async stopFindInFrame(m,P,y){const g=this.getFrameByName(m,P);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}getFrameByName(m,P){const y=this.windowsMainService.getWindowById(m.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${m}`);const S=y.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===P);if(!S)throw new Error(`Unknown frame: ${P}`);return S}};E=ve([J(0,M.IWindowsMainService)],E),e.WebviewMainService=E}),define(Z[250],ee([0,1,8,3,2]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:E,onDidFocusWindow:l,getActiveWindowId:m}){super(),this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(E,l))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,w.createCancelablePromise)(()=>m()),(async()=>{try{const y=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:y}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(E){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=E}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(Z[27],ee([0,1,173,9,31,16,7,5,13]),function(q,e,w,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,E.createDecorator)("contextService");function m(o){const n=o;return typeof n?.id=="string"&&M.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=m,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function P(o,n){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,t.basename)(o)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=o;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=P;function y(o){const n=o;return typeof n?.id=="string"&&M.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=y;function S(o){const n=o;if(n?.uri)return{id:n.id,uri:M.URI.revive(n.uri)};const r=o;if(r?.configPath)return{id:r.id,configPath:M.URI.revive(r.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=S;var g;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function h(o){const n=o;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=h;function b(o){const n=o;return!!(n&&typeof n=="object"&&M.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=b;class C{constructor(n,r,s,c,u){this._id=n,this._transient=s,this._configuration=c,this._ignorePathCasing=u,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=C;class p{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function v(o){return new p({uri:o,index:0,name:(0,R.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function d(o,n){return R.extUriBiasedIgnorePathCase.isEqualOrParent(o,n.untitledWorkspacesHome)}e.isUntitledWorkspace=d;function f(o){let n;return M.URI.isUri(o)?n=o:n=o.configuration,n?.scheme===l.Schemas.tmp}e.isTemporaryWorkspace=f;function a(o,n){return!d(o,n)&&!f(o)}e.isSavedWorkspace=a;function i(o){return(typeof o=="string"?(0,t.extname)(o):(0,R.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(Z[56],ee([0,1,15,8,66,34,2,80,4,12,23,150,5,6,27]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let b=class{constructor(p){this.logService=p,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(p,v){return this.doPick({...p,pickFolders:!0,pickFiles:!0,title:(0,y.localize)(0,null)},v)}pickFolder(p,v){return this.doPick({...p,pickFolders:!0,title:(0,y.localize)(1,null)},v)}pickFile(p,v){return this.doPick({...p,pickFiles:!0,title:(0,y.localize)(2,null)},v)}pickWorkspace(p,v){const d=(0,y.localize)(3,null),f=(0,R.mnemonicButtonLabel)((0,y.localize)(4,null)),a=h.WORKSPACE_FILTER;return this.doPick({...p,pickFiles:!0,title:d,filters:a,buttonLabel:f},v)}async doPick(p,v){const d={title:p.title,buttonLabel:p.buttonLabel,filters:p.filters,defaultPath:p.defaultPath};(typeof p.pickFiles=="boolean"||typeof p.pickFolders=="boolean")&&(d.properties=void 0,p.pickFiles&&p.pickFolders&&(d.properties=["multiSelections","openDirectory","openFile","createDirectory"])),d.properties||(d.properties=["multiSelections",p.pickFolders?"openDirectory":"openFile","createDirectory"]),l.isMacintosh&&d.properties.push("treatPackageAsDirectory");const f=await this.showOpenDialog(d,(0,m.withNullAsUndefined)(v||w.BrowserWindow.getFocusedWindow()));if(f&&f.filePaths&&f.filePaths.length>0)return f.filePaths}getWindowDialogQueue(p){if(p){let v=this.windowDialogQueues.get(p.id);return v||(v=new t.Queue,this.windowDialogQueues.set(p.id,v)),v}else return this.noWindowDialogueQueue}showMessageBox(p,v){return this.getWindowDialogQueue(v).queue(async()=>v?w.dialog.showMessageBox(v,p):w.dialog.showMessageBox(p))}async showSaveDialog(p,v){const d=this.acquireFileDialogLock(p,v);if(!d)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(v).queue(async()=>{let f;return v?f=await w.dialog.showSaveDialog(v,p):f=await w.dialog.showSaveDialog(p),f.filePath=this.normalizePath(f.filePath),f})}finally{(0,M.dispose)(d)}}normalizePath(p){return p&&l.isMacintosh&&(p=(0,E.normalizeNFC)(p)),p}normalizePaths(p){return p.map(v=>this.normalizePath(v))}async showOpenDialog(p,v){p.defaultPath&&(await P.Promises.exists(p.defaultPath)||(p.defaultPath=void 0));const d=this.acquireFileDialogLock(p,v);if(!d)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(v).queue(async()=>{let f;return v?f=await w.dialog.showOpenDialog(v,p):f=await w.dialog.showOpenDialog(p),f.filePaths=this.normalizePaths(f.filePaths),f})}finally{(0,M.dispose)(d)}}acquireFileDialogLock(p,v){if(!v)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",p);let d=this.windowFileDialogLocks.get(v.id);d||(d=new Set,this.windowFileDialogLocks.set(v.id,d));const f=(0,k.hash)(p);if(!d.has(f))return this.logService.trace("[DialogMainService]: new file dialog lock created",p),d.add(f),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",p),d?.delete(f),d?.size===0&&this.windowFileDialogLocks.delete(v.id)})}};b=ve([J(0,g.ILogService)],b),e.DialogMainService=b}),define(Z[251],ee([0,1,3,2,67,27]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends t.Disposable{constructor(l,m){super(),this.logService=l,this.storageMainService=m,this.onDidChangeApplicationStorageEmitter=this._register(new w.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(m.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(l,m){this._register(w.Event.debounce(l.onDidChangeStorage,(P,y)=>(P?P.push(y):P=[y],P),M.STORAGE_CHANGE_DEBOUNCE_TIME)(P=>{P.length&&m.fire(this.serializeStorageChangeEvents(P,l))}))}serializeStorageChangeEvents(l,m){const P=new Map,y=new Set;return l.forEach(S=>{const g=m.get(S.key);typeof g=="string"?P.set(S.key,g):y.add(S.key)}),{changed:Array.from(P.entries()),deleted:Array.from(y.values())}}listen(l,m,P){switch(m){case"onDidChangeStorage":{const y=P.profile?(0,k.revive)(P.profile):void 0;if(!y)return this.onDidChangeApplicationStorageEmitter.event;let S=this.mapProfileToOnDidChangeProfileStorageEmitter.get(y.id);return S||(S=this._register(new w.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(y),S),this.mapProfileToOnDidChangeProfileStorageEmitter.set(y.id,S)),S.event}}throw new Error(`Event not found: ${m}`)}async call(l,m,P){const y=P.profile?(0,k.revive)(P.profile):void 0,S=(0,R.reviveIdentifier)(P.workspace),g=await this.withStorageInitialized(y,S);switch(m){case"getItems":return Array.from(g.items.entries());case"updateItems":{const h=P;if(h.insert)for(const[b,C]of h.insert)g.set(b,C);h.delete?.forEach(b=>g.delete(b));break}case"isUsed":{const h=P.payload;if(typeof h=="string")return this.storageMainService.isUsed(h)}default:throw new Error(`Call not found: ${m}`)}}async withStorageInitialized(l,m){let P;m?P=this.storageMainService.workspaceStorage(m):l?P=this.storageMainService.profileStorage(l):P=this.storageMainService.applicationStorage;try{await P.init()}catch(y){this.logService.error(`StorageIPC#init: Unable to init ${m?"workspace":l?"profile":"application"} storage due to ${y}`)}return P}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[39],ee([0,1,66,3,2,16,12,7,170,35,14,5,6,27,31,51,8,29,25]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function d(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&E.URI.isUri(r.location)&&E.URI.isUri(r.globalStorageHome)&&E.URI.isUri(r.settingsResource)&&E.URI.isUri(r.keybindingsResource)&&E.URI.isUri(r.tasksResource)&&E.URI.isUri(r.snippetsHome)&&((0,M.isUndefined)(r.extensionsResource)||E.URI.isUri(r.extensionsResource)))}e.isUserDataProfile=d,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,y.createDecorator)("IUserDataProfilesService");function f(n,r){return{id:n.id,isDefault:n.isDefault,name:n.name,location:E.URI.revive(n.location).with({scheme:r}),globalStorageHome:E.URI.revive(n.globalStorageHome).with({scheme:r}),settingsResource:E.URI.revive(n.settingsResource).with({scheme:r}),keybindingsResource:E.URI.revive(n.keybindingsResource).with({scheme:r}),tasksResource:E.URI.revive(n.tasksResource).with({scheme:r}),snippetsHome:E.URI.revive(n.snippetsHome).with({scheme:r}),extensionsResource:E.URI.revive(n.extensionsResource)?.with({scheme:r}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=f,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function a(n,r,s,c,u){return{id:n,name:r,location:s,isDefault:!1,globalStorageHome:(0,R.joinPath)(s,"globalStorage"),settingsResource:(0,R.joinPath)(s,"settings.json"),keybindingsResource:(0,R.joinPath)(s,"keybindings.json"),tasksResource:(0,R.joinPath)(s,"tasks.json"),snippetsHome:(0,R.joinPath)(s,"snippets"),extensionsResource:(0,R.joinPath)(s,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:c,isTransient:u}}e.toUserDataProfile=a;let i=class extends k.Disposable{constructor(r,s,c,u){super(),this.environmentService=r,this.fileService=s,this.uriIdentityService=c,this.logService=u,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}get profilesObject(){if(!this._profilesObject){const r=this.enabled?this.getStoredProfiles().map(I=>a((0,R.basename)(I.location),I.name,I.location,I.useDefaultFlags)):[];let s;const c=new h.ResourceMap,u=a((0,w.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,l.localize)(0,null),this.environmentService.userRoamingDataHome);if(r.unshift({...u,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||r.length>0||this.transientProfilesObject.profiles.length>0?u.extensionsResource:void 0}),r.length){const I=this.getStoredProfileAssociations();if(I.workspaces)for(const[D,T]of Object.entries(I.workspaces)){const N=E.URI.parse(D),U=E.URI.parse(T),$=r.find(Y=>this.uriIdentityService.extUri.isEqual(Y.location,U));$&&c.set(N,$)}if(I.emptyWindow){const D=E.URI.parse(I.emptyWindow);s=r.find(T=>this.uriIdentityService.extUri.isEqual(T.location,D))}}this._profilesObject={profiles:r,workspaces:c,emptyWindow:s}}return this._profilesObject}async createTransientProfile(r){const s="Temp",c=new RegExp(`${(0,v.escapeRegExpCharacters)(s)}\\s(\\d+)`);let u=0;for(const D of this.profiles){const T=c.exec(D.name),N=T?parseInt(T[1]):0;u=N>u?N:u}const I=`${s} ${u+1}`;return this.createProfile((0,w.hash)((0,p.generateUuid)()).toString(16),I,void 0,!0,r)}async createNamedProfile(r,s,c){return this.createProfile((0,w.hash)((0,p.generateUuid)()).toString(16),r,s,!1,c)}async createProfile(r,s,c,u,I){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const D=await this.doCreateProfile(r,s,c,!!u);return I&&await this.setProfileForWorkspace(I,D),D}async doCreateProfile(r,s,c,u){let I=this.profileCreationPromises.get(s);return I||(I=(async()=>{try{const D=this.profiles.find(U=>U.name===s||U.id===r);if(D)return D;const T=a(r,s,(0,R.joinPath)(this.profilesHome,r),c,u);await this.fileService.createFolder(T.location);const N=[];return this._onWillCreateProfile.fire({profile:T,join(U){N.push(U)}}),await C.Promises.settled(N),this.updateProfiles([T],[],[]),T}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,I)),I}async updateProfile(r,s,c,u){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let I=this.profiles.find(D=>D.id===r.id);if(!I)throw new Error(`Profile '${r.name}' does not exist`);return I=a(I.id,s,I.location,c,u??I.isTransient),this.updateProfiles([],[],[I]),I}async removeProfile(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(u=>u.id===r.id);if(!s)throw new Error(`Profile '${r.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:s,join(u){c.push(u)}}),await C.Promises.settled(c),s.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const u of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(u)?.id&&this.profilesObject.workspaces.delete(u);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(s.location,{recursive:!0})}catch(u){this.logService.error(u)}}getOrSetProfileForWorkspace(r,s=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let c=this.getProfileForWorkspace(r);return c||(c=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(r,c)),c}async setProfileForWorkspace(r,s){this.setProfileForWorkspaceSync(r,s)}setProfileForWorkspaceSync(r,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(u=>u.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(r,c)}unsetWorkspace(r,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(r,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const r=await this.fileService.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(s=>s.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const r=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(r.map(s=>this.removeProfile(s)))}getProfileForWorkspace(r){const s=this.getWorkspace(r);return E.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(r){return(0,g.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,g.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}isProfileAssociatedToWorkspace(r){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,r.location)||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,r.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,r.location)||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,r.location)))}updateProfiles(r,s,c){const u=[...this.profiles,...r],I=[];this.transientProfilesObject.profiles=[];for(let D of u)D.isDefault||s.some(T=>D.id===T.id)||(D=c.find(T=>D.id===T.id)??D,D.isTransient?this.transientProfilesObject.profiles.push(D):I.push({location:D.location,name:D.name,useDefaultFlags:D.useDefaultFlags}));this.saveStoredProfiles(I),this._profilesObject=void 0,this.triggerProfilesChanges(r,s,c)}triggerProfilesChanges(r,s,c){this._onDidChangeProfiles.fire({added:r,removed:s,updated:c,all:this.profiles})}updateWorkspaceAssociation(r,s,c){c=s?.isTransient?!0:c,c||this.updateWorkspaceAssociation(r,void 0,!0);const u=this.getWorkspace(r),I=c?this.transientProfilesObject:this.profilesObject;E.URI.isUri(u)?(I.workspaces.delete(u),s&&I.workspaces.set(u,s)):I.emptyWindow=s,c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[c,u]of this.profilesObject.workspaces.entries())r[c.toString()]=u.location.toString();const s=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:r,emptyWindow:s}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=ve([J(0,m.IEnvironmentService),J(1,P.IFileService),J(2,b.IUriIdentityService),J(3,S.ILogService)],i),e.UserDataProfilesService=i;class o extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(r){this.storedProfiles=r}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(r){this.storedProfileAssociations=r}}e.InMemoryUserDataProfilesService=o}),define(Z[89],ee([0,1,24,8,50,18,17,43,136,2,13,9,4,16,188,96,12,7,155,35,111,110,187,14,5,6,20,3,67,72,39,51,186]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p,v,d,f,a,i,o,n,r,s,c,u,I,D,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var U;(function(G){function K(F,A){if(F===A)return!0;const W=Object.keys(F),z=new Set;for(const te of Object.keys(A))z.add(te);if(W.length!==z.size)return!1;for(const te of W){if(F[te]!==A[te])return!1;z.delete(te)}return z.size===0}G.equals=K})(U=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let $=class extends m.Disposable{constructor(K,F,A,W,z,te,B,j,L,O,_){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=F,this.extensionsControlLocation=A,this.cacheLocation=W,this.userDataProfilesService=z,this.extensionsProfileScannerService=te,this.fileService=B,this.logService=j,this.environmentService=L,this.productService=O,this.instantiationService=_,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,g.joinPath)(this.cacheLocation,a.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,g.joinPath)(this.cacheLocation,a.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(oe,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(K,F,A){const[W,z]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(F)]),te=A?await this.scanExtensionsUnderDevelopment(K,[...W,...z]):[];return this.dedupExtensions(W,z,te,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const F=[];F.push(this.scanDefaultSystemExtensions(!!K.useCache,K.language)),F.push(this.scanDevSystemExtensions(K.language,!!K.checkControlFile));const[A,W]=await Promise.all(F);return this.applyScanOptions([...A,...W],0,K,!1)}async scanUserExtensions(K){this.logService.trace("Started scanning user extensions");const F=await this.createExtensionScannerInput(K.profileLocation??this.userExtensionsLocation,!!K.profileLocation,1,!K.includeUninstalled,K.language);let W=await(K.useCache&&!F.devMode&&F.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return W=await this.applyScanOptions(W,1,K,!0),this.logService.trace("Scanned user extensions:",W.length),W}async scanExtensionsUnderDevelopment(K,F){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const A=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===P.Schemas.file).map(async W=>{const z=await this.createExtensionScannerInput(W,!1,1,!0,K.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(z)).map(B=>(B.type=F.find(j=>(0,f.areSameExtensions)(j.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,z)))}))).flat();return this.applyScanOptions(A,"development",K,!0)}return[]}async scanExistingExtension(K,F,A){const W=await this.createExtensionScannerInput(K,!1,F,!0,A.language),z=await this.extensionsScanner.scanExtension(W);return!z||!A.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions(K,F,A){const W=await this.createExtensionScannerInput(K,!1,F,!0,A.language),z=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(z,F,A,!0)}async scanMetadata(K){const F=(0,g.joinPath)(K,"package.json"),A=(await this.fileService.readFile(F)).value.toString();return JSON.parse(A).__metadata}async updateMetadata(K,F){const A=(0,g.joinPath)(K,"package.json"),W=(await this.fileService.readFile(A)).value.toString(),z=JSON.parse(W);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,z.__metadata={...z.__metadata,...F},await this.fileService.writeFile((0,g.joinPath)(K,"package.json"),R.VSBuffer.fromString(JSON.stringify(z,null,"	")))}async applyScanOptions(K,F,A,W){return A.includeAllVersions||(K=this.dedupExtensions(F===0?K:void 0,F===1?K:void 0,F==="development"?K:void 0,await this.getTargetPlatform(),W)),A.includeInvalid||(K=K.filter(z=>z.isValid)),K.sort((z,te)=>{const B=y.basename(z.location.fsPath),j=y.basename(te.location.fsPath);return B<j?-1:B>j?1:0})}dedupExtensions(K,F,A,W,z){const te=(j,L,O)=>{if(j.isValid&&!L.isValid)return!1;if(j.isValid===L.isValid){if(z&&h.gt(j.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${j.location.path} with version ${j.manifest.version}`),!1;if(h.eq(j.manifest.version,L.manifest.version)){if(j.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${j.location.path} with same version`),!1;if(j.targetPlatform===W)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${j.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${j.location.path} with ${L.location.path}.`),!0},B=new Map;return K?.forEach(j=>{const L=a.ExtensionIdentifier.toKey(j.identifier.id),O=B.get(L);(!O||te(O,j,!1))&&B.set(L,j)}),F?.forEach(j=>{const L=a.ExtensionIdentifier.toKey(j.identifier.id),O=B.get(L);if(!O&&K&&j.type===0){this.logService.debug(`Skipping obsolete system extension ${j.location.path}.`);return}(!O||te(O,j,!1))&&B.set(L,j)}),A?.forEach(j=>{const L=a.ExtensionIdentifier.toKey(j.identifier.id),O=B.get(L);(!O||te(O,j,!0))&&B.set(L,j),B.set(L,j)}),[...B.values()]}async scanDefaultSystemExtensions(K,F){this.logService.trace("Started scanning system extensions");const A=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,F),z=await(K&&!A.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return this.logService.trace("Scanned system extensions:",z.length),z}async scanDevSystemExtensions(K,F){const A=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!A?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=F?await this.getBuiltInExtensionControl():{},z=[],te=p.URI.file(y.normalize(y.join(P.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions")));for(const j of A){const L=W[j.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":z.push((0,g.joinPath)(te,j.name));break;default:z.push(p.URI.file(L));break}}const B=await Promise.all(z.map(async j=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(j,!1,0,!0,K))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,w.coalesce)(B)}async getBuiltInExtensionControl(){try{const K=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(K.value.toString())}catch{return{}}}async createExtensionScannerInput(K,F,A,W,z,te=!0){const B=await this.getTranslations(z??S.language),j=await this.getMtime(K),L=F?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=L?await this.getMtime(L):void 0;return new Y(K,j,L,O,F,A,W,te,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,z,B)}async getMtime(K){try{const F=await this.fileService.stat(K);if(typeof F.mtime=="number")return F.mtime}catch{}}};$=ve([J(4,D.IUserDataProfilesService),J(5,I.IExtensionsProfileScannerService),J(6,o.IFileService),J(7,r.ILogService),J(8,d.IEnvironmentService),J(9,s.IProductService),J(10,n.IInstantiationService)],$),e.AbstractExtensionsScannerService=$;class Y{constructor(K,F,A,W,z,te,B,j,L,O,_,V,x,re){this.location=K,this.mtime=F,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=W,this.profile=z,this.type=te,this.excludeObsolete=B,this.validate=j,this.productVersion=L,this.productDate=O,this.productCommit=_,this.devMode=V,this.language=x,this.translations=re}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,F){return(0,g.isEqual)(K.location,F.location)&&K.mtime===F.mtime&&(0,g.isEqual)(K.applicationExtensionslocation,F.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&K.profile===F.profile&&K.type===F.type&&K.excludeObsolete===F.excludeObsolete&&K.validate===F.validate&&K.productVersion===F.productVersion&&K.productDate===F.productDate&&K.productCommit===F.productCommit&&K.devMode===F.devMode&&K.language===F.language&&U.equals(K.translations,F.translations)}}let oe=class extends m.Disposable{constructor(K,F,A,W,z){super(),this.obsoleteFile=K,this.extensionsProfileScannerService=F,this.uriIdentityService=A,this.fileService=W,this.logService=z}async scanExtensions(K){const F=K.profile?await this.scanExtensionsFromProfile(K):await this.scanExtensionsFromLocation(K);let A={};if(K.excludeObsolete&&K.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();A=JSON.parse(W)}catch{}return(0,C.isEmptyObject)(A)?F:F.filter(W=>!A[f.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(K){const F=await this.fileService.resolve(K.location);if(!F.children?.length)return[];const A=await Promise.all(F.children.map(async W=>{if(!W.isDirectory||K.type===1&&(0,g.basename)(W.resource).indexOf(".")===0)return null;const z=new Y(W.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(z)}));return(0,w.coalesce)(A).sort((W,z)=>W.location.path<z.location.path?-1:1)}async scanExtensionsFromProfile(K){let F=await this.scanExtensionsFromProfileResource(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(K.location,K.applicationExtensionslocation)){F=F.filter(W=>!W.metadata?.isApplicationScoped);const A=await this.scanExtensionsFromProfileResource(K.applicationExtensionslocation,W=>!!W.metadata?.isApplicationScoped,K);F.push(...A)}return F}async scanExtensionsFromProfileResource(K,F,A){const W=await this.extensionsProfileScannerService.scanProfileExtensions(K);if(!W.length)return[];const z=await Promise.all(W.map(async te=>{if(F(te)){const B=new Y(te.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(B,te.metadata)}return null}));return(0,w.coalesce)(z)}async scanOneOrMultipleExtensions(K){try{if(await this.fileService.exists((0,g.joinPath)(K.location,"package.json"))){const F=await this.scanExtension(K);return F?[F]:[]}else return await this.scanExtensions(K)}catch(F){return this.logService.error(`Error scanning extensions at ${K.location.path}:`,(0,M.getErrorMessage)(F)),[]}}async scanExtension(K,F){try{let A=await this.scanExtensionManifest(K.location);if(A){A.publisher||(A.publisher=a.UNDEFINED_PUBLISHER),F=F??A.__metadata,delete A.__metadata;const W=(0,f.getGalleryExtensionId)(A.publisher,A.name),z=F?.id?{id:W,uuid:F.id}:{id:W},te=F?.isSystem?0:K.type,B=te===0||!!F?.isBuiltin;A=await this.translateManifest(K.location,A,Y.createNlsConfiguration(K));const j={type:te,identifier:z,manifest:A,location:K.location,isBuiltin:B,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return K.validate?this.validate(j,K):j}}catch(A){K.type!==0&&this.logService.error(A)}return null}validate(K,F){let A=!0;const W=(0,i.validateExtensionManifest)(F.productVersion,F.productDate,F.location,K.manifest,K.isBuiltin);for(const[z,te]of W)z===b.default.Error&&(A=!1,this.logService.error(this.formatMessage(F.location,te)));return K.isValid=A,K.validations=W,K}async scanExtensionManifest(K){const F=(0,g.joinPath)(K,"package.json");let A;try{A=(await this.fileService.readFile(F)).value.toString()}catch(z){return(0,o.toFileOperationResult)(z)!==1&&this.logService.error(this.formatMessage(K,(0,v.localize)(0,null,F.path,z.message))),null}let W;try{W=JSON.parse(A)}catch{const te=[];(0,E.parse)(A,te);for(const B of te)this.logService.error(this.formatMessage(K,(0,v.localize)(1,null,F.path,B.offset,B.length,(0,l.getParseErrorMessage)(B.error))));return null}return(0,E.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(K,(0,v.localize)(2,null,F.path))),null):W}async translateManifest(K,F,A){const W=await this.getLocalizedMessages(K,F,A);if(W)try{const z=[],te=await this.resolveOriginalMessageBundle(W.default,z);if(z.length>0)return z.forEach(j=>{this.logService.error(this.formatMessage(K,(0,v.localize)(3,null,W.default?.path,(0,l.getParseErrorMessage)(j.error))))}),F;if((0,E.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(K,(0,v.localize)(4,null,W.default?.path))),F;const B=W.values||Object.create(null);return(0,N.localizeManifest)(F,B,te)}catch{}return F}async getLocalizedMessages(K,F,A){const W=(0,g.joinPath)(K,"package.nls.json"),z=(L,O)=>{O.forEach(_=>{this.logService.error(this.formatMessage(K,(0,v.localize)(5,null,L?.path,(0,l.getParseErrorMessage)(_.error))))})},te=L=>{this.logService.error(this.formatMessage(K,(0,v.localize)(6,null,L?.path)))},B=`${F.publisher}.${F.name}`,j=A.translations[B];if(j)try{const L=p.URI.file(j),O=(await this.fileService.readFile(L)).value.toString(),_=[],V=(0,E.parse)(O,_);return _.length>0?(z(L,_),{values:void 0,default:W}):(0,E.getNodeType)(V)!=="object"?(te(L),{values:void 0,default:W}):{values:V.contents?V.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let O;try{O=await this.findMessageBundles(K,A)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const _=(await this.fileService.readFile(O.localized)).value.toString(),V=[],x=(0,E.parse)(_,V);return V.length>0?(z(O.localized,V),{values:void 0,default:O.original}):(0,E.getNodeType)(x)!=="object"?(te(O.localized),{values:void 0,default:O.original}):{values:x,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(K,F){if(K)try{const A=(await this.fileService.readFile(K)).value.toString();return(0,E.parse)(A,F)}catch{}}findMessageBundles(K,F){return new Promise((A,W)=>{const z=te=>{const B=(0,g.joinPath)(K,`package.nls.${te}.json`);this.fileService.exists(B).then(j=>{j&&A({localized:B,original:(0,g.joinPath)(K,"package.nls.json")});const L=te.lastIndexOf("-");L===-1?A({localized:(0,g.joinPath)(K,"package.nls.json"),original:null}):(te=te.substring(0,L),z(te))})};if(F.devMode||F.pseudo||!F.language)return A({localized:(0,g.joinPath)(K,"package.nls.json"),original:null});z(F.language)})}formatMessage(K,F){return`[${K.path}]: ${F}`}};oe=ve([J(1,I.IExtensionsProfileScannerService),J(2,T.IUriIdentityService),J(3,o.IFileService),J(4,r.ILogService)],oe);let ue=class extends oe{constructor(K,F,A,W,z,te){super(F,A,W,z,te),this.cacheFile=K,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(K){const F=await this.readExtensionCache();if(this.input=K,F&&F.input&&Y.equals(F.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),F.result.map(W=>(W.location=p.URI.revive(W.location),W));const A=await super.scanExtensions(K);return await this.writeExtensionCache({input:K,result:A}),A}async readExtensionCache(){try{const K=await this.fileService.readFile(this.cacheFile),F=JSON.parse(K.value.toString());return{result:F.result,input:(0,u.revive)(F.input)}}catch(K){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,M.getErrorMessage)(K))}return null}async writeExtensionCache(K){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(K)))}catch(F){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,M.getErrorMessage)(F))}}async validateCache(){if(!this.input)return;const K=await this.readExtensionCache();if(!K)return;const F=K.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(A,F))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(W){this.logService.error(W)}}};ue=ve([J(2,I.IExtensionsProfileScannerService),J(3,T.IUriIdentityService),J(4,o.IFileService),J(5,r.ILogService)],ue);function se(G,K){const F=(0,f.getExtensionId)(G.manifest.publisher,G.manifest.name);return{id:F,identifier:new a.ExtensionIdentifier(F),isBuiltin:G.type===0,isUserBuiltin:G.type===1&&G.isBuiltin,isUnderDevelopment:K,extensionLocation:G.location,uuid:G.identifier.uuid,targetPlatform:G.targetPlatform,...G.manifest}}e.toExtensionDescription=se;class he extends ${constructor(K,F,A,W,z,te,B,j,L,O,_){super(K,F,(0,g.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,g.joinPath)(W,a.MANIFEST_CACHE_FOLDER),z,te,B,j,L,O,_),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const V=await this.fileService.readFile(p.URI.file(S.translationsConfigFile));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}getTranslations(K){return this.translationsPromise}}e.NativeExtensionsScannerService=he}),define(Z[252],ee([0,1,7,35,72,89,14,5,6,20,39]),function(q,e,w,t,k,R,M,E,l,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends R.NativeExtensionsScannerService{constructor(g,h,b,C,p,v,d){super(w.URI.file(p.builtinExtensionsPath),w.URI.file(p.extensionsPath),p.userHome,w.URI.file(p.userDataPath),g,h,b,C,p,v,d)}};y=ve([J(0,P.IUserDataProfilesService),J(1,k.IExtensionsProfileScannerService),J(2,M.IFileService),J(3,l.ILogService),J(4,t.INativeEnvironmentService),J(5,m.IProductService),J(6,E.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(Z[253],ee([0,1,15,41,2,31,13,9,4,7,29,35,6,39]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let h=class extends k.Disposable{constructor(C,p,v){super(),this.environmentService=C,this.logService=v,this.validRoots=R.TernarySearchTree.forPaths(!l.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(C.appRoot),this.addValidFileRoot(C.extensionsPath),this.addValidFileRoot(p.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(C.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:C}=w.session;C.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(p,v)=>this.handleResourceRequest(p,v)),C.protocol.interceptFileProtocol(M.Schemas.file,(p,v)=>this.handleFileRequest(p,v)),this._register((0,k.toDisposable)(()=>{C.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),C.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(C){const p=(0,E.normalize)(C);return this.validRoots.get(p)?k.Disposable.None:(this.validRoots.set(p,!0),(0,k.toDisposable)(()=>this.validRoots.delete(p)))}handleFileRequest(C,p){const v=m.URI.parse(C.url);return this.logService.error(`Refused to load resource ${v.fsPath} from ${M.Schemas.file}: protocol (original URL: ${C.url})`),p({error:-3})}handleResourceRequest(C,p){const v=this.requestToNormalizedFilePath(C);let d;return this.environmentService.crossOriginIsolated&&(v.endsWith("/workbench.html")?d=M.COI.CoopAndCoep:d=M.COI.getHeadersFromQuery(C.url)),this.validRoots.findSubstr(v)?p({path:v,headers:d}):this.validExtensions.has((0,E.extname)(v).toLowerCase())?p({path:v}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${v} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${C.url})`),p({error:-3}))}requestToNormalizedFilePath(C){const p=m.URI.parse(C.url),v=M.FileAccess.asFileUri(p);return(0,E.normalize)(v.fsPath)}createIPCObjectUrl(){let C;const p=m.URI.from({scheme:"vscode",path:(0,P.generateUuid)()}),v=p.toString(),d=async()=>C;return t.validatedIpcMain.handle(v,d),this.logService.trace(`IPC Object URL: Registered new channel ${v}.`),{resource:p,update:f=>C=f,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${v}.`),t.validatedIpcMain.removeHandler(v)}}}};h=ve([J(0,y.INativeEnvironmentService),J(1,g.IUserDataProfilesService),J(2,S.ILogService)],h),e.ProtocolMainService=h}),define(Z[254],ee([0,1,15,41,8,3,2,13,12,101,26,21,6,54,61,64,44,39,37]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let d=class extends M.Disposable{constructor(a,i,o,n,r,s,c,u,I){super(),this.machineId=a,this.userEnv=i,this.environmentMainService=o,this.userDataProfilesService=n,this.lifecycleMainService=r,this.logService=s,this.policyService=c,this.themeMainService=u,this.protocolMainService=I,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(a,i)=>this.onWindowConnection(a,i)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(a,i)=>this.onWorkerConnection(a,i)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(a,i){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const o=await this.connect();if(a.sender.isDestroyed())return o.close();a.sender.postMessage("vscode:createSharedProcessMessageChannelResult",i,[o])}onWorkerConnection(a,i){this.logService.trace("SharedProcess: onWorkerConnection",i);const o=new M.DisposableStore,n=s=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${s}')`,i),o.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",i))},r=w.BrowserWindow.fromId(i.reply.windowId);if(!r||r.isDestroyed()||r.webContents.isDestroyed()||!i.reply.channel){n("unavailable");return}o.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===r)(()=>n("load"))),o.add(R.Event.fromNodeEventEmitter(r,"closed")(()=>n("closed"))),r.webContents.postMessage(i.reply.channel,i.reply.nonce,a.ports)}onWillShutdown(){const a=this.window;!a||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(a.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{a.close()}catch{}this.window=void 0},0))}send(a,...i){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${a}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(a,...i)}catch(o){this.logService.warn(`Error sending IPC message to channel '${a}' of shared process: ${(0,C.toErrorMessage)(o)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(a=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),a()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(a=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),a()}))})()),this._whenIpcReady}createWindow(){const a=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new w.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${a.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),a.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:g.default,policiesData:this.policyService.serialize()}),this.window.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",q).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=a=>{this.logService.trace("SharedProcess#close prevented"),a.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(a,i)=>this._onDidError.fire({type:2,details:i})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(a,i,o)=>this._onDidError.fire({type:3,details:{reason:o,exitCode:i}})))}async connect(){await this.whenIpcReady;const a=(0,l.assertIsDefined)(this.window);return(0,m.connect)(a)}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const a=this.window;return a?!a.isDestroyed()&&!a.webContents.isDestroyed():!1}};d=ve([J(2,P.IEnvironmentMainService),J(3,p.IUserDataProfilesService),J(4,y.ILifecycleMainService),J(5,S.ILogService),J(6,v.IPolicyService),J(7,b.IThemeMainService),J(8,h.IProtocolMainService)],d),e.SharedProcess=d}),define(Z[90],ee([0,1,8,3,2,71,12,102,5,39]),function(q,e,w,t,k,R,M,E,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,l.createDecorator)("storageService");var P;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var S;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));function g(v){const d=v.get(e.TARGET_KEY);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.loadKeyTargets=g;class h extends k.Disposable{constructor(d={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=d,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new w.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,w.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(d,f){if(f===e.TARGET_KEY){switch(d){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:d})}else this._onDidChangeValue.fire({scope:d,key:f,target:this.getKeyTargets(d)[f]})}emitWillSaveState(d){this._onWillSaveState.fire({reason:d})}get(d,f,a){return this.getStorage(f)?.get(d,a)}getBoolean(d,f,a){return this.getStorage(f)?.getBoolean(d,a)}getNumber(d,f,a){return this.getStorage(f)?.getNumber(d,a)}store(d,f,a,i){if((0,M.isUndefinedOrNull)(f)){this.remove(d,a);return}this.withPausedEmitters(()=>{this.updateKeyTarget(d,a,i),this.getStorage(a)?.set(d,f)})}remove(d,f){this.withPausedEmitters(()=>{this.updateKeyTarget(d,f,void 0),this.getStorage(f)?.delete(d)})}withPausedEmitters(d){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{d()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(d,f){const a=[],i=this.getKeyTargets(d);for(const o of Object.keys(i))i[o]===f&&a.push(o);return a}updateKeyTarget(d,f,a){const i=this.getKeyTargets(f);typeof a=="number"?i[d]!==a&&(i[d]=a,this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[d]=="number"&&(delete i[d],this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(d){switch(d){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(d){const f=this.getStorage(d);return f?g(f):Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=P.NONE){this._onWillSaveState.fire({reason:d});const f=this.getStorage(-1),a=this.getStorage(0),i=this.getStorage(1);switch(d){case P.NONE:await w.Promises.settled([f?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await w.Promises.settled([f?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,a=this.getStorage(1)?.items??new Map;return p(d,f,a,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(d,f){return this.emitWillSaveState(P.NONE),(0,m.isUserDataProfile)(d)?this.switchToProfile(d,f):this.switchToWorkspace(d,f)}canSwitchProfile(d,f){return!(d.id===f.id||b(f)&&b(d))}switchData(d,f,a,i){this.withPausedEmitters(()=>{if(i)for(const[o,n]of d)f.set(o,n);else{const o=new Set;for(const[n,r]of d)o.add(n),f.get(n)!==r&&this.emitDidChangeValue(a,n);for(const[n]of f.items)o.has(n)||this.emitDidChangeValue(a,n)}})}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;function b(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=b;class C extends h{constructor(){super(),this.applicationStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.profileStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(d=>this.emitDidChangeValue(1,d))),this._register(this.profileStorage.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),this._register(this.applicationStorage.onDidChangeStorage(d=>this.emitDidChangeValue(-1,d)))}getStorage(d){switch(d){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(d){return!1}}e.InMemoryStorageService=C;async function p(v,d,f,a,i,o){const n=U=>{try{return JSON.parse(U)}catch{return U}},r=new Map,s=new Map;v.forEach((U,$)=>{r.set($,U),s.set($,n(U))});const c=new Map,u=new Map;d.forEach((U,$)=>{c.set($,U),u.set($,n(U))});const I=new Map,D=new Map;f.forEach((U,$)=>{I.set($,U),D.set($,n(U))}),console.group(a!==i?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const T=[];if(r.forEach((U,$)=>{T.push({key:$,value:U})}),console.table(T),console.groupEnd(),console.log(s),a!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const U=[];c.forEach(($,Y)=>{U.push({key:Y,value:$})}),console.table(U),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${o})`);const N=[];I.forEach((U,$)=>{N.push({key:$,value:U})}),console.table(N),console.groupEnd(),console.log(D)}e.logStorage=p}),define(Z[255],ee([0,1,24,8,3,2,9,79,7,23,102,147,6,90,36,27]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class C extends R.Disposable{constructor(o,n){super(),this.logService=o,this.fileService=n,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new P.Storage(new P.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=P.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===P.StorageState.None)try{const o=await this.doCreate();this._storage.dispose(),this._storage=o,this._register(o.onDidChangeStorage(r=>this._onDidChangeStorage.fire({key:r}))),await this.doInit(o);const n=o.getBoolean(g.IS_NEW_KEY);n===void 0?o.set(g.IS_NEW_KEY,!0):n&&o.set(g.IS_NEW_KEY,!1)}catch(o){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${o}`)}finally{this.state=P.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?o=>this.logService.trace(o):void 0,logError:o=>this.logService.error(o)}}doInit(o){return o.init()}get items(){return this._storage.items}get(o,n){return this._storage.get(o,n)}set(o,n){return this._storage.set(o,n)}delete(o){return this._storage.delete(o)}async close(){const o=new E.StopWatch(!1);await this.doClose(),o.stop(),o.elapsed()>C.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(o),this._onDidCloseStorage.fire()}async logSlowClose(o){if(!!this.path)try{const n=(0,w.top)(Array.from(this._storage.items.entries()).map(([s,c])=>({key:s,length:c.length})),(s,c)=>c.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),r=(await this.fileService.stat(l.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${o.elapsed()}ms, DB size: ${r}b, Large Keys: ${n}`)}catch(n){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=P.StorageState.Closed,await this._storage.close()}}C.LOG_SLOW_CLOSE_THRESHOLD=2e3;class p extends C{constructor(o,n,r,s){super(r,s),this.profile=o,this.options=n}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.profile.globalStorageHome.fsPath,p.STORAGE_NAME)}async doCreate(){return new P.Storage(new y.SQLiteStorageDatabase(this.path??y.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}p.STORAGE_NAME="state.vscdb";class v extends p{constructor(o,n,r,s){super(o,n,r,s)}}e.ProfileStorageMain=v;class d extends p{constructor(o,n,r,s){super(n.defaultProfile,o,r,s)}async doInit(o){await super.doInit(o),this.updateTelemetryState(o)}updateTelemetryState(o){o.get(h.firstSessionDateStorageKey,void 0)===void 0&&o.set(h.firstSessionDateStorageKey,new Date().toUTCString());const r=o.get(h.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();o.set(h.lastSessionDateStorageKey,typeof r>"u"?null:r),o.set(h.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=d;class f extends C{constructor(o,n,r,s,c){super(r,c),this.workspace=o,this.options=n,this.environmentService=s}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,f.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:o,wasCreated:n}=await this.prepareWorkspaceStorageFolder();return new P.Storage(new y.SQLiteStorageDatabase(o,{logging:this.createLoggingOptions()}),{hint:n?P.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:y.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const o=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),n=(0,M.join)(o,f.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(o)?{storageFilePath:n,wasCreated:!1}:(await m.Promises.mkdir(o,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(o),{storageFilePath:n,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(o){let n;if((0,b.isSingleFolderWorkspaceIdentifier)(this.workspace)?n={folder:this.workspace.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.workspace)&&(n={workspace:this.workspace.configPath.toString()}),n)try{const r=(0,M.join)(o,f.WORKSPACE_META_NAME);await m.Promises.exists(r)||await m.Promises.writeFile(r,JSON.stringify(n,void 0,2))}catch(r){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${r}`)}}}e.WorkspaceStorageMain=f,f.WORKSPACE_STORAGE_NAME="state.vscdb",f.WORKSPACE_META_NAME="workspace.json";class a extends C{get path(){}async doCreate(){return new P.Storage(new P.InMemoryStorageDatabase)}}e.InMemoryStorageMain=a}),define(Z[256],ee([0,1,67,35,14,6,226,51,39]),function(q,e,w,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let m=class Rt extends l.UserDataProfilesService{constructor(y,S,g,h,b){super(g,h,S,b),this.stateService=y}getStoredProfiles(){return(0,w.revive)(this.stateService.getItem(Rt.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,w.revive)(this.stateService.getItem(Rt.PROFILE_ASSOCIATIONS_KEY,{}))}};m=ve([J(0,M.IStateService),J(1,E.IUriIdentityService),J(2,t.IEnvironmentService),J(3,k.IFileService),J(4,R.ILogService)],m),e.UserDataProfilesService=m}),define(Z[42],ee([0,1,7,35,14,5,6,38,51,39,256]),function(q,e,w,t,k,R,M,E,l,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(m.IUserDataProfilesService);let y=class ut extends P.UserDataProfilesService{constructor(g,h,b,C,p){super(g,h,b,C,p),this.stateMainService=g}setEnablement(g){super.setEnablement(g),this.enabled||(this.saveStoredProfiles([]),this.saveStoredProfileAssociations({}))}isEnabled(){return this.enabled}checkAndCreateProfileFromCli(g){if(!!this.isEnabled()){if(g.profile){const h=this.profiles.find(b=>b.name===g.profile);return h?Promise.resolve(h):this.createNamedProfile(g.profile)}if(g["profile-temp"])return this.createTransientProfile()}}saveStoredProfiles(g){g.length?this.stateMainService.setItem(ut.PROFILES_KEY,g):this.stateMainService.removeItem(ut.PROFILES_KEY)}saveStoredProfileAssociations(g){g.emptyWindow||g.workspaces?this.stateMainService.setItem(ut.PROFILE_ASSOCIATIONS_KEY,g):this.stateMainService.removeItem(ut.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const g="workspaceAndProfileInfo",h=this.stateMainService.getItem(g,void 0);if(h){this.stateMainService.removeItem(g);const b=h.reduce((C,{workspace:p,profile:v})=>(C[w.URI.revive(p).toString()]=w.URI.revive(v).toString(),C),{});this.stateMainService.setItem(ut.PROFILE_ASSOCIATIONS_KEY,{workspaces:b})}return super.getStoredProfileAssociations()}};y=ve([J(0,E.IStateMainService),J(1,l.IUriIdentityService),J(2,t.IEnvironmentService),J(3,k.IFileService),J(4,M.ILogService)],y),e.UserDataProfilesMainService=y}),define(Z[257],ee([0,1,2,16,72,89,14,6,39,42]),function(q,e,w,t,k,R,M,E,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let P=class extends w.Disposable{constructor(S,g,h,b,C){super(),this.userDataProfilesService=S,this.fileService=g,this.extensionsScannerService=h,this.extensionsProfileScannerService=b,S.isEnabled()?(this._register(S.onWillCreateProfile(p=>{S.profiles.length===1&&p.join(this.initialize())})),this._register(S.onDidChangeProfiles(p=>{S.profiles.length===1&&this.uninitialize()}))):this.uninitialize().then(null,p=>C.error(p))}async initialize(){const S=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(S)}catch{}const g=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(g.map(h=>[h,h.metadata]),S)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,l.EXTENSIONS_RESOURCE_NAME)}};P=ve([J(0,m.IUserDataProfilesMainService),J(1,M.IFileService),J(2,R.IExtensionsScannerService),J(3,k.IExtensionsProfileScannerService),J(4,E.ILogService)],P),e.DefaultExtensionsProfileInitHandler=P}),define(Z[258],ee([0,1,15,24,4,7,23,19,59,5,6,115,32,42]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,m.createDecorator)(e.ID);let h=class{constructor(C,p,v,d,f){this.logService=C,this.windowsMainService=p,this.urlService=v,this.configurationService=d,this.userDataProfilesMainService=f}async start(C,p){this.logService.trace("Received data from other instance: ",C,p),k.isMacintosh&&w.app.focus({steal:!0});const v=this.parseOpenUrl(C);if(v.length){let d=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const f=(0,t.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));f&&(d=f.ready())}d.then(()=>{for(const{uri:f,url:a}of v)this.urlService.open(f,{originalUrl:a})})}else return this.startOpenWindow(C,p)}parseOpenUrl(C){return C["open-url"]&&C._urls&&C._urls.length>0?(0,t.coalesce)(C._urls.map(p=>{try{return{uri:R.URI.parse(p),url:p}}catch{return null}})):[]}async startOpenWindow(C,p){const v=(0,l.isLaunchedFromCli)(p)?0:4;let d=[];const f=C.wait&&C.waitMarkerFilePath?R.URI.file(C.waitMarkerFilePath):void 0,a=C.remote||void 0,i=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(C),o={context:v,cli:C,userEnv:p,waitMarkerFileURI:f,remoteAuthority:a,profile:i};if(C.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(C.extensionDevelopmentPath,o);else if(!C._.length&&!C["folder-uri"]&&!C["file-uri"]){let n=!1;if(C["new-window"]||C["unity-launch"]||i)n=!0;else if(C["reuse-window"])n=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":n=!0;break;case"off":n=!1;break;default:n=!k.isMacintosh}if(n)d=await this.windowsMainService.open({...o,forceNewWindow:!0,forceEmpty:!0});else{const r=this.windowsMainService.getLastActiveWindow();r?(this.windowsMainService.openExistingWindow(r,o),d=[r]):d=await this.windowsMainService.open({...o,forceEmpty:!0})}}else d=await this.windowsMainService.open({...o,forceNewWindow:C["new-window"],preferNewWindow:!C["reuse-window"]&&!C.wait,forceReuseWindow:C["reuse-window"],diffMode:C.diff,mergeMode:C.merge,addMode:C.add,noRecentEntry:!!C["skip-add-to-recently-opened"],gotoLineMode:C.goto});if(f&&d.length===1&&d[0])return Promise.race([d[0].whenClosedOrLoaded,(0,M.whenDeleted)(f.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};h=ve([J(0,P.ILogService),J(1,S.IWindowsMainService),J(2,y.IURLService),J(3,E.IConfigurationService),J(4,g.IUserDataProfilesMainService)],h),e.LaunchMainService=h}),define(Z[91],ee([0,1,7,49,3,2,35,14,5,21,6,90,255,39,42,51]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,l.createDecorator)("storageMainService");let C=class extends R.Disposable{constructor(d,f,a,i,o,n){super(),this.logService=d,this.environmentService=f,this.userDataProfilesService=a,this.lifecycleMainService=i,this.fileService=o,this.uriIdentityService=n,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new k.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(d=>{d.window.profile&&this.profileStorage(d.window.profile).init(),d.workspace&&this.workspaceStorage(d.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(d=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=d.reason,d.join(this.applicationStorage.close());for(const[,f]of this.mapProfileToStorage)d.join(f.close());for(const[,f]of this.mapWorkspaceToStorage)d.join(f.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(d=>{d.join((async()=>{await this.fileService.exists(d.profile.globalStorageHome)||await this.fileService.createFolder(d.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(d=>{const f=this.mapProfileToStorage.get(d.profile.id);f&&d.join(f.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const d=new S.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,t.once)(d.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),d}profileStorage(d){if((0,y.isProfileUsingDefaultStorage)(d))return this.applicationStorage;let f=this.mapProfileToStorage.get(d.id);if(!f){this.logService.trace(`StorageMainService: creating profile storage (${d.name})`),f=this.createProfileStorage(d),this.mapProfileToStorage.set(d.id,f);const a=this._register(f.onDidChangeStorage(i=>this._onDidChangeProfileStorage.fire({...i,storage:f,profile:d})));(0,t.once)(f.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${d.name})`),this.mapProfileToStorage.delete(d.id),a.dispose()})}return f}createProfileStorage(d){return this.shutdownReason===2?new S.InMemoryStorageMain(this.logService,this.fileService):new S.ProfileStorageMain(d,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(d){let f=this.mapWorkspaceToStorage.get(d.id);return f||(this.logService.trace(`StorageMainService: creating workspace storage (${d.id})`),f=this.createWorkspaceStorage(d),this.mapWorkspaceToStorage.set(d.id,f),(0,t.once)(f.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${d.id})`),this.mapWorkspaceToStorage.delete(d.id)})),f}createWorkspaceStorage(d){return this.shutdownReason===2?new S.InMemoryStorageMain(this.logService,this.fileService):new S.WorkspaceStorageMain(d,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(d){const f=w.URI.file(d);for(const a of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(!!a.path&&this.uriIdentityService.extUri.isEqualOrParent(w.URI.file(a.path),f))return!0;return!1}};C=ve([J(0,P.ILogService),J(1,M.IEnvironmentService),J(2,h.IUserDataProfilesMainService),J(3,m.ILifecycleMainService),J(4,E.IFileService),J(5,b.IUriIdentityService)],C),e.StorageMainService=C,e.IApplicationStorageMainService=(0,l.createDecorator)("applicationStorageMainService");let p=class extends y.AbstractStorageService{constructor(d,f){super(),this.userDataProfilesService=d,this.storageMainService=f,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(d){if(d===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(d){if(d===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};p=ve([J(0,g.IUserDataProfilesService),J(1,e.IStorageMainService)],p),e.ApplicationStorageMainService=p}),define(Z[259],ee([0,1,2,21,42]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends w.Disposable{constructor(E,l){super(),this.userDataProfilesService=l,this._register(E.onWillLoadWindow(m=>{m.reason===2&&this.unsetTransientProfileForWorkspace(m.window.openedWorkspace??"empty-window")})),this._register(E.onBeforeCloseWindow(m=>this.unsetTransientProfileForWorkspace(m.openedWorkspace??"empty-window")))}async unsetTransientProfileForWorkspace(E){this.userDataProfilesService.getOrSetProfileForWorkspace(E).isTransient&&(this.userDataProfilesService.unsetWorkspace(E,!0),await this.userDataProfilesService.cleanUpTransientProfiles())}};R=ve([J(0,t.ILifecycleMainService),J(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(Z[260],ee([0,1,3,2,90]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends t.Disposable{constructor(E,l,m){super(),this.storageMainService=E,this.userDataProfilesService=l,this.logService=m;const P=this._register(new t.MutableDisposable);this._onDidChange=this._register(new w.Emitter({onFirstListenerAdd:()=>P.value=this.registerStorageChangeListeners(),onLastListenerRemove:()=>P.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const E=new t.DisposableStore;return E.add(w.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(l,m)=>(l?l.push(m.key):l=[m.key],l),100)(l=>this.onDidChangeApplicationStorage(l))),E.add(w.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(l,m)=>{l||(l=new Map);let P=l.get(m.profile.id);return P||l.set(m.profile.id,P={profile:m.profile,keys:[],storage:m.storage}),P.keys.push(m.key),l},100)(l=>this.onDidChangeProfileStorage(l))),E}onDidChangeApplicationStorage(E){const l=E.includes(k.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],m=[];if(E=E.filter(P=>P!==k.TARGET_KEY),E.length){const P=(0,k.loadKeyTargets)(this.storageMainService.applicationStorage.storage);m.push({profile:this.userDataProfilesService.defaultProfile,changes:E.map(y=>({key:y,scope:0,target:P[y]}))})}this.triggerEvents(l,m)}onDidChangeProfileStorage(E){const l=[],m=new Map;for(const[P,y]of E.entries()){y.keys.includes(k.TARGET_KEY)&&l.push(y.profile);const S=y.keys.filter(g=>g!==k.TARGET_KEY);if(S.length){const g=(0,k.loadKeyTargets)(y.storage.storage);m.set(P,{profile:y.profile,changes:S.map(h=>({key:h,scope:0,target:g[h]}))})}}this.triggerEvents(l,[...m.values()])}triggerEvents(E,l){(E.length||l.length)&&this._onDidChange.fire({valueChanges:l,targetChanges:E})}listen(E,l,m){switch(l){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${l}`)}async call(E,l){throw new Error(`Call not found: ${l}`)}}e.ProfileStorageChangesListenerChannel=R}),define(Z[117],ee([0,1,16,7,27]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(l,m,P){for(const S of l){const g=S.openedWorkspace;if((0,k.isWorkspaceIdentifier)(g)){const h=await P(g);if(h){if(h.folders.some(b=>w.extUriBiasedIgnorePathCase.isEqualOrParent(m,b.uri)))return S}else if(w.extUriBiasedIgnorePathCase.isEqualOrParent(m,g.configPath))return S}}const y=l.filter(S=>(0,k.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqualOrParent(m,S.openedWorkspace.uri));if(y.length)return y.sort((S,g)=>-(S.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function M(l,m){for(const P of l)if((0,k.isWorkspaceIdentifier)(P.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(P.openedWorkspace.configPath,m)||(0,k.isSingleFolderWorkspaceIdentifier)(P.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(P.openedWorkspace.uri,m))return P}e.findWindowOnWorkspaceOrFolder=M;function E(l,m){const P=y=>m.some(S=>w.extUriBiasedIgnorePathCase.isEqual(t.URI.file(S),t.URI.file(y)));for(const y of l)if(y.config?.extensionDevelopmentPath?.some(S=>P(S)))return y}e.findWindowOnExtensionDevelopmentPath=E}),define(Z[261],ee([0,1,15,2,4,16,7,19,21,6,38,32,116,27]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let h=class Lt extends t.Disposable{constructor(f,a,i,o,n){super(),this.windowsMainService=f,this.stateMainService=a,this.lifecycleMainService=i,this.logService=o,this.configurationService=n,this._state=b(this.stateMainService.getItem(Lt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){w.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(f=>this.onBeforeCloseWindow(f)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(f=>{f.newCount-f.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(f=>this.onBeforeCloseWindow(f))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const f=new Set,a={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!a.lastActiveWindow){let n=this.windowsMainService.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),n&&(a.lastActiveWindow=this.toWindowState(n),a.lastActiveWindow.uiState.mode===3&&f.add(a.lastActiveWindow.uiState.display))}const i=this.windowsMainService.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);i&&(a.lastPluginDevelopmentHostWindow=this.toWindowState(i),a.lastPluginDevelopmentHostWindow.uiState.mode===3&&(f.has(a.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!i.win?.isSimpleFullScreen()&&(a.lastPluginDevelopmentHostWindow.uiState.mode=1):f.add(a.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(a.openedWindows=this.windowsMainService.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const r=this.toWindowState(n);return r.uiState.mode===3&&(f.has(r.uiState.display)?k.isMacintosh&&r.windowId!==a.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(r.uiState.mode=1):f.add(r.uiState.display)),r}));const o=p(a);this.stateMainService.setItem(Lt.windowsStateStorageKey,o),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",o)}onBeforeCloseWindow(f){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(f);f.isExtensionDevelopmentHost&&!f.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!f.isExtensionDevelopmentHost&&f.openedWorkspace&&this._state.openedWindows.forEach(i=>{const o=(0,g.isWorkspaceIdentifier)(f.openedWorkspace)&&i.workspace?.id===f.openedWorkspace.id,n=(0,g.isSingleFolderWorkspaceIdentifier)(f.openedWorkspace)&&i.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(i.folderUri,f.openedWorkspace.uri);(o||n)&&(i.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(f){return{windowId:f.id,workspace:(0,g.isWorkspaceIdentifier)(f.openedWorkspace)?f.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(f.openedWorkspace)?f.openedWorkspace.uri:void 0,backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.serializeWindowState()}}getNewWindowState(f){const a=this.doGetNewWindowState(f),i=this.configurationService.getValue("window");if(a.mode===3){let o;a.hasDefaultState?o=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):o=!!(this.lifecycleMainService.wasRestarted||i?.restoreFullscreen),o||(a.mode=1)}return a}doGetNewWindowState(f){const a=this.windowsMainService.getLastActiveWindow();if(!f.extensionTestsPath){if(!!f.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=f.workspace;if((0,g.isWorkspaceIdentifier)(c)){const I=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===c.id).map(D=>D.uiState);if(I.length)return I[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(c)){const I=this.state.openedWindows.filter(D=>D.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(D.folderUri,c.uri)).map(D=>D.uiState);if(I.length)return I[0]}else if(f.backupPath){const I=this.state.openedWindows.filter(D=>D.backupPath===f.backupPath).map(D=>D.uiState);if(I.length)return I[0]}const u=this.lastClosedState||this.state.lastActiveWindow;if(!a&&u)return u.uiState}let i;const o=w.screen.getAllDisplays();if(o.length===1)i=o[0];else{if(k.isMacintosh){const c=w.screen.getCursorScreenPoint();i=w.screen.getDisplayNearestPoint(c)}!i&&a&&(i=w.screen.getDisplayMatching(a.getBounds())),i||(i=w.screen.getPrimaryDisplay()||o[0])}let n=(0,S.defaultWindowState)();n.x=Math.round(i.bounds.x+i.bounds.width/2-n.width/2),n.y=Math.round(i.bounds.y+i.bounds.height/2-n.height/2);const r=this.configurationService.getValue("window");let s=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")n.mode=0,s=!1;else if(r.newWindowDimensions==="fullscreen")n.mode=3,s=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&a){const c=a.serializeWindowState();c.mode===3?n.mode=3:n=c,s=n.mode!==3&&r.newWindowDimensions==="offset"}}return s&&(n=this.ensureNoOverlap(n)),n.hasDefaultState=!0,n}ensureNoOverlap(f){if(this.windowsMainService.getWindows().length===0)return f;f.x=typeof f.x=="number"?f.x:0,f.y=typeof f.y=="number"?f.y:0;const a=this.windowsMainService.getWindows().map(i=>i.getBounds());for(;a.some(i=>i.x===f.x||i.y===f.y);)f.x+=30,f.y+=30;return f}};h.windowsStateStorageKey="windowsState",h=ve([J(0,y.IWindowsMainService),J(1,P.IStateMainService),J(2,l.ILifecycleMainService),J(3,m.ILogService),J(4,E.IConfigurationService)],h),e.WindowsStateHandler=h;function b(d){const f={openedWindows:[]},a=d||{openedWindows:[]};return a.lastActiveWindow&&(f.lastActiveWindow=C(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(f.lastPluginDevelopmentHostWindow=C(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(f.openedWindows=a.openedWindows.map(i=>C(i))),f}e.restoreWindowsState=b;function C(d){const f={uiState:d.uiState};return d.backupPath&&(f.backupPath=d.backupPath),d.remoteAuthority&&(f.remoteAuthority=d.remoteAuthority),d.folder&&(f.folderUri=M.URI.parse(d.folder)),d.workspaceIdentifier&&(f.workspace={id:d.workspaceIdentifier.id,configPath:M.URI.parse(d.workspaceIdentifier.configURIPath)}),f}function p(d){return{lastActiveWindow:d.lastActiveWindow&&v(d.lastActiveWindow),lastPluginDevelopmentHostWindow:d.lastPluginDevelopmentHostWindow&&v(d.lastPluginDevelopmentHostWindow),openedWindows:d.openedWindows.map(f=>v(f))}}e.getWindowsStateStoreData=p;function v(d){return{workspaceIdentifier:d.workspace&&{id:d.workspace.id,configURIPath:d.workspace.configPath.toString()},folder:d.folderUri&&d.folderUri.toString(),backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.uiState}}}),define(Z[92],ee([0,1,30,43,123,34,13,9,4,16,7,5,63,27]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,y.createDecorator)("workspacesService");function h(D){return D.hasOwnProperty("workspace")}e.isRecentWorkspace=h;function b(D){return D.hasOwnProperty("folderUri")}e.isRecentFolder=b;function C(D){return D.hasOwnProperty("fileUri")}e.isRecentFile=C;function p(D){return v(D)||d(D)}e.isStoredWorkspaceFolder=p;function v(D){const T=D;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function d(D){const T=D;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function f(D,T,N,U,$){if(D.scheme!==U.scheme)return{name:N,uri:D.toString(!0)};let Y=T?void 0:$.relativePath(U,D);if(Y!==void 0)Y.length===0?Y=".":l.isWindows&&(Y=a(Y));else if(D.scheme===M.Schemas.file)Y=D.fsPath,l.isWindows&&(Y=a(Y));else if($.isEqualAuthority(D.authority,U.authority))Y=D.path;else return{name:N,uri:D.toString(!0)};return{name:N,path:Y}}e.getStoredWorkspaceFolder=f;function a(D){return D=(0,R.normalizeDriveLetter)(D),(0,w.isUNC)(D)||(D=(0,w.toSlashes)(D)),D}function i(D,T,N){const U=[],$=new Set,Y=N.dirname(T);for(const oe of D){let ue;if(v(oe))oe.path&&(ue=N.resolvePath(Y,oe.path));else if(d(oe))try{ue=P.URI.parse(oe.uri),ue.path[0]!==E.posix.sep&&(ue=ue.with({path:E.posix.sep+ue.path}))}catch(se){console.warn(se)}if(ue){const se=N.getComparisonKey(ue);if(!$.has(se)){$.add(se);const he=oe.name||N.basenameOrAuthority(ue);U.push(new g.WorkspaceFolder({uri:ue,name:he,index:U.length},oe))}}}return U}e.toWorkspaceFolders=i;function o(D,T,N,U,$){const Y=n(T,D),oe=$.dirname(T),ue=$.dirname(U),se=[];for(const F of Y.folders){const A=v(F)?$.resolvePath(oe,F.path):P.URI.parse(F.uri);let W;N?W=!1:W=!v(F)||(0,E.isAbsolute)(F.path),se.push(f(A,W,F.name,ue,$))}const he={insertSpaces:!1,tabSize:4,eol:l.isLinux||l.isMacintosh?`
`:`\r
`},G=k.setProperty(D,["folders"],se,he);let K=k.applyEdits(D,G);return(0,m.isEqualAuthority)(Y.remoteAuthority,(0,S.getRemoteAuthority)(U))&&(K=k.applyEdits(K,k.removeProperty(K,["remoteAuthority"],he))),K}e.rewriteWorkspaceFileForNewLocation=o;function n(D,T){const N=t.parse(T);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(U=>p(U));else throw new Error(`${D} looks like an invalid workspace file.`);return N}function r(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function s(D){return typeof D.folderUri=="string"}function c(D){return typeof D.fileUri=="string"}function u(D,T){const N={workspaces:[],files:[]};if(D){const U=function(Y,oe){for(let ue=0;ue<Y.length;ue++)try{oe(Y[ue],ue)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(Y[ue])}: ${se.toString()}. Skip entry.`)}},$=D;Array.isArray($.entries)&&U($.entries,Y=>{const oe=Y.label,ue=Y.remoteAuthority;r(Y)?N.workspaces.push({label:oe,remoteAuthority:ue,workspace:{id:Y.workspace.id,configPath:P.URI.parse(Y.workspace.configPath)}}):s(Y)?N.workspaces.push({label:oe,remoteAuthority:ue,folderUri:P.URI.parse(Y.folderUri)}):c(Y)&&N.files.push({label:oe,remoteAuthority:ue,fileUri:P.URI.parse(Y.fileUri)})})}return N}e.restoreRecentlyOpened=u;function I(D){const T={entries:[]};for(const N of D.workspaces)b(N)?T.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):T.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of D.files)T.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return T}e.toStoreData=I}),define(Z[93],ee([0,1,76,13,4,16]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function M(m){function P(){let y=m.scheme===t.Schemas.file?(0,R.originalFSPath)(m):m.toString();return k.isLinux||(y=y.toLowerCase()),(0,w.createHash)("md5").update(y).digest("hex")}return{id:P(),configPath:m}}e.getWorkspaceIdentifier=M;function E(m,P){function y(){if(m.scheme!==t.Schemas.file)return(0,w.createHash)("md5").update(m.toString()).digest("hex");if(!P)return;let g;return k.isLinux?g=P.ino:k.isMacintosh?g=P.birthtime.getTime():k.isWindows&&(typeof P.birthtimeMs=="number"?g=Math.floor(P.birthtimeMs):g=P.birthtime.getTime()),(0,w.createHash)("md5").update(m.fsPath).update(g?String(g):"").digest("hex")}const S=y();if(typeof S=="string")return{id:S,uri:m}}e.getSingleFolderWorkspaceIdentifier=E;function l(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=l}),define(Z[262],ee([0,1,76,30,13,9,4,16,23,177,19,26,38,14,6,176,27,93]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class At{constructor(f,a,i,o){this.environmentMainService=f,this.configurationService=a,this.logService=i,this.stateMainService=o,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=E.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(n,r)=>(0,t.isEqual)(n,r,!M.isLinux)}}async initialize(){const f=await this.initializeAndMigrateBackupWorkspacesMetadata();this.emptyWindows=await this.validateEmptyWorkspaces(f.emptyWindows),this.workspaces=await this.validateWorkspaces((0,m.deserializeWorkspaceInfos)(f)),this.folders=await this.validateFolders((0,m.deserializeFolderInfos)(f)),this.storeWorkspacesMetadata()}async initializeAndMigrateBackupWorkspacesMetadata(){let f=this.stateMainService.getItem(At.backupWorkspacesMetadataStorageKey);if(!f)try{const a=(0,R.join)(this.backupHome,"workspaces.json"),i=await l.Promises.readFile(a,"utf8");try{await l.Promises.unlink(a)}catch{}const o=JSON.parse(i);f={workspaces:Array.isArray(o.rootURIWorkspaces)?o.rootURIWorkspaces:[],folders:Array.isArray(o.folderWorkspaceInfos)?o.folderWorkspaceInfos:[],emptyWindows:Array.isArray(o.emptyWorkspaceInfos)?o.emptyWorkspaceInfos:[]}}catch(a){a.code!=="ENOENT"&&this.logService.error(`Backup: Could not migrate legacy backup workspaces metadata: ${a.toString()}`)}return f??{workspaces:[],folders:[],emptyWindows:[]}}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==g.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===g.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||g.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(f,a){this.workspaces.some(o=>f.workspace.id===o.workspace.id)||(this.workspaces.push(f),this.storeWorkspacesMetadata());const i=(0,R.join)(this.backupHome,f.workspace.id);return a?this.moveBackupFolder(i,a).then(()=>i):i}async moveBackupFolder(f,a){if(await l.Promises.exists(f)&&await this.convertToEmptyWindowBackup(f),await l.Promises.exists(a))try{await l.Promises.rename(a,f)}catch(i){this.logService.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(f){return this.folders.some(a=>this.backupUriComparer.isEqual(f.folderUri,a.folderUri))||(this.folders.push(f),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,this.getFolderHash(f))}registerEmptyWindowBackup(f){return this.emptyWindows.some(a=>!!a.backupFolder&&this.backupPathComparer.isEqual(a.backupFolder,f.backupFolder))||(this.emptyWindows.push(f),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,f.backupFolder)}async validateWorkspaces(f){if(!Array.isArray(f))return[];const a=new Set,i=[];for(const o of f){const n=o.workspace;if(!(0,C.isWorkspaceIdentifier)(n))return[];if(!a.has(n.id)){a.add(n.id);const r=(0,R.join)(this.backupHome,n.id);await this.doHasBackups(r)?n.configPath.scheme!==k.Schemas.file||await l.Promises.exists(n.configPath.fsPath)?i.push(o):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return i}async validateFolders(f){if(!Array.isArray(f))return[];const a=[],i=new Set;for(const o of f){const n=o.folderUri,r=this.backupUriComparer.getComparisonKey(n);if(!i.has(r)){i.add(r);const s=(0,R.join)(this.backupHome,this.getFolderHash(o));await this.doHasBackups(s)?n.scheme!==k.Schemas.file||await l.Promises.exists(n.fsPath)?a.push(o):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return a}async validateEmptyWorkspaces(f){if(!Array.isArray(f))return[];const a=[],i=new Set;for(const o of f){const n=o.backupFolder;if(typeof n!="string")return[];if(!i.has(n)){i.add(n);const r=(0,R.join)(this.backupHome,n);await this.doHasBackups(r)?a.push(o):await this.deleteStaleBackup(r)}}return a}async deleteStaleBackup(f){try{await l.Promises.rm(f,l.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}prepareNewEmptyWindowBackup(){let f=(0,p.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(a=>!!a.backupFolder&&this.backupPathComparer.isEqual(a.backupFolder,f.id));)f=(0,p.createEmptyWorkspaceIdentifier)();return{backupFolder:f.id}}async convertToEmptyWindowBackup(f){const a=this.prepareNewEmptyWindowBackup(),i=(0,R.join)(this.backupHome,a.backupFolder);try{await l.Promises.rename(f,i)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push(a),!0}async getDirtyWorkspaces(){const f=[];for(const a of this.workspaces)await this.hasBackups(a)&&f.push(a);for(const a of this.folders)await this.hasBackups(a)&&f.push(a);return f}hasBackups(f){let a;return(0,m.isEmptyWindowBackupInfo)(f)?a=(0,R.join)(this.backupHome,f.backupFolder):(0,b.isFolderBackupInfo)(f)?a=(0,R.join)(this.backupHome,this.getFolderHash(f)):a=(0,R.join)(this.backupHome,f.workspace.id),this.doHasBackups(a)}async doHasBackups(f){try{const a=await l.Promises.readdir(f);for(const i of a)try{if((await l.Promises.readdir((0,R.join)(f,i))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const f={workspaces:this.workspaces.map(({workspace:a,remoteAuthority:i})=>{const o={id:a.id,configURIPath:a.configPath.toString()};return i&&(o.remoteAuthority=i),o}),folders:this.folders.map(({folderUri:a,remoteAuthority:i})=>{const o={folderUri:a.toString()};return i&&(o.remoteAuthority=i),o}),emptyWindows:this.emptyWindows.map(({backupFolder:a,remoteAuthority:i})=>{const o={backupFolder:a};return i&&(o.remoteAuthority=i),o})};this.stateMainService.setItem(At.backupWorkspacesMetadataStorageKey,f)}getFolderHash(f){const a=f.folderUri;let i;return a.scheme===k.Schemas.file?i=M.isLinux?a.fsPath:a.fsPath.toLowerCase():i=a.toString().toLowerCase(),(0,w.createHash)("md5").update(i).digest("hex")}};v.backupWorkspacesMetadataStorageKey="backupWorkspaces",v=ve([J(0,y.IEnvironmentMainService),J(1,P.IConfigurationService),J(2,h.ILogService),J(3,S.IStateMainService)],v),e.BackupMainService=v}),define(Z[52],ee([0,1,15,3,43,34,2,13,9,16,12,23,175,60,56,26,5,6,20,42,117,27,92,93]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p,v,d,f,a,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,C.createDecorator)("workspacesManagementMainService");let n=class extends M.Disposable{constructor(s,c,u,I,D,T){super(),this.environmentMainService=s,this.logService=c,this.userDataProfilesMainService=u,this.backupMainService=I,this.dialogMainService=D,this.productService=T,this._onDidDeleteUntitledWorkspace=this._register(new t.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new t.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const s=(await y.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(c=>(0,m.joinPath)(this.untitledWorkspacesHome,c,a.UNTITLED_WORKSPACE_NAME));for(const c of s){const u=(0,o.getWorkspaceIdentifier)(c),I=await this.resolveLocalWorkspace(c);I?this.untitledWorkspaces.push({workspace:u,remoteAuthority:I.remoteAuthority}):await this.deleteUntitledWorkspace(u)}}catch(s){s.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${s}).`)}}resolveLocalWorkspace(s){return this.doResolveLocalWorkspace(s,c=>y.Promises.readFile(c,"utf8"))}doResolveLocalWorkspace(s,c){if(!!this.isWorkspacePath(s)&&s.scheme===E.Schemas.file)try{const u=c(s.fsPath);return u instanceof Promise?u.then(I=>this.doResolveWorkspace(s,I),I=>{}):this.doResolveWorkspace(s,u)}catch{return}}isWorkspacePath(s){return(0,a.isUntitledWorkspace)(s,this.environmentMainService)||(0,a.hasWorkspaceFileExtension)(s)}doResolveWorkspace(s,c){try{const u=this.doParseStoredWorkspace(s,c),I=(0,o.getWorkspaceIdentifier)(s);return{id:I.id,configPath:I.configPath,folders:(0,i.toWorkspaceFolders)(u.folders,I.configPath,m.extUriBiasedIgnorePathCase),remoteAuthority:u.remoteAuthority,transient:u.transient}}catch(u){this.logService.warn(u.toString())}}doParseStoredWorkspace(s,c){const u=(0,k.parse)(c);if(u&&Array.isArray(u.folders))u.folders=u.folders.filter(I=>(0,i.isStoredWorkspaceFolder)(I));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return u}async createUntitledWorkspace(s,c){const{workspace:u,storedWorkspace:I}=this.newUntitledWorkspace(s,c),D=u.configPath.fsPath;return await y.Promises.mkdir((0,l.dirname)(D),{recursive:!0}),await y.Promises.writeFile(D,JSON.stringify(I,null,"	")),this.untitledWorkspaces.push({workspace:u,remoteAuthority:c}),u}newUntitledWorkspace(s=[],c){const u=(Date.now()+Math.round(Math.random()*1e3)).toString(),I=(0,m.joinPath)(this.untitledWorkspacesHome,u),D=(0,m.joinPath)(I,a.UNTITLED_WORKSPACE_NAME),T=[];for(const N of s)T.push((0,i.getStoredWorkspaceFolder)(N.uri,!0,N.name,I,m.extUriBiasedIgnorePathCase));return{workspace:(0,o.getWorkspaceIdentifier)(D),storedWorkspace:{folders:T,remoteAuthority:c}}}async getWorkspaceIdentifier(s){return(0,o.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,a.isUntitledWorkspace)(s.configPath,this.environmentMainService)}async deleteUntitledWorkspace(s){!this.isUntitledWorkspace(s)||(await this.doDeleteUntitledWorkspace(s),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(s),this._onDidDeleteUntitledWorkspace.fire(s))}async doDeleteUntitledWorkspace(s){const c=(0,m.originalFSPath)(s.configPath);try{await y.Promises.rm((0,l.dirname)(c));const u=(0,l.join)(this.environmentMainService.workspaceStorageHome.fsPath,s.id);await y.Promises.exists(u)&&await y.Promises.writeFile((0,l.join)(u,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(I=>I.workspace.id!==s.id)}catch(u){this.logService.warn(`Unable to delete untitled workspace ${c} (${u}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(s,c,u){if(!s||!s.win||!s.isReady||!await this.isValidTargetWorkspacePath(s,c,u))return;const D=await this.doEnterWorkspace(s,(0,o.getWorkspaceIdentifier)(u));if(!!D)return this._onDidEnterWorkspace.fire({window:s,workspace:D.workspace}),D}async isValidTargetWorkspacePath(s,c,u){if(!u)return!0;if((0,a.isWorkspaceIdentifier)(s.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,u))return!1;if((0,f.findWindowOnWorkspaceOrFolder)(c,u)){const I={title:this.productService.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,S.localize)(0,null))],message:(0,S.localize)(1,null,(0,m.basename)(u)),detail:(0,S.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(I,(0,P.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow())),!1}return!0}async doEnterWorkspace(s,c){if(!s.config)return;s.focus();let u;return s.config.extensionDevelopmentPath||(s.config.backupPath?u=await this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:s.remoteAuthority},s.config.backupPath):u=this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:s.remoteAuthority})),(0,a.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=c,s.config.backupPath=u,{workspace:c,backupPath:u}}};n=ve([J(0,b.IEnvironmentMainService),J(1,p.ILogService),J(2,d.IUserDataProfilesMainService),J(3,g.IBackupMainService),J(4,h.IDialogMainService),J(5,v.IProductService)],n),e.WorkspacesManagementMainService=n}),define(Z[118],ee([0,1,15,41,22,5,32,27,52,12,6]),function(q,e,w,t,k,R,M,E,l,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let y=class{constructor(g,h,b){this.windowsMainService=g,this.workspacesManagementMainService=h,this.logService=b}async getRemoteDiagnostics(g){const h=this.windowsMainService.getWindows();return(await Promise.all(h.map(async C=>{const p=C.remoteAuthority;if(!p)return;const v=`vscode:getDiagnosticInfoResponse${C.id}`,d={includeProcesses:g.includeProcesses,folders:g.includeWorkspaceMetadata?await this.getFolderURIs(C):void 0};return new Promise(f=>{C.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:v,args:d}),t.validatedIpcMain.once(v,(a,i)=>{i||f({hostName:p,errorMessage:`Unable to resolve connection to '${p}'.`}),f(i)}),setTimeout(()=>{f({hostName:p,errorMessage:`Connection to '${p}' could not be established`})},5e3)})}))).filter(C=>!!C)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const g=[];for(const h of w.BrowserWindow.getAllWindows()){const b=this.windowsMainService.getWindowById(h.id);b?g.push(await this.codeWindowToInfo(b)):g.push(this.browserWindowToInfo(h))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:g,screenReader:!!w.app.accessibilitySupportEnabled,gpuFeatureStatus:w.app.getGPUFeatureStatus()}}async codeWindowToInfo(g){const h=await this.getFolderURIs(g),b=(0,m.assertIsDefined)(g.win);return this.browserWindowToInfo(b,h,g.remoteAuthority)}browserWindowToInfo(g,h=[],b){return{pid:g.webContents.getOSProcessId(),title:g.getTitle(),folderURIs:h,remoteAuthority:b}}async getFolderURIs(g){const h=[],b=g.openedWorkspace;if((0,E.isSingleFolderWorkspaceIdentifier)(b))h.push(b.uri);else if((0,E.isWorkspaceIdentifier)(b)){const C=await this.workspacesManagementMainService.resolveLocalWorkspace(b.configPath);C&&C.folders.forEach(v=>{h.push(v.uri)})}return h}};y=ve([J(0,M.IWindowsMainService),J(1,l.IWorkspacesManagementMainService),J(2,P.ILogService)],y),e.DiagnosticsMainService=y}),define(Z[65],ee([0,1,45,15,28,141,53,3,34,2,13,9,4,7,98,81,23,94,165,56,26,5,21,6,20,64,32,27,52,18,220]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p,v,d,f,a,i,o,n,r,s,c,u,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let T=class extends m.Disposable{constructor(U,$,Y,oe,ue,se,he,G,K){super(),this.sharedProcess=U,this.windowsMainService=$,this.dialogMainService=Y,this.lifecycleMainService=oe,this.environmentMainService=ue,this.logService=se,this.productService=he,this.themeMainService=G,this.workspacesManagementMainService=K,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,F=>F.id),this.onDidTriggerSystemContextMenu=E.Event.filter(E.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:F,x:A,y:W})=>({windowId:F.id,x:A,y:W})),({windowId:F})=>!!this.windowsMainService.getWindowById(F)),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(F,A)=>A.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(F,A)=>A.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(F,A)=>A.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),F=>!!F),F=>F.id),E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(F,A)=>A.id),F=>!!this.windowsMainService.getWindowById(F))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(F,A,W)=>W),F=>!(Array.isArray(F)&&F.length===1&&F[0]==="workArea")),E.Event.fromNodeEventEmitter(t.screen,"display-added"),E.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map($=>({id:$.id,workspace:$.openedWorkspace??(0,c.toWorkspaceIdentifier)($.backupPath,$.isExtensionDevelopmentHost),title:$.win?.getTitle()??"",filename:$.getRepresentedFilename(),dirty:$.isDocumentEdited()}))}async getWindowCount(U){return this.windowsMainService.getWindowCount()}async getActiveWindowId(U){const $=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if($)return $.id}openWindow(U,$,Y){return Array.isArray($)?this.doOpenWindow(U,$,Y):this.doOpenEmptyWindow(U,$)}async doOpenWindow(U,$,Y=Object.create(null)){$.length>0&&await this.windowsMainService.open({context:5,contextWindowId:U,urisToOpen:$,cli:this.environmentMainService.args,forceNewWindow:Y.forceNewWindow,forceReuseWindow:Y.forceReuseWindow,preferNewWindow:Y.preferNewWindow,diffMode:Y.diffMode,mergeMode:Y.mergeMode,addMode:Y.addMode,gotoLineMode:Y.gotoLineMode,noRecentEntry:Y.noRecentEntry,waitMarkerFileURI:Y.waitMarkerFileURI,remoteAuthority:Y.remoteAuthority||void 0})}async doOpenEmptyWindow(U,$){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:U},$)}async toggleFullScreen(U){this.windowById(U)?.toggleFullScreen()}async handleTitleDoubleClick(U){this.windowById(U)?.handleTitleDoubleClick()}async isMaximized(U){const $=this.windowById(U);return $?.win?$.win.isMaximized():!1}async maximizeWindow(U){const $=this.windowById(U);$?.win&&$.win.maximize()}async unmaximizeWindow(U){const $=this.windowById(U);$?.win&&$.win.unmaximize()}async minimizeWindow(U){const $=this.windowById(U);$?.win&&$.win.minimize()}async updateWindowControls(U,$){const Y=this.windowById(U);Y&&Y.updateWindowControls($)}async focusWindow(U,$){$&&typeof $.windowId=="number"&&(U=$.windowId),this.windowById(U)?.focus({force:$?.force??!1})}async setMinimumSize(U,$,Y){const oe=this.windowById(U);if(oe?.win){const[ue,se]=oe.win.getSize(),[he,G]=oe.win.getMinimumSize(),[K,F]=[$??he,Y??G],[A,W]=[Math.max(ue,K),Math.max(se,F)];(he!==K||G!==F)&&oe.win.setMinimumSize(K,F),(ue!==A||se!==W)&&oe.win.setSize(A,W)}}async saveWindowSplash(U,$){this.themeMainService.saveWindowSplash(U,$)}async installShellCommand(U){const{source:$,target:Y}=await this.getShellCommandLink();try{const{symbolicLink:oe}=await C.SymlinkSupport.stat($);if(oe&&!oe.dangling){const ue=await(0,h.realpath)($);if(Y===ue)return}await C.Promises.unlink($)}catch(oe){if(oe.code!=="ENOENT")throw oe}try{await C.Promises.symlink(Y,$)}catch(oe){if(oe.code!=="EACCES"&&oe.code!=="ENOENT")throw oe;const{response:ue}=await this.showMessageBox(U,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,l.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,l.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ue===0)try{const se=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Y}' '${$}'\\" with administrator privileges"`;await(0,R.promisify)(w.exec)(se)}catch{throw new Error((0,v.localize)(3,null,$))}}}async uninstallShellCommand(U){const{source:$}=await this.getShellCommandLink();try{await C.Promises.unlink($)}catch(Y){switch(Y.code){case"EACCES":{const{response:oe}=await this.showMessageBox(U,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,l.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,l.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(oe===0)try{const ue=`osascript -e "do shell script \\"rm '${$}'\\" with administrator privileges"`;await(0,R.promisify)(w.exec)(ue)}catch{throw new Error((0,v.localize)(7,null,$))}break}case"ENOENT":break;default:throw Y}}}async getShellCommandLink(){const U=(0,y.resolve)(this.environmentMainService.appRoot,"bin","code"),$=`/usr/local/bin/${this.productService.applicationName}`;if(!await C.Promises.exists(U))throw new Error((0,v.localize)(8,null,U));return{source:$,target:U}}async showMessageBox(U,$){return this.dialogMainService.showMessageBox($,this.toBrowserWindow(U))}async showSaveDialog(U,$){return this.dialogMainService.showSaveDialog($,this.toBrowserWindow(U))}async showOpenDialog(U,$){return this.dialogMainService.showOpenDialog($,this.toBrowserWindow(U))}toBrowserWindow(U){const $=this.windowById(U);if($?.win)return $.win}async pickFileFolderAndOpen(U,$){const Y=await this.dialogMainService.pickFileFolder($);Y&&await this.doOpenPicked(await Promise.all(Y.map(async oe=>await C.SymlinkSupport.existsDirectory(oe)?{folderUri:g.URI.file(oe)}:{fileUri:g.URI.file(oe)})),$,U)}async pickFolderAndOpen(U,$){const Y=await this.dialogMainService.pickFolder($);Y&&await this.doOpenPicked(Y.map(oe=>({folderUri:g.URI.file(oe)})),$,U)}async pickFileAndOpen(U,$){const Y=await this.dialogMainService.pickFile($);Y&&await this.doOpenPicked(Y.map(oe=>({fileUri:g.URI.file(oe)})),$,U)}async pickWorkspaceAndOpen(U,$){const Y=await this.dialogMainService.pickWorkspace($);Y&&await this.doOpenPicked(Y.map(oe=>({workspaceUri:g.URI.file(oe)})),$,U)}async doOpenPicked(U,$,Y){await this.windowsMainService.open({context:3,contextWindowId:Y,cli:this.environmentMainService.args,urisToOpen:U,forceNewWindow:$.forceNewWindow})}async showItemInFolder(U,$){t.shell.showItemInFolder($)}async setRepresentedFilename(U,$){this.windowById(U)?.setRepresentedFilename($)}async setDocumentEdited(U,$){this.windowById(U)?.setDocumentEdited($)}async openExternal(U,$){return S.isLinuxSnap?this.safeSnapOpenExternal($):t.shell.openExternal($),!0}safeSnapOpenExternal(U){const $=process.env.GDK_PIXBUF_MODULE_FILE,Y=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(U),process.env.GDK_PIXBUF_MODULE_FILE=$,process.env.GDK_PIXBUF_MODULEDIR=Y}moveItemToTrash(U,$){return t.shell.trashItem($)}async isAdmin(){let U;return S.isWindows?U=(await new Promise(($,Y)=>{q(["native-is-elevated"],$,Y)}))():U=process.getuid()===0,U}async writeElevated(U,$,Y,oe){const ue=await new Promise((se,he)=>{q(["@vscode/sudo-prompt"],se,he)});return new Promise((se,he)=>{const G=[`"${this.cliPath}"`];oe?.unlock&&G.push("--file-chmod"),G.push("--file-write",`"${$.fsPath}"`,`"${Y.fsPath}"`);const K={name:this.productService.nameLong.replace("-",""),icns:S.isMacintosh&&this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ue.exec(G.join(" "),K,(F,A,W)=>{A&&this.logService.trace(`[sudo-prompt] received stdout: ${A}`),W&&this.logService.trace(`[sudo-prompt] received stderr: ${W}`),F?he(F):se(void 0)})})}get cliPath(){return S.isWindows?this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):S.isLinux?this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,y.join)(this.environmentMainService.appRoot,"bin","code"):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return b.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return S.isWindows&&(0,D.hasWSLFeatureInstalled)()}async killProcess(U,$,Y){process.kill($,Y)}async readClipboardText(U,$){return t.clipboard.readText($)}async writeClipboardText(U,$,Y){return t.clipboard.writeText($,Y)}async readClipboardFindText(U){return t.clipboard.readFindText()}async writeClipboardFindText(U,$){return t.clipboard.writeFindText($)}async writeClipboardBuffer(U,$,Y,oe){return t.clipboard.writeBuffer($,Buffer.from(Y.buffer),oe)}async readClipboardBuffer(U,$){return I.VSBuffer.wrap(t.clipboard.readBuffer($))}async hasClipboard(U,$,Y){return t.clipboard.has($,Y)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(U,$){this.windowById(U)?.updateTouchBar($)}async notifyReady(U){this.windowById(U)?.setReady()}async relaunch(U,$){return this.lifecycleMainService.relaunch($)}async reload(U,$){const Y=this.windowById(U);if(Y){if((0,c.isWorkspaceIdentifier)(Y.openedWorkspace)){const oe=Y.openedWorkspace.configPath;if(oe.scheme===P.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(oe))?.transient)return this.openWindow(Y.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(Y,$?.disableExtensions!==void 0?{_:[],"disable-extensions":$.disableExtensions}:void 0)}}async closeWindow(U){this.closeWindowById(U,U)}async closeWindowById(U,$){const Y=this.windowById($);if(Y?.win)return Y.win.close()}async quit(U){const $=this.windowsMainService.getLastActiveWindow();$?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&$.win?$.win.close():this.lifecycleMainService.quit()}async exit(U,$){await this.lifecycleMainService.kill($)}async resolveProxy(U,$){const oe=this.windowById(U)?.win?.webContents?.session;if(oe)return oe.resolveProxy($)}findFreePort(U,$,Y,oe,ue=1){return(0,p.findFreePort)($,Y,oe,ue)}async openDevTools(U,$){const Y=this.windowById(U);Y?.win&&Y.win.webContents.openDevTools($)}async toggleDevTools(U){const $=this.windowById(U);$?.win&&$.win.webContents.toggleDevTools()}async sendInputEvent(U,$){const Y=this.windowById(U);Y?.win&&($.type==="mouseDown"||$.type==="mouseUp")&&Y.win.webContents.sendInputEvent($)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(U,$,Y,oe){if(!S.isWindows)return;const ue=await new Promise((se,he)=>{q(["@vscode/windows-registry"],se,he)});try{return ue.GetStringRegKey($,Y,oe)}catch{return}}windowById(U){if(typeof U=="number")return this.windowsMainService.getWindowById(U)}};ve([M.memoize],T.prototype,"cliPath",null),T=ve([J(1,s.IWindowsMainService),J(2,d.IDialogMainService),J(3,i.ILifecycleMainService),J(4,f.IEnvironmentMainService),J(5,o.ILogService),J(6,n.IProductService),J(7,r.IThemeMainService),J(8,u.IWorkspacesManagementMainService)],T),e.NativeHostMainService=T}),define(Z[263],ee([0,1,15,41,28,34,2,13,4,99,163,84,118,56,26,5,6,65,54,20,61,74,30,12]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p,v,d,f,a,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,b.createDecorator)("issueMainService");let n=class _t{constructor(s,c,u,I,D,T,N,U,$){this.userEnv=s,this.environmentMainService=c,this.logService=u,this.diagnosticsService=I,this.diagnosticsMainService=D,this.dialogMainService=T,this.nativeHostMainService=N,this.protocolMainService=U,this.productService=$,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[c,u]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),I=await this.diagnosticsService.getSystemInfo(c,u);this.safeSend(s,"vscode:issueSystemInfoResponse",I)}),t.validatedIpcMain.on("vscode:listProcesses",async s=>{const c=[];try{c.push({name:(0,P.localize)(0,null),rootProcess:await(0,m.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(I=>{(0,y.isRemoteDiagnosticError)(I)?c.push({name:I.hostName,rootProcess:I}):I.processes&&c.push({name:I.hostName,rootProcess:I.processes})})}catch(u){this.logService.error(`Listing processes failed: ${u}`)}this.safeSend(s,"vscode:listProcessesResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{const c={title:this.productService.nameLong,message:(0,P.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,P.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,P.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const u=await this.dialogMainService.showMessageBox(c,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",u.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const c=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,P.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,P.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,P.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(s,c)=>{const{id:u,from:I,args:D}=c;let T;switch(I){case"issueReporter":T=this.issueReporterParentWindow;break;case"processExplorer":T=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${I}`)}T?.webContents.send("vscode:runAction",{id:u,from:I,args:D})}),t.validatedIpcMain.on("vscode:openExternal",(s,c)=>{this.nativeHostMainService.openExternal(void 0,c)}),t.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const c=await this.diagnosticsMainService.getMainDiagnostics();this.safeSend(s,"vscode:windowsInfoResponse",c.windows)})}safeSend(s,c,...u){s.sender.isDestroyed()||s.sender.send(c,...u)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=w.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const c=new M.DisposableStore,u=c.add(this.protocolMainService.createIPCObjectUrl()),I=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(I,u,{backgroundColor:s.styles.backgroundColor,title:(0,P.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),u.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:v.default}),this.issueReporterWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",q).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,c.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,c.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=w.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const c=new M.DisposableStore,u=c.add(this.protocolMainService.createIPCObjectUrl()),I=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(I,u,{backgroundColor:s.styles.backgroundColor,title:(0,P.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),u.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:v.default}),this.processExplorerWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",q).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,c.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,c.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,c,u,I){const D=new w.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:u.title,backgroundColor:u.backgroundColor||_t.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,`--vscode-window-kind=${I}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,a.zoomLevelToZoomFactor)(u.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:u.alwaysOnTop,experimentalDarkMode:!0});return D.setMenuBarVisibility(!1),D}async getSystemStatus(){const[s,c]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,c)}getWindowPosition(s,c,u){let I;const D=w.screen.getAllDisplays();if(D.length===1)I=D[0];else{if(l.isMacintosh){const U=w.screen.getCursorScreenPoint();I=w.screen.getDisplayNearestPoint(U)}!I&&s&&(I=w.screen.getDisplayMatching(s.getBounds())),I||(I=w.screen.getPrimaryDisplay()||D[0])}const T={width:c,height:u},N=I.bounds;return T.x=N.x+N.width/2-T.width/2,T.y=N.y+N.height/2-T.height/2,N.width>0&&N.height>0&&(T.x<N.x&&(T.x=N.x),T.y<N.y&&(T.y=N.y),T.x>N.x+N.width&&(T.x=N.x),T.y>N.y+N.height&&(T.y=N.y),T.width>N.width&&(T.width=N.width),T.height>N.height&&(T.height=N.height)),T}async getPerformanceInfo(){try{const[s,c]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,c)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}async stopTracing(){if(!this.environmentMainService.args.trace)return;const s=await w.contentTracing.stopRecording(`${(0,i.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,P.localize)(9,null),detail:(0,P.localize)(10,null,s),buttons:[(0,R.mnemonicButtonLabel)((0,P.localize)(11,null))],defaultId:0,noLink:!0},(0,o.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,s)}};n.DEFAULT_BACKGROUND_COLOR="#1E1E1E",n=ve([J(1,h.IEnvironmentMainService),J(2,C.ILogService),J(3,y.IDiagnosticsService),J(4,S.IDiagnosticsMainService),J(5,g.IDialogMainService),J(6,p.INativeHostMainService),J(7,f.IProtocolMainService),J(8,d.IProductService)],n),e.IssueMainService=n}),define(Z[264],ee([0,1,22,19,26,21,6,65,20,55,36,48,88]),function(q,e,w,t,k,R,M,E,l,m,P,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let g=class extends S.AbstractUpdateService{constructor(b,C,p,v,d,f,a,i){super(b,C,v,d,f,i),this.telemetryService=p,this.nativeHostMainService=a}buildUpdateFeedUrl(b){return(0,S.createUpdateURL)(`linux-${process.arch}`,b,this.productService)}doCheckForUpdates(b){!this.url||(this.setState(y.State.CheckingForUpdates(b)),this.requestService.request({url:this.url},w.CancellationToken.None).then(m.asJson).then(C=>{!C||!C.url||!C.version||!C.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!b}),this.setState(y.State.Idle(1))):this.setState(y.State.AvailableForDownload(C))}).then(void 0,C=>{this.logService.error(C),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!b});const p=b?C.message||C:void 0;this.setState(y.State.Idle(1,p))}))}async doDownloadUpdate(b){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):b.update.url&&this.nativeHostMainService.openExternal(void 0,b.update.url),this.setState(y.State.Idle(1))}};g=ve([J(0,R.ILifecycleMainService),J(1,t.IConfigurationService),J(2,P.ITelemetryService),J(3,k.IEnvironmentMainService),J(4,m.IRequestService),J(5,M.ILogService),J(6,E.INativeHostMainService),J(7,l.IProductService)],g),e.LinuxUpdateService=g}),define(Z[265],ee([0,1,45,40,28,8,22,53,9,7,127,23,19,26,14,21,6,65,20,55,36,48,88]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p,v,d,f,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function o(c,u=1e3){for(;!c();)await(0,R.timeout)(u)}let n;function r(){return typeof n>"u"&&(n=t.existsSync(l.join(l.dirname(process.execPath),"unins000.exe"))?0:1),n}let s=class extends i.AbstractUpdateService{constructor(u,I,D,T,N,U,$,Y,oe){super(u,I,T,N,U,oe),this.telemetryService=D,this.fileService=$,this.nativeHostMainService=Y}get cachePath(){const u=l.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return y.Promises.mkdir(u,{recursive:!0}).then(()=>u)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(u){let I="win32";return process.arch!=="ia32"&&(I+=`-${process.arch}`),r()===1?I+="-archive":this.productService.target==="user"&&(I+="-user"),(0,i.createUpdateURL)(I,u,this.productService)}doCheckForUpdates(u){!this.url||(this.setState(a.State.CheckingForUpdates(u)),this.requestService.request({url:this.url},M.CancellationToken.None).then(d.asJson).then(I=>{const D=r();return!I||!I.url||!I.version||!I.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!u}),this.setState(a.State.Idle(D)),Promise.resolve(null)):D===1?(this.setState(a.State.AvailableForDownload(I)),Promise.resolve(null)):(this.setState(a.State.Downloading(I)),this.cleanup(I.version).then(()=>this.getUpdatePackagePath(I.version).then(T=>y.Promises.exists(T).then(N=>{if(N)return Promise.resolve(T);const U=I.url,$=I.hash,Y=`${T}.tmp`;return this.requestService.request({url:U},M.CancellationToken.None).then(oe=>this.fileService.writeFile(m.URI.file(Y),oe.stream)).then($?()=>(0,P.checksum)(Y,I.hash):()=>{}).then(()=>y.Promises.rename(Y,T)).then(()=>T)})).then(T=>{const N=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},N&&I.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(a.State.Downloaded(I)):this.setState(a.State.Ready(I))})))}).then(void 0,I=>{this.logService.error(I),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!u});const D=u?I.message||I:void 0;this.setState(a.State.Idle(r(),D))}))}async doDownloadUpdate(u){u.update.url&&this.nativeHostMainService.openExternal(void 0,u.update.url),this.setState(a.State.Idle(r()))}async getUpdatePackagePath(u){const I=await this.cachePath;return l.join(I,`CodeSetup-${this.productService.quality}-${u}.exe`)}async cleanup(u=null){const I=u?U=>!new RegExp(`${this.productService.quality}-${u}\\.exe$`).test(U):()=>!0,D=await this.cachePath,N=(await y.Promises.readdir(D)).filter(I).map(async U=>{try{await y.Promises.unlink(l.join(D,U))}catch{}});await Promise.all(N)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const u=this.state.update;this.setState(a.State.Updating(u));const I=await this.cachePath;this.availableUpdate.updateFilePath=l.join(I,`CodeSetup-${this.productService.quality}-${u.version}.flag`),await y.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,w.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(a.State.Idle(r()))});const T=`${this.productService.win32MutexName}-ready`,N=await new Promise((U,$)=>{q(["windows-mutex"],U,$)});o(()=>N.isActive(T)).then(()=>this.setState(a.State.Ready(u)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,w.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}async _applySpecificUpdate(u){if(this.state.type!=="idle")return;const I=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!I};this.setState(a.State.Downloading(D)),this.availableUpdate={packagePath:u},I?this.productService.target==="user"?this.doApplyUpdate():this.setState(a.State.Downloaded(D)):this.setState(a.State.Ready(D))}};ve([E.memoize],s.prototype,"cachePath",null),s=ve([J(0,b.ILifecycleMainService),J(1,S.IConfigurationService),J(2,f.ITelemetryService),J(3,g.IEnvironmentMainService),J(4,d.IRequestService),J(5,C.ILogService),J(6,h.IFileService),J(7,p.INativeHostMainService),J(8,v.IProductService)],s),e.Win32UpdateService=s}),define(Z[266],ee([0,1,15,8,22,44,3,34,2,13,9,71,4,7,171,60,19,56,26,59,14,21,6,20,61,231,91,36,234,64,74,32,27,52,116,120,37,38,54,42]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p,v,d,f,a,i,o,n,r,s,c,u,I,D,T,N,U,$,Y,oe,ue,se,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var G;(function(F){F[F.NONE=0]="NONE",F[F.NAVIGATING=1]="NAVIGATING",F[F.READY=2]="READY"})(G||(G={}));let K=class Tt extends l.Disposable{constructor(A,W,z,te,B,j,L,O,_,V,x,re,H,ie,ne,ae,fe,De,Le){super(),this.logService=W,this.environmentMainService=z,this.policyService=te,this.userDataProfilesService=B,this.fileService=j,this.applicationStorageMainService=L,this.storageMainService=O,this.configurationService=_,this.themeMainService=V,this.workspacesManagementMainService=x,this.backupMainService=re,this.telemetryService=H,this.dialogMainService=ie,this.lifecycleMainService=ne,this.productService=ae,this.protocolMainService=fe,this.windowsMainService=De,this.stateMainService=Le,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new M.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[ke,Ae]=this.restoreWindowState(A.state);this.windowState=ke,this.logService.trace("window#ctor: using window state",ke);const je=this.windowState.mode===0||this.windowState.mode===3,ge=this.configurationService.getValue("window");let we=!1;typeof ge?.experimental?.useSandbox=="boolean"?we=ge.experimental.useSandbox:we=typeof se.default.quality=="string"&&se.default.quality!=="stable";const Ce={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!je,title:this.productService.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(ge?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...we?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};S.isLinux?Ce.icon=(0,P.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):S.isWindows&&!this.environmentMainService.isBuilt&&(Ce.icon=(0,P.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),S.isMacintosh&&!this.useNativeFullScreen()&&(Ce.fullscreenable=!1),S.isMacintosh&&(Ce.acceptFirstMouse=!0,ge?.clickThroughInactive===!1&&(Ce.acceptFirstMouse=!1));const X=S.isMacintosh&&ge?.nativeTabs===!0;X&&(Ce.tabbingIdentifier=this.productService.nameShort);const ce=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(ce&&(Ce.titleBarStyle="hidden",S.isMacintosh||(Ce.frame=!1),(0,D.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const de=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),ye=Y.Color.fromHex(de).isDarker()?"#FFFFFF":"#000000";Ce.titleBarOverlay={height:29,color:de,symbolColor:ye},this.hasWindowControlOverlay=!0}if((0,y.mark)("code/willCreateCodeBrowserWindow"),this._win=new w.BrowserWindow(Ce),(0,y.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,S.isMacintosh&&ce&&this._win.setSheetOffset(22),ce&&(S.isWindows&&(0,D.useWindowControlsOverlay)(this.configurationService,this.environmentMainService)||S.isMacintosh)){const de=this.stateMainService.getItem(Tt.windowControlHeightStateStorageKey);de&&this.updateWindowControls({height:de})}S.isWindows&&ce&&this._win.hookWindowMessage(278,()=>{const[ye,Ee]=this._win.getPosition(),We=w.screen.getCursorScreenPoint(),Te=We.x-ye,Ne=We.y-Ee;return(()=>!(Te>30&&Ne>=0&&Ne<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Te,y:Ne})),0}),(S.isMacintosh||S.isWindows)&&Ae&&(!X||w.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(de=>typeof de=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),je&&((0,y.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,y.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(A){S.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return S.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){S.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return S.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){S.isMacintosh&&A?.force&&w.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function W(){z.dispose(),te.dispose(),A()}const z=this.onDidClose(()=>W()),te=this.onWillLoad(()=>W())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(W,z)=>this.onWindowError(2,z)),this._win.webContents.on("did-fail-load",(W,z,te)=>this.onWindowError(3,{reason:te,exitCode:z})),this._win.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",W=>{this._config&&(this._config.maximized=!0),w.app.emit("browser-window-maximize",W,this._win)}),this._win.on("unmaximize",W=>{this._config&&(this._config.maximized=!1),w.app.emit("browser-window-unmaximize",W,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(W=>this.onConfigurationUpdated(W))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(W=>this.onDidDeleteUntitledWorkspace(W)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(W,z)=>{const te=await this.getMarketplaceHeaders();z({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,te)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,r.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,W){switch(A){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:W?.reason,code:W?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,h.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,h.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,h.localize)(2,null))],message:(0,h.localize)(3,null),detail:(0,h.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,h.localize)(5,null):void 0},this._win);if(z.response!==1){const te=z.response===0;await this.destroyWindow(te,z.checkboxChecked)}}else if(A===2){let z;W?z=(0,h.localize)(7,null,W.reason,W.exitCode??"<unknown>"):z=(0,h.localize)(6,null);const te=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,h.localize)(8,null)),(0,E.mnemonicButtonLabel)((0,h.localize)(9,null))],message:z,detail:(0,h.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,h.localize)(11,null):void 0},this._win),B=te.response===0;await this.destroyWindow(B,te.checkboxChecked)}break}}async destroyWindow(A,W){const z=this._config?.workspace;if(W&&z)try{const te=this.storageMainService.workspaceStorage(z);await te.init(),te.delete("memento/workbench.parts.editor"),await te.close()}catch(te){this.logService.error(te)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let te,B;(0,N.isSingleFolderWorkspaceIdentifier)(z)?te={folderUri:z.uri}:(0,N.isWorkspaceIdentifier)(z)?te={workspaceUri:z.configPath}:B=!0;const[j]=await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:te?[te]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});j.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const W=this.getMenuBarVisibility();W!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=W,this.setMenuBarVisibility(W));let z=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;z?.endsWith("/")&&(z=z.substr(0,z.length-1));const te=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.currentHttpProxy||te!==this.currentNoProxy)){this.currentHttpProxy=z,this.currentNoProxy=te;const B=z||"",j=te?`${te},<local>`:"<local>";this.logService.trace(`Setting proxy to '${B}', bypassing '${j}'`),this._win.webContents.session.setProxy({proxyRules:B,proxyBypassRules:j,pacScript:""})}}addTabbedWindow(A){S.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,W=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!W.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(A,W),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/workbench/workbench.html",q).toString(!0));const z=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:W.isReload?3:z?2:1})}updateConfiguration(A,W){const z=(this._config??this.pendingLoadConfig)?.userEnv;if(z){const te=(0,d.isLaunchedFromCli)(z)&&!(0,d.isLaunchedFromCli)(A.userEnv),B=this.isExtensionDevelopmentHost;(te||B)&&(A.userEnv={...z,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(A["disable-extensions"]=W.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,y.mark)("code/willOpenNewWindow"),A.perfMarks=(0,y.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const W=Object.assign({},this._config);W.workspace=await this.validateWorkspaceBeforeReload(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToMerge,delete W.filesToWait,this.isExtensionDevelopmentHost&&A&&(W.verbose=A.verbose,W.debugId=A.debugId,W.extensionEnvironment=A.extensionEnvironment,W["inspect-extensions"]=A["inspect-extensions"],W["inspect-brk-extensions"]=A["inspect-brk-extensions"],W["extensions-dir"]=A["extensions-dir"]),W.isInitialStartup=!1,W.policiesData=this.policyService.serialize(),W.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(W,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,N.isWorkspaceIdentifier)(A.workspace)){const W=A.workspace.configPath;if(W.scheme===m.Schemas.file&&!await this.fileService.exists(W))return}else if((0,N.isSingleFolderWorkspaceIdentifier)(A.workspace)){const W=A.workspace.uri;if(W.scheme===m.Schemas.file&&!await this.fileService.exists(W))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,$.defaultWindowState)();if(this.isFullScreen){let z;try{z=w.screen.getDisplayMatching(this.getBounds())}catch{}const te=(0,$.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||te.width,height:this.windowState.height||te.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let W;if(!S.isMacintosh&&this._win.isMaximized()?W=0:W=1,W===0?A.mode=0:A.mode=1,W===1||W===0){let z;W===1?z=this.getBounds():z=this._win.getNormalBounds(),A.x=z.x,A.y=z.y,A.width=z.width,A.height=z.height}return A}updateWindowControls(A){A.height&&this.stateMainService.setItem(Tt.windowControlHeightStateStorageKey,A.height),S.isWindows&&this.hasWindowControlOverlay?this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0}):S.isMacintosh&&A.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(A.height-15)/2})}restoreWindowState(A){(0,y.mark)("code/willRestoreCodeWindowState");let W=!1;if(A)try{const z=w.screen.getAllDisplays();W=z.length>1,A=this.validateWindowState(A,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return(0,y.mark)("code/didRestoreCodeWindowState"),[A||(0,$.defaultWindowState)(),W]}validateWindowState(A,W){if(this.logService.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const B=this.getWorkingArea(W[0]);if(B){let j=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!B||(A.x<B.x&&(A.x=B.x),A.y<B.y&&(A.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),j(),A.width>B.width&&(A.width=B.width),A.height>B.height&&(A.height=B.height),A.x>B.x+B.width-128&&(A.x=B.x+B.width-A.width),A.y>B.y+B.height-128&&(A.y=B.y+B.height-A.height),j()}return A}if(A.display&&A.mode===3){const B=W.find(j=>j.id===A.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const j=(0,$.defaultWindowState)(3);return j.x=B.bounds.x,j.y=B.bounds.y,j}}let z,te;try{z=w.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),te=this.getWorkingArea(z)}catch{}if(z&&te&&A.x+A.width>te.x&&A.y+A.height>te.y&&A.x<te.x+te.width&&A.y<te.y+te.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",te),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,W]=this._win.getPosition(),[z,te]=this._win.getSize();return{x:A,y:W,width:z,height:te}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return S.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(A)}doSetNativeFullScreen(A){S.isMacintosh&&(this.transientIsNativeFullScreen=A,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,W=!0){S.isMacintosh||(A==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,h.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const W=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!W),this._win.autoHideMenuBar=W;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(S.isMacintosh)switch(w.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,W,...z){this.isReady?this.send(A,...z):this.ready().then(()=>{W.isCancellationRequested||this.send(A,...z)})}send(A,...W){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...W)}catch(z){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)(z)}`)}}}updateTouchBar(A){!S.isMacintosh||this.touchBarGroups.forEach((W,z)=>{const te=A[z];W.segments=this.createTouchBarGroupSegments(te)})}createTouchBar(){if(!!S.isMacintosh){for(let A=0;A<10;A++){const W=this.createTouchBarGroup();this.touchBarGroups.push(W)}this._win.setTouchBar(new w.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const W=this.createTouchBarGroupSegments(A),z=new w.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:te=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:z.segments[te].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(A=[]){return A.map(z=>{let te;z.icon&&!u.ThemeIcon.isThemeIcon(z.icon)&&z.icon?.dark?.scheme===m.Schemas.file&&(te=w.nativeImage.createFromPath(g.URI.revive(z.icon.dark).fsPath),te.isEmpty()&&(te=void 0));let B;return typeof z.title=="string"?B=z.title:B=z.title.value,{id:z.id,label:te?void 0:B,icon:te}})}dispose(){super.dispose(),this._win=null}};K.windowControlHeightStateStorageKey="windowControlHeight",K=ve([J(1,i.ILogService),J(2,v.IEnvironmentMainService),J(3,oe.IPolicyService),J(4,he.IUserDataProfilesMainService),J(5,f.IFileService),J(6,s.IApplicationStorageMainService),J(7,s.IStorageMainService),J(8,C.IConfigurationService),J(9,I.IThemeMainService),J(10,U.IWorkspacesManagementMainService),J(11,b.IBackupMainService),J(12,c.ITelemetryService),J(13,p.IDialogMainService),J(14,a.ILifecycleMainService),J(15,o.IProductService),J(16,n.IProtocolMainService),J(17,T.IWindowsMainService),J(18,ue.IStateMainService)],K),e.CodeWindow=K}),define(Z[75],ee([0,1,15,24,8,3,34,2,13,4,16,7,23,174,5,21,6,91,92,27,52]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p,v,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,h.createDecorator)("workspacesHistoryMainService");let a=class nt extends E.Disposable{constructor(o,n,r,s){super(),this.logService=o,this.workspacesManagementMainService=n,this.lifecycleMainService=r,this.applicationStorageMainService=s,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(o=>this.addRecentlyOpened([{workspace:o.workspace,remoteAuthority:o.window.remoteAuthority}])))}async addRecentlyOpened(o){const n=[],r=[];for(const s of o)if((0,v.isRecentWorkspace)(s))!this.workspacesManagementMainService.isUntitledWorkspace(s.workspace)&&this.indexOfWorkspace(n,s.workspace)===-1&&n.push(s);else if((0,v.isRecentFolder)(s))this.indexOfFolder(n,s.folderUri)===-1&&n.push(s);else{const c=this.indexOfFile(r,s.fileUri)>=0,u=s.fileUri.scheme===l.Schemas.file&&nt.COMMON_FILES_FILTER.indexOf((0,P.basename)(s.fileUri))>=0;!c&&!u&&(r.push(s),m.isWindows&&s.fileUri.scheme===l.Schemas.file&&w.app.addRecentDocument(s.fileUri.fsPath))}await this.addEntriesFromStorage(n,r),n.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(n.length=nt.MAX_TOTAL_RECENT_ENTRIES),r.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(r.length=nt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:n,files:r}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(o){const n=u=>{const I=this.location(u);for(const D of o)if(P.extUriBiasedIgnorePathCase.isEqual(D,I))return!1;return!0},r=await this.getRecentlyOpened(),s=r.workspaces.filter(n),c=r.files.filter(n);(s.length!==r.workspaces.length||c.length!==r.files.length)&&(await this.saveRecentlyOpened({files:c,workspaces:s}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),w.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){const o=[],n=[];return await this.addEntriesFromStorage(o,n),{workspaces:o,files:n}}async addEntriesFromStorage(o,n){const r=await this.getRecentlyOpenedFromStorage();for(const s of r.workspaces){const c=(0,v.isRecentFolder)(s)?this.indexOfFolder(o,s.folderUri):this.indexOfWorkspace(o,s.workspace);c>=0?o[c].label=o[c].label||s.label:o.push(s)}for(const s of r.files){const c=this.indexOfFile(n,s.fileUri);c>=0?n[c].label=n[c].label||s.label:n.push(s)}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let o;const n=this.applicationStorageMainService.get(nt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof n=="string")try{o=JSON.parse(n)}catch(r){this.logService.error("Unexpected error parsing opened paths list",r)}return(0,v.restoreRecentlyOpened)(o,this.logService)}async saveRecentlyOpened(o){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(nt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,v.toStoreData)(o)),-1,1)}location(o){return(0,v.isRecentFolder)(o)?o.folderUri:(0,v.isRecentFile)(o)?o.fileUri:o.workspace.configPath}indexOfWorkspace(o,n){return o.findIndex(r=>(0,v.isRecentWorkspace)(r)&&r.workspace.id===n.id)}indexOfFolder(o,n){return o.findIndex(r=>(0,v.isRecentFolder)(r)&&P.extUriBiasedIgnorePathCase.isEqual(r.folderUri,n))}indexOfFile(o,n){return o.findIndex(r=>P.extUriBiasedIgnorePathCase.isEqual(r.fileUri,n))}async handleWindowsJumpList(){!m.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!m.isWindows)return;const o=[];if(o.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(0,null),description:(0,g.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const c of w.app.getJumpListSettings().removedItems){const u=c.args;if(u){const I=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(u);I&&n.push(y.URI.parse(I[2]))}}await this.removeRecentlyOpened(n);let r=!1;const s=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,nt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(c=>{const u=(0,v.isRecentWorkspace)(c)?c.workspace:c.folderUri,{title:I,description:D}=this.getWindowsJumpListLabel(u,c.label);let T;return y.URI.isUri(u)?T=`--folder-uri "${u.toString()}"`:(r=!0,T=`--file-uri "${u.configPath.toString()}"`),{type:"task",title:I.substr(0,255),description:D.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));s.length>0&&o.push({type:"custom",name:r?(0,g.localize)(2,null):(0,g.localize)(3,null),items:s})}o.push({type:"recent"});try{const n=w.app.setJumpList(o);n&&n!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.logService.warn("updateWindowsJumpList#setJumpList",n)}}getWindowsJumpListLabel(o,n){if(n)return{title:(0,M.splitName)(n).name,description:n};if(y.URI.isUri(o))return{title:(0,P.basename)(o),description:this.renderJumpListPathDescription(o)};if(this.workspacesManagementMainService.isUntitledWorkspace(o))return{title:(0,g.localize)(4,null),description:""};let r=(0,P.basename)(o.configPath);return r.endsWith(d.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-d.WORKSPACE_EXTENSION.length-1)),{title:(0,g.localize)(5,null,r),description:this.renderJumpListPathDescription(o.configPath)}}renderJumpListPathDescription(o){return o.scheme==="file"?(0,M.normalizeDriveLetter)(o.fsPath):o.toString()}async updateMacOSRecentDocuments(){if(!m.isMacintosh)return;w.app.clearRecentDocuments();const o=await this.getRecentlyOpened(),n=[];let r=0;for(let c=0;c<o.workspaces.length&&r<nt.MAX_MACOS_DOCK_RECENT_WORKSPACES;c++){const u=this.location(o.workspaces[c]);if(u.scheme===l.Schemas.file){const I=(0,P.originalFSPath)(u);await S.Promises.exists(I)&&(n.push(I),r++)}}const s=[];for(let c=0;c<o.files.length&&r<nt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;c++){const u=this.location(o.files[c]);if(u.scheme===l.Schemas.file){const I=(0,P.originalFSPath)(u);if(nt.COMMON_FILES_FILTER.includes((0,P.basename)(u))||n.includes(I))continue;await S.Promises.exists(I)&&(s.push(I),r++)}}s.reverse().forEach(c=>w.app.addRecentDocument(c)),n.reverse().forEach(c=>w.app.addRecentDocument(c))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a=ve([J(0,C.ILogService),J(1,f.IWorkspacesManagementMainService),J(2,b.ILifecycleMainService),J(3,p.IApplicationStorageMainService)],a),e.WorkspacesHistoryMainService=a}),define(Z[267],ee([0,1,15,8,22,34,4,7,164,19,26,21,6,210,65,20,38,36,48,74,32,75]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p,v,d,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let o=class Ot{constructor(s,c,u,I,D,T,N,U,$,Y,oe){this.updateService=s,this.configurationService=c,this.windowsMainService=u,this.environmentMainService=I,this.telemetryService=D,this.workspacesHistoryMainService=T,this.stateMainService=N,this.lifecycleMainService=U,this.logService=$,this.nativeHostMainService=Y,this.productService=oe,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,d.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(Ot.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,N,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,N,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,N,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,N,U)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,N,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const c=this.productService.requestFeatureUrl;c&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(c,"openUserVoiceUrl"));const u=this.productService.reportIssueUrl;u&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(u,"openReportIssues"));const I=this.productService.licenseUrl;I&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const T=I.indexOf("?")>0?"&":"?";this.openUrl(`${I}${T}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(I,"openLicenseUrl")});const D=this.productService.privacyStatementUrl;D&&I&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(D,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;const s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,c){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(Ot.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!M.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!w.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=w.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){w.Menu.setApplicationMenu(M.isMacintosh?new w.Menu:null);return}const c=new w.Menu;let u;if(M.isMacintosh){const D=new w.Menu;u=new w.MenuItem({label:this.productService.nameShort,submenu:D}),this.setMacApplicationMenu(D),c.append(u)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const D=new w.Menu;D.append(new w.MenuItem({label:this.mnemonicLabel(l.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),w.app.dock.setMenu(D)}if(this.shouldDrawMenu("File")){const D=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(l.localize(1,null)),submenu:D});this.setMenuById(D,"File"),c.append(T)}if(this.shouldDrawMenu("Edit")){const D=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(l.localize(2,null)),submenu:D});this.setMenuById(D,"Edit"),c.append(T)}if(this.shouldDrawMenu("Selection")){const D=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(l.localize(3,null)),submenu:D});this.setMenuById(D,"Selection"),c.append(T)}if(this.shouldDrawMenu("View")){const D=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(l.localize(4,null)),submenu:D});this.setMenuById(D,"View"),c.append(T)}if(this.shouldDrawMenu("Go")){const D=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(l.localize(5,null)),submenu:D});this.setMenuById(D,"Go"),c.append(T)}if(this.shouldDrawMenu("Run")){const D=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(l.localize(6,null)),submenu:D});this.setMenuById(D,"Run"),c.append(T)}if(this.shouldDrawMenu("Terminal")){const D=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(l.localize(7,null)),submenu:D});this.setMenuById(D,"Terminal"),c.append(T)}let I;if(this.shouldDrawMenu("Window")){const D=new w.Menu;I=new w.MenuItem({label:this.mnemonicLabel(l.localize(8,null)),submenu:D,role:"window"}),this.setMacWindowMenu(D)}if(I&&c.append(I),this.shouldDrawMenu("Help")){const D=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(l.localize(9,null)),submenu:D,role:"help"});this.setMenuById(D,"Help"),c.append(T)}c.items&&c.items.length>0?w.Menu.setApplicationMenu(c):w.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const c=this.createMenuItem(l.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),u=this.getUpdateMenuItems();let I;if(this.shouldDrawMenu("Preferences")){const ue=new w.Menu;this.setMenuById(ue,"Preferences"),I=new w.MenuItem({label:this.mnemonicLabel(l.localize(11,null)),submenu:ue})}const D=new w.Menu,T=new w.MenuItem({label:l.localize(12,null),role:"services",submenu:D}),N=new w.MenuItem({label:l.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new w.MenuItem({label:l.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),$=new w.MenuItem({label:l.localize(15,null),role:"unhide"}),Y=new w.MenuItem(this.likeAction("workbench.action.quit",{label:l.localize(16,null,this.productService.nameLong),click:async(ue,se,he)=>{const G=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!w.BrowserWindow.getFocusedWindow()||G?.isMinimized())&&await this.confirmBeforeQuit(he)&&this.nativeHostMainService.quit(void 0)}})),oe=[c];oe.push(...u),I&&oe.push(n(),I),oe.push(n(),T,n(),N,U,$,n(),Y),oe.forEach(ue=>s.append(ue))}async confirmBeforeQuit(s){if(this.windowsMainService.getWindowCount()===0)return!0;const c=this.configurationService.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.isKeyboardEvent(s)){const u={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(l.localize(17,null)),(0,R.mnemonicButtonLabel)(l.localize(18,null))],message:l.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:I}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,u);return I===0}return!0}shouldDrawMenu(s){if(!M.isMacintosh&&(0,d.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,c){c.forEach(u=>{if((0,g.isMenubarMenuItemSeparator)(u))s.append(n());else if((0,g.isMenubarMenuItemSubmenu)(u)){const I=new w.Menu,D=new w.MenuItem({label:this.mnemonicLabel(u.label),submenu:I});this.setMenu(I,u.submenu.items),s.append(D)}else(0,g.isMenubarMenuItemRecentAction)(u)?s.append(this.createOpenRecentMenuItem(u)):(0,g.isMenubarMenuItemAction)(u)&&(u.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[u.id]?s.append(new w.MenuItem(this.likeAction(u.id,{label:this.mnemonicLabel(u.label),click:this.fallbackMenuHandlers[u.id]}))):s.append(this.createMenuItem(u.label,u.id,!1,u.checked)):s.append(this.createMenuItem(u.label,u.id,u.enabled!==!1,!!u.checked)):s.append(this.createMenuItem(u.label,u.id,u.enabled!==!1,!!u.checked)))})}setMenuById(s,c){this.menubarMenus&&this.menubarMenus[c]&&this.setMenu(s,this.menubarMenus[c].items)}insertCheckForUpdatesItems(s){const c=this.getUpdateMenuItems();c.length&&(c.forEach(u=>s.append(u)),s.append(n()))}createOpenRecentMenuItem(s){const c=E.URI.revive(s.uri),u=s.id,I=u==="openRecentFile"?{fileUri:c}:u==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new w.MenuItem(this.likeAction(u,{label:s.label,click:async(D,T,N)=>{const U=this.isOptionClick(N);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[I],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:s.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([c])}},!1))}isOptionClick(s){return!!(s&&(!M.isMacintosh&&(s.ctrlKey||s.shiftKey)||M.isMacintosh&&(s.metaKey||s.altKey)))}isKeyboardEvent(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}createRoleMenuItem(s,c,u){const I={label:this.mnemonicLabel(s),role:u,enabled:!0};return new w.MenuItem(this.withKeybinding(c,I))}setMacWindowMenu(s){const c=new w.MenuItem({label:l.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),u=new w.MenuItem({label:l.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),I=new w.MenuItem({label:l.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),D=this.createMenuItem(l.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(n()),T.push(this.createMenuItem(l.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(l.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(l.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(l.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(l.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,u,n(),D,...T,n(),I].forEach(N=>s.append(N))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new w.MenuItem({label:this.mnemonicLabel(l.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new w.MenuItem({label:l.localize(30,null),enabled:!1})];case"available for download":return[new w.MenuItem({label:this.mnemonicLabel(l.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new w.MenuItem({label:l.localize(32,null),enabled:!1})];case"downloaded":return[new w.MenuItem({label:this.mnemonicLabel(l.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new w.MenuItem({label:l.localize(34,null),enabled:!1})];case"ready":return[new w.MenuItem({label:this.mnemonicLabel(l.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,c,u,I){const D=this.mnemonicLabel(s),T=typeof c=="function"?c:(oe,ue,se)=>{const he=oe?oe.userSettingsLabel:null;let G=c;Array.isArray(c)&&(G=this.isOptionClick(se)?c[1]:c[0]),he&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:he}):this.runActionInRenderer({type:"commandId",commandId:G})},N=typeof u=="boolean"?u:this.windowsMainService.getWindowCount()>0,U=typeof I=="boolean"?I:!1,$={label:D,click:T,enabled:N};U&&($.type="checkbox",$.checked=U);let Y;return typeof c=="string"?Y=c:Array.isArray(c)&&(Y=c[0]),M.isMacintosh&&(Y==="editor.action.clipboardCutAction"?$.role="cut":Y==="editor.action.clipboardCopyAction"?$.role="copy":Y==="editor.action.clipboardPasteAction"&&($.role="paste"),Y==="undo"?$.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.undo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("undo:")}):Y==="redo"?$.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.redo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("redo:")}):Y==="editor.action.selectAll"&&($.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.selectAll(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("selectAll:")}))),new w.MenuItem(this.withKeybinding(Y,$))}makeContextAwareClickHandler(s,c){return(u,I,D)=>{const T=w.BrowserWindow.getFocusedWindow();if(!T)return c.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return c.inDevTools(T.webContents.devToolsWebContents);s(u,I||T,D)}}runActionInRenderer(s){let c=w.BrowserWindow.getFocusedWindow();if(!c){const I=this.windowsMainService.getLastActiveWindow();I?.isMinimized()&&(c=I.win)}const u=c?this.windowsMainService.getWindowById(c.id):void 0;if(u){if(this.logService.trace("menubar#runActionInRenderer",s),M.isMacintosh&&!this.environmentMainService.isBuilt&&!u.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const I={id:s.commandId,from:"menu"};u.sendWhenReady("vscode:runAction",k.CancellationToken.None,I)}else{const I={userSettingsLabel:s.userSettingsLabel};u.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,I)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,c){const u=typeof s=="string"?this.keybindings[s]:void 0;if(u?.label){if(u.isNative!==!1)c.accelerator=u.label,c.userSettingsLabel=u.userSettingsLabel;else if(typeof c.label=="string"){const I=c.label.indexOf("[");I>=0?c.label=`${c.label.substr(0,I)} [${u.label}]`:c.label=`${c.label} [${u.label}]`}}else c.accelerator=void 0;return c}likeAction(s,c,u=!c.accelerator){u&&(c=this.withKeybinding(s,c));const I=c.click;return c.click=(D,T,N)=>{this.reportMenuActionTelemetry(s),I?.(D,T,N)},c}openUrl(s,c){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(c)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:i})}mnemonicLabel(s){return(0,R.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};o.lastKnownMenubarStorageKey="lastKnownMenubarData",o=ve([J(0,v.IUpdateService),J(1,m.IConfigurationService),J(2,f.IWindowsMainService),J(3,P.IEnvironmentMainService),J(4,p.ITelemetryService),J(5,a.IWorkspacesHistoryMainService),J(6,C.IStateMainService),J(7,y.ILifecycleMainService),J(8,S.ILogService),J(9,h.INativeHostMainService),J(10,b.IProductService)],o),e.Menubar=o;function n(){return new w.MenuItem({type:"separator"})}}),define(Z[268],ee([0,1,5,21,6,267]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,w.createDecorator)("menubarMainService");let M=class{constructor(l,m,P){this.instantiationService=l,this.lifecycleMainService=m,this.logService=P,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(l,m){this.logService.trace("menubarService#updateMenubar",l),(await this.menubar).updateMenu(m,l)}};M=ve([J(0,w.IInstantiationService),J(1,t.ILifecycleMainService),J(2,k.ILogService)],M),e.MenubarMainService=M}),define(Z[269],ee([0,1,15,23,28,24,22,3,30,49,34,2,13,9,71,4,33,16,12,7,172,60,19,56,26,14,5,21,6,54,20,61,63,38,74,266,117,261,27,93,75,52,64,37,42]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p,v,d,f,a,i,o,n,r,s,c,u,I,D,T,N,U,$,Y,oe,ue,se,he,G,K,F,A,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(j){return(0,se.isWorkspaceIdentifier)(j?.workspace)}function te(j){return(0,se.isSingleFolderWorkspaceIdentifier)(j?.workspace)}let B=class ht extends y.Disposable{constructor(L,O,_,V,x,re,H,ie,ne,ae,fe,De,Le,ke,Ae,je,ge,we){super(),this.machineId=L,this.initialUserEnv=O,this.logService=_,this.stateMainService=V,this.policyService=x,this.environmentMainService=re,this.userDataProfilesMainService=H,this.lifecycleMainService=ie,this.backupMainService=ne,this.configurationService=ae,this.workspacesHistoryMainService=fe,this.workspacesManagementMainService=De,this.instantiationService=Le,this.dialogMainService=ke,this.fileService=Ae,this.productService=je,this.protocolMainService=ge,this.themeMainService=we,this._onDidOpenWindow=this._register(new E.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new E.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new E.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new E.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new E.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ue.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const O=new y.DisposableStore;if(O.add(E.Event.any(L.onDidClose,L.onDidDestroy)(()=>O.dispose())),L.config.extensionDevelopmentPath)for(const _ of L.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(_));L.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,O){const _=this.environmentMainService.args,V=O?.remoteAuthority||void 0,x=!0,re=O?.forceReuseWindow,H=!re;return this.open({...L,cli:_,forceEmpty:x,forceNewWindow:H,forceReuseWindow:re,remoteAuthority:V})}openExistingWindow(L,O){L.focus(),this.handleWaitMarkerFile(O,[L])}async open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const O=[],_=[],V=[],x=[],re=[];let H,ie=0;const ne=await this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ne);for(const ke of ne)te(ke)?L.addMode?O.push(ke):_.push(ke):z(ke)?V.push(ke):ke.fileUri?(H||(H={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ke.remoteAuthority}),H.filesToOpenOrCreate.push(ke)):ke.backupPath?re.push({backupFolder:(0,g.basename)(ke.backupPath),remoteAuthority:ke.remoteAuthority}):ie++;L.diffMode&&H&&H.filesToOpenOrCreate.length>=2&&(H.filesToDiff=H.filesToOpenOrCreate.slice(0,2),H.filesToOpenOrCreate=[]),L.mergeMode&&H&&H.filesToOpenOrCreate.length===4&&(H.filesToMerge=H.filesToOpenOrCreate.slice(0,4),H.filesToOpenOrCreate=[],H.filesToDiff=[]),H&&L.waitMarkerFileURI&&(H.filesToWait={paths:(0,R.coalesce)([...H.filesToDiff,H.filesToMerge[3],...H.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(x.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),V.push(...x),re.push(...this.backupMainService.getEmptyWindowBackups())):re.length=0;const{windows:ae,filesOpenedInWindow:fe}=await this.doOpen(L,V,_,re,ie,H,O);if(this.logService.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${_.length}, emptyToRestore: ${re.length}, emptyToOpen: ${ie})`),ae.length>1)if(fe)fe.focus();else{const ke=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ae=!0,je=!0;if(ke){const ge=ae.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ge.length&&(ge[0].focus(),Ae=!1,je=!1)}if(Ae)for(let ge=ae.length-1;ge>=0;ge--){const we=ae[ge];if(!(we.openedWorkspace&&x.some(Ce=>we.openedWorkspace&&Ce.workspace.id===we.openedWorkspace.id)||we.backupPath&&re.some(Ce=>we.backupPath&&Ce.backupFolder===(0,g.basename)(we.backupPath)))){we.focus(),je=!1;break}}je&&ae[ae.length-1].focus()}const De=H&&H.filesToDiff.length>0,Le=H&&H.filesToMerge.length>0;if(!ae.some(ke=>ke.isExtensionDevelopmentHost)&&!De&&!Le&&!L.noRecentEntry){const ke=[];for(const Ae of ne)z(Ae)&&!Ae.transient?ke.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):te(Ae)?ke.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&ke.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ke)}return this.handleWaitMarkerFile(L,ae),ae}handleWaitMarkerFile(L,O){const _=L.waitMarkerFileURI;L.context===0&&_&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(_)}catch{}})()}async doOpen(L,O,_,V,x,re,H){const ie=[];let ne;function ae(ge,we){ie.push(ge),we&&(ne=ge,re=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:De}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&H.length>0){const ge=H[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(ge);we&&ae(this.doAddFoldersToExistingWindow(we,H.map(Ce=>Ce.workspace.uri)))}const Le=_.length+O.length+V.length;if(re&&Le===0){const ge=re.filesToOpenOrCreate[0]||re.filesToDiff[0]||re.filesToMerge[3],we=this.getWindows().filter(X=>re&&(0,p.isEqualAuthority)(X.remoteAuthority,re.remoteAuthority));let Ce;ge?.fileUri&&!De&&((L.context===4||L.context===0||L.context===1)&&(Ce=await(0,oe.findWindowOnFile)(we,ge.fileUri,async X=>X.configPath.scheme===S.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(X.configPath):void 0)),Ce||(Ce=this.doGetLastActiveWindow(we))),Ce?(0,se.isWorkspaceIdentifier)(Ce.openedWorkspace)?O.push({workspace:Ce.openedWorkspace,remoteAuthority:Ce.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Ce.openedWorkspace)?_.push({workspace:Ce.openedWorkspace,remoteAuthority:Ce.remoteAuthority}):ae(this.doOpenFilesInExistingWindow(L,Ce,re),!0):ae(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:re,forceNewWindow:!0,remoteAuthority:re.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,profile:L.profile}),!0)}const ke=(0,R.distinct)(O,ge=>ge.workspace.id);if(ke.length>0){const ge=(0,R.coalesce)(ke.map(we=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.configPath)));if(ge.length>0){const we=ge[0],Ce=(0,p.isEqualAuthority)(re?.remoteAuthority,we.remoteAuthority)?re:void 0;ae(this.doOpenFilesInExistingWindow(L,we,Ce),!!Ce),fe=!0}for(const we of ke){if(ge.some(ce=>ce.openedWorkspace&&ce.openedWorkspace.id===we.workspace.id))continue;const Ce=we.remoteAuthority,X=(0,p.isEqualAuthority)(re?.remoteAuthority,Ce)?re:void 0;ae(this.doOpenFolderOrWorkspace(L,we,fe,X),!!X),fe=!0}}const Ae=(0,R.distinct)(_,ge=>p.extUriBiasedIgnorePathCase.getComparisonKey(ge.workspace.uri));if(Ae.length>0){const ge=(0,R.coalesce)(Ae.map(we=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.uri)));if(ge.length>0){const we=ge[0],Ce=(0,p.isEqualAuthority)(re?.remoteAuthority,we.remoteAuthority)?re:void 0;ae(this.doOpenFilesInExistingWindow(L,we,Ce),!!Ce),fe=!0}for(const we of Ae){if(ge.some(ce=>(0,se.isSingleFolderWorkspaceIdentifier)(ce.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(ce.openedWorkspace.uri,we.workspace.uri)))continue;const Ce=we.remoteAuthority,X=(0,p.isEqualAuthority)(re?.remoteAuthority,Ce)?re:void 0;ae(this.doOpenFolderOrWorkspace(L,we,fe,X),!!X),fe=!0}}const je=(0,R.distinct)(V,ge=>ge.backupFolder);if(je.length>0)for(const ge of je){const we=ge.remoteAuthority,Ce=(0,p.isEqualAuthority)(re?.remoteAuthority,we)?re:void 0;ae(this.doOpenEmpty(L,!0,we,Ce,ge),!!Ce),fe=!0}if(ie.length===0||re){re&&!x&&x++;const ge=re?re.remoteAuthority:L.remoteAuthority;for(let we=0;we<x;we++)ae(this.doOpenEmpty(L,fe,ge,re),!!re),fe=!0}return{windows:(0,R.distinct)(ie),filesOpenedInWindow:ne}}doOpenFilesInExistingWindow(L,O,_){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),O.focus();const V={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",M.CancellationToken.None,V),O}doAddFoldersToExistingWindow(L,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),L.focus();const _={foldersToAdd:O};return L.sendWhenReady("vscode:addFolders",M.CancellationToken.None,_),L}doOpenEmpty(L,O,_,V,x){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!x,remoteAuthority:_,filesToOpen:V,forceNewWindow:O});let re;return!O&&typeof L.contextWindowId=="number"&&(re=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:_,forceNewWindow:O,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:re,emptyWindowBackupInfo:x,profile:L.profile})}doOpenFolderOrWorkspace(L,O,_,V,x){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:V}),!_&&!x&&typeof L.contextWindowId=="number"&&(x=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:x,profile:L.profile})}async getPathsToOpen(L){let O,_=!1,V=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(O=await this.doExtractPathsFromAPI(L),_=!0):L.forceEmpty?O=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(O=await this.doExtractPathsFromCLI(L.cli),O.length===0&&O.push(Object.create(null)),_=!0):(O=await this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),V=!0),!L.addMode&&_){const x=O.filter(re=>te(re));if(x.length>1){const re=x[0].remoteAuthority;if(x.every(H=>(0,p.isEqualAuthority)(H.remoteAuthority,re))){const H=await this.workspacesManagementMainService.createUntitledWorkspace(x.map(ie=>({uri:ie.workspace.uri})));O.push({workspace:H,remoteAuthority:re}),O=O.filter(ie=>!te(ie))}}}if(L.initialStartup&&!V&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const x=await this.doGetPathsFromLastSession();O.unshift(...x.filter(re=>z(re)||te(re)||re.backupPath))}return O}async doExtractPathsFromAPI(L){const O={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},_=await Promise.all((0,R.coalesce)(L.urisToOpen||[]).map(async V=>{const x=await this.resolveOpenable(V,O);if(x)return x.label=V.label,x;const re=this.resourceFromOpenable(V),H={title:this.productService.nameLong,type:"info",buttons:[(0,P.mnemonicButtonLabel)((0,f.localize)(0,null))],defaultId:0,message:re.scheme===S.Schemas.file?(0,f.localize)(1,null):(0,f.localize)(2,null),detail:re.scheme===S.Schemas.file?(0,f.localize)(3,null,(0,P.getPathLabel)(re,{os:b.OS,tildify:this.environmentMainService})):(0,f.localize)(4,null,re.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(H,(0,v.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(_)}async doExtractPathsFromCLI(L){const O=[],_={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},V=L["folder-uri"];if(V){const H=await Promise.all(V.map(ie=>{const ne=this.cliArgToUri(ie);if(!!ne)return this.resolveOpenable({folderUri:ne},_)}));O.push(...(0,R.coalesce)(H))}const x=L["file-uri"];if(x){const H=await Promise.all(x.map(ie=>{const ne=this.cliArgToUri(ie);if(!!ne)return this.resolveOpenable((0,se.hasWorkspaceFileExtension)(ie)?{workspaceUri:ne}:{fileUri:ne},_)}));O.push(...(0,R.coalesce)(H))}const re=await Promise.all(L._.map(H=>_.remoteAuthority?this.doResolveRemotePath(H,_):this.doResolveFilePath(H,_)));return O.push(...(0,R.coalesce)(re)),O}cliArgToUri(L){try{const O=d.URI.parse(L);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${L}, ${O.message}`)}}async doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];L!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const _=await Promise.all(O.map(async V=>{if(V.workspace){const x=await this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority,rejectTransientWorkspaces:!0});if(z(x))return x}else if(V.folderUri){const x=await this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});if(te(x))return x}else if(L!=="folders"&&V.backupPath)return{backupPath:V.backupPath,remoteAuthority:V.remoteAuthority}}));return(0,R.coalesce)(_)}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async resolveOpenable(L,O=Object.create(null)){const _=this.resourceFromOpenable(L);return _.scheme===S.Schemas.file?((0,$.isFileToOpen)(L)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(_.fsPath,O)):this.doResolveRemoteOpenable(L,O)}doResolveRemoteOpenable(L,O){let _=this.resourceFromOpenable(L);const V=(0,N.getRemoteAuthority)(_)||O.remoteAuthority;if(_=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(_)),(0,$.isFileToOpen)(L)){if(O.gotoLineMode){const{path:x,line:re,column:H}=(0,l.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:x}),options:{selection:re?{startLineNumber:re,startColumn:H||1}:void 0},remoteAuthority:V}}return{fileUri:_,remoteAuthority:V}}else if((0,$.isWorkspaceToOpen)(L))return{workspace:(0,he.getWorkspaceIdentifier)(_),remoteAuthority:V};return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:V}}resourceFromOpenable(L){return(0,$.isWorkspaceToOpen)(L)?L.workspaceUri:(0,$.isFolderToOpen)(L)?L.folderUri:L.fileUri}async doResolveFilePath(L,O){let _,V;O.gotoLineMode&&({path:L,line:_,column:V}=(0,l.parseLineAndColumnAware)(L)),L=(0,l.sanitizeFilePath)((0,g.normalize)(L),(0,C.cwd)());try{const x=await t.Promises.stat(L);if(x.isFile()){if(!O.forceOpenWorkspaceAsFile){const re=await this.workspacesManagementMainService.resolveLocalWorkspace(d.URI.file(L));if(re)return re.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:re.id,configPath:re.configPath},type:r.FileType.File,exists:!0,remoteAuthority:re.remoteAuthority,transient:re.transient}}return{fileUri:d.URI.file(L),type:r.FileType.File,exists:!0,options:{selection:_?{startLineNumber:_,startColumn:V||1}:void 0}}}else{if(x.isDirectory())return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(d.URI.file(L),x),type:r.FileType.Directory,exists:!0};if(!b.isWindows&&L==="/dev/null")return{fileUri:d.URI.file(L),type:r.FileType.File,exists:!0}}}catch{const re=d.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([re]),O.ignoreFileNotFound)return{fileUri:re,type:r.FileType.File,exists:!1}}}doResolveRemotePath(L,O){const _=L.charCodeAt(0),V=O.remoteAuthority;let x,re;O.gotoLineMode&&({path:L,line:x,column:re}=(0,l.parseLineAndColumnAware)(L)),_!==47&&((0,l.isWindowsDriveLetter)(_)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,l.toSlashes)(L)),L=`/${L}`);const H=d.URI.from({scheme:S.Schemas.vscodeRemote,authority:V,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return O.forceOpenWorkspaceAsFile?{fileUri:H,options:{selection:x?{startLineNumber:x,startColumn:re||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,he.getWorkspaceIdentifier)(H),remoteAuthority:V};if(O.gotoLineMode||g.posix.basename(L).indexOf(".")!==-1)return{fileUri:H,options:{selection:x?{startLineNumber:x,startColumn:re||1}:void 0},remoteAuthority:V}}return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(H),remoteAuthority:V}}shouldOpenNewWindow(L){const O=this.configurationService.getValue("window"),_=O?.openFoldersInNewWindow||"default",V=O?.openFilesInNewWindow||"off";let x=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(_==="on"||_==="off")&&(x=_==="on");let re=!1;return L.forceNewWindow||L.forceReuseWindow?re=!!L.forceNewWindow&&!L.forceReuseWindow:(b.isMacintosh?L.context===1&&(re=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(re=!0),!L.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(re=V==="on")),{openFolderInNewWindow:!!x,openFilesInNewWindow:re}}async openExtensionDevelopmentHostWindow(L,O){const _=(0,oe.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(_)return this.lifecycleMainService.reload(_,O.cli),_.focus(),[_];let V=O.cli["folder-uri"]||[],x=O.cli["file-uri"]||[],re=O.cli._;if(!re.length&&!V.length&&!x.length&&!O.cli.extensionTestsPath){const ne=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ae=ne?.workspace??ne?.folderUri;ae&&(d.URI.isUri(ae)?ae.scheme===S.Schemas.file?re=[ae.fsPath]:V=[ae.toString()]:ae.configPath.scheme===S.Schemas.file?re=[(0,p.originalFSPath)(ae.configPath)]:x=[ae.configPath.toString()])}let H=O.remoteAuthority;for(const ne of L)if(ne.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ae=d.URI.parse(ne),fe=(0,N.getRemoteAuthority)(ae);fe&&(H?(0,p.isEqualAuthority)(fe,H)||this.logService.error("more than one extension development path authority"):H=fe)}re=re.filter(ne=>{const ae=d.URI.file(ne);return(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:(0,p.isEqualAuthority)((0,N.getRemoteAuthority)(ae),H)}),V=V.filter(ne=>{const ae=this.cliArgToUri(ne);return ae&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,p.isEqualAuthority)((0,N.getRemoteAuthority)(ae),H):!1}),x=x.filter(ne=>{const ae=this.cliArgToUri(ne);return ae&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,p.isEqualAuthority)((0,N.getRemoteAuthority)(ae),H):!1}),O.cli._=re,O.cli["folder-uri"]=V,O.cli["file-uri"]=x;const ie={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!re.length&&!V.length&&!x.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:H,profile:O.profile};return this.open(ie)}openInBrowserWindow(L){const O=this.configurationService.getValue("window"),_={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,g.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:I.default,isInitialStartup:L.initialStartup,perfMarks:(0,h.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:w.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize()};let V;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(V=L.windowToUse||this.getLastActiveWindow(),V&&V.focus()),V){const x=V.config;!_.extensionDevelopmentPath&&x?.extensionDevelopmentPath&&(_.extensionDevelopmentPath=x.extensionDevelopmentPath,_.extensionDevelopmentKind=x.extensionDevelopmentKind,_["enable-proposed-api"]=x["enable-proposed-api"],_.verbose=x.verbose,_["inspect-extensions"]=x["inspect-extensions"],_["inspect-brk-extensions"]=x["inspect-brk-extensions"],_.debugId=x.debugId,_.extensionEnvironment=x.extensionEnvironment,_["extensions-dir"]=x["extensions-dir"],_["disable-extensions"]=x["disable-extensions"])}else{const x=this.windowsStateHandler.getNewWindowState(_);(0,h.mark)("code/willCreateCodeWindow");const re=V=this.instantiationService.createInstance(Y.CodeWindow,{state:x,extensionDevelopmentPath:_.extensionDevelopmentPath,isExtensionTestHost:!!_.extensionTestsPath});(0,h.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(re),ht.WINDOWS.push(re),this._onDidOpenWindow.fire(re),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(re.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(re)),(0,m.once)(re.onDidClose)(()=>this.onWindowClosed(re)),(0,m.once)(re.onDidDestroy)(()=>this._onDidDestroyWindow.fire(re)),re.onDidTriggerSystemContextMenu(({x:ie,y:ne})=>this._onDidTriggerSystemContextMenu.fire({window:re,x:ie,y:ne}));const H=(0,v.assertIsDefined)(re.win?.webContents);H.removeAllListeners("devtools-reload-page"),H.on("devtools-reload-page",()=>this.lifecycleMainService.reload(re)),this.lifecycleMainService.registerWindow(re)}return _.windowId=V.id,V.isReady?this.lifecycleMainService.unload(V,4).then(x=>{x||this.doOpenInBrowserWindow(V,_,L)}):this.doOpenInBrowserWindow(V,_,L),V}doOpenInBrowserWindow(L,O,_){O.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,he.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),L.load(O)}resolveProfileForBrowserWindow(L){let O=L.profile;return O&&this.userDataProfilesMainService.setProfileForWorkspaceSync(L.workspace??"empty-window",O),O||(O=this.userDataProfilesMainService.getOrSetProfileForWorkspace(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile)),O}onWindowClosed(L){const O=ht.WINDOWS.indexOf(L);ht.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=w.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,p.isEqualAuthority)(O.remoteAuthority,L)))}doGetLastActiveWindow(L){const O=Math.max.apply(Math,L.map(_=>_.lastFocusTime));return L.find(_=>_.lastFocusTime===O)}sendToFocused(L,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,M.CancellationToken.None,...O)}sendToAll(L,O,_){for(const V of this.getWindows())_&&_.indexOf(V.id)>=0||V.sendWhenReady(L,M.CancellationToken.None,O)}getWindows(){return ht.WINDOWS}getWindowCount(){return ht.WINDOWS.length}getWindowById(L){const O=this.getWindows().filter(_=>_.id===L);return(0,R.firstOrDefault)(O)}getWindowByWebContents(L){const O=w.BrowserWindow.fromWebContents(L);if(!!O)return this.getWindowById(O.id)}};B.WINDOWS=[],B=ve([J(2,u.ILogService),J(3,U.IStateMainService),J(4,A.IPolicyService),J(5,n.IEnvironmentMainService),J(6,W.IUserDataProfilesMainService),J(7,c.ILifecycleMainService),J(8,a.IBackupMainService),J(9,i.IConfigurationService),J(10,G.IWorkspacesHistoryMainService),J(11,K.IWorkspacesManagementMainService),J(12,s.IInstantiationService),J(13,o.IDialogMainService),J(14,r.IFileService),J(15,D.IProductService),J(16,T.IProtocolMainService),J(17,F.IThemeMainService)],B),e.WindowsMainService=B}),define(Z[270],ee([0,1,60,32,75,52]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(l,m,P,y){this.workspacesManagementMainService=l,this.windowsMainService=m,this.workspacesHistoryMainService=P,this.backupMainService=y,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(l,m){const P=this.windowsMainService.getWindowById(l);if(P)return this.workspacesManagementMainService.enterWorkspace(P,this.windowsMainService.getWindows(),m)}createUntitledWorkspace(l,m,P){return this.workspacesManagementMainService.createUntitledWorkspace(m,P)}deleteUntitledWorkspace(l,m){return this.workspacesManagementMainService.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(l,m){return this.workspacesManagementMainService.getWorkspaceIdentifier(m)}getRecentlyOpened(l){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(l,m){return this.workspacesHistoryMainService.addRecentlyOpened(m)}removeRecentlyOpened(l,m){return this.workspacesHistoryMainService.removeRecentlyOpened(m)}clearRecentlyOpened(l){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=ve([J(0,R.IWorkspacesManagementMainService),J(1,t.IWindowsMainService),J(2,k.IWorkspacesHistoryMainService),J(3,w.IBackupMainService)],M),e.WorkspacesMainService=M}),define(Z[271],ee([0,1,15,41,28,18,44,17,30,49,43,34,2,13,9,4,12,7,29,81,131,46,145,101,246,148,60,262,19,69,181,84,118,56,104,179,26,59,112,193,213,194,248,105,195,196,14,206,86,68,5,85,263,225,258,21,6,208,268,65,20,63,254,87,38,251,91,113,36,230,232,73,48,237,238,264,239,265,115,241,242,243,244,249,32,269,250,27,92,75,270,52,247,37,212,42,257,221,55,72,89,252,259,260,8]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p,v,d,f,a,i,o,n,r,s,c,u,I,D,T,N,U,$,Y,oe,ue,se,he,G,K,F,A,W,z,te,B,j,L,O,_,V,x,re,H,ie,ne,ae,fe,De,Le,ke,Ae,je,ge,we,Ce,X,ce,de,ye,Ee,We,Te,Ne,Be,ze,Ue,qe,Q,le,pe,me,Se,Re,Fe,Ve,et,He,Xe,it,at,dt,Ut,vt,Nt,Bt,zt,Wt,$t,qt,jt,Ht,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let It=class extends S.Disposable{constructor(be,Pe,Me,Ie,Oe,$e,Ze,tt,_e,Ke,Qe){super(),this.mainProcessNodeIpcServer=be,this.userEnv=Pe,this.mainInstantiationService=Me,this.logService=Ie,this.environmentMainService=Oe,this.lifecycleMainService=$e,this.configurationService=Ze,this.stateMainService=tt,this.fileService=_e,this.productService=Ke,this.userDataProfilesMainService=Qe,this.configureSession(),this.registerListeners()}configureSession(){const be=_e=>_e?.startsWith(`${g.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);w.session.defaultSession.setPermissionRequestHandler((_e,Ke,Qe,Je)=>be(Je.requestingUrl)?Qe(Pe.has(Ke)):Qe(!1)),w.session.defaultSession.setPermissionCheckHandler((_e,Ke,Qe,Je)=>be(Je.requestingUrl)?Pe.has(Ke):!1);const Me=new Set([g.Schemas.file,g.Schemas.vscodeFileResource,g.Schemas.vscodeRemoteResource,"devtools"]),Ie=_e=>{for(let Ke=_e;Ke;Ke=Ke.parent)if(Ke.url.startsWith(`${g.Schemas.vscodeWebview}://`))return!0;return!1},Oe=_e=>_e.resourceType==="xhr"||Ie(_e.frame),$e=_e=>{const Ke=_e.frame;if(!Ke||!this.windowsMainService)return!1;const Qe=w.BrowserWindow.getAllWindows();for(const Je of Qe)if(Ke.processId===Je.webContents.mainFrame.processId)return!0;return!1},Ze=(_e,Ke)=>{if(_e.path!=="/index.html")return!0;const Qe=Ke.frame;if(!Qe||!this.windowsMainService)return!1;for(const Je of this.windowsMainService.getWindows())if(Je.win&&Qe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};w.session.defaultSession.webRequest.onBeforeRequest((_e,Ke)=>{const Qe=p.URI.parse(_e.url);return Qe.scheme===g.Schemas.vscodeWebview&&!Ze(Qe,_e)?(this.logService.error("Blocked vscode-webview request",_e.url),Ke({cancel:!0})):Qe.scheme===g.Schemas.vscodeFileResource&&!$e(_e)?(this.logService.error("Blocked vscode-file request",_e.url),Ke({cancel:!0})):Qe.path.endsWith(".svg")&&!Me.has(Qe.scheme)?Ke({cancel:!Oe(_e)}):Ke({cancel:!1})}),w.session.defaultSession.webRequest.onHeadersReceived((_e,Ke)=>{const Qe=_e.responseHeaders,Je=Qe["content-type"]||Qe["Content-Type"];if(Je&&Array.isArray(Je)){const st=p.URI.parse(_e.url);if(st.path.endsWith(".svg")&&Me.has(st.scheme))return Qe["Content-Type"]=["image/svg+xml"],Ke({cancel:!1,responseHeaders:Qe});if(!st.path.endsWith(g.Schemas.vscodeRemoteResource)&&Je.some(ot=>ot.toLowerCase().includes("image/svg")))return Ke({cancel:!Oe(_e)})}return Ke({cancel:!1})});const tt=w.session.defaultSession;typeof tt.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&tt.setCodeCachePath((0,h.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(Me=>this.onUnexpectedError(Me)),process.on("uncaughtException",Me=>(0,E.onUnexpectedError)(Me)),process.on("unhandledRejection",Me=>(0,E.onUnexpectedError)(Me)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,f.registerContextMenuListener)(),w.app.on("accessibility-support-changed",(Me,Ie)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),w.app.on("activate",async(Me,Ie)=>{this.logService.trace("app#activate"),Ie||await this.windowsMainService?.openEmptyWindow({context:1})}),w.app.on("web-contents-created",(Me,Ie)=>{Ie.on("will-navigate",Oe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Oe.preventDefault()}),Ie.setWindowOpenHandler(({url:Oe})=>(this.nativeHostMainService?.openExternal(void 0,Oe),{action:"deny"}))});let be=[],Pe;w.app.on("open-file",(Me,Ie)=>{this.logService.trace("app#open-file: ",Ie),Me.preventDefault(),be.push((0,Ve.hasWorkspaceFileExtension)(Ie)?{workspaceUri:p.URI.file(Ie)}:{fileUri:p.URI.file(Ie)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:be,gotoLineMode:!1,preferNewWindow:!0}),be=[],Pe=void 0},100)}),w.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Me=>{const Ie=this.windowsMainService?.getWindowByWebContents(Me.sender);let Oe,$e;return Ie?.config?(Oe=Ie.config,$e={...process.env,...Ie.config.userEnv}):(Oe=this.environmentMainService.args,$e=process.env),this.resolveShellEnvironment(Oe,$e,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Me,Ie,Oe)=>{const $e=this.validateNlsPath([Ie]);if(!$e||typeof Oe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile($e,R.VSBuffer.fromString(Oe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Me,...Ie)=>{const Oe=this.validateNlsPath(Ie);if(!Oe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Oe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Me=>Me.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Me=>Me.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Me=>Me.sender.reload())}validateNlsPath(be){let Pe;for(const Me of be)typeof Me=="string"&&(typeof Pe!="string"?Pe=Me:Pe=(0,h.join)(Pe,Me));if(!(typeof Pe!="string"||!(0,h.isAbsolute)(Pe)||!(0,l.isEqualOrParent)(Pe,this.environmentMainService.cachedLanguagesPath,!b.isLinux)))return p.URI.file(Pe)}onUnexpectedError(be){if(be){const Pe={message:`[uncaught exception in main]: ${be.message}`,stack:be.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${be}`),be.stack&&this.logService.error(be.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const be=this.productService.win32AppUserModelId;b.isWindows&&be&&w.app.setAppUserModelId(be);try{b.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!w.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&w.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(_e){this.logService.error(_e)}const Pe=new i.Server;this.lifecycleMainService.onWillShutdown(_e=>{_e.reason===2&&Pe.dispose()}),this.logService.trace("Resolving machine identifier...");const Me=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Me}`);const{sharedProcess:Ie,sharedProcessReady:Oe,sharedProcessClient:$e}=this.setupSharedProcess(Me),Ze=await this.initServices(Me,Ie,Oe);this.setUpHandlers(Ze),Ze.invokeFunction(_e=>this.initChannels(_e,Pe,$e)),await Ze.invokeFunction(_e=>this.openFirstWindow(_e,Pe)),Ze.invokeFunction(_e=>this.afterWindowOpen(_e,Ie)),this._register(new Ct.RunOnceScheduler(()=>{this._register((0,Ct.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setUpHandlers(be){this._register(be.createInstance(n.ProxyAuthHandler)),this._register(be.createInstance(Nt.DefaultExtensionsProfileInitHandler)),this._register(be.createInstance(jt.UserDataTransientProfilesHandler))}async resolveMachineId(){let be=this.stateMainService.getItem(X.machineIdKey);return(!be||b.isMacintosh&&be==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(be=await(0,d.getMachineId)(),this.stateMainService.setItem(X.machineIdKey,be)),be}setupSharedProcess(be){const Pe=this._register(this.mainInstantiationService.createInstance(ke.SharedProcess,be,this.userEnv)),Me=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Oe=await Pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new o.Client(Oe,"main")})(),Ie=(async()=>(await Pe.whenReady(),Me))();return{sharedProcess:Pe,sharedProcessReady:Ie,sharedProcessClient:Me}}async initServices(be,Pe,Me){const Ie=new _.ServiceCollection;switch(process.platform){case"win32":Ie.set(Ee.IUpdateService,new L.SyncDescriptor(ze.Win32UpdateService));break;case"linux":b.isLinuxSnap?Ie.set(Ee.IUpdateService,new L.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(Ee.IUpdateService,new L.SyncDescriptor(Ne.LinuxUpdateService));break;case"darwin":Ie.set(Ee.IUpdateService,new L.SyncDescriptor(Te.DarwinUpdateService));break}Ie.set(Se.IWindowsMainService,new L.SyncDescriptor(Re.WindowsMainService,[be,this.userEnv],!1));const Oe=new U.DialogMainService(this.logService);Ie.set(U.IDialogMainService,Oe),Ie.set(re.ILaunchMainService,new L.SyncDescriptor(re.LaunchMainService,void 0,!1)),Ie.set(N.IDiagnosticsMainService,new L.SyncDescriptor(N.DiagnosticsMainService,void 0,!1)),Ie.set(T.IDiagnosticsService,a.ProxyChannel.toService((0,a.getDelayedChannel)(Me.then(tt=>tt.getChannel("diagnostics"))))),Ie.set(V.IIssueMainService,new L.SyncDescriptor(V.IssueMainService,[this.userEnv])),Ie.set($.IEncryptionMainService,new L.SyncDescriptor(Y.EncryptionMainService,[be])),Ie.set(x.IKeyboardLayoutMainService,new L.SyncDescriptor(x.KeyboardLayoutMainService)),Ie.set(fe.INativeHostMainService,new L.SyncDescriptor(fe.NativeHostMainService,[Pe],!1)),Ie.set(I.ICredentialsMainService,new L.SyncDescriptor(at.CredentialsNativeMainService)),Ie.set(pe.IWebviewManagerService,new L.SyncDescriptor(me.WebviewMainService)),Ie.set(ae.IMenubarMainService,new L.SyncDescriptor(ae.MenubarMainService)),Ie.set(he.IExtensionUrlTrustService,new L.SyncDescriptor(G.ExtensionUrlTrustService)),Ie.set(K.IExtensionHostStarter,new L.SyncDescriptor(F.ExtensionHostStarter)),Ie.set(we.IStorageMainService,new L.SyncDescriptor(we.StorageMainService)),Ie.set(we.IApplicationStorageMainService,new L.SyncDescriptor(we.ApplicationStorageMainService)),b.isWindows?Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(W.WindowsExternalTerminalService)):b.isMacintosh?Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(W.MacExternalTerminalService)):b.isLinux&&Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(W.LinuxExternalTerminalService));const $e=new c.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateMainService);Ie.set(s.IBackupMainService,$e);const Ze=new it.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,$e,Oe,this.productService);if(Ie.set(it.IWorkspacesManagementMainService,Ze),Ie.set(et.IWorkspacesService,new L.SyncDescriptor(Xe.WorkspacesMainService,void 0,!1)),Ie.set(He.IWorkspacesHistoryMainService,new L.SyncDescriptor(He.WorkspacesHistoryMainService,void 0,!1)),Ie.set(Ue.IURLService,new L.SyncDescriptor(Q.NativeURLService,void 0,!1)),(0,ye.supportsTelemetry)(this.productService,this.environmentMainService)){const tt=(0,ye.isInternalTelemetry)(this.productService,this.configurationService),_e=(0,a.getDelayedChannel)(Me.then(ot=>ot.getChannel("telemetryAppender"))),Ke=new ce.TelemetryAppenderClient(_e),Qe=(0,Ce.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,be,tt,this.environmentMainService.installSourcePath),Je=(0,ye.getPiiPathsFromEnvironment)(this.environmentMainService),st={appenders:[Ke],commonProperties:Qe,piiPaths:Je,sendErrorTelemetry:!0};Ie.set(X.ITelemetryService,new L.SyncDescriptor(de.TelemetryService,[st],!1))}else Ie.set(X.ITelemetryService,ye.NullTelemetryService);return Ie.set(Wt.IExtensionsProfileScannerService,new L.SyncDescriptor(Wt.ExtensionsProfileScannerService,void 0,!0)),Ie.set($t.IExtensionsScannerService,new L.SyncDescriptor(qt.ExtensionsScannerService,void 0,!0)),await Ct.Promises.settled([$e.initialize(),Ze.initialize()]),this.mainInstantiationService.createChild(Ie)}initChannels(be,Pe,Me){const Ie=a.ProxyChannel.fromService(be.get(re.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Ie);const Oe=a.ProxyChannel.fromService(be.get(N.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Oe);const $e=new Ut.PolicyChannel(be.get(dt.IPolicyService));Pe.registerChannel("policy",$e),Me.then(xe=>xe.registerChannel("policy",$e));const Ze=this.fileService.getProvider(g.Schemas.file);(0,C.assertType)(Ze instanceof j.DiskFileSystemProvider);const tt=new B.DiskFileSystemProviderChannel(Ze,this.logService,this.environmentMainService);Pe.registerChannel(z.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt),Me.then(xe=>xe.registerChannel(z.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt));const _e=a.ProxyChannel.fromService(be.get(vt.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",_e),Me.then(xe=>xe.registerChannel("userDataProfiles",_e));const Ke=new Bt.RequestChannel(be.get(zt.IRequestService));Me.then(xe=>xe.registerChannel("request",Ke));const Qe=new We.UpdateChannel(be.get(Ee.IUpdateService));Pe.registerChannel("update",Qe);const Je=a.ProxyChannel.fromService(be.get(V.IIssueMainService));Pe.registerChannel("issue",Je);const st=a.ProxyChannel.fromService(be.get($.IEncryptionMainService));Pe.registerChannel("encryption",st);const ot=a.ProxyChannel.fromService(be.get(I.ICredentialsMainService));Pe.registerChannel("credentials",ot);const Pt=a.ProxyChannel.fromService(be.get(Ae.ISignService));Pe.registerChannel("sign",Pt);const Ye=a.ProxyChannel.fromService(be.get(x.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",Ye),this.nativeHostMainService=be.get(fe.INativeHostMainService);const ft=a.ProxyChannel.fromService(this.nativeHostMainService);Pe.registerChannel("nativeHost",ft),Me.then(xe=>xe.registerChannel("nativeHost",ft));const gt=a.ProxyChannel.fromService(be.get(et.IWorkspacesService));Pe.registerChannel("workspaces",gt);const St=a.ProxyChannel.fromService(be.get(ae.IMenubarMainService));Pe.registerChannel("menubar",St);const kt=a.ProxyChannel.fromService(be.get(Ue.IURLService));Pe.registerChannel("url",kt);const Mt=a.ProxyChannel.fromService(be.get(he.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",Mt);const mt=a.ProxyChannel.fromService(be.get(pe.IWebviewManagerService));Pe.registerChannel("webview",mt);const ct=this._register(new ge.StorageDatabaseChannel(this.logService,be.get(we.IStorageMainService)));Pe.registerChannel("storage",ct),Me.then(xe=>xe.registerChannel("storage",ct));const yt=this._register(new Ht.ProfileStorageChangesListenerChannel(be.get(we.IStorageMainService),be.get(vt.IUserDataProfilesMainService),this.logService));Me.then(xe=>xe.registerChannel("profileStorageListener",yt));const pt=a.ProxyChannel.fromService(be.get(A.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",pt);const Ge=new ne.LogLevelChannel(be.get(ie.ILogService));Pe.registerChannel("logLevel",Ge),Me.then(xe=>xe.registerChannel("logLevel",Ge));const rt=new ne.LoggerChannel(be.get(ie.ILoggerService));Pe.registerChannel("logger",rt),Me.then(xe=>xe.registerChannel("logger",rt));const lt=new D.ElectronExtensionHostDebugBroadcastChannel(be.get(Se.IWindowsMainService),be.get(vt.IUserDataProfilesMainService));Pe.registerChannel("extensionhostdebugservice",lt);const wt=a.ProxyChannel.fromService(be.get(K.IExtensionHostStarter));Pe.registerChannel(K.ipcExtensionHostStarterChannelName,wt)}async openFirstWindow(be,Pe){const Me=this.windowsMainService=be.get(Se.IWindowsMainService),Ie=be.get(Ue.IURLService),Oe=be.get(fe.INativeHostMainService);this.lifecycleMainService.phase=2;const $e=[],Ze=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ge=>{try{return{uri:p.URI.parse(Ge),url:Ge}}catch{return}}).filter(Ge=>{if(!Ge||this.shouldBlockURI(Ge.uri))return!1;const rt=this.getWindowOpenableFromProtocolLink(Ge.uri);return rt?($e.push(rt),!1):!0}),tt=this,_e=this.environmentMainService,Ke=this.productService,Qe=this.logService;Ie.registerHandler({async handleURL(Ge,rt){if(Qe.trace("app#handleURL: ",Ge.toString(!0),rt),Ge.scheme===Ke.urlProtocol&&Ge.path==="workspace"&&(Ge=Ge.with({authority:"file",path:p.URI.parse(Ge.query).path,query:""})),tt.shouldBlockURI(Ge))return!0;let lt=!1;const wt=new URLSearchParams(Ge.query);wt.get("windowId")==="_blank"&&(wt.delete("windowId"),Ge=Ge.with({query:wt.toString()}),lt=!0),lt||=b.isMacintosh&&Me.getWindowCount()===0;const xe=tt.getWindowOpenableFromProtocolLink(Ge);if(Qe.trace("app#handleURL: windowOpenableFromProtocolLink = ",xe),xe){const[Dt]=await Me.open({context:5,cli:{..._e.args},urisToOpen:[xe],forceNewWindow:lt,gotoLineMode:!0});return Dt.focus(),!0}if(lt){const[Dt]=await Me.open({context:5,cli:{..._e.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Le.getRemoteAuthority)(Ge)});return await Dt.ready(),Ie.open(Ge,rt)}return!1}});const Je=this._register(new Fe.ActiveWindowManager({onDidOpenWindow:Oe.onDidOpenWindow,onDidFocusWindow:Oe.onDidFocusWindow,getActiveWindowId:()=>Oe.getActiveWindowId(-1)})),st=new a.StaticRouter(Ge=>Je.getActiveClientId().then(rt=>Ge===rt)),ot=new qe.URLHandlerRouter(st),Pt=Pe.getChannel("urlHandler",ot);Ie.registerHandler(new qe.URLHandlerChannelClient(Pt)),this._register(new le.ElectronURLListener(Ze,Ie,Me,this.environmentMainService,this.productService));const Ye=this.environmentMainService.args,ft=global.macOpenFiles,gt=(0,ue.isLaunchedFromCli)(process.env)?0:4,St=Ye._.length,kt=!!Ye["folder-uri"],Mt=!!Ye["file-uri"],mt=Ye["skip-add-to-recently-opened"]===!0,ct=Ye.wait&&Ye.waitMarkerFilePath?p.URI.file(Ye.waitMarkerFilePath):void 0,yt=Ye.remote||void 0;if($e.length>0)return Me.open({context:gt,cli:Ye,urisToOpen:$e,gotoLineMode:!0,initialStartup:!0});const pt=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(this.environmentMainService.args);if(!St&&!kt&&!Mt){if(Ye["new-window"]||pt)return Me.open({context:gt,cli:Ye,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:mt,waitMarkerFileURI:ct,initialStartup:!0,remoteAuthority:yt,profile:pt});if(ft.length)return Me.open({context:1,cli:Ye,urisToOpen:ft.map(Ge=>(0,Ve.hasWorkspaceFileExtension)(Ge)?{workspaceUri:p.URI.file(Ge)}:{fileUri:p.URI.file(Ge)}),noRecentEntry:mt,waitMarkerFileURI:ct,initialStartup:!0})}return Me.open({context:gt,cli:Ye,forceNewWindow:Ye["new-window"]||!St&&Ye["unity-launch"],diffMode:Ye.diff,mergeMode:Ye.merge,noRecentEntry:mt,waitMarkerFileURI:ct,gotoLineMode:Ye.goto,initialStartup:!0,remoteAuthority:yt,profile:pt})}shouldBlockURI(be){return!!(be.authority===g.Schemas.file&&b.isWindows&&w.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,y.mnemonicButtonLabel)((0,r.localize)(0,null)),(0,y.mnemonicButtonLabel)((0,r.localize)(1,null))],defaultId:0,cancelId:1,message:(0,r.localize)(2,null,(0,y.getPathLabel)(be,{os:b.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,r.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(be){if(!!be.path){if(be.authority===g.Schemas.file){const Pe=p.URI.file(be.fsPath);return(0,Ve.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(be.authority===g.Schemas.vscodeRemote){const Pe=be.path.indexOf(h.posix.sep,1);if(Pe!==-1){const Me=be.path.substring(1,Pe),Ie=be.path.substring(Pe),Oe=p.URI.from({scheme:g.Schemas.vscodeRemote,authority:Me,path:Ie,query:be.query,fragment:be.fragment});return(0,Ve.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Oe}:/:[\d]+$/.test(Ie)?{fileUri:Oe}:{folderUri:Oe}}}}}afterWindowOpen(be,Pe){const Me=be.get(X.ITelemetryService),Ie=be.get(Ee.IUpdateService);this.lifecycleMainService.phase=3,this.handleSharedProcessErrors(Me,Pe),this.installMutex(),w.protocol.registerHttpProtocol(g.Schemas.vscodeRemoteResource,(Oe,$e)=>{$e({url:Oe.url.replace(/^vscode-remote-resource:/,"http:"),method:Oe.method})}),(Ie instanceof ze.Win32UpdateService||Ie instanceof Ne.LinuxUpdateService||Ie instanceof Te.DarwinUpdateService)&&Ie.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const be=this.productService.win32MutexName;if(b.isWindows&&be)try{const Pe=await new Promise((Ie,Oe)=>{q(["windows-mutex"],Ie,Oe)}),Me=new Pe.Mutex(be);(0,m.once)(this.lifecycleMainService.onWillShutdown)(()=>Me.release())}catch(Pe){this.logService.error(Pe)}}handleSharedProcessErrors(be,Pe){let Me=!1;(0,m.once)(this.lifecycleMainService.onWillShutdown)(()=>Me=!0),this._register(Pe.onDidError(({type:Ie,details:Oe})=>{let $e;switch(Ie){case 1:$e="SharedProcess: detected unresponsive window";break;case 2:$e=`SharedProcess: renderer process gone (detail: ${Oe?.reason??"<unknown>"}, code: ${Oe?.exitCode??"<unknown>"})`;break;case 3:$e=`SharedProcess: failed to load (detail: ${Oe?.reason??"<unknown>"}, code: ${Oe?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error($e)),be.publicLog2("sharedprocesserror",{type:Ie,reason:Oe?.reason,code:Oe?.exitCode,visible:Pe.isVisible(),shuttingdown:Me})}))}async resolveShellEnvironment(be,Pe,Me){try{return await(0,se.getResolvedShellEnv)(this.logService,be,Pe)}catch(Ie){const Oe=(0,M.toErrorMessage)(Ie);Me?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Oe):this.logService.error(Oe)}return{}}async updateCrashReporterEnablement(){try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Me=JSON.parse((0,P.stripComments)(Pe)),Oe=(0,ye.getTelemetryLevel)(this.configurationService)>=1;if(Me["enable-crash-reporter"]===void 0){const $e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Oe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.generateUuid)()}"`,"}"],Ze=Pe.substring(0,Pe.length-2).concat(`,
`,$e.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Ze))}else{const $e=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Oe},`);$e!==Pe&&await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString($e))}}catch(be){this.logService.error(be)}}};It=ve([J(2,O.IInstantiationService),J(3,ie.ILogService),J(4,oe.IEnvironmentMainService),J(5,H.ILifecycleMainService),J(6,u.IConfigurationService),J(7,je.IStateMainService),J(8,te.IFileService),J(9,De.IProductService),J(10,vt.IUserDataProfilesMainService)],It),e.CodeApplication=It}),define(Z[272],ee([0,1,37,8,279,2]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class M extends w.AbstractPolicyService{constructor(l){super(),this.productName=l,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(l){await this.throttler.queue(()=>new Promise((m,P)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,l,y=>{for(const S in y){const g=y[S];g===void 0?this.policies.delete(S):this.policies.set(S,g)}this._onDidChange.fire(Object.keys(y)),m()})}catch(y){P(y)}}))}}e.NativePolicyService=M}),define(Z[273],ee([0,1,223,8,18,17,2,12,19,35,112,6,222,280]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let h=class extends M.Disposable{constructor(C,p,v){super(),this.environmentService=p,this.logService=v,this.configure(C.getValue()),this._register(C.onDidChangeConfiguration(()=>this.configure(C.getValue()),this))}configure(C){this.proxyUrl=C.http&&C.http.proxy,this.strictSSL=!!(C.http&&C.http.proxyStrictSSL),this.authorization=C.http&&C.http.proxyAuthorization}async request(C,p){this.logService.trace("RequestService#request (node) - begin",C.url);const{proxyUrl:v,strictSSL:d}=this;let f;try{f=await(0,P.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",o))}const a={...process.env,...f},i=C.agent?C.agent:await(0,S.getProxyAgent)(C.url||"",a,{proxyUrl:v,strictSSL:d});C.agent=i,C.strictSSL=d,this.authorization&&(C.headers={...C.headers||{},"Proxy-Authorization":this.authorization});try{const o=await this._request(C,p);return this.logService.trace("RequestService#request (node) - success",C.url),o}catch(o){throw this.logService.trace("RequestService#request (node) - error",C.url,o),o}}async getNodeRequest(C){return((0,w.parse)(C.url).protocol==="https:"?await new Promise((d,f)=>{q(["https"],d,f)}):await new Promise((d,f)=>{q(["http"],d,f)})).request}_request(C,p){return t.Promises.withAsyncBody(async(v,d)=>{const f=(0,w.parse)(C.url),a=C.getRawRequest?C.getRawRequest(C):await this.getNodeRequest(C),i={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:C.type||"GET",headers:C.headers,agent:C.agent,rejectUnauthorized:(0,E.isBoolean)(C.strictSSL)?C.strictSSL:!0};C.user&&C.password&&(i.auth=C.user+":"+C.password);const o=a(i,n=>{const r=(0,E.isNumber)(C.followRedirects)?C.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&r>0&&n.headers.location)this._request({...C,url:n.headers.location,followRedirects:r-1},p).then(v,d);else{let s=n;n.headers["content-encoding"]==="gzip"&&(s=n.pipe((0,g.createGunzip)())),v({res:n,stream:(0,k.streamToBufferReadableStream)(s)})}});o.on("error",d),C.timeout&&o.setTimeout(C.timeout),C.data&&typeof C.data=="string"&&o.write(C.data),o.end(),p.onCancellationRequested(()=>{o.abort(),d(new R.CancellationError)})})}async resolveProxy(C){}};h=ve([J(0,l.IConfigurationService),J(1,m.INativeEnvironmentService),J(2,y.ILogService)],h),e.RequestService=h}),define(Z[274],ee([0,1,15,273]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(M){return w.net.request}class R extends t.RequestService{request(E,l){return super.request({...E||{},getRawRequest:k},l)}}e.RequestMainService=R}),define(Z[281],ee([0,1,15,40,7,24,8,44,17,30,49,34,13,9,71,4,33,25,23,46,83,271,10,19,216,229,26,59,185,14,204,86,68,201,85,21,107,6,209,108,54,20,61,253,114,235,55,274,87,224,38,228,73,64,42,37,272,211,2,51,240,39,236]),function(q,e,w,t,k,R,M,E,l,m,P,y,S,g,h,b,C,p,v,d,f,a,i,o,n,r,s,c,u,I,D,T,N,U,$,Y,oe,ue,se,he,G,K,F,A,W,z,te,B,j,L,O,_,V,x,re,H,ie,ne,ae,fe,De,Le){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ke{main(){try{this.startup()}catch(ge){console.error(ge.message),w.app.exit(1)}}async startup(){(0,l.setUnexpectedErrorHandler)(We=>console.error(We));const[ge,we,Ce,X,ce,de,ye,Ee]=this.createServices();try{try{await this.initServices(Ce,Ee,X,ce,ye)}catch(We){throw this.handleStartupDataDirError(Ce,ye.nameLong,We),We}await ge.invokeFunction(async We=>{const Te=We.get(ue.ILogService),Ne=We.get(Y.ILifecycleMainService),Be=We.get(I.IFileService),ze=await this.claimInstance(Te,Ce,Ne,ge,ye,!0);return v.Promises.writeFile(Ce.mainLockfile,String(process.pid)).catch(Ue=>{Te.warn(`Error writing main lockfile: ${Ue.stack}`)}),de.logger=new he.SpdLogLogger("main",(0,g.join)(Ce.logsPath,"main.log"),!0,!1,de.getLevel()),(0,P.once)(Ne.onWillShutdown)(Ue=>{Be.dispose(),X.dispose(),Ue.join(v.Promises.unlink(Ce.mainLockfile).catch(()=>{}))}),ge.createInstance(a.CodeApplication,ze,we).startup()})}catch(We){ge.invokeFunction(this.quit,We)}}createServices(){const ge=new $.ServiceCollection,we=new ae.DisposableStore;process.once("exit",()=>we.dispose());const Ce={_serviceBrand:void 0,...G.default};ge.set(K.IProductService,Ce);const X=new s.EnvironmentMainService(this.resolveArgs(),Ce),ce=this.patchEnvironment(X);ge.set(s.IEnvironmentMainService,X);const de=new oe.BufferLogService,ye=we.add(new ue.MultiplexLogService([new ue.ConsoleMainLogger((0,ue.getLogLevel)(X)),de]));ge.set(ue.ILogService,ye);const Ee=new D.FileService(ye);ge.set(I.IFileService,Ee);const We=new T.DiskFileSystemProvider(ye);Ee.registerProvider(S.Schemas.file,We);const Te=new De.UriIdentityService(Ee);ge.set(fe.IUriIdentityService,Te),ge.set(ue.ILoggerService,new se.LoggerService(ye,Ee));const Ne=new _.StateMainService(X,ye,Ee);ge.set(O.IStateMainService,Ne);const Be=new re.UserDataProfilesMainService(Ne,Te,X,Ee,ye);ge.set(re.IUserDataProfilesMainService,Be);const ze=b.isWindows&&Ce.win32RegValueName?we.add(new ie.NativePolicyService(Ce.win32RegValueName)):X.policyFile?we.add(new ne.FilePolicyService(X.policyFile,Ee,ye)):new H.NullPolicyService;ge.set(H.IPolicyService,ze);const Ue=new n.ConfigurationService(Be.defaultProfile.settingsResource,Ee,ze,ye);return ge.set(o.IConfigurationService,Ue),ge.set(Y.ILifecycleMainService,new N.SyncDescriptor(Y.LifecycleMainService,void 0,!1)),ge.set(te.IRequestService,new N.SyncDescriptor(B.RequestMainService,void 0,!0)),ge.set(x.IThemeMainService,new N.SyncDescriptor(x.ThemeMainService)),ge.set(j.ISignService,new N.SyncDescriptor(L.SignService,void 0,!1)),ge.set(W.ITunnelService,new N.SyncDescriptor(z.TunnelService)),ge.set(F.IProtocolMainService,new A.ProtocolMainService(X,Be,ye)),[new U.InstantiationService(ge,!0),ce,X,Ue,Ne,de,Ce,Be]}patchEnvironment(ge){const we={VSCODE_IPC_HOOK:ge.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ce=>{const X=process.env[Ce];typeof X=="string"&&(we[Ce]=X)}),Object.assign(process.env,we),we}async initServices(ge,we,Ce,X,ce){await M.Promises.settled([Promise.all([ge.extensionsPath,ge.codeCachePath,ge.logsPath,we.defaultProfile.globalStorageHome.fsPath,ge.workspaceStorageHome.fsPath,ge.localHistoryHome.fsPath,ge.backupHome].map(de=>de?v.Promises.mkdir(de,{recursive:!0}):void 0)),X.init(),Ce.initialize()]),we.setEnablement(ce.quality!=="stable"||Ce.getValue(Le.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(ge,we,Ce,X,ce,de){let ye;try{(0,h.mark)("code/willStartMainServer"),ye=await(0,f.serve)(we.mainIPCHandle),(0,h.mark)("code/didStartMainServer"),(0,P.once)(Ce.onWillShutdown)(()=>ye.dispose())}catch(Ee){if(Ee.code!=="EADDRINUSE")throw this.handleStartupDataDirError(we,ce.nameLong,Ee),Ee;let We;try{We=await(0,f.connect)(we.mainIPCHandle,"main")}catch(ze){if(!de||b.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.showStartupWarningDialog((0,i.localize)(0,null,ce.nameShort),(0,i.localize)(1,null),ce.nameLong),ze;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(Ue){throw ge.warn("Could not delete obsolete instance handle",Ue),Ue}return this.claimInstance(ge,we,Ce,X,ce,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const ze="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ge.error(ze),We.dispose(),new Error(ze)}let Te;!we.args.wait&&!we.args.status&&(Te=setTimeout(()=>{this.showStartupWarningDialog((0,i.localize)(2,null,ce.nameShort),(0,i.localize)(3,null),ce.nameLong)},1e4));const Ne=d.ProxyChannel.toService(We.getChannel("launch"),{disableMarshalling:!0}),Be=d.ProxyChannel.toService(We.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return X.invokeFunction(async()=>{const ze=new r.DiagnosticsService(V.NullTelemetryService,ce),Ue=await Be.getMainDiagnostics(),qe=await Be.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Q=await ze.getDiagnostics(Ue,qe);throw console.log(Q),new l.ExpectedError});throw b.isWindows&&await this.windowsAllowSetForegroundWindow(Ne,ge),ge.trace("Sending env to running instance..."),await Ne.start(we.args,process.env),We.dispose(),Te&&clearTimeout(Te),new l.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw ge.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new l.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ye}handleStartupDataDirError(ge,we,Ce){if(Ce.code==="EACCES"||Ce.code==="EPERM"){const X=(0,R.coalesce)([ge.userDataPath,ge.extensionsPath,f.XDG_RUNTIME_DIR]).map(ce=>(0,y.getPathLabel)(k.URI.file(ce),{os:b.OS,tildify:ge}));this.showStartupWarningDialog((0,i.localize)(4,null),(0,i.localize)(5,null,(0,E.toErrorMessage)(Ce),X.join(`
`)),we)}}showStartupWarningDialog(ge,we,Ce){w.dialog.showMessageBoxSync({title:Ce,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,i.localize)(6,null))],message:ge,detail:we,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ge,we){if(b.isWindows){const Ce=await ge.getMainProcessId();we.trace("Sending some foreground love to the running instance:",Ce);try{(await new Promise((X,ce)=>{q(["windows-foreground-love"],X,ce)})).allowSetForegroundWindow(Ce)}catch(X){we.error(X)}}}quit(ge,we){const Ce=ge.get(ue.ILogService),X=ge.get(Y.ILifecycleMainService);let ce=0;we&&(we.isExpected?we.message&&Ce.trace(we.message):(ce=1,we.stack?Ce.error(we.stack):Ce.error(`Startup error: ${we.toString()}`))),X.kill(ce)}resolveArgs(){const ge=this.validatePaths((0,c.parseMainProcessArgv)(process.argv));if(ge.wait&&!ge.waitMarkerFilePath){const we=(0,u.createWaitMarkerFileSync)(ge.verbose);we&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",we),ge.waitMarkerFilePath=we)}return ge}validatePaths(ge){if(ge["open-url"]&&(ge._urls=ge._,ge._=[]),!ge.remote){const we=this.doValidatePaths(ge._,ge.goto);ge._=we}return ge}doValidatePaths(ge,we){const Ce=(0,C.cwd)(),X=ge.map(ye=>{let Ee=String(ye),We;we&&(We=(0,m.parseLineAndColumnAware)(Ee),Ee=We.path),Ee&&(Ee=this.preparePath(Ce,Ee));const Te=(0,m.sanitizeFilePath)(Ee,Ce),Ne=(0,g.basename)(Te);return Ne&&!(0,m.isValidBasename)(Ne)?null:we&&We?(We.path=Te,this.toPath(We)):Te}),ce=b.isWindows||b.isMacintosh,de=(0,R.distinct)(X,ye=>ye&&ce?ye.toLowerCase():ye||"");return(0,R.coalesce)(de)}preparePath(ge,we){return b.isWindows&&(we=(0,p.rtrim)(we,'"')),we=(0,p.trim)((0,p.trim)(we," "),"	"),b.isWindows&&(we=(0,g.resolve)(ge,we),we=(0,p.rtrim)(we,".")),we}toPath(ge){const we=[ge.path];return typeof ge.line=="number"&&we.push(String(ge.line)),typeof ge.column=="number"&&we.push(String(ge.column)),we.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/cfc01197555cb14a0d2d3463b331ce41de5733be/core/vs/code/electron-main/main.js.map
