/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/platform","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/severity","vs/platform/files/common/files","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","fs","vs/editor/common/languages","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/hash","vs/base/common/normalization","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(J){for(var e=[],l=0,t=J.length;l<t;l++)e[l]=De[J[l]];return e};define(De[74],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function l(_){return _?_.replace(/\$\((.*?)\)/g,(k,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=l;class t{constructor(k,w,I){this.id=k,this.definition=w,this.description=I,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(_,k){const w=["codicon","codicon-"+_];return k&&w.push("codicon-modifier-"+k),w}e.getClassNamesArray=D;var P;(function(_){_.iconNameSegment="[A-Za-z0-9]+",_.iconNameExpression="[A-Za-z0-9-]+",_.iconModifierExpression="~[A-Za-z]+",_.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${_.iconNameExpression})(${_.iconModifierExpression})?$`);function w(y){if(y instanceof t)return["codicon","codicon-"+y.id];const S=k.exec(y.id);if(!S)return w(t.error);const[,T,E]=S,p=["codicon","codicon-"+T];return E&&p.push("codicon-modifier-"+E.substr(1)),p}_.asClassNameArray=w;function I(y){return w(y).join(" ")}_.asClassName=I;function L(y){return"."+w(y).join(".")}_.asCSSSelector=L})(P=e.CSSIcon||(e.CSSIcon={}))}),define(De[75],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function l(_,k){const w=Object.create(null);for(const I of _){const L=k(I);let y=w[L];y||(y=w[L]=[]),y.push(I)}return w}e.groupBy=l;function t(_,k){const w=[],I=[];for(const L of _)k.has(L)||w.push(L);for(const L of k)_.has(L)||I.push(L);return{removed:w,added:I}}e.diffSets=t;function D(_,k){const w=[],I=[];for(const[L,y]of _)k.has(L)||w.push(y);for(const[L,y]of k)_.has(L)||I.push(y);return{removed:w,added:I}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(k,w){let I=this.map.get(k);I||(I=new Set,this.map.set(k,I)),I.add(w)}delete(k,w){const I=this.map.get(k);!I||(I.delete(w),I.size===0&&this.map.delete(k))}forEach(k,w){const I=this.map.get(k);!I||I.forEach(w)}}e.SetMap=P}),define(De[58],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function l(_){return(k,w,I)=>{let L=null,y=null;if(typeof I.value=="function"?(L="value",y=I.value):typeof I.get=="function"&&(L="get",y=I.get),!y)throw new Error("not supported");I[L]=_(y,w)}}e.createDecorator=l;function t(_,k,w){let I=null,L=null;if(typeof w.value=="function"?(I="value",L=w.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(I="get",L=w.get),!L)throw new Error("not supported");const y=`$memoize$${k}`;w[I]=function(...S){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,S)}),this[y]}}e.memoize=t;function D(_,k,w){return l((I,L)=>{const y=`$debounce$${L}`,S=`$debounce$result$${L}`;return function(...T){this[S]||(this[S]=w?w():void 0),clearTimeout(this[y]),k&&(this[S]=k(this[S],...T),T=[this[S]]),this[y]=setTimeout(()=>{I.apply(this,T),this[S]=w?w():void 0},_)}})}e.debounce=D;function P(_,k,w){return l((I,L)=>{const y=`$throttle$timer$${L}`,S=`$throttle$result$${L}`,T=`$throttle$lastRun$${L}`,E=`$throttle$pending$${L}`;return function(...p){if(this[S]||(this[S]=w?w():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),k&&(this[S]=k(this[S],...p)),this[E])return;const b=this[T]+_;b<=Date.now()?(this[T]=Date.now(),I.apply(this,[this[S]]),this[S]=w?w():void 0):(this[E]=!0,this[y]=setTimeout(()=>{this[E]=!1,this[T]=Date.now(),I.apply(this,[this[S]]),this[S]=w?w():void 0},b-Date.now()))}})}e.throttle=P}),define(De[10],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class l{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?g.isErrorNoTelemetry(n)?new g(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(d=>{d(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=l,e.errorHandler=new l;function t(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=t;function D(m){w(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=D;function P(m){w(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=P;function _(m){if(m instanceof Error){const{name:n,message:d}=m,s=m.stacktrace||m.stack;return{$isError:!0,name:n,message:d,stack:s,noTelemetry:g.isErrorNoTelemetry(m)}}return m}e.transformErrorForSerialization=_;const k="Canceled";function w(m){return m instanceof I?!0:m instanceof Error&&m.name===k&&m.message===k}e.isCancellationError=w;class I extends Error{constructor(){super(k),this.name=this.message}}e.CancellationError=I;function L(){const m=new Error(k);return m.name=m.message,m}e.canceled=L;function y(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=y;function S(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=S;function T(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=T;function E(m){const n=new Error(`${m} has been disposed`);return n.name="DISPOSED",n}e.disposed=E;function p(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=p;class b extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=b;class f extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=f;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class g extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof g)return n;const d=new g;return d.message=n.message,d.stack=n.stack,d}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=g;class c extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype);debugger}}e.BugIndicatingError=c}),define(De[17],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(oe,le=0){return oe[oe.length-(1+le)]}e.tail=t;function D(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=D;function P(oe,le,fe=(Z,ae)=>Z===ae){if(oe===le)return!0;if(!oe||!le||oe.length!==le.length)return!1;for(let Z=0,ae=oe.length;Z<ae;Z++)if(!fe(oe[Z],le[Z]))return!1;return!0}e.equals=P;function _(oe,le){const fe=oe.length-1;le<fe&&(oe[le]=oe[fe]),oe.pop()}e.removeFastWithoutKeepingOrder=_;function k(oe,le,fe){return w(oe.length,Z=>fe(oe[Z],le))}e.binarySearch=k;function w(oe,le){let fe=0,Z=oe-1;for(;fe<=Z;){const ae=(fe+Z)/2|0,ne=le(ae);if(ne<0)fe=ae+1;else if(ne>0)Z=ae-1;else return ae}return-(fe+1)}e.binarySearch2=w;function I(oe,le){let fe=0,Z=oe.length;if(Z===0)return 0;for(;fe<Z;){const ae=Math.floor((fe+Z)/2);le(oe[ae])?Z=ae:fe=ae+1}return fe}e.findFirstInSorted=I;function L(oe,le,fe){if(oe=oe|0,oe>=le.length)throw new TypeError("invalid index");const Z=le[Math.floor(le.length*Math.random())],ae=[],ne=[],ie=[];for(const O of le){const V=fe(O,Z);V<0?ae.push(O):V>0?ne.push(O):ie.push(O)}return oe<ae.length?L(oe,ae,fe):oe<ae.length+ie.length?ie[0]:L(oe-(ae.length+ie.length),ne,fe)}e.quickSelect=L;function y(oe,le){const fe=[];let Z;for(const ae of oe.slice(0).sort(le))!Z||le(Z[0],ae)!==0?(Z=[ae],fe.push(Z)):Z.push(ae);return fe}e.groupBy=y;function S(oe,le,fe){const Z=[];function ae(O,V,q){if(V===0&&q.length===0)return;const K=Z[Z.length-1];K&&K.start+K.deleteCount===O?(K.deleteCount+=V,K.toInsert.push(...q)):Z.push({start:O,deleteCount:V,toInsert:q})}let ne=0,ie=0;for(;;){if(ne===oe.length){ae(ne,0,le.slice(ie));break}if(ie===le.length){ae(ne,oe.length-ne,[]);break}const O=oe[ne],V=le[ie],q=fe(O,V);q===0?(ne+=1,ie+=1):q<0?(ae(ne,1,[]),ne+=1):q>0&&(ae(ne,0,[V]),ie+=1)}return Z}e.sortedDiff=S;function T(oe,le,fe){const Z=S(oe,le,fe),ae=[],ne=[];for(const ie of Z)ae.push(...oe.slice(ie.start,ie.start+ie.deleteCount)),ne.push(...ie.toInsert);return{removed:ae,added:ne}}e.delta=T;function E(oe,le,fe){if(fe===0)return[];const Z=oe.slice(0,fe).sort(le);return b(oe,le,Z,fe,oe.length),Z}e.top=E;function p(oe,le,fe,Z,ae){return fe===0?Promise.resolve([]):new Promise((ne,ie)=>{(async()=>{const O=oe.length,V=oe.slice(0,fe).sort(le);for(let q=fe,K=Math.min(fe+Z,O);q<O;q=K,K=Math.min(K+Z,O)){if(q>fe&&await new Promise(me=>setTimeout(me)),ae&&ae.isCancellationRequested)throw new l.CancellationError;b(oe,le,V,q,K)}return V})().then(ne,ie)})}e.topAsync=p;function b(oe,le,fe,Z,ae){for(const ne=fe.length;Z<ae;Z++){const ie=oe[Z];if(le(ie,fe[ne-1])<0){fe.pop();const O=I(fe,V=>le(ie,V)<0);fe.splice(O,0,ie)}}}function f(oe){return oe.filter(le=>!!le)}e.coalesce=f;function v(oe){let le=0;for(let fe=0;fe<oe.length;fe++)oe[fe]&&(oe[le]=oe[fe],le+=1);oe.length=le}e.coalesceInPlace=v;function g(oe,le,fe){oe.splice(fe,0,oe.splice(le,1)[0])}e.move=g;function c(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=c;function m(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=m;function n(oe,le=fe=>fe){const fe=new Set;return oe.filter(Z=>{const ae=le(Z);return fe.has(ae)?!1:(fe.add(ae),!0)})}e.distinct=n;function d(oe){const le=new Set;return fe=>{const Z=oe(fe);return le.has(Z)?!1:(le.add(Z),!0)}}e.uniqueFilter=d;function s(oe,le){const fe=i(oe,le);if(fe!==-1)return oe[fe]}e.findLast=s;function i(oe,le){for(let fe=oe.length-1;fe>=0;fe--){const Z=oe[fe];if(le(Z))return fe}return-1}e.lastIndex=i;function r(oe,le){return oe.length>0?oe[0]:le}e.firstOrDefault=r;function a(oe,le){return oe.length>0?oe[oe.length-1]:le}e.lastOrDefault=a;function o(oe,le,fe=(Z,ae)=>Z===ae){let Z=0;for(let ae=0,ne=Math.min(oe.length,le.length);ae<ne&&fe(oe[ae],le[ae]);ae++)Z++;return Z}e.commonPrefixLength=o;function u(oe){return[].concat(...oe)}e.flatten=u;function h(oe,le){let fe=typeof le=="number"?oe:0;typeof le=="number"?fe=oe:(fe=0,le=oe);const Z=[];if(fe<=le)for(let ae=fe;ae<le;ae++)Z.push(ae);else for(let ae=fe;ae>le;ae--)Z.push(ae);return Z}e.range=h;function C(oe,le,fe){return oe.reduce((Z,ae)=>(Z[le(ae)]=fe?fe(ae):ae,Z),Object.create(null))}e.index=C;function R(oe,le){return oe.push(le),()=>N(oe,le)}e.insert=R;function N(oe,le){const fe=oe.indexOf(le);if(fe>-1)return oe.splice(fe,1),le}e.remove=N;function M(oe,le,fe){const Z=oe.slice(0,le),ae=oe.slice(le);return Z.concat(fe,ae)}e.arrayInsert=M;function A(oe,le){let fe;if(typeof le=="number"){let Z=le;fe=()=>{const ae=Math.sin(Z++)*179426549;return ae-Math.floor(ae)}}else fe=Math.random;for(let Z=oe.length-1;Z>0;Z-=1){const ae=Math.floor(fe()*(Z+1)),ne=oe[Z];oe[Z]=oe[ae],oe[ae]=ne}}e.shuffle=A;function z(oe,le){const fe=oe.indexOf(le);fe>-1&&(oe.splice(fe,1),oe.unshift(le))}e.pushToStart=z;function H(oe,le){const fe=oe.indexOf(le);fe>-1&&(oe.splice(fe,1),oe.push(le))}e.pushToEnd=H;function F(oe,le){for(const fe of le)oe.push(fe)}e.pushMany=F;function G(oe,le){return Array.isArray(oe)?oe.map(le):le(oe)}e.mapArrayOrNot=G;function B(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=B;function U(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=U;function X(oe,le){for(const fe of oe){const Z=le(fe);if(Z!==void 0)return Z}}e.mapFind=X;function $(oe,le,fe){const Z=Q(oe,le),ae=oe.length,ne=fe.length;oe.length=ae+ne;for(let ie=ae-1;ie>=Z;ie--)oe[ie+ne]=oe[ie];for(let ie=0;ie<ne;ie++)oe[ie+Z]=fe[ie]}e.insertInto=$;function x(oe,le,fe,Z){const ae=Q(oe,le),ne=oe.splice(ae,fe);return $(oe,ae,Z),ne}e.splice=x;function Q(oe,le){return le<0?Math.max(le+oe.length,0):Math.min(le,oe.length)}var de;(function(oe){function le(ae){return ae<0}oe.isLessThan=le;function fe(ae){return ae>0}oe.isGreaterThan=fe;function Z(ae){return ae===0}oe.isNeitherLessOrGreaterThan=Z,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(de=e.CompareResult||(e.CompareResult={}));function te(oe,le){return(fe,Z)=>le(oe(fe),oe(Z))}e.compareBy=te;function pe(...oe){return(le,fe)=>{for(const Z of oe){const ae=Z(le,fe);if(!de.isNeitherLessOrGreaterThan(ae))return ae}return de.neitherLessOrGreaterThan}}e.tieBreakComparators=pe;const Y=(oe,le)=>oe-le;e.numberComparator=Y;function ve(oe,le){if(oe.length===0)return;let fe=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,fe)>0&&(fe=ae)}return fe}e.findMaxBy=ve;function be(oe,le){if(oe.length===0)return;let fe=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,fe)>=0&&(fe=ae)}return fe}e.findLastMaxBy=be;function ke(oe,le){return ve(oe,(fe,Z)=>-le(fe,Z))}e.findMinBy=ke;class Re{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let fe=this.firstIdx;for(;fe<this.items.length&&le(this.items[fe]);)fe++;const Z=fe===this.firstIdx?null:this.items.slice(this.firstIdx,fe);return this.firstIdx=fe,Z}takeFromEndWhile(le){let fe=this.lastIdx;for(;fe>=0&&le(this.items[fe]);)fe--;const Z=fe===this.lastIdx?null:this.items.slice(fe+1,this.lastIdx+1);return this.lastIdx=fe,Z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const le=this.items[this.firstIdx];return this.firstIdx++,le}removeLast(){const le=this.items[this.lastIdx];return this.lastIdx--,le}takeCount(le){const fe=this.items.slice(this.firstIdx,this.firstIdx+le);return this.firstIdx+=le,fe}}e.ArrayQueue=Re;class We{constructor(le){this.iterate=le}forEach(le){this.iterate(fe=>(le(fe),!0))}toArray(){const le=[];return this.iterate(fe=>(le.push(fe),!0)),le}filter(le){return new We(fe=>this.iterate(Z=>le(Z)?fe(Z):!0))}map(le){return new We(fe=>this.iterate(Z=>fe(le(Z))))}some(le){let fe=!1;return this.iterate(Z=>(fe=le(Z),!fe)),fe}findFirst(le){let fe;return this.iterate(Z=>le(Z)?(fe=Z,!1):!0),fe}findLast(le){let fe;return this.iterate(Z=>(le(Z)&&(fe=Z),!0)),fe}findLastMaxBy(le){let fe,Z=!0;return this.iterate(ae=>((Z||de.isGreaterThan(le(ae,fe)))&&(Z=!1,fe=ae),!0)),fe}}e.CallbackIterable=We,We.empty=new We(oe=>{})}),define(De[48],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(w,I){if(!w)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=t;function D(w,I="Unreachable"){throw new Error(I)}e.assertNever=D;function P(w){if(!w)throw new l.BugIndicatingError("Assertion Failed")}e.assert=P;function _(w){if(!w()){debugger;w(),(0,l.onUnexpectedError)(new l.BugIndicatingError("Assertion Failed"))}}e.assertFn=_;function k(w,I){let L=0;for(;L<w.length-1;){const y=w[L],S=w[L+1];if(!I(y,S))return!1;L++}return!0}e.checkAdjacentItems=k}),define(De[59],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function l(t){const D=this;let P=!1,_;return function(){return P||(P=!0,_=t.apply(D,arguments)),_}}e.once=l}),define(De[95],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class l{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=l,e.defaultGenerator=new l("id#")}),define(De[60],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var l;(function(t){function D(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}t.is=D;const P=Object.freeze([]);function _(){return P}t.empty=_;function*k(d){yield d}t.single=k;function w(d){return d||P}t.from=w;function I(d){return!d||d[Symbol.iterator]().next().done===!0}t.isEmpty=I;function L(d){return d[Symbol.iterator]().next().value}t.first=L;function y(d,s){for(const i of d)if(s(i))return!0;return!1}t.some=y;function S(d,s){for(const i of d)if(s(i))return i}t.find=S;function*T(d,s){for(const i of d)s(i)&&(yield i)}t.filter=T;function*E(d,s){let i=0;for(const r of d)yield s(r,i++)}t.map=E;function*p(...d){for(const s of d)for(const i of s)yield i}t.concat=p;function*b(d){for(const s of d)for(const i of s)yield i}t.concatNested=b;function f(d,s,i){let r=i;for(const a of d)r=s(r,a);return r}t.reduce=f;function v(d,s){let i=0;for(const r of d)s(r,i++)}t.forEach=v;function*g(d,s,i=d.length){for(s<0&&(s+=d.length),i<0?i+=d.length:i>d.length&&(i=d.length);s<i;s++)yield d[s]}t.slice=g;function c(d,s=Number.POSITIVE_INFINITY){const i=[];if(s===0)return[i,d];const r=d[Symbol.iterator]();for(let a=0;a<s;a++){const o=r.next();if(o.done)return[i,t.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return r}}]}t.consume=c;function m(d){return c(d)[0]}t.collect=m;function n(d,s,i=(r,a)=>r===a){const r=d[Symbol.iterator](),a=s[Symbol.iterator]();for(;;){const o=r.next(),u=a.next();if(o.done!==u.done)return!1;if(o.done)return!0;if(!i(o.value,u.value))return!1}}t.equals=n})(l=e.Iterable||(e.Iterable={}))}),define(De[144],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var l;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(l=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(n){n.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function _(n,d=!1){let s=0;const i=n.length;let r="",a=0,o=16,u=0;function h(H){let F=0,G=0;for(;F<H;){const B=n.charCodeAt(s);if(B>=48&&B<=57)G=G*16+B-48;else if(B>=65&&B<=70)G=G*16+B-65+10;else if(B>=97&&B<=102)G=G*16+B-97+10;else break;s++,F++}return F<H&&(G=-1),G}function C(H){s=H,r="",a=0,o=16,u=0}function R(){const H=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&I(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&I(n.charCodeAt(s)))for(s++;s<n.length&&I(n.charCodeAt(s));)s++;else return u=3,n.substring(H,s);let F=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&I(n.charCodeAt(s))){for(s++;s<n.length&&I(n.charCodeAt(s));)s++;F=s}else u=3;return n.substring(H,F)}function N(){let H="",F=s;for(;;){if(s>=i){H+=n.substring(F,s),u=2;break}const G=n.charCodeAt(s);if(G===34){H+=n.substring(F,s),s++;break}if(G===92){if(H+=n.substring(F,s),s++,s>=i){u=2;break}switch(n.charCodeAt(s++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:{const U=h(4);U>=0?H+=String.fromCharCode(U):u=4;break}default:u=5}F=s;continue}if(G>=0&&G<=31)if(w(G)){H+=n.substring(F,s),u=2;break}else u=6;s++}return H}function M(){if(r="",u=0,a=s,s>=i)return a=i,o=17;let H=n.charCodeAt(s);if(k(H)){do s++,r+=String.fromCharCode(H),H=n.charCodeAt(s);while(k(H));return o=15}if(w(H))return s++,r+=String.fromCharCode(H),H===13&&n.charCodeAt(s)===10&&(s++,r+=`
`),o=14;switch(H){case 123:return s++,o=1;case 125:return s++,o=2;case 91:return s++,o=3;case 93:return s++,o=4;case 58:return s++,o=6;case 44:return s++,o=5;case 34:return s++,r=N(),o=10;case 47:{const F=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<i&&!w(n.charCodeAt(s));)s++;return r=n.substring(F,s),o=12}if(n.charCodeAt(s+1)===42){s+=2;const G=i-1;let B=!1;for(;s<G;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,B=!0;break}s++}return B||(s++,u=1),r=n.substring(F,s),o=13}return r+=String.fromCharCode(H),s++,o=16}case 45:if(r+=String.fromCharCode(H),s++,s===i||!I(n.charCodeAt(s)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=R(),o=11;default:for(;s<i&&A(H);)s++,H=n.charCodeAt(s);if(a!==s){switch(r=n.substring(a,s),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(H),s++,o=16}}function A(H){if(k(H)||w(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let H;do H=M();while(H>=12&&H<=15);return H}return{setPosition:C,getPosition:()=>s,scan:d?z:M,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>s-a,getTokenError:()=>u}}e.createScanner=_;function k(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function w(n){return n===10||n===13||n===8232||n===8233}function I(n){return n>=48&&n<=57}var L;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(L||(L={}));function y(n,d){const s=[],i=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function u(h,C,R,N){a.value=h,a.offset=C,a.length=R,a.type=N,a.colonOffset=void 0,r=a}try{g(n,{onObjectBegin:(h,C)=>{if(d<=h)throw i;r=void 0,o=d>h,s.push("")},onObjectProperty:(h,C,R)=>{if(d<C||(u(h,C,R,"property"),s[s.length-1]=h,d<=C+R))throw i},onObjectEnd:(h,C)=>{if(d<=h)throw i;r=void 0,s.pop()},onArrayBegin:(h,C)=>{if(d<=h)throw i;r=void 0,s.push(0)},onArrayEnd:(h,C)=>{if(d<=h)throw i;r=void 0,s.pop()},onLiteralValue:(h,C,R)=>{if(d<C||(u(h,C,R,m(h)),d<=C+R))throw i},onSeparator:(h,C,R)=>{if(d<=C)throw i;if(h===":"&&r&&r.type==="property")r.colonOffset=C,o=!1,r=void 0;else if(h===","){const N=s[s.length-1];typeof N=="number"?s[s.length-1]=N+1:(o=!0,s[s.length-1]=""),r=void 0}}})}catch(h){if(h!==i)throw h}return{path:s,previousNode:r,isAtPropertyKey:o,matches:h=>{let C=0;for(let R=0;C<h.length&&R<s.length;R++)if(h[C]===s[R]||h[C]==="*")C++;else if(h[C]!=="**")return!1;return C===h.length}}}e.getLocation=y;function S(n,d=[],s=P.DEFAULT){let i=null,r=[];const a=[];function o(h){Array.isArray(r)?r.push(h):i!==null&&(r[i]=h)}return g(n,{onObjectBegin:()=>{const h={};o(h),a.push(r),r=h,i=null},onObjectProperty:h=>{i=h},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const h=[];o(h),a.push(r),r=h,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:o,onError:(h,C,R)=>{d.push({error:h,offset:C,length:R})}},s),r[0]}e.parse=S;function T(n,d=[],s=P.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(h){i.type==="property"&&(i.length=h-i.offset,i=i.parent)}function a(h){return i.children.push(h),h}g(n,{onObjectBegin:h=>{i=a({type:"object",offset:h,length:-1,parent:i,children:[]})},onObjectProperty:(h,C,R)=>{i=a({type:"property",offset:C,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:h,offset:C,length:R,parent:i})},onObjectEnd:(h,C)=>{i.length=h+C-i.offset,i=i.parent,r(h+C)},onArrayBegin:(h,C)=>{i=a({type:"array",offset:h,length:-1,parent:i,children:[]})},onArrayEnd:(h,C)=>{i.length=h+C-i.offset,i=i.parent,r(h+C)},onLiteralValue:(h,C,R)=>{a({type:m(h),offset:C,length:R,parent:i,value:h}),r(C+R)},onSeparator:(h,C,R)=>{i.type==="property"&&(h===":"?i.colonOffset=C:h===","&&r(C))},onError:(h,C,R)=>{d.push({error:h,offset:C,length:R})}},s);const u=i.children[0];return u&&delete u.parent,u}e.parseTree=T;function E(n,d){if(!n)return;let s=n;for(const i of d)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const a of s.children)if(Array.isArray(a.children)&&a.children[0].value===i){s=a.children[1],r=!0;break}if(!r)return}else{const r=i;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=E;function p(n){if(!n.parent||!n.parent.children)return[];const d=p(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;d.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&d.push(s)}return d}e.getNodePath=p;function b(n){switch(n.type){case"array":return n.children.map(b);case"object":{const d=Object.create(null);for(const s of n.children){const i=s.children[1];i&&(d[s.children[0].value]=b(i))}return d}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=b;function f(n,d,s=!1){return d>=n.offset&&d<n.offset+n.length||s&&d===n.offset+n.length}e.contains=f;function v(n,d,s=!1){if(f(n,d,s)){const i=n.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=d;r++){const a=v(i[r],d,s);if(a)return a}return n}}e.findNodeAtOffset=v;function g(n,d,s=P.DEFAULT){const i=_(n,!1);function r(te){return te?()=>te(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(te){return te?pe=>te(pe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=r(d.onObjectBegin),u=a(d.onObjectProperty),h=r(d.onObjectEnd),C=r(d.onArrayBegin),R=r(d.onArrayEnd),N=a(d.onLiteralValue),M=a(d.onSeparator),A=r(d.onComment),z=a(d.onError),H=s&&s.disallowComments,F=s&&s.allowTrailingComma;function G(){for(;;){const te=i.scan();switch(i.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:H||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(te){case 12:case 13:H?B(10):A();break;case 16:B(1);break;case 15:case 14:break;default:return te}}}function B(te,pe=[],Y=[]){if(z(te),pe.length+Y.length>0){let ve=i.getToken();for(;ve!==17;){if(pe.indexOf(ve)!==-1){G();break}else if(Y.indexOf(ve)!==-1)break;ve=G()}}}function U(te){const pe=i.getTokenValue();return te?N(pe):u(pe),G(),!0}function X(){switch(i.getToken()){case 11:{let te=0;try{te=JSON.parse(i.getTokenValue()),typeof te!="number"&&(B(2),te=0)}catch{B(2)}N(te);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return G(),!0}function $(){return i.getToken()!==10?(B(3,[],[2,5]),!1):(U(!1),i.getToken()===6?(M(":"),G(),de()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function x(){o(),G();let te=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(te||B(4,[],[]),M(","),G(),i.getToken()===2&&F)break}else te&&B(6,[],[]);$()||B(4,[],[2,5]),te=!0}return h(),i.getToken()!==2?B(7,[2],[]):G(),!0}function Q(){C(),G();let te=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(te||B(4,[],[]),M(","),G(),i.getToken()===4&&F)break}else te&&B(6,[],[]);de()||B(4,[],[4,5]),te=!0}return R(),i.getToken()!==4?B(8,[4],[]):G(),!0}function de(){switch(i.getToken()){case 3:return Q();case 1:return x();case 10:return U(!0);default:return X()}}return G(),i.getToken()===17?s.allowEmptyContent?!0:(B(4,[],[]),!1):de()?(i.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=g;function c(n,d){const s=_(n),i=[];let r,a=0,o;do switch(o=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:a!==o&&i.push(n.substring(a,o)),d!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,d)),a=s.getPosition();break}while(r!==17);return i.join("")}e.stripComments=c;function m(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(De[76],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class l{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new l(()=>D(this.getValue()))}}e.Lazy=l}),define(De[6],Ie([1,0,59,60]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let P=null;function _(r){P=r}if(e.setDisposableTracker=_,D){const r="__is_disposable_tracked__";_(new class{trackDisposable(a){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(o)},3e3)}setParent(a,o){if(a&&a!==v.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==v.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function k(r){return P?.trackDisposable(r),r}function w(r){P?.markAsDisposed(r)}function I(r,a){P?.setParent(r,a)}function L(r,a){if(!!P)for(const o of r)P.setParent(o,a)}function y(r){return P?.markAsSingleton(r),r}e.markAsSingleton=y;function S(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=S;function T(r){if(t.Iterable.is(r)){const a=[];for(const o of r)if(o)try{o.dispose()}catch(u){a.push(u)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=T;function E(r){for(const a of r)S(a)&&a.dispose();return[]}e.disposeIfDisposable=E;function p(...r){const a=b(()=>T(r));return L(r,a),a}e.combinedDisposable=p;function b(r){const a=k({dispose:(0,l.once)(()=>{w(a),r()})});return a}e.toDisposable=b;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{T(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return I(a,this),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new f,k(this),I(this._store,this)}dispose(){w(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&I(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&I(a,null),a}}e.MutableDisposable=g;class c{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(a){let o=a;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,w(this))},this}}e.SafeDisposable=m;class n{constructor(){this.references=new Map}acquire(a,...o){let u=this.references.get(a);u||(u={counter:0,object:this.createReferencedObject(a,...o)},this.references.set(a,u));const{object:h}=u,C=(0,l.once)(()=>{--u.counter===0&&(this.destroyReferencedObject(a,u.object),this.references.delete(a))});return u.counter++,{object:h,dispose:C}}}e.ReferenceCollection=n;class d{constructor(a){this.referenceCollection=a}async acquire(a,...o){const u=this.referenceCollection.acquire(a,...o);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(h){throw u.dispose(),h}}}e.AsyncReferenceCollection=d;class s{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=s;function i(r){const a=new f;try{r(a)}finally{a.dispose()}}e.disposeOnReturn=i}),define(De[77],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class l{constructor(P){this.element=P,this.next=l.Undefined,this.prev=l.Undefined}}l.Undefined=new l(void 0);class t{constructor(){this._first=l.Undefined,this._last=l.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===l.Undefined}clear(){let P=this._first;for(;P!==l.Undefined;){const _=P.next;P.prev=l.Undefined,P.next=l.Undefined,P=_}this._first=l.Undefined,this._last=l.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,_){const k=new l(P);if(this._first===l.Undefined)this._first=k,this._last=k;else if(_){const I=this._last;this._last=k,k.prev=I,I.next=k}else{const I=this._first;this._first=k,k.next=I,I.prev=k}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(k))}}shift(){if(this._first!==l.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==l.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==l.Undefined&&P.next!==l.Undefined){const _=P.prev;_.next=P.next,P.next.prev=_}else P.prev===l.Undefined&&P.next===l.Undefined?(this._first=l.Undefined,this._last=l.Undefined):P.next===l.Undefined?(this._last=this._last.prev,this._last.next=l.Undefined):P.prev===l.Undefined&&(this._first=this._first.next,this._first.prev=l.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==l.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),function(J,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[145],Ie([0]),e):(J=typeof globalThis<"u"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(oe,le){for(var fe=0;fe<le.length;fe++){var Z=le[fe];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(oe,Z.key,Z)}}function l(oe,le,fe){return le&&e(oe.prototype,le),fe&&e(oe,fe),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function t(oe,le){if(!!oe){if(typeof oe=="string")return D(oe,le);var fe=Object.prototype.toString.call(oe).slice(8,-1);if(fe==="Object"&&oe.constructor&&(fe=oe.constructor.name),fe==="Map"||fe==="Set")return Array.from(oe);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return D(oe,le)}}function D(oe,le){(le==null||le>oe.length)&&(le=oe.length);for(var fe=0,Z=new Array(le);fe<le;fe++)Z[fe]=oe[fe];return Z}function P(oe,le){var fe=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(fe)return(fe=fe.call(oe)).next.bind(fe);if(Array.isArray(oe)||(fe=t(oe))||le&&oe&&typeof oe.length=="number"){fe&&(oe=fe);var Z=0;return function(){return Z>=oe.length?{done:!0}:{done:!1,value:oe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=_();function k(oe){J.defaults=oe}var w=/[&<>"']/,I=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,S={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(le){return S[le]};function E(oe,le){if(le){if(w.test(oe))return oe.replace(I,T)}else if(L.test(oe))return oe.replace(y,T);return oe}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function b(oe){return oe.replace(p,function(le,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var f=/(^|[^\[])\^/g;function v(oe,le){oe=typeof oe=="string"?oe:oe.source,le=le||"";var fe={replace:function(ae,ne){return ne=ne.source||ne,ne=ne.replace(f,"$1"),oe=oe.replace(ae,ne),fe},getRegex:function(){return new RegExp(oe,le)}};return fe}var g=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(oe,le,fe){if(oe){var Z;try{Z=decodeURIComponent(b(fe)).replace(g,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}le&&!c.test(fe)&&(fe=r(le,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var n={},d=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(oe,le){n[" "+oe]||(d.test(oe)?n[" "+oe]=oe+"/":n[" "+oe]=h(oe,"/",!0)),oe=n[" "+oe];var fe=oe.indexOf(":")===-1;return le.substring(0,2)==="//"?fe?le:oe.replace(s,"$1")+le:le.charAt(0)==="/"?fe?le:oe.replace(i,"$1")+le:oe+le}var a={exec:function(){}};function o(oe){for(var le=1,fe,Z;le<arguments.length;le++){fe=arguments[le];for(Z in fe)Object.prototype.hasOwnProperty.call(fe,Z)&&(oe[Z]=fe[Z])}return oe}function u(oe,le){var fe=oe.replace(/\|/g,function(ne,ie,O){for(var V=!1,q=ie;--q>=0&&O[q]==="\\";)V=!V;return V?"|":" |"}),Z=fe.split(/ \|/),ae=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>le)Z.splice(le);else for(;Z.length<le;)Z.push("");for(;ae<Z.length;ae++)Z[ae]=Z[ae].trim().replace(/\\\|/g,"|");return Z}function h(oe,le,fe){var Z=oe.length;if(Z===0)return"";for(var ae=0;ae<Z;){var ne=oe.charAt(Z-ae-1);if(ne===le&&!fe)ae++;else if(ne!==le&&fe)ae++;else break}return oe.slice(0,Z-ae)}function C(oe,le){if(oe.indexOf(le[1])===-1)return-1;for(var fe=oe.length,Z=0,ae=0;ae<fe;ae++)if(oe[ae]==="\\")ae++;else if(oe[ae]===le[0])Z++;else if(oe[ae]===le[1]&&(Z--,Z<0))return ae;return-1}function R(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(oe,le){if(le<1)return"";for(var fe="";le>1;)le&1&&(fe+=oe),le>>=1,oe+=oe;return fe+oe}function M(oe,le,fe,Z){var ae=le.href,ne=le.title?E(le.title):null,ie=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){Z.state.inLink=!0;var O={type:"link",raw:fe,href:ae,title:ne,text:ie,tokens:Z.inlineTokens(ie)};return Z.state.inLink=!1,O}return{type:"image",raw:fe,href:ae,title:ne,text:E(ie)}}function A(oe,le){var fe=oe.match(/^(\s+)(?:```)/);if(fe===null)return le;var Z=fe[1];return le.split(`
`).map(function(ae){var ne=ae.match(/^\s+/);if(ne===null)return ae;var ie=ne[0];return ie.length>=Z.length?ae.slice(Z.length):ae}).join(`
`)}var z=function(){function oe(fe){this.options=fe||J.defaults}var le=oe.prototype;return le.space=function(Z){var ae=this.rules.block.newline.exec(Z);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},le.code=function(Z){var ae=this.rules.block.code.exec(Z);if(ae){var ne=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:h(ne,`
`)}}},le.fences=function(Z){var ae=this.rules.block.fences.exec(Z);if(ae){var ne=ae[0],ie=A(ne,ae[3]||"");return{type:"code",raw:ne,lang:ae[2]?ae[2].trim():ae[2],text:ie}}},le.heading=function(Z){var ae=this.rules.block.heading.exec(Z);if(ae){var ne=ae[2].trim();if(/#$/.test(ne)){var ie=h(ne,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(ne=ie.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:ne,tokens:this.lexer.inline(ne)}}},le.hr=function(Z){var ae=this.rules.block.hr.exec(Z);if(ae)return{type:"hr",raw:ae[0]}},le.blockquote=function(Z){var ae=this.rules.block.blockquote.exec(Z);if(ae){var ne=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},le.list=function(Z){var ae=this.rules.block.list.exec(Z);if(ae){var ne,ie,O,V,q,K,me,we,ce,Ce,ye,He,je=ae[1].trim(),Ze=je.length>1,Qe={type:"list",raw:"",ordered:Ze,start:Ze?+je.slice(0,-1):"",loose:!1,items:[]};je=Ze?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Ze?je:"[*+-]");for(var Le=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(He=!1,!(!(ae=Le.exec(Z))||this.rules.block.hr.test(Z)));){if(ne=ae[0],Z=Z.substring(ne.length),we=ae[2].split(`
`,1)[0],ce=Z.split(`
`,1)[0],this.options.pedantic?(V=2,ye=we.trimLeft()):(V=ae[2].search(/[^ ]/),V=V>4?1:V,ye=we.slice(V),V+=ae[1].length),K=!1,!we&&/^ *$/.test(ce)&&(ne+=ce+`
`,Z=Z.substring(ce.length+1),He=!0),!He)for(var rt=new RegExp("^ {0,"+Math.min(3,V-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),re=new RegExp("^ {0,"+Math.min(3,V-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),se=new RegExp("^ {0,"+Math.min(3,V-1)+"}(?:```|~~~)"),Se=new RegExp("^ {0,"+Math.min(3,V-1)+"}#");Z&&(Ce=Z.split(`
`,1)[0],we=Ce,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(se.test(we)||Se.test(we)||rt.test(we)||re.test(Z)));){if(we.search(/[^ ]/)>=V||!we.trim())ye+=`
`+we.slice(V);else if(!K)ye+=`
`+we;else break;!K&&!we.trim()&&(K=!0),ne+=Ce+`
`,Z=Z.substring(Ce.length+1)}Qe.loose||(me?Qe.loose=!0:/\n *\n *$/.test(ne)&&(me=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(ye),ie&&(O=ie[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:ne,task:!!ie,checked:O,loose:!1,text:ye}),Qe.raw+=ne}Qe.items[Qe.items.length-1].raw=ne.trimRight(),Qe.items[Qe.items.length-1].text=ye.trimRight(),Qe.raw=Qe.raw.trimRight();var ue=Qe.items.length;for(q=0;q<ue;q++){this.lexer.state.top=!1,Qe.items[q].tokens=this.lexer.blockTokens(Qe.items[q].text,[]);var Te=Qe.items[q].tokens.filter(function(Be){return Be.type==="space"}),Me=Te.every(function(Be){for(var ze=Be.raw.split(""),Ye=0,nt=P(ze),ct;!(ct=nt()).done;){var pt=ct.value;if(pt===`
`&&(Ye+=1),Ye>1)return!0}return!1});!Qe.loose&&Te.length&&Me&&(Qe.loose=!0,Qe.items[q].loose=!0)}return Qe}},le.html=function(Z){var ae=this.rules.block.html.exec(Z);if(ae){var ne={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var ie=this.options.sanitizer?this.options.sanitizer(ae[0]):E(ae[0]);ne.type="paragraph",ne.text=ie,ne.tokens=this.lexer.inline(ie)}return ne}},le.def=function(Z){var ae=this.rules.block.def.exec(Z);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var ne=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:ae[0],href:ae[2],title:ae[3]}}},le.table=function(Z){var ae=this.rules.block.table.exec(Z);if(ae){var ne={type:"table",header:u(ae[1]).map(function(me){return{text:me}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=ae[0];var ie=ne.align.length,O,V,q,K;for(O=0;O<ie;O++)/^ *-+: *$/.test(ne.align[O])?ne.align[O]="right":/^ *:-+: *$/.test(ne.align[O])?ne.align[O]="center":/^ *:-+ *$/.test(ne.align[O])?ne.align[O]="left":ne.align[O]=null;for(ie=ne.rows.length,O=0;O<ie;O++)ne.rows[O]=u(ne.rows[O],ne.header.length).map(function(me){return{text:me}});for(ie=ne.header.length,V=0;V<ie;V++)ne.header[V].tokens=this.lexer.inline(ne.header[V].text);for(ie=ne.rows.length,V=0;V<ie;V++)for(K=ne.rows[V],q=0;q<K.length;q++)K[q].tokens=this.lexer.inline(K[q].text);return ne}}},le.lheading=function(Z){var ae=this.rules.block.lheading.exec(Z);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},le.paragraph=function(Z){var ae=this.rules.block.paragraph.exec(Z);if(ae){var ne=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:ne,tokens:this.lexer.inline(ne)}}},le.text=function(Z){var ae=this.rules.block.text.exec(Z);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},le.escape=function(Z){var ae=this.rules.inline.escape.exec(Z);if(ae)return{type:"escape",raw:ae[0],text:E(ae[1])}},le.tag=function(Z){var ae=this.rules.inline.tag.exec(Z);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):E(ae[0]):ae[0]}},le.link=function(Z){var ae=this.rules.inline.link.exec(Z);if(ae){var ne=ae[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var ie=h(ne.slice(0,-1),"\\");if((ne.length-ie.length)%2===0)return}else{var O=C(ae[2],"()");if(O>-1){var V=ae[0].indexOf("!")===0?5:4,q=V+ae[1].length+O;ae[2]=ae[2].substring(0,O),ae[0]=ae[0].substring(0,q).trim(),ae[3]=""}}var K=ae[2],me="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);we&&(K=we[1],me=we[3])}else me=ae[3]?ae[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(ne)?K=K.slice(1):K=K.slice(1,-1)),M(ae,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:me&&me.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},le.reflink=function(Z,ae){var ne;if((ne=this.rules.inline.reflink.exec(Z))||(ne=this.rules.inline.nolink.exec(Z))){var ie=(ne[2]||ne[1]).replace(/\s+/g," ");if(ie=ae[ie.toLowerCase()],!ie||!ie.href){var O=ne[0].charAt(0);return{type:"text",raw:O,text:O}}return M(ne,ie,ne[0],this.lexer)}},le.emStrong=function(Z,ae,ne){ne===void 0&&(ne="");var ie=this.rules.inline.emStrong.lDelim.exec(Z);if(!!ie&&!(ie[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var O=ie[1]||ie[2]||"";if(!O||O&&(ne===""||this.rules.inline.punctuation.exec(ne))){var V=ie[0].length-1,q,K,me=V,we=0,ce=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,ae=ae.slice(-1*Z.length+V);(ie=ce.exec(ae))!=null;)if(q=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!q){if(K=q.length,ie[3]||ie[4]){me+=K;continue}else if((ie[5]||ie[6])&&V%3&&!((V+K)%3)){we+=K;continue}if(me-=K,!(me>0)){if(K=Math.min(K,K+me+we),Math.min(V,K)%2){var Ce=Z.slice(1,V+ie.index+K);return{type:"em",raw:Z.slice(0,V+ie.index+K+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ye=Z.slice(2,V+ie.index+K-1);return{type:"strong",raw:Z.slice(0,V+ie.index+K+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},le.codespan=function(Z){var ae=this.rules.inline.code.exec(Z);if(ae){var ne=ae[2].replace(/\n/g," "),ie=/[^ ]/.test(ne),O=/^ /.test(ne)&&/ $/.test(ne);return ie&&O&&(ne=ne.substring(1,ne.length-1)),ne=E(ne,!0),{type:"codespan",raw:ae[0],text:ne}}},le.br=function(Z){var ae=this.rules.inline.br.exec(Z);if(ae)return{type:"br",raw:ae[0]}},le.del=function(Z){var ae=this.rules.inline.del.exec(Z);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},le.autolink=function(Z,ae){var ne=this.rules.inline.autolink.exec(Z);if(ne){var ie,O;return ne[2]==="@"?(ie=E(this.options.mangle?ae(ne[1]):ne[1]),O="mailto:"+ie):(ie=E(ne[1]),O=ie),{type:"link",raw:ne[0],text:ie,href:O,tokens:[{type:"text",raw:ie,text:ie}]}}},le.url=function(Z,ae){var ne;if(ne=this.rules.inline.url.exec(Z)){var ie,O;if(ne[2]==="@")ie=E(this.options.mangle?ae(ne[0]):ne[0]),O="mailto:"+ie;else{var V;do V=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(V!==ne[0]);ie=E(ne[0]),ne[1]==="www."?O="http://"+ie:O=ie}return{type:"link",raw:ne[0],text:ie,href:O,tokens:[{type:"text",raw:ie,text:ie}]}}},le.inlineText=function(Z,ae){var ne=this.rules.inline.text.exec(Z);if(ne){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):E(ne[0]):ne[0]:ie=E(this.options.smartypants?ae(ne[0]):ne[0]),{type:"text",raw:ne[0],text:ie}}},oe}(),H={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};H._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,H._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,H.def=v(H.def).replace("label",H._label).replace("title",H._title).getRegex(),H.bullet=/(?:[*+-]|\d{1,9}[.)])/,H.listItemStart=v(/^( *)(bull) */).replace("bull",H.bullet).getRegex(),H.list=v(H.list).replace(/bull/g,H.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+H.def.source+")").getRegex(),H._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",H._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,H.html=v(H.html,"i").replace("comment",H._comment).replace("tag",H._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),H.paragraph=v(H._paragraph).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.blockquote=v(H.blockquote).replace("paragraph",H.paragraph).getRegex(),H.normal=o({},H),H.gfm=o({},H.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),H.gfm.table=v(H.gfm.table).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.gfm.paragraph=v(H._paragraph).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",H.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.pedantic=o({},H.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",H._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:v(H.normal._paragraph).replace("hr",H.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",H.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=v(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=v(H._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=v(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=v(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=v(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=v(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=v(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=v(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=v(F.reflink).replace("label",F._label).replace("ref",H._label).getRegex(),F.nolink=v(F.nolink).replace("ref",H._label).getRegex(),F.reflinkSearch=v(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=o({},F),F.pedantic=o({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=o({},F.normal,{escape:v(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=v(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=o({},F.gfm,{br:v(F.br).replace("{2,}","*").getRegex(),text:v(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function G(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(oe){var le="",fe,Z,ae=oe.length;for(fe=0;fe<ae;fe++)Z=oe.charCodeAt(fe),Math.random()>.5&&(Z="x"+Z.toString(16)),le+="&#"+Z+";";return le}var U=function(){function oe(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||J.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:H.normal,inline:F.normal};this.options.pedantic?(Z.block=H.pedantic,Z.inline=F.pedantic):this.options.gfm&&(Z.block=H.gfm,this.options.breaks?Z.inline=F.breaks:Z.inline=F.gfm),this.tokenizer.rules=Z}oe.lex=function(Z,ae){var ne=new oe(ae);return ne.lex(Z)},oe.lexInline=function(Z,ae){var ne=new oe(ae);return ne.inlineTokens(Z)};var le=oe.prototype;return le.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},le.blockTokens=function(Z,ae){var ne=this;ae===void 0&&(ae=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(me,we,ce){return we+"    ".repeat(ce.length)});for(var ie,O,V,q;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(me){return(ie=me.call({lexer:ne},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.space(Z)){Z=Z.substring(ie.raw.length),ie.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(ie);continue}if(ie=this.tokenizer.code(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=O.text):ae.push(ie);continue}if(ie=this.tokenizer.fences(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.heading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.hr(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.blockquote(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.list(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.html(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.def(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=O.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.lheading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(V=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var me=1/0,we=Z.slice(1),ce=void 0;ne.options.extensions.startBlock.forEach(function(Ce){ce=Ce.call({lexer:this},we),typeof ce=="number"&&ce>=0&&(me=Math.min(me,ce))}),me<1/0&&me>=0&&(V=Z.substring(0,me+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(V))){O=ae[ae.length-1],q&&O.type==="paragraph"?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):ae.push(ie),q=V.length!==Z.length,Z=Z.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&O.type==="text"?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):ae.push(ie);continue}if(Z){var K="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,ae},le.inline=function(Z,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:Z,tokens:ae}),ae},le.inlineTokens=function(Z,ae){var ne=this;ae===void 0&&(ae=[]);var ie,O,V,q=Z,K,me,we;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)ce.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,K.index)+"["+N("a",K[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,K.index)+"["+N("a",K[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,K.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(me||(we=""),me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(ie=ye.call({lexer:ne},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.tag(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&ie.type==="text"&&O.type==="text"?(O.raw+=ie.raw,O.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.link(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&ie.type==="text"&&O.type==="text"?(O.raw+=ie.raw,O.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.emStrong(Z,q,we)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.codespan(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.br(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.del(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.autolink(Z,B)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(Z,B))){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(V=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,He=Z.slice(1),je=void 0;ne.options.extensions.startInline.forEach(function(Ze){je=Ze.call({lexer:this},He),typeof je=="number"&&je>=0&&(ye=Math.min(ye,je))}),ye<1/0&&ye>=0&&(V=Z.substring(0,ye+1))}(),ie=this.tokenizer.inlineText(V,G)){Z=Z.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(we=ie.raw.slice(-1)),me=!0,O=ae[ae.length-1],O&&O.type==="text"?(O.raw+=ie.raw,O.text+=ie.text):ae.push(ie);continue}if(Z){var Ce="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ae},l(oe,null,[{key:"rules",get:function(){return{block:H,inline:F}}}]),oe}(),X=function(){function oe(fe){this.options=fe||J.defaults}var le=oe.prototype;return le.code=function(Z,ae,ne){var ie=(ae||"").match(/\S*/)[0];if(this.options.highlight){var O=this.options.highlight(Z,ie);O!=null&&O!==Z&&(ne=!0,Z=O)}return Z=Z.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+E(ie,!0)+'">'+(ne?Z:E(Z,!0))+`</code></pre>
`:"<pre><code>"+(ne?Z:E(Z,!0))+`</code></pre>
`},le.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},le.html=function(Z){return Z},le.heading=function(Z,ae,ne,ie){if(this.options.headerIds){var O=this.options.headerPrefix+ie.slug(ne);return"<h"+ae+' id="'+O+'">'+Z+"</h"+ae+`>
`}return"<h"+ae+">"+Z+"</h"+ae+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(Z,ae,ne){var ie=ae?"ol":"ul",O=ae&&ne!==1?' start="'+ne+'"':"";return"<"+ie+O+`>
`+Z+"</"+ie+`>
`},le.listitem=function(Z){return"<li>"+Z+`</li>
`},le.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(Z){return"<p>"+Z+`</p>
`},le.table=function(Z,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ae+`</table>
`},le.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},le.tablecell=function(Z,ae){var ne=ae.header?"th":"td",ie=ae.align?"<"+ne+' align="'+ae.align+'">':"<"+ne+">";return ie+Z+("</"+ne+`>
`)},le.strong=function(Z){return"<strong>"+Z+"</strong>"},le.em=function(Z){return"<em>"+Z+"</em>"},le.codespan=function(Z){return"<code>"+Z+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(Z){return"<del>"+Z+"</del>"},le.link=function(Z,ae,ne){if(Z=m(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var ie='<a href="'+E(Z)+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=">"+ne+"</a>",ie},le.image=function(Z,ae,ne){if(Z=m(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var ie='<img src="'+Z+'" alt="'+ne+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=this.options.xhtml?"/>":">",ie},le.text=function(Z){return Z},oe}(),$=function(){function oe(){}var le=oe.prototype;return le.strong=function(Z){return Z},le.em=function(Z){return Z},le.codespan=function(Z){return Z},le.del=function(Z){return Z},le.html=function(Z){return Z},le.text=function(Z){return Z},le.link=function(Z,ae,ne){return""+ne},le.image=function(Z,ae,ne){return""+ne},le.br=function(){return""},oe}(),x=function(){function oe(){this.seen={}}var le=oe.prototype;return le.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(Z,ae){var ne=Z,ie=0;if(this.seen.hasOwnProperty(ne)){ie=this.seen[Z];do ie++,ne=Z+"-"+ie;while(this.seen.hasOwnProperty(ne))}return ae||(this.seen[Z]=ie,this.seen[ne]=0),ne},le.slug=function(Z,ae){ae===void 0&&(ae={});var ne=this.serialize(Z);return this.getNextSafeSlug(ne,ae.dryrun)},oe}(),Q=function(){function oe(fe){this.options=fe||J.defaults,this.options.renderer=this.options.renderer||new X,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $,this.slugger=new x}oe.parse=function(Z,ae){var ne=new oe(ae);return ne.parse(Z)},oe.parseInline=function(Z,ae){var ne=new oe(ae);return ne.parseInline(Z)};var le=oe.prototype;return le.parse=function(Z,ae){ae===void 0&&(ae=!0);var ne="",ie,O,V,q,K,me,we,ce,Ce,ye,He,je,Ze,Qe,Le,rt,re,se,Se,ue=Z.length;for(ie=0;ie<ue;ie++){if(ye=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Se=this.options.extensions.renderers[ye.type].call({parser:this},ye),Se!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ne+=Se||"";continue}switch(ye.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,b(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ce="",we="",q=ye.header.length,O=0;O<q;O++)we+=this.renderer.tablecell(this.parseInline(ye.header[O].tokens),{header:!0,align:ye.align[O]});for(ce+=this.renderer.tablerow(we),Ce="",q=ye.rows.length,O=0;O<q;O++){for(me=ye.rows[O],we="",K=me.length,V=0;V<K;V++)we+=this.renderer.tablecell(this.parseInline(me[V].tokens),{header:!1,align:ye.align[V]});Ce+=this.renderer.tablerow(we)}ne+=this.renderer.table(ce,Ce);continue}case"blockquote":{Ce=this.parse(ye.tokens),ne+=this.renderer.blockquote(Ce);continue}case"list":{for(He=ye.ordered,je=ye.start,Ze=ye.loose,q=ye.items.length,Ce="",O=0;O<q;O++)Le=ye.items[O],rt=Le.checked,re=Le.task,Qe="",Le.task&&(se=this.renderer.checkbox(rt),Ze?Le.tokens.length>0&&Le.tokens[0].type==="paragraph"?(Le.tokens[0].text=se+" "+Le.tokens[0].text,Le.tokens[0].tokens&&Le.tokens[0].tokens.length>0&&Le.tokens[0].tokens[0].type==="text"&&(Le.tokens[0].tokens[0].text=se+" "+Le.tokens[0].tokens[0].text)):Le.tokens.unshift({type:"text",text:se}):Qe+=se),Qe+=this.parse(Le.tokens,Ze),Ce+=this.renderer.listitem(Qe,re,rt);ne+=this.renderer.list(Ce,He,je);continue}case"html":{ne+=this.renderer.html(ye.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(Ce=ye.tokens?this.parseInline(ye.tokens):ye.text;ie+1<ue&&Z[ie+1].type==="text";)ye=Z[++ie],Ce+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ne+=ae?this.renderer.paragraph(Ce):Ce;continue}default:{var Te='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return ne},le.parseInline=function(Z,ae){ae=ae||this.renderer;var ne="",ie,O,V,q=Z.length;for(ie=0;ie<q;ie++){if(O=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[O.type]&&(V=this.options.extensions.renderers[O.type].call({parser:this},O),V!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(O.type))){ne+=V||"";continue}switch(O.type){case"escape":{ne+=ae.text(O.text);break}case"html":{ne+=ae.html(O.text);break}case"link":{ne+=ae.link(O.href,O.title,this.parseInline(O.tokens,ae));break}case"image":{ne+=ae.image(O.href,O.title,O.text);break}case"strong":{ne+=ae.strong(this.parseInline(O.tokens,ae));break}case"em":{ne+=ae.em(this.parseInline(O.tokens,ae));break}case"codespan":{ne+=ae.codespan(O.text);break}case"br":{ne+=ae.br();break}case"del":{ne+=ae.del(this.parseInline(O.tokens,ae));break}case"text":{ne+=ae.text(O.text);break}default:{var K='Token with "'+O.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return ne},oe}();function de(oe,le,fe){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof le=="function"&&(fe=le,le=null),le=o({},de.defaults,le||{}),R(le),fe){var Z=le.highlight,ae;try{ae=U.lex(oe,le)}catch(q){return fe(q)}var ne=function(K){var me;if(!K)try{le.walkTokens&&de.walkTokens(ae,le.walkTokens),me=Q.parse(ae,le)}catch(we){K=we}return le.highlight=Z,K?fe(K):fe(null,me)};if(!Z||Z.length<3||(delete le.highlight,!ae.length))return ne();var ie=0;de.walkTokens(ae,function(q){q.type==="code"&&(ie++,setTimeout(function(){Z(q.text,q.lang,function(K,me){if(K)return ne(K);me!=null&&me!==q.text&&(q.text=me,q.escaped=!0),ie--,ie===0&&ne()})},0))}),ie===0&&ne();return}function O(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+E(q.message+"",!0)+"</pre>";throw q}try{var V=U.lex(oe,le);if(le.walkTokens){if(le.async)return Promise.all(de.walkTokens(V,le.walkTokens)).then(function(){return Q.parse(V,le)}).catch(O);de.walkTokens(V,le.walkTokens)}return Q.parse(V,le)}catch(q){O(q)}}de.options=de.setOptions=function(oe){return o(de.defaults,oe),k(de.defaults),de},de.getDefaults=_,de.defaults=J.defaults,de.use=function(){for(var oe=arguments.length,le=new Array(oe),fe=0;fe<oe;fe++)le[fe]=arguments[fe];var Z=o.apply(void 0,[{}].concat(le)),ae=de.defaults.extensions||{renderers:{},childTokens:{}},ne;le.forEach(function(ie){if(ie.extensions&&(ne=!0,ie.extensions.forEach(function(V){if(!V.name)throw new Error("extension name required");if(V.renderer){var q=ae.renderers?ae.renderers[V.name]:null;q?ae.renderers[V.name]=function(){for(var K=arguments.length,me=new Array(K),we=0;we<K;we++)me[we]=arguments[we];var ce=V.renderer.apply(this,me);return ce===!1&&(ce=q.apply(this,me)),ce}:ae.renderers[V.name]=V.renderer}if(V.tokenizer){if(!V.level||V.level!=="block"&&V.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[V.level]?ae[V.level].unshift(V.tokenizer):ae[V.level]=[V.tokenizer],V.start&&(V.level==="block"?ae.startBlock?ae.startBlock.push(V.start):ae.startBlock=[V.start]:V.level==="inline"&&(ae.startInline?ae.startInline.push(V.start):ae.startInline=[V.start]))}V.childTokens&&(ae.childTokens[V.name]=V.childTokens)})),ie.renderer&&function(){var V=de.defaults.renderer||new X,q=function(we){var ce=V[we];V[we]=function(){for(var Ce=arguments.length,ye=new Array(Ce),He=0;He<Ce;He++)ye[He]=arguments[He];var je=ie.renderer[we].apply(V,ye);return je===!1&&(je=ce.apply(V,ye)),je}};for(var K in ie.renderer)q(K);Z.renderer=V}(),ie.tokenizer&&function(){var V=de.defaults.tokenizer||new z,q=function(we){var ce=V[we];V[we]=function(){for(var Ce=arguments.length,ye=new Array(Ce),He=0;He<Ce;He++)ye[He]=arguments[He];var je=ie.tokenizer[we].apply(V,ye);return je===!1&&(je=ce.apply(V,ye)),je}};for(var K in ie.tokenizer)q(K);Z.tokenizer=V}(),ie.walkTokens){var O=de.defaults.walkTokens;Z.walkTokens=function(V){var q=[];return q.push(ie.walkTokens.call(this,V)),O&&(q=q.concat(O.call(this,V))),q}}ne&&(Z.extensions=ae),de.setOptions(Z)})},de.walkTokens=function(oe,le){for(var fe=[],Z=function(){var O=ne.value;switch(fe=fe.concat(le.call(de,O)),O.type){case"table":{for(var V=P(O.header),q;!(q=V()).done;){var K=q.value;fe=fe.concat(de.walkTokens(K.tokens,le))}for(var me=P(O.rows),we;!(we=me()).done;)for(var ce=we.value,Ce=P(ce),ye;!(ye=Ce()).done;){var He=ye.value;fe=fe.concat(de.walkTokens(He.tokens,le))}break}case"list":{fe=fe.concat(de.walkTokens(O.items,le));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[O.type]?de.defaults.extensions.childTokens[O.type].forEach(function(je){fe=fe.concat(de.walkTokens(O[je],le))}):O.tokens&&(fe=fe.concat(de.walkTokens(O.tokens,le)))}},ae=P(oe),ne;!(ne=ae()).done;)Z();return fe},de.parseInline=function(oe,le){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");le=o({},de.defaults,le||{}),R(le);try{var fe=U.lexInline(oe,le);return le.walkTokens&&de.walkTokens(fe,le.walkTokens),Q.parseInline(fe,le)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+E(Z.message+"",!0)+"</pre>";throw Z}},de.Parser=Q,de.parser=Q.parse,de.Renderer=X,de.TextRenderer=$,de.Lexer=U,de.lexer=U.lex,de.Tokenizer=z,de.Slugger=x,de.parse=de;var te=de.options,pe=de.setOptions,Y=de.use,ve=de.walkTokens,be=de.parseInline,ke=de,Re=Q.parse,We=U.lex;J.Lexer=U,J.Parser=Q,J.Renderer=X,J.Slugger=x,J.TextRenderer=$,J.Tokenizer=z,J.getDefaults=_,J.lexer=We,J.marked=de,J.options=te,J.parse=ke,J.parseInline=be,J.parser=Re,J.setOptions=pe,J.use=Y,J.walkTokens=ve,Object.defineProperty(J,"__esModule",{value:!0})}),define(De[96],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function l(k,w,I){return Math.min(Math.max(k,w),I)}e.clamp=l;function t(k,w){return(w+k%w)%w}e.rot=t;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class P{constructor(){this._n=1,this._val=0}update(w){return this._val=this._val+(w-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class _{constructor(w){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(w),this._values.fill(0,0,w)}update(w){const I=this._values[this._index];return this._values[this._index]=w,this._index=(this._index+1)%this._values.length,this._sum-=I,this._sum+=w,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function J(D){const P=[];typeof D=="number"&&P.push("code/timeOrigin",D);function _(w){P.push(w,Date.now())}function k(){const w=[];for(let I=0;I<P.length;I+=2)w.push({name:P[I],startTime:P[I+1]});return w}return{mark:_,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const _ of performance.getEntriesByType("mark"))P.push({name:_.name,startTime:Math.round(D+_.startTime)});return P}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function l(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=l(t))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var l=e();for(var t in l)(typeof exports=="object"?exports:J)[t]=l[t]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function l(t){if(e[t])return e[t].exports;var D=e[t]={i:t,l:!1,exports:{}};return J[t].call(D.exports,D,D.exports,l),D.l=!0,D.exports}return l.m=J,l.c=e,l.d=function(t,D,P){l.o(t,D)||Object.defineProperty(t,D,{enumerable:!0,get:P})},l.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},l.t=function(t,D){if(1&D&&(t=l(t)),8&D||4&D&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(l.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&D&&typeof t!="string")for(var _ in t)l.d(P,_,function(k){return t[k]}.bind(null,_));return P},l.n=function(t){var D=t&&t.__esModule?function(){return t.default}:function(){return t};return l.d(D,"a",D),D},l.o=function(t,D){return Object.prototype.hasOwnProperty.call(t,D)},l.p="",l(l.s=0)}([function(J,e,l){(function(t){var D;e=J.exports=Y,D=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],w=e.src=[],I=0,L=I++;w[L]="0|[1-9]\\d*";var y=I++;w[y]="[0-9]+";var S=I++;w[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=I++;w[T]="("+w[L]+")\\.("+w[L]+")\\.("+w[L]+")";var E=I++;w[E]="("+w[y]+")\\.("+w[y]+")\\.("+w[y]+")";var p=I++;w[p]="(?:"+w[L]+"|"+w[S]+")";var b=I++;w[b]="(?:"+w[y]+"|"+w[S]+")";var f=I++;w[f]="(?:-("+w[p]+"(?:\\."+w[p]+")*))";var v=I++;w[v]="(?:-?("+w[b]+"(?:\\."+w[b]+")*))";var g=I++;w[g]="[0-9A-Za-z-]+";var c=I++;w[c]="(?:\\+("+w[g]+"(?:\\."+w[g]+")*))";var m=I++,n="v?"+w[T]+w[f]+"?"+w[c]+"?";w[m]="^"+n+"$";var d="[v=\\s]*"+w[E]+w[v]+"?"+w[c]+"?",s=I++;w[s]="^"+d+"$";var i=I++;w[i]="((?:<|>)?=?)";var r=I++;w[r]=w[y]+"|x|X|\\*";var a=I++;w[a]=w[L]+"|x|X|\\*";var o=I++;w[o]="[v=\\s]*("+w[a]+")(?:\\.("+w[a]+")(?:\\.("+w[a]+")(?:"+w[f]+")?"+w[c]+"?)?)?";var u=I++;w[u]="[v=\\s]*("+w[r]+")(?:\\.("+w[r]+")(?:\\.("+w[r]+")(?:"+w[v]+")?"+w[c]+"?)?)?";var h=I++;w[h]="^"+w[i]+"\\s*"+w[o]+"$";var C=I++;w[C]="^"+w[i]+"\\s*"+w[u]+"$";var R=I++;w[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=I++;w[N]="(?:~>?)";var M=I++;w[M]="(\\s*)"+w[N]+"\\s+",k[M]=new RegExp(w[M],"g");var A=I++;w[A]="^"+w[N]+w[o]+"$";var z=I++;w[z]="^"+w[N]+w[u]+"$";var H=I++;w[H]="(?:\\^)";var F=I++;w[F]="(\\s*)"+w[H]+"\\s+",k[F]=new RegExp(w[F],"g");var G=I++;w[G]="^"+w[H]+w[o]+"$";var B=I++;w[B]="^"+w[H]+w[u]+"$";var U=I++;w[U]="^"+w[i]+"\\s*("+d+")$|^$";var X=I++;w[X]="^"+w[i]+"\\s*("+n+")$|^$";var $=I++;w[$]="(\\s*)"+w[i]+"\\s*("+d+"|"+w[o]+")",k[$]=new RegExp(w[$],"g");var x=I++;w[x]="^\\s*("+w[o]+")\\s+-\\s+("+w[o]+")\\s*$";var Q=I++;w[Q]="^\\s*("+w[u]+")\\s+-\\s+("+w[u]+")\\s*$";var de=I++;w[de]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)D(te,w[te]),k[te]||(k[te]=new RegExp(w[te]));function pe(ce,Ce){if(ce instanceof Y)return ce;if(typeof ce!="string"||ce.length>P||!(Ce?k[s]:k[m]).test(ce))return null;try{return new Y(ce,Ce)}catch{return null}}function Y(ce,Ce){if(ce instanceof Y){if(ce.loose===Ce)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof Y))return new Y(ce,Ce);D("SemVer",ce,Ce),this.loose=Ce;var ye=ce.trim().match(Ce?k[s]:k[m]);if(!ye)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(He){if(/^[0-9]+$/.test(He)){var je=+He;if(je>=0&&je<_)return je}return He}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=pe,e.valid=function(ce,Ce){var ye=pe(ce,Ce);return ye?ye.version:null},e.clean=function(ce,Ce){var ye=pe(ce.trim().replace(/^[=v]+/,""),Ce);return ye?ye.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(ce){return D("SemVer.compare",this.version,this.loose,ce),ce instanceof Y||(ce=new Y(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},Y.prototype.compareMain=function(ce){return ce instanceof Y||(ce=new Y(ce,this.loose)),be(this.major,ce.major)||be(this.minor,ce.minor)||be(this.patch,ce.patch)},Y.prototype.comparePre=function(ce){if(ce instanceof Y||(ce=new Y(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var Ce=0;do{var ye=this.prerelease[Ce],He=ce.prerelease[Ce];if(D("prerelease compare",Ce,ye,He),ye===void 0&&He===void 0)return 0;if(He===void 0)return 1;if(ye===void 0)return-1;if(ye!==He)return be(ye,He)}while(++Ce)},Y.prototype.inc=function(ce,Ce){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,Ce,ye,He){typeof ye=="string"&&(He=ye,ye=void 0);try{return new Y(ce,ye).inc(Ce,He).version}catch{return null}},e.diff=function(ce,Ce){if(oe(ce,Ce))return null;var ye=pe(ce),He=pe(Ce);if(ye.prerelease.length||He.prerelease.length){for(var je in ye)if((je==="major"||je==="minor"||je==="patch")&&ye[je]!==He[je])return"pre"+je;return"prerelease"}for(var je in ye)if((je==="major"||je==="minor"||je==="patch")&&ye[je]!==He[je])return je},e.compareIdentifiers=be;var ve=/^[0-9]+$/;function be(ce,Ce){var ye=ve.test(ce),He=ve.test(Ce);return ye&&He&&(ce=+ce,Ce=+Ce),ye&&!He?-1:He&&!ye?1:ce<Ce?-1:ce>Ce?1:0}function ke(ce,Ce,ye){return new Y(ce,ye).compare(new Y(Ce,ye))}function Re(ce,Ce,ye){return ke(ce,Ce,ye)>0}function We(ce,Ce,ye){return ke(ce,Ce,ye)<0}function oe(ce,Ce,ye){return ke(ce,Ce,ye)===0}function le(ce,Ce,ye){return ke(ce,Ce,ye)!==0}function fe(ce,Ce,ye){return ke(ce,Ce,ye)>=0}function Z(ce,Ce,ye){return ke(ce,Ce,ye)<=0}function ae(ce,Ce,ye,He){var je;switch(Ce){case"===":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),je=ce===ye;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),je=ce!==ye;break;case"":case"=":case"==":je=oe(ce,ye,He);break;case"!=":je=le(ce,ye,He);break;case">":je=Re(ce,ye,He);break;case">=":je=fe(ce,ye,He);break;case"<":je=We(ce,ye,He);break;case"<=":je=Z(ce,ye,He);break;default:throw new TypeError("Invalid operator: "+Ce)}return je}function ne(ce,Ce){if(ce instanceof ne){if(ce.loose===Ce)return ce;ce=ce.value}if(!(this instanceof ne))return new ne(ce,Ce);D("comparator",ce,Ce),this.loose=Ce,this.parse(ce),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ce,Ce){return be(Ce,ce)},e.major=function(ce,Ce){return new Y(ce,Ce).major},e.minor=function(ce,Ce){return new Y(ce,Ce).minor},e.patch=function(ce,Ce){return new Y(ce,Ce).patch},e.compare=ke,e.compareLoose=function(ce,Ce){return ke(ce,Ce,!0)},e.rcompare=function(ce,Ce,ye){return ke(Ce,ce,ye)},e.sort=function(ce,Ce){return ce.sort(function(ye,He){return e.compare(ye,He,Ce)})},e.rsort=function(ce,Ce){return ce.sort(function(ye,He){return e.rcompare(ye,He,Ce)})},e.gt=Re,e.lt=We,e.eq=oe,e.neq=le,e.gte=fe,e.lte=Z,e.cmp=ae,e.Comparator=ne;var ie={};function O(ce,Ce){if(ce instanceof O)return ce.loose===Ce?ce:new O(ce.raw,Ce);if(ce instanceof ne)return new O(ce.value,Ce);if(!(this instanceof O))return new O(ce,Ce);if(this.loose=Ce,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function V(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function q(ce,Ce,ye,He,je,Ze,Qe,Le,rt,re,se,Se,ue){return((Ce=V(ye)?"":V(He)?">="+ye+".0.0":V(je)?">="+ye+"."+He+".0":">="+Ce)+" "+(Le=V(rt)?"":V(re)?"<"+(+rt+1)+".0.0":V(se)?"<"+rt+"."+(+re+1)+".0":Se?"<="+rt+"."+re+"."+se+"-"+Se:"<="+Le)).trim()}function K(ce,Ce){for(var ye=0;ye<ce.length;ye++)if(!ce[ye].test(Ce))return!1;if(Ce.prerelease.length){for(ye=0;ye<ce.length;ye++)if(D(ce[ye].semver),ce[ye].semver!==ie&&ce[ye].semver.prerelease.length>0){var He=ce[ye].semver;if(He.major===Ce.major&&He.minor===Ce.minor&&He.patch===Ce.patch)return!0}return!1}return!0}function me(ce,Ce,ye){try{Ce=new O(Ce,ye)}catch{return!1}return Ce.test(ce)}function we(ce,Ce,ye,He){var je,Ze,Qe,Le,rt;switch(ce=new Y(ce,He),Ce=new O(Ce,He),ye){case">":je=Re,Ze=Z,Qe=We,Le=">",rt=">=";break;case"<":je=We,Ze=fe,Qe=Re,Le="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(me(ce,Ce,He))return!1;for(var re=0;re<Ce.set.length;++re){var se=Ce.set[re],Se=null,ue=null;if(se.forEach(function(Te){Te.semver===ie&&(Te=new ne(">=0.0.0")),Se=Se||Te,ue=ue||Te,je(Te.semver,Se.semver,He)?Se=Te:Qe(Te.semver,ue.semver,He)&&(ue=Te)}),Se.operator===Le||Se.operator===rt||(!ue.operator||ue.operator===Le)&&Ze(ce,ue.semver)||ue.operator===rt&&Qe(ce,ue.semver))return!1}return!0}ne.prototype.parse=function(ce){var Ce=this.loose?k[U]:k[X],ye=ce.match(Ce);if(!ye)throw new TypeError("Invalid comparator: "+ce);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new Y(ye[2],this.loose):this.semver=ie},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(ce){return D("Comparator.test",ce,this.loose),this.semver===ie||(typeof ce=="string"&&(ce=new Y(ce,this.loose)),ae(ce,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(ce,Ce){if(!(ce instanceof ne))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new O(ce.value,Ce),me(this.value,ye,Ce);if(ce.operator==="")return ye=new O(this.value,Ce),me(ce.semver,ye,Ce);var He=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ze=this.semver.version===ce.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Le=ae(this.semver,"<",ce.semver,Ce)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),rt=ae(this.semver,">",ce.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return He||je||Ze&&Qe||Le||rt},e.Range=O,O.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},O.prototype.toString=function(){return this.range},O.prototype.parseRange=function(ce){var Ce=this.loose;ce=ce.trim(),D("range",ce,Ce);var ye=Ce?k[Q]:k[x];ce=ce.replace(ye,q),D("hyphen replace",ce),ce=ce.replace(k[$],"$1$2$3"),D("comparator trim",ce,k[$]),ce=(ce=(ce=ce.replace(k[M],"$1~")).replace(k[F],"$1^")).split(/\s+/).join(" ");var He=Ce?k[U]:k[X],je=ce.split(" ").map(function(Ze){return function(Qe,Le){return D("comp",Qe),Qe=function(rt,re){return rt.trim().split(/\s+/).map(function(se){return function(Se,ue){D("caret",Se,ue);var Te=ue?k[B]:k[G];return Se.replace(Te,function(Me,Be,ze,Ye,nt){var ct;return D("caret",Se,Me,Be,ze,Ye,nt),V(Be)?ct="":V(ze)?ct=">="+Be+".0.0 <"+(+Be+1)+".0.0":V(Ye)?ct=Be==="0"?">="+Be+"."+ze+".0 <"+Be+"."+(+ze+1)+".0":">="+Be+"."+ze+".0 <"+(+Be+1)+".0.0":nt?(D("replaceCaret pr",nt),nt.charAt(0)!=="-"&&(nt="-"+nt),ct=Be==="0"?ze==="0"?">="+Be+"."+ze+"."+Ye+nt+" <"+Be+"."+ze+"."+(+Ye+1):">="+Be+"."+ze+"."+Ye+nt+" <"+Be+"."+(+ze+1)+".0":">="+Be+"."+ze+"."+Ye+nt+" <"+(+Be+1)+".0.0"):(D("no pr"),ct=Be==="0"?ze==="0"?">="+Be+"."+ze+"."+Ye+" <"+Be+"."+ze+"."+(+Ye+1):">="+Be+"."+ze+"."+Ye+" <"+Be+"."+(+ze+1)+".0":">="+Be+"."+ze+"."+Ye+" <"+(+Be+1)+".0.0"),D("caret return",ct),ct})}(se,re)}).join(" ")}(Qe,Le),D("caret",Qe),Qe=function(rt,re){return rt.trim().split(/\s+/).map(function(se){return function(Se,ue){var Te=ue?k[z]:k[A];return Se.replace(Te,function(Me,Be,ze,Ye,nt){var ct;return D("tilde",Se,Me,Be,ze,Ye,nt),V(Be)?ct="":V(ze)?ct=">="+Be+".0.0 <"+(+Be+1)+".0.0":V(Ye)?ct=">="+Be+"."+ze+".0 <"+Be+"."+(+ze+1)+".0":nt?(D("replaceTilde pr",nt),nt.charAt(0)!=="-"&&(nt="-"+nt),ct=">="+Be+"."+ze+"."+Ye+nt+" <"+Be+"."+(+ze+1)+".0"):ct=">="+Be+"."+ze+"."+Ye+" <"+Be+"."+(+ze+1)+".0",D("tilde return",ct),ct})}(se,re)}).join(" ")}(Qe,Le),D("tildes",Qe),Qe=function(rt,re){return D("replaceXRanges",rt,re),rt.split(/\s+/).map(function(se){return function(Se,ue){Se=Se.trim();var Te=ue?k[C]:k[h];return Se.replace(Te,function(Me,Be,ze,Ye,nt,ct){D("xRange",Se,Me,Be,ze,Ye,nt,ct);var pt=V(ze),Je=pt||V(Ye),st=Je||V(nt);return Be==="="&&st&&(Be=""),pt?Me=Be===">"||Be==="<"?"<0.0.0":"*":Be&&st?(Je&&(Ye=0),st&&(nt=0),Be===">"?(Be=">=",Je?(ze=+ze+1,Ye=0,nt=0):st&&(Ye=+Ye+1,nt=0)):Be==="<="&&(Be="<",Je?ze=+ze+1:Ye=+Ye+1),Me=Be+ze+"."+Ye+"."+nt):Je?Me=">="+ze+".0.0 <"+(+ze+1)+".0.0":st&&(Me=">="+ze+"."+Ye+".0 <"+ze+"."+(+Ye+1)+".0"),D("xRange return",Me),Me})}(se,re)}).join(" ")}(Qe,Le),D("xrange",Qe),Qe=function(rt,re){return D("replaceStars",rt,re),rt.trim().replace(k[de],"")}(Qe,Le),D("stars",Qe),Qe}(Ze,Ce)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Ze){return!!Ze.match(He)})),je=je.map(function(Ze){return new ne(Ze,Ce)})},O.prototype.intersects=function(ce,Ce){if(!(ce instanceof O))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(He){return ce.set.some(function(je){return je.every(function(Ze){return He.intersects(Ze,Ce)})})})})},e.toComparators=function(ce,Ce){return new O(ce,Ce).set.map(function(ye){return ye.map(function(He){return He.value}).join(" ").trim().split(" ")})},O.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new Y(ce,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(K(this.set[Ce],ce))return!0;return!1},e.satisfies=me,e.maxSatisfying=function(ce,Ce,ye){var He=null,je=null;try{var Ze=new O(Ce,ye)}catch{return null}return ce.forEach(function(Qe){Ze.test(Qe)&&(He&&je.compare(Qe)!==-1||(je=new Y(He=Qe,ye)))}),He},e.minSatisfying=function(ce,Ce,ye){var He=null,je=null;try{var Ze=new O(Ce,ye)}catch{return null}return ce.forEach(function(Qe){Ze.test(Qe)&&(He&&je.compare(Qe)!==1||(je=new Y(He=Qe,ye)))}),He},e.validRange=function(ce,Ce){try{return new O(ce,Ce).range||"*"}catch{return null}},e.ltr=function(ce,Ce,ye){return we(ce,Ce,"<",ye)},e.gtr=function(ce,Ce,ye){return we(ce,Ce,">",ye)},e.outside=we,e.prerelease=function(ce,Ce){var ye=pe(ce,Ce);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ce,Ce,ye){return ce=new O(ce,ye),Ce=new O(Ce,ye),ce.intersects(Ce)},e.coerce=function(ce){if(ce instanceof Y)return ce;if(typeof ce!="string")return null;var Ce=ce.match(k[R]);return Ce==null?null:pe((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,l(1))},function(J,e){var l,t,D=J.exports={};function P(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function k(b){if(l===setTimeout)return setTimeout(b,0);if((l===P||!l)&&setTimeout)return l=setTimeout,setTimeout(b,0);try{return l(b,0)}catch{try{return l.call(null,b,0)}catch{return l.call(this,b,0)}}}(function(){try{l=typeof setTimeout=="function"?setTimeout:P}catch{l=P}try{t=typeof clearTimeout=="function"?clearTimeout:_}catch{t=_}})();var w,I=[],L=!1,y=-1;function S(){L&&w&&(L=!1,w.length?I=w.concat(I):y=-1,I.length&&T())}function T(){if(!L){var b=k(S);L=!0;for(var f=I.length;f;){for(w=I,I=[];++y<f;)w&&w[y].run();y=-1,f=I.length}w=null,L=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===_||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(b)}}function E(b,f){this.fun=b,this.array=f}function p(){}D.nextTick=function(b){var f=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)f[v-1]=arguments[v];I.push(new E(b,f)),I.length!==1||L||k(T)},E.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=p,D.addListener=p,D.once=p,D.off=p,D.removeListener=p,D.removeAllListeners=p,D.emit=p,D.prependListener=p,D.prependOnceListener=p,D.listeners=function(b){return[]},D.binding=function(b){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(b){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(De[97],Ie([1,0,10,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(c){const m=c;return m?typeof m.read=="function":!1}e.isReadable=D;function P(c){const m=c;return m?[m.on,m.pause,m.resume,m.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=P;function _(c){const m=c;return m?P(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=_;function k(c,m){return new w(c,m)}e.newWriteableStream=k;class w{constructor(m,n){this.reducer=m,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m<"u"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(n=>n(m))}emitError(m){this.listeners.error.length===0?(0,l.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(n=>n(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,n){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(m,n){if(this.state.destroyed)return;let d;switch(m){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const s=d.indexOf(n);s>=0&&d.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(c,m){const n=[];let d;for(;(d=c.read())!==null;)n.push(d);return m(n)}e.consumeReadable=I;function L(c,m,n){const d=[];let s;for(;(s=c.read())!==null&&d.length<n;)d.push(s);return s===null&&d.length>0?m(d):{read:()=>{if(d.length>0)return d.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return c.read()}}}e.peekReadable=L;function y(c,m){return new Promise((n,d)=>{const s=[];S(c,{onData:i=>{m&&s.push(i)},onError:i=>{m?d(i):n(void 0)},onEnd:()=>{n(m?m(s):void 0)}})})}e.consumeStream=y;function S(c,m){let n=!1;return c.on("error",d=>{n||m.onError(d)}),c.on("end",()=>{n||m.onEnd()}),c.on("data",d=>{n||m.onData(d)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=S;function T(c,m){return new Promise((n,d)=>{const s=new t.DisposableStore,i=[],r=u=>{if(i.push(u),i.length>m)return s.dispose(),c.pause(),n({stream:c,buffer:i,ended:!1})},a=u=>d(u),o=()=>n({stream:c,buffer:i,ended:!0});s.add((0,t.toDisposable)(()=>c.removeListener("error",a))),c.on("error",a),s.add((0,t.toDisposable)(()=>c.removeListener("end",o))),c.on("end",o),s.add((0,t.toDisposable)(()=>c.removeListener("data",r))),c.on("data",r)})}e.peekStream=T;function E(c,m){const n=k(m);return n.end(c),n}e.toStream=E;function p(){const c=k(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=p;function b(c){let m=!1;return{read:()=>m?null:(m=!0,c)}}e.toReadable=b;function f(c,m,n){const d=k(n);return S(c,{onData:s=>d.write(m.data(s)),onError:s=>d.error(m.error?m.error(s):s),onEnd:()=>d.end()}),d}e.transform=f;function v(c,m,n){let d=!1;return{read:()=>{const s=m.read();return d?s:(d=!0,s!==null?n([c,s]):c)}}}e.prefixedReadable=v;function g(c,m,n){let d=!1;const s=k(n);return S(m,{onData:i=>d?s.write(i):(d=!0,s.write(n([c,i]))),onError:i=>s.error(i),onEnd:()=>{d||(d=!0,s.write(c)),s.end()}}),s}e.prefixedStream=g}),define(De[23],Ie([1,0,97]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let D,P;class _{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return t?new _(Buffer.allocUnsafe(u)):new _(new Uint8Array(u))}static wrap(u){return t&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new _(u)}static fromString(u,h){return!(h?.dontUseNodeBuffer||!1)&&t?new _(Buffer.from(u)):(D||(D=new TextEncoder),new _(D.encode(u)))}static fromByteArray(u){const h=_.alloc(u.length);for(let C=0,R=u.length;C<R;C++)h.buffer[C]=u[C];return h}static concat(u,h){if(typeof h>"u"){h=0;for(let N=0,M=u.length;N<M;N++)h+=u[N].byteLength}const C=_.alloc(h);let R=0;for(let N=0,M=u.length;N<M;N++){const A=u[N];C.set(A,R),R+=A.byteLength}return C}clone(){const u=_.alloc(this.byteLength);return u.set(this),u}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(u,h){return new _(this.buffer.subarray(u,h))}set(u,h){if(u instanceof _)this.buffer.set(u.buffer,h);else if(u instanceof Uint8Array)this.buffer.set(u,h);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),h);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return I(this.buffer,u)}writeUInt32BE(u,h){L(this.buffer,u,h)}readUInt32LE(u){return y(this.buffer,u)}writeUInt32LE(u,h){S(this.buffer,u,h)}readUInt8(u){return T(this.buffer,u)}writeUInt8(u,h){E(this.buffer,u,h)}}e.VSBuffer=_;function k(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0}e.readUInt16LE=k;function w(o,u,h){o[h+0]=u&255,u=u>>>8,o[h+1]=u&255}e.writeUInt16LE=w;function I(o,u){return o[u]*2**24+o[u+1]*2**16+o[u+2]*2**8+o[u+3]}e.readUInt32BE=I;function L(o,u,h){o[h+3]=u,u=u>>>8,o[h+2]=u,u=u>>>8,o[h+1]=u,u=u>>>8,o[h]=u}e.writeUInt32BE=L;function y(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0|o[u+2]<<16>>>0|o[u+3]<<24>>>0}e.readUInt32LE=y;function S(o,u,h){o[h+0]=u&255,u=u>>>8,o[h+1]=u&255,u=u>>>8,o[h+2]=u&255,u=u>>>8,o[h+3]=u&255}e.writeUInt32LE=S;function T(o,u){return o[u]}e.readUInt8=T;function E(o,u,h){o[h]=u}e.writeUInt8=E;function p(o){return l.consumeReadable(o,u=>_.concat(u))}e.readableToBuffer=p;function b(o){return l.toReadable(o)}e.bufferToReadable=b;function f(o){return l.consumeStream(o,u=>_.concat(u))}e.streamToBuffer=f;async function v(o){return o.ended?_.concat(o.buffer):_.concat([...o.buffer,await f(o.stream)])}e.bufferedStreamToBuffer=v;function g(o){return l.toStream(o,u=>_.concat(u))}e.bufferToStream=g;function c(o){return l.transform(o,{data:u=>typeof u=="string"?_.fromString(u):_.wrap(u)},u=>_.concat(u))}e.streamToBufferReadableStream=c;function m(o){return l.newWriteableStream(u=>_.concat(u),o)}e.newWriteableBufferStream=m;function n(o,u){return l.prefixedReadable(o,u,h=>_.concat(h))}e.prefixedBufferReadable=n;function d(o,u){return l.prefixedStream(o,u,h=>_.concat(h))}e.prefixedBufferStream=d;function s(o){let u=0,h=0,C=0;const R=new Uint8Array(Math.floor(o.length/4*3)),N=A=>{switch(h){case 3:R[C++]=u|A,h=0;break;case 2:R[C++]=u|A>>>2,u=A<<6,h=3;break;case 1:R[C++]=u|A>>>4,u=A<<4,h=2;break;default:u=A<<2,h=1}};for(let A=0;A<o.length;A++){const z=o.charCodeAt(A);if(z>=65&&z<=90)N(z-65);else if(z>=97&&z<=122)N(z-97+26);else if(z>=48&&z<=57)N(z-48+52);else if(z===43||z===45)N(62);else if(z===47||z===95)N(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${o[A]}`)}}const M=C;for(;h>0;)N(0);return _.wrap(R).slice(0,M)}e.decodeBase64=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:o},u=!0,h=!1){const C=h?r:i;let R="";const N=o.byteLength%3;let M=0;for(;M<o.byteLength-N;M+=3){const A=o[M+0],z=o[M+1],H=o[M+2];R+=C[A>>>2],R+=C[(A<<4|z>>>4)&63],R+=C[(z<<2|H>>>6)&63],R+=C[H&63]}if(N===1){const A=o[M+0];R+=C[A>>>2],R+=C[A<<4&63],u&&(R+="==")}else if(N===2){const A=o[M+0],z=o[M+1];R+=C[A>>>2],R+=C[(A<<4|z>>>4)&63],R+=C[z<<2&63],u&&(R+="=")}return R}e.encodeBase64=a}),define(De[16],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function l(d){return typeof d=="string"}e.isString=l;function t(d){return Array.isArray(d)&&d.every(s=>l(s))}e.isStringArray=t;function D(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=D;function P(d){const s=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof s}e.isTypedArray=P;function _(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=_;function k(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=k;function w(d){return d===!0||d===!1}e.isBoolean=w;function I(d){return typeof d>"u"}e.isUndefined=I;function L(d){return!y(d)}e.isDefined=L;function y(d){return I(d)||d===null}e.isUndefinedOrNull=y;function S(d,s){if(!d)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=S;function T(d){if(y(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=T;function E(...d){const s=[];for(let i=0;i<d.length;i++){const r=d[i];if(y(r))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);s.push(r)}return s}e.assertAllDefined=E;const p=Object.prototype.hasOwnProperty;function b(d){if(!D(d))return!1;for(const s in d)if(p.call(d,s))return!1;return!0}e.isEmptyObject=b;function f(d){return typeof d=="function"}e.isFunction=f;function v(...d){return d.length>0&&d.every(f)}e.areFunctions=v;function g(d,s){const i=Math.min(d.length,s.length);for(let r=0;r<i;r++)c(d[r],s[r])}e.validateConstraints=g;function c(d,s){if(l(s)){if(typeof d!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(f(s)){try{if(d instanceof s)return}catch{}if(!y(d)&&d.constructor===s||s.length===1&&s.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function m(d){return d===null?void 0:d}e.withNullAsUndefined=m;function n(d){return typeof d>"u"?null:d}e.withUndefinedAsNull=n}),define(De[24],Ie([1,0,16]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const v=Array.isArray(f)?[]:{};return Object.keys(f).forEach(g=>{f[g]&&typeof f[g]=="object"?v[g]=t(f[g]):v[g]=f[g]}),v}e.deepClone=t;function D(f){if(!f||typeof f!="object")return f;const v=[f];for(;v.length>0;){const g=v.shift();Object.freeze(g);for(const c in g)if(P.call(g,c)){const m=g[c];typeof m=="object"&&!Object.isFrozen(m)&&!(0,l.isTypedArray)(m)&&v.push(m)}}return f}e.deepFreeze=D;const P=Object.prototype.hasOwnProperty;function _(f,v){return k(f,v,new Set)}e.cloneAndChange=_;function k(f,v,g){if((0,l.isUndefinedOrNull)(f))return f;const c=v(f);if(typeof c<"u")return c;if(Array.isArray(f)){const m=[];for(const n of f)m.push(k(n,v,g));return m}if((0,l.isObject)(f)){if(g.has(f))throw new Error("Cannot clone recursive data-structure");g.add(f);const m={};for(const n in f)P.call(f,n)&&(m[n]=k(f[n],v,g));return g.delete(f),m}return f}function w(f,v,g=!0){return(0,l.isObject)(f)?((0,l.isObject)(v)&&Object.keys(v).forEach(c=>{c in f?g&&((0,l.isObject)(f[c])&&(0,l.isObject)(v[c])?w(f[c],v[c],g):f[c]=v[c]):f[c]=v[c]}),f):v}e.mixin=w;function I(f,v){if(f===v)return!0;if(f==null||v===null||v===void 0||typeof f!=typeof v||typeof f!="object"||Array.isArray(f)!==Array.isArray(v))return!1;let g,c;if(Array.isArray(f)){if(f.length!==v.length)return!1;for(g=0;g<f.length;g++)if(!I(f[g],v[g]))return!1}else{const m=[];for(c in f)m.push(c);m.sort();const n=[];for(c in v)n.push(c);if(n.sort(),!I(m,n))return!1;for(g=0;g<m.length;g++)if(!I(f[m[g]],v[m[g]]))return!1}return!0}e.equals=I;function L(f){const v=new Set;return JSON.stringify(f,(g,c)=>{if((0,l.isObject)(c)||Array.isArray(c)){if(v.has(c))return"[Circular]";v.add(c)}return c})}e.safeStringify=L;function y(f,v){const g=Object.create(null);return!f||!v||Object.keys(v).forEach(m=>{const n=f[m],d=v[m];I(n,d)||(g[m]=d)}),g}e.distinct=y;function S(f,v){const g=v.toLowerCase(),c=Object.keys(f).find(m=>m.toLowerCase()===g);return c?f[c]:f[v]}e.getCaseInsensitive=S;function T(f,v){const g=Object.create(null);for(const[c,m]of Object.entries(f))v(c,m)&&(g[c]=m);return g}e.filter=T;function E(f){let v=[],g=Object.getPrototypeOf(f);for(;Object.prototype!==g;)v=v.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return v}e.getAllPropertyNames=E;function p(f){const v=[];for(const g of E(f))typeof f[g]=="function"&&v.push(g);return v}e.getAllMethodNames=p;function b(f,v){const g=m=>function(){const n=Array.prototype.slice.call(arguments,0);return v(m,n)},c={};for(const m of f)c[m]=g(m);return c}e.createProxyObject=b}),define(De[98],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var l;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(l=e.Constants||(e.Constants={}));function t(P){return P<0?0:P>255?255:P|0}e.toUint8=t;function D(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=D}),define(De[34],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return l.test(D)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(k){for(let w=0;w<k.length;w++)k[w]=Math.floor(Math.random()*256);return k};const P=new Uint8Array(16),_=[];for(let k=0;k<256;k++)_.push(k.toString(16).padStart(2,"0"));return function(){D(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let w=0,I="";return I+=_[P[w++]],I+=_[P[w++]],I+=_[P[w++]],I+=_[P[w++]],I+="-",I+=_[P[w++]],I+=_[P[w++]],I+="-",I+=_[P[w++]],I+=_[P[w++]],I+="-",I+=_[P[w++]],I+=_[P[w++]],I+="-",I+=_[P[w++]],I+=_[P[w++]],I+=_[P[w++]],I+=_[P[w++]],I+=_[P[w++]],I+=_[P[w++]],I}}()}),define(De[99],Ie([1,0,98]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(k){const w=(0,l.toUint8)(k);this._defaultValue=w,this._asciiMap=t._createAsciiMap(w),this._map=new Map}static _createAsciiMap(k){const w=new Uint8Array(256);for(let I=0;I<256;I++)w[I]=k;return w}set(k,w){const I=(0,l.toUint8)(w);k>=0&&k<256?this._asciiMap[k]=I:this._map.set(k,I)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=t;var D;(function(_){_[_.False=0]="False",_[_.True=1]="True"})(D||(D={}));class P{constructor(){this._actual=new t(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=P}),define(De[49],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class l{constructor(D,P){this.lineNumber=D,this.column=P}with(D=this.lineNumber,P=this.column){return D===this.lineNumber&&P===this.column?this:new l(D,P)}delta(D=0,P=0){return this.with(this.lineNumber+D,this.column+P)}equals(D){return l.equals(this,D)}static equals(D,P){return!D&&!P?!0:!!D&&!!P&&D.lineNumber===P.lineNumber&&D.column===P.column}isBefore(D){return l.isBefore(this,D)}static isBefore(D,P){return D.lineNumber<P.lineNumber?!0:P.lineNumber<D.lineNumber?!1:D.column<P.column}isBeforeOrEqual(D){return l.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,P){return D.lineNumber<P.lineNumber?!0:P.lineNumber<D.lineNumber?!1:D.column<=P.column}static compare(D,P){const _=D.lineNumber|0,k=P.lineNumber|0;if(_===k){const w=D.column|0,I=P.column|0;return w-I}return _-k}clone(){return new l(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new l(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=l}),define(De[35],Ie([1,0,49]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,_,k,w){P>k||P===k&&_>w?(this.startLineNumber=k,this.startColumn=w,this.endLineNumber=P,this.endColumn=_):(this.startLineNumber=P,this.startColumn=_,this.endLineNumber=k,this.endColumn=w)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,_){return!(_.lineNumber<P.startLineNumber||_.lineNumber>P.endLineNumber||_.lineNumber===P.startLineNumber&&_.column<P.startColumn||_.lineNumber===P.endLineNumber&&_.column>P.endColumn)}static strictContainsPosition(P,_){return!(_.lineNumber<P.startLineNumber||_.lineNumber>P.endLineNumber||_.lineNumber===P.startLineNumber&&_.column<=P.startColumn||_.lineNumber===P.endLineNumber&&_.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,_){return!(_.startLineNumber<P.startLineNumber||_.endLineNumber<P.startLineNumber||_.startLineNumber>P.endLineNumber||_.endLineNumber>P.endLineNumber||_.startLineNumber===P.startLineNumber&&_.startColumn<P.startColumn||_.endLineNumber===P.endLineNumber&&_.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,_){return!(_.startLineNumber<P.startLineNumber||_.endLineNumber<P.startLineNumber||_.startLineNumber>P.endLineNumber||_.endLineNumber>P.endLineNumber||_.startLineNumber===P.startLineNumber&&_.startColumn<=P.startColumn||_.endLineNumber===P.endLineNumber&&_.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,_){let k,w,I,L;return _.startLineNumber<P.startLineNumber?(k=_.startLineNumber,w=_.startColumn):_.startLineNumber===P.startLineNumber?(k=_.startLineNumber,w=Math.min(_.startColumn,P.startColumn)):(k=P.startLineNumber,w=P.startColumn),_.endLineNumber>P.endLineNumber?(I=_.endLineNumber,L=_.endColumn):_.endLineNumber===P.endLineNumber?(I=_.endLineNumber,L=Math.max(_.endColumn,P.endColumn)):(I=P.endLineNumber,L=P.endColumn),new t(k,w,I,L)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,_){let k=P.startLineNumber,w=P.startColumn,I=P.endLineNumber,L=P.endColumn;const y=_.startLineNumber,S=_.startColumn,T=_.endLineNumber,E=_.endColumn;return k<y?(k=y,w=S):k===y&&(w=Math.max(w,S)),I>T?(I=T,L=E):I===T&&(L=Math.min(L,E)),k>I||k===I&&w>L?null:new t(k,w,I,L)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,_){return!!P&&!!_&&P.startLineNumber===_.startLineNumber&&P.startColumn===_.startColumn&&P.endLineNumber===_.endLineNumber&&P.endColumn===_.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new l.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new l.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,_){return new t(this.startLineNumber,this.startColumn,P,_)}setStartPosition(P,_){return new t(P,_,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(P){return new t(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,_=P){return new t(P.lineNumber,P.column,_.lineNumber,_.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,_){return!(P.endLineNumber<_.startLineNumber||P.endLineNumber===_.startLineNumber&&P.endColumn<_.startColumn||_.endLineNumber<P.startLineNumber||_.endLineNumber===P.startLineNumber&&_.endColumn<P.startColumn)}static areIntersecting(P,_){return!(P.endLineNumber<_.startLineNumber||P.endLineNumber===_.startLineNumber&&P.endColumn<=_.startColumn||_.endLineNumber<P.startLineNumber||_.endLineNumber===P.startLineNumber&&_.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,_){if(P&&_){const I=P.startLineNumber|0,L=_.startLineNumber|0;if(I===L){const y=P.startColumn|0,S=_.startColumn|0;if(y===S){const T=P.endLineNumber|0,E=_.endLineNumber|0;if(T===E){const p=P.endColumn|0,b=_.endColumn|0;return p-b}return T-E}return y-S}return I-L}return(P?1:0)-(_?1:0)}static compareRangesUsingEnds(P,_){return P.endLineNumber===_.endLineNumber?P.endColumn===_.endColumn?P.startLineNumber===_.startLineNumber?P.startColumn-_.startColumn:P.startLineNumber-_.startLineNumber:P.endColumn-_.endColumn:P.endLineNumber-_.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(De[146],Ie([1,0,49,35]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(_){_[_.LTR=0]="LTR",_[_.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class P extends t.Range{constructor(k,w,I,L){super(k,w,I,L),this.selectionStartLineNumber=k,this.selectionStartColumn=w,this.positionLineNumber=I,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return P.selectionsEqual(this,k)}static selectionsEqual(k,w){return k.selectionStartLineNumber===w.selectionStartLineNumber&&k.selectionStartColumn===w.selectionStartColumn&&k.positionLineNumber===w.positionLineNumber&&k.positionColumn===w.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,w){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,k,w):new P(k,w,this.startLineNumber,this.startColumn)}getPosition(){return new l.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new l.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,w){return this.getDirection()===0?new P(k,w,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,k,w)}static fromPositions(k,w=k){return new P(k.lineNumber,k.column,w.lineNumber,w.column)}static fromRange(k,w){return w===0?new P(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new P(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new P(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,w){if(k&&!w||!k&&w)return!1;if(!k&&!w)return!0;if(k.length!==w.length)return!1;for(let I=0,L=k.length;I<L;I++)if(!this.selectionsEqual(k[I],w[I]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,w,I,L,y){return y===0?new P(k,w,I,L):new P(I,L,k,w)}}e.Selection=P}),define(De[147],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[148],Ie([1,0,99]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(_){_[_.Regular=0]="Regular",_[_.Whitespace=1]="Whitespace",_[_.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends l.CharacterClassifier{constructor(k){super(0);for(let w=0,I=k.length;w<I;w++)this.set(k.charCodeAt(w),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function P(_){const k={};return w=>(k.hasOwnProperty(w)||(k[w]=_(w)),k[w])}e.getMapForWordSeparators=P(_=>new D(_))}),define(De[100],Ie([1,0,60,6,77]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(y=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)y.indexOf(T)>=0||(S+="\\"+T);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=P();function _(y){let S=e.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)S=y;else{let T="g";y.ignoreCase&&(T+="i"),y.multiline&&(T+="m"),y.unicode&&(T+="u"),S=new RegExp(y.source,T)}return S.lastIndex=0,S}e.ensureValidWordDefinition=_;const k=new D.LinkedList;k.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function w(y){const S=k.unshift(y);return(0,t.toDisposable)(S)}e.setDefaultGetWordAtTextConfig=w;function I(y,S,T,E,p){if(p||(p=l.Iterable.first(k)),T.length>p.maxLen){let c=y-p.maxLen/2;return c<0?c=0:E+=c,T=T.substring(c,y+p.maxLen/2),I(y,S,T,E,p)}const b=Date.now(),f=y-1-E;let v=-1,g=null;for(let c=1;!(Date.now()-b>=p.timeBudget);c++){const m=f-p.windowSize*c;S.lastIndex=Math.max(0,m);const n=L(S,T,f,v);if(!n&&g||(g=n,m<=0))break;v=m}if(g){const c={word:g[0],startColumn:E+1+g.index,endColumn:E+1+g.index+g[0].length};return S.lastIndex=0,c}return null}e.getWordAtText=I;function L(y,S,T,E){let p;for(;p=y.exec(S);){const b=p.index||0;if(b<=T&&y.lastIndex>=T)return p;if(E>0&&b>E)return null}return null}}),define(De[149],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var l;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(l=e.IndentAction||(e.IndentAction={}));class t{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let w=0,I=k.notIn.length;w<I;w++)switch(k.notIn[w]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,w){if(k.getTokenCount()===0)return!0;const I=k.findTokenIndexAtOffset(w-2),L=k.getStandardTokenType(I);return this.isOK(L)}_findNeutralCharacterInRange(k,w){for(let I=k;I<=w;I++){const L=String.fromCharCode(I);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class D{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of k)P(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),P(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),P(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),P(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&P(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.AutoClosingPairs=D;function P(_,k,w){_.has(k)?_.get(k).push(w):_.set(k,[w])}}),define(De[150],Ie([1,0,99]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class D{constructor(E,p,b){const f=new Uint8Array(E*p);for(let v=0,g=E*p;v<g;v++)f[v]=b;this._data=f,this.rows=E,this.cols=p}get(E,p){return this._data[E*this.cols+p]}set(E,p,b){this._data[E*this.cols+p]=b}}e.Uint8Matrix=D;class P{constructor(E){let p=0,b=0;for(let v=0,g=E.length;v<g;v++){const[c,m,n]=E[v];m>p&&(p=m),c>b&&(b=c),n>b&&(b=n)}p++,b++;const f=new D(b,p,0);for(let v=0,g=E.length;v<g;v++){const[c,m,n]=E[v];f.set(c,m,n)}this._states=f,this._maxCharCode=p}nextState(E,p){return p<0||p>=this._maxCharCode?0:this._states.get(E,p)}}e.StateMachine=P;let _=null;function k(){return _===null&&(_=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),_}var w;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(w||(w={}));let I=null;function L(){if(I===null){I=new l.CharacterClassifier(0);const T=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<T.length;p++)I.set(T.charCodeAt(p),1);const E=".,;:";for(let p=0;p<E.length;p++)I.set(E.charCodeAt(p),2)}return I}class y{static _createLink(E,p,b,f,v){let g=v-1;do{const c=p.charCodeAt(g);if(E.get(c)!==2)break;g--}while(g>f);if(f>0){const c=p.charCodeAt(f-1),m=p.charCodeAt(g);(c===40&&m===41||c===91&&m===93||c===123&&m===125)&&g--}return{range:{startLineNumber:b,startColumn:f+1,endLineNumber:b,endColumn:g+2},url:p.substring(f,g+1)}}static computeLinks(E,p=k()){const b=L(),f=[];for(let v=1,g=E.getLineCount();v<=g;v++){const c=E.getLineContent(v),m=c.length;let n=0,d=0,s=0,i=1,r=!1,a=!1,o=!1,u=!1;for(;n<m;){let h=!1;const C=c.charCodeAt(n);if(i===13){let R;switch(C){case 40:r=!0,R=0;break;case 41:R=r?0:1;break;case 91:o=!0,a=!0,R=0;break;case 93:o=!1,R=a?0:1;break;case 123:u=!0,R=0;break;case 125:R=u?0:1;break;case 39:R=s===39?1:0;break;case 34:R=s===34?1:0;break;case 96:R=s===96?1:0;break;case 42:R=s===42?1:0;break;case 124:R=s===124?1:0;break;case 32:R=o?0:1;break;default:R=b.get(C)}R===1&&(f.push(y._createLink(b,c,v,d,n)),h=!0)}else if(i===12){let R;C===91?(a=!0,R=0):R=b.get(C),R===1?h=!0:i=13}else i=p.nextState(i,C),i===0&&(h=!0);h&&(i=1,r=!1,a=!1,u=!1,d=n+1,s=C),n++}i===13&&f.push(y._createLink(b,c,v,d,m))}return f}}e.LinkComputer=y;function S(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:y.computeLinks(T)}e.computeLinks=S}),define(De[101],Ie([1,0,24]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var _;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(_=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var w;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(w=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),this.indentSize=c.tabSize|0,this.insertSpaces=Boolean(c.insertSpaces),this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=Boolean(c.trimAutoWhitespace),this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,l.equals)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class L{constructor(c,m){this._findMatchBrand=void 0,this.range=c,this.matches=m}}e.FindMatch=L;var y;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function S(g){return g&&typeof g.read=="function"}e.isITextSnapshot=S;var T;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(T=e.PositionAffinity||(e.PositionAffinity={}));var E;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E=e.ModelConstants||(e.ModelConstants={}));class p{constructor(c,m,n,d,s,i){this.identifier=c,this.range=m,this.text=n,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=s,this._isTracked=i}}e.ValidAnnotatedEditOperation=p;class b{constructor(c,m,n){this.regex=c,this.wordSeparators=m,this.simpleSearch=n}}e.SearchData=b;class f{constructor(c,m,n){this.reverseEdits=c,this.changes=m,this.trimAutoWhitespaceLineNumbers=n}}e.ApplyEditsResult=f;function v(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}e.shouldSynchronizeModel=v}),define(De[151],Ie([1,0,17,98]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class D{constructor(w){this.values=w,this.prefixSum=new Uint32Array(w.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(w,I){w=(0,t.toUint32)(w);const L=this.values,y=this.prefixSum,S=I.length;return S===0?!1:(this.values=new Uint32Array(L.length+S),this.values.set(L.subarray(0,w),0),this.values.set(L.subarray(w),w+S),this.values.set(I,w),w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(w,I){return w=(0,t.toUint32)(w),I=(0,t.toUint32)(I),this.values[w]===I?!1:(this.values[w]=I,w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),!0)}removeValues(w,I){w=(0,t.toUint32)(w),I=(0,t.toUint32)(I);const L=this.values,y=this.prefixSum;if(w>=L.length)return!1;const S=L.length-w;return I>=S&&(I=S),I===0?!1:(this.values=new Uint32Array(L.length-I),this.values.set(L.subarray(0,w),0),this.values.set(L.subarray(w+I),w),this.prefixSum=new Uint32Array(this.values.length),w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(w){return w<0?0:(w=(0,t.toUint32)(w),this._getPrefixSum(w))}_getPrefixSum(w){if(w<=this.prefixSumValidIndex[0])return this.prefixSum[w];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),w>=this.values.length&&(w=this.values.length-1);for(let L=I;L<=w;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],w),this.prefixSum[w]}getIndexOf(w){w=Math.floor(w),this.getTotalSum();let I=0,L=this.values.length-1,y=0,S=0,T=0;for(;I<=L;)if(y=I+(L-I)/2|0,S=this.prefixSum[y],T=S-this.values[y],w<T)L=y-1;else if(w>=S)I=y+1;else break;return new _(y,w-T)}}e.PrefixSumComputer=D;class P{constructor(w){this._values=w,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(w){return this._ensureValid(),w===0?0:this._prefixSum[w-1]}getIndexOf(w){this._ensureValid();const I=this._indexBySum[w],L=I>0?this._prefixSum[I-1]:0;return new _(I,w-L)}removeValues(w,I){this._values.splice(w,I),this._invalidate(w)}insertValues(w,I){this._values=(0,l.arrayInsert)(this._values,w,I),this._invalidate(w)}_invalidate(w){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,w-1)}_ensureValid(){if(!this._isValid){for(let w=this._validEndIndex+1,I=this._values.length;w<I;w++){const L=this._values[w],y=w>0?this._prefixSum[w-1]:0;this._prefixSum[w]=y+L;for(let S=0;S<L;S++)this._indexBySum[y+S]=w}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(w,I){this._values[w]!==I&&(this._values[w]=I,this._invalidate(w))}}e.ConstantTimePrefixSumComputer=P;class _{constructor(w,I){this.index=w,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=w,this.remainder=I}}e.PrefixSumIndexOfResult=_}),define(De[152],Ie([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(De[153],Ie([1,0,152]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,D=t*60,P=D*24,_=P*7,k=P*30,w=P*365;function I(y,S,T){typeof y!="number"&&(y=y.getTime());const E=Math.round((new Date().getTime()-y)/1e3);if(E<-30)return(0,l.localize)(0,null,I(new Date().getTime()+E*1e3,!1));if(E<30)return(0,l.localize)(1,null);let p;return E<t?(p=E,S?p===1?T?(0,l.localize)(2,null,p):(0,l.localize)(3,null,p):T?(0,l.localize)(4,null,p):(0,l.localize)(5,null,p):p===1?T?(0,l.localize)(6,null,p):(0,l.localize)(7,null,p):T?(0,l.localize)(8,null,p):(0,l.localize)(9,null,p)):E<D?(p=Math.floor(E/t),S?p===1?T?(0,l.localize)(10,null,p):(0,l.localize)(11,null,p):T?(0,l.localize)(12,null,p):(0,l.localize)(13,null,p):p===1?T?(0,l.localize)(14,null,p):(0,l.localize)(15,null,p):T?(0,l.localize)(16,null,p):(0,l.localize)(17,null,p)):E<P?(p=Math.floor(E/D),S?p===1?T?(0,l.localize)(18,null,p):(0,l.localize)(19,null,p):T?(0,l.localize)(20,null,p):(0,l.localize)(21,null,p):p===1?T?(0,l.localize)(22,null,p):(0,l.localize)(23,null,p):T?(0,l.localize)(24,null,p):(0,l.localize)(25,null,p)):E<_?(p=Math.floor(E/P),S?p===1?(0,l.localize)(26,null,p):(0,l.localize)(27,null,p):p===1?(0,l.localize)(28,null,p):(0,l.localize)(29,null,p)):E<k?(p=Math.floor(E/_),S?p===1?T?(0,l.localize)(30,null,p):(0,l.localize)(31,null,p):T?(0,l.localize)(32,null,p):(0,l.localize)(33,null,p):p===1?T?(0,l.localize)(34,null,p):(0,l.localize)(35,null,p):T?(0,l.localize)(36,null,p):(0,l.localize)(37,null,p)):E<w?(p=Math.floor(E/k),S?p===1?T?(0,l.localize)(38,null,p):(0,l.localize)(39,null,p):T?(0,l.localize)(40,null,p):(0,l.localize)(41,null,p):p===1?T?(0,l.localize)(42,null,p):(0,l.localize)(43,null,p):T?(0,l.localize)(44,null,p):(0,l.localize)(45,null,p)):(p=Math.floor(E/w),S?p===1?T?(0,l.localize)(46,null,p):(0,l.localize)(47,null,p):T?(0,l.localize)(48,null,p):(0,l.localize)(49,null,p):p===1?T?(0,l.localize)(50,null,p):(0,l.localize)(51,null,p):T?(0,l.localize)(52,null,p):(0,l.localize)(53,null,p))}e.fromNow=I;function L(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(De[154],Ie([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(De[50],Ie([1,0,17,16,154]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(y,S){return S&&(y.stack||y.stacktrace)?D.localize(0,null,k(y),_(y.stack)||_(y.stacktrace)):k(y)}function _(y){return Array.isArray(y)?y.join(`
`):y}function k(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?D.localize(1,null,y.message):y.message||D.localize(2,null)}function w(y=null,S=!1){if(!y)return D.localize(3,null);if(Array.isArray(y)){const T=l.coalesce(y),E=w(T[0],S);return T.length>1?D.localize(4,null,E,T.length):E}if(t.isString(y))return y;if(y.detail){const T=y.detail;if(T.error)return P(T.error,S);if(T.exception)return P(T.exception,S)}return y.stack?P(y,S):y.message?y.message:D.localize(5,null)}e.toErrorMessage=w;function I(y){const S=y;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=I;function L(y,S){let T;return typeof y=="string"?T=new Error(y):T=y,T.actions=S,T}e.createErrorWithActions=L}),define(De[155],Ie([19,20]),function(J,e){return J.create("vs/base/common/platform",e)}),define(De[11],Ie([1,0,155]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let D=!1,P=!1,_=!1,k=!1,w=!1,I=!1,L=!1,y=!1,S=!1,T=!1,E,p=t,b,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?v=e.globals.vscode.process:typeof process<"u"&&(v=process);const g=typeof v?.versions?.electron=="string",c=g&&v?.type==="renderer";if(typeof navigator=="object"&&!c)f=navigator.userAgent,D=f.indexOf("Windows")>=0,P=f.indexOf("Macintosh")>=0,y=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=f.indexOf("Linux")>=0,T=f?.indexOf("Mobi")>=0,I=!0,E=l.getConfiguredDefaultLocale(l.localize(0,null))||t,p=E;else if(typeof v=="object"){D=v.platform==="win32",P=v.platform==="darwin",_=v.platform==="linux",k=_&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,L=g,S=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=t,p=t;const u=v.env.VSCODE_NLS_CONFIG;if(u)try{const h=JSON.parse(u),C=h.availableLanguages["*"];E=h.locale,p=C||t,b=h._translationsConfigFile}catch{}w=!0}else console.error("Unable to resolve platform.");var m;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function n(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=n;let d=0;P?d=1:D?d=3:_&&(d=2),e.isWindows=D,e.isMacintosh=P,e.isLinux=_,e.isLinuxSnap=k,e.isNative=w,e.isElectron=L,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=y,e.isMobile=T,e.isCI=S,e.platform=d,e.userAgent=f,e.language=p;var s;(function(u){function h(){return e.language}u.value=h;function C(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=C;function R(){return e.language==="en"}u.isDefault=R})(s=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=b,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const u=[];e.globals.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let R=0,N=u.length;R<N;R++){const M=u[R];if(M.id===C.data.vscodeScheduleAsyncWork){u.splice(R,1),M.callback();return}}});let h=0;return C=>{const R=++h;u.push({id:R,callback:C}),e.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return u=>setTimeout(u)})();var i;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||y?2:D?1:3;let r=!0,a=!1;function o(){if(!a){a=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,r=new Uint16Array(u.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[40],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof l.globals.vscode<"u"&&typeof l.globals.vscode.process<"u"){const D=l.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return l.isWindows?"win32":l.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(De[9],Ie([1,0,40]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,D=97,P=90,_=122,k=46,w=47,I=92,L=58,y=63;class S extends Error{constructor(c,m,n){let d;typeof m=="string"&&m.indexOf("not ")===0?(d="must not be",m=m.replace(/^not /,"")):d="must be";const s=c.indexOf(".")!==-1?"property":"argument";let i=`The "${c}" ${s} ${d} of type ${m}`;i+=`. Received type ${typeof n}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function T(g,c){if(typeof g!="string")throw new S(c,"string",g)}function E(g){return g===w||g===I}function p(g){return g===w}function b(g){return g>=t&&g<=P||g>=D&&g<=_}function f(g,c,m,n){let d="",s=0,i=-1,r=0,a=0;for(let o=0;o<=g.length;++o){if(o<g.length)a=g.charCodeAt(o);else{if(n(a))break;a=w}if(n(a)){if(!(i===o-1||r===1))if(r===2){if(d.length<2||s!==2||d.charCodeAt(d.length-1)!==k||d.charCodeAt(d.length-2)!==k){if(d.length>2){const u=d.lastIndexOf(m);u===-1?(d="",s=0):(d=d.slice(0,u),s=d.length-1-d.lastIndexOf(m)),i=o,r=0;continue}else if(d.length!==0){d="",s=0,i=o,r=0;continue}}c&&(d+=d.length>0?`${m}..`:"..",s=2)}else d.length>0?d+=`${m}${g.slice(i+1,o)}`:d=g.slice(i+1,o),s=o-i-1;i=o,r=0}else a===k&&r!==-1?++r:r=-1}return d}function v(g,c){if(c===null||typeof c!="object")throw new S("pathObject","Object",c);const m=c.dir||c.root,n=c.base||`${c.name||""}${c.ext||""}`;return m?m===c.root?`${m}${n}`:`${m}${g}${n}`:n}e.win32={resolve(...g){let c="",m="",n=!1;for(let d=g.length-1;d>=-1;d--){let s;if(d>=0){if(s=g[d],T(s,"path"),s.length===0)continue}else c.length===0?s=l.cwd():(s=l.env[`=${c}`]||l.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==c.toLowerCase()&&s.charCodeAt(2)===I)&&(s=`${c}\\`));const i=s.length;let r=0,a="",o=!1;const u=s.charCodeAt(0);if(i===1)E(u)&&(r=1,o=!0);else if(E(u))if(o=!0,E(s.charCodeAt(1))){let h=2,C=h;for(;h<i&&!E(s.charCodeAt(h));)h++;if(h<i&&h!==C){const R=s.slice(C,h);for(C=h;h<i&&E(s.charCodeAt(h));)h++;if(h<i&&h!==C){for(C=h;h<i&&!E(s.charCodeAt(h));)h++;(h===i||h!==C)&&(a=`\\\\${R}\\${s.slice(C,h)}`,r=h)}}}else r=1;else b(u)&&s.charCodeAt(1)===L&&(a=s.slice(0,2),r=2,i>2&&E(s.charCodeAt(2))&&(o=!0,r=3));if(a.length>0)if(c.length>0){if(a.toLowerCase()!==c.toLowerCase())continue}else c=a;if(n){if(c.length>0)break}else if(m=`${s.slice(r)}\\${m}`,n=o,o&&c.length>0)break}return m=f(m,!n,"\\",E),n?`${c}\\${m}`:`${c}${m}`||"."},normalize(g){T(g,"path");const c=g.length;if(c===0)return".";let m=0,n,d=!1;const s=g.charCodeAt(0);if(c===1)return p(s)?"\\":g;if(E(s))if(d=!0,E(g.charCodeAt(1))){let r=2,a=r;for(;r<c&&!E(g.charCodeAt(r));)r++;if(r<c&&r!==a){const o=g.slice(a,r);for(a=r;r<c&&E(g.charCodeAt(r));)r++;if(r<c&&r!==a){for(a=r;r<c&&!E(g.charCodeAt(r));)r++;if(r===c)return`\\\\${o}\\${g.slice(a)}\\`;r!==a&&(n=`\\\\${o}\\${g.slice(a,r)}`,m=r)}}}else m=1;else b(s)&&g.charCodeAt(1)===L&&(n=g.slice(0,2),m=2,c>2&&E(g.charCodeAt(2))&&(d=!0,m=3));let i=m<c?f(g.slice(m),!d,"\\",E):"";return i.length===0&&!d&&(i="."),i.length>0&&E(g.charCodeAt(c-1))&&(i+="\\"),n===void 0?d?`\\${i}`:i:d?`${n}\\${i}`:`${n}${i}`},isAbsolute(g){T(g,"path");const c=g.length;if(c===0)return!1;const m=g.charCodeAt(0);return E(m)||c>2&&b(m)&&g.charCodeAt(1)===L&&E(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let c,m;for(let s=0;s<g.length;++s){const i=g[s];T(i,"path"),i.length>0&&(c===void 0?c=m=i:c+=`\\${i}`)}if(c===void 0)return".";let n=!0,d=0;if(typeof m=="string"&&E(m.charCodeAt(0))){++d;const s=m.length;s>1&&E(m.charCodeAt(1))&&(++d,s>2&&(E(m.charCodeAt(2))?++d:n=!1))}if(n){for(;d<c.length&&E(c.charCodeAt(d));)d++;d>=2&&(c=`\\${c.slice(d)}`)}return e.win32.normalize(c)},relative(g,c){if(T(g,"from"),T(c,"to"),g===c)return"";const m=e.win32.resolve(g),n=e.win32.resolve(c);if(m===n||(g=m.toLowerCase(),c=n.toLowerCase(),g===c))return"";let d=0;for(;d<g.length&&g.charCodeAt(d)===I;)d++;let s=g.length;for(;s-1>d&&g.charCodeAt(s-1)===I;)s--;const i=s-d;let r=0;for(;r<c.length&&c.charCodeAt(r)===I;)r++;let a=c.length;for(;a-1>r&&c.charCodeAt(a-1)===I;)a--;const o=a-r,u=i<o?i:o;let h=-1,C=0;for(;C<u;C++){const N=g.charCodeAt(d+C);if(N!==c.charCodeAt(r+C))break;N===I&&(h=C)}if(C!==u){if(h===-1)return n}else{if(o>u){if(c.charCodeAt(r+C)===I)return n.slice(r+C+1);if(C===2)return n.slice(r+C)}i>u&&(g.charCodeAt(d+C)===I?h=C:C===2&&(h=3)),h===-1&&(h=0)}let R="";for(C=d+h+1;C<=s;++C)(C===s||g.charCodeAt(C)===I)&&(R+=R.length===0?"..":"\\..");return r+=h,R.length>0?`${R}${n.slice(r,a)}`:(n.charCodeAt(r)===I&&++r,n.slice(r,a))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const c=e.win32.resolve(g);if(c.length<=2)return g;if(c.charCodeAt(0)===I){if(c.charCodeAt(1)===I){const m=c.charCodeAt(2);if(m!==y&&m!==k)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(b(c.charCodeAt(0))&&c.charCodeAt(1)===L&&c.charCodeAt(2)===I)return`\\\\?\\${c}`;return g},dirname(g){T(g,"path");const c=g.length;if(c===0)return".";let m=-1,n=0;const d=g.charCodeAt(0);if(c===1)return E(d)?g:".";if(E(d)){if(m=n=1,E(g.charCodeAt(1))){let r=2,a=r;for(;r<c&&!E(g.charCodeAt(r));)r++;if(r<c&&r!==a){for(a=r;r<c&&E(g.charCodeAt(r));)r++;if(r<c&&r!==a){for(a=r;r<c&&!E(g.charCodeAt(r));)r++;if(r===c)return g;r!==a&&(m=n=r+1)}}}}else b(d)&&g.charCodeAt(1)===L&&(m=c>2&&E(g.charCodeAt(2))?3:2,n=m);let s=-1,i=!0;for(let r=c-1;r>=n;--r)if(E(g.charCodeAt(r))){if(!i){s=r;break}}else i=!1;if(s===-1){if(m===-1)return".";s=m}return g.slice(0,s)},basename(g,c){c!==void 0&&T(c,"ext"),T(g,"path");let m=0,n=-1,d=!0,s;if(g.length>=2&&b(g.charCodeAt(0))&&g.charCodeAt(1)===L&&(m=2),c!==void 0&&c.length>0&&c.length<=g.length){if(c===g)return"";let i=c.length-1,r=-1;for(s=g.length-1;s>=m;--s){const a=g.charCodeAt(s);if(E(a)){if(!d){m=s+1;break}}else r===-1&&(d=!1,r=s+1),i>=0&&(a===c.charCodeAt(i)?--i===-1&&(n=s):(i=-1,n=r))}return m===n?n=r:n===-1&&(n=g.length),g.slice(m,n)}for(s=g.length-1;s>=m;--s)if(E(g.charCodeAt(s))){if(!d){m=s+1;break}}else n===-1&&(d=!1,n=s+1);return n===-1?"":g.slice(m,n)},extname(g){T(g,"path");let c=0,m=-1,n=0,d=-1,s=!0,i=0;g.length>=2&&g.charCodeAt(1)===L&&b(g.charCodeAt(0))&&(c=n=2);for(let r=g.length-1;r>=c;--r){const a=g.charCodeAt(r);if(E(a)){if(!s){n=r+1;break}continue}d===-1&&(s=!1,d=r+1),a===k?m===-1?m=r:i!==1&&(i=1):m!==-1&&(i=-1)}return m===-1||d===-1||i===0||i===1&&m===d-1&&m===n+1?"":g.slice(m,d)},format:v.bind(null,"\\"),parse(g){T(g,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return c;const m=g.length;let n=0,d=g.charCodeAt(0);if(m===1)return E(d)?(c.root=c.dir=g,c):(c.base=c.name=g,c);if(E(d)){if(n=1,E(g.charCodeAt(1))){let h=2,C=h;for(;h<m&&!E(g.charCodeAt(h));)h++;if(h<m&&h!==C){for(C=h;h<m&&E(g.charCodeAt(h));)h++;if(h<m&&h!==C){for(C=h;h<m&&!E(g.charCodeAt(h));)h++;h===m?n=h:h!==C&&(n=h+1)}}}}else if(b(d)&&g.charCodeAt(1)===L){if(m<=2)return c.root=c.dir=g,c;if(n=2,E(g.charCodeAt(2))){if(m===3)return c.root=c.dir=g,c;n=3}}n>0&&(c.root=g.slice(0,n));let s=-1,i=n,r=-1,a=!0,o=g.length-1,u=0;for(;o>=n;--o){if(d=g.charCodeAt(o),E(d)){if(!a){i=o+1;break}continue}r===-1&&(a=!1,r=o+1),d===k?s===-1?s=o:u!==1&&(u=1):s!==-1&&(u=-1)}return r!==-1&&(s===-1||u===0||u===1&&s===r-1&&s===i+1?c.base=c.name=g.slice(i,r):(c.name=g.slice(i,s),c.base=g.slice(i,r),c.ext=g.slice(s,r))),i>0&&i!==n?c.dir=g.slice(0,i-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let c="",m=!1;for(let n=g.length-1;n>=-1&&!m;n--){const d=n>=0?g[n]:l.cwd();T(d,"path"),d.length!==0&&(c=`${d}/${c}`,m=d.charCodeAt(0)===w)}return c=f(c,!m,"/",p),m?`/${c}`:c.length>0?c:"."},normalize(g){if(T(g,"path"),g.length===0)return".";const c=g.charCodeAt(0)===w,m=g.charCodeAt(g.length-1)===w;return g=f(g,!c,"/",p),g.length===0?c?"/":m?"./":".":(m&&(g+="/"),c?`/${g}`:g)},isAbsolute(g){return T(g,"path"),g.length>0&&g.charCodeAt(0)===w},join(...g){if(g.length===0)return".";let c;for(let m=0;m<g.length;++m){const n=g[m];T(n,"path"),n.length>0&&(c===void 0?c=n:c+=`/${n}`)}return c===void 0?".":e.posix.normalize(c)},relative(g,c){if(T(g,"from"),T(c,"to"),g===c||(g=e.posix.resolve(g),c=e.posix.resolve(c),g===c))return"";const m=1,n=g.length,d=n-m,s=1,i=c.length-s,r=d<i?d:i;let a=-1,o=0;for(;o<r;o++){const h=g.charCodeAt(m+o);if(h!==c.charCodeAt(s+o))break;h===w&&(a=o)}if(o===r)if(i>r){if(c.charCodeAt(s+o)===w)return c.slice(s+o+1);if(o===0)return c.slice(s+o)}else d>r&&(g.charCodeAt(m+o)===w?a=o:o===0&&(a=0));let u="";for(o=m+a+1;o<=n;++o)(o===n||g.charCodeAt(o)===w)&&(u+=u.length===0?"..":"/..");return`${u}${c.slice(s+a)}`},toNamespacedPath(g){return g},dirname(g){if(T(g,"path"),g.length===0)return".";const c=g.charCodeAt(0)===w;let m=-1,n=!0;for(let d=g.length-1;d>=1;--d)if(g.charCodeAt(d)===w){if(!n){m=d;break}}else n=!1;return m===-1?c?"/":".":c&&m===1?"//":g.slice(0,m)},basename(g,c){c!==void 0&&T(c,"ext"),T(g,"path");let m=0,n=-1,d=!0,s;if(c!==void 0&&c.length>0&&c.length<=g.length){if(c===g)return"";let i=c.length-1,r=-1;for(s=g.length-1;s>=0;--s){const a=g.charCodeAt(s);if(a===w){if(!d){m=s+1;break}}else r===-1&&(d=!1,r=s+1),i>=0&&(a===c.charCodeAt(i)?--i===-1&&(n=s):(i=-1,n=r))}return m===n?n=r:n===-1&&(n=g.length),g.slice(m,n)}for(s=g.length-1;s>=0;--s)if(g.charCodeAt(s)===w){if(!d){m=s+1;break}}else n===-1&&(d=!1,n=s+1);return n===-1?"":g.slice(m,n)},extname(g){T(g,"path");let c=-1,m=0,n=-1,d=!0,s=0;for(let i=g.length-1;i>=0;--i){const r=g.charCodeAt(i);if(r===w){if(!d){m=i+1;break}continue}n===-1&&(d=!1,n=i+1),r===k?c===-1?c=i:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||n===-1||s===0||s===1&&c===n-1&&c===m+1?"":g.slice(c,n)},format:v.bind(null,"/"),parse(g){T(g,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return c;const m=g.charCodeAt(0)===w;let n;m?(c.root="/",n=1):n=0;let d=-1,s=0,i=-1,r=!0,a=g.length-1,o=0;for(;a>=n;--a){const u=g.charCodeAt(a);if(u===w){if(!r){s=a+1;break}continue}i===-1&&(r=!1,i=a+1),u===k?d===-1?d=a:o!==1&&(o=1):d!==-1&&(o=-1)}if(i!==-1){const u=s===0&&m?1:s;d===-1||o===0||o===1&&d===i-1&&d===s+1?c.base=c.name=g.slice(u,i):(c.name=g.slice(u,d),c.base=g.slice(u,i),c.ext=g.slice(d,i))}return s>0?c.dir=g.slice(0,s-1):m&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=l.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=l.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=l.platform==="win32"?e.win32.join:e.posix.join,e.resolve=l.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=l.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=l.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=l.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=l.platform==="win32"?e.win32.extname:e.posix.extname,e.format=l.platform==="win32"?e.win32.format:e.posix.format,e.parse=l.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=l.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=l.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=l.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(De[102],Ie([1,0,9]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(L){const y=(0,l.extname)(L),S=t[y.toLowerCase()];return S!==void 0?S:_(L)}e.getMediaOrTextMime=P;function _(L){const y=(0,l.extname)(L);return D[y.toLowerCase()]}e.getMediaMime=_;function k(L){for(const y in D)if(D[y]===L)return y}e.getExtensionForMimeType=k;const w=/^(.+)\/(.+?)(;.+)?$/;function I(L,y){const S=w.exec(L);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:y?void 0:L}e.normalizeMimeType=I}),define(De[103],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var D;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(k,...w){const I=w.reduce((S,T)=>(S[T]=!0,S),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(S=>!I[S]).forEach(S=>{for(let T=0;T<L.length;T++)if(S.search(L[T])!==-1){delete k[S];break}})}e.sanitizeProcessEnvironment=P;function _(k){!k||(delete k.DEBUG,l.isMacintosh&&delete k.DYLD_LIBRARY_PATH,l.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=_}),define(De[51],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=l.globals.performance&&typeof l.globals.performance.now=="function";class D{constructor(_){this._highResolution=t&&_,this._startTime=this._now(),this._stopTime=-1}static create(_=!0){return new D(_)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?l.globals.performance.now():Date.now()}}e.StopWatch=D}),define(De[4],Ie([1,0,10,59,6,77,51]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,w=!1;var I;(function(a){a.None=()=>D.Disposable.None;function o(ve){if(w){const{onListenerDidAdd:be}=ve,ke=E.create();let Re=0;ve.onListenerDidAdd=()=>{++Re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ke.print()),be?.()}}}function u(ve){return(be,ke=null,Re)=>{let We=!1,oe;return oe=ve(le=>{if(!We)return oe?oe.dispose():We=!0,be.call(ke,le)},null,Re),We&&oe.dispose(),oe}}a.once=u;function h(ve,be,ke){return z((Re,We=null,oe)=>ve(le=>Re.call(We,be(le)),null,oe),ke)}a.map=h;function C(ve,be,ke){return z((Re,We=null,oe)=>ve(le=>{be(le),Re.call(We,le)},null,oe),ke)}a.forEach=C;function R(ve,be,ke){return z((Re,We=null,oe)=>ve(le=>be(le)&&Re.call(We,le),null,oe),ke)}a.filter=R;function N(ve){return ve}a.signal=N;function M(...ve){return(be,ke=null,Re)=>(0,D.combinedDisposable)(...ve.map(We=>We(oe=>be.call(ke,oe),null,Re)))}a.any=M;function A(ve,be,ke,Re){let We=ke;return h(ve,oe=>(We=be(We,oe),We),Re)}a.reduce=A;function z(ve,be){let ke;const Re={onFirstListenerAdd(){ke=ve(We.fire,We)},onLastListenerRemove(){ke?.dispose()}};be||o(Re);const We=new b(Re);return be?.add(We),We.event}function H(ve,be,ke=100,Re=!1,We,oe){let le,fe,Z,ae=0;const ne={leakWarningThreshold:We,onFirstListenerAdd(){le=ve(O=>{ae++,fe=be(fe,O),Re&&!Z&&(ie.fire(fe),fe=void 0),clearTimeout(Z),Z=setTimeout(()=>{const V=fe;fe=void 0,Z=void 0,(!Re||ae>1)&&ie.fire(V),ae=0},ke)})},onLastListenerRemove(){le.dispose()}};oe||o(ne);const ie=new b(ne);return oe?.add(ie),ie.event}a.debounce=H;function F(ve,be=(Re,We)=>Re===We,ke){let Re=!0,We;return R(ve,oe=>{const le=Re||!be(oe,We);return Re=!1,We=oe,le},ke)}a.latch=F;function G(ve,be,ke){return[a.filter(ve,be,ke),a.filter(ve,Re=>!be(Re),ke)]}a.split=G;function B(ve,be=!1,ke=[]){let Re=ke.slice(),We=ve(fe=>{Re?Re.push(fe):le.fire(fe)});const oe=()=>{Re?.forEach(fe=>le.fire(fe)),Re=null},le=new b({onFirstListenerAdd(){We||(We=ve(fe=>le.fire(fe)))},onFirstListenerDidAdd(){Re&&(be?setTimeout(oe):oe())},onLastListenerRemove(){We&&We.dispose(),We=null}});return le.event}a.buffer=B;class U{constructor(be){this.event=be,this.disposables=new D.DisposableStore}map(be){return new U(h(this.event,be,this.disposables))}forEach(be){return new U(C(this.event,be,this.disposables))}filter(be){return new U(R(this.event,be,this.disposables))}reduce(be,ke){return new U(A(this.event,be,ke,this.disposables))}latch(){return new U(F(this.event,void 0,this.disposables))}debounce(be,ke=100,Re=!1,We){return new U(H(this.event,be,ke,Re,We,this.disposables))}on(be,ke,Re){return this.event(be,ke,Re)}once(be,ke,Re){return u(this.event)(be,ke,Re)}dispose(){this.disposables.dispose()}}function X(ve){return new U(ve)}a.chain=X;function $(ve,be,ke=Re=>Re){const Re=(...fe)=>le.fire(ke(...fe)),We=()=>ve.on(be,Re),oe=()=>ve.removeListener(be,Re),le=new b({onFirstListenerAdd:We,onLastListenerRemove:oe});return le.event}a.fromNodeEventEmitter=$;function x(ve,be,ke=Re=>Re){const Re=(...fe)=>le.fire(ke(...fe)),We=()=>ve.addEventListener(be,Re),oe=()=>ve.removeEventListener(be,Re),le=new b({onFirstListenerAdd:We,onLastListenerRemove:oe});return le.event}a.fromDOMEventEmitter=x;function Q(ve){return new Promise(be=>u(ve)(be))}a.toPromise=Q;function de(ve,be){return be(void 0),ve(ke=>be(ke))}a.runAndSubscribe=de;function te(ve,be){let ke=null;function Re(oe){ke?.dispose(),ke=new D.DisposableStore,be(oe,ke)}Re(void 0);const We=ve(oe=>Re(oe));return(0,D.toDisposable)(()=>{We.dispose(),ke?.dispose()})}a.runAndSubscribeWithStore=te;class pe{constructor(be,ke){this.obs=be,this._counter=0,this._hasChanged=!1;const Re={onFirstListenerAdd:()=>{be.addObserver(this)},onLastListenerRemove:()=>{be.removeObserver(this)}};ke||o(Re),this.emitter=new b(Re),ke&&ke.add(this.emitter)}beginUpdate(be){this._counter++}handleChange(be,ke){this._hasChanged=!0}endUpdate(be){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Y(ve,be){return new pe(ve,be).emitter.event}a.fromObservable=Y})(I=e.Event||(e.Event={}));class L{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${L._idPool++}`,L.all.add(this)}start(o){this._stopWatch=new _.StopWatch(!0),this.listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=L,L.all=new Set,L._idPool=0;let y=-1;function S(a){const o=y;return y=a,{dispose(){y=o}}}e.setGlobalLeakWarningThreshold=S;class T{constructor(o,u=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o,u){let h=y;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),h<=0||u<h)return;this._stacks||(this._stacks=new Map);const C=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,C+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let R,N=0;for(const[M,A]of this._stacks)(!R||N<A)&&(R=M,N=A);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${N}):`),console.warn(R)}return()=>{const R=this._stacks.get(o.value)||0;this._stacks.set(o.value,R-1)}}}class E{constructor(o){this.value=o}static create(){return new E(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(o,u,h){this.callback=o,this.callbackThis=u,this.stack=h,this.subscription=new D.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class b{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=y>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new L(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(k){const o=Array.from(this._listeners);queueMicrotask(()=>{for(const u of o)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(o,u,h)=>{this._listeners||(this._listeners=new P.LinkedList);const C=this._listeners.isEmpty();C&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let R,N;this._leakageMon&&this._listeners.size>=30&&(N=E.create(),R=this._leakageMon.check(N,this._listeners.size+1)),k&&(N=N??E.create());const M=new p(o,u,N),A=this._listeners.push(M);C&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,u);const z=M.subscription.set(()=>{R?.(),this._disposed||(A(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof D.DisposableStore?h.add(z):Array.isArray(h)&&h.push(z),z}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const u of this._listeners)this._deliveryQueue.push(this,u,o);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=b;class f{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(o,u,h){this._queue.push(new g(o,u,h))}clear(o){const u=new P.LinkedList;for(const h of this._queue)h.emitter!==o&&u.push(h);this._queue=u}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(u){(0,l.onUnexpectedError)(u)}}}}e.EventDeliveryQueue=f;class v extends f{clear(o){this._queue.clear()}}class g{constructor(o,u,h){this.emitter=o,this.listener=u,this.event=h}}class c extends b{async fireAsync(o,u,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const C of this._listeners)this._asyncDeliveryQueue.push([C,o]);for(;this._asyncDeliveryQueue.size>0&&!u.isCancellationRequested;){const[C,R]=this._asyncDeliveryQueue.shift(),N=[],M={...R,token:u,waitUntil:A=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");h&&(A=h(A,C.callback)),N.push(A)}};try{C.invoke(M)}catch(A){(0,l.onUnexpectedError)(A);continue}Object.freeze(N),await Promise.allSettled(N).then(A=>{for(const z of A)z.status==="rejected"&&(0,l.onUnexpectedError)(z.reason)})}}}}e.AsyncEmitter=c;class m extends b{constructor(o){super(o),this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=m;class n extends m{constructor(o){super(o),this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=n;class d extends b{constructor(o){super(o),this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){!this.hasListeners()||(this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(u=>super.fire(u)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=d;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const u={event:o,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const h=()=>{this.hasListeners&&this.unhook(u);const C=this.events.indexOf(u);this.events.splice(C,1)};return(0,D.toDisposable)((0,t.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(u=>this.emitter.fire(u))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=s;class i{constructor(){this.buffers=[]}wrapEvent(o){return(u,h,C)=>o(R=>{const N=this.buffers[this.buffers.length-1];N?N.push(()=>u.call(h,R)):u.call(h,R)},void 0,C)}bufferEvents(o){const u=[];this.buffers.push(u);const h=o();return this.buffers.pop(),u.forEach(C=>C()),h}}e.EventBufferer=i;class r{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=D.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(De[21],Ie([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(k,w){const I=setTimeout(k.bind(w),0);return{dispose(){clearTimeout(I)}}});var D;(function(k){function w(I){return I===k.None||I===k.Cancelled||I instanceof P?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}k.isCancellationToken=w,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:l.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new l.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=D.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=_}),define(De[156],Ie([1,0,21]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(k){this.task=k,this.result=null}get(){if(this.result)return this.result;const k=new l.CancellationTokenSource,w=this.task(k.token);return this.result={promise:w,dispose:()=>{this.result=null,k.cancel(),k.dispose()}},this.result}}e.Cache=t;class D{constructor(k){this.fn=k,this.lastCache=void 0,this.lastArgKey=void 0}get(k){const w=JSON.stringify(k);return this.lastArgKey!==w&&(this.lastArgKey=w,this.lastCache=this.fn(k)),this.lastCache}}e.LRUCachedFunction=D;class P{constructor(k){this.fn=k,this._map=new Map}get cachedValues(){return this._map}get(k){if(this._map.has(k))return this._map.get(k);const w=this.fn(k);return this._map.set(k,w),w}}e.CachedFunction=P}),define(De[8],Ie([1,0,156,76]),function(J,e,l,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=P;const _=/{(\d+)}/g;function k(ue,...Te){return Te.length===0?ue:ue.replace(_,function(Me,Be){const ze=parseInt(Be,10);return isNaN(ze)||ze<0||ze>=Te.length?Me:Te[ze]})}e.format=k;const w=/{([^}]+)}/g;function I(ue,Te){return ue.replace(w,(Me,Be)=>Te[Be]??Me)}e.format2=I;function L(ue){return ue.replace(/[<>&]/g,function(Te){switch(Te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Te}})}e.escape=L;function y(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function S(ue,Te){let Me=0;const Be=Te.charCodeAt(0);for(let ze=ue.length-1;ze>=0;ze--)ue.charCodeAt(ze)===Be&&Me++;return Me}e.count=S;function T(ue,Te,Me="\u2026"){return ue.length<=Te?ue:`${ue.substr(0,Te)}${Me}`}e.truncate=T;function E(ue,Te=" "){const Me=p(ue,Te);return b(Me,Te)}e.trim=E;function p(ue,Te){if(!ue||!Te)return ue;const Me=Te.length;if(Me===0||ue.length===0)return ue;let Be=0;for(;ue.indexOf(Te,Be)===Be;)Be=Be+Me;return ue.substring(Be)}e.ltrim=p;function b(ue,Te){if(!ue||!Te)return ue;const Me=Te.length,Be=ue.length;if(Me===0||Be===0)return ue;let ze=Be,Ye=-1;for(;Ye=ue.lastIndexOf(Te,ze-1),!(Ye===-1||Ye+Me!==ze);){if(Ye===0)return"";ze=Ye}return ue.substring(0,ze)}e.rtrim=b;function f(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function v(ue){return ue.replace(/\*/g,"")}e.stripWildcards=v;function g(ue,Te,Me={}){if(!ue)throw new Error("Cannot create regex from empty string");Te||(ue=y(ue)),Me.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Be="";return Me.global&&(Be+="g"),Me.matchCase||(Be+="i"),Me.multiline&&(Be+="m"),Me.unicode&&(Be+="u"),new RegExp(ue,Be)}e.createRegExp=g;function c(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function m(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function n(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=n;function d(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=d;function s(ue){for(let Te=0,Me=ue.length;Te<Me;Te++){const Be=ue.charCodeAt(Te);if(Be!==32&&Be!==9)return Te}return-1}e.firstNonWhitespaceIndex=s;function i(ue,Te=0,Me=ue.length){for(let Be=Te;Be<Me;Be++){const ze=ue.charCodeAt(Be);if(ze!==32&&ze!==9)return ue.substring(Te,Be)}return ue.substring(Te,Me)}e.getLeadingWhitespace=i;function r(ue,Te=ue.length-1){for(let Me=Te;Me>=0;Me--){const Be=ue.charCodeAt(Me);if(Be!==32&&Be!==9)return Me}return-1}e.lastNonWhitespaceIndex=r;function a(ue,Te,Me){const Be=[];let ze=0;for(const Ye of ue.matchAll(Te)){if(Be.push(ue.slice(ze,Ye.index)),Ye.index===void 0)throw new Error("match.index should be defined");ze=Ye.index+Ye[0].length,Be.push(Me(Ye[0],...Ye.slice(1),Ye.index,ue,Ye.groups))}return Be.push(ue.slice(ze)),Promise.all(Be).then(Ye=>Ye.join(""))}e.replaceAsync=a;function o(ue,Te){return ue<Te?-1:ue>Te?1:0}e.compare=o;function u(ue,Te,Me=0,Be=ue.length,ze=0,Ye=Te.length){for(;Me<Be&&ze<Ye;Me++,ze++){const pt=ue.charCodeAt(Me),Je=Te.charCodeAt(ze);if(pt<Je)return-1;if(pt>Je)return 1}const nt=Be-Me,ct=Ye-ze;return nt<ct?-1:nt>ct?1:0}e.compareSubstring=u;function h(ue,Te){return C(ue,Te,0,ue.length,0,Te.length)}e.compareIgnoreCase=h;function C(ue,Te,Me=0,Be=ue.length,ze=0,Ye=Te.length){for(;Me<Be&&ze<Ye;Me++,ze++){let pt=ue.charCodeAt(Me),Je=Te.charCodeAt(ze);if(pt===Je)continue;if(pt>=128||Je>=128)return u(ue.toLowerCase(),Te.toLowerCase(),Me,Be,ze,Ye);N(pt)&&(pt-=32),N(Je)&&(Je-=32);const st=pt-Je;if(st!==0)return st}const nt=Be-Me,ct=Ye-ze;return nt<ct?-1:nt>ct?1:0}e.compareSubstringIgnoreCase=C;function R(ue){return ue>=48&&ue<=57}e.isAsciiDigit=R;function N(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=N;function M(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=M;function A(ue,Te){return ue.length===Te.length&&C(ue,Te)===0}e.equalsIgnoreCase=A;function z(ue,Te){const Me=Te.length;return Te.length>ue.length?!1:C(ue,Te,0,Me)===0}e.startsWithIgnoreCase=z;function H(ue,Te){const Me=Math.min(ue.length,Te.length);let Be;for(Be=0;Be<Me;Be++)if(ue.charCodeAt(Be)!==Te.charCodeAt(Be))return Be;return Me}e.commonPrefixLength=H;function F(ue,Te){const Me=Math.min(ue.length,Te.length);let Be;const ze=ue.length-1,Ye=Te.length-1;for(Be=0;Be<Me;Be++)if(ue.charCodeAt(ze-Be)!==Te.charCodeAt(Ye-Be))return Be;return Me}e.commonSuffixLength=F;function G(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=G;function B(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=B;function U(ue,Te){return(ue-55296<<10)+(Te-56320)+65536}e.computeCodePoint=U;function X(ue,Te,Me){const Be=ue.charCodeAt(Me);if(G(Be)&&Me+1<Te){const ze=ue.charCodeAt(Me+1);if(B(ze))return U(Be,ze)}return Be}e.getNextCodePoint=X;function $(ue,Te){const Me=ue.charCodeAt(Te-1);if(B(Me)&&Te>1){const Be=ue.charCodeAt(Te-2);if(G(Be))return U(Be,Me)}return Me}class x{constructor(Te,Me=0){this._str=Te,this._len=Te.length,this._offset=Me}get offset(){return this._offset}setOffset(Te){this._offset=Te}prevCodePoint(){const Te=$(this._str,this._offset);return this._offset-=Te>=65536?2:1,Te}nextCodePoint(){const Te=X(this._str,this._len,this._offset);return this._offset+=Te>=65536?2:1,Te}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class Q{constructor(Te,Me=0){this._iterator=new x(Te,Me)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Te=je.getInstance(),Me=this._iterator,Be=Me.offset;let ze=Te.getGraphemeBreakType(Me.nextCodePoint());for(;!Me.eol();){const Ye=Me.offset,nt=Te.getGraphemeBreakType(Me.nextCodePoint());if(ye(ze,nt)){Me.setOffset(Ye);break}ze=nt}return Me.offset-Be}prevGraphemeLength(){const Te=je.getInstance(),Me=this._iterator,Be=Me.offset;let ze=Te.getGraphemeBreakType(Me.prevCodePoint());for(;Me.offset>0;){const Ye=Me.offset,nt=Te.getGraphemeBreakType(Me.prevCodePoint());if(ye(nt,ze)){Me.setOffset(Ye);break}ze=nt}return Be-Me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Q;function de(ue,Te){return new Q(ue,Te).nextGraphemeLength()}e.nextCharLength=de;function te(ue,Te){return new Q(ue,Te).prevGraphemeLength()}e.prevCharLength=te;function pe(ue,Te){Te>0&&B(ue.charCodeAt(Te))&&Te--;const Me=Te+de(ue,Te);return[Me-te(ue,Me),Me]}e.getCharContainingOffset=pe;let Y;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function be(ue){return Y||(Y=ve()),Y.test(ue)}e.containsRTL=be;const ke=/^[\t\n\r\x20-\x7E]*$/;function Re(ue){return ke.test(ue)}e.isBasicASCII=Re,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function We(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=We;function oe(ue){return ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=oe;function le(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129008||ue>=129280&&ue<=129535||ue>=129648&&ue<=129782}e.isEmojiImprecise=le;function fe(ue,Te){if(ue.length<Te)return ue;const Me=/\b/g;let Be=0;for(;Me.test(ue)&&!(ue.length-Me.lastIndex<Te);)Be=Me.lastIndex,Me.lastIndex+=1;return ue.substring(Be).replace(/^\s/,"")}e.lcut=fe;const Z=/\x1B\x5B[12]?K/g,ae=/\x1b\[\d+m/g,ne=/\x1b\[0?m/g;function ie(ue){return ue&&(ue=ue.replace(Z,""),ue=ue.replace(ae,""),ue=ue.replace(ne,"")),ue}e.removeAnsiEscapeCodes=ie,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function O(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=O;function V(ue){return O(ue)?ue.substr(1):ue}e.stripUTF8BOM=V;function q(ue,Te){if(!ue||!Te||ue.length<Te.length)return!1;const Me=Te.length,Be=ue.toLowerCase();let ze=0,Ye=-1;for(;ze<Me;){const nt=Be.indexOf(Te[ze],Ye+1);if(nt<0)return!1;Ye=nt,ze++}return!0}e.fuzzyContains=q;function K(ue,Te=!1){return ue?(Te&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=K;function me(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=me;function we(ue,Te=1){if(Te===0)return"";let Me=-1;do Me=ue.indexOf(`
`,Me+1),Te--;while(Te>0&&Me>=0);return Me===-1?ue:(ue[Me-1]==="\r"&&Me--,ue.substr(0,Me))}e.getNLines=we;function ce(ue){return ue=ue%(2*26),ue<26?String.fromCharCode(97+ue):String.fromCharCode(65+ue-26)}e.singleLetterHash=ce;function Ce(ue){return je.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=Ce;function ye(ue,Te){return ue===0?Te!==5&&Te!==7:ue===2&&Te===3?!1:ue===4||ue===2||ue===3||Te===4||Te===2||Te===3?!0:!(ue===8&&(Te===8||Te===9||Te===11||Te===12)||(ue===11||ue===9)&&(Te===9||Te===10)||(ue===12||ue===10)&&Te===10||Te===5||Te===13||Te===7||ue===1||ue===13&&Te===14||ue===6&&Te===6)}var He;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class je{constructor(){this._data=Ze()}static getInstance(){return je._INSTANCE||(je._INSTANCE=new je),je._INSTANCE}getGraphemeBreakType(Te){if(Te<32)return Te===10?3:Te===13?2:4;if(Te<127)return 0;const Me=this._data,Be=Me.length/3;let ze=1;for(;ze<=Be;)if(Te<Me[3*ze])ze=2*ze;else if(Te>Me[3*ze+1])ze=2*ze+1;else return Me[3*ze+2];return 0}}je._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Qe(ue,Te){if(ue===0)return 0;const Me=Le(ue,Te);if(Me!==void 0)return Me;const Be=new x(Te,ue);return Be.prevCodePoint(),Be.offset}e.getLeftDeleteOffset=Qe;function Le(ue,Te){const Me=new x(Te,ue);let Be=Me.prevCodePoint();for(;rt(Be)||Be===65039||Be===8419;){if(Me.offset===0)return;Be=Me.prevCodePoint()}if(!le(Be))return;let ze=Me.offset;return ze>0&&Me.prevCodePoint()===8205&&(ze=Me.offset),ze}function rt(ue){return 127995<=ue&&ue<=127999}var re;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(re||(re={})),e.noBreakWhitespace="\xA0";class se{constructor(Te){this.confusableDictionary=Te}static getInstance(Te){return se.cache.get(Array.from(Te))}static getLocales(){return se._locales.getValue()}isAmbiguous(Te){return this.confusableDictionary.has(Te)}getPrimaryConfusable(Te){return this.confusableDictionary.get(Te)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=se,D=se,se.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),se.cache=new l.LRUCachedFunction(ue=>{function Te(Je){const st=new Map;for(let Et=0;Et<Je.length;Et+=2)st.set(Je[Et],Je[Et+1]);return st}function Me(Je,st){const Et=new Map(Je);for(const[Lt,Dt]of st)Et.set(Lt,Dt);return Et}function Be(Je,st){if(!Je)return st;const Et=new Map;for(const[Lt,Dt]of Je)st.has(Lt)&&Et.set(Lt,Dt);return Et}const ze=D.ambiguousCharacterData.getValue();let Ye=ue.filter(Je=>!Je.startsWith("_")&&Je in ze);Ye.length===0&&(Ye=["_default"]);let nt;for(const Je of Ye){const st=Te(ze[Je]);nt=Be(nt,st)}const ct=Te(ze._common),pt=Me(ct,nt);return new se(pt)}),se._locales=new t.Lazy(()=>Object.keys(se.ambiguousCharacterData.getValue()).filter(ue=>!ue.startsWith("_")));class Se{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Se.getRawData())),this._data}static isInvisibleCharacter(Te){return Se.getData().has(Te)}static get codePoints(){return Se.getData()}}e.InvisibleCharacters=Se,Se._data=void 0}),define(De[31],Ie([1,0,9,11,8,16]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(r){return r===47||r===92}e.isPathSeparator=_;function k(r){return r.replace(/[\\/]/g,l.posix.sep)}e.toSlashes=k;function w(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=w;function I(r,a=l.posix.sep){if(!r)return"";const o=r.length,u=r.charCodeAt(0);if(_(u)){if(_(r.charCodeAt(1))&&!_(r.charCodeAt(2))){let C=3;const R=C;for(;C<o&&!_(r.charCodeAt(C));C++);if(R!==C&&!_(r.charCodeAt(C+1))){for(C+=1;C<o;C++)if(_(r.charCodeAt(C)))return r.slice(0,C+1).replace(/[\\/]/g,a)}}return a}else if(f(u)&&r.charCodeAt(1)===58)return _(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let h=r.indexOf("://");if(h!==-1){for(h+=3;h<o;h++)if(_(r.charCodeAt(h)))return r.slice(0,h+1)}return""}e.getRoot=I;function L(r){if(!t.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let o=2;const u=o;for(;o<r.length&&(a=r.charCodeAt(o),a!==92);o++);return!(u===o||(a=r.charCodeAt(o+1),isNaN(a)||a===92))}e.isUNC=L;const y=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(r,a=t.isWindows){const o=a?y:S;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||a&&T.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=E;function p(r,a,o){const u=r===a;return!o||u?u:!r||!a?!1:(0,D.equalsIgnoreCase)(r,a)}e.isEqual=p;function b(r,a,o,u=l.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(o){if(!(0,D.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let C=a.length;return a.charAt(a.length-1)===u&&C--,r.charAt(C)===u}return a.charAt(a.length-1)!==u&&(a+=u),r.indexOf(a)===0}e.isEqualOrParent=b;function f(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=f;function v(r,a){return t.isWindows&&r.endsWith(":")&&(r+=l.sep),(0,l.isAbsolute)(r)||(r=(0,l.join)(a,r)),r=(0,l.normalize)(r),t.isWindows?(r=(0,D.rtrim)(r,l.sep),r.endsWith(":")&&(r+=l.sep)):(r=(0,D.rtrim)(r,l.sep),r||(r=l.sep)),r}e.sanitizeFilePath=v;function g(r){const a=(0,l.normalize)(r);return t.isWindows?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===l.posix.sep}e.isRootOrDriveLetter=g;function c(r,a=t.isWindows){return a?f(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function m(r){return c(r)?r[0]:void 0}e.getDriveLetter=m;function n(r,a,o){return a.length>r.length?-1:r===a?0:(o&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=n;function d(r){const a=r.split(":");let o,u,h;for(const C of a){const R=Number(C);(0,P.isNumber)(R)?u===void 0?u=R:h===void 0&&(h=R):o=o?[o,C].join(":"):C}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:u!==void 0?u:void 0,column:h!==void 0?h:u!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,a,o=8){let u="";for(let C=0;C<o;C++)u+=s.charAt(Math.floor(Math.random()*s.length));let h;return a?h=`${a}-${u}`:h=u,r?(0,l.join)(r,h):h}e.randomPath=i}),define(De[78],Ie([1,0,8]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(f){return D(f,0)}e.hash=t;function D(f,v){switch(typeof f){case"object":return f===null?P(349,v):Array.isArray(f)?w(f,v):I(f,v);case"string":return k(f,v);case"boolean":return _(f,v);case"number":return P(f,v);case"undefined":return P(937,v);default:return P(617,v)}}e.doHash=D;function P(f,v){return(v<<5)-v+f|0}e.numberHash=P;function _(f,v){return P(f?433:863,v)}function k(f,v){v=P(149417,v);for(let g=0,c=f.length;g<c;g++)v=P(f.charCodeAt(g),v);return v}e.stringHash=k;function w(f,v){return v=P(104579,v),f.reduce((g,c)=>D(c,g),v)}function I(f,v){return v=P(181387,v),Object.keys(f).sort().reduce((g,c)=>(g=k(c,g),D(f[c],g)),v)}class L{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=D(v,this._value),this._value}}e.Hasher=L;var y;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function S(f,v,g=32){const c=g-v,m=~((1<<c)-1);return(f<<v|(m&f)>>>c)>>>0}function T(f,v=0,g=f.byteLength,c=0){for(let m=0;m<g;m++)f[v+m]=c}function E(f,v,g="0"){for(;f.length<v;)f=g+f;return f}function p(f,v=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(g=>g.toString(16).padStart(2,"0")).join(""):E((f>>>0).toString(16),v/4)}e.toHexString=p;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const g=v.length;if(g===0)return;const c=this._buff;let m=this._buffLen,n=this._leftoverHighSurrogate,d,s;for(n!==0?(d=n,s=-1,n=0):(d=v.charCodeAt(0),s=0);;){let i=d;if(l.isHighSurrogate(d))if(s+1<g){const r=v.charCodeAt(s+1);l.isLowSurrogate(r)?(s++,i=l.computeCodePoint(d,r)):i=65533}else{n=d;break}else l.isLowSurrogate(d)&&(i=65533);if(m=this._push(c,m,i),s++,s<g)d=v.charCodeAt(s);else break}this._buffLen=m,this._leftoverHighSurrogate=n}_push(v,g,c){return c<128?v[g++]=c:c<2048?(v[g++]=192|(c&1984)>>>6,v[g++]=128|(c&63)>>>0):c<65536?(v[g++]=224|(c&61440)>>>12,v[g++]=128|(c&4032)>>>6,v[g++]=128|(c&63)>>>0):(v[g++]=240|(c&1835008)>>>18,v[g++]=128|(c&258048)>>>12,v[g++]=128|(c&4032)>>>6,v[g++]=128|(c&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=b._bigBlock32,g=this._buffDV;for(let o=0;o<64;o+=4)v.setUint32(o,g.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)v.setUint32(o,S(v.getUint32(o-12,!1)^v.getUint32(o-32,!1)^v.getUint32(o-56,!1)^v.getUint32(o-64,!1),1),!1);let c=this._h0,m=this._h1,n=this._h2,d=this._h3,s=this._h4,i,r,a;for(let o=0;o<80;o++)o<20?(i=m&n|~m&d,r=1518500249):o<40?(i=m^n^d,r=1859775393):o<60?(i=m&n|m&d|n&d,r=2400959708):(i=m^n^d,r=3395469782),a=S(c,5)+i+s+r+v.getUint32(o*4,!1)&4294967295,s=d,d=n,n=S(m,30),m=c,c=a;this._h0=this._h0+c&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+d&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(De[25],Ie([1,0,17,8]),function(J,e,l,t){"use strict";var D,P,_;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(s,i,r){let a=s.get(i);return a===void 0&&(a=r,s.set(i,a)),a}e.getOrSet=k;function w(s){const i=[];return s.forEach((r,a)=>{i.push(`${a} => ${r}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=w;function I(s){const i=[];return s.forEach(r=>{i.push(r)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=I;class L{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return r-a}value(){return this._value[this._pos]}}e.StringIterator=L;class y{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class S{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const a=this._value.charCodeAt(r);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var T;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(T||(T={}));class E{constructor(i,r){this._ignorePathCasing=i,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=E;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(b||(b={}));class f{constructor(i){this._iter=i}static forUris(i=()=>!1,r=()=>!1){return new f(new E(i,r))}static forPaths(i=!1){return new f(new S(void 0,!i))}static forStrings(){return new f(new L)}static forConfigKeys(){return new f(new y)}clear(){this._root=void 0}fill(i,r){if(r){const a=r.slice(0);(0,l.shuffle)(a);for(const o of a)this.set(o,i)}else{const a=i.slice(0);(0,l.shuffle)(a);for(const o of a)this.set(o[0],o[1])}}set(i,r){const a=this._iter.reset(i);let o;this._root||(this._root=new p,this._root.segment=a.value());const u=[];for(o=this._root;;){const C=a.cmp(o.segment);if(C>0)o.left||(o.left=new p,o.left.segment=a.value()),u.push([-1,o]),o=o.left;else if(C<0)o.right||(o.right=new p,o.right.segment=a.value()),u.push([1,o]),o=o.right;else if(a.hasNext())a.next(),o.mid||(o.mid=new p,o.mid.segment=a.value()),u.push([0,o]),o=o.mid;else break}const h=o.value;o.value=r,o.key=i;for(let C=u.length-1;C>=0;C--){const R=u[C][1];R.updateHeight();const N=R.balanceFactor();if(N<-1||N>1){const M=u[C][0],A=u[C+1][0];if(M===1&&A===1)u[C][1]=R.rotateLeft();else if(M===-1&&A===-1)u[C][1]=R.rotateRight();else if(M===1&&A===-1)R.right=u[C+1][1]=u[C+1][1].rotateRight(),u[C][1]=R.rotateLeft();else if(M===-1&&A===1)R.left=u[C+1][1]=u[C+1][1].rotateLeft(),u[C][1]=R.rotateRight();else throw new Error;if(C>0)switch(u[C-1][0]){case-1:u[C-1][1].left=u[C][1];break;case 1:u[C-1][1].right=u[C][1];break;case 0:u[C-1][1].mid=u[C][1];break}else this._root=u[0][1]}}return h}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let a=this._root;for(;a;){const o=r.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const a=this._iter.reset(i),o=[];let u=this._root;for(;u;){const h=a.cmp(u.segment);if(h>0)o.push([-1,u]),u=u.left;else if(h<0)o.push([1,u]),u=u.right;else if(a.hasNext())a.next(),o.push([0,u]),u=u.mid;else break}if(!!u){if(r?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const h=this._min(u.right),{key:C,value:R,segment:N}=h;this._delete(h.key,!1),u.key=C,u.value=R,u.segment=N}else{const h=u.left??u.right;if(o.length>0){const[C,R]=o[o.length-1];switch(C){case-1:R.left=h;break;case 0:R.mid=h;break;case 1:R.right=h;break}}else this._root=h}for(let h=o.length-1;h>=0;h--){const C=o[h][1];C.updateHeight();const R=C.balanceFactor();if(R>1?(C.right.balanceFactor()>=0||(C.right=C.right.rotateRight()),o[h][1]=C.rotateLeft()):R<-1&&(C.left.balanceFactor()<=0||(C.left=C.left.rotateLeft()),o[h][1]=C.rotateRight()),h>0)switch(o[h-1][0]){case-1:o[h-1][1].left=o[h][1];break;case 1:o[h-1][1].right=o[h][1];break;case 0:o[h-1][1].mid=o[h][1];break}else this._root=o[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let a=this._root,o;for(;a;){const u=r.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(r.hasNext())r.next(),o=a.value||o,a=a.mid;else break}return a&&a.value||o}findSuperstr(i){const r=this._iter.reset(i);let a=this._root;for(;a;){const o=r.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[r,a]of this)i(a,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const r=[];return this._dfsEntries(i,r),r[Symbol.iterator]()}_dfsEntries(i,r){!i||(i.left&&this._dfsEntries(i.left,r),i.value&&r.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,r),i.right&&this._dfsEntries(i.right,r))}_isBalanced(){const i=r=>{if(!r)return!0;const a=r.balanceFactor();return a<-1||a>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=f;class v{constructor(i,r){this.uri=i,this.value=r}}class g{constructor(i,r){this[D]="ResourceMap",i instanceof g?(this.map=new Map(i.map),this.toKey=r??g.defaultToKey):(this.map=new Map,this.toKey=i??g.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new v(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r<"u"&&(i=i.bind(r));for(const[a,o]of this.map)i(o.value,o.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=g,g.defaultToKey=s=>s.toString();class c{constructor(i,r){this[P]="ResourceSet",!i||typeof i=="function"?this._map=new g(i):(this._map=new g(r),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,r){this._map.forEach((a,o)=>i.call(r,o,o,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=c;var m;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(m=e.Touch||(e.Touch={}));class n{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const a=this._map.get(i);if(!!a)return r!==0&&this.touch(a,r),a.value}set(i,r,a=0){let o=this._map.get(i);if(o)o.value=r,a!==0&&this.touch(o,a);else{switch(o={key:i,value:r,next:void 0,previous:void 0},a){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const a=this._state;let o=this._head;for(;o;){if(r?i.bind(r)(o.value,o.key,this):i(o.value,o.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,r=this._state;let a=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const u={value:a.key,done:!1};return a=a.next,u}else return{value:void 0,done:!0}}};return o}values(){const i=this,r=this._state;let a=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const u={value:a.value,done:!1};return a=a.next,u}else return{value:void 0,done:!0}}};return o}entries(){const i=this,r=this._state;let a=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const u={value:[a.key,a.value],done:!1};return a=a.next,u}else return{value:void 0,done:!0}}};return o}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,a=this.size;for(;r&&a>i;)this._map.delete(r.key),r=r.next,a--;this._head=r,this._size=a,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,a=i.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const a=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(a.previous=o,o.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const a=i.next,o=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=o,o.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,a)=>{i.push([a,r])}),i}fromJSON(i){this.clear();for(const[r,a]of i)this.set(r,a)}}e.LinkedMap=n;class d extends n{constructor(i,r=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d}),define(De[104],Ie([1,0,25,8]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...ne){return function(ie,O){for(let V=0,q=ne.length;V<q;V++){const K=ne[V](ie,O);if(K)return K}return null}}e.or=D,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(ne,ie,O){if(!O||O.length<ie.length)return null;let V;return ne?V=t.startsWithIgnoreCase(O,ie):V=O.indexOf(ie)===0,V?ie.length>0?[{start:0,end:ie.length}]:[]:null}function _(ne,ie){const O=ie.toLowerCase().indexOf(ne.toLowerCase());return O===-1?null:[{start:O,end:O+ne.length}]}e.matchesContiguousSubString=_;function k(ne,ie){return w(ne.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=k;function w(ne,ie,O,V){if(O===ne.length)return[];if(V===ie.length)return null;if(ne[O]===ie[V]){let q=null;return(q=w(ne,ie,O+1,V+1))?f({start:V,end:V+1},q):null}return w(ne,ie,O,V+1)}function I(ne){return 97<=ne&&ne<=122}function L(ne){return 65<=ne&&ne<=90}e.isUpper=L;function y(ne){return 48<=ne&&ne<=57}function S(ne){return ne===32||ne===9||ne===10||ne===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>T.add(ne.charCodeAt(0)));function E(ne){return S(ne)||T.has(ne)}function p(ne,ie){return ne===ie||E(ne)&&E(ie)}function b(ne){return I(ne)||L(ne)||y(ne)}function f(ne,ie){return ie.length===0?ie=[ne]:ne.end===ie[0].start?ie[0].start=ne.start:ie.unshift(ne),ie}function v(ne,ie){for(let O=ie;O<ne.length;O++){const V=ne.charCodeAt(O);if(L(V)||y(V)||O>0&&!b(ne.charCodeAt(O-1)))return O}return ne.length}function g(ne,ie,O,V){if(O===ne.length)return[];if(V===ie.length)return null;if(ne[O]!==ie[V].toLowerCase())return null;{let q=null,K=V+1;for(q=g(ne,ie,O+1,V+1);!q&&(K=v(ie,K))<ie.length;)q=g(ne,ie,O+1,K),K++;return q===null?null:f({start:V,end:V+1},q)}}function c(ne){let ie=0,O=0,V=0,q=0,K=0;for(let ye=0;ye<ne.length;ye++)K=ne.charCodeAt(ye),L(K)&&ie++,I(K)&&O++,b(K)&&V++,y(K)&&q++;const me=ie/ne.length,we=O/ne.length,ce=V/ne.length,Ce=q/ne.length;return{upperPercent:me,lowerPercent:we,alphaPercent:ce,numericPercent:Ce}}function m(ne){const{upperPercent:ie,lowerPercent:O}=ne;return O===0&&ie>.6}function n(ne){const{upperPercent:ie,lowerPercent:O,alphaPercent:V,numericPercent:q}=ne;return O>.2&&ie<.8&&V>.6&&q<.2}function d(ne){let ie=0,O=0,V=0,q=0;for(let K=0;K<ne.length;K++)V=ne.charCodeAt(K),L(V)&&ie++,I(V)&&O++,S(V)&&q++;return(ie===0||O===0)&&q===0?ne.length<=30:ie<=5}function s(ne,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!d(ne)||ie.length>60)return null;const O=c(ie);if(!n(O)){if(!m(O))return null;ie=ie.toLowerCase()}let V=null,q=0;for(ne=ne.toLowerCase();q<ie.length&&(V=g(ne,ie,0,q))===null;)q=v(ie,q+1);return V}e.matchesCamelCase=s;function i(ne,ie,O=!1){if(!ie||ie.length===0)return null;let V=null,q=0;for(ne=ne.toLowerCase(),ie=ie.toLowerCase();q<ie.length&&(V=r(ne,ie,0,q,O))===null;)q=a(ie,q+1);return V}e.matchesWords=i;function r(ne,ie,O,V,q){if(O===ne.length)return[];if(V===ie.length)return null;if(p(ne.charCodeAt(O),ie.charCodeAt(V))){let K=null,me=V+1;if(K=r(ne,ie,O+1,V+1,q),!q)for(;!K&&(me=a(ie,me))<ie.length;)K=r(ne,ie,O+1,me,q),me++;return K?ne.charCodeAt(O)!==ie.charCodeAt(V)?K:f({start:V,end:V+1},K):null}else return null}function a(ne,ie){for(let O=ie;O<ne.length;O++)if(E(ne.charCodeAt(O))||O>0&&E(ne.charCodeAt(O-1)))return O;return ne.length}const o=D(e.matchesPrefix,s,_),u=D(e.matchesPrefix,s,k),h=new l.LRUCache(1e4);function C(ne,ie,O=!1){if(typeof ne!="string"||typeof ie!="string")return null;let V=h.get(ne);V||(V=new RegExp(t.convertSimple2RegExpPattern(ne),"i"),h.set(ne,V));const q=V.exec(ie);return q?[{start:q.index,end:q.index+q[0].length}]:O?u(ne,ie):o(ne,ie)}e.matchesFuzzy=C;function R(ne,ie){const O=Re(ne,ne.toLowerCase(),0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return O?M(O):null}e.matchesFuzzy2=R;function N(ne,ie,O,V,q,K){const me=Math.min(13,ne.length);for(;O<me;O++){const we=Re(ne,ie,O,V,q,K,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(we)return we}return[0,K]}e.anyScore=N;function M(ne){if(typeof ne>"u")return[];const ie=[],O=ne[1];for(let V=ne.length-1;V>1;V--){const q=ne[V]+O,K=ie[ie.length-1];K&&K.end===q?K.end=q+1:ie.push({start:q,end:q+1})}return ie}e.createMatches=M;const A=128;function z(){const ne=[],ie=[];for(let O=0;O<=A;O++)ie[O]=0;for(let O=0;O<=A;O++)ne.push(ie.slice(0));return ne}function H(ne){const ie=[];for(let O=0;O<=ne;O++)ie[O]=0;return ie}const F=H(2*A),G=H(2*A),B=z(),U=z(),X=z(),$=!1;function x(ne,ie,O,V,q){function K(we,ce,Ce=" "){for(;we.length<ce;)we=Ce+we;return we}let me=` |   |${V.split("").map(we=>K(we,3)).join("|")}
`;for(let we=0;we<=O;we++)we===0?me+=" |":me+=`${ie[we-1]}|`,me+=ne[we].slice(0,q+1).map(ce=>K(ce.toString(),3)).join("|")+`
`;return me}function Q(ne,ie,O,V){ne=ne.substr(ie),O=O.substr(V),console.log(x(U,ne,ne.length,O,O.length)),console.log(x(X,ne,ne.length,O,O.length)),console.log(x(B,ne,ne.length,O,O.length))}function de(ne,ie){if(ie<0||ie>=ne.length)return!1;const O=ne.codePointAt(ie);switch(O){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(O)}}function te(ne,ie){if(ie<0||ie>=ne.length)return!1;switch(ne.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function pe(ne,ie,O){return ie[ne]!==O[ne]}function Y(ne,ie,O,V,q,K,me=!1){for(;ie<O&&q<K;)ne[ie]===V[q]&&(me&&(F[ie]=q),ie+=1),q+=1;return ie===O}e.isPatternInWord=Y;var ve;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var be;(function(ne){ne.Default=[-100,0];function ie(O){return!O||O.length===2&&O[0]===-100&&O[1]===0}ne.isDefault=ie})(be=e.FuzzyScore||(e.FuzzyScore={}));class ke{constructor(ie,O){this.firstMatchCanBeWeak=ie,this.boostFullMatch=O}}e.FuzzyScoreOptions=ke,ke.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Re(ne,ie,O,V,q,K,me=ke.default){const we=ne.length>A?A:ne.length,ce=V.length>A?A:V.length;if(O>=we||K>=ce||we-O>ce-K||!Y(ie,O,we,q,K,ce,!0))return;We(we,ce,O,K,ie,q);let Ce=1,ye=1,He=O,je=K;const Ze=[!1];for(Ce=1,He=O;He<we;Ce++,He++){const se=F[He],Se=G[He],ue=He+1<we?G[He+1]:ce;for(ye=se-K+1,je=se;je<ue;ye++,je++){let Te=Number.MIN_SAFE_INTEGER,Me=!1;je<=Se&&(Te=oe(ne,ie,He,O,V,q,je,ce,K,B[Ce-1][ye-1]===0,Ze));let Be=0;Te!==Number.MAX_SAFE_INTEGER&&(Me=!0,Be=Te+U[Ce-1][ye-1]);const ze=je>se,Ye=ze?U[Ce][ye-1]+(B[Ce][ye-1]>0?-5:0):0,nt=je>se+1&&B[Ce][ye-1]>0,ct=nt?U[Ce][ye-2]+(B[Ce][ye-2]>0?-5:0):0;if(nt&&(!ze||ct>=Ye)&&(!Me||ct>=Be))U[Ce][ye]=ct,X[Ce][ye]=3,B[Ce][ye]=0;else if(ze&&(!Me||Ye>=Be))U[Ce][ye]=Ye,X[Ce][ye]=2,B[Ce][ye]=0;else if(Me)U[Ce][ye]=Be,X[Ce][ye]=1,B[Ce][ye]=B[Ce-1][ye-1]+1;else throw new Error("not possible")}}if($&&Q(ne,O,V,K),!Ze[0]&&!me.firstMatchCanBeWeak)return;Ce--,ye--;const Qe=[U[Ce][ye],K];let Le=0,rt=0;for(;Ce>=1;){let se=ye;do{const Se=X[Ce][se];if(Se===3)se=se-2;else if(Se===2)se=se-1;else break}while(se>=1);Le>1&&ie[O+Ce-1]===q[K+ye-1]&&!pe(se+K-1,V,q)&&Le+1>B[Ce][se]&&(se=ye),se===ye?Le++:Le=1,rt||(rt=se),Ce--,ye=se-1,Qe.push(ye)}ce===we&&me.boostFullMatch&&(Qe[0]+=2);const re=rt-we;return Qe[0]-=re,Qe}e.fuzzyScore=Re;function We(ne,ie,O,V,q,K){let me=ne-1,we=ie-1;for(;me>=O&&we>=V;)q[me]===K[we]&&(G[me]=we,me--),we--}function oe(ne,ie,O,V,q,K,me,we,ce,Ce,ye){if(ie[O]!==K[me])return Number.MIN_SAFE_INTEGER;let He=1,je=!1;return me===O-V?He=ne[O]===q[me]?7:5:pe(me,q,K)&&(me===0||!pe(me-1,q,K))?(He=ne[O]===q[me]?7:5,je=!0):de(K,me)&&(me===0||!de(K,me-1))?He=5:(de(K,me-1)||te(K,me-1))&&(He=5,je=!0),He>1&&O===V&&(ye[0]=!0),je||(je=pe(me,q,K)||de(K,me-1)||te(K,me-1)),O===V?me>ce&&(He-=je?3:5):Ce?He+=je?2:0:He+=je?0:1,me+1===we&&(He-=je?3:5),He}function le(ne,ie,O,V,q,K,me){return Z(ne,ie,O,V,q,K,!0,me)}e.fuzzyScoreGracefulAggressive=le;function fe(ne,ie,O,V,q,K,me){return Z(ne,ie,O,V,q,K,!1,me)}e.fuzzyScoreGraceful=fe;function Z(ne,ie,O,V,q,K,me,we){let ce=Re(ne,ie,O,V,q,K,we);if(ce&&!me)return ce;if(ne.length>=3){const Ce=Math.min(7,ne.length-1);for(let ye=O+1;ye<Ce;ye++){const He=ae(ne,ye);if(He){const je=Re(He,He.toLowerCase(),O,V,q,K,we);je&&(je[0]-=3,(!ce||je[0]>ce[0])&&(ce=je))}}}return ce}function ae(ne,ie){if(ie+1>=ne.length)return;const O=ne[ie],V=ne[ie+1];if(O!==V)return ne.slice(0,ie)+V+O+ne.slice(ie+2)}}),define(De[157],Ie([1,0,74,104,8]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(l.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${P.source}`,"g");function w(b){return b.replace(k,(f,v)=>v?f:`\\${f}`)}e.escapeIcons=w;const I=new RegExp(`\\\\${P.source}`,"g");function L(b){return b.replace(I,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=L;const y=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function S(b){return b.indexOf(e.iconStartMarker)===-1?b:b.replace(y,(f,v,g,c)=>g?f:v||c||"")}e.stripIcons=S;function T(b){const f=b.indexOf(e.iconStartMarker);return f===-1?{text:b}:E(b,f)}e.parseLabelWithIcons=T;function E(b,f){const v=[];let g="";function c(o){if(o){g+=o;for(const u of o)v.push(d)}}let m=-1,n="",d=0,s,i,r=f;const a=b.length;for(c(b.substr(0,f));r<a;)s=b[r],i=b[r+1],s===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(m=r,c(n),n=e.iconStartMarker,r++):s===")"&&m!==-1?(d+=r-m+1,m=-1,n=""):m!==-1?_.test(s)?n+=s:(c(n),m=-1,n=""):c(s),r++;return c(n),{text:g,iconOffsets:v}}function p(b,f,v=!1){const{text:g,iconOffsets:c}=f;if(!c||c.length===0)return(0,t.matchesFuzzy)(b,g,v);const m=(0,D.ltrim)(g," "),n=g.length-m.length,d=(0,t.matchesFuzzy)(b,m,v);if(d)for(const s of d){const i=c[s.start+n]+n;s.start+=i,s.end+=i}return d}e.matchesFuzzyIconAware=p}),define(De[79],Ie([1,0,25]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new l.LRUCache(1e4);function D(I){return w(I,"NFC",t)}e.normalizeNFC=D;const P=new l.LRUCache(1e4);function _(I){return w(I,"NFD",P)}e.normalizeNFD=_;const k=/[^\u0000-\u0080]/;function w(I,L,y){if(!I)return I;const S=y.get(I);if(S)return S;let T;return k.test(I)?T=I.normalize(L):T=I,y.set(I,T),T}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(L){return _(L).replace(I,"")}}()}),define(De[41],Ie([1,0,8]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(t||(t={})),function(D){const P="error",_="warning",k="warn",w="info",I="ignore";function L(S){return S?l.equalsIgnoreCase(P,S)?D.Error:l.equalsIgnoreCase(_,S)||l.equalsIgnoreCase(k,S)?D.Warning:l.equalsIgnoreCase(w,S)?D.Info:D.Ignore:D.Ignore}D.fromValue=L;function y(S){switch(S){case D.Error:return P;case D.Warning:return _;case D.Info:return w;default:return I}}D.toString=y}(t||(t={})),e.default=t}),define(De[2],Ie([1,0,9,11]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,P=/^\//,_=/^\/\//;function k(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!P.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(s,i){return!s&&!i?"file":s}function I(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==y&&(i=y+i):i=y;break}return i}const L="",y="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{constructor(i,r,a,o,u,h=!1){typeof i=="object"?(this.scheme=i.scheme||L,this.authority=i.authority||L,this.path=i.path||L,this.query=i.query||L,this.fragment=i.fragment||L):(this.scheme=w(i,h),this.authority=r||L,this.path=I(this.scheme,a||L),this.query=o||L,this.fragment=u||L,k(this,h))}static isUri(i){return i instanceof T?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return g(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:a,path:o,query:u,fragment:h}=i;return r===void 0?r=this.scheme:r===null&&(r=L),a===void 0?a=this.authority:a===null&&(a=L),o===void 0?o=this.path:o===null&&(o=L),u===void 0?u=this.query:u===null&&(u=L),h===void 0?h=this.fragment:h===null&&(h=L),r===this.scheme&&a===this.authority&&o===this.path&&u===this.query&&h===this.fragment?this:new p(r,a,o,u,h)}static parse(i,r=!1){const a=S.exec(i);return a?new p(a[2]||L,d(a[4]||L),d(a[5]||L),d(a[7]||L),d(a[9]||L),r):new p(L,L,L,L,L)}static file(i){let r=L;if(t.isWindows&&(i=i.replace(/\\/g,y)),i[0]===y&&i[1]===y){const a=i.indexOf(y,2);a===-1?(r=i.substring(2),i=y):(r=i.substring(2,a),i=i.substring(a)||y)}return new p("file",r,i,L,L)}static from(i){const r=new p(i.scheme,i.authority,i.path,i.query,i.fragment);return k(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&i.scheme==="file"?a=T.file(l.win32.join(g(i,!0),...r)).path:a=l.posix.join(i.path,...r),i.with({path:a})}toString(i=!1){return c(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof T)return i;{const r=new p(i);return r._formatted=i.external,r._fsPath=i._sep===E?i.fsPath:null,r}}else return i}}e.URI=T;const E=t.isWindows?1:void 0;class p extends T{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(i=!1){return i?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=E),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(s,i){let r,a=-1;for(let o=0;o<s.length;o++){const u=s.charCodeAt(o);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||i&&u===47)a!==-1&&(r+=encodeURIComponent(s.substring(a,o)),a=-1),r!==void 0&&(r+=s.charAt(o));else{r===void 0&&(r=s.substr(0,o));const h=b[u];h!==void 0?(a!==-1&&(r+=encodeURIComponent(s.substring(a,o)),a=-1),r+=h):a===-1&&(a=o)}}return a!==-1&&(r+=encodeURIComponent(s.substring(a))),r!==void 0?r:s}function v(s){let i;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(i===void 0&&(i=s.substr(0,r)),i+=b[a]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function g(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=g;function c(s,i){const r=i?v:f;let a="",{scheme:o,authority:u,path:h,query:C,fragment:R}=s;if(o&&(a+=o,a+=":"),(u||o==="file")&&(a+=y,a+=y),u){let N=u.indexOf("@");if(N!==-1){const M=u.substr(0,N);u=u.substr(N+1),N=M.indexOf(":"),N===-1?a+=r(M,!1):(a+=r(M.substr(0,N),!1),a+=":",a+=r(M.substr(N+1),!1)),a+="@"}u=u.toLowerCase(),N=u.indexOf(":"),N===-1?a+=r(u,!1):(a+=r(u.substr(0,N),!1),a+=u.substr(N))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const N=h.charCodeAt(1);N>=65&&N<=90&&(h=`/${String.fromCharCode(N+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const N=h.charCodeAt(0);N>=65&&N<=90&&(h=`${String.fromCharCode(N+32)}:${h.substr(2)}`)}a+=r(h,!0)}return C&&(a+="?",a+=r(C,!1)),R&&(a+="#",a+=i?R:f(R,!1)),a}function m(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+m(s.substr(3)):s}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(s){return s.match(n)?s.replace(n,i=>m(i)):s}}),define(De[80],Ie([1,0,23,8,2]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(I){return JSON.stringify(I,k)}e.stringify=P;function _(I){let L=JSON.parse(I);return L=w(L),L}e.parse=_;function k(I,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,t.regExpFlags)(L)}:L}function w(I,L=0){if(!I||L>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return D.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof l.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let y=0;y<I.length;++y)I[y]=w(I[y],L+1);else for(const y in I)Object.hasOwnProperty.call(I,y)&&(I[y]=w(I[y],L+1))}return I}e.revive=w}),define(De[12],Ie([1,0,11,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(I){this._preferredWebSchema=I}setDelegate(I){this._delegate=I}setServerRootPath(I){this._remoteResourcesPath=`${I}/${D.vscodeRemoteResource}`}set(I,L,y){this._hosts[I]=L,this._ports[I]=y}setConnectionToken(I,L){this._connectionTokens[I]=L}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(I){if(this._delegate)return this._delegate(I);const L=I.authority;let y=this._hosts[L];y&&y.indexOf(":")!==-1&&(y=`[${y}]`);const S=this._ports[L],T=this._connectionTokens[L];let E=`path=${encodeURIComponent(I.path)}`;return typeof T=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(T)}`),t.URI.from({scheme:l.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${y}:${S}`,path:this._remoteResourcesPath,query:E})}}e.RemoteAuthorities=new P;class _{asBrowserUri(I,L){const y=this.toUri(I,L);return y.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===D.file&&(l.isNative||l.isWebWorker&&l.globals.origin===`${D.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?y.with({scheme:D.vscodeFileResource,authority:y.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(I,L){const y=this.toUri(I,L);return y.scheme===D.vscodeFileResource?y.with({scheme:D.file,authority:y.authority!==_.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(I,L){return t.URI.isUri(I)?I:t.URI.parse(L.toUrl(I))}}_.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new _;var k;(function(w){const I=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(I.get("3"));const L="vscode-coi";function y(T){let E;typeof T=="string"?E=new URL(T).searchParams:T instanceof URL?E=T.searchParams:t.URI.isUri(T)&&(E=new URL(T.toString(!0)).searchParams);const p=E?.get(L);if(!!p)return I.get(p)}w.getHeadersFromQuery=y;function S(T,E,p){if(!globalThis.crossOriginIsolated)return;const b=E&&p?"3":p?"2":"1";T instanceof URLSearchParams?T.set(L,b):T[L]=b}w.addSearchParam=S})(k=e.COI||(e.COI={}))}),define(De[22],Ie([1,0,31,12,9,11,8,2]),function(J,e,l,t,D,P,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(T){return(0,k.uriToFsPath)(T,!0)}e.originalFSPath=w;class I{constructor(E){this._ignorePathCasing=E}compare(E,p,b=!1){return E===p?0:(0,_.compare)(this.getComparisonKey(E,b),this.getComparisonKey(p,b))}isEqual(E,p,b=!1){return E===p?!0:!E||!p?!1:this.getComparisonKey(E,b)===this.getComparisonKey(p,b)}getComparisonKey(E,p=!1){return E.with({path:this._ignorePathCasing(E)?E.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(E){return this._ignorePathCasing(E)}isEqualOrParent(E,p,b=!1){if(E.scheme===p.scheme){if(E.scheme===t.Schemas.file)return l.isEqualOrParent(w(E),w(p),this._ignorePathCasing(E))&&E.query===p.query&&(b||E.fragment===p.fragment);if((0,e.isEqualAuthority)(E.authority,p.authority))return l.isEqualOrParent(E.path,p.path,this._ignorePathCasing(E),"/")&&E.query===p.query&&(b||E.fragment===p.fragment)}return!1}joinPath(E,...p){return k.URI.joinPath(E,...p)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return D.posix.basename(E.path)}extname(E){return D.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let p;return E.scheme===t.Schemas.file?p=k.URI.file(D.dirname(w(E))).path:(p=D.posix.dirname(E.path),E.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),p="/")),E.with({path:p})}normalizePath(E){if(!E.path.length)return E;let p;return E.scheme===t.Schemas.file?p=k.URI.file(D.normalize(w(E))).path:p=D.posix.normalize(E.path),E.with({path:p})}relativePath(E,p){if(E.scheme!==p.scheme||!(0,e.isEqualAuthority)(E.authority,p.authority))return;if(E.scheme===t.Schemas.file){const v=D.relative(w(E),w(p));return P.isWindows?l.toSlashes(v):v}let b=E.path||"/";const f=p.path||"/";if(this._ignorePathCasing(E)){let v=0;for(const g=Math.min(b.length,f.length);v<g&&!(b.charCodeAt(v)!==f.charCodeAt(v)&&b.charAt(v).toLowerCase()!==f.charAt(v).toLowerCase());v++);b=f.substr(0,v)+b.substr(v)}return D.posix.relative(b,f)}resolvePath(E,p){if(E.scheme===t.Schemas.file){const b=k.URI.file(D.resolve(w(E),p));return E.with({authority:b.authority,path:b.path})}return p=l.toPosixPath(p),E.with({path:D.posix.resolve(E.path,p)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,p){return E===p||E!==void 0&&p!==void 0&&(0,_.equalsIgnoreCase)(E,p)}hasTrailingPathSeparator(E,p=D.sep){if(E.scheme===t.Schemas.file){const b=w(E);return b.length>l.getRoot(b).length&&b[b.length-1]===p}else{const b=E.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,p=D.sep){return(0,e.hasTrailingPathSeparator)(E,p)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,p=D.sep){let b=!1;if(E.scheme===t.Schemas.file){const f=w(E);b=f!==void 0&&f.length===l.getRoot(f).length&&f[f.length-1]===p}else{p="/";const f=E.path;b=f.length===1&&f.charCodeAt(f.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(E,p)?E.with({path:E.path+"/"}):E}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(T=>T.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new I(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(T,E){const p=[];for(let b=0;b<T.length;b++){const f=E(T[b]);T.some((v,g)=>g===b?!1:(0,e.isEqualOrParent)(f,E(v)))||p.push(T[b])}return p}e.distinctParents=L;var y;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function E(p){const b=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(g=>{const[c,m]=g.split(":");c&&m&&b.set(c,m)});const v=p.path.substring(0,p.path.indexOf(";"));return v&&b.set(T.META_DATA_MIME,v),b}T.parseMetaData=E})(y=e.DataUri||(e.DataUri={}));function S(T,E,p){if(E){let b=T.path;return b&&b[0]!==D.posix.sep&&(b=D.posix.sep+b),T.with({scheme:p,authority:E,path:b})}return T.with({scheme:p})}e.toLocalResource=S}),define(De[18],Ie([1,0,21,10,4,6,22,11]),function(J,e,l,t,D,P,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(pe){return!!pe&&typeof pe.then=="function"}e.isThenable=w;function I(pe){const Y=new l.CancellationTokenSource,ve=pe(Y.token),be=new Promise((ke,Re)=>{const We=Y.token.onCancellationRequested(()=>{We.dispose(),Y.dispose(),Re(new t.CancellationError)});Promise.resolve(ve).then(oe=>{We.dispose(),Y.dispose(),ke(oe)},oe=>{We.dispose(),Y.dispose(),Re(oe)})});return new class{cancel(){Y.cancel()}then(ke,Re){return be.then(ke,Re)}catch(ke){return this.then(void 0,ke)}finally(ke){return be.finally(ke)}}}e.createCancelablePromise=I;function L(pe,Y,ve){return new Promise((be,ke)=>{const Re=Y.onCancellationRequested(()=>{Re.dispose(),be(ve)});pe.then(be,ke).finally(()=>Re.dispose())})}e.raceCancellation=L;function y(pe,Y){return new Promise((ve,be)=>{const ke=Y.onCancellationRequested(()=>{ke.dispose(),be(new t.CancellationError)});pe.then(ve,be).finally(()=>ke.dispose())})}e.raceCancellationError=y;async function S(pe){let Y=-1;const ve=pe.map((ke,Re)=>ke.then(We=>(Y=Re,We))),be=await Promise.race(ve);return pe.forEach((ke,Re)=>{Re!==Y&&ke.cancel()}),be}e.raceCancellablePromises=S;function T(pe,Y,ve){let be;const ke=setTimeout(()=>{be?.(void 0),ve?.()},Y);return Promise.race([pe.finally(()=>clearTimeout(ke)),new Promise(Re=>be=Re)])}e.raceTimeout=T;function E(pe){return new Promise((Y,ve)=>{const be=pe();w(be)?be.then(Y,ve):Y(be)})}e.asPromise=E;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const ve=()=>{this.queuedPromise=null;const be=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,be};this.queuedPromise=new Promise(be=>{this.activePromise.then(ve,ve).then(be)})}return new Promise((ve,be)=>{this.queuedPromise.then(ve,be)})}return this.activePromise=Y(),new Promise((ve,be)=>{this.activePromise.then(ke=>{this.activePromise=null,ve(ke)},ke=>{this.activePromise=null,be(ke)})})}}e.Throttler=p;class b{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=b;class f{constructor(){this.promiseMap=new Map}queue(Y,ve){const ke=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(ve).finally(()=>{this.promiseMap.get(Y)===ke&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,ke),ke}}e.SequencerByKey=f;const v=(pe,Y)=>{let ve=!0;const be=setTimeout(()=>{ve=!1,Y()},pe);return{isTriggered:()=>ve,dispose:()=>{clearTimeout(be),ve=!1}}},g=pe=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,pe())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,ve=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ke,Re)=>{this.doResolve=ke,this.doReject=Re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ke=this.task;return this.task=null,ke()}}));const be=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ve===e.MicrotaskDelay?g(be):v(ve,be),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class m{constructor(Y){this.delayer=new c(Y),this.throttler=new p}trigger(Y,ve){return this.delayer.trigger(()=>this.throttler.queue(Y),ve)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class n{constructor(){this._isOpen=!1,this._promise=new Promise((Y,ve)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class d extends n{constructor(Y){super(),this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function s(pe,Y){return Y?new Promise((ve,be)=>{const ke=setTimeout(()=>{Re.dispose(),ve()},pe),Re=Y.onCancellationRequested(()=>{clearTimeout(ke),Re.dispose(),be(new t.CancellationError)})}):I(ve=>s(pe,ve))}e.timeout=s;function i(pe,Y=0){const ve=setTimeout(pe,Y);return(0,P.toDisposable)(()=>clearTimeout(ve))}e.disposableTimeout=i;function r(pe){const Y=[];let ve=0;const be=pe.length;function ke(){return ve<be?pe[ve++]():null}function Re(We){We!=null&&Y.push(We);const oe=ke();return oe?oe.then(Re):Promise.resolve(Y)}return Promise.resolve(null).then(Re)}e.sequence=r;function a(pe,Y=be=>!!be,ve=null){let be=0;const ke=pe.length,Re=()=>{if(be>=ke)return Promise.resolve(ve);const We=pe[be++];return Promise.resolve(We()).then(le=>Y(le)?Promise.resolve(le):Re())};return Re()}e.first=a;function o(pe,Y=be=>!!be,ve=null){if(pe.length===0)return Promise.resolve(ve);let be=pe.length;const ke=()=>{be=-1;for(const Re of pe)Re.cancel?.()};return new Promise((Re,We)=>{for(const oe of pe)oe.then(le=>{--be>=0&&Y(le)?(ke(),Re(le)):be===0&&Re(ve)}).catch(le=>{--be>=0&&(ke(),We(le))})})}e.firstParallel=o;class u{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Y){return this._size++,new Promise((ve,be)=>{this.outstandingPromises.push({factory:Y,c:ve,e:be}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const ve=Y.factory();ve.then(Y.c,Y.e),ve.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=u;class h extends u{constructor(){super(1)}}e.Queue=h;class C{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new X;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,ve=_.extUri){const be=ve.getComparisonKey(Y);let ke=this.queues.get(be);return ke||(ke=new h,D.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.queues.delete(be),this.onDidQueueDrain()}),this.queues.set(be,ke)),ke}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=C;class R{constructor(Y,ve){this._token=-1,typeof Y=="function"&&typeof ve=="number"&&this.setIfNotSet(Y,ve)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,ve){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},ve)}setIfNotSet(Y,ve){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},ve))}}e.TimeoutTimer=R;class N{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,ve){this.cancel(),this._token=setInterval(()=>{Y()},ve)}}e.IntervalTimer=N;class M{constructor(Y,ve){this.timeoutToken=-1,this.runner=Y,this.timeout=ve,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=M;class A{constructor(Y,ve){ve%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ve}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=ve,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=A;class z extends M{constructor(Y,ve){super(Y,ve),this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner?.(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class H extends P.Disposable{constructor(Y,ve){super(),this.options=Y,this.handler=ve,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=pe=>{(0,k.setTimeout0)(()=>{if(Y)return;const ve=Date.now()+15;pe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(pe,Y)=>{const ve=requestIdleCallback(pe,typeof Y=="number"?{timeout:Y}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(ve))}}}}();class F{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(ve){this._error=ve}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function G(pe,Y,ve){let be;for(let ke=0;ke<ve;ke++)try{return await pe()}catch(Re){be=Re,await s(Y)}throw be}e.retry=G;class B{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Y,ve,be){return this._pending={taskId:Y,cancel:()=>be?.(),promise:ve},ve.then(()=>this.donePending(Y),()=>this.donePending(Y)),ve}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let ve,be;const ke=new Promise((Re,We)=>{ve=Re,be=We});this._next={run:Y,promise:ke,promiseResolve:ve,promiseReject:be}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=B;class U{constructor(Y,ve=()=>Date.now()){this.interval=Y,this.nowFn=ve,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=U;class X{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,ve)=>{this.completeCallback=Y,this.errorCallback=ve})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Y){return new Promise(ve=>{this.completeCallback(Y),this.resolved=!0,ve()})}error(Y){return new Promise(ve=>{this.errorCallback(Y),this.rejected=!0,ve()})}cancel(){new Promise(Y=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=X;var $;(function(pe){async function Y(be){let ke;const Re=await Promise.all(be.map(We=>We.then(oe=>oe,oe=>{ke||(ke=oe)})));if(typeof ke<"u")throw ke;return Re}pe.settled=Y;function ve(be){return new Promise(async(ke,Re)=>{try{await be(ke,Re)}catch(We){Re(We)}})}pe.withAsyncBody=ve})($=e.Promises||(e.Promises={}));var x;(function(pe){pe[pe.Initial=0]="Initial",pe[pe.DoneOK=1]="DoneOK",pe[pe.DoneError=2]="DoneError"})(x||(x={}));class Q{constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const ve={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(Y(ve)),this.resolve()}catch(be){this.reject(be)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}static fromArray(Y){return new Q(ve=>{ve.emitMany(Y)})}static fromPromise(Y){return new Q(async ve=>{ve.emitMany(await Y)})}static fromPromises(Y){return new Q(async ve=>{await Promise.all(Y.map(async be=>ve.emitOne(await be)))})}static merge(Y){return new Q(async ve=>{await Promise.all(Y.map(async be=>{for await(const ke of be)ve.emitOne(ke)}))})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,ve){return new Q(async be=>{for await(const ke of Y)be.emitOne(ve(ke))})}map(Y){return Q.map(this,Y)}static filter(Y,ve){return new Q(async be=>{for await(const ke of Y)ve(ke)&&be.emitOne(ke)})}filter(Y){return Q.filter(this,Y)}static coalesce(Y){return Q.filter(Y,ve=>!!ve)}coalesce(){return Q.coalesce(this)}static async toPromise(Y){const ve=[];for await(const be of Y)ve.push(be);return ve}toPromise(){return Q.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=Q,Q.EMPTY=Q.fromArray([]);class de extends Q{constructor(Y,ve){super(ve),this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=de;function te(pe){const Y=new l.CancellationTokenSource,ve=pe(Y.token);return new de(Y,async be=>{const ke=Y.token.onCancellationRequested(()=>{ke.dispose(),Y.dispose(),be.reject(new t.CancellationError)});try{for await(const Re of ve){if(Y.token.isCancellationRequested)return;be.emitOne(Re)}ke.dispose(),Y.dispose()}catch(Re){ke.dispose(),Y.dispose(),be.reject(Re)}})}e.createCancelableAsyncIterable=te}),define(De[105],Ie([1,0,18,9]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new l.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),P=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(h,C,R=!1){const N=h||"",M=C||"",A=D.value.collator.compare(N,M);return D.value.collatorIsNumeric&&A===0&&N!==M?N<M?-1:1:A}e.compareFileNames=k;function w(h,C){const R=P.value.collator;return h=h||"",C=C||"",m(R,h,C)}e.compareFileNamesDefault=w;function I(h,C){const R=P.value.collator;return h=h||"",C=C||"",i(h,C)||m(R,h,C)}e.compareFileNamesUpper=I;function L(h,C){const R=P.value.collator;return h=h||"",C=C||"",s(h,C)||m(R,h,C)}e.compareFileNamesLower=L;function y(h,C){return h=h||"",C=C||"",h===C?0:h<C?-1:1}e.compareFileNamesUnicode=y;function S(h,C,R=!1){R||(h=h&&h.toLowerCase(),C=C&&C.toLowerCase());const[N,M]=g(h),[A,z]=g(C);return N!==A?N<A?-1:1:M===z?0:M<z?-1:1}e.noIntlCompareFileNames=S;function T(h,C){const[R,N]=g(h),[M,A]=g(C);let z=D.value.collator.compare(N,A);if(z===0){if(D.value.collatorIsNumeric&&N!==A)return N<A?-1:1;if(z=D.value.collator.compare(R,M),D.value.collatorIsNumeric&&z===0&&R!==M)return R<M?-1:1}return z}e.compareFileExtensions=T;function E(h,C){h=h||"",C=C||"";const R=c(h),N=c(C),M=P.value.collator,A=_.value.collator;return m(A,R,N)||m(M,h,C)}e.compareFileExtensionsDefault=E;function p(h,C){h=h||"",C=C||"";const R=c(h),N=c(C),M=P.value.collator,A=_.value.collator;return m(A,R,N)||i(h,C)||m(M,h,C)}e.compareFileExtensionsUpper=p;function b(h,C){h=h||"",C=C||"";const R=c(h),N=c(C),M=P.value.collator,A=_.value.collator;return m(A,R,N)||s(h,C)||m(M,h,C)}e.compareFileExtensionsLower=b;function f(h,C){h=h||"",C=C||"";const R=c(h).toLowerCase(),N=c(C).toLowerCase();return R!==N?R<N?-1:1:h!==C?h<C?-1:1:0}e.compareFileExtensionsUnicode=f;const v=/^(.*?)(\.([^.]*))?$/;function g(h,C=!1){const R=h?v.exec(h):[];let N=[R&&R[1]||"",R&&R[3]||""];return C&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function c(h){const C=h?v.exec(h):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function m(h,C,R){const N=h.compare(C,R);return N!==0?N:C.length!==R.length?C.length<R.length?-1:1:0}function n(h){const C=h.charAt(0);return C.toLocaleUpperCase()!==C}function d(h){const C=h.charAt(0);return C.toLocaleLowerCase()!==C}function s(h,C){return n(h)&&d(C)?-1:d(h)&&n(C)?1:0}function i(h,C){return d(h)&&n(C)?-1:n(h)&&d(C)?1:0}function r(h,C,R=!1){return R||(h=h&&h.toLowerCase(),C=C&&C.toLowerCase()),h===C?0:h<C?-1:1}function a(h,C,R=!1){const N=h.split(t.sep),M=C.split(t.sep),A=N.length-1,z=M.length-1;let H,F;for(let G=0;;G++){if(H=A===G,F=z===G,H&&F)return k(N[G],M[G],R);if(H)return-1;if(F)return 1;const B=r(N[G],M[G],R);if(B!==0)return B}}e.comparePaths=a;function o(h,C,R){const N=h.toLowerCase(),M=C.toLowerCase(),A=u(h,C,R);if(A)return A;const z=N.endsWith(R),H=M.endsWith(R);if(z!==H)return z?-1:1;const F=k(N,M);return F!==0?F:N.localeCompare(M)}e.compareAnything=o;function u(h,C,R){const N=h.toLowerCase(),M=C.toLowerCase(),A=N.startsWith(R),z=M.startsWith(R);if(A!==z)return A?-1:1;if(A&&z){if(N.length<M.length)return-1;if(N.length>M.length)return 1}return 0}e.compareByPrefix=u}),define(De[106],Ie([1,0,105,104,78,9,11,8]),function(J,e,l,t,D,P,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const w=0,I=[w,[]];function L(B,U,X,$){if(!B||!U)return I;const x=B.length,Q=U.length;if(x<Q)return I;const de=B.toLowerCase();return y(U,X,Q,B,de,x,$)}e.scoreFuzzy=L;function y(B,U,X,$,x,Q,de){const te=[],pe=[];for(let ke=0;ke<X;ke++){const Re=ke*Q,We=Re-Q,oe=ke>0,le=B[ke],fe=U[ke];for(let Z=0;Z<Q;Z++){const ae=Z>0,ne=Re+Z,ie=ne-1,O=We+Z-1,V=ae?te[ie]:0,q=oe&&ae?te[O]:0,K=oe&&ae?pe[O]:0;let me;!q&&oe?me=0:me=S(le,fe,$,x,Z,K),me&&q+me>=V&&(de||oe||x.startsWith(U,Z))?(pe[ne]=K+1,te[ne]=q+me):(pe[ne]=w,te[ne]=V)}}const Y=[];let ve=X-1,be=Q-1;for(;ve>=0&&be>=0;){const ke=ve*Q+be;pe[ke]===w||(Y.push(be),ve--),be--}return[te[X*Q-1],Y.reverse()]}function S(B,U,X,$,x,Q){let de=0;if(!T(U,$[x]))return de;if(de+=1,Q>0&&(de+=Q*5),B===X[x]&&(de+=1),x===0)de+=8;else{const te=E(X.charCodeAt(x-1));te?de+=te:(0,t.isUpper)(X.charCodeAt(x))&&Q===0&&(de+=2)}return de}function T(B,U){return B===U?!0:B==="/"||B==="\\"?U==="/"||U==="\\":!1}function E(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function b(B,U,X=0,$=0){const x=U;return x.values&&x.values.length>1?f(B,x.values,X,$):v(B,U,X,$)}e.scoreFuzzy2=b;function f(B,U,X,$){let x=0;const Q=[];for(const de of U){const[te,pe]=v(B,de,X,$);if(typeof te!="number")return p;x+=te,Q.push(...pe)}return[x,u(Q)]}function v(B,U,X,$){const x=(0,t.fuzzyScore)(U.original,U.originalLowercase,X,B,B.toLowerCase(),$,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return x?[x[0],(0,t.createMatches)(x)]:p}const g=Object.freeze({score:0}),c=1<<18,m=1<<17,n=1<<16;function d(B,U,X,$){const x=$.values?$.values:[$];return(0,D.hash)({[$.normalized]:{values:x.map(de=>({value:de.normalized,expectContiguousMatch:de.expectContiguousMatch})),label:B,description:U,allowNonContiguousMatches:X}})}function s(B,U,X,$,x){if(!B||!U.normalized)return g;const Q=$.getItemLabel(B);if(!Q)return g;const de=$.getItemDescription(B),te=d(Q,de,X,U),pe=x[te];if(pe)return pe;const Y=i(Q,de,$.getItemPath(B),U,X);return x[te]=Y,Y}e.scoreItemFuzzy=s;function i(B,U,X,$,x){const Q=!X||!$.containsPathSeparator;return X&&(_.isLinux?$.pathNormalized===X:(0,k.equalsIgnoreCase)($.pathNormalized,X))?{score:c,labelMatch:[{start:0,end:B.length}],descriptionMatch:U?[{start:0,end:U.length}]:void 0}:$.values&&$.values.length>1?r(B,U,X,$.values,Q,x):a(B,U,X,$,Q,x)}function r(B,U,X,$,x,Q){let de=0;const te=[],pe=[];for(const Y of $){const{score:ve,labelMatch:be,descriptionMatch:ke}=a(B,U,X,Y,x,Q);if(ve===w)return g;de+=ve,be&&te.push(...be),ke&&pe.push(...ke)}return{score:de,labelMatch:u(te),descriptionMatch:u(pe)}}function a(B,U,X,$,x,Q){if(x||!U){const[de,te]=L(B,$.normalized,$.normalizedLowercase,Q&&!$.expectContiguousMatch);if(de){const pe=(0,t.matchesPrefix)($.normalized,B);let Y;return pe?(Y=m,Y+=Math.round($.normalized.length/B.length*100)):Y=n,{score:Y+de,labelMatch:pe||o(te)}}}if(U){let de=U;X&&(de=`${U}${P.sep}`);const te=de.length,pe=`${de}${B}`,[Y,ve]=L(pe,$.normalized,$.normalizedLowercase,Q&&!$.expectContiguousMatch);if(Y){const be=o(ve),ke=[],Re=[];return be.forEach(We=>{We.start<te&&We.end>te?(ke.push({start:0,end:We.end-te}),Re.push({start:We.start,end:te})):We.start>=te?ke.push({start:We.start-te,end:We.end-te}):Re.push(We)}),{score:Y,labelMatch:ke,descriptionMatch:Re}}}return g}function o(B){const U=[];if(!B)return U;let X;for(const $ of B)X&&X.end===$?X.end+=1:(X={start:$,end:$+1},U.push(X));return U}function u(B){const U=B.sort((x,Q)=>x.start-Q.start),X=[];let $;for(const x of U)!$||!h($,x)?($=x,X.push(x)):($.start=Math.min($.start,x.start),$.end=Math.max($.end,x.end));return X}function h(B,U){return!(B.end<U.start||U.end<B.start)}function C(B,U,X,$,x,Q){const de=s(B,X,$,x,Q),te=s(U,X,$,x,Q),pe=de.score,Y=te.score;if((pe===c||Y===c)&&pe!==Y)return pe===c?-1:1;if(pe>n||Y>n){if(pe!==Y)return pe>Y?-1:1;if(pe<m&&Y<m){const le=N(de.labelMatch,te.labelMatch);if(le!==0)return le}const We=x.getItemLabel(B)||"",oe=x.getItemLabel(U)||"";if(We.length!==oe.length)return We.length-oe.length}if(pe!==Y)return pe>Y?-1:1;const ve=Array.isArray(de.labelMatch)&&de.labelMatch.length>0,be=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(ve&&!be)return-1;if(be&&!ve)return 1;const ke=R(B,de,x),Re=R(U,te,x);return ke&&Re&&ke!==Re?Re>ke?-1:1:M(B,U,X,x)}e.compareItemsByFuzzyScore=C;function R(B,U,X){let $=-1,x=-1;if(U.descriptionMatch&&U.descriptionMatch.length?$=U.descriptionMatch[0].start:U.labelMatch&&U.labelMatch.length&&($=U.labelMatch[0].start),U.labelMatch&&U.labelMatch.length){if(x=U.labelMatch[U.labelMatch.length-1].end,U.descriptionMatch&&U.descriptionMatch.length){const Q=X.getItemDescription(B);Q&&(x+=Q.length)}}else U.descriptionMatch&&U.descriptionMatch.length&&(x=U.descriptionMatch[U.descriptionMatch.length-1].end);return x-$}function N(B,U){if(!B&&!U||(!B||!B.length)&&(!U||!U.length))return 0;if(!U||!U.length)return-1;if(!B||!B.length)return 1;const X=B[0].start,x=B[B.length-1].end-X,Q=U[0].start,te=U[U.length-1].end-Q;return x===te?0:te<x?1:-1}function M(B,U,X,$){const x=$.getItemLabel(B)||"",Q=$.getItemLabel(U)||"",de=$.getItemDescription(B),te=$.getItemDescription(U),pe=x.length+(de?de.length:0),Y=Q.length+(te?te.length:0);if(pe!==Y)return pe-Y;const ve=$.getItemPath(B),be=$.getItemPath(U);return ve&&be&&ve.length!==be.length?ve.length-be.length:x!==Q?(0,l.compareAnything)(x,Q,X.normalized):de&&te&&de!==te?(0,l.compareAnything)(de,te,X.normalized):ve&&be&&ve!==be?(0,l.compareAnything)(ve,be,X.normalized):0}function A(B){return B.startsWith('"')&&B.endsWith('"')}const z=" ";function H(B){typeof B!="string"&&(B="");const U=B.toLowerCase(),{pathNormalized:X,normalized:$,normalizedLowercase:x}=F(B),Q=X.indexOf(P.sep)>=0,de=A(B);let te;const pe=B.split(z);if(pe.length>1)for(const Y of pe){const ve=A(Y),{pathNormalized:be,normalized:ke,normalizedLowercase:Re}=F(Y);ke&&(te||(te=[]),te.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:be,normalized:ke,normalizedLowercase:Re,expectContiguousMatch:ve}))}return{original:B,originalLowercase:U,pathNormalized:X,normalized:$,normalizedLowercase:x,values:te,containsPathSeparator:Q,expectContiguousMatch:de}}e.prepareQuery=H;function F(B){let U;_.isWindows?U=B.replace(/\//g,P.sep):U=B.replace(/\\/g,P.sep);const X=(0,k.stripWildcards)(U).replace(/\s|"/g,"");return{pathNormalized:U,normalized:X,normalizedLowercase:X.toLowerCase()}}function G(B){return Array.isArray(B)?H(B.map(U=>U.original).join(z)):H(B.original)}e.pieceToQuery=G}),define(De[36],Ie([1,0,17,18,31,25,9,11,8]),function(J,e,l,t,D,P,_,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",y="[^/\\\\]",S=/\//g;function T(X,$){switch(X){case 0:return"";case 1:return`${y}*?`;default:return`(?:${L}|${y}+${L}${$?`|${L}${y}+`:""})*?`}}function E(X,$){if(!X)return[];const x=[];let Q=!1,de=!1,te="";for(const pe of X){switch(pe){case $:if(!Q&&!de){x.push(te),te="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":de=!0;break;case"]":de=!1;break}te+=pe}return te&&x.push(te),x}e.splitGlobAware=E;function p(X){if(!X)return"";let $="";const x=E(X,e.GLOB_SPLIT);if(x.every(Q=>Q===e.GLOBSTAR))$=".*";else{let Q=!1;x.forEach((de,te)=>{if(de===e.GLOBSTAR){if(Q)return;$+=T(2,te===x.length-1)}else{let pe=!1,Y="",ve=!1,be="";for(const ke of de){if(ke!=="}"&&pe){Y+=ke;continue}if(ve&&(ke!=="]"||!be)){let Re;ke==="-"?Re=ke:(ke==="^"||ke==="!")&&!be?Re="^":ke===e.GLOB_SPLIT?Re="":Re=(0,w.escapeRegExpCharacters)(ke),be+=Re;continue}switch(ke){case"{":pe=!0;continue;case"[":ve=!0;continue;case"}":{$+=`(?:${E(Y,",").map(oe=>p(oe)).join("|")})`,pe=!1,Y="";break}case"]":{$+="["+be+"]",ve=!1,be="";break}case"?":$+=y;continue;case"*":$+=T(1);continue;default:$+=(0,w.escapeRegExpCharacters)(ke)}}te<x.length-1&&(x[te+1]!==e.GLOBSTAR||te+2<x.length)&&($+=L)}Q=de===e.GLOBSTAR})}return $}const b=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new P.LRUCache(1e4),d=function(){return!1},s=function(){return null};function i(X,$){if(!X)return s;let x;typeof X!="string"?x=X.pattern:x=X,x=x.trim();const Q=`${x}_${!!$.trimForExclusions}`;let de=n.get(Q);if(de)return r(de,X);let te;return b.test(x)?de=o(x.substr(4),x):(te=f.exec(a(x,$)))?de=u(te[1],x):($.trimForExclusions?g:v).test(x)?de=h(x,$):(te=c.exec(a(x,$)))?de=C(te[1].substr(1),x,!0):(te=m.exec(a(x,$)))?de=C(te[1],x,!1):de=R(x),n.set(Q,de),r(de,X)}function r(X,$){if(typeof $=="string")return X;const x=function(Q,de){return(0,D.isEqualOrParent)(Q,$.base,!k.isLinux)?X(Q.substr($.base.length+1),de):null};return x.allBasenames=X.allBasenames,x.allPaths=X.allPaths,x.basenames=X.basenames,x.patterns=X.patterns,x}function a(X,$){return $.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function o(X,$){return function(x,Q){return typeof x=="string"&&x.endsWith(X)?$:null}}function u(X,$){const x=`/${X}`,Q=`\\${X}`,de=function(pe,Y){return typeof pe!="string"?null:Y?Y===X?$:null:pe===X||pe.endsWith(x)||pe.endsWith(Q)?$:null},te=[X];return de.basenames=te,de.patterns=[$],de.allBasenames=te,de}function h(X,$){const x=B(X.slice(1,-1).split(",").map(Y=>i(Y,$)).filter(Y=>Y!==s),X),Q=x.length;if(!Q)return s;if(Q===1)return x[0];const de=function(Y,ve){for(let be=0,ke=x.length;be<ke;be++)if(x[be](Y,ve))return X;return null},te=x.find(Y=>!!Y.allBasenames);te&&(de.allBasenames=te.allBasenames);const pe=x.reduce((Y,ve)=>ve.allPaths?Y.concat(ve.allPaths):Y,[]);return pe.length&&(de.allPaths=pe),de}function C(X,$,x){const Q=_.sep===_.posix.sep,de=Q?X:X.replace(S,_.sep),te=_.sep+de,pe=_.posix.sep+X;let Y;return x?Y=function(ve,be){return typeof ve=="string"&&(ve===de||ve.endsWith(te)||!Q&&(ve===X||ve.endsWith(pe)))?$:null}:Y=function(ve,be){return typeof ve=="string"&&(ve===de||!Q&&ve===X)?$:null},Y.allPaths=[(x?"*/":"./")+X],Y}function R(X){try{const $=new RegExp(`^${p(X)}$`);return function(x){return $.lastIndex=0,typeof x=="string"&&$.test(x)?X:null}}catch{return s}}function N(X,$,x){return!X||typeof $!="string"?!1:M(X)($,void 0,x)}e.match=N;function M(X,$={}){if(!X)return d;if(typeof X=="string"||A(X)){const x=i(X,$);if(x===s)return d;const Q=function(de,te){return!!x(de,te)};return x.allBasenames&&(Q.allBasenames=x.allBasenames),x.allPaths&&(Q.allPaths=x.allPaths),Q}return F(X,$)}e.parse=M;function A(X){const $=X;return $?typeof $.base=="string"&&typeof $.pattern=="string":!1}e.isRelativePattern=A;function z(X){return X.allBasenames||[]}e.getBasenameTerms=z;function H(X){return X.allPaths||[]}e.getPathTerms=H;function F(X,$){const x=B(Object.getOwnPropertyNames(X).map(Y=>G(Y,X[Y],$)).filter(Y=>Y!==s)),Q=x.length;if(!Q)return s;if(!x.some(Y=>!!Y.requiresSiblings)){if(Q===1)return x[0];const Y=function(ke,Re){let We;for(let oe=0,le=x.length;oe<le;oe++){const fe=x[oe](ke,Re);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(We||(We=[]),We.push(fe))}return We?(async()=>{for(const oe of We){const le=await oe;if(typeof le=="string")return le}return null})():null},ve=x.find(ke=>!!ke.allBasenames);ve&&(Y.allBasenames=ve.allBasenames);const be=x.reduce((ke,Re)=>Re.allPaths?ke.concat(Re.allPaths):ke,[]);return be.length&&(Y.allPaths=be),Y}const de=function(Y,ve,be){let ke,Re;for(let We=0,oe=x.length;We<oe;We++){const le=x[We];le.requiresSiblings&&be&&(ve||(ve=(0,_.basename)(Y)),ke||(ke=ve.substr(0,ve.length-(0,_.extname)(Y).length)));const fe=le(Y,ve,ke,be);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(Re||(Re=[]),Re.push(fe))}return Re?(async()=>{for(const We of Re){const oe=await We;if(typeof oe=="string")return oe}return null})():null},te=x.find(Y=>!!Y.allBasenames);te&&(de.allBasenames=te.allBasenames);const pe=x.reduce((Y,ve)=>ve.allPaths?Y.concat(ve.allPaths):Y,[]);return pe.length&&(de.allPaths=pe),de}function G(X,$,x){if($===!1)return s;const Q=i(X,x);if(Q===s)return s;if(typeof $=="boolean")return Q;if($){const de=$.when;if(typeof de=="string"){const te=(pe,Y,ve,be)=>{if(!be||!Q(pe,Y))return null;const ke=de.replace("$(basename)",ve),Re=be(ke);return(0,t.isThenable)(Re)?Re.then(We=>We?X:null):Re?X:null};return te.requiresSiblings=!0,te}}return Q}function B(X,$){const x=X.filter(Y=>!!Y.basenames);if(x.length<2)return X;const Q=x.reduce((Y,ve)=>{const be=ve.basenames;return be?Y.concat(be):Y},[]);let de;if($){de=[];for(let Y=0,ve=Q.length;Y<ve;Y++)de.push($)}else de=x.reduce((Y,ve)=>{const be=ve.patterns;return be?Y.concat(be):Y},[]);const te=function(Y,ve){if(typeof Y!="string")return null;if(!ve){let ke;for(ke=Y.length;ke>0;ke--){const Re=Y.charCodeAt(ke-1);if(Re===47||Re===92)break}ve=Y.substr(ke)}const be=Q.indexOf(ve);return be!==-1?de[be]:null};te.basenames=Q,te.patterns=de,te.allBasenames=Q;const pe=X.filter(Y=>!Y.basenames);return pe.push(te),pe}function U(X,$){return(0,l.equals)(X,$,(x,Q)=>typeof x=="string"&&typeof Q=="string"?x===Q:typeof x!="string"&&typeof Q!="string"?x.base===Q.base&&x.pattern===Q.pattern:!1)}e.patternsEquals=U}),define(De[107],Ie([1,0,10,157,22,8,2]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(b){b[b.Paragraph=0]="Paragraph",b[b.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class w{constructor(f="",v=!1){if(this.value=f,typeof this.value!="string")throw(0,l.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(f,v=0){return this.value+=S(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(g,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,v){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(f,v,g){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(f),")"),g&&(this.value+=` "${this._escape(this._escape(g,'"'),")")}"`),this.value+=")",this}_escape(f,v){const g=new RegExp((0,P.escapeRegExpCharacters)(v),"g");return f.replace(g,(c,m)=>f.charAt(m-1)!=="\\"?`\\${c}`:c)}}e.MarkdownString=w;function I(b){return L(b)?!b.value:Array.isArray(b)?b.every(I):!0}e.isEmptyMarkdownString=I;function L(b){return b instanceof w?!0:b&&typeof b=="object"?typeof b.value=="string"&&(typeof b.isTrusted=="boolean"||b.isTrusted===void 0)&&(typeof b.supportThemeIcons=="boolean"||b.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function y(b,f){return b===f?!0:!b||!f?!1:b.value===f.value&&b.isTrusted===f.isTrusted&&b.supportThemeIcons===f.supportThemeIcons&&b.supportHtml===f.supportHtml&&(b.baseUri===f.baseUri||!!b.baseUri&&!!f.baseUri&&(0,D.isEqual)(_.URI.from(b.baseUri),_.URI.from(f.baseUri)))}e.markdownStringEqual=y;function S(b){return b.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function T(b){return b.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function E(b){return b&&b.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=E;function p(b){const f=[],v=b.split("|").map(c=>c.trim());b=v[0];const g=v[1];if(g){const c=/height=(\d+)/.exec(g),m=/width=(\d+)/.exec(g),n=c?c[1]:"",d=m?m[1]:"",s=isFinite(parseInt(d)),i=isFinite(parseInt(n));s&&f.push(`width="${d}"`),i&&f.push(`height="${n}"`)}return{href:b,dimensions:f}}e.parseHrefAndDimensions=p}),define(De[108],Ie([1,0,17,31,9,11,22,8]),function(J,e,l,t,D,P,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(s,i){const{os:r,tildify:a,relative:o}=i;if(o){const C=I(s,o,r);if(typeof C=="string")return C}let u=s.fsPath;if(r===1&&!P.isWindows?u=u.replace(/\//g,"\\"):r!==1&&P.isWindows&&(u=u.replace(/\\/g,"/")),r!==1&&a?.userHome){const C=a.userHome.fsPath;let R;s.scheme!==a.userHome.scheme&&s.path.startsWith(D.posix.sep)?R=a.userHome.with({path:s.path}).fsPath:R=s.fsPath,u=S(R,C,r)}return(r===1?D.win32:D.posix).normalize(L(u,r===1))}e.getPathLabel=w;function I(s,i,r){const a=r===1?D.win32:D.posix,o=r===3?_.extUri:_.extUriIgnorePathCase,u=i.getWorkspace(),h=(0,l.firstOrDefault)(u.folders);if(!h)return;s.scheme!==h.uri.scheme&&s.path.startsWith(D.posix.sep)&&(s=h.uri.with({path:s.path}));const C=i.getWorkspaceFolder(s);if(!C)return;let R;if(o.isEqual(C.uri,s)?R="":R=o.relativePath(C.uri,s)??"",R&&(R=a.normalize(R)),u.folders.length>1&&!i.noPrefix){const N=C.name?C.name:o.basenameOrAuthority(C.uri);R=R?`${N} \u2022 ${R}`:N}return R}function L(s,i=P.isWindows){return(0,t.hasDriveLetter)(s,i)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=L;let y=Object.create(null);function S(s,i,r=P.OS){if(r===1||!s||!i)return s;let a=y.original===i?y.normalized:void 0;a||(a=i,P.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,k.rtrim)(a,D.posix.sep)}${D.posix.sep}`,y={original:i,normalized:a});let o=s;return P.isWindows&&(o=(0,t.toSlashes)(o)),(r===3?o.startsWith(a):(0,k.startsWithIgnoreCase)(o,a))?`~/${o.substr(a.length)}`:s}e.tildify=S;function T(s,i){return s.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=T;const E="\u2026",p="\\\\",b="~";function f(s,i=D.sep){const r=new Array(s.length);let a=!1;for(let o=0;o<s.length;o++){const u=s[o];if(u===""){r[o]=`.${i}`;continue}if(!u){r[o]=u;continue}a=!0;let h="",C=u;C.indexOf(p)===0?(h=C.substr(0,C.indexOf(p)+p.length),C=C.substr(C.indexOf(p)+p.length)):C.indexOf(i)===0?(h=C.substr(0,C.indexOf(i)+i.length),C=C.substr(C.indexOf(i)+i.length)):C.indexOf(b)===0&&(h=C.substr(0,C.indexOf(b)+b.length),C=C.substr(C.indexOf(b)+b.length));const R=C.split(i);for(let N=1;a&&N<=R.length;N++)for(let M=R.length-N;a&&M>=0;M--){a=!1;let A=R.slice(M,M+N).join(i);for(let z=0;!a&&z<s.length;z++)if(z!==o&&s[z]&&s[z].indexOf(A)>-1){const H=M+N===R.length,F=M>0&&s[z].indexOf(i)>-1?i+A:A,G=s[z].endsWith(F);a=!H||G}if(!a){let z="";(R[0].endsWith(":")||h!=="")&&(M===1&&(M=0,N++,A=R[0]+i+A),M>0&&(z=R[0]+i),z=h+z),M>0&&(z=z+E+i),z=z+A,M+N<R.length&&(z=z+i+E),r[o]=z}}a&&(r[o]=u)}return r}e.shorten=f;var v;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function g(s,i=Object.create(null)){const r=[];let a=!1,o="";for(const u of s)if(u==="$"||a&&u==="{")o&&r.push({value:o,type:v.TEXT}),o="",a=!0;else if(u==="}"&&a){const h=i[o];if(typeof h=="string")h.length&&r.push({value:h,type:v.VARIABLE});else if(h){const C=r[r.length-1];(!C||C.type!==v.SEPARATOR)&&r.push({value:h.label,type:v.SEPARATOR})}o="",a=!1}else o+=u;return o&&!a&&r.push({value:o,type:v.TEXT}),r.filter((u,h)=>{if(u.type===v.SEPARATOR){const C=r[h-1],R=r[h+1];return[C,R].every(N=>N&&(N.type===v.VARIABLE||N.type===v.TEXT)&&N.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=g;function c(s,i){return P.isMacintosh||i?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):s.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function m(s,i){return P.isMacintosh||i?s.replace(/\(&&\w\)|&&/g,""):P.isWindows?s.replace(/&&|&/g,r=>r==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=m;function n(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=n;function d(s){const i=s.indexOf("/")!==-1?D.posix:D.win32,r=i.basename(s),a=i.dirname(s);return r.length?{name:r,parentPath:a}:{name:a,parentPath:""}}e.splitName=d}),define(De[109],Ie([1,0,2]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(L){return L.toJSON()}class D{constructor(y){this._uriTransformer=y}transformIncoming(y){const S=this._uriTransformer.transformIncoming(y);return S===y?y:t(l.URI.from(S))}transformOutgoing(y){const S=this._uriTransformer.transformOutgoing(y);return S===y?y:t(l.URI.from(S))}transformOutgoingURI(y){const S=this._uriTransformer.transformOutgoing(y);return S===y?y:l.URI.from(S)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function P(L,y,S){if(!L||S>200)return null;if(typeof L=="object"){if(L instanceof l.URI)return y.transformOutgoing(L);for(const T in L)if(Object.hasOwnProperty.call(L,T)){const E=P(L[T],y,S+1);E!==null&&(L[T]=E)}}return null}function _(L,y){const S=P(L,y,0);return S===null?L:S}e.transformOutgoingURIs=_;function k(L,y,S,T){if(!L||T>200)return null;if(typeof L=="object"){if(L.$mid===1)return S?l.URI.revive(y.transformIncoming(L)):y.transformIncoming(L);for(const E in L)if(Object.hasOwnProperty.call(L,E)){const p=k(L[E],y,S,T+1);p!==null&&(L[E]=p)}}return null}function w(L,y){const S=k(L,y,!1,0);return S===null?L:S}e.transformIncomingURIs=w;function I(L,y){const S=k(L,y,!0,0);return S===null?L:S}e.transformAndReviveIncomingURIs=I}),define(De[29],Ie([1,0,61,81,302,18,31,79,9,11,22,2]),function(J,e,l,t,D,P,_,k,w,I,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function T(F,G=S.UNLINK){if((0,_.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return G===S.UNLINK?p(F):E(F)}async function E(F){try{const G=(0,_.randomPath)((0,t.tmpdir)());try{await l.promises.rename(F,G)}catch(B){return B.code==="ENOENT"?void 0:p(F)}p(G).catch(B=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function p(F){return(0,D.promisify)(l.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function b(F){if((0,_.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");l.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function f(F,G){return c(await(G?v(F):(0,D.promisify)(l.readdir)(F)))}async function v(F){try{return await(0,D.promisify)(l.readdir)(F,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const G=[],B=await f(F);for(const U of B){let X=!1,$=!1,x=!1;try{const Q=await e.Promises.lstat((0,w.join)(F,U));X=Q.isFile(),$=Q.isDirectory(),x=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}G.push({name:U,isFile:()=>X,isDirectory:()=>$,isSymbolicLink:()=>x})}return G}function g(F){return c(l.readdirSync(F))}e.readdirSync=g;function c(F){return F.map(G=>typeof G=="string"?I.isMacintosh?(0,k.normalizeNFC)(G):G:(G.name=I.isMacintosh?(0,k.normalizeNFC)(G.name):G.name,G))}async function m(F){const G=await f(F),B=[];for(const U of G)await d.existsDirectory((0,w.join)(F,U))&&B.push(U);return B}function n(F,G=1e3){return new Promise(B=>{let U=!1;const X=setInterval(()=>{U||(U=!0,l.access(F,$=>{U=!1,$&&(clearInterval(X),B(void 0))}))},G)})}e.whenDeleted=n;var d;(function(F){async function G(X){let $;try{if($=await e.Promises.lstat(X),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(I.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw Q}throw x}}F.stat=G;async function B(X){try{const{stat:$,symbolicLink:x}=await F.stat(X);return $.isFile()&&x?.dangling!==!0}catch{}return!1}F.existsFile=B;async function U(X){try{const{stat:$,symbolicLink:x}=await F.stat(X);return $.isDirectory()&&x?.dangling!==!0}catch{}return!1}F.existsDirectory=U})(d=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new P.ResourceQueue;function i(F,G,B){return s.queueFor(y.URI.file(F),L.extUriBiasedIgnorePathCase).queue(()=>{const U=h(B);return new Promise((X,$)=>o(F,G,U,x=>x?$(x):X()))})}let r=!0;function a(F){r=F}e.configureFlushOnWrite=a;function o(F,G,B,U){if(!r)return l.writeFile(F,G,{mode:B.mode,flag:B.flag},U);l.open(F,B.flag,B.mode,(X,$)=>{if(X)return U(X);l.writeFile($,G,x=>{if(x)return l.close($,()=>U(x));l.fdatasync($,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),a(!1)),l.close($,de=>U(de))))})})}function u(F,G,B){const U=h(B);if(!r)return l.writeFileSync(F,G,{mode:U.mode,flag:U.flag});const X=l.openSync(F,U.flag,U.mode);try{l.writeFileSync(X,G);try{l.fdatasyncSync(X)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),a(!1)}}finally{l.closeSync(X)}}e.writeFileSync=u;function h(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function C(F,G){if(F!==G)try{await e.Promises.rename(F,G)}catch(B){if(F.toLowerCase()!==G.toLowerCase()&&B.code==="EXDEV"||F.endsWith("."))await R(F,G,{preserveSymlinks:!1}),await T(F,S.MOVE);else throw B}}async function R(F,G,B){return M(F,G,{root:{source:F,target:G},options:B,handledSourcePaths:new Set})}const N=511;async function M(F,G,B){if(B.handledSourcePaths.has(F))return;B.handledSourcePaths.add(F);const{stat:U,symbolicLink:X}=await d.stat(F);if(X){if(B.options.preserveSymlinks)try{return await H(F,G,B)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(X.dangling)return}return U.isDirectory()?A(F,G,U.mode&N,B):z(F,G,U.mode&N)}async function A(F,G,B,U){await e.Promises.mkdir(G,{recursive:!0,mode:B});const X=await f(F);for(const $ of X)await M((0,w.join)(F,$),(0,w.join)(G,$),U)}async function z(F,G,B){await e.Promises.copyFile(F,G),await e.Promises.chmod(G,B)}async function H(F,G,B){let U=await e.Promises.readlink(F);(0,_.isEqualOrParent)(U,B.root.source,!I.isLinux)&&(U=(0,w.join)(B.root.target,U.substr(B.root.source.length+1))),await e.Promises.symlink(U,G)}e.Promises=new class{get access(){return(0,D.promisify)(l.access)}get stat(){return(0,D.promisify)(l.stat)}get lstat(){return(0,D.promisify)(l.lstat)}get utimes(){return(0,D.promisify)(l.utimes)}get read(){return(F,G,B,U,X)=>new Promise(($,x)=>{l.read(F,G,B,U,X,(Q,de,te)=>Q?x(Q):$({bytesRead:de,buffer:te}))})}get readFile(){return(0,D.promisify)(l.readFile)}get write(){return(F,G,B,U,X)=>new Promise(($,x)=>{l.write(F,G,B,U,X,(Q,de,te)=>Q?x(Q):$({bytesWritten:de,buffer:te}))})}get appendFile(){return(0,D.promisify)(l.appendFile)}get fdatasync(){return(0,D.promisify)(l.fdatasync)}get truncate(){return(0,D.promisify)(l.truncate)}get rename(){return(0,D.promisify)(l.rename)}get copyFile(){return(0,D.promisify)(l.copyFile)}get open(){return(0,D.promisify)(l.open)}get close(){return(0,D.promisify)(l.close)}get symlink(){return(0,D.promisify)(l.symlink)}get readlink(){return(0,D.promisify)(l.readlink)}get chmod(){return(0,D.promisify)(l.chmod)}get mkdir(){return(0,D.promisify)(l.mkdir)}get unlink(){return(0,D.promisify)(l.unlink)}get rmdir(){return(0,D.promisify)(l.rmdir)}get realpath(){return(0,D.promisify)(l.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return m}get writeFile(){return i}get rm(){return T}get move(){return C}get copy(){return R}}}),define(De[110],Ie([1,0,61,9,11,8,29]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(S){if(D.isLinux)return S;const T=(0,t.dirname)(S);if(S===T)return S;const E=((0,t.basename)(S)||S).toLowerCase();try{const b=(0,_.readdirSync)(T).filter(f=>f.toLowerCase()===E);if(b.length===1){const f=k(T);if(f)return(0,t.join)(f,b[0])}else if(b.length>1){const f=b.indexOf(E);if(f>=0){const v=k(T);if(v)return(0,t.join)(v,b[f])}}}catch{}return null}e.realcaseSync=k;async function w(S){if(D.isLinux)return S;const T=(0,t.dirname)(S);if(S===T)return S;const E=((0,t.basename)(S)||S).toLowerCase();try{const b=(await _.Promises.readdir(T)).filter(f=>f.toLowerCase()===E);if(b.length===1){const f=await w(T);if(f)return(0,t.join)(f,b[0])}else if(b.length>1){const f=b.indexOf(E);if(f>=0){const v=await w(T);if(v)return(0,t.join)(v,b[f])}}}catch{}return null}e.realcase=w;async function I(S){try{return await _.Promises.realpath(S)}catch{const E=y(S);return await _.Promises.access(E,l.constants.R_OK),E}}e.realpath=I;function L(S){try{return l.realpathSync(S)}catch{const E=y(S);return l.accessSync(E,l.constants.R_OK),E}}e.realpathSync=L;function y(S){return(0,P.rtrim)((0,t.normalize)(S),t.sep)}}),define(De[111],Ie([1,0,9,11,40,103,16,29]),function(J,e,l,t,D,P,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function w(y=D.env){return y.comspec||"cmd.exe"}e.getWindowsShell=w;function I(y){let S=[],T=!1;const E=function(p){if(T){S.push(p);return}(!y.send(p,f=>{if(f&&console.error(f),T=!1,S.length>0){const v=S.slice(0);S=[],v.forEach(g=>E(g))}})||t.isWindows)&&(T=!0)};return{send:E}}e.createQueuedSender=I;var L;(function(y){async function S(T,E,p){if(l.isAbsolute(T))return T;if(E===void 0&&(E=D.cwd()),l.dirname(T)!=="."||(p===void 0&&_.isString(D.env.PATH)&&(p=D.env.PATH.split(l.delimiter)),p===void 0||p.length===0))return l.join(E,T);async function f(v){if(await k.Promises.exists(v)){let g;try{g=await k.Promises.stat(v)}catch(c){c.message.startsWith("EACCES")&&(g=await k.Promises.lstat(v))}return g?!g.isDirectory():!1}return!1}for(const v of p){let g;if(l.isAbsolute(v)?g=l.join(v,T):g=l.join(E,v,T),await f(g))return g;let c=g+".com";if(await f(c)||(c=g+".exe",await f(c)))return c}return l.join(E,T)}y.findExecutable=S})(L=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(J,e,l,t){var D=arguments.length,P=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,l):t,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(J,e,l,t);else for(var k=J.length-1;k>=0;k--)(_=J[k])&&(P=(D<3?_(P):D>3?_(e,l,P):_(e,l))||P);return D>3&&P&&Object.defineProperty(e,l,P),P};define(De[112],Ie([1,0,17,18,23,21,58,10,4,6,80,8,16]),function(J,e,l,t,D,P,_,k,w,I,L,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var T;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(T=e.RequestType||(e.RequestType={}));function E(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function b(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(f||(f={}));class v{constructor($){this.buffer=$,this.pos=0}read($){const x=this.buffer.slice(this.pos,this.pos+$);return this.pos+=x.byteLength,x}}class g{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}var c;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object"})(c||(c={}));function m(X){const $=D.VSBuffer.alloc(4);return $.writeUInt32BE(X,0),$}function n(X){return X.read(4).readUInt32BE(0)}function d(X){const $=D.VSBuffer.alloc(1);return $.writeUInt8(X,0),$}const s={Undefined:d(c.Undefined),String:d(c.String),Buffer:d(c.Buffer),VSBuffer:d(c.VSBuffer),Array:d(c.Array),Object:d(c.Object)},i=typeof Buffer<"u";function r(X,$){if(typeof $>"u")X.write(s.Undefined);else if(typeof $=="string"){const x=D.VSBuffer.fromString($);X.write(s.String),X.write(m(x.byteLength)),X.write(x)}else if(i&&Buffer.isBuffer($)){const x=D.VSBuffer.wrap($);X.write(s.Buffer),X.write(m(x.byteLength)),X.write(x)}else if($ instanceof D.VSBuffer)X.write(s.VSBuffer),X.write(m($.byteLength)),X.write($);else if(Array.isArray($)){X.write(s.Array),X.write(m($.length));for(const x of $)r(X,x)}else{const x=D.VSBuffer.fromString(JSON.stringify($));X.write(s.Object),X.write(m(x.byteLength)),X.write(x)}}function a(X){switch(X.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return X.read(n(X)).toString();case c.Buffer:return X.read(n(X)).buffer;case c.VSBuffer:return X.read(n(X));case c.Array:{const x=n(X),Q=[];for(let de=0;de<x;de++)Q.push(a(X));return Q}case c.Object:return JSON.parse(X.read(n(X)).toString())}}class o{constructor($,x,Q=null,de=1e3){this.protocol=$,this.ctx=x,this.logger=Q,this.timeoutDelay=de,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(te=>this.onRawMessage(te)),this.sendResponse({type:200})}registerChannel($,x){this.channels.set($,x),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const x=this.send([$.type]);this.logger?.logOutgoing(x,0,1,b($.type));return}case 201:case 202:case 204:case 203:{const x=this.send([$.type,$.id],$.data);this.logger?.logOutgoing(x,$.id,1,b($.type),$.data);return}}}send($,x=void 0){const Q=new g;return r(Q,$),r(Q,x),this.sendBuffer(Q.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onRawMessage($){const x=new v($),Q=a(x),de=a(x),te=Q[0];switch(te){case 100:return this.logger?.logIncoming($.byteLength,Q[1],1,`${E(te)}: ${Q[2]}.${Q[3]}`,de),this.onPromise({type:te,id:Q[1],channelName:Q[2],name:Q[3],arg:de});case 102:return this.logger?.logIncoming($.byteLength,Q[1],1,`${E(te)}: ${Q[2]}.${Q[3]}`,de),this.onEventListen({type:te,id:Q[1],channelName:Q[2],name:Q[3],arg:de});case 101:return this.logger?.logIncoming($.byteLength,Q[1],1,`${E(te)}`),this.disposeActiveRequest({type:te,id:Q[1]});case 103:return this.logger?.logIncoming($.byteLength,Q[1],1,`${E(te)}`),this.disposeActiveRequest({type:te,id:Q[1]})}}onPromise($){const x=this.channels.get($.channelName);if(!x){this.collectPendingRequest($);return}const Q=new P.CancellationTokenSource;let de;try{de=x.call(this.ctx,$.name,$.arg,Q.token)}catch(Y){de=Promise.reject(Y)}const te=$.id;de.then(Y=>{this.sendResponse({id:te,data:Y,type:201}),this.activeRequests.delete($.id)},Y=>{Y instanceof Error?this.sendResponse({id:te,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:te,data:Y,type:203}),this.activeRequests.delete($.id)});const pe=(0,I.toDisposable)(()=>Q.cancel());this.activeRequests.set($.id,pe)}onEventListen($){const x=this.channels.get($.channelName);if(!x){this.collectPendingRequest($);return}const Q=$.id,te=x.listen(this.ctx,$.name,$.arg)(pe=>this.sendResponse({id:Q,data:pe,type:204}));this.activeRequests.set($.id,te)}disposeActiveRequest($){const x=this.activeRequests.get($.id);x&&(x.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let x=this.pendingRequests.get($.channelName);x||(x=[],this.pendingRequests.set($.channelName,x));const Q=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:$,timeoutTimer:Q})}flushPendingRequests($){const x=this.pendingRequests.get($);if(x){for(const Q of x)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.onPromise(Q.request);break;case 102:this.onEventListen(Q.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=o;var u;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class h{constructor($,x=null){this.protocol=$,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Q=>this.onBuffer(Q)),this.logger=x}getChannel($){const x=this;return{call(Q,de,te){return x.isDisposed?Promise.reject(new k.CancellationError):x.requestPromise($,Q,de,te)},listen(Q,de){return x.isDisposed?w.Event.None:x.requestEvent($,Q,de)}}}requestPromise($,x,Q,de=P.CancellationToken.None){const te=this.lastRequestId++,Y={id:te,type:100,channelName:$,name:x,arg:Q};if(de.isCancellationRequested)return Promise.reject(new k.CancellationError);let ve;return new Promise((ke,Re)=>{if(de.isCancellationRequested)return Re(new k.CancellationError);const We=()=>{const Z=ae=>{switch(ae.type){case 201:this.handlers.delete(te),ke(ae.data);break;case 202:{this.handlers.delete(te);const ne=new Error(ae.data.message);ne.stack=ae.data.stack,ne.name=ae.data.name,Re(ne);break}case 203:this.handlers.delete(te),Re(ae.data);break}};this.handlers.set(te,Z),this.sendRequest(Y)};let oe=null;this.state===f.Idle?We():(oe=(0,t.createCancelablePromise)(Z=>this.whenInitialized()),oe.then(()=>{oe=null,We()}));const le=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:te,type:101}),Re(new k.CancellationError)},fe=de.onCancellationRequested(le);ve=(0,I.combinedDisposable)((0,I.toDisposable)(le),fe),this.activeRequests.add(ve)}).finally(()=>{this.activeRequests.delete(ve)})}requestEvent($,x,Q){const de=this.lastRequestId++,pe={id:de,type:102,channelName:$,name:x,arg:Q};let Y=null;const ve=new w.Emitter({onFirstListenerAdd:()=>{Y=(0,t.createCancelablePromise)(ke=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(ve),this.sendRequest(pe)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(ve),this.sendRequest({id:de,type:103}))}}),be=ke=>ve.fire(ke.data);return this.handlers.set(de,be),ve.event}sendRequest($){switch($.type){case 100:case 102:{const x=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger?.logOutgoing(x,$.id,0,`${E($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const x=this.send([$.type,$.id]);this.logger?.logOutgoing(x,$.id,0,E($.type));return}}}send($,x=void 0){const Q=new g;return r(Q,$),r(Q,x),this.sendBuffer(Q.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onBuffer($){const x=new v($),Q=a(x),de=a(x),te=Q[0];switch(te){case 200:return this.logger?.logIncoming($.byteLength,0,0,b(te)),this.onResponse({type:Q[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming($.byteLength,Q[1],0,b(te),de),this.onResponse({type:Q[0],id:Q[1],data:de})}}onResponse($){if($.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get($.id)?.($)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}qe([_.memoize],h.prototype,"onDidInitializePromise",null),e.ChannelClient=h;class C{constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,$(({protocol:x,onDidClientDisconnect:Q})=>{w.Event.once(x.onMessage)(te=>{const pe=new v(te),Y=a(pe),ve=new o(x,Y),be=new h(x);this.channels.forEach((Re,We)=>ve.registerChannel(We,Re));const ke={channelServer:ve,channelClient:be,ctx:Y};this._connections.add(ke),this._onDidAddConnection.fire(ke),Q(()=>{ve.dispose(),be.dispose(),this._connections.delete(ke),this._onDidRemoveConnection.fire(ke)})})})}get connections(){const $=[];return this._connections.forEach(x=>$.push(x)),$}getChannel($,x){const Q=this;return{call(de,te,pe){let Y;if((0,S.isFunction)(x)){const be=(0,l.getRandomElement)(Q.connections.filter(x));Y=be?Promise.resolve(be):w.Event.toPromise(w.Event.filter(Q.onDidAddConnection,x))}else Y=x.routeCall(Q,de,te);const ve=Y.then(be=>be.channelClient.getChannel($));return N(ve).call(de,te,pe)},listen(de,te){if((0,S.isFunction)(x))return Q.getMulticastEvent($,x,de,te);const pe=x.routeEvent(Q,de,te).then(Y=>Y.channelClient.getChannel($));return N(pe).listen(de,te)}}}getMulticastEvent($,x,Q,de){const te=this;let pe=new I.DisposableStore;const Y=new w.Emitter({onFirstListenerAdd:()=>{pe=new I.DisposableStore;const ve=new w.EventMultiplexer,be=new Map,ke=We=>{const le=We.channelClient.getChannel($).listen(Q,de),fe=ve.add(le);be.set(We,fe)},Re=We=>{const oe=be.get(We);!oe||(oe.dispose(),be.delete(We))};te.connections.filter(x).forEach(ke),w.Event.filter(te.onDidAddConnection,x)(ke,void 0,pe),te.onDidRemoveConnection(Re,void 0,pe),ve.event(Y.fire,Y,pe),pe.add(ve)},onLastListenerRemove:()=>{pe.dispose()}});return Y.event}registerChannel($,x){this.channels.set($,x),this._connections.forEach(Q=>{Q.channelServer.registerChannel($,x)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=C;class R{constructor($,x,Q=null){const de=new g;r(de,x),$.send(de.buffer),this.channelClient=new h($,Q),this.channelServer=new o($,x,Q)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,x){this.channelServer.registerChannel($,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function N(X){return{call($,x,Q){return X.then(de=>de.call($,x,Q))},listen($,x){const Q=new w.Relay;return X.then(de=>Q.input=de.listen($,x)),Q.event}}}e.getDelayedChannel=N;function M(X){let $=!1;return{call(x,Q,de){return $?X.call(x,Q,de):(0,t.timeout)(0).then(()=>$=!0).then(()=>X.call(x,Q,de))},listen(x,Q){if($)return X.listen(x,Q);const de=new w.Relay;return(0,t.timeout)(0).then(()=>$=!0).then(()=>de.input=X.listen(x,Q)),de.event}}}e.getNextTickChannel=M;class A{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const x of $.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await w.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=A;var z;(function(X){function $(te,pe){const Y=te,ve=pe&&pe.disableMarshalling,be=new Map;for(const ke in Y)Q(ke)&&be.set(ke,w.Event.buffer(Y[ke],!0));return new class{listen(ke,Re,We){const oe=be.get(Re);if(oe)return oe;if(de(Re)){const le=Y[Re];if(typeof le=="function")return le.call(Y,We)}throw new Error(`Event not found: ${Re}`)}call(ke,Re,We){const oe=Y[Re];if(typeof oe=="function"){if(!ve&&Array.isArray(We))for(let le=0;le<We.length;le++)We[le]=(0,L.revive)(We[le]);return oe.apply(Y,We)}throw new Error(`Method not found: ${Re}`)}}}X.fromService=$;function x(te,pe){const Y=pe&&pe.disableMarshalling;return new Proxy({},{get(ve,be){if(typeof be=="string")return pe?.properties?.has(be)?pe.properties.get(be):de(be)?function(ke){return te.listen(be,ke)}:Q(be)?te.listen(be):async function(...ke){let Re;pe&&!(0,S.isUndefinedOrNull)(pe.context)?Re=[pe.context,...ke]:Re=ke;const We=await te.call(be,Re);return Y?We:(0,L.revive)(We)};throw new Error(`Property not found: ${String(be)}`)}})}X.toService=x;function Q(te){return te[0]==="o"&&te[1]==="n"&&y.isUpperAsciiLetter(te.charCodeAt(2))}function de(te){return/^onDynamic/.test(te)&&y.isUpperAsciiLetter(te.charCodeAt(9))}})(z=e.ProxyChannel||(e.ProxyChannel={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const $=X.toString();if($!=="[object Object]")return $}return X}function G(X){return Array.isArray(X)?X.map(F):F(X)}function B(X,$,x,Q,de,te,pe){pe=G(pe);const Y=H[de],ve=Y[Q%Y.length];let be=[`%c[${X}]%c[${String($).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${ve}`];/\($/.test(te)?(be=be.concat(pe),be.push(")")):be.push(pe),console.log.apply(console,be)}e.logWithColors=B;class U{constructor($,x){this._outgoingPrefix=$,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,x,Q,de,te){this._totalOutgoing+=$,B(this._outgoingPrefix,this._totalOutgoing,$,x,Q,de,te)}logIncoming($,x,Q,de,te){this._totalIncoming+=$,B(this._incomingPrefix,this._totalIncoming,$,x,Q,de,te)}}e.IPCLogger=U}),define(De[113],Ie([1,0,23,4,6,112]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var _;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(_=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let a=0;function o(h,C){if(!r.has(h)){const R=String(++a);r.set(h,R)}return r.get(h)}function u(h,C,R,N){if(!i.enableDiagnostics)return;const M=o(h,C);if(N instanceof l.VSBuffer||N instanceof Uint8Array||N instanceof ArrayBuffer||ArrayBuffer.isView(N)){const A=l.VSBuffer.alloc(N.byteLength);A.set(N),i.records.push({timestamp:Date.now(),id:M,label:C,type:R,buff:A})}else i.records.push({timestamp:Date.now(),id:M,label:C,type:R,data:N})}i.traceSocketEvent=u})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function L(){return I||(I=l.VSBuffer.alloc(0)),I}class y{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,a){if(r===0)return L();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const C=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=r),C}if(this._chunks[0].byteLength>r){const C=this._chunks[0].slice(0,r);return a&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),C}const o=l.VSBuffer.alloc(r);let u=0,h=0;for(;r>0;){const C=this._chunks[h];if(C.byteLength>r){const R=C.slice(0,r);o.set(R,u),u+=r,a&&(this._chunks[h]=C.slice(r),this._totalLength-=r),r-=r}else o.set(C,u),u+=C.byteLength,a?(this._chunks.shift(),this._totalLength-=C.byteLength):h++,r-=C.byteLength}return o}}e.ChunkStream=y;var S;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(S||(S={}));function T(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var E;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(r,a,o,u){this.type=r,this.id=a,this.ack=o,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends D.Disposable{constructor(r){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,u=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new p(o,u,h,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=l.VSBuffer.alloc(13);a.writeUInt8(r.type,0),a.writeUInt32BE(r.id,1),a.writeUInt32BE(r.ack,5),a.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:T(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(a,r.data)}_bufferAdd(r,a){const o=this._totalLength===0;return this._data.push(r,a),this._totalLength+=r.byteLength+a.byteLength,o}_bufferTake(){const r=l.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,a){this._bufferAdd(r,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class v extends D.Disposable{constructor(r){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new p(1,0,0,r))}}e.Protocol=v;class g extends P.IPCClient{constructor(r,a,o=null){super(r,a,o),this.protocol=r}static fromSocket(r,a){return new g(new v(r),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=g;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class m{constructor(r){this.data=r,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let r=0,a=this._first;for(;a;)a=a.next,r++;return r}peek(){return this._first?this._first.data:null}toArray(){const r=[];let a=0,o=this._first;for(;o;)r[a++]=o.data,o=o.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const a=new m(r);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class d{constructor(){this.lastRuns=[];const r=Date.now();for(let a=0;a<d._HISTORY_LENGTH;a++)this.lastRuns[a]=r-1e3*a;setInterval(()=>{for(let a=d._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return d._INSTANCE||(d._INSTANCE=new d),d._INSTANCE}load(){const r=Date.now(),a=(1+d._HISTORY_LENGTH)*1e3;let o=0;for(let u=0;u<d._HISTORY_LENGTH;u++)r-this.lastRuns[u]<=a&&o++;return 1-o/d._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}d._HISTORY_LENGTH=10,d._INSTANCE=null;class s{constructor(r,a=null,o=d.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),a&&this._socketReader.acceptChunk(a),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new p(5,0,0,L());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new p(7,0,0,L());this._socketWriter.write(r)}sendResume(){const r=new p(8,0,0,L());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new p(3,0,this._incomingAckId,L());this._socketWriter.write(r);const a=this._outgoingUnackMsg.toArray();for(let o=0,u=a.length;o<u;o++)this._socketWriter.write(a[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new p(6,0,0,L())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let o=0,u=a.length;o<u;o++)this._socketWriter.write(a[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new p(1,a,this._incomingAckId,r);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(r){const a=new p(2,0,0,r);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),a=Date.now()-r.writtenTime,o=Date.now()-this._socketReader.lastReadTime,u=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&o>=2e4&&u>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:o});return}const h=Math.max(2e4-a,2e4-o,2e4-u,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},h)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new p(3,0,this._incomingAckId,L());this._socketWriter.write(r)}_sendKeepAlive(){const r=new p(9,0,0,L());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(De[114],Ie([1,0,23,10,4,6,9,11,34,112,113]),function(J,e,l,t,D,P,_,k,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function y(){return{crypto:J.__$__nodeRequire("crypto"),zlib:J.__$__nodeRequire("zlib"),net:J.__$__nodeRequire("net"),os:J.__$__nodeRequire("os")}}class S{constructor(o,u=""){this.debugLabel=u,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=h=>{if(this.traceSocketEvent("error",{code:h?.code,message:h?.message}),h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}},this.socket.on("error",this._errorListener)}traceSocketEvent(o,u){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,u)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(o){const u=h=>{this.traceSocketEvent("read",h),o(l.VSBuffer.wrap(h))};return this.socket.on("data",u),{dispose:()=>this.socket.off("data",u)}}onClose(o){const u=h=>{this.traceSocketEvent("close",{hadError:h}),o({type:0,hadError:h,error:void 0})};return this.socket.on("close",u),{dispose:()=>this.socket.off("close",u)}}onEnd(o){const u=()=>{this.traceSocketEvent("nodeEndReceived"),o()};return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(o){if(!this.socket.destroyed)try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,u=>{if(u){if(u.code==="EPIPE")return;(0,t.onUnexpectedError)(u)}})}catch(u){if(u.code==="EPIPE")return;(0,t.onUnexpectedError)(u)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,u)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=S;var T;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(T||(T={}));var E;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(E||(E={}));class p extends P.Disposable{constructor(o,u,h,C){super(),this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:u,inflateBytesLength:h?.byteLength||0,recordInflateBytes:C}),this._flowManager=this._register(new b(this,u,h,C,this._onData,(R,N)=>this._write(R,N))),this._register(this._flowManager.onError(R=>{console.error(R),(0,t.onUnexpectedError)(R),this._onClose.fire({type:0,hadError:!0,error:R})})),this._incomingData=new L.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(R=>this._onClose.fire(R)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(o,u){this.socket.traceSocketEvent(o,u)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this._onData.event(o)}onClose(o){return this._onClose.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this._flowManager.writeMessage(o)}_write(o,u){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let h=2;o.byteLength<126?h+=0:o.byteLength<2**16?h+=2:h+=8;const C=l.VSBuffer.alloc(h);if(u?C.writeUInt8(194,0):C.writeUInt8(130,0),o.byteLength<126)C.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){C.writeUInt8(126,1);let R=1;C.writeUInt8(o.byteLength>>>8&255,++R),C.writeUInt8(o.byteLength>>>0&255,++R)}else{C.writeUInt8(127,1);let R=1;C.writeUInt8(0,++R),C.writeUInt8(0,++R),C.writeUInt8(0,++R),C.writeUInt8(0,++R),C.writeUInt8(o.byteLength>>>24&255,++R),C.writeUInt8(o.byteLength>>>16&255,++R),C.writeUInt8(o.byteLength>>>8&255,++R),C.writeUInt8(o.byteLength>>>0&255,++R)}this.socket.write(l.VSBuffer.concat([C,o]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(o){if(o.byteLength!==0){for(this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const u=this._incomingData.peek(this._state.readLen),h=u.readUInt8(0),C=(h&128)>>>7,R=(h&64)>>>6,N=u.readUInt8(1),M=(N&128)>>>7,A=N&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(A===126?2:0)+(A===127?8:0),this._state.fin=C,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(R)),this._state.firstFrameOfMessage=Boolean(C),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const u=this._incomingData.read(this._state.readLen),h=u.readUInt8(1),C=(h&128)>>>7;let R=h&127,N=1;R===126?R=u.readUInt8(++N)*2**8+u.readUInt8(++N):R===127&&(R=u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*2**24+u.readUInt8(++N)*2**16+u.readUInt8(++N)*2**8+u.readUInt8(++N));let M=0;C&&(M=u.readUInt8(++N)*2**24+u.readUInt8(++N)*2**16+u.readUInt8(++N)*2**8+u.readUInt8(++N)),this._state.state=3,this._state.readLen=R,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const u=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",u),g(u,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",u),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(u,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class b extends P.Disposable{constructor(o,u,h,C,R,N){super(),this._tracer=o,this._onData=R,this._writeFn=N,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,u?(this._zlibInflateStream=this._register(new f(this._tracer,C,h,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:l.VSBuffer.alloc(0)}writeMessage(o){this._writeQueue.push(o),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const o=this._writeQueue.shift();if(this._zlibDeflateStream){const u=await this._deflateMessage(this._zlibDeflateStream,o);this._writeFn(u,!0)}else this._writeFn(o,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(o,u){return new Promise((h,C)=>{o.write(u),o.flush(R=>h(R))})}acceptFrame(o,u,h){this._readQueue.push({data:o,isCompressed:u,isLastFrameOfMessage:h}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const o=this._readQueue.shift();if(this._zlibInflateStream&&o.isCompressed){const u=await this._inflateFrame(this._zlibInflateStream,o.data,o.isLastFrameOfMessage);this._onData.fire(u)}else this._onData.fire(o.data)}this._isProcessingReadQueue=!1}}_inflateFrame(o,u,h){return new Promise((C,R)=>{o.write(u),h&&o.write(l.VSBuffer.fromByteArray([0,0,255,255])),o.flush(N=>C(N))})}}class f extends P.Disposable{constructor(o,u,h,C){super(),this._tracer=o,this._recordInflateBytes=u,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=y().zlib.createInflateRaw(C),this._zlibInflate.on("error",R=>{this._tracer.traceSocketEvent("zlibInflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibInflate.on("data",R=>{this._tracer.traceSocketEvent("zlibInflateData",R),this._pendingInflateData.push(l.VSBuffer.wrap(R))}),h&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",h.buffer),this._zlibInflate.write(h.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?l.VSBuffer.concat(this._recordedInflateBytes):l.VSBuffer.alloc(0)}write(o){this._recordInflateBytes&&this._recordedInflateBytes.push(o.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",o),this._zlibInflate.write(o.buffer)}flush(o){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const u=l.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,o(u)})}}class v extends P.Disposable{constructor(o,u){super(),this._tracer=o,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=y().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",h=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:h?.message,code:h?.code}),this._onError.fire(h)}),this._zlibDeflate.on("data",h=>{this._tracer.traceSocketEvent("zlibDeflateData",h),this._pendingDeflateData.push(l.VSBuffer.wrap(h))})}write(o){this._tracer.traceSocketEvent("zlibDeflateWrite",o.buffer),this._zlibDeflate.write(o.buffer)}flush(o){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let u=l.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,u=u.slice(0,u.byteLength-4),o(u)})}}function g(a,o){if(o===0)return;const u=a.byteLength>>>2;for(let A=0;A<u;A++){const z=a.readUInt32BE(A*4);a.writeUInt32BE(z^o,A*4)}const h=u*4,C=a.byteLength-h,R=o>>>24&255,N=o>>>16&255,M=o>>>8&255;C>=1&&a.writeUInt8(a.readUInt8(h)^R,h),C>=2&&a.writeUInt8(a.readUInt8(h+1)^N,h+1),C>=3&&a.writeUInt8(a.readUInt8(h+2)^M,h+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const c={[2]:107,[1]:103};function m(){const a=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,_.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):o=(0,_.join)(y().os.tmpdir(),`vscode-ipc-${a}.sock`),d(o),o}e.createRandomIPCHandle=m;function n(a,o,u){const h=y().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${u}-${o}-sock`;let C;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?C=(0,_.join)(e.XDG_RUNTIME_DIR,`vscode-${h.substr(0,8)}-${u}-${o}.sock`):C=(0,_.join)(a,`${u}-${o}.sock`),d(C),C}e.createStaticIPCHandle=n;function d(a){const o=c[k.platform];typeof o=="number"&&a.length>=o&&console.warn(`WARNING: IPC handle "${a}" is longer than ${o} chars, try a shorter --user-data-dir`)}class s extends I.IPCServer{constructor(o){super(s.toClientConnectionEvent(o)),this.server=o}static toClientConnectionEvent(o){const u=D.Event.fromNodeEventEmitter(o,"connection");return D.Event.map(u,h=>({protocol:new L.Protocol(new S(h,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(h,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function i(a){return new Promise((o,u)=>{const h=y().net.createServer();h.on("error",u),h.listen(a,()=>{h.removeListener("error",u),o(new s(h))})})}e.serve=i;function r(a,o){return new Promise((u,h)=>{const C=y().net.createConnection(a,()=>{C.removeListener("error",h),u(L.Client.fromSocket(new S(C,`ipc-client${o}`),o))});C.once("error",h)})}e.connect=r}),define(De[158],Ie([1,0,36,9]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(P,_,k,w,I,L){if(Array.isArray(P)){let y=0;for(const S of P){const T=D(S,_,k,w,I,L);if(T===10)return T;T>y&&(y=T)}return y}else{if(typeof P=="string")return w?P==="*"?5:P===k?10:0:0;if(P){const{language:y,pattern:S,scheme:T,hasAccessToAllModels:E,notebookType:p}=P;if(!w&&!E)return 0;p&&I&&(_=I);let b=0;if(T)if(T===_.scheme)b=10;else if(T==="*")b=5;else return 0;if(y)if(y===k)b=10;else if(y==="*")b=Math.max(b,5);else return 0;if(p)if(p===L)b=10;else if(p==="*"&&L!==void 0)b=Math.max(b,5);else return 0;if(S){let f;if(typeof S=="string"?f=S:f={...S,base:(0,t.normalize)(S.base)},f===_.fsPath||(0,l.match)(f,_.fsPath))b=10;else return 0}return b}else return 0}}e.score=D}),define(De[159],Ie([1,0,8,49,151]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(k,w,I,L){this._uri=k,this._lines=w,this._eol=I,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const w=k.changes;for(const I of w)this._acceptDeleteRange(I.range),this._acceptInsertText(new t.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,w=this._lines.length,I=new Uint32Array(w);for(let L=0;L<w;L++)I[L]=this._lines[L].length+k;this._lineStarts=new D.PrefixSumComputer(I)}}_setLineText(k,w){this._lines[k]=w,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,w){if(w.length===0)return;const I=(0,l.splitLines)(w);if(I.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+I[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}I[I.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+I[0]);const L=new Uint32Array(I.length-1);for(let y=1;y<I.length;y++)this._lines.splice(k.lineNumber+y-1,0,I[y]),L[y-1]=I[y].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,L)}}e.MirrorTextModel=P}),define(De[160],Ie([1,0,8,148,49,35,101]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class w{constructor(v,g,c,m){this.searchString=v,this.isRegex=g,this.matchCase=c,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=I(this.searchString):v=this.searchString.indexOf(`
`)>=0;let g=null;try{g=l.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!g)return null;let c=!this.isRegex&&!v;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new _.SearchData(g,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=w;function I(f){if(!f||f.length===0)return!1;for(let v=0,g=f.length;v<g;v++){const c=f.charCodeAt(v);if(c===10)return!0;if(c===92){if(v++,v>=g)break;const m=f.charCodeAt(v);if(m===110||m===114||m===87)return!0}}return!1}e.isMultilineRegexSource=I;function L(f,v,g){if(!g)return new _.FindMatch(f,null);const c=[];for(let m=0,n=v.length;m<n;m++)c[m]=v[m];return new _.FindMatch(f,c)}e.createFindMatch=L;class y{constructor(v){const g=[];let c=0;for(let m=0,n=v.length;m<n;m++)v.charCodeAt(m)===10&&(g[c++]=m);this._lineFeedsOffsets=g}findLineFeedCountBeforeOffset(v){const g=this._lineFeedsOffsets;let c=0,m=g.length-1;if(m===-1||v<=g[0])return 0;for(;c<m;){const n=c+((m-c)/2>>0);g[n]>=v?m=n-1:g[n+1]>=v?(c=n,m=n):c=n+1}return c+1}}class S{static findMatches(v,g,c,m,n){const d=g.parseSearchRequest();return d?d.regex.multiline?this._doFindMatchesMultiline(v,c,new b(d.wordSeparators,d.regex),m,n):this._doFindMatchesLineByLine(v,c,d,m,n):[]}static _getMultilineMatchRange(v,g,c,m,n,d){let s,i=0;m?(i=m.findLineFeedCountBeforeOffset(n),s=g+n+i):s=g+n;let r;if(m){const h=m.findLineFeedCountBeforeOffset(n+d.length)-i;r=s+d.length+h}else r=s+d.length;const a=v.getPositionAt(s),o=v.getPositionAt(r);return new P.Range(a.lineNumber,a.column,o.lineNumber,o.column)}static _doFindMatchesMultiline(v,g,c,m,n){const d=v.getOffsetAt(g.getStartPosition()),s=v.getValueInRange(g,1),i=v.getEOL()===`\r
`?new y(s):null,r=[];let a=0,o;for(c.reset(0);o=c.next(s);)if(r[a++]=L(this._getMultilineMatchRange(v,d,s,i,o.index,o[0]),o,m),a>=n)return r;return r}static _doFindMatchesLineByLine(v,g,c,m,n){const d=[];let s=0;if(g.startLineNumber===g.endLineNumber){const r=v.getLineContent(g.startLineNumber).substring(g.startColumn-1,g.endColumn-1);return s=this._findMatchesInLine(c,r,g.startLineNumber,g.startColumn-1,s,d,m,n),d}const i=v.getLineContent(g.startLineNumber).substring(g.startColumn-1);s=this._findMatchesInLine(c,i,g.startLineNumber,g.startColumn-1,s,d,m,n);for(let r=g.startLineNumber+1;r<g.endLineNumber&&s<n;r++)s=this._findMatchesInLine(c,v.getLineContent(r),r,0,s,d,m,n);if(s<n){const r=v.getLineContent(g.endLineNumber).substring(0,g.endColumn-1);s=this._findMatchesInLine(c,r,g.endLineNumber,0,s,d,m,n)}return d}static _findMatchesInLine(v,g,c,m,n,d,s,i){const r=v.wordSeparators;if(!s&&v.simpleSearch){const u=v.simpleSearch,h=u.length,C=g.length;let R=-h;for(;(R=g.indexOf(u,R+h))!==-1;)if((!r||p(r,g,C,R,h))&&(d[n++]=new _.FindMatch(new P.Range(c,R+1+m,c,R+1+h+m),null),n>=i))return n;return n}const a=new b(v.wordSeparators,v.regex);let o;a.reset(0);do if(o=a.next(g),o&&(d[n++]=L(new P.Range(c,o.index+1+m,c,o.index+1+o[0].length+m),o,s),n>=i))return n;while(o);return n}static findNextMatch(v,g,c,m){const n=g.parseSearchRequest();if(!n)return null;const d=new b(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(v,c,d,m):this._doFindNextMatchLineByLine(v,c,d,m)}static _doFindNextMatchMultiline(v,g,c,m){const n=new D.Position(g.lineNumber,1),d=v.getOffsetAt(n),s=v.getLineCount(),i=v.getValueInRange(new P.Range(n.lineNumber,n.column,s,v.getLineMaxColumn(s)),1),r=v.getEOL()===`\r
`?new y(i):null;c.reset(g.column-1);const a=c.next(i);return a?L(this._getMultilineMatchRange(v,d,i,r,a.index,a[0]),a,m):g.lineNumber!==1||g.column!==1?this._doFindNextMatchMultiline(v,new D.Position(1,1),c,m):null}static _doFindNextMatchLineByLine(v,g,c,m){const n=v.getLineCount(),d=g.lineNumber,s=v.getLineContent(d),i=this._findFirstMatchInLine(c,s,d,g.column,m);if(i)return i;for(let r=1;r<=n;r++){const a=(d+r-1)%n,o=v.getLineContent(a+1),u=this._findFirstMatchInLine(c,o,a+1,1,m);if(u)return u}return null}static _findFirstMatchInLine(v,g,c,m,n){v.reset(m-1);const d=v.next(g);return d?L(new P.Range(c,d.index+1,c,d.index+1+d[0].length),d,n):null}static findPreviousMatch(v,g,c,m){const n=g.parseSearchRequest();if(!n)return null;const d=new b(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(v,c,d,m):this._doFindPreviousMatchLineByLine(v,c,d,m)}static _doFindPreviousMatchMultiline(v,g,c,m){const n=this._doFindMatchesMultiline(v,new P.Range(1,1,g.lineNumber,g.column),c,m,10*k);if(n.length>0)return n[n.length-1];const d=v.getLineCount();return g.lineNumber!==d||g.column!==v.getLineMaxColumn(d)?this._doFindPreviousMatchMultiline(v,new D.Position(d,v.getLineMaxColumn(d)),c,m):null}static _doFindPreviousMatchLineByLine(v,g,c,m){const n=v.getLineCount(),d=g.lineNumber,s=v.getLineContent(d).substring(0,g.column-1),i=this._findLastMatchInLine(c,s,d,m);if(i)return i;for(let r=1;r<=n;r++){const a=(n+d-r-1)%n,o=v.getLineContent(a+1),u=this._findLastMatchInLine(c,o,a+1,m);if(u)return u}return null}static _findLastMatchInLine(v,g,c,m){let n=null,d;for(v.reset(0);d=v.next(g);)n=L(new P.Range(c,d.index+1,c,d.index+1+d[0].length),d,m);return n}}e.TextModelSearch=S;function T(f,v,g,c,m){if(c===0)return!0;const n=v.charCodeAt(c-1);if(f.get(n)!==0||n===13||n===10)return!0;if(m>0){const d=v.charCodeAt(c);if(f.get(d)!==0)return!0}return!1}function E(f,v,g,c,m){if(c+m===g)return!0;const n=v.charCodeAt(c+m);if(f.get(n)!==0||n===13||n===10)return!0;if(m>0){const d=v.charCodeAt(c+m-1);if(f.get(d)!==0)return!0}return!1}function p(f,v,g,c,m){return T(f,v,g,c,m)&&E(f,v,g,c,m)}e.isValidMatch=p;class b{constructor(v,g){this._wordSeparators=v,this._searchRegex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const g=v.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===g||(c=this._searchRegex.exec(v),!c))return null;const m=c.index,n=c[0].length;if(m===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){l.getNextCodePoint(v,g,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=m,this._prevMatchLength=n,!this._wordSeparators||p(this._wordSeparators,v,g,m,n))return c}while(c);return null}}e.Searcher=b}),define(De[115],Ie([1,0,23,11]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(D||(D={}));function P(y){for(let S=0,T=y.length;S<T;S+=4){const E=y[S+0],p=y[S+1],b=y[S+2],f=y[S+3];y[S+0]=f,y[S+1]=b,y[S+2]=p,y[S+3]=E}}function _(y){const S=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return t.isLittleEndian()||P(S),l.VSBuffer.wrap(S)}function k(y){const S=y.buffer;if(t.isLittleEndian()||P(S),S.byteOffset%4===0)return new Uint32Array(S.buffer,S.byteOffset,S.length/4);{const T=new Uint8Array(S.byteLength);return T.set(S),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function w(y){const S=new Uint32Array(I(y));let T=0;if(S[T++]=y.id,y.type==="full")S[T++]=1,S[T++]=y.data.length,S.set(y.data,T),T+=y.data.length;else{S[T++]=2,S[T++]=y.deltas.length;for(const E of y.deltas)S[T++]=E.start,S[T++]=E.deleteCount,E.data?(S[T++]=E.data.length,S.set(E.data,T),T+=E.data.length):S[T++]=0}return _(S)}e.encodeSemanticTokensDto=w;function I(y){let S=0;if(S+=1+1,y.type==="full")S+=1+y.data.length;else{S+=1,S+=(1+1+1)*y.deltas.length;for(const T of y.deltas)T.data&&(S+=T.data.length)}return S}function L(y){const S=k(y);let T=0;const E=S[T++];if(S[T++]===1){const v=S[T++],g=S.subarray(T,T+v);return T+=v,{id:E,type:"full",data:g}}const b=S[T++],f=[];for(let v=0;v<b;v++){const g=S[T++],c=S[T++],m=S[T++];let n;m>0&&(n=S.subarray(T,T+m),T+=m),f[v]={start:g,deleteCount:c,data:n}}return{id:E,type:"delta",deltas:f}}e.decodeSemanticTokensDto=L}),define(De[161],Ie([1,0,4,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class D{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new l.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,w){return this._map.set(k,w),this.fire([k]),(0,t.toDisposable)(()=>{this._map.get(k)===w&&(this._map.delete(k),this.fire([k]))})}registerFactory(k,w){this._factories.get(k)?.dispose();const I=new P(this,k,w);return this._factories.set(k,I),(0,t.toDisposable)(()=>{const L=this._factories.get(k);!L||L!==I||(this._factories.delete(k),L.dispose())})}async getOrCreate(k){const w=this.get(k);if(w)return w;const I=this._factories.get(k);return!I||I.isResolved?null:(await I.resolve(),this.get(k))}get(k){return this._map.get(k)||null}isResolved(k){if(this.get(k))return!0;const I=this._factories.get(k);return!!(!I||I.isResolved)}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=D;class P extends t.Disposable{constructor(k,w,I){super(),this._registry=k,this._languageId=w,this._factory=I,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const k=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,k&&!this._isDisposed&&this._register(this._registry.register(this._languageId,k))}}}),define(De[62],Ie([1,0,74,2,35,161]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class _{constructor(h,C,R){this._tokenBrand=void 0,this.offset=h,this.type=C,this.language=R}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=_;class k{constructor(h,C){this._tokenizationResultBrand=void 0,this.tokens=h,this.endState=C}}e.TokenizationResult=k;class w{constructor(h,C){this._encodedTokenizationResultBrand=void 0,this.tokens=h,this.endState=C}}e.EncodedTokenizationResult=w;var I;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(I=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(u){const h=new Map;h.set(0,l.Codicon.symbolMethod),h.set(1,l.Codicon.symbolFunction),h.set(2,l.Codicon.symbolConstructor),h.set(3,l.Codicon.symbolField),h.set(4,l.Codicon.symbolVariable),h.set(5,l.Codicon.symbolClass),h.set(6,l.Codicon.symbolStruct),h.set(7,l.Codicon.symbolInterface),h.set(8,l.Codicon.symbolModule),h.set(9,l.Codicon.symbolProperty),h.set(10,l.Codicon.symbolEvent),h.set(11,l.Codicon.symbolOperator),h.set(12,l.Codicon.symbolUnit),h.set(13,l.Codicon.symbolValue),h.set(15,l.Codicon.symbolEnum),h.set(14,l.Codicon.symbolConstant),h.set(15,l.Codicon.symbolEnum),h.set(16,l.Codicon.symbolEnumMember),h.set(17,l.Codicon.symbolKeyword),h.set(27,l.Codicon.symbolSnippet),h.set(18,l.Codicon.symbolText),h.set(19,l.Codicon.symbolColor),h.set(20,l.Codicon.symbolFile),h.set(21,l.Codicon.symbolReference),h.set(22,l.Codicon.symbolCustomColor),h.set(23,l.Codicon.symbolFolder),h.set(24,l.Codicon.symbolTypeParameter),h.set(25,l.Codicon.account),h.set(26,l.Codicon.issues);function C(M){let A=h.get(M);return A||(console.info("No codicon found for CompletionItemKind "+M),A=l.Codicon.symbolProperty),A}u.toIcon=C;const R=new Map;R.set("method",0),R.set("function",1),R.set("constructor",2),R.set("field",3),R.set("variable",4),R.set("class",5),R.set("struct",6),R.set("interface",7),R.set("module",8),R.set("property",9),R.set("event",10),R.set("operator",11),R.set("unit",12),R.set("value",13),R.set("constant",14),R.set("enum",15),R.set("enum-member",16),R.set("enumMember",16),R.set("keyword",17),R.set("snippet",27),R.set("text",18),R.set("color",19),R.set("file",20),R.set("reference",21),R.set("customcolor",22),R.set("folder",23),R.set("type-parameter",24),R.set("typeParameter",24),R.set("account",25),R.set("issue",26);function N(M,A){let z=R.get(M);return typeof z>"u"&&!A&&(z=9),z}u.fromString=N})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var y;(function(u){u[u.Deprecated=1]="Deprecated"})(y=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var p;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(p=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var b;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(b=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(u){return u&&t.URI.isUri(u.uri)&&D.Range.isIRange(u.range)&&(D.Range.isIRange(u.originSelectionRange)||D.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=v;var g;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(g=e.SymbolKind||(e.SymbolKind={}));var c;(function(u){u[u.Deprecated=1]="Deprecated"})(c=e.SymbolTag||(e.SymbolTag={}));var m;(function(u){const h=new Map;h.set(0,l.Codicon.symbolFile),h.set(1,l.Codicon.symbolModule),h.set(2,l.Codicon.symbolNamespace),h.set(3,l.Codicon.symbolPackage),h.set(4,l.Codicon.symbolClass),h.set(5,l.Codicon.symbolMethod),h.set(6,l.Codicon.symbolProperty),h.set(7,l.Codicon.symbolField),h.set(8,l.Codicon.symbolConstructor),h.set(9,l.Codicon.symbolEnum),h.set(10,l.Codicon.symbolInterface),h.set(11,l.Codicon.symbolFunction),h.set(12,l.Codicon.symbolVariable),h.set(13,l.Codicon.symbolConstant),h.set(14,l.Codicon.symbolString),h.set(15,l.Codicon.symbolNumber),h.set(16,l.Codicon.symbolBoolean),h.set(17,l.Codicon.symbolArray),h.set(18,l.Codicon.symbolObject),h.set(19,l.Codicon.symbolKey),h.set(20,l.Codicon.symbolNull),h.set(21,l.Codicon.symbolEnumMember),h.set(22,l.Codicon.symbolStruct),h.set(23,l.Codicon.symbolEvent),h.set(24,l.Codicon.symbolOperator),h.set(25,l.Codicon.symbolTypeParameter);function C(R){let N=h.get(R);return N||(console.info("No codicon found for SymbolKind "+R),N=l.Codicon.symbolProperty),N}u.toIcon=C})(m=e.SymbolKinds||(e.SymbolKinds={}));class n{constructor(h){this.value=h}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var d;(function(u){function h(C){return!C||typeof C!="object"?!1:typeof C.id=="string"&&typeof C.title=="string"}u.is=h})(d=e.Command||(e.Command={}));var s;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var i;(function(u){u[u.Unresolved=0]="Unresolved",u[u.Resolved=1]="Resolved"})(i=e.CommentThreadState||(e.CommentThreadState={}));var r;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(r=e.CommentMode||(e.CommentMode={}));var a;(function(u){u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(a=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var o;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(o=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(De[162],Ie([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(De[116],Ie([1,0,162,11,100,17,24,147]),function(J,e,l,t,D,P,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var w;(function(re){re[re.None=0]="None",re[re.Keep=1]="Keep",re[re.Brackets=2]="Brackets",re[re.Advanced=3]="Advanced",re[re.Full=4]="Full"})(w=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=I;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class y{constructor(se,Se,ue,Te){this.id=se,this.name=Se,this.defaultValue=ue,this.schema=Te}applyUpdate(se,Se){return T(se,Se)}compute(se,Se,ue){return ue}}class S{constructor(se,Se){this.newValue=se,this.didChange=Se}}e.ApplyUpdateResult=S;function T(re,se){if(typeof re!="object"||typeof se!="object"||!re||!se)return new S(se,re!==se);if(Array.isArray(re)||Array.isArray(se)){const ue=Array.isArray(re)&&Array.isArray(se)&&P.equals(re,se);return new S(se,!ue)}let Se=!1;for(const ue in se)if(se.hasOwnProperty(ue)){const Te=T(re[ue],se[ue]);Te.didChange&&(re[ue]=Te.newValue,Se=!0)}return new S(re,Se)}class E{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Se){return T(se,Se)}validate(se){return this.defaultValue}}class p{constructor(se,Se,ue,Te){this.id=se,this.name=Se,this.defaultValue=ue,this.schema=Te}applyUpdate(se,Se){return T(se,Se)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Se,ue){return ue}}function b(re,se){return typeof re>"u"?se:re==="false"?!1:Boolean(re)}e.boolean=b;class f extends p{constructor(se,Se,ue,Te=void 0){typeof Te<"u"&&(Te.type="boolean",Te.default=ue),super(se,Se,ue,Te)}validate(se){return b(se,this.defaultValue)}}function v(re,se,Se,ue){if(typeof re>"u")return se;let Te=parseInt(re,10);return isNaN(Te)?se:(Te=Math.max(Se,Te),Te=Math.min(ue,Te),Te|0)}e.clampedInt=v;class g extends p{constructor(se,Se,ue,Te,Me,Be=void 0){typeof Be<"u"&&(Be.type="integer",Be.default=ue,Be.minimum=Te,Be.maximum=Me),super(se,Se,ue,Be),this.minimum=Te,this.maximum=Me}static clampedInt(se,Se,ue,Te){return v(se,Se,ue,Te)}validate(se){return g.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class c extends p{constructor(se,Se,ue,Te,Me){typeof Me<"u"&&(Me.type="number",Me.default=ue),super(se,Se,ue,Me),this.validationFn=Te}static clamp(se,Se,ue){return se<Se?Se:se>ue?ue:se}static float(se,Se){if(typeof se=="number")return se;if(typeof se>"u")return Se;const ue=parseFloat(se);return isNaN(ue)?Se:ue}validate(se){return this.validationFn(c.float(se,this.defaultValue))}}class m extends p{static string(se,Se){return typeof se!="string"?Se:se}constructor(se,Se,ue,Te=void 0){typeof Te<"u"&&(Te.type="string",Te.default=ue),super(se,Se,ue,Te)}validate(se){return m.string(se,this.defaultValue)}}function n(re,se,Se){return typeof re!="string"||Se.indexOf(re)===-1?se:re}e.stringSet=n;class d extends p{constructor(se,Se,ue,Te,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.enum=Te,Me.default=ue),super(se,Se,ue,Me),this._allowedValues=Te}validate(se){return n(se,this.defaultValue,this._allowedValues)}}class s extends y{constructor(se,Se,ue,Te,Me,Be,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.enum=Me,ze.default=Te),super(se,Se,ue,ze),this._allowedValues=Me,this._convert=Be}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function i(re){switch(re){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",description:l.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Se,ue){return ue===0?se.accessibilitySupport:ue}}class a extends y{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:l.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{insertSpace:b(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:b(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(re){re[re.Hidden=0]="Hidden",re[re.Blink=1]="Blink",re[re.Smooth=2]="Smooth",re[re.Phase=3]="Phase",re[re.Expand=4]="Expand",re[re.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(re){switch(re){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(re){re[re.Line=1]="Line",re[re.Block=2]="Block",re[re.Underline=3]="Underline",re[re.LineThin=4]="LineThin",re[re.BlockOutline=5]="BlockOutline",re[re.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function C(re){switch(re){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=C;function R(re){switch(re){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class N extends E{constructor(){super(130)}compute(se,Se,ue){const Te=["monaco-editor"];return Se.get(34)&&Te.push(Se.get(34)),se.extraEditorClassName&&Te.push(se.extraEditorClassName),Se.get(67)==="default"?Te.push("mouse-default"):Se.get(67)==="copy"&&Te.push("mouse-copy"),Se.get(101)&&Te.push("showUnused"),Se.get(128)&&Te.push("showDeprecated"),Te.join(" ")}}class M extends f{constructor(){super(33,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(se,Se,ue){return ue&&se.emptySelectionClipboard}}class A extends y{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:l.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:l.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{cursorMoveOnType:b(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":n(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":n(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:b(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:b(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:b(Se.loop,this.defaultValue.loop)}}}class z extends y{constructor(){super(46,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?z.OFF:se==="true"?z.ON:se:Boolean(se)?z.ON:z.OFF}}e.EditorFontLigatures=z,z.OFF='"liga" off, "calt" off',z.ON='"liga" on, "calt" on';class H extends E{constructor(){super(45)}compute(se,Se,ue){return se.fontInfo}}class F extends p{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(22,null)})}validate(se){const Se=c.float(se,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(Se,6,100)}compute(se,Se,ue){return se.fontInfo.fontSize}}class G extends y{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.MINIMUM_VALUE,maximum:G.MAXIMUM_VALUE,errorMessage:l.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(g.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,G.MINIMUM_VALUE,G.MAXIMUM_VALUE))}}G.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],G.MINIMUM_VALUE=1,G.MAXIMUM_VALUE=1e3;class B extends y{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[l.localize(25,null),l.localize(26,null),l.localize(27,null)]},ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(29,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(30,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:l.localize(31,null),...Se},"editor.gotoLocation.multipleImplementations":{description:l.localize(32,null),...Se},"editor.gotoLocation.multipleReferences":{description:l.localize(33,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:ue,description:l.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:ue,description:l.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:ue,description:l.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:ue,description:l.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:ue,description:l.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{multiple:n(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??n(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??n(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??n(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??n(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??n(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class U extends y{constructor(){const se={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:l.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:l.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:l.localize(41,null)},"editor.hover.above":{type:"boolean",default:se.above,description:l.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:b(Se.enabled,this.defaultValue.enabled),delay:g.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:b(Se.sticky,this.defaultValue.sticky),above:b(Se.above,this.defaultValue.above)}}}var X;(function(re){re[re.None=0]="None",re[re.Text=1]="Text",re[re.Blocks=2]="Blocks"})(X=e.RenderMinimap||(e.RenderMinimap={}));class $ extends E{constructor(){super(133)}compute(se,Se,ue){return $.computeLayout(Se,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const Se=se.height/se.lineHeight,ue=se.scrollBeyondLastLine?Se-1:0,Te=(se.viewLineCount+ue)/(se.pixelRatio*se.height),Me=Math.floor(se.viewLineCount/Te);return{typicalViewportLineCount:Se,extraLinesBeyondLastLine:ue,desiredRatio:Te,minimapLineCount:Me}}static _computeMinimapLayout(se,Se){const ue=se.outerWidth,Te=se.outerHeight,Me=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Me*Te),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Te};const Be=Se.stableMinimapLayoutInput,ze=Be&&se.outerHeight===Be.outerHeight&&se.lineHeight===Be.lineHeight&&se.typicalHalfwidthCharacterWidth===Be.typicalHalfwidthCharacterWidth&&se.pixelRatio===Be.pixelRatio&&se.scrollBeyondLastLine===Be.scrollBeyondLastLine&&se.minimap.enabled===Be.minimap.enabled&&se.minimap.side===Be.minimap.side&&se.minimap.size===Be.minimap.size&&se.minimap.showSlider===Be.minimap.showSlider&&se.minimap.renderCharacters===Be.minimap.renderCharacters&&se.minimap.maxColumn===Be.minimap.maxColumn&&se.minimap.scale===Be.minimap.scale&&se.verticalScrollbarWidth===Be.verticalScrollbarWidth&&se.isViewportWrapping===Be.isViewportWrapping,Ye=se.lineHeight,nt=se.typicalHalfwidthCharacterWidth,ct=se.scrollBeyondLastLine,pt=se.minimap.renderCharacters;let Je=Me>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const st=se.minimap.maxColumn,Et=se.minimap.size,Lt=se.minimap.side,Dt=se.verticalScrollbarWidth,ft=se.viewLineCount,Pt=se.remainingWidth,Ut=se.isViewportWrapping,Wt=pt?2:3;let Xe=Math.floor(Me*Te);const Ft=Xe/Me;let At=!1,Nt=!1,gt=Wt*Je,Ae=Je/Me,Oe=1;if(Et==="fill"||Et==="fit"){const{typicalViewportLineCount:it,extraLinesBeyondLastLine:ut,desiredRatio:mt,minimapLineCount:It}=$.computeContainedMinimapLineCount({viewLineCount:ft,scrollBeyondLastLine:ct,height:Te,lineHeight:Ye,pixelRatio:Me});if(ft/It>1)At=!0,Nt=!0,Je=1,gt=1,Ae=Je/Me;else{let _t=!1,Rt=Je+1;if(Et==="fit"){const St=Math.ceil((ft+ut)*gt);Ut&&ze&&Pt<=Se.stableFitRemainingWidth?(_t=!0,Rt=Se.stableFitMaxMinimapScale):_t=St>Xe}if(Et==="fill"||_t){At=!0;const St=Je;gt=Math.min(Ye*Me,Math.max(1,Math.floor(1/mt))),Ut&&ze&&Pt<=Se.stableFitRemainingWidth&&(Rt=Se.stableFitMaxMinimapScale),Je=Math.min(Rt,Math.max(1,Math.floor(gt/Wt))),Je>St&&(Oe=Math.min(2,Je/St)),Ae=Je/Me/Oe,Xe=Math.ceil(Math.max(it,ft+ut)*gt),Ut?(Se.stableMinimapLayoutInput=se,Se.stableFitRemainingWidth=Pt,Se.stableFitMaxMinimapScale=Je):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const _e=Math.floor(st*Ae),ee=Math.min(_e,Math.max(0,Math.floor((Pt-Dt-2)*Ae/(nt+Ae)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(Me*ee);const Ve=Fe/Me;Fe=Math.floor(Fe*Oe);const ot=pt?1:2,Ge=Lt==="left"?0:ue-ee-Dt;return{renderMinimap:ot,minimapLeft:Ge,minimapWidth:ee,minimapHeightIsEditorHeight:At,minimapIsSampling:Nt,minimapScale:Je,minimapLineHeight:gt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:Ve,minimapCanvasOuterHeight:Ft}}static computeLayout(se,Se){const ue=Se.outerWidth|0,Te=Se.outerHeight|0,Me=Se.lineHeight|0,Be=Se.lineNumbersDigitCount|0,ze=Se.typicalHalfwidthCharacterWidth,Ye=Se.maxDigitWidth,nt=Se.pixelRatio,ct=Se.viewLineCount,pt=se.get(125),Je=pt==="inherit"?se.get(124):pt,st=Je==="inherit"?se.get(120):Je,Et=se.get(123),Lt=se.get(2),Dt=Se.isDominatedByLongLines,ft=se.get(51),Pt=se.get(61).renderType!==0,Ut=se.get(62),Wt=se.get(95),Xe=se.get(66),Ft=se.get(93),At=Ft.verticalScrollbarSize,Nt=Ft.verticalHasArrows,gt=Ft.arrowSize,Ae=Ft.horizontalScrollbarSize,Oe=se.get(59),_e=se.get(38),ee=se.get(100)!=="never";let Fe;if(typeof Oe=="string"&&/^\d+(\.\d+)?ch$/.test(Oe)){const bt=parseFloat(Oe.substr(0,Oe.length-2));Fe=g.clampedInt(bt*ze,0,0,1e3)}else Fe=g.clampedInt(Oe,0,0,1e3);_e&&ee&&(Fe+=16);let Ve=0;if(Pt){const bt=Math.max(Be,Ut);Ve=Math.round(bt*Ye)}let ot=0;ft&&(ot=Me);let Ge=0,it=Ge+ot,ut=it+Ve,mt=ut+Fe;const It=ue-ot-Ve-Fe;let wt=!1,_t=!1,Rt=-1;Lt!==2&&(Je==="inherit"&&Dt?(wt=!0,_t=!0):st==="on"||st==="bounded"?_t=!0:st==="wordWrapColumn"&&(Rt=Et));const St=$._computeMinimapLayout({outerWidth:ue,outerHeight:Te,lineHeight:Me,typicalHalfwidthCharacterWidth:ze,pixelRatio:nt,scrollBeyondLastLine:Wt,minimap:Xe,verticalScrollbarWidth:At,viewLineCount:ct,remainingWidth:It,isViewportWrapping:_t},Se.memory||new L);St.renderMinimap!==0&&St.minimapLeft===0&&(Ge+=St.minimapWidth,it+=St.minimapWidth,ut+=St.minimapWidth,mt+=St.minimapWidth);const kt=It-St.minimapWidth,Yt=Math.max(1,Math.floor((kt-At-2)/ze)),qt=Nt?gt:0;return _t&&(Rt=Math.max(1,Yt),st==="bounded"&&(Rt=Math.min(Rt,Et))),{width:ue,height:Te,glyphMarginLeft:Ge,glyphMarginWidth:ot,lineNumbersLeft:it,lineNumbersWidth:Ve,decorationsLeft:ut,decorationsWidth:Fe,contentLeft:mt,contentWidth:kt,minimap:St,viewportColumn:Yt,isWordWrapMinified:wt,isViewportWrapping:_t,wrappingColumn:Rt,verticalScrollbarWidth:At,horizontalScrollbarHeight:Ae,overviewRuler:{top:qt,width:At,height:Te-2*qt,right:0}}}}e.EditorLayoutInfoComputer=$;class x extends y{constructor(){const se={enabled:!0};super(58,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:l.localize(43,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:b(se.enabled,this.defaultValue.enabled)}}}class Q extends y{constructor(){const se={enabled:!1,maxLineCount:5};super(105,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:l.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:l.localize(45,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:b(Se.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(Se.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class de extends y{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:l.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(47,null),l.localize(48,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(49,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:l.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:l.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:l.localize(53,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return typeof Se.enabled=="boolean"&&(Se.enabled=Se.enabled?"on":"off"),{enabled:n(Se.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(Se.fontFamily,this.defaultValue.fontFamily),padding:b(Se.padding,this.defaultValue.padding)}}}class te extends c{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>c.clamp(se,0,150),{markdownDescription:l.localize(54,null)})}compute(se,Se,ue){return se.fontInfo.lineHeight}}class pe extends y{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:l.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:l.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(57,null),l.localize(58,null),l.localize(59,null)],default:se.size,description:l.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:l.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:l.localize(62,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:l.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:l.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:b(Se.enabled,this.defaultValue.enabled),autohide:b(Se.autohide,this.defaultValue.autohide),size:n(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(Se.side,this.defaultValue.side,["right","left"]),showSlider:n(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:b(Se.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(Se.scale,1,1,3),maxColumn:g.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(re){return re==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ve extends y{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(67,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{top:g.clampedInt(Se.top,0,0,1e3),bottom:g.clampedInt(Se.bottom,0,0,1e3)}}}class be extends y{constructor(){const se={enabled:!0,cycle:!1};super(77,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:l.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:l.localize(69,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:b(Se.enabled,this.defaultValue.enabled),cycle:b(Se.cycle,this.defaultValue.cycle)}}}class ke extends E{constructor(){super(131)}compute(se,Se,ue){return se.pixelRatio}}class Re extends y{constructor(){const se={other:"on",comments:"off",strings:"off"},Se=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(70,null),l.localize(71,null),l.localize(72,null)]}];super(80,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Se,default:se.strings,description:l.localize(73,null)},comments:{anyOf:Se,default:se.comments,description:l.localize(74,null)},other:{anyOf:Se,default:se.other,description:l.localize(75,null)}},default:se,markdownDescription:l.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const nt=se?"on":"off";return{comments:nt,strings:nt,other:nt}}if(!se||typeof se!="object")return this.defaultValue;const{other:Se,comments:ue,strings:Te}=se,Me=["on","inline","off"];let Be,ze,Ye;return typeof Se=="boolean"?Be=Se?"on":"off":Be=n(Se,this.defaultValue.other,Me),typeof ue=="boolean"?ze=ue?"on":"off":ze=n(ue,this.defaultValue.comments,Me),typeof Te=="boolean"?Ye=Te?"on":"off":Ye=n(Te,this.defaultValue.strings,Me),{other:Be,comments:ze,strings:Ye}}}var We;(function(re){re[re.Off=0]="Off",re[re.On=1]="On",re[re.Relative=2]="Relative",re[re.Interval=3]="Interval",re[re.Custom=4]="Custom"})(We=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends y{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(77,null),l.localize(78,null),l.localize(79,null),l.localize(80,null)],default:"on",description:l.localize(81,null)})}validate(se){let Se=this.defaultValue.renderType,ue=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Se=4,ue=se):se==="interval"?Se=3:se==="relative"?Se=2:se==="on"?Se=1:Se=0),{renderType:Se,renderFn:ue}}}function le(re){const se=re.get(88);return se==="editable"?re.get(82):se!=="on"}e.filterValidationDecorations=le;class fe extends y{constructor(){const se=[],Se={type:"number",description:l.localize(82,null)};super(92,"rulers",se,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:l.localize(83,null),format:"color-hex"}}}]},default:se,description:l.localize(84,null)})}validate(se){if(Array.isArray(se)){const Se=[];for(const ue of se)if(typeof ue=="number")Se.push({column:g.clampedInt(ue,0,0,1e4),color:null});else if(ue&&typeof ue=="object"){const Te=ue;Se.push({column:g.clampedInt(Te.column,0,0,1e4),color:Te.color})}return Se.sort((ue,Te)=>ue.column-Te.column),Se}return this.defaultValue}}function Z(re,se){if(typeof re!="string")return se;switch(re){case"hidden":return 2;case"visible":return 3;default:return 1}}class ae extends y{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(85,null),l.localize(86,null),l.localize(87,null)],default:"auto",description:l.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(89,null),l.localize(90,null),l.localize(91,null)],default:"auto",description:l.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:l.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:l.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:l.localize(95,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se,ue=g.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Te=g.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Z(Se.vertical,this.defaultValue.vertical),horizontal:Z(Se.horizontal,this.defaultValue.horizontal),useShadows:b(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:b(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:b(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:b(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:b(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ue,horizontalSliderSize:g.clampedInt(Se.horizontalSliderSize,ue,0,1e3),verticalScrollbarSize:Te,verticalSliderSize:g.clampedInt(Se.verticalSliderSize,Te,0,1e3),scrollByPage:b(Se.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ne extends y{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:l.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:l.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:l.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:l.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:l.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:l.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:l.localize(102,null)}})}applyUpdate(se,Se){let ue=!1;Se.allowedCharacters&&se&&(_.equals(se.allowedCharacters,Se.allowedCharacters)||(se={...se,allowedCharacters:Se.allowedCharacters},ue=!0)),Se.allowedLocales&&se&&(_.equals(se.allowedLocales,Se.allowedLocales)||(se={...se,allowedLocales:Se.allowedLocales},ue=!0));const Te=super.applyUpdate(se,Se);return ue?new S(Te.newValue,!0):Te}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{nonBasicASCII:q(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:b(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:b(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:q(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:q(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(se.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(se,Se){if(typeof se!="object"||!se)return Se;const ue={};for(const[Te,Me]of Object.entries(se))Me===!0&&(ue[Te]=!0);return ue}}class ie extends y{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:l.localize(103,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:b(Se.enabled,this.defaultValue.enabled),mode:n(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class O extends y{constructor(){const se={enabled:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:l.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:l.localize(105,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:b(Se.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:b(Se.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class V extends y{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(106,null),l.localize(107,null),l.localize(108,null)],default:se.bracketPairs,description:l.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(110,null),l.localize(111,null),l.localize(112,null)],default:se.bracketPairsHorizontal,description:l.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:l.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:l.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(116,null),l.localize(117,null),l.localize(118,null)],default:se.highlightActiveIndentation,description:l.localize(119,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{bracketPairs:q(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:q(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:b(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:b(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:q(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function q(re,se,Se){const ue=Se.indexOf(re);return ue===-1?se:Se[ue]}class K extends y{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(120,null),l.localize(121,null)],default:se.insertMode,description:l.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:l.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:l.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:l.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:l.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:l.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:l.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:l.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:l.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{insertMode:n(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:b(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:b(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:b(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:b(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:b(Se.showIcons,this.defaultValue.showIcons),showStatusBar:b(Se.showStatusBar,this.defaultValue.showStatusBar),preview:b(Se.preview,this.defaultValue.preview),previewMode:n(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:b(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:b(Se.showMethods,this.defaultValue.showMethods),showFunctions:b(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:b(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:b(Se.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:b(Se.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:b(Se.showFields,this.defaultValue.showFields),showVariables:b(Se.showVariables,this.defaultValue.showVariables),showClasses:b(Se.showClasses,this.defaultValue.showClasses),showStructs:b(Se.showStructs,this.defaultValue.showStructs),showInterfaces:b(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:b(Se.showModules,this.defaultValue.showModules),showProperties:b(Se.showProperties,this.defaultValue.showProperties),showEvents:b(Se.showEvents,this.defaultValue.showEvents),showOperators:b(Se.showOperators,this.defaultValue.showOperators),showUnits:b(Se.showUnits,this.defaultValue.showUnits),showValues:b(Se.showValues,this.defaultValue.showValues),showConstants:b(Se.showConstants,this.defaultValue.showConstants),showEnums:b(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:b(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:b(Se.showKeywords,this.defaultValue.showKeywords),showWords:b(Se.showWords,this.defaultValue.showWords),showColors:b(Se.showColors,this.defaultValue.showColors),showFiles:b(Se.showFiles,this.defaultValue.showFiles),showReferences:b(Se.showReferences,this.defaultValue.showReferences),showFolders:b(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:b(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:b(Se.showSnippets,this.defaultValue.showSnippets),showUsers:b(Se.showUsers,this.defaultValue.showUsers),showIssues:b(Se.showIssues,this.defaultValue.showIssues)}}}class me extends y{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(163,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:b(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class we extends E{constructor(){super(132)}compute(se,Se,ue){return Se.get(82)?!0:se.tabFocusMode}}var ce;(function(re){re[re.None=0]="None",re[re.Same=1]="Same",re[re.Indent=2]="Indent",re[re.DeepIndent=3]="DeepIndent"})(ce=e.WrappingIndent||(e.WrappingIndent={}));function Ce(re){switch(re){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ye extends E{constructor(){super(134)}compute(se,Se,ue){const Te=Se.get(133);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Te.isWordWrapMinified,isViewportWrapping:Te.isViewportWrapping,wrappingColumn:Te.wrappingColumn}}}class He extends y{constructor(){const se={enabled:!0};super(32,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:l.localize(164,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:b(se.enabled,this.defaultValue.enabled)}}}const je="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",Qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Ze:t.isLinux?Qe:je,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(re){return e.editorOptionsRegistry[re.id]=re,re}var rt;(function(re){re[re.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",re[re.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",re[re.accessibilitySupport=2]="accessibilitySupport",re[re.accessibilityPageSize=3]="accessibilityPageSize",re[re.ariaLabel=4]="ariaLabel",re[re.autoClosingBrackets=5]="autoClosingBrackets",re[re.autoClosingDelete=6]="autoClosingDelete",re[re.autoClosingOvertype=7]="autoClosingOvertype",re[re.autoClosingQuotes=8]="autoClosingQuotes",re[re.autoIndent=9]="autoIndent",re[re.automaticLayout=10]="automaticLayout",re[re.autoSurround=11]="autoSurround",re[re.bracketPairColorization=12]="bracketPairColorization",re[re.guides=13]="guides",re[re.codeLens=14]="codeLens",re[re.codeLensFontFamily=15]="codeLensFontFamily",re[re.codeLensFontSize=16]="codeLensFontSize",re[re.colorDecorators=17]="colorDecorators",re[re.columnSelection=18]="columnSelection",re[re.comments=19]="comments",re[re.contextmenu=20]="contextmenu",re[re.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",re[re.cursorBlinking=22]="cursorBlinking",re[re.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",re[re.cursorStyle=24]="cursorStyle",re[re.cursorSurroundingLines=25]="cursorSurroundingLines",re[re.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",re[re.cursorWidth=27]="cursorWidth",re[re.disableLayerHinting=28]="disableLayerHinting",re[re.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",re[re.domReadOnly=30]="domReadOnly",re[re.dragAndDrop=31]="dragAndDrop",re[re.dropIntoEditor=32]="dropIntoEditor",re[re.emptySelectionClipboard=33]="emptySelectionClipboard",re[re.extraEditorClassName=34]="extraEditorClassName",re[re.fastScrollSensitivity=35]="fastScrollSensitivity",re[re.find=36]="find",re[re.fixedOverflowWidgets=37]="fixedOverflowWidgets",re[re.folding=38]="folding",re[re.foldingStrategy=39]="foldingStrategy",re[re.foldingHighlight=40]="foldingHighlight",re[re.foldingImportsByDefault=41]="foldingImportsByDefault",re[re.foldingMaximumRegions=42]="foldingMaximumRegions",re[re.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",re[re.fontFamily=44]="fontFamily",re[re.fontInfo=45]="fontInfo",re[re.fontLigatures=46]="fontLigatures",re[re.fontSize=47]="fontSize",re[re.fontWeight=48]="fontWeight",re[re.formatOnPaste=49]="formatOnPaste",re[re.formatOnType=50]="formatOnType",re[re.glyphMargin=51]="glyphMargin",re[re.gotoLocation=52]="gotoLocation",re[re.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",re[re.hover=54]="hover",re[re.inDiffEditor=55]="inDiffEditor",re[re.inlineSuggest=56]="inlineSuggest",re[re.letterSpacing=57]="letterSpacing",re[re.lightbulb=58]="lightbulb",re[re.lineDecorationsWidth=59]="lineDecorationsWidth",re[re.lineHeight=60]="lineHeight",re[re.lineNumbers=61]="lineNumbers",re[re.lineNumbersMinChars=62]="lineNumbersMinChars",re[re.linkedEditing=63]="linkedEditing",re[re.links=64]="links",re[re.matchBrackets=65]="matchBrackets",re[re.minimap=66]="minimap",re[re.mouseStyle=67]="mouseStyle",re[re.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",re[re.mouseWheelZoom=69]="mouseWheelZoom",re[re.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",re[re.multiCursorModifier=71]="multiCursorModifier",re[re.multiCursorPaste=72]="multiCursorPaste",re[re.occurrencesHighlight=73]="occurrencesHighlight",re[re.overviewRulerBorder=74]="overviewRulerBorder",re[re.overviewRulerLanes=75]="overviewRulerLanes",re[re.padding=76]="padding",re[re.parameterHints=77]="parameterHints",re[re.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",re[re.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",re[re.quickSuggestions=80]="quickSuggestions",re[re.quickSuggestionsDelay=81]="quickSuggestionsDelay",re[re.readOnly=82]="readOnly",re[re.renameOnType=83]="renameOnType",re[re.renderControlCharacters=84]="renderControlCharacters",re[re.renderFinalNewline=85]="renderFinalNewline",re[re.renderLineHighlight=86]="renderLineHighlight",re[re.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",re[re.renderValidationDecorations=88]="renderValidationDecorations",re[re.renderWhitespace=89]="renderWhitespace",re[re.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",re[re.roundedSelection=91]="roundedSelection",re[re.rulers=92]="rulers",re[re.scrollbar=93]="scrollbar",re[re.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",re[re.scrollBeyondLastLine=95]="scrollBeyondLastLine",re[re.scrollPredominantAxis=96]="scrollPredominantAxis",re[re.selectionClipboard=97]="selectionClipboard",re[re.selectionHighlight=98]="selectionHighlight",re[re.selectOnLineNumbers=99]="selectOnLineNumbers",re[re.showFoldingControls=100]="showFoldingControls",re[re.showUnused=101]="showUnused",re[re.snippetSuggestions=102]="snippetSuggestions",re[re.smartSelect=103]="smartSelect",re[re.smoothScrolling=104]="smoothScrolling",re[re.stickyScroll=105]="stickyScroll",re[re.stickyTabStops=106]="stickyTabStops",re[re.stopRenderingLineAfter=107]="stopRenderingLineAfter",re[re.suggest=108]="suggest",re[re.suggestFontSize=109]="suggestFontSize",re[re.suggestLineHeight=110]="suggestLineHeight",re[re.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",re[re.suggestSelection=112]="suggestSelection",re[re.tabCompletion=113]="tabCompletion",re[re.tabIndex=114]="tabIndex",re[re.unicodeHighlighting=115]="unicodeHighlighting",re[re.unusualLineTerminators=116]="unusualLineTerminators",re[re.useShadowDOM=117]="useShadowDOM",re[re.useTabStops=118]="useTabStops",re[re.wordSeparators=119]="wordSeparators",re[re.wordWrap=120]="wordWrap",re[re.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",re[re.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",re[re.wordWrapColumn=123]="wordWrapColumn",re[re.wordWrapOverride1=124]="wordWrapOverride1",re[re.wordWrapOverride2=125]="wordWrapOverride2",re[re.wrappingIndent=126]="wrappingIndent",re[re.wrappingStrategy=127]="wrappingStrategy",re[re.showDeprecated=128]="showDeprecated",re[re.inlayHints=129]="inlayHints",re[re.editorClassName=130]="editorClassName",re[re.pixelRatio=131]="pixelRatio",re[re.tabFocusMode=132]="tabFocusMode",re[re.layoutInfo=133]="layoutInfo",re[re.wrappingInfo=134]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(165,null)})),acceptSuggestionOnEnter:Le(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(166,null),""],markdownDescription:l.localize(167,null)})),accessibilitySupport:Le(new r),accessibilityPageSize:Le(new g(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(168,null)})),ariaLabel:Le(new m(4,"ariaLabel",l.localize(169,null))),autoClosingBrackets:Le(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(170,null),l.localize(171,null),""],description:l.localize(172,null)})),autoClosingDelete:Le(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(173,null),""],description:l.localize(174,null)})),autoClosingOvertype:Le(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(175,null),""],description:l.localize(176,null)})),autoClosingQuotes:Le(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(177,null),l.localize(178,null),""],description:l.localize(179,null)})),autoIndent:Le(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[l.localize(180,null),l.localize(181,null),l.localize(182,null),l.localize(183,null),l.localize(184,null)],description:l.localize(185,null)})),automaticLayout:Le(new f(10,"automaticLayout",!1)),autoSurround:Le(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(186,null),l.localize(187,null),l.localize(188,null),""],description:l.localize(189,null)})),bracketPairColorization:Le(new O),bracketPairGuides:Le(new V),stickyTabStops:Le(new f(106,"stickyTabStops",!1,{description:l.localize(190,null)})),codeLens:Le(new f(14,"codeLens",!0,{description:l.localize(191,null)})),codeLensFontFamily:Le(new m(15,"codeLensFontFamily","",{description:l.localize(192,null)})),codeLensFontSize:Le(new g(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(193,null)})),colorDecorators:Le(new f(17,"colorDecorators",!0,{description:l.localize(194,null)})),columnSelection:Le(new f(18,"columnSelection",!1,{description:l.localize(195,null)})),comments:Le(new a),contextmenu:Le(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new f(21,"copyWithSyntaxHighlighting",!0,{description:l.localize(196,null)})),cursorBlinking:Le(new s(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:l.localize(197,null)})),cursorSmoothCaretAnimation:Le(new f(23,"cursorSmoothCaretAnimation",!1,{description:l.localize(198,null)})),cursorStyle:Le(new s(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:l.localize(199,null)})),cursorSurroundingLines:Le(new g(25,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(200,null)})),cursorSurroundingLinesStyle:Le(new d(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(201,null),l.localize(202,null)],description:l.localize(203,null)})),cursorWidth:Le(new g(27,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(204,null)})),disableLayerHinting:Le(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new f(30,"domReadOnly",!1)),dragAndDrop:Le(new f(31,"dragAndDrop",!0,{description:l.localize(205,null)})),emptySelectionClipboard:Le(new M),dropIntoEditor:Le(new He),stickyScroll:Le(new Q),extraEditorClassName:Le(new m(34,"extraEditorClassName","")),fastScrollSensitivity:Le(new c(35,"fastScrollSensitivity",5,re=>re<=0?5:re,{markdownDescription:l.localize(206,null)})),find:Le(new A),fixedOverflowWidgets:Le(new f(37,"fixedOverflowWidgets",!1)),folding:Le(new f(38,"folding",!0,{description:l.localize(207,null)})),foldingStrategy:Le(new d(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(208,null),l.localize(209,null)],description:l.localize(210,null)})),foldingHighlight:Le(new f(40,"foldingHighlight",!0,{description:l.localize(211,null)})),foldingImportsByDefault:Le(new f(41,"foldingImportsByDefault",!1,{description:l.localize(212,null)})),foldingMaximumRegions:Le(new g(42,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(213,null)})),unfoldOnClickAfterEndOfLine:Le(new f(43,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(214,null)})),fontFamily:Le(new m(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(215,null)})),fontInfo:Le(new H),fontLigatures2:Le(new z),fontSize:Le(new F),fontWeight:Le(new G),formatOnPaste:Le(new f(49,"formatOnPaste",!1,{description:l.localize(216,null)})),formatOnType:Le(new f(50,"formatOnType",!1,{description:l.localize(217,null)})),glyphMargin:Le(new f(51,"glyphMargin",!0,{description:l.localize(218,null)})),gotoLocation:Le(new B),hideCursorInOverviewRuler:Le(new f(53,"hideCursorInOverviewRuler",!1,{description:l.localize(219,null)})),hover:Le(new U),inDiffEditor:Le(new f(55,"inDiffEditor",!1)),letterSpacing:Le(new c(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,re=>c.clamp(re,-5,20),{description:l.localize(220,null)})),lightbulb:Le(new x),lineDecorationsWidth:Le(new p(59,"lineDecorationsWidth",10)),lineHeight:Le(new te),lineNumbers:Le(new oe),lineNumbersMinChars:Le(new g(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new f(63,"linkedEditing",!1,{description:l.localize(221,null)})),links:Le(new f(64,"links",!0,{description:l.localize(222,null)})),matchBrackets:Le(new d(65,"matchBrackets","always",["always","near","never"],{description:l.localize(223,null)})),minimap:Le(new pe),mouseStyle:Le(new d(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new c(68,"mouseWheelScrollSensitivity",1,re=>re===0?1:re,{markdownDescription:l.localize(224,null)})),mouseWheelZoom:Le(new f(69,"mouseWheelZoom",!1,{markdownDescription:l.localize(225,null)})),multiCursorMergeOverlapping:Le(new f(70,"multiCursorMergeOverlapping",!0,{description:l.localize(226,null)})),multiCursorModifier:Le(new s(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[l.localize(227,null),l.localize(228,null)],markdownDescription:l.localize(229,null)})),multiCursorPaste:Le(new d(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(230,null),l.localize(231,null)],markdownDescription:l.localize(232,null)})),occurrencesHighlight:Le(new f(73,"occurrencesHighlight",!0,{description:l.localize(233,null)})),overviewRulerBorder:Le(new f(74,"overviewRulerBorder",!0,{description:l.localize(234,null)})),overviewRulerLanes:Le(new g(75,"overviewRulerLanes",3,0,3)),padding:Le(new ve),parameterHints:Le(new be),peekWidgetDefaultFocus:Le(new d(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(235,null),l.localize(236,null)],description:l.localize(237,null)})),definitionLinkOpensInPeek:Le(new f(79,"definitionLinkOpensInPeek",!1,{description:l.localize(238,null)})),quickSuggestions:Le(new Re),quickSuggestionsDelay:Le(new g(81,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(239,null)})),readOnly:Le(new f(82,"readOnly",!1)),renameOnType:Le(new f(83,"renameOnType",!1,{description:l.localize(240,null),markdownDeprecationMessage:l.localize(241,null)})),renderControlCharacters:Le(new f(84,"renderControlCharacters",!0,{description:l.localize(242,null),restricted:!0})),renderFinalNewline:Le(new f(85,"renderFinalNewline",!0,{description:l.localize(243,null)})),renderLineHighlight:Le(new d(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(244,null)],description:l.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Le(new f(87,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(246,null)})),renderValidationDecorations:Le(new d(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new d(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(247,null),l.localize(248,null),l.localize(249,null),""],description:l.localize(250,null)})),revealHorizontalRightPadding:Le(new g(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new f(91,"roundedSelection",!0,{description:l.localize(251,null)})),rulers:Le(new fe),scrollbar:Le(new ae),scrollBeyondLastColumn:Le(new g(94,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(252,null)})),scrollBeyondLastLine:Le(new f(95,"scrollBeyondLastLine",!0,{description:l.localize(253,null)})),scrollPredominantAxis:Le(new f(96,"scrollPredominantAxis",!0,{description:l.localize(254,null)})),selectionClipboard:Le(new f(97,"selectionClipboard",!0,{description:l.localize(255,null),included:t.isLinux})),selectionHighlight:Le(new f(98,"selectionHighlight",!0,{description:l.localize(256,null)})),selectOnLineNumbers:Le(new f(99,"selectOnLineNumbers",!0)),showFoldingControls:Le(new d(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(257,null),l.localize(258,null),l.localize(259,null)],description:l.localize(260,null)})),showUnused:Le(new f(101,"showUnused",!0,{description:l.localize(261,null)})),showDeprecated:Le(new f(128,"showDeprecated",!0,{description:l.localize(262,null)})),inlayHints:Le(new de),snippetSuggestions:Le(new d(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(263,null),l.localize(264,null),l.localize(265,null),l.localize(266,null)],description:l.localize(267,null)})),smartSelect:Le(new me),smoothScrolling:Le(new f(104,"smoothScrolling",!1,{description:l.localize(268,null)})),stopRenderingLineAfter:Le(new g(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new K),inlineSuggest:Le(new ie),suggestFontSize:Le(new g(109,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new g(110,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new f(111,"suggestOnTriggerCharacters",!0,{description:l.localize(271,null)})),suggestSelection:Le(new d(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(272,null),l.localize(273,null),l.localize(274,null)],description:l.localize(275,null)})),tabCompletion:Le(new d(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(276,null),l.localize(277,null),l.localize(278,null)],description:l.localize(279,null)})),tabIndex:Le(new g(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new ne),unusualLineTerminators:Le(new d(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(280,null),l.localize(281,null),l.localize(282,null)],description:l.localize(283,null)})),useShadowDOM:Le(new f(117,"useShadowDOM",!0)),useTabStops:Le(new f(118,"useTabStops",!0,{description:l.localize(284,null)})),wordSeparators:Le(new m(119,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:l.localize(285,null)})),wordWrap:Le(new d(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(286,null),l.localize(287,null),l.localize(288,null),l.localize(289,null)],description:l.localize(290,null)})),wordWrapBreakAfterCharacters:Le(new m(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new m(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new g(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(291,null)})),wordWrapOverride1:Le(new d(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new d(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Le(new s(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ce,{enumDescriptions:[l.localize(292,null),l.localize(293,null),l.localize(294,null),l.localize(295,null)],description:l.localize(296,null)})),wrappingStrategy:Le(new d(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[l.localize(297,null),l.localize(298,null)],description:l.localize(299,null)})),editorClassName:Le(new N),pixelRatio:Le(new ke),tabFocusMode:Le(new we),layoutInfo:Le(new $),wrappingInfo:Le(new ye)}}),define(De[163],Ie([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[164],Ie([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[165],Ie([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[166],Ie([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[167],Ie([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(De[168],Ie([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(De[169],Ie([19,20]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(De[170],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[171],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[172],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(De[173],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[174],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[175],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[176],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[177],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[178],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[179],Ie([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(De[180],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[181],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[182],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[183],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[184],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[185],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[186],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[187],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[188],Ie([1,0,22,41,165,303]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function w(f){return f=f.trim(),f==="*"||_.test(f)}e.isValidVersionStr=w;function I(f){if(!w(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=f.match(_);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=I;function L(f){if(!f)return null;const v=f.majorBase,g=f.majorMustEqual,c=f.minorBase;let m=f.minorMustEqual;const n=f.patchBase;let d=f.patchMustEqual;f.hasCaret&&(v===0||(m=!1),d=!1);let s=0;if(f.preRelease){const i=k.exec(f.preRelease);if(i){const[,r,a,o]=i;s=Date.UTC(Number(r),Number(a)-1,Number(o))}}return{majorBase:v,majorMustEqual:g,minorBase:c,minorMustEqual:m,patchBase:n,patchMustEqual:d,isMinimum:f.hasGreaterEquals,notBefore:s}}e.normalizeVersion=L;function y(f,v,g){let c;typeof f=="string"?c=L(I(f)):c=f;let m;v instanceof Date?m=v.getTime():typeof v=="string"&&(m=new Date(v).getTime());let n;if(typeof g=="string"?n=L(I(g)):n=g,!c||!n)return!1;const d=c.majorBase,s=c.minorBase,i=c.patchBase;let r=n.majorBase,a=n.minorBase,o=n.patchBase;const u=n.notBefore;let h=n.majorMustEqual,C=n.minorMustEqual,R=n.patchMustEqual;return n.isMinimum?d>r?!0:d<r?!1:s>a?!0:s<a||m&&m<u?!1:i>=o:(d===1&&r===0&&(!h||!C||!R)&&(r=1,a=0,o=0,h=!0,C=!1,R=!1),d<r?!1:d>r?!h:s<a?!1:s>a?!C:i<o?!1:i>o?!R:!(m&&m<u))}e.isValidVersion=y;function S(f,v,g,c,m){const n=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return n.push([t.default.Error,D.localize(0,null)]),n;if(typeof c.name!="string")return n.push([t.default.Error,D.localize(1,null,"name")]),n;if(typeof c.version!="string")return n.push([t.default.Error,D.localize(2,null,"version")]),n;if(!c.engines)return n.push([t.default.Error,D.localize(3,null,"engines")]),n;if(typeof c.engines.vscode!="string")return n.push([t.default.Error,D.localize(4,null,"engines.vscode")]),n;if(typeof c.extensionDependencies<"u"&&!b(c.extensionDependencies))return n.push([t.default.Error,D.localize(5,null,"extensionDependencies")]),n;if(typeof c.activationEvents<"u"){if(!b(c.activationEvents))return n.push([t.default.Error,D.localize(6,null,"activationEvents")]),n;if(typeof c.main>"u"&&typeof c.browser>"u")return n.push([t.default.Error,D.localize(7,null,"activationEvents","main")]),n}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&n.push([t.default.Warning,D.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return n.push([t.default.Error,D.localize(9,null,"main")]),n;{const i=(0,l.joinPath)(g,c.main);(0,l.isEqualOrParent)(i,g)||n.push([t.default.Warning,D.localize(10,null,i.path,g.path)])}if(typeof c.activationEvents>"u")return n.push([t.default.Error,D.localize(11,null,"activationEvents","main")]),n}if(typeof c.browser<"u"){if(typeof c.browser!="string")return n.push([t.default.Error,D.localize(12,null,"browser")]),n;{const i=(0,l.joinPath)(g,c.browser);(0,l.isEqualOrParent)(i,g)||n.push([t.default.Warning,D.localize(13,null,i.path,g.path)])}if(typeof c.activationEvents>"u")return n.push([t.default.Error,D.localize(14,null,"activationEvents","browser")]),n}if(!P.valid(c.version))return n.push([t.default.Error,D.localize(15,null)]),n;const d=[];if(!T(f,v,c,m,d))for(const i of d)n.push([t.default.Error,i]);return n}e.validateExtensionManifest=S;function T(f,v,g,c,m){return c||typeof g.main>"u"&&typeof g.browser>"u"?!0:p(f,v,g.engines.vscode,m)}e.isValidExtensionVersion=T;function E(f,v,g){return f==="*"||p(v,g,f)}e.isEngineValid=E;function p(f,v,g,c=[]){const m=L(I(g));if(!m)return c.push(D.localize(16,null,g)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return c.push(D.localize(17,null,g)),!1}else if(!m.majorMustEqual)return c.push(D.localize(18,null,g)),!1;return y(f,v,m)?!0:(c.push(D.localize(19,null,f,g)),!1)}function b(f){if(!Array.isArray(f))return!1;for(let v=0,g=f.length;v<g;v++)if(typeof f[v]!="string")return!1;return!0}}),define(De[117],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class l{constructor(D,P=[],_=!1){this.ctor=D,this.staticArguments=P,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=l}),define(De[82],Ie([1,0,117]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var D;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function P(k,w,I){w instanceof l.SyncDescriptor||(w=new l.SyncDescriptor(w,[],Boolean(I))),t.push([k,w])}e.registerSingleton=P;function _(){return t}e.getSingletonServiceDescriptors=_}),define(De[189],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class l{constructor(P,_){this.key=P,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=l;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const _ of this._nodes.values())_.outgoing.size===0&&P.push(_);return P}insertEdge(P,_){const k=this.lookupOrInsertNode(P),w=this.lookupOrInsertNode(_);k.outgoing.set(w.key,w),w.incoming.set(k.key,k)}removeNode(P){const _=this._hashFn(P);this._nodes.delete(_);for(const k of this._nodes.values())k.outgoing.delete(_),k.incoming.delete(_)}lookupOrInsertNode(P){const _=this._hashFn(P);let k=this._nodes.get(_);return k||(k=new l(_,P),this._nodes.set(_,k)),k}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[_,k]of this._nodes)P.push(`${_}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,_]of this._nodes){const k=new Set([P]),w=this._findCycle(_,k);if(w)return w}}_findCycle(P,_){for(const[k,w]of P.outgoing){if(_.has(k))return[..._,k].join(" -> ");_.add(k);const I=this._findCycle(w,_);if(I)return I;_.delete(k)}}}e.Graph=t}),define(De[3],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var l;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function k(w){return w[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=k})(l=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function t(_,k,w){k[l.DI_TARGET]===k?k[l.DI_DEPENDENCIES].push({id:_,index:w}):(k[l.DI_DEPENDENCIES]=[{id:_,index:w}],k[l.DI_TARGET]=k)}function D(_){if(l.serviceIds.has(_))return l.serviceIds.get(_);const k=function(w,I,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,w,L)};return k.toString=()=>_,l.serviceIds.set(_,k),k}e.createDecorator=D;function P(_){return _}e.refineServiceDecorator=P}),define(De[83],Ie([1,0,16,2,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function P(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationOverrides=P;function _(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=_;var k;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function I(f,v){const g=Object.create(null);for(const c in f)L(g,c,f[c],v);return g}e.toValuesTree=I;function L(f,v,g,c){const m=v.split("."),n=m.pop();let d=f;for(let s=0;s<m.length;s++){const i=m[s];let r=d[i];switch(typeof r){case"undefined":r=d[i]=Object.create(null);break;case"object":break;default:c(`Ignoring ${v} as ${m.slice(0,s+1).join(".")} is ${JSON.stringify(r)}`);return}d=r}if(typeof d=="object"&&d!==null)try{d[n]=g}catch{c(`Ignoring ${v} as ${m.join(".")} is ${JSON.stringify(d)}`)}else c(`Ignoring ${v} as ${m.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=L;function y(f,v){const g=v.split(".");S(f,g)}e.removeFromValueTree=y;function S(f,v){const g=v.shift();if(v.length===0){delete f[g];return}if(Object.keys(f).indexOf(g)!==-1){const c=f[g];typeof c=="object"&&!Array.isArray(c)&&(S(c,v),Object.keys(c).length===0&&delete f[g])}}function T(f,v,g){function c(d,s){let i=d;for(const r of s){if(typeof i!="object"||i===null)return;i=i[r]}return i}const m=v.split("."),n=c(f,m);return typeof n>"u"?g:n}e.getConfigurationValue=T;function E(f,v,g){Object.keys(v).forEach(c=>{c!=="__proto__"&&(c in f?l.isObject(f[c])&&l.isObject(v[c])?E(f[c],v[c],g):g&&(f[c]=v[c]):f[c]=v[c])})}e.merge=E;function p(f,v,g){const c=f.inspect(v),m=f.inspect(g);return typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:typeof m.userValue<"u"||typeof m.workspaceValue<"u"||typeof m.workspaceFolderValue<"u"?m.value:c.defaultValue}e.getMigratedSettingValue=p;function b(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(De[52],Ie([1,0,11,8,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",l.isMacintosh),P.set("isLinux",l.isLinux),P.set("isWindows",l.isWindows),P.set("isWeb",l.isWeb),P.set("isMacNative",l.isMacintosh&&!l.isWeb),P.set("isEdge",l.isEdge),P.set("isFirefox",l.isFirefox),P.set("isChrome",l.isChrome),P.set("isSafari",l.isSafari);const _=Object.prototype.hasOwnProperty;var k;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return y.INSTANCE}static true(){return S.INSTANCE}static has(A){return T.create(A)}static equals(A,z){return E.create(A,z)}static notEquals(A,z){return f.create(A,z)}static regex(A,z){return s.create(A,z)}static in(A,z){return p.create(A,z)}static notIn(A,z){return b.create(A,z)}static not(A){return v.create(A)}static and(...A){return a.create(A,null)}static or(...A){return o.create(A,null,!0)}static greater(A,z){return c.create(A,z)}static greaterEquals(A,z){return m.create(A,z)}static smaller(A,z){return n.create(A,z)}static smallerEquals(A,z){return d.create(A,z)}static deserialize(A,z=!1){if(!!A)return this._deserializeOrExpression(A,z)}static _deserializeOrExpression(A,z){const H=A.split("||");return o.create(H.map(F=>this._deserializeAndExpression(F,z)),null,!0)}static _deserializeAndExpression(A,z){const H=A.split("&&");return a.create(H.map(F=>this._deserializeOne(F,z)),null)}static _deserializeOne(A,z){if(A=A.trim(),A.indexOf("!=")>=0){const H=A.split("!=");return f.create(H[0].trim(),this._deserializeValue(H[1],z))}if(A.indexOf("==")>=0){const H=A.split("==");return E.create(H[0].trim(),this._deserializeValue(H[1],z))}if(A.indexOf("=~")>=0){const H=A.split("=~");return s.create(H[0].trim(),this._deserializeRegexValue(H[1],z))}if(A.indexOf(" not in ")>=0){const H=A.split(" not in ");return b.create(H[0].trim(),H[1].trim())}if(A.indexOf(" in ")>=0){const H=A.split(" in ");return p.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const H=A.split(">=");return m.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const H=A.split(">");return c.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const H=A.split("<=");return d.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const H=A.split("<");return n.create(H[0].trim(),H[1].trim())}return/^\!\s*/.test(A)?v.create(A.substr(1).trim()):T.create(A)}static _deserializeValue(A,z){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;const H=/^'([^']*)'$/.exec(A);return H?H[1].trim():A}static _deserializeRegexValue(A,z){if((0,t.isFalsyOrWhitespace)(A)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const H=A.indexOf("/"),F=A.lastIndexOf("/");if(H===F||H<0){if(z)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}const G=A.slice(H+1,F),B=A[F+1]==="i"?"i":"";try{return new RegExp(G,B)}catch(U){if(z)throw new Error(`bad regexp-value '${A}', parse error: ${U}`);return console.warn(`bad regexp-value '${A}', parse error: ${U}`),null}}}e.ContextKeyExpr=w;function I(M,A){const z=M?M.substituteConstants():void 0,H=A?A.substituteConstants():void 0;return!z&&!H?!0:!z||!H?!1:z.equals(H)}e.expressionsAreEqualWithConstantSubstitution=I;function L(M,A){return M.cmp(A)}class y{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class S{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class T{constructor(A,z){this.key=A,this.negated=z,this.type=2}static create(A,z=null){const H=P.get(A);return typeof H=="boolean"?H?S.INSTANCE:y.INSTANCE:new T(A,z)}cmp(A){return A.type!==this.type?this.type-A.type:h(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?S.INSTANCE:y.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class E{constructor(A,z,H){this.key=A,this.value=z,this.negated=H,this.type=4}static create(A,z,H=null){if(typeof z=="boolean")return z?T.create(A,H):v.create(A,H);const F=P.get(A);return typeof F=="boolean"?z===(F?"true":"false")?S.INSTANCE:y.INSTANCE:new E(A,z,H)}cmp(A){return A.type!==this.type?this.type-A.type:C(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const z=A?"true":"false";return this.value===z?S.INSTANCE:y.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=E;class p{constructor(A,z){this.key=A,this.valueKey=z,this.type=10,this.negated=null}static create(A,z){return new p(A,z)}cmp(A){return A.type!==this.type?this.type-A.type:C(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const z=A.getValue(this.valueKey),H=A.getValue(this.key);return Array.isArray(z)?z.includes(H):typeof H=="string"&&typeof z=="object"&&z!==null?_.call(z,H):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=p;class b{constructor(A,z){this.key=A,this.valueKey=z,this.type=11,this._negated=p.create(A,z)}static create(A,z){return new b(A,z)}cmp(A){return A.type!==this.type?this.type-A.type:this._negated.cmp(A._negated)}equals(A){return A.type===this.type?this._negated.equals(A._negated):!1}substituteConstants(){return this}evaluate(A){return!this._negated.evaluate(A)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(A){return A.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=b;class f{constructor(A,z,H){this.key=A,this.value=z,this.negated=H,this.type=5}static create(A,z,H=null){if(typeof z=="boolean")return z?v.create(A,H):T.create(A,H);const F=P.get(A);return typeof F=="boolean"?z===(F?"true":"false")?y.INSTANCE:S.INSTANCE:new f(A,z,H)}cmp(A){return A.type!==this.type?this.type-A.type:C(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const z=A?"true":"false";return this.value===z?y.INSTANCE:S.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=f;class v{constructor(A,z){this.key=A,this.negated=z,this.type=3}static create(A,z=null){const H=P.get(A);return typeof H=="boolean"?H?y.INSTANCE:S.INSTANCE:new v(A,z)}cmp(A){return A.type!==this.type?this.type-A.type:h(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?y.INSTANCE:S.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function g(M,A){if(typeof M=="string"){const z=parseFloat(M);isNaN(z)||(M=z)}return typeof M=="string"||typeof M=="number"?A(M):y.INSTANCE}class c{constructor(A,z,H){this.key=A,this.value=z,this.negated=H,this.type=12}static create(A,z,H=null){return g(z,F=>new c(A,F,H))}cmp(A){return A.type!==this.type?this.type-A.type:C(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class m{constructor(A,z,H){this.key=A,this.value=z,this.negated=H,this.type=13}static create(A,z,H=null){return g(z,F=>new m(A,F,H))}cmp(A){return A.type!==this.type?this.type-A.type:C(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=m;class n{constructor(A,z,H){this.key=A,this.value=z,this.negated=H,this.type=14}static create(A,z,H=null){return g(z,F=>new n(A,F,H))}cmp(A){return A.type!==this.type?this.type-A.type:C(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class d{constructor(A,z,H){this.key=A,this.value=z,this.negated=H,this.type=15}static create(A,z,H=null){return g(z,F=>new d(A,F,H))}cmp(A){return A.type!==this.type?this.type-A.type:C(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=d;class s{constructor(A,z){this.key=A,this.regexp=z,this.type=7,this.negated=null}static create(A,z){return new s(A,z)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const z=this.regexp?this.regexp.source:"",H=A.regexp?A.regexp.source:"";return z<H?-1:z>H?1:0}equals(A){if(A.type===this.type){const z=this.regexp?this.regexp.source:"",H=A.regexp?A.regexp.source:"";return this.key===A.key&&z===H}return!1}substituteConstants(){return this}evaluate(A){const z=A.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class i{constructor(A){this._actual=A,this.type=8}static create(A){return new i(A)}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(A){return new i(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function r(M){let A=null;for(let z=0,H=M.length;z<H;z++){const F=M[z].substituteConstants();if(M[z]!==F&&A===null){A=[];for(let G=0;G<z;G++)A[G]=M[G]}A!==null&&(A[z]=F)}return A===null?M:A}class a{constructor(A,z){this.expr=A,this.negated=z,this.type=6}static create(A,z){return a._normalizeArr(A,z)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let z=0,H=this.expr.length;z<H;z++){const F=L(this.expr[z],A.expr[z]);if(F!==0)return F}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let z=0,H=this.expr.length;z<H;z++)if(!this.expr[z].equals(A.expr[z]))return!1;return!0}return!1}substituteConstants(){const A=r(this.expr);return A===this.expr?this:a.create(A,this.negated)}evaluate(A){for(let z=0,H=this.expr.length;z<H;z++)if(!this.expr[z].evaluate(A))return!1;return!0}static _normalizeArr(A,z){const H=[];let F=!1;for(const G of A)if(!!G){if(G.type===1){F=!0;continue}if(G.type===0)return y.INSTANCE;if(G.type===6){H.push(...G.expr);continue}H.push(G)}if(H.length===0&&F)return S.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(L);for(let G=1;G<H.length;G++)H[G-1].equals(H[G])&&(H.splice(G,1),G--);if(H.length===1)return H[0];for(;H.length>1;){const G=H[H.length-1];if(G.type!==9)break;H.pop();const B=H.pop(),U=H.length===0,X=o.create(G.expr.map($=>a.create([$,B],null)),null,U);X&&(H.push(X),H.sort(L))}return H.length===1?H[0]:new a(H,z)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const z of this.expr)A.push(...z.keys());return A}map(A){return new a(this.expr.map(z=>z.map(A)),null)}negate(){if(!this.negated){const A=[];for(const z of this.expr)A.push(z.negate());this.negated=o.create(A,this,!0)}return this.negated}}class o{constructor(A,z){this.expr=A,this.negated=z,this.type=9}static create(A,z,H){return o._normalizeArr(A,z,H)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let z=0,H=this.expr.length;z<H;z++){const F=L(this.expr[z],A.expr[z]);if(F!==0)return F}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let z=0,H=this.expr.length;z<H;z++)if(!this.expr[z].equals(A.expr[z]))return!1;return!0}return!1}substituteConstants(){const A=r(this.expr);return A===this.expr?this:o.create(A,this.negated,!1)}evaluate(A){for(let z=0,H=this.expr.length;z<H;z++)if(this.expr[z].evaluate(A))return!0;return!1}static _normalizeArr(A,z,H){let F=[],G=!1;if(A){for(let B=0,U=A.length;B<U;B++){const X=A[B];if(!!X){if(X.type===0){G=!0;continue}if(X.type===1)return S.INSTANCE;if(X.type===9){F=F.concat(X.expr);continue}F.push(X)}}if(F.length===0&&G)return y.INSTANCE;F.sort(L)}if(F.length!==0){if(F.length===1)return F[0];for(let B=1;B<F.length;B++)F[B-1].equals(F[B])&&(F.splice(B,1),B--);if(F.length===1)return F[0];if(H){for(let B=0;B<F.length;B++)for(let U=B+1;U<F.length;U++)R(F[B],F[U])&&(F.splice(U,1),U--);if(F.length===1)return F[0]}return new o(F,z)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const z of this.expr)A.push(...z.keys());return A}map(A){return new o(this.expr.map(z=>z.map(A)),null)}negate(){if(!this.negated){const A=[];for(const z of this.expr)A.push(z.negate());for(;A.length>1;){const z=A.shift(),H=A.shift(),F=[];for(const B of N(z))for(const U of N(H))F.push(a.create([B,U],null));const G=A.length===0;A.unshift(o.create(F,null,G))}this.negated=A[0]}return this.negated}}class u extends T{constructor(A,z,H){super(A,null),this._defaultValue=z,typeof H=="object"?u._info.push({...H,key:A}):H!==!0&&u._info.push({key:A,description:H,type:z!=null?typeof z:void 0})}static all(){return u._info.values()}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return E.create(this.key,A)}notEqualsTo(A){return f.create(this.key,A)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(M,A){return M<A?-1:M>A?1:0}function C(M,A,z,H){return M<z?-1:M>z?1:A<H?-1:A>H?1:0}function R(M,A){if(A.type===6&&M.type!==9&&M.type!==6){for(const F of A.expr)if(M.equals(F))return!0}const z=M.negate(),H=N(z).concat(N(A));H.sort(L);for(let F=0;F<H.length;F++){const B=H[F].negate();for(let U=F+1;U<H.length;U++){const X=H[U];if(B.equals(X))return!0}}return!1}e.implies=R;function N(M){return M.type===9?M.expr:[M]}}),define(De[190],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,l.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,l.refineServiceDecorator)(e.IEnvironmentService)}),define(De[84],Ie([1,0,164,3]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function P(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function _(f,v){switch(f){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function k(f,v){return v==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function w(f,v,g){return k(v,g)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===g?!0:I(g).includes(f)}e.isTargetPlatformCompatible=w;function I(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function L(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=L;var y;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var S;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var T;(function(f){f.Install="install",f.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var E;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var p;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(v,g){super(v),this.code=g,this.name=g}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,l.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,l.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(De[191],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,l.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,l.createDecorator)("externalTerminal")}),define(De[192],Ie([1,0,44,12,9,11,103,29,111,166,191]),function(J,e,l,t,D,P,_,k,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=I.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends S{openTerminal(c,m){return this.spawnTerminal(l,c,w.getWindowsShell(),m)}spawnTerminal(c,m,n,d){const s=m.windowsExec||T.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const i=D.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return c.spawn(s,d?[d]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((a,o)=>{const u=b(process),h=c.spawn(n,r,{cwd:d,env:u});h.on("error",o),h.on("exit",()=>a())})}runInTerminal(c,m,n,d,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:T.getDefaultTerminalWindows();return new Promise((r,a)=>{const o=`"${m} - ${y}"`,u=`""${n.join('" "')}" & pause"`,h=["/c","start",o,"/wait",i,"/c",u],C=Object.assign({},b(process),d);Object.keys(C).filter(M=>C[M]===null).forEach(M=>delete C[M]);const R={cwd:m,env:C,windowsVerbatimArguments:!0};l.spawn(T.CMD,h,R).on("error",M=>{a(f(M))}),r(void 0)})}static getDefaultTerminalWindows(){if(!T._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return T._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=T,T.CMD="cmd.exe";class E extends S{openTerminal(c,m){return this.spawnTerminal(l,c,m)}runInTerminal(c,m,n,d,s){const i=s.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{if(i===L.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const o=i===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`,J).fsPath,"-t",c||y,"-w",m];for(const N of n)h.push("-a"),h.push(N);if(d){const N=Object.assign({},b(process),d);for(const M in N){const A=N[M];A===null?(h.push("-u"),h.push(M)):(h.push("-e"),h.push(`${M}=${A}`))}}let C="";const R=l.spawn(E.OSASCRIPT,h);R.on("error",N=>{a(f(N))}),R.stderr.on("data",N=>{C+=N.toString()}),R.on("exit",N=>{if(N===0)r(void 0);else if(C){const M=C.split(`
`,1);a(new Error(M[0]))}else a(new Error(I.localize(1,null,o,N)))})}else a(new Error(I.localize(2,null,i)))})}spawnTerminal(c,m,n){const d=m.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const r=["-a",d];n&&r.push(n);const a=b(process),o=c.spawn("/usr/bin/open",r,{cwd:n,env:a});o.on("error",i),o.on("exit",()=>s())})}}e.MacExternalTerminalService=E,E.OSASCRIPT="/usr/bin/osascript";class p extends S{openTerminal(c,m){return this.spawnTerminal(l,c,m)}runInTerminal(c,m,n,d,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{const o=[];i.then(u=>{u.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const h=`${v(n)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;o.push(`''${h}''`);const C=Object.assign({},b(process),d);Object.keys(C).filter(A=>C[A]===null).forEach(A=>delete C[A]);const R={cwd:m,env:C};let N="";const M=l.spawn(u,o,R);M.on("error",A=>{a(f(A))}),M.stderr.on("data",A=>{N+=A.toString()}),M.on("exit",A=>{if(A===0)r(void 0);else if(N){const z=N.split(`
`,1);a(new Error(z[0]))}else a(new Error(I.localize(4,null,u,A)))})})})}static async getDefaultTerminalLinuxReady(){if(!p._DEFAULT_TERMINAL_LINUX_READY)if(!P.isLinux)p._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const c=await k.Promises.exists("/etc/debian_version");p._DEFAULT_TERMINAL_LINUX_READY=new Promise(m=>{c?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(c,m,n){const d=m.linuxExec?Promise.resolve(m.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{d.then(r=>{const a=b(process),o=c.spawn(r,[],{cwd:n,env:a});o.on("error",i),o.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=p,p.WAIT_MESSAGE=I.localize(3,null);function b(g){const c={...g.env};return(0,_.sanitizeProcessEnvironment)(c),c}function f(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(I.localize(5,null,g.path)):g}function v(g){let c="";for(const m of g)m.indexOf(" ")>=0?c+='"'+m+'"':c+=m,c+=" ";return c}}),define(De[42],Ie([1,0,25,9,8,16,2,167,3]),function(J,e,l,t,D,P,_,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function I(B){return B.create===!0}e.isFileOpenForWriteOptions=I;var L;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var y;(function(B){B[B.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var S;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function T(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=T;function E(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=E;function p(B){return!!(B.capabilities&32768)}e.hasFileCloneCapability=p;function b(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function f(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=f;function v(B){return T(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var g;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(U,X){super(U),this.code=X}}e.FileSystemProviderError=c;function m(B,U){const X=new c(B.toString(),U);return d(X,U),X}e.createFileSystemProviderError=m;function n(B){return B||m((0,k.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=n;function d(B,U){return B.name=U?`${U} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=d;function s(B){if(!B)return g.Unknown;if(B instanceof c)return B.code;const U=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!U)return g.Unknown;switch(U[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=s;function i(B){if(B instanceof C)return B.fileOperationResult;switch(s(B)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var r;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class a{constructor(U,X,$){this.resource=U,this.operation=X,this.target=$}isOperation(U){return this.operation===U}}e.FileOperationEvent=a;var o;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class u{constructor(U,X){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=U;const $=new Map;for(const x of U){const Q=$.get(x.type);switch(Q?Q.push([x.resource,x]):$.set(x.type,[[x.resource,x]]),x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}}for(const[x,Q]of $)switch(x){case 1:this.added=l.TernarySearchTree.forUris(()=>X),this.added.fill(Q);break;case 0:this.updated=l.TernarySearchTree.forUris(()=>X),this.updated.fill(Q);break;case 2:this.deleted=l.TernarySearchTree.forUris(()=>X),this.deleted.fill(Q);break}}contains(U,...X){return this.doContains(U,{includeChildren:!1},...X)}affects(U,...X){return this.doContains(U,{includeChildren:!0},...X)}doContains(U,X,...$){if(!U)return!1;const x=$.length>0;return!!((!x||$.includes(1))&&(this.added?.get(U)||X.includeChildren&&this.added?.findSuperstr(U))||(!x||$.includes(0))&&(this.updated?.get(U)||X.includeChildren&&this.updated?.findSuperstr(U))||(!x||$.includes(2))&&(this.deleted?.findSubstr(U)||X.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=u;function h(B,U,X){return!B||!U||B===U||U.length>B.length?!1:(U.charAt(U.length-1)!==t.sep&&(U+=t.sep),X?(0,D.startsWithIgnoreCase)(B,U):B.indexOf(U)===0)}e.isParent=h;class C extends Error{constructor(U,X,$){super(U),this.fileOperationResult=X,this.options=$}}e.FileOperationError=C;class R extends C{constructor(U,X,$){super(U,2,$),this.stat=X}}e.NotModifiedSinceFileOperationError=R;var N;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(N=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var M;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(M=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function A(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=A;async function z(B,U){if(!U.hasProvider(_.URI.from({scheme:B.scheme})))return new Promise(X=>{const $=U.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===B.scheme&&x.added&&($.dispose(),X())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(U){return(0,P.isNumber)(U)||(U=0),U<H.KB?(0,k.localize)(1,null,U.toFixed(0)):U<H.MB?(0,k.localize)(2,null,(U/H.KB).toFixed(2)):U<H.GB?(0,k.localize)(3,null,(U/H.MB).toFixed(2)):U<H.TB?(0,k.localize)(4,null,(U/H.GB).toFixed(2)):(0,k.localize)(5,null,(U/H.TB).toFixed(2))}}e.ByteSize=H,H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB;var F;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function G(B){return{maxFileSize:B===0?300*H.MB:16*H.GB,maxHeapSize:B===0?700*H.MB:2*700*H.MB}}e.getPlatformLimits=G}),define(De[85],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class l{constructor(...D){this._entries=new Map;for(const[P,_]of D)this.set(P,_)}set(D,P){const _=this._entries.get(D);return this._entries.set(D,P),_}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=l}),define(De[193],Ie([1,0,18,10,117,189,3,85]),function(J,e,l,t,D,P,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class I extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class L{constructor(E=new k.ServiceCollection,p=!1,b,f=w){this._services=E,this._strict=p,this._parent=b,this._enableTracing=f,this._activeInstantiations=new Set,this._services.set(_.IInstantiationService,this),this._globalGraph=f?b?._globalGraph??new P.Graph(v=>v):void 0}createChild(E){return new L(E,this._strict,this,this._enableTracing)}invokeFunction(E,...p){const b=S.traceInvocation(this._enableTracing,E);let f=!1;try{return E({get:g=>{if(f)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(g,b);if(!c)throw new Error(`[invokeFunction] unknown service '${g}'`);return c}},...p)}finally{f=!0,b.stop()}}createInstance(E,...p){let b,f;return E instanceof D.SyncDescriptor?(b=S.traceCreation(this._enableTracing,E.ctor),f=this._createInstance(E.ctor,E.staticArguments.concat(p),b)):(b=S.traceCreation(this._enableTracing,E),f=this._createInstance(E,p,b)),b.stop(),f}_createInstance(E,p=[],b){const f=_._util.getServiceDependencies(E).sort((c,m)=>c.index-m.index),v=[];for(const c of f){const m=this._getOrCreateServiceInstance(c.id,b);m||this._throwIfStrict(`[createInstance] ${E.name} depends on UNKNOWN service ${c.id}.`,!1),v.push(m)}const g=f.length>0?f[0].index:p.length;if(p.length!==g){console.trace(`[createInstance] First service dependency of ${E.name} at position ${g+1} conflicts with ${p.length} static arguments`);const c=g-p.length;c>0?p=p.concat(new Array(c)):p=p.slice(0,g)}return new E(...p,...v)}_setServiceInstance(E,p){if(this._services.get(E)instanceof D.SyncDescriptor)this._services.set(E,p);else if(this._parent)this._parent._setServiceInstance(E,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(E){const p=this._services.get(E);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(E):p}_getOrCreateServiceInstance(E,p){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(E));const b=this._getServiceInstanceOrDescriptor(E);return b instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(E,b,p.branch(E,!0)):(p.branch(E,!1),b)}_safeCreateAndCacheServiceInstance(E,p,b){if(this._activeInstantiations.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this._activeInstantiations.add(E);try{return this._createAndCacheServiceInstance(E,p,b)}finally{this._activeInstantiations.delete(E)}}_createAndCacheServiceInstance(E,p,b){const f=new P.Graph(c=>c.id.toString());let v=0;const g=[{id:E,desc:p,_trace:b}];for(;g.length;){const c=g.pop();if(f.lookupOrInsertNode(c),v++>1e3)throw new I(f);for(const m of _._util.getServiceDependencies(c.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(m.id);if(n||this._throwIfStrict(`[createInstance] ${E} depends on ${m.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(c.id),String(m.id)),n instanceof D.SyncDescriptor){const d={id:m.id,desc:n,_trace:c._trace.branch(m.id,!0)};f.insertEdge(c,d),g.push(d)}}}for(;;){const c=f.roots();if(c.length===0){if(!f.isEmpty())throw new I(f);break}for(const{data:m}of c){if(this._getServiceInstanceOrDescriptor(m.id)instanceof D.SyncDescriptor){const d=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,d)}f.removeNode(m)}}return this._getServiceInstanceOrDescriptor(E)}_createServiceInstanceWithOwner(E,p,b=[],f,v){if(this._services.get(E)instanceof D.SyncDescriptor)return this._createServiceInstance(E,p,b,f,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(E,p,b,f,v);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(E,p,b=[],f,v){if(f){const g=new L(void 0,this._strict,this,this._enableTracing);g._globalGraphImplicitDependency=String(E);const c=new l.IdleValue(()=>g._createInstance(p,b,v));return new Proxy(Object.create(null),{get(m,n){if(n in m)return m[n];const d=c.value;let s=d[n];return typeof s!="function"||(s=s.bind(d),m[n]=s),s},set(m,n,d){return c.value[n]=d,!0}})}else return this._createInstance(p,b,v)}_throwIfStrict(E,p){if(p&&console.warn(E),this._strict)throw new Error(E)}}e.InstantiationService=L;var y;(function(T){T[T.Creation=0]="Creation",T[T.Invocation=1]="Invocation",T[T.Branch=2]="Branch"})(y||(y={}));class S{constructor(E,p){this.type=E,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(E,p){return E?new S(1,p.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S._None}static traceCreation(E,p){return E?new S(0,p.name):S._None}branch(E,p){const b=new S(2,E.toString());return this._dep.push([E,p,b]),b}stop(){const E=Date.now()-this._start;S._totals+=E;let p=!1;function b(v,g){const c=[],m=new Array(v+1).join("	");for(const[n,d,s]of g._dep)if(d&&s){p=!0,c.push(`${m}CREATES -> ${n}`);const i=b(v+1,s);i&&c.push(i)}else c.push(`${m}uses -> ${n}`);return c.join(`
`)}const f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(E>2||p)&&S.all.add(f.join(`
`))}}e.Trace=S,S.all=new Set,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(De[13],Ie([1,0,50,4,6,11,3]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function k(){return new Date().toISOString()}var w;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function I(d,s,i){switch(s){case w.Trace:d.trace(i);break;case w.Debug:d.debug(i);break;case w.Info:d.info(i);break;case w.Warning:d.warn(i);break;case w.Error:d.error(i);break;case w.Critical:d.critical(i);break;default:throw new Error("Invalid log level")}}e.log=I;function L(d){let s="";for(let i=0;i<d.length;i++){let r=d[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}s+=(i>0?" ":"")+r}return s}e.format=L;class y extends D.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class S extends y{constructor(s){super(),this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...i){this.checkLogLevel(w.Trace)&&this.log(w.Trace,L([s,...i]))}debug(s,...i){this.checkLogLevel(w.Debug)&&this.log(w.Debug,L([s,...i]))}info(s,...i){this.checkLogLevel(w.Info)&&this.log(w.Info,L([s,...i]))}warn(s,...i){this.checkLogLevel(w.Warning)&&this.log(w.Warning,L([s,...i]))}error(s,...i){if(this.checkLogLevel(w.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(w.Error,L(r))}else this.log(w.Error,L([s,...i]))}critical(s,...i){this.checkLogLevel(w.Critical)&&this.log(w.Critical,L([s,...i]))}flush(){}}e.AbstractMessageLogger=S;class T extends y{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.useColors=!P.isWindows}trace(s,...i){this.getLevel()<=w.Trace&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,s,...i):console.log(`[main ${k()}]`,s,...i))}debug(s,...i){this.getLevel()<=w.Debug&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,s,...i):console.log(`[main ${k()}]`,s,...i))}info(s,...i){this.getLevel()<=w.Info&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,s,...i):console.log(`[main ${k()}]`,s,...i))}warn(s,...i){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,s,...i):console.warn(`[main ${k()}]`,s,...i))}error(s,...i){this.getLevel()<=w.Error&&(this.useColors?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,s,...i):console.error(`[main ${k()}]`,s,...i))}critical(s,...i){this.getLevel()<=w.Critical&&(this.useColors?console.error(`\x1B[90m[main ${k()}]\x1B[0m`,s,...i):console.error(`[main ${k()}]`,s,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class E extends y{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...i){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",s,...i)}debug(s,...i){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...i)}info(s,...i){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",s,...i)}warn(s,...i){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",s,...i)}error(s,...i){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",s,...i)}critical(s,...i){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...i)}dispose(){}flush(){}}e.ConsoleLogger=E;class p extends y{constructor(s,i=e.DEFAULT_LOG_LEVEL){super(),this.adapter=s,this.setLevel(i)}trace(s,...i){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(s),...i])}debug(s,...i){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(s),...i])}info(s,...i){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(s),...i])}warn(s,...i){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(s),...i])}error(s,...i){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(s),...i])}critical(s,...i){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(s),...i])}extractMessage(s){return typeof s=="string"?s:(0,l.toErrorMessage)(s,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class b extends y{constructor(s){super(),this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const i of this.logServices)i.setLevel(s);super.setLevel(s)}trace(s,...i){for(const r of this.logServices)r.trace(s,...i)}debug(s,...i){for(const r of this.logServices)r.debug(s,...i)}info(s,...i){for(const r of this.logServices)r.info(s,...i)}warn(s,...i){for(const r of this.logServices)r.warn(s,...i)}error(s,...i){for(const r of this.logServices)r.error(s,...i)}critical(s,...i){for(const r of this.logServices)r.critical(s,...i)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=b;class f extends D.Disposable{constructor(s){super(),this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...i){this.logger.trace(s,...i)}debug(s,...i){this.logger.debug(s,...i)}info(s,...i){this.logger.info(s,...i)}warn(s,...i){this.logger.warn(s,...i)}error(s,...i){this.logger.error(s,...i)}critical(s,...i){this.logger.critical(s,...i)}flush(){this.logger.flush()}}e.LogService=f;class v extends D.Disposable{constructor(s,i){super(),this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(r))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,i){let r=this.loggers.get(s.toString());return r||(r=this.doCreateLogger(s,i?.always?w.Trace:this.logLevel,i),this.loggers.set(s.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class g{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(s){}getLevel(){return w.Info}trace(s,...i){}debug(s,...i){}info(s,...i){}warn(s,...i){}error(s,...i){}critical(s,...i){}dispose(){}flush(){}}e.NullLogService=g;function c(d){if(d.verbose)return w.Trace;if(typeof d.logLevel=="string"){const s=m(d.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function m(d){switch(d){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=m;function n(d){switch(d){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=n}),define(De[194],Ie([1,0,42,13]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(k,w,I,L,y){try{const S=await new Promise((E,p)=>{J(["spdlog"],E,p)});S.setFlushOn(t.LogLevel.Trace);const T=await S.createAsyncRotatingLogger(k,w,I,L);return y&&T.clearFormatters(),T}catch(S){console.error(S)}return null}function P(k,w,I){switch(w){case t.LogLevel.Trace:k.trace(I);break;case t.LogLevel.Debug:k.debug(I);break;case t.LogLevel.Info:k.info(I);break;case t.LogLevel.Warning:k.warn(I);break;case t.LogLevel.Error:k.error(I);break;case t.LogLevel.Critical:k.critical(I);break;default:throw new Error("Invalid log level")}}class _ extends t.AbstractMessageLogger{constructor(w,I,L,y,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(w,I,L,y),this._register(this.onDidChangeLogLevel(T=>{this._logger?.setLevel(T)}))}async _createSpdLogLogger(w,I,L,y){const S=L?6:1,T=30/S*l.ByteSize.MB,E=await D(w,I,T,S,y);if(E){this._logger=E,this._logger.setLevel(this.getLevel());for(const{level:p,message:b}of this.buffer)P(this._logger,p,b);this.buffer=[]}}log(w,I){this._logger?P(this._logger,w,I):this.getLevel()<=w&&this.buffer.push({level:w,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=_}),define(De[118],Ie([1,0,41,168,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var _;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(w){function I(E,p){return p-E}w.compare=I;const L=Object.create(null);L[w.Error]=(0,t.localize)(0,null),L[w.Warning]=(0,t.localize)(1,null),L[w.Info]=(0,t.localize)(2,null);function y(E){return L[E]||""}w.toString=y;function S(E){switch(E){case l.default.Error:return w.Error;case l.default.Warning:return w.Warning;case l.default.Info:return w.Info;case l.default.Ignore:return w.Hint}}w.fromSeverity=S;function T(E){switch(E){case w.Error:return l.default.Error;case w.Warning:return l.default.Warning;case w.Info:return l.default.Info;case w.Hint:return l.default.Ignore}}w.toSeverity=T}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(w){const I="";function L(S){return y(S,!0)}w.makeKey=L;function y(S,T){const E=[I];return S.source?E.push(S.source.replace("\xA6","\\\xA6")):E.push(I),S.code?typeof S.code=="string"?E.push(S.code.replace("\xA6","\\\xA6")):E.push(S.code.value.replace("\xA6","\\\xA6")):E.push(I),S.severity!==void 0&&S.severity!==null?E.push(_.toString(S.severity)):E.push(I),S.message&&T?E.push(S.message.replace("\xA6","\\\xA6")):E.push(I),S.startLineNumber!==void 0&&S.startLineNumber!==null?E.push(S.startLineNumber.toString()):E.push(I),S.startColumn!==void 0&&S.startColumn!==null?E.push(S.startColumn.toString()):E.push(I),S.endLineNumber!==void 0&&S.endLineNumber!==null?E.push(S.endLineNumber.toString()):E.push(I),S.endColumn!==void 0&&S.endColumn!==null?E.push(S.endColumn.toString()):E.push(I),E.push(I),E.join("\xA6")}w.makeKeyOptionalMessage=y})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(De[195],Ie([1,0,4,41,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,D.createDecorator)("notificationService");var P;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new w,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=k;class w{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=w}),define(De[119],Ie([1,0,6,8,2,3]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return l.Disposable.None},registerValidator(){return l.Disposable.None},registerExternalUriResolver(){return l.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return l.Disposable.None},async open(){return!1},async resolveExternalUri(L){return{resolved:L,dispose(){}}}});function _(L,y){return D.URI.isUri(L)?(0,t.equalsIgnoreCase)(L.scheme,y):(0,t.startsWithIgnoreCase)(L,y+":")}e.matchesScheme=_;function k(L,...y){return y.some(S=>_(L,S))}e.matchesSomeScheme=k;function w(L,y){return L.with({fragment:`${y.startLineNumber},${y.startColumn}${y.endLineNumber?`-${y.endLineNumber}${y.endColumn?`,${y.endColumn}`:""}`:""}`})}e.withSelection=w;function I(L){let y;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(L.fragment);return S&&(y={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},L=L.with({fragment:""})),{selection:y,uri:L}}e.extractSelection=I}),define(De[196],Ie([1,0,12,11,40,22]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let _;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const k=t.globals.vscode.context.configuration();if(k)_=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const k=(0,P.dirname)(l.FileAccess.asFileUri("",J));_=J.__$__nodeRequire((0,P.joinPath)(k,"product.json").fsPath);const w=J.__$__nodeRequire((0,P.joinPath)(k,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(_,{nameShort:`${_.nameShort} Dev`,nameLong:`${_.nameLong} Dev`,dataFolderName:`${_.dataFolderName}-dev`,serverDataFolderName:_.serverDataFolderName?`${_.serverDataFolderName}-dev`:void 0}),Object.assign(_,{version:w.version})}else _={},Object.keys(_).length===0&&Object.assign(_,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=_}),define(De[197],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,l.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var xe=this&&this.__param||function(J,e){return function(l,t){e(l,t,J)}};define(De[120],Ie([1,0,18,21,6,3]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var _;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let w=class extends D.Disposable{constructor(y,S){super(),this.deferred=new l.DeferredPromise,S.withProgress(y,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};w=qe([xe(1,e.IProgressService)],w),e.UnmanagedProgress=w;class I extends D.Disposable{constructor(y){super(),this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(y){this.stop();const S=++this.currentOperationId,T=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{S===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:S,token:T.token,stop:()=>this.doStop(S),isCurrent:()=>this.currentOperationId===S}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(De[43],Ie([1,0,48,16]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(_,k){l.ok(t.isString(_)),l.ok(t.isObject(k)),l.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,k)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new D}),define(De[121],Ie([1,0,4,43]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class P{constructor(){this._onDidChangeSchema=new l.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,I){this.schemasById[D(w)]=I,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new P;t.Registry.add(e.Extensions.JSONContribution,_)}),define(De[122],Ie([1,0,17,4,16,163,83,121,43]),function(J,e,l,t,D,P,_,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=w.Registry.as(k.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,d=!0){this.registerConfigurations([n],d)}registerConfigurations(n,d=!0){const s=this.doRegisterConfigurations(n,d);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(n){const d=this.doDeregisterConfigurations(n);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:n,remove:d}){const s=[];s.push(...this.doDeregisterConfigurations(d)),s.push(...this.doRegisterConfigurations(n,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,l.distinct)(s)})}registerDefaultConfigurations(n){const d=[],s=[];for(const{overrides:i,source:r}of n)for(const a in i)if(d.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const o=this.configurationDefaultsOverrides.get(a),u=o?.valuesSources??new Map;if(r)for(const N of Object.keys(i[a]))u.set(N,r);const h={...o?.value||{},...i[a]};this.configurationDefaultsOverrides.set(a,{source:r,value:h,valuesSources:u});const C=(0,_.getLanguageTagSettingPlainKey)(a),R={type:"object",default:h,description:P.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:D.isString(r)?void 0:r,defaultValueSource:r};s.push(...p(a)),this.configurationProperties[a]=R,this.defaultLanguageConfigurationOverridesNode.properties[a]=R}else{this.configurationDefaultsOverrides.set(a,{value:i[a],source:r});const o=this.configurationProperties[a];o&&(this.updatePropertyDefaultValue(a,o),this.updateSchema(a,o))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const d=[];for(const{overrides:s,source:i}of n)for(const r in s){const a=this.configurationDefaultsOverrides.get(r),o=D.isString(i)?i:i?.id,u=D.isString(a?.source)?a?.source:a?.source?.id;if(o===u)if(d.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const h=this.configurationProperties[r];h&&(this.updatePropertyDefaultValue(r,h),this.updateSchema(r,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const d of n)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,d){const s=[];return n.forEach(i=>{s.push(...this.validateAndRegisterProperties(i,d,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),s}doDeregisterConfigurations(n){const d=[],s=i=>{if(i.properties)for(const r in i.properties){d.push(r);const a=this.configurationProperties[r];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>s(r))};for(const i of n){s(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}return d}validateAndRegisterProperties(n,d=!0,s,i,r=3){r=D.isUndefinedOrNull(n.scope)?r:n.scope;const a=[],o=n.properties;if(o)for(const h in o){const C=o[h];if(d&&g(h,C)){delete o[h];continue}if(C.source=s,C.defaultDefaultValue=o[h].default,this.updatePropertyDefaultValue(h,C),e.OVERRIDE_PROPERTY_REGEX.test(h)?C.scope=void 0:(C.scope=D.isUndefinedOrNull(C.scope)?r:C.scope,C.restricted=D.isUndefinedOrNull(C.restricted)?!!i?.includes(h):C.restricted),o[h].hasOwnProperty("included")&&!o[h].included){this.excludedConfigurationProperties[h]=o[h],delete o[h];continue}else this.configurationProperties[h]=o[h],o[h].policy?.name&&this.policyConfigurations.set(o[h].policy.name,h);!o[h].deprecationMessage&&o[h].markdownDeprecationMessage&&(o[h].deprecationMessage=o[h].markdownDeprecationMessage),a.push(h)}const u=n.allOf;if(u)for(const h of u)a.push(...this.validateAndRegisterProperties(h,d,s,i,r));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const d=s=>{const i=s.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);s.allOf?.forEach(d)};d(n)}updateSchema(n,d){switch(e.allSettings.properties[n]=d,d.scope){case 1:e.applicationSettings.properties[n]=d;break;case 2:e.machineSettings.properties[n]=d;break;case 6:e.machineOverridableSettings.properties[n]=d;break;case 3:e.windowSettings.properties[n]=d;break;case 4:e.resourceSettings.properties[n]=d;break;case 5:e.resourceSettings.properties[n]=d,this.resourceLanguageSettingsSchema.properties[n]=d;break}}removeFromSchema(n,d){switch(delete e.allSettings.properties[n],d.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const d=`[${n}]`,s={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,s),e.allSettings.properties[d]=s,e.applicationSettings.properties[d]=s,e.machineSettings.properties[d]=s,e.machineOverridableSettings.properties[d]=s,e.windowSettings.properties[d]=s,e.resourceSettings.properties[d]=s}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,d){const s=this.configurationDefaultsOverrides.get(n);let i=s?.value,r=s?.source;D.isUndefined(i)&&(i=d.defaultDefaultValue,r=void 0),D.isUndefined(i)&&(i=f(d.type)),d.default=i,d.defaultValueSource=r}}const T="\\[([^\\]]+)\\]",E=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(m){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let d=E.exec(m);for(;d?.length;){const s=d[1].trim();s&&n.push(s),d=E.exec(m)}}return(0,l.distinct)(n)}e.overrideIdentifiersFromKey=p;function b(m){return m.reduce((n,d)=>`${n}[${d}]`,"")}e.keyFromOverrideIdentifiers=b;function f(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const v=new S;w.Registry.add(e.Extensions.Configuration,v);function g(m,n){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?P.localize(7,null,m):v.getConfigurationProperties()[m]!==void 0?P.localize(8,null,m):n.policy?.name&&v.getPolicyConfigurations().get(n.policy?.name)!==void 0?P.localize(9,null,m,n.policy?.name,v.getPolicyConfigurations().get(n.policy?.name)):null:P.localize(6,null)}e.validateProperty=g;function c(){const m=[],n=v.getConfigurationProperties();for(const d of Object.keys(n))m.push([d,n[d].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=c}),define(De[198],Ie([1,0,17,4,144,6,25,24,16,2,83,122,43]),function(J,e,l,t,D,P,_,k,w,I,L,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class T{constructor(n={},d=[],s=[]){this._contents=n,this._keys=d,this._overrides=s,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,L.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,d){const s=this.getContentsForOverrideIdentifer(d);return s?n?(0,L.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const d=[];for(const s of this.overrides)s.identifiers.includes(n)&&d.push(...s.keys);return l.distinct(d)}getAllOverrideIdentifiers(){const n=[];for(const d of this.overrides)n.push(...d.identifiers);return l.distinct(n)}override(n){let d=this.overrideConfigurations.get(n);return d||(d=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,d)),d}merge(...n){const d=k.deepClone(this.contents),s=k.deepClone(this.overrides),i=[...this.keys];for(const r of n)if(!r.isEmpty()){this.mergeContents(d,r.contents);for(const a of r.overrides){const[o]=s.filter(u=>l.equals(u.identifiers,a.identifiers));o?(this.mergeContents(o.contents,a.contents),o.keys.push(...a.keys),o.keys=l.distinct(o.keys)):s.push(k.deepClone(a))}for(const a of r.keys)i.indexOf(a)===-1&&i.push(a)}return new T(d,i,s)}freeze(){return this.frozen=!0,this}clone(){return new T(k.deepClone(this.contents),[...this.keys],k.deepClone(this.overrides))}createOverrideConfigurationModel(n){const d=this.getContentsForOverrideIdentifer(n);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const s={};for(const i of l.distinct([...Object.keys(this.contents),...Object.keys(d)])){let r=this.contents[i];const a=d[i];a&&(typeof r=="object"&&typeof a=="object"?(r=k.deepClone(r),this.mergeContents(r,a)):r=a),s[i]=r}return new T(s,this.keys,this.overrides)}mergeContents(n,d){for(const s of Object.keys(d)){if(s in n&&w.isObject(n[s])&&w.isObject(d[s])){this.mergeContents(n[s],d[s]);continue}n[s]=k.deepClone(d[s])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?k.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let d=null,s=null;const i=r=>{r&&(s?this.mergeContents(s,r):s=k.deepClone(r))};for(const r of this.overrides)l.equals(r.identifiers,[n])?d=r.contents:r.identifiers.includes(n)&&i(r.contents);return i(d),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,d){this.addKey(n),(0,L.addToValueTree)(this.contents,n,d,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,L.removeFromValueTree)(this.contents,n)}addKey(n){let d=this.keys.length;for(let s=0;s<d;s++)n.indexOf(this.keys[s])===0&&(d=s);this.keys.splice(d,1,n)}removeKey(n){const d=this.keys.indexOf(n);return d!==-1?(this.keys.splice(d,1),!0):!1}}e.ConfigurationModel=T;class E{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,d){if(!w.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,d)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,d){this._raw=n;const{contents:s,keys:i,overrides:r,restricted:a}=this.doParseRaw(n,d);this._configurationModel=new T(s,i,r),this._restrictedConfigurations=a||[]}doParseContent(n){let d={},s=null,i=[];const r=[],a=[];function o(h){Array.isArray(i)?i.push(h):s!==null&&(i[s]=h)}const u={onObjectBegin:()=>{const h={};o(h),r.push(i),i=h,s=null},onObjectProperty:h=>{s=h},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const h=[];o(h),r.push(i),i=h,s=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:o,onError:(h,C,R)=>{a.push({error:h,offset:C,length:R})}};if(n)try{D.visit(n,u),d=i[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return d}doParseRaw(n,d){const s=S.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),i=this.filter(n,s,!0,d);n=i.raw;const r=(0,L.toValuesTree)(n,u=>console.error(`Conflict in settings file ${this._name}: ${u}`)),a=Object.keys(n),o=this.toOverrides(n,u=>console.error(`Conflict in settings file ${this._name}: ${u}`));return{contents:r,keys:a,overrides:o,restricted:i.restricted}}filter(n,d,s,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:n,restricted:[]};const r={},a=[];for(const o in n)if(y.OVERRIDE_PROPERTY_REGEX.test(o)&&s){const u=this.filter(n[o],d,!1,i);r[o]=u.raw,a.push(...u.restricted)}else{const u=d[o],h=u?typeof u.scope<"u"?u.scope:3:void 0;u?.restricted&&a.push(o),(h===void 0||i.scopes===void 0||i.scopes.includes(h))&&(i.skipRestricted&&u?.restricted||(r[o]=n[o]))}return{raw:r,restricted:a}}toOverrides(n,d){const s=[];for(const i of Object.keys(n))if(y.OVERRIDE_PROPERTY_REGEX.test(i)){const r={};for(const a in n[i])r[a]=n[i][a];s.push({identifiers:(0,y.overrideIdentifiersFromKey)(i),keys:Object.keys(r),contents:(0,L.toValuesTree)(r,d)})}return s}}e.ConfigurationModelParser=E;class p extends P.Disposable{constructor(n,d,s,i){super(),this.userSettingsResource=n,this.scopes=d,this.fileService=i,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,r=>r.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&s.isEqual(r.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class b{constructor(n,d,s,i,r=new T,a=new T,o=new _.ResourceMap,u=new T,h=new _.ResourceMap,C=!0){this._defaultConfiguration=n,this._policyConfiguration=d,this._applicationConfiguration=s,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=a,this._folderConfigurations=o,this._memoryConfiguration=u,this._memoryConfigurationByResource=h,this._freeze=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(n,d,s){return this.getConsolidatedConfigurationModel(n,d,s).getValue(n)}updateValue(n,d,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new T,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,d===void 0?i.removeValue(n):i.setValue(n,d),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,d,s){const i=this.getConsolidatedConfigurationModel(n,d,s),r=this.getFolderConfigurationModelForResource(d.resource,s),a=d.resource?this._memoryConfigurationByResource.get(d.resource)||this._memoryConfiguration:this._memoryConfiguration,o=d.overrideIdentifier?this._defaultConfiguration.freeze().override(d.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),u=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),h=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(n),C=d.overrideIdentifier?this.userConfiguration.freeze().override(d.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),R=d.overrideIdentifier?this.localUserConfiguration.freeze().override(d.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),N=d.overrideIdentifier?this.remoteUserConfiguration.freeze().override(d.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),M=s?d.overrideIdentifier?this._workspaceConfiguration.freeze().override(d.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,A=r?d.overrideIdentifier?r.freeze().override(d.overrideIdentifier).getValue(n):r.freeze().getValue(n):void 0,z=d.overrideIdentifier?a.override(d.overrideIdentifier).getValue(n):a.getValue(n),H=i.getValue(n),F=l.distinct(i.overrides.map(G=>G.identifiers).flat()).filter(G=>i.getOverrideValue(n,G)!==void 0);return{defaultValue:o,policyValue:u,applicationValue:h,userValue:C,userLocalValue:R,userRemoteValue:N,workspaceValue:M,workspaceFolderValue:A,memoryValue:z,value:H,default:o!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:d.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,policy:u!==void 0?{value:u}:void 0,application:h!==void 0?{value:h,override:d.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,user:C!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:d.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:d.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,userRemote:N!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:d.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,workspace:M!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:d.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,workspaceFolder:A!==void 0?{value:r?.freeze().getValue(n),override:d.overrideIdentifier?r?.freeze().getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:a.getValue(n),override:d.overrideIdentifier?a.getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,overrideIdentifiers:F.length?F:void 0}}keys(n){const d=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:d?d.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,d){this._folderConfigurations.set(n,d),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,d){const s=[];if(!d){const{added:i,updated:r,removed:a}=g(this._defaultConfiguration,n);d=[...i,...r,...a]}for(const i of d)for(const r of(0,y.overrideIdentifiersFromKey)(i)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(r),o=n.getKeysForOverrideIdentifier(r),u=[...o.filter(h=>a.indexOf(h)===-1),...a.filter(h=>o.indexOf(h)===-1),...a.filter(h=>!k.equals(this._defaultConfiguration.override(r).getValue(h),n.override(r).getValue(h)))];s.push([r,u])}return this.updateDefaultConfiguration(n),{keys:d,overrides:s}}compareAndUpdatePolicyConfiguration(n){const{added:d,updated:s,removed:i}=g(this._policyConfiguration,n),r=[...d,...s,...i];return r.length&&this.updatePolicyConfiguration(n),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:d,updated:s,removed:i,overrides:r}=g(this.applicationConfiguration,n),a=[...d,...s,...i];return a.length&&this.updateApplicationConfiguration(n),{keys:a,overrides:r}}compareAndUpdateLocalUserConfiguration(n){const{added:d,updated:s,removed:i,overrides:r}=g(this.localUserConfiguration,n),a=[...d,...s,...i];return a.length&&this.updateLocalUserConfiguration(n),{keys:a,overrides:r}}compareAndUpdateRemoteUserConfiguration(n){const{added:d,updated:s,removed:i,overrides:r}=g(this.remoteUserConfiguration,n),a=[...d,...s,...i];return a.length&&this.updateRemoteUserConfiguration(n),{keys:a,overrides:r}}compareAndUpdateWorkspaceConfiguration(n){const{added:d,updated:s,removed:i,overrides:r}=g(this.workspaceConfiguration,n),a=[...d,...s,...i];return a.length&&this.updateWorkspaceConfiguration(n),{keys:a,overrides:r}}compareAndUpdateFolderConfiguration(n,d){const s=this.folderConfigurations.get(n),{added:i,updated:r,removed:a,overrides:o}=g(s,d),u=[...i,...r,...a];return(u.length||!s)&&this.updateFolderConfiguration(n,d),{keys:u,overrides:o}}compareAndDeleteFolderConfiguration(n){const d=this.folderConfigurations.get(n);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:i,removed:r,overrides:a}=g(d,void 0);return{keys:[...s,...i,...r],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,d,s){let i=this.getConsolidatedConfigurationModelForResource(d,s);return d.overrideIdentifier&&(i=i.override(d.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(i=i.merge(this._policyConfiguration)),i}getConsolidatedConfigurationModelForResource({resource:n},d){let s=this.getWorkspaceConsolidatedConfiguration();if(d&&n){const i=d.getFolder(n);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const r=this._memoryConfigurationByResource.get(n);r&&(s=s.merge(r))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let d=this._foldersConsolidatedConfigurations.get(n);if(!d){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(n);i?(d=s.merge(i),this._freeze&&(d=d.freeze()),this._foldersConsolidatedConfigurations.set(n,d)):d=s}return d}getFolderConfigurationModelForResource(n,d){if(d&&n){const s=d.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,d)=>{const{contents:s,overrides:i,keys:r}=this._folderConfigurations.get(d);return n.push([d,{contents:s,overrides:i,keys:r}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(d=>n.add(d)),this.userConfiguration.freeze().keys.forEach(d=>n.add(d)),this._workspaceConfiguration.freeze().keys.forEach(d=>n.add(d)),this._folderConfigurations.forEach(d=>d.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(d=>n.add(d)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(d=>n.add(d)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(d=>n.add(d)),this._folderConfigurations.forEach(d=>d.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const d=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>d.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>d.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>d.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(i=>d.add(i))),[...d.values()]}static parse(n){const d=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.policy),i=this.parseConfigurationModel(n.application),r=this.parseConfigurationModel(n.user),a=this.parseConfigurationModel(n.workspace),o=n.folders.reduce((u,h)=>(u.set(I.URI.revive(h[0]),this.parseConfigurationModel(h[1])),u),new _.ResourceMap);return new b(d,s,i,r,new T,a,o,new T,new _.ResourceMap,!1)}static parseConfigurationModel(n){return new T(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=b;function f(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const n=new Set,d=new Map;for(const i of m)i.keys.forEach(r=>n.add(r)),i.overrides.forEach(([r,a])=>{const o=(0,_.getOrSet)(d,r,new Set);a.forEach(u=>o.add(u))});const s=[];return d.forEach((i,r)=>s.push([r,[...i.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=f;class v{constructor(n,d,s,i){this.change=n,this.previous=d,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const r=new Set;n.keys.forEach(o=>r.add(o)),n.overrides.forEach(([,o])=>o.forEach(u=>r.add(u))),this.affectedKeys=[...r.values()];const a=new T;this.affectedKeys.forEach(o=>a.setValue(o,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,d){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(d){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,d,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(n,d,this.currentWorkspace);return!k.equals(s,i)}return!0}return!1}doesAffectedKeysTreeContains(n,d){let s=(0,L.toValuesTree)({[d]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(n=n[i],!n)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=v;function g(m,n){const{added:d,removed:s,updated:i}=c(n,m),r=[],a=m?.getAllOverrideIdentifiers()||[],o=n?.getAllOverrideIdentifiers()||[];if(n){const u=o.filter(h=>!a.includes(h));for(const h of u)r.push([h,n.getKeysForOverrideIdentifier(h)])}if(m){const u=a.filter(h=>!o.includes(h));for(const h of u)r.push([h,m.getKeysForOverrideIdentifier(h)])}if(n&&m){for(const u of a)if(o.includes(u)){const h=c({contents:m.getOverrideValue(void 0,u)||{},keys:m.getKeysForOverrideIdentifier(u)},{contents:n.getOverrideValue(void 0,u)||{},keys:n.getKeysForOverrideIdentifier(u)});r.push([u,[...h.added,...h.removed,...h.updated]])}}return{added:d,removed:s,updated:i,overrides:r}}function c(m,n){const d=m?n?m.keys.filter(r=>n.keys.indexOf(r)===-1):[...m.keys]:[],s=n?m?n.keys.filter(r=>m.keys.indexOf(r)===-1):[...n.keys]:[],i=[];if(m&&n){for(const r of n.keys)if(m.keys.indexOf(r)!==-1){const a=(0,L.getConfigurationValue)(n.contents,r),o=(0,L.getConfigurationValue)(m.contents,r);k.equals(a,o)||i.push(r)}}return{added:d,removed:s,updated:i}}}),define(De[123],Ie([1,0,10,3]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var D;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends l.ErrorNoTelemetry{constructor(k,w=D.Unknown,I){super(k),this._message=k,this._code=w,this._detail=I,this.isHandled=w===D.NotAvailable&&I===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(k){return k instanceof P&&k._code===D.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof P&&k._code===D.NoResolverFound}static isHandled(k){return k instanceof P&&k.isHandled}}e.RemoteAuthorityResolverError=P}),define(De[124],Ie([1,0,12]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(I){return I.scheme===l.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=t;function D(I){if(!I)return;const L=I.indexOf("+");return L<0?I:I.substr(0,L)}e.getRemoteName=D;function P(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=P;function _(I){const{host:L,port:y}=w(I);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:y}}e.parseAuthorityWithPort=_;function k(I,L){let{host:y,port:S}=w(I);return typeof S>"u"&&(S=L),{host:y,port:S}}e.parseAuthorityWithOptionalPort=k;function w(I){const L=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const y=I.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const S=I.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:I,port:void 0}}}),define(De[28],Ie([1,0,8,3,124]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=P;function _(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));var w;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,b){if(typeof p>"u"||p===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof p=="string"||typeof b=="string"){const f=typeof p=="string"?p:p.value,v=typeof b=="string"?b:b.value;return l.equalsIgnoreCase(f,v)}return p._lower===b._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=I;function L(E){return y(E)}e.isApplicationScopedExtension=L;function y(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function S(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function T(E,p){if(p){const b=`onResolveRemoteAuthority:${(0,D.getRemoteName)(p)}`;return E.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[199],Ie([1,0,8,84,28,11,2,10,40]),function(J,e,l,t,D,P,_,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(d,s){return d.uuid&&s.uuid?d.uuid===s.uuid:d.id===s.id?!0:(0,l.compareIgnoreCase)(d.id,s.id)===0}e.areSameExtensions=I;const L=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{constructor(s,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=s.id}static create(s){const i=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new y(s.identifier,i,r)}static parse(s){const i=L.exec(s);return i&&i[1]&&i[2]?new y({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof y?I(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=y;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(d){const s=S.exec(d);return s&&s[1]?[p(s[1]),s[2]]:[p(d),void 0]}e.getIdAndVersion=T;function E(d,s){return`${d}.${s}`}e.getExtensionId=E;function p(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=p;function b(d,s){return p(E(d,s))}e.getGalleryExtensionId=b;function f(d,s){const i=[],r=a=>{for(const o of i)if(o.some(u=>I(s(u),s(a))))return o;return null};for(const a of d){const o=r(a);o?o.push(a):i.push([a])}return i}e.groupByExtension=f;function v(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function g(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function c(d,s){const i=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&i.every(o=>!I(o.identifier,{id:a}))){const o=d.filter(u=>I(u.identifier,{id:a}));o.length===1&&(i.push(o[0]),r.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=c;async function m(d,s){if(!P.isLinux)return!1;let i;try{i=(await d.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await d.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=m;async function n(d,s){const i=await m(d,s),r=(0,t.getTargetPlatform)(i?"alpine":P.platform,w.arch);return s.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=n}),define(De[200],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class l{constructor(){this.validators=new Map}vsda(){return new Promise((D,P)=>J(["vsda"],D,P))}async createNewMessage(D){try{const P=await this.vsda(),_=new P.validator;if(_){const k=String(l._nextId++);return this.validators.set(k,_),{id:k,data:_.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,P){if(!D.id)return!0;const _=this.validators.get(D.id);if(!_)return!1;this.validators.delete(D.id);try{return _.validate(P)==="ok"}catch{return!1}}async sign(D){try{const P=await this.vsda(),_=new P.signer;if(_)return _.sign(D)}catch{}return D}}e.SignService=l,l._nextId=1}),define(De[201],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class l{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,P,_=5){const k=P(w=>{const I=typeof w=="string"?w:w.data;let L=this._terminalBufferMap.get(D);if(L){L.data.push(I);return}const y=setTimeout(()=>this.flushBuffer(D),_);L={data:[I],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(D),k.dispose()}},this._terminalBufferMap.set(D,L)});return k}stopBuffering(D){this._terminalBufferMap.get(D)?.dispose()}flushBuffer(D){const P=this._terminalBufferMap.get(D);P&&(this._terminalBufferMap.delete(D),this._callback(D,P.data.join("")))}}e.TerminalDataBufferer=l}),define(De[202],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var l;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(l=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===l.HIGH_CONTRAST_DARK||P===l.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function D(P){return P===l.DARK||P===l.HIGH_CONTRAST_DARK}e.isDark=D}),define(De[86],Ie([1,0,74,4,6,3,43,202]),function(J,e,l,t,D,P,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var w;(function(b){function f(v){return v&&typeof v=="object"&&typeof v.id=="string"}b.isThemeColor=f})(w=e.ThemeColor||(e.ThemeColor={}));function I(b){return{id:b}}e.themeColorFromId=I;var L;(function(b){function f(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||w.isThemeColor(i.color))}b.isThemeIcon=f;const v=new RegExp(`^\\$\\((${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?)\\)$`);function g(i){const r=v.exec(i);if(!r)return;const[,a]=r;return{id:a}}b.fromString=g;function c(i){return{id:i}}b.fromId=c;function m(i,r){let a=i.id;const o=a.lastIndexOf("~");return o!==-1&&(a=a.substring(0,o)),r&&(a=`${a}~${r}`),{id:a}}b.modify=m;function n(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}b.getModifier=n;function d(i,r){return i.id===r.id&&i.color?.id===r.color?.id}b.isEqual=d;function s(i,r){return{id:i.id,color:r?I(r):void 0}}b.asThemeIcon=s,b.asClassNameArray=l.CSSIcon.asClassNameArray,b.asClassName=l.CSSIcon.asClassName,b.asCSSSelector=l.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=l.Codicon.file,e.FolderThemeIcon=l.Codicon.folder;function y(b){switch(b){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case k.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(f){return this.themingParticipants.push(f),this.onThemingParticipantAddedEmitter.fire(f),(0,D.toDisposable)(()=>{const v=this.themingParticipants.indexOf(f);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const T=new S;_.Registry.add(e.Extensions.ThemingContribution,T);function E(b){return T.onColorThemeChange(b)}e.registerThemingParticipant=E;class p extends D.Disposable{constructor(f){super(),this.themeService=f,this.theme=f.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(f){this.theme=f,this.updateStyles()}updateStyles(){}getColor(f,v){let g=this.theme.getColor(f);return g&&v&&(g=v(g,this.theme)),g?g.toString():null}}e.Themable=p}),define(De[125],Ie([1,0,4,11,3,13]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var _;(function(p){p.Http="http",p.Https="https"})(_=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=y;function S(p,b){return b?b!==1&&p<1024:!t.isWindows&&p<1024}e.isPortPrivileged=S;class T{constructor(b,f,v){this.remoteAddress=b,this.localAddress=f,this._dispose=v,this._onDispose=new l.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=T;let E=class{constructor(b){this.logService=b,this._onTunnelOpened=new l.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new l.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new l.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(b){return this._tunnelProvider=b,b?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const b=[],f=Array.from(this._tunnels.values());for(const v of f){const g=Array.from(v.values());for(const c of g){const m=await c.value;m&&b.push(m)}}return b}async dispose(){for(const b of this._tunnels.values()){for(const{value:f}of b.values())await f.then(v=>v?.dispose());b.clear()}this._tunnels.clear()}openTunnel(b,f,v,g,c=!1,m,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${v} on local port ${g}.`),!b)return;if(f||(f="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.retainOrCreateTunnel(b,f,v,g,c,m,n);return d?d.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(s);return(s.tunnelRemoteHost!==f||s.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}makeTunnel(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const f=this._tunnels.get(b.tunnelRemoteHost);if(f){const v=f.get(b.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(b.tunnelRemoteHost,b.tunnelRemotePort,v))}}}}async tryDisposeTunnel(b,f,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${f}.`);const g=v.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(b)&&this._tunnels.get(b).delete(f),g}}async closeTunnel(b,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${f} `);const v=this._tunnels.get(b);if(v&&v.has(f)){const g=v.get(f);g.refcount=0,await this.tryDisposeTunnel(b,f,g)}}addTunnelToMap(b,f,v){this._tunnels.has(b)||this._tunnels.set(b,new Map),this._tunnels.get(b).set(f,{refcount:1,value:v})}async removeEmptyTunnelFromMap(b,f){const v=this._tunnels.get(b);v&&(await v.get(f)||v.delete(f),v.size===0&&this._tunnels.delete(b))}getTunnelFromMap(b,f){const v=[b];L(b)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):y(b)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const g=v.map(c=>this._tunnels.get(c));for(const c of g){const m=c?.get(f);if(m)return m}}canTunnel(b){return!!I(b)}createWithProvider(b,f,v,g,c,m,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${v} on local port ${g}.`);const d=v;this._factoryInProgress.add(d);const i={elevationRequired:c?S(g===void 0?v:g):!1},r={remoteAddress:{host:f,port:v},localAddressPort:g,privacy:m,public:m?m!==k.Private:void 0,protocol:n},a=b.forwardPort(r,i);return a?(this.addTunnelToMap(f,v,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(d)})):this._factoryInProgress.delete(d),a}};E=qe([xe(0,P.ILogService)],E),e.AbstractTunnelService=E}),define(De[203],Ie([1,0,12]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(w){return w.scheme!==l.Schemas.file&&w.scheme!==l.Schemas.vscodeRemote}e.isVirtualResource=t;function D(w){if(w.folders.length)return w.folders.every(I=>t(I.uri))?w.folders[0].uri:void 0;if(w.configuration&&t(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=D;function P(w){return D(w)?.scheme}e.getVirtualWorkspaceScheme=P;function _(w){return D(w)?.authority}e.getVirtualWorkspaceAuthority=_;function k(w){return D(w)!==void 0}e.isVirtualWorkspace=k}),define(De[45],Ie([1,0,169,9,25,22,2,3,12]),function(J,e,l,t,D,P,_,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function I(d){const s=d;return typeof s?.id=="string"&&_.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=I,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function L(d,s){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,t.basename)(d)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const i=d;if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=L;function y(d){const s=d;return typeof s?.id=="string"&&_.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=y;function S(d){const s=d;if(s?.uri)return{id:s.id,uri:_.URI.revive(s.uri)};const i=d;if(i?.configPath)return{id:i.id,configPath:_.URI.revive(i.configPath)};if(d?.id)return{id:d.id}}e.reviveIdentifier=S;var T;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function E(d){const s=d;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=E;function p(d){const s=d;return!!(s&&typeof s=="object"&&_.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=p;class b{constructor(s,i,r,a,o){this._id=s,this._transient=r,this._configuration=a,this._ignorePathCasing=o,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=i}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class f{constructor(s,i){this.raw=i,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,P.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function v(d){return new f({uri:d,index:0,name:(0,P.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,l.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(d,s){return P.extUriBiasedIgnorePathCase.isEqualOrParent(d,s.untitledWorkspacesHome)}e.isUntitledWorkspace=g;function c(d){let s;return _.URI.isUri(d)?s=d:s=d.configuration,s?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=c;function m(d,s){return!g(d,s)&&!c(d)}e.isSavedWorkspace=m;function n(d){return(typeof d=="string"?(0,t.extname)(d):(0,P.extname)(d))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(De[87],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class l{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const P=this._idPool++;return this._data.set(P,D),this.logDebugInfo(),P}get(D,P){return this._data.has(D)?this._data.get(D)[P]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!l.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=l,l.enableDebugLogging=!1}),define(De[46],Ie([1,0,12,22,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(l.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(k=>{const w=this._providerInfo.get(k.scheme);return!(w===void 0||w&1024)})}$acceptProviderInfos(k,w){w===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,w)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,l.createDecorator)("IExtHostInitDataService")}),define(De[204],Ie([1,0,18]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(_,k,w){this._deferredPromises=new Map,this._id=_,this._shared=k,this._storage=w,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new l.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of I.values())L.complete()}catch(L){for(const y of I.values())y.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,_])=>_!==void 0).map(([_])=>_)}get whenReady(){return this._init}get(_,k){let w=this._value[_];return typeof w>"u"&&(w=k),w}update(_,k){this._value[_]=k;const w=this._deferredPromises.get(_);if(w!==void 0)return w.p;const I=new l.DeferredPromise;return this._deferredPromises.set(_,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class D extends t{constructor(_,k){super(_.identifier.value,!0,k),this._extension=_}setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}}e.ExtensionGlobalMemento=D}),define(De[205],Ie([1,0,4,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(_){this._notebooksAndEditors=_,this._onDidSaveNotebookDocument=new l.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new l.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(_,k,w,I){const y=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(_)).acceptModelChanged(k.value,w,I);this._onDidChangeNotebookDocument.fire(y)}$acceptDirtyStateChanged(_,k){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(_)).acceptDirty(k)}$acceptModelSaved(_){const k=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(_));this._onDidSaveNotebookDocument.fire(k.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(De[14],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,l.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[206],Ie([1,0,28,4]),function(J,e,l,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(k,w){D.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=l.ExtensionIdentifier.toKey(k.identifier),tt(this,D,w,"f"),Ue(this,D,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(k){return Ue(this,D,"f").get(this._id,k)}store(k,w){return Ue(this,D,"f").store(this._id,k,w)}delete(k){return Ue(this,D,"f").delete(this._id,k)}}e.ExtensionSecrets=P,D=new WeakMap}),define(De[126],Ie([1,0,3,4]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(_,k){this._level=_,this._productConfig=k||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(_){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=_,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,l.createDecorator)("IExtHostTelemetry")}),define(De[53],Ie([1,0,3,125,4,14]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var _;(function(w){function I(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:y.protocol}}w.fromApiTunnel=I;function L(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==t.TunnelPrivacyId.ConstantPrivate&&y.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}w.fromServiceTunnel=L})(_=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,l.createDecorator)("IExtHostTunnelService");let k=class{constructor(I){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,L){}async getTunnels(){return[]}async setTunnelFactory(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,L){return{dispose:()=>{}}}async $providePortAttributes(I,L,y,S,T){return[]}async $forwardPort(I,L){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=qe([xe(0,P.IExtHostRpcService)],k),e.ExtHostTunnelService=k}),define(De[54],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,l.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=t}),define(De[207],Ie([1,0,23]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(w){let I=this.buffers.indexOf(w);return I<0&&(I=this.buffers.length,this.buffers.push(w)),I}}function D(k,w){if(w.serializeBuffersForPostMessage){const I=new t,L=(T,E)=>{if(E instanceof ArrayBuffer){const p=I.add(E);return{$$vscode_array_buffer_reference$$:!0,index:p}}else if(ArrayBuffer.isView(E)){const p=P(E);if(p){const b=I.add(E.buffer);return{$$vscode_array_buffer_reference$$:!0,index:b,view:{type:p,byteLength:E.byteLength,byteOffset:E.byteOffset}}}}return E},y=JSON.stringify(k,L),S=I.buffers.map(T=>{const E=new Uint8Array(T);return l.VSBuffer.wrap(E)});return{message:y,buffers:S}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=D;function P(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(k,w){const I=w.map(S=>{const T=new ArrayBuffer(S.byteLength);return new Uint8Array(T).set(S.buffer),T}),L=w.length?(S,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const E=T,{index:p}=E,b=I[p];if(E.view)switch(E.view.type){case 1:return new Int8Array(b,E.view.byteOffset,E.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,E.view.byteOffset,E.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,E.view.byteOffset,E.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,E.view.byteOffset,E.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,E.view.byteOffset,E.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,E.view.byteOffset,E.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,E.view.byteOffset,E.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,E.view.byteOffset,E.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,E.view.byteOffset,E.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,E.view.byteOffset,E.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,E.view.byteOffset,E.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return T}:void 0;return{message:JSON.parse(k,L),arrayBuffers:I}}e.deserializeWebviewMessage=_}),define(De[208],Ie([1,0,109]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:_=>_.scheme==="vscode-remote"?{scheme:"file",path:_.path,query:_.query,fragment:_.fragment}:_.scheme==="file"?{scheme:"vscode-local",path:_.path,query:_.query,fragment:_.fragment}:_,transformOutgoing:_=>_.scheme==="file"?{scheme:"vscode-remote",authority:P,path:_.path,query:_.query,fragment:_.fragment}:_.scheme==="vscode-local"?{scheme:"file",path:_.path,query:_.query,fragment:_.fragment}:_,transformOutgoingScheme:_=>_==="file"?"vscode-remote":_==="vscode-local"?"file":_}}function D(P){return new l.URITransformer(t(P))}e.createURITransformer=D}),define(De[127],Ie([1,0,179,16,2,6,3,43,42,17,12]),function(J,e,l,t,D,P,_,k,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var y;(function($){$[$.PROGRAMMATIC=1]="PROGRAMMATIC",$[$.USER=2]="USER",$[$.EDIT=3]="EDIT",$[$.NAVIGATION=4]="NAVIGATION",$[$.JUMP=5]="JUMP"})(y=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var S;(function($){$[$.IDENTICAL=1]="IDENTICAL",$[$.SIMILAR=2]="SIMILAR",$[$.DIFFERENT=3]="DIFFERENT"})(S=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function T($){const x=$;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.isEditorPaneWithSelection=T;function E($,x,Q){for(const de of Q.visibleEditorPanes)if(de.group.id===x&&$.matches(de.input))return de.getViewState()}e.findViewStateForEditor=E;function p($){if(a($))return!1;const x=$;return D.URI.isUri(x?.resource)}e.isResourceEditorInput=p;function b($){if(a($))return!1;const x=$;return x?.original!==void 0&&x.modified!==void 0}e.isResourceDiffEditorInput=b;function f($){if(a($)||b($))return!1;const x=$;return x?.primary!==void 0&&x.secondary!==void 0}e.isResourceSideBySideEditorInput=f;function v($){if(a($))return!1;const x=$;return x?x.resource===void 0||x.resource.scheme===L.Schemas.untitled||x.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=v;const g=/Untitled-\d+/;function c($){return $.scheme===L.Schemas.untitled&&$.path.length>1&&!g.test($.path)}e.isUntitledWithAssociatedResource=c;function m($){if(a($))return!1;const x=$;return D.URI.isUri(x?.base?.resource)&&D.URI.isUri(x?.input1?.resource)&&D.URI.isUri(x?.input2?.resource)&&D.URI.isUri(x?.result?.resource)}e.isResourceMergeEditorInput=m;var n;(function($){$[$.SHORT=0]="SHORT",$[$.MEDIUM=1]="MEDIUM",$[$.LONG=2]="LONG"})(n=e.Verbosity||(e.Verbosity={}));var d;(function($){$[$.EXPLICIT=1]="EXPLICIT",$[$.AUTO=2]="AUTO",$[$.FOCUS_CHANGE=3]="FOCUS_CHANGE",$[$.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d=e.SaveReason||(e.SaveReason={}));class s{constructor(){this.mapIdToSaveSource=new Map}registerSource(x,Q){let de=this.mapIdToSaveSource.get(x);return de||(de={source:x,label:Q},this.mapIdToSaveSource.set(x,de)),de.source}getSourceLabel(x){return this.mapIdToSaveSource.get(x)?.label??x}}e.SaveSourceRegistry=new s;var i;(function($){$[$.None=0]="None",$[$.Readonly=2]="Readonly",$[$.Untitled=4]="Untitled",$[$.Singleton=8]="Singleton",$[$.RequiresTrust=16]="RequiresTrust",$[$.CanSplitInGroup=32]="CanSplitInGroup",$[$.ForceDescription=64]="ForceDescription",$[$.CanDropIntoEditor=128]="CanDropIntoEditor",$[$.MultipleEditors=256]="MultipleEditors"})(i=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends P.Disposable{}e.AbstractEditorInput=r;function a($){return $ instanceof r}e.isEditorInput=a;function o($){const x=$;return D.URI.isUri(x?.preferredResource)}function u($){const x=$;return a(x?.primary)&&a(x?.secondary)}e.isSideBySideEditorInput=u;function h($){const x=$;return a(x?.modified)&&a(x?.original)}e.isDiffEditorInput=h;function C($){return a($?.editor)}e.isEditorInputWithOptions=C;function R($){const x=$;return C($)&&x?.group!==void 0}e.isEditorInputWithOptionsAndGroup=R;function N($){const x=$;return typeof x?.groupId=="number"&&a(x.editor)}e.isEditorIdentifier=N;var M;(function($){$[$.UNKNOWN=0]="UNKNOWN",$[$.REPLACE=1]="REPLACE",$[$.MOVE=2]="MOVE",$[$.UNPIN=3]="UNPIN"})(M=e.EditorCloseContext||(e.EditorCloseContext={}));var A;(function($){$[$.GROUP_ACTIVE=0]="GROUP_ACTIVE",$[$.GROUP_INDEX=1]="GROUP_INDEX",$[$.GROUP_LOCKED=2]="GROUP_LOCKED",$[$.EDITOR_OPEN=3]="EDITOR_OPEN",$[$.EDITOR_CLOSE=4]="EDITOR_CLOSE",$[$.EDITOR_MOVE=5]="EDITOR_MOVE",$[$.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",$[$.EDITOR_LABEL=7]="EDITOR_LABEL",$[$.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",$[$.EDITOR_PIN=9]="EDITOR_PIN",$[$.EDITOR_STICKY=10]="EDITOR_STICKY",$[$.EDITOR_DIRTY=11]="EDITOR_DIRTY",$[$.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(A=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var z;(function($){$[$.PRIMARY=1]="PRIMARY",$[$.SECONDARY=2]="SECONDARY",$[$.BOTH=3]="BOTH",$[$.ANY=4]="ANY"})(z=e.SideBySideEditor||(e.SideBySideEditor={}));class H{getOriginalUri(x,Q){if(!x)return;if(m(x))return e.EditorResourceAccessor.getOriginalUri(x.result,Q);if(Q?.supportSideBySide){const{primary:te,secondary:pe}=this.getSideEditors(x);if(te&&pe){if(Q?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:Q.filterByScheme}),secondary:this.getOriginalUri(pe,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===z.ANY)return this.getOriginalUri(te,{filterByScheme:Q.filterByScheme})??this.getOriginalUri(pe,{filterByScheme:Q.filterByScheme});x=Q.supportSideBySide===z.PRIMARY?te:pe}}if(b(x)||f(x)||m(x))return;const de=o(x)?x.preferredResource:x.resource;return!de||!Q||!Q.filterByScheme?de:this.filterUri(de,Q.filterByScheme)}getSideEditors(x){return u(x)||f(x)?{primary:x.primary,secondary:x.secondary}:h(x)||b(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,Q){if(!x)return;if(m(x))return e.EditorResourceAccessor.getCanonicalUri(x.result,Q);if(Q?.supportSideBySide){const{primary:te,secondary:pe}=this.getSideEditors(x);if(te&&pe){if(Q?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:Q.filterByScheme}),secondary:this.getCanonicalUri(pe,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===z.ANY)return this.getCanonicalUri(te,{filterByScheme:Q.filterByScheme})??this.getCanonicalUri(pe,{filterByScheme:Q.filterByScheme});x=Q.supportSideBySide===z.PRIMARY?te:pe}}if(b(x)||f(x)||m(x))return;const de=x.resource;return!de||!Q||!Q.filterByScheme?de:this.filterUri(de,Q.filterByScheme)}filterUri(x,Q){if(Array.isArray(Q)){if(Q.some(de=>x.scheme===de))return x}else if(Q===x.scheme)return x}}e.EditorResourceAccessor=new H;var F;(function($){$[$.LEFT=0]="LEFT",$[$.RIGHT=1]="RIGHT"})(F=e.CloseDirection||(e.CloseDirection={}));class G{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(x){const Q=this.instantiationService=x.get(_.IInstantiationService);for(const[de,te]of this.editorSerializerConstructors)this.createEditorSerializer(de,te,Q);this.editorSerializerConstructors.clear()}createEditorSerializer(x,Q,de){const te=de.createInstance(Q);this.editorSerializerInstances.set(x,te)}registerFileEditorFactory(x){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=x}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(x,Q){if(this.editorSerializerConstructors.has(x)||this.editorSerializerInstances.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.instantiationService?this.createEditorSerializer(x,Q,this.instantiationService):this.editorSerializerConstructors.set(x,Q),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(x),this.editorSerializerInstances.delete(x)})}getEditorSerializer(x){return this.editorSerializerInstances.get(typeof x=="string"?x:x.typeId)}}k.Registry.add(e.EditorExtensions.EditorFactory,new G);async function B($,x){if(!$||!$.length)return[];const Q=await Promise.all($.map(async de=>{const te=D.URI.revive(de.fileUri);if(!te||!await x.canHandleResource(te))return;let Y=de.exists,ve=de.type;if(typeof Y!="boolean"||typeof ve!="number")try{ve=(await x.stat(te)).isDirectory?w.FileType.Directory:w.FileType.Unknown,Y=!0}catch{Y=!1}if(!Y&&de.openOnlyIfExists||ve===w.FileType.Directory)return;const be={...de.options,pinned:!0};let ke;return Y?ke={resource:te,options:be}:ke={resource:te,options:be,forceUntitled:!0},ke}));return(0,I.coalesce)(Q)}e.pathsToEditors=B;var U;(function($){$[$.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",$[$.SEQUENTIAL=1]="SEQUENTIAL"})(U=e.EditorsOrder||(e.EditorsOrder={}));function X($){const x=$;if(!x)return!1;const Q=x;if(Q.modified)return X(Q.modified);const de=x;return!!(de.contributionsState&&de.viewState&&Array.isArray(de.cursorState))}e.isTextEditorViewState=X}),define(De[88],Ie([1,0,12,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(k,w){return k.scheme===l.Schemas.http||k.scheme===l.Schemas.https?k:(w&&w.authority&&w.isRemote&&k.scheme===l.Schemas.file&&(k=t.URI.from({scheme:l.Schemas.vscodeRemote,authority:w.authority,path:k.path})),t.URI.from({scheme:l.Schemas.https,authority:`${k.scheme}+${P(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=D;function P(k){return k.replace(/./g,w=>{const I=w.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?w:"-"+I.toString(16).padStart(4,"0")})}function _(k){return k.replace(/-([0-9a-f]{4})/g,(w,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=_}),define(De[209],Ie([1,0,4,6,88]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(k,w,I){this._proxy=k,this._editors=w,this._remoteInfo=I,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(w.onDidChangeVisibleTextEditors(()=>{const L=w.getVisibleTextEditors();for(const y of this._insets.values())L.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,w,I,L,y){let S;for(const g of this._editors.getVisibleTextEditors(!0))if(g.value===k){S=g;break}if(!S)throw new Error("not a visible editor");const T=this,E=this._handlePool++,p=new l.Emitter,b=new l.Emitter,f=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(g){return(0,D.asWebviewUri)(g,T._remoteInfo)}get cspSource(){return D.webviewGenericCspSource}set options(g){this._options=g,T._proxy.$setOptions(E,g)}get options(){return this._options}set html(g){this._html=g,T._proxy.$setHtml(E,g)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(g){return T._proxy.$postMessage(E,g)}},v=new class{constructor(){this.editor=k,this.line=w,this.height=I,this.webview=f,this.onDidDispose=b.event}dispose(){T._insets.has(E)&&(T._insets.delete(E),T._proxy.$disposeEditorInset(E),b.fire(),b.dispose(),p.dispose())}};return this._proxy.$createEditorInset(E,S.id,S.value.document.uri,w+1,I,L||{},y.identifier,y.extensionLocation),this._insets.set(E,{editor:k,inset:v,onDidReceiveMessage:p}),v}$onDidDispose(k){const w=this._insets.get(k);w&&w.inset.dispose()}$onDidReceiveMessage(k,w){this._insets.get(k)?.onDidReceiveMessage.fire(w)}}e.ExtHostEditorInsets=P}),define(De[128],Ie([1,0,4,18,180]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new l.Emitter,this._onExit=new l.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,w,I,L){const y={command:k};if(w&&Object.keys(w).length>0&&(y.arguments=w),this.internalSend("request",y),typeof L=="number"){const S=setTimeout(()=>{clearTimeout(S);const T=this.pendingRequests.get(y.seq);if(T){this.pendingRequests.delete(y.seq);const E={type:"response",seq:0,request_seq:y.seq,success:!1,command:k,message:(0,D.localize)(0,null,L,k)};T(E)}},L)}return I&&this.pendingRequests.set(y.seq,I),y.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,w){return k.type!=="event"||w.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,t.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback?.(k);break;case"request":this.requestCallback?.(k);break;case"response":{const w=k,I=this.pendingRequests.get(w.request_seq);I&&(this.pendingRequests.delete(w.request_seq),I(w));break}}}}internalSend(k,w){w.type=k,w.seq=this.sequence++,this.sendMessage(w)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((w,I)=>k.set(I,w)),await(0,t.timeout)(500),k.forEach((w,I)=>{w({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(De[210],Ie([1,0,181,52,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:l.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:l.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:l.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:l.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:l.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:l.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:l.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:l.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:l.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:l.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:l.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:l.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:l.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:l.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:l.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:l.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:l.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:l.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:l.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:l.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:l.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:l.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:l.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:l.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:l.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:l.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:l.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:l.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:l.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:l.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:l.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:l.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:l.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:l.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:l.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:l.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:l.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:l.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:l.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:l.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:l.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:l.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:l.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:l.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:l.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:l.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:l.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:l.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:l.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:l.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:l.localize(50,null)});const P=S=>l.localize(51,null,S);e.debuggerDisabledMessage=P,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:l.localize(52,null)};var _;(function(S){S[S.Inactive=0]="Inactive",S[S.Initializing=1]="Initializing",S[S.Stopped=2]="Stopped",S[S.Running=3]="Running"})(_=e.State||(e.State={}));function k(S){switch(S){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=k;var w;(function(S){S[S.Valid=0]="Valid",S[S.Unreadable=1]="Unreadable",S[S.Error=2]="Error"})(w=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var I;(function(S){S[S.Initial=1]="Initial",S[S.Dynamic=2]="Dynamic"})(I=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(S){S.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,D.createDecorator)(e.DEBUG_SERVICE_ID);var y;(function(S){S[S.CONDITION=0]="CONDITION",S[S.HIT_COUNT=1]="HIT_COUNT",S[S.LOG_MESSAGE=2]="LOG_MESSAGE"})(y=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[211],Ie([1,0,8,2,9,24,12]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function w(s,i,r){return s.replace(k,function(a,o){return i&&o.length>0&&o[0]!=="_"?a:r&&r.hasOwnProperty(o)?r[o]:a})}e.formatPII=w;function I(s){const i={};for(const r of Object.keys(s))r.startsWith("!")||(i[r]=s[r]);return i}e.filterExceptionsFromTelemetry=I;function L(s){return s.configuration.request==="attach"&&!y(s)&&(!s.parentSession||L(s.parentSession))}e.isSessionAttach=L;function y(s){let i=s.configuration.type;if(!!i)return i==="vslsShare"&&(i=s.configuration.adapterProxy.configuration.type),(0,l.equalsIgnoreCase)(i,"extensionhost")||(0,l.equalsIgnoreCase)(i,"pwa-extensionhost")?s:s.parentSession?y(s.parentSession):void 0}e.getExtensionHostDebugSession=y;function S(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=S;function T(s,i,r){let a,o=0;const u=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=u.exec(s);){const C=h.index+1,R=C+h[0].length;if(C<=i&&R>=r){a=h[0],o=C;break}}if(a){const C=/\w+/g;let R=null;for(;(R=C.exec(a))&&!(R.index+1+o+R[0].length>=r););R&&(a=a.substring(0,C.lastIndex))}return a?{start:o,end:o+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const E=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(s){return!!(s&&s.match(E))}e.isUri=p;function b(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(p(s.path))return t.URI.parse(s.path);if((0,D.isAbsolute)(s.path))return t.URI.file(s.path)}return s.path}function f(s){if(typeof s.path=="object"){const i=t.URI.revive(s.path);if(i)return i.scheme===_.Schemas.file?i.fsPath:i.toString()}return s.path}function v(s,i){const r=i?b:f,a=(0,P.deepClone)(s);return c(a,(o,u)=>{o&&u&&(u.path=r(u))}),a}e.convertToDAPaths=v;function g(s,i){const r=i?b:f,a=(0,P.deepClone)(s);return c(a,(o,u)=>{!o&&u&&(u.path=r(u))}),a}e.convertToVSCPaths=g;function c(s,i){switch(s.type){case"event":{const r=s;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=s;switch(r.command){case"setBreakpoints":i(!0,r.arguments.source);break;case"breakpointLocations":i(!0,r.arguments.source);break;case"source":i(!0,r.arguments.source);break;case"gotoTargets":i(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(a=>i(!1,a));break;default:break}break}case"response":{const r=s;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(a=>i(!1,a.source));break;case"loadedSources":r.body.sources.forEach(a=>i(!1,a));break;case"scopes":r.body.scopes.forEach(a=>i(!1,a.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(a=>i(!1,a.source));break;case"setBreakpoints":r.body.breakpoints.forEach(a=>i(!1,a.source));break;case"disassemble":r.body?.instructions.forEach(o=>i(!1,o.location));break;default:break}break}}}function m(s){return s.filter(i=>!i.presentation?.hidden).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):n(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:n(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=m;function n(s,i){return typeof s!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:s-i}async function d(s,i){const r=s.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(r!=="none"&&(await i.saveAll(),r==="allEditorsInActiveGroup")){const a=i.activeEditorPane;a&&a.input.resource?.scheme===_.Schemas.untitled&&await i.save({editor:a.input,groupId:a.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=d}),define(De[212],Ie([1,0,29,44,182,213,9,8,24,11,84,128]),function(J,e,l,t,D,P,_,k,w,I,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class S extends y.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(v,g){this.outputStream=g,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,v.on("data",c=>this.handleData(c))}sendMessage(v){if(this.outputStream){const g=JSON.stringify(v);this.outputStream.write(`Content-Length: ${Buffer.byteLength(g,"utf8")}${S.TWO_CRLF}${g}`,"utf8")}}handleData(v){for(this.rawData=Buffer.concat([this.rawData,v]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const g=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,g.length>0)try{this.acceptMessage(JSON.parse(g))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+g))}continue}}else{const g=this.rawData.indexOf(S.TWO_CRLF);if(g!==-1){const m=this.rawData.toString("utf8",0,g).split(S.HEADER_LINESEPARATOR);for(const n of m){const d=n.split(S.HEADER_FIELDSEPARATOR);d[0]==="Content-Length"&&(this.contentLength=Number(d[1]))}this.rawData=this.rawData.slice(g+S.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=S,S.TWO_CRLF=`\r
\r
`,S.HEADER_LINESEPARATOR=/\r?\n/,S.HEADER_FIELDSEPARATOR=/: */;class T extends S{startSession(){return new Promise((v,g)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),v(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):g(new Error("connection closed"))}),this.socket.on("error",m=>{c?this._onError.fire(m):g(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=T;class E extends T{constructor(v){super(),this.adapterServer=v}createConnection(v){return P.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",v)}}e.SocketDebugAdapter=E;class p extends T{constructor(v){super(),this.adapterServer=v}createConnection(v){return P.createConnection(this.adapterServer.path,v)}}e.NamedPipeDebugAdapter=p;class b extends S{constructor(v,g,c){super(),this.adapterExecutable=v,this.debugType=g,this.outputService=c}async startSession(){const v=this.adapterExecutable.command,g=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(v)if(_.isAbsolute(v)){if(!await l.Promises.exists(v))throw new Error(D.localize(0,null,v))}else v.indexOf("/")<0&&v.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let m=process.env;if(c.env&&Object.keys(c.env).length>0&&(m=w.mixin(w.deepClone(process.env),c.env)),v==="node")if(Array.isArray(g)&&g.length>0){const d=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:m,execArgv:d?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(s.cwd=c.cwd);const i=t.fork(g[0],g.slice(1),s);if(!i.pid)throw new Error(D.localize(2,null,g[0]));this.serverProcess=i}else throw new Error(D.localize(3,null));else{const d={env:m};c.cwd&&(d.cwd=c.cwd),this.serverProcess=t.spawn(v,g,d)}this.serverProcess.on("error",d=>{this._onError.fire(d)}),this.serverProcess.on("exit",(d,s)=>{this._onExit.fire(d)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",d=>{this._onError.fire(d)}),this.serverProcess.stdin.on("error",d=>{this._onError.fire(d)});const n=this.outputService;if(n){const d=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{n.getChannel(L.ExtensionsChannelId)?.append(d(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),I.isWindows?new Promise((v,g)=>{const c=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,n,d){if(m)return g(m)});c.on("exit",v),c.on("error",g)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(v,g){if(!v)return;const c=Object.create(null);v.runtime&&(v.runtime.indexOf("./")===0?c.runtime=_.join(g,v.runtime):c.runtime=v.runtime),v.runtimeArgs&&(c.runtimeArgs=v.runtimeArgs),v.program&&(_.isAbsolute(v.program)?c.program=v.program:c.program=_.join(g,v.program)),v.args&&(c.args=v.args);const m=v;return m.win&&(c.win=b.extract(m.win,g)),m.winx86&&(c.winx86=b.extract(m.winx86,g)),m.windows&&(c.windows=b.extract(m.windows,g)),m.osx&&(c.osx=b.extract(m.osx,g)),m.linux&&(c.linux=b.extract(m.linux,g)),c}static platformAdapterExecutable(v,g){let c=Object.create(null);g=g.toLowerCase();for(const r of v)if(r.contributes){const a=r.contributes.debuggers;a&&a.length>0&&a.filter(o=>typeof o.type=="string"&&k.equalsIgnoreCase(o.type,g)).forEach(o=>{const u=b.extract(o,r.extensionLocation.fsPath);c=w.mixin(c,u,r.isBuiltin)})}let m;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=c.winx86||c.win||c.windows:I.isWindows?m=c.win||c.windows:I.isMacintosh?m=c.osx:I.isLinux&&(m=c.linux),m=m||c;const n=m.program||c.program,d=m.args||c.args,s=m.runtime||c.runtime,i=m.runtimeArgs||c.runtimeArgs;if(s)return{type:"executable",command:s,args:(i||[]).concat(typeof n=="string"?[n]:[]).concat(d||[])};if(n)return{type:"executable",command:n,args:d||[]}}}e.ExecutableDebugAdapter=b}),define(De[214],Ie([1,0,44,31,11]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(I,L){return new Promise((y,S)=>{let T="";const E=l.spawn(I,L);E.pid&&E.stdout.on("data",p=>{T+=p.toString()}),E.on("error",p=>{S(p)}),E.on("close",p=>{y(T)})})}async function _(I){if(I)if(D.isWindows){const L=await new Promise((y,S)=>{J(["windows-process-tree"],y,S)});return new Promise(y=>{L.getProcessTree(I,S=>{y(!!S&&S.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(I)]).then(L=>{const y=L.trim();return!(y.length===0||y.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=_;var k;(function(I){I[I.cmd=0]="cmd",I[I.powershell=1]="powershell",I[I.bash=2]="bash"})(k||(k={}));function w(I,L,y,S,T){I=I.trim().toLowerCase();let E;I.indexOf("powershell")>=0||I.indexOf("pwsh")>=0?E=1:I.indexOf("cmd.exe")>=0?E=0:I.indexOf("bash")>=0?E=2:D.isWindows?E=0:E=2;let p,b=" ";switch(E){case 1:if(p=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),S){const f=(0,t.getDriveLetter)(S);f&&(b+=`${f}:; `),b+=`cd ${p(S)}; `}if(T)for(const f in T){const v=T[f];v===null?b+=`Remove-Item env:${f}; `:b+=`\${env:${f}}='${v}'; `}if(L.length>0){const f=L.shift(),v=y?f:p(f);b+=v[0]==="'"?`& ${v} `:`${v} `;for(const g of L)b+=g==="<"||g===">"||y?g:p(g),b+=" "}break;case 0:if(p=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(v=>f.includes(v))||f.length===0?`"${f}"`:f),S){const f=(0,t.getDriveLetter)(S);f&&(b+=`${f}: && `),b+=`cd ${p(S)} && `}if(T){b+='cmd /C "';for(const f in T){let v=T[f];v===null?b+=`set "${f}=" && `:(v=v.replace(/[&^|<>]/g,g=>`^${g}`),b+=`set "${f}=${v}" && `)}}for(const f of L)b+=f==="<"||f===">"||y?f:p(f),b+=" ";T&&(b+='"');break;case 2:{p=v=>(v=v.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),v.length===0?'""':v);const f=v=>/[^\w@%\/+=,.:^-]/.test(v)?`'${v.replace(/'/g,"'\\''")}'`:v;if(S&&(b+=`cd ${p(S)} ; `),T){b+="/usr/bin/env";for(const v in T){const g=T[v];g===null?b+=` -u ${f(v)}`:b+=` ${f(`${v}=${g}`)}`}b+=" "}for(const v of L)b+=v==="<"||v===">"||y?v:p(v),b+=" ";break}}return b}e.prepareCommand=w}),define(De[89],Ie([1,0,23,36,60,102,12,9,11,52]),function(J,e,l,t,D,P,_,k,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var L;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.latex,P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.latex,P.Mimes.markdown,"application/json",P.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={}));var S;(function(o){o[o.Unconfirmed=1]="Unconfirmed",o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(S=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeCellLanguage=5]="ChangeCellLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var b;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(b=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var v;(function(o){o.scheme=_.Schemas.vscodeNotebookCell;const u=["W","X","Y","Z","a","b","c","d","e","f"],h=new RegExp(`^[${u.join("")}]+`),C=7;function R(F,G){const B=G.toString(C),X=`${B.length<u.length?u[B.length-1]:"z"}${B}s${(0,l.encodeBase64)(l.VSBuffer.fromString(F.scheme),!0,!0)}`;return F.with({scheme:o.scheme,fragment:X})}o.generate=R;function N(F){if(F.scheme!==o.scheme)return;const G=F.fragment.indexOf("s");if(G<0)return;const B=parseInt(F.fragment.substring(0,G).replace(h,""),C),U=(0,l.decodeBase64)(F.fragment.substring(G+1)).toString();if(!isNaN(B))return{handle:B,notebook:F.with({scheme:U,fragment:null})}}o.parse=N;function M(F,G){return F.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`op${G??""},${F.scheme!==_.Schemas.file?F.scheme:""}`})}o.generateCellOutputUri=M;function A(F){if(F.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const G=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(F.fragment);if(!G)return;const B=G[1]&&G[1]!==""?G[1]:void 0,U=G[2];return{outputId:B,notebook:F.with({scheme:U||_.Schemas.file,fragment:null})}}o.parseCellOutputUri=A;function z(F,G,B){return o.generate(F,G).with({scheme:B})}o.generateCellPropertyUri=z;function H(F,G){if(F.scheme===G)return o.parse(F.with({scheme:o.scheme}))}o.parseCellPropertyUri=H})(v=e.CellUri||(e.CellUri={}));const g=o=>w.isWindows?o.replace(/\//g,"\\"):o;class c{constructor(u=[],h=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=h,this.order=[...new Set(u)].map(C=>({pattern:C,matches:t.parse(g(C))}))}sort(u){const h=new Map(D.Iterable.map(u,R=>[R,g(R)]));let C=[];for(const{matches:R}of this.order)for(const[N,M]of h)if(R(M)){C.push(N),h.delete(N);break}return h.size&&(C=C.concat([...h.keys()].sort((R,N)=>this.defaultOrder.indexOf(R)-this.defaultOrder.indexOf(N)))),C}prioritize(u,h){const C=this.findIndex(u);if(C===-1){this.order.unshift({pattern:u,matches:t.parse(g(u))});return}const R=new Set(h.map(M=>this.findIndex(M,C)));R.delete(-1);const N=Array.from(R).sort();this.order.splice(C+1,0,...N.map(M=>this.order[M]));for(let M=N.length-1;M>=0;M--)this.order.splice(N[M],1)}toArray(){return this.order.map(u=>u.pattern)}findIndex(u,h=this.order.length){const C=g(u);for(let R=0;R<h;R++)if(this.order[R].matches(C))return R;return-1}}e.MimeTypeDisplayOrder=c;function m(o,u,h,C=(R,N)=>R===N){const R=[];function N(z,H,F){if(H===0&&F.length===0)return;const G=R[R.length-1];G&&G.start+G.deleteCount===z?(G.deleteCount+=H,G.toInsert.push(...F)):R.push({start:z,deleteCount:H,toInsert:F})}let M=0,A=0;for(;;){if(M===o.length){N(M,0,u.slice(A));break}if(A===u.length){N(M,o.length-M,[]);break}const z=o[M],H=u[A];if(C(z,H)){M+=1,A+=1;continue}h(H)?(N(M,1,[]),M+=1):(N(M,0,[H]),A+=1)}return R}e.diff=m,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(o){o.default="default",o.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(o){const u=o;return!!((typeof u.include=="string"||t.isRelativePattern(u.include))&&(typeof u.exclude=="string"||t.isRelativePattern(u.exclude)))}e.isDocumentExcludePattern=d;function s(o,u,h){if(Array.isArray(o.viewType)&&o.viewType.indexOf(u)>=0||o.viewType===u)return!0;if(o.filenamePattern){const C=d(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,R=d(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(t.match(C,(0,k.basename)(h.fsPath).toLowerCase()))return!(R&&t.match(R,(0,k.basename)(h.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(u){return`${r._prefix}${u}`}static parse(u){if(u.startsWith(r._prefix))return u.substring(r._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r._prefix="notebook/";function a(o){return["application/vnd.code.notebook.stdout","application/x.notebook.stdout","application/x.notebook.stream","application/vnd.code.notebook.stderr","application/x.notebook.stderr"].includes(o)}e.isTextStreamMime=a}),define(De[215],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,l.createDecorator)("INotebookExecutionService")}),define(De[216],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function l(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=l;function t(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=t;function D(_){return Array.from(_.entries()).map(k=>[k[0],l(k[1].map)])}e.serializeEnvironmentVariableCollections=D;function P(_){return new Map(_.map(k=>[k[0],{map:t(k[1])}]))}e.deserializeEnvironmentVariableCollections=P}),define(De[63],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(P){P.Delimiter="\0"})(l=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class D{constructor(_,k=_.length){if(this.path=_,this.viewEnd=k,_.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(_,k,w=_.parent){if(_.id===k)return new D([k]);const I=[_.id];for(let L=w;L&&L.id!==k;L=L.parent)I.push(L.id);return I.push(k),new D(I.reverse())}static isRoot(_){return!_.includes("\0")}static root(_){const k=_.indexOf("\0");return k===-1?_:_.slice(0,k)}static fromString(_){return new D(_.split("\0"))}static join(_,k){return new D([..._.path,k])}static joinToString(_,k){return _.toString()+"\0"+k}static compare(_,k){return _===k?0:k.startsWith(_+"\0")?2:_.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let _=1;_<=this.viewEnd;_++)yield new D(this.path,_)}compare(_){if(typeof _=="string")return D.compare(this.toString(),_);for(let k=0;k<_.viewEnd&&k<this.viewEnd;k++)if(_.path[k]!==this.path[k])return 1;return _.viewEnd>this.viewEnd?2:_.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let _=1;_<this.viewEnd;_++)this.stringifed+="\0",this.stringifed+=this.path[_]}return this.stringifed}}e.TestId=D}),define(De[64],Ie([1,0,2,35]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var D;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(D=e.TestResultState||(e.TestResultState={}));var P;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(P=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(r){r.serialize=a=>({range:a.range.toJSON(),uri:a.uri.toJSON()}),r.deserialize=a=>({range:t.Range.lift(a.range),uri:l.URI.revive(a.uri)})})(_=e.IRichLocation||(e.IRichLocation={}));var k;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(k=e.TestMessageType||(e.TestMessageType={}));var w;(function(r){r.serialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&_.serialize(a.location)}),r.deserialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&_.deserialize(a.location)})})(w=e.ITestErrorMessage||(e.ITestErrorMessage={}));var I;(function(r){r.serialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&_.serialize(a.location)}),r.deserialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&_.deserialize(a.location)})})(I=e.ITestOutputMessage||(e.ITestOutputMessage={}));var L;(function(r){r.serialize=a=>a.type===0?w.serialize(a):I.serialize(a),r.deserialize=a=>a.type===0?w.deserialize(a):I.deserialize(a)})(L=e.ITestMessage||(e.ITestMessage={}));var y;(function(r){r.serializeWithoutMessages=a=>({state:a.state,duration:a.duration,messages:[]}),r.serialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(L.serialize)}),r.deserialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(L.deserialize)})})(y=e.ITestTaskState||(e.ITestTaskState={}));const S="\0",T=(r,a)=>r+S+a;e.namespaceTestTag=T;const E=r=>{const a=r.indexOf(S);return{ctrlId:r.slice(0,a),tagId:r.slice(a+1)}};e.denamespaceTestTag=E;var p;(function(r){r.serialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?.toJSON(),range:a.range?.toJSON()||null,description:a.description,error:a.error,sortText:a.sortText}),r.deserialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?l.URI.revive(a.uri):void 0,range:a.range?t.Range.lift(a.range):null,description:a.description,error:a.error,sortText:a.sortText})})(p=e.ITestItem||(e.ITestItem={}));var b;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var f;(function(r){r.serialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:p.serialize(a.item)}),r.deserialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:p.deserialize(a.item)})})(f=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(r){r.serialize=a=>{let o;return a.item&&(o={},a.item.label!==void 0&&(o.label=a.item.label),a.item.tags!==void 0&&(o.tags=a.item.tags),a.item.busy!==void 0&&(o.busy=a.item.busy),a.item.uri!==void 0&&(o.uri=a.item.uri?.toJSON()),a.item.range!==void 0&&(o.range=a.item.range?.toJSON()),a.item.description!==void 0&&(o.description=a.item.description),a.item.error!==void 0&&(o.error=a.item.error),a.item.sortText!==void 0&&(o.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:o,docv:a.docv}},r.deserialize=a=>{let o;return a.item&&(o={},a.item.label!==void 0&&(o.label=a.item.label),a.item.tags!==void 0&&(o.tags=a.item.tags),a.item.busy!==void 0&&(o.busy=a.item.busy),a.item.range!==void 0&&(o.range=a.item.range?t.Range.lift(a.item.range):null),a.item.description!==void 0&&(o.description=a.item.description),a.item.error!==void 0&&(o.error=a.item.error),a.item.sortText!==void 0&&(o.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:o,docv:a.docv}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const g=(r,a)=>{a.expand!==void 0&&(r.expand=a.expand),a.item!==void 0&&(r.item=r.item?Object.assign(r.item,a.item):a.item)};e.applyTestItemUpdate=g;var c;(function(r){r.serializeWithoutMessages=a=>({...f.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(y.serializeWithoutMessages),retired:a.retired}),r.serialize=a=>({...f.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(y.serialize),retired:a.retired})})(c=e.TestResultItem||(e.TestResultItem={}));var m;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(m=e.DetailType||(e.DetailType={}));var n;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(n=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(r){r.deserialize=a=>a.op===0?{op:a.op,item:f.deserialize(a.item)}:a.op===1?{op:a.op,item:v.deserialize(a.item)}:a,r.serialize=a=>a.op===0?{op:a.op,item:f.serialize(a.item)}:a.op===1?{op:a.op,item:v.serialize(a.item)}:a})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class s{add(a){}update(a){}remove(a,o){}complete(){}}e.IncrementalChangeCollector=s;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const o=this.createChangeCollector();for(const u of a)switch(u.op){case 0:{const h=f.deserialize(u.item);if(h.parent){if(this.items.has(h.parent)){const C=this.items.get(h.parent);C.children.add(h.item.extId);const R=this.createItem(h,C);this.items.set(h.item.extId,R),o.add(R)}}else{const C=this.createItem(h);this.roots.add(C),this.items.set(h.item.extId,C),o.add(C)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=v.deserialize(u.item),C=this.items.get(h.extId);if(!C)break;h.expand!==void 0&&(C.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(C,h),o.update(C);break}case 2:{const h=this.items.get(u.itemId);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h);const C=[[u.itemId]];for(;C.length;)for(const R of C.pop()){const N=this.items.get(R);N&&(C.push(N.children),this.items.delete(R),o.remove(N,N!==h),N.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(u.itemId);break;case 3:this.updatePendingRoots(u.amount);break;case 5:this._tags.set(u.tag.id,u.tag);break;case 6:this._tags.delete(u.id);break}o.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new s}}e.AbstractIncrementalTestCollection=i}),define(De[90],Ie([1,0,18,4,6,48,64,63]),function(J,e,l,t,D,P,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var w;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk"})(w=e.TestItemEventOp||(e.TestItemEventOp={}));const I=(f,v)=>f===v,L={range:(f,v)=>f===v?!0:!f||!v?!1:f.equalsRange(v),busy:I,label:I,description:I,error:I,tags:(f,v)=>!(f.length!==v.length||f.some(g=>!v.includes(g)))},y=(f,v)=>{let g;for(const[c,m]of Object.entries(L))m(f[c],v[c])||(g?g[c]=v[c]:g={[c]:v[c]});return g};class S extends D.Disposable{constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new l.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(v){this._resolveHandler=v;for(const g of this.tree.values())this.updateExpandability(g)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){const g=this.diff[this.diff.length-1];if(g&&v.op===1){if(g.op===1&&g.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(g.item,v.item);return}if(g.op===0&&g.item.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(g.item,v.item);return}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,g){const c=this.tree.get(v);if(!!c){if((c.expandLevels===void 0||g>c.expandLevels)&&(c.expandLevels=g),c.expand===1){const m=this.resolveChildren(c);return m.isOpen()?this.expandChildren(c,g-1):m.wait().then(()=>this.expandChildren(c,g-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,g-1)):this.expandChildren(c,g-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,g){switch(g.op){case 3:this.removeItem(k.TestId.joinToString(v.fullId,g.id));break;case 0:this.upsertItem(g.item,v);break;case 5:for(const c of g.ops)this.onTestItemEvent(v,c);break;case 1:this.diffTagRefs(g.new,g.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:g.update,docv:this.options.getDocumentVersion(v.actual.uri)}});break;default:(0,P.assertNever)(g)}}upsertItem(v,g){const c=k.TestId.fromExtHostTestItem(v,this.root.id,g?.actual),m=this.options.getApiFor(v);m.parent&&m.parent!==g?.actual&&this.options.getChildren(m.parent).delete(v.id);let n=this.tree.get(c.toString());if(!n){n={fullId:c,actual:v,parent:g?c.parentId:null,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(n.fullId.toString(),n),this.setItemParent(v,g),this.pushDiff({op:0,item:{parent:n.parent&&n.parent.toString(),controllerId:this.options.controllerId,expand:n.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,n,g);return}if(n.actual===v){this.connectItem(v,n,g);return}const d=this.options.getChildren(n.actual),s=n.actual,i=y(this.options.toITestItem(s),this.options.toITestItem(v));this.options.getApiFor(s).listener=void 0,n.actual=v,n.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,s.tags,c.toString()),delete i.tags),this.onTestItemEvent(n,{op:4,update:i})),this.connectItemAndChildren(v,n,g);for(const[r,a]of d)this.options.getChildren(v).get(a.id)||this.removeItem(k.TestId.joinToString(c,a.id))}diffTagRefs(v,g,c){const m=new Set(g.map(n=>n.id));for(const n of v)m.delete(n.id)||this.incrementTagRefs(n);this.pushDiff({op:1,item:{extId:c,item:{tags:v.map(n=>(0,_.namespaceTestTag)(this.options.controllerId,n.id))}}}),m.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const g=this.tags.get(v.id);g?g.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,_.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const g=this.tags.get(v);g&&!--g.refCount&&(this.tags.delete(v),this.pushDiff({op:6,id:(0,_.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,g){this.options.getApiFor(v).parent=g&&g.actual!==this.root?g.actual:void 0}connectItem(v,g,c){this.setItemParent(v,c);const m=this.options.getApiFor(v);m.parent=c?.actual,m.listener=n=>this.onTestItemEvent(g,n),this.updateExpandability(g)}connectItemAndChildren(v,g,c){this.connectItem(v,g,c);for(const[m,n]of this.options.getChildren(v))this.upsertItem(n,g)}updateExpandability(v){let g;this._resolveHandler?v.resolveBarrier?g=v.resolveBarrier.isOpen()?3:2:g=v.actual.canResolveChildren?1:0:g=0,g!==v.expand&&(v.expand=g,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:g}}),g===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,g){if(g<0)return;const c=[];for(const[m,n]of this.options.getChildren(v.actual)){const d=this.expand(k.TestId.joinToString(v.fullId,n.id),g);(0,l.isThenable)(d)&&c.push(d)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const n=new l.Barrier;return n.open(),n}v.expand=2,this.pushExpandStateUpdate(v);const g=v.resolveBarrier=new l.Barrier,c=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,n)};let m;try{m=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(n){c(n)}return(0,l.isThenable)(m)?m.catch(c).then(()=>{g.open(),this.updateExpandability(v)}):(g.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const g=this.tree.get(v);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:v});const c=[g];for(;c.length;){const m=c.pop();if(!!m){this.options.getApiFor(m.actual).listener=void 0;for(const n of m.actual.tags)this.decrementTagRefs(n.id);this.tree.delete(m.fullId.toString());for(const[n,d]of this.options.getChildren(m.actual))c.push(this.tree.get(k.TestId.joinToString(m.fullId,d.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=S;class T extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=T;class E extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class p extends Error{constructor(v,g,c){super(`TestItem with ID "${v}" is from controller "${g}" and cannot be added as a child of an item from controller "${c}".`)}}e.MixedTestItemController=p;const b=(f,v,g)=>{let c=new Map;return{get size(){return c.size},forEach(m,n){for(const d of c.values())m.call(n,d,this)},[Symbol.iterator](){return c.entries()},replace(m){const n=new Map,d=new Set(c.keys()),s={op:5,ops:[]};for(const i of m){if(!(i instanceof g))throw new E(i.id);const r=v(i).controllerId;if(r!==f.controllerId)throw new p(i.id,r,f.controllerId);if(n.has(i.id))throw new T(i.id);n.set(i.id,i),d.delete(i.id),s.ops.push({op:0,item:i})}for(const i of d.keys())s.ops.push({op:3,id:i});f.listener?.(s),c=n},add(m){if(!(m instanceof g))throw new E(m.id);c.set(m.id,m),f.listener?.({op:0,item:m})},delete(m){c.delete(m)&&f.listener?.({op:3,id:m})},get(m){return c.get(m)},toJSON(){return Array.from(c.values())}}};e.createTestItemChildren=b}),define(De[129],Ie([1,0,90]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,D=(_,k)=>{const w={controllerId:k};return t.set(_,w),w};e.createPrivateApiFor=D;const P=_=>{const k=t.get(_);if(!k)throw new l.InvalidTestItemError(_?.id||"<unknown>");return k};e.getPrivateApiFor=P}),define(De[217],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,l.createDecorator)("configurationResolverService");var t;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(_,k){super(k),this.variable=_}}e.VariableError=D}),define(De[218],Ie([1,0,9,40,16,24,11,108,185,217,8]),function(J,e,l,t,D,P,_,k,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class y{constructor(T,E,p,b){this._contributedVariables=new Map,this._context=T,this._labelService=E,this._userHomePromise=p,b&&(this._envVariablesPromise=b.then(f=>this.prepareEnv(f)))}prepareEnv(T){if(_.isWindows){const E=Object.create(null);return Object.keys(T).forEach(p=>{E[p.toLowerCase()]=T[p]}),E}return T}resolveWithEnvironment(T,E,p){return this.recursiveResolve({env:this.prepareEnv(T),userHome:void 0},E?E.uri:void 0,p)}async resolveAsync(T,E){const p={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(p,T?T.uri:void 0,E)}async resolveAnyBase(T,E,p,b){const f=P.deepClone(E);_.isWindows&&f.windows?Object.keys(f.windows).forEach(g=>f[g]=f.windows[g]):_.isMacintosh&&f.osx?Object.keys(f.osx).forEach(g=>f[g]=f.osx[g]):_.isLinux&&f.linux&&Object.keys(f.linux).forEach(g=>f[g]=f.linux[g]),delete f.windows,delete f.osx,delete f.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,T?T.uri:void 0,f,p,b)}async resolveAnyAsync(T,E,p){return this.resolveAnyBase(T,E,p)}async resolveAnyMap(T,E,p){const b=new Map;return{newConfig:await this.resolveAnyBase(T,E,p,b),resolvedVariables:b}}resolveWithInteractionReplace(T,E,p,b){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,E,p,b){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,E){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,E)}async recursiveResolve(T,E,p,b,f){if(D.isString(p))return this.resolveString(T,E,p,b,f);if(Array.isArray(p))return Promise.all(p.map(v=>this.recursiveResolve(T,E,v,b,f)));if(D.isObject(p)){const v=Object.create(null),g=await Promise.all(Object.keys(p).map(async c=>[await this.resolveString(T,E,c,b,f),await this.recursiveResolve(T,E,p[c],b,f)]));for(const[c,m]of g)v[c]=m;return v}return p}resolveString(T,E,p,b,f){return(0,L.replaceAsync)(p,y.VARIABLE_REGEXP,async(v,g)=>{if(g.includes(y.VARIABLE_LHS))return v;let c=await this.evaluateSingleVariable(T,v,g,E,b);return f?.set(g,c),c!==v&&D.isString(c)&&c.match(y.VARIABLE_REGEXP)&&(c=await this.resolveString(T,E,c,b,f)),c})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}async evaluateSingleVariable(T,E,p,b,f){let v;const g=p.split(":");g.length>1&&(p=g[0],v=g[1]);const c=d=>{const s=this._context.getFilePath();if(s)return s;throw new I.VariableError(d,(0,w.localize)(0,null,E))},m=d=>{const s=c(d);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new I.VariableError(d,(0,w.localize)(1,null,E,l.basename(s)))},n=d=>{if(v){const s=this._context.getFolderUri(v);if(s)return s;throw new I.VariableError(d,(0,w.localize)(2,null,E,v))}if(b)return b;throw this._context.getWorkspaceFolderCount()>1?new I.VariableError(d,(0,w.localize)(3,null,E)):new I.VariableError(d,(0,w.localize)(4,null,E))};switch(p){case"env":if(v){if(T.env){const d=T.env[_.isWindows?v.toLowerCase():v];if(D.isString(d))return d}return""}throw new I.VariableError(I.VariableKind.Env,(0,w.localize)(5,null,E));case"config":if(v){const d=this._context.getConfigurationValue(b,v);if(D.isUndefinedOrNull(d))throw new I.VariableError(I.VariableKind.Config,(0,w.localize)(6,null,E,v));if(D.isObject(d))throw new I.VariableError(I.VariableKind.Config,(0,w.localize)(7,null,E,v));return d}throw new I.VariableError(I.VariableKind.Config,(0,w.localize)(8,null,E));case"command":return this.resolveFromMap(I.VariableKind.Command,E,v,f,"command");case"input":return this.resolveFromMap(I.VariableKind.Input,E,v,f,"input");case"extensionInstallFolder":if(v){const d=await this._context.getExtension(v);if(!d)throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,E,v));return this.fsPath(d.extensionLocation)}throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,E));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(n(I.VariableKind.WorkspaceFolder)));case"cwd":return b||v?(0,k.normalizeDriveLetter)(this.fsPath(n(I.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return l.basename(this.fsPath(n(I.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(T.userHome)return T.userHome;throw new I.VariableError(I.VariableKind.UserHome,(0,w.localize)(11,null,E))}case"lineNumber":{const d=this._context.getLineNumber();if(d)return d;throw new I.VariableError(I.VariableKind.LineNumber,(0,w.localize)(12,null,E))}case"selectedText":{const d=this._context.getSelectedText();if(d)return d;throw new I.VariableError(I.VariableKind.SelectedText,(0,w.localize)(13,null,E))}case"file":return c(I.VariableKind.File);case"fileWorkspaceFolder":return m(I.VariableKind.FileWorkspaceFolder);case"relativeFile":return b||v?l.relative(this.fsPath(n(I.VariableKind.RelativeFile)),c(I.VariableKind.RelativeFile)):c(I.VariableKind.RelativeFile);case"relativeFileDirname":{const d=l.dirname(c(I.VariableKind.RelativeFileDirname));if(b||v){const s=l.relative(this.fsPath(n(I.VariableKind.RelativeFileDirname)),d);return s.length===0?".":s}return d}case"fileDirname":return l.dirname(c(I.VariableKind.FileDirname));case"fileExtname":return l.extname(c(I.VariableKind.FileExtname));case"fileBasename":return l.basename(c(I.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=l.basename(c(I.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-l.extname(d).length)}case"fileDirnameBasename":return l.basename(l.dirname(c(I.VariableKind.FileDirnameBasename)));case"execPath":{const d=this._context.getExecPath();return d||E}case"execInstallFolder":{const d=this._context.getAppRoot();return d||E}case"pathSeparator":return l.sep;default:try{const d=v?`${p}:${v}`:p;return this.resolveFromMap(I.VariableKind.Unknown,E,d,f,void 0)}catch{return E}}}}resolveFromMap(T,E,p,b,f){if(p&&b){const v=f===void 0?b[p]:b[f+":"+p];if(typeof v=="string")return v;throw new I.VariableError(T,(0,w.localize)(14,null,E))}return E}}e.AbstractVariableResolverService=y,y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[130],Ie([1,0,3,127]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,l.createDecorator)("editorGroupsService");var D;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var P;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var _;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(_=e.GroupLocation||(e.GroupLocation={}));var k;(function(E){E[E.MAXIMIZE=0]="MAXIMIZE",E[E.EVEN=1]="EVEN",E[E.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var w;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(w=e.MergeGroupMode||(e.MergeGroupMode={}));function I(E){const p=E;return(0,t.isEditorInput)(p?.editor)&&(0,t.isEditorInput)(p?.replacement)}e.isEditorReplacement=I;var L;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(y=e.OpenEditorContext||(e.OpenEditorContext={}));function S(E){const p=E;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=S;function T(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(De[219],Ie([1,0,3,130]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,l.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(P){const _=P;return typeof P=="number"||(0,t.isEditorGroup)(_)}e.isPreferredGroup=D}),define(De[220],Ie([1,0,3,190]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,l.refineServiceDecorator)(t.IEnvironmentService)}),define(De[221],Ie([1,0,28,4,9]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(y){this.removedDueToLooping=y}}e.DeltaExtensionsResult=P;class _{constructor(y){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=y,this._initialize()}_initialize(){this._extensionDescriptions.sort(w),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const y of this._extensionDescriptions){if(this._extensionsMap.has(l.ExtensionIdentifier.toKey(y.identifier))){console.error("Extension `"+y.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(l.ExtensionIdentifier.toKey(y.identifier),y),this._extensionsArr.push(y),Array.isArray(y.activationEvents))for(let S of y.activationEvents)S==="onUri"&&(S=`onUri:${l.ExtensionIdentifier.toKey(y.identifier)}`),this._activationMap.has(S)||this._activationMap.set(S,[]),this._activationMap.get(S).push(y)}}set(y){this._extensionDescriptions=y,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(y,S){this._extensionDescriptions=I(this._extensionDescriptions,S),this._extensionDescriptions=this._extensionDescriptions.concat(y);const T=_._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=I(this._extensionDescriptions,T.map(E=>E.identifier)),this._initialize(),this._onDidChange.fire(void 0),new P(T)}static _findLoopingExtensions(y){const S=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,v){this.addNode(f),this.addNode(v),this._arcs.has(f)?this._arcs.get(f).push(v):this._arcs.set(f,[v])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,v){const g=S.getArcs(f);for(let c=0;c<g.length;c++)if(!v.has(g[c]))return!1;return!0}getNodes(){return this._nodesArr}},T=new Map;for(const f of y){const v=l.ExtensionIdentifier.toKey(f.identifier);if(T.set(v,f),f.extensionDependencies)for(const g of f.extensionDependencies){const c=l.ExtensionIdentifier.toKey(g);S.addArc(v,c)}}const E=new Set;S.getNodes().filter(f=>S.getArcs(f).length===0).forEach(f=>E.add(f));const p=S.getNodes().filter(f=>!E.has(f));let b;do{b=!1;for(let f=0;f<p.length;f++){const v=p[f];S.hasOnlyGoodArcs(v,E)&&(p.splice(f,1),f--,E.add(v),b=!0)}}while(b);return p.map(f=>T.get(f))}containsActivationEvent(y){return this._activationMap.has(y)}containsExtension(y){return this._extensionsMap.has(l.ExtensionIdentifier.toKey(y))}getExtensionDescriptionsForActivationEvent(y){const S=this._activationMap.get(y);return S?S.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(y){const S=this._extensionsMap.get(l.ExtensionIdentifier.toKey(y));return S||void 0}getExtensionDescriptionByUUID(y){for(const S of this._extensionsArr)if(S.uuid===y)return S}getExtensionDescriptionByIdOrUUID(y,S){return this.getExtensionDescription(y)??(S?this.getExtensionDescriptionByUUID(S):void 0)}}e.ExtensionDescriptionRegistry=_;var k;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(k||(k={}));function w(L,y){const S=L.isBuiltin?0:L.isUnderDevelopment?2:1,T=y.isBuiltin?0:y.isUnderDevelopment?2:1;if(S!==T)return S-T;const E=D.posix.basename(L.extensionLocation.path),p=D.posix.basename(y.extensionLocation.path);return E<p?-1:E>p?1:0}function I(L,y){const S=new Set;return y.forEach(T=>S.add(l.ExtensionIdentifier.toKey(T))),L.filter(T=>!S.has(l.ExtensionIdentifier.toKey(T.identifier)))}}),define(De[222],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var l;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(l=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(y){this.pipeName=y,this.type=1}serialize(y){y[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class D{constructor(){this.type=2}serialize(y){y[D.ENV_KEY]="1"}}e.SocketExtHostConnection=D,D.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(y){y[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function _(L){delete L[t.ENV_KEY],delete L[D.ENV_KEY],delete L[P.ENV_KEY]}function k(L,y){_(y),L.serialize(y)}e.writeExtHostConnection=k;function w(L){if(L[t.ENV_KEY])return I(L,new t(L[t.ENV_KEY]));if(L[D.ENV_KEY])return I(L,new D);if(L[P.ENV_KEY])return I(L,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=w;function I(L,y){return _(L),y}}),define(De[131],Ie([1,0,23]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(I){I[I.Desktop=1]="Desktop",I[I.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var D;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function _(I){const L=l.VSBuffer.alloc(1);switch(I){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=_;function k(I,L){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=k;var w;(function(I){I.Start="START_NATIVE_LOG",I.End="END_NATIVE_LOG"})(w=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[27],Ie([1,0,4,2,3,28,199]),function(J,e,l,t,D,P,_){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class w{constructor(a){this.affinity=a,this.kind=1}equals(a){return this.kind===a.kind&&this.affinity===a.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=w;class I{constructor(){this.kind=2,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=I;class L{constructor(){this.kind=3,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class y{constructor(a){this.dependency=a}}e.MissingExtensionDependency=y;var S;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class E{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(a,o){const u=[],h=[],C=[],R=[],N=f(this._allExtensions),M=f(a),A=(G,B)=>G.extensionLocation.toString()===B.extensionLocation.toString()||G.isBuiltin===B.isBuiltin||G.isUserBuiltin===B.isUserBuiltin||G.isUnderDevelopment===B.isUnderDevelopment;for(const G of this._allExtensions){const B=M.get(P.ExtensionIdentifier.toKey(G.identifier));if(!B){u.push(G.identifier),N.delete(P.ExtensionIdentifier.toKey(G.identifier));continue}if(!A(G,B)){u.push(G.identifier),N.delete(P.ExtensionIdentifier.toKey(G.identifier));continue}}for(const G of a){const B=N.get(P.ExtensionIdentifier.toKey(G.identifier));if(!B){h.push(G);continue}if(!A(B,G)){u.push(B.identifier),N.delete(P.ExtensionIdentifier.toKey(B.identifier));continue}}const z=b(this._myExtensions),H=b(o);for(const G of this._myExtensions)H.has(P.ExtensionIdentifier.toKey(G))||C.push(G);for(const G of o)z.has(P.ExtensionIdentifier.toKey(G))||R.push(G);const F={toRemove:u,toAdd:h,myToRemove:C,myToAdd:R};return this.delta(F),F}delta(a){const{toRemove:o,toAdd:u,myToRemove:h,myToAdd:C}=a,R=b(o),N=b(h);for(let M=0;M<this._allExtensions.length;M++)R.has(P.ExtensionIdentifier.toKey(this._allExtensions[M].identifier))&&(this._allExtensions.splice(M,1),M--);for(let M=0;M<this._myExtensions.length;M++)N.has(P.ExtensionIdentifier.toKey(this._myExtensions[M]))&&(this._myExtensions.splice(M,1),M--);for(const M of u)this._allExtensions.push(M);for(const M of C)this._myExtensions.push(M)}containsExtension(a){for(const o of this._myExtensions)if(P.ExtensionIdentifier.equals(o,a))return!0;return!1}}e.ExtensionHostExtensions=E;class p{constructor(a){if(this[k]="ExtensionIdentifierSet",this._map=new Map,this._toKey=P.ExtensionIdentifier.toKey,a)for(const o of a)this.add(o)}get size(){return this._map.size}add(a){return this._map.set(this._toKey(a),a),this}clear(){this._map.clear()}delete(a){return this._map.delete(this._toKey(a))}has(a){return this._map.has(this._toKey(a))}forEach(a,o){this._map.forEach(u=>a.call(o,u,u,this))}*entries(){for(const[a,o]of this._map)yield[o,o]}keys(){return this._map.values()}values(){return this._map.values()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=p;function b(r){const a=new Set;for(const o of r)a.add(P.ExtensionIdentifier.toKey(o));return a}e.extensionIdentifiersArrayToSet=b;function f(r){const a=new Map;for(const o of r)a.set(P.ExtensionIdentifier.toKey(o.identifier),o);return a}function v(r,a){return r.enabledApiProposals?r.enabledApiProposals.includes(a):!1}e.isProposedApiEnabled=v;function g(r,a){if(!v(r,a))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=g;class c{constructor(a,o,u,h){this.codeLoadingTime=a,this.activateCallTime=o,this.activateResolvedTime=u,this.activationReason=h}}e.ActivationTimes=c;class m{constructor(a,o){this.description=a,this.value=o}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var n;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function d(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function s(r,a){return{identifier:new P.ExtensionIdentifier((0,_.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!a,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,browserNlsBundleUris:r.browserNlsBundleUris}}e.toExtensionDescription=s;class i{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a,o){return Promise.resolve(0)}getInspectPorts(a,o){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(a,o){return Promise.resolve()}}e.NullExtensionService=i}),define(De[223],Ie([1,0,10,28,27,13,18]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class k{constructor(b,f,v,g){this.startup=b,this.codeLoadingTime=f,this.activateCallTime=v,this.activateResolvedTime=g}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class w{constructor(b){this._startup=b,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(b,f){return b===-1||f===-1?-1:f-b}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=w;class I{constructor(b,f,v,g,c,m){this.activationFailed=b,this.activationFailedError=f,this.activationTimes=v,this.module=g,this.exports=c,this.subscriptions=m}}e.ActivatedExtension=I;class L extends I{constructor(b){super(!1,null,b,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class y extends I{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=y;class S extends I{constructor(b){super(!0,b,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=S;let T=class{constructor(b,f,v,g,c){this._logService=c,this._registry=b,this._resolvedExtensionsSet=new Set,f.forEach(m=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(m))),this._externalExtensionsMap=new Map,v.forEach(m=>this._externalExtensionsMap.set(t.ExtensionIdentifier.toKey(m),m)),this._host=g,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[b,f]of this._operations)f.dispose()}isActivated(b){const f=this._operations.get(t.ExtensionIdentifier.toKey(b));return Boolean(f&&f.value)}getActivatedExtension(b){const f=this._operations.get(t.ExtensionIdentifier.toKey(b));if(!f||!f.value)throw new Error(`Extension '${b.value}' is not known or not activated`);return f.value}async activateByEvent(b,f){if(this._alreadyActivatedEvents[b])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(b);await this._activateExtensions(v.map(g=>({id:g.identifier,reason:{startup:f,extensionId:g.identifier,activationEvent:b}}))),this._alreadyActivatedEvents[b]=!0}activateById(b,f){const v=this._registry.getExtensionDescription(b);if(!v)throw new Error(`Extension '${b}' is not known`);return this._activateExtensions([{id:v.identifier,reason:f}])}async _activateExtensions(b){const f=b.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(f.map(v=>v.wait()))}_handleActivationRequest(b){if(this._operations.has(t.ExtensionIdentifier.toKey(b.id)))return this._operations.get(t.ExtensionIdentifier.toKey(b.id));if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(b.id)))return this._createAndSaveOperation(b,null,[],null);const f=this._registry.getExtensionDescription(b.id);if(!f){const c=new Error(`Cannot activate unknown extension '${b.id.value}'`),m=this._createAndSaveOperation(b,null,[],new S(c));return this._host.onExtensionActivationError(b.id,c,new D.MissingExtensionDependency(b.id.value)),m}const v=[],g=typeof f.extensionDependencies>"u"?[]:f.extensionDependencies;for(const c of g){if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(c)))continue;const m=this._operations.get(t.ExtensionIdentifier.toKey(c));if(m){v.push(m);continue}if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(c))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(t.ExtensionIdentifier.toKey(c)),reason:b.reason}));continue}const n=this._registry.getExtensionDescription(c);if(n){if(!n.main&&!n.browser)continue;v.push(this._handleActivationRequest({id:n.identifier,reason:b.reason}));continue}const d=f.displayName||f.identifier.value,s=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${c}'`),i=this._createAndSaveOperation(b,f.displayName,[],new S(s));return this._host.onExtensionActivationError(f.identifier,s,new D.MissingExtensionDependency(c)),i}return this._createAndSaveOperation(b,f.displayName,v,null)}_createAndSaveOperation(b,f,v,g){const c=new E(b.id,f,b.reason,v,g,this._host,this._logService);return this._operations.set(t.ExtensionIdentifier.toKey(b.id),c),c}};T=qe([xe(4,P.ILogService)],T),e.ExtensionsActivator=T;let E=class{constructor(b,f,v,g,c,m,n){this._id=b,this._displayName=f,this._reason=v,this._deps=g,this._value=c,this._host=m,this._logService=n,this._barrier=new _.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let b=0;b<this._deps.length;b++){const f=this._deps[b];if(f.value&&!f.value.activationFailed){this._deps.splice(b,1),b--;continue}if(f.value&&f.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);v.detail=f.value.activationFailedError,this._value=new S(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(b=>b.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(b){const f=new Error;if(b&&b.name&&(f.name=b.name),b&&b.message?f.message=`Activating extension '${this._id.value}' failed: ${b.message}.`:f.message=`Activating extension '${this._id.value}' failed: ${b}.`,b&&b.stack&&(f.stack=b.stack),this._value=new S(f),this._isDisposed&&l.isCancellationError(b))return;this._host.onExtensionActivationError(this._id,f,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(b)}}};E=qe([xe(6,P.ILogService)],E)}),define(De[224],Ie([1,0,13,26,27]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends l.LogService{constructor(k,w){super(k.createLogger(w.logFile,{name:D.ExtensionHostLogFileName}))}};P=qe([xe(0,l.ILoggerService),xe(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[7],Ie([1,0,17,10,107,25,102,8,16,2,34,42,123,89,27]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E){"use strict";var p,b,f,v,g,c,m,n,d,s,i,r,a,o,u,h,C,R,N,M,A,z,H;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function F(j){function W(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(W,j),Object.setPrototypeOf(W.prototype,j.prototype),W}let G=c=class{constructor(W){p.set(this,void 0),tt(this,p,W,"f")}static from(...W){let he=W;return new c(function(){if(he){for(const Pe of he)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();he=void 0}})}dispose(){typeof Ue(this,p,"f")=="function"&&(Ue(this,p,"f").call(this),tt(this,p,void 0,"f"))}};p=new WeakMap,G=c=qe([F],G),e.Disposable=G;let B=m=class{constructor(W,he){if(W<0)throw(0,t.illegalArgument)("line must be non-negative");if(he<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=W,this._character=he}static Min(...W){if(W.length===0)throw new TypeError;let he=W[0];for(let Pe=1;Pe<W.length;Pe++){const Ke=W[Pe];Ke.isBefore(he)&&(he=Ke)}return he}static Max(...W){if(W.length===0)throw new TypeError;let he=W[0];for(let Pe=1;Pe<W.length;Pe++){const Ke=W[Pe];Ke.isAfter(he)&&(he=Ke)}return he}static isPosition(W){if(!W)return!1;if(W instanceof m)return!0;const{line:he,character:Pe}=W;return typeof he=="number"&&typeof Pe=="number"}static of(W){if(W instanceof m)return W;if(this.isPosition(W))return new m(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,he=0){if(W===null||he===null)throw(0,t.illegalArgument)();let Pe;return typeof W>"u"?Pe=0:typeof W=="number"?Pe=W:(Pe=typeof W.lineDelta=="number"?W.lineDelta:0,he=typeof W.characterDelta=="number"?W.characterDelta:0),Pe===0&&he===0?this:new m(this.line+Pe,this.character+he)}with(W,he=this.character){if(W===null||he===null)throw(0,t.illegalArgument)();let Pe;return typeof W>"u"?Pe=this.line:typeof W=="number"?Pe=W:(Pe=typeof W.line=="number"?W.line:this.line,he=typeof W.character=="number"?W.character:this.character),Pe===this.line&&he===this.character?this:new m(Pe,he)}toJSON(){return{line:this.line,character:this.character}}};B=m=qe([F],B),e.Position=B;let U=n=class{constructor(W,he,Pe,Ke){let et,lt;if(typeof W=="number"&&typeof he=="number"&&typeof Pe=="number"&&typeof Ke=="number"?(et=new B(W,he),lt=new B(Pe,Ke)):B.isPosition(W)&&B.isPosition(he)&&(et=B.of(W),lt=B.of(he)),!et||!lt)throw new Error("Invalid arguments");et.isBefore(lt)?(this._start=et,this._end=lt):(this._start=lt,this._end=et)}static isRange(W){return W instanceof n?!0:W?B.isPosition(W.start)&&B.isPosition(W.end):!1}static of(W){if(W instanceof n)return W;if(this.isRange(W))return new n(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(W){return n.isRange(W)?this.contains(W.start)&&this.contains(W.end):B.isPosition(W)?!(B.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const he=B.Max(W.start,this._start),Pe=B.Min(W.end,this._end);if(!he.isAfter(Pe))return new n(he,Pe)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const he=B.Min(W.start,this._start),Pe=B.Max(W.end,this.end);return new n(he,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,he=this.end){if(W===null||he===null)throw(0,t.illegalArgument)();let Pe;return W?B.isPosition(W)?Pe=W:(Pe=W.start||this.start,he=W.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&he.isEqual(this.end)?this:new n(Pe,he)}toJSON(){return[this.start,this.end]}};U=n=qe([F],U),e.Range=U;let X=d=class extends U{constructor(W,he,Pe,Ke){let et,lt;if(typeof W=="number"&&typeof he=="number"&&typeof Pe=="number"&&typeof Ke=="number"?(et=new B(W,he),lt=new B(Pe,Ke)):B.isPosition(W)&&B.isPosition(he)&&(et=B.of(W),lt=B.of(he)),!et||!lt)throw new Error("Invalid arguments");super(et,lt),this._anchor=et,this._active=lt}static isSelection(W){return W instanceof d?!0:W?U.isRange(W)&&B.isPosition(W.anchor)&&B.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};X=d=qe([F],X),e.Selection=X;class ${constructor(W,he,Pe){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("host");if(typeof he!="number"||he===0||Math.round(he)!==he)throw(0,t.illegalArgument)("port");if(typeof Pe<"u"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,t.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(he),this.connectionToken=Pe}}e.ResolvedAuthority=$;class x extends Error{constructor(W,he=S.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(W),this._message=W,this._code=he,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype)}static NotAvailable(W,he){return new x(W,S.RemoteAuthorityResolverErrorCode.NotAvailable,he)}static TemporarilyNotAvailable(W){return new x(W,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=x;var Q;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Q=e.EndOfLine||(e.EndOfLine={}));var de;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(de=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let te=s=class{constructor(W,he){this._range=W,this._newText=he}static isTextEdit(W){return W instanceof s?!0:W?U.isRange(W)&&typeof W.newText=="string":!1}static replace(W,he){return new s(W,he)}static insert(W,he){return s.replace(new U(W,W),he)}static delete(W){return s.replace(W,"")}static setEndOfLine(W){const he=new s(new U(new B(0,0),new B(0,0)),"");return he.newEol=W,he}get range(){return this._range}set range(W){if(W&&!U.isRange(W))throw(0,t.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,t.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,t.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};te=s=qe([F],te),e.TextEdit=te;let pe=i=class{constructor(W,he){this.range=W,this.newCells=he}static isNotebookCellEdit(W){return W instanceof i?!0:W?xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,he){return new i(W,he)}static insertCells(W,he){return new i(new xt(W,W),he)}static deleteCells(W){return new i(W,[])}static updateCellMetadata(W,he){const Pe=new i(new xt(W,W),[]);return Pe.newCellMetadata=he,Pe}static updateNotebookMetadata(W){const he=new i(new xt(0,0),[]);return he.newNotebookMetadata=W,he}};pe=i=qe([F],pe),e.NotebookEdit=pe;class Y{constructor(W,he){this.range=W,this.snippet=he}static isSnippetTextEdit(W){return W instanceof Y?!0:W?U.isRange(W.range)&&ke.isSnippetString(W.snippet):!1}static replace(W,he){return new Y(W,he)}static insert(W,he){return Y.replace(new U(W,W),he)}}e.SnippetTextEdit=Y;var ve;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(ve=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,he,Pe,Ke){this._edits.push({_type:1,from:W,to:he,options:Pe,metadata:Ke})}createFile(W,he,Pe){this._edits.push({_type:1,from:void 0,to:W,options:he,metadata:Pe})}deleteFile(W,he,Pe){this._edits.push({_type:1,from:W,to:void 0,options:he,metadata:Pe})}replaceNotebookMetadata(W,he,Pe){this._edits.push({_type:3,metadata:Pe,uri:W,edit:{editType:5,metadata:he},notebookMetadata:he})}replaceNotebookCells(W,he,Pe,Ke){const et=he.start,lt=he.end;(et!==lt||Pe.length>0)&&this._edits.push({_type:5,uri:W,index:et,count:lt-et,cells:Pe,metadata:Ke})}replaceNotebookCellMetadata(W,he,Pe,Ke){this._edits.push({_type:3,metadata:Ke,uri:W,edit:{editType:8,index:he,metadata:Pe}})}replace(W,he,Pe,Ke){this._edits.push({_type:2,uri:W,edit:new te(he,Pe),metadata:Ke})}insert(W,he,Pe,Ke){this.replace(W,new U(he,he),Pe,Ke)}delete(W,he,Pe){this.replace(W,he,"",Pe)}has(W){return this._edits.some(he=>he._type===2&&he.uri.toString()===W.toString())}set(W,he){if(he)for(const Pe of he){if(!Pe)continue;let Ke,et;Array.isArray(Pe)?(Ke=Pe[0],et=Pe[1]):Ke=Pe,pe.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.replaceNotebookCellMetadata(W,Ke.range.start,Ke.newCellMetadata,et):Ke.newNotebookMetadata?this.replaceNotebookMetadata(W,Ke.newNotebookMetadata,et):this.replaceNotebookCells(W,Ke.range,Ke.newCells,et):Y.isSnippetTextEdit(Ke)?this._edits.push({_type:6,uri:W,range:Ke.range,edit:Ke.snippet,metadata:et}):this._edits.push({_type:2,uri:W,edit:Ke,metadata:et})}else{for(let Pe=0;Pe<this._edits.length;Pe++){const Ke=this._edits[Pe];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===W.toString()&&(this._edits[Pe]=void 0);break}}(0,l.coalesceInPlace)(this._edits)}}get(W){const he=[];for(const Pe of this._edits)Pe._type===2&&Pe.uri.toString()===W.toString()&&he.push(Pe.edit);return he}entries(){const W=new P.ResourceMap;for(const he of this._edits)if(he._type===2){let Pe=W.get(he.uri);Pe||(Pe=[he.uri,[]],W.set(he.uri,Pe)),Pe[1].push(he.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=qe([F],be),e.WorkspaceEdit=be;let ke=r=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof r?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=r._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,he=this._tabstop++){if(typeof W=="function"){const Pe=new r;Pe._tabstop=this._tabstop,W(Pe),this._tabstop=Pe._tabstop,W=Pe.value}else W=r._escape(W);return this.value+="${",this.value+=he,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,he=this._tabstop++){const Pe=W.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=he,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(W,he){if(typeof he=="function"){const Pe=new r;Pe._tabstop=this._tabstop,he(Pe),this._tabstop=Pe._tabstop,he=Pe.value}else typeof he=="string"&&(he=he.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,he&&(this.value+=":",this.value+=he),this.value+="}",this}};ke=r=qe([F],ke),e.SnippetString=ke;var Re;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(Re=e.DiagnosticTag||(e.DiagnosticTag={}));var We;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(We=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=a=class{constructor(W,he){if(this.uri=W,he)if(U.isRange(he))this.range=U.of(he);else if(B.isPosition(he))this.range=new U(he,he);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof a?!0:W?U.isRange(W.range)&&I.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};oe=a=qe([F],oe),e.Location=oe;let le=class{constructor(W,he){this.location=W,this.message=he}static is(W){return W?typeof W.message=="string"&&W.location&&U.isRange(W.location.range)&&I.URI.isUri(W.location.uri):!1}static isEqual(W,he){return W===he?!0:!W||!he?!1:W.message===he.message&&W.location.range.isEqual(he.location.range)&&W.location.uri.toString()===he.location.uri.toString()}};le=qe([F],le),e.DiagnosticRelatedInformation=le;let fe=class{constructor(W,he,Pe=We.Error){if(!U.isRange(W))throw new TypeError("range must be set");if(!he)throw new TypeError("message must be set");this.range=W,this.message=he,this.severity=Pe}toJSON(){return{severity:We[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,he){return W===he?!0:!W||!he?!1:W.message===he.message&&W.severity===he.severity&&W.code===he.code&&W.severity===he.severity&&W.source===he.source&&W.range.isEqual(he.range)&&(0,l.equals)(W.tags,he.tags)&&(0,l.equals)(W.relatedInformation,he.relatedInformation,le.isEqual)}};fe=qe([F],fe),e.Diagnostic=fe;let Z=class{constructor(W,he){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=he}};Z=qe([F],Z),e.Hover=Z;var ae;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ne=class{constructor(W,he=ae.Text){this.range=W,this.kind=he}toJSON(){return{range:this.range,kind:ae[this.kind]}}};ne=qe([F],ne),e.DocumentHighlight=ne;var ie;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ie=e.SymbolKind||(e.SymbolKind={}));var O;(function(j){j[j.Deprecated=1]="Deprecated"})(O=e.SymbolTag||(e.SymbolTag={}));let V=o=class{constructor(W,he,Pe,Ke,et){this.name=W,this.kind=he,this.containerName=et,typeof Pe=="string"&&(this.containerName=Pe),Ke instanceof oe?this.location=Ke:Pe instanceof U&&(this.location=new oe(Ke,Pe)),o.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};V=o=qe([F],V),e.SymbolInformation=V;let q=u=class{constructor(W,he,Pe,Ke,et){this.name=W,this.detail=he,this.kind=Pe,this.range=Ke,this.selectionRange=et,this.children=[],u.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(u.validate)}};q=u=qe([F],q),e.DocumentSymbol=q;var K;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(K=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let me=class{constructor(W,he){this.title=W,this.kind=he}};me=qe([F],me),e.CodeAction=me;let we=h=class{constructor(W){this.value=W}append(W){return new h(this.value?this.value+h.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+h.sep)}};we.sep=".",we=h=qe([F],we),e.CodeActionKind=we,we.Empty=new we(""),we.QuickFix=we.Empty.append("quickfix"),we.Refactor=we.Empty.append("refactor"),we.RefactorExtract=we.Refactor.append("extract"),we.RefactorInline=we.Refactor.append("inline"),we.RefactorMove=we.Refactor.append("move"),we.RefactorRewrite=we.Refactor.append("rewrite"),we.Source=we.Empty.append("source"),we.SourceOrganizeImports=we.Source.append("organizeImports"),we.SourceFixAll=we.Source.append("fixAll");let ce=class{constructor(W,he){if(this.range=W,this.parent=he,he&&!he.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ce=qe([F],ce),e.SelectionRange=ce;class Ce{constructor(W,he,Pe,Ke,et,lt){this.kind=W,this.name=he,this.detail=Pe,this.uri=Ke,this.range=et,this.selectionRange=lt}}e.CallHierarchyItem=Ce;class ye{constructor(W,he){this.fromRanges=he,this.from=W}}e.CallHierarchyIncomingCall=ye;class He{constructor(W,he){this.fromRanges=he,this.to=W}}e.CallHierarchyOutgoingCall=He;var je;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ze=class{constructor(W,he){this.range=W,this.command=he}get isResolved(){return!!this.command}};Ze=qe([F],Ze),e.CodeLens=Ze;let Qe=C=class{constructor(W,he=!1){b.set(this,void 0),tt(this,b,new D.MarkdownString(W,{supportThemeIcons:he}),"f")}static isMarkdownString(W){return W instanceof C?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return Ue(this,b,"f").value}set value(W){Ue(this,b,"f").value=W}get isTrusted(){return Ue(this,b,"f").isTrusted}set isTrusted(W){Ue(this,b,"f").isTrusted=W}get supportThemeIcons(){return Ue(this,b,"f").supportThemeIcons}set supportThemeIcons(W){Ue(this,b,"f").supportThemeIcons=W}get supportHtml(){return Ue(this,b,"f").supportHtml}set supportHtml(W){Ue(this,b,"f").supportHtml=W}get baseUri(){return Ue(this,b,"f").baseUri}set baseUri(W){Ue(this,b,"f").baseUri=W}appendText(W){return Ue(this,b,"f").appendText(W),this}appendMarkdown(W){return Ue(this,b,"f").appendMarkdown(W),this}appendCodeblock(W,he){return Ue(this,b,"f").appendCodeblock(he??"",W),this}};b=new WeakMap,Qe=C=qe([F],Qe),e.MarkdownString=Qe;let Le=class{constructor(W,he){this.label=W,this.documentation=he}};Le=qe([F],Le),e.ParameterInformation=Le;let rt=class{constructor(W,he){this.label=W,this.documentation=he,this.parameters=[]}};rt=qe([F],rt),e.SignatureInformation=rt;let re=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};re=qe([F],re),e.SignatureHelp=re;var se;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(se=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Se;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Se=e.InlayHintKind||(e.InlayHintKind={}));let ue=class{constructor(W){this.value=W}};ue=qe([F],ue),e.InlayHintLabelPart=ue;let Te=class{constructor(W,he,Pe){this.position=W,this.label=he,this.kind=Pe}};Te=qe([F],Te),e.InlayHint=Te;var Me;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Me=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var ze;(function(j){j[j.Deprecated=1]="Deprecated"})(ze=e.CompletionItemTag||(e.CompletionItemTag={}));let Ye=class{constructor(W,he){this.label=W,this.kind=he}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ye=qe([F],Ye),e.CompletionItem=Ye;let nt=class{constructor(W=[],he=!1){this.items=W,this.isIncomplete=he}};nt=qe([F],nt),e.CompletionList=nt;let ct=class{constructor(W,he,Pe){this.insertText=W,this.range=he,this.command=Pe}};ct=qe([F],ct),e.InlineSuggestion=ct;let pt=class{constructor(W){this.commands=void 0,this.items=W}};pt=qe([F],pt),e.InlineSuggestionList=pt;let Je=class{constructor(W,he,Pe){this.insertText=W,this.range=he,this.command=Pe}};Je=qe([F],Je),e.InlineSuggestionNew=Je;let st=class{constructor(W,he){this.items=W,this.commands=he}};st=qe([F],st),e.InlineSuggestionsNew=st;var Et;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var Lt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Dt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Dt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ft;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Pt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Pt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ut;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Wt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Wt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Xe;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Xe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function W(he){switch(he){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=W}(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(W,he){if(he&&!I.URI.isUri(he))throw(0,t.illegalArgument)("target");if(!U.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.target=he}};Ft=qe([F],Ft),e.DocumentLink=Ft;let At=class{constructor(W,he,Pe,Ke){this.red=W,this.green=he,this.blue=Pe,this.alpha=Ke}};At=qe([F],At),e.Color=At;let Nt=class{constructor(W,he){if(he&&!(he instanceof At))throw(0,t.illegalArgument)("color");if(!U.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.color=he}};Nt=qe([F],Nt),e.ColorInformation=Nt;let gt=class{constructor(W){if(!W||typeof W!="string")throw(0,t.illegalArgument)("label");this.label=W}};gt=qe([F],gt),e.ColorPresentation=gt;var Ae;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Ae=e.ColorFormat||(e.ColorFormat={}));var Oe;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Oe=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var _e;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(_e=e.TerminalExitReason||(e.TerminalExitReason={}));class ee{constructor(W,he,Pe){if(this.startIndex=W,this.length=he,this.tooltip=Pe,typeof W!="number"||W<0)throw(0,t.illegalArgument)("startIndex");if(typeof he!="number"||he<1)throw(0,t.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=ee;var Fe;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Fe=e.TerminalLocation||(e.TerminalLocation={}));class Ve{constructor(W){if(this.options=W,typeof W!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ve;var ot;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ot=e.TaskRevealKind||(e.TaskRevealKind={}));var Ge;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Ge=e.TaskPanelKind||(e.TaskPanelKind={}));let it=R=class{constructor(W,he){if(this.label=he,typeof W!="string"||typeof he!="string")throw(0,t.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return R.Clean;case"build":return R.Build;case"rebuild":return R.Rebuild;case"test":return R.Test;default:return}}get id(){return this._id}};it.Clean=new R("clean","Clean"),it.Build=new R("build","Build"),it.Rebuild=new R("rebuild","Rebuild"),it.Test=new R("test","Test"),it=R=qe([F],it),e.TaskGroup=it;function ut(j){let W="";for(let he=0;he<j.length;he++)W+=j[he].replace(/,/g,",,")+",";return W}let mt=class{constructor(W,he,Pe){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=W,he!==void 0&&(Array.isArray(he)?(this._args=he,this._options=Pe):this._options=he)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const he of this._args)W.push(he);return ut(W)}};mt=qe([F],mt),e.ProcessExecution=mt;let It=class{constructor(W,he,Pe){if(this._args=[],Array.isArray(he)){if(!W)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W,this._args=he,this._options=Pe}else{if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W,this._options=he}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const he of this._args)W.push(typeof he=="string"?he:he.value);return ut(W)}};It=qe([F],It),e.ShellExecution=It;var wt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(wt=e.ShellQuoting||(e.ShellQuoting={}));var _t;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(_t=e.TaskScope||(e.TaskScope={}));class Rt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Rt;let St=N=class{constructor(W,he,Pe,Ke,et,lt){this.__deprecated=!1,this._definition=this.definition=W;let ht;typeof he=="string"?(this._name=this.name=he,this._source=this.source=Pe,this.execution=Ke,ht=et,this.__deprecated=!0):he===_t.Global||he===_t.Workspace?(this.target=he,this._name=this.name=Pe,this._source=this.source=Ke,this.execution=et,ht=lt):(this.target=he,this._name=this.name=Pe,this._source=this.source=Ke,this.execution=et,ht=lt),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof mt?this._definition={type:N.ProcessType,id:this._execution.computeId()}:this._execution instanceof It?this._definition={type:N.ShellType,id:this._execution.computeId()}:this._execution instanceof Rt?this._definition={type:N.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:N.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const he=this._definition.type;(N.EmptyType===he||N.ProcessType===he||N.ShellType===he||N.ExtensionCallbackType===he)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};St.ExtensionCallbackType="customExecution",St.ProcessType="process",St.ShellType="shell",St.EmptyType="$empty",St=N=qe([F],St),e.Task=St;var kt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(kt=e.ProgressLocation||(e.ProgressLocation={}));let Yt=M=class{constructor(W,he=qt.None){this.collapsibleState=he,I.URI.isUri(W)?this.resourceUri=W:this.label=W}static isTreeItem(W,he){if(W instanceof M)return!0;const Pe=W;if(Pe.label!==void 0&&!(0,w.isString)(Pe.label)&&!Pe.label?.label)return console.log("INVALID tree item, invalid label",Pe.label),!1;if(Pe.id!==void 0&&!(0,w.isString)(Pe.id))return console.log("INVALID tree item, invalid id",Pe.id),!1;if(Pe.iconPath!==void 0&&!(0,w.isString)(Pe.iconPath)&&!I.URI.isUri(Pe.iconPath)&&(!Pe.iconPath||!(0,w.isString)(Pe.iconPath.id))){const Ke=Pe.iconPath;if(!Ke||!(0,w.isString)(Ke.light)&&!I.URI.isUri(Ke.light)&&!(0,w.isString)(Ke.dark)&&!I.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Pe.iconPath),!1}if(Pe.description!==void 0&&!(0,w.isString)(Pe.description)&&typeof Pe.description!="boolean")return console.log("INVALID tree item, invalid description",Pe.description),!1;if(Pe.resourceUri!==void 0&&!I.URI.isUri(Pe.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Pe.resourceUri),!1;if(Pe.tooltip!==void 0&&!(0,w.isString)(Pe.tooltip)&&!(Pe.tooltip instanceof Qe))return console.log("INVALID tree item, invalid tooltip",Pe.tooltip),!1;if(Pe.command!==void 0&&!Pe.command.command)return console.log("INVALID tree item, invalid command",Pe.command),!1;if(Pe.collapsibleState!==void 0&&Pe.collapsibleState<qt.None&&Pe.collapsibleState>qt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Pe.collapsibleState),!1;if(Pe.contextValue!==void 0&&!(0,w.isString)(Pe.contextValue))return console.log("INVALID tree item, invalid contextValue",Pe.contextValue),!1;if(Pe.accessibilityInformation!==void 0&&!Pe.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Pe.accessibilityInformation),!1;if(Pe.checkboxState!==void 0){(0,E.checkProposedApiEnabled)(he,"treeItemCheckbox");const Ke=(0,w.isNumber)(Pe.checkboxState)?Pe.checkboxState:(0,w.isObject)(Pe.checkboxState)&&(0,w.isNumber)(Pe.checkboxState.state)?Pe.checkboxState.state:void 0,et=!(0,w.isNumber)(Pe.checkboxState)&&(0,w.isObject)(Pe.checkboxState)?Pe.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==bt.Checked&&Ke!==bt.Unchecked||et!==void 0&&!(0,w.isString)(et))return console.log("INVALID tree item, invalid checkboxState",Pe.checkboxState),!1}return!0}};Yt=M=qe([F],Yt),e.TreeItem=Yt;var qt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(qt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var bt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(bt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let tn=class{constructor(W,he){this.value=W,this.id=he??(0,L.generateUuid)()}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};tn=qe([F],tn),e.DataTransferItem=tn;let nn=class{constructor(W){f.set(this,new Map);for(const[he,Pe]of W??[]){const Ke=Ue(this,f,"f").get(he);Ke?Ke.push(Pe):Ue(this,f,"f").set(he,[Pe])}}get(W){return Ue(this,f,"f").get(W)?.[0]}set(W,he){Ue(this,f,"f").set(W,[he])}forEach(W,he){for(const[Pe,Ke]of Ue(this,f,"f"))for(const et of Ke)W.call(he,et,Pe,this)}*[(f=new WeakMap,Symbol.iterator)](){for(const[W,he]of Ue(this,f,"f"))for(const Pe of he)yield[W,Pe]}};nn=qe([F],nn),e.DataTransfer=nn;let rn=class{constructor(W){this.insertText=W}};rn=qe([F],rn),e.DocumentDropEdit=rn;let gn=class{constructor(W){this.insertText=W}};gn=qe([F],gn),e.DocumentPasteEdit=gn;let Ct=class{constructor(W,he){this.id=W,this.color=he}};Ct=qe([F],Ct),e.ThemeIcon=Ct,Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let sn=class{constructor(W){this.id=W}};sn=qe([F],sn),e.ThemeColor=sn;var On;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(On=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Jt=class{constructor(W,he){if(typeof W!="string"&&(!W||!I.URI.isUri(W)&&!I.URI.isUri(W.uri)))throw(0,t.illegalArgument)("base");if(typeof he!="string")throw(0,t.illegalArgument)("pattern");typeof W=="string"?this.baseUri=I.URI.file(W):I.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=he}get base(){return this._base}set base(W){this._base=W,this._baseUri=I.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Jt=qe([F],Jt),e.RelativePattern=Jt;let $t=class{constructor(W,he,Pe,Ke){this.enabled=typeof W=="boolean"?W:!0,typeof he=="string"&&(this.condition=he),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};$t=qe([F],$t),e.Breakpoint=$t;let dt=class extends $t{constructor(W,he,Pe,Ke,et){if(super(he,Pe,Ke,et),W===null)throw(0,t.illegalArgument)("location");this.location=W}};dt=qe([F],dt),e.SourceBreakpoint=dt;let pn=class extends $t{constructor(W,he,Pe,Ke,et){super(he,Pe,Ke,et),this.functionName=W}};pn=qe([F],pn),e.FunctionBreakpoint=pn;let Ht=class extends $t{constructor(W,he,Pe,Ke,et,lt,ht){if(super(Ke,et,lt,ht),!he)throw(0,t.illegalArgument)("dataId");this.label=W,this.dataId=he,this.canPersist=Pe}};Ht=qe([F],Ht),e.DataBreakpoint=Ht;let Gt=class{constructor(W,he,Pe){this.command=W,this.args=he||[],this.options=Pe}};Gt=qe([F],Gt),e.DebugAdapterExecutable=Gt;let on=class{constructor(W,he){this.port=W,this.host=he}};on=qe([F],on),e.DebugAdapterServer=on;let vn=class{constructor(W){this.path=W}};vn=qe([F],vn),e.DebugAdapterNamedPipeServer=vn;let an=class{constructor(W){this.implementation=W}};an=qe([F],an),e.DebugAdapterInlineImplementation=an;let bn=class{constructor(W,he){this.range=W,this.expression=he}};bn=qe([F],bn),e.EvaluatableExpression=bn;var In;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(In=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var cn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(cn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let wn=class{constructor(W,he){this.range=W,this.text=he}};wn=qe([F],wn),e.InlineValueText=wn;let Zt=class{constructor(W,he,Pe=!0){this.range=W,this.variableName=he,this.caseSensitiveLookup=Pe}};Zt=qe([F],Zt),e.InlineValueVariableLookup=Zt;let en=class{constructor(W,he){this.range=W,this.expression=he}};en=qe([F],en),e.InlineValueEvaluatableExpression=en;let En=class{constructor(W,he){this.frameId=W,this.stoppedLocation=he}};En=qe([F],En),e.InlineValueContext=En;var Fn;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Fn=e.FileChangeType||(e.FileChangeType={}));let Kt=A=class extends Error{constructor(W,he=y.FileSystemProviderErrorCode.Unknown,Pe){super(I.URI.isUri(W)?W.toString(!0):W),this.code=Pe?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,he),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists(W){return new A(W,y.FileSystemProviderErrorCode.FileExists,A.FileExists)}static FileNotFound(W){return new A(W,y.FileSystemProviderErrorCode.FileNotFound,A.FileNotFound)}static FileNotADirectory(W){return new A(W,y.FileSystemProviderErrorCode.FileNotADirectory,A.FileNotADirectory)}static FileIsADirectory(W){return new A(W,y.FileSystemProviderErrorCode.FileIsADirectory,A.FileIsADirectory)}static NoPermissions(W){return new A(W,y.FileSystemProviderErrorCode.NoPermissions,A.NoPermissions)}static Unavailable(W){return new A(W,y.FileSystemProviderErrorCode.Unavailable,A.Unavailable)}};Kt=A=qe([F],Kt),e.FileSystemError=Kt;let Sn=class{constructor(W,he,Pe){this.start=W,this.end=he,this.kind=Pe}};Sn=qe([F],Sn),e.FoldingRange=Sn;var Nn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Nn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Mn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Mn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Un;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Un=e.CommentMode||(e.CommentMode={}));var _n;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(_n=e.CommentThreadState||(e.CommentThreadState={}));class kn{constructor(W,he=[]){this.tokenTypes=W,this.tokenModifiers=he}}e.SemanticTokensLegend=kn;function Tn(j){return typeof j>"u"||(0,w.isStringArray)(j)}class $e{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let he=0,Pe=W.tokenTypes.length;he<Pe;he++)this._tokenTypeStrToInt.set(W.tokenTypes[he],he);for(let he=0,Pe=W.tokenModifiers.length;he<Pe;he++)this._tokenModifierStrToInt.set(W.tokenModifiers[he],he)}}push(W,he,Pe,Ke,et){if(typeof W=="number"&&typeof he=="number"&&typeof Pe=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this._pushEncoded(W,he,Pe,Ke,et);if(U.isRange(W)&&typeof he=="string"&&Tn(Pe))return this._push(W,he,Pe);throw(0,t.illegalArgument)()}_push(W,he,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(he))throw new Error("`tokenType` is not in the provided legend");const Ke=W.start.line,et=W.start.character,lt=W.end.character-W.start.character,ht=this._tokenTypeStrToInt.get(he);let Ot=0;if(Pe)for(const zt of Pe){if(!this._tokenModifierStrToInt.has(zt))throw new Error("`tokenModifier` is not in the provided legend");const Vt=this._tokenModifierStrToInt.get(zt);Ot|=1<<Vt>>>0}this._pushEncoded(Ke,et,lt,ht,Ot)}_pushEncoded(W,he,Pe,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&he<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ot=this._data.length/5|0;let zt=0,Vt=0;for(let jt=0;jt<Ot;jt++){let Xt=this._data[5*jt],Cn=this._data[5*jt+1];Xt===0?(Xt=zt,Cn+=Vt):Xt+=zt,this._data[5*jt]=Xt,this._data[5*jt+1]=Cn,zt=Xt,Vt=Cn}}let lt=W,ht=he;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=W,this._prevChar=he}static _sortAndDeltaEncode(W){const he=[],Pe=W.length/5|0;for(let ht=0;ht<Pe;ht++)he[ht]=ht;he.sort((ht,Ot)=>{const zt=W[5*ht],Vt=W[5*Ot];if(zt===Vt){const jt=W[5*ht+1],Xt=W[5*Ot+1];return jt-Xt}return zt-Vt});const Ke=new Uint32Array(W.length);let et=0,lt=0;for(let ht=0;ht<Pe;ht++){const Ot=5*he[ht],zt=W[Ot+0],Vt=W[Ot+1],jt=W[Ot+2],Xt=W[Ot+3],Cn=W[Ot+4],Zn=zt-et,yi=Zn===0?Vt-lt:Vt,Dn=5*ht;Ke[Dn+0]=Zn,Ke[Dn+1]=yi,Ke[Dn+2]=jt,Ke[Dn+3]=Xt,Ke[Dn+4]=Cn,et=zt,lt=Vt}return Ke}build(W){return this._dataIsSortedAndDeltaEncoded?new Bt(new Uint32Array(this._data),W):new Bt($e._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=$e;class Bt{constructor(W,he){this.resultId=he,this.data=W}}e.SemanticTokens=Bt;class Pn{constructor(W,he,Pe){this.start=W,this.deleteCount=he,this.data=Pe}}e.SemanticTokensEdit=Pn;class vt{constructor(W,he){this.resultId=he,this.edits=W}}e.SemanticTokensEdits=vt;var Bn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Bn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ln=class{constructor(){}};ln.Back={iconPath:new Ct("arrow-left")},ln=qe([F],ln),e.QuickInputButtons=ln;var An;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(An=e.QuickPickItemKind||(e.QuickPickItemKind={}));var zn;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(zn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var un;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(un=e.ExtensionKind||(e.ExtensionKind={}));class Wn{constructor(W,he,Pe){this.badge=W,this.tooltip=he,this.color=Pe}static validate(W){if(W.badge){let he=(0,k.nextCharLength)(W.badge,0);if(he<W.badge.length&&(he+=(0,k.nextCharLength)(W.badge,he)),W.badge.length>he)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Wn;let yn=class{constructor(W){this.kind=W}};yn=qe([F],yn),e.ColorTheme=yn;var $n;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})($n=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{constructor(W,he){if(W<0)throw(0,t.illegalArgument)("start must be positive");if(he<0)throw(0,t.illegalArgument)("end must be positive");W<=he?(this._start=W,this._end=he):(this._start=he,this._end=W)}static isNotebookRange(W){return W instanceof xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let he=this._start,Pe=this._end;return W.start!==void 0&&(he=W.start),W.end!==void 0&&(Pe=W.end),he===this._start&&Pe===this._end?this:new xt(he,Pe)}}e.NotebookRange=xt;class dn{constructor(W,he,Pe,Ke,et,lt,ht){this.kind=W,this.value=he,this.languageId=Pe,this.mime=Ke,this.outputs=et??[],this.metadata=lt,this.executionSummary=ht,dn.validate(this)}static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(he=>dn.isNotebookCellData(he))}static isNotebookCellData(W){return!0}}e.NotebookCellData=dn;class Hn{constructor(W){this.cells=W}}e.NotebookData=Hn;class Mt{constructor(W,he){this.data=W,this.mime=he;const Pe=(0,_.normalizeMimeType)(he,!0);if(!Pe)throw new Error(`INVALID mime type: ${he}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem(W){return W instanceof Mt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const he={name:W.name,message:W.message,stack:W.stack};return Mt.json(he,"application/vnd.code.notebook.error")}static stdout(W){return Mt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Mt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,he="application/octet-stream"){return new Mt(W,he)}static text(W,he=_.Mimes.text){const Pe=Ue(Mt,v,"f",g).encode(String(W));return new Mt(Pe,he)}static json(W,he="text/x-json"){const Pe=JSON.stringify(W,void 0,"	");return Mt.text(Pe,he)}}e.NotebookCellOutputItem=Mt,v=Mt,g={value:new TextEncoder};class hn{constructor(W,he,Pe){this.items=hn.ensureUniqueMimeTypes(W,!0),typeof he=="string"?(this.id=he,this.metadata=Pe):(this.id=(0,L.generateUuid)(),this.metadata=he??Pe)}static isNotebookCellOutput(W){return W instanceof hn?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,he=!1){const Pe=new Set,Ke=new Set;for(let et=0;et<W.length;et++){const lt=W[et],ht=(0,_.normalizeMimeType)(lt.mime);if(!Pe.has(ht)||(0,T.isTextStreamMime)(ht)){Pe.add(ht);continue}Ke.add(et),he&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ke.size===0?W:W.filter((et,lt)=>!Ke.has(lt))}}e.NotebookCellOutput=hn;var xn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(xn=e.NotebookCellKind||(e.NotebookCellKind={}));var Vn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Vn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ge;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ge=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ee;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ee=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ne{constructor(W,he){this.text=W,this.alignment=he}}e.NotebookCellStatusBarItem=Ne;var at;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(at=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class yt{constructor(W,he=[]){this.uri=W,this.provides=(0,l.asArray)(he)}}e.NotebookRendererScript=yt;let Tt=class{constructor(W,he){this.label=W,this.timestamp=he}};Tt=qe([F],Tt),e.TimelineItem=Tt;var ii;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(ii=e.ExtensionMode||(e.ExtensionMode={}));var ri;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(ri=e.ExtensionRuntime||(e.ExtensionRuntime={}));var si;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(si=e.StandardTokenType||(e.StandardTokenType={}));class oi{constructor(W,he){this.ranges=W,this.wordPattern=he}}e.LinkedEditingRanges=oi;class ai{constructor(W,he){this._port=W,this._autoForwardAction=he}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ai;var ci;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ci=e.TestResultState||(e.TestResultState={}));var li;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let jn=class{constructor(W=void 0,he=void 0,Pe=void 0){this.include=W,this.exclude=he,this.profile=Pe}};jn=qe([F],jn),e.TestRunRequest=jn;let qn=z=class{constructor(W){this.message=W}static diff(W,he,Pe){const Ke=new z(W);return Ke.expectedOutput=he,Ke.actualOutput=Pe,Ke}};qn=z=qe([F],qn),e.TestMessage=qn;let Gn=class{constructor(W){this.id=W}};Gn=qe([F],Gn),e.TestTag=Gn;let fn=class{constructor(W,he){this.covered=W,this.total=he}};fn=qe([F],fn),e.CoveredCount=fn;let Kn=H=class{constructor(W,he,Pe,Ke){this.uri=W,this.statementCoverage=he,this.branchCoverage=Pe,this.functionCoverage=Ke}static fromDetails(W,he){const Pe=new fn(0,0),Ke=new fn(0,0),et=new fn(0,0);for(const ht of he)if("branches"in ht){Pe.total+=1,Pe.covered+=ht.executionCount>0?1:0;for(const Ot of ht.branches)Ke.total+=1,Ke.covered+=Ot.executionCount>0?1:0}else et.total+=1,et.covered+=ht.executionCount>0?1:0;const lt=new H(W,Pe,Ke.total>0?Ke:void 0,et.total>0?et:void 0);return lt.detailedCoverage=he,lt}};Kn=H=qe([F],Kn),e.FileCoverage=Kn;let Xn=class{constructor(W,he,Pe=[]){this.executionCount=W,this.location=he,this.branches=Pe}};Xn=qe([F],Xn),e.StatementCoverage=Xn;let Qn=class{constructor(W,he){this.executionCount=W,this.location=he}};Qn=qe([F],Qn),e.BranchCoverage=Qn;let Yn=class{constructor(W,he){this.executionCount=W,this.location=he}};Yn=qe([F],Yn),e.FunctionCoverage=Yn;var ui;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(ui=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var di;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(di=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var hi;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(hi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class fi{constructor(W,he,Pe,Ke,et,lt){this.kind=W,this.name=he,this.detail=Pe,this.uri=Ke,this.range=et,this.selectionRange=lt}}e.TypeHierarchyItem=fi;class mi{constructor(W){this.uri=W}}e.TextTabInput=mi;class gi{constructor(W,he){this.original=W,this.modified=he}}e.TextDiffTabInput=gi;class pi{constructor(W,he,Pe,Ke){this.base=W,this.input1=he,this.input2=Pe,this.result=Ke}}e.TextMergeTabInput=pi;class vi{constructor(W,he){this.uri=W,this.viewType=he}}e.CustomEditorTabInput=vi;class bi{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=bi;class wi{constructor(W,he){this.uri=W,this.notebookType=he}}e.NotebookEditorTabInput=wi;class Ei{constructor(W,he,Pe){this.original=W,this.modified=he,this.notebookType=Pe}}e.NotebookDiffEditorTabInput=Ei;class Si{constructor(){}}e.TerminalEditorTabInput=Si;class _i{constructor(W,he){this.uri=W,this.inputBoxUri=he}}e.InteractiveWindowInput=_i}),define(De[132],Ie([1,0,48,12,8,159,100,7,17]),function(J,e,l,t,D,P,_,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function L(E,p){p?I.set(E,p):I.delete(E)}e.setWordDefinitionFor=L;function y(E){return I.get(E)}e.getWordDefinitionFor=y;class S extends P.MirrorTextModel{constructor(p,b,f,v,g,c,m,n){super(b,f,v,g),this._proxy=p,this._languageId=c,this._isDirty=m,this.notebook=n,this._isDisposed=!1}dispose(){(0,l.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(p){return(0,w.equals)(this._lines,p)}get document(){if(!this._document){const p=this;this._document={get uri(){return p._uri},get fileName(){return p._uri.fsPath},get isUntitled(){return p._uri.scheme===t.Schemas.untitled},get languageId(){return p._languageId},get version(){return p._versionId},get isClosed(){return p._isDisposed},get isDirty(){return p._isDirty},save(){return p._save()},getText(b){return b?p._getTextInRange(b):p.getText()},get eol(){return p._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return p._lines.length},lineAt(b){return p._lineAt(b)},offsetAt(b){return p._offsetAt(b)},positionAt(b){return p._positionAt(b)},validateRange(b){return p._validateRange(b)},validatePosition(b){return p._validatePosition(b)},getWordRangeAtPosition(b,f){return p._getWordRangeAtPosition(b,f)}}}return Object.freeze(this._document)}_acceptLanguageId(p){(0,l.ok)(!this._isDisposed),this._languageId=p}_acceptIsDirty(p){(0,l.ok)(!this._isDisposed),this._isDirty=p}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(p){const b=this._validateRange(p);if(b.isEmpty)return"";if(b.isSingleLine)return this._lines[b.start.line].substring(b.start.character,b.end.character);const f=this._eol,v=b.start.line,g=b.end.line,c=[];c.push(this._lines[v].substring(b.start.character));for(let m=v+1;m<g;m++)c.push(this._lines[m]);return c.push(this._lines[g].substring(0,b.end.character)),c.join(f)}_lineAt(p){let b;if(p instanceof k.Position?b=p.line:typeof p=="number"&&(b=p),typeof b!="number"||b<0||b>=this._lines.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new T(b,this._lines[b],b===this._lines.length-1)}_offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.line-1)+p.character}_positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(p),f=this._lines[b.index].length;return new k.Position(b.index,Math.min(b.remainder,f))}_validateRange(p){if(!(p instanceof k.Range))throw new Error("Invalid argument");const b=this._validatePosition(p.start),f=this._validatePosition(p.end);return b===p.start&&f===p.end?p:new k.Range(b.line,b.character,f.line,f.character)}_validatePosition(p){if(!(p instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return p.with(0,0);let{line:b,character:f}=p,v=!1;if(b<0)b=0,f=0,v=!0;else if(b>=this._lines.length)b=this._lines.length-1,f=this._lines[b].length,v=!0;else{const g=this._lines[b].length;f<0?(f=0,v=!0):f>g&&(f=g,v=!0)}return v?new k.Position(b,f):p}_getWordRangeAtPosition(p,b){const f=this._validatePosition(p);if(!b)b=y(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const v=(0,_.getWordAtText)(f.character+1,(0,_.ensureValidWordDefinition)(b),this._lines[f.line],0);if(v)return new k.Range(f.line,v.startColumn-1,f.line,v.endColumn-1)}}e.ExtHostDocumentData=S;class T{constructor(p,b,f){this._line=p,this._text=b,this._isLastLine=f}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(De[225],Ie([1,0,7,14,4]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(k){this._actual=new l.ColorTheme(l.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let w;switch(k){case"light":w=l.ColorThemeKind.Light;break;case"hcDark":w=l.ColorThemeKind.HighContrast;break;case"hcLight":w=l.ColorThemeKind.HighContrastLight;break;default:w=l.ColorThemeKind.Dark}this._actual=new l.ColorTheme(w),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=qe([xe(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(De[15],Ie([1,0,17,23,107,25,145,80,24,16,2,35,62,118,129,127,89,63,64,219,7,59]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f,v,g,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Ae){function Oe(ee){const{selectionStartLineNumber:Fe,selectionStartColumn:Ve,positionLineNumber:ot,positionColumn:Ge}=ee,it=new c.Position(Fe-1,Ve-1),ut=new c.Position(ot-1,Ge-1);return new c.Selection(it,ut)}Ae.to=Oe;function _e(ee){const{anchor:Fe,active:Ve}=ee;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Ae.from=_e})(n=e.Selection||(e.Selection={}));var d;(function(Ae){function Oe(ee){if(!ee)return;const{start:Fe,end:Ve}=ee;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Ae.from=Oe;function _e(ee){if(!ee)return;const{startLineNumber:Fe,startColumn:Ve,endLineNumber:ot,endColumn:Ge}=ee;return new c.Range(Fe-1,Ve-1,ot-1,Ge-1)}Ae.to=_e})(d=e.Range||(e.Range={}));var s;(function(Ae){function Oe(_e){switch(_e){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}Ae.to=Oe})(s=e.TokenType||(e.TokenType={}));var i;(function(Ae){function Oe(ee){return new c.Position(ee.lineNumber-1,ee.column-1)}Ae.to=Oe;function _e(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Ae.from=_e})(i=e.Position||(e.Position={}));var r;(function(Ae){function Oe(Fe,Ve){return(0,l.coalesce)((0,l.asArray)(Fe).map(ot=>_e(ot,Ve)))}Ae.from=Oe;function _e(Fe,Ve){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ee(Fe.scheme,Ve),pattern:Se.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function ee(Fe,Ve){return Ve&&typeof Fe=="string"?Ve.transformOutgoingScheme(Fe):Fe}})(r=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(Ae){function Oe(ee){switch(ee){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function _e(ee){switch(ee){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}Ae.to=_e})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(Ae){function Oe(ee){let Fe;return ee.code&&((0,I.isString)(ee.code)||(0,I.isNumber)(ee.code)?Fe=String(ee.code):Fe={value:String(ee.code.value),target:ee.code.target}),{...d.from(ee.range),message:ee.message,source:ee.source,code:Fe,severity:h.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(u.from),tags:Array.isArray(ee.tags)?(0,l.coalesce)(ee.tags.map(a.from)):void 0}}Ae.from=Oe;function _e(ee){const Fe=new c.Diagnostic(d.to(ee),ee.message,h.to(ee.severity));return Fe.source=ee.source,Fe.code=(0,I.isString)(ee.code)?ee.code:ee.code?.value,Fe.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(u.to),Fe.tags=ee.tags&&(0,l.coalesce)(ee.tags.map(a.to)),Fe}Ae.to=_e})(o=e.Diagnostic||(e.Diagnostic={}));var u;(function(Ae){function Oe(ee){return{...d.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Ae.from=Oe;function _e(ee){return new c.DiagnosticRelatedInformation(new c.Location(ee.resource,d.to(ee)),ee.message)}Ae.to=_e})(u=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(Ae){function Oe(ee){switch(ee){case c.DiagnosticSeverity.Error:return T.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return T.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return T.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return T.MarkerSeverity.Hint}return T.MarkerSeverity.Error}Ae.from=Oe;function _e(ee){switch(ee){case T.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case T.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case T.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case T.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}Ae.to=_e})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var C;(function(Ae){function Oe(ee){return typeof ee=="number"&&ee>=c.ViewColumn.One?ee-1:ee===c.ViewColumn.Beside?g.SIDE_GROUP:g.ACTIVE_GROUP}Ae.from=Oe;function _e(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=_e})(C=e.ViewColumn||(e.ViewColumn={}));function R(Ae){return typeof Ae.range<"u"}function N(Ae){return Ae.length===0?!0:!!R(Ae[0])}e.isDecorationOptionsArr=N;var M;(function(Ae){function Oe(Ge){return Ge.map(Ae.from)}Ae.fromMany=Oe;function _e(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function ee(Ge){let it;if(_e(Ge)){const{language:wt,value:_t}=Ge;it={value:"```"+wt+`
`+_t+"\n```\n"}}else c.MarkdownString.isMarkdownString(Ge)?it={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?it={value:Ge}:it={value:""};const ut=Object.create(null);it.uris=ut;const mt=wt=>{try{let _t=L.URI.parse(wt,!0);_t=_t.with({query:Fe(_t.query,ut)}),ut[wt]=_t}catch{}return""},It=new _.marked.Renderer;return It.link=mt,It.image=wt=>typeof wt=="string"?mt(D.parseHrefAndDimensions(wt).href):"",(0,_.marked)(it.value,{renderer:It}),it}Ae.from=ee;function Fe(Ge,it){if(!Ge)return Ge;let ut;try{ut=(0,k.parse)(Ge)}catch{}if(!ut)return Ge;let mt=!1;return ut=(0,w.cloneAndChange)(ut,It=>{if(L.URI.isUri(It)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[wt]=It,mt=!0,wt}else return}),mt?JSON.stringify(ut):Ge}function Ve(Ge){const it=new c.MarkdownString(Ge.value,Ge.supportThemeIcons);return it.isTrusted=Ge.isTrusted,it.supportHtml=Ge.supportHtml,it.baseUri=Ge.baseUri?L.URI.from(Ge.baseUri):void 0,it}Ae.to=Ve;function ot(Ge){if(!!Ge)return typeof Ge=="string"?Ge:Ae.from(Ge)}Ae.fromStrict=ot})(M=e.MarkdownString||(e.MarkdownString={}));function A(Ae){return N(Ae)?Ae.map(Oe=>({range:d.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?M.fromMany(Oe.hoverMessage):Oe.hoverMessage?M.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:d.from(Oe)}))}e.fromRangeOrRangeWithMessage=A;function z(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?L.URI.file(Ae):Ae}e.pathOrURIToURI=z;var H;(function(Ae){function Oe(_e){return typeof _e>"u"?_e:{contentText:_e.contentText,contentIconPath:_e.contentIconPath?z(_e.contentIconPath):void 0,border:_e.border,borderColor:_e.borderColor,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,color:_e.color,backgroundColor:_e.backgroundColor,margin:_e.margin,width:_e.width,height:_e.height}}Ae.from=Oe})(H=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(Ae){function Oe(_e){return typeof _e>"u"?_e:{backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?z(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?H.from(_e.before):void 0,after:_e.after?H.from(_e.after):void 0}}Ae.from=Oe})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var G;(function(Ae){function Oe(_e){if(typeof _e>"u")return _e;switch(_e){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(G=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(Ae){function Oe(_e){return{isWholeLine:_e.isWholeLine,rangeBehavior:_e.rangeBehavior?G.from(_e.rangeBehavior):void 0,overviewRulerLane:_e.overviewRulerLane,light:_e.light?F.from(_e.light):void 0,dark:_e.dark?F.from(_e.dark):void 0,backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?z(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?H.from(_e.before):void 0,after:_e.after?H.from(_e.after):void 0}}Ae.from=Oe})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var U;(function(Ae){function Oe(ee){return{text:ee.newText,eol:ee.newEol&&Qe.from(ee.newEol),range:d.from(ee.range)}}Ae.from=Oe;function _e(ee){const Fe=new c.TextEdit(d.to(ee.range),ee.text);return Fe.newEol=typeof ee.eol>"u"?void 0:Qe.to(ee.eol),Fe}Ae.to=_e})(U=e.TextEdit||(e.TextEdit={}));var X;(function(Ae){function Oe(ee,Fe){const Ve={edits:[]};if(ee instanceof c.WorkspaceEdit){const ot=new P.ResourceSet;for(const Ge of ee._allEntries())Ge._type===1&&L.URI.isUri(Ge.to)&&Ge.from===void 0&&ot.add(Ge.to);for(const Ge of ee._allEntries())Ge._type===1?Ve.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contentsBase64:Ge.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ge.options.contents))},metadata:Ge.metadata}):Ge._type===2?Ve.edits.push({resource:Ge.uri,textEdit:U.from(Ge.edit),versionId:ot.has(Ge.uri)?void 0:Fe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Ve.edits.push({resource:Ge.uri,textEdit:{range:d.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:ot.has(Ge.uri)?void 0:Fe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(nt.from)}})}return Ve}Ae.from=Oe;function _e(ee){const Fe=new c.WorkspaceEdit;for(const Ve of ee.edits)Ve.textEdit?Fe.replace(L.URI.revive(Ve.resource),d.to(Ve.textEdit.range),Ve.textEdit.text):Fe.renameFile(L.URI.revive(Ve.oldResource),L.URI.revive(Ve.newResource),Ve.options);return Fe}Ae.to=_e})(X=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(Ae){const Oe=Object.create(null);Oe[c.SymbolKind.File]=0,Oe[c.SymbolKind.Module]=1,Oe[c.SymbolKind.Namespace]=2,Oe[c.SymbolKind.Package]=3,Oe[c.SymbolKind.Class]=4,Oe[c.SymbolKind.Method]=5,Oe[c.SymbolKind.Property]=6,Oe[c.SymbolKind.Field]=7,Oe[c.SymbolKind.Constructor]=8,Oe[c.SymbolKind.Enum]=9,Oe[c.SymbolKind.Interface]=10,Oe[c.SymbolKind.Function]=11,Oe[c.SymbolKind.Variable]=12,Oe[c.SymbolKind.Constant]=13,Oe[c.SymbolKind.String]=14,Oe[c.SymbolKind.Number]=15,Oe[c.SymbolKind.Boolean]=16,Oe[c.SymbolKind.Array]=17,Oe[c.SymbolKind.Object]=18,Oe[c.SymbolKind.Key]=19,Oe[c.SymbolKind.Null]=20,Oe[c.SymbolKind.EnumMember]=21,Oe[c.SymbolKind.Struct]=22,Oe[c.SymbolKind.Event]=23,Oe[c.SymbolKind.Operator]=24,Oe[c.SymbolKind.TypeParameter]=25;function _e(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Ae.from=_e;function ee(Fe){for(const Ve in Oe)if(Oe[Ve]===Fe)return Number(Ve);return c.SymbolKind.Property}Ae.to=ee})($=e.SymbolKind||(e.SymbolKind={}));var x;(function(Ae){function Oe(ee){switch(ee){case c.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function _e(ee){switch(ee){case 1:return c.SymbolTag.Deprecated}}Ae.to=_e})(x=e.SymbolTag||(e.SymbolTag={}));var Q;(function(Ae){function Oe(ee){return{name:ee.name,kind:$.from(ee.kind),tags:ee.tags&&ee.tags.map(x.from),containerName:ee.containerName,location:ve.from(ee.location)}}Ae.from=Oe;function _e(ee){const Fe=new c.SymbolInformation(ee.name,$.to(ee.kind),ee.containerName,ve.to(ee.location));return Fe.tags=ee.tags&&ee.tags.map(x.to),Fe}Ae.to=_e})(Q=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var de;(function(Ae){function Oe(ee){const Fe={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:d.from(ee.range),selectionRange:d.from(ee.selectionRange),kind:$.from(ee.kind),tags:ee.tags?.map(x.from)??[]};return ee.children&&(Fe.children=ee.children.map(Oe)),Fe}Ae.from=Oe;function _e(ee){const Fe=new c.DocumentSymbol(ee.name,ee.detail,$.to(ee.kind),d.to(ee.range),d.to(ee.selectionRange));return(0,l.isNonEmptyArray)(ee.tags)&&(Fe.tags=ee.tags.map(x.to)),ee.children&&(Fe.children=ee.children.map(_e)),Fe}Ae.to=_e})(de=e.DocumentSymbol||(e.DocumentSymbol={}));var te;(function(Ae){function Oe(ee){const Fe=new c.CallHierarchyItem($.to(ee.kind),ee.name,ee.detail||"",L.URI.revive(ee.uri),d.to(ee.range),d.to(ee.selectionRange));return Fe._sessionId=ee._sessionId,Fe._itemId=ee._itemId,Fe}Ae.to=Oe;function _e(ee,Fe,Ve){if(Fe=Fe??ee._sessionId,Ve=Ve??ee._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,name:ee.name,detail:ee.detail,kind:$.from(ee.kind),uri:ee.uri,range:d.from(ee.range),selectionRange:d.from(ee.selectionRange),tags:ee.tags?.map(x.from)}}Ae.from=_e})(te=e.CallHierarchyItem||(e.CallHierarchyItem={}));var pe;(function(Ae){function Oe(_e){return new c.CallHierarchyIncomingCall(te.to(_e.from),_e.fromRanges.map(ee=>d.to(ee)))}Ae.to=Oe})(pe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Y;(function(Ae){function Oe(_e){return new c.CallHierarchyOutgoingCall(te.to(_e.to),_e.fromRanges.map(ee=>d.to(ee)))}Ae.to=Oe})(Y=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(Ae){function Oe(ee){return{range:ee.range&&d.from(ee.range),uri:ee.uri}}Ae.from=Oe;function _e(ee){return new c.Location(L.URI.revive(ee.uri),d.to(ee.range))}Ae.to=_e})(ve=e.location||(e.location={}));var be;(function(Ae){function Oe(ee){const Fe=ee,Ve=ee;return{originSelectionRange:Fe.originSelectionRange?d.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ve.uri,range:d.from(Fe.targetRange?Fe.targetRange:Ve.range),targetSelectionRange:Fe.targetSelectionRange?d.from(Fe.targetSelectionRange):void 0}}Ae.from=Oe;function _e(ee){return{targetUri:L.URI.revive(ee.uri),targetRange:d.to(ee.range),targetSelectionRange:ee.targetSelectionRange?d.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?d.to(ee.originSelectionRange):void 0}}Ae.to=_e})(be=e.DefinitionLink||(e.DefinitionLink={}));var ke;(function(Ae){function Oe(ee){return{range:d.from(ee.range),contents:M.fromMany(ee.contents)}}Ae.from=Oe;function _e(ee){return new c.Hover(ee.contents.map(M.to),d.to(ee.range))}Ae.to=_e})(ke=e.Hover||(e.Hover={}));var Re;(function(Ae){function Oe(ee){return{range:d.from(ee.range),expression:ee.expression}}Ae.from=Oe;function _e(ee){return new c.EvaluatableExpression(d.to(ee.range),ee.expression)}Ae.to=_e})(Re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var We;(function(Ae){function Oe(ee){if(ee instanceof c.InlineValueText)return{type:"text",range:d.from(ee.range),text:ee.text};if(ee instanceof c.InlineValueVariableLookup)return{type:"variable",range:d.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function _e(ee){switch(ee.type){case"text":return{range:d.to(ee.range),text:ee.text};case"variable":return{range:d.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:d.to(ee.range),expression:ee.expression}}}Ae.to=_e})(We=e.InlineValue||(e.InlineValue={}));var oe;(function(Ae){function Oe(ee){return{frameId:ee.frameId,stoppedLocation:d.from(ee.stoppedLocation)}}Ae.from=Oe;function _e(ee){return new c.InlineValueContext(ee.frameId,d.to(ee.stoppedLocation))}Ae.to=_e})(oe=e.InlineValueContext||(e.InlineValueContext={}));var le;(function(Ae){function Oe(ee){return{range:d.from(ee.range),kind:ee.kind}}Ae.from=Oe;function _e(ee){return new c.DocumentHighlight(d.to(ee.range),ee.kind)}Ae.to=_e})(le=e.DocumentHighlight||(e.DocumentHighlight={}));var fe;(function(Ae){function Oe(_e){switch(_e){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}Ae.to=Oe})(fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(Ae){function Oe(_e){return{triggerKind:fe.to(_e.triggerKind),triggerCharacter:_e.triggerCharacter}}Ae.to=Oe})(Z=e.CompletionContext||(e.CompletionContext={}));var ae;(function(Ae){function Oe(ee){switch(ee){case c.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function _e(ee){switch(ee){case 1:return c.CompletionItemTag.Deprecated}}Ae.to=_e})(ae=e.CompletionItemTag||(e.CompletionItemTag={}));var ne;(function(Ae){const Oe=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function _e(Ve){return Oe.get(Ve)??9}Ae.from=_e;const ee=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Fe(Ve){return ee.get(Ve)??c.CompletionItemKind.Property}Ae.to=Fe})(ne=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(Ae){function Oe(_e,ee){const Fe=new c.CompletionItem(_e.label);return Fe.insertText=_e.insertText,Fe.kind=ne.to(_e.kind),Fe.tags=_e.tags?.map(ae.to),Fe.detail=_e.detail,Fe.documentation=D.isMarkdownString(_e.documentation)?M.to(_e.documentation):_e.documentation,Fe.sortText=_e.sortText,Fe.filterText=_e.filterText,Fe.preselect=_e.preselect,Fe.commitCharacters=_e.commitCharacters,y.Range.isIRange(_e.range)?Fe.range=d.to(_e.range):typeof _e.range=="object"&&(Fe.range={inserting:d.to(_e.range.insert),replacing:d.to(_e.range.replace)}),Fe.keepWhitespace=typeof _e.insertTextRules>"u"?!1:Boolean(_e.insertTextRules&1),typeof _e.insertTextRules<"u"&&_e.insertTextRules&4?Fe.insertText=new c.SnippetString(_e.insertText):(Fe.insertText=_e.insertText,Fe.textEdit=Fe.range instanceof c.Range?new c.TextEdit(Fe.range,Fe.insertText):void 0),_e.additionalTextEdits&&_e.additionalTextEdits.length>0&&(Fe.additionalTextEdits=_e.additionalTextEdits.map(Ve=>U.to(Ve))),Fe.command=ee&&_e.command?ee.fromInternal(_e.command):void 0,Fe}Ae.to=Oe})(ie=e.CompletionItem||(e.CompletionItem={}));var O;(function(Ae){function Oe(ee){return{label:ee.label,documentation:M.fromStrict(ee.documentation)}}Ae.from=Oe;function _e(ee){return{label:ee.label,documentation:D.isMarkdownString(ee.documentation)?M.to(ee.documentation):ee.documentation}}Ae.to=_e})(O=e.ParameterInformation||(e.ParameterInformation={}));var V;(function(Ae){function Oe(ee){return{label:ee.label,documentation:M.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(O.from):[],activeParameter:ee.activeParameter}}Ae.from=Oe;function _e(ee){return{label:ee.label,documentation:D.isMarkdownString(ee.documentation)?M.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(O.to):[],activeParameter:ee.activeParameter}}Ae.to=_e})(V=e.SignatureInformation||(e.SignatureInformation={}));var q;(function(Ae){function Oe(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(V.from):[]}}Ae.from=Oe;function _e(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(V.to):[]}}Ae.to=_e})(q=e.SignatureHelp||(e.SignatureHelp={}));var K;(function(Ae){function Oe(_e,ee){const Fe=new c.InlayHint(i.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(me.to.bind(void 0,_e)),ee.kind&&we.to(ee.kind));return Fe.textEdits=ee.textEdits&&ee.textEdits.map(U.to),Fe.tooltip=D.isMarkdownString(ee.tooltip)?M.to(ee.tooltip):ee.tooltip,Fe.paddingLeft=ee.paddingLeft,Fe.paddingRight=ee.paddingRight,Fe}Ae.to=Oe})(K=e.InlayHint||(e.InlayHint={}));var me;(function(Ae){function Oe(_e,ee){const Fe=new c.InlayHintLabelPart(ee.label);return Fe.tooltip=D.isMarkdownString(ee.tooltip)?M.to(ee.tooltip):ee.tooltip,S.Command.is(ee.command)&&(Fe.command=_e.fromInternal(ee.command)),ee.location&&(Fe.location=ve.to(ee.location)),Fe}Ae.to=Oe})(me=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var we;(function(Ae){function Oe(ee){return ee}Ae.from=Oe;function _e(ee){return ee}Ae.to=_e})(we=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(Ae){function Oe(ee){return{range:d.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Ae.from=Oe;function _e(ee){let Fe;if(ee.url)try{Fe=typeof ee.url=="string"?L.URI.parse(ee.url,!0):L.URI.revive(ee.url)}catch{}return new c.DocumentLink(d.to(ee.range),Fe)}Ae.to=_e})(ce=e.DocumentLink||(e.DocumentLink={}));var Ce;(function(Ae){function Oe(ee){const Fe=new c.ColorPresentation(ee.label);return ee.textEdit&&(Fe.textEdit=U.to(ee.textEdit)),ee.additionalTextEdits&&(Fe.additionalTextEdits=ee.additionalTextEdits.map(Ve=>U.to(Ve))),Fe}Ae.to=Oe;function _e(ee){return{label:ee.label,textEdit:ee.textEdit?U.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Fe=>U.from(Fe)):void 0}}Ae.from=_e})(Ce=e.ColorPresentation||(e.ColorPresentation={}));var ye;(function(Ae){function Oe(ee){return new c.Color(ee[0],ee[1],ee[2],ee[3])}Ae.to=Oe;function _e(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Ae.from=_e})(ye=e.Color||(e.Color={}));var He;(function(Ae){function Oe(ee){return{range:d.from(ee.range)}}Ae.from=Oe;function _e(ee){return new c.SelectionRange(d.to(ee.range))}Ae.to=_e})(He=e.SelectionRange||(e.SelectionRange={}));var je;(function(Ae){function Oe(_e){switch(_e){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ze;(function(Ae){function Oe(ee){switch(ee){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function _e(ee){switch(ee){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}Ae.to=_e})(Ze=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Qe;(function(Ae){function Oe(ee){if(ee===c.EndOfLine.CRLF)return 1;if(ee===c.EndOfLine.LF)return 0}Ae.from=Oe;function _e(ee){if(ee===1)return c.EndOfLine.CRLF;if(ee===0)return c.EndOfLine.LF}Ae.to=_e})(Qe=e.EndOfLine||(e.EndOfLine={}));var Le;(function(Ae){function Oe(_e){if(typeof _e=="object")return _e.viewId;switch(_e){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(Le=e.ProgressLocation||(e.ProgressLocation={}));var rt;(function(Ae){function Oe(_e){const ee={start:_e.start+1,end:_e.end+1};return _e.kind&&(ee.kind=re.from(_e.kind)),ee}Ae.from=Oe})(rt=e.FoldingRange||(e.FoldingRange={}));var re;(function(Ae){function Oe(_e){if(_e)switch(_e){case c.FoldingRangeKind.Comment:return S.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return S.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return S.FoldingRangeKind.Region}}Ae.from=Oe})(re=e.FoldingRangeKind||(e.FoldingRangeKind={}));var se;(function(Ae){function Oe(_e){if(_e)return{pinned:typeof _e.preview=="boolean"?!_e.preview:void 0,inactive:_e.background,preserveFocus:_e.preserveFocus,selection:typeof _e.selection=="object"?d.from(_e.selection):void 0,override:typeof _e.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Oe})(se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Se;(function(Ae){function Oe(Ve){return Ve instanceof c.RelativePattern?Ve.toJSON():typeof Ve=="string"?Ve:_e(Ve)||ee(Ve)?new c.RelativePattern(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Ae.from=Oe;function _e(Ve){const ot=Ve;return ot?L.URI.isUri(ot.baseUri)&&typeof ot.pattern=="string":!1}function ee(Ve){const ot=Ve;return ot?typeof ot.base=="string"&&typeof ot.pattern=="string":!1}function Fe(Ve){return typeof Ve=="string"?Ve:new c.RelativePattern(L.URI.revive(Ve.baseUri),Ve.pattern)}Ae.to=Fe})(Se=e.GlobPattern||(e.GlobPattern={}));var ue;(function(Ae){function Oe(_e){if(_e){if(Array.isArray(_e))return _e.map(Oe);if(typeof _e=="string")return _e;{const ee=_e;return{language:ee.language,scheme:ee.scheme,pattern:Se.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Ae.from=Oe})(ue=e.LanguageSelector||(e.LanguageSelector={}));var Te;(function(Ae){function Oe(ee){return{start:ee.start,end:ee.end}}Ae.from=Oe;function _e(ee){return new c.NotebookRange(ee.start,ee.end)}Ae.to=_e})(Te=e.NotebookRange||(e.NotebookRange={}));var Me;(function(Ae){function Oe(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Ae.to=Oe;function _e(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Ae.from=_e})(Me=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Ae){function Oe(_e){if(_e===b.NotebookCellExecutionState.Unconfirmed)return c.NotebookCellExecutionState.Pending;if(_e===b.NotebookCellExecutionState.Pending)return;if(_e===b.NotebookCellExecutionState.Executing)return c.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${_e}`)}Ae.to=Oe})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ze;(function(Ae){function Oe(ee){switch(ee){case c.NotebookCellKind.Markup:return b.CellKind.Markup;case c.NotebookCellKind.Code:default:return b.CellKind.Code}}Ae.from=Oe;function _e(ee){switch(ee){case b.CellKind.Markup:return c.NotebookCellKind.Markup;case b.CellKind.Code:default:return c.NotebookCellKind.Code}}Ae.to=_e})(ze=e.NotebookCellKind||(e.NotebookCellKind={}));var Ye;(function(Ae){function Oe(ee){const Fe={metadata:ee.metadata??Object.create(null),cells:[]};for(const Ve of ee.cells)c.NotebookCellData.validate(Ve),Fe.cells.push(nt.from(Ve));return Fe}Ae.from=Oe;function _e(ee){const Fe=new c.NotebookData(ee.cells.map(nt.to));return(0,I.isEmptyObject)(ee.metadata)||(Fe.metadata=ee.metadata),Fe}Ae.to=_e})(Ye=e.NotebookData||(e.NotebookData={}));var nt;(function(Ae){function Oe(ee){return{cellKind:ze.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:Me.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(pt.from):[]}}Ae.from=Oe;function _e(ee){return new c.NotebookCellData(ze.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(pt.to):void 0,ee.metadata,ee.internalMetadata?Me.to(ee.internalMetadata):void 0)}Ae.to=_e})(nt=e.NotebookCellData||(e.NotebookCellData={}));var ct;(function(Ae){function Oe(ee){return{mime:ee.mime,valueBytes:t.VSBuffer.wrap(ee.data)}}Ae.from=Oe;function _e(ee){return new c.NotebookCellOutputItem(ee.valueBytes.buffer,ee.mime)}Ae.to=_e})(ct=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var pt;(function(Ae){function Oe(ee){return{outputId:ee.id,items:ee.items.map(ct.from),metadata:ee.metadata}}Ae.from=Oe;function _e(ee){const Fe=ee.items.map(ct.to);return new c.NotebookCellOutput(Fe,ee.outputId,ee.metadata)}Ae.to=_e})(pt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Je;(function(Ae){function Oe(Fe){return ee(Fe)?{include:(0,I.withNullAsUndefined)(Se.from(Fe.include)),exclude:(0,I.withNullAsUndefined)(Se.from(Fe.exclude))}:(0,I.withNullAsUndefined)(Se.from(Fe))}Ae.from=Oe;function _e(Fe){return ee(Fe)?{include:Se.to(Fe.include),exclude:Se.to(Fe.exclude)}:Se.to(Fe)}Ae.to=_e;function ee(Fe){const Ve=Fe;return Ve?!(0,I.isUndefinedOrNull)(Ve.include)&&!(0,I.isUndefinedOrNull)(Ve.exclude):!1}})(Je=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var st;(function(Ae){function Oe(_e,ee,Fe){const Ve=typeof _e.command=="string"?{title:"",command:_e.command}:_e.command;return{alignment:_e.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(Ve,Fe),text:_e.text,tooltip:_e.tooltip,accessibilityInformation:_e.accessibilityInformation,priority:_e.priority}}Ae.from=Oe})(st=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Et;(function(Ae){function Oe(_e){return{transientOutputs:_e?.transientOutputs??!1,transientCellMetadata:_e?.transientCellMetadata??{},transientDocumentMetadata:_e?.transientDocumentMetadata??{}}}Ae.from=Oe})(Et=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Lt;(function(Ae){function Oe(ee){return{uri:ee.uri,provides:ee.provides}}Ae.from=Oe;function _e(ee){return new c.NotebookRendererScript(L.URI.revive(ee.uri),ee.provides)}Ae.to=_e})(Lt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Dt;(function(Ae){function Oe(ee){return{message:M.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,location:ee.location&&{range:d.from(ee.location.range),uri:ee.location.uri}}}Ae.from=Oe;function _e(ee){const Fe=new c.TestMessage(typeof ee.message=="string"?ee.message:M.to(ee.message));return Fe.actualOutput=ee.actual,Fe.expectedOutput=ee.expected,Fe.location=ee.location?ve.to(ee.location):void 0,Fe}Ae.to=_e})(Dt=e.TestMessage||(e.TestMessage={}));var ft;(function(Ae){Ae.namespace=v.namespaceTestTag,Ae.denamespace=v.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var Pt;(function(Ae){function Oe(ee){const Fe=(0,E.getPrivateApiFor)(ee).controllerId;return{extId:f.TestId.fromExtHostTestItem(ee,Fe).toString(),label:ee.label,uri:L.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(Ve=>ft.namespace(Fe,Ve.id)),range:y.Range.lift(d.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&M.fromStrict(ee.error)||null}}Ae.from=Oe;function _e(ee){return{parent:void 0,error:void 0,id:f.TestId.fromString(ee.extId).localId,label:ee.label,uri:L.URI.revive(ee.uri),tags:(ee.tags||[]).map(Fe=>{const{tagId:Ve}=ft.denamespace(Fe);return new c.TestTag(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Ae.toPlain=_e})(Pt=e.TestItem||(e.TestItem={})),function(Ae){function Oe(ee){return{id:ee.id}}Ae.from=Oe;function _e(ee){return new c.TestTag(ee.id)}Ae.to=_e}(ft=e.TestTag||(e.TestTag={}));var Ut;(function(Ae){const Oe=(ee,Fe)=>{const Ve=[];for(const[Ge,it]of Fe)f.TestId.compare(it.item.extId,Ge)===2&&(Fe.delete(Ge),Ve.push(it));const ot={...Pt.toPlain(ee.item),parent:void 0,taskStates:ee.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(it=>it.type===0).map(Dt.to)})),children:Ve.map(Ge=>Oe(Ge,Fe))};for(const Ge of ot.children)Ge.parent=ot;return ot};function _e(ee){const Fe=[],Ve=new Map;for(const ot of ee.items)Ve.set(ot.item.extId,ot),ee.request.targets.some(Ge=>Ge.controllerId===ot.controllerId&&Ge.testIds.includes(ot.item.extId))&&Fe.push(ot);return{completedAt:ee.completedAt,results:Fe.map(ot=>Oe(ot,Ve))}}Ae.to=_e})(Ut=e.TestResults||(e.TestResults={}));var Wt;(function(Ae){function Oe(Ve){return{covered:Ve.covered,total:Ve.covered}}function _e(Ve){return"line"in Ve?i.from(Ve):d.from(Ve)}function ee(Ve){return"branches"in Ve?{count:Ve.executionCount,location:_e(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(ot=>({count:ot.executionCount,location:ot.location&&_e(ot.location)})):void 0}:{type:0,count:Ve.executionCount,location:_e(Ve.location)}}Ae.fromDetailed=ee;function Fe(Ve){return{uri:Ve.uri,statement:Oe(Ve.statementCoverage),branch:Ve.branchCoverage&&Oe(Ve.branchCoverage),function:Ve.functionCoverage&&Oe(Ve.functionCoverage),details:Ve.detailedCoverage?.map(ee)}}Ae.fromFile=Fe})(Wt=e.TestCoverage||(e.TestCoverage={}));var Xe;(function(Ae){function Oe(_e){switch(_e){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(Xe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(Ae){function Oe(ee){const Fe=new c.TypeHierarchyItem($.to(ee.kind),ee.name,ee.detail||"",L.URI.revive(ee.uri),d.to(ee.range),d.to(ee.selectionRange));return Fe._sessionId=ee._sessionId,Fe._itemId=ee._itemId,Fe}Ae.to=Oe;function _e(ee,Fe,Ve){if(Fe=Fe??ee._sessionId,Ve=Ve??ee._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,kind:$.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:d.from(ee.range),selectionRange:d.from(ee.selectionRange),tags:ee.tags?.map(x.from)}}Ae.from=_e})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var At;(function(Ae){function Oe(_e){if(!!_e)return{value:_e.value,tooltip:_e.tooltip}}Ae.from=Oe})(At=e.ViewBadge||(e.ViewBadge={}));var Nt;(function(Ae){function Oe(_e,ee){const Fe=_e.fileData;return Fe?new class extends c.DataTransferItem{asFile(){return{name:Fe.name,uri:L.URI.revive(Fe.uri),data:(0,m.once)(()=>ee())}}}("",_e.id):new c.DataTransferItem(_e.asString)}Ae.toDataTransferItem=Oe})(Nt=e.DataTransferItem||(e.DataTransferItem={}));var gt;(function(Ae){function Oe(ee,Fe){const Ve=ee.items.map(([ot,Ge])=>[ot,Nt.toDataTransferItem(Ge,()=>Fe(Ge.id))]);return new c.DataTransfer(Ve)}Ae.toDataTransfer=Oe;async function _e(ee){const Fe={items:[]},Ve=[];return ee.forEach((ot,Ge)=>{Ve.push((async()=>{const it=await ot.asString(),ut=ot.asFile();Fe.items.push([Ge,{id:ot.id,asString:it,fileData:ut?{name:ut.name,uri:ut.uri}:void 0}])})())}),await Promise.all(Ve),Fe}Ae.toDataTransferDTO=_e})(gt=e.DataTransfer||(e.DataTransfer={}))}),define(De[226],Ie([1,0,2,10,7,15,77]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(I,L,y,S={timeout:1500,errors:3}){this._logService=I,this._documents=L,this._mainThreadBulkEdits=y,this._thresholds=S,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(L,y,S)=>{const E={dispose:this._callbacks.push([L,y,I])};return Array.isArray(S)&&S.push(E),E}}async $participateInSave(I,L){const y=l.URI.revive(I);let S=!1;const T=setTimeout(()=>S=!0,this._thresholds.timeout),E=[];try{for(const p of[...this._callbacks]){if(S)break;const b=this._documents.getDocument(y),f=await this._deliverEventAsyncAndBlameBadListeners(p,{document:b,reason:P.TextDocumentSaveReason.to(L)});E.push(f)}}finally{clearTimeout(T)}return E}_deliverEventAsyncAndBlameBadListeners([I,L,y],S){const T=this._badListeners.get(I);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,I,L,S).then(()=>!0,E=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(E),!(E instanceof Error)||E.message!=="concurrent_edits"){const p=this._badListeners.get(I);this._badListeners.set(I,p?p+1:1),typeof p=="number"&&p>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,L,y,S){const T=[],E=Date.now(),{document:p,reason:b}=S,{version:f}=p,v=Object.freeze({document:p,reason:b,waitUntil(g){if(Object.isFrozen(T))throw(0,t.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(g))}});try{L.apply(y,[v])}catch(g){return Promise.reject(g)}return Object.freeze(T),new Promise((g,c)=>{const m=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-E}ms`),clearTimeout(m),g(n)}).catch(n=>{clearTimeout(m),c(n)})}).then(g=>{const c={edits:[]};for(const m of g)if(Array.isArray(m)&&m.every(n=>n instanceof D.TextEdit))for(const{newText:n,newEol:d,range:s}of m)c.edits.push({resource:p.uri,versionId:void 0,textEdit:{range:s&&P.Range.from(s),text:n,eol:d&&P.EndOfLine.from(d)}});if(c.edits.length!==0)return f===p.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(De[227],Ie([1,0,12,2,15,7,89]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(y,S,T,E){this.start=y,this.deletedCount=S,this.deletedItems=T,this.items=E}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class w{constructor(y,S,T){this.notebook=y,this._extHostDocument=S,this._cellData=T,this.handle=T.handle,this.uri=t.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}static asModelAddData(y,S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1,notebook:y}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const y=this,S=this._extHostDocument.getDocument(this.uri);if(!S)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:S.document,get mime(){return y._mime},set mime(E){y._mime=E},get outputs(){return y._outputs.slice(0)},get metadata(){return y._metadata},get executionSummary(){return y._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(y){this._outputs=y.map(D.NotebookCellOutput.to)}setOutputItems(y,S,T){const E=T.map(D.NotebookCellOutputItem.to),p=this._outputs.find(b=>b.id===y);p&&(S||(p.items.length=0),p.items.push(...E))}setMetadata(y){this._metadata=Object.freeze(y)}setInternalMetadata(y){this._internalMetadata=y,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=w;class I{constructor(y,S,T,E,p){this._proxy=y,this._textDocumentsAndEditors=S,this._textDocuments=T,this.uri=E,this.handle=I._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=p.viewType,this._metadata=Object.freeze(p.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,p.cells]],!0,void 0),this._versionId=p.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const y=this,S={get uri(){return y.uri},get version(){return y._versionId},get notebookType(){return y._notebookType},get isDirty(){return y._isDirty},get isUntitled(){return y.uri.scheme===l.Schemas.untitled},get isClosed(){return y._disposed},get metadata(){return y._metadata},get cellCount(){return y._cells.length},cellAt(T){return T=y._validateIndex(T),y._cells[T].apiCell},getCells(T){return(T?y._getCells(T):y._cells).map(p=>p.apiCell)},save(){return y._save()}};this._notebook=Object.freeze(S)}return this._notebook}acceptDocumentPropertiesChanged(y){y.metadata&&(this._metadata=Object.freeze({...this._metadata,...y.metadata}))}acceptDirty(y){this._isDirty=y}acceptModelChanged(y,S,T){this._versionId=y.versionId,this._isDirty=S,this.acceptDocumentPropertiesChanged({metadata:T});const E={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},p=[];for(const f of y.rawEvents)f.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1,E.contentChanges):f.kind===_.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx,E.contentChanges):f.kind===_.NotebookCellsChangeType.Output?(this._setCellOutputs(f.index,f.outputs),p.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===_.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems),p.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===_.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(f.index,f.language),p.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document})):f.kind===_.NotebookCellsChangeType.ChangeCellContent?p.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document}):f.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===_.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(f.index,f.metadata),p.push({cell:this._cells[f.index].apiCell,metadata:this._cells[f.index].apiCell.metadata})):f.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(f.index,f.internalMetadata),p.push({cell:this._cells[f.index].apiCell,executionSummary:this._cells[f.index].apiCell.executionSummary}));const b=new Map;for(let f=0;f<p.length;f++){const v=p[f],g=b.get(v.cell);if(g===void 0){const c=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});b.set(v.cell,c-1)}else E.cellChanges[g]={...E.cellChanges[g],...v}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}_validateIndex(y){return y=y|0,y<0?0:y>=this._cells.length?this._cells.length-1:y}_validateRange(y){let S=y.start|0,T=y.end|0;return S<0&&(S=0),T>this._cells.length&&(T=this._cells.length),y.with({start:S,end:T})}_getCells(y){y=this._validateRange(y);const S=[];for(let T=y.start;T<y.end;T++)S.push(this._cells[T]);return S}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(y,S,T){if(this._disposed)return;const E=[],p=[],b=[];if(y.reverse().forEach(f=>{const g=f[2].map(n=>{const d=new w(this,this._textDocumentsAndEditors,n);return S||p.push(w.asModelAddData(this.apiNotebook,n)),d}),c=new k(f[0],f[1],[],g),m=this._cells.splice(f[0],f[1],...g);for(const n of m)b.push(n.uri),c.deletedItems.push(n.apiCell);E.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:b}),T)for(const f of E)T.push(f.asApiEvent())}_moveCell(y,S,T){const E=this._cells.splice(y,1);this._cells.splice(S,0,...E);const p=[new k(y,1,E.map(b=>b.apiCell),[]),new k(S,0,[],E)];for(const b of p)T.push(b.asApiEvent())}_setCellOutputs(y,S){this._cells[y].setOutputs(S)}_setCellOutputItems(y,S,T,E){this._cells[y].setOutputItems(S,T,E)}_changeCellLanguage(y,S){const T=this._cells[y];T.apiCell.document.languageId!==S&&this._textDocuments.$acceptModelLanguageChanged(T.uri,S)}_changeCellMime(y,S){const T=this._cells[y];T.apiCell.mime=S}_changeCellMetadata(y,S){this._cells[y].setMetadata(S)}_changeCellInternalMetadata(y,S){this._cells[y].setInternalMetadata(S)}getCellFromApiCell(y){return this._cells.find(S=>S.apiCell===y)}getCellFromIndex(y){return this._cells[y]}getCell(y){return this._cells.find(S=>S.handle===y)}getCellIndex(y){return this._cells.indexOf(y)}}e.ExtHostNotebookDocument=I,I._handlePool=0}),define(De[133],Ie([1,0,10,15,7]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(k,w,I,L,y,S){this.id=k,this._proxy=w,this.notebookData=I,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=y,this._visibleRanges=L,this._viewColumn=S}get apiEditor(){if(!this._editor){const k=this;this._editor={get document(){return k.notebookData.apiNotebook},get notebook(){return k.notebookData.apiNotebook},get selection(){return k._selections[0]},set selection(w){this.selections=[w]},get selections(){return k._selections},set selections(w){if(!Array.isArray(w)||!w.every(D.NotebookRange.isNotebookRange))throw(0,l.illegalArgument)("selections");k._selections=w,k._trySetSelections(w)},get visibleRanges(){return k._visibleRanges},revealRange(w,I){k._proxy.$tryRevealRange(k.id,t.NotebookRange.from(w),I??D.NotebookEditorRevealType.Default)},get viewColumn(){return k._viewColumn}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(k){this._visible=k}_acceptVisibleRanges(k){this._visibleRanges=k}_acceptSelections(k){this._selections=k}_trySetSelections(k){this._proxy.$trySetSelections(this.id,k.map(t.NotebookRange.from))}_acceptViewColumn(k){this._viewColumn=k}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(De[228],Ie([1,0,4,13,15]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(k,w){this._logService=k,this._notebooksAndEditors=w,this._onDidChangeNotebookEditorSelection=new l.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new l.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(k,w){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,w);const I=this._notebooksAndEditors.getEditorById(k);w.visibleRanges&&I._acceptVisibleRanges(w.visibleRanges.ranges.map(D.NotebookRange.to)),w.selections&&I._acceptSelections(w.selections.selections.map(D.NotebookRange.to)),w.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),w.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const w in k)this._notebooksAndEditors.getEditorById(w)._acceptViewColumn(D.ViewColumn.to(k[w]))}};P=qe([xe(0,t.ILogService)],P),e.ExtHostNotebookEditors=P}),define(De[229],Ie([1,0,15,120,172,21,58,10]),function(J,e,l,t,D,P,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class w{constructor(S){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=S}async withProgress(S,T,E){const p=this._handles++,{title:b,location:f,cancellable:v}=T,g={label:(0,D.localize)(0,null,S.displayName||S.name),id:S.identifier.value};return this._proxy.$startProgress(p,{location:l.ProgressLocation.from(f),title:b,source:g,cancellable:v},S.isUnderDevelopment?void 0:S.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(p,E,!!v)}_withProgress(S,T,E){let p;E&&(p=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(S,p));const b=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),p?.dispose()};let f;try{f=T(new L(this._proxy,S),E&&p?p.token:P.CancellationToken.None)}catch(v){throw b(S),v}return f.then(v=>b(S),v=>b(S)),f}$acceptProgressCanceled(S){const T=this._mapHandleToCancellationSource.get(S);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(S))}}e.ExtHostProgress=w;function I(y,S){return y.message=S.message,typeof S.increment=="number"&&(typeof y.increment=="number"?y.increment+=S.increment:y.increment=S.increment),y}class L extends t.Progress{constructor(S,T){super(E=>this.throttledReport(E)),this._proxy=S,this._handle=T}throttledReport(S){this._proxy.$progressReport(this._handle,S)}}qe([(0,_.throttle)(100,(y,S)=>I(y,S),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(De[134],Ie([1,0,35,129,63,90,64,15,2]),function(J,e,l,t,D,P,_,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const I=(g,c,m,n)=>{let d=c;return{enumerable:!0,configurable:!1,get(){return d},set(s){if(!m(d,s)){const i=d;d=s,g.listener?.(n(s,i))}}}},L=(g,c)=>g===c,y={range:(g,c)=>g===c?!0:!g||!c?!1:g.isEqual(c),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(g,c)=>!(g.length!==c.length||g.some(m=>!c.find(n=>m.id===n.id)))},S=g=>c=>({op:4,update:g(c)}),T=(g,c)=>({range:I(g,void 0,y.range,S(m=>({range:l.Range.lift(k.Range.from(m))}))),label:I(g,c,y.label,S(m=>({label:m}))),description:I(g,void 0,y.description,S(m=>({description:m}))),sortText:I(g,void 0,y.sortText,S(m=>({sortText:m}))),canResolveChildren:I(g,!1,y.canResolveChildren,m=>({op:2,state:m})),busy:I(g,!1,y.busy,S(m=>({busy:m}))),error:I(g,void 0,y.error,S(m=>({error:k.MarkdownString.fromStrict(m)||null}))),tags:I(g,[],y.tags,(m,n)=>({op:1,new:m.map(k.TestTag.from),old:n.map(k.TestTag.from)}))}),E=g=>{const c=D.TestId.fromString(g.extId),m=new b(c.controllerId,c.localId,g.label,w.URI.revive(g.uri)||void 0);return m.range=k.Range.to(g.range||void 0),m.description=g.description||void 0,m.sortText=g.sortText||void 0,m.tags=g.tags.map(n=>k.TestTag.to({id:(0,_.denamespaceTestTag)(n).tagId})),m},p=g=>{let c;for(const m of g.tests){const n=E(m.item);(0,t.getPrivateApiFor)(n).parent=c,c=n}return c};e.toItemFromContext=p;class b{constructor(c,m,n,d){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const s=(0,t.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof f?void 0:s.parent}},children:{value:(0,P.createTestItemChildren)(s,t.getPrivateApiFor,b),enumerable:!0,writable:!1},...T(s,n)})}}e.TestItemImpl=b;class f extends b{constructor(c,m){super(c,c,m,void 0)}}e.TestItemRootImpl=f;class v extends P.TestItemCollection{constructor(c,m,n){super({controllerId:c,getDocumentVersion:d=>n.getDocument(d)?.version,getApiFor:t.getPrivateApiFor,getChildren:d=>d.children,root:new f(c,m),toITestItem:k.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(De[135],Ie([1,0,48,10,95,15,7]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(S,T,E){const p=k._Keys.nextId();S.$registerTextEditorDecorationType(T.identifier,p,P.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:p,dispose(){S.$removeTextEditorDecorationType(p)}})}}e.TextEditorDecorationType=k,k._Keys=new D.IdGenerator("TextEditorDecorationType");class w{constructor(S,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=S,this._documentVersionId=S.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(S,T){this._throwIfFinalized();let E=null;if(S instanceof _.Position)E=new _.Range(S,S);else if(S instanceof _.Range)E=S;else throw new Error("Unrecognized location");this._pushEdit(E,T,!1)}insert(S,T){this._throwIfFinalized(),this._pushEdit(new _.Range(S,S),T,!0)}delete(S){this._throwIfFinalized();let T=null;if(S instanceof _.Range)T=S;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(S,T,E){const p=this._document.validateRange(S);this._collectedEdits.push({range:p,text:T,forceMoveMarkers:E})}setEndOfLine(S){if(this._throwIfFinalized(),S!==_.EndOfLine.LF&&S!==_.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=S}}e.TextEditorEdit=w;class I{constructor(S,T,E,p){this._proxy=S,this._id=T,this._accept(E),this._logService=p;const b=this;this.value={get tabSize(){return b._tabSize},set tabSize(f){b._setTabSize(f)},get insertSpaces(){return b._insertSpaces},set insertSpaces(f){b._setInsertSpaces(f)},get cursorStyle(){return b._cursorStyle},set cursorStyle(f){b._setCursorStyle(f)},get lineNumbers(){return b._lineNumbers},set lineNumbers(f){b._setLineNumbers(f)}}}_accept(S){this._tabSize=S.tabSize,this._insertSpaces=S.insertSpaces,this._cursorStyle=S.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(S.lineNumbers)}_validateTabSize(S){if(S==="auto")return"auto";if(typeof S=="number"){const T=Math.floor(S);return T>0?T:null}if(typeof S=="string"){const T=parseInt(S,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(S){const T=this._validateTabSize(S);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(S){return S==="auto"?"auto":S==="false"?!1:Boolean(S)}_setInsertSpaces(S){const T=this._validateInsertSpaces(S);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(S){this._cursorStyle!==S&&(this._cursorStyle=S,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:S})))}_setLineNumbers(S){this._lineNumbers!==S&&(this._lineNumbers=S,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(S)})))}assign(S){const T={};let E=!1;if(typeof S.tabSize<"u"){const p=this._validateTabSize(S.tabSize);p==="auto"?(E=!0,T.tabSize=p):typeof p=="number"&&this._tabSize!==p&&(this._tabSize=p,E=!0,T.tabSize=p)}if(typeof S.insertSpaces<"u"){const p=this._validateInsertSpaces(S.insertSpaces);p==="auto"?(E=!0,T.insertSpaces=p):this._insertSpaces!==p&&(this._insertSpaces=p,E=!0,T.insertSpaces=p)}typeof S.cursorStyle<"u"&&this._cursorStyle!==S.cursorStyle&&(this._cursorStyle=S.cursorStyle,E=!0,T.cursorStyle=S.cursorStyle),typeof S.lineNumbers<"u"&&this._lineNumbers!==S.lineNumbers&&(this._lineNumbers=S.lineNumbers,E=!0,T.lineNumbers=P.TextEditorLineNumbersStyle.from(S.lineNumbers)),E&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(S,T){T.catch(E=>{this._logService.warn(`ExtHostTextEditorOptions '${S}' failed:'`),this._logService.warn(E)})}}e.ExtHostTextEditorOptions=I;class L{constructor(S,T,E,p,b,f,v,g){this.id=S,this._proxy=T,this._logService=E,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=b,this._options=new I(this._proxy,this.id,f,E),this._visibleRanges=v,this._viewColumn=g;const c=this;this.value=Object.freeze({get document(){return p.getValue()},set document(m){throw(0,t.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(m){if(!(m instanceof _.Selection))throw(0,t.illegalArgument)("selection");c._selections=[m],c._trySetSelection()},get selections(){return c._selections},set selections(m){if(!Array.isArray(m)||m.some(n=>!(n instanceof _.Selection)))throw(0,t.illegalArgument)("selections");c._selections=m,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(m){throw(0,t.readonly)("visibleRanges")},get options(){return c._options.value},set options(m){c._disposed||c._options.assign(m)},get viewColumn(){return c._viewColumn},set viewColumn(m){throw(0,t.readonly)("viewColumn")},edit(m,n={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new w(p.getValue(),n);return m(d),c._applyEdit(d)},insertSnippet(m,n,d={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!n||Array.isArray(n)&&n.length===0)s=c._selections.map(i=>P.Range.from(i));else if(n instanceof _.Position){const{lineNumber:i,column:r}=P.Position.from(n);s=[{startLineNumber:i,startColumn:r,endLineNumber:i,endColumn:r}]}else if(n instanceof _.Range)s=[P.Range.from(n)];else{s=[];for(const i of n)if(i instanceof _.Range)s.push(P.Range.from(i));else{const{lineNumber:r,column:a}=P.Position.from(i);s.push({startLineNumber:r,startColumn:a,endLineNumber:r,endColumn:a})}}return T.$tryInsertSnippet(S,p.getValue().version,m.value,s,d)},setDecorations(m,n){const d=n.length===0;d&&!c._hasDecorationsForKey.has(m.key)||(d?c._hasDecorationsForKey.delete(m.key):c._hasDecorationsForKey.add(m.key),c._runOnProxy(()=>{if(P.isDecorationOptionsArr(n))return T.$trySetDecorations(S,m.key,P.fromRangeOrRangeWithMessage(n));{const s=new Array(4*n.length);for(let i=0,r=n.length;i<r;i++){const a=n[i];s[4*i]=a.start.line+1,s[4*i+1]=a.start.character+1,s[4*i+2]=a.end.line+1,s[4*i+3]=a.end.character+1}return T.$trySetDecorationsFast(S,m.key,s)}}))},revealRange(m,n){c._runOnProxy(()=>T.$tryRevealRange(S,P.Range.from(m),n||_.TextEditorRevealType.Default))},show(m){T.$tryShowEditor(S,P.ViewColumn.from(m))},hide(){T.$tryHideEditor(S)}})}dispose(){(0,l.ok)(!this._disposed),this._disposed=!0}_acceptOptions(S){(0,l.ok)(!this._disposed),this._options._accept(S)}_acceptVisibleRanges(S){(0,l.ok)(!this._disposed),this._visibleRanges=S}_acceptViewColumn(S){(0,l.ok)(!this._disposed),this._viewColumn=S}_acceptSelections(S){(0,l.ok)(!this._disposed),this._selections=S}async _trySetSelection(){const S=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,S)),this.value}_applyEdit(S){const T=S.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const E=T.edits.map(b=>b.range);E.sort((b,f)=>b.end.line===f.end.line?b.end.character===f.end.character?b.start.line===f.start.line?b.start.character-f.start.character:b.start.line-f.start.line:b.end.character-f.end.character:b.end.line-f.end.line);for(let b=0,f=E.length-1;b<f;b++){const v=E[b].end;if(E[b+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=T.edits.map(b=>({range:P.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,p,{setEndOfLine:typeof T.setEndOfLine=="number"?P.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(S){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):S().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=L}),define(De[230],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewSize.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",localization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.localization.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceEditIsRefactoring:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceEditIsRefactoring.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[231],Ie([1,0,186,10,41,84,121,43,28,230,197]),function(J,e,l,t,D,P,_,k,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const y=k.Registry.as(_.Extensions.JSONContribution);class S{constructor(c,m,n){this._messageHandler=c,this._extension=m,this._extensionPointId=n}_msg(c,m){this._messageHandler({type:c,message:m,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(c){this._msg(D.default.Error,c)}warn(c){this._msg(D.default.Warning,c)}info(c){this._msg(D.default.Info,c)}}e.ExtensionMessageCollector=S;class T{constructor(c,m){this.added=c,this.removed=m}static _toSet(c){const m=new Set;for(let n=0,d=c.length;n<d;n++)m.add(w.ExtensionIdentifier.toKey(c[n].description.identifier));return m}static compute(c,m){if(!c||!c.length)return new T(m,[]);if(!m||!m.length)return new T([],c);const n=this._toSet(c),d=this._toSet(m),s=m.filter(r=>!n.has(w.ExtensionIdentifier.toKey(r.description.identifier))),i=c.filter(r=>!d.has(w.ExtensionIdentifier.toKey(r.description.identifier)));return new T(s,i)}}e.ExtensionPointUserDelta=T;class E{constructor(c,m){this.name=c,this.defaultExtensionKind=m,this._handler=null,this._users=null,this._delta=null}setHandler(c){if(this._handler!==null)throw new Error("Handler already set!");this._handler=c,this._handle()}acceptUsers(c){this._delta=T.compute(this._users,c),this._users=c,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(c){(0,t.onUnexpectedError)(c)}}}e.ExtensionPoint=E;const p={type:"string",enum:["ui","workspace"],enumDescriptions:[l.localize(0,null),l.localize(1,null)]},b="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:l.localize(2,null),properties:{vscode:{type:"string",description:l.localize(3,null),default:"^1.22.0"}}},publisher:{description:l.localize(4,null),type:"string"},displayName:{description:l.localize(5,null),type:"string"},categories:{description:l.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:w.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:l.localize(7,null)}]}},galleryBanner:{type:"object",description:l.localize(8,null),properties:{color:{description:l.localize(9,null),type:"string"},theme:{description:l.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:l.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:l.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:l.localize(13,null)},enabledApiProposals:{markdownDescription:l.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}},activationEvents:{description:l.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:l.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:l.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:l.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:l.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:l.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:l.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:l.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:l.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:l.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:l.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:l.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:l.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:l.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:l.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:l.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:l.localize(31,null)},{label:"onUri",body:"onUri",description:l.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:l.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:l.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:l.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:l.localize(36,null)},{label:"onRenderer",description:l.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:l.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:l.localize(39,null)},{label:"*",description:l.localize(40,null),body:"*"}]}},badges:{type:"array",description:l.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:l.localize(42,null)},href:{type:"string",description:l.localize(43,null)},description:{type:"string",description:l.localize(44,null)}}}},markdown:{type:"string",description:l.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:l.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:l.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:l.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:l.localize(49,null),type:"array",items:p,default:["workspace"],defaultSnippets:[{body:["ui"],description:l.localize(50,null)},{body:["workspace"],description:l.localize(51,null)},{body:["ui","workspace"],description:l.localize(52,null)},{body:["workspace","ui"],description:l.localize(53,null)},{body:[],description:l.localize(54,null)}]},capabilities:{description:l.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:l.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:l.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(58,null),l.localize(59,null),l.localize(60,null)]},description:{type:"string",markdownDescription:l.localize(61,null)}}},untrustedWorkspaces:{description:l.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:l.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(64,null),l.localize(65,null),l.localize(66,null)]},restrictedConfigurations:{description:l.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:l.localize(68,null)}}}}},sponsor:{description:l.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:l.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:l.localize(71,null),type:"string"},"vscode:uninstall":{description:l.localize(72,null),type:"string"}}},icon:{type:"string",description:l.localize(73,null)}}};class f{constructor(){this._extensionPoints=new Map}registerExtensionPoint(c){if(this._extensionPoints.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const m=new E(c.extensionPoint,c.defaultExtensionKind);return this._extensionPoints.set(c.extensionPoint,m),e.schema.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,y.registerSchema(b,e.schema),m}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=f;const v={ExtensionsRegistry:"ExtensionsRegistry"};k.Registry.add(v.ExtensionsRegistry,new f),e.ExtensionsRegistry=k.Registry.as(v.ExtensionsRegistry),y.registerSchema(b,e.schema),y.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:l.localize(74,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}}]}}}})}),define(De[232],Ie([1,0,183,16,24,231,52,4]),function(J,e,l,t,D,P,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const w={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:l.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:l.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:l.localize(2,null),default:""}}};var I;(function(S){function T(E,p,b){if(!E)return;const f=t.isString(E.type)?E.type:void 0;if(!f||f.length===0){b.error(l.localize(3,null));return}const v=[];if(Array.isArray(E.required))for(const g of E.required)t.isString(g)&&v.push(g);return{extensionId:p.value,taskType:f,required:v,properties:E.properties?D.deepClone(E.properties):{},when:E.when?_.ContextKeyExpr.deserialize(E.when):void 0}}S.from=T})(I||(I={}));const L=P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:l.localize(4,null),type:"array",items:w}});class y{constructor(){this._onDefinitionsChanged=new k.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,E)=>{L.setHandler((p,b)=>{this._schema=void 0;try{for(const f of b.removed){const v=f.value;for(const g of v)this.taskTypes&&g.type&&this.taskTypes[g.type]&&delete this.taskTypes[g.type]}for(const f of b.added){const v=f.value;for(const g of v){const c=I.from(g,f.description.identifier,f.collector);c&&(this.taskTypes[c.taskType]=c)}}(b.removed.length>0||b.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const E of this.all()){const p={type:"object",additionalProperties:!1};E.required.length>0&&(p.required=E.required.slice(0)),E.properties!==void 0?p.properties=D.deepClone(E.properties):p.properties=Object.create(null),p.properties.type={type:"string",enum:[E.taskType]},T.push(p)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistryImpl=y,e.TaskDefinitionRegistry=new y}),define(De[233],Ie([1,0,184,16,22,24,52,232]),function(J,e,l,t,D,P,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new _.RawContextKey("taskRunning",!1,l.localize(0,null)),e.TASKS_CATEGORY={value:l.localize(1,null),original:"Tasks"};var w;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(w=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function G(B){if(!B)return F.Strong;switch(B.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=G}(w=e.ShellQuoting||(e.ShellQuoting={}));var I;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(I=e.CommandOptions||(e.CommandOptions={}));var L;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(F){function G(B){switch(B.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=G}(L=e.RevealKind||(e.RevealKind={}));var y;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(y=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function G(B){switch(B.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=G}(y=e.RevealProblemKind||(e.RevealProblemKind={}));var S;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(S=e.PanelKind||(e.PanelKind={})),function(F){function G(B){switch(B.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=G}(S=e.PanelKind||(e.PanelKind={}));var T;(function(F){F.defaults={echo:!0,reveal:L.Always,revealProblems:y.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var E;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(E=e.RuntimeType||(e.RuntimeType={})),function(F){function G(U){switch(U.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=G;function B(U){switch(U){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=B}(E=e.RuntimeType||(e.RuntimeType={}));var p;(function(F){function G(B){return t.isString(B)?B:B.value}F.value=G})(p=e.CommandString||(e.CommandString={}));var b;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function G(U){return U===F.Clean._id||U===F.Build._id||U===F.Rebuild._id||U===F.Test._id}F.is=G;function B(U){if(U!==void 0)return t.isString(U)?G(U)?{_id:U,isDefault:!1}:void 0:U}F.from=B})(b=e.TaskGroup||(e.TaskGroup={}));var f;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var v;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function G(B){switch(B){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=G})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var g;(function(F){F.parallel="parallel",F.sequence="sequence"})(g=e.DependsOrder||(e.DependsOrder={}));var c;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(c=e.RunOnOptions||(e.RunOnOptions={}));var m;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(m=e.RunOptions||(e.RunOptions={}));class n{constructor(G,B,U,X,$,x){this._label="",this._id=G,B&&(this._label=B),U&&(this.type=U),this.runOptions=X,this.configurationProperties=$,this._source=x}getDefinition(G){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const G={folder:this.getFolderId(),id:this._id};return JSON.stringify(G)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(G,B=!1){if(G===void 0)return!1;if(t.isString(G))return G===this._label||G===this.configurationProperties.identifier||B&&G===this._id;const U=this.getDefinition(!0);return U!==void 0&&U._key===G._key}getQualifiedLabel(){const G=this.getWorkspaceFolder();return G?`${this._label} (${G.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(G){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),G&&(this._taskLoadMessages=this._taskLoadMessages.concat(G))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=n;class d extends n{constructor(G,B,U,X,$,x,Q,de){super(G,U,void 0,Q,de,B),this.command={},this._source=B,this.hasDefinedMatchers=x,$&&(this.command=$)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(G=!1){if(G&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case E.Shell:B="shell";break;case E.Process:B="process";break;case E.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(G){return G instanceof d}getMapKey(){const G=this._source.config.workspaceFolder;return G?`${G.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const G=this.getFolderId();if(!G)return;let B=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(B+=this._source.kind);const U={type:e.CUSTOMIZED_TASK_TYPE,folder:G,id:B};return JSON.stringify(U)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(G){return new d(G._id,G._source,G._label,G.type,G.command,G.hasDefinedMatchers,G.runOptions,G.configurationProperties)}}e.CustomTask=d;class s extends n{constructor(G,B,U,X,$,x,Q){super(G,U,X,x,Q,B),this._source=B,this.configures=$}static is(G){return G instanceof s}fromObject(G){return G}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const G=this.getFolderId();if(!G)return;let B=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(B+=this._source.kind);const U={type:e.CUSTOMIZED_TASK_TYPE,folder:G,id:B};return JSON.stringify(U)}}e.ConfiguringTask=s;class i extends n{constructor(G,B,U,X,$,x,Q,de,te){super(G,U,X,de,te,B),this.defines=$,this.hasDefinedMatchers=Q,this.command=x,this.icon=te.icon,this.hide=te.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(G){return G instanceof i}getMapKey(){const G=this._source.workspaceFolder;return G?`${this._source.scope.toString()}|${G.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const G={type:"contributed",scope:this._source.scope,id:this._id};return G.folder=this.getFolderId(),JSON.stringify(G)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(G){return new i(G._id,G._source,G._label,G.type,G.defines,G.command,G.hasDefinedMatchers,G.runOptions,G.configurationProperties)}}e.ContributedTask=i;class r extends n{constructor(G,B,U,X,$,x){super(G,U,X,$,x,B),this._source=B}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(G){return G instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(G){return new r(G._id,G._source,G._label,G.type,G.runOptions,G.configurationProperties)}}e.InMemoryTask=r;var a;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(a=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(a=e.ExecutionEngine||(e.ExecutionEngine={}));var o;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(o=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class u{constructor(G){this._order=new Map;for(let B=0;B<G.length;B++)this._order.set(G[B].uri.toString(),B)}compare(G,B){const U=G.getWorkspaceFolder(),X=B.getWorkspaceFolder();if(U&&X){let $=this._order.get(U.uri.toString());$=$===void 0?0:$+1;let x=this._order.get(X.uri.toString());return x=x===void 0?0:x+1,$===x?G._label.localeCompare(B._label):$-x}else return!U&&X?-1:U&&!X?1:0}}e.TaskSorter=u;var h;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(h=e.TaskEventKind||(e.TaskEventKind={}));var C;(function(F){F.SingleRun="singleRun",F.Background="background"})(C=e.TaskRunType||(e.TaskRunType={}));var R;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(R=e.TaskRunSource||(e.TaskRunSource={}));var N;(function(F){function G(B,U,X,$,x){if(U){const Q={kind:B,taskId:U._id,taskName:U.configurationProperties.name,runType:U.configurationProperties.isBackground?"background":"singleRun",group:U.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:U};return B==="start"?(Q.terminalId=X,Q.resolvedVariables=$):B==="processStarted"?Q.processId=X:B==="processEnded"&&(Q.exitCode=X),Object.freeze(Q)}else return Object.freeze({kind:"changed"})}F.create=G})(N=e.TaskEvent||(e.TaskEvent={}));var M;(function(F){function G(U){const X=Object.keys(U).sort();let $="";for(const x of X){let Q=U[x];Q instanceof Object?Q=G(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),$+=x+","+Q+","}return $}function B(U){const $={_key:G(U),type:U.taskType};return Object.assign($,U),$}F.create=B})(M=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var A;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(A=e.TaskSettingId||(e.TaskSettingId={}));var z;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(z=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var H;(function(F){function G(B,U){const X=k.TaskDefinitionRegistry.get(B.type);if(X===void 0){const de=P.deepClone(B);return delete de._key,M.create(de)}const $=Object.create(null);$.type=X.taskType;const x=new Set;X.required.forEach(de=>x.add(de));const Q=X.properties;for(const de of Object.keys(Q)){const te=B[de];if(te!=null)$[de]=te;else if(x.has(de)){const pe=Q[de];if(pe.default!==void 0)$[de]=P.deepClone(pe.default);else switch(pe.type){case"boolean":$[de]=!1;break;case"number":case"integer":$[de]=0;break;case"string":$[de]="";break;default:U.error(l.localize(2,null,JSON.stringify(B,void 0,0),de));return}}}return M.create($)}F.createTaskIdentifier=G})(H=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[234],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,k)=>{this._actualOk=_,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,l.onUnexpectedError)(_))}then(_,k){return this._ensureActual().then(_,k)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=t;class D extends t{constructor(){super(),this._hasErr=!0,this._err=new l.CancellationError}}e.CanceledLazyPromise=D}),define(De[55],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class l{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++l.count}}e.ProxyIdentifier=l,l.count=0;const t=[];function D(k){const w=new l(k);return t[w.nid]=w,w}e.createProxyIdentifier=D;function P(k){return t[k].sid}e.getStringIdentifierForProxy=P;class _{constructor(w){this.value=w}}e.SerializableObjectWithBuffers=_}),define(De[5],Ie([1,0,55]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var P;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(P=e.TabModelOperationKind||(e.TabModelOperationKind={}));var _;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var k;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(k=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var w;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(w=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class y{static mixin(b){return b._id=y._n++,b}}e.IdObject=y,y._n=0;var S;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.command="m",p.kindModifier="n"})(S=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var T;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(T=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,l.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,l.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,l.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,l.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,l.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,l.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,l.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,l.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,l.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,l.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,l.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,l.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,l.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,l.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,l.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,l.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,l.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,l.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,l.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,l.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,l.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,l.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,l.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,l.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,l.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,l.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,l.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,l.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,l.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,l.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,l.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,l.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,l.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,l.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,l.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,l.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,l.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,l.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,l.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,l.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,l.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,l.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,l.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,l.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,l.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,l.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,l.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,l.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,l.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,l.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,l.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,l.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,l.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,l.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,l.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,l.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,l.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,l.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,l.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,l.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,l.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,l.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,l.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,l.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,l.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,l.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,l.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,l.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,l.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,l.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,l.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,l.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,l.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,l.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,l.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,l.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,l.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,l.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,l.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,l.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,l.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,l.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,l.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,l.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,l.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,l.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,l.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,l.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,l.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,l.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,l.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,l.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,l.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,l.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,l.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,l.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,l.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,l.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,l.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,l.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,l.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,l.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,l.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,l.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,l.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,l.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,l.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,l.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,l.createProxyIdentifier)("ExtHostLocalization")}}),define(De[65],Ie([1,0,3,13,5,14]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,l.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(w,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=w.getProxy(D.MainContext.MainThreadTelemetry)}report(w,I,L){const y=this.getUsageKey(w,I);this._reportedUsages.has(y)||(this._reportedUsages.add(y),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${w}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:w}))}getUsageKey(w,I){return`${w}-${I.identifier.value}`}};_=qe([xe(0,P.IExtHostRpcService),xe(1,t.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(k,w,I){}})}),define(De[235],Ie([1,0,4,5,7,28]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(w){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new l.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=w.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(w){return this._providers=w,Promise.resolve()}async getSession(w,I,L,y={}){const S=P.ExtensionIdentifier.toKey(w.identifier),T=this._inFlightRequests.get(S)||[],E=[...L].sort().join(" ");let p=T.find(b=>b.providerId===I&&b.scopes===E);if(p)return p.result;{const b=this._getSession(w,S,I,L,y);p={providerId:I,scopes:E,result:b},T.push(p),this._inFlightRequests.set(S,T);try{await b}finally{const f=T.findIndex(v=>v.providerId===I&&v.scopes===E);f>-1&&(T.splice(f),this._inFlightRequests.set(S,T))}return b}}async _getSession(w,I,L,y,S={}){await this._proxy.$ensureProvider(L);const T=w.displayName||w.name;return this._proxy.$getSession(L,y,I,T,S)}async removeSession(w,I){const L=this._authenticationProviders.get(w);return L?L.provider.removeSession(I):this._proxy.$removeSession(w,I)}registerAuthenticationProvider(w,I,L,y){if(this._authenticationProviders.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this._authenticationProviders.set(w,{label:I,provider:L,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===w)||this._providers.push({id:w,label:I});const S=L.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(w,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(w,I,y?.supportsMultipleAccounts??!1),new D.Disposable(()=>{S.dispose(),this._authenticationProviders.delete(w);const T=this._providers.findIndex(E=>E.id===w);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(w)})}$createSession(w,I){const L=this._authenticationProviders.get(w);if(L)return Promise.resolve(L.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,I){const L=this._authenticationProviders.get(w);if(L)return Promise.resolve(L.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,I){const L=this._authenticationProviders.get(w);if(L)return Promise.resolve(L.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,I){return this._onDidChangeSessions.fire({provider:{id:w,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(De[236],Ie([1,0,5,14,15,27]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let _=class{constructor(w,I){this._proxy=w.getProxy(l.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:L=>I.getDocument(L)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(w,I,L){const y=(0,P.isProposedApiEnabled)(I,"workspaceEditIsRefactoring");L&&!y&&(console.warn(`Extension '${I.identifier.value}' uses a proposed API 'workspaceEditIsRefactoring' which is NOT enabled for it`),L=void 0);const S=D.WorkspaceEdit.from(w,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(S,void 0,L)}};_=qe([xe(0,t.IExtHostRpcService)],_),e.ExtHostBulkEdits=_}),define(De[237],Ie([1,0,5]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const _=P.getProxy(l.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(k){return _.$writeText(k)}})}}e.ExtHostClipboard=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[37],Ie([1,0,16,7,15,24,5,17,13,80,35,49,2,6,3,14,134,23,55,50]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f,v,g){"use strict";var c,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let n=class{constructor(o,u){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,m.set(this,void 0),tt(this,c,o.getProxy(_.MainContext.MainThreadCommands),"f"),this._logService=u,tt(this,m,o.getProxy(_.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,h=>{const C=this._apiCommands.get(h);return C?.result===i.Void?C:void 0},u),this._argumentProcessors=[{processArgument(h){return(0,I.revive)(h)}},{processArgument(h){return(0,P.cloneAndChange)(h,function(C){if(L.Range.isIRange(C))return D.Range.to(C);if(y.Position.isIPosition(C))return D.Position.to(C);if(L.Range.isIRange(C.range)&&S.URI.isUri(C.uri))return D.location.to(C);if(C instanceof f.VSBuffer)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const u=this.registerCommand(!1,o.id,async(...h)=>{const C=o.args.map((N,M)=>{if(!N.validate(h[M]))throw new Error(`Invalid argument '${N.name}' when running '${o.id}', received: ${h[M]}`);return N.convert(h[M])}),R=await this.executeCommand(o.internalId,...C);return o.result.convert(R,h,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new t.Disposable(()=>{u.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,u,h,C,R,N){if(this._logService.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this._commands.has(u))throw new Error(`command '${u}' already exists`);return this._commands.set(u,{callback:h,thisArg:C,description:R,extension:N}),o&&Ue(this,c,"f").$registerCommand(u),new t.Disposable(()=>{this._commands.delete(u)&&o&&Ue(this,c,"f").$unregisterCommand(u)})}executeCommand(o,...u){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,u,!0)}async _doExecuteCommand(o,u,h){if(this._commands.has(o))return Ue(this,c,"f").$fireCommandActivationEvent(o),this._executeContributedCommand(o,u,!1);{let C=!1;const R=(0,P.cloneAndChange)(u,function(N){if(N instanceof t.Position)return D.Position.from(N);if(N instanceof t.Range)return D.Range.from(N);if(N instanceof t.Location)return D.location.from(N);if(t.NotebookRange.isNotebookRange(N))return D.NotebookRange.from(N);if(N instanceof ArrayBuffer)return C=!0,f.VSBuffer.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return C=!0,f.VSBuffer.wrap(N);if(N instanceof f.VSBuffer)return C=!0,N;if(!Array.isArray(N))return N});try{const N=await Ue(this,c,"f").$executeCommand(o,C?new v.SerializableObjectWithBuffers(R):R,h);return(0,I.revive)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this._doExecuteCommand(o,u,!1);throw N}}}async _executeContributedCommand(o,u,h){const C=this._commands.get(o);if(!C)throw new Error("Unknown command");this._reportTelemetry(C,o);const{callback:R,thisArg:N,description:M}=C;if(M)for(let A=0;A<M.args.length;A++)try{(0,l.validateConstraint)(u[A],M.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${M.args[A].name}' - ${M.args[A].description}`)}try{return await R.apply(N,u)}catch(A){if(o===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...u);z&&(o=z.command)}throw this._logService.error(A,o,C.extension?.identifier),h?new class extends Error{constructor(){super((0,g.toErrorMessage)(A)),this.id=o,this.source=C.extension?.displayName??C.extension?.name}}:A}}_reportTelemetry(o,u){!o.extension||o.extension.isBuiltin||Ue(this,m,"f").$publicLog2("Extension:ActionExecuted",{extensionId:o.extension.identifier.value,id:u})}$executeContributedCommand(o,...u){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(u=u.map(h=>this._argumentProcessors.reduce((C,R)=>R.processArgument(C),h)),this._executeContributedCommand(o,u,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),Ue(this,c,"f").$getCommands().then(u=>(o&&(u=u.filter(h=>h[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(const[u,h]of this._commands){const{description:C}=h;C&&(o[u]=C)}return Promise.resolve(o)}};c=new WeakMap,m=new WeakMap,n=qe([xe(0,p.IExtHostRpcService),xe(1,w.ILogService)],n),e.ExtHostCommands=n,e.IExtHostCommands=(0,E.createDecorator)("IExtHostCommands");class d{constructor(o,u,h){this._commands=o,this._lookupApiCommand=u,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,u){if(!o)return;const h={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return h;const C=this._lookupApiCommand(o.command);if(C)h.id=C.internalId,h.arguments=C.args.map((R,N)=>R.convert(o.arguments&&o.arguments[N]));else if((0,k.isNonEmptyArray)(o.arguments)){const R=++this._cachIdPool;this._cache.set(R,o),u.add((0,T.toDisposable)(()=>{this._cache.delete(R),this._logService.trace("CommandsConverter#DISPOSE",R)})),h.$ident=R,h.id=this.delegatingCommandId,h.arguments=[R],this._logService.trace("CommandsConverter#CREATE",o.command,R)}return h}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const u=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],u?u.command:"MISSING"),u?this._commands.executeCommand(u.command,...u.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class s{constructor(o,u,h,C){this.name=o,this.description=u,this.validate=h,this.convert=C}optional(){return new s(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,u){return new s(o??this.name,u??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s,s.Uri=new s("uri","Uri of a text document",a=>S.URI.isUri(a),a=>a),s.Position=new s("position","A position in a text document",a=>t.Position.isPosition(a),D.Position.from),s.Range=new s("range","A range in a text document",a=>t.Range.isRange(a),D.Range.from),s.Selection=new s("selection","A selection in a text document",a=>t.Selection.isSelection(a),D.Selection.from),s.Number=new s("number","",a=>typeof a=="number",a=>a),s.String=new s("string","",a=>typeof a=="string",a=>a),s.CallHierarchyItem=new s("item","A call hierarchy item",a=>a instanceof t.CallHierarchyItem,D.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",a=>a instanceof t.TypeHierarchyItem,D.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",a=>a instanceof b.TestItemImpl,D.TestItem.from);class i{constructor(o,u){this.description=o,this.convert=u}}e.ApiCommandResult=i,i.Void=new i("no result",a=>a);class r{constructor(o,u,h,C,R){this.id=o,this.internalId=u,this.description=h,this.args=C,this.result=R}}e.ApiCommand=r}),define(De[238],Ie([1,0,2,15,7,62,37,17,115,119,12]),function(J,e,l,t,D,P,_,k,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(t.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(p,b)=>{if((0,k.isFalsyOrEmpty)(p))return;class f extends D.SymbolInformation{static to(g){const c=new f(g.name,t.SymbolKind.to(g.kind),g.containerName||"",new D.Location(b[0],t.Range.to(g.range)));return c.detail=g.detail,c.range=c.location.range,c.selectionRange=t.Range.to(g.selectionRange),c.children=g.children?g.children.map(f.to):[],c}}return p.map(f.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",p=>!0,p=>p)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",p=>!0,p=>p)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",p=>typeof p=="string",p=>p),new _.ApiCommandArgument("options","Formatting options",p=>!0,p=>p)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(t.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(t.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",p=>Array.isArray(p)&&p.every(b=>D.Position.isPosition(b)),p=>p.map(t.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",p=>p.map(b=>{let f;for(const v of b.reverse())f=new D.SelectionRange(t.Range.to(v),f);return f}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",p=>p.map(t.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",p=>p.map(t.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",p=>p.map(t.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",p=>p.map(t.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",p=>{if(!!p)return{range:t.Range.to(p.range),placeholder:p.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",p=>{if(!!p){if(p.rejectReason)throw new Error(p.rejectReason);return t.WorkspaceEdit.to(p)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",p=>p.map(t.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",p=>{if(!!p)return new D.SemanticTokensLegend(p.tokenTypes,p.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",p=>{if(!p)return;const b=(0,w.decodeSemanticTokensDto)(p);if(b.type==="full")return new D.SemanticTokens(b.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",p=>{if(!!p)return new D.SemanticTokensLegend(p.tokenTypes,p.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",p=>{if(!p)return;const b=(0,w.decodeSemanticTokensDto)(p);if(b.type==="full")return new D.SemanticTokens(b.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(p,b,f)=>{if(!p)return new D.CompletionList([]);const v=p.suggestions.map(g=>t.CompletionItem.to(g,f));return new D.CompletionList(v,p.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",p=>{if(p)return t.SignatureHelp.to(p)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(p,b,f)=>T(v=>new D.CodeLens(t.Range.to(v.range),v.command&&f.fromInternal(v.command)))(p))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",p=>D.Range.isRange(p),p=>D.Selection.isSelection(p)?t.Selection.from(p):t.Range.from(p)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(p,b,f)=>T(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(v.command)}else{const g=new D.CodeAction(v.title,v.kind?new D.CodeActionKind(v.kind):void 0);return v.edit&&(g.edit=t.WorkspaceEdit.to(v.edit)),v.command&&(g.command=f.fromInternal(v.command)),g.isPreferred=v.isPreferred,g}})(p))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",p=>p?p.map(b=>new D.ColorInformation(t.Range.to(b.range),t.Color.to(b.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",p=>p instanceof D.Color,t.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",p=>!0,p=>({uri:p.uri,range:t.Range.from(p.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",p=>p?p.map(t.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",(p,b,f)=>p.map(t.InlayHint.to.bind(void 0,f)))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(p=>({viewType:p.viewType,displayName:p.displayName,options:{transientOutputs:p.options.transientOutputs,transientCellMetadata:p.options.transientCellMetadata,transientDocumentMetadata:p.options.transientDocumentMetadata},filenamePattern:p.filenamePattern.map(b=>t.NotebookExclusiveDocumentPattern.to(b))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",p=>p.map(t.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new _.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",p=>l.URI.isUri(p)||typeof p=="string"&&(0,I.matchesSomeScheme)(p,L.Schemas.http,L.Schemas.https),p=>p),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",p=>p===void 0||typeof p=="number"||typeof p=="object",p=>p&&(typeof p=="number"?[t.ViewColumn.from(p),void 0]:[t.ViewColumn.from(p.viewColumn),t.TextEditorOpenOptions.from(p)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",p=>p===void 0||typeof p=="number"||typeof p=="object",p=>p&&(typeof p=="number"?[t.ViewColumn.from(p),void 0]:[t.ViewColumn.from(p.viewColumn),t.TextEditorOpenOptions.from(p)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",p=>p===void 0||typeof p=="object",p=>p&&[t.ViewColumn.from(p.viewColumn),t.TextEditorOpenOptions.from(p)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",p=>p.map(t.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",p=>p.map(t.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",p=>p.map(t.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void),new _.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[_.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],_.ApiCommandResult.Void)];class S{static register(b){y.forEach(b.registerApiCommand,b)}}e.ExtHostApiCommands=S;function T(p){return b=>{if(Array.isArray(b))return b.map(p)}}function E(p){if(!Array.isArray(p))return;const b=[];for(const f of p)P.isLocationLink(f)?b.push(t.DefinitionLink.to(f)):b.push(t.location.to(f));return b}}),define(De[239],Ie([1,0,18,58,4,6,2,62,28,15,7,27,5]),function(J,e,l,t,D,P,_,k,w,I,L,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(E,p,b){const f=E.getProxy(S.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,p.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===6){const o=this._commentControllers.get(a.handle);return o?o.value:a}else if(a&&a.$mid===7){const o=this._commentControllers.get(a.commentControlHandle);if(!o)return a;const u=o.getCommentThread(a.commentThreadHandle);return u?u.value:a}else if(a&&a.$mid===8){const o=this._commentControllers.get(a.thread.commentControlHandle);if(!o)return a;const u=o.getCommentThread(a.thread.commentThreadHandle);return u?{thread:u.value,text:a.text}:a}else if(a&&a.$mid===9){const o=this._commentControllers.get(a.thread.commentControlHandle);if(!o)return a;const u=o.getCommentThread(a.thread.commentThreadHandle);if(!u)return a;const h=a.commentUniqueId,C=u.getCommentByUniqueId(h);return C||a}else if(a&&a.$mid===10){const o=this._commentControllers.get(a.thread.commentControlHandle);if(!o)return a;const u=o.getCommentThread(a.thread.commentThreadHandle);if(!u)return a;const h=a.text,C=a.commentUniqueId,R=u.getCommentByUniqueId(C);return R?(typeof R.body=="string"?R.body=h:R.body.value=h,R):a}return a}})}createCommentController(a,o,u){const h=v.handlePool++,C=new c(a,h,o,u);this._commentControllers.set(C.handle,C);const R=this._commentControllersByExtension.get(w.ExtensionIdentifier.toKey(a.identifier))||[];return R.push(C),this._commentControllersByExtension.set(w.ExtensionIdentifier.toKey(a.identifier),R),C.value}$createCommentThreadTemplate(a,o,u){const h=this._commentControllers.get(a);!h||h.$createCommentThreadTemplate(o,u)}async $updateCommentThreadTemplate(a,o,u){const h=this._commentControllers.get(a);!h||h.$updateCommentThreadTemplate(o,u)}$deleteCommentThread(a,o){this._commentControllers.get(a)?.$deleteCommentThread(o)}$provideCommentingRanges(a,o,u){const h=this._commentControllers.get(a);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const C=b.getDocument(_.URI.revive(o));return(0,l.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(C,u)).then(R=>R?R.map(N=>I.Range.from(N)):void 0)}$toggleReaction(a,o,u,h,C){const R=this._commentControllers.get(a);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,l.asPromise)(()=>{const N=R.getCommentThread(o);if(N){const M=N.getCommentByUniqueId(h.uniqueIdInThread);if(R!==void 0&&M&&R.reactionHandler)return R.reactionHandler(M,d(C))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class g{constructor(a,o,u,h,C,R,N,M){this._commentControllerHandle=o,this._id=u,this._uri=h,this._range=C,this._comments=R,this.extensionDescription=N,this._isTemplate=M,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${a}.${this.handle}`),f.$createCommentThread(o,this.handle,this._id,this._uri,I.Range.from(this._range),N.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{f.$deleteCommentThread(o,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(z){A.range=z},get comments(){return A.comments},set comments(z){A.comments=z},get collapsibleState(){return A.collapsibleState},set collapsibleState(z){A.collapsibleState=z},get canReply(){return A.canReply},set canReply(z){A.canReply=z},get contextValue(){return A.contextValue},set contextValue(z){A.contextValue=z},get label(){return A.label},set label(z){A.label=z},get state(){return A.state},set state(z){A.state=z},dispose:()=>{A.dispose()}}}set threadId(a){this._id=a}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(a){a.isEqual(this._range)||(this._range=a,this.modifications.range=a,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(a){this._canReply!==a&&(this._canReply=a,this.modifications.canReply=a,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(a){this._label=a,this.modifications.label=a,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(a){this._contextValue=a,this.modifications.contextValue=a,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(a){this._comments=a,this.modifications.comments=a,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(a){this._collapseState=a,this.modifications.collapsibleState=a,this._onDidUpdateCommentThread.fire()}get state(){return(0,y.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(a){(0,y.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=a,this.modifications.state=a,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const a=u=>Object.prototype.hasOwnProperty.call(this.modifications,u),o={};a("range")&&(o.range=I.Range.from(this._range)),a("label")&&(o.label=this.label),a("contextValue")&&(o.contextValue=this.contextValue??null),a("comments")&&(o.comments=this._comments.map(u=>m(this,u,this._commentsMap))),a("collapsibleState")&&(o.collapseState=s(this._collapseState)),a("canReply")&&(o.canReply=this.canReply),a("state")&&(o.state=i(this._state)),a("isTemplate")&&(o.isTemplate=this._isTemplate),this.modifications={},f.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(a){for(const o of this._commentsMap){const u=o[0],h=o[1];if(a===h)return u}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(a=>a.dispose())}}g._handlePool=0,qe([(0,t.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(a,o,u,h){this._extension=a,this._handle=o,this._id=u,this._label=h,this._threads=new Map,f.$registerCommentController(this.handle,u,h);const C=this;this.value=Object.freeze({id:C.id,label:C.label,get options(){return C.options},set options(R){C.options=R},get commentingRangeProvider(){return C.commentingRangeProvider},set commentingRangeProvider(R){C.commentingRangeProvider=R},get reactionHandler(){return C.reactionHandler},set reactionHandler(R){C.reactionHandler=R},createCommentThread(R,N,M){return C.createCommentThread(R,N,M).value},dispose:()=>{C.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(a){this._commentingRangeProvider=a,f.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(a){this._reactionHandler=a,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!a})}get options(){return this._options}set options(a){this._options=a,f.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(a,o,u,h){if(typeof a=="string"){const C=new g(this.id,this.handle,a,o,u,h,this._extension,!1);return this._threads.set(C.handle,C),C}else{const C=new g(this.id,this.handle,void 0,a,o,u,this._extension,!1);return this._threads.set(C.handle,C),C}}$createCommentThreadTemplate(a,o){const u=new g(this.id,this.handle,void 0,_.URI.revive(a),I.Range.to(o),[],this._extension,!0);return u.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(u.handle,u),u}$updateCommentThreadTemplate(a,o){const u=this._threads.get(a);u&&(u.range=I.Range.to(o))}$deleteCommentThread(a){this._threads.get(a)?.dispose(),this._threads.delete(a)}getCommentThread(a){return this._threads.get(a)}dispose(){this._threads.forEach(a=>{a.dispose()}),this._localDisposables.forEach(a=>a.dispose())}}function m(r,a,o){let u=o.get(a);u||(u=++r.commentHandle,o.set(a,u));const h=a.author&&a.author.iconPath?a.author.iconPath.toString():void 0;return{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:u,body:typeof a.body=="string"?a.body:I.MarkdownString.from(a.body),userName:a.author.name,userIconPath:h,label:a.label,commentReactions:a.reactions?a.reactions.map(C=>n(C)):void 0,timestamp:a.timestamp?.toJSON()}}function n(r){return{label:r.label,iconPath:r.iconPath?I.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function d(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?_.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function s(r){if(r!==void 0)switch(r){case L.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}function i(r){if(r!==void 0)switch(r){case L.CommentThreadState.Unresolved:return k.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return k.CommentThreadState.Resolved}return k.CommentThreadState.Unresolved}return new v}e.createExtHostComments=T}),define(De[240],Ie([1,0,24,5,26,14]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let _=class{constructor(L,y){this._mainThreadConsole=L.getProxy(t.MainContext.MainThreadConsole),this._includeStack=y.consoleForward.includeStack,this._logNative=y.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(L,y){const S=this,T=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){S._handleConsoleCall(L,y,T,arguments)}})}_handleConsoleCall(L,y,S,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:y,arguments:w(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(L,S,T)}};_=qe([xe(0,P.IExtHostRpcService),xe(1,D.IExtHostInitDataService)],_),e.AbstractExtHostConsoleForwarder=_;const k=1e5;function w(I,L){const y=[];if(I.length)for(let S=0;S<I.length;S++){let T=I[S];if(typeof T>"u")T="undefined";else if(T instanceof Error){const E=T;E.stack?T=E.stack:T=E.toString()}y.push(T)}if(L){const S=new Error().stack;S&&y.push({__$stack:S.split(`
`).slice(3).join(`
`)})}try{const S=(0,l.safeStringify)(y);return S.length>k?"Output omitted for a large object that exceeds the limits":S}catch(S){return`Output omitted for an object that cannot be inspected ('${S.toString()}')`}}}),define(De[136],Ie([1,0,2,5,7,3,14,13,17,8,9]),function(J,e,l,t,D,P,_,k,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class Rn{constructor(T,E){this._logService=E,this._provider=new Map,this._proxy=T.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,E){const p=Rn._handlePool++;this._provider.set(p,{provider:T,extensionId:E}),this._proxy.$registerDecorationProvider(p,E.value);const b=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(f=>{if(!f){this._proxy.$onDidChange(p,null);return}const v=(0,w.asArray)(f);if(v.length<=Rn._maxEventSize){this._proxy.$onDidChange(p,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",E.value,v.length);const g=v.map(n=>({uri:n,rank:(0,I.count)(n.path,"/")})),c=(0,w.groupBy)(g,(n,d)=>n.rank-d.rank||(0,I.compare)(n.uri.path,d.uri.path)),m=[];e:for(const n of c){let d;for(const s of n){const i=(0,L.dirname)(s.uri.path);if(d!==i&&(d=i,m.push(s.uri)>=Rn._maxEventSize))break e}}this._proxy.$onDidChange(p,m)});return new D.Disposable(()=>{b?.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(T,E,p){if(!this._provider.has(T))return Object.create(null);const b=Object.create(null),{provider:f,extensionId:v}=this._provider.get(T);return await Promise.all(E.map(async g=>{try{const{uri:c,id:m}=g,n=await Promise.resolve(f.provideFileDecoration(l.URI.revive(c),p));if(!n)return;try{D.FileDecoration.validate(n),b[m]=[n.propagate,n.tooltip,n.badge,n.color]}catch(d){this._logService.warn(`INVALID decoration from extension '${v.value}': ${d}`)}}catch(c){this._logService.error(c)}})),b}};y._handlePool=0,y._maxEventSize=250,y=qe([xe(0,_.IExtHostRpcService),xe(1,k.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[241],Ie([1,0,170,118,2,5,7,15,4,13,25,46]),function(J,e,l,t,D,P,_,k,w,I,L,y){"use strict";var S,T,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class p{constructor(v,g,c,m,n,d){this._name=v,this._owner=g,this._maxDiagnosticsPerFile=c,S.set(this,void 0),T.set(this,void 0),E.set(this,void 0),this._isDisposed=!1,tt(this,E,new L.ResourceMap(s=>m.getComparisonKey(s)),"f"),tt(this,S,n,"f"),tt(this,T,d,"f")}dispose(){this._isDisposed||(Ue(this,T,"f").fire([...Ue(this,E,"f").keys()]),Ue(this,S,"f")?.$clear(this._owner),Ue(this,E,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,g){if(!v){this.clear();return}this._checkDisposed();let c=[];if(D.URI.isUri(v)){if(!g){this.delete(v);return}Ue(this,E,"f").set(v,g.slice()),c=[v]}else if(Array.isArray(v)){c=[];let n;v=[...v].sort(p._compareIndexedTuplesByUri);for(const d of v){const[s,i]=d;if((!n||s.toString()!==n.toString())&&(n&&Ue(this,E,"f").get(n).length===0&&Ue(this,E,"f").delete(n),n=s,c.push(s),Ue(this,E,"f").set(s,[])),i)Ue(this,E,"f").get(s)?.push(...i);else{const r=Ue(this,E,"f").get(s);r&&(r.length=0)}}}if(Ue(this,T,"f").fire(c),!Ue(this,S,"f"))return;const m=[];for(const n of c){let d=[];const s=Ue(this,E,"f").get(n);if(s)if(s.length>this._maxDiagnosticsPerFile){d=[];const i=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const a of s)if(a.severity===i[r]&&d.push(k.Diagnostic.from(a))===this._maxDiagnosticsPerFile)break e;d.push({severity:t.MarkerSeverity.Info,message:(0,l.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=s.map(i=>k.Diagnostic.from(i));m.push([n,d])}Ue(this,S,"f").$changeMany(this._owner,m)}delete(v){this._checkDisposed(),Ue(this,T,"f").fire([v]),Ue(this,E,"f").delete(v),Ue(this,S,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Ue(this,T,"f").fire([...Ue(this,E,"f").keys()]),Ue(this,E,"f").clear(),Ue(this,S,"f")?.$clear(this._owner)}forEach(v,g){this._checkDisposed();for(const[c,m]of this)v.call(g,c,m,this)}*[(S=new WeakMap,T=new WeakMap,E=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Ue(this,E,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const g=Ue(this,E,"f").get(v);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Ue(this,E,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,g){return v[0].toString()<g[0].toString()?-1:v[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=p;let b=class mn{constructor(v,g,c){this._logService=g,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new w.DebounceEmitter({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=w.Event.map(this._onDidChangeDiagnostics.event,mn._mapper),this._proxy=v.getProxy(P.MainContext.MainThreadDiagnostics)}static _mapper(v){const g=new L.ResourceMap;for(const c of v)g.set(c,c);return{uris:Object.freeze(Array.from(g.values()))}}createDiagnosticCollection(v,g){const{_collections:c,_proxy:m,_onDidChangeDiagnostics:n,_logService:d,_fileSystemInfoService:s}=this,i=new class{$changeMany(o,u){m.$changeMany(o,u),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,o,u.length===0?"CLEARING":u)}$clear(o){m.$clear(o),d.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,o)}dispose(){m.dispose()}};let r;if(!g)g="_generated_diagnostic_collection_name_#"+mn._idPool++,r=g;else if(!c.has(g))r=g;else{this._logService.warn(`DiagnosticCollection with name '${g}' does already exist.`);do r=g+mn._idPool++;while(c.has(r))}return new class extends p{constructor(){super(g,r,mn._maxDiagnosticsPerFile,s.extUri,i,n),c.set(r,this)}dispose(){super.dispose(),c.delete(r)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const g=new Map,c=[];for(const m of this._collections.values())m.forEach((n,d)=>{let s=g.get(n.toString());typeof s>"u"&&(s=c.length,g.set(n.toString(),s),c.push([n,[]])),c[s][1]=c[s][1].concat(...d)});return c}}_getDiagnostics(v){let g=[];for(const c of this._collections.values())c.has(v)&&(g=g.concat(c.get(v)));return g}$acceptMarkersChange(v){if(!this._mirrorCollection){const g="_generated_mirror",c=new p(g,g,mn._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(g,c),this._mirrorCollection=c}for(const[g,c]of v)this._mirrorCollection.set(D.URI.revive(g),c.map(k.Diagnostic.to))}};b._idPool=0,b._maxDiagnosticsPerFile=1e3,b=qe([xe(1,I.ILogService),xe(2,y.IExtHostFileSystemInfo)],b),e.ExtHostDiagnostics=b}),define(De[242],Ie([1,0,2,5]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(_){this._proxy=_.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(k=>k?k.map(w=>l.URI.revive(w)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(k=>k?l.URI.revive(k):void 0)}}e.ExtHostDialogs=D}),define(De[243],Ie([1,0,10,2,7,5,12,21,8]),function(J,e,l,t,D,P,_,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(y,S,T){this._documentsAndEditors=S,this._logService=T,this._documentContentProviders=new Map,this._proxy=y.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,S){if(Object.keys(_.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const T=I._handlePool++;this._documentContentProviders.set(T,S),this._proxy.$registerTextContentProvider(T,y);let E;return typeof S.onDidChange=="function"&&(E=S.onDidChange(p=>{if(p.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(p)&&this.$provideTextDocumentContent(T,p).then(b=>{if(!b&&typeof b!="string")return;const f=this._documentsAndEditors.getDocument(p);if(!f)return;const v=(0,w.splitLines)(b);if(!f.equalLines(v))return this._proxy.$onVirtualDocumentChange(p,b)},l.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(y,S){const T=this._documentContentProviders.get(y);return T?Promise.resolve(T.provideTextDocumentContent(t.URI.revive(S),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${S.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(De[244],Ie([1,0,4,6,2,5,132,15,16,24,7]),function(J,e,l,t,D,P,_,k,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(T,E){this._onDidAddDocument=new l.Emitter,this._onDidRemoveDocument=new l.Emitter,this._onDidChangeDocument=new l.Emitter,this._onDidSaveDocument=new l.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=E,this._documentsAndEditors.onDidRemoveDocuments(p=>{for(const b of p)this._onDidRemoveDocument.fire(b.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(p=>{for(const b of p)this._onDidAddDocument.fire(b.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const E=this._documentsAndEditors.getDocument(T);if(E)return E}getDocument(T){const E=this.getDocumentData(T);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return E.document}ensureDocumentData(T){const E=this._documentsAndEditors.getDocument(T);if(E)return Promise.resolve(E);let p=this._documentLoader.get(T.toString());return p||(p=this._proxy.$tryOpenDocument(T).then(b=>{this._documentLoader.delete(T.toString());const f=D.URI.revive(b);return(0,w.assertIsDefined)(this._documentsAndEditors.getDocument(f))},b=>(this._documentLoader.delete(T.toString()),Promise.reject(b))),this._documentLoader.set(T.toString(),p)),p}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(E=>D.URI.revive(E))}$acceptModelLanguageChanged(T,E){const p=D.URI.revive(T),b=this._documentsAndEditors.getDocument(p);if(!b)throw new Error("unknown document");this._onDidRemoveDocument.fire(b.document),b._acceptLanguageId(E),this._onDidAddDocument.fire(b.document)}$acceptModelSaved(T){const E=D.URI.revive(T),p=this._documentsAndEditors.getDocument(E);if(!p)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(p.document)}$acceptDirtyStateChanged(T,E){const p=D.URI.revive(T),b=this._documentsAndEditors.getDocument(p);if(!b)throw new Error("unknown document");b._acceptIsDirty(E),this._onDidChangeDocument.fire({document:b.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,E,p){const b=D.URI.revive(T),f=this._documentsAndEditors.getDocument(b);if(!f)throw new Error("unknown document");f._acceptIsDirty(p),f.onEvents(E);let v;E.isUndoing?v=L.TextDocumentChangeReason.Undo:E.isRedoing&&(v=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:f.document,contentChanges:E.changes.map(g=>({range:k.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text})),reason:v}))}setWordDefinitionFor(T,E){(0,_.setWordDefinitionFor)(T,E)}}e.ExtHostDocuments=y}),define(De[56],Ie([1,0,48,4,6,2,3,5,132,14,135,15,13,25,12,60,76]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let v=class{constructor(c,m){this._extHostRpc=c,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const m=[],n=[],d=[];if(c.removedDocuments)for(const s of c.removedDocuments){const i=P.URI.revive(s),r=this._documents.get(i);r?.unref()&&(this._documents.delete(i),m.push(r.value))}if(c.addedDocuments)for(const s of c.addedDocuments){const i=P.URI.revive(s.uri);let r=this._documents.get(i);if(r&&i.scheme!==E.Schemas.vscodeNotebookCell&&i.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);r||(r=new f(new w.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(i,r),n.push(r.value)),r.ref()}if(c.removedEditors)for(const s of c.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&d.push(i)}if(c.addedEditors)for(const s of c.addedEditors){const i=P.URI.revive(s.documentUri);l.ok(this._documents.has(i),`document '${i}' does not exist`),l.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const r=this._documents.get(i).value,a=new L.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new b.Lazy(()=>r.document),s.selections.map(y.Selection.to),s.options,s.visibleRanges.map(o=>y.Range.to(o)),typeof s.editorPosition=="number"?y.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,a)}c.newActiveEditor!==void 0&&(l.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,D.dispose)(m),(0,D.dispose)(d),c.removedDocuments&&this._onDidRemoveDocuments.fire(m),c.addedDocuments&&this._onDidAddDocuments.fire(n),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return p.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return c?m:m?.value}allEditors(){return[...this._editors.values()]}};v=qe([xe(0,I.IExtHostRpcService),xe(1,S.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[57],Ie([1,0,15,5,2,4,3,7,14,16,75]),function(J,e,l,t,D,P,_,k,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,_.createDecorator)("IExtHostEditorTabs");class y{constructor(b,f,v){this._activeTabIdGetter=v,this._parentGroup=f,this.acceptDtoUpdate(b)}get apiObject(){if(!this._apiObject){const b=this,f={get isActive(){return b._dto.id===b._activeTabIdGetter()},get label(){return b._dto.label},get input(){return b._input},get isDirty(){return b._dto.isDirty},get isPinned(){return b._dto.isPinned},get isPreview(){return b._dto.isPreview},get group(){return b._parentGroup.apiObject}};this._apiObject=Object.freeze(f)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(b){this._dto=b,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new k.TextTabInput(D.URI.revive(this._dto.input.uri));case 2:return new k.TextDiffTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified));case 3:return new k.TextMergeTabInput(D.URI.revive(this._dto.input.base),D.URI.revive(this._dto.input.input1),D.URI.revive(this._dto.input.input2),D.URI.revive(this._dto.input.result));case 6:return new k.CustomEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new k.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new k.NotebookEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new k.NotebookDiffEditorTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new k.TerminalEditorTabInput;case 9:return new k.InteractiveWindowInput(D.URI.revive(this._dto.input.uri),D.URI.revive(this._dto.input.inputBoxUri));default:return}}}class S{constructor(b,f){this._tabs=[],this._activeTabId="",this._dto=b,this._activeGroupIdGetter=f;for(const v of b.tabs)v.isActive&&(this._activeTabId=v.id),this._tabs.push(new y(v,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const b=this,f={get isActive(){return b._dto.groupId===b._activeGroupIdGetter()},get viewColumn(){return l.ViewColumn.to(b._dto.viewColumn)},get activeTab(){return b._tabs.find(v=>v.tabId===b._activeTabId)?.apiObject},get tabs(){return Object.freeze(b._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(f)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(b){this._dto=b}acceptTabOperation(b){if(b.kind===0){const v=new y(b.tabDto,this,()=>this.activeTabId());return this._tabs.splice(b.index,0,v),b.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(b.kind===1){const v=this._tabs.splice(b.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${b.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(b.kind===3){if(b.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(b.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${b.oldIndex} which does not exist`);return this._tabs.splice(b.index,0,v),v}const f=this._tabs.find(v=>v.tabId===b.tabDto.id);if(!f)throw new Error("INVALID tab");return b.tabDto.isActive?this._activeTabId=b.tabDto.id:this._activeTabId===b.tabDto.id&&!b.tabDto.isActive&&(this._activeTabId=""),f.acceptDtoUpdate(b.tabDto),f}activeTabId(){return this._activeTabId}}let T=class{constructor(b){this._onDidChangeTabs=new P.Emitter,this._onDidChangeTabGroups=new P.Emitter,this._extHostTabGroups=[],this._proxy=b.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const b=this,f={onDidChangeTabGroups:b._onDidChangeTabGroups.event,onDidChangeTabs:b._onDidChangeTabs.event,get all(){return Object.freeze(b._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=b._activeGroupId;return(0,I.assertIsDefined)(b._extHostTabGroups.find(c=>c.groupId===v)?.apiObject)},close:async(v,g)=>{const c=Array.isArray(v)?v:[v];return c.length?E(c[0])?this._closeGroups(c,g):this._closeTabs(c,g):!0}};this._apiObject=Object.freeze(f)}return this._apiObject}$acceptEditorTabModel(b){const f=new Set(this._extHostTabGroups.map(s=>s.groupId)),v=new Set(b.map(s=>s.groupId)),g=(0,L.diffSets)(f,v),c=this._extHostTabGroups.filter(s=>g.removed.includes(s.groupId)).map(s=>s.apiObject),m=[],n=[];this._extHostTabGroups=b.map(s=>{const i=new S(s,()=>this._activeGroupId);return g.added.includes(i.groupId)?m.push(i.apiObject):n.push(i.apiObject),i});const d=(0,I.assertIsDefined)(b.find(s=>s.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:m,closed:c,changed:n}))}$acceptTabGroupUpdate(b){const f=this._extHostTabGroups.find(v=>v.groupId===b.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(b),b.isActive&&(this._activeGroupId=b.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(b){const f=this._extHostTabGroups.find(g=>g.groupId===b.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const v=f.acceptTabOperation(b);switch(b.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(b){for(const f of this._extHostTabGroups)for(const v of f.tabs)if(v.apiObject===b)return v}_findExtHostTabGroupFromApi(b){return this._extHostTabGroups.find(f=>f.apiObject===b)}async _closeTabs(b,f){const v=[];for(const g of b){const c=this._findExtHostTabFromApi(g);if(!c)throw new Error("Tab close: Invalid tab not found!");v.push(c.tabId)}return this._proxy.$closeTab(v,f)}async _closeGroups(b,f){const v=[];for(const g of b){const c=this._findExtHostTabGroupFromApi(g);if(!c)throw new Error("Group close: Invalid group not found!");v.push(c.groupId)}return this._proxy.$closeGroup(v,f)}};T=qe([xe(0,w.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function E(p){return p.tabs!==void 0}}),define(De[245],Ie([1,0,2,5,6,7,15,150,8,23,27]),function(J,e,l,t,D,P,_,k,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class y{constructor(){this._schemes=[]}add(E){this._stateMachine=void 0,this._schemes.push(E)}delete(E){const p=this._schemes.indexOf(E);p>=0&&(this._schemes.splice(p,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const E=this._schemes.sort(),p=[];let b,f,v=14,g=14;for(const c of E){let m=b?(0,w.commonPrefixLength)(b,c):0;for(m===0?f=1:f=g;m<c.length;m++)m+1===c.length?(v=g,g=9):g+=1,p.push([f,c.toUpperCase().charCodeAt(m),g]),p.push([f,c.toLowerCase().charCodeAt(m),g]),f=g;b=c,g=v}p.push([9,58,10]),p.push([10,47,12]),this._stateMachine=new k.StateMachine(p)}}provideDocumentLinks(E){this._initStateMachine();const p=[],b=k.LinkComputer.computeLinks({getLineContent(f){return E.lineAt(f-1).text},getLineCount(){return E.lineCount}},this._stateMachine);for(const f of b){const v=_.DocumentLink.to(f);v.target&&p.push(v)}return p}}class S{constructor(E,p){this._extHostLanguageFeatures=p,this._linkProvider=new y,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=E.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(E,p,b,f={}){if(this._registeredSchemes.has(p))throw new Error(`a provider for the scheme '${p}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(E,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(p),this._registeredSchemes.add(p),this._fsProvider.set(v,b);let g=2;f.isCaseSensitive&&(g+=1024),f.isReadonly&&(g+=2048),typeof b.copy=="function"&&(g+=8),typeof b.open=="function"&&typeof b.close=="function"&&typeof b.read=="function"&&typeof b.write=="function"&&((0,L.checkProposedApiEnabled)(E,"fsChunks"),g+=4),this._proxy.$registerFileSystemProvider(v,p,g).catch(m=>{console.error(`FAILED to register filesystem provider of ${E.identifier.value}-extension for the scheme ${p}`),console.error(m)});const c=b.onDidChangeFile(m=>{const n=[];for(const d of m){const{uri:s,type:i}=d;if(s.scheme!==p)continue;let r;switch(i){case P.FileChangeType.Changed:r=0;break;case P.FileChangeType.Created:r=1;break;case P.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:s,type:r})}this._proxy.$onFileSystemChange(v,n)});return(0,D.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(p),this._registeredSchemes.delete(p),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(E){const{type:p,ctime:b,mtime:f,size:v,permissions:g}=E;return{type:p,ctime:b,mtime:f,size:v,permissions:g}}$stat(E,p){return Promise.resolve(this._getFsProvider(E).stat(l.URI.revive(p))).then(b=>S._asIStat(b))}$readdir(E,p){return Promise.resolve(this._getFsProvider(E).readDirectory(l.URI.revive(p)))}$readFile(E,p){return Promise.resolve(this._getFsProvider(E).readFile(l.URI.revive(p))).then(b=>I.VSBuffer.wrap(b))}$writeFile(E,p,b,f){return Promise.resolve(this._getFsProvider(E).writeFile(l.URI.revive(p),b.buffer,f))}$delete(E,p,b){return Promise.resolve(this._getFsProvider(E).delete(l.URI.revive(p),b))}$rename(E,p,b,f){return Promise.resolve(this._getFsProvider(E).rename(l.URI.revive(p),l.URI.revive(b),f))}$copy(E,p,b,f){const v=this._getFsProvider(E);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(l.URI.revive(p),l.URI.revive(b),f))}$mkdir(E,p){return Promise.resolve(this._getFsProvider(E).createDirectory(l.URI.revive(p)))}$watch(E,p,b,f){const v=this._getFsProvider(E).watch(l.URI.revive(b),f);this._watches.set(p,v)}$unwatch(E,p){const b=this._watches.get(p);b&&(b.dispose(),this._watches.delete(p))}$open(E,p,b){const f=this._getFsProvider(E);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(l.URI.revive(p),b))}$close(E,p){const b=this._getFsProvider(E);if(!b.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(b.close(p))}$read(E,p,b,f){const v=this._getFsProvider(E);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const g=I.VSBuffer.alloc(f);return Promise.resolve(v.read(p,b,g.buffer,0,f)).then(c=>g.slice(0,c))}$write(E,p,b,f){const v=this._getFsProvider(E);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(p,b,f.buffer,0,f.byteLength))}_getFsProvider(E){const p=this._fsProvider.get(E);if(!p){const b=new Error;throw b.name="ENOPRO",b.message="no provider",b}return p}}e.ExtHostFileSystem=S}),define(De[66],Ie([1,0,5,42,7,23,3,14,46,6]),function(J,e,l,t,D,P,_,k,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Qt{constructor(S,T){this._fileSystemProvider=new Map,this._proxy=S.getProxy(l.MainContext.MainThreadFileSystem);const E=this;this.value=Object.freeze({async stat(p){try{const b=E._fileSystemProvider.get(p.scheme);if(!b)return await E._proxy.$stat(p);await E._proxy.$ensureActivation(p.scheme);const f=await b.stat(p);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(b){Qt._handleError(b)}},async readDirectory(p){try{const b=E._fileSystemProvider.get(p.scheme);return b?(await E._proxy.$ensureActivation(p.scheme),(await b.readDirectory(p)).slice()):await E._proxy.$readdir(p)}catch(b){return Qt._handleError(b)}},async createDirectory(p){try{return await E._proxy.$mkdir(p)}catch(b){return Qt._handleError(b)}},async readFile(p){try{const b=E._fileSystemProvider.get(p.scheme);return b?(await E._proxy.$ensureActivation(p.scheme),(await b.readFile(p)).slice()):(await E._proxy.$readFile(p)).buffer}catch(b){return Qt._handleError(b)}},async writeFile(p,b){try{return await E._proxy.$writeFile(p,P.VSBuffer.wrap(b))}catch(f){return Qt._handleError(f)}},async delete(p,b){try{const f=E._fileSystemProvider.get(p.scheme);return f?(await E._proxy.$ensureActivation(p.scheme),await f.delete(p,{recursive:!1,...b})):await E._proxy.$delete(p,{recursive:!1,useTrash:!1,...b})}catch(f){return Qt._handleError(f)}},async rename(p,b,f){try{return await E._proxy.$rename(p,b,{overwrite:!1,...f})}catch(v){return Qt._handleError(v)}},async copy(p,b,f){try{return await E._proxy.$copy(p,b,{overwrite:!1,...f})}catch(v){return Qt._handleError(v)}},isWritableFileSystem(p){const b=T.getCapabilities(p);if(typeof b=="number")return!(b&2048)}})}static _handleError(S){if(S instanceof D.FileSystemError)throw S;if(!(S instanceof Error))throw new D.FileSystemError(String(S));if(S.name==="ENOPRO")throw D.FileSystemError.Unavailable(S.message);switch(S.name){case t.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(S.message);case t.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(S.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(S.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(S.message);case t.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(S.message);case t.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(S.message);default:throw new D.FileSystemError(S.message,S.name)}}addFileSystemProvider(S,T){return this._fileSystemProvider.set(S,T),(0,I.toDisposable)(()=>this._fileSystemProvider.delete(S))}};L=qe([xe(0,k.IExtHostRpcService),xe(1,w.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(De[246],Ie([1,0,4,36,2,5,15,7]),function(J,e,l,t,D,P,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class w{constructor(y,S,T,E,p,b,f,v){this._onDidCreate=new l.Emitter,this._onDidChange=new l.Emitter,this._onDidDelete=new l.Emitter;const g=this.ensureWatching(y,T,p);this._config=0,b&&(this._config+=1),f&&(this._config+=2),v&&(this._config+=4);const c=(0,t.parse)(p),m=typeof p=="string",n=E(d=>{if(!b)for(const s of d.created){const i=D.URI.revive(s);c(i.fsPath)&&(!m||S.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!f)for(const s of d.changed){const i=D.URI.revive(s);c(i.fsPath)&&(!m||S.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!v)for(const s of d.deleted){const i=D.URI.revive(s);c(i.fsPath)&&(!m||S.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=k.Disposable.from(g,this._onDidCreate,this._onDidChange,this._onDidDelete,n)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(y,S,T){const E=k.Disposable.from();if(typeof T=="string")return E;const p=y.getProxy(P.MainContext.MainThreadFileSystem);let b=!1;(T.pattern.includes(t.GLOBSTAR)||T.pattern.includes(t.GLOB_SPLIT))&&(b=!0);const f=Math.random();return p.$watch(S.identifier.value,f,T.baseUri,{recursive:b,excludes:[]}),k.Disposable.from({dispose:()=>p.$unwatch(f)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class I{constructor(y,S,T){this._mainContext=y,this._logService=S,this._extHostDocumentsAndEditors=T,this._onFileSystemEvent=new l.Emitter,this._onDidRenameFile=new l.Emitter,this._onDidCreateFile=new l.Emitter,this._onDidDeleteFile=new l.Emitter,this._onWillRenameFile=new l.AsyncEmitter,this._onWillCreateFile=new l.AsyncEmitter,this._onWillDeleteFile=new l.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(y,S,T,E,p,b){return new w(this._mainContext,y,S,this._onFileSystemEvent.event,_.GlobPattern.from(T),E,p,b)}$onFileEvent(y){this._onFileSystemEvent.fire(y)}$onDidRunFileOperation(y,S){switch(y){case 2:this._onDidRenameFile.fire(Object.freeze({files:S.map(T=>({oldUri:D.URI.revive(T.source),newUri:D.URI.revive(T.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:S.map(T=>D.URI.revive(T.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:S.map(T=>D.URI.revive(T.target))}));break;default:}}getOnWillRenameFileEvent(y){return this._createWillExecuteEvent(y,this._onWillRenameFile)}getOnWillCreateFileEvent(y){return this._createWillExecuteEvent(y,this._onWillCreateFile)}getOnWillDeleteFileEvent(y){return this._createWillExecuteEvent(y,this._onWillDeleteFile)}_createWillExecuteEvent(y,S){return(T,E,p)=>{const b=function(v){T.call(E,v)};return b.extension=y,S.event(b,void 0,p)}}async $onWillRunFileOperation(y,S,T,E){switch(y){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:S.map(p=>({oldUri:D.URI.revive(p.source),newUri:D.URI.revive(p.target)}))},T,E);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:S.map(p=>D.URI.revive(p.target))},T,E);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:S.map(p=>D.URI.revive(p.target))},T,E)}}async _fireWillEvent(y,S,T,E){const p=new Set,b=[];if(await y.fireAsync(S,E,async(v,g)=>{const c=Date.now(),m=await Promise.resolve(v);m instanceof k.WorkspaceEdit&&(b.push([g.extension,m]),p.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-c>T&&this._logService.warn("SLOW file-participant",g.extension.identifier)}),E.isCancellationRequested||b.length===0)return;const f={edits:[]};for(const[,v]of b){const{edits:g}=_.WorkspaceEdit.from(v,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});f.edits=f.edits.concat(g)}return{edit:f,extensionNames:Array.from(p)}}}e.ExtHostFileSystemEventService=I}),define(De[247],Ie([1,0,2,37]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(_,k,w,I,L){this._extHostNotebooks=k,this._textDocumentsAndEditors=w,this._commands=I;const y=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",S=>!0,S=>S),new t.ApiCommandArgument("resource","Interactive resource Uri",S=>!0,S=>S),new t.ApiCommandArgument("controllerId","Notebook controller Id",S=>!0,S=>S),new t.ApiCommandArgument("title","Interactive editor title",S=>!0,S=>S)],new t.ApiCommandResult("Notebook and input URI",S=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",S.notebookEditorId),S.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(S.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:l.URI.revive(S.notebookUri),inputUri:l.URI.revive(S.inputUri),notebookEditor:T.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",S.notebookUri,S.inputUri),{notebookUri:l.URI.revive(S.notebookUri),inputUri:l.URI.revive(S.inputUri)}}));this._commands.registerApiCommand(y)}$willAddInteractiveDocument(_,k,w,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:w,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(l.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=D}),define(De[248],Ie([1,0,6,5]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(_){this._handlePool=0,this._proxy=_.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,_),(0,l.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=D}),define(De[249],Ie([1,0,2,24,15,7,62,5,8,35,17,16,146,21,6,115,95,87,51,10,18,27]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f,v,g,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class n{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentSymbols(O,V){const q=this._documents.getDocument(O),K=await this._provider.provideDocumentSymbols(q,V);if(!(0,L.isFalsyOrEmpty)(K))return K[0]instanceof P.DocumentSymbol?K.map(D.DocumentSymbol.from):n._asDocumentSymbolTree(K)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((K,me)=>{let we=K.location.range.start.compareTo(me.location.range.start);return we===0&&(we=me.location.range.end.compareTo(K.location.range.end)),we});const V=[],q=[];for(const K of O){const me={name:K.name||"!!MISSING: name!!",kind:D.SymbolKind.from(K.kind),tags:K.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:D.Range.from(K.location.range),selectionRange:D.Range.from(K.location.range),children:[]};for(;;){if(q.length===0){q.push(me),V.push(me);break}const we=q[q.length-1];if(I.Range.containsRange(we.range,me.range)&&!I.Range.equalsRange(we.range,me.range)){we.children?.push(me),q.push(me);break}q.pop()}}return V}}class d{constructor(O,V,q){this._documents=O,this._commands=V,this._provider=q,this._cache=new f.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,V){const q=this._documents.getDocument(O),K=await this._provider.provideCodeLenses(q,V);if(!K||V.isCancellationRequested)return;const me=this._cache.add(K),we=new E.DisposableStore;this._disposables.set(me,we);const ce={cacheId:me,lenses:[]};for(let Ce=0;Ce<K.length;Ce++)ce.lenses.push({cacheId:[me,Ce],range:D.Range.from(K[Ce].range),command:this._commands.toInternal(K[Ce].command,we)});return ce}async resolveCodeLens(O,V){const q=O.cacheId&&this._cache.get(...O.cacheId);if(!q)return;let K;if(typeof this._provider.resolveCodeLens!="function"||q.isResolved?K=q:K=await this._provider.resolveCodeLens(q,V),K||(K=q),V.isCancellationRequested)return;const me=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!me)return O.command=this._commands.toInternal(K.command??d._badCmd,me),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function s(ie){return Array.isArray(ie)?ie.map(D.DefinitionLink.from):ie?[D.DefinitionLink.from(ie)]:[]}class i{constructor(O,V){this._documents=O,this._provider=V}async provideDefinition(O,V,q){const K=this._documents.getDocument(O),me=D.Position.to(V),we=await this._provider.provideDefinition(K,me,q);return s(we)}}class r{constructor(O,V){this._documents=O,this._provider=V}async provideDeclaration(O,V,q){const K=this._documents.getDocument(O),me=D.Position.to(V),we=await this._provider.provideDeclaration(K,me,q);return s(we)}}class a{constructor(O,V){this._documents=O,this._provider=V}async provideImplementation(O,V,q){const K=this._documents.getDocument(O),me=D.Position.to(V),we=await this._provider.provideImplementation(K,me,q);return s(we)}}class o{constructor(O,V){this._documents=O,this._provider=V}async provideTypeDefinition(O,V,q){const K=this._documents.getDocument(O),me=D.Position.to(V),we=await this._provider.provideTypeDefinition(K,me,q);return s(we)}}class u{constructor(O,V){this._documents=O,this._provider=V}async provideHover(O,V,q){const K=this._documents.getDocument(O),me=D.Position.to(V),we=await this._provider.provideHover(K,me,q);if(!(!we||(0,L.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=K.getWordRangeAtPosition(me)),we.range||(we.range=new P.Range(me,me)),D.Hover.from(we)}}class h{constructor(O,V){this._documents=O,this._provider=V}async provideEvaluatableExpression(O,V,q){const K=this._documents.getDocument(O),me=D.Position.to(V),we=await this._provider.provideEvaluatableExpression(K,me,q);if(we)return D.EvaluatableExpression.from(we)}}class C{constructor(O,V){this._documents=O,this._provider=V}async provideInlineValues(O,V,q,K){const me=this._documents.getDocument(O),we=await this._provider.provideInlineValues(me,D.Range.to(V),D.InlineValueContext.to(q),K);if(Array.isArray(we))return we.map(ce=>D.InlineValue.from(ce))}}class R{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentHighlights(O,V,q){const K=this._documents.getDocument(O),me=D.Position.to(V),we=await this._provider.provideDocumentHighlights(K,me,q);if(Array.isArray(we))return we.map(D.DocumentHighlight.from)}}class N{constructor(O,V){this._documents=O,this._provider=V}async provideLinkedEditingRanges(O,V,q){const K=this._documents.getDocument(O),me=D.Position.to(V),we=await this._provider.provideLinkedEditingRanges(K,me,q);if(we&&Array.isArray(we.ranges))return{ranges:(0,L.coalesce)(we.ranges.map(D.Range.from)),wordPattern:we.wordPattern}}}class M{constructor(O,V){this._documents=O,this._provider=V}async provideReferences(O,V,q,K){const me=this._documents.getDocument(O),we=D.Position.to(V),ce=await this._provider.provideReferences(me,we,q,K);if(Array.isArray(ce))return ce.map(D.location.from)}}class A{constructor(O,V,q,K,me,we,ce){this._documents=O,this._commands=V,this._diagnostics=q,this._provider=K,this._logService=me,this._extension=we,this._apiDeprecation=ce,this._cache=new f.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,V,q,K){const me=this._documents.getDocument(O),we=S.Selection.isISelection(V)?D.Selection.to(V):D.Range.to(V),ce=[];for(const Qe of this._diagnostics.getDiagnostics(O))if(we.intersection(Qe.range)&&ce.push(Qe)>A._maxCodeActionsPerFile)break;const Ce={diagnostics:ce,only:q.only?new P.CodeActionKind(q.only):void 0,triggerKind:D.CodeActionTriggerKind.to(q.trigger)},ye=await this._provider.provideCodeActions(me,we,Ce,K);if(!(0,L.isNonEmptyArray)(ye)||K.isCancellationRequested)return;const He=this._cache.add(ye),je=new E.DisposableStore;this._disposables.set(He,je);const Ze=[];for(let Qe=0;Qe<ye.length;Qe++){const Le=ye[Qe];!Le||(A._isCommand(Le)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:Le.title,command:this._commands.toInternal(Le,je)})):(Ce.only&&(Le.kind?Ce.only.contains(Le.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action is of kind '${Le.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[He,Qe],title:Le.title,command:Le.command&&this._commands.toInternal(Le.command,je),diagnostics:Le.diagnostics&&Le.diagnostics.map(D.Diagnostic.from),edit:Le.edit&&D.WorkspaceEdit.from(Le.edit,void 0),kind:Le.kind&&Le.kind.value,isPreferred:Le.isPreferred,disabled:Le.disabled?.reason})))}return{cacheId:He,actions:Ze}}async resolveCodeAction(O,V){const[q,K]=O,me=this._cache.get(q,K);if(!me||A._isCommand(me)||!this._provider.resolveCodeAction)return;const we=await this._provider.resolveCodeAction(me,V)??me;return we?.edit?D.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}A._maxCodeActionsPerFile=1e3;class z{constructor(O,V,q,K){this._proxy=O,this._documents=V,this._provider=q,this._handle=K}async prepareDocumentPaste(O,V,q,K){if(!this._provider.prepareDocumentPaste)return;const me=this._documents.getDocument(O),we=V.map(Ce=>D.Range.to(Ce)),ce=D.DataTransfer.toDataTransfer(q,()=>{throw new g.NotImplementedError});return await this._provider.prepareDocumentPaste(me,we,ce,K),D.DataTransfer.toDataTransferDTO(ce)}async providePasteEdits(O,V,q,K,me){const we=this._documents.getDocument(V),ce=q.map(He=>D.Range.to(He)),Ce=D.DataTransfer.toDataTransfer(K,async He=>(await this._proxy.$resolvePasteFileData(this._handle,O,He)).buffer),ye=await this._provider.provideDocumentPasteEdits(we,ce,Ce,me);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?D.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class H{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentFormattingEdits(O,V,q){const K=this._documents.getDocument(O),me=await this._provider.provideDocumentFormattingEdits(K,V,q);if(Array.isArray(me))return me.map(D.TextEdit.from)}}class F{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentRangeFormattingEdits(O,V,q,K){const me=this._documents.getDocument(O),we=D.Range.to(V),ce=await this._provider.provideDocumentRangeFormattingEdits(me,we,q,K);if(Array.isArray(ce))return ce.map(D.TextEdit.from)}}class G{constructor(O,V){this._documents=O,this._provider=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,V,q,K,me){const we=this._documents.getDocument(O),ce=D.Position.to(V),Ce=await this._provider.provideOnTypeFormattingEdits(we,ce,q,K,me);if(Array.isArray(Ce))return Ce.map(D.TextEdit.from)}}class B{constructor(O,V){this._provider=O,this._logService=V,this._cache=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,V){const q=await this._provider.provideWorkspaceSymbols(O,V);if(!(0,L.isNonEmptyArray)(q))return{symbols:[]};const K=this._cache.add(q),me={cacheId:K,symbols:[]};for(let we=0;we<q.length;we++){const ce=q[we];if(!ce||!ce.name){this._logService.warn("INVALID SymbolInformation",ce);continue}me.symbols.push({...D.WorkspaceSymbol.from(ce),cacheId:[K,we]})}return me}async resolveWorkspaceSymbol(O,V){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const q=this._cache.get(...O.cacheId);if(q){const K=await this._provider.resolveWorkspaceSymbol(q,V);return K&&(0,t.mixin)(O,D.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class U{constructor(O,V,q){this._documents=O,this._provider=V,this._logService=q}static supportsResolving(O){return typeof O.prepareRename=="function"}async provideRenameEdits(O,V,q,K){const me=this._documents.getDocument(O),we=D.Position.to(V);try{const ce=await this._provider.provideRenameEdits(me,we,q,K);return ce?D.WorkspaceEdit.from(ce):void 0}catch(ce){const Ce=U._asMessage(ce);return Ce?{rejectReason:Ce,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(O,V,q){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const K=this._documents.getDocument(O),me=D.Position.to(V);try{const we=await this._provider.prepareRename(K,me,q);let ce,Ce;if(P.Range.isRange(we)?(ce=we,Ce=K.getText(we)):(0,y.isObject)(we)&&(ce=we.range,Ce=we.placeholder),!ce||!Ce)return;if(ce.start.line>me.line||ce.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ce),text:Ce}}catch(we){const ce=U._asMessage(we);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(we)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class X{constructor(O,V){this.resultId=O,this.tokens=V}}class ${constructor(O,V){this._documents=O,this._provider=V,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,V,q){const K=this._documents.getDocument(O),me=V!==0?this._previousResults.get(V):null;let we=typeof me?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(K,me.resultId,q):await this._provider.provideDocumentSemanticTokens(K,q);return me&&this._previousResults.delete(V),we?(we=$._fixProvidedSemanticTokens(we),this._send($._convertToEdits(me,we),we)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return $._isSemanticTokens(O)?$._isCorrectSemanticTokens(O)?O:new P.SemanticTokens(new Uint32Array(O.data),O.resultId):$._isSemanticTokensEdits(O)?$._isCorrectSemanticTokensEdits(O)?O:new P.SemanticTokensEdits(O.edits.map(V=>new P.SemanticTokensEdit(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const V of O.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,V){if(!$._isSemanticTokens(V)||!O||!O.tokens)return V;const q=O.tokens,K=q.length,me=V.data,we=me.length;let ce=0;const Ce=Math.min(K,we);for(;ce<Ce&&q[ce]===me[ce];)ce++;if(ce===K&&ce===we)return new P.SemanticTokensEdits([],V.resultId);let ye=0;const He=Ce-ce;for(;ye<He&&q[K-ye-1]===me[we-ye-1];)ye++;return new P.SemanticTokensEdits([{start:ce,deleteCount:K-ce-ye,data:me.subarray(ce,we-ye)}],V.resultId)}_send(O,V){if($._isSemanticTokens(O)){const q=this._nextResultId++;return this._previousResults.set(q,new X(O.resultId,O.data)),(0,p.encodeSemanticTokensDto)({id:q,type:"full",data:O.data})}if($._isSemanticTokensEdits(O)){const q=this._nextResultId++;return $._isSemanticTokens(V)?this._previousResults.set(q,new X(V.resultId,V.data)):this._previousResults.set(q,new X(O.resultId)),(0,p.encodeSemanticTokensDto)({id:q,type:"delta",deltas:(O.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}e.DocumentSemanticTokensAdapter=$;class x{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentRangeSemanticTokens(O,V,q){const K=this._documents.getDocument(O),me=await this._provider.provideDocumentRangeSemanticTokens(K,D.Range.to(V),q);return me?this._send(me):null}_send(O){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}e.DocumentRangeSemanticTokensAdapter=x;class Q{constructor(O,V,q,K,me){this._documents=O,this._commands=V,this._provider=q,this._apiDeprecation=K,this._extension=me,this._cache=new f.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}async provideCompletionItems(O,V,q,K){const me=this._documents.getDocument(O),we=D.Position.to(V),ce=me.getWordRangeAtPosition(we)||new P.Range(we,we),Ce=ce.with({end:we}),ye=new v.StopWatch(!0),He=await this._provider.provideCompletionItems(me,we,K,D.CompletionContext.to(q));if(!He||K.isCancellationRequested)return;const je=Array.isArray(He)?new P.CompletionList(He):He,Ze=Q.supportsResolving(this._provider)?this._cache.add(je.items):this._cache.add([]),Qe=new E.DisposableStore;this._disposables.set(Ze,Qe);const Le=[],rt={x:Ze,b:Le,a:{replace:D.Range.from(ce),insert:D.Range.from(Ce)},c:je.isIncomplete||void 0,d:ye.elapsed()};for(let re=0;re<je.items.length;re++){const se=je.items[re],Se=this._convertCompletionItem(se,[Ze,re],Ce,ce);Le.push(Se)}return rt}async resolveCompletionItem(O,V){if(typeof this._provider.resolveCompletionItem!="function")return;const q=this._cache.get(...O);if(!q)return;const K=await this._provider.resolveCompletionItem(q,V);if(!!K)return this._convertCompletionItem(K,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,V,q,K){const me=this._disposables.get(V[0]);if(!me)throw Error("DisposableStore is missing...");const we={x:V,a:O.label,b:O.kind!==void 0?D.CompletionItemKind.from(O.kind):void 0,n:O.tags&&O.tags.map(D.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:D.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters,l:O.additionalTextEdits&&O.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(O.command,me)};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=O.textEdit.newText):typeof O.insertText=="string"?we.h=O.insertText:O.insertText instanceof P.SnippetString&&(we.h=O.insertText.value,we.i|=4);let ce;return O.textEdit?ce=O.textEdit.range:O.range&&(ce=O.range),P.Range.isRange(ce)?we.j=D.Range.from(ce):ce&&(!q?.isEqual(ce.inserting)||!K?.isEqual(ce.replacing))&&(we.j={insert:D.Range.from(ce.inserting),replace:D.Range.from(ce.replacing)}),we}}class de{async provideInlineCompletions(O,V,q,K){}disposeCompletions(O){}handleDidShowCompletionItem(O,V){}}class te extends de{constructor(O,V,q,K){super(),this._extension=O,this._documents=V,this._provider=q,this._commands=K,this._references=new Y,this._isAdditionsProposedApiEnabled=(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[_.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,V,q,K){const me=this._documents.getDocument(O),we=D.Position.to(V),ce=await this._provider.provideInlineCompletionItems(me,we,{selectedCompletionInfo:q.selectedSuggestionInfo?{range:D.Range.to(q.selectedSuggestionInfo.range),text:q.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[q.triggerKind]},K);if(!ce||K.isCancellationRequested)return;const Ce=Array.isArray(ce)?ce:ce.items,ye=this._isAdditionsProposedApiEnabled?Array.isArray(ce)?[]:ce.commands||[]:[];let He;return{pid:this._references.createReferenceId({dispose(){He?.dispose()},items:Ce}),items:Ce.map((Ze,Qe)=>{let Le;Ze.command&&(He||(He=new E.DisposableStore),Le=this._commands.toInternal(Ze.command,He));const rt=Ze.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Ze.filterText,range:Ze.range?D.Range.from(Ze.range):void 0,command:Le,idx:Qe,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>(He||(He=new E.DisposableStore),this._commands.toInternal(Ze,He)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,V){const q=this._references.get(O)?.items[V];q&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(q)}}class pe extends de{constructor(O,V,q,K){super(),this.extension=O,this._documents=V,this._provider=q,this._commands=K,this._references=new Y,this.isAdditionProposedApiEnabled=(0,m.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKindNew.Automatic,[_.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(O,V,q,K){const me=this._documents.getDocument(O),we=D.Position.to(V),ce=await this._provider.provideInlineCompletionItems(me,we,{selectedCompletionInfo:q.selectedSuggestionInfo?{range:D.Range.to(q.selectedSuggestionInfo.range),text:q.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[q.triggerKind]},K);if(!ce||K.isCancellationRequested)return;const Ce=Array.isArray(ce)?ce:ce.items,ye=Array.isArray(ce)?[]:ce.commands||[];let He;return{pid:this._references.createReferenceId({dispose(){He?.dispose()},items:Ce}),items:Ce.map((Ze,Qe)=>{let Le;Ze.command&&(He||(He=new E.DisposableStore),Le=this._commands.toInternal(Ze.command,He));const rt=Ze.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Ze.filterText,range:Ze.range?D.Range.from(Ze.range):void 0,command:Le,idx:Qe,completeBracketPairs:this.isAdditionProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>(He||(He=new E.DisposableStore),this._commands.toInternal(Ze,He)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,V){const q=this._references.get(O)?.items[V];q&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(q)}}class Y{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const V=this._idPool++;return this._references.set(V,O),V}disposeReferenceId(O){const V=this._references.get(O);return this._references.delete(O),V}get(O){return this._references.get(O)}}class ve{constructor(O,V){this._documents=O,this._provider=V,this._cache=new f.Cache("SignatureHelp")}async provideSignatureHelp(O,V,q,K){const me=this._documents.getDocument(O),we=D.Position.to(V),ce=this.reviveContext(q),Ce=await this._provider.provideSignatureHelp(me,we,K,ce);if(Ce){const ye=this._cache.add([Ce]);return{...D.SignatureHelp.from(Ce),id:ye}}}reviveContext(O){let V;if(O.activeSignatureHelp){const q=D.SignatureHelp.to(O.activeSignatureHelp),K=this._cache.get(O.activeSignatureHelp.id,0);K?(V=K,V.activeSignature=q.activeSignature,V.activeParameter=q.activeParameter):V=q}return{...O,activeSignatureHelp:V}}releaseSignatureHelp(O){this._cache.delete(O)}}class be{constructor(O,V,q,K,me){this._documents=O,this._commands=V,this._provider=q,this._logService=K,this._extension=me,this._cache=new f.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,V,q){const K=this._documents.getDocument(O),me=D.Range.to(V),we=await this._provider.provideInlayHints(K,me,q);if(!Array.isArray(we)||we.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${V}`);return}if(q.isCancellationRequested)return;const ce=this._cache.add(we);this._disposables.set(ce,new E.DisposableStore);const Ce={hints:[],cacheId:ce};for(let ye=0;ye<we.length;ye++)this._isValidInlayHint(we[ye],me)&&Ce.hints.push(this._convertInlayHint(we[ye],[ce,ye]));return this._logService.trace(`[InlayHints] ${Ce.hints.length} inlay hints from '${this._extension.identifier.value}' for ${V}`),Ce}async resolveInlayHint(O,V){if(typeof this._provider.resolveInlayHint!="function")return;const q=this._cache.get(...O);if(!q)return;const K=await this._provider.resolveInlayHint(q,V);if(!!K&&!!this._isValidInlayHint(K))return this._convertInlayHint(K,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,V){return O.label.length===0||Array.isArray(O.label)&&O.label.every(q=>q.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(V&&!V.contains(O.position))}_convertInlayHint(O,V){const q=this._disposables.get(V[0]);if(!q)throw Error("DisposableStore is missing...");const K={label:"",cacheId:V,tooltip:D.MarkdownString.fromStrict(O.tooltip),position:D.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(D.TextEdit.from),kind:O.kind&&D.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?K.label=O.label:K.label=O.label.map(me=>{const we={label:me.value};return we.tooltip=D.MarkdownString.fromStrict(me.tooltip),P.Location.isLocation(me.location)&&(we.location=D.location.from(me.location)),me.command&&(we.command=this._commands.toInternal(me.command,q)),we}),K}}class ke{constructor(O,V){this._documents=O,this._provider=V,this._cache=new f.Cache("DocumentLink")}async provideLinks(O,V){const q=this._documents.getDocument(O),K=await this._provider.provideDocumentLinks(q,V);if(!(!Array.isArray(K)||K.length===0)&&!V.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:K.filter(ke._validateLink).map(D.DocumentLink.from)};{const me=this._cache.add(K),we={links:[],cacheId:me};for(let ce=0;ce<K.length;ce++){if(!ke._validateLink(K[ce]))continue;const Ce=D.DocumentLink.from(K[ce]);Ce.cacheId=[me,ce],we.links.push(Ce)}return we}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,V){if(typeof this._provider.resolveDocumentLink!="function")return;const q=this._cache.get(...O);if(!q)return;const K=await this._provider.resolveDocumentLink(q,V);if(!(!K||!ke._validateLink(K)))return D.DocumentLink.from(K)}releaseLinks(O){this._cache.delete(O)}}class Re{constructor(O,V){this._documents=O,this._provider=V}async provideColors(O,V){const q=this._documents.getDocument(O),K=await this._provider.provideDocumentColors(q,V);return Array.isArray(K)?K.map(we=>({color:D.Color.from(we.color),range:D.Range.from(we.range)})):[]}async provideColorPresentations(O,V,q){const K=this._documents.getDocument(O),me=D.Range.to(V.range),we=D.Color.to(V.color),ce=await this._provider.provideColorPresentations(we,{document:K,range:me},q);if(!!Array.isArray(ce))return ce.map(D.ColorPresentation.from)}}class We{constructor(O,V){this._documents=O,this._provider=V}async provideFoldingRanges(O,V,q){const K=this._documents.getDocument(O),me=await this._provider.provideFoldingRanges(K,V,q);if(!!Array.isArray(me))return me.map(D.FoldingRange.from)}}class oe{constructor(O,V,q){this._documents=O,this._provider=V,this._logService=q}async provideSelectionRanges(O,V,q){const K=this._documents.getDocument(O),me=V.map(D.Position.to),we=await this._provider.provideSelectionRanges(K,me,q);if(!(0,L.isNonEmptyArray)(we))return[];if(we.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Ce=0;Ce<me.length;Ce++){const ye=[];ce.push(ye);let He=me[Ce],je=we[Ce];for(;;){if(!je.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(ye.push(D.SelectionRange.from(je)),!je.parent)break;He=je.range,je=je.parent}}return ce}}class le{constructor(O,V){this._documents=O,this._provider=V,this._idPool=new b.IdGenerator(""),this._cache=new Map}async prepareSession(O,V,q){const K=this._documents.getDocument(O),me=D.Position.to(V),we=await this._provider.prepareCallHierarchy(K,me,q);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ce=>this._cacheAndConvertItem(ce,Ce)):[this._cacheAndConvertItem(ce,we)]}async provideCallsTo(O,V,q){const K=this._itemFromCache(O,V);if(!K)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(K,q);if(!!me)return me.map(we=>({from:this._cacheAndConvertItem(O,we.from),fromRanges:we.fromRanges.map(ce=>D.Range.from(ce))}))}async provideCallsFrom(O,V,q){const K=this._itemFromCache(O,V);if(!K)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(K,q);if(!!me)return me.map(we=>({to:this._cacheAndConvertItem(O,we.to),fromRanges:we.fromRanges.map(ce=>D.Range.from(ce))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,V){const q=this._cache.get(O),K=D.CallHierarchyItem.from(V,O,q.size.toString(36));return q.set(K._itemId,V),K}_itemFromCache(O,V){return this._cache.get(O)?.get(V)}}class fe{constructor(O,V){this._documents=O,this._provider=V,this._idPool=new b.IdGenerator(""),this._cache=new Map}async prepareSession(O,V,q){const K=this._documents.getDocument(O),me=D.Position.to(V),we=await this._provider.prepareTypeHierarchy(K,me,q);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ce=>this._cacheAndConvertItem(ce,Ce)):[this._cacheAndConvertItem(ce,we)]}async provideSupertypes(O,V,q){const K=this._itemFromCache(O,V);if(!K)throw new Error("missing type hierarchy item");const me=await this._provider.provideTypeHierarchySupertypes(K,q);if(!!me)return me.map(we=>this._cacheAndConvertItem(O,we))}async provideSubtypes(O,V,q){const K=this._itemFromCache(O,V);if(!K)throw new Error("missing type hierarchy item");const me=await this._provider.provideTypeHierarchySubtypes(K,q);if(!!me)return me.map(we=>this._cacheAndConvertItem(O,we))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,V){const q=this._cache.get(O),K=D.TypeHierarchyItem.from(V,O,q.size.toString(36));return q.set(K._itemId,V),K}_itemFromCache(O,V){return this._cache.get(O)?.get(V)}}class Z{constructor(O,V,q,K){this._proxy=O,this._documents=V,this._provider=q,this._handle=K}async provideDocumentOnDropEdits(O,V,q,K,me){const we=this._documents.getDocument(V),ce=D.Position.to(q),Ce=D.DataTransfer.toDataTransfer(K,async He=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,He)).buffer),ye=await this._provider.provideDocumentDropEdits(we,ce,Ce,me);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?D.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class ae{constructor(O,V){this.adapter=O,this.extension=V}}class ne{constructor(O,V,q,K,me,we,ce){this._adapter=new Map,this._uriTransformer=V,this._proxy=O.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=q,this._commands=K,this._diagnostics=me,this._logService=we,this._apiDeprecation=ce}_transformDocumentSelector(O){return D.DocumentSelector.from(O,this._uriTransformer)}_createDisposable(O){return new P.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return ne._handlePool++}async _withAdapter(O,V,q,K,me,we=!1){const ce=this._adapter.get(O);if(!ce||!(ce.adapter instanceof V))return K;const Ce=Date.now();we||this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${q.toString().replace(/[\r\n]/g,"")}'`);const ye=q(ce.adapter,ce.extension);return Promise.resolve(ye).catch(He=>{(0,g.isCancellationError)(He)||(this._logService.error(`[${ce.extension.identifier.value}] provider FAILED`),this._logService.error(He))}).finally(()=>{we||this._logService.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Ce}ms`)}),T.CancellationToken.isCancellationToken(me)?(0,c.raceCancellationError)(ye,me):ye}_addNewAdapter(O,V){const q=this._nextHandle();return this._adapter.set(q,new ae(O,V)),q}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,V,q,K){const me=this._addNewAdapter(new n(this._documents,q),O),we=K&&K.label||ne._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(V),we),this._createDisposable(me)}$provideDocumentSymbols(O,V,q){return this._withAdapter(O,n,K=>K.provideDocumentSymbols(l.URI.revive(V),q),void 0,q)}registerCodeLensProvider(O,V,q){const K=this._nextHandle(),me=typeof q.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(K,new ae(new d(this._documents,this._commands.converter,q),O)),this._proxy.$registerCodeLensSupport(K,this._transformDocumentSelector(V),me);let we=this._createDisposable(K);if(me!==void 0){const ce=q.onDidChangeCodeLenses(Ce=>this._proxy.$emitCodeLensEvent(me));we=P.Disposable.from(we,ce)}return we}$provideCodeLenses(O,V,q){return this._withAdapter(O,d,K=>K.provideCodeLenses(l.URI.revive(V),q),void 0,q)}$resolveCodeLens(O,V,q){return this._withAdapter(O,d,K=>K.resolveCodeLens(V,q),void 0,void 0)}$releaseCodeLenses(O,V){this._withAdapter(O,d,q=>Promise.resolve(q.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(O,V,q){const K=this._addNewAdapter(new i(this._documents,q),O);return this._proxy.$registerDefinitionSupport(K,this._transformDocumentSelector(V)),this._createDisposable(K)}$provideDefinition(O,V,q,K){return this._withAdapter(O,i,me=>me.provideDefinition(l.URI.revive(V),q,K),[],K)}registerDeclarationProvider(O,V,q){const K=this._addNewAdapter(new r(this._documents,q),O);return this._proxy.$registerDeclarationSupport(K,this._transformDocumentSelector(V)),this._createDisposable(K)}$provideDeclaration(O,V,q,K){return this._withAdapter(O,r,me=>me.provideDeclaration(l.URI.revive(V),q,K),[],K)}registerImplementationProvider(O,V,q){const K=this._addNewAdapter(new a(this._documents,q),O);return this._proxy.$registerImplementationSupport(K,this._transformDocumentSelector(V)),this._createDisposable(K)}$provideImplementation(O,V,q,K){return this._withAdapter(O,a,me=>me.provideImplementation(l.URI.revive(V),q,K),[],K)}registerTypeDefinitionProvider(O,V,q){const K=this._addNewAdapter(new o(this._documents,q),O);return this._proxy.$registerTypeDefinitionSupport(K,this._transformDocumentSelector(V)),this._createDisposable(K)}$provideTypeDefinition(O,V,q,K){return this._withAdapter(O,o,me=>me.provideTypeDefinition(l.URI.revive(V),q,K),[],K)}registerHoverProvider(O,V,q,K){const me=this._addNewAdapter(new u(this._documents,q),O);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(V)),this._createDisposable(me)}$provideHover(O,V,q,K){return this._withAdapter(O,u,me=>me.provideHover(l.URI.revive(V),q,K),void 0,K)}registerEvaluatableExpressionProvider(O,V,q,K){const me=this._addNewAdapter(new h(this._documents,q),O);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(V)),this._createDisposable(me)}$provideEvaluatableExpression(O,V,q,K){return this._withAdapter(O,h,me=>me.provideEvaluatableExpression(l.URI.revive(V),q,K),void 0,K)}registerInlineValuesProvider(O,V,q,K){const me=typeof q.onDidChangeInlineValues=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new C(this._documents,q),O);this._proxy.$registerInlineValuesProvider(we,this._transformDocumentSelector(V),me);let ce=this._createDisposable(we);if(me!==void 0){const Ce=q.onDidChangeInlineValues(ye=>this._proxy.$emitInlineValuesEvent(me));ce=P.Disposable.from(ce,Ce)}return ce}$provideInlineValues(O,V,q,K,me){return this._withAdapter(O,C,we=>we.provideInlineValues(l.URI.revive(V),q,K,me),void 0,me)}registerDocumentHighlightProvider(O,V,q){const K=this._addNewAdapter(new R(this._documents,q),O);return this._proxy.$registerDocumentHighlightProvider(K,this._transformDocumentSelector(V)),this._createDisposable(K)}$provideDocumentHighlights(O,V,q,K){return this._withAdapter(O,R,me=>me.provideDocumentHighlights(l.URI.revive(V),q,K),void 0,K)}registerLinkedEditingRangeProvider(O,V,q){const K=this._addNewAdapter(new N(this._documents,q),O);return this._proxy.$registerLinkedEditingRangeProvider(K,this._transformDocumentSelector(V)),this._createDisposable(K)}$provideLinkedEditingRanges(O,V,q,K){return this._withAdapter(O,N,async me=>{const we=await me.provideLinkedEditingRanges(l.URI.revive(V),q,K);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ne._serializeRegExp(we.wordPattern):void 0}},void 0,K)}registerReferenceProvider(O,V,q){const K=this._addNewAdapter(new M(this._documents,q),O);return this._proxy.$registerReferenceSupport(K,this._transformDocumentSelector(V)),this._createDisposable(K)}$provideReferences(O,V,q,K,me){return this._withAdapter(O,M,we=>we.provideReferences(l.URI.revive(V),q,K,me),void 0,me)}registerCodeActionProvider(O,V,q,K){const me=new E.DisposableStore,we=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,q,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(V),{providedKinds:K?.providedCodeActionKinds?.map(ce=>ce.value),documentation:K?.documentation?.map(ce=>({kind:ce.kind.value,command:this._commands.converter.toInternal(ce.command,me)}))},ne._extLabel(O),Boolean(q.resolveCodeAction)),me.add(this._createDisposable(we)),me}$provideCodeActions(O,V,q,K,me){return this._withAdapter(O,A,we=>we.provideCodeActions(l.URI.revive(V),q,K,me),void 0,me)}$resolveCodeAction(O,V,q){return this._withAdapter(O,A,K=>K.resolveCodeAction(V,q),void 0,void 0)}$releaseCodeActions(O,V){this._withAdapter(O,A,q=>Promise.resolve(q.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(O,V,q){const K=this._addNewAdapter(new H(this._documents,q),O);return this._proxy.$registerDocumentFormattingSupport(K,this._transformDocumentSelector(V),O.identifier,O.displayName||O.name),this._createDisposable(K)}$provideDocumentFormattingEdits(O,V,q,K){return this._withAdapter(O,H,me=>me.provideDocumentFormattingEdits(l.URI.revive(V),q,K),void 0,K)}registerDocumentRangeFormattingEditProvider(O,V,q){const K=this._addNewAdapter(new F(this._documents,q),O);return this._proxy.$registerRangeFormattingSupport(K,this._transformDocumentSelector(V),O.identifier,O.displayName||O.name),this._createDisposable(K)}$provideDocumentRangeFormattingEdits(O,V,q,K,me){return this._withAdapter(O,F,we=>we.provideDocumentRangeFormattingEdits(l.URI.revive(V),q,K,me),void 0,me)}registerOnTypeFormattingEditProvider(O,V,q,K){const me=this._addNewAdapter(new G(this._documents,q),O);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(V),K,O.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(O,V,q,K,me,we){return this._withAdapter(O,G,ce=>ce.provideOnTypeFormattingEdits(l.URI.revive(V),q,K,me,we),void 0,we)}registerWorkspaceSymbolProvider(O,V){const q=this._addNewAdapter(new B(V,this._logService),O);return this._proxy.$registerNavigateTypeSupport(q,typeof V.resolveWorkspaceSymbol=="function"),this._createDisposable(q)}$provideWorkspaceSymbols(O,V,q){return this._withAdapter(O,B,K=>K.provideWorkspaceSymbols(V,q),{symbols:[]},q)}$resolveWorkspaceSymbol(O,V,q){return this._withAdapter(O,B,K=>K.resolveWorkspaceSymbol(V,q),void 0,void 0)}$releaseWorkspaceSymbols(O,V){this._withAdapter(O,B,q=>q.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(O,V,q){const K=this._addNewAdapter(new U(this._documents,q,this._logService),O);return this._proxy.$registerRenameSupport(K,this._transformDocumentSelector(V),U.supportsResolving(q)),this._createDisposable(K)}$provideRenameEdits(O,V,q,K,me){return this._withAdapter(O,U,we=>we.provideRenameEdits(l.URI.revive(V),q,K,me),void 0,me)}$resolveRenameLocation(O,V,q,K){return this._withAdapter(O,U,me=>me.resolveRenameLocation(l.URI.revive(V),q,K),void 0,K)}registerDocumentSemanticTokensProvider(O,V,q,K){const me=this._addNewAdapter(new $(this._documents,q),O),we=typeof q.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(V),K,we);let ce=this._createDisposable(me);if(we){const Ce=q.onDidChangeSemanticTokens(ye=>this._proxy.$emitDocumentSemanticTokensEvent(we));ce=P.Disposable.from(ce,Ce)}return ce}$provideDocumentSemanticTokens(O,V,q,K){return this._withAdapter(O,$,me=>me.provideDocumentSemanticTokens(l.URI.revive(V),q,K),null,K)}$releaseDocumentSemanticTokens(O,V){this._withAdapter(O,$,q=>q.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,V,q,K){const me=this._addNewAdapter(new x(this._documents,q),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(V),K),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(O,V,q,K){return this._withAdapter(O,x,me=>me.provideDocumentRangeSemanticTokens(l.URI.revive(V),q,K),null,K)}registerCompletionItemProvider(O,V,q,K){const me=this._addNewAdapter(new Q(this._documents,this._commands.converter,q,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(me,this._transformDocumentSelector(V),K,Q.supportsResolving(q),`${O.identifier.value}(${K.join("")})`),this._createDisposable(me)}$provideCompletionItems(O,V,q,K,me){return this._withAdapter(O,Q,we=>we.provideCompletionItems(l.URI.revive(V),q,K,me),void 0,me)}$resolveCompletionItem(O,V,q){return this._withAdapter(O,Q,K=>K.resolveCompletionItem(V,q),void 0,q)}$releaseCompletionItems(O,V){this._withAdapter(O,Q,q=>q.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(O,V,q){const K=new te(O,this._documents,q,this._commands.converter),me=this._addNewAdapter(K,O);return this._proxy.$registerInlineCompletionsSupport(me,this._transformDocumentSelector(V),K.supportsHandleDidShowCompletionItem),this._createDisposable(me)}registerInlineCompletionsProviderNew(O,V,q){const K=this._addNewAdapter(new pe(O,this._documents,q,this._commands.converter),O);return this._proxy.$registerInlineCompletionsSupport(K,this._transformDocumentSelector(V),!0),this._createDisposable(K)}$provideInlineCompletions(O,V,q,K,me){return this._withAdapter(O,de,we=>we.provideInlineCompletions(l.URI.revive(V),q,K,me),void 0,me)}$handleInlineCompletionDidShow(O,V,q){this._withAdapter(O,de,async K=>{K.handleDidShowCompletionItem(V,q)},void 0,void 0)}$freeInlineCompletionsList(O,V){this._withAdapter(O,de,async q=>{q.disposeCompletions(V)},void 0,void 0)}registerSignatureHelpProvider(O,V,q,K){const me=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,we=this._addNewAdapter(new ve(this._documents,q),O);return this._proxy.$registerSignatureHelpProvider(we,this._transformDocumentSelector(V),me),this._createDisposable(we)}$provideSignatureHelp(O,V,q,K,me){return this._withAdapter(O,ve,we=>we.provideSignatureHelp(l.URI.revive(V),q,K,me),void 0,me)}$releaseSignatureHelp(O,V){this._withAdapter(O,ve,q=>q.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(O,V,q){const K=typeof q.onDidChangeInlayHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new be(this._documents,this._commands.converter,q,this._logService,O),O);this._proxy.$registerInlayHintsProvider(me,this._transformDocumentSelector(V),typeof q.resolveInlayHint=="function",K,ne._extLabel(O));let we=this._createDisposable(me);if(K!==void 0){const ce=q.onDidChangeInlayHints(Ce=>this._proxy.$emitInlayHintsEvent(K));we=P.Disposable.from(we,ce)}return we}$provideInlayHints(O,V,q,K){return this._withAdapter(O,be,me=>me.provideInlayHints(l.URI.revive(V),q,K),void 0,K)}$resolveInlayHint(O,V,q){return this._withAdapter(O,be,K=>K.resolveInlayHint(V,q),void 0,q)}$releaseInlayHints(O,V){this._withAdapter(O,be,q=>q.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(O,V,q){const K=this._addNewAdapter(new ke(this._documents,q),O);return this._proxy.$registerDocumentLinkProvider(K,this._transformDocumentSelector(V),typeof q.resolveDocumentLink=="function"),this._createDisposable(K)}$provideDocumentLinks(O,V,q){return this._withAdapter(O,ke,K=>K.provideLinks(l.URI.revive(V),q),void 0,q,V.scheme==="output")}$resolveDocumentLink(O,V,q){return this._withAdapter(O,ke,K=>K.resolveLink(V,q),void 0,void 0,!0)}$releaseDocumentLinks(O,V){this._withAdapter(O,ke,q=>q.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(O,V,q){const K=this._addNewAdapter(new Re(this._documents,q),O);return this._proxy.$registerDocumentColorProvider(K,this._transformDocumentSelector(V)),this._createDisposable(K)}$provideDocumentColors(O,V,q){return this._withAdapter(O,Re,K=>K.provideColors(l.URI.revive(V),q),[],q)}$provideColorPresentations(O,V,q,K){return this._withAdapter(O,Re,me=>me.provideColorPresentations(l.URI.revive(V),q,K),void 0,K)}registerFoldingRangeProvider(O,V,q){const K=this._nextHandle(),me=typeof q.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(K,new ae(new We(this._documents,q),O)),this._proxy.$registerFoldingRangeProvider(K,this._transformDocumentSelector(V),me);let we=this._createDisposable(K);if(me!==void 0){const ce=q.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));we=P.Disposable.from(we,ce)}return we}$provideFoldingRanges(O,V,q,K){return this._withAdapter(O,We,me=>me.provideFoldingRanges(l.URI.revive(V),q,K),void 0,K)}registerSelectionRangeProvider(O,V,q){const K=this._addNewAdapter(new oe(this._documents,q,this._logService),O);return this._proxy.$registerSelectionRangeProvider(K,this._transformDocumentSelector(V)),this._createDisposable(K)}$provideSelectionRanges(O,V,q,K){return this._withAdapter(O,oe,me=>me.provideSelectionRanges(l.URI.revive(V),q,K),[],K)}registerCallHierarchyProvider(O,V,q){const K=this._addNewAdapter(new le(this._documents,q),O);return this._proxy.$registerCallHierarchyProvider(K,this._transformDocumentSelector(V)),this._createDisposable(K)}$prepareCallHierarchy(O,V,q,K){return this._withAdapter(O,le,me=>Promise.resolve(me.prepareSession(l.URI.revive(V),q,K)),void 0,K)}$provideCallHierarchyIncomingCalls(O,V,q,K){return this._withAdapter(O,le,me=>me.provideCallsTo(V,q,K),void 0,K)}$provideCallHierarchyOutgoingCalls(O,V,q,K){return this._withAdapter(O,le,me=>me.provideCallsFrom(V,q,K),void 0,K)}$releaseCallHierarchy(O,V){this._withAdapter(O,le,q=>Promise.resolve(q.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(O,V,q){const K=this._addNewAdapter(new fe(this._documents,q),O);return this._proxy.$registerTypeHierarchyProvider(K,this._transformDocumentSelector(V)),this._createDisposable(K)}$prepareTypeHierarchy(O,V,q,K){return this._withAdapter(O,fe,me=>Promise.resolve(me.prepareSession(l.URI.revive(V),q,K)),void 0,K)}$provideTypeHierarchySupertypes(O,V,q,K){return this._withAdapter(O,fe,me=>me.provideSupertypes(V,q,K),void 0,K)}$provideTypeHierarchySubtypes(O,V,q,K){return this._withAdapter(O,fe,me=>me.provideSubtypes(V,q,K),void 0,K)}$releaseTypeHierarchy(O,V){this._withAdapter(O,fe,q=>Promise.resolve(q.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(O,V,q){const K=this._nextHandle();return this._adapter.set(K,new ae(new Z(this._proxy,this._documents,q,K),O)),this._proxy.$registerDocumentOnDropEditProvider(K,this._transformDocumentSelector(V)),this._createDisposable(K)}$provideDocumentOnDropEdits(O,V,q,K,me,we){return this._withAdapter(O,Z,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(V,l.URI.revive(q),K,me,we)),void 0,void 0)}registerDocumentPasteEditProvider(O,V,q,K){const me=this._nextHandle();return this._adapter.set(me,new ae(new z(this._proxy,this._documents,q,me),O)),this._proxy.$registerPasteEditProvider(me,this._transformDocumentSelector(V),!!q.prepareDocumentPaste,K.pasteMimeTypes),this._createDisposable(me)}$prepareDocumentPaste(O,V,q,K,me){return this._withAdapter(O,z,we=>we.prepareDocumentPaste(l.URI.revive(V),q,K,me),void 0,me)}$providePasteEdits(O,V,q,K,me,we){return this._withAdapter(O,z,ce=>ce.providePasteEdits(V,l.URI.revive(q),K,me,we),void 0,we)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,w.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:ne._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:ne._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?ne._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?ne._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:ne._serializeRegExp(O.beforeText),afterText:O.afterText?ne._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?ne._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(ne._serializeOnEnterRule)}setLanguageConfiguration(O,V,q){const{wordPattern:K}=q;if(K&&(0,w.regExpLeadsToEndlessLoop)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this._documents.setWordDefinitionFor(V,K):this._documents.setWordDefinitionFor(V,void 0),q.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),q.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const me=this._nextHandle(),we={comments:q.comments,brackets:q.brackets,wordPattern:q.wordPattern?ne._serializeRegExp(q.wordPattern):void 0,indentationRules:q.indentationRules?ne._serializeIndentationRule(q.indentationRules):void 0,onEnterRules:q.onEnterRules?ne._serializeOnEnterRules(q.onEnterRules):void 0,__electricCharacterSupport:q.__electricCharacterSupport,__characterPairSupport:q.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,V,we),this._createDisposable(me)}$setWordDefinitions(O){for(const V of O)this._documents.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.ExtHostLanguageFeatures=ne,ne._handlePool=0}),define(De[250],Ie([1,0,5,15,7,41,18,6]),function(J,e,l,t,D,P,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class w{constructor(L,y,S,T){this._documents=y,this._commands=S,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(l.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,y){await this._proxy.$changeLanguage(L,y);const S=this._documents.getDocumentData(L);if(!S)throw new Error(`document '${L.toString()}' NOT found`);return S.document}async tokenAtPosition(L,y){const S=L.version,T=t.Position.from(y),E=await this._proxy.$tokensAtPosition(L.uri,T),p={type:D.StandardTokenType.Other,range:L.getWordRangeAtPosition(y)??new D.Range(y.line,y.character,y.line,y.character)};if(!E)return p;const b={range:t.Range.to(E.range),type:t.TokenType.to(E.type)};return!b.range.contains(y)||S!==L.version?p:b}createLanguageStatusItem(L,y,S){const T=this._handlePool++,E=this._proxy,p=this._ids,b=`${L.identifier.value}/${y}`;if(p.has(b))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);p.add(b);const f={selector:S,id:y,name:L.displayName??L.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const g=new k.DisposableStore,c=()=>{v?.dispose(),v=(0,_.disposableTimeout)(()=>{g.clear(),this._proxy.$setLanguageStatus(T,{id:b,name:f.name??L.displayName??L.name,source:L.displayName??L.name,selector:t.DocumentSelector.from(f.selector,this._uriTransformer),label:f.text,detail:f.detail??"",severity:f.severity===D.LanguageStatusSeverity.Error?P.default.Error:f.severity===D.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:f.command&&this._commands.toInternal(f.command,g),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},m={dispose(){g.dispose(),v?.dispose(),E.$removeLanguageStatus(T),p.delete(b)},get id(){return f.id},get name(){return f.name},set name(n){f.name=n,c()},get selector(){return f.selector},set selector(n){f.selector=n,c()},get text(){return f.text},set text(n){f.text=n,c()},get detail(){return f.detail},set detail(n){f.detail=n,c()},get severity(){return f.severity},set severity(n){f.severity=n,c()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(n){f.accessibilityInformation=n,c()},get command(){return f.command},set command(n){f.command=n,c()},get busy(){return f.busy},set busy(n){f.busy=n,c()}};return c(),m}}e.ExtHostLanguages=w}),define(De[91],Ie([1,0,11,8,2,3,13,5,14]),function(J,e,l,t,D,P,_,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let I=class{constructor(y,S){this.logService=S,this.bundleCache=new Map,this._proxy=y.getProxy(k.MainContext.MainThreadLocalization)}getMessage(y,S){const{message:T,args:E,comment:p}=S;if(l.Language.isDefault())return(0,t.format)(T,E);let b=T;p&&p.length>0&&(b+=`/${p.join()}`);const f=this.bundleCache.get(y)?.contents[b];return f||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${b}`),(0,t.format)(f??b,E)}getBundle(y){return this.bundleCache.get(y)?.contents??{}}getBundleUri(y){return this.bundleCache.get(y)?.uri}async initializeLocalizedMessages(y){if(l.Language.isDefault()||!y.l10nBundleLocation||this.bundleCache.has(y.identifier.value))return;let S;const T=this.getBundleLocation(y);if(!T){this.logService.error(`No bundle location found for extension ${y.identifier.value}`);return}const E=D.URI.joinPath(T,`bundle.l10n.${l.Language.value()}.json`);try{const p=await this._proxy.$fetchBundleContents(E);S=JSON.parse(p)}catch(p){this.logService.error(`Failed to load translations for ${y.identifier.value} from ${E}: ${p.message}`);return}S&&this.bundleCache.set(y.identifier.value,{contents:S,uri:E})}getBundleLocation(y){if(y.l10nBundleLocation)return D.URI.joinPath(y.extensionLocation,y.l10nBundleLocation)}};I=qe([xe(0,w.IExtHostRpcService),xe(1,_.ILogService)],I),e.ExtHostLocalizationService=I,e.IExtHostLocalizationService=(0,P.createDecorator)("IExtHostLocalizationService")}),define(De[137],Ie([1,0,13,5,26,14,4]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends l.AbstractLoggerService{constructor(L,y){const S=new _.Emitter;super(y.logLevel,S.event),this._proxy=L.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(S)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,y,S){return new w(this._proxy,L,y,S)}};k=qe([xe(0,P.IExtHostRpcService),xe(1,D.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class w extends l.AbstractMessageLogger{constructor(L,y,S,T){super(T?.always),this.proxy=L,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(S),this.proxy.$createLogger(y,T).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,y){const S=[[L,y]];this.isLoggerCreated?this.doLog(S):this.buffer.push(...S)}doLog(L){this.proxy.$log(this.file,L)}}}),define(De[251],Ie([1,0,5,13,27]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(k){return k&&k.title}let _=class{constructor(w,I){this._logService=I,this._proxy=w.getProxy(l.MainContext.MainThreadMessageService)}showMessage(w,I,L,y,S){const T={source:{identifier:w.identifier,label:w.displayName||w.name}};let E;typeof y=="string"||P(y)?E=[y,...S]:(T.modal=y?.modal,T.useCustom=y?.useCustom,T.detail=y?.detail,E=S),T.useCustom&&(0,D.checkProposedApiEnabled)(w,"resolvers");const p=[];for(let b=0;b<E.length;b++){const f=E[b];if(typeof f=="string")p.push({title:f,handle:b,isCloseAffordance:!1});else if(typeof f=="object"){const{title:v,isCloseAffordance:g}=f;p.push({title:v,isCloseAffordance:!!g,handle:b})}else this._logService.warn("Invalid message item:",f)}return this._proxy.$showMessage(I,L,T,p).then(b=>{if(typeof b=="number")return E[b]})}};_=qe([xe(1,t.ILogService)],_),e.ExtHostMessageService=_}),define(De[252],Ie([1,0,23,4,6,25,8,16,2,87,5,37,15,7,55,227,133]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{constructor(g,c,m,n){this._textDocumentsAndEditors=m,this._textDocuments=n,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=g.getProxy(L.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=g.getProxy(L.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=g.getProxy(L.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===12){const s=d.notebookEditor?.notebookUri,i=d.cell.handle,a=this._documents.get(s)?.getCell(i);if(a)return a.apiCell}return d}}),f._registerApiCommands(c)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(g=>g.apiEditor)}getEditorById(g){const c=this._editors.get(g);if(!c)throw new Error(`unknown text editor: ${g}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(g){for(const[c,m]of this._editors)if(m.apiEditor===g)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(g,c){const m=this._documents.get(g);if(!m&&!c)throw new Error(`NO notebook document for '${g}'`);return m}_getProviderData(g){const c=this._notebookContentProviders.get(g);if(!c)throw new Error(`NO provider for '${g}'`);return c}registerNotebookContentProvider(g,c,m,n,d){if((0,_.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);return this._notebookContentProviders.set(c,{extension:g,provider:m}),this._notebookProxy.$registerNotebookProvider({id:g.identifier,location:g.extensionLocation},c,S.NotebookDocumentContentOptions.from(n),f._convertNotebookRegistrationData(g,d)),new T.Disposable(()=>{this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(g,c){if(!c)return;const m=c.filenamePattern.map(n=>S.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(c.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:g.identifier,providerDisplayName:g.displayName||g.name,displayName:c.displayName,filenamePattern:m,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(g,c,m){const n=f._notebookStatusBarItemProviderHandlePool++,d=typeof m.onDidChangeCellStatusBarItems=="function"?f._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(n,m),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(n,d,c);let s;return d!==void 0&&(s=m.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(d))),new T.Disposable(()=>{this._notebookStatusBarItemProviders.delete(n),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(n,d),s?.dispose()})}async createNotebookDocument(g){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:g.viewType,content:g.content&&S.NotebookData.from(g.content)});return w.URI.revive(c)}async openNotebookDocument(g){const c=this._documents.get(g);if(c)return c.apiNotebook;const m=await this._notebookDocumentsProxy.$tryOpenNotebook(g),n=this._documents.get(w.URI.revive(m));return(0,k.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(g,c){w.URI.isUri(g)&&(g=await this.openNotebookDocument(g));let m;typeof c=="object"?m={position:S.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(S.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:m={preserveFocus:!1};const n=await this._notebookEditorsProxy.$tryShowNotebookDocument(g.uri,g.notebookType,m),d=n&&this._editors.get(n)?.apiEditor;if(d)return d;throw n?new Error(`Could NOT open editor for "${g.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${g.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(g,c,m,n){const d=this._notebookStatusBarItemProviders.get(g),s=w.URI.revive(c),i=this._documents.get(s);if(!i||!d)return;const r=i.getCellFromIndex(m);if(!r)return;const a=await d.provideCellStatusBarItems(r.apiCell,n);if(!a)return;const o=new D.DisposableStore,u=this._statusBarCache.add([o]),C=(Array.isArray(a)?a:[a]).map(R=>S.NotebookStatusBarItem.from(R,this._commandsConverter,o));return{cacheId:u,items:C}}$releaseNotebookCellStatusBarItems(g){this._statusBarCache.delete(g)}registerNotebookSerializer(g,c,m,n,d){if((0,_.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,m),this._notebookProxy.$registerNotebookSerializer(s,{id:g.identifier,location:g.extensionLocation},c,S.NotebookDocumentContentOptions.from(n),f._convertNotebookRegistrationData(g,d)),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(g,c,m){const n=this._notebookSerializer.get(g);if(!n)throw new Error("NO serializer found");const d=await n.deserializeNotebook(c.buffer,m);return new E.SerializableObjectWithBuffers(S.NotebookData.from(d))}async $notebookToData(g,c,m){const n=this._notebookSerializer.get(g);if(!n)throw new Error("NO serializer found");const d=await n.serializeNotebook(S.NotebookData.to(c.value),m);return l.VSBuffer.wrap(d)}async $openNotebook(g,c,m,n,d){const{provider:s}=this._getProviderData(g),i=await s.openNotebook(w.URI.revive(c),{backupId:m,untitledDocumentData:n?.buffer},d);return new E.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(S.NotebookCellData.from)})}_createExtHostEditor(g,c,m){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const n=new b.ExtHostNotebookEditor(c,this._notebookEditorsProxy,g,m.visibleRanges.map(S.NotebookRange.to),m.selections.map(S.NotebookRange.to),typeof m.viewColumn=="number"?S.ViewColumn.to(m.viewColumn):void 0);this._editors.set(c,n)}$acceptDocumentAndEditorsDelta(g){if(g.value.removedDocuments)for(const m of g.value.removedDocuments){const n=w.URI.revive(m),d=this._documents.get(n);d&&(d.dispose(),this._documents.delete(n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(d.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===n.toString()&&this._editors.delete(s.id)}if(g.value.addedDocuments){const m=[];for(const n of g.value.addedDocuments){const d=w.URI.revive(n.uri);if(this._documents.has(d))throw new Error(`adding EXISTING notebook ${d} `);const s=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,d,n);m.push(...n.cells.map(i=>p.ExtHostCell.asModelAddData(s.apiNotebook,i))),this._documents.get(d)?.dispose(),this._documents.set(d,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(g.value.addedEditors)for(const m of g.value.addedEditors){if(this._editors.has(m.id))return;const n=w.URI.revive(m.documentUri),d=this._documents.get(n);d&&this._createExtHostEditor(d,m.id,m)}const c=[];if(g.value.removedEditors)for(const m of g.value.removedEditors){const n=this._editors.get(m);n&&(this._editors.delete(m),this._activeNotebookEditor?.id===n.id&&(this._activeNotebookEditor=void 0),c.push(n))}if(g.value.visibleEditors){this._visibleNotebookEditors=g.value.visibleEditors.map(n=>this._editors.get(n)).filter(n=>!!n);const m=new Set;this._visibleNotebookEditors.forEach(n=>m.add(n.id));for(const n of this._editors.values()){const d=m.has(n.id);n._acceptVisibility(d)}this._visibleNotebookEditors=[...this._editors.values()].map(n=>n).filter(n=>n.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}g.value.newActiveEditor===null?this._activeNotebookEditor=void 0:g.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(g.value.newActiveEditor)),g.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(g){const c=y.ApiCommandArgument.String.with("notebookType","A notebook type"),m=new y.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[c,new y.ApiCommandArgument("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>l.VSBuffer.wrap(d))],new y.ApiCommandResult("Notebook Data",d=>S.NotebookData.to(d.value))),n=new y.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[c,new y.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new E.SerializableObjectWithBuffers(S.NotebookData.from(d)))],new y.ApiCommandResult("Bytes",d=>d.buffer));g.registerApiCommand(m),g.registerApiCommand(n)}}e.ExtHostNotebookController=f,f._notebookStatusBarItemProviderHandlePool=0}),define(De[253],Ie([1,0,17,18,21,4,6,25,2,28,13,5,37,15,7,88,215,27,55]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let g=class{constructor(i,r,a,o,u){this._initData=r,this._extHostNotebook=a,this._commands=o,this._logService=u,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(y.MainContext.MainThreadNotebookKernels);const h=new S.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new S.ApiCommandArgument("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const R=this._extHostNotebook.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:R}}else if(C&&"notebookEditor"in C){const R=this._extHostNotebook.getIdByEditor(C.notebookEditor);if(R===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.document.uri.toString()}`);return{notebookEditorId:R}}return C})],S.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(i,r,a,o,u,h){for(const Q of this._kernelData.values())if(Q.controller.id===r&&I.ExtensionIdentifier.equals(i.identifier,Q.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const C=this._handlePool++,R=this;this._logService.trace(`NotebookController[${C}], CREATED by ${i.identifier.value}, ${r}`);const N=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${i.identifier}'`);let M=!1;const A=new _.DisposableStore,z=new P.Emitter,H=new P.Emitter,F={id:d(i.identifier,r),notebookType:a,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:o||i.identifier.value,preloads:h?h.map(T.NotebookRendererScript.from):[]};let G=u??N,B;this._proxy.$addKernel(C,F).catch(Q=>{console.log(Q),M=!0});let U=0;const X=()=>{if(M)return;const Q=++U;Promise.resolve().then(()=>{Q===U&&this._proxy.$updateKernel(C,F)})},$=new k.ResourceMap,x={get id(){return r},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return F.label},set label(Q){F.label=Q??i.displayName??i.name,X()},get detail(){return F.detail??""},set detail(Q){F.detail=Q,X()},get description(){return F.description??""},set description(Q){F.description=Q,X()},get kind(){return(0,f.checkProposedApiEnabled)(i,"notebookControllerKind"),F.kind??""},set kind(Q){(0,f.checkProposedApiEnabled)(i,"notebookControllerKind"),F.kind=Q,X()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(Q){F.supportedLanguages=Q,X()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(Q){F.supportsExecutionOrder=Q,X()},get rendererScripts(){return F.preloads?F.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return G},set executeHandler(Q){G=Q??N},get interruptHandler(){return B},set interruptHandler(Q){B=Q,F.supportsInterrupt=Boolean(Q),X()},createNotebookCellExecution(Q){if(M)throw new Error("notebook controller is DISPOSED");if(!$.has(Q.notebook.uri))throw R._logService.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${Q.notebook.uri.toString()}`);return R._createNotebookCellExecution(Q,d(i.identifier,this.id))},dispose:()=>{M||(this._logService.trace(`NotebookController[${C}], DISPOSED`),M=!0,this._kernelData.delete(C),A.dispose(),z.dispose(),H.dispose(),this._proxy.$removeKernel(C))},updateNotebookAffinity(Q,de){R._proxy.$updateNotebookPriority(C,Q.uri,de)},onDidReceiveMessage:H.event,postMessage(Q,de){return(0,f.checkProposedApiEnabled)(i,"notebookMessaging"),R._proxy.$postMessage(C,de&&R._extHostNotebook.getIdByEditor(de),Q)},asWebviewUri(Q){return(0,f.checkProposedApiEnabled)(i,"notebookMessaging"),(0,p.asWebviewUri)(Q,R._initData.remote)}};return this._kernelData.set(C,{extensionId:i.identifier,controller:x,onDidReceiveMessage:H,onDidChangeSelection:z,associatedNotebooks:$}),x}getIdByController(i){for(const[r,a]of this._kernelData)if(a.controller===i)return d(a.extensionId,i.id);return null}$acceptNotebookAssociation(i,r,a){const o=this._kernelData.get(i);if(o){const u=this._extHostNotebook.getNotebookDocument(w.URI.revive(r));a?o.associatedNotebooks.set(u.uri,!0):o.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,u.uri.toString(),a),o.onDidChangeSelection.fire({selected:a,notebook:u.apiNotebook})}}async $executeCells(i,r,a){const o=this._kernelData.get(i);if(!o)return;const u=this._extHostNotebook.getNotebookDocument(w.URI.revive(r)),h=[];for(const C of a){const R=u.getCell(C);R&&h.push(R.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,u.uri.toString(),h.length),await o.controller.executeHandler.call(o.controller,h,u.apiNotebook,o.controller)}catch(C){this._logService.error(`NotebookController[${i}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(i,r,a){const o=this._kernelData.get(i);if(!o)return;const u=this._extHostNotebook.getNotebookDocument(w.URI.revive(r));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,u.apiNotebook);else for(const h of a){const C=u.getCell(h);C&&this._activeExecutions.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,r,a){const o=this._kernelData.get(i);if(!o)return;const u=this._extHostNotebook.getEditorById(r);o.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:a}))}$cellExecutionChanged(i,r,a){const u=this._extHostNotebook.getNotebookDocument(w.URI.revive(i)).getCell(r);if(u){const h=a?T.NotebookCellExecutionState.to(a):E.NotebookCellExecutionState.Idle;h!==void 0&&this._onDidChangeCellExecutionState.fire({cell:u.apiCell,state:h})}}_createNotebookCellExecution(i,r){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const u=new m(r,o,this._proxy);this._activeExecutions.set(o.uri,u);const h=u.onDidChangeState(()=>{u.state===c.Resolved&&(u.dispose(),h.dispose(),this._activeExecutions.delete(o.uri))});return u.asApiObject()}};g=qe([xe(4,L.ILogService)],g),e.ExtHostNotebookKernels=g;var c;(function(s){s[s.Init=0]="Init",s[s.Started=1]="Started",s[s.Resolved=2]="Resolved"})(c||(c={}));class m extends _.Disposable{constructor(i,r,a){super(),this._cell=r,this._proxy=a,this._handle=m.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new n(10,o=>this.update(o)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const r=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let r=this._cell;if(i&&(r=this._cell.notebook.getCellFromApiCell(i)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(i){return i.map(r=>{const a=E.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return a===r.items?T.NotebookCellOutput.from(r):T.NotebookCellOutput.from({items:a,id:r.id,metadata:r.metadata})})}async updateOutputs(i,r,a){const o=this.cellIndexToHandle(r),u=this.validateAndConvertOutputs((0,l.asArray)(i));return this.updateSoon({editType:b.CellExecutionUpdateType.Output,cellHandle:o,append:a,outputs:u})}async updateOutputItems(i,r,a){return i=E.NotebookCellOutput.ensureUniqueMimeTypes((0,l.asArray)(i),!0),this.updateSoon({editType:b.CellExecutionUpdateType.OutputItems,items:i.map(T.NotebookCellOutputItem.from),outputId:r.id,append:a})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(a){i._executionOrder=a,i.update([{editType:b.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(a){if(i._state===c.Resolved||i._state===c.Started)throw new Error("Cannot call start again");i._state=c.Started,i._onDidChangeState.fire(),i.update({editType:b.CellExecutionUpdateType.ExecutionState,runStartTime:a})},end(a,o){if(i._state===c.Resolved)throw new Error("Cannot call resolve twice");i._state=c.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new v.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:a}))},clearOutput(a){return i.verifyStateForOutput(),i.updateOutputs([],a,!1)},appendOutput(a,o){return i.verifyStateForOutput(),i.updateOutputs(a,o,!0)},replaceOutput(a,o){return i.verifyStateForOutput(),i.updateOutputs(a,o,!1)},appendOutputItems(a,o){return i.verifyStateForOutput(),i.updateOutputItems(a,o,!0)},replaceOutputItems(a,o){return i.verifyStateForOutput(),i.updateOutputItems(a,o,!1)}})}}m.HANDLE=0;class n{constructor(i,r){this.delay=i,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>i.complete())}}function d(s,i){return`${s.value}/${i}`}e.createKernelId=d}),define(De[254],Ie([1,0,4,5,133]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(k,w){this._extHostNotebook=w,this._rendererMessageEmitters=new Map,this.proxy=k.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(k,w,I){const L=this._extHostNotebook.getEditorById(k);this._rendererMessageEmitters.get(w)?.fire({editor:L.apiEditor,message:I})}createRendererMessaging(k,w){if(!k.contributes?.notebookRenderer?.some(L=>L.id===w))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${w})`);return{onDidReceiveMessage:(L,y,S)=>this.getOrCreateEmitterFor(w).event(L,y,S),postMessage:(L,y)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,y]=[y,L]);const S=y&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(y);return this.proxy.$postMessage(S?.id,w,L)}}}getOrCreateEmitterFor(k){let w=this._rendererMessageEmitters.get(k);return w||(w=new l.Emitter({onLastListenerRemove:()=>{w?.dispose(),this._rendererMessageEmitters.delete(k)}}),this._rendererMessageEmitters.set(k,w),w)}}e.ExtHostNotebookRenderers=P}),define(De[255],Ie([1,0,21,4,6,5,2,7,10,17,41,86]),function(J,e,l,t,D,P,_,k,w,I,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function S(T,E,p){const b=T.getProxy(P.MainContext.MainThreadQuickOpen);class f{constructor(r,a){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=a}showQuickPick(r,a,o=l.CancellationToken.None){this._onDidSelectItem=void 0;const u=Promise.resolve(r),h=++this._instances,C=b.$show(h,{title:a?.title,placeHolder:a?.placeHolder,matchOnDescription:a?.matchOnDescription,matchOnDetail:a?.matchOnDetail,ignoreFocusLost:a?.ignoreFocusOut,canPickMany:a?.canPickMany},o),R={},N=C.then(()=>R);return Promise.race([N,u]).then(M=>{if(M!==R)return u.then(A=>{const z=[];for(let H=0;H<A.length;H++){const F=A[H];typeof F=="string"?z.push({label:F,handle:H}):F.kind===k.QuickPickItemKind.Separator?z.push({type:"separator",label:F.label}):z.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:H})}return a&&typeof a.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{a.onDidSelectItem(A[H])}),b.$setItems(h,z),C.then(H=>{if(typeof H=="number")return A[H];if(Array.isArray(H))return H.map(F=>A[F])})})}).then(void 0,M=>{if(!(0,w.isCancellationError)(M))return b.$setError(h,M),Promise.reject(M)})}$onItemSelected(r){this._onDidSelectItem?.(r)}showInput(r,a=l.CancellationToken.None){return this._validateInput=r?.validateInput,b.$input(r,typeof this._validateInput=="function",a).then(void 0,o=>{if(!(0,w.isCancellationError)(o))return Promise.reject(o)})}async $validateInput(r){if(!this._validateInput)return;const a=await this._validateInput(r);if(!a||typeof a=="string")return a;let o;switch(a.severity){case k.InputBoxValidationSeverity.Info:o=L.default.Info;break;case k.InputBoxValidationSeverity.Warning:o=L.default.Warning;break;case k.InputBoxValidationSeverity.Error:o=L.default.Error;break;default:o=a.message?L.default.Error:L.default.Ignore;break}return{content:a.message,severity:o}}async showWorkspaceFolderPick(r,a=l.CancellationToken.None){const o=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!o)return;const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(h=>h.uri.toString()===o.uri.toString())}createQuickPick(r){const a=new d(r,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}createInputBox(r){const a=new s(r,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(r,a){this._sessions.get(r)?._fireDidChangeValue(a)}$onDidAccept(r){this._sessions.get(r)?._fireDidAccept()}$onDidChangeActive(r,a){const o=this._sessions.get(r);o instanceof d&&o._fireDidChangeActive(a)}$onDidChangeSelection(r,a){const o=this._sessions.get(r);o instanceof d&&o._fireDidChangeSelection(a)}$onDidTriggerButton(r,a){this._sessions.get(r)?._fireDidTriggerButton(a)}$onDidTriggerItemButton(r,a,o){const u=this._sessions.get(r);u instanceof d&&u._fireDidTriggerItemButton(a,o)}$onDidHide(r){this._sessions.get(r)?._fireDidHide()}}class v{constructor(r,a){this._extensionId=r,this._onDidDispose=a,this._id=d._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new t.Emitter,this._onDidChangeValueEmitter=new t.Emitter,this._onDidTriggerButtonEmitter=new t.Emitter,this._onDidHideEmitter=new t.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((a,o)=>{const u=a===k.QuickInputButtons.Back?-1:o;this._handlesToButtons.set(u,a)}),this.update({buttons:r.map((a,o)=>({...n(a),tooltip:a.tooltip,handle:a===k.QuickInputButtons.Back?-1:o}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const a=this._handlesToButtons.get(r);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(r){if(!this._disposed){for(const a of Object.keys(r)){const o=r[a];this._pendingUpdate[a]=o===void 0?null:o}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function g(i){if(i instanceof k.ThemeIcon)return{id:i.id};const r=m(i),a=c(i);return{dark:typeof r=="string"?_.URI.file(r):r,light:typeof a=="string"?_.URI.file(a):a}}function c(i){return typeof i=="object"&&"light"in i?i.light:i}function m(i){return typeof i=="object"&&"dark"in i?i.dark:i}function n(i){const r=g(i.iconPath);let a,o;return"id"in r?o=y.ThemeIcon.asClassName(r):a=r,{iconPath:a,iconClass:o}}class d extends v{constructor(r,a){super(r.identifier,a),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new t.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new t.Emitter,this._onDidTriggerItemButtonEmitter=new t.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((o,u)=>{this._handlesToItems.set(u,o),this._itemsToHandles.set(o,u)});const a=[];for(let o=0;o<r.length;o++){const u=r[o];u.kind===k.QuickPickItemKind.Separator?a.push({type:"separator",label:u.label}):a.push({handle:o,label:u.label,description:u.description,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons?.map((h,C)=>({...n(h),tooltip:h.tooltip,handle:C}))})}this.update({items:a})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(r){this._keepScrollPosition=r,this.update({keepScrollPosition:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(r){const a=(0,I.coalesce)(r.map(o=>this._handlesToItems.get(o)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(r){const a=(0,I.coalesce)(r.map(o=>this._handlesToItems.get(o)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}_fireDidTriggerItemButton(r,a){const o=this._handlesToItems.get(r);if(!o||!o.buttons||!o.buttons.length)return;const u=o.buttons[a];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:o})}}class s extends v{constructor(r,a){super(r.identifier,a),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,r?typeof r=="string"?this.update({validationMessage:r,severity:L.default.Error}):this.update({validationMessage:r.message,severity:r.severity??L.default.Error}):this.update({validationMessage:void 0,severity:L.default.Ignore})}}return new f(E,p)}e.createExtHostQuickOpen=S});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[256],Ie([1,0,2,4,58,6,18,5,17,105,13,28,86,15,27]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E){"use strict";var p,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(u){if(u)return typeof u.iconPath=="string"?l.URI.file(u.iconPath):l.URI.isUri(u.iconPath)||S.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function v(u,h){if(!u.iconPath&&!h.iconPath)return 0;if(u.iconPath){if(!h.iconPath)return 1}else return-1;const C=typeof u.iconPath=="string"?u.iconPath:l.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,R=typeof h.iconPath=="string"?h.iconPath:l.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,I.comparePaths)(C,R)}function g(u,h){let C=0;if(u.strikeThrough!==h.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==h.faded)return u.faded?1:-1;if(u.tooltip!==h.tooltip)return(u.tooltip||"").localeCompare(h.tooltip||"");if(C=v(u,h),C!==0)return C;if(u.light&&h.light)C=v(u.light,h.light);else{if(u.light)return 1;if(h.light)return-1}if(C!==0)return C;if(u.dark&&h.dark)C=v(u.dark,h.dark);else{if(u.dark)return 1;if(h.dark)return-1}return C}function c(u,h){if(u.command!==h.command)return u.command<h.command?-1:1;if(u.title!==h.title)return u.title<h.title?-1:1;if(u.tooltip!==h.tooltip){if(u.tooltip!==void 0&&h.tooltip!==void 0)return u.tooltip<h.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(u.arguments===h.arguments)return 0;if(u.arguments)if(h.arguments){if(u.arguments.length!==h.arguments.length)return u.arguments.length-h.arguments.length}else return 1;else return-1;for(let C=0;C<u.arguments.length;C++){const R=u.arguments[C],N=h.arguments[C];if(R!==N)return R<N?-1:1}return 0}function m(u,h){let C=(0,I.comparePaths)(u.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(C!==0)return C;if(u.command&&h.command)C=c(u.command,h.command);else{if(u.command)return 1;if(h.command)return-1}if(C!==0)return C;if(u.decorations&&h.decorations)C=g(u.decorations,h.decorations);else{if(u.decorations)return 1;if(h.decorations)return-1}return C}function n(u,h){for(let C=0;C<u.length;C++)if(u[C]!==h[C])return!1;return!0}function d(u,h){return u.command===h.command&&u.title===h.title&&u.tooltip===h.tooltip&&(u.arguments&&h.arguments?n(u.arguments,h.arguments):u.arguments===h.arguments)}function s(u,h){return(0,w.equals)(u,h,d)}class i{constructor(h,C,R){this._extension=h,this._sourceControlHandle=R,p.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,tt(this,p,C,"f")}get value(){return this._value}set value(h){h=h??"",Ue(this,p,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){Ue(this,p,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,Ue(this,p,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get enabled(){return this._enabled}set enabled(h){h=!!h,this._enabled!==h&&(this._enabled=h,Ue(this,p,"f").$setInputBoxEnablement(this._sourceControlHandle,h))}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,Ue(this,p,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}showValidationMessage(h,C){(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),Ue(this,p,"f").$showValidationMessage(this._sourceControlHandle,h,C)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=i,p=new WeakMap;class r{constructor(h,C,R,N,M){this._proxy=h,this._commands=C,this._sourceControlHandle=R,this._id=N,this._label=M,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,C){const R=this._resourceStatesCommandsMap.get(h);return R?(0,_.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(m),R=(0,w.sortedDiff)(this._resourceSnapshot,h,m).map(A=>{const z=A.toInsert.map(H=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,H);const G=H.resourceUri;let B;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const ve=new P.DisposableStore;B=this._commands.converter.toInternal(H.command,ve),this._resourceStatesDisposablesMap.set(F,ve)}else this._resourceStatesCommandsMap.set(F,H.command);const U=f(H.decorations),X=H.decorations&&f(H.decorations.light)||U,$=H.decorations&&f(H.decorations.dark)||U,x=[X,$],Q=H.decorations&&H.decorations.tooltip||"",de=H.decorations&&!!H.decorations.strikeThrough,te=H.decorations&&!!H.decorations.faded,pe=H.contextValue||"";return{rawResource:[F,G,x,Q,de,te,pe,B],handle:F}});return{start:A.start,deleteCount:A.deleteCount,toInsert:z}}),N=R.map(({start:A,deleteCount:z,toInsert:H})=>[A,z,H.map(F=>F.rawResource)]),M=R.reverse();for(const{start:A,deleteCount:z,toInsert:H}of M){const F=H.map(B=>B.handle),G=this._handlesSnapshot.splice(A,z,...F);for(const B of G)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=h,N}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class a{constructor(h,C,R,N,M,A){this._extension=h,this._commands=R,this._id=N,this._label=M,this._rootUri=A,b.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=a._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,b,C,"f"),this._inputBox=new i(h,Ue(this,b,"f"),this.handle),Ue(this,b,"f").$registerSourceControl(this.handle,N,M,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,Ue(this,b,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,Ue(this,b,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,Ue(this,b,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=h;const C=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);Ue(this,b,"f").$updateSourceControl(this.handle,{acceptInputCommand:C})}get actionButton(){return(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=h;const C=h!==void 0?{command:this._commands.converter.toInternal(h.command,this._actionButtonDisposables.value),secondaryCommands:h.secondaryCommands?.map(R=>R.map(N=>this._commands.converter.toInternal(N,this._actionButtonDisposables.value))),description:h.description,enabled:h.enabled}:void 0;Ue(this,b,"f").$updateSourceControl(this.handle,{actionButton:C??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&s(this._statusBarCommands,h))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=h;const C=(h||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));Ue(this,b,"f").$updateSourceControl(this.handle,{statusBarCommands:C})}get selected(){return this._selected}createResourceGroup(h,C){const R=new r(Ue(this,b,"f"),this._commands,this.handle,h,C),N=t.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,N),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const h=[],C=[];for(const[R,N]of this.createdResourceGroups){N.dispose();const M=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});t.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),M.dispose(),this._groups.delete(R.handle),Ue(this,b,"f").$unregisterGroup(this.handle,R.handle)}),h.push([R.handle,R.id,R.label,R.features]);const A=R._takeResourceStateSnapshot();A.length>0&&C.push([R.handle,A]),this._groups.set(R.handle,R)}Ue(this,b,"f").$registerGroups(this.handle,h,C),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(C=>{const R=C._takeResourceStateSnapshot();R.length!==0&&h.push([C.handle,R])}),h.length>0&&Ue(this,b,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),Ue(this,b,"f").$unregisterSourceControl(this.handle)}}b=new WeakMap,a._handlePool=0,qe([(0,D.debounce)(100)],a.prototype,"eventuallyAddResourceGroups",null),qe([(0,D.debounce)(100)],a.prototype,"eventuallyUpdateResourceStates",null);let o=class ei{constructor(h,C,R){this._commands=C,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=h.getProxy(k.MainContext.MainThreadSCM),this._telemetry=h.getProxy(k.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const M=this._sourceControls.get(N.sourceControlHandle);if(!M)return N;const A=M.getResourceGroup(N.groupHandle);return A?A.getResourceState(N.handle):N}else if(N&&N.$mid===4){const M=this._sourceControls.get(N.sourceControlHandle);return M?M.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const M=this._sourceControls.get(N.handle);return M||N}return N}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,C,R,N){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,C,R,N),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const M=ei._handlePool++,A=new a(h,this._proxy,this._commands,C,R,N);this._sourceControls.set(M,A);const z=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(h.identifier))||[];return z.push(A),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(h.identifier),z),A}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const C=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(h.identifier)),R=C&&C[C.length-1];return R&&R.inputBox}$provideOriginalResource(h,C,R){const N=l.URI.revive(C);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,N.toString());const M=this._sourceControls.get(h);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>M.quickDiffProvider.provideOriginalResource(N,R)).then(A=>A||null)}$onInputBoxValueChange(h,C){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const R=this._sourceControls.get(h);return R&&R.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(h,C,R,N){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,C,R);const M=this._sourceControls.get(h);if(!M)return Promise.resolve(void 0);const A=M.getResourceGroup(C);return A?A.$executeResourceCommand(R,N):Promise.resolve(void 0)}$validateInput(h,C,R){this.logService.trace("ExtHostSCM#$validateInput",h);const N=this._sourceControls.get(h);return!N||!N.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>N.inputBox.validateInput(C,R)).then(M=>{if(!M)return Promise.resolve(void 0);const A=T.MarkdownString.fromStrict(M.message);return A?Promise.resolve([A,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};o._handlePool=0,o=qe([xe(2,L.ILogService)],o),e.ExtHostSCM=o}),define(De[92],Ie([1,0,5,4,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(k){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(l.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,w){return this._proxy.$getPassword(k,w)}store(k,w,I){return this._proxy.$setPassword(k,w,I)}delete(k,w){return this._proxy.$deletePassword(k,w)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[257],Ie([1,0,7,5,173,6,15,16]),function(J,e,l,t,D,P,_,k){"use strict";var w,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(E,p,b,f,v=l.StatusBarAlignment.Left,g){w.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,w,E,"f"),tt(this,I,p,"f"),this._entryId=L.ID_GEN++,this._extension=b,this._id=f,this._alignment=v,this._priority=this.validatePriority(g)}validatePriority(E){if(!!(0,k.isNumber)(E))return E===Number.POSITIVE_INFINITY?Number.MAX_VALUE:E===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(E){this._text=E,this.update()}set name(E){this._name=E,this.update()}set tooltip(E){this._tooltip=E,this.update()}set color(E){this._color=E,this.update()}set backgroundColor(E){E&&!L.ALLOWED_BACKGROUND_COLORS.has(E.id)&&(E=void 0),this._backgroundColor=E,this.update()}set command(E){this._command?.fromApi!==E&&(this._internalCommandRegistration.clear(),typeof E=="string"?this._command={fromApi:E,internal:Ue(this,I,"f").toInternal({title:"",command:E},this._internalCommandRegistration)}:E?this._command={fromApi:E,internal:Ue(this,I,"f").toInternal(E,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(E){this._accessibilityInformation=E,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,w,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let E;this._extension?this._id?E=`${this._extension.identifier.value}.${this._id}`:E=this._extension.identifier.value:E=this._id;let p;this._name?p=this._name:p=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let b=this._color;this._backgroundColor&&(b=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const f=_.MarkdownString.fromStrict(this._tooltip);Ue(this,w,"f").$setEntry(this._entryId,E,p,this._text,f,this._command?.internal,b,this._backgroundColor,this._alignment===l.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,w=new WeakMap,I=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new l.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.ThemeColor("statusBarItem.warningForeground")]]);class y{constructor(E){this._messages=[],this._item=E.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(E){const p={message:E};return this._messages.unshift(p),this._update(),new l.Disposable(()=>{const b=this._messages.indexOf(p);b>=0&&(this._messages.splice(b,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class S{constructor(E,p){this._proxy=E.getProxy(t.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new y(this)}createStatusBarEntry(E,p,b,f){return new L(this._proxy,this._commands,E,p,b,f)}setStatusBarMessage(E,p){const b=this._statusMessage.setMessage(E);let f;return typeof p=="number"?f=setTimeout(()=>b.dispose(),p):typeof p<"u"&&p.then(()=>b.dispose(),()=>b.dispose()),new l.Disposable(()=>{b.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=S}),define(De[93],Ie([1,0,5,4,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(k){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(l.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,w){this._proxy.$registerExtensionStorageKeysToSync(k,w)}initializeExtensionStorage(k,w,I){return this._proxy.$initializeExtensionStorage(k,w).then(L=>L||I)}setValue(k,w,I){return this._proxy.$setValue(k,w,I)}$acceptValue(k,w,I){this._onDidChangeStorage.fire({shared:k,key:w,value:I})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(De[67],Ie([1,0,3,26,13,66,2]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,l.createDecorator)("IExtensionStoragePaths");let k=class{constructor(I,L,y){this._logService=L,this._extHostFileSystem=y,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(S=>this._value=S)}async _getWorkspaceStorageURI(I){return _.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,L=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:_.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(I){if(this._value)return _.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return _.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=qe([xe(0,t.IExtHostInitDataService),xe(1,D.ILogService),xe(2,P.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(De[138],Ie([1,0,3,5,14]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,l.createDecorator)("IExtHostTelemetryLogService");let P=class{constructor(k){this._telemetryShape=k.getProxy(t.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(k,w,I){this._telemetryShape.$logTelemetryToOutputChannel(`${k.identifier.value}/${w}`,I)}};P=qe([xe(0,D.IExtHostRpcService)],P),e.ExtHostTelemetryLogService=P}),define(De[38],Ie([1,0,4,5,3,2,14,6,7,174,10,216,21,34,201,86,16,18,15]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class g{constructor(o,u,h,C){this._proxy=o,this._id=u,this._creationOptions=h,this._name=C,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(N=>this._pidPromiseComplete=N);const R=this;this.value={get name(){return R._name||""},get processId(){return R._pidPromise},get creationOptions(){return R._creationOptions},get exitStatus(){return R._exitStatus},get state(){return R._state},sendText(N,M=!0){R._checkDisposed(),R._proxy.$sendText(R._id,N,M)},show(N){R._checkDisposed(),R._proxy.$show(R._id,N)},hide(){R._checkDisposed(),R._proxy.$hide(R._id)},dispose(){R._disposed||(R._disposed=!0,R._proxy.$dispose(R._id))},get dimensions(){if(!(R._cols===void 0||R._rows===void 0))return{columns:R._cols,rows:R._rows}}}}async create(o,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,b.withNullAsUndefined)(o.shellPath),shellArgs:(0,b.withNullAsUndefined)(o.shellArgs),cwd:(0,b.withNullAsUndefined)(o.cwd),env:(0,b.withNullAsUndefined)(o.env),icon:(0,b.withNullAsUndefined)(i(o.iconPath)),color:p.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,b.withNullAsUndefined)(o.message),strictEnv:(0,b.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,b.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,b.withNullAsUndefined)(u?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,b.withNullAsUndefined)(u?.useShellEnvironment),location:u?.location||this._serializeParentTerminal(o.location,u?.resolvedExtHostIdentifier),isTransient:(0,b.withNullAsUndefined)(o.isTransient)})}async createExtensionTerminal(o,u,h,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:p.ThemeColor.isThemeColor(C)?C.id:void 0,location:this._serializeParentTerminal(o,u),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,u){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&u?{parentTerminal:u}:"viewColumn"in o?{viewColumn:v.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitStatus(o,u){this._exitStatus=Object.freeze({code:o,reason:u})}setDimensions(o,u){return o===this._cols&&u===this._rows||o===0||u===0?!1:(this._cols=o,this._rows=u,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(u=>{u!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=g;class c{constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._onProcessData=new l.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new l.Emitter,this._onDidChangeProperty=new l.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new l.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,u){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${u}`)}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput?.(o)}resize(o,u){this._pty.setDimensions?.({columns:o,rows:u})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(u=>this._onProcessData.fire(u)),this._pty.onDidClose?.((u=void 0)=>{this._onProcessExit.fire(u===void 0?void 0:u)}),this._pty.onDidOverrideDimensions?.(u=>{u&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:u.columns,rows:u.rows}})}),this._pty.onDidChangeName?.(u=>{this._onDidChangeProperty.fire({type:"title",value:u})}),this._pty.open(o||void 0),o&&this._pty.setDimensions?.(o),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=c;let m=1,n=class extends k.Disposable{constructor(o,u){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new l.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new l.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new l.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new l.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new l.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new l.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=u.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new E.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new l.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[h,C]of this._terminalProcesses)C.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,u){const h=new g(this._proxy,(0,T.generateUuid)(),o,o.name),C=new c(o.pty);return h.createExtensionTerminal(o.location,this._serializeParentTerminal(o,u).resolvedExtHostIdentifier,i(o.iconPath),r(o.color)).then(R=>{const N=this._setupExtHostProcessListeners(R,C);this._terminalProcessDisposables[R]=N}),this._terminals.push(h),h.value}_serializeParentTerminal(o,u){if(u=u||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const h=o.location.parentTerminal;if(h){const C=this._terminals.find(R=>R.value===h);C&&(u.resolvedExtHostIdentifier=C._id)}}else o.location&&typeof o.location!="object"?u.location=o.location:u.location&&typeof u.location=="object"&&"splitActiveTerminal"in u.location&&(u.location={splitActiveTerminal:!0});return u}attachPtyToTerminal(o,u){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const C=new c(u),R=this._setupExtHostProcessListeners(o,C);this._terminalProcessDisposables[o]=R}async $acceptActiveTerminalChanged(o){const u=this._activeTerminal;if(o===null){this._activeTerminal=void 0,u!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(o);h&&(this._activeTerminal=h,u!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,u){const h=this._getTerminalById(o);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:u})}async $acceptTerminalDimensions(o,u,h){const C=this._getTerminalById(o);C&&C.setDimensions(u,h)&&this._onDidChangeTerminalDimensions.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptTerminalMaximumDimensions(o,u,h){this._terminalProcesses.get(o)?.resize(u,h)}async $acceptTerminalTitleChange(o,u){const h=this._getTerminalById(o);h&&(h.name=u)}async $acceptTerminalClosed(o,u,h){const C=this._getTerminalObjectIndexById(this._terminals,o);if(C!==null){const R=this._terminals.splice(C,1)[0];R.setExitStatus(u,h),this._onDidCloseTerminal.fire(R.value)}}$acceptTerminalOpened(o,u,h,C){if(u){const M=this._getTerminalObjectIndexById(this._terminals,u);if(M!==null){this._terminals[M]._id=o,this._onDidOpenTerminal.fire(this.terminals[M]),this._terminals[M].isOpen=!0;return}}const R={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:P.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},N=new g(this._proxy,o,R,h);this._terminals.push(N),this._onDidOpenTerminal.fire(N.value),N.isOpen=!0}async $acceptTerminalProcessId(o,u){this._getTerminalById(o)?._setProcessId(u)}async $startExtensionTerminal(o,u){const h=this._getTerminalById(o);if(!h)return{message:(0,I.localize)(0,null,o)};h.isOpen||await new Promise(R=>{const N=this.onDidOpenTerminal(async M=>{M===h.value&&(N.dispose(),R())})});const C=this._terminalProcesses.get(o);C?C.startSendingEvents(u):this._extensionTerminalAwaitingStart[o]={initialDimensions:u}}_setupExtHostProcessListeners(o,u){const h=new k.DisposableStore;h.add(u.onProcessReady(R=>this._proxy.$sendProcessReady(o,R.pid,R.cwd))),h.add(u.onDidChangeProperty(R=>this._proxy.$sendProcessProperty(o,R))),this._bufferer.startBuffering(o,u.onProcessData),h.add(u.onProcessExit(R=>this._onProcessExit(o,R))),this._terminalProcesses.set(o,u);const C=this._extensionTerminalAwaitingStart[o];return C&&u instanceof c&&(u.startSendingEvents(C.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),h}$acceptProcessAckDataEvent(o,u){this._terminalProcesses.get(o)?.acknowledgeDataEvent(u)}$acceptProcessInput(o,u){this._terminalProcesses.get(o)?.input(u)}$acceptTerminalInteraction(o){const u=this._getTerminalById(o);u?.setInteractedWith()&&this._onDidChangeTerminalState.fire(u.value)}$acceptProcessResize(o,u,h){try{this._terminalProcesses.get(o)?.resize(u,h)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(o,u){this._terminalProcesses.get(o)?.shutdown(u)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(u=>this._proxy.$sendProcessProperty(o,{type:"initialCwd",value:u}))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(u=>this._proxy.$sendProcessProperty(o,{type:"cwd",value:u}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new w.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,u,h){if(this._profileProviders.has(u))throw new Error(`Terminal profile provider "${u}" already registered`);return this._profileProviders.set(u,h),this._proxy.$registerProfileProvider(u,o.identifier.value),new w.Disposable(()=>{this._profileProviders.delete(u),this._proxy.$unregisterProfileProvider(u)})}async $createContributedProfileTerminal(o,u){const h=new S.CancellationTokenSource().token;let C=await this._profileProviders.get(o)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,u);return}this.createTerminalFromOptions(C.options,u)}}async $provideLinks(o,u){const h=this._getTerminalById(o);if(!h)return[];this._terminalLinkCache.delete(o),this._terminalLinkCancellationSource.get(o)?.dispose(!0);const R=new S.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,R);const N=[],M={terminal:h.value,line:u},A=[];for(const F of this._linkProviders)A.push(f.Promises.withAsyncBody(async G=>{R.token.onCancellationRequested(()=>G({provider:F,links:[]}));const B=await F.provideTerminalLinks(M,R.token)||[];R.token.isCancellationRequested||G({provider:F,links:B})}));const z=await Promise.all(A);if(R.token.isCancellationRequested)return[];const H=new Map;for(const F of z)F&&F.links.length>0&&N.push(...F.links.map(G=>{const B={id:m++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return H.set(B.id,{provider:F.provider,link:G}),B}));return this._terminalLinkCache.set(o,H),N}$activateLink(o,u){const h=this._terminalLinkCache.get(o)?.get(u);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(o,u){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const h=this._terminalProcessDisposables[o];h&&(h.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,u)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,u){const h=this._getTerminalObjectIndexById(o,u);return h!==null?o[h]:null}_getTerminalObjectIndexById(o,u){let h=null;return o.some((C,R)=>C._id===u?(h=R,!0):!1),h}getEnvironmentVariableCollection(o){let u=this._environmentVariableCollections.get(o.identifier.value);return u||(u=new d,this._setEnvironmentVariableCollection(o.identifier.value,u)),u}_syncEnvironmentVariableCollection(o,u){const h=(0,y.serializeEnvironmentVariableCollection)(u.map);this._proxy.$setEnvironmentVariableCollection(o,u.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(o){o.forEach(u=>{const h=u[0],C=new d(u[1]);this._setEnvironmentVariableCollection(h,C)})}$acceptDefaultProfile(o,u){const h=this._defaultProfile;this._defaultProfile=o,this._defaultAutomationProfile=u,h?.path!==o.path&&this._onDidChangeShell.fire(o.path)}_setEnvironmentVariableCollection(o,u){this._environmentVariableCollections.set(o,u),u.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,u)})}};n=qe([xe(1,_.IExtHostRpcService)],n),e.BaseExtHostTerminalService=n;class d{constructor(o){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new l.Emitter,this.map=new Map(o)}get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(o,u){this._setIfDiffers(o,{value:u,type:w.EnvironmentVariableMutatorType.Replace})}append(o,u){this._setIfDiffers(o,{value:u,type:w.EnvironmentVariableMutatorType.Append})}prepend(o,u){this._setIfDiffers(o,{value:u,type:w.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(o,u){const h=this.map.get(o);(!h||h.value!==u.value||h.type!==u.type)&&(this.map.set(o,u),this._onDidChangeCollection.fire())}get(o){return this.map.get(o)}forEach(o,u){this.map.forEach((h,C)=>o.call(u,C,h,this))}[Symbol.iterator](){return this.map.entries()}delete(o){this.map.delete(o),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let s=class extends n{constructor(o){super(!1,o)}createTerminal(o,u,h){throw new L.NotSupportedError}createTerminalFromOptions(o,u){throw new L.NotSupportedError}};s=qe([xe(0,_.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function i(a){if(!(!a||typeof a=="string"))return"id"in a?{id:a.id,color:a.color}:a}function r(a){return p.ThemeColor.isThemeColor(a)?a:void 0}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[258],Ie([1,0,17,23,21,4,59,78,6,24,16,34,5,14,134,15,7,63,90,64]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f,v,g){"use strict";var c,m;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let n=class{constructor(M,A,z){this.editors=z,this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=M.getProxy(S.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new s(this.proxy),A.registerArgumentProcessor({processArgument:H=>H?.$mid===13?(0,E.toItemFromContext)(H):H})}createTestController(M,A,z){if(this.controllers.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const H=new w.DisposableStore,F=H.add(new E.ExtHostTestItemCollection(M,A,this.editors));F.root.label=A;const G=new Map,B=this.proxy,U={items:F.root.children,get label(){return A},set label($){A=$,F.root.label=$,B.$updateController(M,{label:A})},get refreshHandler(){return z},set refreshHandler($){z=$,B.$updateController(M,{canRefresh:!!$})},get id(){return M},createRunProfile:($,x,Q,de,te)=>{let pe=(0,k.hash)($);for(;G.has(pe);)pe++;return new C(this.proxy,G,M,pe,$,x,Q,de,te)},createTestItem($,x,Q){return new E.TestItemImpl(M,$,x,Q)},createTestRun:($,x,Q=!0)=>this.runTracker.createTestRun(M,F,$,x,Q),set resolveHandler($){F.resolveHandler=$},get resolveHandler(){return F.resolveHandler},dispose:()=>{H.dispose()}};B.$registerTestController(M,A,!!z),H.add((0,w.toDisposable)(()=>B.$unregisterTestController(M)));const X={controller:U,collection:F,profiles:G};return this.controllers.set(M,X),H.add((0,w.toDisposable)(()=>this.controllers.delete(M))),H.add(F.onDidGenerateDiff($=>B.$publishDiff(M,$.map(g.TestsDiffOp.serialize)))),U}createTestObserver(){return this.observer.checkout()}async runTests(M,A=D.CancellationToken.None){const z=i(M);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const H=this.controllers.get(z.controllerId);if(!H)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(F=>f.TestId.fromExtHostTestItem(F,H.collection.root.id).toString())??[H.collection.root.id],profileGroup:R[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:M.exclude?.map(F=>F.id)},A)}$provideFileCoverage(M,A,z){return(0,l.mapFind)(this.runTracker.trackers,F=>F.id===M?F.getCoverage(A):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(M,A,z,H){return(0,l.mapFind)(this.runTracker.trackers,G=>G.id===M?G.getCoverage(A):void 0)?.resolveFileCoverage(z,H)??Promise.resolve([])}$configureRunProfile(M,A){this.controllers.get(M)?.profiles.get(A)?.configureHandler?.()}async $refreshTests(M,A){await this.controllers.get(M)?.controller.refreshHandler?.(A)}$publishTestResults(M){this.results=Object.freeze(M.map(A=>(0,I.deepFreeze)(p.TestResults.to(A))).concat(this.results).sort((A,z)=>z.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(M,A){const z=this.controllers.get(f.TestId.fromString(M).controllerId)?.collection;z&&(await z.expand(M,A<0?1/0:A),z.flushDiff())}$acceptDiff(M){this.observer.applyDiff(M.map(g.TestsDiffOp.deserialize))}async $runControllerTests(M,A){return Promise.all(M.map(z=>this.runControllerTestRequest(z,A)))}async runControllerTestRequest(M,A){const z=this.controllers.get(M.controllerId);if(!z)return{};const{collection:H,profiles:F}=z,G=F.get(M.profileId);if(!G)return{};const B=M.testIds.map(x=>H.tree.get(x)).filter(L.isDefined),U=M.excludeExtIds.map(x=>z.collection.tree.get(x)).filter(L.isDefined).filter(x=>B.some(Q=>Q.fullId.compare(x.fullId)===2));if(!B.length)return{};const X=new b.TestRunRequest(B.some(x=>x.actual instanceof E.TestItemRootImpl)?void 0:B.map(x=>x.actual),U.map(x=>x.actual),G),$=this.runTracker.prepareForMainThreadTestRun(X,r.fromInternal(M,z.collection),A);try{return await G.runHandler(X,A),{}}catch(x){return{error:String(x)}}finally{$.isRunning&&!A.isCancellationRequested&&await P.Event.toPromise($.onEnd),$.dispose()}}$cancelExtensionTestRun(M){M===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(M)}};n=qe([xe(0,T.IExtHostRpcService)],n),e.ExtHostTesting=n;class d extends w.Disposable{constructor(M,A,z){super(),this.dto=M,this.proxy=A,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(z)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:H}of this.tasks.values())H.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(M){return this.tasks.get(M)?.coverage}createRun(M){const A=this.dto.id,z=this.dto.controllerId,H=(0,y.generateUuid)(),F=new a(this.proxy,A,H),G=$=>(x,...Q)=>{if(U){console.warn(`Setting the state of test "${x.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(x)||(this.ensureTestIsKnown(x),$(x,...Q))},B=($,x)=>{const Q=x instanceof Array?x.map(p.TestMessage.from):[p.TestMessage.from(x)];if($.uri&&$.range){const de={range:p.Range.from($.range),uri:$.uri};for(const te of Q)te.location=te.location||de}this.proxy.$appendTestMessagesInRun(A,H,f.TestId.fromExtHostTestItem($,z).toString(),Q)};let U=!1;const X={isPersisted:this.dto.isPersisted,token:this.cts.token,name:M,get coverageProvider(){return F.coverageProvider},set coverageProvider($){F.coverageProvider=$},enqueued:G($=>{this.proxy.$updateTestStateInRun(A,H,f.TestId.fromExtHostTestItem($,z).toString(),1)}),skipped:G($=>{this.proxy.$updateTestStateInRun(A,H,f.TestId.fromExtHostTestItem($,z).toString(),5)}),started:G($=>{this.proxy.$updateTestStateInRun(A,H,f.TestId.fromExtHostTestItem($,z).toString(),2)}),errored:G(($,x,Q)=>{B($,x),this.proxy.$updateTestStateInRun(A,H,f.TestId.fromExtHostTestItem($,z).toString(),6,Q)}),failed:G(($,x,Q)=>{B($,x),this.proxy.$updateTestStateInRun(A,H,f.TestId.fromExtHostTestItem($,z).toString(),4,Q)}),passed:G(($,x)=>{this.proxy.$updateTestStateInRun(A,H,f.TestId.fromExtHostTestItem($,this.dto.controllerId).toString(),3,x)}),appendOutput:($,x,Q)=>{U||(Q&&(this.dto.isIncluded(Q)?this.ensureTestIsKnown(Q):Q=void 0),this.proxy.$appendOutputToRun(A,H,t.VSBuffer.fromString($),x&&p.location.from(x),Q&&f.TestId.fromExtHostTestItem(Q,z).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(A,H),this.tasks.delete(H),this.isRunning||this.dispose())}};return this.tasks.set(H,{run:X,coverage:F}),this.proxy.$startedTestRunTask(A,{id:H,name:M,running:!0}),X}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(M){if(!(M instanceof E.TestItemImpl))throw new v.InvalidTestItemError(M.id);if(this.sharedTestIds.has(f.TestId.fromExtHostTestItem(M,this.dto.controllerId).toString()))return;const A=[],z=this.dto.colllection.root;for(;;){const H=p.TestItem.from(M);if(A.unshift(H),this.sharedTestIds.has(H.extId)||(this.sharedTestIds.add(H.extId),M===z))break;M=M.parent||z}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,A)}}class s{constructor(M){this.proxy=M,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(M,A,z){return this.getTracker(M,A,z)}cancelRunById(M){for(const A of this.tracked.values())if(A.id===M){A.dispose();return}}cancelAllRuns(){for(const M of this.tracked.values())M.dispose()}createTestRun(M,A,z,H,F){const G=this.tracked.get(z);if(G)return G.createRun(H);const B=r.fromPublic(M,A,z,F),U=i(z);this.proxy.$startedExtensionTestRun({controllerId:M,profile:U&&{group:R[U.kind],id:U.profileId},exclude:z.exclude?.map($=>f.TestId.fromExtHostTestItem($,A.root.id).toString())??[],id:B.id,include:z.include?.map($=>f.TestId.fromExtHostTestItem($,A.root.id).toString())??[A.root.id],persist:F});const X=this.getTracker(z,B);return X.onEnd(()=>this.proxy.$finishedExtensionTestRun(B.id)),X.createRun(H)}getTracker(M,A,z){const H=new d(A,this.proxy,z);return this.tracked.set(M,H),H.onEnd(()=>this.tracked.delete(M)),H}}e.TestRunCoordinator=s;const i=N=>{if(!!N.profile){if(!(N.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class r{constructor(M,A,z,H,F,G){this.controllerId=M,this.id=A,this.isPersisted=F,this.colllection=G,this.includePrefix=z.map(B=>B+"\0"),this.excludePrefix=H.map(B=>B+"\0")}static fromPublic(M,A,z,H){return new r(M,(0,y.generateUuid)(),z.include?.map(F=>f.TestId.fromExtHostTestItem(F,M).toString())??[M],z.exclude?.map(F=>f.TestId.fromExtHostTestItem(F,M).toString())??[],H,A)}static fromInternal(M,A){return new r(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,A)}isIncluded(M){const A=f.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const z of this.excludePrefix)if(A===z||A.startsWith(z))return!1;for(const z of this.includePrefix)if(A===z||A.startsWith(z))return!0;return!1}}e.TestRunDto=r;class a{constructor(M,A,z){this.proxy=M,this.runId=A,this.taskId=z}set coverageProvider(M){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!M||(this._coverageProvider=M,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(M){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(M))());try{return(await this.fileCoverage)?.map(p.TestCoverage.fromFile)??[]}catch(A){throw this.fileCoverage=void 0,A}}async resolveFileCoverage(M,A){const z=await this.fileCoverage;let H=z?.[M];return!this._coverageProvider||!z||!H?[]:(H.detailedCoverage||(H=z[M]=await this._coverageProvider.resolveFileCoverage?.(H,A)??H),H.detailedCoverage?.map(p.TestCoverage.fromDetailed)??[])}}class o extends g.IncrementalChangeCollector{constructor(M){super(),this.emitter=M,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(M){this.added.add(M)}update(M){Object.assign(M.revived,p.TestItem.toPlain(M.item)),this.added.has(M)||this.updated.add(M)}remove(M){if(this.added.has(M)){this.added.delete(M);return}if(this.updated.delete(M),M.parent&&this.alreadyRemoved.has(M.parent)){this.alreadyRemoved.add(M.item.extId);return}this.removed.add(M)}getChangeEvent(){const{added:M,updated:A,removed:z}=this;return{get added(){return[...M].map(H=>H.revived)},get updated(){return[...A].map(H=>H.revived)},get removed(){return[...z].map(H=>H.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class u extends g.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(M){return this.items.get(M)}getMirroredTestDataByReference(M){return this.items.get(M.id)}createItem(M,A){return{...M,revived:p.TestItem.toPlain(M.item),depth:A?A.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=u;class h{constructor(M){this.proxy=M}checkout(){this.current||(this.current=this.createObserverData());const M=this.current;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(A=>A.revived)},dispose:(0,_.once)(()=>{--M.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(M){return this.current?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.current?.tests.apply(M)}createObserverData(){const M=new u;return this.proxy.$subscribeToDiffs(),{observers:0,tests:M}}}class C{constructor(M,A,z,H,F,G,B,U=!1,X=void 0){this.controllerId=z,this.profileId=H,this._label=F,this.kind=G,this.runHandler=B,this._isDefault=U,this._tag=X,c.set(this,void 0),m.set(this,void 0),tt(this,c,M,"f"),tt(this,m,A,"f"),A.set(H,this);const $=R[G];if(typeof $!="number")throw new Error(`Unknown TestRunProfile.group ${G}`);Ue(this,c,"f").$publishTestRunProfile({profileId:H,controllerId:z,tag:X?p.TestTag.namespace(this.controllerId,X.id):null,label:F,group:$,isDefault:U,hasConfigurationHandler:!1})}get label(){return this._label}set label(M){M!==this._label&&(this._label=M,Ue(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get isDefault(){return this._isDefault}set isDefault(M){M!==this._isDefault&&(this._isDefault=M,Ue(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,Ue(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?p.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(M){M!==this._configureHandler&&(this._configureHandler=M,Ue(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}dispose(){Ue(this,m,"f")?.delete(this.profileId)&&(tt(this,m,void 0,"f"),Ue(this,c,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=C,c=new WeakMap,m=new WeakMap;const R={[b.TestRunProfileKind.Coverage]:8,[b.TestRunProfileKind.Debug]:4,[b.TestRunProfileKind.Run]:2}}),define(De[259],Ie([1,0,17,4,5,135,15,7]),function(J,e,l,t,D,P,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class w{constructor(L,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new t.Emitter,this._onDidChangeTextEditorOptions=new t.Emitter,this._onDidChangeTextEditorVisibleRanges=new t.Emitter,this._onDidChangeTextEditorViewColumn=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(S=>this._onDidChangeVisibleTextEditors.fire(S)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(S=>this._onDidChangeActiveTextEditor.fire(S))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const y=this._extHostDocumentsAndEditors.allEditors();return L?y:y.map(S=>S.value)}async showTextDocument(L,y,S){let T;typeof y=="number"?T={position:_.ViewColumn.from(y),preserveFocus:S}:typeof y=="object"?T={position:_.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?_.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:T={preserveFocus:!1};const E=await this._proxy.$tryShowTextDocument(L.uri,T),p=E&&this._extHostDocumentsAndEditors.getEditor(E);if(p)return p.value;throw E?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,y){return new P.TextEditorDecorationType(this._proxy,L,y).value}$acceptEditorPropertiesChanged(L,y){const S=this._extHostDocumentsAndEditors.getEditor(L);if(!S)throw new Error("unknown text editor");if(y.options&&S._acceptOptions(y.options),y.selections){const T=y.selections.selections.map(_.Selection.to);S._acceptSelections(T)}if(y.visibleRanges){const T=l.coalesce(y.visibleRanges.map(_.Range.to));S._acceptVisibleRanges(T)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:S.value,options:{...y.options,lineNumbers:_.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const T=k.TextEditorSelectionChangeKind.fromValue(y.selections.source),E=y.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:S.value,selections:E,kind:T})}if(y.visibleRanges){const T=l.coalesce(y.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:S.value,visibleRanges:T})}}$acceptEditorPositionData(L){for(const y in L){const S=this._extHostDocumentsAndEditors.getEditor(y);if(!S)throw new Error("Unknown text editor");const T=_.ViewColumn.to(L[y]);S.value.viewColumn!==T&&(S._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:S.value,viewColumn:T}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=w}),define(De[260],Ie([1,0,2,3,5,6,7,15,16]),function(J,e,l,t,D,P,_,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class I{constructor(S,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=S.getProxy(D.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===11){const p=E.uri===void 0?void 0:l.URI.revive(E.uri);return this._itemsBySourceAndUriMap.get(E.source)?.get(L(p))?.get(E.handle)}return E}})}async $getTimeline(S,T,E,p){return this._providers.get(S)?.provideTimeline(l.URI.revive(T),E,p)}registerTimelineProvider(S,T,E,p){const b=new P.DisposableStore,f=this.convertTimelineItem(T.id,p,b).bind(this);let v;T.onDidChange&&(v=T.onDidChange(c=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:T.id}),this));const g=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:S,onDidChange:void 0,async provideTimeline(c,m,n){m?.resetCache&&(b.clear(),g.get(T.id)?.clear());const d=await T.provideTimeline(c,m,n);if(d==null)return;const s=f(c,m);return{...d,source:T.id,items:d.items.map(s)}},dispose(){for(const c of g.values())c.get(T.id)?.clear();v?.dispose(),b.dispose()}})}convertTimelineItem(S,T,E){return(p,b)=>{let f;if(b?.cacheResults){let v=this._itemsBySourceAndUriMap.get(S);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(S,v));const g=L(p);f=v.get(g),f===void 0&&(f=new Map,v.set(g,f))}return v=>{const{iconPath:g,...c}=v,m=`${S}|${v.id??v.timestamp}`;f?.set(m,v);let n,d,s;v.iconPath&&(g instanceof _.ThemeIcon?s={id:g.id,color:g.color}:l.URI.isUri(g)?(n=g,d=g):{light:n,dark:d}=g);let i;return _.MarkdownString.isMarkdownString(c.tooltip)?i=k.MarkdownString.from(c.tooltip):(0,w.isString)(c.tooltip)?i=c.tooltip:_.MarkdownString.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=k.MarkdownString.from(c.detail)):(0,w.isString)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=c.detail),{...c,id:c.id??void 0,handle:m,source:S,command:v.command?T.toInternal(v.command,E):void 0,icon:n,iconDark:d,themeIcon:s,tooltip:i,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(S){if(this._providers.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this._proxy.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this._providers.set(S.id,S),(0,P.toDisposable)(()=>{for(const E of this._itemsBySourceAndUriMap.values())E.get(S.id)?.clear();this._providers.delete(S.id),this._proxy.$unregisterTimelineProvider(S.id),S.dispose()})}}e.ExtHostTimeline=I;function L(y){return y?.toString()}}),define(De[261],Ie([1,0,6,12,2,5]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(w){this._openers=new Map,this._proxy=w.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(w,I,L,y){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const S=y.schemes.find(T=>!_.supportedSchemes.has(T));if(S)throw new Error(`Scheme '${S}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,L),this._proxy.$registerUriOpener(I,y.schemes,w,y.label),(0,l.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(w,I,L){const y=this._openers.get(w);if(!y)throw new Error(`Unknown opener with id: ${w}`);const S=D.URI.revive(I);return y.canOpenExternalUri(S,L)}async $openUri(w,I,L){const y=this._openers.get(w);if(!y)throw new Error(`Unknown opener id: '${w}'`);return y.openExternalUri(D.URI.revive(I.resolvedUri),{sourceUri:D.URI.revive(I.sourceUri)},L)}}e.ExtHostUriOpeners=_,_.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(De[262],Ie([1,0,5,2,6,10,28]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(l.MainContext.MainThreadUrls)}registerUriHandler(I,L){if(this.handles.has(_.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const y=k.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(I)),this.handlers.set(y,L),this._proxy.$registerUriHandler(y,I),(0,D.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(I)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(I,L){const y=this.handlers.get(I);if(!y)return Promise.resolve(void 0);try{y.handleUri(t.URI.revive(L))}catch(S){(0,P.onUnexpectedError)(S)}return Promise.resolve(void 0)}async createAppUri(I){return t.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=k,k.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[68],Ie([1,0,4,12,2,188,207,88,5]),function(J,e,l,t,D,P,_,k,w){"use strict";var I,L,y,S,T,E,p,b,f,v,g,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(u,h,C,R,N,M,A){I.set(this,void 0),L.set(this,void 0),y.set(this,void 0),S.set(this,void 0),T.set(this,void 0),E.set(this,void 0),p.set(this,""),b.set(this,void 0),f.set(this,!1),v.set(this,!1),g.set(this,!1),this._onMessageEmitter=new l.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new l.Emitter),this._onDidDispose=Ue(this,c,"f").event,tt(this,I,u,"f"),tt(this,L,h,"f"),tt(this,b,C,"f"),tt(this,S,R,"f"),tt(this,T,N,"f"),tt(this,E,M,"f"),tt(this,g,n(M),"f"),tt(this,y,A,"f")}dispose(){tt(this,f,!0,"f"),Ue(this,c,"f").fire(),Ue(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return tt(this,v,!0,"f"),(0,k.asWebviewUri)(u,Ue(this,S,"f"))}get cspSource(){const u=Ue(this,E,"f").extensionLocation;if(u.scheme===t.Schemas.https||u.scheme===t.Schemas.http){let h=u.toString();return h.endsWith("/")||(h+="/"),h+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,p,"f")}set html(u){this.assertNotDisposed(),Ue(this,p,"f")!==u&&(tt(this,p,u,"f"),!Ue(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(tt(this,v,!0,"f"),Ue(this,y,"f").report("Webview vscode-resource: uris",Ue(this,E,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,L,"f").$setHtml(Ue(this,I,"f"),u))}get options(){return this.assertNotDisposed(),Ue(this,b,"f")}set options(u){this.assertNotDisposed(),Ue(this,L,"f").$setOptions(Ue(this,I,"f"),i(Ue(this,E,"f"),Ue(this,T,"f"),u)),tt(this,b,u,"f")}async postMessage(u){if(Ue(this,f,"f"))return!1;const h=(0,_.serializeWebviewMessage)(u,{serializeBuffersForPostMessage:Ue(this,g,"f")});return Ue(this,L,"f").$postMessage(Ue(this,I,"f"),h.message,...h.buffers)}assertNotDisposed(){if(Ue(this,f,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,I=new WeakMap,L=new WeakMap,y=new WeakMap,S=new WeakMap,T=new WeakMap,E=new WeakMap,p=new WeakMap,b=new WeakMap,f=new WeakMap,v=new WeakMap,g=new WeakMap,c=new WeakMap;function n(o){try{const u=(0,P.normalizeVersion)((0,P.parseVersion)(o.engines.vscode));return!!u&&u.majorBase>=1&&u.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;class d{constructor(u,h,C,R,N){this.remoteInfo=h,this.workspace=C,this._logService=R,this._deprecationService=N,this._webviews=new Map,this._webviewProxy=u.getProxy(w.MainContext.MainThreadWebviews)}$onMessage(u,h,C){const R=this.getWebview(u);if(R){const{message:N}=(0,_.deserializeWebviewMessage)(h,C.value);R._onMessageEmitter.fire(N)}}$onMissingCsp(u,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,h,C){const R=new m(u,this._webviewProxy,r(h),this.remoteInfo,this.workspace,C,this._deprecationService);return this._webviews.set(u,R),R._onDidDispose(()=>{this._webviews.delete(u)}),R}deleteWebview(u){this._webviews.delete(u)}getWebview(u){return this._webviews.get(u)}}e.ExtHostWebviews=d;function s(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=s;function i(o,u,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||a(o,u)}}e.serializeWebviewOptions=i;function r(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(u=>D.URI.from(u))}}e.reviveOptions=r;function a(o,u){return[...(u?.getWorkspaceFolders()||[]).map(h=>h.uri),o.extensionLocation]}}),define(De[263],Ie([1,0,21,78,6,12,22,2,15,68,87,5,7]),function(J,e,l,t,D,P,_,k,w,I,L,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(n,d){this.document=n,this._storagePath=d,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,d){await this.getEdit(n).undo(),d||this.disposeBackup()}async redo(n,d){await this.getEdit(n).redo(),d||this.disposeBackup()}disposeEdits(n){for(const d of n)this._edits.delete(d)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=c(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,n)}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(n){const d=this._edits.get(n,0);if(!d)throw new Error("No edit found");return d}}class E{constructor(){this._documents=new Map}get(n,d){return this._documents.get(this.key(n,d))}add(n,d,s){const i=this.key(n,d.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${n} resource:${d.uri}`);const r=new T(d,s);return this._documents.set(i,r),r}delete(n,d){const s=this.key(n,d.uri);this._documents.delete(s)}key(n,d){return`${n}@@@${d}`}}var p;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(p||(p={}));class b{constructor(){this._providers=new Map}addTextProvider(n,d,s){return this.add(0,n,d,s)}addCustomProvider(n,d,s){return this.add(1,n,d,s)}get(n){return this._providers.get(n)}add(n,d,s,i){if(this._providers.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this._providers.set(d,{type:n,extension:s,provider:i}),new S.Disposable(()=>this._providers.delete(d))}}class f{constructor(n,d,s,i,r){this._extHostDocuments=d,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=r,this._editorProviders=new b,this._documents=new E,this._proxy=n.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,d,s,i){const r=new D.DisposableStore;return v(s)?(r.add(this._editorProviders.addTextProvider(d,n,s)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(n),d,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(n))):(r.add(this._editorProviders.addCustomProvider(d,n,s)),this.supportEditing(s)&&r.add(s.onDidChangeCustomDocument(a=>{const o=this.getCustomDocumentEntry(d,a.document.uri);if(g(a)){const u=o.addEdit(a);this._proxy.$onDidEdit(a.document.uri,d,u,a.label)}else this._proxy.$onContentChange(a.document.uri,d)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(n),d,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(n))),S.Disposable.from(r,new S.Disposable(()=>{this._proxy.$unregisterEditorProvider(d)}))}async $createCustomDocument(n,d,s,i,r){const a=this._editorProviders.get(d);if(!a)throw new Error(`No provider found for '${d}'`);if(a.type!==1)throw new Error(`Invalid provide type for '${d}'`);const o=k.URI.revive(n),u=await a.provider.openCustomDocument(o,{backupId:s,untitledDocumentData:i?.buffer},r);let h;return this.supportEditing(a.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(a.extension)??this._extensionStoragePaths.globalValue(a.extension)),this._documents.add(d,u,h),{editable:this.supportEditing(a.provider)}}async $disposeCustomDocument(n,d){const s=this._editorProviders.get(d);if(!s)throw new Error(`No provider found for '${d}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${d}'`);const i=k.URI.revive(n),{document:r}=this.getCustomDocumentEntry(d,i);this._documents.delete(d,r),r.dispose()}async $resolveWebviewEditor(n,d,s,i,r,a){const o=this._editorProviders.get(s);if(!o)throw new Error(`No provider found for '${s}'`);const u=w.ViewColumn.to(r),h=this._extHostWebview.createNewWebview(d,i.webviewOptions,o.extension),C=this._extHostWebviewPanels.createNewWebviewPanel(d,s,i.title,u,i.panelOptions,h,!0),R=k.URI.revive(n);switch(o.type){case 1:{const{document:N}=this.getCustomDocumentEntry(s,R);return o.provider.resolveCustomEditor(N,C,a)}case 0:{const N=this._extHostDocuments.getDocument(R);return o.provider.resolveCustomTextEditor(N,C,a)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,d,s){this.getCustomDocumentEntry(d,n).disposeEdits(s)}async $onMoveCustomEditor(n,d,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const r=this._extHostWebviewPanels.getWebviewPanel(n);if(!r)throw new Error("No webview found");const a=k.URI.revive(d),o=this._extHostDocuments.getDocument(a);await i.provider.moveCustomTextEditor(o,r,l.CancellationToken.None)}async $undo(n,d,s,i){return this.getCustomDocumentEntry(d,n).undo(s,i)}async $redo(n,d,s,i){return this.getCustomDocumentEntry(d,n).redo(s,i)}async $revert(n,d,s){const i=this.getCustomDocumentEntry(d,n);await this.getCustomEditorProvider(d).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(n,d,s){const i=this.getCustomDocumentEntry(d,n);await this.getCustomEditorProvider(d).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(n,d,s,i){const r=this.getCustomDocumentEntry(d,n);return this.getCustomEditorProvider(d).saveCustomDocumentAs(r.document,k.URI.revive(s),i)}async $backup(n,d,s){const i=this.getCustomDocumentEntry(d,n),a=await this.getCustomEditorProvider(d).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(a),a.id}getCustomDocumentEntry(n,d){const s=this._documents.get(n,k.URI.revive(d));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(n){const s=this._editorProviders.get(n)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(n){return!!n.onDidChangeCustomDocument}}e.ExtHostCustomEditors=f;function v(m){return typeof m.resolveCustomTextEditor=="function"}function g(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function c(m){const n=m.scheme===P.Schemas.file||m.scheme===P.Schemas.untitled?m.fsPath:m.toString();return(0,t.hash)(n)+""}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[264],Ie([1,0,4,6,2,34,15,68,5,7]),function(J,e,l,t,D,P,_,k,w,I){"use strict";var L,y,S,T,E,p,b,f,v,g,c,m,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends t.Disposable{constructor(a,o,u,h){super(),L.set(this,void 0),y.set(this,void 0),S.set(this,void 0),T.set(this,void 0),E.set(this,void 0),p.set(this,void 0),b.set(this,void 0),f.set(this,void 0),v.set(this,!0),g.set(this,void 0),c.set(this,!1),m.set(this,this._register(new l.Emitter)),this.onDidDispose=Ue(this,m,"f").event,n.set(this,this._register(new l.Emitter)),this.onDidChangeViewState=Ue(this,n,"f").event,tt(this,L,a,"f"),tt(this,y,o,"f"),tt(this,T,u,"f"),tt(this,S,h.viewType,"f"),tt(this,E,h.panelOptions,"f"),tt(this,f,h.viewColumn,"f"),tt(this,p,h.title,"f"),tt(this,g,h.active,"f")}dispose(){Ue(this,c,"f")||(tt(this,c,!0,"f"),Ue(this,m,"f").fire(),Ue(this,y,"f").$disposeWebview(Ue(this,L,"f")),Ue(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,T,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,S,"f")}get title(){return this.assertNotDisposed(),Ue(this,p,"f")}set title(a){this.assertNotDisposed(),Ue(this,p,"f")!==a&&(tt(this,p,a,"f"),Ue(this,y,"f").$setTitle(Ue(this,L,"f"),a))}get iconPath(){return this.assertNotDisposed(),Ue(this,b,"f")}set iconPath(a){this.assertNotDisposed(),Ue(this,b,"f")!==a&&(tt(this,b,a,"f"),Ue(this,y,"f").$setIconPath(Ue(this,L,"f"),D.URI.isUri(a)?{light:a,dark:a}:a))}get options(){return Ue(this,E,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,f,"f")=="number"&&Ue(this,f,"f")<0))return Ue(this,f,"f")}get active(){return this.assertNotDisposed(),Ue(this,g,"f")}get visible(){return this.assertNotDisposed(),Ue(this,v,"f")}_updateViewState(a){Ue(this,c,"f")||(this.active!==a.active||this.visible!==a.visible||this.viewColumn!==a.viewColumn)&&(tt(this,g,a.active,"f"),tt(this,v,a.visible,"f"),tt(this,f,a.viewColumn,"f"),Ue(this,n,"f").fire({webviewPanel:this}))}reveal(a,o){this.assertNotDisposed(),Ue(this,y,"f").$reveal(Ue(this,L,"f"),{viewColumn:typeof a>"u"?void 0:_.ViewColumn.from(a),preserveFocus:!!o})}assertNotDisposed(){if(Ue(this,c,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,y=new WeakMap,S=new WeakMap,T=new WeakMap,E=new WeakMap,p=new WeakMap,b=new WeakMap,f=new WeakMap,v=new WeakMap,g=new WeakMap,c=new WeakMap,m=new WeakMap,n=new WeakMap;class s{constructor(a,o,u){this.webviews=o,this.workspace=u,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=a.getProxy(w.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(a,o,u,h,C={}){const R=typeof h=="object"?h.viewColumn:h,N={viewColumn:_.ViewColumn.from(R),preserveFocus:typeof h=="object"&&!!h.preserveFocus},M=(0,k.shouldSerializeBuffersForPostMessage)(a),A=s.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(a),A,o,{title:u,panelOptions:i(C),webviewOptions:(0,k.serializeWebviewOptions)(a,this.workspace,C),serializeBuffersForPostMessage:M},N);const z=this.webviews.createNewWebview(A,C,a);return this.createNewWebviewPanel(A,o,u,R,C,z,!0)}$onDidChangeWebviewPanelViewStates(a){const o=Object.keys(a);o.sort((u,h)=>{const C=a[u],R=a[h];return C.active?1:R.active?-1:+C.visible-+R.visible});for(const u of o){const h=this.getWebviewPanel(u);if(!h)continue;const C=a[u];h._updateViewState({active:C.active,visible:C.visible,viewColumn:_.ViewColumn.to(C.position)})}}async $onDidDisposeWebviewPanel(a){this.getWebviewPanel(a)?.dispose(),this._webviewPanels.delete(a),this.webviews.deleteWebview(a)}registerWebviewPanelSerializer(a,o,u){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:u,extension:a}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(a)}),new I.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(a,o,u,h){const C=this._serializers.get(o);if(!C)throw new Error(`No serializer found for '${o}'`);const{serializer:R,extension:N}=C,M=this.webviews.createNewWebview(a,u.webviewOptions,N),A=this.createNewWebviewPanel(a,o,u.title,h,u.panelOptions,M,u.active);await R.deserializeWebviewPanel(A,u.state)}createNewWebviewPanel(a,o,u,h,C,R,N){const M=new d(a,this._proxy,R,{viewType:o,title:u,viewColumn:h,panelOptions:C,active:N});return this._webviewPanels.set(a,M),M}getWebviewPanel(a){return this._webviewPanels.get(a)}}e.ExtHostWebviewPanels=s;function i(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[265],Ie([1,0,4,6,68,15,5,7]),function(J,e,l,t,D,P,_,k){"use strict";var w,I,L,y,S,T,E,p,b,f,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class g extends t.Disposable{constructor(n,d,s,i,r,a,o){super(),w.set(this,void 0),I.set(this,void 0),L.set(this,void 0),y.set(this,void 0),S.set(this,!1),T.set(this,void 0),E.set(this,void 0),p.set(this,void 0),b.set(this,void 0),f.set(this,this._register(new l.Emitter)),this.onDidChangeVisibility=Ue(this,f,"f").event,v.set(this,this._register(new l.Emitter)),this.onDidDispose=Ue(this,v,"f").event,tt(this,L,s,"f"),tt(this,E,i,"f"),tt(this,w,n,"f"),tt(this,I,d,"f"),tt(this,y,r,"f"),tt(this,T,o,"f")}dispose(){Ue(this,S,"f")||(tt(this,S,!0,"f"),Ue(this,v,"f").fire(),Ue(this,y,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,E,"f")}set title(n){this.assertNotDisposed(),Ue(this,E,"f")!==n&&(tt(this,E,n,"f"),Ue(this,I,"f").$setWebviewViewTitle(Ue(this,w,"f"),n))}get description(){return this.assertNotDisposed(),Ue(this,p,"f")}set description(n){this.assertNotDisposed(),Ue(this,p,"f")!==n&&(tt(this,p,n,"f"),Ue(this,I,"f").$setWebviewViewDescription(Ue(this,w,"f"),n))}get visible(){return Ue(this,T,"f")}get webview(){return Ue(this,y,"f")}get viewType(){return Ue(this,L,"f")}_setVisible(n){n===Ue(this,T,"f")||Ue(this,S,"f")||(tt(this,T,n,"f"),Ue(this,f,"f").fire())}get badge(){return this.assertNotDisposed(),Ue(this,b,"f")}set badge(n){this.assertNotDisposed(),!(n?.value===Ue(this,b,"f")?.value&&n?.tooltip===Ue(this,b,"f")?.tooltip)&&(tt(this,b,P.ViewBadge.from(n),"f"),Ue(this,I,"f").$setWebviewViewBadge(Ue(this,w,"f"),n))}show(n){this.assertNotDisposed(),Ue(this,I,"f").$show(Ue(this,w,"f"),!!n)}assertNotDisposed(){if(Ue(this,S,"f"))throw new Error("Webview is disposed")}}w=new WeakMap,I=new WeakMap,L=new WeakMap,y=new WeakMap,S=new WeakMap,T=new WeakMap,E=new WeakMap,p=new WeakMap,b=new WeakMap,f=new WeakMap,v=new WeakMap;class c{constructor(n,d){this._extHostWebview=d,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=n.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,d,s,i){if(this._viewProviders.has(d))throw new Error(`View provider for '${d}' already registered`);return this._viewProviders.set(d,{provider:s,extension:n}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(n),d,{retainContextWhenHidden:i?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(n)}),new k.Disposable(()=>{this._viewProviders.delete(d),this._proxy.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(n,d,s,i,r){const a=this._viewProviders.get(d);if(!a)throw new Error(`No view provider found for '${d}'`);const{provider:o,extension:u}=a,h=this._extHostWebview.createNewWebview(n,{},u),C=new g(n,this._proxy,d,s,h,u,!0);this._webviewViews.set(n,C),await o.resolveWebviewView(C,{state:i},r)}async $onDidChangeWebviewViewVisibility(n,d){this.getWebviewView(n)._setVisible(d)}async $disposeWebviewView(n){const d=this.getWebviewView(n);this._webviewViews.delete(n),d.dispose(),this._extHostWebview.deleteWebview(n)}getWebviewView(n){const d=this._webviewViews.get(n);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=c}),define(De[139],Ie([1,0,4,5,2,12,8,3,14]),function(J,e,l,t,D,P,_,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class ti{constructor(y){this._onDidChangeWindowState=new l.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ti.InitialState,this._proxy=y.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(S=>this.$onDidChangeWindowFocus(S))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,S){let T;if(typeof y=="string"){T=y;try{y=D.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,_.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,T,S)}async asExternalUri(y,S){if((0,_.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(y,S);return D.URI.from(T)}};I.InitialState={focused:!0},I=qe([xe(0,w.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(De[266],Ie([1,0,114,267,61,37,2,13,45]),function(J,e,l,t,D,P,_,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(S,T,E){this._commands=S,this.logService=T,this._ipcHandlePath=E,this._server=t.createServer((p,b)=>this.onRequest(p,b)),this.setup().catch(p=>(T.error(p),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",S=>this.logService.error(S))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(S,T){const E=(b,f)=>{T.writeHead(b,{"content-type":"application/json"}),T.end(JSON.stringify(f||null),v=>v&&this.logService.error(v))},p=[];S.setEncoding("utf8"),S.on("data",b=>p.push(b)),S.on("end",async()=>{try{const b=JSON.parse(p.join(""));let f;switch(b.type){case"open":f=await this.open(b);break;case"openExternal":f=await this.openExternal(b);break;case"status":f=await this.getStatus(b);break;case"extensionManagement":f=await this.manageExtensions(b);break;default:E(404,`Unknown message type: ${b.type}`);break}E(200,f)}catch(b){const f=b instanceof Error?b.message:JSON.stringify(b);E(500,f),this.logService.error("Error while processing pipe request",b)}})}async open(S){const{fileURIs:T,folderURIs:E,forceNewWindow:p,diffMode:b,mergeMode:f,addMode:v,forceReuseWindow:g,gotoLineMode:c,waitMarkerFilePath:m,remoteAuthority:n}=S,d=[];if(Array.isArray(E))for(const a of E)try{d.push({folderUri:_.URI.parse(a)})}catch{}if(Array.isArray(T))for(const a of T)try{(0,w.hasWorkspaceFileExtension)(a)?d.push({workspaceUri:_.URI.parse(a)}):d.push({fileUri:_.URI.parse(a)})}catch{}const s=m?_.URI.file(m):void 0,r={forceNewWindow:p,diffMode:b,mergeMode:f,addMode:v,gotoLineMode:c,forceReuseWindow:g,preferNewWindow:!g&&!s&&!v,waitMarkerFileURI:s,remoteAuthority:n};return this._commands.executeCommand("_remoteCLI.windowOpen",d,r),""}async openExternal(S){for(const T of S.uris){const E=_.URI.parse(T),p=E.scheme==="file"?E:T;await this._commands.executeCommand("_remoteCLI.openExternal",p)}}async manageExtensions(S){const T=p=>p?.map(b=>/\.vsix$/i.test(b)?_.URI.parse(b):b),E={list:S.list,install:T(S.install),uninstall:T(S.uninstall),force:S.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",E)}async getStatus(S){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let L=class extends I{constructor(S,T){super(S,T,(0,l.createRandomIPCHandle)())}};L=qe([xe(0,P.IExtHostCommands),xe(1,k.ILogService)],L),e.CLIServer=L}),define(De[268],Ie([1,0,240,26,14]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const P=1024*1024;let _=class extends l.AbstractExtHostConsoleForwarder{constructor(w,I){super(w,I),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(w,I,L){const y=w==="error"||w==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,y.write(`
START_NATIVE_LOG
`),I.apply(console,L),y.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(w,I){const L=process[w],y=L.write;let S="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(T,E,p)=>{if(!this._isMakingConsoleCall){S+=T.toString(E);const b=S.length>P?S.length:S.lastIndexOf(`
`);b!==-1&&(console[I](S.slice(0,b)),S=S.slice(b+1))}y.call(L,T,E,p)}})}};_=qe([xe(0,D.IExtHostRpcService),xe(1,t.IExtHostInitDataService)],_),e.ExtHostConsoleForwarder=_}),define(De[269],Ie([1,0,9,81,34,37,6,5,2,14]),function(J,e,l,t,D,P,_,k,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends _.Disposable{constructor(S,T){super();const E=S.getProxy(k.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async p=>{const b=w.URI.file((0,l.join)((0,t.tmpdir)(),(0,D.generateUuid)()));return await E.$download(p,b),b})}};L=qe([xe(0,I.IExtHostRpcService),xe(1,P.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(De[270],Ie([1,0,137,12,194,34]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class _ extends l.ExtHostLoggerService{doCreateLogger(w,I,L){return w.scheme===t.Schemas.file?new D.SpdLogLogger(L?.name||(0,P.generateUuid)(),w.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,I):super.doCreateLogger(w,I,L)}}e.ExtHostLoggerService=_}),define(De[271],Ie([1,0,61,9,2,67,6,12,18,29]),function(J,e,l,t,D,P,_,k,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends P.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(n){const d=await super._getWorkspaceStorageURI(n);if(d.scheme!==k.Schemas.file)return d;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${d.fsPath}.`),d;const s=d.fsPath;let i=0;do{let r;i===0?r=s:r=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${i}`:`${s}-${i}`,await y(r);const a=t.join(r,"vscode.lock"),o=await p(this._logService,a,!1);if(o)return this._workspaceStorageLock=o,process.on("exit",()=>{o.dispose()}),D.URI.file(r);i++}while(i<10);return d}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function y(m){try{await I.Promises.stat(m);return}catch{}try{await I.Promises.mkdir(m,{recursive:!0})}catch{}}const S=1e3,T=10*60*1e3;class E extends _.Disposable{constructor(n,d){super(),this.logService=n,this.filename=d,this._timer=this._register(new w.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await b(n,d);(!s||s.pid!==process.pid)&&(n.info(`Lock '${d}': The lock was lost unexpectedly.`),this._timer.cancel());try{await I.Promises.utimes(d,new Date,new Date)}catch(i){n.error(i),n.info(`Lock '${d}': Could not update mtime.`)}},S)}dispose(){super.dispose();try{l.unlinkSync(this.filename)}catch{}}async setWillRelease(n){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const d={pid:process.pid,willReleaseAt:Date.now()+n};await I.Promises.writeFile(this.filename,JSON.stringify(d),{flag:"w"})}catch(d){this.logService.error(d)}}}async function p(m,n,d){try{const i={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(n,JSON.stringify(i),{flag:"wx"})}catch(i){m.error(i)}const s=await b(m,n);return!s||s.pid!==process.pid?d?(m.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),g(m,n)):(m.info(`Lock '${n}': Lock acquired.`),new E(m,n))}async function b(m,n){let d;try{d=await I.Promises.readFile(n)}catch(s){return m.error(s),null}try{return JSON.parse(String(d))}catch(s){return m.error(s),null}}async function f(m,n){let d;try{d=await I.Promises.stat(n)}catch(s){return m.error(s),0}return d.mtime.getTime()}function v(m){try{return process.kill(m,0),!0}catch{return!1}}async function g(m,n){const d=await b(m,n);if(!d)return m.info(`Lock '${n}': Could not read pid of lock holder.`),c(m,n);if(d.willReleaseAt){let o=d.willReleaseAt-Date.now();if(o<5e3){for(o>0?m.info(`Lock '${n}': The lockfile is scheduled to be released in ${o} ms.`):m.info(`Lock '${n}': The lockfile is scheduled to have been released.`);o>0;){if(await(0,w.timeout)(Math.min(100,o)),await f(m,n)===0)return c(m,n);o=d.willReleaseAt-Date.now()}return c(m,n)}}if(!v(d.pid))return m.info(`Lock '${n}': The pid ${d.pid} appears to be gone.`),c(m,n);const s=await f(m,n),i=Date.now()-s;if(i<=T)return m.info(`Lock '${n}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;m.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,w.timeout)(2e3);const r=await f(m,n),a=Date.now()-r;return a<=T?(m.info(`Lock '${n}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null):(m.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),c(m,n))}async function c(m,n){m.info(`Lock '${n}': Deleting a stale lock.`);try{await I.Promises.unlink(n)}catch{}return p(m,n,!0)}}),define(De[272],Ie([1,0,34,14,38]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let P=class extends D.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,w,I){return this.createTerminalFromOptions({name:k,shellPath:w,shellArgs:I})}createTerminalFromOptions(k,w){const I=new D.ExtHostTerminal(this._proxy,(0,l.generateUuid)(),k,k.name);return this._terminals.push(I),I.create(k,this._serializeParentTerminal(k,w)),I.value}};P=qe([xe(0,t.IExtHostRpcService)],P),e.ExtHostTerminalService=P}),define(De[273],Ie([1,0,5,14,178,6,26,2,44,22,29,7,11,53,4,125,96,13]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class v extends p.DisposableTunnel{}function g(o){const u=o.trim().split(`
`),h=[];return u.forEach(R=>{const N=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);N&&N.length>=3&&h.push({pid:parseInt(N[1],10),socket:parseInt(N[2],10)})}),h.reduce((R,N)=>(R[N.socket]=N,R),{})}e.getSockets=g;function c(...o){const u=[].concat(...o.map(n));return[...new Map(u.filter(h=>h.st==="0A").map(h=>{const C=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:m(C[0]),port:parseInt(C[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=c;function m(o){let u="";if(o.length===8)for(let h=o.length-2;h>=0;h-=2)u+=parseInt(o.substr(h,2),16),h!==0&&(u+=".");else for(let h=o.length-4;h>=0;h-=4)u+=parseInt(o.substr(h,4),16).toString(16),h!==0&&(u+=":");return u}e.parseIpAddress=m;function n(o){const u=o.trim().split(`
`),h=u.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return u.map(R=>R.trim().split(/\s+/).reduce((N,M,A)=>(N[h[A]||A]=M,N),{}))}e.loadConnectionTable=n;function d(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/server-main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function s(o){const u=o.trim().split(`
`),h=[];return u.forEach(C=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(C);R&&R.length>=4&&h.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),h}e.getRootProcesses=s;async function i(o,u,h){const C=h.reduce((N,M)=>(N[M.pid]=M,N),{}),R=[];return o.forEach(({socket:N,ip:M,port:A})=>{const z=u[N]?u[N].pid:void 0,H=z?C[z]?.cmd:void 0;z&&H&&!d(H)&&R.push({host:M,port:A,detail:H,pid:z})}),R}e.findPorts=i;function r(o,u,h){const C=new Map,R=s(u);for(const N of o){const M=h.get(N.port);if(M){C.set(N.port,M);continue}const A=R.find(z=>z.cmd.includes(`${N.port}`));if(A){let z=A,H;do H=R.find(F=>F.ppid===z.pid),H&&(z=H);while(H);C.set(N.port,{host:N.ip,port:N.port,pid:z.pid,detail:z.cmd,ppid:z.ppid})}else C.set(N.port,{host:N.ip,port:N.port,ppid:Number.MAX_VALUE})}return C}e.tryFindRootPorts=r;let a=class extends P.Disposable{constructor(u,h,C){super(),this.logService=C,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new E.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=u.getProxy(l.MainContext.MainThreadTunnelService),S.isLinux&&h.remote.isRemote&&h.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(u,h){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${u.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const C=await this._proxy.$openTunnel(h,u.displayName);if(C){const R=new v(C.remoteAddress,C.localAddress,()=>this._proxy.$closeTunnel(C.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(u){return Math.max(u*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(u,h){const C=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(C,{selector:u,provider:h}),this._proxy.$registerPortsAttributesProvider(u,C),new y.Disposable(()=>{this._portAttributesProviders.delete(C),this._proxy.$unregisterPortsAttributesProvider(C)})}async $providePortAttributes(u,h,C,R,N){const M=[];for(const z of u){const H=this._portAttributesProviders.get(z);if(!H)return[];M.push(...await Promise.all(h.map(async F=>H.provider.providePortAttributes(F,C,R,N))))}const A=M.filter(z=>!!z);return A.length>0?A.map(z=>({autoForwardAction:z.autoForwardAction,port:z.port})):[]}async $registerCandidateFinder(u){if(u&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=u;const h=new b.MovingAverage;let C;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),N=(await this.findCandidatePorts()).filter(A=>(0,p.isLocalhost)(A.host)||(0,p.isAllInterfaces)(A.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${N.map(A=>A.port).join(", ")}`);const M=new Date().getTime()-R;h.update(M),(!C||JSON.stringify(C)!==JSON.stringify(N))&&(C=N,await this._proxy.$onFoundNewCandidates(C)),await new Promise(A=>setTimeout(()=>A(),this.calculateDelay(h.value)))}}async setTunnelFactory(u){if(u){if(u.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(u.candidatePortSource),u.showCandidatePort&&(this._showCandidatePort=u.showCandidatePort,this._proxy.$setCandidateFilter()),u.tunnelFactory){this._forwardPortProvider=u.tunnelFactory;let h=u.tunnelFeatures?.privacyOptions??[];u.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:D.localize(0,null),themeIcon:"lock"},{id:"public",label:D.localize(1,null),themeIcon:"eye"}]);const C=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,public:!!u.tunnelFeatures?.public,privacyOptions:h}:void 0;this._proxy.$setTunnelProvider(C)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(u,h){if(this._extensionTunnels.has(u.host)){const C=this._extensionTunnels.get(u.host);C.has(u.port)&&(h&&C.get(u.port).disposeListener.dispose(),await C.get(u.port).tunnel.dispose(),C.delete(u.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(u,h){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const C=this._forwardPortProvider(u,h);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),C!==void 0){const R=await C;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(u.remoteAddress.host)||this._extensionTunnels.set(u.remoteAddress.host,new Map);const N=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(u.remoteAddress.host).set(u.remoteAddress.port,{tunnel:R,disposeListener:N}),T.TunnelDtoConverter.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(u){const h=await Promise.all(u.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),C=u.filter((R,N)=>h[N]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${u.map(R=>R.port).join(", ")} to ${C.map(R=>R.port).join(", ")}`),C}async findCandidatePorts(){let u="",h="";try{u=await L.Promises.readFile("/proc/net/tcp","utf8"),h=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const C=c(u,h),R=await new Promise(B=>{(0,w.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(U,X,$)=>{B(X)})}),N=g(R),M=await L.Promises.readdir("/proc"),A=[];for(const B of M)try{const U=Number(B),X=I.joinPath(k.URI.file("/proc"),B);if((await L.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(U)){const x=await L.Promises.readlink(I.joinPath(X,"cwd").fsPath),Q=await L.Promises.readFile(I.joinPath(X,"cmdline").fsPath,"utf8");A.push({pid:U,cwd:x,cmd:Q})}}catch{}const z=[],H=C.filter(B=>{const U=N[B.socket];return U||z.push(B),U}),F=i(H,N,A);let G;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${z.length}`),z.length>0){const B=await new Promise(U=>{(0,w.exec)("ps -F -A -l | grep root",(X,$,x)=>{U($)})});this._foundRootPorts=r(z,B,this._foundRootPorts),G=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${G.join(", ")}`)}return F.then(B=>G?B.concat(G):B)}};a=qe([xe(0,t.IExtHostRpcService),xe(1,_.IExtHostInitDataService),xe(2,f.ILogService)],a),e.ExtHostTunnelService=a}),define(De[274],Ie([1,0,18,23,21,10,4,6,109,234,55]),function(J,e,l,t,D,P,_,k,w,I,L){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function S(C,R){try{return JSON.stringify(C,R)}catch{return"null"}}const T="$$ref$$",E={[T]:-1};class p{constructor(R,N){this.jsonString=R,this.referencedBuffers=N}}function b(C,R=null,N=!1){const M=[];return{jsonString:(N?S:JSON.stringify)(C,(z,H)=>{if(typeof H>"u")return E;if(typeof H=="object"){if(H instanceof t.VSBuffer){const F=M.push(H)-1;return{[T]:F}}if(R)return R(z,H)}return H}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=b;function f(C,R,N){return JSON.parse(C,(M,A)=>{if(A){const z=A[T];if(typeof z=="number")return R[z];if(N&&A.$mid===1)return N.transformIncoming(A)}return A})}e.parseJsonAndRestoreBufferRefs=f;function v(C,R){return JSON.stringify(C,R)}function g(C){return C?(R,N)=>N&&N.$mid===1?C.transformOutgoing(N):N:null}var c;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(C){C[C.Responsive=0]="Responsive",C[C.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},d=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class i extends k.Disposable{constructor(R,N=null,M=null){super(),this[y]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=N,this._uriTransformer=M,this._uriReplacer=g(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,z=L.ProxyIdentifier.count;A<z;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new l.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,w.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:N,sid:M}=R;return this._proxies[N]||(this._proxies[N]=this._createProxy(N,M)),this._proxies[N]}_createProxy(R,N){const M={get:(A,z)=>(typeof z=="string"&&!A[z]&&z.charCodeAt(0)===36&&(A[z]=(...H)=>this._remoteCall(R,z,H)),z===s?N:A[z])};return new Proxy(Object.create(null),M)}set(R,N){return this._locals[R.nid]=N,N}assertRegistered(R){for(let N=0,M=R.length;N<M;N++){const A=R[N];if(!this._locals[A.nid])throw new Error(`Missing proxy instance ${A.sid}`)}}_receiveOneMessage(R){if(this._isDisposed)return;const N=R.byteLength,M=r.read(R,0),A=M.readUInt8(),z=M.readUInt32();switch(A){case 1:case 2:{let{rpcId:H,method:F,args:G}=o.deserializeRequestJSONArgs(M);this._uriTransformer&&(G=(0,w.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(N,z,H,F,G,A===2);break}case 3:case 4:{let{rpcId:H,method:F,args:G}=o.deserializeRequestMixedArgs(M);this._uriTransformer&&(G=(0,w.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(N,z,H,F,G,A===4);break}case 5:{this._logger?.logIncoming(N,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(N,z);break}case 7:{this._receiveReply(N,z,void 0);break}case 9:{let H=o.deserializeReplyOKJSON(M);this._uriTransformer&&(H=(0,w.transformIncomingURIs)(H,this._uriTransformer)),this._receiveReply(N,z,H);break}case 10:{const H=o.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(N,z,H);break}case 8:{const H=o.deserializeReplyOKVSBuffer(M);this._receiveReply(N,z,H);break}case 11:{let H=o.deserializeReplyErrError(M);this._uriTransformer&&(H=(0,w.transformIncomingURIs)(H,this._uriTransformer)),this._receiveReplyErr(N,z,H);break}case 12:{this._receiveReplyErr(N,z,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,N,M,A,z,H){this._logger?.logIncoming(R,N,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(M)}.${A}(`,z);const F=String(N);let G,B;if(H){const X=new D.CancellationTokenSource;z.push(X.token),G=this._invokeHandler(M,A,z),B=()=>X.cancel()}else G=this._invokeHandler(M,A,z),B=n;this._cancelInvokedHandlers[F]=B;const U=o.serializeAcknowledged(N);this._logger?.logOutgoing(U.byteLength,N,1,"ack"),this._protocol.send(U),G.then(X=>{delete this._cancelInvokedHandlers[F];const $=o.serializeReplyOK(N,X,this._uriReplacer);this._logger?.logOutgoing($.byteLength,N,1,"reply:",X),this._protocol.send($)},X=>{delete this._cancelInvokedHandlers[F];const $=o.serializeReplyErr(N,X);this._logger?.logOutgoing($.byteLength,N,1,"replyErr:",X),this._protocol.send($)})}_receiveCancel(R,N){this._logger?.logIncoming(R,N,1,"receiveCancel");const M=String(N);this._cancelInvokedHandlers[M]?.()}_receiveReply(R,N,M){this._logger?.logIncoming(R,N,0,"receiveReply:",M);const A=String(N);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const z=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],z.resolveOk(M)}_receiveReplyErr(R,N,M){this._logger?.logIncoming(R,N,0,"receiveReplyErr:",M);const A=String(N);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const z=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let H;M&&(M.$isError?(H=new Error,H.name=M.name,H.message=M.message,H.stack=M.stack):H=M),z.resolveErr(H)}_invokeHandler(R,N,M){try{return Promise.resolve(this._doInvokeHandler(R,N,M))}catch(A){return Promise.reject(A)}}_doInvokeHandler(R,N,M){const A=this._locals[R];if(!A)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(R));const z=A[N];if(typeof z!="function")throw new Error("Unknown method "+N+" on actor "+(0,L.getStringIdentifierForProxy)(R));return z.apply(A,M)}_remoteCall(R,N,M){if(this._isDisposed)return new I.CanceledLazyPromise;let A=null;if(M.length>0&&D.CancellationToken.isCancellationToken(M[M.length-1])&&(A=M.pop()),A&&A.isCancellationRequested)return Promise.reject(P.canceled());const z=o.serializeRequestArguments(M,this._uriReplacer),H=++this._lastMessageId,F=String(H),G=new I.LazyPromise;A&&A.onCancellationRequested(()=>{const U=o.serializeCancel(H);this._logger?.logOutgoing(U.byteLength,H,0,"cancel"),this._protocol.send(o.serializeCancel(H))}),this._pendingRPCReplies[F]=G,this._onWillSendRequest(H);const B=o.serializeRequest(H,R,N,z,!!A);return this._logger?.logOutgoing(B.byteLength,H,0,`request: ${(0,L.getStringIdentifierForProxy)(R)}.${N}(`,M),this._protocol.send(B),G}}e.RPCProtocol=i,y=d,i.UNRESPONSIVE_TIME=3*1e3;class r{constructor(R,N){this._buff=R,this._offset=N}static alloc(R,N,M){const A=new r(t.VSBuffer.alloc(M+1+4),0);return A.writeUInt8(R),A.writeUInt32(N),A}static read(R,N){return new r(R,N)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,M}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,M}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,N}static sizeMixedArray(R){let N=0;N+=1;for(let M=0,A=R.length;M<A;M++){const z=R[M];switch(N+=1,z.type){case 1:N+=this.sizeLongString(z.value);break;case 2:N+=this.sizeVSBuffer(z.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(z.value);for(let H=0;H<z.buffers.length;++H)N+=this.sizeVSBuffer(z.buffers[H]);break;case 4:break}}return N}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let N=0,M=R.length;N<M;N++){const A=R[N];switch(A.type){case 1:this.writeUInt8(1),this.writeLongString(A.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A.value);break;case 3:this.writeUInt8(3),this.writeUInt32(A.buffers.length),this.writeLongString(A.value);for(let z=0;z<A.buffers.length;++z)this.writeBuffer(A.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const N=new Array(R);for(let M=0;M<R;M++)switch(this.readUInt8()){case 1:N[M]=this.readLongString();break;case 2:N[M]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),H=this.readLongString(),F=[];for(let G=0;G<z;++G)F.push(this.readVSBuffer());N[M]=new L.SerializableObjectWithBuffers(f(H,F,null));break}case 4:N[M]=void 0;break}return N}}r.sizeUInt32=4;var a;(function(C){C[C.Simple=0]="Simple",C[C.Mixed=1]="Mixed"})(a||(a={}));class o{static _useMixedArgSerialization(R){for(let N=0,M=R.length;N<M;N++)if(R[N]instanceof t.VSBuffer||R[N]instanceof L.SerializableObjectWithBuffers||typeof R[N]>"u")return!0;return!1}static serializeRequestArguments(R,N){if(this._useMixedArgSerialization(R)){const M=[];for(let A=0,z=R.length;A<z;A++){const H=R[A];if(H instanceof t.VSBuffer)M[A]={type:2,value:H};else if(typeof H>"u")M[A]={type:4};else if(H instanceof L.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:G}=b(H.value,N);M[A]={type:3,value:t.VSBuffer.fromString(F),buffers:G}}else M[A]={type:1,value:t.VSBuffer.fromString(v(H,N))}}return{type:1,args:M}}return{type:0,args:v(R,N)}}static serializeRequest(R,N,M,A,z){switch(A.type){case 0:return this._requestJSONArgs(R,N,M,A.args,z);case 1:return this._requestMixedArgs(R,N,M,A.args,z)}}static _requestJSONArgs(R,N,M,A,z){const H=t.VSBuffer.fromString(M),F=t.VSBuffer.fromString(A);let G=0;G+=r.sizeUInt8(),G+=r.sizeShortString(H),G+=r.sizeLongString(F);const B=r.alloc(z?2:1,R,G);return B.writeUInt8(N),B.writeShortString(H),B.writeLongString(F),B.buffer}static deserializeRequestJSONArgs(R){const N=R.readUInt8(),M=R.readShortString(),A=R.readLongString();return{rpcId:N,method:M,args:JSON.parse(A)}}static _requestMixedArgs(R,N,M,A,z){const H=t.VSBuffer.fromString(M);let F=0;F+=r.sizeUInt8(),F+=r.sizeShortString(H),F+=r.sizeMixedArray(A);const G=r.alloc(z?4:3,R,F);return G.writeUInt8(N),G.writeShortString(H),G.writeMixedArray(A),G.buffer}static deserializeRequestMixedArgs(R){const N=R.readUInt8(),M=R.readShortString(),A=R.readMixedArray(),z=new Array(A.length);for(let H=0,F=A.length;H<F;H++){const G=A[H];typeof G=="string"?z[H]=JSON.parse(G):z[H]=G}return{rpcId:N,method:M,args:z}}static serializeAcknowledged(R){return r.alloc(5,R,0).buffer}static serializeCancel(R){return r.alloc(6,R,0).buffer}static serializeReplyOK(R,N,M){if(typeof N>"u")return this._serializeReplyOKEmpty(R);if(N instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(R,N);if(N instanceof L.SerializableObjectWithBuffers){const{jsonString:A,referencedBuffers:z}=b(N.value,M,!0);return this._serializeReplyOKJSONWithBuffers(R,A,z)}else return this._serializeReplyOKJSON(R,S(N,M))}static _serializeReplyOKEmpty(R){return r.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,N){let M=0;M+=r.sizeVSBuffer(N);const A=r.alloc(8,R,M);return A.writeVSBuffer(N),A.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,N){const M=t.VSBuffer.fromString(N);let A=0;A+=r.sizeLongString(M);const z=r.alloc(9,R,A);return z.writeLongString(M),z.buffer}static _serializeReplyOKJSONWithBuffers(R,N,M){const A=t.VSBuffer.fromString(N);let z=0;z+=r.sizeUInt32,z+=r.sizeLongString(A);for(const F of M)z+=r.sizeVSBuffer(F);const H=r.alloc(10,R,z);H.writeUInt32(M.length),H.writeLongString(A);for(const F of M)H.writeBuffer(F);return H.buffer}static deserializeReplyOKJSON(R){const N=R.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(R,N){const M=R.readUInt32(),A=R.readLongString(),z=[];for(let H=0;H<M;++H)z.push(R.readVSBuffer());return new L.SerializableObjectWithBuffers(f(A,z,N))}static serializeReplyErr(R,N){const M=N?S(P.transformErrorForSerialization(N),null):void 0;if(typeof M!="string")return this._serializeReplyErrEmpty(R);const A=t.VSBuffer.fromString(M);let z=0;z+=r.sizeLongString(A);const H=r.alloc(11,R,z);return H.writeLongString(A),H.buffer}static deserializeReplyErrError(R){const N=R.readLongString();return JSON.parse(N)}static _serializeReplyErrEmpty(R){return r.alloc(12,R,0).buffer}}var u;(function(C){C[C.RequestJSONArgs=1]="RequestJSONArgs",C[C.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",C[C.RequestMixedArgs=3]="RequestMixedArgs",C[C.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",C[C.Acknowledged=5]="Acknowledged",C[C.Cancel=6]="Cancel",C[C.ReplyOKEmpty=7]="ReplyOKEmpty",C[C.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",C[C.ReplyOKJSON=9]="ReplyOKJSON",C[C.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",C[C.ReplyErrError=11]="ReplyErrError",C[C.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var h;(function(C){C[C.String=1]="String",C[C.VSBuffer=2]="VSBuffer",C[C.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",C[C.Undefined=4]="Undefined"})(h||(h={}))}),define(De[275],Ie([1,0,4,43,52,3,42,10,18]),function(J,e,l,t,D,P,_,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.channels=new Map,this._onDidRegisterChannel=new l.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new l.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(E){this.channels.has(E.id)||(this.channels.set(E.id,E),this._onDidRegisterChannel.fire(E.id))}getChannels(){const E=[];return this.channels.forEach(p=>E.push(p)),E}getChannel(E){return this.channels.get(E)}removeChannel(E){this.channels.delete(E),this._onDidRemoveChannel.fire(E)}}t.Registry.add(e.Extensions.OutputChannels,new L);function y(T,E,p,b,f){return(0,w.createCancelablePromise)(async v=>{await(0,_.whenProviderRegistered)(p,b);const g=t.Registry.as(e.Extensions.OutputChannels);try{await S(p,1,b,f,v),g.registerChannel({id:T,label:E,file:p,log:!0})}catch(c){(0,k.isCancellationError)(c)||f.error("Error while registering log channel",p.toString(),(0,k.getErrorMessage)(c))}})}e.registerLogChannel=y;async function S(T,E,p,b,f){if(!await p.exists(T)){if(f.isCancellationRequested)throw new k.CancellationError;if(E>10)throw new Error("Timed out while waiting for file to be created");b.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,w.timeout)(1e3,f),await S(T,E+1,p,b,f)}}}),define(De[140],Ie([1,0,5,6,3,14,13,275,66,26,46,153,23,16]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class E extends t.Disposable{constructor(f,v,g,c){super(),this.id=f,this.name=v,this.logger=g,this.proxy=c,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(f){this.append(f+`
`)}append(f){this.write(f),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const f=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,f)}replace(f){const v=this.offset;this.write(f),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,v),this.visible&&this.logger.flush()}show(f,v){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof f=="boolean"?f:v))}hide(){this.proxy.$close(this.id)}write(f){this.offset+=S.VSBuffer.fromString(f).byteLength,this.logger.info(f)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=E;let p=class{constructor(f,v,g,c,m){this.extHostFileSystem=g,this.extHostFileSystemInfo=c,this.loggerService=m,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=f.getProxy(l.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(v.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(f){this.visibleChannelId=f;for(const[v,g]of this.channels)g.visible=v===this.visibleChannelId}createOutputChannel(f,v,g){if(f=f.trim(),!f)throw new Error("illegal argument `name`. must not be falsy");if((0,T.isString)(v)&&!v.trim())throw new Error("illegal argument `languageId`. must not be empty");const c=this.doCreateOutputChannel(f,v,g);return c.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),this.createExtHostOutputChannel(f,c)}async doCreateOutputChannel(f,v,g){const c=await this.createOutputDirectory(),m=this.extHostFileSystemInfo.extUri.joinPath(c,`${this.namePool++}-${f.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),n=this.loggerService.createLogger(m,{always:!0,donotRotate:!0,donotUseFormatters:!0}),d=await this.proxy.$register(f,!1,m,v,g.identifier.value);return new E(d,f,n,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(f,v){let g=!1;const c=()=>{if(g)throw new Error("Channel has been closed")};return{get name(){return f},append(m){c(),v.then(n=>n.append(m))},appendLine(m){c(),v.then(n=>n.appendLine(m))},clear(){c(),v.then(m=>m.clear())},replace(m){c(),v.then(n=>n.replace(m))},show(m,n){c(),v.then(d=>d.show(m,n))},hide(){c(),v.then(m=>m.hide())},dispose(){g=!0,v.then(m=>m.dispose())}}}};p=qe([xe(0,P.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,w.IExtHostConsumerFileSystem),xe(3,L.IExtHostFileSystemInfo),xe(4,_.ILoggerService)],p),e.ExtHostOutputService=p,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(De[276],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,l.createDecorator)("remoteAgentService")}),define(De[277],Ie([1,0,31,12,9,11,22,2,3,203,45,220,276]),function(J,e,l,t,D,P,_,k,w,I,L,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,w.createDecorator)("pathService");let T=class ni{constructor(p,b,f,v){this.localUserHome=p,this.remoteAgentService=b,this.environmentService=f,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const g=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=g?.userHome??p})()}hasValidBasename(p,b,f){return typeof b=="string"||typeof b>"u"?this.resolveOS.then(v=>this.doHasValidBasename(p,v,b)):this.doHasValidBasename(p,b,f)}doHasValidBasename(p,b,f){return p.scheme===t.Schemas.file||p.scheme===t.Schemas.vscodeRemote?(0,l.isValidBasename)(f??(0,_.basename)(p),b===1):!0}get defaultUriScheme(){return ni.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(p,b){if(p.remoteAuthority)return t.Schemas.vscodeRemote;const f=(0,I.getVirtualWorkspaceScheme)(b.getWorkspace());if(f)return f;const v=b.getWorkspace().folders[0];if(v)return v.uri.scheme;const g=b.getWorkspace().configuration;return g?g.scheme:t.Schemas.file}userHome(p){return p?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(p=>p===1?D.win32:D.posix)}async fileURI(p){let b="";if(await this.resolveOS===1&&(p=p.replace(/\\/g,"/")),p[0]==="/"&&p[1]==="/"){const v=p.indexOf("/",2);v===-1?(b=p.substring(2),p="/"):(b=p.substring(2,v),p=p.substring(v)||"/")}return k.URI.from({scheme:t.Schemas.file,authority:b,path:p,query:"",fragment:""})}};T=qe([xe(1,S.IRemoteAgentService),xe(2,y.IWorkbenchEnvironmentService),xe(3,L.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(De[69],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class l{constructor(_,k){this.line=_,this.character=k}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,k){return new l(0,0)}with(_){return new l(0,0)}}e.Position=l;class t{constructor(_,k,w,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(_,k),this.end=new l(w,I)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new t(0,0,0,0)}with(_){return new t(0,0,0,0)}}e.Range=t;var D;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[30],Ie([1,0,17,36,24,31,8,3,9,10,69,18]),function(J,e,l,t,D,P,_,k,w,I,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const S="\u27EA ",T=" characters skipped \u27EB",E=(S.length+T.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var p;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(p=e.SearchProviderType||(e.SearchProviderType={}));var b;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(b=e.QueryType||(e.QueryType={}));function f(x){return!!x.preview}e.resultIsMatch=f;function v(x){return!!x.resource}e.isFileMatch=v;function g(x){return!!x.message}e.isProgressMessage=g;var c;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(Q){this.resource=Q,this.results=[]}}e.FileMatch=m;class n{constructor(Q,de,te){this.ranges=de;const pe=Array.isArray(de)?de:[de];if(te&&te.matchLines===1&&d(pe)){Q=(0,_.getNLines)(Q,te.matchLines);let Y="",ve=0,be=0;const ke=Math.floor(te.charsPerLine/5),Re=[];for(const We of pe){const oe=Math.max(We.startColumn-ke,0),le=We.startColumn+te.charsPerLine;if(oe>be+ke+E){const fe=S+(oe-be)+T;Y+=fe+Q.slice(oe,le),ve+=oe-(be+fe.length)}else Y+=Q.slice(be,le);Re.push(new i(0,We.startColumn-ve,We.endColumn-ve)),be=le}this.preview={text:Y,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const Y=Array.isArray(de)?de[0].startLineNumber:de.startLineNumber;this.preview={text:Q,matches:(0,l.mapArrayOrNot)(de,ve=>new s(ve.startLineNumber-Y,ve.startColumn,ve.endLineNumber-Y,ve.endColumn))}}}}e.TextSearchMatch=n;function d(x){const Q=x[0].startLineNumber;for(const de of x)if(de.startLineNumber!==Q||de.endLineNumber!==Q)return!1;return!0}class s{constructor(Q,de,te,pe){this.startLineNumber=Q,this.startColumn=de,this.endLineNumber=te,this.endColumn=pe}}e.SearchRange=s;class i extends s{constructor(Q,de,te){super(Q,de,Q,te)}}e.OneLineRange=i;var r;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function a(x,Q=!0){const de=x&&x.files&&x.files.exclude,te=Q&&x&&x.search&&x.search.exclude;if(!de&&!te)return;if(!de||!te)return de||te;let pe=Object.create(null);return pe=D.mixin(pe,D.deepClone(de)),pe=D.mixin(pe,D.deepClone(te),!0),pe}e.getExcludes=a;function o(x,Q){return x.excludePattern&&t.match(x.excludePattern,Q)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&t.match(x.includePattern,Q)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(de=>{const te=de.folder.fsPath;if(P.isEqualOrParent(Q,te)){const pe=w.relative(te,Q);return!de.includePattern||!!t.match(de.includePattern,pe)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var u;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(u=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(Q,de){super(Q),this.code=de}}e.SearchError=h;function C(x){const Q=x.message;if((0,I.isCancellationError)(x))return new h(Q,u.canceled);try{const de=JSON.parse(Q);return new h(de.message,de.code)}catch{return new h(Q,u.other)}}e.deserializeSearchError=C;function R(x){const Q={message:x.message,code:x.code};return new Error(JSON.stringify(Q))}e.serializeSearchError=R;function N(x){return x.type==="error"?!0:x.type==="success"}e.isSerializedSearchComplete=N;function M(x){return x.type==="success"}e.isSerializedSearchSuccess=M;function A(x){return!!x.path}e.isSerializedFileMatch=A;function z(x,Q){const de=x.searchPath?x.searchPath:x.relativePath;return(0,_.fuzzyContains)(de,Q)}e.isFilePatternMatch=z;class H{constructor(Q){this.path=Q,this.results=[]}addMatch(Q){this.results.push(Q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=H;function F(x,Q){const de={...x||{},...Q||{}};return Object.keys(de).filter(te=>{const pe=de[te];return typeof pe=="boolean"&&pe})}e.resolvePatternsForProvider=F;class G{constructor(Q,de){this._parsedIncludeExpression=null,this._excludeExpression={...Q.excludePattern||{},...de.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let te=Q.includePattern;de.includePattern&&(te?te={...te,...de.includePattern}:te=de.includePattern),te&&(this._parsedIncludeExpression=t.parse(te))}matchesExcludesSync(Q,de,te){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Q,de,te))}includedInQuerySync(Q,de,te){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Q,de,te)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Q,de,te))}includedInQuery(Q,de,te){const pe=this._parsedExcludeExpression(Q,de,te),Y=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(Q,de,te):!0;return(0,y.isThenable)(pe)?pe.then(ve=>ve?!1:Y()):Y()}hasSiblingExcludeClauses(){return B(this._excludeExpression)}}e.QueryGlobTester=G;function B(x){for(const Q in x)if(typeof x[Q]!="boolean")return!0;return!1}function U(x){if(!x)return;let Q;return de=>(Q||(Q=(x()||Promise.resolve([])).then(te=>te?$(te):{})),Q.then(te=>!!te[de]))}e.hasSiblingPromiseFn=U;function X(x){if(!x)return;let Q;return de=>{if(!Q){const te=x();Q=te?$(te):{}}return!!Q[de]}}e.hasSiblingFn=X;function $(x){const Q={};for(const de of x)Q[de]=!0;return Q}}),define(De[32],Ie([1,0,17,18,21,4,6,25,12,96,22,8,16,2,176,3,13,195,45,46,26,14,15,7,54,30,5]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f,v,g,c,m,n,d,s,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(A,z,H){return new L.ExtUri(F=>C(F,H)).isEqual(A,z)}function o(A,z,H){return a(A.uri,z.uri,H)?0:(0,y.compare)(A.uri.toString(),z.uri.toString())}function u(A,z,H){return A.index!==z.index?A.index<z.index?-1:1:a(A.uri,z.uri,H)?(0,y.compare)(A.name,z.name):(0,y.compare)(A.uri.toString(),z.uri.toString())}function h(A,z,H,F){const G=A.slice(0).sort((U,X)=>H(U,X,F)),B=z.slice(0).sort((U,X)=>H(U,X,F));return(0,l.delta)(G,B,(U,X)=>H(U,X,F))}function C(A,z){const H=z.getCapabilities(A.scheme);return!(H&&H&1024)}class R extends v.Workspace{constructor(z,H,F,G,B,U,X){super(z,F.map($=>new v.WorkspaceFolder($)),G,B,X),this._name=H,this._isUntitled=U,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(X),F.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(z,H,F,G){if(!z)return{workspace:null,added:[],removed:[]};const{id:B,name:U,folders:X,configuration:$,transient:x,isUntitled:Q}=z,de=[],te=H;H?X.forEach((be,ke)=>{const Re=T.URI.revive(be.uri),We=R._findFolder(F||H,Re,G);We?(We.name=be.name,We.index=be.index,de.push(We)):de.push({uri:Re,name:be.name,index:ke})}):de.push(...X.map(({uri:be,name:ke,index:Re})=>({uri:T.URI.revive(be),name:ke,index:Re}))),de.sort((be,ke)=>be.index<ke.index?-1:1);const pe=new R(B,U,de,!!x,$?T.URI.revive($):null,!!Q,be=>C(be,G)),{added:Y,removed:ve}=h(te?te.workspaceFolders:[],pe.workspaceFolders,o,G);return{workspace:pe,added:Y,removed:ve}}static _findFolder(z,H,F){for(let G=0;G<z.folders.length;G++){const B=z.workspaceFolders[G];if(a(B.uri,H,F))return B}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(z,H){return H&&this._structure.get(z)&&(z=(0,L.dirname)(z)),this._structure.findSubstr(z)}resolveWorkspaceFolder(z){return this._structure.get(z)}}let N=class{constructor(z,H,F,G,B){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=G,this._extHostFileSystemInfo=F,this._uriTransformerService=B,this._requestIdProvider=new I.Counter,this._barrier=new t.Barrier,this._proxy=z.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=z.getProxy(r.MainContext.MainThreadMessageService);const U=H.workspace;this._confirmedWorkspace=U?new R(U.id,U.name,[],!!U.transient,U.configuration?T.URI.revive(U.configuration):null,!!U.isUntitled,X=>C(X,F)):void 0}$initializeWorkspace(z,H){this._trusted=H,this.$acceptWorkspaceData(z),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?T.URI.from({scheme:w.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(z,H,F,...G){const B=[];if(Array.isArray(G)&&G.forEach(Q=>{T.URI.isUri(Q.uri)&&!B.some(de=>a(de.uri,Q.uri,this._extHostFileSystemInfo))&&B.push({uri:Q.uri,name:Q.name||(0,L.basenameOrAuthority)(Q.uri)})}),this._unconfirmedWorkspace||[H,F].some(Q=>typeof Q!="number"||Q<0)||F===0&&B.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(H+F>U.length)return!1;const X=U.slice(0);X.splice(H,F,...B.map(Q=>({uri:Q.uri,name:Q.name||(0,L.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<X.length;Q++){const de=X[Q];if(X.some((te,pe)=>pe!==Q&&a(de.uri,te.uri,this._extHostFileSystemInfo)))return!1}X.forEach((Q,de)=>Q.index=de);const{added:$,removed:x}=h(U,X,u,this._extHostFileSystemInfo);if($.length===0&&x.length===0)return!1;if(this._proxy){const Q=z.displayName||z.name;this._proxy.$updateWorkspaceFolders(Q,H,F,B).then(void 0,de=>{this._unconfirmedWorkspace=void 0;const te={source:{identifier:z.identifier,label:z.displayName||z.name}};this._messageService.$showMessage(f.Severity.Error,(0,E.localize)(0,null,Q,de.toString()),te,[])})}return this.trySetWorkspaceFolders(X),!0}getWorkspaceFolder(z,H){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,H)}async getWorkspaceFolder2(z,H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,H)}async resolveWorkspaceFolder(z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(z)}getPath(){if(!this._actualWorkspace)return;const{folders:z}=this._actualWorkspace;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,H){let F,G="";if(typeof z=="string"?(F=T.URI.file(z),G=z):typeof z<"u"&&(F=z,G=z.fsPath),!F)return G;const B=this.getWorkspaceFolder(F,!0);if(!B)return G;typeof H>"u"&&this._actualWorkspace&&(H=this._actualWorkspace.folders.length>1);let U=(0,L.relativePath)(B.uri,F);return H&&B.name&&(U=`${B.name}/${U}`),U}trySetWorkspaceFolders(z){this._actualWorkspace&&(this._unconfirmedWorkspace=R.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:z,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:H,added:F,removed:G}=R.toExtHostWorkspace(z,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=H||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:F,removed:G}))}findFiles(z,H,F,G,B=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let U;if(H===null?U=!1:H&&(typeof H=="string"?U=H:U=H.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:$}=M(n.GlobPattern.from(z));return this._proxy.$startFileSearch((0,S.withUndefinedAsNull)(X),(0,S.withUndefinedAsNull)($),(0,S.withUndefinedAsNull)(U),(0,S.withUndefinedAsNull)(F),B).then(x=>Array.isArray(x)?x.map(Q=>T.URI.revive(Q)):[])}async findTextInFiles(z,H,F,G,B=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),X=typeof H.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:H.previewOptions,{includePattern:$,folder:x}=M(n.GlobPattern.from(H.include)),Q=typeof H.exclude=="string"?H.exclude:H.exclude?H.exclude.pattern:void 0,de={ignoreSymlinks:typeof H.followSymlinks=="boolean"?!H.followSymlinks:void 0,disregardIgnoreFiles:typeof H.useIgnoreFiles=="boolean"?!H.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof H.useGlobalIgnoreFiles=="boolean"?!H.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof H.useParentIgnoreFiles=="boolean"?!H.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof H.useDefaultExcludes=="boolean"?!H.useDefaultExcludes:!0,fileEncoding:H.encoding,maxResults:H.maxResults,previewOptions:X,afterContext:H.afterContext,beforeContext:H.beforeContext,includePattern:$,excludePattern:Q},te=!1;if(this._activeSearchCallbacks[U]=pe=>{if(te)return;const Y=T.URI.revive(pe.resource);pe.results.forEach(ve=>{(0,i.resultIsMatch)(ve)?F({uri:Y,preview:{text:ve.preview.text,matches:(0,l.mapArrayOrNot)(ve.preview.matches,be=>new d.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,l.mapArrayOrNot)(ve.ranges,be=>new d.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):F({uri:Y,text:ve.text,lineNumber:ve.lineNumber})})},B.isCancellationRequested)return{};try{const pe=await this._proxy.$startTextSearch(z,(0,S.withUndefinedAsNull)(x),de,U,B);return delete this._activeSearchCallbacks[U],pe||{}}catch(pe){throw delete this._activeSearchCallbacks[U],pe}}$handleTextSearchResult(z,H){this._activeSearchCallbacks[H]?.(z)}saveAll(z){return this._proxy.$saveAll(z)}resolveProxy(z){return this._proxy.$resolveProxy(z)}get trusted(){return this._trusted}requestWorkspaceTrust(z){return this._proxy.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(z,H){if(this._editSessionIdentityProviders.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this._editSessionIdentityProviders.set(z,H);const F=this._uriTransformerService.transformOutgoingScheme(z),G=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(G,F),(0,_.toDisposable)(()=>{this._editSessionIdentityProviders.delete(z),this._proxy.$unregisterEditSessionIdentityProvider(G)})}async $getEditSessionIdentifier(z,H){this._logService.info("Getting edit session identifier for workspaceFolder",z);const F=await this.resolveWorkspaceFolder(T.URI.revive(z));if(!F){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const G=this._editSessionIdentityProviders.get(F.uri.scheme);if(this._logService.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!G),!G)return;const B=await G.provideEditSessionIdentity(F,H);if(this._logService.info("Provider returned edit session identifier: ",B),!!B)return B}};N=qe([xe(0,m.IExtHostRpcService),xe(1,c.IExtHostInitDataService),xe(2,g.IExtHostFileSystemInfo),xe(3,b.ILogService),xe(4,s.IURITransformerService)],N),e.ExtHostWorkspace=N,e.IExtHostWorkspace=(0,p.createDecorator)("IExtHostWorkspace");function M(A){let z,H;return A&&(typeof A=="string"?z=A:(z=A.pattern,H=T.URI.revive(A.baseUri))),{includePattern:z,folder:H}}}),define(De[33],Ie([1,0,24,4,32,5,7,198,122,16,18,3,14,13,2]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function p(d,s){if(s){const i=s.split(".");let r=d;for(let a=0;r&&a<i.length;a++)r=r[i[a]];return r}}function b(d){return d instanceof E.URI}function f(d){return d&&d.uri instanceof E.URI&&d.languageId&&typeof d.languageId=="string"}function v(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function g(d){return d&&d.uri instanceof E.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function c(d){if(b(d))return{resource:d};if(f(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(v(d))return{overrideIdentifier:d.languageId};if(g(d))return{resource:d.uri};if(d===null)return{resource:null}}let m=class{constructor(s,i,r){this._proxy=s.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=r,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new n(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(s,i))}};m=qe([xe(0,S.IExtHostRpcService),xe(1,D.IExtHostWorkspace),xe(2,T.ILogService)],m),e.ExtHostConfiguration=m;class n{constructor(s,i,r,a){this._onDidChangeConfiguration=new t.Emitter,this._proxy=s,this._logService=a,this._extHostWorkspace=i,this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,r))}getConfiguration(s,i,r){const a=c(i)||{},o=this._toReadonlyValue(s?p(this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,a,r?.identifier);function u(C){if(C==null)return null;if(typeof C=="boolean")return C?2:5;switch(C){case _.ConfigurationTarget.Global:return 2;case _.ConfigurationTarget.Workspace:return 5;case _.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(C){return typeof p(o,C)<"u"},get:(C,R)=>{this._validateConfigurationAccess(s?`${s}.${C}`:C,a,r?.identifier);let N=p(o,C);if(typeof N>"u")N=R;else{let M;const A=(z,H)=>{let F;const G=()=>{M=M||(0,l.deepClone)(o),F=F||p(M,H)};return(0,I.isObject)(z)?new Proxy(z,{get:(B,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return G(),()=>F;if(M)return F=F||p(M,H),F[U];const X=B[U];return typeof U=="string"?A(X,`${H}.${U}`):X},set:(B,U,X)=>(G(),F&&(F[U]=X),!0),deleteProperty:(B,U)=>(G(),F&&delete F[U],!0),defineProperty:(B,U,X)=>(G(),F&&Object.defineProperty(F,U,X),!0)}):z};N=A(N,C)}return N},update:(C,R,N,M)=>{C=s?`${s}.${C}`:C;const A=u(N);return R!==void 0?this._proxy.$updateConfigurationOption(A,C,R,a,M):this._proxy.$removeConfigurationOption(A,C,a,M)},inspect:C=>{C=s?`${s}.${C}`:C;const R=(0,l.deepClone)(this._configuration.inspect(C,a,this._extHostWorkspace.workspace));if(R)return{key:C,defaultValue:R.policy?.value??R.default?.value,globalValue:R.user?.value??R.application?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override??R.application?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof o=="object"&&(0,l.mixin)(h,o,!1),Object.freeze(h)}_toReadonlyValue(s){const i=r=>(0,I.isObject)(r)?new Proxy(r,{get:(a,o)=>i(a[o]),set:(a,o,u)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(a,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(a,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:a=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return i(s)}_validateConfigurationAccess(s,i,r){const a=w.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),o=r?`[${r.value}] `:"";if(a===4){typeof i?.resource>"u"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(a===3){i?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const r=new k.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(a,o)=>r.affectsConfiguration(a,c(o))})}_toMap(s){return s.reduce((i,r)=>(i.set(r[0],r[1]),i),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[70],Ie([1,0,2,18,4,5,7,32,56,33,21,38,14,26,3,12,11,13,65,233,10]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f,v,g,c){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var n;(function(H){function F(B){if(B!=null)return B}H.from=F;function G(B){if(B!=null)return B}H.to=G})(n=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var d;(function(H){function F(B){if(B!=null)return B}H.from=F;function G(B){if(B!=null)return B}H.to=G})(d=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(H){function F(B){if(B!=null)return B}H.from=F;function G(B){if(B!=null)return B}H.to=G})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(H){function F(U){if(U){const X=U;return X&&!!X.process}else return!1}H.is=F;function G(U){if(U==null)return;const X={process:U.process,args:U.args};return U.options&&(X.options=s.from(U.options)),X}H.from=G;function B(U){if(U!=null)return new _.ProcessExecution(U.process,U.args,U.options)}H.to=B})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(H){function F(B){if(B!=null)return B}H.from=F;function G(B){if(B!=null)return B}H.to=G})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var a;(function(H){function F(U){if(U){const X=U;return X&&(!!X.commandLine||!!X.command)}else return!1}H.is=F;function G(U){if(U==null)return;const X={};return U.commandLine!==void 0?X.commandLine=U.commandLine:(X.command=U.command,X.args=U.args),U.options&&(X.options=r.from(U.options)),X}H.from=G;function B(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new _.ShellExecution(U.commandLine,U.options):new _.ShellExecution(U.command,U.args?U.args:[],U.options)}H.to=B})(a=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(H){function F(U){if(U){const X=U;return X&&X.customExecution==="customExecution"}else return!1}H.is=F;function G(U){return{customExecution:"customExecution"}}H.from=G;function B(U,X){return X.get(U)}H.to=B})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var u;(function(H){function F(G,B){let U;return G.scope!==void 0&&typeof G.scope!="number"?U=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===_.TaskScope.Workspace&&B&&B.workspaceFile?U=B.workspaceFile:U=g.USER_TASKS_GROUP_KEY),{id:G._id,workspaceFolder:U}}H.from=F})(u=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(H){function F(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}H.from=F})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var C;(function(H){function F(U,X){if(U==null)return[];const $=[];for(const x of U){const Q=G(x,X);Q&&$.push(Q)}return $}H.fromMany=F;function G(U,X){if(U==null)return;let $;U.execution instanceof _.ProcessExecution?$=i.from(U.execution):U.execution instanceof _.ShellExecution?$=a.from(U.execution):U.execution&&U.execution instanceof _.CustomExecution&&($=o.from(U.execution));const x=n.from(U.definition);let Q;return U.scope?typeof U.scope=="number"?Q=U.scope:Q=U.scope.uri:Q=_.TaskScope.Workspace,!x||!Q?void 0:{_id:U._id,definition:x,name:U.name,source:{extensionId:X.identifier.value,label:U.source,scope:Q},execution:$,isBackground:U.isBackground,group:h.from(U.group),presentationOptions:d.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}H.from=G;async function B(U,X,$){if(U==null)return;let x;i.is(U.execution)?x=i.to(U.execution):a.is(U.execution)?x=a.to(U.execution):o.is(U.execution)&&(x=o.to(U._id,$));const Q=n.to(U.definition);let de;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?de=U.source.scope:de=await X.resolveWorkspaceFolder(l.URI.revive(U.source.scope)):de=_.TaskScope.Workspace),!Q||!de)return;const te=new _.Task(Q,de,U.name,U.source.label,x,U.problemMatchers);return U.isBackground!==void 0&&(te.isBackground=U.isBackground),U.group!==void 0&&(te.group=_.TaskGroup.from(U.group._id),te.group&&U.group.isDefault&&(te.group=new _.TaskGroup(te.group.id,te.group.label),U.group.isDefault===!0&&(te.group.isDefault=U.group.isDefault))),U.presentationOptions&&(te.presentationOptions=d.to(U.presentationOptions)),U._id&&(te._id=U._id),U.detail&&(te.detail=U.detail),te}H.to=B})(C=e.TaskDTO||(e.TaskDTO={}));var R;(function(H){function F(B){return B}H.from=F;function G(B){if(!!B)return Object.assign(Object.create(null),B)}H.to=G})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class N{constructor(F,G,B){this._id=G,this._task=B,m.set(this,void 0),tt(this,m,F,"f")}get task(){return this._task}terminate(){Ue(this,m,"f").terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}m=new WeakMap;var M;(function(H){function F(G){return{id:G._id,task:void 0}}H.from=F})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let A=class{constructor(F,G,B,U,X,$,x,Q){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=F.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=U,this._configurationService=X,this._terminalService=$,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=x,this._deprecationService=Q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(F,G,B){if(!B)return new _.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:G,provider:B,extension:F}),this._proxy.$registerTaskProvider(U,G),new _.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(F,G){this._proxy.$registerTaskSystem(F,G)}fetchTasks(F){return this._proxy.$fetchTasks(R.from(F)).then(async G=>{const B=[];for(const U of G){const X=await C.to(U,this._workspaceProvider,this._providedCustomExecutions2);X&&B.push(X)}return B})}get taskExecutions(){const F=[];return this._taskExecutions.forEach(G=>F.push(G)),F}terminateTask(F){if(!(F instanceof N))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(F._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(F,G,B){const U=this._providedCustomExecutions2.get(F.id);U&&(this._activeCustomExecutions2.set(F.id,U),this._terminalService.attachPtyToTerminal(G,await U.callback(B))),this._lastStartedTask=F.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(F)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(F){const G=await this.getTaskExecution(F);this._taskExecutionPromises.delete(F.id),this._taskExecutions.delete(F.id),this.customExecutionComplete(F),this._onDidTerminateTask.fire({execution:G})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(F){const G=await this.getTaskExecution(F.id);this._onDidTaskProcessStarted.fire({execution:G,processId:F.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(F){const G=await this.getTaskExecution(F.id);this._onDidTaskProcessEnded.fire({execution:G,exitCode:F.exitCode})}$provideTasks(F,G){const B=this._handlers.get(F);if(!B)return Promise.reject(new Error("no handler found"));const U=[],X=(0,t.asPromise)(()=>B.provider.provideTasks(L.CancellationToken.None)).then($=>this.provideTasksInternal(G,U,B,$));return new Promise($=>{X.then(x=>{Promise.all(U).then(()=>{$(x)})})})}async $resolveTask(F,G){const B=this._handlers.get(F);if(!B)return Promise.reject(new Error("no handler found"));if(G.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${B.type}].`);const U=await C.to(G,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const X=await B.provider.resolveTask(U,L.CancellationToken.None);if(!X)return;this.checkDeprecation(X,B);const $=C.from(X,B.extension);if(!$)throw new Error("Unexpected: Task cannot be resolved.");if(X.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is($.execution)&&await this.addCustomExecution($,X,!0),await this.resolveTaskInternal($)}nextHandle(){return this._handleCounter++}async addCustomExecution(F,G,B){const U=await this._proxy.$createTaskId(F);!B&&!this._providedCustomExecutions2.has(U)&&(this._notProvidedCustomExecutions.add(U),this._activeCustomExecutions2.set(U,G.execution)),this._providedCustomExecutions2.set(U,G.execution)}async getTaskExecution(F,G){if(typeof F=="string"){const X=this._taskExecutionPromises.get(F);if(!X)throw new Error("Unexpected: The specified task is missing an execution");return X}const B=this._taskExecutionPromises.get(F.id);if(B)return B;const U=new Promise((X,$)=>{function x(Q,de,te){te?X(new N(Q,de.id,te)):$("Unexpected: Task does not exist.")}G?x(this,F,G):C.to(F.task,this._workspaceProvider,this._providedCustomExecutions2).then(Q=>x(this,F,Q))});return this._taskExecutionPromises.set(F.id,U),U.then(X=>(this._taskExecutions.set(F.id,X),X),X=>Promise.reject(X))}checkDeprecation(F,G){F._deprecated&&this._deprecationService.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(F){this._activeCustomExecutions2.get(F.id)&&this._activeCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.has(F.id)&&this._lastStartedTask!==F.id&&(this._providedCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.delete(F.id));const B=this._notProvidedCustomExecutions.values();let U=B.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=B.next()}};A=qe([xe(0,S.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,k.IExtHostWorkspace),xe(3,w.IExtHostDocumentsAndEditors),xe(4,I.IExtHostConfiguration),xe(5,y.IExtHostTerminalService),xe(6,f.ILogService),xe(7,v.IExtHostApiDeprecationService)],A),e.ExtHostTaskBase=A;let z=class extends A{constructor(F,G,B,U,X,$,x,Q){super(F,G,B,U,X,$,x,Q),this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(F,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const B=C.from(G,F);if(B===void 0)throw new Error("Task is not valid");if(o.is(B.execution))await this.addCustomExecution(B,G,!1);else throw new c.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),G);return this._proxy.$executeTask(B).catch(X=>{throw new Error(X)}),U}provideTasksInternal(F,G,B,U){const X=[];if(U)for(const $ of U){this.checkDeprecation($,B),(!$.definition||!F[$.definition.type])&&this._logService.warn(`The task [${$.source}, ${$.name}] uses an undefined task type. The task will be ignored in the future.`);const x=C.from($,B.extension);x&&o.is(x.execution)?(X.push(x),G.push(this.addCustomExecution(x,$,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:X,extension:B.extension}}async resolveTaskInternal(F){if(o.is(F.execution))return F;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(F,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,G,B){}};z=qe([xe(0,S.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,k.IExtHostWorkspace),xe(3,w.IExtHostDocumentsAndEditors),xe(4,I.IExtHostConfiguration),xe(5,y.IExtHostTerminalService),xe(6,f.ILogService),xe(7,v.IExtHostApiDeprecationService)],z),e.WorkerExtHostTask=z,e.IExtHostTask=(0,E.createDecorator)("IExtHostTask")}),define(De[278],Ie([1,0,9,21,50,36,22,51,30]),function(J,e,l,t,D,P,_,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(S,T,E){this.config=S,this.provider=T,this.sessionToken=E,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=S.filePattern,this.includePattern=S.includePattern&&P.parse(S.includePattern),this.maxResults=S.maxResults||void 0,this.exists=S.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=S.excludePattern&&P.parse(S.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(S=>S.cancel()),this.activeCancellationTokens=new Set}search(S){const T=this.config.folderQueries||[];return new Promise((E,p)=>{const b=f=>{this.resultCount++,S(f)};if(this.isCanceled)return E({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(f=>{const v=f.toString(),g=l.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,g)||this.matchFile(b,{base:f,basename:g})}),Promise.all(T.map(f=>this.searchInFolder(f,b))).then(f=>{E({limitHit:this.isLimitHit,stats:f[0]||void 0})},f=>{p(new Error((0,D.toErrorMessage)(f)))})})}async searchInFolder(S,T){const E=new t.CancellationTokenSource,p=this.getSearchOptionsForFolder(S),b=this.initDirectoryTree(),f=new w.QueryGlobTester(this.config,S),v=!f.hasSiblingExcludeClauses();let g;try{this.activeCancellationTokens.add(E),g=k.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},p,E.token),m=g.elapsed(),n=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(d=>{const s=l.posix.relative(S.folder.path,d.path);if(v){const i=l.basename(d.path);this.matchFile(T,{base:S.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(b,S.folder,s,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(b,f,T),{providerTime:m,postProcessTime:n.elapsed()})}finally{E.dispose(),this.activeCancellationTokens.delete(E)}}getSearchOptionsForFolder(S){const T=(0,w.resolvePatternsForProvider)(this.config.includePattern,S.includePattern),E=(0,w.resolvePatternsForProvider)(this.config.excludePattern,S.excludePattern);return{folder:S.folder,excludes:E,includes:T,useIgnoreFiles:!S.disregardIgnoreFiles,useGlobalIgnoreFiles:!S.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!S.disregardParentIgnoreFiles,followSymlinks:!S.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const S={rootEntries:[],pathToEntries:Object.create(null)};return S.pathToEntries["."]=S.rootEntries,S}addDirectoryEntries({pathToEntries:S},T,E,p){if(E===this.filePattern){const f=l.basename(this.filePattern);this.matchFile(p,{base:T,relativePath:this.filePattern,basename:f})}function b(f){const v=l.basename(f),g=l.dirname(f);let c=S[g];c||(c=S[g]=[],b(g)),c.push({base:T,relativePath:f,basename:v})}b(E)}matchDirectoryTree({rootEntries:S,pathToEntries:T},E,p){const b=this,f=this.filePattern;function v(g){const c=(0,w.hasSiblingFn)(()=>g.map(m=>m.basename));for(let m=0,n=g.length;m<n;m++){const d=g[m],{relativePath:s,basename:i}=d;if(E.matchesExcludesSync(s,i,f!==i?c:void 0))continue;const r=T[s];if(r)v(r);else{if(s===f)continue;b.matchFile(p,d)}if(b.isLimitHit)break}}v(S)}matchFile(S,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||S(T))}}class L{constructor(){this.sessions=new Map}fileSearch(S,T,E,p){const b=this.getSessionTokenSource(S.cacheKey),f=new I(S,T,b&&b.token);let v=0;const g=c=>{v+=c.length,E(c.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(f,L.BATCH_SIZE,g,p).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:c.stats}}))}clearCache(S){this.getSessionTokenSource(S)?.cancel()}getSessionTokenSource(S){if(!!S)return this.sessions.has(S)||this.sessions.set(S,new t.CancellationTokenSource),this.sessions.get(S)}rawMatchToSearchItem(S){return S.relativePath?{resource:_.joinPath(S.base,S.relativePath)}:{resource:S.base}}doSearch(S,T,E,p){p.onCancellationRequested(()=>{S.cancel()});const b=v=>{v&&(f.push(v),T>0&&f.length>=T&&(E(f),f=[]))};let f=[];return S.search(b).then(v=>(f.length&&E(f),v),v=>(f.length&&E(f),Promise.reject(v)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(De[279],Ie([1,0,17,75,36,108,25,12,9,22,8,16,2,160,187,83,13,45,130,277,30]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f,v,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(h,C,R,N,M){this.configurationService=h,this.workspaceContextService=C,this.editorGroupsService=R,this.logService=N,this.pathService=M}text(h,C,R={}){h=this.getContentPattern(h,R);const N=this.configurationService.getValue(),M=C&&C.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(C?.map(f.toWorkspaceFolder),R),type:2,contentPattern:h,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:N.search.usePCRE2||M||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}getContentPattern(h,C){const R=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const N={...h,wordSeparators:R.editor.wordSeparators};return this.isCaseSensitive(h,C)&&(N.isCaseSensitive=!0),this.isMultiline(h)&&(N.isMultiline=!0),N}file(h,C={}){return{...this.commonQuery(h,C),type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey}}handleIncludeExclude(h,C){return h?(h=Array.isArray(h)?h.map(r):r(h),C?this.parseSearchPaths(h):{pattern:d(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],C={}){const R=this.handleIncludeExclude(C.includePattern,C.expandPatterns),N=this.handleIncludeExclude(C.excludePattern,C.expandPatterns),M=h.length>1,A=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(F=>this.getFolderQueryForSearchPath(F,C,N)):h.map(F=>this.getFolderQueryForRoot(F,C,N,M))).filter(F=>!!F),z={_reason:C._reason,folderQueries:A,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:N.pattern,includePattern:R.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const F=l.coalesce(l.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(X=>X.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const G=F.filter(U=>(0,c.pathIncludedInQuery)(z,U.fsPath)),B=this.commonQueryFromFileList(G);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...z,...B}}const H=C.extraFileResources&&C.extraFileResources.filter(F=>(0,c.pathIncludedInQuery)(z,F.fsPath));return z.extraFileResources=H&&H.length?H:void 0,z}commonQueryFromFileList(h){const C=[],R=new _.ResourceMap,N={};let M=!1;return h.forEach(A=>{if(A.scheme===k.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(A)){const H=this.workspaceContextService.getWorkspaceFolder(A)?.uri??A.with({path:w.dirname(A.fsPath)});let F=R.get(H);F||(M=!0,F={folder:H,includePattern:{}},C.push(F),R.set(H,F));const G=w.relative(H.fsPath,A.fsPath);(0,y.assertIsDefined)(F.includePattern)[G.replace(/\\/g,"/")]=!0}else A.fsPath&&(M=!0,N[A.fsPath]=!0)}),{folderQueries:C,includePattern:N,usingSearchPaths:!0,excludePattern:M?void 0:{"**/*":!0}}}isCaseSensitive(h,C){if(C.isSmartCase){if(h.isRegExp){if(L.containsUppercaseCharacter(h.pattern,!0))return!0}else if(L.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,T.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const C=B=>w.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),N=(Array.isArray(h)?h:s(h)).map(B=>{const U=this.pathService.resolvedUserHome;return U?(0,P.untildify)(B,U.scheme===k.Schemas.file?U.fsPath:U.path):B}),M=t.groupBy(N,B=>C(B)?"searchPaths":"exprSegments"),A=(M.exprSegments||[]).map(B=>L.rtrim(B,"/")).map(B=>L.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),i(B))),z={},H=this.expandSearchPathPatterns(M.searchPaths||[]);H&&H.length&&(z.searchPaths=H);const F=l.flatten(A),G=d(...F);return G&&(z.pattern=G),z}getExcludesForFolder(h,C){return C.disregardExcludeSettings?void 0:(0,c.getExcludes)(h,!C.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const C=l.flatten(h.map(N=>{let{pathPortion:M,globPortion:A}=n(N);A&&(A=a(A));const z=this.expandOneSearchPath(M);return l.flatten(z.map(H=>this.resolveOneSearchPathPattern(H,A)))})),R=new Map;return C.forEach(N=>{const M=N.searchPath.toString(),A=R.get(M);A?N.pattern&&(A.pattern=A.pattern||{},A.pattern[N.pattern]=!0):R.set(M,{searchPath:N.searchPath,pattern:N.pattern?d(N.pattern):void 0})}),Array.from(R.values())}expandOneSearchPath(h){if(w.isAbsolute(h)){const C=this.workspaceContextService.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==k.Schemas.file?[{searchPath:C[0].uri.with({path:h})}]:[{searchPath:S.URI.file(w.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const C=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=r(h),h.startsWith("../")||h===".."){const N=w.posix.resolve(C.path,h);return[{searchPath:C.with({path:N})}]}const R=a(h);return[{searchPath:C,pattern:R}]}else{if(h==="./"||h===".\\")return[];{const C=h.replace(/^\.[\/\\]/,""),N=this.workspaceContextService.getWorkspace().folders.map(M=>{const A=C.match(new RegExp(`^${L.escapeRegExpCharacters(M.name)}(?:/(.*)|$)`));return A?{match:A,folder:M}:null}).filter(y.isDefined);if(N.length)return N.map(M=>{const A=M.match[1];return{searchPath:M.folder.uri,pattern:A&&a(A)}});{const M=h.match(/\.[\/\\](.+)[\/\\]?/),A=M?M[1]:h,z=E.localize(0,null,A);throw new Error(z)}}}}resolveOneSearchPathPattern(h,C){const R=h.pattern&&C?`${h.pattern}/${C}`:h.pattern||C,N=[{searchPath:h.searchPath,pattern:R}];return R&&!R.endsWith("**")&&N.push({searchPath:h.searchPath,pattern:R+"/**"}),N}getFolderQueryForSearchPath(h,C,R){const N=this.getFolderQueryForRoot((0,f.toWorkspaceFolder)(h.searchPath),C,R,!1);return N?{...N,includePattern:h.pattern}:null}getFolderQueryForRoot(h,C,R,N){let M;const A=S.URI.isUri(h)?h:h.uri;if(R.searchPaths){const B=R.searchPaths.filter(U=>(0,I.isEqual)(U.searchPath,A))[0];if(B&&!B.pattern)return null;B&&(M=B.pattern)}const z=this.configurationService.getValue({resource:A}),F={...this.getExcludesForFolder(z,C)||{},...M||{}},G=S.URI.isUri(h)?(0,I.basename)(h):h.name;return{folder:A,folderName:N?G:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof C.disregardParentIgnoreFiles=="boolean"?C.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!z.search.followSymlinks}}};m=qe([xe(0,p.IConfigurationService),xe(1,f.IWorkspaceContextService),xe(2,v.IEditorGroupsService),xe(3,b.ILogService),xe(4,g.IPathService)],m),e.QueryBuilder=m;function n(u){const h=u.match(/[\*\{\}\(\)\[\]\?]/);if(h){const C=h.index,R=u.substr(0,C).match(/[/|\\][^/\\]*$/);if(R){let N=u.substr(0,R.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:u.substr((R.index||0)+1)}}}return{pathPortion:u}}function d(...u){return u.length?u.reduce((h,C)=>(h[C]=!0,h),Object.create(null)):void 0}function s(u){return D.splitGlobAware(u,",").map(h=>h.trim()).filter(h=>!!h.length)}function i(u){return[`**/${u}/**`,`**/${u}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function r(u){return u.replace(/\\/g,"/")}function a(u){return r(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(u,h){u=l.distinct(u,N=>N.toString());const C=[],R=h.getWorkspace();return u&&u.forEach(N=>{let M;if(h.getWorkbenchState()===2)M=(0,I.relativePath)(R.folders[0].uri,N),M&&M!=="."&&(M="./"+M);else{const A=h.getWorkspaceFolder(N);if(A){const z=A.name;if(R.folders.filter(F=>F.name===z).length===1){const F=(0,I.relativePath)(A.uri,N);F===""?M=`./${A.name}`:M=`./${A.name}/${F}`}else M=N.fsPath}}M&&C.push(M)}),C}e.resolveResourcesForSearchIncludes=o}),define(De[280],Ie([1,0,22,2,21,10,3,279,30,45]),function(J,e,l,t,D,P,_,k,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function y(p,b){const f=b.activationEvents;if(!f)return Promise.resolve(void 0);const v=[],g=[];for(const i of f)if(/^workspaceContains:/.test(i)){const r=i.substr(18);r.indexOf("*")>=0||r.indexOf("?")>=0||p.forceUsingSearch?g.push(r):v.push(r)}if(v.length===0&&g.length===0)return Promise.resolve(void 0);let c;const m=new Promise((i,r)=>{c=i}),n=i=>c({activationEvent:i}),d=Promise.all(v.map(i=>S(p,i,n))).then(()=>{}),s=T(p,b.identifier,g,n);return Promise.all([d,s]).then(()=>{c(void 0)}),m}e.checkActivateWorkspaceContainsExtension=y;async function S(p,b,f){for(const v of p.folders)if(await p.exists(l.joinPath(t.URI.revive(v),b))){f(`workspaceContains:${b}`);return}}async function T(p,b,f,v){if(f.length===0)return Promise.resolve(void 0);const g=new D.CancellationTokenSource,c=p.checkExists(p.folders,f,g.token),m=setTimeout(async()=>{g.cancel(),p.logService.info(`Not activating extension '${b.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},L);let n=!1;try{n=await c}catch(d){P.isCancellationError(d)||P.onUnexpectedError(d)}g.dispose(),clearTimeout(m),n&&v(`workspaceContains:${f.join(",")}`)}function E(p,b,f,v){const g=p.get(_.IInstantiationService),c=p.get(w.ISearchService),n=g.createInstance(k.QueryBuilder).file(b.map(d=>(0,I.toWorkspaceFolder)(t.URI.revive(d))),{_reason:"checkExists",includePattern:f,exists:!0});return c.fileSearch(n,v).then(d=>!!d.limitHit,d=>P.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=E});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[39],Ie([1,0,171,9,71,22,18,6,25,2,13,5,33,223,93,32,27,221,10,28,23,204,7,123,3,26,67,14,85,53,38,4,280,92,206,12,91]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f,v,g,c,m,n,d,s,i,r,a,o,u,h,C,R,N,M,A,z){"use strict";var H,F,G;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let B=class Ln extends k.Disposable{constructor(te,pe,Y,ve,be,ke,Re,We,oe,le,fe){super(),this._onDidChangeRemoteConnectionData=this._register(new C.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=pe,this._extHostContext=Y,this._initData=Re,this._extHostWorkspace=ve,this._extHostConfiguration=be,this._logService=ke,this._extHostTunnelService=oe,this._extHostTerminalService=le,this._extHostLocalizationService=fe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._globalRegistry=new f.ExtensionDescriptionRegistry(this._initData.allExtensions);const Z=(0,b.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new f.ExtensionDescriptionRegistry($(this._globalRegistry,Z)),this._storage=new E.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=We,this._instaService=te.createChild(new o.ServiceCollection([E.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));let ae=[],ne=[];this._initData.remote.isRemote&&(ae=this._initData.allExtensions.filter(O=>!O.main&&!O.browser).map(O=>O.identifier),ne=this._initData.allExtensions.filter(O=>!Z.has(g.ExtensionIdentifier.toKey(O.identifier.value))).filter(O=>(O.main||O.browser)&&O.api==="none").map(O=>O.identifier));const ie=(0,b.extensionIdentifiersArrayToSet)(ne);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,ae,ne,{onExtensionActivationError:(O,V,q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(O,v.transformErrorForSerialization(V),q)},actualActivateExtension:async(O,V)=>{if(ie.has(g.ExtensionIdentifier.toKey(O)))return await this._mainThreadExtensionsProxy.$activateExtension(O,V),new T.HostExtension;const q=this._myRegistry.getExtensionDescription(O);return this._activateExtension(q,V)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(te){v.onUnexpectedError(te)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let te=[];try{te=this._myRegistry.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this._deactivate(be))}catch{}await Promise.all(te)}terminate(te,pe=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${te}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(ve=>{this._logService.error(ve)}),this._extHostContext.dispose();const Y=this._deactivateAll();Promise.race([(0,_.timeout)(5e3),Y]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${pe}`):this._logService.info(`Extension host exiting with code ${pe}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(pe)})}isActivated(te){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(te):!1}async getExtension(te){const pe=await this._mainThreadExtensionsProxy.$getExtension(te);let Y;if(pe?.browserNlsBundleUris){Y={};for(const ve of Object.keys(pe.browserNlsBundleUris))Y[ve]=I.URI.revive(pe.browserNlsBundleUris[ve])}return pe&&{...pe,identifier:new g.ExtensionIdentifier(pe.identifier.value),extensionLocation:I.URI.revive(pe.extensionLocation),browserNlsBundleUris:Y}}_activateByEvent(te,pe){return this._activator.activateByEvent(te,pe)}_activateById(te,pe){return this._activator.activateById(te,pe)}activateByIdWithErrors(te,pe){return this._activateById(te,pe).then(()=>{const Y=this._activator.getActivatedExtension(te);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(te=>this._myRegistry)}getExtensionExports(te){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(te).exports:null}async _realPathExtensionUri(te){if(te.scheme!==A.Schemas.file)return te;const pe=await this._hostUtils.realpath(te.fsPath);return I.URI.file(pe)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(te=>new Q(te))),this._extensionPathIndex}async _createExtensionPathIndex(te){const pe=w.TernarySearchTree.forUris(Y=>P.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(te.map(async Y=>{if(this._getEntryPoint(Y)){const ve=await this._realPathExtensionUri(Y.extensionLocation);pe.set(ve,Y)}})),pe}_deactivate(te){let pe=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(te))return pe;const Y=this._activator.getActivatedExtension(te);if(!Y)return pe;try{typeof Y.module.deactivate=="function"&&(pe=Promise.resolve(Y.module.deactivate()).then(void 0,ve=>(this._logService.error(ve),Promise.resolve(void 0))))}catch(ve){this._logService.error(`An error occurred when deactivating the extension '${te.value}':`),this._logService.error(ve)}try{(0,k.dispose)(Y.subscriptions)}catch(ve){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this._logService.error(ve)}return pe}async _activateExtension(te,pe){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier),this._doActivateExtension(te,pe).then(Y=>{const ve=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(te.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,pe),this._logExtensionActivationTimes(te,pe,"success",ve),Y},Y=>{throw this._logExtensionActivationTimes(te,pe,"failure"),Y})}_logExtensionActivationTimes(te,pe,Y,ve){const be=U(te,pe);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...be,...ve||{},outcome:Y})}_doActivateExtension(te,pe){const Y=U(te,pe);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const ve=this._getEntryPoint(te);if(!ve)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${pe.startup}, activationEvent: '${pe.activationEvent}'${te.identifier.value!==pe.extensionId.value?`, root cause: ${pe.extensionId.value}`:""}`),this._logService.flush();const be=new T.ExtensionActivationTimesBuilder(pe.startup);return Promise.all([this._loadCommonJSModule(te,(0,P.joinPath)(te.extensionLocation,ve),be),this._loadExtensionContext(te)]).then(ke=>(D.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Ln._callActivate(this._logService,te.identifier,ke[0],ke[1],be))).then(ke=>(D.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),ke))}_loadExtensionContext(te){const pe=new m.ExtensionGlobalMemento(te,this._storage),Y=new m.ExtensionMemento(te.identifier.value,!1,this._storage),ve=new M.ExtensionSecrets(te,this._secretState),be=te.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,ke=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([pe.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let We,oe;const le=(0,b.isProposedApiEnabled)(te,"ipc")?this._initData.messagePorts?.get(g.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:pe,workspaceState:Y,secrets:ve,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(fe){return t.join(te.extensionLocation.fsPath,fe)},get storagePath(){return Re._storagePath.workspaceValue(te)?.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(te).fsPath},get logPath(){return t.join(Re._initData.logsLocation.fsPath,te.identifier.value)},get logUri(){return I.URI.joinPath(Re._initData.logsLocation,te.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(te)},get globalStorageUri(){return Re._storagePath.globalValue(te)},get extensionMode(){return be},get extension(){return We===void 0&&(We=new X(Re,te.identifier,te,ke,!1)),We},get extensionRuntime(){return(0,b.checkProposedApiEnabled)(te,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!oe){if(!le)return;const fe=C.Event.buffer(C.Event.fromDOMEventEmitter(le,"message",Z=>Z.data));le.start(),oe={onDidReceiveMessage:fe,postMessage:le.postMessage.bind(le)}}return oe}})})}static _callActivate(te,pe,Y,ve,be){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(te,pe,Y,ve,be).then(ke=>new T.ActivatedExtension(!1,null,be.build(),Y,ke,ve.subscriptions))}static _callActivateOptional(te,pe,Y,ve,be){if(typeof Y.activate=="function")try{be.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${pe.value}`);const ke=typeof global=="object"?global:self,Re=Y.activate.apply(ke,[ve]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(Re).then(We=>(be.activateResolveStop(),We))}catch(ke){return Promise.reject(ke)}else return Promise.resolve(Y)}_activateOneStartupFinished(te,pe){this._activateById(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:pe}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const te of this._myRegistry.getAllExtensionDescriptions())if(te.activationEvents)for(const pe of te.activationEvents)pe==="onStartupFinished"&&this._activateOneStartupFinished(te,pe)}_handleEagerExtensions(){const te=this._activateByEvent("*",!0).then(void 0,be=>{this._logService.error(be)});this._register(this._extHostWorkspace.onDidChangeWorkspace(be=>this._handleWorkspaceContainsEagerExtensions(be.added)));const pe=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(pe),ve=Promise.all([te,Y]).then(()=>{});return Promise.race([ve,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ve}_handleWorkspaceContainsEagerExtensions(te){return te.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(pe=>this._handleWorkspaceContainsEagerExtension(te,pe))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(te,pe){if(this.isActivated(pe.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ve={logService:this._logService,folders:te.map(ke=>ke.uri),forceUsingSearch:Y,exists:ke=>this._hostUtils.exists(ke.fsPath),checkExists:(ke,Re,We)=>this._mainThreadWorkspaceProxy.$checkExists(ke,Re,We)},be=await(0,R.checkActivateWorkspaceContainsExtension)(ve,pe);if(!!be)return this._activateById(pe.identifier,{startup:!0,extensionId:pe.identifier,activationEvent:be.activationEvent}).then(void 0,ke=>this._logService.error(ke))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(te){throw console.error(te),te}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:pe}=this._initData.environment;if(!te||!pe)throw new Error(l.localize(0,null));const Y=await this._loadCommonJSModule(null,pe,new T.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(l.localize(1,null,pe.toString()));return new Promise((ve,be)=>{const ke=(oe,le)=>{oe?be(oe):ve(typeof le=="number"&&le>0?1:0)},Re=(0,P.originalFSPath)(pe),We=Y.run(Re,ke);We&&We.then&&We.then(()=>{ve(0)}).catch(oe=>{be(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,pe){return this._resolvers[te]=pe,(0,k.toDisposable)(()=>{delete this._resolvers[te]})}async _activateAndGetResolver(te){const pe=te.indexOf("+");if(pe===-1)throw new Error("Not an authority that can be resolved!");const Y=te.substr(0,pe);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(te,pe){this._logService.info(`$resolveAuthority invoked for authority (${x(te)})`);const{authorityPrefix:Y,resolver:ve}=await this._activateAndGetResolver(te);if(!ve)return{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ve)),D.mark(`code/extHost/willResolveAuthority/${Y}`);const be=await ve.resolve(te,{resolveAttempt:pe});D.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const ke={authority:te,host:be.host,port:be.port,connectionToken:be.connectionToken},Re={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ke,options:Re,tunnelInformation:{environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures}}}}catch(be){if(D.mark(`code/extHost/didResolveAuthorityError/${Y}`),be instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:be._code,message:be._message,detail:be._detail}};throw be}}async $getCanonicalURI(te,pe){this._logService.info(`$getCanonicalURI invoked for authority (${x(te)})`);const{resolver:Y}=await this._activateAndGetResolver(te);if(!Y)return null;const ve=I.URI.revive(pe);if(typeof Y.getCanonicalURI>"u")return ve;const be=await(0,_.asPromise)(()=>Y.getCanonicalURI(ve));return be||ve}static _applyExtensionsDelta(te,pe,Y){const ve=new f.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());ve.deltaExtensions(Y.toAdd,Y.toRemove);const be=(0,b.extensionIdentifiersArrayToSet)(pe.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of Y.myToRemove)be.delete(g.ExtensionIdentifier.toKey(Re));for(const Re of Y.myToAdd)be.add(g.ExtensionIdentifier.toKey(Re));const ke=$(ve,be);return{globalRegistry:ve,myExtensions:ke}}$startExtensionHost(te){te.toAdd.forEach(ve=>ve.extensionLocation=I.URI.revive(ve.extensionLocation));const{globalRegistry:pe,myExtensions:Y}=Ln._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te);return this._globalRegistry.set(pe.getAllExtensionDescriptions()),this._myRegistry.set(Y),this._startExtensionHost()}$activateByEvent(te,pe){return pe===1?this._activateByEvent(te,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(te,!1))}async $activate(te,pe){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(te)?(await this._activateById(te,pe),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(ke=>ke.extensionLocation=I.URI.revive(ke.extensionLocation));const{globalRegistry:pe,myExtensions:Y}=Ln._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te),ve=await this._createExtensionPathIndex(Y);return(await this.getExtensionPathIndex()).setSearchTree(ve),this._globalRegistry.set(pe.getAllExtensionDescriptions()),this._myRegistry.set(Y),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const pe=c.VSBuffer.alloc(te),Y=Math.random()%256;for(let ve=0;ve<te;ve++)pe.writeUInt8(Y,ve);return pe}async $updateRemoteConnectionData(te){this._remoteConnectionData=te,this._onDidChangeRemoteConnectionData.fire()}};B=qe([xe(0,s.IInstantiationService),xe(1,e.IHostUtils),xe(2,a.IExtHostRpcService),xe(3,p.IExtHostWorkspace),xe(4,S.IExtHostConfiguration),xe(5,L.ILogService),xe(6,i.IExtHostInitDataService),xe(7,r.IExtensionStoragePaths),xe(8,u.IExtHostTunnelService),xe(9,h.IExtHostTerminalService),xe(10,z.IExtHostLocalizationService)],B),e.AbstractExtHostExtensionService=B;function U(de,te){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class X{constructor(te,pe,Y,ve,be){H.set(this,void 0),F.set(this,void 0),G.set(this,void 0),tt(this,H,te,"f"),tt(this,F,pe,"f"),tt(this,G,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=ve,this.isFromDifferentExtensionHost=be}get isActive(){return Ue(this,H,"f").isActivated(Ue(this,G,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,H,"f").getExtensionExports(Ue(this,G,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,H,"f").activateByIdWithErrors(Ue(this,G,"f"),{startup:!1,extensionId:Ue(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=X,H=new WeakMap,F=new WeakMap,G=new WeakMap;function $(de,te){return de.getAllExtensionDescriptions().filter(pe=>te.has(g.ExtensionIdentifier.toKey(pe.identifier)))}function x(de){const te=de.indexOf("+");return te===-1?de:de.substring(0,te)}class Q{constructor(te){this._searchTree=te}setSearchTree(te){this._searchTree=te}findSubstr(te){return this._searchTree.findSubstr(te)}forEach(te){return this._searchTree.forEach(te)}}e.ExtensionPaths=Q}),define(De[281],Ie([1,0,71,2,5,33,27,28,14,26,3,39,40,13,8]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let p=class{constructor(m,n,d,s,i,r,a){this._apiFactory=m,this._extensionRegistry=n,this._instaService=d,this._extHostConfiguration=s,this._extHostExtensionService=i,this._initData=r,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),l.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const n=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,n,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(v,n)),this.register(this._instaService.createInstance(b)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(g,n,this._initData.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(const n of m.nodeModuleName)this._factories.set(n,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(n=>m.alternativeModuleName(n))}};p=qe([xe(2,L.IInstantiationService),xe(3,P.IExtHostConfiguration),xe(4,y.IExtHostExtensionService),xe(5,I.IExtHostInitDataService),xe(6,T.ILogService)],p),e.RequireInterceptor=p;let b=class Jn{constructor(m){if(m.environment.appRoot&&Jn.aliased.size){const n=(0,E.escapeRegExpCharacters)(this.forceForwardSlashes(m.environment.appRoot.fsPath)),d="[a-z0-9_.-]",s=`@${d}+\\/${d}+|${d}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${n}/${i}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(m){if(!this.re)return;const n=this.re.exec(this.forceForwardSlashes(m));if(!n)return;const[,d,s,i]=n,r=Jn.aliased.get(s);if(r!==void 0)return console.warn(`${s} as been renamed to ${r}, please update your imports`),d+r+i}forceForwardSlashes(m){return m.replace(/\\/g,"/")}};b.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),b=qe([xe(0,I.IExtHostInitDataService)],b);class f{constructor(m,n,d,s,i){this._apiFactory=m,this._extensionPaths=n,this._extensionRegistry=d,this._configProvider=s,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,n){const d=this._extensionPaths.findSubstr(n);if(d){let s=this._extApiImpl.get(k.ExtensionIdentifier.toKey(d.identifier));return s||(s=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(d.identifier),s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((i,r)=>s+=`	${r} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(m,n,d){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=n.getProxy(D.MainContext.MainThreadTelemetry);const{environment:s}=d,i=n.getProxy(D.MainContext.MainThreadKeytar);if(s.appRoot){let r=s.appRoot.fsPath;S.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,a)=>i.$getPassword(r,a),setPassword:(r,a,o)=>i.$setPassword(r,a,o),deletePassword:(r,a)=>i.$deletePassword(r,a),findPassword:r=>i.$findPassword(r),findCredentials(r){return i.$findCredentials(r)}}}load(m,n){const d=this._extensionPaths.findSubstr(n);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const n=m.length;if(n<=7||!this.alternativeNames)return;const d=n-7;if((m.charAt(d)==="/"||m.charAt(d)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};v=qe([xe(1,w.IExtHostRpcService),xe(2,I.IExtHostInitDataService)],v);let g=class{constructor(m,n,d){this._extensionPaths=m,this._appUriScheme=n,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(D.MainContext.MainThreadTelemetry);const s=d.getProxy(D.MainContext.MainThreadWindow);this._impl=(i,r)=>{const a=t.URI.parse(i);return r?this.callOriginal(i,r):a.scheme==="http"||a.scheme==="https"?s.$openUri(a,i,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?s.$openUri(a,i,{}):this.callOriginal(i,r)}}load(m,n,d){const s=this._extensionPaths.findSubstr(n);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=d(m),this._impl}callOriginal(m,n){return this.sendNoForwardTelemetry(),this._original(m,n)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};g=qe([xe(2,w.IExtHostRpcService)],g)}),define(De[47],Ie([1,0,76,6,9,40,3,56,57,39,7,32,218,33]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,_.createDecorator)("IExtHostVariableResolverProvider");class E extends S.AbstractVariableResolverService{constructor(f,v,g,c,m,n,d){function s(){if(g){const i=g.activeEditor();if(i)return i.document.uri;const r=c.tabGroups.all.find(a=>a.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof L.TextDiffTabInput||r.input instanceof L.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof L.TextTabInput||r.input instanceof L.NotebookEditorTabInput||r.input instanceof L.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:i=>{const r=n.folders.filter(a=>a.name===i);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(i,r)=>m.getConfiguration(void 0,i).get(r),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=s();if(i)return D.normalize(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const i=s();if(i){const r=v.getWorkspaceFolder(i);if(r)return D.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(g){const i=g.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(g){const i=g.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>f.getExtension(i)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(P.env))}}let p=class extends t.Disposable{constructor(f,v,g,c,m){super(),this.extensionService=f,this.workspaceService=v,this.editorService=g,this.configurationService=c,this.editorTabs=m,this._resolver=new l.Lazy(async()=>{const n=await this.configurationService.getConfigProvider(),s={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async i=>{s.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new E(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,n,s,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};p=qe([xe(0,I.IExtHostExtensionService),xe(1,y.IExtHostWorkspace),xe(2,k.IExtHostDocumentsAndEditors),xe(3,T.IExtHostConfiguration),xe(4,w.IExtHostEditorTabs)],p),e.ExtHostVariableResolverProviderService=p}),define(De[72],Ie([1,0,18,4,16,2,3,5,57,39,14,7,32,128,211,33,47]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let f=class{constructor(s,i,r,a,o,u){this._workspaceService=i,this._extensionService=r,this._configurationService=a,this._editorTabs=o,this._variableResolver=u,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new t.Emitter,this._onDidTerminateDebugSession=new t.Emitter,this._onDidChangeActiveDebugSession=new t.Emitter,this._onDidReceiveDebugSessionCustomEvent=new t.Emitter,this._debugServiceProxy=s.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new t.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new g(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(h=>{h.onDidChange(C=>{this.registerAllDebugTypes(h)}),this.registerAllDebugTypes(h)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(s,i){const r=s;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let a=`debug:${encodeURIComponent(r.path||"")}`,o="?";return i&&(a+=`${o}session=${encodeURIComponent(i.id)}`,o="&"),a+=`${o}ref=${r.sourceReference}`,P.URI.parse(a)}else{if(r.path)return P.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const i=[];for(const r of s.getAllExtensionDescriptions())if(r.contributes){const a=r.contributes.debuggers;if(a&&a.length>0)for(const o of a)(0,E.isDebuggerMainContribution)(o)&&i.push(o.type)}this._debugServiceProxy.$registerDebugTypes(i)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(i=>s.push(i)),s}addBreakpoints(s){this.startBreakpoints();const i=s.filter(o=>{const u=o.id;return this._breakpoints.has(u)?!1:(this._breakpoints.set(u,o),!0)});this.fireBreakpointChanges(i,[],[]);const r=[],a=new Map;for(const o of i)if(o instanceof y.SourceBreakpoint){let u=a.get(o.location.uri.toString());u||(u={type:"sourceMulti",uri:o.location.uri,lines:[]},a.set(o.location.uri.toString(),u),r.push(u)),u.lines.push({id:o.id,enabled:o.enabled,condition:o.condition,hitCondition:o.hitCondition,logMessage:o.logMessage,line:o.location.range.start.line,character:o.location.range.start.character})}else o instanceof y.FunctionBreakpoint&&r.push({type:"function",id:o.id,enabled:o.enabled,hitCondition:o.hitCondition,logMessage:o.logMessage,condition:o.condition,functionName:o.functionName});return this._debugServiceProxy.$registerBreakpoints(r)}removeBreakpoints(s){this.startBreakpoints();const i=s.filter(u=>this._breakpoints.delete(u.id));this.fireBreakpointChanges([],i,[]);const r=i.filter(u=>u instanceof y.SourceBreakpoint).map(u=>u.id),a=i.filter(u=>u instanceof y.FunctionBreakpoint).map(u=>u.id),o=i.filter(u=>u instanceof y.DataBreakpoint).map(u=>u.id);return this._debugServiceProxy.$unregisterBreakpoints(r,a,o)}startDebugging(s,i,r){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,i,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,debugUI:r.debugUI,suppressSaveBeforeStart:r.suppressSaveBeforeStart})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,i,r){if(!i)return new y.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:a,provider:i}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,r,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,a),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(o=>o.provider!==i),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(s,i,r){if(!r)return new y.Disposable(()=>{});if(!this.definesDebugType(s,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.getAdapterDescriptorFactoryByType(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:i,handle:a,factory:r}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(i,a),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(o=>o.factory!==r),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(s,i){if(!i)return new y.Disposable(()=>{});const r=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:r,factory:i}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==i)})}async $runInTerminal(s,i){return Promise.resolve(void 0)}async $substituteVariables(s,i){let r;const a=await this.getFolder(s);return a&&(r={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(r,i)}createDebugAdapter(s,i){if(s.type==="implementation")return new m(s.implementation)}createSignService(){}async $startDASession(s,i){const r=this,a=await this.getSession(i);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const u=this.convertToDto(o),h=this.createDebugAdapter(u,a);if(!h)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const C=h;return this._debugAdapters.set(s,C),this.getDebugAdapterTrackers(a).then(R=>(R&&this._debugAdaptersTrackers.set(s,R),C.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const M=N,A={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const z=await this._signService.sign(M.arguments.value);A.body={signature:z},C.sendResponse(A)}else throw new Error("no signer")}catch(z){A.success=!1,A.message=z.message,C.sendResponse(A)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(N),N=(0,E.convertToVSCPaths)(N,!0),r._debugServiceProxy.$acceptDAMessage(s,N)}),C.onError(N=>{R&&R.onError&&R.onError(N),this._debugServiceProxy.$acceptDAError(s,N.name,N.message,N.stack)}),C.onExit(N=>{R&&R.onExit&&R.onExit((0,D.withNullAsUndefined)(N),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,D.withNullAsUndefined)(N),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),C.startSession()))})}$sendDAMessage(s,i){i=(0,E.convertToDAPaths)(i,!1);const r=this._debugAdaptersTrackers.get(s);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(i),this._debugAdapters.get(s)?.sendMessage(i)}$stopDASession(s){const i=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),i&&i.onWillStopSession&&i.onWillStopSession();const r=this._debugAdapters.get(s);return this._debugAdapters.delete(s),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const i=[],r=[],a=[];if(s.added)for(const o of s.added){const u=o.id;if(u&&!this._breakpoints.has(u)){let h;if(o.type==="function")h=new y.FunctionBreakpoint(o.functionName,o.enabled,o.condition,o.hitCondition,o.logMessage);else if(o.type==="data")h=new y.DataBreakpoint(o.label,o.dataId,o.canPersist,o.enabled,o.hitCondition,o.condition,o.logMessage);else{const C=P.URI.revive(o.uri);h=new y.SourceBreakpoint(new y.Location(C,new y.Position(o.line,o.character)),o.enabled,o.condition,o.hitCondition,o.logMessage)}h._id=u,this._breakpoints.set(u,h),i.push(h)}}if(s.removed)for(const o of s.removed){const u=this._breakpoints.get(o);u&&(this._breakpoints.delete(o),r.push(u))}if(s.changed){for(const o of s.changed)if(o.id){const u=this._breakpoints.get(o.id);if(u){if(u instanceof y.FunctionBreakpoint&&o.type==="function"){const h=u;h.enabled=o.enabled,h.condition=o.condition,h.hitCondition=o.hitCondition,h.logMessage=o.logMessage,h.functionName=o.functionName}else if(u instanceof y.SourceBreakpoint&&o.type==="source"){const h=u;h.enabled=o.enabled,h.condition=o.condition,h.hitCondition=o.hitCondition,h.logMessage=o.logMessage,h.location=new y.Location(P.URI.revive(o.uri),new y.Position(o.line,o.character))}a.push(u)}}}this.fireBreakpointChanges(i,r,a)}$provideDebugConfigurations(s,i,r){return(0,l.asPromise)(async()=>{const a=this.getConfigProviderByHandle(s);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const o=await this.getFolder(i);return a.provideDebugConfigurations(o,r)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(s,i,r,a){return(0,l.asPromise)(async()=>{const o=this.getConfigProviderByHandle(s);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const u=await this.getFolder(i);return o.resolveDebugConfiguration(u,r,a)})}$resolveDebugConfigurationWithSubstitutedVariables(s,i,r,a){return(0,l.asPromise)(async()=>{const o=this.getConfigProviderByHandle(s);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const u=await this.getFolder(i);return o.resolveDebugConfigurationWithSubstitutedVariables(u,r,a)})}async $provideDebugAdapter(s,i){const r=this.getAdapterDescriptorFactoryByHandle(s);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(i);return this.getAdapterDescriptor(r,a).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(o)})}async $acceptDebugSessionStarted(s){const i=await this.getSession(s);this._onDidStartDebugSession.fire(i)}async $acceptDebugSessionTerminated(s){const i=await this.getSession(s);i&&(this._onDidTerminateDebugSession.fire(i),this._debugSessions.delete(i.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,i){(await this.getSession(s))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(s,i){const a={session:await this.getSession(s),event:i.event,body:i.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(s){if(s instanceof y.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof y.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const i=this._adapterFactories.filter(r=>r.type===s);if(i.length>0)return i[0].factory}getAdapterDescriptorFactoryByHandle(s){const i=this._adapterFactories.filter(r=>r.handle===s);if(i.length>0)return i[0].factory}getConfigProviderByHandle(s){const i=this._configProviders.filter(r=>r.handle===s);if(i.length>0)return i[0].provider}definesDebugType(s,i){if(s.contributes){const r=s.contributes.debuggers;if(r&&r.length>0){for(const a of r)if(a.label&&a.type&&a.type===i)return!0}}return!1}getDebugAdapterTrackers(s){const r=s.configuration.type,a=this._trackerFactories.filter(o=>o.type===r||o.type==="*").map(o=>(0,l.asPromise)(()=>o.factory.createDebugAdapterTracker(s)).then(u=>u,u=>null));return Promise.race([Promise.all(a).then(o=>{const u=o.filter(h=>!!h);if(u.length>0)return new c(u)}),new Promise((o,u)=>{const h=setTimeout(()=>{clearTimeout(h),u(new Error("timeout"))},1e3)})]).catch(o=>{})}async getAdapterDescriptor(s,i){const r=i.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new y.DebugAdapterServer(r));if(s){const o=await this._extensionService.getExtensionRegistry();return(0,l.asPromise)(()=>s.createDebugAdapterDescriptor(i,this.daExecutableFromPackage(i,o))).then(u=>{if(u)return u})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(i,a))}daExecutableFromPackage(s,i){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,i,r){(s.length>0||i.length>0||r.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:i,changed:r}))}async getSession(s){if(s)if(typeof s=="string"){const i=this._debugSessions.get(s);if(i)return i}else{let i=this._debugSessions.get(s.id);if(!i){const r=await this.getFolder(s.folderUri),a=s.parent?this._debugSessions.get(s.parent):void 0;i=new v(this._debugServiceProxy,s.id,s.type,s.name,r,s.configuration,a),this._debugSessions.set(i.id,i),this._debugServiceProxy.$sessionCached(i.id)}return i}throw new Error("cannot find session")}getFolder(s){if(s){const i=P.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};f=qe([xe(0,L.IExtHostRpcService),xe(1,S.IExtHostWorkspace),xe(2,I.IExtHostExtensionService),xe(3,p.IExtHostConfiguration),xe(4,w.IExtHostEditorTabs),xe(5,b.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class v{constructor(s,i,r,a,o,u,h){this._debugServiceProxy=s,this._id=i,this._type=r,this._name=a,this._workspaceFolder=o,this._configuration=u,this._parentSession=h}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,i){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,i)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=v;class g{constructor(s){this.value=Object.freeze({append(i){s.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.ExtHostDebugConsole=g;class c{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(i=>i.onError?i.onError(s):void 0)}onExit(s,i){this.trackers.forEach(r=>r.onExit?r.onExit(s,i):void 0)}}class m extends T.AbstractDebugAdapter{constructor(s){super(),this.implementation=s,s.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let n=class extends f{constructor(s,i,r,a,o,u){super(s,i,r,a,o,u)}};n=qe([xe(0,L.IExtHostRpcService),xe(1,S.IExtHostWorkspace),xe(2,I.IExtHostExtensionService),xe(3,p.IExtHostConfiguration),xe(4,w.IExtHostEditorTabs),xe(5,b.IExtHostVariableResolverProvider)],n),e.WorkerExtHostDebugService=n}),define(De[282],Ie([1,0,10,71,2,5,274,13,82,85,26,193,14,54,39]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class p{constructor(f,v,g,c,m){this._hostUtils=g,this._rpcProtocol=new _.RPCProtocol(f,null,c),v=p._transform(v,this._rpcProtocol);const n=new I.ServiceCollection(...(0,w.getSingletonServiceDescriptors)());n.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...v,messagePorts:m}),n.set(S.IExtHostRpcService,new S.ExtHostRpcService(this._rpcProtocol)),n.set(T.IURITransformerService,new T.URITransformerService(c)),n.set(E.IHostUtils,g);const d=new y.InstantiationService(n,!0);this._logService=d.invokeFunction(a=>a.get(k.ILogService)),t.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=d.invokeFunction(a=>a.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const s=new WeakMap;this._extensionService.getExtensionPathIndex().then(a=>{Error.prepareStackTrace=(o,u)=>{let h="",C,R;for(const N of u)h+=`
	at ${N.toString()}`,R=N.getFileName(),!C&&R&&(C=a.findSubstr(D.URI.file(R)));return s.set(o,C),`${o.name||"Error"}: ${o.message||""}${h}`}});const i=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),r=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);l.setUnexpectedErrorHandler(a=>{const o=l.transformErrorForSerialization(a),u=s.get(a);u?i.$onExtensionRuntimeError(u.identifier,o):r.$onUnexpectedError(o)})}async asBrowserUri(f){const v=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return D.URI.revive(await v.$asBrowserUri(f))}terminate(f){this._extensionService.terminate(f)}static _transform(f,v){f.allExtensions.forEach(c=>{c.extensionLocation=D.URI.revive(v.transformIncomingURIs(c.extensionLocation));const m={};c.browserNlsBundleUris&&(Object.keys(c.browserNlsBundleUris).forEach(n=>m[n]=D.URI.revive(v.transformIncomingURIs(c.browserNlsBundleUris[n]))),c.browserNlsBundleUris=m)}),f.environment.appRoot=D.URI.revive(v.transformIncomingURIs(f.environment.appRoot));const g=f.environment.extensionDevelopmentLocationURI;return g&&(f.environment.extensionDevelopmentLocationURI=g.map(c=>D.URI.revive(v.transformIncomingURIs(c)))),f.environment.extensionTestsLocationURI=D.URI.revive(v.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=D.URI.revive(v.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=D.URI.revive(v.transformIncomingURIs(f.environment.workspaceStorageHome)),f.nlsBaseUrl=D.URI.revive(v.transformIncomingURIs(f.nlsBaseUrl)),f.logsLocation=D.URI.revive(v.transformIncomingURIs(f.logsLocation)),f.logFile=D.URI.revive(v.transformIncomingURIs(f.logFile)),f.workspace=v.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=p}),define(De[283],Ie([1,0,18,11,177,192,200,72,57,39,14,38,7,47,32,212,214,33]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let v=class extends k.ExtHostDebugServiceBase{constructor(d,s,i,r,a,o,u){super(d,s,i,r,o,u),this._terminalService=a,this._integratedTerminalInstances=new m}createDebugAdapter(d,s){switch(d.type){case"server":return new p.SocketDebugAdapter(d);case"pipeServer":return new p.NamedPipeDebugAdapter(d);case"executable":return new p.ExecutableDebugAdapter(d,s.type)}return super.createDebugAdapter(d,s)}daExecutableFromPackage(d,s){const i=p.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),d.type);if(i)return new S.DebugAdapterExecutable(i.command,i.args,i.options)}createSignService(){return new _.SignService}async $runInTerminal(d,s){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(z=>{this._integratedTerminalInstances.onTerminalClosed(z)}));const i=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),a=this._terminalService.getDefaultShellArgs(!0),o=d.title||D.localize(0,null),u=JSON.stringify({shell:r,shellArgs:a});let h=await this._integratedTerminalInstances.checkout(u,o),C,R=!1;if(h)C=d.cwd;else{const z={shellPath:r,shellArgs:a,cwd:d.cwd,name:o,iconPath:new S.ThemeIcon("debug")};R=!0,h=this._terminalService.createTerminalFromOptions(z,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(h,u)}h.show(!0);const N=await h.processId;R?await new Promise(z=>setTimeout(z,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?h.sendText("cls"):r.indexOf("bash")>=0?h.sendText("clear"):t.isWindows?h.sendText("cls"):h.sendText("clear"));const M=(0,b.prepareCommand)(r,d.args,!!d.argsCanBeInterpretedByShell,C,d.env);h.sendText(M);const A=this.onDidTerminateDebugSession(z=>{z.id===s&&(this._integratedTerminalInstances.free(h),A.dispose())});return N}else if(d.kind==="external")return c(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,s)}};v=qe([xe(0,L.IExtHostRpcService),xe(1,E.IExtHostWorkspace),xe(2,I.IExtHostExtensionService),xe(3,f.IExtHostConfiguration),xe(4,y.IExtHostTerminalService),xe(5,w.IExtHostEditorTabs),xe(6,T.IExtHostVariableResolverProvider)],v),e.ExtHostDebugService=v;let g;function c(n,d){if(!g)if(t.isWindows)g=new P.WindowsExternalTerminalService;else if(t.isMacintosh)g=new P.MacExternalTerminalService;else if(t.isLinux)g=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=d.getConfiguration("terminal");return g.runInTerminal(n.title,n.cwd,n.args,n.env||{},s.external||{})}e.runInExternalTerminal=c;class m{constructor(){this._terminalInstances=new Map}async checkout(d,s){const r=[...this._terminalInstances.entries()].map(([a,o])=>(0,l.createCancelablePromise)(async u=>{if(a.name!==s||o.lastUsedAt!==-1&&await(0,b.hasChildProcesses)(await a.processId))return null;const h=Date.now();return o.lastUsedAt+m.minUseDelay>h||u.isCancellationRequested||o.config!==d?null:(o.lastUsedAt=h,a)}));return await(0,l.firstParallel)(r,a=>!!a)}insert(d,s){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:s})}free(d){const s=this._terminalInstances.get(d);s&&(s.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}m.minUseDelay=1e3}),define(De[284],Ie([1,0,9,2,111,32,56,33,45,38,14,26,70,12,13,65,22,81,47]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let g=class extends S.ExtHostTaskBase{constructor(m,n,d,s,i,r,a,o,u){super(m,n,d,s,i,r,a,o),this.workspaceService=d,this.variableResolver=u,n.remote.isRemote&&n.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:n.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(m,n){const d=n;if(!n.execution&&d._id===void 0)throw new Error("Tasks to execute must include an execution");if(d._id!==void 0){const s=S.TaskHandleDTO.from(d,this.workspaceService),i=await this._proxy.$getTaskExecution(s);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(i,n);return this._proxy.$executeTask(s).catch(()=>{}),r}else{const s=S.TaskDTO.from(n,m);if(s===void 0)return Promise.reject(new Error("Task is not valid"));S.CustomExecutionDTO.is(s.execution)&&await this.addCustomExecution(s,n,!1);const i=await this.getTaskExecution(await this._proxy.$getTaskExecution(s),n);return this._proxy.$executeTask(s).catch(()=>{}),i}}provideTasksInternal(m,n,d,s){const i=[];if(s)for(const r of s){this.checkDeprecation(r,d),(!r.definition||!m[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const a=S.TaskDTO.from(r,d.extension);a&&(i.push(a),S.CustomExecutionDTO.is(a.execution)&&n.push(this.addCustomExecution(a,r,!0)))}return{tasks:i,extension:d.extension}}async resolveTaskInternal(m){return m}async getAFolder(m){let n=m&&m.length>0?m[0]:void 0;if(!n){const d=t.URI.file((0,f.homedir)());n=new w.WorkspaceFolder({uri:d,name:b.basename(d),index:0})}return{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(m,n){const d=t.URI.revive(m),s={process:void 0,variables:Object.create(null)},i=await this._workspaceProvider.resolveWorkspaceFolder(d),r=await this._workspaceProvider.getWorkspaceFolders2()??[],a=await this.variableResolver.getResolver(),o=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(r);for(const u of n.variables)s.variables[u]=await a.resolveAsync(o,u);if(n.process!==void 0){let u;if(n.process.path!==void 0){u=n.process.path.split(l.delimiter);for(let h=0;h<u.length;h++)u[h]=await a.resolveAsync(o,u[h])}s.process=await D.win32.findExecutable(await a.resolveAsync(o,n.process.name),n.process.cwd!==void 0?await a.resolveAsync(o,n.process.cwd):void 0,u)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(m,n,d){return D.win32.findExecutable(m,n,d)}};g=qe([xe(0,L.IExtHostRpcService),xe(1,y.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,_.IExtHostDocumentsAndEditors),xe(4,k.IExtHostConfiguration),xe(5,I.IExtHostTerminalService),xe(6,E.ILogService),xe(7,p.IExtHostApiDeprecationService),xe(8,v.IExtHostVariableResolverProvider)],g),e.ExtHostTask=g}),define(De[285],Ie([1,0,81,47]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class D extends t.ExtHostVariableResolverProviderService{homeDir(){return(0,l.homedir)()}}e.NodeExtHostVariableResolverProviderService=D}),define(De[141],Ie([1,0,17,18,21,50,12,9,22,2,30]),function(J,e,l,t,D,P,_,k,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class y{constructor(v,g,c,m){this.query=v,this.provider=g,this.fileUtils=c,this.processType=m,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,g){const c=this.query.folderQueries||[],m=new D.CancellationTokenSource;return g.onCancellationRequested(()=>m.cancel()),new Promise((n,d)=>{this.collector=new T(v);let s=!1;const i=(r,a)=>{if(!s&&!this.isLimitHit){const o=this.resultSize(r);p(r)&&typeof this.query.maxResults=="number"&&this.resultCount+o>this.query.maxResults&&(this.isLimitHit=!0,s=!0,m.cancel(),r=this.trimResultToSize(r,this.query.maxResults-this.resultCount));const u=this.resultSize(r);this.resultCount+=u,(u>0||!p(r))&&this.collector.add(r,a)}};Promise.all(c.map((r,a)=>this.searchInFolder(r,o=>i(o,a),m.token))).then(r=>{m.dispose(),this.collector.flush();const a=r.some(o=>!!o&&!!o.limitHit);n({limitHit:this.isLimitHit||a,messages:(0,l.flatten)(r.map(o=>o?.message?Array.isArray(o.message)?o.message:[o.message]:[])),stats:{type:this.processType}})},r=>{m.dispose();const a=(0,P.toErrorMessage)(r);d(new Error(a))})})}resultSize(v){return p(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,g){const c=Array.isArray(v.ranges)?v.ranges:[v.ranges],m=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:c.slice(0,g),preview:{matches:m.slice(0,g),text:v.preview.text},uri:v.uri}}async searchInFolder(v,g,c){const m=new L.QueryGlobTester(this.query,v),n=[],d={report:r=>{if(!this.validateProviderResult(r))return;const a=v.folder.scheme===_.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(w.dirname(r.uri))):void 0,o=w.relativePath(v.folder,r.uri);if(o){const u=m.includedInQuery(o,k.basename(o),a);(0,t.isThenable)(u)?n.push(u.then(h=>{h&&g(r)})):u&&g(r)}}},s=this.getSearchOptionsForFolder(v),i=await this.provider.provideTextSearchResults(S(this.query.contentPattern),s,d,c);return n.length&&await Promise.all(n),i}validateProviderResult(v){if(p(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const g=(0,L.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),c=(0,L.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),m={folder:I.URI.from(v.folder),excludes:c,includes:g,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return m.usePCRE2=this.query.usePCRE2,m}}e.TextSearchManager=y;function S(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class T{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,g=>this.sendItems(g))}add(v,g){this._currentFileMatch&&(this._currentFolderIdx!==g||!w.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=g,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(E(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=T;function E(f){return p(f)?{preview:{matches:(0,l.mapArrayOrNot)(f.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:f.preview.text},ranges:(0,l.mapArrayOrNot)(f.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function p(f){return!!f.preview}e.extensionResultIsMatch=p;class b{constructor(v,g){this.maxBatchSize=v,this.cb=g,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,g){!v||this.addItemToBatch(v,g)}addItems(v,g){!v||this.addItemsToBatch(v,g)}addItemToBatch(v,g){this.batch.push(v),this.batchSize+=g,this.onUpdate()}addItemsToBatch(v,g){this.batch=this.batch.concat(v),this.batchSize+=g,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(De[73],Ie([1,0,6,5,3,278,14,54,13,2,141]),function(J,e,l,t,D,P,_,k,w,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let y=class{constructor(p,b,f){this.extHostRpc=p,this._uriTransformer=b,this._logService=f,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}registerTextSearchProvider(p,b){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const f=this._handlePool++;return this._textSearchProvider.set(f,b),this._proxy.$registerTextSearchProvider(f,this._transformScheme(p)),(0,l.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}registerFileSearchProvider(p,b){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const f=this._handlePool++;return this._fileSearchProvider.set(f,b),this._proxy.$registerFileSearchProvider(f,this._transformScheme(p)),(0,l.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(p,b,f,v){const g=S(f),c=this._fileSearchProvider.get(p);if(c)return this._fileSearchManager.fileSearch(g,c,m=>{this._proxy.$handleFileMatch(p,b,m.map(n=>n.resource))},v);throw new Error("unknown provider: "+p)}$clearCache(p){return this._fileSearchManager.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,b,f,v){const g=this._textSearchProvider.get(p);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const c=S(f);return this.createTextSearchManager(c,g).search(n=>this._proxy.$handleTextMatch(p,b,n),v)}$enableExtensionHostSearch(){}createTextSearchManager(p,b){return new L.TextSearchManager(p,b,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};y=qe([xe(0,_.IExtHostRpcService),xe(1,k.IURITransformerService),xe(2,w.ILogService)],y),e.ExtHostSearch=y;function S(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(T),extraFileResources:E.extraFileResources&&E.extraFileResources.map(p=>I.URI.revive(p))}}e.reviveQuery=S;function T(E){return{...E,folder:I.URI.revive(E.folder)}}}),define(De[286],Ie([1,0,82,140,32,136,33,37,56,38,70,72,73,93,53,65,139,66,46,92,126,57,137,13,224,47,138,91]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f,v,g,c,m,n,d,s,i,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(a.IExtHostLocalizationService,a.ExtHostLocalizationService,!0),(0,l.registerSingleton)(d.ILoggerService,n.ExtHostLoggerService,!0),(0,l.registerSingleton)(d.ILogService,s.ExtHostLogService,!0),(0,l.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService,!1),(0,l.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands,!1),(0,l.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration,!1),(0,l.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem,!1),(0,l.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService,!1),(0,l.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations,!1),(0,l.registerSingleton)(w.IExtHostDocumentsAndEditors,w.ExtHostDocumentsAndEditors,!1),(0,l.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,!1),(0,l.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,!0),(0,l.registerSingleton)(S.IExtHostSearch,S.ExtHostSearch,!1),(0,l.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,!1),(0,l.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,!1),(0,l.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService,!1),(0,l.registerSingleton)(E.IExtHostTunnelService,E.ExtHostTunnelService,!1),(0,l.registerSingleton)(b.IExtHostWindow,b.ExtHostWindow,!1),(0,l.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,!1),(0,l.registerSingleton)(g.IExtHostSecretState,g.ExtHostSecretState,!1),(0,l.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry,!1),(0,l.registerSingleton)(r.IExtHostTelemetryLogService,r.ExtHostTelemetryLogService,!1),(0,l.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs,!1),(0,l.registerSingleton)(i.IExtHostVariableResolverProvider,i.ExtHostVariableResolverProviderService,!1)}),define(De[94],Ie([1,0,17,13,30,69]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function _(y){return y.startsWith("**")||y.startsWith("/")?y:`/${y}`}e.anchorGlob=_;function k(y,S,T,E){const p=(0,l.mapArrayOrNot)(T,w),b=new D.TextSearchMatch(S,p,E),f=b.preview.matches;return{ranges:(0,l.mapArrayOrNot)(p,I),uri:y,preview:{text:b.preview.text,matches:(0,l.mapArrayOrNot)(f,I)}}}e.createTextSearchResult=k;function w(y){return new D.SearchRange(y.start.line,y.start.character,y.end.line,y.end.character)}function I(y){return new P.Range(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn)}let L=class{constructor(S,T){this.prefix=S,this.logService=T}appendLine(S){this.logService.debug(`${this.prefix}#search`,S)}};L=qe([xe(1,t.ILogService)],L),e.OutputChannel=L}),define(De[287],Ie([1,0,44,9,79,31,11,8,94,288]),function(J,e,l,t,D,P,_,k,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function y(g,c,m,n){const d=S(g,c,m,n),s=c.folder.fsPath;return{cmd:l.spawn(L,d.args,{cwd:s}),rgDiskPath:L,siblingClauses:d.siblingClauses,rgArgs:d,cwd:s}}e.spawnRipgrepCmd=y;function S(g,c,m,n){const d=["--files","--hidden","--case-sensitive"];E([c],m,!1).forEach(i=>{const r=(0,w.anchorGlob)(i);if(d.push("-g",r),_.isMacintosh){const a=(0,D.normalizeNFD)(r);a!==r&&d.push("-g",a)}});const s=T([c],n,void 0,!1);return s.globArgs.forEach(i=>{const r=`!${(0,w.anchorGlob)(i)}`;if(d.push("-g",r),_.isMacintosh){const a=(0,D.normalizeNFD)(r);a!==r&&d.push("-g",a)}}),c.disregardIgnoreFiles!==!1?d.push("--no-ignore"):c.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),c.ignoreSymlinks||d.push("--follow"),g.exists&&d.push("--quiet"),d.push("--no-config"),c.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:s.siblingClauses}}function T(g,c,m,n=!0){const d=[];let s={};return g.forEach(i=>{const r=Object.assign({},i.excludePattern||{},c||{}),a=p(r,n?i.folder.fsPath:void 0,m);d.push(...a.globArgs),a.siblingClauses&&(s=Object.assign(s,a.siblingClauses))}),{globArgs:d,siblingClauses:s}}e.foldersToRgExcludeGlobs=T;function E(g,c,m=!0){const n=[];return g.forEach(d=>{const s=Object.assign({},c||{},d.includePattern||{}),i=p(s,m?d.folder.fsPath:void 0);n.push(...i.globArgs)}),n}e.foldersToIncludeGlobs=E;function p(g,c,m){const n=[],d={};return Object.keys(g).forEach(s=>{if(m&&m.has(s)||!s)return;const i=g[s];s=f(c?b(c,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof i=="boolean"&&i?(s.startsWith("\\\\")&&(s+="**"),n.push(v(s))):i&&i.when&&(d[s]=i)}),{globArgs:n,siblingClauses:d}}function b(g,c){return t.isAbsolute(c)?c:t.join(g,c)}e.getAbsoluteGlob=b;function f(g){return g=k.rtrim(g,"\\"),k.rtrim(g,"/")}function v(g){return P.getRoot(g).toLowerCase()==="c:/"?g.replace(/^c:[/\\]/i,"/"):g}e.fixDriveC=v}),define(De[289],Ie([1,0,44,61,9,290,17,50,36,79,31,11,51,8,16,29,30,287,106]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const g=new Set;process.on("exit",()=>{g.forEach(s=>s())});class c{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&w.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,v.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&w.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(r=>{const a=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),o=r.folder.fsPath;i.folderQueries.map(u=>u.folder.fsPath).filter(u=>u!==o).forEach(u=>{(0,L.isEqualOrParent)(u,o)&&(a[D.relative(o,u)]=!0)}),this.folderExcludePatterns.set(o,new n(a,o))})}cancel(){this.isCanceled=!0,g.forEach(i=>i())}walk(i,r,a,o,u){if(this.fileWalkSW=S.StopWatch.create(!1),this.isCanceled)return u(null,this.isLimitHit);r.forEach(h=>{const C=D.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,C)||this.matchFile(a,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=S.StopWatch.create(!1),this.parallel(i,(h,C)=>{this.call(this.cmdTraversal,this,h,a,o,R=>{if(R){const N=(0,k.toErrorMessage)(R);console.error(N),this.errors.push(N),C(R,void 0)}else C(null,void 0)})},(h,C)=>{this.fileWalkSW.stop();const R=h?_.coalesce(h)[0]:null;u(R,this.isLimitHit)})}parallel(i,r,a){const o=new Array(i.length),u=new Array(i.length);let h=!1,C=0;if(i.length===0)return a(null,[]);i.forEach((R,N)=>{r(R,(M,A)=>{if(M?(h=!0,o[N]=null,u[N]=M):(o[N]=A,u[N]=null),++C===i.length)return a(h?u:null,o)})})}call(i,r,...a){try{i.apply(r,a)}catch(o){a[a.length-1](o)}}cmdTraversal(i,r,a,o){const u=i.folder.fsPath,h=y.isMacintosh,C=()=>z&&z.kill();g.add(C);let R=B=>{g.delete(C),R=()=>{},o(B)},N="";const M=this.initDirectoryTree(),A=(0,f.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression),z=A.cmd,H=!Object.keys(A.siblingClauses).length,F=A.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let G=`${A.rgDiskPath} ${F}
 - cwd: ${A.cwd}`;A.rgArgs.siblingClauses&&(G+=`
 - Sibling clauses: ${JSON.stringify(A.rgArgs.siblingClauses)}`),a({message:G}),this.cmdResultCount=0,this.collectStdout(z,"utf8",a,(B,U,X)=>{if(B){R(B);return}if(this.isLimitHit){R();return}const x=(N+(h?I.normalizeNFC(U||""):U)).split(`
`);if(X){const Q=x.length;x[Q-1]=x[Q-1].trim(),x[Q-1]||x.pop()}else N=x.pop()||"";if(x.length&&x[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=x.length,H){for(const Q of x)if(this.matchFile(r,{base:u,relativePath:Q,searchPath:this.getSearchPath(i,Q)}),this.isLimitHit){C();break}(X||this.isLimitHit)&&R();return}this.addDirectoryEntries(i,M,u,x,r),X&&(this.matchDirectoryTree(M,u,r),R())})}spawnFindCmd(i){const r=this.folderExcludePatterns.get(i.folder.fsPath),a=r.getBasenameTerms(),o=r.getPathTerms(),u=["-L","."];if(a.length||o.length){u.push("-not","(","(");for(const h of a)u.push("-name",h),u.push("-o");for(const h of o)u.push("-path",h),u.push("-o");u.pop(),u.push(")","-prune",")")}return u.push("-type","f"),l.spawn("find",u,{cwd:i.folder.fsPath})}readStdout(i,r,a){let o="";this.collectStdout(i,r,()=>{},(u,h,C)=>{if(u){a(u);return}o+=h,C&&a(null,o)})}collectStdout(i,r,a,o){let u=(R,N,M)=>{(R||M)&&(u=()=>{},this.cmdSW?.stop()),o(R,N,M)},h=!1;i.stdout?(this.forwardData(i.stdout,r,u),i.stdout.once("data",()=>h=!0)):a({message:"stdout is null"});let C;i.stderr?C=this.collectData(i.stderr):a({message:"stderr is null"}),i.on("error",R=>{u(R)}),i.on("close",R=>{let N;!h&&(N=this.decodeData(C,r))&&d(N)?u(new Error(`command failed with error code ${R}: ${this.decodeData(C,r)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),u(null,"",!0))})}forwardData(i,r,a){const o=new P.StringDecoder(r);return i.on("data",u=>{a(null,o.write(u))}),o}collectData(i){const r=[];return i.on("data",a=>{r.push(a)}),r}decodeData(i,r){const a=new P.StringDecoder(r);return i.map(o=>a.write(o)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:r},a,o,u){o.indexOf(this.filePattern)!==-1&&this.matchFile(u,{base:a,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const h=C=>{const R=D.basename(C),N=D.dirname(C);let M=r[N];M||(M=r[N]=[],h(N)),M.push({base:a,relativePath:C,basename:R,searchPath:this.getSearchPath(i,C)})};o.forEach(h)}matchDirectoryTree({rootEntries:i,pathToEntries:r},a,o){const u=this,h=this.folderExcludePatterns.get(a),C=this.filePattern;function R(N){u.directoriesWalked++;const M=(0,b.hasSiblingFn)(()=>N.map(A=>A.basename));for(let A=0,z=N.length;A<z;A++){const H=N[A],{relativePath:F,basename:G}=H;if(h.test(F,G,C!==G?M:void 0))continue;const B=r[F];if(B)R(B);else{if(u.filesWalked++,F===C)continue;u.matchFile(o,H)}if(u.isLimitHit)break}}R(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,r,a,o,u){const h=i.folder,C=(0,b.hasSiblingFn)(()=>a);this.parallel(a,(R,N)=>{if(this.isCanceled||this.isLimitHit)return N(null);const M=r?[r,R].join(D.sep):R;if(this.folderExcludePatterns.get(i.folder.fsPath).test(M,R,this.config.filePattern!==R?C:void 0))return N(null);const A=[h.fsPath,M].join(D.sep);t.lstat(A,(z,H)=>{if(z||this.isCanceled||this.isLimitHit)return N(null);this.statLinkIfNeeded(A,H,(F,G)=>F||this.isCanceled||this.isLimitHit?N(null):G.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(A,H,(B,U)=>B||this.isCanceled||this.isLimitHit||(U=U||"",this.walkedPaths[U])?N(null):(this.walkedPaths[U]=!0,p.Promises.readdir(A).then(X=>{if(this.isCanceled||this.isLimitHit)return N(null);this.doWalk(i,M,X,o,$=>N($||null))},X=>{N(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&E.isNumber(G.size)&&G.size>this.maxFilesize||this.matchFile(o,{base:h.fsPath,relativePath:M,searchPath:this.getSearchPath(i,M)}),N(null,void 0)))})},R=>{const N=R&&_.coalesce(R);return u(N&&N.length>0?N[0]:void 0)})}matchFile(i,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,D.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(r))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,b.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,r,a){return r.isSymbolicLink()?t.stat(i,a):a(null,r)}realPathIfNeeded(i,r,a){return r.isSymbolicLink()?t.realpath(i,(o,u)=>o?a(o):a(null,u)):a(null,i)}getSearchPath(i,r){return i.folderName?D.join(i.folderName,r):r}}e.FileWalker=c;class m{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new c(i)}search(i,r,a){this.walker.walk(this.folderQueries,this.extraFiles,i,r,(o,u)=>{a(o,{limitHit:u,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class n{constructor(i,r){this.expression=i,this.root=r,this.init(i)}init(i){let r,a;Object.keys(i).filter(o=>i[o]).forEach(o=>{D.isAbsolute(o)?(r=r||w.getEmptyExpression(),r[o]=i[o]):(a=a||w.getEmptyExpression(),a[o]=i[o])}),this.absoluteParsedExpr=r&&w.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=a&&w.parse(a,{trimForExclusions:!0})}test(i,r,a){return this.relativeParsedExpr&&this.relativeParsedExpr(i,r,a)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,i),r,a)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...w.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...w.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...w.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...w.getPathTerms(this.relativeParsedExpr)),i}}function d(s){const i=s.trim().split(`
`),r=i[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return T.uppercaseFirstLetter(i[i.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=d}),define(De[291],Ie([1,0,97,23]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function D(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===s)}e.isUTFEncoding=D,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,_=512,k=512*8,w=512*128;var I;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(i,r){super(i),this.decodeStreamErrorKind=r}}e.DecodeStreamError=L;class y{constructor(i){this.iconvLiteDecoder=i}static async create(i){let r;if(i!==e.UTF8)r=(await new Promise((o,u)=>{J(["@vscode/iconv-lite-umd"],o,u)})).getDecoder(p(i));else{const a=new TextDecoder;r={write(o){return a.decode(o,{stream:!0})},end(){return a.decode()}}}return new y(r)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function S(s,i){const r=i.minBytesRequiredForDetection??i.guessEncoding?k:_;return new Promise((a,o)=>{const u=(0,l.newWriteableStream)(A=>A.join("")),h=[];let C=0,R,N;const M=async()=>{try{const A=await d({buffer:t.VSBuffer.concat(h),bytesRead:C},i.guessEncoding);if(A.seemsBinary&&i.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);A.encoding=await i.overwriteEncoding(A.encoding),R=await y.create(A.encoding);const z=R.write(t.VSBuffer.concat(h).buffer);u.write(z),h.length=0,C=0,a({stream:u,detected:A})}catch(A){N?.dispose(),u.destroy(),o(A)}};N=(0,l.listenStream)(s,{onData:async A=>{R?u.write(R.write(A.buffer)):(h.push(A),C+=A.byteLength,C>=r&&(s.pause(),await M(),setTimeout(()=>s.resume())))},onError:A=>u.error(A),onEnd:async()=>{R||await M(),u.end(R?.end())}})})}e.toDecodeStream=S;async function T(s,i,r){const o=(await new Promise((C,R)=>{J(["@vscode/iconv-lite-umd"],C,R)})).getEncoder(p(i),r);let u=!1,h=!1;return{read(){if(h)return null;const C=s.read();if(typeof C!="string"){if(h=!0,!u&&r?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=o.end();return R&&R.length>0?(u=!0,t.VSBuffer.wrap(R)):null}return u=!0,t.VSBuffer.wrap(o.write(C))}}}e.toEncodeReadable=T;async function E(s){return(await new Promise((r,a)=>{J(["@vscode/iconv-lite-umd"],r,a)})).encodingExists(p(s))}e.encodingExists=E;function p(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=p;function b(s,i){if(!s||i<e.UTF16be_BOM.length)return null;const r=s.readUInt8(0),a=s.readUInt8(1);if(r===e.UTF16be_BOM[0]&&a===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&a===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const o=s.readUInt8(2);return r===e.UTF8_BOM[0]&&a===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=b;const f=["ascii","utf-16","utf-32"];async function v(s){const i=await new Promise((h,C)=>{J(["jschardet"],h,C)}),r=s.slice(0,w),a=m(r.buffer),o=i.detect(a);if(!o||!o.encoding)return null;const u=o.encoding.toLowerCase();return 0<=f.indexOf(u)?null:c(o.encoding)}const g={ibm866:"cp866",big5:"cp950"};function c(s){const i=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return g[i]||i}function m(s){let i="";for(let r=0;r<s.length;r++)i+=String.fromCharCode(s[r]);return i}function n(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=s.match(/windows(\d+)/);return i?"windows-"+i[1]:s}}}e.toCanonicalName=n;function d({buffer:s,bytesRead:i},r){let a=b(s,i),o=!1;if(a!==e.UTF16be&&a!==e.UTF16le&&s){let u=!0,h=!0,C=!1;for(let R=0;R<i&&R<P;R++){const N=R%2===1,M=s.readUInt8(R)===0;if(M&&(C=!0),u&&(N&&!M||!N&&M)&&(u=!1),h&&(N&&M||!N&&!M)&&(h=!1),M&&!u&&!h)break}C&&(u?a=e.UTF16le:h?a=e.UTF16be:o=!0)}return r&&!o&&!a&&s?v(s.slice(0,i)).then(u=>({seemsBinary:!1,encoding:u})):{seemsBinary:o,encoding:a}}e.detectEncodingFromBuffer=d,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[142],Ie([1,0,291,29,141]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends D.TextSearchManager{constructor(k,w,I=t,L="searchProcess"){super(k,w,{readdir:y=>I.Promises.readdir(y.fsPath),toCanonicalName:y=>(0,l.toCanonicalName)(y)},L)}}e.NativeTextSearchManager=P}),define(De[292],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class l{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(D){if(D&&this._dragOperations.has(D)){const P=this._dragOperations.get(D);return this._dragOperations.delete(D),P}}addDragOperationTransfer(D,P){this._dragOperations.set(D,P)}getRenderedTreeElement(D){if(this._renderedElements.has(D))return this._renderedElements.get(D)}addRenderedTreeItemElement(D,P){this._renderedElements.set(D,P)}removeRenderedTreeItemElement(D){this._renderedElements.has(D)&&this._renderedElements.delete(D)}}e.TreeviewsService=l}),define(De[293],Ie([1,0,175,7,22,2,4,6,18,7,16,17,15,21,292,27]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function b(g,c){if((0,L.isString)(g))return{label:g};if(g&&typeof g=="object"&&typeof g.label=="string"){let m;return Array.isArray(g.highlights)&&(m=g.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),m=m.length?m:void 0),{label:g.label,highlights:m}}}class f{constructor(c,m,n){this._proxy=c,this.commands=m,this.logService=n,this.treeViews=new Map,this.treeDragAndDropService=new E.TreeviewsService;function d(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}m.registerArgumentProcessor({processArgument:s=>d(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(i=>d(i)?this.convertArgument(i):i):s})}registerTreeDataProvider(c,m,n){const d=this.createTreeView(c,{treeDataProvider:m},n);return{dispose:()=>d.dispose()}}createTreeView(c,m,n){if(!m||!m.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=m.dragAndDropController?.dropMimeTypes??[],s=m.dragAndDropController?.dragMimeTypes??[],i=!!m.dragAndDropController?.handleDrag,r=!!m.dragAndDropController?.handleDrop,a=this.createExtHostTreeView(c,m,n),o=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!m.showCollapseAll,canSelectMany:!!m.canSelectMany,dropMimeTypes:d,dragMimeTypes:s,hasHandleDrag:i,hasHandleDrop:r});return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get onDidChangeTreeCheckbox(){return(0,p.checkProposedApiEnabled)(n,"treeItemCheckbox"),a.onDidChangeTreeCheckbox},get message(){return a.message},set message(u){a.message=u},get title(){return a.title},set title(u){a.title=u},get description(){return a.description},set description(u){a.description=u},get badge(){return a.badge},set badge(u){a.badge=u},reveal:(u,h)=>a.reveal(u,h),dispose:async()=>{await o,this.treeViews.delete(c),a.dispose()}}}$getChildren(c,m){const n=this.treeViews.get(c);return n?n.getChildren(m):Promise.reject(new Error((0,l.localize)(0,null,c)))}async $handleDrop(c,m,n,d,s,i,r,a){const o=this.treeViews.get(c);if(!o)return Promise.reject(new Error((0,l.localize)(1,null,c)));const u=S.DataTransfer.toDataTransfer(n,async h=>(await this._proxy.$resolveDropFileData(c,m,h)).buffer);return r===c&&a&&await this.addAdditionalTransferItems(u,o,a,s,i),o.onDrop(u,d,s)}async addAdditionalTransferItems(c,m,n,d,s){const i=this.treeDragAndDropService.removeDragOperationTransfer(s);if(i)(await i)?.forEach((r,a)=>{r&&c.set(a,r)});else if(s&&m.handleDrag){const r=m.handleDrag(n,c,d);this.treeDragAndDropService.addDragOperationTransfer(s,r),await r}return c}async $handleDrag(c,m,n,d){const s=this.treeViews.get(c);if(!s)return Promise.reject(new Error((0,l.localize)(2,null,c)));const i=await this.addAdditionalTransferItems(new t.DataTransfer,s,m,d,n);if(!!i)return S.DataTransfer.toDataTransferDTO(i)}async $hasResolve(c){const m=this.treeViews.get(c);if(!m)throw new Error((0,l.localize)(3,null,c));return m.hasResolve}$resolve(c,m,n){const d=this.treeViews.get(c);if(!d)throw new Error((0,l.localize)(4,null,c));return d.resolveTreeItem(m,n)}$setExpanded(c,m,n){const d=this.treeViews.get(c);if(!d)throw new Error((0,l.localize)(5,null,c));d.setExpanded(m,n)}$setSelection(c,m){const n=this.treeViews.get(c);if(!n)throw new Error((0,l.localize)(6,null,c));n.setSelection(m)}$setFocus(c,m){const n=this.treeViews.get(c);if(!n)throw new Error((0,l.localize)(7,null,c));n.setFocus(m)}$setVisible(c,m){const n=this.treeViews.get(c);if(!n)throw new Error((0,l.localize)(8,null,c));n.setVisible(m)}$changeCheckboxState(c,m){const n=this.treeViews.get(c);if(!n)throw new Error((0,l.localize)(9,null,c));n.setCheckboxState(m)}createExtHostTreeView(c,m,n){const d=new v(c,m,this._proxy,this.commands.converter,this.logService,n);return this.treeViews.set(c,d),d}convertArgument(c){const m=this.treeViews.get(c.$treeViewId);return m&&"$treeItemHandle"in c?m.getExtensionElement(c.$treeItemHandle):m&&"$focusedTreeItem"in c&&c.$focusedTreeItem?m.focusedElement:null}}e.ExtHostTreeViews=f;class v extends k.Disposable{constructor(c,m,n,d,s,i){if(super(),this.viewId=c,this.proxy=n,this.commands=d,this.logService=s,this.extension=i,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeTreeCheckbox=this._register(new _.Emitter),this.onDidChangeTreeCheckbox=this._onDidChangeTreeCheckbox.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new T.CancellationTokenSource,i.contributes&&i.contributes.views)for(const o in i.contributes.views)for(const u of i.contributes.views[o])u.id===c&&(this._title=u.name);this.dataProvider=m.treeDataProvider,this.dndController=m.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let r,a;this._register(_.Event.debounce(this._onDidChangeData.event,(o,u)=>(o||(o={message:!1,elements:[]}),u.element!==!1&&(r||(r=new Promise(h=>a=h),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(u.element)?o.elements.push(...u.element):o.elements.push(u.element)),u.message&&(o.message=!0),o),200,!0)(({message:o,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=a;return r=null,this.refresh(u).then(()=>h())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,L.isUndefinedOrNull)(c))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}async getChildren(c){const m=c?this.getExtensionElement(c):void 0;if(c&&!m)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let n=this.getChildrenNodes(c);return n||(n=await this.fetchChildrenNodes(m)),n?n.map(d=>d.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,m){m=m||{select:!0,focus:!1};const n=(0,L.isUndefinedOrNull)(m.select)?!0:m.select,d=(0,L.isUndefinedOrNull)(m.focus)?!1:m.focus,s=(0,L.isUndefinedOrNull)(m.expand)?!1:m.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(i=>this.resolveTreeNode(c,i[i.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:i.map(a=>a.item)},{select:n,focus:d,expand:s})),i=>this.logService.error(i)):this.proxy.$reveal(this.viewId,void 0,{select:n,focus:d,expand:s})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}get badge(){return this._badge}set badge(c){this._badge?.value===c?.value&&this._badge?.tooltip===c?.tooltip||(this._badge=S.ViewBadge.from(c),this.proxy.$setBadge(this.viewId,c))}setExpanded(c,m){const n=this.getExtensionElement(c);n&&(m?this._onDidExpandElement.fire(Object.freeze({element:n})):this._onDidCollapseElement.fire(Object.freeze({element:n})))}setSelection(c){(0,y.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(c){this._focusedHandle=c}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(c){const m=(await Promise.all(c.map(async n=>{const d=this.getExtensionElement(n.treeItemHandle);return d?{extensionItem:d,treeItem:await this.dataProvider.getTreeItem(d),newState:n.newState?I.TreeItemCheckboxState.Checked:I.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);m.forEach(n=>{n.treeItem.checkboxState=n.newState?I.TreeItemCheckboxState.Checked:I.TreeItemCheckboxState.Unchecked}),this._onDidChangeTreeCheckbox.fire({items:m.map(n=>[n.extensionItem,n.newState])})}async handleDrag(c,m,n){const d=[];for(const s of c){const i=this.getExtensionElement(s);i&&d.push(i)}if(!(!this.dndController?.handleDrag||d.length===0))return await this.dndController.handleDrag(d,m,n),m}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(c,m,n){const d=m?this.getExtensionElement(m):void 0;if(!(!d&&m||!this.dndController?.handleDrop))return(0,w.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(d,c,n):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,m){if(!this.dataProvider.resolveTreeItem)return;const n=this.elements.get(c);if(n){const d=this.nodes.get(n);if(d){const s=await this.dataProvider.resolveTreeItem(d.extensionItem,n,m)??d.extensionItem;return this.validateTreeItem(s),d.item.tooltip=this.getTooltip(s.tooltip),d.item.command=this.getCommand(d.disposableStore,s.command),d.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(m=>m?this.resolveUnknownParentChain(m).then(n=>this.resolveTreeNode(m,n[n.length-1]).then(d=>(n.push(d),n))):Promise.resolve([]))}resolveParent(c){const m=this.nodes.get(c);return m?Promise.resolve(m.parent?this.elements.get(m.parent.item.handle):void 0):(0,w.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,m){const n=this.nodes.get(c);return n?Promise.resolve(n):(0,w.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(d=>this.createHandle(c,d,m,!0)).then(d=>this.getChildren(m?m.item.handle:void 0).then(()=>{const s=this.getExtensionElement(d);if(s){const i=this.nodes.get(s);if(i)return Promise.resolve(i)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(c){if(c){let m;if(typeof c=="string"){const n=this.getExtensionElement(c);m=n?this.nodes.get(n):void 0}else m=c;return m&&m.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const m=new T.CancellationTokenSource(this._refreshCancellationSource.token);try{const n=c?this.nodes.get(c):void 0,d=await this.dataProvider.getChildren(c);if(m.token.isCancellationRequested)return;const s=await Promise.all((0,y.coalesce)(d||[]).map(async i=>{const r=await this.dataProvider.getTreeItem(i);return r&&!m.token.isCancellationRequested?this.createAndRegisterTreeNode(i,r,n):null}));return m.token.isCancellationRequested?void 0:(0,y.coalesce)(s)}finally{m.dispose()}}refresh(c){if(c.some(n=>!n))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new T.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const n=this.getHandlesToRefresh(c);if(n.length)return this.refreshHandles(n)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const m=new Set,n=c.map(s=>this.nodes.get(s));for(const s of n)if(s&&!m.has(s.item.handle)){let i=s;for(;i&&i.parent&&n.findIndex(r=>i&&i.parent&&r&&r.item.handle===i.parent.item.handle)===-1;){const r=this.elements.get(i.parent.item.handle);i=r?this.nodes.get(r):void 0}i&&!i.parent&&m.add(s.item.handle)}const d=[];return m.forEach(s=>{const i=this.elements.get(s);if(i){const r=this.nodes.get(i);r&&(!r.parent||!m.has(r.parent.item.handle))&&d.push(s)}}),d}refreshHandles(c){const m={};return Promise.all(c.map(n=>this.refreshNode(n).then(d=>{d&&(m[n]=d.item)}))).then(()=>Object.keys(m).length?this.proxy.$refresh(this.viewId,m):void 0)}refreshNode(c){const m=this.getExtensionElement(c);if(m){const n=this.nodes.get(m);if(n)return this.clearChildren(m),(0,w.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(d=>{if(d){const s=this.createTreeNode(m,d,n.parent);return this.updateNodeCache(m,s,n,n.parent),n.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,m,n){const d=this.createTreeNode(c,m,n);if(m.id&&this.elements.has(d.item.handle))throw new Error((0,l.localize)(10,null,m.id));return this.addNodeToCache(c,d),this.addNodeToParentCache(d,n),d}getTooltip(c){return I.MarkdownString.isMarkdownString(c)?S.MarkdownString.from(c):c}getCommand(c,m){return m?{...this.commands.toInternal(m,c),originalId:m.command}:void 0}getCheckbox(c){if(!c.checkboxState)return;let m,n;return typeof c.checkboxState=="number"?m=c.checkboxState:(m=c.checkboxState.state,n=c.checkboxState.tooltip),{isChecked:m===I.TreeItemCheckboxState.Checked,tooltip:n}}validateTreeItem(c){if(!I.TreeItem.isTreeItem(c,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(c,m,n){this.validateTreeItem(m);const d=new k.DisposableStore,s=this.createHandle(c,m,n),i=this.getLightIconPath(m);return{item:{handle:s,parentHandle:n?n.item.handle:void 0,label:b(m.label,this.extension),description:m.description,resourceUri:m.resourceUri,tooltip:this.getTooltip(m.tooltip),command:this.getCommand(d,m.command),contextValue:m.contextValue,icon:i,iconDark:this.getDarkIconPath(m)||i,themeIcon:this.getThemeIcon(m),collapsibleState:(0,L.isUndefinedOrNull)(m.collapsibleState)?I.TreeItemCollapsibleState.None:m.collapsibleState,accessibilityInformation:m.accessibilityInformation,checkbox:this.getCheckbox(m)},extensionItem:m,parent:n,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(c){return c.iconPath instanceof I.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:m,label:n,resourceUri:d},s,i){if(m)return`${v.ID_HANDLE_PREFIX}/${m}`;const r=b(n,this.extension),a=s?s.item.handle:v.LABEL_HANDLE_PREFIX;let o=r?r.label:d?(0,D.basename)(d):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const u=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,h=this.getChildrenNodes(s)||[];let C,R=0;do{if(C=`${a}/${R}:${o}`,i||!this.elements.has(C)||u===C)break;R++}while(R<=h.length);return C}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof I.ThemeIcon))return typeof c.iconPath=="string"||P.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof I.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return P.URI.isUri(c)?c:P.URI.file(c)}addNodeToCache(c,m){this.elements.set(m.item.handle,c),this.nodes.set(c,m)}updateNodeCache(c,m,n,d){this.elements.delete(m.item.handle),this.nodes.delete(c),m.item.handle!==n.item.handle&&this.elements.delete(n.item.handle),this.addNodeToCache(c,m);const s=this.getChildrenNodes(d)||[],i=s.filter(r=>r.item.handle===n.item.handle)[0];i&&s.splice(s.indexOf(i),1,m)}addNodeToParentCache(c,m){m?(m.children||(m.children=[]),m.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const m=this.nodes.get(c);if(m){if(m.children)for(const n of m.children){const d=this.elements.get(n.item.handle);d&&this.clear(d)}m.children=void 0}}else this.clearAll()}clear(c){const m=this.nodes.get(c);if(m){if(m.children)for(const n of m.children){const d=this.elements.get(n.item.handle);d&&this.clear(d)}this.nodes.delete(c),this.elements.delete(m.item.handle),m.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(De[294],Ie([1,0,21,10,4,41,2,116,101,149,158,42,5,131,238,237,37,239,33,241,242,243,226,244,56,39,245,246,249,250,251,140,229,255,256,257,93,38,259,293,15,7,262,68,139,32,209,248,124,136,70,72,73,13,54,14,26,252,225,53,65,235,260,67,66,265,263,264,236,46,258,261,92,57,126,253,69,254,12,119,228,205,247,6,27,210,138,91]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f,v,g,c,m,n,d,s,i,r,a,o,u,h,C,R,N,M,A,z,H,F,G,B,U,X,$,x,Q,de,te,pe,Y,ve,be,ke,Re,We,oe,le,fe,Z,ae,ne,ie,O,V,q,K,me,we,ce,Ce,ye,He,je,Ze,Qe,Le,rt,re,se,Se,ue,Te,Me,Be,ze,Ye,nt,ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function pt(Je){const st=Je.get(le.IExtHostInitDataService),Et=Je.get(Ce.IExtHostFileSystemInfo),Lt=Je.get(q.IExtHostConsumerFileSystem),Dt=Je.get(i.IExtHostExtensionService),ft=Je.get(Q.IExtHostWorkspace),Pt=Je.get(Qe.IExtHostTelemetry),Ut=Je.get(v.IExtHostConfiguration),Wt=Je.get(We.IURITransformerService),Xe=Je.get(oe.IExtHostRpcService),Ft=Je.get(z.IExtHostStorage),At=Je.get(V.IExtensionStoragePaths),Nt=Je.get(Re.ILoggerService),gt=Je.get(Re.ILogService),Ae=Je.get(ae.IExtHostTunnelService),Oe=Je.get(nt.IExtHostTelemetryLogService),_e=Je.get(ne.IExtHostApiDeprecationService),ee=Je.get(x.IExtHostWindow),Fe=Je.get(je.IExtHostSecretState),Ve=Je.get(Ze.IExtHostEditorTabs);Xe.set(S.ExtHostContext.ExtHostFileSystemInfo,Et),Xe.set(S.ExtHostContext.ExtHostLogLevelServiceShape,Nt),Xe.set(S.ExtHostContext.ExtHostWorkspace,ft),Xe.set(S.ExtHostContext.ExtHostConfiguration,Ut),Xe.set(S.ExtHostContext.ExtHostExtensionService,Dt),Xe.set(S.ExtHostContext.ExtHostStorage,Ft),Xe.set(S.ExtHostContext.ExtHostTunnelService,Ae),Xe.set(S.ExtHostContext.ExtHostWindow,ee),Xe.set(S.ExtHostContext.ExtHostSecretState,Fe),Xe.set(S.ExtHostContext.ExtHostTelemetry,Pt),Xe.set(S.ExtHostContext.ExtHostEditorTabs,Ve);const ot=Xe.set(S.ExtHostContext.ExtHostDecorations,Je.get(Y.IExtHostDecorations)),Ge=Xe.set(S.ExtHostContext.ExtHostDocumentsAndEditors,Je.get(s.IExtHostDocumentsAndEditors)),it=Xe.set(S.ExtHostContext.ExtHostCommands,Je.get(b.IExtHostCommands)),ut=Xe.set(S.ExtHostContext.ExtHostTerminalService,Je.get(H.IExtHostTerminalService)),mt=Xe.set(S.ExtHostContext.ExtHostDebugService,Je.get(be.IExtHostDebugService)),It=Xe.set(S.ExtHostContext.ExtHostSearch,Je.get(ke.IExtHostSearch)),wt=Xe.set(S.ExtHostContext.ExtHostTask,Je.get(ve.IExtHostTask)),_t=Xe.set(S.ExtHostContext.ExtHostOutputService,Je.get(C.IExtHostOutputService)),Rt=Xe.set(S.ExtHostContext.ExtHostLocalization,Je.get(ct.IExtHostLocalizationService)),St=Xe.set(S.ExtHostContext.ExtHostUrls,new X.ExtHostUrls(Xe)),kt=Xe.set(S.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Xe,Ge)),Yt=Xe.set(S.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(Xe,Ge,gt)),qt=Xe.set(S.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(gt,kt,Xe.getProxy(S.MainContext.MainThreadBulkEdits))),bt=Xe.set(S.ExtHostContext.ExtHostNotebook,new fe.ExtHostNotebookController(Xe,it,Ge,kt)),tn=Xe.set(S.ExtHostContext.ExtHostNotebookDocuments,new Te.ExtHostNotebookDocuments(bt)),nn=Xe.set(S.ExtHostContext.ExtHostNotebookEditors,new ue.ExtHostNotebookEditors(gt,bt)),rn=Xe.set(S.ExtHostContext.ExtHostNotebookKernels,new Le.ExtHostNotebookKernels(Xe,st,bt,it,gt)),gn=Xe.set(S.ExtHostContext.ExtHostNotebookRenderers,new re.ExtHostNotebookRenderers(Xe,bt)),Ct=Xe.set(S.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Xe,Ge)),sn=Xe.set(S.ExtHostContext.ExtHostTreeViews,new G.ExtHostTreeViews(Xe.getProxy(S.MainContext.MainThreadTreeViews),it,gt)),On=Xe.set(S.ExtHostContext.ExtHostEditorInsets,new de.ExtHostEditorInsets(Xe.getProxy(S.MainContext.MainThreadEditorInsets),Ct,st.remote)),Jt=Xe.set(S.ExtHostContext.ExtHostDiagnostics,new g.ExtHostDiagnostics(Xe,gt,Et)),$t=Xe.set(S.ExtHostContext.ExtHostLanguages,new u.ExtHostLanguages(Xe,kt,it.converter,Wt)),dt=Xe.set(S.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(Xe,Wt,kt,it,Jt,gt,_e)),pn=Xe.set(S.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Xe,dt)),Ht=Xe.set(S.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(Xe,gt,Ge)),Gt=Xe.set(S.ExtHostContext.ExtHostQuickOpen,(0,N.createExtHostQuickOpen)(Xe,ft,it)),on=Xe.set(S.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(Xe,it,gt)),vn=Xe.set(S.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(Xe,it,kt)),an=Xe.set(S.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Xe.getProxy(S.MainContext.MainThreadProgress))),bn=Xe.set(S.ExtHostContext.ExtHosLabelService,new te.ExtHostLabelService(Xe)),In=Xe.set(S.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Xe)),cn=Xe.set(S.ExtHostContext.ExtHostAuthentication,new ie.ExtHostAuthentication(Xe)),wn=Xe.set(S.ExtHostContext.ExtHostTimeline,new O.ExtHostTimeline(Xe,it)),Zt=Xe.set(S.ExtHostContext.ExtHostWebviews,new $.ExtHostWebviews(Xe,st.remote,ft,gt,_e)),en=Xe.set(S.ExtHostContext.ExtHostWebviewPanels,new we.ExtHostWebviewPanels(Xe,Zt,ft)),En=Xe.set(S.ExtHostContext.ExtHostCustomEditors,new me.ExtHostCustomEditors(Xe,kt,At,Zt,en)),Fn=Xe.set(S.ExtHostContext.ExtHostWebviewViews,new K.ExtHostWebviewViews(Xe,Zt)),Kt=Xe.set(S.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(Xe,it,Ge)),Sn=Xe.set(S.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(Xe));Xe.set(S.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Xe,bt,Ge,it,gt));const Nn=Object.values(S.ExtHostContext);Xe.assertRegistered(Nn);const Mn=new ce.ExtHostBulkEdits(Xe,Ge),Un=new p.ExtHostClipboard(Xe),_n=new h.ExtHostMessageService(Xe,gt),kn=new c.ExtHostDialogs(Xe),Tn=new A.ExtHostStatusBar(Xe,it.converter);return E.ExtHostApiCommands.register(it),function($e,Bt,Pn){const vt=function(){let ge=!$e.isUnderDevelopment;function Ee(){ge||(gt.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Ne(at){if(Array.isArray(at))at.forEach(Ne);else if(typeof at=="string")Ee();else{const yt=at;typeof yt.scheme>"u"&&Ee(),typeof yt.exclusive=="boolean"&&(0,ze.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return at}}(),Bn={getSession(ge,Ee,Ne){return cn.getSession($e,ge,Ee,Ne)},async hasSession(ge,Ee){return(0,ze.checkProposedApiEnabled)($e,"authSession"),!!await cn.getSession($e,ge,Ee,{silent:!0})},get onDidChangeSessions(){return cn.onDidChangeSessions},registerAuthenticationProvider(ge,Ee,Ne,at){return cn.registerAuthenticationProvider(ge,Ee,Ne,at)}},ln={registerCommand(ge,Ee,Ne){return it.registerCommand(!0,ge,Ee,Ne,void 0,$e)},registerTextEditorCommand(ge,Ee,Ne){return it.registerCommand(!0,ge,(...at)=>{const yt=Ct.getActiveTextEditor();if(!yt){gt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return yt.edit(Tt=>{Ee.apply(Ne,[yt,Tt,...at])}).then(Tt=>{Tt||gt.warn("Edits from command "+ge+" were not applied.")},Tt=>{gt.warn("An error occurred while running command "+ge,Tt)})},void 0,void 0,$e)},registerDiffInformationCommand:(ge,Ee,Ne)=>((0,ze.checkProposedApiEnabled)($e,"diffCommand"),it.registerCommand(!0,ge,async(...at)=>{const yt=Ge.activeEditor(!0);if(!yt){gt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Tt=await Ct.getDiffInformation(yt.id);Ee.apply(Ne,[Tt,...at])},void 0,void 0,$e)),executeCommand(ge,...Ee){return it.executeCommand(ge,...Ee)},getCommands(ge=!1){return it.getCommands(ge)}},An={get machineId(){return st.telemetryInfo.machineId},get sessionId(){return st.telemetryInfo.sessionId},get language(){return st.environment.appLanguage},get appName(){return st.environment.appName},get appRoot(){return st.environment.appRoot?.fsPath??""},get appHost(){return st.environment.appHost},get uriScheme(){return st.environment.appUriScheme},get clipboard(){return Un.value},get shell(){return ut.getDefaultShell(!1)},get onDidChangeShell(){return(0,ze.checkProposedApiEnabled)($e,"envShellEvent"),ut.onDidChangeShell},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Pt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.checkProposedApiEnabled)($e,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.checkProposedApiEnabled)($e,"telemetry"),Pt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ge=Date.now()-new Date(st.telemetryInfo.firstSessionDate).getTime();return isNaN(ge)?!1:ge<1e3*60*60*24},openExternal(ge,Ee){return ee.openUri(ge,{allowTunneling:!!st.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===st.environment.appUriScheme)return St.createAppUri(ge);try{return await ee.asExternalUri(ge,{allowTunneling:!!st.remote.authority})}catch(Ee){if((0,Se.matchesScheme)(ge,se.Schemas.http)||(0,Se.matchesScheme)(ge,se.Schemas.https))return ge;throw Ee}},get remoteName(){return(0,pe.getRemoteName)(st.remote.authority)},get remoteAuthority(){return(0,ze.checkProposedApiEnabled)($e,"resolvers"),st.remote.authority},get uiKind(){return st.uiKind}};st.environment.extensionTestsLocationURI||Object.freeze(An);const zn={createTestController(ge,Ee,Ne){return Kt.createTestController(ge,Ee,Ne)},createTestObserver(){return(0,ze.checkProposedApiEnabled)($e,"testObserver"),Kt.createTestObserver()},runTests(ge){return(0,ze.checkProposedApiEnabled)($e,"testObserver"),Kt.runTests(ge)},get onDidChangeTestResults(){return(0,ze.checkProposedApiEnabled)($e,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,ze.checkProposedApiEnabled)($e,"testObserver"),Kt.results}},un=st.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Wn={getExtension(ge,Ee){(0,ze.isProposedApiEnabled)($e,"extensionsAny")||(Ee=!1);const Ne=Bt.mine.getExtensionDescription(ge);if(Ne)return new i.Extension(Dt,$e.identifier,Ne,un,!1);if(Ee){const at=Bt.all.getExtensionDescription(ge);if(at)return new i.Extension(Dt,$e.identifier,at,un,!0)}},get all(){const ge=[];for(const Ee of Bt.mine.getAllExtensionDescriptions())ge.push(new i.Extension(Dt,$e.identifier,Ee,un,!1));return ge},get allAcrossExtensionHosts(){(0,ze.checkProposedApiEnabled)($e,"extensionsAny");const ge=new ze.ExtensionIdentifierSet(Bt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),Ee=[];for(const Ne of Bt.all.getAllExtensionDescriptions()){const at=!ge.has(Ne.identifier);Ee.push(new i.Extension(Dt,$e.identifier,Ne,un,at))}return Ee},get onDidChange(){return(0,ze.isProposedApiEnabled)($e,"extensionsAny")?D.Event.any(Bt.mine.onDidChange,Bt.all.onDidChange):Bt.mine.onDidChange}},yn={createDiagnosticCollection(ge){return Jt.createDiagnosticCollection($e.identifier,ge)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:ge=>Jt.getDiagnostics(ge),getLanguages(){return $t.getLanguages()},setTextDocumentLanguage(ge,Ee){return $t.changeLanguage(ge.uri,Ee)},match(ge,Ee){const Ne=kt.getDocumentData(Ee.uri)?.notebook;return(0,L.score)(B.LanguageSelector.from(ge),Ee.uri,Ee.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(ge,Ee,Ne){return dt.registerCodeActionProvider($e,vt(ge),Ee,Ne)},registerDocumentPasteEditProvider(ge,Ee,Ne){return(0,ze.checkProposedApiEnabled)($e,"documentPaste"),dt.registerDocumentPasteEditProvider($e,vt(ge),Ee,Ne)},registerCodeLensProvider(ge,Ee){return dt.registerCodeLensProvider($e,vt(ge),Ee)},registerDefinitionProvider(ge,Ee){return dt.registerDefinitionProvider($e,vt(ge),Ee)},registerDeclarationProvider(ge,Ee){return dt.registerDeclarationProvider($e,vt(ge),Ee)},registerImplementationProvider(ge,Ee){return dt.registerImplementationProvider($e,vt(ge),Ee)},registerTypeDefinitionProvider(ge,Ee){return dt.registerTypeDefinitionProvider($e,vt(ge),Ee)},registerHoverProvider(ge,Ee){return dt.registerHoverProvider($e,vt(ge),Ee,$e.identifier)},registerEvaluatableExpressionProvider(ge,Ee){return dt.registerEvaluatableExpressionProvider($e,vt(ge),Ee,$e.identifier)},registerInlineValuesProvider(ge,Ee){return dt.registerInlineValuesProvider($e,vt(ge),Ee,$e.identifier)},registerDocumentHighlightProvider(ge,Ee){return dt.registerDocumentHighlightProvider($e,vt(ge),Ee)},registerLinkedEditingRangeProvider(ge,Ee){return dt.registerLinkedEditingRangeProvider($e,vt(ge),Ee)},registerReferenceProvider(ge,Ee){return dt.registerReferenceProvider($e,vt(ge),Ee)},registerRenameProvider(ge,Ee){return dt.registerRenameProvider($e,vt(ge),Ee)},registerDocumentSymbolProvider(ge,Ee,Ne){return dt.registerDocumentSymbolProvider($e,vt(ge),Ee,Ne)},registerWorkspaceSymbolProvider(ge){return dt.registerWorkspaceSymbolProvider($e,ge)},registerDocumentFormattingEditProvider(ge,Ee){return dt.registerDocumentFormattingEditProvider($e,vt(ge),Ee)},registerDocumentRangeFormattingEditProvider(ge,Ee){return dt.registerDocumentRangeFormattingEditProvider($e,vt(ge),Ee)},registerOnTypeFormattingEditProvider(ge,Ee,Ne,...at){return dt.registerOnTypeFormattingEditProvider($e,vt(ge),Ee,[Ne].concat(at))},registerDocumentSemanticTokensProvider(ge,Ee,Ne){return dt.registerDocumentSemanticTokensProvider($e,vt(ge),Ee,Ne)},registerDocumentRangeSemanticTokensProvider(ge,Ee,Ne){return dt.registerDocumentRangeSemanticTokensProvider($e,vt(ge),Ee,Ne)},registerSignatureHelpProvider(ge,Ee,Ne,...at){return typeof Ne=="object"?dt.registerSignatureHelpProvider($e,vt(ge),Ee,Ne):dt.registerSignatureHelpProvider($e,vt(ge),Ee,typeof Ne>"u"?[]:[Ne,...at])},registerCompletionItemProvider(ge,Ee,...Ne){return dt.registerCompletionItemProvider($e,vt(ge),Ee,Ne)},registerInlineCompletionItemProvider(ge,Ee){return Ee.handleDidShowCompletionItem&&(0,ze.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider($e,vt(ge),Ee)},registerInlineCompletionItemProviderNew(ge,Ee){if((0,ze.checkProposedApiEnabled)($e,"inlineCompletionsNew"),Ee.handleDidShowCompletionItem&&!(0,ze.isProposedApiEnabled)($e,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew($e,vt(ge),Ee)},registerDocumentLinkProvider(ge,Ee){return dt.registerDocumentLinkProvider($e,vt(ge),Ee)},registerColorProvider(ge,Ee){return dt.registerColorProvider($e,vt(ge),Ee)},registerFoldingRangeProvider(ge,Ee){return dt.registerFoldingRangeProvider($e,vt(ge),Ee)},registerSelectionRangeProvider(ge,Ee){return dt.registerSelectionRangeProvider($e,ge,Ee)},registerCallHierarchyProvider(ge,Ee){return dt.registerCallHierarchyProvider($e,ge,Ee)},registerTypeHierarchyProvider(ge,Ee){return dt.registerTypeHierarchyProvider($e,ge,Ee)},setLanguageConfiguration:(ge,Ee)=>dt.setLanguageConfiguration($e,ge,Ee),getTokenInformationAtPosition(ge,Ee){return(0,ze.checkProposedApiEnabled)($e,"tokenInformation"),$t.tokenAtPosition(ge,Ee)},registerInlayHintsProvider(ge,Ee){return dt.registerInlayHintsProvider($e,ge,Ee)},createLanguageStatusItem(ge,Ee){return $t.createLanguageStatusItem($e,ge,Ee)},registerDocumentDropEditProvider(ge,Ee){return dt.registerDocumentOnDropEditProvider($e,ge,Ee)}},$n={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(ge,Ee,Ne){const at=await(_.URI.isUri(ge)?Promise.resolve(xt.openTextDocument(ge)):Promise.resolve(ge));return Ct.showTextDocument(at,Ee,Ne)},createTextEditorDecorationType(ge){return Ct.createTextEditorDecorationType($e,ge)},onDidChangeActiveTextEditor(ge,Ee,Ne){return Ct.onDidChangeActiveTextEditor(ge,Ee,Ne)},onDidChangeVisibleTextEditors(ge,Ee,Ne){return Ct.onDidChangeVisibleTextEditors(ge,Ee,Ne)},onDidChangeTextEditorSelection(ge,Ee,Ne){return Ct.onDidChangeTextEditorSelection(ge,Ee,Ne)},onDidChangeTextEditorOptions(ge,Ee,Ne){return Ct.onDidChangeTextEditorOptions(ge,Ee,Ne)},onDidChangeTextEditorVisibleRanges(ge,Ee,Ne){return Ct.onDidChangeTextEditorVisibleRanges(ge,Ee,Ne)},onDidChangeTextEditorViewColumn(ge,Ee,Ne){return Ct.onDidChangeTextEditorViewColumn(ge,Ee,Ne)},onDidCloseTerminal(ge,Ee,Ne){return ut.onDidCloseTerminal(ge,Ee,Ne)},onDidOpenTerminal(ge,Ee,Ne){return ut.onDidOpenTerminal(ge,Ee,Ne)},onDidChangeActiveTerminal(ge,Ee,Ne){return ut.onDidChangeActiveTerminal(ge,Ee,Ne)},onDidChangeTerminalDimensions(ge,Ee,Ne){return(0,ze.checkProposedApiEnabled)($e,"terminalDimensions"),ut.onDidChangeTerminalDimensions(ge,Ee,Ne)},onDidChangeTerminalState(ge,Ee,Ne){return ut.onDidChangeTerminalState(ge,Ee,Ne)},onDidWriteTerminalData(ge,Ee,Ne){return(0,ze.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),ut.onDidWriteTerminalData(ge,Ee,Ne)},get state(){return ee.state},onDidChangeWindowState(ge,Ee,Ne){return ee.onDidChangeWindowState(ge,Ee,Ne)},showInformationMessage(ge,...Ee){return _n.showMessage($e,P.default.Info,ge,Ee[0],Ee.slice(1))},showWarningMessage(ge,...Ee){return _n.showMessage($e,P.default.Warning,ge,Ee[0],Ee.slice(1))},showErrorMessage(ge,...Ee){return _n.showMessage($e,P.default.Error,ge,Ee[0],Ee.slice(1))},showQuickPick(ge,Ee,Ne){return Gt.showQuickPick(ge,Ee,Ne)},showWorkspaceFolderPick(ge){return Gt.showWorkspaceFolderPick(ge)},showInputBox(ge,Ee){return Gt.showInput(ge,Ee)},showOpenDialog(ge){return kn.showOpenDialog(ge)},showSaveDialog(ge){return kn.showSaveDialog(ge)},createStatusBarItem(ge,Ee,Ne){let at,yt,Tt;return typeof ge=="string"?(at=ge,yt=Ee,Tt=Ne):(yt=ge,Tt=Ee),Tn.createStatusBarEntry($e,at,yt,Tt)},setStatusBarMessage(ge,Ee){return Tn.setStatusBarMessage(ge,Ee)},withScmProgress(ge){return _e.report("window.withScmProgress",$e,"Use 'withProgress' instead."),an.withProgress($e,{location:U.ProgressLocation.SourceControl},(Ee,Ne)=>ge({report(at){}}))},withProgress(ge,Ee){return an.withProgress($e,ge,Ee)},createOutputChannel(ge,Ee){return _t.createOutputChannel(ge,Ee,$e)},createWebviewPanel(ge,Ee,Ne,at){return en.createWebviewPanel($e,ge,Ee,Ne,at)},createWebviewTextEditorInset(ge,Ee,Ne,at){return(0,ze.checkProposedApiEnabled)($e,"editorInsets"),On.createWebviewEditorInset(ge,Ee,Ne,at,$e)},createTerminal(ge,Ee,Ne){return typeof ge=="object"?"pty"in ge?ut.createExtensionTerminal(ge):ut.createTerminalFromOptions(ge):ut.createTerminal(ge,Ee,Ne)},registerTerminalLinkProvider(ge){return ut.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,Ee){return ut.registerProfileProvider($e,ge,Ee)},registerTreeDataProvider(ge,Ee){return sn.registerTreeDataProvider(ge,Ee,$e)},createTreeView(ge,Ee){return sn.createTreeView(ge,Ee,$e)},registerWebviewPanelSerializer:(ge,Ee)=>en.registerWebviewPanelSerializer($e,ge,Ee),registerCustomEditorProvider:(ge,Ee,Ne={})=>En.registerCustomEditorProvider($e,ge,Ee,Ne),registerFileDecorationProvider(ge){return ot.registerFileDecorationProvider(ge,$e.identifier)},registerUriHandler(ge){return St.registerUriHandler($e.identifier,ge)},createQuickPick(){return Gt.createQuickPick($e)},createInputBox(){return Gt.createInputBox($e)},get activeColorTheme(){return In.activeColorTheme},onDidChangeActiveColorTheme(ge,Ee,Ne){return In.onDidChangeActiveColorTheme(ge,Ee,Ne)},registerWebviewViewProvider(ge,Ee,Ne){return Fn.registerWebviewViewProvider($e,ge,Ee,Ne?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,Ee,Ne){return bt.onDidChangeActiveNotebookEditor(ge,Ee,Ne)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,Ee,Ne){return nn.onDidChangeNotebookEditorSelection(ge,Ee,Ne)},onDidChangeNotebookEditorVisibleRanges(ge,Ee,Ne){return nn.onDidChangeNotebookEditorVisibleRanges(ge,Ee,Ne)},showNotebookDocument(ge,Ee){return _.URI.isUri(ge)&&_e.report("window.showNotebookDocument(uri)",$e,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),bt.showNotebookDocument(ge,Ee)},registerExternalUriOpener(ge,Ee,Ne){return(0,ze.checkProposedApiEnabled)($e,"externalUriOpener"),Sn.registerExternalUriOpener($e.identifier,ge,Ee,Ne)},get tabGroups(){return Ve.tabGroups},logTelemetryToOutputChannel(ge,Ee){(0,ze.checkProposedApiEnabled)($e,"telemetryLog"),Oe.logToTelemetryOutputChannel($e,ge,Ee)}},xt={get rootPath(){return _e.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ge){throw t.readonly()},getWorkspaceFolder(ge){return ft.getWorkspaceFolder(ge)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ge){throw t.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ge){throw t.readonly()},updateWorkspaceFolders:(ge,Ee,...Ne)=>ft.updateWorkspaceFolders($e,ge,Ee||0,...Ne),onDidChangeWorkspaceFolders:function(ge,Ee,Ne){return ft.onDidChangeWorkspace(ge,Ee,Ne)},asRelativePath:(ge,Ee)=>ft.getRelativePath(ge,Ee),findFiles:(ge,Ee,Ne,at)=>ft.findFiles(ge,Ee,Ne,$e.identifier,at),findTextInFiles:(ge,Ee,Ne,at)=>{(0,ze.checkProposedApiEnabled)($e,"findTextInFiles");let yt,Tt;return typeof Ee=="object"?(yt=Ee,Tt=Ne):(yt={},Tt=Ee,at=Ne),ft.findTextInFiles(ge,yt||{},Tt,$e.identifier,at)},saveAll:ge=>ft.saveAll(ge),applyEdit(ge,Ee){return Mn.applyWorkspaceEdit(ge,$e,Ee)},createFileSystemWatcher:(ge,Ee,Ne,at)=>Ht.createFileSystemWatcher(ft,$e,ge,Ee,Ne,at),get textDocuments(){return kt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw t.readonly()},openTextDocument(ge){let Ee;const Ne=ge;if(typeof ge=="string")Ee=Promise.resolve(_.URI.file(ge));else if(_.URI.isUri(ge))Ee=Promise.resolve(ge);else if(!Ne||typeof Ne=="object")Ee=kt.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(at=>kt.ensureDocumentData(at).then(yt=>yt.document))},onDidOpenTextDocument:(ge,Ee,Ne)=>kt.onDidAddDocument(ge,Ee,Ne),onDidCloseTextDocument:(ge,Ee,Ne)=>kt.onDidRemoveDocument(ge,Ee,Ne),onDidChangeTextDocument:(ge,Ee,Ne)=>kt.onDidChangeDocument(ge,Ee,Ne),onDidSaveTextDocument:(ge,Ee,Ne)=>kt.onDidSaveDocument(ge,Ee,Ne),onWillSaveTextDocument:(ge,Ee,Ne)=>qt.getOnWillSaveTextDocumentEvent($e)(ge,Ee,Ne),get notebookDocuments(){return bt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,Ee){let Ne;if(_.URI.isUri(ge))Ne=ge,await bt.openNotebookDocument(ge);else if(typeof ge=="string")Ne=_.URI.revive(await bt.createNotebookDocument({viewType:ge,content:Ee}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ge,Ee,Ne){return tn.onDidSaveNotebookDocument(ge,Ee,Ne)},onDidChangeNotebookDocument(ge,Ee,Ne){return tn.onDidChangeNotebookDocument(ge,Ee,Ne)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(ge,Ee,Ne,at){return bt.registerNotebookSerializer($e,ge,Ee,Ne,(0,ze.isProposedApiEnabled)($e,"notebookLiveShare")?at:void 0)},registerNotebookContentProvider:(ge,Ee,Ne,at)=>((0,ze.checkProposedApiEnabled)($e,"notebookContentProvider"),_e.report("workspace.registerNotebookContentProvider",$e,"The notebookContentProvider API is not on track for finalization and will be removed."),bt.registerNotebookContentProvider($e,ge,Ee,Ne,(0,ze.isProposedApiEnabled)($e,"notebookLiveShare")?at:void 0)),onDidChangeConfiguration:(ge,Ee,Ne)=>Pn.onDidChangeConfiguration(ge,Ee,Ne),getConfiguration(ge,Ee){return Ee=arguments.length===1?void 0:Ee,Pn.getConfiguration(ge,Ee,$e)},registerTextDocumentContentProvider(ge,Ee){return Yt.registerTextDocumentContentProvider(ge,Ee)},registerTaskProvider:(ge,Ee)=>(_e.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),wt.registerTaskProvider($e,ge,Ee)),registerFileSystemProvider(ge,Ee,Ne){return(0,Be.combinedDisposable)(pn.registerFileSystemProvider($e,ge,Ee,Ne),Lt.addFileSystemProvider(ge,Ee))},get fs(){return Lt.value},registerFileSearchProvider:(ge,Ee)=>((0,ze.checkProposedApiEnabled)($e,"fileSearchProvider"),It.registerFileSearchProvider(ge,Ee)),registerTextSearchProvider:(ge,Ee)=>((0,ze.checkProposedApiEnabled)($e,"textSearchProvider"),It.registerTextSearchProvider(ge,Ee)),registerRemoteAuthorityResolver:(ge,Ee)=>((0,ze.checkProposedApiEnabled)($e,"resolvers"),Dt.registerRemoteAuthorityResolver(ge,Ee)),registerResourceLabelFormatter:ge=>((0,ze.checkProposedApiEnabled)($e,"resolvers"),bn.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,Ee,Ne)=>Ht.onDidCreateFile(ge,Ee,Ne),onDidDeleteFiles:(ge,Ee,Ne)=>Ht.onDidDeleteFile(ge,Ee,Ne),onDidRenameFiles:(ge,Ee,Ne)=>Ht.onDidRenameFile(ge,Ee,Ne),onWillCreateFiles:(ge,Ee,Ne)=>Ht.getOnWillCreateFileEvent($e)(ge,Ee,Ne),onWillDeleteFiles:(ge,Ee,Ne)=>Ht.getOnWillDeleteFileEvent($e)(ge,Ee,Ne),onWillRenameFiles:(ge,Ee,Ne)=>Ht.getOnWillRenameFileEvent($e)(ge,Ee,Ne),openTunnel:ge=>((0,ze.checkProposedApiEnabled)($e,"resolvers"),Ae.openTunnel($e,ge).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,ze.checkProposedApiEnabled)($e,"resolvers"),Ae.getTunnels()},onDidChangeTunnels:(ge,Ee,Ne)=>((0,ze.checkProposedApiEnabled)($e,"resolvers"),Ae.onDidChangeTunnels(ge,Ee,Ne)),registerPortAttributesProvider:(ge,Ee)=>((0,ze.checkProposedApiEnabled)($e,"portsAttributes"),Ae.registerPortsAttributesProvider(ge,Ee)),registerTimelineProvider:(ge,Ee)=>((0,ze.checkProposedApiEnabled)($e,"timeline"),wn.registerTimelineProvider(ge,Ee,$e.identifier,it.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ge=>((0,ze.checkProposedApiEnabled)($e,"workspaceTrust"),ft.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,Ee,Ne)=>ft.onDidGrantWorkspaceTrust(ge,Ee,Ne),registerEditSessionIdentityProvider:(ge,Ee)=>((0,ze.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ge,Ee))},dn={get inputBox(){return _e.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),on.getLastInputBox($e)},createSourceControl(ge,Ee,Ne){return on.createSourceControl($e,ge,Ee,Ne)}},Hn={createCommentController(ge,Ee){return vn.createCommentController($e,ge,Ee)}},Mt={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(ge,Ee,Ne){return mt.onDidStartDebugSession(ge,Ee,Ne)},onDidTerminateDebugSession(ge,Ee,Ne){return mt.onDidTerminateDebugSession(ge,Ee,Ne)},onDidChangeActiveDebugSession(ge,Ee,Ne){return mt.onDidChangeActiveDebugSession(ge,Ee,Ne)},onDidReceiveDebugSessionCustomEvent(ge,Ee,Ne){return mt.onDidReceiveDebugSessionCustomEvent(ge,Ee,Ne)},onDidChangeBreakpoints(ge,Ee,Ne){return mt.onDidChangeBreakpoints(ge,Ee,Ne)},registerDebugConfigurationProvider(ge,Ee,Ne){return mt.registerDebugConfigurationProvider(ge,Ee,Ne||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,Ee){return mt.registerDebugAdapterDescriptorFactory($e,ge,Ee)},registerDebugAdapterTrackerFactory(ge,Ee){return mt.registerDebugAdapterTrackerFactory(ge,Ee)},startDebugging(ge,Ee,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?mt.startDebugging(ge,Ee,{parentSession:Ne}):mt.startDebugging(ge,Ee,Ne||{})},stopDebugging(ge){return mt.stopDebugging(ge)},addBreakpoints(ge){return mt.addBreakpoints(ge)},removeBreakpoints(ge){return mt.removeBreakpoints(ge)},asDebugSourceUri(ge,Ee){return mt.asDebugSourceUri(ge,Ee)}},hn={registerTaskProvider:(ge,Ee)=>wt.registerTaskProvider($e,ge,Ee),fetchTasks:ge=>wt.fetchTasks(ge),executeTask:ge=>wt.executeTask($e,ge),get taskExecutions(){return wt.taskExecutions},onDidStartTask:(ge,Ee,Ne)=>wt.onDidStartTask(ge,Ee,Ne),onDidEndTask:(ge,Ee,Ne)=>wt.onDidEndTask(ge,Ee,Ne),onDidStartTaskProcess:(ge,Ee,Ne)=>wt.onDidStartTaskProcess(ge,Ee,Ne),onDidEndTaskProcess:(ge,Ee,Ne)=>wt.onDidEndTaskProcess(ge,Ee,Ne)},xn={createNotebookController(ge,Ee,Ne,at,yt){return rn.createNotebookController($e,ge,Ee,Ne,at,(0,ze.isProposedApiEnabled)($e,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ge,Ee)=>bt.registerNotebookCellStatusBarItemProvider($e,ge,Ee),createRendererMessaging(ge){return gn.createRendererMessaging($e,ge)},onDidChangeNotebookCellExecutionState(ge,Ee,Ne){return(0,ze.checkProposedApiEnabled)($e,"notebookCellExecutionState"),rn.onDidChangeNotebookCellExecutionState(ge,Ee,Ne)}},Vn={t(...ge){if((0,ze.checkProposedApiEnabled)($e,"localization"),typeof ge[0]=="string"){const Ee=ge.shift();return Rt.getMessage($e.identifier.value,{message:Ee,args:ge})}return Rt.getMessage($e.identifier.value,ge[0])},get bundle(){return(0,ze.checkProposedApiEnabled)($e,"localization"),Rt.getBundle($e.identifier.value)},get uri(){return(0,ze.checkProposedApiEnabled)($e,"localization"),Rt.getBundleUri($e.identifier.value)}};return{version:st.version,authentication:Bn,commands:ln,comments:Hn,debug:Mt,env:An,extensions:Wn,l10n:Vn,languages:yn,notebooks:xn,scm:dn,tasks:hn,tests:zn,window:$n,workspace:xt,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:l.CancellationTokenSource,CandidatePortSource:S.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CommentThreadState:U.CommentThreadState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:U.InlineCompletionTriggerKindNew,EventEmitter:D.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionItemNew:U.InlineSuggestionNew,InlineCompletionList:U.InlineSuggestionList,InlineCompletionListNew:U.InlineSuggestionsNew,Hover:U.Hover,IndentAction:I.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,SnippetTextEdit:U.SnippetTextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItem2:U.TreeItem,TreeItemCheckboxState:U.TreeItemCheckboxState,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:T.UIKind,Uri:_.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,DocumentDropEdit:U.DocumentDropEdit,DocumentPasteEdit:U.DocumentPasteEdit,InlayHint:U.InlayHint,InlayHintLabelPart:U.InlayHintLabelPart,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,NotebookEdit:U.NotebookEdit,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:rt.TextSearchCompleteMessageType,DataTransfer:U.DataTransfer,DataTransferItem:U.DataTransferItem,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity,QuickPickItemKind:U.QuickPickItemKind,InputBoxValidationSeverity:U.InputBoxValidationSeverity,TabInputText:U.TextTabInput,TabInputTextDiff:U.TextDiffTabInput,TabInputTextMerge:U.TextMergeTabInput,TabInputCustom:U.CustomEditorTabInput,TabInputNotebook:U.NotebookEditorTabInput,TabInputNotebookDiff:U.NotebookDiffEditorTabInput,TabInputWebview:U.WebviewEditorTabInput,TabInputTerminal:U.TerminalEditorTabInput,TabInputInteractiveWindow:U.InteractiveWindowInput,TerminalExitReason:U.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=pt}),define(De[295],Ie([1,0,267,304,305,2,306]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(y,S,T,E,p,b){const f=b.environment.useHostProxy,v=typeof f=="boolean"?f:!b.remote.isRemote,g=(0,_.createProxyResolver)({resolveProxy:m=>y.resolveProxy(m),getHttpProxySetting:()=>S.getConfiguration("http").get("proxy"),log:(m,n,...d)=>{switch(m){case _.LogLevel.Trace:E.trace(n,...d);break;case _.LogLevel.Debug:E.debug(n,...d);break;case _.LogLevel.Info:E.info(n,...d);break;case _.LogLevel.Warning:E.warn(n,...d);break;case _.LogLevel.Error:E.error(n,...d);break;case _.LogLevel.Critical:E.critical(n,...d);break;case _.LogLevel.Off:break;default:s(m,n,d);break}function s(i,r,...a){E.error("Unknown log level",i),E.error(r,...a)}},getLogLevel:()=>E.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:v,env:process.env}),c=w(S,g);return L(T,c)}e.connectProxyResolver=k;function w(y,S){const T={config:y.getConfiguration("http").get("proxySupport")||"off"};y.onDidChangeConfiguration(p=>{T.config=y.getConfiguration("http").get("proxySupport")||"off"});const E={config:!!y.getConfiguration("http").get("systemCertificates")};return y.onDidChangeConfiguration(p=>{E.config=!!y.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},l,(0,_.createHttpPatch)(l,S,{config:"off"},E,!0)),on:Object.assign({},l,(0,_.createHttpPatch)(l,S,{config:"on"},E,!0)),override:Object.assign({},l,(0,_.createHttpPatch)(l,S,{config:"override"},E,!0)),onRequest:Object.assign({},l,(0,_.createHttpPatch)(l,S,T,E,!0)),default:Object.assign(l,(0,_.createHttpPatch)(l,S,T,E,!1))},https:{off:Object.assign({},t,(0,_.createHttpPatch)(t,S,{config:"off"},E,!0)),on:Object.assign({},t,(0,_.createHttpPatch)(t,S,{config:"on"},E,!0)),override:Object.assign({},t,(0,_.createHttpPatch)(t,S,{config:"override"},E,!0)),onRequest:Object.assign({},t,(0,_.createHttpPatch)(t,S,T,E,!0)),default:Object.assign(t,(0,_.createHttpPatch)(t,S,T,E,!1))},tls:Object.assign(D,(0,_.createTlsPatch)(D))}}const I=new Map;function L(y,S){return y.getExtensionPathIndex().then(T=>{const E=J.__$__nodeRequire("module"),p=E._load;E._load=function(f,v,g){if(f==="tls")return S.tls;if(f!=="http"&&f!=="https")return p.apply(this,arguments);const c=S[f],m=T.findSubstr(P.URI.file(v.filename));let n=I.get(m);if(n||I.set(m,n={}),!n[f]){const d=c.default;n[f]={...d}}return n[f]}})}}),define(De[296],Ie([1,0,71,294,281,295,39,269,2,12,7,266,110,268]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class E extends D.RequireInterceptor{_installInterceptor(){const f=this,v=J.__$__nodeRequire("module"),g=v._load;v._load=function(d,s,i){return d=m(d),f._factories.has(d)?f._factories.get(d).load(d,w.URI.file((0,S.realpathSync)(s.filename)),r=>g.apply(this,[r,s,i])):g.apply(this,arguments)};const c=v._resolveLookupPaths;v._resolveLookupPaths=(n,d)=>c.call(this,m(n),d);const m=n=>{for(const d of f._alternatives){const s=d(n);if(s){n=s;break}}return n}}}class p extends _.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(T.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(k.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const c=this._instaService.createInstance(y.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}await this._instaService.createInstance(E,f,{mine:this._myRegistry,all:this._globalRegistry}).install(),l.mark("code/extHost/didInitAPI");const g=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,g,this,this._logService,this._mainThreadTelemetryProxy,this._initData),l.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(f){return f.main}async _loadCommonJSModule(f,v,g){if(v.scheme!==I.Schemas.file)throw new Error(`Cannot load URI: '${v}', must be of file-scheme`);let c=null;g.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${v.toString(!0)}`),this._logService.flush();const m=f?.identifier.value;f&&await this._extHostLocalizationService.initializeLocalizedMessages(f);try{m&&l.mark(`code/extHost/willLoadExtensionCode/${m}`),c=J.__$__nodeRequire(v.fsPath)}finally{m&&l.mark(`code/extHost/didLoadExtensionCode/${m}`),g.codeLoadingStop()}return c}async $setRemoteEnvironment(f){if(!!this._initData.remote.isRemote)for(const v in f){const g=f[v];g===null?delete process.env[v]:process.env[v]=g}}}e.ExtHostExtensionService=p}),define(De[143],Ie([1,0,44,307,290,17,75,36,9,8,2,30,69,308,288,94]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const b=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(h){this.outputChannel=h}provideTextSearchResults(h,C,R,N){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify({...C,folder:C.folder.toString()})}`),new Promise((M,A)=>{N.onCancellationRequested(()=>$());const z=d(h,C),H=C.folder.fsPath,F=z.map(pe=>pe.match(/^-/)?pe:`'${pe}'`).join(" ");this.outputChannel.appendLine(`${b} ${F}
 - cwd: ${H}`);let G=l.spawn(b,z,{cwd:H});G.on("error",pe=>{console.error(pe),this.outputChannel.appendLine("Error: "+(pe&&pe.message)),A((0,y.serializeSearchError)(new y.SearchError(pe&&pe.message,y.SearchErrorCode.rgProcessError)))});let B=!1;const U=new c(C.maxResults,H,C.previewOptions);U.on("result",pe=>{B=!0,Q="",R.report(pe)});let X=!1;const $=()=>{X=!0,G?.kill(),U?.cancel()};let x=!1;U.on("hitLimit",()=>{x=!0,$()});let Q="";G.stdout.on("data",pe=>{U.handleData(pe),B||(Q+=pe)});let de=!1;G.stdout.once("data",()=>de=!0);let te="";G.stderr.on("data",pe=>{const Y=pe.toString();this.outputChannel.appendLine(Y),te.length+Y.length<1e6&&(te+=Y)}),G.on("close",()=>{if(this.outputChannel.appendLine(de?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(B?"Got result from parser":"No result from parser"),Q&&this.outputChannel.appendLine(`Got data without result: ${Q}`),this.outputChannel.appendLine(""),X)M({limitHit:x});else{U.flush(),G=null;let pe;te&&!de&&(pe=v(te))?A((0,y.serializeSearchError)(new y.SearchError(pe.message,pe.code))):M({limitHit:x})}})})}}e.RipgrepTextSearchEngine=f;function v(u){const h=u.split(`
`),C=h[0].trim();if(h.some(N=>N.startsWith("regex parse error")))return new y.SearchError(g(h),y.SearchErrorCode.regexParseError);const R=C.match(/grep config error: unknown encoding: (.*)/);if(R)return new y.SearchError(`Unknown encoding: ${R[1]}`,y.SearchErrorCode.unknownEncoding);if(C.startsWith("error parsing glob"))return new y.SearchError(C.charAt(0).toUpperCase()+C.substr(1),y.SearchErrorCode.globParseError);if(C.startsWith("the literal"))return new y.SearchError(C.charAt(0).toUpperCase()+C.substr(1),y.SearchErrorCode.invalidLiteral);if(C.startsWith("PCRE2: error compiling pattern"))return new y.SearchError(C,y.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=v;function g(u){const h=["Regex parse error"],C=u.filter(R=>R.startsWith("PCRE2:"));if(C.length>=1){const R=C[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const N=R.split(":")[1];h.push(":"+N)}}return h.join("")}e.buildRegexParseError=g;class c extends t.EventEmitter{constructor(h,C,R){super(),this.maxResults=h,this.rootFolder=C,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,C){return super.on(h,C),this}handleData(h){if(this.isDone)return;const C=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(C)}handleDecodedData(h){let C=h.indexOf(`
`);const R=this.remainder+h;if(C>=0)C+=this.remainder.length;else{this.remainder=R;return}let N=0;for(;C>=0;)this.handleLine(R.substring(N,C).trim()),N=C+1,C=R.indexOf(`
`,N);this.remainder=R.substring(N)}handleLine(h){if(this.isDone||!h)return;let C;try{C=JSON.parse(h)}catch{throw new Error(`malformed line from rg: ${h}`)}if(C.type==="match"){const R=m(C.data.path),N=L.URI.file(w.join(this.rootFolder,R)),M=this.createTextSearchMatch(C.data,N);this.onResult(M),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(C.type==="context"){const R=m(C.data.path),N=L.URI.file(w.join(this.rootFolder,R));this.createTextSearchContext(C.data,N).forEach(A=>this.onResult(A))}}createTextSearchMatch(h,C){const R=h.line_number-1,N=m(h.lines),M=Buffer.from(N);let A=0,z=0,H=R;h.submatches.length===0&&h.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const F=(0,P.coalesce)(h.submatches.map((G,B)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const U=m(G.match),X=M.slice(A,G.start).toString().length,$=z+X,x=n(U),Q=H,de=x.numLines+Q,te=x.numLines>0?x.lastLineLength:x.lastLineLength+$;return A=G.end,z=te,H=de,new S.Range(Q,$,de,te)}));return(0,p.createTextSearchResult)(C,N,F,this.previewOptions)}createTextSearchContext(h,C){const R=m(h.lines),N=h.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((M,A)=>({text:M,uri:C,lineNumber:N+A}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=c;function m(u){return u.bytes?Buffer.from(u.bytes,"base64").toString():u.text}function n(u){const h=/\n/g;let C=0,R=-1,N;for(;N=h.exec(u);)C++,R=N.index;const M=R>=0?u.length-R-1:u.length;return{numLines:C,lastLineLength:M}}function d(u,h){const C=["--hidden"];C.push(u.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:N}=(0,_.groupBy)(h.includes,A=>A.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const A=new Set;N.forEach(z=>{A.add(z)}),C.push("-g","!*"),A.forEach(z=>{s(z).map(p.anchorGlob).forEach(H=>{C.push("-g",H)})})}R&&R.length&&R.forEach(A=>{C.push("-g",A)}),h.excludes.map(p.anchorGlob).forEach(A=>C.push("-g",`!${A}`)),h.maxFileSize&&C.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?h.useParentIgnoreFiles||C.push("--no-ignore-parent"):C.push("--no-ignore"),h.followSymlinks&&C.push("--follow"),h.encoding&&h.encoding!=="utf8"&&C.push("--encoding",h.encoding),u.pattern==="--"&&(u.isRegExp=!0,u.pattern="\\-\\-"),u.isMultiline&&!u.isRegExp&&(u.pattern=(0,I.escapeRegExpCharacters)(u.pattern),u.isRegExp=!0),h.usePCRE2&&C.push("--pcre2"),C.push("--crlf"),u.isRegExp&&(u.pattern=i(u.pattern),C.push("--engine","auto"));let M;if(u.isWordMatch){const z=(0,I.createRegExp)(u.pattern,!!u.isRegExp,{wholeWord:u.isWordMatch}).source.replace(/\\\//g,"/");C.push("--regexp",z)}else if(u.isRegExp){let A=a(u.pattern);A=o(A),C.push("--regexp",A)}else M=u.pattern,C.push("--fixed-strings");return C.push("--no-config"),h.useGlobalIgnoreFiles||C.push("--no-ignore-global"),C.push("--json"),u.isMultiline&&C.push("--multiline"),h.beforeContext&&C.push("--before-context",h.beforeContext+""),h.afterContext&&C.push("--after-context",h.afterContext+""),C.push("--"),M&&C.push(M),C.push("."),C}function s(u){const h=(0,k.splitGlobAware)(u,"/");return h.map((C,R)=>h.slice(0,R+1).join("/"))}e.spreadGlobComponents=s;function i(u){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;u.match(h);)u=u.replace(h,"$1\\x{$2}");const C=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;u.match(C);)u=u.replace(C,"$1\\x{$2}");return u}e.unicodeEscapesToPCRE2=i;const r=u=>u.type==="Assertion"&&u.kind==="lookbehind";function a(u){let h;try{h=new T.RegExpParser().parsePattern(u)}catch{return u}let C="",R=0;const N=(z,H,F)=>{C+=u.slice(R,z)+F,R=H},M=[];return new T.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const H=M[0];if(!H)N(z.start,z.end,"\\r?\\n");else if(!M.some(r))if(H.type==="CharacterClass")if(H.negate){const F=u.slice(H.start+2,z.start)+u.slice(z.end,H.end-1);H.parent?.type==="Quantifier"?N(H.start,H.end,F?`[^${F}]`:"."):N(H.start,H.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=u.slice(H.start+1,z.start)+u.slice(z.end,H.end-1);N(H.start,H.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else H.type==="Quantifier"&&N(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){M.unshift(z)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(z){M.unshift(z)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(z){M.unshift(z)},onCharacterClassLeave(){M.shift()},onAssertionEnter(z){r(z)&&M.push(z)},onAssertionLeave(z){M[0]===z&&M.shift()}}).visit(h),C+=u.slice(R),C}e.fixRegexNewline=a;function o(u){return u.replace(/\n/g,"\\r?\\n")}e.fixNewline=o}),define(De[297],Ie([1,0,21,143,120,12]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class _{constructor(I){this.outputChannel=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(I,L,y,S){const T=new t.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===P.Schemas.vscodeUserData){const E={...L,folder:L.folder.with({scheme:P.Schemas.file})},p=new D.Progress(b=>y.report({...b,uri:b.uri.with({scheme:L.folder.scheme})}));return this.withToken(S,b=>T.provideTextSearchResults(I,E,p,b))}else return this.withToken(S,E=>T.provideTextSearchResults(I,L,y,E))}async withToken(I,L){const y=k(I);this.inProgress.add(y);const S=await L(y.token);return this.inProgress.delete(y),S}dispose(){this.inProgress.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=_;function k(w){const I=new l.CancellationTokenSource;return w.onCancellationRequested(()=>I.cancel()),I}}),define(De[298],Ie([1,0,29,143,142]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(w){this.query=w}search(w,I,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const y={appendLine(T){L({message:T})}},S=new D.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(y),l);return new Promise((T,E)=>S.search(p=>{I(p.map(_))},w).then(p=>T({limitHit:p.limitHit,type:"success",stats:p.stats}),E))}}e.TextSearchEngineAdapter=P;function _(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((w,I)=>{if(I.ranges){const L=I;return w+(Array.isArray(L.ranges)?L.ranges.length:1)}else return w+1},0)}}}),define(De[299],Ie([1,0,17,18,10,4,106,9,51,2,42,30,289,298]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class E{constructor(c="searchProcess"){this.processType=c,this.caches=Object.create(null)}fileSearch(c){let m;const n=f(c),d=new P.Emitter({onFirstListenerDidAdd:()=>{m=(0,t.createCancelablePromise)(s=>this.doFileSearchWithEngine(S.Engine,n,i=>d.fire(i),s)),m.then(s=>d.fire(s),s=>d.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return d.event}textSearch(c){let m;const n=f(c),d=new P.Emitter({onFirstListenerDidAdd:()=>{m=(0,t.createCancelablePromise)(s=>this.ripgrepTextSearch(n,i=>d.fire(i),s)),m.then(s=>d.fire(s),s=>d.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return d.event}ripgrepTextSearch(c,m,n){return c.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new T.TextSearchEngineAdapter(c).search(n,m,m)}doFileSearch(c,m,n){return this.doFileSearchWithEngine(S.Engine,c,m,n)}doFileSearchWithEngine(c,m,n,d,s=E.BATCH_SIZE){let i=0;const r=o=>{Array.isArray(o)?(i+=o.length,n(o.map(u=>this.rawMatchToSearchItem(u)))):o.relativePath?(i++,n(this.rawMatchToSearchItem(o))):n(o)};if(m.sortByScore){let o=this.trySortedSearchFromCache(m,r,d);if(!o){const u=m.maxResults?Object.assign({},m,{maxResults:null}):m,h=new c(u);o=this.doSortedSearch(h,m,n,r,d)}return new Promise((u,h)=>{o.then(([C,R])=>{const N=R.map(M=>this.rawMatchToSearchItem(M));this.sendProgress(N,n,s),u(C)},h)})}const a=new c(m);return this.doSearch(a,r,s,d).then(o=>({limitHit:o.limitHit,type:"success",stats:{detailStats:o.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(c){return{path:c.base?(0,k.join)(c.base,c.relativePath):c.relativePath}}doSortedSearch(c,m,n,d,s){const i=new P.Emitter;let r=(0,t.createCancelablePromise)(o=>{let u=[];const h=C=>{Array.isArray(C)?u=C:(d(C),i.fire(C))};return this.doSearch(c,h,-1,o).then(C=>[C,u])}),a;if(m.cacheKey){a=this.getOrCreateCache(m.cacheKey);const o={promise:r,event:i.event,resolved:!1};a.resultsToSearchCache[m.filePattern||""]=o,r.then(()=>{o.resolved=!0},u=>{delete a.resultsToSearchCache[m.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([o,u])=>{const h=a?a.scorerCache:Object.create(null),C=(typeof m.maxResults!="number"||m.maxResults>0)&&w.StopWatch.create(!1);return this.sortResults(m,u,h,s).then(R=>{const N=C?C.elapsed():-1;return[{type:"success",stats:{detailStats:o.stats,sortingTime:N,fromCache:!1,type:this.processType,workspaceFolderCount:m.folderQueries.length,resultCount:R.length},messages:o.messages,limitHit:o.limitHit||typeof m.maxResults=="number"&&u.length>m.maxResults},R]})})}getOrCreateCache(c){const m=this.caches[c];return m||(this.caches[c]=new p)}trySortedSearchFromCache(c,m,n){const d=c.cacheKey&&this.caches[c.cacheKey];if(!d)return;const s=this.getResultsFromCache(d,c.filePattern||"",m,n);if(s)return s.then(([i,r,a])=>{const o=w.StopWatch.create(!1);return this.sortResults(c,r,d.scorerCache,n).then(u=>{const h=o.elapsed(),C={fromCache:!0,detailStats:a,type:this.processType,resultCount:r.length,sortingTime:h};return[{type:"success",limitHit:i.limitHit||typeof c.maxResults=="number"&&r.length>c.maxResults,stats:C},u]})})}sortResults(c,m,n,d){const s=(0,_.prepareQuery)(c.filePattern||""),i=(a,o)=>(0,_.compareItemsByFuzzyScore)(a,o,s,!0,b,n),r=typeof c.maxResults=="number"?c.maxResults:Number.MAX_VALUE;return l.topAsync(m,i,r,1e4,d)}sendProgress(c,m,n){if(n&&n>0)for(let d=0;d<c.length;d+=n)m(c.slice(d,d+n));else m(c)}getResultsFromCache(c,m,n,d){const s=w.StopWatch.create(!1),i=m.indexOf(k.sep)>=0;let r;for(const h in c.resultsToSearchCache)if(m.startsWith(h)){if(i&&h.indexOf(k.sep)<0&&h!=="")continue;const C=c.resultsToSearchCache[h];r={promise:this.preventCancellation(C.promise),event:C.event,resolved:C.resolved};break}if(!r)return null;const a=s.elapsed(),o=w.StopWatch.create(!1),u=r.event(n);return d&&d.onCancellationRequested(()=>{u.dispose()}),r.promise.then(([h,C])=>{if(d&&d.isCancellationRequested)throw(0,D.canceled)();const R=[],N=(0,_.prepareQuery)(m).normalizedLowercase;for(const M of C)!(0,y.isFilePatternMatch)(M,N)||R.push(M);return[h,R,{cacheWasResolved:r.resolved,cacheLookupTime:a,cacheFilterTime:o.elapsed(),cacheEntryCount:C.length}]})}doSearch(c,m,n,d){return new Promise((s,i)=>{let r=[];d?.onCancellationRequested(()=>c.cancel()),c.search(a=>{a&&(n?(r.push(a),n>0&&r.length>=n&&(m(r),r=[])):m(a))},a=>{m(a)},(a,o)=>{r.length&&m(r),a?i(a):s(o)})})}clearCache(c){return delete this.caches[c],Promise.resolve(void 0)}preventCancellation(c){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,n){return c.then(m,n)}catch(m){return this.then(void 0,m)}finally(m){return c.finally(m)}}}}e.SearchService=E,E.BATCH_SIZE=512;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(g){return(0,k.basename)(g.relativePath)}getItemDescription(g){return(0,k.dirname)(g.relativePath)}getItemPath(g){return g.relativePath}};function f(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(v),extraFileResources:g.extraFileResources&&g.extraFileResources.map(c=>I.URI.revive(c))}}function v(g){return{...g,folder:I.URI.revive(g.folder)}}}),define(De[300],Ie([1,0,6,12,2,29,13,26,14,73,54,30,299,297,94,142]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let b=class extends I.ExtHostSearch{constructor(v,g,c,m){super(v,c,m),this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const n=new E.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new T.RipgrepSearchProvider(n)),g.remote.isRemote&&g.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const v=new E.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new T.RipgrepSearchProvider(v)),this.registerInternalFileSearchProvider(t.Schemas.file,new S.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(v,g){const c=this._handlePool++;return this._internalFileSearchProvider=g,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(v)),(0,l.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(v,g,c,m){const n=(0,I.reviveQuery)(c);return v===this._internalFileSearchHandle?this.doInternalFileSearch(v,g,n,m):super.$provideFileSearchResults(v,g,c,m)}doInternalFileSearch(v,g,c,m){const n=d=>{if((0,y.isSerializedFileMatch)(d)&&(d=[d]),Array.isArray(d)){this._proxy.$handleFileMatch(v,g,d.map(s=>D.URI.file(s.path)));return}d.message&&this._logService.debug("ExtHostSearch",d.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,n,m)}$clearCache(v){return this._internalFileSearchProvider?.clearCache(v),super.$clearCache(v)}createTextSearchManager(v,g){return new p.NativeTextSearchManager(v,g,void 0,"textSearchProvider")}};b=qe([xe(0,w.IExtHostRpcService),xe(1,k.IExtHostInitDataService),xe(2,L.IURITransformerService),xe(3,_.ILogService)],b),e.NativeExtHostSearch=b}),define(De[301],Ie([1,0,82,272,284,283,300,296,273,72,39,73,70,38,53,67,271,270,13,285,47]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f,v,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(L.IExtHostExtensionService,k.ExtHostExtensionService,!1),(0,l.registerSingleton)(v.ILoggerService,f.ExtHostLoggerService,!0),(0,l.registerSingleton)(p.IExtensionStoragePaths,b.ExtensionStoragePaths,!1),(0,l.registerSingleton)(I.IExtHostDebugService,P.ExtHostDebugService,!1),(0,l.registerSingleton)(y.IExtHostSearch,_.NativeExtHostSearch,!1),(0,l.registerSingleton)(S.IExtHostTask,D.ExtHostTask,!1),(0,l.registerSingleton)(T.IExtHostTerminalService,t.ExtHostTerminalService,!1),(0,l.registerSingleton)(E.IExtHostTunnelService,w.ExtHostTunnelService,!1),(0,l.registerSingleton)(c.IExtHostVariableResolverProvider,g.NodeExtHostVariableResolverProviderService,!1)}),define(De[309],Ie([1,0,213,310,71,10,113,114,196,131,282,23,29,110,18,116,208,222,286,301]),function(J,e,l,t,D,P,_,k,w,I,L,y,S,T,E,p,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let a=0;a<process.execArgv.length;a++)process.execArgv[a]==="--inspect-port=0"&&(process.execArgv.splice(a,1),a--)}();const v=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const r=J.__$__nodeRequire("module"),a=r._load;r._load=function(o){if(o==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return a.apply(this,arguments)}})();const g=process.exit.bind(process);function c(r){process.exit=function(a){if(r)g(a);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const a=new Error("An extension called process.crash() and this was prevented.");console.warn(a.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let m=function(r){g()};function n(){const r=(0,f.readExtHostConnection)(process.env);if(r.type===3)return new Promise((a,o)=>{const u=h=>{const C=h[0],R=new _.BufferedEmitter;C.on("message",N=>R.fire(y.VSBuffer.wrap(N.data))),C.on("close",()=>{m("renderer closed the MessagePort")}),C.start(),a({onMessage:R.event,send:N=>C.postMessage(N.buffer)})};if(global.vscodePorts){const h=global.vscodePorts;delete global.vscodePorts,u(h)}else global.vscodePortsCallback=u});if(r.type===2)return new Promise((a,o)=>{let u=null;const h=setTimeout(()=>{m("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),C=108e5,R=3e5,N=new E.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (1)"),C),M=new E.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (2)"),R);process.on("message",(z,H)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){H.setNoDelay(!0);const F=y.VSBuffer.wrap(Buffer.from(z.initialDataChunk,"base64"));let G;if(z.skipWebSocketFrames)G=new k.NodeSocket(H,"extHost-socket");else{const B=y.VSBuffer.wrap(Buffer.from(z.inflateBytes,"base64"));G=new k.WebSocketNodeSocket(new k.NodeSocket(H,"extHost-socket"),z.permessageDeflate,B,!1)}u?(N.cancel(),M.cancel(),u.beginAcceptReconnection(G,F),u.endAcceptReconnection(),u.sendResume()):(clearTimeout(h),u=new _.PersistentProtocol(G,F),u.sendResume(),u.onDidDispose(()=>m("renderer disconnected")),a(u),u.onSocketClose(()=>{N.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(M.isScheduled())return;N.isScheduled()&&M.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(A)});{const a=r.pipeName;return new Promise((o,u)=>{const h=l.createConnection(a,()=>{h.removeListener("error",u);const C=new _.PersistentProtocol(new k.NodeSocket(h,"extHost-renderer"));C.sendResume(),o(C)});h.once("error",u),h.on("close",()=>{m("renderer closed the socket")})})}}async function d(){const r=await n();return new class{constructor(){this._onMessage=new _.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,r.onMessage(a=>{(0,I.isMessageOfType)(a,2)?(this._terminating=!0,m("received terminate message from renderer")):this._onMessage.fire(a)})}send(a){this._terminating||r.send(a)}async drain(){if(r.drain)return r.drain()}}}function s(r){return new Promise(a=>{const o=r.onMessage(u=>{o.dispose();const h=JSON.parse(u.toString()),C=h.commit,R=w.default.commit;if(C&&R&&C!==R&&g(55),h.parentPid){let N=0;setInterval(function(){try{process.kill(h.parentPid,0),N=0}catch(A){A&&A.code==="EPERM"?(N++,N>=3&&m(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${A.message} (code: ${A.code}) (errno: ${A.errno})`)):m(`parent process ${h.parentPid} does not exist anymore: ${A.message} (code: ${A.code}) (errno: ${A.errno})`)}},1e3);let M;try{M=J.__$__nodeRequire("native-watchdog"),M.start(h.parentPid)}catch(A){(0,P.onUnexpectedError)(A)}}r.send((0,I.createMessageOfType)(0)),a({protocol:r,initData:h})});r.send((0,I.createMessageOfType)(1))})}async function i(){const r=[];process.on("unhandledRejection",(N,M)=>{r.push(M),setTimeout(()=>{const A=r.indexOf(M);A>=0&&M.catch(z=>{r.splice(A,1),(0,P.isCancellationError)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),N&&(0,P.onUnexpectedError)(N))})},1e3)}),process.on("rejectionHandled",N=>{const M=r.indexOf(N);M>=0&&r.splice(M,1)}),process.on("uncaughtException",function(N){(0,P.onUnexpectedError)(N)}),D.mark("code/extHost/willConnectToRenderer");const a=await d();D.mark("code/extHost/didConnectToRenderer");const o=await s(a);D.mark("code/extHost/didWaitForInitData");const{initData:u}=o;c(!!u.environment.extensionTestsLocationURI),u.environment.useHostProxy=v.useHostProxy!==void 0?v.useHostProxy!=="false":void 0,u.environment.skipWorkspaceStorageLock=(0,p.boolean)(v.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(M){g(M)}exists(M){return S.Promises.exists(M)}realpath(M){return(0,T.realpath)(M)}};let C=null;u.remote.authority&&v.transformURIs&&(C=(0,b.createURITransformer)(u.remote.authority));const R=new L.ExtensionHostMain(o.protocol,u,h,C);m=N=>R.terminate(N)}e.startExtensionHostProcess=i,i().catch(r=>console.log(r))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/cfc01197555cb14a0d2d3463b331ce41de5733be/core/vs/workbench/api/node/extensionHostProcess.js.map
